//http://esperilo.be/butler.htm
//by Montagu C. Butler, London 1967. Revised by Bernhard Pabst Berlin 2014.
var butlerDict=[
["A", "", "[F], letter A. (ac) <I>440 vibroj sekunde</I>. A-be (bemola), A flat. A-is (diesa), A sharp. A natura, A natural. Aboco-libro, ABC-book. <B>~kordo</B>, A-string. ~vorto (<I>adjektivo</I>), adjective.", "0"],
["a", "-a", "[UV] (-<I>rilata</I>), adj. ending; denotes relation or quality corresponding to the root. The simple form -a is usually sufficient, but more precise forms are available if wanted. It shows <B>I</B> (noun root): <B>1</B> RELATION, <B>(a)</B> Genitive (<I>-de -o</I>), belonging to. <I>Homo, mano, mia libro</I>. <B>(b)</B> Material ( = consisting of). <I>Ora vazo, silka tuko</I>. <B>(c)</B> Possession (<I>~~-hava, -porta). Korna besto</I>. <B>(d)</B> Multitude (<I>= Mult-a, -plena, -riĉa, -oza</I>). Ŝtona vojo</I>. <B>(e)</B> Order. <I>Dun</I>. <B>(f)</B> Preposition (<I>ĉe)rivera</I> promeno, (<I>en) Haga kongreso, (por)poŝa tranĉilo, (pri)muzika leciono, (pro)domsi elspezo</I>. <B>2</B> QUALITY, APPEARANCE (= <I>-aspekta, -eca, -forma, -ojda, -simila, ŝajna; kvazaŭa</I> <I>Anĝela voĉo, reĝa sinteno</I>. <B>II</B> (verb root): <B>1</B> RELATION, (<I>per)skriba respondo, (por)montra. fenestro, (pri)ama poemo</I>. <B>2</B> QUALITY (<I>= -anta, -eca, -ema, -iva, -hava, -plena). Helpa mano, nutra manĝo, rifuza gesto</I>. Rim.: Compare <I>-a</I> (quality), <I>-anta</I> (action). <I>Ama vorto,</I> word of love; <I>amanta filo,</I> loving son.", "0"],
["abako", "abak-o", "abacus (wide sense). (mat) <I>~~ kalkulilo</I>. (arch, carp) = <I>kapitela (balustra) supro</I>.", "0"],
["abato", "abat-o", "[UV] abbot. <B>~ejo</B>, abbey. <B>~ino</B>, abbess.", "0"],
["abdiki", "abdik-i", "(<I>-n</I>) [OA], Abdicate, relinquish, renounce, surrender (<I>rajtojn, tronon</I>); resign (<I>oficon</I>). <B>~o</B>, abdication. <B>~into</B>. ➞ <I>demet, eksiĝ, forlas, rezign</I>.", "0"],
["abdomeno", "abdomen-o", "abdomen. <B>~a</B>, abdominal. ➞ ordinary language <I>ventr</I>.", "0"],
["abelo", "abel-o", "[UV] Bee (<I>Apis</I>). <B>Labor~o</B>, worker bee. <B>Vir~o</B>, drone. <B>~aro</B>, <B>~svarmo</B>, swarm of bees. <B>~ejo</B>, apiary, bee garden. <B>~ino</B>, fem. bee. <B>~isto</B>, beekeeper, apiarist. <B>~ujo</B>, <B>~korbo</B>, hive, skip. <I>En ~ujon ne blovu</I>. <B>~bredo</B>, <B>~kulturo</B>, apiculture. <B>~reĝino</B>, queen-b. ➞ <I>burd, merop, vaks, vesp</I>.", "0"],
["aberacio", "aberaci-o", "(as, bi, opt), aberration, deviation from type. <I>~o kromata, planeda, sfera</I>. <B>~a</B>, aberrant. ➞ <I>delokiĝ, devojiĝ, devi, variaĵ</I>.", "0"],
["abio", "abi-o", "[UV] fir tree (<I>Abies</I>), typical silver f. (<I>A. alba</I>). <B>Granda ~o</B>, giant fir (<I>A. grandis</I>). <B>Greka ~o</B>, Greek fir (<I>A. cepha- lonica</I>). <B>Hispana ~o</B>, (<I>pinsapo</I>), Spanish fir (<I>A. pinsapo</I>). <B>Kristnaska ~o</B>, Christmas tree (more correctly <B>Norvega piceo</B>). <B>~a</B> <I>frukto (strobilo</I>), fir cone. <I>~a ligno</I> (a. <B>pinligno</B>), fir wood, deal. <B>~a pinglo</B>, fir needle. ➞ <I>cug, duglasi, pice, pin, pini</I>.", "0"],
["abismo", "abism-o", "[OA] (<I>profundegaĵo</I>), (geol) abyss, bottomless chasm, lowest depth, deep gorge (Ge 1/2). <I>La profundaj ~oj de la oceano</I>. <B>~a</B>, abyssal. <I>~a roko</I>. <B>f</B> abysmal. <B>En~iĝi</B> (<I>fali en ~on</I>), sink into the depths, be engulfed, overwhelmed, swallowed up. <B>f</B> <I>Fremda animo estas ~o sen limo</I>. ➞ <I>faŭk, senfund</I>.", "0"],
["abituriento", "abiturient-o", "[OA] secondary school student past leaving-exam stage. ~a <I>diplomo</I>, school-leavg (higher-school) certificate. ➞ <I>bakalaŭr</I>.", "0"],
["ablativo", "ablativ-o", "[UV] ablative case. <I>~o absoluta</I>.", "0"],
["abnegi", "abneg-i", "(<I>-n</I>), deny one’s, give up, renounce. <I>~i kredon, rajton</I>. <I>Sin ~i</I>, sacrifice one’s interests. <B>~(ad)o</B> [<B>abnegacio</B> [OA]], renunciation, self-denial (-sacrifice). ➞ <I>abdik, altruism, rezign, sinofer</I>.", "0"],
["aboli", "abol-i", "(<I>-n) (forigi</I>), abolish, do away with, make an end of. <I>~i leĝon, moron, sklavecon</I>. <B>~o</B>, abolition, annulment, repeal, recission. <B>~iĝi</B>, <B>~ismo</B>. <B>~isto</B>, abolitionist. ➞ <I>nulig</I>.", "0"],
["abomeno", "abomen-o", "[UV] (<I>al, antaŭ, kontraŭ</I>). abomin/ation, abhorrence, detestation, loathing. <B>~i</B> (-W, -(‘ <I>=senti ~on</I>), abominate, abhor, execrate, loathe (Ps 139/21). <I>~i mensogon (mensogi</I>). <B>~(ind)a</B>, abominable, detestable, loathsome, odious, revolting. <I>~a ago, odoro</I>. <I>Kiel ~el</I> How disgusting! <B>~(ind)aĵo</B>, abomination, atrocity. (Se 11/1). <I>Tiu kafo estas ~aĵo</I> (wretched stuff). ➞ <I>antipati, naŭz</I>. opposite <I>log, simpati</I>.", "0"],
["aboni", "abon-i", "(<I>-n</I>), [UV] subscri/be for (to), pay for temporary use of, take in. <I>~i gazeton, loĝion</I>. <B>~o</B>, <B>~pago</B>, <B>~prezo</B>, subscription. <B>~antaro</B>, subscribers, circulation. <B>~igi</B> (<I>ion, iun</I>), canvass, get subscribers for, get to s. <B>~ilo</B>, subscription form. <B>~into</B>, subscriber. <B>~bileto</B>, <B>~karto</B>, season ticket. <B>Mal~i</B>, cancel subscription. ➞ <I>kotiz</I>.", "0"],
["aborti", "abort-i", "(<I>nt</I>) [OA] (<I>fuŝnaski</I>), abort, have premature delivery, miscarry, <B>f</B> be fruitless, come to nothing, remain undeveloped. <B>~a</B>, abortive, arrested, fruitless, undeveloped. <B>~o</B>, miscarriage, premature birth. <B>~aĵo</B>, <B>~ito</B>, abortion. <B>~igi</B>, cause abortion. <B>~igilo</B>, abortifacient. <B>~isto</B>. ➞ <I>antaŭtemp, nevivipov; rudiment; fiask, senrezult</I>.", "0"],
["abradi", "abrad-i", "abrade, rub or scrape off, wear away by rubbing. <B>~o</B>, abrasion. (med) rough or sore place on skin caused by this. <B>~a</B>, abrasive. <B>~aĵo</B>, abrasive substance, e.g., emery. ➞ <I>erod</I>.", "0"],
["abrikoto", "abrikot-o", "[UV] apricot. <B>~arbo</B>, apricot tree (<I>Prunus armeniaca</I>).", "0"],
["abrotano", "abrotan-o", "southernwood, lad’s love (<I>Artemisia abrotanum</I>). ➞ <I>artemizi</I>.", "0"],
["abrupta", "abrupt-a", "[OA] Abrupt (wide sense), hasty, sudden; disconnected, precipitous, sharp, sheer, steep, <B>f</B> blunt, brusque, rough, short. <I>~a halto, malsupreniro, stilo</I>. (mus) <I>~a modulaĵo</I>. <B>~e</B> <I>demandi, foriri</I>. ~<B>aĵa</B>, craggy, rugged. <B>~ulo</B>. ➞ <I>neatendit, subit; brusk, krud, krut; klif</I>.", "0"],
["absceso", "absces-o", "[UV] Abscess, gathering (El 9/9). <B>Gingiv~o</B>, gumboil. <B>~i</B>, form an a. ➞ <I>frostoŝvel, furunk, pus(tul), tumor, ulcer</I>.", "0"],
["absciso", "abscis-o", "(geom) abscissa.", "0"],
["absido", "absid-o", "(ecc, arch), apse. ➞ <I>apsid</I>.", "0"],
["absinto", "absint-o", "[UV] <B>1</B> wormwood (<I>Artemisia absinthium</I>) (Rd 29/18). <B>2 ~aĵo</B>, <B>~likvoro</B>, absinthe. <B>~ismo</B>, absinthism. ➞ <I>artemizi, vermut</I>.", "0"],
["absoluta", "absolut-a", "[FE], absolut/e (wide sense), unconditional, unqualified, unrestricted). <I>~a oboe, povo, reĝo, regulo</I>. <I>~a dezerto</I> (J1 2/3). <I>~a vantaĵo</I> (Ps 39/5). (gram) without relation to context. <I>~a participo</I>. (chem) (mus) pure. <I>~a alkoholo. muziko, piĉo, silento</I>. <B>~e</B>, absolutly, completely, entirely. <I>~e ne</I>, not in the least. <I>La</I> <B>~o</B>, the A. <B>~ismo</B> (pol) (thl), absolutism. <B>~isto</B>, absolutist. ➞ <I>nedepend, senescept, senkondiĉ, senlim-, senrezerv; pur, senmiks</I>. opposite <I>relativ</I>.", "0"],
["absolvi", "absolv-i", "(<I>-n, de) (malkondamni</I>), absolve, acquit, exonerate, shrive, free from blame. <I>[Ne=</I> finish studies, pass exam.]. <B>~o</B>, absolution, acquittal, discharge, formal forgiveness, remission. ➞ <I>indulgenc, pardon, pekliberig, sen-kulp(-pek)ig</I>.", "0"],
["absorbi", "absorb-i", "(<I>-n</I>) [OA], (<I>tute okupi</I>), engross, absorb (the attention, mind). <B>~a</B>, engrossing. <B>~iĝi</B> (<I>de, en, per</I>), be engrossed (wrapped up) in, bury one’s in. <B>~ata</B>, engrossed (buried, intensely interested, wrapped up) <I>en sia laboro</I>. ➞ <I>profundiĝ, sorb</I>.", "0"],
["abstini", "abstin-i", "[OA] (<I>sin deteni) (de</I>), abstain (keep one’s away, refrain) from, indulging in something, e.g., <I>alkoholo, tabako, viando</I>. <B>~o</B>, abstinence, (pol) abstention from voting. <B>~ema</B>, abstemious, sparing in use of. <B>~emo</B><I>,</I> sobriety. <B>~ismo</B>, temperance movement. <B>~ulo</B>, abstainer, teetotaller. ➞ <I>fast, moder, sobr, vegetar, kontraŭ-</I>.", "0"],
["abstrakti", "abstrakt-i", "(<I>-n) (de</I>) [OA], abstract; disengage attention from, isolate, separate in thought. <B>~a</B>, abstract, not concrete. <B>~e</B>, in the abstract. <B>~o</B>, <B>~ado</B>, <B>~aĵo</B>, abstraction, withdrawal. ➞ <I>apartig, nereal, spekulativ, teori</I>. opposite <I>konkret</I>.", "0"],
["absurda", "absurd-a", "[OA] absurd, irrational, nonsensical, preposterous, ridiculous, unreasonable. <I>~a ideo, konkludo, suspekto</I>. <B>~aĵo</B>, <B>~eco</B>, absurdity. <I>Rekta ~o. Pruvo per ~o. Redukto al ~o</I>. <B>~igi</B>, stultify. ➞ <I>kontraŭlogik, malkonsekvenc, malraci, sensenc, sinkontraŭdir</I>.", "0"],
["abunda", "abund-a", "(<I>grandkvanta</I>) [OA], abundant, ample, copious, luxuriant, plentiful, profuse. <I>~a manĝo, rikolto</I>. <I>~aj haroj, larmoj</I>. abound, be plentiful, luxuriate. <B>~(ec)o</B>, abundance, more than enough, profusion (Ij 21/23). <B>Mal~a</B>, rare, scanty, scarce. <B>Super~a</B>, <B>tro~a</B>, superabundant, excessive. ➞ <I>amas, luks, malmank, plenplen, riĉ, sufiĉeg, svarm</I>.", "0"],
["abutilo", "abutil-o", "mallow bush, flowering maple (<I>Abutilon</I>).", "0"],
["abutmento", "abutment-o", "(arch) abutment, buttress, pier (of arch, bridge), prop. <B>~aĵo</B>, cordon.", "0"],
["acereno", "aceren-o", "= perĉo.", "0"],
["acero", "acer-o", "[UV] Maple (<I>Acer</I>). <B>~o Norvega</B>, Norway m. (<I>A. platanoides</I>). <B>Platan~o</B>, great or sycamore m. (<I>A. pseudoplatanus</I>), ordinary language \"sycamore\". <B>~a</B> <I>sukero</I>. ➞ <I>platan, sikomor</I>.", "0"],
["acet", "acet-", "(chem) acet-. <B>~a</B>, acetic. <B>~ato</B>, acetate. <B>~atacido</B>, acetic acid. <B>~ileno</B>, acetylene <B>~ometro</B>, acetimeter. <B>~ono</B>, acetone.", "0"],
["acida", "acid-a", "[UV] acid; sharp to taste, sour, tart. <I>~a frukto, salo</I>. <B>f</B> biting, severe. <I>~a humoro, provo, respondo</I>. <B>~o</B>, acid. <B>Gras~o</B>, fatty a. <I>Abomena ~aĵo</I>. <B>~eco</B>, acidity. <B>~eta</B>, acidulous. <B>~igi</B>, <B>~izi</B>, acidify. <B>~ometro</B>, acidimeter. ➞ <I>akr, amar, korod, maldolĉ, pik, ranc</I>. ➞ <B>Sulfat~o</B>, sulphuric a., <B>Sulfit~o</B>, sulphurous a., <B>Sulfid~o</B>, hydrosulphuric a., forming sulphacidates, -ites, -ides, respectively.", "0"],
["acoj", "-ac-oj", "(bot) (sfx) denotes family (<I>-aceae</I>). <B>Lili~oj</B>, liliaceae. <B>Roz~oj</B>, rosaceae. (zoo) <B>Krust~oj</B>, crustacea. <B>~a</B>, crustaceous.", "0"],
["Acoroj", "Acor-oj", "", "0"],
["aĉ", "-aĉ", "[OA] pej. [sfx officialized in 1910], denotes disparagement, contempt, dislike = abominble, horrid, odious, wretched, vile; (col) awful, don’t think much of it, \"rotten\". <B>Dom~o</B>, hovel; <B>hund~o</B>, cur; <B>infan~o</B>, brat; <B>virin~o</B>, hag. <B>Bel~a</B>, tawdry; <B>dik~a</B>, bloated; <B>humil~a</B>, grovelling; <B>mol~a</B>, flabby. <B>Babil~i</B>, jabber; <B>konstru~i</B>, jerry-build; <B>skrib~i</B>, scrawl. <B>~a</B>, poor, \"rotten\", etc. <B>~aĵo</B>, trash. <B>~iga</B>, pejorative. <B>~ulo</B>, wretch. <B>~aspekta</B>, unsightly. <B>~odora</B>, stinking. <B>Aĉ!</B> (interjection), Awful! Rotten! Tosh! etc. ➞ <I>fi, fuŝ, mis, ve</I>. Rim: ➞ <B>-aĉ</B> (colloquial, subjective), denotes unfavourable opinion: <B>fi-</B> (objective, stronger), denotes shamefulness, moral badness. ➞ <B>vivaĉi</B>, drag out a miserable existence; <B>fivivi</B>, live a wicked life.", "0"],
["aĉakaturo", "", "(<I>noteto</I>), (mus) acciacatura, crushing-note.", "0"],
["aĉeti", "aĉet-i", "(<I>-n</I>) [UV] buy, purchase. <I>~i kontante, kredite, pogrande</I><B>. ~anto</B>, <B>~isto</B>, buyer, purchaser. <B>~ebla</B>, for sale. <B>~propono</B>, offer. <B>Antaŭ~i</B>, buy in advance. <B>El~i</B>, redeem. <I>El~a mono, prezo</I>, ransom. <I>El~into,</I> Redeemer. <B>Kun~anto</B>, co-purchaser. <B>sub~i</B>, [UV] (<I>korupti, ŝmiri la manon</I>), bribe, corrupt, suborn. <B>~ebla</B>, venal. ➞ <I>akapar, butikum, klient, pag, prez, vend</I>.", "0"],
["ad", "-ad", "[UV] (sfx denotes Action). <B>1 ~ado</B> (a) (with noun root) adds the idea of action (<I>~~la ago -i</I>, -ation, -ing). <I>Krono,</I> a crown; <B>kron-ado</B>, <I>coronation</I>, crown ing. <I>Najlo,</I> a nail; <B>najl~o</B>, nailing. <I>Sango,</I> blood; <B>sang~o</B>, bleeding, (b) (with verb root) denotes action in general, as distinct from an isolated act or an abstraction. <I>Bato,</I> a blow; <B>bat~o</B>, beating. <I>Vivo,</I> life; <B>viv~o</B>, living. <I>Mi amas</I> <B>lud~on</B>, I like playing (to play). <B>2 ~adi</B> reinforces the idea of action. The action is (a) Continued, persistent. <B>Kur~i</B>, keep on running. (b) Repeated (= often, continually). <I>Mi</I> <B>salt~is</B> (kept on jumping about) <I>la tutan tagon</I>. <B>Vizit~i</B>, often visit, (c) Habitual, customary. (<I>En junulaj tagoj mi</I>) <B>kant~is</B>, (used to, was accustomed to, would often) sing. <B>Ada</B>, <B>ade</B>, continually, unceasingly.", "0"],
["adaĝo", "adaĝ-o", "(mus) adagio, leisurely movement.", "0"],
["adapti", "adapt-i", "(-n <I>al</I>) [OA] (<I>alĝustiĝi, konformiĝi</I>), adapt, adjust, fit, suit; alter, modify, make suitable. <B>~aĵo</B>, adaptation. <B>~ebla</B>, adaptable, <B>~iĝi (sin ~i)</B>, adjust one’s (to), (el) <B>~ilo</B>, adapter. ➞ <I>akomod, alfar, laŭ, modif</I>.", "0"],
["adasismo", "adasism-o", "(pros) rhyme by repetition of a sfx, e.g., <I>diradas, kuradas; beleco, boneco</I>. <B>~isto</B>.", "0"],
["adekvata", "adekvat-a", "adequate, proportionate to what is necessary, sufficient. <B>~eco</B>, adequacy. <B>Ne~a</B>, inadequate. ➞ <I>ekvivalent, sufiĉ, taŭg</I>.", "0"],
["adenito (~ojda, ~omo)", "aden-ito (~ojda, ~omo)", "(technical language) = <I>aden-itis (-oid, -ome)</I>; (ordinary language) = <I>gland-inflamo (~eca, ~eca tumoro)</I>.", "0"],
["adepto", "adept-o", "[OA] <B>1</B> adept, expert, person fully proficient. <B>2</B> initiate, insider. <I>~o de E.,</I> good Esp-ist. <B>~a</B>, proficient, skilled. <B>~igi</B> (<I>inici</I>). ➞ <I>ekspert, spert, kompetent, lert, majstr; aliĝint, disĉipl</I>.", "0"],
["adheri", "adher-i", "(nt, <I>al</I>), adhe/re, cleave to, stick. <B>~(aĵ)o</B>, adhesion. <B>~ema</B> (<I>algluiĝema</I>), adhesive, sticky, tacky. ➞ <I>algluiĝ, alteniĝ, koher; resti ĉe</I>.", "0"],
["adianto", "adiant-o", "(<I>harfiliko</I>), maiden-hair fern (<I>Adiantum</I>).", "0"],
["adiaŭ", "", "[UV] (interjection) (etym. <I>= Al Dio</I>), Adieu! Good-bye! (<I>-n, al) (diri ~</I>), bid farewell to, take leave of. ~a (farewell) <I>kiso, kunveno, letero</I>. <B>~o</B>, leave-taking, parting. <B>~oj</B>, farewells. <B>~diro</B>, valediction. ➞ <I>Ĝxis la revido</I>.", "0"],
["adicii", "adici-i", "[OA] (<I>sumigi</I>), (arit) add (tot) up, cast. <B>~o</B>, addition. ➞ <I>aldon, kalkul</I>.", "0"],
["adjektivo", "adjektiv-o", "[UV] (<I>a-vorto</I>), adjective. ➞ <I>atribut, epitet</I>.", "0"],
["adjekto", "adjekt-o", "(gram) circumstantial complement (of a predicate).", "0"],
["adjunkto", "adjunkt-o", "assistant (colleague, deputy) to an official. ➞ <I>asesor, helpant, koleg</I>.", "0"],
["adjutanto", "adjutant-o", "[OA] (mil) adjutant (2 Rĝ 25/19). <I>~o kampa, ĝenerala</I>, aide-decamp. ➞ <I>help</I>.", "0"],
["administri", "administr-i", "(<I>-n</I>), [UV] administer, manage (affairs, estate); carry on, conduct, direct. <I>aferojn, bienon, distrikton</I>. <B>~a</B>, administrative, executive. <I>~a komitato</I>. <B>~ado</B><I>,</I> administration. <B>~anto</B>, manager. <B>~antaro</B>, Board of M-ment. <B>~ejo</B>, gen. offices. <B>Mis~i</B>. [<B>administraci-o</B> [OA] = ~o, <I>~ado, ~antaro, ~ejo</I>]. ➞ <I>direkt, gvid, konduk, organiz, reg</I>.", "0"],
["admiralo", "admiral-o", "[OA] (mar), admiral. <B>~a</B> <I>ŝipo,</I> flagship. <B>~ar(ej)o</B>, <B>admiralitat-o</B>, [OA] admirality. ➞ <I>atalant, limenit</I>.", "0"],
["Admiraltoj", "Admiralt-oj", ".", "0"],
["admiri", "admir-i", "(<I>-n</I>), [UV] admire, look up to, think fine. <B>~o</B>, admiration. <I>Rigardi ~e (kun ~o)</I>. <I>~i bildon, pejzaĝon, verkon</I>. <B>~egi</B>, marvel at. <B>~inda</B>, admirable. ➞ <I>estim, respekt, ŝat; plaĉ, rav</I>.", "0"],
["admoni", "admon-i", "(<I>-n</I>), [UV] admonish. <B>1</B> exhort, advise, \"talk to\", warn (Jĝ 14/15). <B>2</B> censure, reprimand. <B>~o</B>, admonition, advice, reproof. <B>Re~o</B>, Deuteronomy. <B>Lit~o</B>, \"curtain lecture\". <B>~a</B>, admonitory. <B>De~i</B>, dissuade from … ing, advise not to … ➞ <I>avert, konsil, moralig, riproĉ</I>.", "0"],
["adobo", "adob-o", "adobe, (a) sun-dried clay, (b) hut made from this.", "0"],
["adokso", "adoks-o", "(bot) moschatel (<I>Adoxa</I>).", "0"],
["adoleska", "adolesk-a", "adolescent, between childhood and maturity, growing up, teen-aged, ~<B>ulo</B>.", "0"],
["adolta", "adolt-a", "adult, grown-up, mature, of age. <B>~o</B>, adult ➞ <I>plenkresk, matur</I>.", "0"],
["adonido", "adonid-o", "(bot) pheasant’s eye (<I>Adonis</I>).", "0"],
["adopti", "adopt-i", "(<I>-n</I>) [OA], adopt. <B>1</B> (<I>infanon</I>, etc), <B>~a</B>, by adoption, adoptive (<I>patro</I>), adopted (<I>infano</I>). <B>~intoj</B> (<I>~aj gepatroj</I>), parents by adoption. <B>~ito</B>, adopted child. <B>2</B> take for and use as one’s own, embrace, take up. <I>~i kutimon, lingvon, metodon, nomon</I>. ➞ <I>fil(iri)ig; akcept, alpren, alproprig</I>.", "0"],
["adori", "ador-i", "(<I>-n</I>), [UV] adore. <B>1</B> Worship as deity (Ne 8/6). <B>~ejo</B>, sanctuary, shrine, place of w. <B>~kliniĝi</B> (<I>antaŭ</I>), bow in w. <B>2</B> admire profoundly, idolize, regard with utmost respect and affection. <I>Vivanton ni malhonoras, mortinton ni ~as</I>. <B>~inda</B>, adorable. ➞ <I>apoteoz, kult, preĝ; ameg, ŝateg</I>.", "0"],
["adrenalino", "adrenalin-o", "(chem) adrenalin.", "0"],
["adreso", "adres-o", "[F][OA], address, destination for mail. <I>~o Londona, telegrafa, Sub la ~o</I>, at the address. <B>~i</B> (<I>-n) (al</I>), address, direct, send, <B>f</B> <I>~i al iu dankon. [Ne= alparoli]</I>. <B>~aro</B>, <B>~libro</B>, address , directory. <B>~loko</B>, place of destination. <B>~ilo</B>, addressing machine. <B>Mis~i. Re~i</B>, readdress, forward. ➞ <I>direkt</I>.", "0"],
["adstringa", "adstring-a", "Astringent, (med) binding, styptic, <B>f</B> severe, <B>-aĵo</B>, a. <B>~i</B>, constrict. ➞ <I>acid</I>.", "0"],
["adulario", "adulari-o", "(<I>lunŝtono</I>), (min) moonstone, species of glassy feldspar.", "0"],
["adulti", "adult-i", "[UV] commit adultery. <B>~(em)a</B>, adulterous. <B>~ul(in)o. Sang~o</B>, incest. ➞ <I>fals, fi-miks</I>.", "0"],
["adurolo", "adurol-o", "(phot) adurol.", "0"],
["adventica", "adventic-a", "adventitious, casual, from without. <I>~a membrano, radiko</I>. (jur) <I>~a heredaĵo</I>.", "0"],
["advento", "advent-o", "[OA] (<I>Kristalveno</I>) advent. <I>~a dimanĉo</I>. <B>~ismo</B>, (rel.) <B>~isto.</B>", "0"],
["adverbo", "adverb-o", "[UV] adverb. <B>~a</B> <I>klaŭzo</I>. ➞ <I>e-vort</I>.", "0"],
["advokato", "advokat-o", "[OA] (jur) <B>1</B> advocate, barrister, counsel. <I>~o por la diablo</I>. <B>2</B> one who pleads for another, speaks for a cause; intercessor (Jo 2/1). <B>~i</B> (<I>pro</I>), plead; support, speak for (on behalf of). <B>~aro</B>, the bar. <B>~iĝi</B>, be called to the bar. ➞ <I>defend, pled, proparol</I>.", "0"],
["adzo", "adz-o", "adze. <B>~i</B>, cut with an a.", "0"],
["aero", "aer-o", "[UV] air, atmosphere, <B>f</B> <I>kastelo en ~o</I>. <B>(En)~a</B>, of air, airy, aerial. <B>~eca</B>, etherial, light. <B>~(iz)i</B>, inflate. <B>~umi</B>, [UV] air, aerate, expose to air. <I>~umi ĉambron, panon, tolaĵon</I>. <B>~umado</B>, air-conditioning. <B>~omanka</B>, stuffy. <B>Sen~a</B> (<I>vakua</I>), airless. ➞ <I>atmosfer, vent; freŝ, liber; trablov, ventum</I>.", "0"],
["Aero", "Aero-", "(pfx): <B>-batiko; ~bia</B> (~viva); <B>~dino; -dinamiko; -dromo; ~gramo</B> (air letter); <B>~lito</B>, [OA] (stony meteorite); <B>~logio</B>, <B>~naŭto</B>, <B>~naŭtiko</B> (<I>aeronavigado</I>); <B>~plano</B>, [OA] <B>~stato</B>, <B>~statiko</B>. ➞ <I>aviad, balon, biplan, meteorit, monoplan</I>.", "0"],
["afabla", "afabl-a", "(<I>al, kontraŭ</I>), [UV] affable, friendly, kindly. <I>~a vorto</I>. <B>~e</B> <I>rigardi, saluti</I> (1 Sa 30/21). <I>Kiu agas <B>~e</B>, vivas agrable</I>. <B>~aĵo</B>, <B>~eco</B>, affability, courtesy, kindness. <I>Havu la ~econ</I> .../’, be so good as to … <B>~ulo</B>. <B>mal~a</B>, [UV] surly, rough, ungracious. ➞ <I>amik, bonvol, ĝentil, komplez</I>.", "0"],
["afazio", "afazi-o", "aphasia, loss of power of speech. ➞ <I>afoni</I>.", "0"],
["afekcio", "afekci-o", "(psy, med) affect/ion. <B>1</B> mental state, emotion. <B>2</B> bodily disorder. <B>~i</B> (<I>-n</I>), affect, move, touch (feelings). <B>~a</B>, affective, emotional. ➞ <I>ekscit, emoci, impres, influ, kortuŝ; atak, kapt, perturb</I>.", "0"],
["afekti", "afekt-i", "[UV] <B>(</B><I>ŝajnigi</I>). <B>1</B> (<I>nt</I>) act affectedly, attitudinize, be affabed (unnatural), mince, put on airs (side), show off, simper, smirk, strut. <I>~i antaŭ la spegulo</I>. <B>2</B> (<I>-n</I>), assume a character, imitate, pretend to be (do, feel, have). <I>~i drinkulon, saĝon. ~i nescii</I>. <B>~o</B>, affabation, pretence, show, studied display. <B>~(em)a</B>, affabed, artificial, assumed. <B>~aĵo</B>, mannerism. <B>~ulo</B>, poseur. <I>Kia ~ulo!</I> Doesn’t he put on airs! <B>Ne~a</B>, <B>Sen~a</B>, unaffabed, simple. <B>Bel~a</B>, dandified, foppish. <B>Distance</B>, distant, haughty, reserved. <B>Ĉasta, honta</B>, prudish. <B>Moral~o, pi~o</B>, cant. ➞ <I>formal, imit, poz, rol</I>. opposite <I>natur, senart, simpl. [Ne= efik, influ, kortuŝ, rilat]</I>.", "0"],
["afelio", "afeli-o", "(astr) aphelion, orbital point farthest from sun. ➞ <I>apsid, apoge</I>. opposite <I>periheli</I>.", "0"],
["aferezo", "aferez-o", "(rh) aphaeresis, \"front-cut\", e.g., (<I>a)migdalo, (forte)piano, (omni)buso, (tele)fono, (violon)ĉelo</I>. ➞ <I>apokope</I>.", "0"],
["afero", "afer-o", "[UV] Affair. <B>1</B> Object, thing. <I>Kolekti siajn ~ojn</I> (belongings). <I>Senpova kolero, ridinda ~o</I>. <B>2</B> business, concern, matter. <I>~o de gusto</I>, matter of taste; <I>de la koro</I>, love-affair; <I>de honoro. Malbona ~o</I>, sorry business. <I>Al la ~o!</I> To business! <I>Tio ne estas via ~o</I>, that is no business of yours. <I>Havi ~on kun</I>, deal (have to do) with (4 FA 43/28). <I>La ~o estas</I>, the thing is that. <I>Pri kio estas la ~o?</I> What is it all about? <I>Tio estas alia ~o</I> (alters the case, is another question). <I>Nia A~o</I>, our movement. <B>~oj</B>, business dealings (transactions). <I>Paroli pri ~oj,</I> talk shop. <I>La ~oj estas la ~oj</I>, business is business <I>Ŝtataj ~oj</I>, matters of state. <B>~ema</B>, businesslike. <B>~isto</B>, businessman. <B>~papero</B>, business document. <B>Ĉef~o</B>, great thing, main point. <B>Mult~a</B>, <B>~oplena</B>, busy. ➞ <I>objekt, tem, negoc</I>.", "0"],
["Afganujo, Afganio", "Afgan-ujo, Afganio", "AF", "0"],
["afido", "afid-o", "(<I>plantlaŭso</I>), aphis, green fly (<I>Aphis</I>). <B>~a</B> <I>sukero</I>, honey-dew. <B>~omanĝa</B>, aphidivorous.", "0"],
["afikso", "afiks-o", "[OA] affix (= prefix or suffix).", "0"],
["afineco", "afin-eco", "affinity, relationship, structural resemblance. (chem) (<I>kombiniĝemo</I>), attraction, chemical affinity. <B>~a</B>, having affinity with.", "0"],
["afiŝo", "afiŝ-o", "[OA] bill, placard, poster. <B>Man~o</B>, hand-bill. <B>~i</B> <I>i-n</I>), display a placard, put up a notice. <B>~ejo</B>, <B>~kolono</B>, hoarding. <B>~isto</B>, bill-sticker. <B>~ulo</B> (<I>sandviĉulo</I>), sandwich-man. ➞ <I>anonc, aviz</I>.", "0"],
["aflikti", "aflikt-i", "(<I>-n</I>) [OA] afflict, distress (with bodily or mental sufferg), grieve, pain. <B>~o</B>, affliction, distress, misery, trouble. <B>~igi</B> (<I>pri, pro</I>), be afflicted, distressed, cut up; grieve, take to heart (Ge 6/6). ➞ <I>ĉagren, dolor, prem</I>.", "0"],
["afonio", "afoni-o", "(<I>senvoĉeco</I>) (med) aphonia. <B>~a</B>, voiceless. ➞ <I>afazi</I>.", "0"],
["aforismo", "aforism-o", "[OA] aphorism, short pithy maxim. ➞ <I>aksiom, lakon, maksim, mot, sentenc</I>.", "0"],
["afranki", "afrank-i", "(<I>-n</I>) [OA] frank, pay postage (carriage) on, stamp. <I>~ita letero</I>, stamped letter. <B>~(aĵ)o</B>, postage, <B>~ite</B>, postage paid, \"post free\". <B>~maŝino</B>, stamping machine. <B>~ŝulda</B> <I>marko</I>, postage-due stamp. ➞ <I>stamp</I>.", "0"],
["afrikanso", "afrikans-o", "africans language.", "0"],
["afrikato", "afrikat-o", "(phon), affricative (<I>c, dz, ĉ, ĝ</I>).", "0"],
["Afriko", "Afrik-o", "[OA 8] Africa. <B>Sud-Afriko</B> ZA.", "0"],
["afrodito", "afrodit-o", "(<I>mara pikvermo</I>), sea mouse (<I>Aphrodite</I>).", "0"],
["afto", "aft-o", "(<I>buŝveziketo</I>), aphtha, <B>~oj</B>, thrush. <B>~a</B> <I>febro</I>, foot and mouth disease.", "0"],
["afusto", "afust-o", "[OA] (mil) gun carriage.", "0"],
["agaci", "agac-i", "(<I>-n, abs</I>) [UV]. <B>1</B> (<I>dentojn, nervojn</I>), grate, jar upon, set on edge. <B>2</B> (<I>tun</I>), annoy, get on one’s nerves, irritate. <I>Tio (min) ~as</I>. <B>~a</B>, aggravating, annoying, irritating, provoking. <B>~iĝi</B>, be set on edge (Jer 31/2). ➞ <I>inch</I>.", "0"],
["agamio", "agami-o", "(orn) agami heron, trumpeter (<I>Agamia</I>).", "0"],
["agamo", "agam-o", "agama lizard (<I>Agama</I>).", "0"],
["agapanto", "agapant-o", "African lily (<I>Agapanthus</I>).", "0"],
["agapo", "agap-o", "(rel) agape, love-feast.", "0"],
["agariko", "agarik-o", "(<I>lamenfungo</I>), agaric (<I>Agaricus</I>), genus of gill-bearing fungi, especially <B>Kamp~o</B>, (common edible or field) Mushroom (<I>A. campestris</I>). <B>~a saŭco</B>, m-ketchup. The horse-m is <I>A. arvensis</I>. ➞ <I>fung, ŝampinjon</I>.", "0"],
["agar(agar)o", "agar(agar)-o", "(pharm) agar-agar, preparation from <I>Gracilara confervoides</I> (agaragar) or from <I>Gigartina</I>.", "0"],
["agato", "agat-o", "[OA] (min) agate. ➞ <I>kalcedoni, kvarc, obsidian, oniks, opal</I>.", "0"],
["agavo", "agav-o", "agave (<I>Agave</I>). <B>~o Amerika</B>, <I>American aloe, century plant</I>. <B>~a vino</B>, <I>pulque</I>. ➞ <I>alo, sisal</I>.", "0"],
["agendo", "agend-o", "(<I>memorlibro</I>), engagement -(memorandum-) book. ➞ <I>aferlist, program, tagord</I>.", "0"],
["agento", "agent-o", "(<I>pernio</I>) [OA], agent. <B>Reklam~o</B>, advertising agent. <B>Bien~o</B>, <B>komerc~o</B>, <B>patent~o</B>, <B>ŝip~o. ~ejo</B>, agency bureau. <I>Edziĝ~ejo</I>. ➞ <I>komisiit, maklerist, perul</I>.", "0"],
["agerato", "agerat-o", "floss-flower (<I>Ageratum</I>).", "0"],
["agi", "ag-i", "(<I>kun, kontraŭ</I>) (nt), [UV] act, behave. <I>~i affable, juste, noble</I>. <B>~i</B>, sur (<I>-n</I>). <B>~o</B>, act, action, deed. <I>Vortojn ŝparu, ~ojn faru</I>. <B>~oj</B>, (Bb) Acts. <B>~ado</B>, action(s) (1 Sa 29/6). <I>Libereco de ~ado. ~ado subĉiela</I>, field work. <I>~ada</I> (Executive) <I>Komitato</I>. <B>~(em)a</B>, active, energetic. <B>~maniero</B>, method. <B>Kontraŭ~i</B>, counteract. <B>Kun~i</B>, cooperate, work hand in hand. <B>Mis~i, Re~i</B>, react. (➞ <I>reakci</I>). ➞ <I>akt, aktiv, efik, funkci, kondut, proced, sinokup</I>.", "0"],
["agiti", "agit-i", "(<I>-n</I>) [OA], <B>1</B> agitate, move; shake (<I>arbon, botelon</I>), stir (tniksafon). <I>La hundo (ĉevalo) ~as</I> (wags, whisks) <I>sian voston</I>. <B>2</B> disquiet, disturb, excite, trouble. <I>~i la merkaton</I>. <B>~ata</B>, broken (<I>dormo</I>) choppy, rough (<I>maro</I>); restless (<I>paciento</I>); troubled (<I>animo). Haroj ~ataj</I> (ruffled) <I>de la vento</I>. <B>~(ad)o</B>, agitation, movement, shaking, waving. <B>~iĝi</B>, be agited, in ferment, toss (in sleep). <B>~ilo</B>, mixer, stirring rod. <B>~isto</B>, agitator. ➞ <I>kirl, sku; ekscit, ribelig; demagog</I>.", "0"],
["aglo", "agl-o", "[UV] eagle (<I>Aquila</I>). <B>Fiŝ-o</B> (<I>pandiono</I>), osprey. <B>Imperiestra ~o</B>, imperial eagle. <B>Kri~o</B>, spotted eagle. <B>Reĝ~o</B>, golden eagle. <B>~a</B>, aquiline. <I>~a flugilo</I> (El 19/4). <B>~ejo</B> (<I>~onesto</I>), eyrie. <B>~ido</B>, eaglet. <B>~oŝtono</B> (<I>aetito</I>), eaglestone. ➞ <I>akrevid, penetrem; cirku, folk, gipaet, haliaet</I>.", "0"],
["aglomeri", "aglomer-i", "<B>~iĝi</B>, agglomer/ate, collect (crowd) into a mass. <B>~(aĵ)o</B>, (geol) agglomeration. ➞ <I>konglomer</I>.", "0"],
["aglutini", "aglutin-i", "(<I>-ojn) (kunglui</I>), agglutinate, unite as with glue. <B>~a</B> agglutinative. <I>E-o estas lingvo ~a</I> (combining independent unchangeable roots to express compound ideas). <B>~iĝi</B>, (<I>vundoj</I>) close up, heal. ➞ <I>cikatr, glu</I>.", "0"],
["agnata", "agnat-a", "agnate, descended from same male ancestor; of same clan or nation. <B>~o</B>, a. ➞ <I>afin, parenc</I>.", "0"],
["agnoski", "agnosk-i", "officialy recognize. ➞ <I>konfes, rekon</I>.", "0"],
["agnostika", "agnostik-a", "agnostic, (rel) denying possibility of knowledge about God. <B>~ismo</B>, agnosticism. <B>~ulo</B>, a.", "0"],
["agonii", "agoni-i", "(<I>nt</I>) [OA] be dying, at the point (in the throes) of death: breathe one’s last, <B>f</B> <I>La tago ~as</I>. <B>~o</B>, death agony (struggle). <B>~ante</B>, with one’s dying breath, at one’s last gasp. ➞ <I>angor, mort, stertor</I>. [Ne= agony (<I>dolorego)]</I>.", "0"],
["agorafobio", "agorafobi-o", "fear of open spaces (public places). <B>~ulo</B>. opposite <I>klostrofobi</I>.", "0"],
["agordi", "agord-i", "(<I>-n</I>) [UV] (mus) (put in) tune, syntonize. <I>pianon</I>. (rad) <I>ricevilon</I>. <B>f</B> attune. <I>~i ammon, parolon</I>. <B>~o</B>, tun, tuning. <I>Kanti, ludi, pensi</I> <B>~e</B>, in t. <B>~ilo</B>, tuning hammer (peg). <B>~isto</B>, tuner. <B>Mal~a</B>, out of tune. <B>Mis~i</B>, put out of tun. <B>f</B> set at variance. ➞ <I>akord, fork, harmoni, piĉ, temper</I>.", "0"],
["agrabla", "agrabl-a", "(<I>al, por</I>) [UV] (<I>plaĉa, plezuriga</I>), agreeable, pleasant, pleasing, nice; gratifying (<I>memoro</I>); prepossessing, winsome (<I>vizaĝo). Vi ne estas ~aj al mi</I> (Mai 1/10). <B>~aĵo</B>, amenity, pleasure. <B>Mal~a</B>, disagreeablea, offensive, invidious (<I>tasko</I>). ➞ <I>bonven, log, simpati</I>. opposite <I>ĉagren, ĝen, ted</I>.", "0"],
["agrafo", "agraf-o", "[OA] Clasp, Hook, or similar fastener; buckle (<I>rimena</I>); catch, hasp (<I>fenestra)’</I>, clasp (<I>albuma)’</I>, clip (for papers), staple (binding). (bid) cramp-iron, dowel. <B>~i</B>, fasten (<I>per ~o</I>); clip together (<I>paperojn</I>); do up (<I>robon</I>); hook up (<I>kurtenon</I>). <B>~ilo</B>, stapler. <B>~ingo</B>, eye (in hooks and eyes). <B>Mal~i</B>, unclasp, undo, unfasten, unhook. ➞ <I>kramp</I>.", "0"],
["agregato", "agregat-o", "aggregate, collected amount; (ph) mass of homogeneous particles, (bio) closely packed, clustered. ➞ <I>aglomer, amas</I>.", "0"],
["agresi", "agres-i", "(nt) (<I>iniciati kverelon</I>), be the aggressor, assume the offensive. <B>~o</B>, aggression, unprovoked assault. <B>~anto</B>, aggressor, assailant. <B>~(em)a</B>, aggressive, offensive, provocative, disposed to aggression.", "0"],
["agrikulturo =", "agrikultur-o =", "<I>agrokultivo, terkultivo</I>, agriculture, farming.", "0"],
["agrimonio", "agrimoni-o", "(bot) agrimony (<I>Agrimonia</I>).", "0"],
["agro", "agr-o", "cultivated field. <B>~aro</B>, landed property. ~ara, agrarian.", "0"],
["agronomo", "agronom-o", "[OA] agronomist. <B>~io</B>, [OA] agronomy, husbandry, rural economy, scientific agriculture.", "0"],
["agropiro", "agropir-o", "(<I>hundherbo</I>), couch (dog) grass, quitch, twitch (<I>Agropyron</I>). ➞ <I>cinodont</I>.", "0"],
["agrostemo", "agrostem-o", "(bot), corn-cockle (<I>agrostemma githago</I>).", "0"],
["agrostido", "agrostid-o", "bent grass (<I>Agrostis</I>).", "0"],
["agutio", "aguti-o", "(zool., ordinary language) agouti (<I>Dasyprocta</I>).", "0"],
["aĝio", "aĝi-o", "[OA] agio (charge on currency exchange). <B>Bank~o</B>, bank rate. ➞ <I>kurtaĝ, makler, valut</I>.", "0"],
["aĝioti", "aĝiot-i", "speculate in stocks, <B>~ado</B>, stock-jobbing. ➞ <I>arbitraĝ, spekul</I>.", "0"],
["aĝo", "aĝ-o", "[UV] age. <B>1</B> (in years) <I>Havi la ~on de</I> (Ez 3/8). be … years old. <B>Je mia ~o,</B> at my time of life. <I>Kiain mi havis vian ~on</I> (was your age). <I>Kiom~a vi estas? (Kiom vi ~as)?</I> How old are you? <I>~a tri jarojn</I>, three years old. <I>Mi estas pli ~a</I> (older) <I>ol vi</I>. <B>Grand~a</B>, aged. <B>Matur~a</B>, grown-up. <B>Mez~a</B>, middle-aged. <B>plen~a</B>, [UV] of age. <B>Plen~(ec)o</B>, majority. <B>Plenaĝulo</B>, adult. <B>Sam~a</B>, contemporary <B>2</B> Epoch, generation, period. <I>La ora (ŝtona) ~o</I>, the golden (stone) age. ➞ <I>adolt, beb, infan, jun; epok, jar</I>.", "0"],
["aha!", "", "(interjection) aha! denotes irony, surprise, suspicion, triumph. <I>li kriis</I>.", "0"],
["ahem!", "", "(interjection) cough to attract attention, gain time, etc.", "0"],
["aĥ!", "", "(interjection, emotional variant of <B>ha!)</B>. Ah! Alas! Heigh ho!", "0"],
["ailanto", "ailant-o", "ailanthus, tree of heaven (Ailanthus). ➞ <I>lak</I>.", "0"],
["airo", "air-o", "hair-grass (<I>Aira</I>).", "0"],
["ajapano", "ajapan-o", "ayapana (Brazilian tree) (<I>Eupatorium triplinerva</I>).", "0"],
["ajlo", "ajl-o", "[UV] garlic (<I>Allium sativum</I>). <B>~a</B> radiko. ➞ <I>ampelopraz, askelon, cep, pore, ŝenopraz</I>.", "0"],
["ajn", "", "[UV] denotes indef-ness. <B>1</B> (with <B>ki</B>-correlative) = -ever, -soever (Ps 39/5, 58/5). <I>Kio ~</I>, (two words, no hyphen) what(so)ever. <I>Manĝu kion ~</I>, Eat anything (you like) (whatever it may be). <B>2</B> (with i-correlative): similar meaning. <I>Manĝu ~ ion</I> eat anything (it doesn’t matter what). <B>3</B> (with <B>neni</B> -correlative): <B>nenio</B> nothing at all, absolutely nothing. <B>4</B> (with <B>ĉi</B>-correlative): <B>ĉio</B> absolutely everything. <B>~a</B> (=<I>ia ajn</I>). <I>En ~a triangulo ABC</I>, in any triangle ABC. <I>S-ro ~ulo</I>, Mr X, Mr So-and-so.", "0"],
["ajugo", "ajug-o", "(bot) bugle (<I>Ajuga</I>).", "0"],
["ajuto", "ajut-o", "delivery tube, jet, to regulate flow of liquids; mouth-piece of artificial fountain. <B>Ŝpruc~o</B>, spray nozzle. ➞ <I>blovtub</I>.", "0"],
["aj! aŭ!", "", "(both Z.), (interjection). Oh! Ow! Den. sudden twinge of pain.", "0"],
["aĵ", "-aĵ", "[UV] afx (➞ <I>-age</I> in package, denotes concrete idea). thing (object, matter, stuff). <I>Viaj ~oj</I>, your things (goods, etc.). <B>I.</B> (adj. root): <I>= io -a</I>. <B>Bel~o</B> (<I>= io bela</I>), a beautiful thing. <B>Nov~o</B> (<I>= io nova</I>), news, novelty. <B>II.</B> (vb root): = <B>(a)</B> (active) <I>= io -anta;</I> <B>(b)</B> (passive) = <I>io -ata</I>, as shown by context, or by addn of <I>ant</I> or <I>at</I>. Examples: <B>1</B> <B>Nutr(ant)~o</B>, nourishment; <B>okaz~o</B>, happening; <B>rest~o</B>, remainder; <B>sorĉ~o</B>, spell. <B>2</B> <B>kre(at)~o</B>, creation; <B>aĉet~o</B>, purchase; <B>cit~o</B>, quotation; <B>hered~o</B>, heritage. <B>III.</B> (noun root): = <I>io</I>. <B>(a)</B> <I>rilate al:</I> <B>Lit~o</B>, bedding; <B>ret~o</B>, network, <B>(b)</B> <I>farita el:</I> <B>Lan~oj</B>, woollens; <B>ov~o</B>, egg-dish, <B>(c)</B> <I>farita de:</I> <B>Arane~o</B>, spider’s web; <B>majstr~o</B>, masterpiece. <B>Rim</B>.: ➞ <B>-aĵo</B> (concrete), <B>-eco</B> (abstract). <B>Acid~o</B>, something acid, <B>~eco</B>, acidity. <I>Montru amikecon per amik~oj</I>. <B>Rim</B>.: ➞ <I>-aĵo</I>, <B>-ilo</B>. With a passive meaning the distinction is clear: <B>kudr(at)~o</B>, sewing; <B>kudrilo</B>, needle. With an active meaning the distinction is finer; sometimes either form will serve. Generally <B>-aĵo</B> = substance, material; <B>-ilo</B> = object, tool. <B>Hejt~o</B>, fuel; <B>hejt-ilo</B>, stoking-iron. <B>Rim</B>.: Sometimes <B>-aĵo</B> is contracted to <B>-o</B>. <I>Neĝa</I> <B>kovr(aĵ)o</B>, <B>produkt(aĵ)oj</B> <I>de la tero</I>. <B>Rim</B>.: ➞ <I>-aĵ, -ul</I>. <B>Bon~o</B> = <I>io bona, bona afero</I>. <B>Bonulo</B> = <I>iu bona, bona homo</I>.", "0"],
["aĵura", "aĵur-a", "(<I>tru-plena</I>), open-work, perforated, pierced. <I>~a segado</I>, fretwork <I>~a ŝtrumpo. ~a silueto de la Eiffel-turo</I>. ➞ <I>puntec, travidebl</I>.", "0"],
["akacio", "akaci-o", "[OA] acacia (<I>Acacia</I>). <B>Araba ~o</B>, gum arabic tree. <B>~a</B> <I>ligno</I> (El 25/10). ➞ <I>kateĉu, robini</I>.", "0"],
["akademio", "akademi-o", "[OA] academy. <B>1</B> Society or institution for cultivating or promoting art, literature, or science. <I>La Franca ~o. La ~o E-ista. ~o de muziko</I>. <B>2</B> Place of learning or study <I>= altlernejo, gimnazio</I>. <B>~a</B>, academic. <I>~a demando</I>. <B>~ano</B>, academician.", "0"],
["akalefo", "akalef-o", "(<I>marurtiko</I>), sea-nettle (<I>Acalepha) &gt; hidrozo, meduz</I>. ➞ <I>fizali, polip</I>.", "0"],
["akantiaso", "akantias-o", "piked dog-fish (<I>Acanthias</I>).", "0"],
["akanto", "akant-o", "(bot) acanthus (<I>Acanthus). ~o sendorna</I>, bear’s breech, (arch) <B>~a</B> <I>folio,</I> a. (<I>ornamaĵo</I>).", "0"],
["akapari", "akapar-i", "(<I>-n</I>) [OA], corner, buy up, monopolize. <I>~i tritikon</I>. <B>f</B> bag (secure) <I>la plej bonajn sidlokojn. ~i atenton</I>. <B>~o</B>, corner, monopoly. ➞ <I>kartel, monopol, trust</I>.", "0"],
["akaro", "akar-o", "[UV] mite, tick (<I>Acarus</I>). <B>Fromaĝ~o</B> (<I>tiroglifo</I>), cheese-mite. <B>Rikolt~o</B> (<I>lepto</I>), harvest-mite. (-tick.). <B>Skabi~o</B> (<I>sarkopto</I>), scab mite. <B>Ŝaf~o</B> (<I>iksodo</I>), sheep-tick.", "0"],
["akceli", "akcel-i", "(<I>-n</I>), [UV] accelerate, put on pace, quicken, speed up. <I>~i la pulson, trafikon, la paŝojn</I>. <B>f</B> advance, expedite, hasten. <I>~i progreson. sciencon</I>. <B>~(ad)o</B>, acceleration. (astr) <I>~o luna, stela, tajda</I>. (ph) rate of increase in velocity. <B>~a</B> <I>forto,</I> accelering force. <B>~a</B> <I>pedalo</I>. <B>~aĵo</B>, <B>~ilo</B>, (ch) (mec) (phot) accelerator. <B>~iĝi</B>, go faster, <B>~ita</B> <I>movo</I>, (ph) progressively quicker motion. <B>~mezurilo</B>, accelerometer. <B>Mal~i</B>, retard, slacken, slow down. <I>~~ilo</I>, retarder. ➞ <I>plirapidig, progresig</I>. opposite <I>brems, prokrast</I>.", "0"],
["akcento", "akcent-o", "[UV] accent (wide sense), stress. <I>~o prozodia, oratora, silaba, tonika</I>. (mus) <I>~o forta</I>, strong accent of bar. <B>~i</B> (<I>-n</I>), accentuate, emphasize, give prominence (importance) to. <B>f</B> intensity. <I>la antaŭlastan silabon</I>. (mus) <I>~ita noto, pulso</I>. <B>Sen~a</B>, unstressed, weak. <I>Sen~a silabo</I>. ➞ <I>emfaz, relief, substrek; (super)sign</I>. <B>Rim</B>.: <I>Akcent</I> is gen. used for stress of syllables, <I>emfaz</I> for stress of words or meaning.", "0"],
["akcentoro", "akcentor-o", "= pronelo.", "0"],
["akcepti", "akcept-i", "[UV] (<I>-it</I>) (wide sense), accept, take, consent to receive. <B>1</B> (<I>preni</I>), take what is offered. <I>~i artikolon, donacon, honoron</I>. <B>2</B> (<I>adopti</I>), adopt, take to one’s. <I>~i formon, mienon</I>. <B>3</B> (<I>allasi</I>), admit, agree to, allow the truth of. <I>~i argumenton, ekskuzon, proponon. ~i kiel fakton</I>, take for granted. <B>4</B> acquiesce in. <I>~i defion, inviton, kondiĉon</I>. <B>5</B> (<I>bonvenigi</I>), welcome. <I>~i gaston, vizitanton</I> (Mai 1/9). <B>6</B> (<I>preni sur sin</I>), honour (<I>kambion</I>), undertake (<I>oficon</I>). <B>~o</B> acceptance. <B>~a</B> <I>tago</I>, at-home day. <B>~anto</B>, drawee (of bill). <B>~ebla</B>, admissible, eligible. <B>~ejo</B>, reception room. ➞ <I>konsultej</I>. <B>~inda</B>, acceptable, welcome. <B>Mal~i</B>, decline, blackball, rebuff, refuse, reject, repulse.", "0"],
["akcesora", "akcesor-a", "[OA] accessory, additional, adventitious, subordinate, contributive. <I>~a afero, profito. Ludi ~an rolon</I>, play a minor part. <I>~a garantio</I>, collateral security. <B>~aĵo</B> accessory adjunct, smaller article. <I>Flankenlasi ~aĵojn</I>, ignore minor details. <B>~ulo</B>, accessory ➞ <I>apart, flank, neĉef, neprincip, suplement</I>.", "0"],
["akcidento", "akcident-o", "[OA] accident. <B>1</B> disaster, mischance, mishap. <I>~o fervoja</I>, smash. <I>~o persona</I>, casualty. <I>Esti trafita de ~o (havi ~on</I>), come to grief. <I>Alveni</I> sen<B>~e</B>, safely. <B>2</B> (phi) unessential property (quality). ➞ <I>hazard, malfeliĉ, neintenc, okaz</I>, (mus) <I>kromsign</I>.", "0"],
["akcio", "akci-o", "[OA] (com) share. <B>~a</B>, joint-stock (<I>banko</I>), limited (<I>kompanio). ~a makleristo</I>, share dealer.", "0"],
["akcipitro", "akcipitr-o", "[UV] goshawk (<I>Accipiter</I>). ➞ <I>falk, milv, niz</I>.", "0"],
["akcizo", "akciz-o", "[OA] excise duty. <B>~i</B>, excise. <B>~ebla</B>, <B>~opaga</B>, excisable. ➞ <I>dogan, impost</I>.", "0"],
["akeno", "aken-o", "(bot) achene. <B>~a</B> <I>tufo (papuso</I>), pappus.", "0"],
["akileo", "akile-o", "(<I>milfolio</I>), milfoil, yarrow (<I>Achillea millefolium</I>). ➞ <I>ptarmik</I>.", "0"],
["akiri", "akir-i", "(<I>-n</I>) [UV] (<I>havigi al si</I>), acqui/re, come to have, gain, get, obtain, secure, win. <I>~i favoron, on, influon, laboron, permeson, profiton</I> (1 Sa 1/18). <I>Kiel ~ite, tiel perdite. ~ita gusto, karakterizaĵo</I>. <B>~aĵo</B>, acquisition. <B>~ebla</B>, obtainable. <B>~eblaĵo</B> (Jos 11/14), <B>~ema</B>, acquisitive. <B>Batal~o</B>, <B>milit~o</B>, <B>rab~o</B>, <B>venk~o</B>, (<I>predo</I>), booty, loot, plunder, prey, spoil. <B>Flat</B>~i (<I>elflati</I>), win by flattery (coaxing, wheedling). <B>Plor~i</B>, get by tears. <B>Re~i</B>, recover (breath, etc.). ➞ <I>gajn, kapt, konker, obten, rikolt</I>.", "0"],
["aklami", "aklam-i", "(<I>-n, al, abs</I>) [OA], acclaim, applaud, loudly cheer, hail, welcome. <I>Oni ~is lin reĝo</I>. <B>~o</B>, acclamation. <I>Elektita per ~o. La</I> <B>~ado</B> <I>estis longa</I>. ➞ <I>aplaŭd, hurai, omaĝ, ovaci, salut, vivu!</I>.", "0"],
["akno", "akn-o", "[UV] pimple, acne. <I>Suferi de ~oj</I>. <B>Pus~o</B>, pustule. <B>~(ohav)a</B>, <B>~oza</B>, pimply. <B>~ulo</B>.", "0"],
["akolado", "akolad-o", "<B>~i</B>, <B>1</B> accolade (<I>ceremonio kavaliriga</I>). <B>2</B> (mus, typ) (<I>kuniga krampo</I>), brace, bracket ( }.", "0"],
["akolito", "akolit-o", "(rc) acolyte.", "0"],
["akomodi", "akomod-i", "(<I>-n al</I>), accommodate, adapt, adjust, arrange, fit, suit (to circumstances or wishes). <I>Sin ~i al</I>, adapt one’s to, come to an arrangement (get on) with, (opt) <I>~i (fokusi) okulon al distanco</I>. <B>~ebla</B>, adjustable. <B>~iĝema</B>, accommodating, obliging. ➞ <I>adapt, alfar, alĝustig, kompromis</I>.", "0"],
["akompani", "akompan-i", "[UV] accompany. <B>1</B> act as companion to, attend, escort, go with. <I>~i blindulon</I>. <B>2</B> (mus) <I>~i kant(ist)on. ~ata de</I>, accompanied by, to the accompaniment of. <B>~(aĵ)o</B>, accompaniment. <B>~anto</B>, companion. <B>~isto</B>, accompanist. ➞ <I>eskort</I>.", "0"],
["akonito", "akonit-o", "aconite, friars’ caps, monk’s -hood, wolf’sbane (<I>Aconitum</I>). ➞ <I>erantid</I>.", "0"],
["akordeono", "akordeon-o", "(<I>tirharmoniko</I>), (m.i.) accordion.", "0"],
["akordo", "akord-o", "[OA] accord, agreement (of feelings, ideas, opinions, etc.), conformity, harmony. <I>Komuna ~o</I>, common consent, (gram) concord (e.g., agreement of adj. with noun). (mus) chord. <B>Sept~o. Sestri~o</B>. <I>~o diatona, kromata, maĵora, minora, rompita, tonika</I>. <B>~i</B> (<I>esti en</I> ~o), agree, be consistent (in harmony), conform, correspond, square, tally), (colour) match. <B>~a</B> <I>kun</I>, compatible with. <B>~igi</B>, make to agree, reconcile. <I>~igi du vidpunktojn. ~iĝema</I>, conciliatory. <B>Mal~o</B>, conflict, discord. ➞ <I>agord, konkord, konsent, unuec; sest, triad</I>.", "0"],
["akoro", "akor-o", "(bot) sweet flag (<I>Acorus</I>).", "0"],
["akra", "akr-a", "[UV] (wide sense), sharp, keen. <B>1</B> (<I>= akuta, pika, tranĉa</I>): fine-edged, pointed. <I>~a angulo, dento, glavo, krajono, tranĉilo</I>. <B>2</B> (<I>= klara</I>): clear-cut, well-defined. <I>~a impreso, silueto</I>. <B>3</B> (of sound): harsh, shrill. <I>~a disonanco, sono, tono</I>. <B>4</B> (of taste): ac(r)id, biting, pungent, tart. <I>~a gusto</I>. <B>5</B> (<I>= penetrema, subtila</I>): acute, keen, quick, sensitive. <I>~a cerbo, okulo, rigardo</I>. <B>6</B> (= <I>dolora, forta, trapika</I>): intense, painful, severe. <I>~a doloro, frosto, vento</I>. <B>7</B> (= <I>maldolĉa, morda, sarkasma</I>): acrimonious, bitter, harsh. <I>~a riproĉo, voĉo</I>. <B>~igi</B>, sharpen, whet, put an edge on. <B>~~a ŝtono</B>, hone, whetstone. <B>Krajon~~ilo</B>, <I>pencil sharpener</I>. <B>Leda ~~ilo</B> (<I>razrimeno</I>), strop. <B>~evida</B>, sharp-sighted. <B>Mal~a</B>, blunt, dull, muffled. <B>~~igi</B>, deaden, soften, tone down. ➞ <I>damp, dies, obtuz, sufok</I>.", "0"],
["akrediti", "akredit-i", "(-n), accredit, give standing to, send with credentials <B>(~aĵoj)</B>. ~i ambasadoron</I>. <I>➞ kredit, legitim, plenpov, rajtig</I>.", "0"],
["akreo", "akre-o", "acre, <B>~aro</B>, acreage.", "0"],
["akrido", "akrid-o", "[UV] Locust (<I>Acridium) &gt;</I> the true locusts and grasshoppers with short antennae. <B>~o migra</B>, migratory 1. &gt; <I>pakitelo; melanopolo</I> (Am); <I>skistokerko</I> (N. Africa). <B>~aro</B> (El 10/14). ➞ <I>gril, katidid, lokust</I>.", "0"],
["akrobato", "akrobat-o", "[OA] acrobat, tumbler, etc. (av) <B>~aĵo</B>, stunt. ➞ <I>ekvilibr, gimnast, ŝnurdanc</I>.", "0"],
["Akrocefalo", "Akrocefal-o", "= kanbirdo.", "0"],
["akromata", "akromat-a", "(opt) (<I>senkolora</I>), achromatic. <B>~eco</B>.", "0"],
["Akrostiko £~a", "Akrostik-o £~a", "acrostic.", "0"],
["akselo", "aksel-o", "[OA] <B>1</B> (anat) armpit. <B>2</B> (bot) axil. <B>~a</B>, axillary. ➞ <I>aks</I>.", "0"],
["aksiometro", "aksiometr-o", "(mar) steering indicator, tell-tale.", "0"],
["aksiomo", "aksiom-o", "[OA] axiom, established principle, self-evident truth, truism. <I>~o Eŭklida</I>. <B>~a</B>, axiomatic. ➞ <I>aforism, evident, postul</I>.", "0"],
["aksiso", "aksis-o", "axis (or spotted) deer (<I>Axis</I>).", "0"],
["akso", "aks-o", "[UV] <B>1</B> (<I>mezlinio</I>), (mat, opt), axis, straight central line (real or imaginary). <I>~o magneta</I>. <I>~o de globo, kristalo, rotacio, vido</I>. <B>f</B> central organ. <I>~o de alianco, movado</I>. (av) <I>~o flurezista, leva, longa, normala, transa</I>, drag (lift, longitudinal, normal, lateral) a. <B>2</B> (mec) axle (tree), cross-shaft, pin, spindle (on which wheel etc. revolves). <I>Pedal~o, krank~o, rad~o</I>, <I>~o fiksita, kuplita, libera, movebla</I>. <B>~a</B>, axial. <B>~ingo</B> (<I>nabo</I>), hub, nave. <B>~ujo</B> (<I>~lagro</I>), axis box, bearings. ➞ <I>pivot, spindel, ŝaft</I>.", "0"],
["aksolotlo", "aksolotl-o", "axolotl, larval form of <I>Ambistomo tigra</I>.", "0"],
["akteo", "akte-o", "baneberry, herb Christopher (<I>Actaea</I>).", "0"],
["aktina", "aktin-a", "(chem, phot) actin/ic. <B>~ometro</B>, actinometer.", "0"],
["aktinio", "aktini-o", "<B>1</B> (chem) actinium (Ac). <B>2</B> (zoo) (<I>maranemono, mara rozo</I>), sea anemone (<I>Actinia</I>).", "0"],
["aktiva", "aktiv-a", "[UV] (<I>agema</I>), active (wide sense). <B>1</B> acting, alert, diligent, effective, energetic. <I>~a armeo, intereso, membro, servo. ~a komerco</I>, brisk trade. <B>2</B> (gram) <I>~a voĉo</I>. 3 ~o (<I>com</I>), assets, credit. ➞ <I>hav, kapital, kredit, posedaĵ</I>. <B>~igi</B>, actuate, stimulate. <I>~igi</I> poke (revive) <I>la fajron</I>. ➞ <I>funkciig, instig, stimul</I>. (phi) <B>~ismo</B>, <B>~isto</B>, activism, activist. <B>Ne~eco</B>, inaactivity. <B>Retro~a</B>, retroactiva. opposite <I>pasiv</I>.", "0"],
["aktoro", "aktor-o", "[OA] (th) Actor, player. <B>~aro</B>, company. <B>Ĉef~o</B>, star a. ➞ <I>dram, mimik, prezent, teatr</I>.", "0"],
["akto,", "akt-o,", "[OA] act (wide sense) [Ne= action (<I>ago</I>)]. <B>1</B> (th) act. <I>Komedio tri~a</I>. <B>Inter~o</B>, interval. <B>2</B> (jur) brief, deed, title, legal or official document. <I>~o de Parlamento</I>. <I>~oj publikaj</I>, public registers. <B>Akuz~o</B>, bill of indictment. <B>Nask~o</B>, <B>Mort~o</B>, birth (death) certificate. <B>Transdon~o</B>, deed of conveyance. <B>Vend~o</B>, bill of sale. <B>~aro</B>, dossier. <B>~isto</B>, registrar. <B>~ujo</B>, portfolio. ➞ <I>ag, atest, leĝ</I>.", "0"],
["aktuala", "aktual-a", "[OA] (<I>hodiaŭa, nuntempa</I>). present(-day), of present interest, current, immediate, now existing. Ne=actual (<I>efektiva, fakta</I>). <B>~aĵo</B> (<I>~a demando</I>), question of present interest, of the hour (moment). <I>~a valoro</I>, present value. <I>Prezoj ~aj</I>, ruling prices. <B>~e</B>, at the present time, just now.", "0"],
["aktuaro", "aktuar-o", "(ins) actuary. ➞ <I>asekur, statistik</I>.", "0"],
["akumuli", "akumul-i", "(<I>-n) (amasigi</I>), accumulate, amass, heap (pile) up, hoard. <B>~aĵo</B>, accumulation. (el) <B>~ilo</B>, accumulator, storage battery. ➞ <I>bateri, pil</I>.", "0"],
["akupunkturo", "akupunktur-o", "(med) acupuncture.", "0"],
["akurata", "akurat-a", "[OA] (<I>Justatempa</I>), punctual, prompt, regular, to time. <I>~a alven -(ferm-)o</I>. [<I>Ne=</I> accurate (<I>ĝusta, senerara</I>)]. <B>~e</B>, punctually, when due. <I>~e pagi, veni. ~e je la oka</I>, at 8.0 sharp. <B>Ne~a</B>, unpunctual, irregular, late. ➞ <I>preciz, regul</I>.", "0"],
["akustiko", "akustik-o", "acoustics. <I>La ~o de la ĉambro</I>. <B>~a</B>, acoustical.", "0"],
["akuŝo", "akuŝ-o", "[UV] (obsolete) labour, confinement, childbirth, delivery. <I>~o antaŭtempa,</I> premature delivery. <B>~i</B>, be brought to bed. <B>~ant(~ul)ino</B>, woman in labour (travail) (Ps 48/6). <B>~ejo</B>, lying-in hospital, nursing-home. <B>~igi</B> (<I>-n</I>), deliver of a child, attend in child-birth. <B>~ist(in)o</B>, [UV] accoucheur, midwife, obstetrician (El 1/19) (LR 20). <B>~arto</B> (<I>obstetriko</I>), obstetrics. ➞ <I>abort</I>.", "0"],
["akuta", "akut-a", "[OA] Acute (wide sense). <B>1</B> (<I>akra</I>): sharp, penetrating. <I>~a observo</I>. <B>2</B> (med) (<I>kriza, severa;</I> opposite <I>kronika). ~a atako, kataro</I>. <B>3</B> (geom) <I>~a angulo</I>. ➞ <I>obtuz</I>. <B>4</B> (typ) <I>~a supersigno</I> (´), acute accent. <B>~eco</B>, acuity.", "0"],
["akuzativo", "akuzativ-o", "[UV] Accusative (case). <I>~o de almovo (direkto</I>), a. of direction. <B>~igi</B>, put into the a.", "0"],
["akuzi", "akuz-i", "(-n, <I>ke, pri</I>) [OA], accuse, blame for, impute to, lay fault on. Our) charge (tax) with, indict (Rd 19/18). <B>~o</B>, accusation, charge, indictment (Ez 4/6). ~anto, plaintiff. <B>~ato</B>, accused, defendant. <B>Mis~i</B>, accus falsely. ➞ <I>denunc, imput, plend</I>.", "0"],
["akvaforto", "akvafort-o", "[OA] etching, metal-plate engraving. <B>~i</B>, etch. <B>~aĵo</B>, etching. ➞ <I>akvatint, mezotint</I>.", "0"],
["akvamarino", "akvamarin-o", "(min) aquamarine (<I>bluverda berilo</I>). <B>~a</B>, <I>bluverda</I>.", "0"],
["akvarelo", "akvarel-o", "[OA] (<I>akvopentraĵo</I>), watercolour (painting). <B>~a</B> <I>farbo</I>, watercolour. <B>~e</B>, in watercolours. ➞ <I>akv</I>.", "0"],
["akvario", "akvari-o", "[OA] aquarium, tank for fish (plants).", "0"],
["akvatinto", "akvatint-o", "(phot, typ), aquatint. <B>~aĵo</B>, a. ➞ <I>mezotint, lavum, tuĉ</I>.", "0"],
["akvedukto", "akvedukt-o", "(<I>akvokondukilo</I>), aqueduct, culvert.", "0"],
["akvilegio", "akvilegi-o", "[OA] (bot) columbine (<I>Aquilegia</I>).", "0"],
["akvo", "akv-o", "[UV] <B>1</B> water. <I>~o dolĉa</I> (opposite <I>sala), kur(ant)a, star(ant)a</I>. <I>Ban~o, kran~o, mar~o, mineral~o, pluv~o, roz~o, sankt~o, sod~o, trink~o</I>. <B>Muel~o</B>, mill race (stream). <B>Tegment~o</B>, cavesdroppings. <B>Turn~o</B>, eddy, whirlpool. <B>Verŝ~o</B>, waste water. <B>2</B> water solution, or fluid of similar appearance. <B>Fort~o</B>, aqua fortis (nitric acid). <B>Kalk~o</B>, lime-water. <B>Kolonja ~o</B>, eau de Cologne. <B>Reĝ~o</B>, aqua regia (mixture of nitric and hydrochloric acids). <B>Ŝaŭm~o</B> (\"Sod~o\"), aerated water. <B>Spruc~o</B>, spindrift, spray. <B>~(ec)a</B>, of water, aquatic, aqueous. <B>~(um)i</B> (<I>-n</I>) (Ge 13/10). <I>~(um)ilo</I>, watering can. <I>~uma ĉaro</I>, watering cart. ➞ <I>asperg, irigac, verŝ</I>. <B>~aro</B>, waters. <B>~ero</B> (<B>~oguto</B>), drop of water. <B>~ejo</B> (Le 11/36). <B>~ujo</B>, cistern, reservoir, tank (Pr 2/6). ➞ <I>cistern. Sankt~ujo</I>, holy water stoup. <B>~e</B> <I>saturita</I>, waterlogged. <B>El~ĝi</B>, emerge. <B>En~igi</B> (<I>mergi, trempi</I>), immerse. <B>Sen~a</B> (<I>seka</I>), waterless, thirsty (<I>tero</I>). <B>Sen~igi</B>, dehydrate, dry. <B>Sub~igi</B>, submerge. ➞ <I>dren</I>. <B>Sub~iĝi</B>, sink. ➞ <I>alfundiĝ, sink</I>. <B>super~i</B> [UV] (<I>inundi</I>), deluge, flood, overflow. ➞ <I>diluv, inund</I>.", "0"],
["al", "", "[UV] (<I>malde</I>), (prep) To, towards. Den. <B>1</B> Approach: <I>Iri, veni. Iri ~ Oslo = iri Oslon</I>. <B>Rim.:</B> Strictly, <B>al</B> denotes aim: <B>-n =</B> <I>al+ĝis</I> (the aim is reached). <B>2</B> Direction, aim. Of action: <I>Doni, pagi, sendi La vojo <B>~</B></I>. Of feeling: <I>Esperi, fidi, minaci, sopiri</I> <B>~</B>. Of thought: <I>Diri, ordoni, respondi</I> <B>~</B>. Of will: <I>Abomeno, amo, favoro, inklino</I> <B>~</B>. <B>3</B> Concern, relation. <I>Cedi, plaĉi, rilati, servi, ŝajni</I> <B>~</B>. <B>4</B> (= direktita al) (➞ <I>de</I>): <I>Amo <B>~</B> Dio; akcepto <B>~</B> la reĝo; kontentigo <B>~</B> soifo; mortigo <B>~</B> malamiko; provo <B>~</B> solvo</I>. <B>5</B> (= <I>por</I>): <I>Akiri <B>~</B> si (ion</I>); <I>deziri, konveni <B>~</B></I>. <B>6</B> (= <I>ĝis</I>): <I>ŝanĝi <B>~</B> io = ŝanĝi en ion</I>. <B>~aĵo</B>, annexe. PFX; <B>~iĝi</B> ally one’s to, join. <B>~iĝilo</B>, membership form. <B>~paŝi</B>, step towards, approach, (av) <B>~teriĝo</B>, landing flight. <B>~veni</B>, arrive (Ge 33/18). Sometimes denotes addition: <B>~diri</B>, <B>~doni</B>, to add. <I>PHRASES: Ekiri ~ Oslo</I>, start for Oslo. <I>Kaŝita al mi per kurteno</I>, hidden from me by a curtain. <I>Kio estas ~ vi?</I> What is the matter with you? <I>~ mi estas varme,</I> I feel hot. <I>Lavi al si la manojn (= siajn manojn</I>), wash one’s hands.", "0"],
["alabastro", "alabastr-o", "[OA] <B>~a</B>, alabaster. ➞ <I>gips, marmor</I>.", "0"],
["alarmi", "alarm-i", "(<I>-n</I>) [OA], (give the) alarm, rouse to vigilance, warn of danger (J1 2/1). <B>~o</B>, a., alert, call to arms or for help, (air-raid) warning. <I>[Ne= timig]</I>, <B>~a</B> <I>horloĝo</I>, a-clock. ~a <I>sonorilo</I>, communicate cord, tocsin. <B>~isto</B>, alarmist. <B>~ilo</B>, alar(u)m. <I>Brul~ilo, Fajr~ilo</I>, fire-alarm.", "0"],
["alaŭdo", "alaŭd-o", "[UV] (orn) Lark (<I>alauda</I>). <B>Arb~o</B>, wood-lark (<I>Lullula</I>). <B>Kamp~o</B>, sky-lark. <B>Mont~o</B>, shore-lark (<B><I>Eremophila</I></B>). <B>Tuf~o</B>, crested-lark (<I>Galerida</I>). ➞ <I>delfini</I>.", "0"],
["albano", "alban-o", "[OA 8] <B>Albanujo</B>, Albanio [OA 8] AL", "0"],
["albatroso", "albatros-o", "albatross (<I>Diomedea</I>).", "0"],
["albedo", "albed-o", "(as, opt) albedo.", "0"],
["albino", "albin-o", "[OA 4], (bot) (med) albino. <B>~eco</B>, <B>~ismo</B>, albinism.", "0"],
["albito", "albit-o", "(min) albite, white feldspar. ➞ <I>feldspat</I>.", "0"],
["albo", "alb-o", "alb; surplice reaching to feet. ➞ <I>surplis</I>.", "0"],
["albugo", "albug-o", "(med) albugo.", "0"],
["albumeno", "albumen-o", "albumen. <B>1</B> (bot) endosperm from grains, etc. <B>2</B> (<I>ovblanko, ovalbumino</I>), white of egg (Ij 6/6).", "0"],
["albumino", "albumin-o", "(chem) albumin, protein soluble in water, coagulable by heat. <B>Lakt~o</B>, <B>ov~o</B>. (phot) albuminize, coat with a. <B>~ojdo</B>, albuminoid. <B>~urio</B>, albuminuria, Bright’s disease.", "0"],
["albumo", "album-o", "[OA] album. <I>Foto~o. Skribi en ~o</I>. <I>~o liberfolia</I>, loose-leaf album. <B>~folio</B>, album leaf. ➞ <I>memorlibro, skizlibro</I>.", "0"],
["alburno", "alburn-o", "<B>1</B> (bot) (<I>sukligno</I>), sapwood. <B>2</B> (ich) (<I>blankfiŝo</I>), bleak (<I>Alburnus</I>).", "0"],
["alcionioj", "alcioni-oj", "alcyonaria (soft corals), cow-paps, dead man’s fingers.", "0"],
["alciono", "alcion-o", "[UV] <B>1</B> (orn) (<I>Blufiŝisto</I>) (better <I>alcedo</I>), kingfisher (<I>Alcedo</I>). <B>2</B> (myth) halcyon, <B>f</B> <I>~aj tagoj</I>.", "0"],
["aldehido", "aldehid-o", "(chem) aldehyde.", "0"],
["Alderneo", "Alderne-o", ".", "0"],
["aldo", "ald-o", "[OA] (male) alto, falsetto, highest male voice. <B>~(ul)o</B>, alto singer. <B>~hobojo</B>, English horn, cor anglais. <B>~(violon)o</B>, viola. <B>~a klefo</B>, A-clef (with C on middle line). ➞ <I>kontralt</I>.", "0"],
["alegorio", "alegori-o", "[OA] allegory, figurative tale (=extended metaphor). ➞ <I>parabol</I>.", "0"],
["alegro", "alegr-o", "(mus) allegro (=lively). <B>~eto</B>, allegretto.", "0"],
["alektoro", "alektor-o", "denotes various partridges (chucor, red-legged, etc.) (<I>Alectoria</I>).", "0"],
["aleno", "alen-o", "[OA] (<I>truigilo</I>), awl, punch (El 21/6).", "0"],
["aleo", "ale-o", "[OA] (<I>arbvojo</I>), tree-lined garden path (lane, walk), woodland avenue, (av) <B>Flug~o</B>, flight-way. ➞ <I>avenu</I>.", "0"],
["alergio", "alergi-o", "(med) allergy. <B>~a</B>, allergic.", "0"],
["alerono", "aleron-o", "(av) aileron, wing-tip.", "0"],
["alezi", "alez-i", "bore by grinding, smooth or enlarge the bore (of gun, cylinder, or other tube). <B>~ilo</B>, reamer. ➞ <I>bor, frez</I>.", "0"],
["alfabeto", "alfabet-o", "[UV] alphabet. <B>~a</B> <I>ordo</I>.", "0"],
["alfenido", "alfenid-o", "German (nickel) silver (various alloys of Cu, Zn, Ni).", "0"],
["alfreska", "alfresk-a", "(<I>subĉiela</I>), open-air, out-of- doors. <I>~a manĝo, koncerto</I>.", "0"],
["algebro", "algebr-o", "[OA] algebra.", "0"],
["algo", "alg-o", "[OA] seaweed in gen. (<I>Alga</I>). <I>~oj brunaj, ruĝaj, verdaj</I>. ➞ <I>fuk, zoster</I>.", "0"],
["Alĝerio", "Alĝeri-o", "[OA 8] DZ,", "0"],
["alĥemio", "alĥemi-o", "[OA 2], <B>alkemi-o</B> [OA 8], alchemy. <B>~isto</B>, alchemist.", "0"],
["alia", "ali-a", "[UV] (<I>malsama, neidenta</I>), other. <B>1</B> (adj.) different. <I>Tute ~a afero. ~aj domoj, ~aj homoj. iu ~a</I>. someone else. <I>~a vin laŭdu</I>, let someone else praise you (Se 27/3). <I>Neniu ~a, ol (krom</I>), no one other than. <B>2</B> (pron) <I>La ~a</I>, the other one. <I>Unu la ~an</I>, each other. <I>Unu la ~ajn</I>, one another. <I>Kritiki ~ajn</I>, criticize others <I>De ~a</I>, someone else’s, <B>~e</B>, otherwise. l = in another way (<I>alimaniere</I>). 2 = (or) else, if not. <I>~ ne</I>, not otherwise (4 FA 202/25). ~(aĵ)o (<I>io ~a</I>), something else. <I>Tio aŭ ~o</I>, this or that (Pr 11/6). <I>Nek io, nek ~o</I>, neither one thing nor the other. <B>~eco</B>, difference, dissimotherity. ~igi (~iĝi), alter, change. ➞ <I>metamorfoz, ŝanĝ, transform</I>. <B>~ulo</B>, another (some other) person. <I>~ulaj aferoj</I>, other people’s business. <I>~ula kampo</I>, another’s field. ~dir(~vort)e, in other words. Inter<B>~e</B>, inter alia, among other things. <B>Kun~e</B>, with other things. Sen~e (just that and) nothing more. ➞ <I>ankoraŭ, ceter, diferenc</I>. if A proposed crltive series alial ... is inadmissible (alia, alie, having other meanings). Nevertheless, alies (col)=someone else’s, though unorthodox, is useful.", "0"],
["alianco", "alianc-o", "alliance. <B>1</B> in marriage. <B>2</B> (pol) confederation. <I>Triopa ~o</I>, triple alliance. <B>~ano</B>, <B>~ito</B>, ally. <B>~iĝi</B>, join, (side) with. ➞ <I>feder, koalici, interlig, unuiĝ</I>.", "0"],
["aliario", "aliari-o", "garlic mustard, hedge garlic, Jack by the hedge (<I>Alliaria</I>). ➞ <I>sizimbri</I>.", "0"],
["alibio", "alibi-o", "[OA] (jur) alibi. <I>Prezenti (Pruvi) ~on</I>.", "0"],
["alidado", "alidad-o", "alidade, movable index-arm of quadrant etc.", "0"],
["aligatoro", "aligator-o", "[OA] alligator (<I>Alligator</I>).", "0"],
["alilo", "alil-o", "(chem) allyl.", "0"],
["alimento", "aliment-o", "maintenance, support, sustenance. <B>~i</B>, feed, keep going, supply. <I>~i fabrikejon per elektro; fajron per karbo; ĵurnalon per novaĵo</I>. ~a <I>valoro,</I> food value. <I>~a fako</I>, catering department. <I>~a karto</I>, ration card. <I>~a pago</I>, (jur) alimony; <I>~tubo</I>, alimentary canal. <B>~ado</B>, provisioning. <B>~aĵo</B>, foodstuff. <B>~ilo</B>, (mec) feeder.", "0"],
["alineo", "aline-o", "[OA] (typ) indentation (break) at begining of paragraph. <B>~a</B>, indented. <B>~izi</B>, break up (copy) into paragraphs. ➞ <I>paragraf</I>.", "0"],
["alismo", "alism-o", "(<I>akvoplantago</I>), water-plantain (Alisma). ➞ sagitari.", "0"],
["aliso", "alis-o", "(bot) alison (<I>Alyssum</I>).", "0"],
["aliteracio", "aliteraci-o", "alliteration (e.g., <I>la vojo, la vero, kaj la vivo</I> (Jn 14/6). Vd Ge 15/17; Rd 32/14, 28; Se 12/28.", "0"],
["alizarino", "alizarin-o", "alizarin, madder dye. ➞ <I>rubiaj</I>.", "0"],
["alizo", "aliz-o", "common whitebeam (<I>Sorbus aria</I>). Various species, Kimra, Kornvala, salik-folia, Sveda. ➞ aŭkupari, sorp.", "0"],
["alkalio", "alkali-o", "(<I>alkala metalo</I>), alkali metal (Li, Na, K, Rb, Cs, Fr). Ter<B>~o</B>, alkaline earth metal (Ca, Sv, Ba, Ra).", "0"],
["alkalo", "alkal-o", "alkali, e.g., <I>sodo</I>. <B>Ter~o</B>, alkaline earth e.g., <I>kalko</I>. <B>~a</B>, alkaline. <B>~eco</B>, alkalinity <B>~ojdo</B>, alkaloid.", "0"],
["alkao", "alka-o", "(orn) auk. <B>~ego</B>, great auk (<I>Alea impennis</I>). <B>~eto</B>, little auk ➞ <I>fraterkol, uri</I>.", "0"],
["alkekengo", "alkekeng-o", "winter cherry, strawberry tomato (<I>Physalis alkekengi</I>).", "0"],
["alkemilo", "alkemil-o", "(<I>dama mantelo</I>), lady’s mantle (<I>Alchemilla</I>). Kampa <B>~o</B>, parsley piert.", "0"],
["alko", "alk-o", "[UV] (zoo) elk, (Am) moose (<I>Alces</I>).", "0"],
["alkoholo", "alkohol-o", "[OA] alcohol, spirit(s). <I>~o industria</I>, methylated spirit. <B>~a</B>, alcoholic, spirituous. <I>~a fermento</I>. <I>~a lampo</I>. <B>~aĵo ~a</B> (<I>fluido</I>), alcoholic liquor, tincture. <B>~ismo</B>, alcoholism. <B>~izi</B>, alcoholize. <B>~ulo</B>, alcoholic. <I>~ometro</I>. <B>Sen~a</B>, free from alcohol. ➞ <I>abstin, drink, likvor, -ol, rektif</I>.", "0"],
["alkovo", "alkov-o", "[OA] (<I>litniĉo</I>), alcove, vaulted recess in wall or hedge (especially for bed).", "0"],
["almanako", "almanak-o", "[OA] almanac, annual calendar. ➞ <I>kalendar</I>.", "0"],
["almenaŭ", "", "(adv) <B>1</B> (<I>ne malpli ol; se ne pli; minimume</I>). at Least (not less than). <I>~ du jaroj</I>, two years at least <I>Se mi havus ~ pencon!</I>, If I had but a penny! <B>2</B> (<I>ĉiuokaze); (eĉ se ne ... tamen</I>); merely (Es 7/4). <I>~ li iros</I>, He, at least, (at any rate, anyway) will go. <I>Se vi ne helpos, ~ ne malhelpu!</I>. <I>~ provu!</I>", "0"],
["almozo", "almoz-o", "[UV] alms, charitable relief. <I>akcepti ~on</I>. <I>don?i ~on</I>. <I>pet?i ~on</I>. <I>~(pet)i, beg (Ij 20/10)</I>. <I>Viv?i ~e</I>, by charity. <B>~isto</B>, almoner. <B>~ujo</B>, alms box. <B>~ulo</B>, almsman. <B>~ulejo</B>, almshouse. <B>~o¨don?ema</B>, charitable.", "0"],
["alno", "aln-o", "[UV] (bot) alder (<I>Alnus). ~o blanka,</I> grey a.", "0"],
["alo", "al-o", "outstanding sidepart: aisle (<I>preĝeja</I>); arm (<I>semafora</I>); blade (<I>helica, remila</I>); flank (<I>armea</I>); fluke (<I>ankra</I>); mudguard (<I>aŭta</I>); panel (<I>triptika</I>); sail (<I>ventmuelila</I>); wing (<I>konstruaĵa, naza, partia, pizflora</I>). (av) <B>Direkt~o</B>, tail fin.", "0"],
["alo", "-alo", "<B>1</B> (bot sfx) denotes order (<I>-ales</I>) e.g., <B>roz~oj</B>, rosales &gt; <I>ribacoj kaj rozacoj</I>. <B>2</B> (ch sfx) den aldehydes and acetals e.g., <B>etan~o</B>, ethanal.", "0"],
["alojo", "aloj-o", "(mt) Alloy. a. <B>f</B> <I>Feliĉo sen~a</I>. ➞ <I>amalgam</I>.", "0"],
["alonĝo", "alonĝ-o", "(<I>plilongigo</I>), extension, allonge (<I>document</I>), leaf (<I>table</I>).", "0"],
["aloo", "alo-o", "[OA] (bot) aloe(s) (<I>aloes</I>) (Ps 45/8). <B>~aĵo</B>, bitter aloes. ➞ <I>agav</I>.", "0"],
["alopatio", "alopat/io", "allopathy. <B>~o</B>, allopath. ➞ <I>homeopati</I>.", "0"],
["alopekuro", "alopekur-o", "(<I>vulpa vosto</I>), foxtail grass (<I>Alopecurus</I>).", "0"],
["alopiaso", "alopias-o", "thresher (fox) shark (<I>Alopias</I>).", "0"],
["aloso", "alos-o", "(ich) shad (<I>Clupea alosa</I>).", "0"],
["alotropo", "alotrop-o", "Allotrop/e. <B>~a</B>, -ic.", "0"],
["alpako", "alpak-o", "(zoo) alpaca (<I>Lama pacos</I>). (tex) <I>~a drap-(fel-lan-led-)o</I>.", "0"],
["Alpo", "Alp-o", "Alp. <B>~a</B>, -ine. <I>~a bastono</I>, -enstock. <I>~a korno</I>, -ine horn. <I>~a planto</I>, rockery plant. <B>~ano</B>, -ine dweller. <B>~isto</B>, -inist.", "0"],
["alta", "alt-a", "[UV] high, lofty. <B>1</B> (vertically): <I>~a arbo, homo, monto</I>. <I>~a maro</I>, high tide. <B>2</B> great, outstanding: <I>~a estimo, nivelo, ofico, prezo, temperaturo, tensio</I>. <B>3</B> (<I>nobla</I>): <I>~a celo, penso, sento</I>. (Bb) <I>A~a Kanto,</I> Song of Solomon. <B>4</B> (mus) high-pitched. <I>~a sono, voĉo</I>. <I>~piĉa piano</I>. <B>~(ec)o</B>, altitude, elevation, eminence, height. <B>~o</B>, (bridge) clearance, headway. <I>~o super-mara</I> (above sea-level). <B>~e</B>, highly, on high, aloft. <I>~e taksi</I>, rate highly. <I>rigardi ~en</I>, look upwards. <B>~aĵo</B>, high place (1 Sa 9/13). <B>~aĵeto</B>, bank, hillock, mound. <B>~igi</B>, exalt, raise. <B>Prez~igi</B> (fin) bull. <B>~iĝi</B>, rise, soar, (av) <B>~iĝrapido</B>, rate of climb. <B>~indikilo</B>, height indicator. <B>~kreska</B>, tall. <B>~lernejo</B>, high-school. <B>~limo</B>, (fin) ceiling. <B>~ometro</B>, altimeter, height gauge. <B>mal~a</B>, [UV] low. ➞ <I>bas, profund</I>. <B>mal~igi</B>, abase, lower, reduce, (fin) bear. <B>La Plej~ulo</B>, the Highest. <B>Pli~igi</B>, advance elevate, promote.", "0"],
["altano", "altan-o", "(<I>altejo</I>), (arch) artificialy raised place, high look-out (balcony, terrace, etc.). ➞ <I>balkon, belvidej, teras</I>.", "0"],
["altaro", "altar-o", "[UV] altar. <I>~a tuko</I>, altar-cloth.", "0"],
["alteo", "alte-o", "[UV] (bot) marsh mallow (<I>Althaea</I>). <B>Roz~o</B>, hollyhock. ➞ <I>malv</I>.", "0"],
["alternanco", "", "alternance. ➞ <I>ŝanĝ, vic</I>.", "0"],
["alternativo,", "alternativ-o,", "[OA] alternative, either of two possible courses, one of various possibilities. <B>~a</B>, mutually exclusive. <I>~a propono, signifo</I>. ➞ <I>elekt, selekt</I>.", "0"],
["alterni", "altern-i", "(nt), [UV] alternate, succeed one another by turn. <I>Ruĝo ~is kun bluo</I>. <I>Ĉe la tablo ~is viroj kaj virinoj</I>. <B>~a</B>, alternating, in turn, each after one of the other kind. <I>~aj anguloj, folioj, rimoj</I>. <I>~aj linioj</I>, every other line, (agr) <I>~a kultivado</I>, rotation of crops. <I>~a kurento</I>, alternating current. <B>~e</B>, by turns, turn and turn about. <B>~(ad)o</B>, alternation. <I>~ado de lumo kaj ombro</I>. (bid) (<I>brika) junt~o</I>, bond. <B>~igi</B>, interchange alternatly. <I>~igi virojn kaj virinojn</I>. <B>~ilo</B>, alternator, generator for alternating current.", "0"],
["altitudo", "altitud-o", "(as) (geog) (geom) altitude, height.", "0"],
["altruismo", "altruism-o", "(<I>malegoismo</I>), altruism.", "0"],
["altruisto", "altruist-o", "altruist. <B>~a</B>, altruistic. ➞ <I>filantrop, homam, neprofitem, sindon, sinforges</I>.", "0"],
["aluato", "aluat-o", "howler monkey (<I>Alouatta</I>).", "0"],
["alucito", "alucit-o", "alucite, plume-moth (attacking corn) (<I>Alucita</I>).", "0"],
["aludi", "alud-i", "[UV] (<I>-n, al, pri</I>) allude (refer indirectly or covertly) to, mention (touch) in passing. <B>~o</B>, allusion, implied reference. <I>Por saĝulo sufiĉas ~o</I>. ~o vualita (insinuo), hint, innuendo. ➞ <I>menci, tuŝ</I>.", "0"],
["alumeto", "alumet-o", "[UV] match. <I>~o sendanĝera, vaksa</I>. <B>~ujo</B>, matchbox.", "0"],
["aluminio", "alumini-o", "[OA] (chem) aluminium (Al), <B>~aĵoj</B>, aluminium-ware.", "0"],
["alumino", "alumin-o", "(chem) alumin/a, A1<SUB>2</SUB>O<SUB>3</SUB>. <B>~ato</B>, aluminate. <B>~izi</B>, aluminize. ➞ <I>alun, korund</I>.", "0"],
["aluno", "alun-o", "[UV] alum. <B>~ado</B>, (phot) hardening in alum bath. <B>~ito</B> (<I>ŝton~o</I>), alum stone, alunite.", "0"],
["aluvio", "aluvi-o", "alluvium, water-borne deposit. <B>~a</B>, alluvial.", "0"],
["alveolo", "alveol-o", "(<I>kaveto</I>), alveolus, cavity, socket. <I>~o buŝa, denta, pulma;</I> cell (of honeycomb). <B>~hava</B>, <B>~oza</B>, alveolate, cellular, honeycombed, pitted. ➞ <I>cel</I>.", "0"],
["amalgamo", "amalgam-o", "(chem) amalgam, alloy with mercury, <B>f</B> merger, <B>~i</B>, amalgamate, <B>f</B> combine, unite. <I>~i ideojn, societojn</I>. <B>~iĝi</B>, amalgam ➞ <I>aloj, kunfand, miksaĵ</I>.", "0"],
["amando", "amand-o", "kernel of fruit. <B>ĉeriz~o</B>, cherry stone.", "0"],
["amanito", "amanit-o", "amanita fungus (<I>Amanita) &gt; ~o bulba, verda</I>, deathcap (<I>A. phalloides</I>), <B>Muŝ~o</B> (<I>muŝfungo</I>), fly agaric (<I>A. muscaria</I>).", "0"],
["amara", "amar-a", "[OA] bitter (to taste). <I>~a bedaŭro, doloro, kritiko, riproĉo. Dolĉ~o</I>, (bot) bitter sweet (<I>Solanum dulcamara</I>). ➞ <I>acid, akr, gal, maldolĉ</I>.", "0"],
["amaranto", "amarant-o", "amaranth, love-lies-bleeding, Prince’s feather; pigweed (<I>Amaranthus</I>). <B>~a</B>, amaranthine, purplish.", "0"],
["amarilido", "amarilid-o", "belladonna lily (<I>Amaryllis belladonna</I>).", "0"],
["amaso", "amas-o", "[UV] (great unorderly) accumulation, mass; heap, pile. <I>~o da mono, ŝtonoj, ŝuldoj</I>. <B>f</B> concourse, crowd, multitude, swarm, throng. <B>Miks~o</B>, hotch-potch, jumble, litter, medley, mess. <B>Neĝ~o</B>, snow-drift. <B>Pajl~o</B>, straw stack. <B>popol~o</B>, [UV] crowd, multitude, mob, populace. <B>popol~ano</B>, man in the street. <B>Sterk~o</B>, dunghill. <B>~a</B> (<I>grandara</I>), mass. <I>~a buĉad-(kunven-)o. Flugi, kolektiĝi</I> <B>~e</B>, swarm (El 38/8). <B>~igi</B>, accumulate, amass, collect, heap up, hoard. <B>~iĝi</B>, come (crowd) together. <B>~produkto</B>, mass product. ➞ <I>akon, aglomer, greg, kolekt, mas, svarm</I>.", "0"],
["amatoro", "amator-o", "[OA 8], amateur; one fond of, connoisseur, fancier, <B>~a</B>, amateur, amateurish, unprofessional, unskilful. <B>~e</B>, as a hobby, for the love of the thing, amateurishly. <B>~i</B>, be an amateur, dabble. ➞ <I>am, dilet, nemeti, neprofesi, ŝat.</I>", "0"],
["ambasado", "ambasad-o", ". [OA 8] (<I>ambasadoro kun ties sekvantaro, konsilantaro ktp</I>.) embassy.", "0"],
["ambasadoro", "ambasador-o", "[OA 2], <B>1</B> ambassador. <B>2</B> official deputy, messenger. <B>~ejo</B> (<I>ambasado</I>), embassy.", "0"],
["ambaŭ", "", "[UV] (<I>ĉiuj du</I>) (pron), both. <I>ambaŭmanoj, ambaŭokuloj</I>. <B>ambaŭ tie</B>, neither. <B>ambaŭ ne povas</B>, neither can. <B>ambaŭdekstra</B>, ambidexterous. <B>ambaŭflanka</B>, on both sides (Jen 45/7). <I>ambaŭflanke presita</I>. <B>ambaŭmane</B>, with both hands. <B>ambaŭseksa</B>, hermaphrodite. <B>ambaŭtranĉa</B>, two-edged. ➞ <I>kaj ... kaj</I>. <B>IT ambaŭ la</B> is usually avoided (LR/121). But <I>ambaŭ la knaboj venis</I>, and <I>la knaboj ambaŭ venis</I>, follow English usage (though <I>la ambaŭ knaboj</I> does not, and are defensible) (➞<B>1</B> Kr 12/15) (➞<B>2</B> FA 67/29, 130/21; Rd 9/17)", "0"],
["ambicia", "ambici-a", "[OA] (<I>altaspira</I>), ambitious, desiring distinction (glory, honour, power, etc.). <B>f</B> high-flown, pretentious, showy (of style, work). <B>~o</B>, ambition. <B>~i</B>, aspire to, be ambitious of, covet, pursue with ardour. <B>~ulo</B>, careerist, pusher. <B>Sen~a</B>, disinterested, modest. ➞ <I>aspir, gloram, honoram, streb</I>.", "0"],
["ambigua", "ambigu-a", "ambiguous.", "0"],
["ambistomo", "ambistom-o", "species of salamander (Ambystoma). ➞ <I>aksolotl</I>.", "0"],
["ambli", "ambl-i", "(nt) <B>~o</B>, amble. <B>1</B> (horse) lift two feet on same side together. <B>2</B> go at an easy pace.", "0"],
["ambono", "ambon-o", "(early ecc arch), ambo, platform, pulpit (Ne 8/4, <B>2</B> Kr 6/13).", "0"],
["amboso", "ambos-o", "[UV] <B>1</B> Anvil. <I>Inter martelo kaj ~o. ~o dupinta</I>, two-beaked a. <B>2</B> (anat) ear-bone.", "0"],
["ambro", "ambr-o", "[OA] amber(gris), substance from sperm whale. ➞ <I>sukcen</I>.", "0"],
["ambrosio", "ambrosi-o", "(bot) ragweed (<I>Ambrosia</I>). ➞ <I>setieci</I>.", "0"],
["ambrozio", "ambrozi-o", "[OA] ambrosi/a, food of the gods, <B>f</B> something delightful to taste or smell. <B>~a</B>, ambrosial. <I>~a gust-(manĝ-odor-)o</I>.", "0"],
["ambulanco", "ambulanc-o", "[OA] (<I>kampa hospitalo</I>), ambulance, field hospital.", "0"],
["amebo", "ameb-o", "(zoo) amoeba, microscopic animalcule.", "0"],
["amelo", "amel-o", "[UV] starch. <I>~o jod-(terpom-tritik -)a</I>. <B>~(ec)a</B>, starchy, <B>~a</B> <I>glao</I>, starch-paste. <B>~i</B>, starch (clothes, etc.). ➞ <I>dekstrin</I>.", "0"],
["amendi", "amend-i", "(<I>-n</I>), (jur, pol), amend, correct, improve, make better, modify (text of project, etc.). <B>~o</B>, amendment. ➞ <I>modif, plibonig</I>.", "0"],
["amento", "ament-o", "(bot) amentum, catkin. ~acoj, amentaceae.", "0"],
["amen!", "", "[UL] (interjection) Amen! So be it! <I>Mi al ĉio diras</I> <B>~o</B> <I>diablon ne forpelas</I>.", "0"],
["Ameriko", "Amerik-o", ". [OA 8] America.", "0"],
["ametisto", "ametist-o", "[OA] amethyst, mauve vrty of quartz colored by manganese.", "0"],
["amfi", "amfi-", "(Gk pfx = on both sides), Amphi-.", "0"],
["amfibio", "", "[UV] (av, zool), amphibian. <B>~a</B>, amphibious. <I>~a animalo, tanko</I>.", "0"],
["amfibolo", "", "(min) amphibole &gt; hornblende, (rh)", "0"],
["amfibologio", "", "(<I>dusencaĵo</I>), amphybology, ambiguous speech.", "0"],
["amfibrako", "", "(pros) amphibrach (\"). <B>~okso</B>, (ich) lancelet (<I>Amphioxus</I>). <B>~podoj</B>, -pods, &gt; sand-fleas / (-hoppers).", "0"],
["amfiteatro", "amfiteatr-o", "[OA] theatre, building with rising seats round central space. ➞ <I>aren</I>.", "0"],
["amfiumo", "amfium-o", "blind eel, Congo snake (<I>Amphiuma</I>).", "0"],
["amforo", "amfor-o", "[OA] (ant) amphora; two- handled vase, (astr) Aquarius.", "0"],
["ami", "am-i", "(<I>-n</I>), [UV] love (has wide sense of Fr <I>aimer</I>). <B>1</B> Love, feel affection for: <I>~i edzon, infanon</I>. <B>2</B> be attached to (fond of), care for, delight in, like: <I>~i muzikon</I>, like (be fond of) music. <I>Kiu ~as honoron, ~u laboron. Teatr~anto</I> (FE). <I>Ŝi diris, ke neniu ŝin ~as</I> (cared for her). <I>~ata de la tuta mondo</I>, a universal favourite. <I>Eĉ por pomo putranta troviĝas ~anto</I>. <B>3</B> (with infinity): <I>~i danci</I>, love (to dance). <I>Vi ~as preni, ~u redoni</I>. <B>~ema</B>, <B>~oplena</B>, of 1ove, loving, affectionate, fond, tender. <B>~o</B>, love. <I>Havi (senti) ~on al iu (io)</I>. <I>Pro ~o al</I>, for the love of. <I>Malsana de ~o</I> (Alt 5/8). <B>~ataĵo</B>, (Jes 44/9). <B>~at(in)o</B>, loved one, beloved, darling, sweetheart. <B>~egi</B> (<I>-n</I>), love passionately, adore, <B>~eto</B>, liking (\"a tiny seed of love\") for. <I>Mi nur ~etas lin</I>. <B>~igi</B> (<I>-n</I>), endear. <B>~igilo</B>, love-potion. <B>~inda</B>, lovable (➞ <I>ĉarm, plaĉ</I>). <B>~afero</B>, <B>~intrigo</B>, <B>~rilato</B>, love-affair. <B>-deklaro</B>, <B>~esprimo</B>, <B>~ĵuro</B>, <B>~konfeso</B>, <B>~letero. ~dezira</B>, <B>~sopira</B>, thirsting for love. <B>~vundita</B>, love smitten. <B>Ek~i</B> (<I>-n), en~iĝi (al iu, en iuri</I>) fall in love. <B>En~igi</B>, captivate, enamour. <B>Ge~antoj</B>, lovers. <B>Mal~o (</B><I>kontraŭ</I>), enmity, hatred. <B>Mal~inda</B>, hateful, odious, detestable. <B>Pli~i</B> (<I>ol</I>), prefer (to). <B>Sen~a</B>, loveless, cold, indifferent, unloving. <B>Mon~a</B>, mercenary, sordid. <B>Mon~o</B>, cupidity. <B>Sin~o</B>, self-esteem, egoism. ➞ <I>ador, amor; amindum; favor, fremd, simpati; ŝat; karesem, tener</I>.", "0"],
["amianto", "amiant-o", "amianthus, silky vrty of asbestos.", "0"],
["amidolo", "amidol-o", "(phot) amidol.", "0"],
["amiko", "amik-o", "[UV] friend. <I>~o bona, intima, nova</I>. <I>~o en ĝojo kaj ploro</I>. <B>~(iĝem)a</B>, friendly, amicable, sociable. ➞ <I>afabl</I>. <B>~a</B> <I>helpo, konsilo, nacio, riproĉo, servo, vento</I>. <B>~e</B>, as a friend. be friends, on good terms. <B>~aĵo</B>, friendly act, greeting. <B>~aro</B>, circle of friends. <B>~eco</B>, friendliness, friendship. <B>~iĝi</B>, become (make). <B>I</B> <B>~iĝema</B>, sociable. <B>~ino</B>, girl (lady) friend. <B>Kor~o</B>, bosom friend. <B>Mal~o</B>, foe, enemy. <B>Mal~a</B>, hostile, inimical. <B>Mal~igi</B>, set at variance. <B>Re~iĝi</B>, be reconciled. ➞</I> kontraŭ, malam</I>. <B>Fianĉ~o</B>, best man. <B>Pseŭd~o</B>, false friend. <B>Re~igi</B>, reconcile. <B>Sen~a</B>, friendless. <B>II</B> <B>~o</B>, (rel) Friend, Quaker</I>.", "0"],
["amilo", "amil-o", "amyl (C<SUB>5</SUB>H<SUB>2</SUB>).", "0"],
["amindumi", "amindum-i", "(kun), [UV] Court, make love to, woo. <B>~ado</B>, c-ship. ➞ am, flirt, koket, okulum, svat</I>.", "0"],
["amino", "amin-o", "amine (NH<SUB>2</SUB>).", "0"],
["amio", "ami-o", "(ich) bowfin (<I>Amia</I>).", "0"],
["amirido", "amirid-o", "(Amyris), genus of American trees &gt; Jamaican rosewood</I>.", "0"],
["amnestio", "amnesti-o", "[OA], amnesty, act of oblivion, gen. pardon. <B>~i</B> (-n).", "0"],
["amnezio", "amnezi-o", "(perdo de memoro), amnesia.", "0"],
["amnio", "amni-o", "(obsolete), amnion. <B>~a</B>, (amniotic) fluido. ➞ <I>oment</I>.", "0"],
["amodito", "amodit-o", "sand-eel, launce (<I>Ammodytes</I>).", "0"],
["amofilo", "amofil-o", "marram gass (<I>Ammophila</I>).", "0"],
["amomo", "amom-o", "ginger-wort (<I>Amomum</I>) (Ap 18/13). ➞ <I>azar, kardamon</I>.", "0"],
["amoniako", "amoniak-o", "[UV] ammonia (NH<SUB>3</SUB>), or solution of this.", "0"],
["amonio", "amoni-o", "ammonium (NH4). <B>~a</B> <I>klorido = salamoniako</I>.", "0"],
["amonito", "amonit-o", "ammonite fossil.", "0"],
["amorco", "amorc-o", "cartridge (percussion) cap. ➞ <I>eksplodigil, prajm</I>.", "0"],
["amorfa", "amorf-a", "(<I>senforma</I>), amorphous, shapeless, structureless, non-crystalline.", "0"],
["Amoro", "Amor-o", "Cupid, god of love (1 FA 34/11). <B>f</B> amour, sexual love. <B>~a</B>, amatory, amorous. <I>~a revo</I>. <B>~i</B>, be amorous, <B>~oveka</B>, sexy. ➞ <I>amem</I>.", "0"],
["amortizi", "amortiz-i", "(<I>-n</I>), [OA], amortize, progressively diminish, abate, weaken. Absorb (<I>ŝokon</I>); allay (<I>doloron, febron</I>); break the force of (<I>falon</I>); cool, damp (<I>pasion</I>); extinguish, liquidate, pay off (<I>ŝuldon</I>); subdue (<I>lumon</I>). <B>~o</B>, deadening, etc. <B>~a</B> <I>kaso</I>, sinking fund. <B>~ebla</B>, (com) redeemable. <B>~ilo</B>, damper. ➞ <I>damp</I>.", "0"],
["ampeloprazo", "ampelopraz-o", "wild leek (<I>Allium ampeloprasum</I>).", "0"],
["ampelopso", "ampelops-o", "(bot) ampelopsis creeper (<I>Ampelopsis) &gt;</I> Virginia creeper.", "0"],
["ampero", "amper-o", "ampere, unit of current. <B>~metro</B>, ammeter. ➞ <I>kulomb</I>.", "0"],
["amplekso", "ampleks-o", "[UV] compass, dimension, extent, magnitude, proportions, range, scope, volume. <I>Interna ~o</I>, capacity. <I>Natura ~o</I>, natural size. <I>Surfac~o,</I> superficies. <I>~o de ideo, instrumento, organizo, voĉo</I>. <B>~i</B> (<I>-n</I>), comprise, cover, include, reach, take up. <I>La ĉielo de ĉieloj ne povas vin ~i</I> (1 Rĝ 8/27). <B>Egal~a</B>, <B>sam~a</B>, of the same scope (size). <B>Grand~a</B>, <B>mult~a</B>, <B>vast~a</B>, capacious, comprehensive, extensive, wide. <I>~~a agado, scio, verko</I>. ➞ <I>dimensi, enhav, grand, skal, spac, volumen</I>.", "0"],
["amplifi", "amplif-i", "(<I>-n</I>), Amplif/y, enlarge, expand, increase strength of. (el) <I>~i kurenton, oscilon, tension</I>. <B>f</B> add details. <B>~o</B>, -ication. <B>~ilo</B>, -ier. <I>~ilo (mal)altfrekvenca</I>. (phot) enlarger.", "0"],
["amplitudo", "amplitud-o", "(ph) amplitude. <I>~o de ondo</I>. ➞ <I>ampleks</I>.", "0"],
["ampolo", "ampol-o", "[OA 8], ampulla, (hollow) bulb, bulging extension. <B>1</B> (pharm) bottle with long neck and bottom bulge. <B>2</B> bulb for electric light or thermometer. <B>3</B> (bio) dilated end of duct or vessel. <B>~forma</B>, flask-shaped. <B>~tubo</B> (<I>pipeto</I>), pipette.", "0"],
["amputi", "amput-i", "(<I>-n</I>). [OA], (surg) amputate, cut off. ~i <I>membron</I>. <B>f</B> cut down, curtail. ➞ <I>fortranĉ</I>.", "0"],
["amuleto", "amulet-o", "[OA] amulet, charm worn against evil. ➞ <I>talisman</I>.", "0"],
["amuzi", "amuz-i", "(<I>-n, per</I>), [UV] Amus/e, entertain, tickle the fancy of. <B>~o</B> -ment (reed), pleasant diversion. <B>~a</B>, -ing, diverting, droll. <B>~aĵo</B>, -ment, pastime. <B>~aĵeto</B><I>,</I> plaything. <B>~iĝi</B> (<I>Je, kuri</I>), a. (enjoy) one’s, be -ed (laugh) at. <I>Bone ~iĝi</I>, have a good time <B>~iĝo</B>, -ment (felt). <B>~ilo</B>, toy. <B>~isto.</B> entertainer. <I>Kortega ~isto</I>, court fool, jester. <B>Mal~i</B>, bore. ➞ <I>distr, gajig, malenuig, ridig, komik, ludil, ted</I>.", "0"],
["an", "-an", "[UV] (sfx) = man (belonging to). <B>1</B> Member, unit. <B>Akademi~o</B>, academician; <B>polic~o</B>, policeman. <B>2</B> Inhabitant of, dweller in. <B>Afrik~o</B>, African; <B>orient~o</B>, oriental. <B>3</B> Adherent, disciple, follower, partisan, one on the side of, pro-. <B>Krist~o</B>, Christian; <B>vegetar~o</B>, vegetarian. <B>~o</B>, adherent, member, etc. <B>~aro</B>, [UV] band, circle, company, group, party, troop. <B>~iĝi</B>, become a member, join. <B>~kotizo</B>, membership subscription. ➞ <I>ist, ul</I>.", "0"],
["an", "-an", "(ch afx), denotes paraffin hydrocarbons. <B>Met~o</B>, <B>et~o</B>, <B>prop~o</B>, <B>but~o</B>, <B>pent~o.</B>", "0"],
["anabaptismo", "anabapt/ismo", "<B>~isto</B>, anabapt-ism, ist. ➞ <I>rebapt</I>.", "0"],
["anaforo", "anafor-o", "(<I>ripetita frazkomenco</I>), (rh) anaphora (Mt 5/3-11).", "0"],
["anagalo", "anagal-o", "[OA] pimpernel, poor man’s weatherglass (<I>Anagallis</I>).", "0"],
["anagiro", "anagir-o", "(bot) bean trefoil (<I>Anagyris</I>).", "0"],
["anaglifo", "anaglif-o", "anaglyph. <B>1</B> embossed ornament. <B>2</B> (phot) stereoscopic picture in superimposed complementary colours. ➞ <I>relief</I>.", "0"],
["anagramo", "anagram-o", "[OA] anagram, e.g. <I>evil, Levi, live, veil, vile</I>.", "0"],
["anakardio", "anakardi-o", "cashew nut, <B>~arbo</B>, c. tree (<I>Anacardium</I>).", "0"],
["anakoluto", "anakolut-o", "(<I>pensrompo</I>), (rh) anacolution, breaking the sequence of thought (Mk 11/32; Lu 5/14).", "0"],
["anakondo", "anakond-o", "(zoo) anaconda (<I>Eunectes</I>). ➞ <I>boa</I>.", "0"],
["anakronismo", "anakronism-o", "[OA] anachronism.", "0"],
["analfabeto", "analfabet-o", "<B>~a</B>, illitera/te (<I>nelegiv-ulo, ~a</I>), <B>~eco</B>, -cy.", "0"],
["analitiko", "analitik-o", "(log) (mat) analytic/s. <B>~a</B>. -al. <I>~a geometrio</I>.", "0"],
["analizi", "analiz-i", "(<I>-n</I>) [OA], analyse, examine minutely the constitution of, reduce to primary parts. <I>~i argumenton, solvaĵon, substancon. Juĝa</I> ~o (1 Sa 12/7). <I>~o kvalita, kvanta. En la fina ~o</I>. when all is said and done, all things considered, (gram) <B>~i</B> (a., parse) <I>frazon</I>. (lit) abstract, outline, precis. <B>~a</B>. analitical. <B>~ema</B>, critical. <B>~isto</B>, analyst. <B>Sin~o</B>, introspection.", "0"],
["analoga", "analog-a", "[OA] Analog/ous, parallel, similar. <B>~(aĵ)o</B>, -ue, -y. <B>~eco</B>, agreement, resemblance of form or function. (log) <I>rezonado laŭ ~eco</I>, reasoning by -y, from parallel cases, (lin) imitation of construction or inflection.", "0"],
["analoj", "anal-oj", "(<I>jarkroniko</I>), (hist) Annal/s, yearly records, narrative of historical events. <B>~isto</B>, -ist. [<I>Ne = jarlibro</I>]. ➞ <I>kronik</I>.", "0"],
["anamirto", "anamirt-o", "fish (Indian) berries, \"cockles\" (<I>Anamirta</I>).", "0"],
["ananaso", "ananas-o", "[UV] pineapple (<I>Ananas sativus</I>)", "0"],
["anapesto", "anapest-o", "[OA] (pros) anapaest (\"\"-).", "0"],
["anarĥio (anarkio)", "anarĥi-o (anarki-o)", "[OA] Anarch/y, absence of government, disorder, pol. confusion. <B>~ismo</B>, <B>~isto</B>, -ism, -ist (a. <B>anark-ism</B>, <B>-ist)</B>. ➞ <I>ĥaos, nihil, senbrid, senord</I>.", "0"],
["anarkiko", "anarkik-o", "(<I>mara lupo</I>), sea-wolf, wolf- fish (<I>Anarchicas lupus</I>).", "0"],
["anaso", "anas-o", "[UV] <B>~ino</B>, Duck (<I>Anas</I>). <B>~oj</B>, denotes ducks in gen. <B>Brunkapa ~o</B>, common pochard. <B>Fajf~o</B>, wigeon. <B>Histrion~o</B>, harlequin duck. <B>Krik~o</B>, teal. <B>Kuler~o</B>, shoveller. <B>mol~o</B> [UV] (<I>= somaterio</I>), eider. <B>Pintvosta ~o</B>, pintail. <B>Rok~o</B>, scaup (<I>Aytha marila</I>). <B>Sovaĝa ~o</B>, wild duck, mallard. <B>~ido</B>, -ling, <B>~iri</B>, waddle. <B>Vir~o</B>, drake. ➞ <I>fuligol, kerkedol, klangol, melanit, merĝ, nirok, somateri, streper, tadorn</I>.", "0"],
["anastatiko", "anastatik-o", "(<I>Jeriĥa rozo</I>), rose of Jericho (<I>Anastatica</I>).", "0"],
["anatemo", "anatem-o", "(ecc) Anathem/a, ban, curse by the Church, excommunication. <I>Sub ~o</I> (Jos 6/17). <B>f</B> execration, imprecation. <B>~i</B> (<I>-n</I>), -atize, curse. (Rd 7/2,26), <B>~aĵo</B>, <B>(~ito)</B>, accursed thing (person). ➞ <I>ekskomunik, elpel, malben</I>.", "0"],
["anatomio,", "anatom-io,", "[OA] Anatom/y. <B>~a</B>, -ical, structural. <B>~(iist)o</B>, -ist.", "0"],
["anĉovo", "anĉov-o", "[OA] spiced Anchovy or sprat. <B>~a</B> <I>butero</I>, a-paste. <I>saŭco</I>. ➞ <I>engraŭl, sprot</I>.", "0"],
["andanto", "andant-o", "(mus) andant/e (= moderately slow) <B>~ino</B>, -ino.", "0"],
["Andoro", "", "AD", "0"],
["andreno", "andren-o", "andrena, solitary bee (<I>Andrena</I>).", "0"],
["andromedo", "andromed-o", "andromeda, bog rosemary, heathwort (<I>Andromeda</I>).", "0"],
["andropogono", "andropogon-o", "genus of grasses (<I>Andropogon</I>) &gt; broom sedge.", "0"],
["androsemo", "androsem-o", "tutsan (<I>Hypericum androsemum</I>). ➞ <I>hiperik</I>.", "0"],
["anekdoto", "anekdot-o", "[OA] (<I>rakonteto</I>), anecdot/e, narrative of detached incident. <B>~a</B>, -al. <B>~aro. ~ema</B>, garrulous. <B>~isto</B>.", "0"],
["aneksi", "aneks-i", "(<I>-n</I>) [OA], Annex. <B>1</B> (pol) take possession of (<I>teritorio</I> etc.). <B>2</B> append. <B>~(aĵ)o</B>, <B>1</B> -ation. <B>2</B> annex, addition to document, building. <B>~ismo</B>, <B>~isto</B>, -ation -ism (-ist). ➞ <I>proprig, preni por si</I>.", "0"],
["anelido", "anelid-o", "annelid, segmented (or bristle) worm (<I>Annelida</I>).", "0"],
["anemio", "anemi-o", "(<I>sangmanko</I>), Anaem/ia, unhealthy pallor. <I>~o pereiga</I>, pernicious a. <B>~a</B>, -ic, lacking blood. <B>~igi</B>, impoverish, weaken, <B>~ulo</B>, -ic.", "0"],
["anemono", "anemon-o", "[OA] (<I>ventrozo</I>), Anemone, wind-flower. <B>Paska ~o</B>, pasque flower (<I>A. Pulsatilla</I>), <B>f Mar~o</B>, sea-a (<I>aktinio</I>).", "0"],
["anerojda", "anerojd-a", "aneroid. <I>~a barometro</I>.", "0"],
["anestezi", "anestez-i", "(<I>-n), (sensentigi</I>), Anaesthe/tize. <B>~o</B>, -sia, local insensibility. <B>~aĵo</B>, <B>~ilo</B>, -tic. <B>~isto</B>, -ist. ➞ <I>kloroform, narkot</I>.", "0"],
["aneto", "anet-o", "(bot) dill (<I>Anethum). ~akvo,</I> d-water.", "0"],
["aneŭrismo", "aneŭrism-o", "(med) aneurism, localized dilatation of artery. ➞ <B>varik</B>.", "0"],
["anfio", "anfi-o", "Reed, tongue, of m.i. <I>~instrumento. ~o libera</I>, free r. <B>~a</B> <I>familio</I>.", "0"],
["angeliko", "angelik-o", "[OA] (bot) angelica (<I>Angelica</I>).", "0"],
["angilo", "angil-o", "[UV] Eel (<I>Anguilla</I>). <B>Mar~o</B> (<I>kongro</I>), conger. <B>Sabla ~o</B>, sand-e. <B>~ejo</B>, e-pond. ➞ <I>kongr, muren</I>.", "0"],
["angino", "angin-o", "[OA] Angina. <B>Brust~o</B> (a. <I>brustangoro</I>), a. pectoris. ➞ <I>tonsilit</I>.", "0"],
["angio", "angi-o", "blood-vessel, lymph-vessel. <B>~a</B>, vascular.", "0"],
["anglikano", "anglikan-o", "anglican, churchman, member of the Church of England (<I>~a eklezio</I>). ➞ <I>cant</I>.", "0"],
["Anglujo", "Angl-ujo", "Anglio [FE]", "0"],
["Angolo", "Angol-o", "AO", "0"],
["angoro", "angor-o", "[OA] anguish, severe bodily or mental pain, intense distress (Ce 1/15). <B>Brust~o</B>, angina pectoris. <B>Mort~o</B>, pangs of death. <B>~a</B>, harrowing, heart-rending, poignant. ➞ <I>agoni, doloreg</I>.", "0"],
["angosturo", "angostur-o", "Angostura (<I>Cusparia angostura</I>). <B>~a</B> <I>ŝelo</I>, a-bark. <I>~a likvoro</I>, a-bitters.", "0"],
["angulo", "angul-o", "[UV] <B>1</B> (geom) Ang/le. <I>~o akuta, obtuza</I>, acute (obtuse) angle. <I>~o orta (ort~o</I>), right a. <I>Vid~o</I>, a. of sight, (av) <I>Driv~o, staŭl~o, trak~o</I>, drift-, stall-, track-angle. (mec) <I>frot~o, prem~o</I>, friction-(pressure-) angle. <B>2</B> Corner (<I>malvasta loko). ~o de ĉambro, domo, kameno. ~o de la kamparo. Kaŝ~o</I>, nook, recess. <B>~a</B>, angular; bony (<I>vizaĝo</I>); rugged (<I>konturo). Iri</I> ~en (<I>ĉirkaŭ la ~on</I>), turn the c. <B>~aĵo (~fero</B>, <B>~relo)</B> a-iron, V-rail. <B>~eco</B>, angularity. <B>~eto</B>, niche, nook. <B>~ilo</B>, square. <B>~mezurilo</B>, protractor. <B>~ŝtono</B>, cornerstone (Ij 38/6). <B>Egal~a</B>, equiangular. <B>En~igi</B>, corner. <I>t= premi al la muro (senelirejo</I>). <B>Rekt~a</B>, rectangular. &gt; <I>oblongo</I>. <B>Strat~o</B>, street c. <B>Tri~o</B>, (geom, m.i.), triangle. similar <B>kvin~o</B> (<I>pentagono</I>), pentagon.", "0"],
["angviso", "angvis-o", "(zoo) blindworm, slowworm (<I>Anguis</I>).", "0"],
["anĝelo", "anĝel-o", "[UV] Angel. <I>~o falinta, malbona</I>. <B>Gard~o</B>, guardian a. <B>f</B> lovely or innocent being. <B>~(in)o</B> <I>mia!</I> <B>~a</B>, -ic. <I>~a kanto, vizaĝo</I>. <B>~aro</B>, host of angels. (col) <B>~eto</B>, little cherub. <B>Ĉef~o</B>, arch-a. ➞ <I>diabl, kerub, seraf, skvaten, spirit</I>.", "0"],
["anĝeluso", "anĝelus-o", "Angelus. <B>1</B> prayer. <B>2</B> (<I>~a sonorilo</I>), <B>a</B>-bell.", "0"],
["anheli", "anhel-i", "(<I>spiregi</I>), (nt) be out of breath, breathe hard, gasp, pant. <I>~i pro kurado. ~antaj ĉevaloj. \"Rapidu!\" ŝi ~is</I> (gasped).", "0"],
["anhidra", "anhidr-a", "(chem) anhydr/ous, water-free. <B>~a</B> <I>kalko</I>, quicklime. <B>~ido</B>, -ide. <I>Sulfata (sulfita) ~ido</I>. <B>~ito</B>, ~ite (Ca S0<SUB>4</SUB>).", "0"],
["anilino", "anilin-o", "[OA] (<I>fenilamino</I>), Aniline. <B>~a</B> <I>nigra</I>, a-black. <I>~a presado. ~a ruĝo (fuksino</I>), fuchsine, magenta. <B>Roz~o</B><I>,</I> ros-a.", "0"],
["anilo", "anil-o", "Anil, indigo plant (<I>Indigofera anil</I>). <B>~ido</B>, -ide.", "0"],
["animalkulo", "animalkul-o", "animalcule.", "0"],
["animalo", "animal-o", "[OA 8], Animal, living being, member of the <B>~a</B> <I>regno</I> (a. kingdom). <B>~ismo</B>, -ism", "0"],
["animo", "anim-o", "[UV] Anim/ating spirit, soul. <B>1</B> (immaterial being): <I>La senmorteco de la ~o</I>. <B>2</B> (emotional being) (1 Sa 18/1): <I>Nobla ~o. Lia tuta ~o ribelis kontraŭ tio</I>. <B>3</B> (heart, central part): <I>Li estis la ~o de la entrepreno</I>. <B>4</B> (life) (Ge 1/30, Ps 33/19): <I>Ellasi sian ~on</I>. <B>~a</B>, of the soul. -ate, breathe life into, enliven, quicken, inspirit. <B>~ita</B> (actuated prompted) <I>de ĵaluzo;</I> (buoyed up) <I>de espero</I>. <B>~eco</B>, -ation. <B>~ismo</B>, -ism. <B>Bon~a</B>, benignant, good-natured <B>Egal~a</B>, calm, even- tempered. <B>~~eco</B>, equity. <B>Facil~a</B> (Ce 3/4), fickle, frivolous, hare-brained. <B>grand~a</B>, [UV] high-souled, magnanimous. <B>Larĝ~a</B>, liberal-minded. <B>Malgrand~a</B>, mean, small-minded. <B>Re~i</B>, re-a. <B>Simpl~a</B>, ingenuous, naive, simple-minded, straightforward, unaffected. <B>Sobr~a</B>, sober-minded. <B>Trankvil~a</B>, placid. <B>Unu~a</B>, unanimous. <B>Vent~a</B>, flighty, scatter-brained, ➞ <I>inspir, psik, spirit</I>. Opp <I>korp, mens</I>.", "0"],
["anizo", "aniz-o", "[UV] Anise (<I>Pimpinella anisum) ~a semo</I>, aniseed, <B>~likvoro</B>, a- cordial. ➞ <I>ilici (stel~o</I>).", "0"],
["ankaŭ", "", "(adv), [UV] Also, too. <I>~ mi kantos,</I> I, too, will sing. <I>Amiko de amiko estas ~ amiko. Ne nur …, sed</I> not only … but a. ➞ <I>ceter, krom</I>. Precedes the word to be emphasized.", "0"],
["ankilozo", "ankiloz-o", "(<I>artika rigidiĝo</I>), ankylosis, stiffening of joints. <B>~igi</B>, <B>~iĝi.</B>", "0"],
["ankoraŭ", "", "(adv), [UV] 1 (<I>ĝis nun, ĝis tiam</I>) (shows continuation, no change) = Still, Yet, till (up to) now (tm in question). <I>Li ~ kantas</I>, he (was and) is s. singing. <I>Virino - juna</I>. <B>Rim</B>.: Place <I>ankoraŭ</I> before a negative word. ~ <B>ne</B>, not y., s. not. <I>Li</I> <B>- ne</B> <I>kantas</I>, he (was not, and) is s. not singing, he is not singing y. ~ <B>neniam</B>, never yet. <B>A7~nenion</B> <I>scias</I>, we know nothing yet, we s. know nothing. <B>2</B> (<I>denove, plue, ree</I>), s.(y.) another (more, besides). <I>~ kelke da vortoj</I>, s. (y.) a few words more. - <I>alia,</I> yet another. <I>Ni bezonas ~ du</I>, another two (two more). <I>Kion</I> What else? ➞ <I>ali, bis, jam, krom, pli, plu</I>. <B>Rim.:</B> Use <B>jam ne</B>, not <B>ne ankoraŭ</B>.", "0"],
["ankro", "ankr-o", "[UV] Anchor. <B>Flot~o</B>, sea-a, drogue. <I>~o granda (malgranda</I>), sheet (ketch) a. <B>~i</B> (-n, abs) (<I>ĵeti ~on</I>), anchor, cast (drop) a. <I>~i ŝipon</I>. <B>f</B> fix firmly. <B>~ita</B>, at anchor. <B>~ejo</B>, anchorage. ➞ <I>rod</I>. <B>~iĝi</B>, <B>f</B> settle down. <B>~otreni</B>, drag a. ➞ <I>grapl, ŝtok</I>.", "0"],
["ankuzo", "ankuz-o", "(bot) alkanet, anchusa (<I>Anchusa</I>).", "0"],
["anobio", "anobi-o", "(<I>frapskarabo</I>), death-watch beetle (<I>Anobium</I>). <B>~a</B> <I>larvo</I>, bore-worm, <B>~borita</B> (<I>vermborita</I>), worm-eaten.", "0"],
["anodo", "anod-o", "(el) anode, positive pole or terminal.", "0"],
["anodonto", "anodont-o", "swan mussel (<I>Anodonta</I>).", "0"],
["anofelo", "anofel-o", "malaria gnat (<I>Anopheles</I>), ordinary language <I>moskit</I>.", "0"],
["anomalio", "anomali-o", "[OA] anomaly, departure from normal, irregularity. <B>~a</B>, anomalous, abnormal, exceptional. ➞ <I>aberaci, nenormal</I>.", "0"],
["anomuro", "anomur-o", "hermit crab (<I>Anomura</I>). ➞ <I>pagur</I>.", "0"],
["anonci", "anonc-i", "(<I>-n, al, pri; ke</I>), [UV] announce, advertise, give out, give public notice of, make known, notify, proclaim; break (<I>malbonan novaĵon</I>); intimate presence of (<I>vizitanto</I>); publish (banns). <I>Esti preĝej~ita</I>, have one’s banns read, (cgm) declare. <B>~o</B>, announcement, notice, notification, proclamation. <B>Edziĝ~o</B>, <B>gazet~o</B>. <I>Lum~o,</I> illuminated sign, (rel) Annunciation. (mus) <I>~o (a ~sekcio) (de fugo, sonato</I>), exposition. <B>~ado</B>, advertising. <B>~anto</B>, (th) <B>~isto</B>, compere, <I>publika ~isto</I>, town crier. <B>~ilo</B>, prospectus. <B>~agento</B>, <B>~oficejo</B>, advertising agent (agency). ➞ <I>afiŝ, aviz, inform, publik, reklam, sciig</I>.", "0"],
["anonima", "anonim-a", "[OA] Anonym/ous, nameless, unnamed. <I>~a bonfaranto, aŭtoro, letero</I>. <B>~eco</B>, -ity. <B>~ulo</B>, a. person. <B>~a societo</B>, joint-stock (limited liability) company. ➞ <I>inkognit, nekonat, pseŭdonim, sennom, sensubskrib</I>.", "0"],
["anono", "anon-o", "custard apple, etc. (<I>Anona</I>).", "0"],
["anorako", "anorak-o", "(cl) anorak.", "0"],
["ansero", "anser-o", "[UV] <B>~ino</B>, Goose (<I>Anser</I>). <B>~oj&gt;</B> geese (in gen.), <B>~o blankfrunta</B>, white- fronted g.; <B>blankvanga</B>, barnacle g.; <B>faba</B>, bean g.; <B>griza</B>, greylag; <B>Kanada</B>, Canada g.; <B>kolringa</B>, brent g.; <B>neĝa</B>, snow g.; <B>ruĝkola</B>, red-breasted g. <B>~a.</B> anserine, silly, <B>f</B> <I>~a haŭto</I>, g-flesh. <B>~ido</B>, gosling. <B>~bleki</B>, gaggle. <B>~vice</B>, in single file. <B>Vir~o</B>, gander.", "0"],
["anso", "ans-o", "(<I>tenilo</I>). <B>1</B> knob (<I>porda, tirkesid</I>). <B>2</B> other outstanding pt; bight, loop (<I>ŝnura</I>); ear (<I>sonorila</I>); haft (<I>ponarda, riglila</I>); handle (<I>korba, kruĉa; tasa</I>); sash-fastener (<I>fenestra</I>); shank (<I>butona</I>). <B>~eto</B>, ring of metal. <B>~igi</B> (<I>meti ~e</I>), put akimbo (<I>la brakojn</I>), (org) <B>Tir~o</B>, stop. ➞ <I>klink</I>.", "0"],
["anstataŭ", "", "[UV] instead of. <B>1</B> (prep) = as a Substitute for, in place (default, lieu) of, for. <I>Mi iris ~ li. ke ĉiu iru</I>. <B>2</B> (conj) (before infinitive). <I>Li dormis ~ labori</I> (instead of workg). <I>Skribu al li, ~ (skribi) al mi</I>. Write to him instead of (writg) to me. <I>Iri dekstren, ~ (iri) maldekstren</I>. <B>~a</B>, proxy, spare, refill. (➞ <I>provizor, vie). <B>~e</B></I>, instead, as a s., in exchange, in (his) stead. ~e de, in exchange for. <B>~i</B> (<I>-n</I>), [UV] act (be a s.) for, be in (fill, take) the place of, represent, understudy. <I>Mi ~os vin</I>. <B>~aĵo</B> (<I>surogato</I>), s. <B>~anto</B>, <B>~ulo</B>, s., proxy. ➞ <I>agent, vikari</I>. ~igi <I>A per B;</I> replace A ‘by B(=s. B for A, put B in place of A). <I>~igo</I>, substitute, supersession. <I>Ne~igebla,</I> irreplaceable. <B>Rim</B>.: The accusative after <I>anstataŭ</I> is useful to avoid ambiguity. <I>Petro batis Paŭlon ~ (bati) Vilhelmon. Vilhelmo</I> word mean instead of W’s doing so). <I>Mi helpos vin ( ~~ al vi) ~ Petron (al Petro). ~ Petro</I> word mean Peter’s doing so. But Z. sometimes omits the accusative where no ambiguity is possible, e.g., <I>~ kafo li donis al mi teon</I> (E/26). Vd. LR.77.", "0"],
["anstromo", "anstrom-o", "(ph) angstrom.", "0"],
["ant", "-ant", "[UV] (ending of present active participle) = -ing. <B>Fal~a</B> <I>folio</I>, falling leaf. <B>Instru~e</B>, (by, in, when, while, teaching), <I>oni lernas. Li staris, nenion</I> <B>dir~e</B> (without saying anything). <B>IT -anto</B> usually means a person <B>(=-antulo). Rigard~o</B>, looker-on. But it may also mean an object <B>(=-antaĵo)</B>, <B>Divid~o</B>, divisor.", "0"],
["antagonismo", "antagon/ismo", "antagon/ism, active opposition. <I>Veki ~ismon</I>, -ize. <B>-isto</B>, -ist, adversary, opponent. ➞ <I>konflikt, kontraŭul, batalant, opon, opozici</I>.", "0"],
["antanaklazo", "antanaklaz-o", "(rh) use of word with different meanings in same sentence, e.g., \"The more I think of it, the less I think of it.\" ➞ Mat <B>8/22</B>, <I>vortludo</I>.", "0"],
["Antarkto", "Antarkt-o", "[OA 9], <B>~a</B> [OA 9]. <I>la A~a cirklo</I>; <I>A~a klimato</I>; <I>A~a glacio</I>.", "0"],
["antaŭ", "", "[UV]. I (prep): Before (place or time), (a) PLACE: = before, in front of. (Position): <I>stari ~ la domo, iri ~ la domon. Jxeti perlojn ~ porkojn</I>. (Priority): <I>~ ĉio,</I> Above (first of) all, especially (➞ <I>precip). Aferoj ~ plezuro</I>. (In the presence of): <I>Parolu ~ li</I>, speak in his presence. <I>Timo</I> ~(or <I>al) Dio</I>, fear of God. (From): <I>Kaŝu nenion ~</I> (or <I>de) mi</I>, Hide nothing from me. (b) TIME (<I>= pli frue ol</I>): (a) b., earlier than. <I>~ tiam</I>, b. then <I>~ la oka</I>, b. 8.0. (b) Ago (= b. now, in the past): <I>~ du jaroj</I>, two years ago. <I>~ longe</I>, long since. <I>~ nelonge</I>, recently, not long ago . <B>~a</B>, antecedent. X Fore, front. <I>La ~a vico</I>. <B>2</B> Former, previous, prior, quondam. <I>En ~a vivo</I>. <B>~e</B>, X (<I>fronte</I>), ahead, in advance, <I>Li marŝis ~e</I>. <B>2</B> First, previously, ~e <I>pensu, poste agu. Jam <B>~e</B></I>, beforehand. <B>~(ir)i</B>, precede. <B>~en</B>, forward(s), onward(s), to the front. <I>~enigi</I>, further, help on, promote. <I>~enema</I>, forward, progressive, pushing. <B>~(aĵ)o</B>, (<I>fronto</I>), fore (part), front, prow; vamp (<I>ŝuo</I>). <B>~eco</B>, precedence, priority. <B>~ulo</B>, fore-runner, predecessor. <B>Mal~e(n)</B>, at (to) the back (rear), abaft, aft, astern, behind. <B>Kap~e</B>, head foremost.", "0"],
["antemido", "antemid-o", ". Chamomile (<I>Anthemis</I>). <B>~o fetora</B>, stinking c. <B>~o flava</B>, yellow c. <B>~o grenkampa</B>, corn c. ➞ <I>kamomil, matrikari</I>.", "0"],
["antemo", "antem-o", "anthem, British species of motet, usually with Biblical words.", "0"],
["antenario", "antenari-o", "(bot) cat’s foot, mountain everlasting (<I>Antennaria</I>).", "0"],
["anteno", "anten-o", "[OA] <B>1</B> (ent, zool) feeler, horn (➞ <I>palpil, tentakl</I>). <B>2</B> (rad) aerial. <I>~o direktebla, dissenda, frama, libera, pendanta, riceva</I>. <B>~a</B> <I>drato</I>, aerial wire.", "0"],
["antero", "anter-o", "(bot) anther, pt of stamen containing pollen.", "0"],
["anti", "anti-", "= kontraŭ, anti-, against, opposed to. <I>~alkohola, ~biotika, ~febra, ~klerikala, ~sepsa, ~tusa; ~ciklono, ~klimakso, ~militismo, ~semito</I>.", "0"],
["antiaro", "antiar-o", "antiar, Javanese tree (<I>Antiaris</I>). <B>~o toksa</B>, upas tree.", "0"],
["anticipi", "anticip-i", "(<I>-n</I>), [OA], Anticipat/e. <B>1</B> act (take, use) in advance. <I>~i pagon</I>. <B>2</B> be beforehand, before another, forestall. <I>~i agon</I>. <B>3</B> realize in advance, bank (reckon) on. <I>~i konkludon de argumento</I>. <B>4</B> expect, fore-see (taste), have a previous impression, look forward to. <I>~i deziron, eventon, sukceson</I>. <B>~o</B>, -ion, foretaste, instinctive prevision. (rh) prolepsis (Mt 3/9); <B>~a</B> (<I>antaŭdata</I>), in -ion (advance). <I>~a pago</I>. (mus) ~a <I>noto</I>, -ion note. <I>Pagi, danki, ĝui</I> <B>~e</B>.", "0"],
["antidorko", "antidork-o", "(<I>saltantilopo</I>), springbok. (<I>Antidorcas</I>).", "0"],
["antidoto", "antidot-o", "(<I>kontraŭ</I>), antidote. ➞ <I>kontraŭrimed, kontraŭvenen</I>.", "0"],
["antifono", "antifon-o", "(mus) Antiphon; versicle sung by one choir in response to another. <B>~a</B>, -al, sung alternately, <I>decani</I> against <I>cantoris</I>. <I>~a kantado</I>. <B>~aro</B>, -ary. ➞ <I>antem, ĉant</I>.", "0"],
["Antigvo kaj Barbudo", "", "AG", "0"],
["antikva", "antikv-a", "[UV] antiqu/e. <B>1</B> ancient, from old time, of the past. <I>~a ceremonio, lingvo, tempo, urbo</I>. <B>2</B> Old-fashioned. <I>~a mebl -(rob-)o. De</I> <B>~e</B>, of olden time. <B>~aĵo</B>, object. of ancient art, relic. <I>~aĵisto</I>, dealer in -ities. <B>~eco</B>, -ity. <B>~isto</B>, -arian. ➞ <I>arkaik, arkeolog, malmodern, malnovmod, praform, pratemp</I>.", "0"],
["antilido", "antilid-o", "kidney vetch, lady’s fingers (<I>Anthyllis</I>).", "0"],
["antilokapro", "antilokapr-o", "prongback, pronghorn (<I>Antilocapra</I>).", "0"],
["antilopo", "antilop-o", "[OA] antelopo (<I>Antilope</I>) (Rd 14/5). ➞ <I>antidork, antilokapr, cefalof, gazel, kama, oriks</I>.", "0"],
["antimono", "antimon-o", "[UV] (chem) antimony, stibium (Sb).", "0"],
["antinomio", "antinomi-o", "antinomy, contradiction, discrepancy (in a law, or between laws or opinions). ➞ <I>paradoks</I>.", "0"],
["antiopo", "antiop-o", "(ent) Camberwell beauty butterfly, mourning cloak (<I>Nymphalis antiopa.</I>)", "0"],
["antipatio", "antipati-o", "(<I>al, inter, kontraŭ</I>) [OA], antipathy, constitutional or settled aversion, strong dislike. <I>~oj kaj simpatioj</I>. <B>~a</B>, repugnant, to which one has aversion. <I>~a homo, kutimo. Li estas por mi ~a</I>, I dislike him. ➞ <I>abomen, alergi, malestim, malinklin, naŭz</I>, opposite <I>simpati</I>.", "0"],
["antipirino", "antipirin-o", "(med) antipyrin.", "0"],
["antipodo", "antipod-o", "[OA] Antipod/es, other side of earth. <B>~a</B> (<I>diametre kontraŭa</I>), direct opposite. <I>Lando ~a</I>. <B>~ano</B>, <B>~ulo</B>, -ean.", "0"],
["antireno", "antiren-o", "(<I>leonfaŭko</I>), (bot) snapdragon, bunnie’s mouth (<I>Antirrhinum</I>).", "0"],
["antitezo", "antitez-o", "[OA] (rh) antithesis, contrast of ideas, phrases, words (Mk 2/27; Jes 59/9; 65/13,14).", "0"],
["antoksanto", "antoksant-o", "vernal grass (<I>Anthoxanthum). ~o odora</I>, sweet v-g.", "0"],
["antologio", "antologi-o", "[OA] anthology, collection of choice poems, etc. ➞ <I>krestomati</I>.", "0"],
["antonimo", "antonim-o", "(rh) antonym, word with opposite meaning.", "0"],
["antonomazio", "antonomazi-o", "(rh) antonomasia, use of epithet or descriptive phrase instead of proper name.", "0"],
["antracito", "antracit-o", "(<I>ŝtonkarbo</I>), anthracite.", "0"],
["antrakso", "antraks-o", "anthrax, inflammatory skin lesions. <B>1</B> of sheep and cattle. <B>2</B> in man by infection from this. ➞ <I>absces, furwk, karbunkol</I>.", "0"],
["antrisko", "antrisk-o", "&gt; beaked parsley, bur chervil (<I>Anthriscus</I>). ➞ <I>cerefoli</I>.", "0"],
["antrop", "antrop-", "(<I>hom-</I>), (ppfx) anthrop-. <B>~ocentra</B>, -ocentric. <B>~ojda</B> (<I>homsimila</I>), -oid.", "0"],
["antropologo", "antropolog-o", "[OA] <B>~io</B>, [OA] -ologist, -ology. <B>~ometrio</B>, -ometry, <B>~omorfismo</B>, (rh) -omorphism, attribution to God of human form or personality.", "0"],
["antuso", "antus-o", "= pipio.", "0"],
["Anunciacio", "Anunciaci-o", "[UV] = anonco (rel).", "0"],
["anuso", "anus-o", "(anat) An/us. <B>~a</B>. -al.", "0"],
["aoristo", "aorist-o", "(gram) aorist, tense with limitation.", "0"],
["aorto", "aort-o", "[OA] aorta, chief artery from heart.", "0"],
["apaĉo", "apaĉ-o", "apache, <B>1</B> West American indian. <B>2</B> city rough, hooligan.", "0"],
["apanaĝo", "apanaĝ-o", "ap(p)anage, allowance to royal children. <B>2</B> perquisite.", "0"],
["aparato", "aparat-o", "[OA] apparatus. <B>1</B> outfit, plant, set, tackle. <B>2</B> appliance, device, gear, mechanism. <B>3</B> instrument, machine. <I>~o administra, fota, fotografa, telegrafa. Gas~o,</I> gas fittings. (anat) ~o <I>digesta, reprodukta, spira</I>. ➞ <I>ekip, il(ar), instrument, maŝin, organar</I>.", "0"],
["aparta", "apart-a", "[UV] Separ/ate. <B>1</B> apart, distinct, independent, particular, reserved. <I>~a ĉambr-(fak-kovert-kupe-)o. ~a loko por ĉio</I>. <B>2</B> one’s own., e.g., special, out of the ordinary, unique. <I>~a intereso, trezoro</I> (Mai 3/17). (typ) <I>~aj literoj</I>, movable type. <B>~e</B>, -ately, (e)specially; aloof, aside, in a stage whisper. <B>~aĵo</B>, -s. compartment, section(Ge 6/14); <B>~eco</B>, characteristic, speciality. <B>~ejo. ~igi</B> (<I>-n de</I>), -ate, isolate, segregate, set apart (aside) (Ge 1/4); devote, reserve. <B>~igo</B>, distinction (El 9/4). <B>~iĝema</B>, unsociable, <B>~ismo</B>, -ism. <B>Nc~igebla</B>, in-able, indissolubly bound. ➞ <I>fak, flank, komun, malkun, precip, sol, special</I>.", "0"],
["apartamento", "apartament-o", "[OA] (<I>ĉambraro</I>), apartments), flat, suite (of rooms).", "0"],
["aparteni", "aparten-i", "(<I>al</I>), [UV] <B>1</B> belong to. <I>Ĝxi ~as al mi ~~ Ĝi estas mia</I>, it is my property. <B>2</B> appertain (be appropriate or due) to. be the affair of, depend on, relate to. <I>Lingvaj decidoj ~as al la Akademio. La honoro ~as al vi. Tio ne ~as al</I> (does not fall within) <I>miaj devoj. Ne ~as al mi (~i</I>), It does not behove (fall on) me, is not incumbent on me (to). <B>3</B> Be one (or, part) of. <I>Mi ~as al la komitato</I>. <B>~aĵo</B>, (Ge 2/1).", "0"],
["apatio", "apati-o", "[OA] Apath/y, indifference, insensibility to suffering, mental indolce. <I>~o de la publiko. Afekti ~on, Levi el ~o,</I> rouse. <B>~a</B>, -etic, listless. ➞ <I>indiferent, malvigl, nesentem, senenergi, senpasi</I>.", "0"],
["apaturo", "apatur-o", "purple emperor butterfly (<I>Apatura</I>).", "0"],
["apekso", "apeks-o", "apex, peak, tip, top. vertex. <B>~a</B>, apical.", "0"],
["apeli", "apel-i", "[<B>apelaci-i</B> [OA]] (<I>alvoki proteste aŭ por subteno</I>), Appeal. <I>~i al publika opinio (sento de justo, supera tribunalo). ~i kontraŭ verdikto</I>. <B>~o</B>, appeal. <B>~a</B> <I>tribunalo,</I> court of a. <B>~anto</B>, appelant. <I>Juĝo</I> <B>sen~a</B>, final judgment. ➞ <I>sin turni</I>.", "0"],
["apenaŭ", "", "[UV] (<I>etym = kun peno</I>), Hardly, Only Just, barely, scarcely. <B>1</B> (achievement): (= preskaŭ ne): only with difficulty. <I>Mi ~ povas vidi (= mi preskaŭ ne povas vidi</I>), I can hardly (o.j., scarcely) see, I can see only with an effort. <I>~ kaŝita,</I> thinly disguised. <B>Rim</B>.: Conversely, apenaŭ ne = preskaŭ (Ps 73/2). <I>Li ~ ne dronis = li preskaŭ dronis</I>), he almost (all but, well nigh) drowned, barely escaped drowning. <B>2</B> (time) (<I>nur ĵus): ~ ŝi venis</I>. she had hardly (o.j.) come. <I>~ li ricevis ĝin,</I> no sooner had he got it (than). (Ge 40/10, 1 Sa 4/18, 1 Rĝ 14/17, Ps 37/36) <B>3</B> (measure) (<I>ne pli ol</I>): not more than, at the most. <I>Mi rest is ~ du horojn</I>. <B>~a</B>, almost imperceptible.", "0"],
["apendico", "apendic-o", "(anat) appendix. <I>~o vermoforma</I>. <B>~ito</B>, appendicitis.", "0"],
["aperi", "aper-i", "(nt), [UV] Appear. <B>1</B> (<I>ekesti, vidiĝi): become</I> visible (manifest), come into view, show, turn up. <I>~i ĉe la pordo (antaŭ la publiko). Jam ~is la primoloj</I>. <B>2</B> (<I>sin montri</I>): present one’s. <I>~i antaŭ la tribunalo</I>. <B>3</B> (<I>eldoniĝi</I>): be published. <I>La libro ĵus ~is</I>. <B>~o</B>, appearance, -ing (➞ <I>epifani</I>). <B>~aĵo</B>, <B>~anto</B>, apparition, phenomenon (➞ <I>fenomenon, fantom, vizi</I>). <B>~eti</B>, show the tip of one’s nose. <B>~igi</B>, bring out, cause to a., reveal. ➞ <I>malkaŝ, malkovr</I>. (phot) (<I>riveli</I>), develop. <B>~igilo</B>, developer. <B>Ek~i</B>, break out, crop (loom) up. <B>mal~i</B>, [UV] disappear, pass away, vanish. <I>~~i kiel vaporo (ŝtono en maron</I>). ➞ <I>forpas, neniiĝ, mort, pere, vaporiĝ</I>. <B>~~ema</B> (<I>efemera</I>), ephemeral, passing. <B>~~igi</B>, efface, remove (➞ <I>detru, elimin, forig, forviŝ, vual</I>). <B>~~inta</B>, missing. <B>Re~i</B>, reappear. <B>~~antoj</B>, ghosts (Ibsen). [Ne= seem (<I>aspekt, mien, ŝajn</I>)].", "0"],
["aperitivo", "aperitiv-o", "(alcoholic) aperitif, appetizer.", "0"],
["aperturo", "apertur-o", "[OA] (<I>malfermaĵo</I>) (Ge 7/11, El 39/23, Jos 10/22), Aperture, gap, mouth, opening, orifice. <I>~o de buŝo, fenestro, kamero, puto, tubo, vesto</I>. <B>Son~oj</B> <I>de turo</I> (1 FA 36/40). ➞ <I>bus, fend, luk, tru</I>.", "0"],
["apetit", "", "<B>-o,</B>, [OA] Appet/ite. desire (inclination) for food, etc, relish. <I>Bremsi</I> (curb), <I>Perdi</I> (lose) <I>la ~on. Bonan ~on!</I> <B>~i</B> (<I>al</I>), crave for, desire. <B>~odona</B>, <B>~veka</B>, -izing. <I>Manĝi</I> <B>bon~e</B>, heartily. <B>Sen~a</B>, without a. ➞ <I>dezir, gust, ĝu, palatoplaĉ</I>.", "0"],
["apika", "apik-a", "steep, vertical, (mar) <I>Ankri ~e (superankre</I>), up and down.", "0"],
["apio", "api-o", "[OA] smallage, wild celery &gt; fool’s watercress (<I>Apium</I>). ➞ <I>celeri, petrosel</I>.", "0"],
["apioso", "apios-o", "(bot) earthnut (<I>Apios</I>).", "0"],
["aplanata", "aplanat-a", "(opt) aplanatic. <I>~a lenso</I>.", "0"],
["aplaŭdi", "aplaŭd-i", "(<I>-n, al</I>, abs), [UV] applaud; express approval, especially cheer, clap. <I>~i oratoron, spektaklon</I>. <B>f</B> commend, publicly praise. <I>~i ies kuraĝon. ~o,</I> applause, loud approbation. <B>~egi</B> (<I>tondre ~i</I>), (th) bring the house down. <B>~ema</B>, appreciative. <B>~istaro</B>, (th) hired clappers. ➞ <I>aklam, gratul, laŭd, ovaci</I>.", "0"],
["apliki", "aplik-i", "(<I>-n, al</I>) [OA], Appl/y, bring to bear on, employ (use) for special purpose, put into contact with, practice, turn to account, utilize. <I>~i epiteton, kataplasmon, leĝon, metodon, regulon, sperton. Sin ~i al</I>, a. one’s to. <I>~itaj sciencoj</I>. <B>~o</B>, -ication. <I>~o (de bandaĝo</I>), devotion (<I>al studado</I>). <B>~ebla</B>, <B>~iĝi</B>, (be) -icable. ➞ <I>adapt, almet, praktik, rilatig, utilig, uz</I>. [Ne= apply (<I>sin turni al</I>)].", "0"],
["aplombo", "aplomb-o", "[OA] <B>1</B> assurance, balance, coolness, equilibrium, poise, self-confi- dence (self-possession). <I>Vi havas ~on</I>, you’re a cool customer. <B>2 (~aĵo)</B>, cheek. <I>Kia ~o!</I> What impudence! <B>~a</B>, cool. <B>Sen~a</B>, shaky, wobbly. ➞ <I>sinfid</I>.", "0"],
["apoceno", "apocen-o", "dog-bane (<I>Apoeynum). ~o kanaba (Hinda kanabo</I>), Indian hemp (<I>A. cannabium</I>).", "0"],
["apogeo", "apoge-o", "[OA] (astr) apogee, furthest point from earth, <B>f</B> climax. <I>Esti ĉe (en) la ~o</I> (at the height, in the hey-day) <I>de sia famo</I>. ➞ <I>afeli, klimaks, kulmin, zenit</I>. Opp <I>perige</I>.", "0"],
["apogi", "apog-i", "(<I>-n, je, kontraŭ, per, sur</I>) [UV] (<I>subteni</I>), Support. <B>1</B> Place (rest) on for s. <I>~i la kapon sur la mano(j)n</I>. <B>2</B> Give s. to. <I>~i kandidaton, proponon; muron per trabo. Sin ~i (al, sur</I>), lean, rest. s. one’s against (upon) (Jeh 29/7). <I><B>f</B></I> rely on, use as basis. ~i <I>sin sur la fakto, ke … <B>~o</B>,</I> s. (Ij 24/23). <I>~o morala. <B>~a</B> relo, stango, trabo, prop,</I> shore. <I><B>~ilo</B>,</I> something to lean against, or on, s., brace, prop, rest, stay, staff, strut, back (<I>de seĝo</I>), rail (<I>de ŝtuparo) (balustraro</I>) (El 21/19).<I> <B>Kap~ilo</B></I>, head-rest. <I><B>Libr~ilo</B></I>, book-end.<I> <B>Man~ilo</B></I>, handrail. <I><B>Menton~ilo</B></I>, (vn) chin-rest.<I> <B>Mur~ilo</B></I> (<I>abutmento</I>),<I> <B>Trus~ilo</B></I>, brace, strut. <I><B>~iĝilo</B></I>, staff (Ps 23/4). ➞ <I>baz, help, ste, strut</I>.", "0"],
["apoĝaturo", "apoĝatur-o", "(mus) appogiatura, leang note.", "0"],
["apokalipso", "apokalips-o", "apocalypse, revelation, especially (Bb) Revelations. <B>~a</B>, -tic. ➞ <I>rivel</I>. <B>apokope-o</B> (<I>fintranĉo</I>), (rh) apocope, elision of last part of word., e.g., <I>aŭt(o-mobil)o, fot(ografaĵ)o, kin(ematograf)o, taksi(metr)o, tram(veturil)o</I>. ➞ <I>aferez, sinkop</I>.", "0"],
["apokrifo", "apokrif-o", "[OA] Apocryph/a. <B>~a</B>, of the A., -al. <B>f</B> of doubtful authenticity, false, spurious. ➞ <I>fals, neaŭtent</I>.", "0"],
["apologio", "apologi-o", "apolog/ia, defence, explanation, vindication. <I>~o de Sokrato, pro sia kredo [Ne= ekskuz, pardonpet]. ~i (pro</I>). defend, justify. <B>~isto</B>, -ist. <B>~arto</B>, -etics, ➞ <I>defend, pravig</I>.", "0"],
["apologo", "apolog-o", "[OA] = fablo.", "0"],
["apopleksio", "apopleksi-o", "[OA] Apople/xy, cerebral haemorrhage. <I>Atako de ~o</I>, stroke. be -ctic. <B>~eca</B>, <B>~ema</B>, <B>~ulo</B>, -ctic. ➞ <I>paraliz</I>.", "0"],
["aposiopezo", "aposiopez-o", "(<I>subita silento</I>), (rh) aposiopesis, breaking off, leaving hearer to supply words unsaid. (Ps 6/3; Da 4/21, Ag 23/9).", "0"],
["apostato", "apostat-o", "Aposta/te. <B>f</B> turncoat. <B>~i</B>, -tize, renounce one’s faith (party, vows). <B>~eco</B>, <B>~iĝo</B>, -cy. ➞ <I>prozelit, renegat</I>.", "0"],
["aposteriora", "aposterior-a", "(log) a posteriori, based on fact and experience; (log) inductive, reasoning from effects to cause, (lin) derived from natural langs. <I>Esperanto estas ~a lingvo</I>.", "0"],
["apostolo", "apostol-o", "[OA] <B>1</B> Apostle, especially one of the 12 (Mt 10/2). <B>2 f</B> pioneer, missionary, leader of reform. <B>~a</B> <I>kredkonfeso</I>. <B>~ado</B>, <B>~eco</B>, apostleship. ➞ <I>misi, pionir, propagand</I>.", "0"],
["apostrofo", "apostrof-o", "[OA] apostrophe. <B>1</B> (gram) sign of elision. <B>2</B> (rh) (<I>alparolo</I>), exclamatory address (especially to absent person or thing). <B>~i</B> (<I>-n</I>), apostrophize (both meanings). ➞ <I>alparol, elizi</I>.", "0"],
["apoteko", "apotek-o", "[OA] chemist’s shop, drugstore. <B>~aĵoj</B>, drugs, medicine. <B>~isto</B>, druggist, pharmaceutical chemist. ➞ <I>drog, farmaci, ĥxemi</I>.", "0"],
["apoteozo", "apoteoz-o", "[OA] Apotheos/is, deification, deified ideal. -ize.", "0"],
["apozicio", "apozici-o", "[OA] (gram) apposition. ➞ <I>apud- met, epitet</I>.", "0"],
["apreti", "apret-i", "(<I>-n</I>), dress, finish, glaze, get up, stiffen (leather, textile, etc), (av) dope. <B>~ado</B>, <B>~aĵo</B>, dressing, etc. <B>~isto</B>, finisher. ➞ <I>glazur, pretig</I>.", "0"],
["aprezi", "aprez-i", "appraise, estimate the artistic value of.", "0"],
["Aprilo", "April-o", "[UV] April. <B>~a</B> <I>pluvo, ŝerco, vetero</I>.", "0"],
["apriora", "aprior-a", "a priori, based on theory instead of facts and experience, (log) deductive (reasoning), from cause to effect, (lin) theoretical, artificial. <I>Solresol estis ~a lingvo</I>.", "0"],
["apro", "apr-o", "[UV] wild boar (<I>Sus ~orofa</I>). <B>~ino</B>, wild sow. ➞ <I>fakofer, pork</I>, (ich) <B>~ofiŝo</B>, boarfish (<I>Capros</I>).", "0"],
["aprobi", "aprob-i", "(<I>-n</I>), [UV] <B>1</B> Approv/e (of), be pleased (hold) with, commend, like. ~i <I>agon, ideon, planon</I>. <B>2</B> authorize, certify, confirm, recognize, sanction. <I>Profesoro</I> <B>~ita. ~o</B>, -al, certificate (of document), commendation, consent. <B>Mal~i</B>, dis-a, censure, condemn. ➞ <I>laud, sankci; certig, diplom</I>. opposite <I>kondamn</I>.", "0"],
["apsido", "apsid-o", "(astr) apsis: Ap-(peri-)helion (of planet); apo-(peri-)gee of moon. <I>~a linio</I>, line of apsides (joining these). ➞ <I>absid</I>.", "0"],
["aptenodito", "aptenodit-o", "➞ <I>pingven</I>.", "0"],
["apterigo", "apterig-o", "(a. <I>kivio</I>), (orn) kiwi (<I>Apteryx</I>).", "0"],
["apud", "", "(a. <I>apude de</I>), [UV] (prep) 1 (<I>flanke de)’</I>. at (the side of), beside. <B>2</B> (<I>Najbare, proksime, de</I>): by, close to, near. <I>Tablo ~ la seĝo. Sidu ~ mi. Metu ĝin ~ min</I>. <B>~a</B>, adjacent, adjoining, contiguous, neighbouring. <I>~a domo</I>. <B>~e</B>, alongside, at the side, near by, close. <I>Staru ~e</I>. <B>~(est)i</B>, be near (➞ <I>limtuŝ</I>). <B>~eco</B>, <B>~esto</B>, proximity. ➞ <I>ĉi, flank, najbar, nekst, proksim</I>.", "0"],
["apuso", "apus-o", "(orn) swift, martinet. (<I>Apus</I>).", "0"],
["ar", "-ar", "[UV] (sfx) Collection (group, set) of (several or all) units of the same kind, regarded as a whole. It forms \"nouns of multitude\", (a) (people): band, bevy, circle, company, crew, crowd, gang, host, team, (b) (animals): brood, flock, herd, litter, pack, swarm, etc. (c) (Objects): code (<I>reguloj</I>), forest (<I>arboj</I>), peal (<I>sonoriloj</I>), set (<I>verkoj</I>), suite (<I>ĉambroj</I>), etc. E.g., <I>adres-(amik-best -hom-kamp-klav-pin-plant-tend-)aro</I>, which see <B>Rim</B>.: An <B>ar</B>-word denotes a unity, complete in itself. <B>Vagonaro</B> is more than <I>aro da vagonoj</I>; it is the combination we call a train. A <I>vort~o</I> is not any group of words, but a dictionary. <B>~o</B>, group, etc. <B>~iĝema</B>, gregarious, social. ➞ <I>amas, band, greg, grup, hard, kolekt, kompleks, sum, svarm, trup</I>. opposite <I>er</I>.", "0"],
["arabesko", "arabesk-o", "[OA] (des, mus) arabesque.", "0"],
["arabido", "arabid-o", "rock cress (<I>Arabis</I>).", "0"],
["arabo", "arab-o", "[OA 8], Arab.", "0"],
["aragonito", "aragonit-o", "(min) aragonite.", "0"],
["arakido", "arakid-o", "(<I>ternukso</I>), groundnut, monkeynut, peanut (<I>Arachis</I>).", "0"],
["arako", "arak-o", "(bev) arrack, rice brandy.", "0"],
["aralio", "arali-o", "aralia (<I>Aralia). ~o dorna,</I> angelica tree (<I>A. spinosa</I>).", "0"],
["araneo", "arane-o", "[UV] Spider. <B>Akva ~o</B> (<I>argiron- ekto</I>), diving spider. <B>Birdomanĝa ~o</B> (<I>avikulario</I>), bird-eating s. <B>~o diadema</B>, garden-s. <B>Dom~o</B> (<I>tegenario</I>), house-s. <B>Nigra ~o</B>, black widow. <B>~aĵo</B>, <I>~a reto (teksaĵo</I>), s’s web, cobweb. <B>~ojdo</B>, arachnid. ➞ <I>atip</I>.", "0"],
["aranĝi", "aranĝ-i", "(<I>-n, ke, por, pri</I>), [UV] Arrange (wide sense) <B>1</B> (<I>ordigi</I>) put in order; <I>~i ĉambron, kravaton, liton, tablon</I>. <B>2</B> (<I>reguligi</I>) adjust, dispose of, settle. <I>~i aferon, disputon, proceson</I>. <B>3</B> form plans for, get up, manage, organize, take steps: <I>~i akcepton, feston. Komunikon, kongreson</I>. <B>4</B> (mus) (<I>adapti): ~i solkanton kiel kvarteton</I>. <B>~o</B>, -ment. <I>Pari ~ojn</I>, <B>Bon~o</B> (Se 8/14), <B>Har~o</B>, coiffure. <B>~ema</B>, contriving, ingenious. <B>Antaŭ~i</B>, pre-a. <I>Antaŭ~ita decido</I>. <B>En~i</B> set (gems). <B>Mal~i</B>, <B>dis-a</B>, jumble, put out of order, upset. <B>Fin~i</B>, conclude, settle. <B>Sulk~i</B> <I>kampon</I>, (Jes 28/24). ➞ <I>konfuz, malordig, renvers</I>.", "0"],
["arao", "ara-o", "(orn) macaw (<I>Ara</I>).", "0"],
["araŭkario", "araŭkari-o", "monkey puzzle, Chili pine (<I>Araucaria</I>).", "0"],
["arbalesto", "arbalest-o", "[OA] (<I>ŝultra pafarko</I>), crossbow.", "0"],
["arbedo", "arbed-o", "shrub branching from base, e.g., <I>ribo, kratago</I>. Rim.: The distinction between <I>arbed</I> and <I>arbust</I> seems doubtfully useful: perhaps <I>arbed</I> might be dropped.", "0"],
["arbitra", "arbitr-a", "[UV] Arbitrary. <B>1</B> At discretion. <B>2</B> capricious, despotic, high-handed, overbearing. <I>~a ago, elekto, juĝo, povo, regulo</I>. <B>~o</B>, caprice, choice, discretion, free will, good pleasure, option. <I>Laŭ la ~o</I> (at the mercy) <I>de. Agi</I> <B>~e</B> (<I>laŭ sia ~o</I>), at will. <B>~i</B>, lay down the law. <B>~aĵo</B>, a. act. ➞ <I>bontrov, kapric, libervol, propradecid; despot, tiran</I>.", "0"],
["arbitracio", "arbitraci-o", "[OA] Arbitrat/ion, settlement by arbiter. <I>~a kortumo</I>, court of a. <I>~a decido</I>, settlement by a. <I>~a komisiono,</I> board of referees. <B>~e</B>, by a. <B>~i</B>, arbitrate, decide by agreed judge(s). <B>~anto</B> (Ij 9/33), -or, arbiter, judge, mediator, referee, umpire. ➞ <I>akordig, aranĝ, juĝ</I>.", "0"],
["arbo", "arb-o", "[UV] Tree. <I>Kia la ~o, tia la frukto. Frukt~o</I>, fruit-tree. <I>Nuks~o</I>, nut-tree. <I>Pan~o,</I> breadfruit tree. (<I>artokarpo). Tulip~o (liliodendro). Vaks~o (miriko</I>). <B>~a</B>, arboreal. ~<B>aro</B>, [UV] forest. <B>~ara</B> (<I>-oza, -oriĉa</I>), sylvan, well-wooded. <I>~ara gardisto,</I> ranger. <B>~areto</B>, grove, small wood. <B>~arigi</B>, afforest. <B>~(ar)ismo</B>, forestry, woodcraft. <I>~(ar)ismano</I>, woodcrafter. <B>~(ar)isto</B>, forester, <B>~etaĵo</B>, [UV] brushwood, bush, scrub. <B>~etaro</B>, coppice, plantation, thicket. <B>~ido</B>, sapling. <B>~idejo</B>, nursery. <B>~okulturo</B>, arboriculture. <B>Pra~aro</B>, virgin forest. <B>Sub~aĵo</B>, undergrowth (-wood). <B>Re~arigi</B>, reforest. ➞ <I>arbed, arbust, bosk, lign, vepr</I>.", "0"],
["arbusto", "arbust-o", "[OA] shrub, bush (trunk woody at base, herbaceous at top), e.g., <I>frambujo</I> (➞ <I>arbed</I>). <B>~aĵo</B>, <B>~aro</B>, brushwood, scrub, shrubbery. <B>Dorn-o</B> (Jĝ 9/14). <B>Pik~o</B> (Jes 5/6). ➞ <I>vepr</I>.", "0"],
["arbut", "", "-o, arbutus, strawberry-tree (<I>Arbutus). ~a arbo, frukto</I>. ➞ <I>frag</I>.", "0"],
["arĉo", "arĉ-o", "[UV] (mus) Bow, fiddlestick (<I>kun haroj kaj stango</I>). <B>~kordo</B>, b-string. <B>f</B> <I>havi plurajn kordojn por sia ~o</I>.", "0"],
["arda", "ard-a", "[OA] Ard/ent, burning, glowing, hot, fiery, blazing, scorching (<I>suno</I>), live (<I>karbo</I>), raging (<I>febro</I>). <B>f</B> eager, fervent, fierce, keen, lively, passionate. <I>~a atako, deziro, parolo, sento</I>. <B>~anta</B> (<I>forno</I>) (Da 3/6). <B>~o</B>, -our, eagerness, enthusiasm, fervour, zeal. <B>Seks~o</B>, rut. be a. (burning hot). <I>La fajro, forno ~as</I>. <B>~aĵo</B>, glowing matter. <B>Karb~aĵo</B>, embers, live coals. <B>~ilo</B> (<I>mufo</I>), (gas) mantle. <B>Blank~a</B> (<I>inkandeska</I>), white hot. <B>Ruĝ~a</B> (<I>brulruĝa</I>), red hot. ➞ <I>brul, flam, varmeg; fajr, fervor, pasi</I>.", "0"],
["ardeo", "arde-o", "[UV] heron (<I>Ardea</I>) (Le 11/19). <B>Nokt~o</B>, night heron. (<I>Nycticorax</I>). <B>~o</B> <B>purpura</B>, purple heron. ➞ <I>egret</I>.", "0"],
["ardezo", "ardez-o", "[UV] Slate (min). <B>~a</B> <I>lato</I>, roof s. <B>~ejo</B>, s-quarry. <B>~(kolor)a</B> (<I>blugriza</I>), s-gray. ➞ <I>skist</I>. <B>2</B> (<I>skrib~o</I>), writing-s. <I>~a krajono (grifelo</I>), s-pencil.", "0"],
["areko", "arek-o", "betel palm (<I>Areca</I>), <B>Kateĉu~o</B>, catechu-palm (<I>A. catechu</I>), <B>~a</B> <I>nukso,</I> areca nut. ➞ <I>kateĉu</I>.", "0"],
["arenario", "arenari-o", "(<I>Arenaria</I>). <B>1</B> (bot) sandwort. <B>2</B> (orn) (<I>ŝtonturnulo</I>), turnstone.", "0"],
["arenikolo", "arenikol-o", "lugworm (<I>Arenicola</I>).", "0"],
["areno", "aren-o", "[UV] arena, central area, <B>f</B> field, scene of conflict, (box) ring. <I>Eniri la ~on,</I> enter the lists (fray). ➞ <I>batalej, luktej</I>.", "0"],
["areo", "are-o", "Area, extent of surface, region, tract, (bid) court, yard. <I>Plank~o</I>, floor space, <B>f</B> province, range, scope (<I>de kompetento, influo, tribunalo</I>). (av) <I>Alteriga ~o</I>, landing-a. <B>Sam~a</B>, of equal a. ➞ <I>ampleks, aren, surfac, teren, volumen, zon</I>.", "0"],
["areolo", "areol-o", "(<I>areeto</I>), (bot) (zool), areola, small surrounding area, patch, spot.", "0"],
["areometro", "areometr-o", "[OA] = hidrometro.", "0"],
["areopago", "areopag-o", "areopagus, site of Gk tribunal, <B>f</B> authtive impartial tribunal.", "0"],
["aresti", "arest-i", "[UV] Arrest, apprehend, seize, take in charge (into custody), catch attention. <B>Sub ~o</B>, under a., in custody. <B>~ejo</B>, cell, detention room. <B>~igi</B> have -ed. give into custody. <B>~ito</B>, prisoner, <B>~ordono</B>, warrant of a. ➞ <I>gard, kapt, karcer, malliber</I>.", "0"],
["argano", "argan-o", "(a. <I>gruo</I>), (mec) Crane, derrick. <I>~o kun stango</I>, jib. c. <B>Mura ~o</B>, wall c. <B>~o sur relponto</B>, travelling c. <B>Svinga ~o</B>, swing c. ➞ <I>gru, puli, turnil, vine</I>.", "0"],
["arganto", "argant-o", "species of tick &gt; Miana bug (<I>Argas</I>).", "0"],
["argemono", "argemon-o", "devil’s fig, prickly or Mexican poppy (<I>Argemone</I>).", "0"],
["argeno", "argen-o", "fritillary butterfly (<I>Argynnis</I>).", "0"],
["Argentino", "Argentin-o", "AR, Argentina.", "0"],
["argilo", "argil-o", "[UV] Clay. <I>Fajr~o, pip~o, skist~o,</I> fire-(pipe-) c., shale. <B>Kalk~o</B> (<I>marno</I>), marl. Modla ~o. Potista <B>~o</B>, potter’s c. <B>~eca</B>, <B>~oza</B>, -ey, argillaceous. <I>~a pipo, tero. ~a dometo (planko</I>), mud hut (floor). <B>~aĵo</B>, crockery, earthernware, pottery. ➞ <I>kaolin, porcelan, terakot</I>.", "0"],
["argironeto", "argironet-o", "(<I>akva araneo</I>), diving spider (<I>Argyroneta</I>).", "0"],
["argonaŭto", "argonaŭt-o", "<B>1</B> (myth) argonaut. <B>2</B> (zoo) paper-sailor(-nautilus) (<I>Argonauta</I>).", "0"],
["argono", "argon-o", "(chem) argon (A).", "0"],
["argumento", "argument-o", "[UV] Argument, reasoning advanced (Ij 23/4) <I>~o ĝusta, valida. Tiri ~on el</I>, infer (deduce) from. ~i (<I>pri, ke, kontraŭ</I>), argue, maintain by reasoning. <I>~i pri ĉio, ~i, ke</I>. <B>~ado</B>, debate. ~ema, -ative. Kontraŭ<B>~o</B>, objection. <B>For~i</B>, argue away. ➞ <I>diskut, inferenc, pruv, rezon, silogism</I>.", "0"],
["arĝento", "arĝent-o", "[UV] Silver (Ag) <B>~a</B>, s. <I>~a kulero, monero, pokalo. ~a nitrato (oksido</I>). <B>f</B> silvern, silvery, silver-toned. <I>~a brilo, rido, sono, voĉo</I>. <B>~(iz)i</B>, plate, cover with s. <B>~aĵ(ar)o</B>, s-plate, etc. <B>~itaĵo</B>, s-plated article. <B>~ero</B>, s-coin.", "0"],
["ARĤ", "ARĤ-", "= <B>ARK-</B> (RK as an alternative for RĤ was approved by LK in 1922 and confirmed in OA 8, 1974: “La ses formoj: alkemio, arkaismo, arkitekturo, kemio, mekaniko kaj monarko estas oficialigitaj kiel paralelaj al la Oficiala alĥemio kaj al la Fundamentaj arĥaismo, arĥitekturo, ĥemio, meĥaniko kaj monarĥo.”).", "0"],
["arĥaismo", "arĥaism-o", "[F] (a. <B>ARK-</B> [OA 8]), archaism, obsolete word or phrase; imitation of this. ➞ <I>arkaik</I>.", "0"],
["arĥitekturo", "arĥitektur-o", "[UV] (a. <B>ark-</B> [OA 8]) architecture.", "0"],
["arida", "arid-a", "arid, barren, dry, parched.", "0"],
["ariero", "arier-o", "(mil) rear, hinder pt. <B>~gardo</B>, rear-guard.", "0"],
["arilo", "aril-o", "(bot) aril, extra seed-covering.", "0"],
["ario", "ari-o", "[OA] <B>1</B> air, melody, tune. <B>2</B> Aria. <I>~eto,</I> ditty. <B>2</B> arietta.", "0"],
["aristo", "arist-o", "(bot) (zoo) arista, awn, <I>beard( gre/ta</I>), bristleOKa). ➞ ar.", "0"],
["aristokrato", "aristokrat-o", "[OA 1], Aristocra/t, nobleman. <B>~a</B>, -tic. <B>~aro</B>, -cy, nobility, <B>f</B> best representatives (of intellect, etc). <B>~eco</B>, -cy, high birth, quality, etc. <B>~ismo</B> = <B>aristokrati-o</B> [OA 8], regime in which pol. power belongs to the -cy.", "0"],
["aristolokio", "aristoloki-o", "birthwort (<I>Aristolochia</I>). ➞ <I>serpentari</I>.", "0"],
["aritmetiko", "aritmetik-o", "[OA] (<I>nombroscienco</I>), arithmetic.", "0"],
["arkaa", "arka-a", "<I>see</I> arkaika.", "0"],
["arkado", "arkad-o", "[OA] Arcade, archway, passage arched over. <I>Blind~o</I>, blind a. ➞ <I>galeri, klostr, kolonaĵ, pergol</I>.", "0"],
["arkaika", "arkaik-a", "[OA] (<B>arĥ-</B> [OA]) (a. <B>arka-a</B>). archaic, antiquated, no longer in gen. use, primitive. <I>~a diro, parolo, forto</I>. <B>~aĵo</B>, <B>~eco</B> (<I>= arkaismo, arĥaismo</I> [OA 8]). ➞ <I>antikv, eksmod, malmodern, primitiv</I>.", "0"],
["arkeo", "arke-o", "(Bb) (Noah’s) ark (Ge 6/14). ➞ <I>kest. tabernakl</I>.", "0"],
["arkeologio", "arkeologi-o", "[OA] <B>arkeolog-o</B> [OA] (a. arkeologi/ist-o) (a. <B>arĥ-</B> [OA]), archeology, archeologist.", "0"],
["arkipelago", "arkipelag-o", "[OA] = insularo, archipelago.", "0"],
["arkitekto", "arkitekt-o", "[OA] (a. <B>arĥ-</B> [OA]), architect.", "0"],
["arkitekturo", "arkitektur-o", "[OA] (a. <B>arĥ-</B> [OA]), architecture, science or style of building.", "0"],
["arkitravo", "arkitrav-o", "architrave. <B>1</B> main beam resting on column(s). <B>2</B> moulded frame.", "0"],
["arkivo", "arkiv-o", "[OA] (<B>arĥ-</B> [OA]), archives, files, records. <B>1</B> (<I>dokumentaro</I>). <B>2</B> (<I> = ~ejo</I>), place where these are kept, records office. <I>Formeti en ~on. Regna (Ŝtata) ~o</I>. <B>~isto</B>. archivist, filing clerk, keeper of records, registrar. ➞ <I>registr</I>.", "0"],
["arkivolto", "arkivolt-o", "archivolt, undercurve of arch, moulding on this.", "0"],
["arko", "ark-o", "[UV] <B>1</B> arc, curve, pt of circle or other conic section. <B>2</B> (el) arc: ~lampo. <B>3</B> Arch: <I>Kurba, ogiva, triumfa, volba ~o ~o de fenestro</I>. <B>4</B> (<I>pafarko</I>). (mil) Bow: <I>Malstreĉi la ~on</I>, unbend the bow <B>f</B> relax. <B>Apog~o</B>, flying buttress. <B>Balanc~o</B>, rocker (<I>de brakseĝo</I>). <B>Ĉiel~o</B>, (pIuv~o), rain-bow. <I>Mian ~on mi metos en la nubon</I> (Ge 9/13). <B>Nebul~o</B>, fog-b. <B>Pied~o</B>, instep. <B>Pint~o</B> (<I>ogivo</I>), ogive. <B>Vest~o</B>, coat- hanger. <B>~aĵo</B>, [UV] (<I>volbo</I>), arch. <I>~o ĉiela, subtera. ~aĵo de ponto, (tunelo</I>). <B>~aĵa</B>, arched, vaulted. ~aĵaro, arcade, cloister. ~igi (<I>fleksi</I>), arch, bend, camber, curve, hump. <I>~igi branĉon, la brovojn, la porson (kato</I>). <B>(Paf)~isto</B>, bowman, archer, (astr) Sagittarius.", "0"],
["arktio", "arkti-o", "tiger moth (<I>Arctia caja</I>). <B>~a</B> (<I>lana, ursa) raŭpo</I>, woolly bear. ➞ <I>lap</I>.", "0"],
["Arkto", "Arkt-o", "[OA 9] (<I>~a regiono</I>), the Artic. ~<B>a</B> [OA 9] (<I>nordpulusa</I>), Arctic, north polar. <I>A~a cirklo, A~a klimato, A~a Oceano</I>. opposite <I>antarkt</I>.", "0"],
["arktostafilo", "arktostafil-o", "bearberry (<I>Arctostaphylos</I>).", "0"],
["arlekeno", "arleken-o", "[UV] (<I>burleskulo</I>). Harlequin, buffoon, clown, mountebank. <I>Vestita <B>~e</B></I>, in motley. <B>~aĵo</B>, -ade, slapstick. ➞ <I>grotesk, klaŭn, petol</I>.", "0"],
["armadelo", "armadel-o", "armadillo. <B>1</B> <I>= dazipo</I>. <B>2</B> (<I>~eto</I>) armadillo, species of woodlouse (➞ <I>dazip, onisk</I>).", "0"],
["armaturo", "armatur-o", "(<I>fortigaĵo</I>), Armature (wide sense). brace, defensive cas-(cover-sheath-)ing, framework, reinforcement (<I>betona</I>), truss (<I>traba</I>), roofing (<I>tegmenta</I>), <B>f</B> backbone, sinews (<I>de entrepreno). ~o betona, fera, ligna; mura, tegmenta, volba; horizontala, vertikala</I>. (el) <I>~o de magneto</I>. <B>~i</B>, furnish with an a. ➞ <I>armaĵ</I>.", "0"],
["Armenujo", "", "Armenio [OA 8] AM.", "0"],
["armeo", "arme-o", "[OA] Army, force(s), host. <I>~o aer-(ŝtat-)a</I>. <B>Mar~o</B>, navy. <B>Sav~o</B>, Salvation a. <B>Ter~o</B>, ground forces, <B>f</B> body, host. <I>~o de akridoj, oficistoj</I>. <B>~ano</B> (<I>soldato</I>). <B>~estro</B> (<I>generate</I>). ➞ <I>amas, legion, militistar, svarm, trup</I>.", "0"],
["armerio", "armeri-o", "(bot) thrift (<I>Armeria) ~o mara,</I> sea pink.", "0"],
["armi", "arm-i", "(<I>-n kontraŭ</I>), [UV] <B>1</B> Arm (against), accoutre, equip (fit out, furnish, provide) with arms. <I>urbanojn. Sin ~i</I>, a. one’s, take up with arms. <B>2</B> brace, fortify, strengthen. <B>~ita</B> <I>betono</I>, reinforced concrete. <I>~ita drato, fadeno, vitro. Ne ~ita</I> (naked) <I>okulo</I>. <B>~(ad)o</B>, armament, -ing. <I>Limigo de ~ado</I>. <B>3</B> (her) <B>~oj</B> (arms) <I>de urbo</I>. <B>~aĵo</B> (<I>armaturo</I>), -our, accoutrement, mail, plate, sheathing. ➞ <I>kiras, ŝild, ŝirmil</I>. <B>~iloj</B>, arms. <B>~ilejo</B>, (<I>arsenate</I>), -oury, arsenal. <B>~il(far)isto</B>, armourer. <B>~ilportisto</B>, armour bearer. <B>~itoj</B>, -ed men. <B>Mal~i</B>, <B>Sen~(il)igi</B>, disarm. <B>Re~ado</B>, rearmament. <B>Sen~a</B>, defenceless, unarmed. ➞ <I>armatur, ekip</I>.", "0"],
["armilario", "armilari-o", "honey fungus (<I>Armillaria</I>).", "0"],
["armistico", "armistic-o", "(<I>batalhalto</I>), armistice, short temporary truce.", "0"],
["armoracio", "armoraci-o", "(ordinary language <B>kreno</B>), horse-radish (<I>Armoracia</I>).", "0"],
["arniko", "arnik-o", "[OA] (bot) arnica (<I>Arnica</I>) mountain tobacco. <B>~aĵo</B>, tincture of a.", "0"],
["arogi", "arog-i", "(<I>al si) (-n, -i</I>), Arrog/ate to one’s, claim unduly, have the audacity, presume (Da 7/25). <I>~i al si privilegion, rajton,</I> <B>~anta</B> [UV] (<I>ofende fiera</I>), arrogant, forward, high-handed, overbearing, presumptuous, uppish. <I>~~a fripono, maniero, parolo</I>. <B>~~(ec)o</B>, -ance, \"cheek\", effrontery, presumption. <B>~~aĵo</B>, piece of impudence.", "0"],
["aroki", "arok-i", "(chs) castle. <B>~o</B>, castling. ➞ <I>tur</I>.", "0"],
["aromo", "arom-o", "[OA] Arom/a, subtle pervasive quality, delicate fragrance, sweet smell. <I>~o de kafo, teo, supo, vanilo; de floroj, spicoj. Balzama ~o</I>. <B>f</B> <I>~o de romaneco</I>. <B>~a</B>, -atic, balmy, fragrant (El 30/23). <I>~aj lilioj</I>. (cul) <I>~aj herboj</I>, mixed herbs. <B>~i</B>, (nt) be fragrant. <B>~aĵo</B>, -atic substance, spice. <B>~igi</B>, -atize.", "0"],
["aroruto", "arorut-o", "(<I>marant-amelo</I>), arrow-root, ➞ <I>marant</I>.", "0"],
["arpego", "arpeg-o", "[OA] <B>~i</B>, (mus) arpeggio.", "0"],
["arsenalo", "arsenal-o", "(<I>armilaro, armilejo</I>), arsenal, armoury, (also figuratively)", "0"],
["arseno", "arsen-o", ". Arsen/ic (As). <B>~a</B>, -ical. <B>~ato</B>, arsenate. <I>Plumb~ato, zink~ato</I>. <B>~atacido</B>, a-acid. <B>~ido</B>, -ide. <B>-iko</B>, [UV] white a. (<I>~oza oksido</I>) (As<SUB>2</SUB>0<SUB>3</SUB>).", "0"],
["arsino", "arsin-o", "(chem) arsine (As H<SUB>3</SUB>).", "0"],
["artemizio", "artemizi-o", "mugwort, wormwood. (<I>Artemisia</I>). ➞ <I>abrotan, absint, drak- unkol</I>.", "0"],
["arterio", "arteri-o", "[OA] (anat) Arter/y. <I>Kol~o (karotido</I>), carotid a. <B>f</B> (<I>trafikvojo</I>), channel of communication or supplies, -ial road, thoroughfare. <B>Gas~o</B>, gas main. <B>~a</B>, -ial. <I>~a sango</I>. <B>~ito</B>, -itis. <B>~osklerozo</B>, -oschlerosis, hardeng of the aa. ➞ <I>aneŭrism</I>.", "0"],
["artifiko", "artifik-o", "[UV] (<I>lert-ruz-aĵo</I>), artifice, contrivance, device, dodge, expedient, stratagem, subterfuge, trick (Ps 10/2). <I>~o de advokato, ĵonglisto, komercisto, milito</I>. <B>~a</B>, artful, crafty, cunning, tricky. <B>~i</B>, concoct, contrive, devise, work up. Sen~a (<I>senkaŝa, natura, simpla</I>), artless, guileless, ingenuous, sincere, straight- forward, without subterfuge. ➞ <I>elturniĝ, intrig, lert, mistifik, ruz</I>.", "0"],
["artiklo", "artikl-o", "(com) article of commerce, commodity. ➞ <I>var</I>.", "0"],
["artiko", "artik-o", "[UV] (anat, mech), Articul/ation, Joint; connection, hinge, link, (bot) node. <B>Genu~o</B>, <B>man~o</B>, <B>pied~o. ĉarnir~o</B>, <B>glob~o. ~(ohav)a</B>, j-ed. <I>~a stango</I>, a-ated rod. <B>~i</B>, a-ate, connect by j. (phon) divide into syllables or words., pronounce distinctly. <B>~ado</B>, a-ation, clear utterance. <B>~igi</B> <I>silabojn</I>. <B>De~(El~)igi</B>, dis-j. (-locate), put out of j., uncouple. <B>En~igi</B>, set, reassemble. ➞ <I>artrit, artropod, junt, sinovi</I>.", "0"],
["artikolo", "artikol-o", "[UV] Article. <B>1</B> (gram) \"<I>La\" estas ~o determina, difina</I>. <B>2</B> (lit) composition. Ĉef<B>~o</B>, leading a. ~o <I>pri Esp-o. [3 = artiklo</I> (K176/27)]. ➞ <I>afer, af, objekt, var; ese, traktaĵ</I>.", "0"],
["artilerio", "artileri-o", "[OA] Artillery. <B>1</B> (<I>kanonaro</I>), cannon, ordnance. <I>~o kampa,</I> <B>2</B> (<I>kanonistaro</I>). <B>~ano</B>, (<I>kanonisto</I>), a-man, gunner.", "0"],
["artiŝoko", "artiŝok-o", "[UV] globe artichoke (<I>Cynara</I>). ➞ <I>heliant, kardort</I>.", "0"],
["arto", "art-o", "[UV] Art. <B>1</B> artistry, dexterity, knack, skilful workmanship. <B>2</B> object. to which this is applied (Ps 58/5). <I>~o aplikita, dekora. Naĝ~o</I>, <B>Nigra ~o</B>, black magic. <B>~(ec)a</B>, <B>~(oplen)a</B>, of art, artistic (El 38/23). <I>~a bindo, lingvo, verko</I>. <B>~e</B> <I>laborita</I> (El 26/1). <B>1</B> done by art. <B>2</B> artificial. <I>~e farita lumo, spektaklo</I>. <B>~aĉo</B>, meretricious art. <B>~aĵo, ~objekto, ~verko</B>, work of art. <B>~ismo</B>, <B>~sento</B>, artistry, artistic talent. <B>~isto</B>, -ist. <B>~isma, ~ista, ~plena</B>, artistic. <B>~amanto</B>, art lover. <B>~laborejo</B>, studio. <B>Bel~oj</B> (<I>beletro</I>), fine arts. <B>Kontraŭ~a</B>, inartistic, clumsy, crude, uncultured, unskilful. <B>Sen~a</B> (<I>naiva, natura, simpla</I>), without art, artless, naive, natural. <I>Paroli sen<B>~e</B></I>, speak unaffectedly. ➞ <I>afekt, artifik, inĝeni, lert</I>. opposite <I>natur</I>.", "0"],
["artokarpo", "artokarp-o", "(<I>panarbo</I>), breadfruit tree (<I>Artocarpus</I>).", "0"],
["artrito", "artrit-o", "[UV] <I>artikinflamo</I>), arthrit/is. <B>~a</B>, -ic. ➞ <I>podagr, reŭmatism, sinovi</I>.", "0"],
["artropodoj", "artropod-oj", "(<I>artikpieduloj</I>), (zool) arthropoda.", "0"],
["arumo", "", "(bot) arum (<I>Arum</I>), especially <I>A. maculatum</I>, cuckoo-pint, lords and ladies, wake-robin. ➞ <I>kala, kardamen</I>.", "0"],
["arvikolo", "arvikol-o", "water-vole (<I>Arvicola</I>). ➞ <I>mikrot</I>.", "0"],
["as", "-as", "[UV] ending of present tense. Den. state or action (a) at the time of speaking: <I>li dormas (nun). Mi vidis, ke li dormas</I> (was sleeping), (b) in general: <I>Oni dormas (kutime) en la nokto</I>. <B>~tempo</B>, present tense.", "0"],
["asafetido", "asafetid-o", "asafoetida, gum from <I>farolo</I>.", "0"],
["asbesto", "asbest-o", "(min) asbestos. ➞ <I>amiant, amfibol</I>.", "0"],
["ascendi", "ascend-i", "(<I>supreniri</I>), ascend, come (go slope) up(wards), climb, mount, rise, <I>~i mont-(river-tron-)on</I>. <B>~o</B>, ascen-sion-t. <I>~i al la ĉielo</I>. <B>~a</B> <I>aero, vento</I>. (av. <B>~ometro</B>, rate-of-climb meter. <B>~otago</B>, Ascension day, Holy Thursday.", "0"],
["ascidio", "ascidi-o", "(zoo) sea-squirt (<I>Ascidium</I>). ➞ <I>nepent, utrikl</I>.", "0"],
["asekuri", "asekur-i", "(<I>-n, kontraŭ</I>), [UV] <B>1</B> Assur/e, secure value of property if lost, or specified sum on death: <I>~i domon, la sort-(viv-)on</I>. <B>2</B> Insur/e against accident (damage, fire, loss, risk): <I>Laboro ~as kontraŭ mizero</I>. <B>Fajr~o</B> (<I>~o kontraŭ fajro</I>), Fire i-ance. <B>Viv~o</B> (<I>~o pri vivo</I>), Life i-ance. <B>~a</B> <I>kompanio (societo</I>), i-ance company. <I>~a pago</I>, premium. <B>~isto</B>, underwriter. <B>~agento</B>, i-ance agent. <B>~ito</B>, party i-ed. ➞ <I>cert-(sekur-sendanĝer-)ig, protekt</I>.", "0"],
["asembleo", "asemble-o", "(jur, pol), Assembly, gathering of deliberative body, legislative council. ~a <I>ĉambro</I>.", "0"],
["asepsa", "aseps-a", "(<I>sensepsa</I>), Asep/tic, free from putrefaction. <B>~o</B>, -sis, (state or treatment). ➞ <I>antiseps, sen-ĝerm(-infekt</I>). <B>~igi</B>, -ticize.", "0"],
["aserti", "asert-i", "(<I>-n, ke</I>) [OA], Assert, affirm, claim, declare, maintain, state. <I>~i sian rajton. ~o</I>, -ion, positive statement. <I>Laŭ ~o,</I> ostensibly, professedly, self-styled. <B>~(em)a</B>, -ive, dogmatic. <B>Sin~a</B>, insistent on one’s rights. ➞ <I>certig, pretend</I>.", "0"],
["asesoro,", "asesor-o,", "[OA] assessor, valuer. <B>Jura</B> <B>~o</B>, adviser to judge or magistrate. ➞ <I>taks</I>.", "0"],
["asfalto", "asfalt-o", "[OA] (<I>terpeĉo</I>) asphalt. <B>1</B> solid or plastic pitch (El 2/3). <B>2</B> mixture of this with sand, etc., for road-surfacing. (cover with) a. <B>~a</B> <I>kartono</I>, roof (tarred) felt.", "0"],
["asfiksio", "asfiksi-o", "Asphyxi/a, suspended animation. <B>~i</B> (<I>-n</I>), -ate. <I>~ita de gasoj</I>. <B>~iĝi</B>, be -ed. ➞ <I>komat, sufok</I>.", "0"],
["asfodelo", "asfodel-o", "asphodel, king’s rod (<I>Asphodelus</I>). ➞ <I>narcis</I>.", "0"],
["asigni", "asign-i", "[UV] Assign (wide sense), designate- <B>1</B> allot, ear-mark, formally make over, set apart for definite purpose. (<I>al iu) lokon, parton, rolon, salajron, seĝon, sumon, taskon</I>. <B>2</B> appoint, fix, grant, settle, specify. <I>~i horon, limon, lokon, rendevuon</I>. <B>3</B> ascribe, attribute, impute; date (to event), motive, reason (for action). <B>~o</B>, -ment, -ation, appointment, allotment, formal transferee. <B>~(aĵ)o</B>, (com. jur) draft, order, ticket, voucher. <B>~anto</B>, drawer. <B>~ato</B>, drawee. ➞ <I>apart-(dispori)ig, destin, difin, trans-ced(-don-pag), mandat</I>.", "0"],
["asimili", "asimil-i", "(<I>-n</I>) [OA], assimil/ate. <B>1</B> absorb into the system, digest. <I>~i nutron</I>. <B>2</B> make one’s own., take in. <I>~i ide-(instru-metod-popol-)on</I>. <B>f</B> <I>\"Manĉestro\" estas ~ita formo de \"Manchester\"</I>. ➞ <I>digest, enig, encerbig, enkapig; aneks, proprig</I>.", "0"],
["asimptoto", "asimptot-o", "(mat) asymptote.", "0"],
["asindetono", "asindeton-o", "(rh) asyndeton, omis sion of conj., \"no-ands\" (Mk 7/21-22). ➞ <I>polisindeton</I>.", "0"],
["asisti", "asist-i", "<B>1</B> Assist officialy [not merely <I>helpi],</I> be in attendance, back up, support, take pt in. <I>Du kuracistoj ~is ĉe la lito</I>. <B>~i</B> <I>juĝist-(pastr-profesor-)on</I>. <B>~anto</B>, -ant, deputy, locum tenens, subordinate worker. <B>2 ~o</B>, -ance, relief. <I>Publika ~o,</I> public -ance. <I>Ŝtata ~o</I>, State relief. ➞ <I>adjunkt, asesor, helpant, sub-, vie-</I>.", "0"],
["asizo", "asiz-o", "Assize. <B>~a</B> <I>kortumo</I>, court of a., \"the aa\".", "0"],
["askalono", "askalon-o", "(a. <I>ŝaloto</I>), shallot (<I>Allium ascalonicum</I>).", "0"],
["askarido", "askarid-o", "ascaris, intestinal pin-(round-) worm (<I>Ascaris</I>).", "0"],
["asketo", "asket-o", "<B>~a</B>, Ascetic, <B>~ado</B>, ~eco, <B>~ismo</B>, -ism.", "0"],
["asklepiado", "asklepiad-o", "butterfly-weed, pleurisy-root, swallow-wort (<I>Asclepias</I>).", "0"],
["asko", "ask-o", "(bot) ascus, spore sac. <B>~ofungoj</B> (<I>askomicetoj</I>), ascomycetes, cup-fungi.", "0"],
["aso", "as-o", "[UV] ace, the \"one\" on cards, dice, etc. ➞ <I>atut</I>.", "0"],
["asocio", "asoci-o", "[OA] Associ/ation. <B>1</B> organized body for common aim. <I>~o Esperantista, komerca</I>. <B>2</B> connection, relation. <I>~o de ideoj</I>. <B>~i</B> (<I>-n kun</I>), -ate, form into an -ation or partnership. (<I>rilatigi</I>) connect mentally. <B>~a</B>, allied, in -ation, -ate, joined. <B>~ado</B>, -ation, fellowship, intimacy, interchange. <B>~ano</B>, member of an a. <B>~iĝi (sin ~i)</B>, bem a partner, combine for common purpose. <B>~ito</B>, -ate, partner. ➞ <I>kombin\\ alianc, klub, kompani, lig, societ, uni</I>.", "0"],
["asonanco", "asonanc-o", "[OA] Asson/ance, rhyming of accented vowels (but not of consonants) e.g., <I>mola, bona</I>. <B>~i</B>, be -ant. ➞ <I>aliteraci</I>.", "0"],
["asparago", "asparag-o", "[UV] asparagus (<I>Asparagus</I>).", "0"],
["aspekti", "aspekt-i", "(<I>-a, -e</I>) [OA], Appear to be, Look (Ne 2/2). <I>kiel (kvazaŭ</I>), 1. like (as though). <B>~o</B>, 1., a-ance, aspect, expression, exterior (Da 3/19). (astr) aspect, e.g., of planet (➞ <I>kvadratur, sizigi</I>). (gram) aspect of vb. <B>~e</B>, in -ance. <I>Malgranda <B>~e</B>, granda intelekte</I>. <B>~igi</B> (<I>-n</I>), make 1. <B>Bel~a</B>, <B>Bon~a</B>, good-(nice-)looking, handsome. ➞ <I>allog, plaĉ; montriĝ, ŝajn; eksteraĵ, fizionomi, mien</I>.", "0"],
["aspergi", "asperg-i", "(<I>-n</I>) [OA] (Le 14/7). Sprinkle. <I>~i florojn, ~i iun per sankta akvo</I>. <B>~a</B> <I>kaliko</I>. <B>~ilo</B>, sprinkler, aspergillum. ➞ <I>akv, surŝprucig, surverŝ</I>.", "0"],
["asperolo (~ulo)", "asperol-o (~ulo)", "Woodruff, squinancy- wort (2FA 88/4) (<I>Asperula</I>). <B>~o odora</B>, sweet w.", "0"],
["asperugo", "asperug-o", "(bot) mad wort (<I>Asperugo</I>).", "0"],
["aspidistro", "aspidistr-o", "(bot) aspidistra.", "0"],
["aspido", "aspid-o", "[UV] asp (<I>Vipera aspis</I>) (Ij 20/14,16). fany small venomous serpent.", "0"],
["aspiko", "aspik-o", "(<I>vianda feleo</I>), aspic, meat jelly.", "0"],
["aspiri", "aspir-i", "(<I>-n, al, pri</I>) [OA] (Ge 4/7), Aspir/e after (to do), be ambitious of (eager for), desire earnestly, seek after. <I>la manon de fraŭlino</I>. <B>~(ad)o</B>, -ation. <B>~anto</B>, -ant, candidate (for), suitor (➞ <I>kandidato</I>). <B>~ema</B>, -ing (➞ <I>ambici, suprencel</I>). ➞ cel, <I>dezir, sere, sopir</I>.", "0"],
["aspirino", "aspirin-o", "(<I>acetilsalicilatacido</I>), aspirin.", "0"],
["asplenio", "aspleni-o", "spleen wort (fern) (<I>Asplenium</I>).", "0"],
["aspra", "aspr-a", "raspy, rough, rugged (<I>surfaco</I>), crabbed, cross-grained, harsh (<I>naturo, stilo</I>). <B>~o</B>, asperity.", "0"],
["astako", "astak-o", "species of <I>kankro</I> (crayfish) (<I>Astacus</I>).", "0"],
["astato", "astat-o", "(chem) astatine (At).", "0"],
["asterio", "asteri-o", "(<I>astrofiŝo, marstelo</I>), starfish (<I>Asterias</I>).", "0"],
["asterisko", "asterisk-o", "(<I>steleto</I>), (typ) asterisk (*). <B>~i</B>, to a.", "0"],
["astero", "aster-o", "(<I>astrofloro</I>) (4 FA 127/14), aster, star-wort (<I>Aster) &gt;</I> Michaelmas daisy. ➞ <I>kalistef, lekant, stelari</I>.", "0"],
["asterojdo", "asterojd-o", "(<I>planedeto</I>), asteroid, minor planet.", "0"],
["astigmata", "astigmat-a", "(<I>nefokusiva</I>), (opt) astigmat/ic. <B>~eco</B>, -ism.", "0"],
["astmo", "astm-o", "[OA] Asthm/a. <I>Fojn~o, somer~o</I>, hay fever. <B>~ulo</B>, -atic. <B>Kontraŭ~a</B> <I>cigaredo</I>. ➞ <I>angin</I>.", "0"],
["astragalo", "astragal-o", "<B>1</B> (anat) ankle-bone. <B>2</B> (bot) milk-vetch (<I>Astragalus</I>). ➞ <I>tragakant</I>. 3 astragal, ring-moulding round cannon- mouth or column.", "0"],
["astrala", "", "(theosophy), astral.", "0"],
["astro", "astr-o", "[OA] heavenly body, luminary, orb (sun, star, planet, etc.). <B>f</B> (film) \"star\", <B>-ofiziko</B>, <B>~onaŭto. ~a</B>, astral.", "0"],
["astrolabo", "astrolab-o", "astrolabe, mediaeval sextant.", "0"],
["astrologio", "astrologi-o", "[OA] astrolog/y. <B>-o</B>, -er (Da 4/7).", "0"],
["astronomio", "astronomi-o", "[OA] Astronom/y. <I>Radio~io. ~o</I>, -er. <B>~ia</B>, -ical. <B>f</B> immense.", "0"],
["at", "-at", "[UV] ending of pres. passive. participle. <B>~a</B>, -ed. <B>~o</B> (usually <I>= -atulo</I>). <B>Kon~o</B>, acquaintance. <B>Pun~e</B>, <I>li.</I> . . While (when, etc.) being punished, he . <B>. . ~as (~is</B>, <B>~os)</B>, unofficial abbreviation for <I>est-as (-is-os) ~ata</I>. <B>II -ato</B> (chem) -ate, salt of -ic acid. <B>Nitr~o</B>, nitrate: <I>nitratacido</I>, nitric acid.", "0"],
["ataki", "atak-i", "(<I>-n</I>), [UV] Attack. <B>1</B> Assail, assault, fall (set) upon. <I>~i landon, popolon</I>. <B>f</B> <I>~i demandon, kredon</I>. ➞ <I>kritik, kontraŭ- disput</I>. <B>2</B> begin, tackle, wire into. <I>~i laboron, manĝon. Rusto ~as</I> (eats into) <I>feron</I>. ➞ <I>difekt, korod, mord. Febro min ~is</I> (➞ <I>kapt, traf</I>). <B>~(em)a</B>, agressive, bellicose, quarrelsome. <I>~ema humoro</I>. <B>~o</B>, a., onset, onslaught. <I>~o</I> (sally) <I>kontraŭ sieĝantoj</I>. (med) a., bout, fit, stroke. <I>~o de grip-(koler-pasi-)o</I>. <B>Aer~o</B>, air-raid. <B>Flank~o. Surpriz~o</B>, surprise a. <B>~egi</B>, charge, storm. <B>~eto</B>, twinge. <B>Kontraŭ~i</B>, counter-a. <B>Ne~ebla</B>, unassailable. ➞ <I>atenc, ekbatal, invad, sieĝ</I>.", "0"],
["ataksio", "ataksi-o", ". Ataxy, tabes, irreg-ty of function causing loss of control of movement. <B>Ir~o</B>, locomotor ataxy.", "0"],
["atalanto", "atalant-o", "(<I>ruĝa admiralo</I>), red admiral butterfly (<I>Vanessa atalanta</I>).", "0"],
["ataŝeo", "ataŝe-o", "Attache, junior official of embassy. <I>~a teko</I>, a-case.", "0"],
["atavismo", "atavism-o", "[OA] Atav/ism, resemblance to ancestors, rever sion to type. <B>~a</B>, -istic. <I>~a instinkto, trajto</I>. ➞ <I>pra, refal</I>.", "0"],
["ateismo", "ate/ismo", "[OA] Athe-ism, disbelief in existance of God. <B>-isto</B>, [OA] -ist.", "0"],
["atelo", "atel-o", "(<I>aranea simio</I>), <I>spider-monkey (Ateles</I>).", "0"],
["atenci", "atenc-i", "(<I>-n</I>) [UV] (<I>fari ~on kontrau</I>), make a criminal attempt on, outrage (2 Sa 21<I>15</I>) [<I>Ne =</I> attempt (<I>pen, prov</I>)o], <I>~i honon, temon, liberon, monujon, privilegion, virton, vivon</I>. <B>~o</B> (Ps 21/11), criminal attempt, infringement (of), violation. <I>Tiu propono estas ~o kontraŭ la lingvo</I>. <B>Majest~o</B>, lese majesty. <B>Seks~o</B>, rape. ➞ <I>atak, insid, krim</I>.", "0"],
["atendi", "atend-i", "(<I>-n, ĝis, por</I>), [UV] <B>1</B> Wait, await, be on the look-out for, pause (tarry), hoping to see, etc. <I>~u por mi. ~i amikon, decidon, novaĵon, respondon. ~u kaj vidu! ~u, ĝis mi venos. ~i kaŝe</I> (Ij 31/9); <I>starvice,</I> in a queue; <I>time</I>, dread, be apprehensive; <I>vane</I>, wait in vain, be disappointed. ➞ <I>resti ĝis</I>. <B>~ejo</B>, -ing room. <B>~ema</B> (<I>pacienca</I>), patient. <B>~igi</B>, keep -ing. <B>Ĝis~i</B>, wait until. <B>Sen~e</B> (<I>senhezite, senprokraste</I>), at once, without delay. <B>2 f</B> await; be destined (in store, ready) for. <I>Manĝo, morto, surprizo vin ~as. [Ne= atenti</I> (pay attention), <I>ĉeesti</I> (attend meeting)]. <B>3</B> <I>~i, ke -os</I>, expect, regard as likely to happen. <B>Rim</B>.: For this meaning <I>ekspekti</I> (which see) is increasingly used. ➞ <I>antaŭvid, anticip, desapont</I>.", "0"],
["atenta", "atent-a", "[UV] Attent/ive, careful, heedful, mindful, observant (Ne 1/6). <B>~o</B>, attention. <I>Streĉa ~o. Meti, turni ~on al io (sur ion</I>). <B>~i</B> (<I>-n, pri, ke</I>. abs), be a., pay (give) -ion to, consider, heed, follow, mind, look on as important, obey, observe, see to, take notice of (Da 11/37). <I>~i averton, konsilon, paŝon, regulon</I>. <B>~u!</B> -ion! Look out! Take care! (mar) Stand by! <B>~u</B>, <I>ke vi ne falu</I>. Take heed lest you fall, mind you don’t fall. <B>~igi</B> (<I>iun pri io</I>), call (direct, turn) -ion to (➞ <I>avert, rimarkig</I>). <B>~inda</B> (<I>grava</I>), worthy of -ion, to be heeded. <B>Mal~i</B> (<I>preterlasi</I>), disregard, ignore, take notice of. <I>Mal~a</I>, inattentive, distrait, listless, <B>Ne~inda</B>, negligible. <B>Sen~a</B>, careless, heedless, unheeding. ➞ <I>gard, zorg, streĉi okulojn, orelojn</I>.", "0"],
["atenui", "atenu-i", "(<I>-n</I>), Attenuat/e, reduce in force or value, thin out. <B>~ita</B>, -ed, rarified.", "0"],
["atesti", "atest-i", "(<I>-n, kontraŭ, por, pri</I>, abs), [UV] Attest, (bear) Witness to, certify, solemnly declare, testify. <I>Griza barbo saĝon ne ~as</I>. <B>~(il)o</B>, -ation, certificate, testimonial, verification. (acting) warrant. <I>~o pri kapablo (konduto</I>), certificate of proficiency (good conduct). <B>Karg~o</B>, bill of lading. <B>Konfid~o</B>, credentials, letter of recommendation. <B>Pag~o</B>, <B>Ricev~o</B> (<I>kvitanco</I>), receipt, voucher. <B>San~o</B>, bill of health. <B>ŝuld~o</B>, promissory note. <B>~(aĵ)o</B>, deposition, evidence, testimony (El 25/16). <B>~anto</B>, w. (No. 35/30). <I>Vidanta ~anto</I> eye-w. (4 FA 27/32). <B>~igi</B>, call to w. (Re 4/26). ➞ <I>certig, konfirm, pruv, viz</I>.", "0"],
["atingi", "ating-i", "(-n, <I>ke</I>), [UV] Reach, attain (to). <B>1</B> (<I>alveni, ĝisiri, trafi</I>): arrive at. <I>~i aĝon, alton, celon, supron, urbon, la vesperon de sia vivo</I>. <B>2</B> (<I>etendiĝi</I>): Extend, stretch. <I>~i ĝis la maro</I>. <B>3</B> (<I>akiri, gajni, trafi</I>): accomplish, achieve, gain, obtain, succeed in getting. <I>~i konsenton, prezon, rezulton, sukceson</I>. <B>~(aĵ)o</B>, achievment. <B>~ebla</B>, accessible (➞ <I>sub la mano</I>). <B>~eco</B>, <B>~odistanco</B>. <B>~opovo</B>, reach, extent (to which), range, scope. <B>Kur~i</B>, catch up, overtake. <B>Mal~i</B>, fail to reach, miss. <B>Ne~ebla</B> (<I>ekster ~o</I>), unattainable, out of reach.", "0"],
["atipo", "atip-o", "leaping (trap-door) spider (<I>Atypus</I>).", "0"],
["atirio", "atiri-o", "lady fern (<I>Athyrium</I>).", "0"],
["Atlanta", "Atlant-a", "Atlantic. <I>~a oceano</I>. Trans<B>~a</B>, trans-ic.", "0"],
["atlaso", "atlas-o", "[OA] <B>1</B> (myth) Atlas. <B>2</B> (tex) satin, glossy silk fabric. <I>Virino en ~aĵoj</I>. <B>f</B> <I>~a haŭto</I>. <B>3</B> (anat) atlas, first cervical vertebra. [Ne= atlas (<I>maparo</I>)].", "0"],
["atleto", "atlet-o", "[OA] Athlet/e. <B>~a</B>, -ic. <B>~eco</B>, <B>~ismo</B>, -ics. ➞ <I>sport</I>.", "0"],
["atmosfero", "atmosfer-o", "[OA] Atmospher/e. <B>1</B> (astr) gas round heavenly body. <I>~o de Marso, la tero</I>). <B>2</B> Air in gen. <B>3</B> (ph) unit of pressure. f (<I>etoso</I>), impression produced by environment. <B>~a</B> <I>premo</I>, -ic pressure.", "0"],
["atolo", "atol-o", "(<I>korala rifo</I>), atoll, ring-shaped coral reef round lagoon.", "0"],
["atomo", "atom-o", "[OA] Atom. <B>1</B> (chem) <I>~a bombo, energio, pezo, pilo, teorio</I>. <B>2</B> Minute object., mote, speck. <I>Sen ~o da vero</I>, without a jot of truth. <B>~eco</B>, -icity. <B>~igi</B>, -ize. <B>~ismo</B>, -ism. ➞ <I>valent</I>.", "0"],
["atonio", "atoni-o", "atony, debility, sluggishness, want of tone.", "0"],
["atrabila", "atrabil-a", "atrabilious. <B>1</B> melancholy, <B>2</B> acrimonious, irritable. ➞ <I>gal, melankoli, splen</I>.", "0"],
["atribui", "atribu-i", "[OA] attribut/e, ascribe, assign, father on, put down to, <B>1</B> as belonging to: <I>~i signifon al vorto, poemon al Z., 2</I> as due to (effect of): <I>~i morton al ŝoko, satton al vegetarismo</I>. ➞ <I>aljuĝ, asign, imput</I>.", "0"],
["atributo", "atribut-o", "[OA] Attribute. <B>1</B> essential characteristic, inherent property. <I>La ~oj de Dio</I>. <B>2</B> emblem (symbol) appropriate to office or person. [3 (gram) avoid, as ambiguous: in G. a<I>, = epiteto</I>, in Fr. a<I>.=predikato.]</I> ➞ <I>atribu, ec, kvalit</I>.", "0"],
["atriplo", "atripl-o", "[UV] orache, mountain spinach (<I>A triplex</I>). ➞ <I>kenopodi</I>.", "0"],
["atrofio", "atrofi-o", ". Atroph/y, emaciation, wasting away. <B>~i</B>, <B>~iĝi</B>, be (become) -ied. ➞ <I>ftiz, marasm, nekresk</I>.", "0"],
["atropino", "atropin-o", "atropin, alkaloid of <I>beladono,</I> which see", "0"],
["atroposo", "atropos-o", "(<I>mortkapo</I>), (ent) death’s head hawk-moth (<I>Aeherontia atropos). &lt; sfingo</I>.", "0"],
["atuto", "atut-o", "[UV] Trump (card) (also figuratively). <B>~i</B>, play a t. Super<B>~i</B>, t. higher.", "0"],
["aŭ", "", "(conj), [UV] <B>1</B> or (alternatvs). <I>Jes ~ ne? 2</I> aŭ ... aŭ. either ... or. <B>3</B> (<I>alie, se ne</I>), otherwise. <I>Ĉesu! ~ mi ekkrios</I>. <B>4</B> (<I>alinome</I>) or (=otherwise called). <I>Kabe (~Bein</I>). (log) ~a (<I>disiga) silogismo</I>. aŭbad-o, (mus) aubade, music for dawn.", "0"],
["aŭbrietio", "aŭbrieti-o", "rock cress (<I>Aubrietia</I>).", "0"],
["aŭdac~a", "", "Audac/ious, bold, daring, impudent. <I>~a ago, diro, paradokso</I>. <B>~o</B>, -ity, cheek, impudce, <I>Pardonu mian ~on</I> (presumption). ~i (<I>maltimi</I>), dare (have the face) to …, risk … ing. ➞ <I>aplomb, kuraĝ, riskem</I>.", "0"],
["aŭdi", "aŭd-i", "[UV]. <B>1</B> Hear (Ps 135/17). ~u! Hear! Hear! 2 (<I>de, pri; ke) (ekscii, informiĝi</I>), get news. <I>Mi ~as, ke. Mi ~is hazarde,</I> it came to my ears. <I>Unu vido pli taŭgas, ol dek ~oj</I>. <B>~a</B>, audit-ive-ory, aural. <B>~ado</B>, h-ing, audition (Pr 1/8). ~antaro, audience. (Klar)<B>~ebla</B>, audible, distinct. <B>~iĝi</B>, be heard. <B>~igi</B>, cause to h. (or be heard). <I>~igi surdulon (sian voĉon</I>). (tel) ~ilo, <I>aŭskultilo</I>). Kap~ilo, headphone. Dis~igi (<I>brodkasti</I>), broadcast. Ek<B>~i</B>, catch the sound of. El~i (<I>preĝon), give</I> ear to. Malbon<B>~a</B>, hard of h-ing. Ne~ita, unheard (of), unexampled. Mis<B>~i</B>, mis-h. ➞ <I>aŭskult</I>.", "0"],
["aŭdienco", "aŭdienc-o", "(<I>ĉe</I>) [OA], (<I>formal</I>) Audience, interview, sitting <I>[Ne= aŭskultantaro]. Konsenti, peti, ricevi ~on. ~ejo, a-chamber</I>. ➞ <I>akcept, alias, intervju</I>.", "0"],
["aŭditorio", "aŭditori-o", "[OA] (<I>aŭskultejo</I>), auditorium, concert hall, lecture room, etc. ➞ <I>lekciej, prelegej</I>.", "0"],
["aŭguri", "aŭgur-i", "[OA] Augur, anticipate, forbode, foreshadow, <B>~o</B>, omen, portent; <B>f</B> presage, promise. <I>~o pri sukceso</I>. <B>~ado</B>, -y, divination. <B>~isto</B>, diviner, soothsayer (1 Sa 28/7, 8, 9.) <B>Bon~a</B>, of good omen. <B>Malbon~a</B>, of ill omen, that bodes no good. ➞ <I>antaŭ-sign(-vid), aŭspici,profet, prognoz, sort. »</I>", "0"],
["Aŭgusto", "Aŭgust-o", "August.", "0"],
["aŭkcio", "aŭkci-o", "[OA] <B>~i</B>, Auction. <I>Aĉeti, vendi</I> ~e (<I>per ~o</I>), by a. <B>~a</B> <I>vendo, propono</I>. <B>~ejo</B>, a-room. <B>~isto</B>, -eer.", "0"],
["aŭkubo", "aŭkub-o", "spotted (variegated) laurel (<I>Aucuba</I>).", "0"],
["aŭkupario", "aŭkupari-o", "rowan tree, mountain ash (<I>Sorbus aucuparia</I>) ➞ <I>aliz, sorp</I>.", "0"],
["aŭlo", "aŭl-o", "aula, court, <B>f</B> <I>La ~oj de la ĉielo</I>. ➞ <I>aŭditori, solenej</I>.", "0"],
["aŭreolo", "aŭreol-o", "[OA] (<I>lumrondo</I>), aureola, glory, nimbus. <B>1</B> (<I>glorkrono, nimbo</I>), halo round head of saint. <I>~o</I> (radiance) <I>de gloro</I>. <B>2</B> (met) halo of moon, or round sun in eclipse, <B>f</B> (<I>famo, prestiĝo), ~o de sukceso (venko). La ~o de edzeco</I> (3 <B>FA</B> 42/6).", "0"],
["aŭrika", "aŭrik-a", "(mar) fore and aft. <I>~a velo</I>.", "0"],
["aŭriklo", "aŭrikl-o", "auricle. <B>1</B> (<I>kor~o</I>), upper cavity of heart. <B>2</B> (<I>orel~o, ~konko</I>), lower lobe of ear.", "0"],
["aŭrikolo", "aŭrikol-o", "<B>1</B> (bot) auricula, bear’s ear (<I>Primula auricula</I>). <B>2</B> (mol) ear-shell (<I>Auricula</I>).", "0"],
["aŭrikulario", "aŭrikulari-o", "auricularia. <B>1</B> (zoo) larval sea-cucumber (➞ <I>holoturi</I>). <B>2</B> (bot) (<I>orelfungo</I>), ear-fungus.", "0"],
["aŭro", "aŭr-o", "aura, subtle emanation. ➞ <I>arom</I>.", "0"],
["aŭroro", "aŭror-o", "Auror/a. <B>1</B> (<I>ĉielruĝo). ~o materia (materia ruĝo</I>), dawn, colour of sky at sunrise. <I>~o vespera (vespera ruĝo</I>), sunset sky. <B>2</B> (<I>polusa lumo), ~o arkta (antarkta</I>), Northern, Southern lights, <I>A. Borealis (Australis</I>). <B>f</B> promising beginning. <I>~o de vivo (nova epoko</I>). <B>~a</B>, -al.", "0"],
["aŭskulti", "aŭskult-i", "(-n, <I>al, abs</I>) [UV] (<I>atente audi)-</I> Listen; give ear (to), hearken (Ps 138/3)- <I>Rifuzi ~i</I>, turn a deaf ear. <B>f</B> follow, obey. <I>~i konsilon</I>. <B>~(ad)o</B>, 1-ing. (med) auscul- tation. <B>~antaro</B>, audience, <B>~ejo</B>, auditorium. <B>~ilo</B>, (tel) receiver, (med) stethoscope (<I>stetoskopo</I>). <B>~umi</B> (<I>brust~i), (~e esplori</I>), sound (<I>pulmojn</I>). <B>El~i</B>, hear to the end. <B>Sub~i</B> (<I>~i kaŝe</I>), eavesdrop. ➞ <I>atent, obe, sekv</I>.", "0"],
["aŭspicio", "aŭspici-o", "auspice, omen, portent for the future. <I>Favora ~o</I>. <B>2 ~oj</B>, auspices, patronage, protection, <I>Sub la ~oj de la BEA</I>. ➞ <I>favor, patron, protekt</I>.", "0"],
["Aŭstralazio", "Aŭstralazi-o", "Australasia.", "0"],
["Aŭstralio", "Aŭstrali-o", "[OA 8] AU, Australia.", "0"],
["Aŭstrujo, Aŭstrio", "Aŭstr-ujo, Aŭstrio", "AT, Austria.", "0"],
["aŭtentika", "aŭtentik-a", "[OA] <B>= aŭtenta</B>, authentic, genuine, of undisputed origin, reliable, trustworthy, <I>~a dokumento, kopio, subskribo</I>. (mus) <I>~a kadenco, modalo</I>. <B>~eco</B>, authentity. <I>Oni dubas pri ĝia aŭtenteco</I> (3 FA 55/15). <B>~igi</B>, authenticate, establish genuineness of, make valid. <B>Mal~a</B> (<I>apokrifa</I>), false, imitation, spurious. ➞ <I>malfals, original, valid, ver</I>.", "0"],
["aŭto", "aŭto-", "(ppfx) (<I>= mem-, de si mem</I>), auto-, self-.", "0"],
["aŭto", "aŭt-o", "(ordinary language) abbreviation of <I>aŭtomobilo</I>. <B>~i</B> Motor. <B>~ejo</B> (<I>~a remizo, garaĝo</I>), garage. <B>~ismo</B>, -ing. <B>~isto</B>, -ist. <B>~buso</B>, m-omnibus. <B>~ĉaro</B>, charabanc, m-coach. <B>Kiras~o</B>, armoured car. <B>Raŭp~o</B>, caterpillar tractor. <B>Ŝarĝ~o</B>, (open) lorry, (covered) m-van. (mot) <B>Trejn~o</B>, learner’s car. <B>Trup~o</B>. ➞ <I>kamion, motor, ŝofor, veturig</I>.", "0"],
["aŭtobiografio", "aŭtobiograf-io", "[OA] <B>~o</B>, autobiography, autobiographer.", "0"],
["aŭtodidakto", "aŭtodidakt-o", "(<I>sininstruinto</I>), self-taught person.", "0"],
["aŭtogena", "aŭtogen-a", "autogenie. <B>~giro</B>, -giro, rotaplane.", "0"],
["aŭtografo", "aŭtograf-o", "[OA] (<I>memskribo</I>), Autograph, author’s own MS or writing, especially signature. <I>Kolekto de ~oj</I>. <B>~a</B> <I>dokumento. <B>~i</B>,</I> a., write in one’s own hand. ➞ <I>manuskript</I>.", "0"],
["aŭtoklavo", "aŭtoklav-o", "autoclave (<I>altpremilo</I>), especially (cul) pressure cooker.", "1"],
["aŭtokrato", "aŭtokrat-o", "[OA] Autocra/t, absolute ruler, <B>f</B> dictatorial overbearing person. <B>~a</B>, -ic. <B>~aro</B>, <B>~eco</B>, <B>~ismo</B>, -cy. <B>~io</B>, [OA] absolute government, absolutist state. ➞ <I>absolut, despot</I>.", "1"],
["aŭtolizo", "aŭtoliz-o", "autolysis. <B>~sugesto</B>, autosuggestion, (av) <B>~kuro</B>, taxying. (m.i.)", "0"],
["aŭtomato", "aŭtomat-o", "[OA] automat/on, self-acting mechanism. <B>Pes~o</B>, <B>Poŝtmark~o</B>, <B>Vend~o. ~a</B>, automatic, self-acting, working by itself, <B>f</B> mechanical, unconscious. <B>~a</B> <I>laboro, movo, ripeto. Ripeti</I> <B>~e. ~eco</B>, <B>~ismo</B>, automatism. <B>~igo</B>, automation. ➞ <I>robot</I>.", "0"],
["aŭtomobilo", "aŭtomobil-o", "[OA] ( = <B>aŭto</B> ordinary language) Automobile, motor-car.", "0"],
["aŭtonoma", "aŭtonom-a", "[OA] autonomous, self-governing. <B>~eco</B>, autonomy, home rule, self-government. ➞ <I>memstar, sendepend, sinreg</I>.", "0"],
["aŭtopiano", "aŭtopian-o", "(<I>pianolo</I>), pianola.", "0"],
["aŭtoritato", "aŭtoritat-o", "[F]. Authorit/y. <B>1</B> Power right to enforce deference or obedience. <I>~o de estro, leĝo. ~o morala</I>. <B>2</B> book, quotation, etc., considered decisive. <I>Citi ~ojn</I>, quote chapter and verse. <B>~o</B>, -ative. <I>~a juĝo. Paroli</I> <B>~e</B> (<I>kun -o</I>). <B>~(ul)o</B>, person of weight, expert. <I>Esti ~o pri fajenco</I>. ➞ <I>potenc, pot; decid, ekspert, kompetent</I>.", "0"],
["aŭtoro", "aŭtor-o", "[F], Author, writer, <B>f</B> originator. <B>~eco</B>. -ship. ~ino, -ess. ➞ <I>elpensint, kreint, komponint, verkint, literatur, pair, tantiem</I>.", "0"],
["aŭtotipio", "aŭtotipi-o", "(<I>retkliŝa procedo</I>), (typ) halftone. <I>~aj punktoj</I>, h-t dots.", "0"],
["aŭtuno", "aŭtun-o", "[UV] Autumn, (Am) fall, <B>f</B> season of decay. <B>~a</B>, -al. <I>~a ekvinokso</I>. ➞ <I>krepusk. velk, vesper</I>.", "0"],
["avanci", "avanc-i", "(<I>antaŭeniri</I>), (nt) <B>1</B> (mil) Advance. <B>2</B> get on, go (move) forward, make headway. <B>~o</B>, a. ➞ <I>antaŭpag, promociiĝ, rangaltiĝ</I>.", "0"],
["avangardo", "avangard-o", "(<I>antaŭgvardio</I>), advance guard, pioneers, van(guard). ➞ <I>arier</I>.", "0"],
["avantaĝo", "avantaĝ-o", "Advantag/e, better position, favourable circumstance, precedence, superiority. <I>Havi ~on (super). Ricevi ~on,</I> reap a benefit. <I>Tiri ~on el</I>, take a. of, turn to account. <B>~a</B>, advantageous, beneficial, favourable. <I>~a kondiĉo, propono</I>. <B>Mal~o</B>, disadvantage.", "0"],
["avara", "avar-a", "[UV] Avaric/ious. <B>1</B> <I>Monavida, amavida</I>, covetous, grasping, greedy. <B>2</B> (<I>troŝparema</I>), close-fisted, mean, miserly, niggardly, stingy. ~i (<I>-n, je, pri</I>), be chary of (sparing with), stint. <I>~i helpon, laŭdon. Patro ~as, filo malŝparas</I>. <B>~(ec)o</B>, avarice, cupidity, greed, eager desire to gain and keep. <B>~ulo</B>, [UV] miser, screw, <B>Mal~a</B> (<I>donema</I>), generous, open-handed. <I>~~a je promesoj</I>. ➞ <I>avid, domaĝ. ŝparem</I>.", "0"],
["avataro", "avatar-o", "(hin) (comp) avatar (<I>virtuala figuro</I>).", "0"],
["avelo", "avel-o", "[UV] hazelnut, cobnut, filbert. <B>~arbo</B>, h-bush (-tree) (<I>Corylus avellana</I>).", "0"],
["aveno", "aven-o", "[UV] oat/s (grain or grass) (<I>Avens</I>). <B>~(ec)a</B>, oat(en).~a <I>pajlero, supo</I>. ~faruno, o-meal. <B>~flokoj</B>, o-flakes. <B>~kaĉo</B>, o-meal porridge.", "0"],
["aventurino", "aventurin-o", "Aventurine, <B>~a feldspato</B>, a-feldspar, sunstone. <B>~a kvarco</B>, a-quartz.", "0"],
["aventuro", "aventur-o", "[UV] Adventur/e, Venture, daring (hazardous) enterprise, unexpected (exciting) experience. <I>Serĉi ~ojn</I>. <B>~ama</B>, <B>~ema</B>, <B>~oplena</B>, a-ous, enterprising, v-some. <B>~e</B>, at a v., at random, in a happy-go-lucky fashion. <B>~i</B>, v., dare (to enter upon). <B>~isto</B>, a-er. <B>Mis~o</B>, mis-a. ➞ <I>aŭdac, danĝer, risk</I>.", "0"],
["avenuo", "avenu-o", "(<I>aleego</I>), avenue, wide tree-bordered approach to house.", "0"],
["averaĝo", "averaĝ-o", "average (arithmetical mean). <I>La ~o de</I> 3, 4, 5, 20, <I>estas</I> 8. ➞ <I>mez -grand-valor-a</I>.", "0"],
["averio", "averi-o", "(ins) Average, apportionment of damage or loss to ship or cargo. <I>~o aparta, ĝenerala</I>, particular (general) a. <B>~isto</B>, a-adjuster. <B>~raporto</B>, a-adjustment. ➞ <I>damaĝ, difekt, ruin</I>.", "0"],
["averti", "avert-i", "(<I>-n, ke, pri, kontraŭ, abs</I>), [UV] Caution, Warn [<I>Ne =</I> avert], <B>1</B> admonish, put on guard (Jeĥ 33/9). <I>~i pri danĝero, eraro, risko</I>. <B>2</B> <I>~i (ke oni ne fari) (ne fari</I>), advise against doing (not to do). <B>~o</B>, c., admonition, warning. <I>Ni forgesas ~on, ni memoras la sperton. Storm~o,</I> gale w-ing. <B>~a</B>, c-ary. <I>~a letero</I>, reminder. <B>~eto</B>, broad hint. <B>~ilo</B>, c-board, sign of w-ing. <B>Antaŭ~i</B>, fore-w, give notice, tell beforehand. <B>Sen~e</B>, unawares. ➞ <I>admon, antaŭsciig, atentig, malkonsil</I>.", "0"],
["aviado", "aviad-o", "[OA] (<I>aera navigado, flugarto</I>), aviation. <B>~i</B>, travel in aircraft. <B>~a</B> <I>malsano</I>, flying sickness, <B>~ilo</B> (<I>aeroplano, flugmaŝino</I>), aeroplane. <I>~ilo batala, mara, skolta</I>. <B>Ŝip~ilo</B>, ship plane. <B>Veter~ilo</B>, weather aeroplane. <I>~ila ŝipo</I>, aircraft carrier. <B>~isto</B>, aviator, airman. ➞ <I>aeroplan, flug, glisil, helikopter</I>.", "0"],
["avida", "avid-a", "(<I>al, je, pri</I>), [UV] Covetous, eager (hungry, thirsting) for, grasping, greedy. <B>~i</B> (<I>deziregi posedi</I>), cast c. eyes on, crave (hunger, long, yearn) for, hanker (lust, sigh) after. <I>~i gloron, laŭdon, ripozon</I>. <I>~aj brakoj</I>. <I>Aŭskulti, rigardi ~e</I>. <B>~eco</B>, avidity. <B>~ega</B>. insatiable. ➞ <I>ambici, aspir, avar, cel, soif, sopir</I>. Rim.: <B>-avida</B> (as a sfx): = <B>-amo, -ema</B>. <B>Glor~a</B>, thirsting for glory. <B>Mon~o</B>, avarice, cupidity, greed. <B>Rang~o</B>, tuft-hunting. <B>Sang~a</B>, bloodthirsty.", "0"],
["avikulario", "avikulari-o", "bird-eating spider (<I>Avicularia</I>).", "0"],
["avizo", "aviz-o", "[UV] Notic/e, announcement, information, intimation, notification, (com) advice. <B>~o al la publiko</B>, \"Take Notice\". <I>Doni ~on, ke … </I>. <I>Presigi ~on en gazeto</I>. <B>~o skriba</B>, n. in writing. (<I>Atendi) ĝis plua ~o</I>, till further notice. <B>Antaŭ~o</B>, previous n. <B>Liver~o</B>, delivery note. <B>Ricev~o</B>, acknowledgment, receipt. <B>~i</B> (<I>-n pri</I>), advise, announce, give notice of, inform, notify. <B>~letero</B>, letter of advice. ➞ <I>avert, inform, komunik, sciig</I>.", "0"],
["avo", "av-o", "[UV] Grandfather. <I>~o patrinflanke</I> (g. on the mother’s side). <B>Prage~oj</B>, great-grandparents. <B>Prapra~o</B>, great-great-g.", "0"],
["avoceto", "avocet-o", "(orn) avocet (<I>Recurvirostra avocetta</I>).", "0"],
["avokado", "avokad-o", "avocado pear (<I>Persea</I>).", "0"],
["azaleo", "azale-o", "azalea (<I>Azalea</I>) &lt; rododendr, which see", "0"],
["azaro", "azar-o", "asabaracca, wild ginger (<I>Asarum</I>).", "0"],
["azarolo", "azarol-o", "azarole, Neapolitan medlar, fruit of <B>~arbo (</B><I>Crataegus azarolus</I>).", "0"],
["azedarako", "azedarak-o", "azedarach, bead-tree, white cedir (<I>Melia azedarach</I>).", "0"],
["azeno", "azen-o", "[UV] Ass, donkey. (<I>Asinus</I>). <B>f</B> blockhead, dolt (type of ignorance or stupidity). <B>~i</B> (<I>agi stulte</I>). <B>~a</B>, asinine. <B>~aĉo</B>, moke. <B>~aĵo</B>, stupidity. <B>~ido</B>, ass’s colt (foal). <I>Forveturis ~ido kaj revenis ~o. <B>~</B></I><B>ino</B> (Jer 2/24). <B>~bleki</B>, bray. <B>Vir~o</B>, jackass. ➞ <I>hemion, onagr</I>.", "0"],
["Azerbajĝano", "Azerbajĝan-o", "AZ, Azerbaijan, a. Azerbaidzhan.", "0"],
["azilo", "azil-o", "[OA] (<I>rifuĝejo</I>), asylum, place of refuge or safety, sanctuary <I>por fuĝantoj, kadukuloj, malriĉuloj, senhejmuloj. Serĉi ~on en preĝejo</I>. <B>~petanto</B>.", "0"],
["azimuto", "azimut-o", "azimuth, arc from zenith to horizon. <I>~o magneta, vera</I>. <B>~a</B> <I>angulo, cirklo, kompaso. ~aj (polusaj) koordinatoj</I>.", "0"],
["Azio", "Azi-o", "Asia.", "0"],
["azoto", "azot-o", "[UV] <B>= nitrogeno.</B>", "0"],
["B natura", "", "B natural. B <B>be</B> (B <B>bemola)</B>, B flat.", "0"],
["babili", "babil-i", "(<I>-n, pri, abs</I>), [UV] Chatter; babble, chat, prattle. <B>~aĉi</B>, crackle, clack, gab, jabber. <B>~ado</B>, <B>~aĵo</B>, c., chit-chat, gossip, idle talk, tittle-tattle(Ij 30/9). <I>Intima~ado</I>. <B>~ema</B> [UV] (<I>parolema</I>), garrulious, loquacious, talkative. <B>~(em)ulo</B>, c-box, gossip, tell-tale. <B>Dis~i</B>, <B>El~i</B>, blab, blurt out, <I>El~i sekreton</I>, let the cat out of the bag. ➞ <I>klaĉ, klak; malkaŝ, perfid</I>.", "0"],
["babiruso", "babirus-o", "(zoo) babirusa, wild hog (<I>Babirussa</I>).", "0"],
["babordo", "babord-o", "(<I>ruĝa flanko</I>), (mar) port.", "0"],
["bacilo", "bacil-o", "[OA] bacillus (rod-shaped bacterium). <I>~o tetana, tifa</I>.", "0"],
["badmintono", "badminton-o", "(gm) badminton.", "0"],
["bagatelo", "bagatel-o", "[UV] (<I>malgravaĵo</I>), mere trifle, bagatelle, something negligible, (mus) short unpretentious piece. <I>Aĉeti por ~o</I>, buy for a mere song. <B>~a</B>, insignificant, paltry, petty, trivial. <B>~ema</B> (<I>detalema, pedanta</I>), mean, pettifogging, small-minded, straw-splitting. <B>~igi</B> (<I>-n</I>), make light of. ➞ <I>neatentind, negrav, sensignif, senvalor, trivial; bilardet</I>.", "0"],
["bagno", "bagn-o", "(<I>punlaborejo</I>), convict prison. <B>~o flotanta</B>, galleys, hulks.", "0"],
["Bahamoj", "Baham-oj", "BS", "0"],
["bajoneto", "bajonet-o", "[UV] (<I>pikklingo</I>), bayonet. <B>~i</B>, b.", "0"],
["baj!", "", "(interjection), (a. <I>Iu lu!</I>), Hushaby! (to lull a child to sleep), usually <I>Baj! Baj!</I> or <I>Baju! Baju!</I>", "0"],
["bakalaŭro", "bakalaŭr-o", "bachelor (B.A., B.Sc., etc.). (the meaning varies in different lands). ➞ <I>magistr</I>.", "0"],
["bakanalo", "bakanal-o", "bacchanalia. <B>f</B> drunken revel. ➞ <I>orgi</I>.", "0"],
["bakarato", "bakarat-o", "(cgm) baccarat.", "0"],
["bakelito", "bakelit-o", "bakelite, synthetic plastic material.", "0"],
["baki", "bak-i", "(<I>-n</I>), [UV] bake. <B>1</B> cook by dry heat. <I>~i panon</I>. <B>2</B> (➞ <I>kalcin</I>), dry (harden) by heat, fire (pottery). <I>~i brikojn. Nove ~ita,</I> newly baked. <I>Sun~itaj fruktoj</I>. <B>f</B> <I>Nove ~ita Esp-isto</I>. <B>~(it)aĵo</B>, -ed cakes, meats etc.; a \"batch\". <B>~ejo</B>, b-house, bakery. <B>~isto</B>, baker. <I>Tort~isto</I>, confectioner. <B>~istestro</B> (Ge 41/10). <B>~ujo</B>, <B>~forno</B>. oven. ➞ <I>pulvor</I>.", "0"],
["bakŝiŝo", "bakŝiŝ-o", "backsheesh.", "0"],
["bakterio", "bakteri-o", "[OA] bacterium.", "0"],
["bakteriologo, bakteriologio", "bakteriolog-o, bakteriologi-o", "bacteriologist. bacteriology.", "0"],
["balado", "balad-o", "[OA] ballad. <B>1</B> narrative, poem in short verses. <B>2</B> musical setting of this. E.g., <I>Sea-drift</I> (Sibelius). <B>3</B> sentimental song with several verses, more or less to same melody, e.g., <I>Home Sweet Home</I>. <B>4</B> instrumental piece with idea of a narrative e.g., <I>~oj de Chopin</I>. <B>5</B> (pros) Ballade, poetic form.", "0"],
["balai", "bala-i", "(<I>-n</I>), [UV] Sweep, clean with broom. <B>~i</B> <I>la ĉambron, plankon, straton</I>. <B>f</B> <I>Lumradio ~as la teron; robo ~as la grundon; vento ~as la stepon</I>. <B>~aĵo</B>, -ings. <B>~ajujo</B>, dust-bin, rubbish-box. <B>~ilo</B>, broom. <B>Branĉ~ilo</B>, besom. <B>Franĝ~ilo</B>, mop. <B>Kaŭĉuka ~ilo</B>, squeegee. <B>Mekanika ~ilo</B>, carpet s-er. <B>~ileto (plum~ilo)</B>, feather duster, whisk. <B>~indajo</B> (PI 3/45). (<I>Strat)~isto</I>, road s-er, scavenger. <B>~maŝino</B>, road-ing cart. <B>For~i</B>, s. away (up), make a clean s. of. <I>For~i polvon. La vento for~is la nubojn</I>. ➞ <I>bros, ŝvabr</I>.", "0"],
["balalajko", "balalajk-o", "balalaika (Russian m.i.).", "0"],
["balanci", "balanc-i", "(<I>-n</I>), [UV] Rock, Swing (especially up and down), balance, toss. <I>~i infanon en hamako, surgenue. La floroj (mandareno) ~is</I> (nodded) <I>la kapon. ~i la kapon (jese), skui la kapon (nee</I>). <B>Rim</B>.: In some lands <I>~i nee, skui jese</I>. <B>~a</B> <I>seĝo</I>, rocking chair. <B>~iĝi</B>, (nt), rock, swing, dangle, oscillate, pitch, roll, sway, toss, <B>f</B> fluctuate, ~<B>iĝado</B>, rocking, swinging, tossing. <B>~ilo</B> (<I>~tabulo, baskulo</I>), see-saw (➞ <I>pendolo, svingilo</I>), swing. <B>~arko</B>, rocker (<I>de seĝo, lulilo</I>). <B>~ĉevalo</B>, rocking horse. ➞ <I>rul, sku, sving, ŝancel. [Ne= bilanc, ekvilibr, kompens, pesil, sald]</I>.", "0"],
["balanciero", "balancier-o", "(hor) (mec) balance-beam (-wheel).", "0"],
["balaneno", "balanen-o", "nut weevil (<I>Balaninus</I>).", "0"],
["balano", "balan-o", "(<I>mar-glano</I>), acorn barnacle (<I>Balanus</I>). ➞ <I>lepad</I>.", "0"],
["balasto", "balast-o", "[OA] Ballast, (bid) <I>Sabla ~o,</I> sand cushion (filling), <B>f</B> (<I>senutilaĵo, superaĵo, fluaĵo). Nenecesa neologismo estas ~o</I>. <B>Kun ~o</B>, in ballast. <I><B>~i</B> </I>(<I>ŝipon) (preni ~on</I>), lade with (take in) b. <B>~a ŝarĝo</B>, dead freight. <B>Sen~igi</B> (<I>malpezigi) ŝipon</I>, lighten. ➞ <I>balaaĵ, rub</I>.", "0"],
["balato", "balat-o", "balata, gum from bully-tree (<I>Mimuops balata</I>). ➞ <I>gutaperk</I>.", "0"],
["balbuti", "balbut-i", "(-n, abs), [UV] Stammer, splutter, stutter, have impediment in one’s speech, <B>f</B> falter out (<I>ekskuzon</I>). <B>~ado</B>, -ing. <B>~ulo</B>, -er. ➞ <I>kartav, lisp</I>.", "0"],
["baldakeno", "baldaken-o", "[UV] hanging canopy (over bed, throne, etc.).", "0"],
["baldaŭ", "", "[UV] (<I>post mallonga tempo</I>), (adv) Soon, promptly, shortly. <I>Mi ~ revenos. ~ poste</I>, soon afterwards. <I>Pli ~</I> sooner, earlier. <I>Kiel eble plej ~</I> as soon as possible (abbr: asap). <B>~a</B>, early, prompt, <I>Ĝis ~a revido, La plej ~a</I> (4 FA 133/10). <B>~eco</B>, proximity (of event). <B>~igi</B>, hasten, bring near. ➞ <I>fru, post-ne-long, tuj</I>.", "0"],
["Balearoj", "Balear-oj", "Balearic Islands.", "0"],
["baleno", "balen-o", "[UV] Whal<B>/</B>e (<I>Balaena), ~o ĝiba, dorsa</I>, hump-backed whale. <I>~o spermaceta (kaĉaloto</I>), sperm w. <B>~aĵo</B>, <B>(~osto)</B> [UV] (<I>barto</I>), whalebone. <B>~ido</B>, w-cub. <B>~ino</B>, w-cow. <B>-blanko</B>, <B>~vakso</B> (<I>spermaceto</I>), spermaceti. <B>~boato</B>, <B>~ŝipo</B>, w-er. <B>~ĉasŝipo</B>, w-catcher. <B>~kaptado</B>, w-ing. <B>~oleo</B>, w-oil, train oil. ➞ <I>focen</I>.", "0"],
["balenoptero", "", "rorqual, blue or finback whale (<I>Balaenoptera</I>).", "0"],
["baleto", "balet-o", "[OA] ballet. <B>~ist(in)o</B>, b-dancer.", "0"],
["balgo", "balg-o", "<B>1</B> (folding) Bellows. <B>2</B> accordion pleating. <I>~o akordion- (intervagon- kamer-)a</I>. (org) <B>(Pump)-o</B> (<I>~blovilo</I>), b. <I>Treti la ~on</I>, blow the b.", "0"],
["balistiko", "", "[OA] ballistics, science of projectiles.", "0"],
["balisto", "balist-o", "(mil) ballista.", "0"],
["balisto", "balist-o", "(ich) trigger-fish (<I>Ballistes</I>).", "0"],
["balkono", "balkon-o", "[OA] balcony. <B>1</B> Outside balus- trated platform with access from upper- floor window. <B>2</B> (th) tier of seats between dress circle and gallery <B>Unua ~o</B>, dress circle. ➞ <I>altan, galeri, teras, verand</I>.", "0"],
["balo", "bal-o", "(<B><I>danckunveno</I></B>) [F], Ball, dance <I>[Ne= pilko]. La reĝino de la ~o</I>. <B>Kostum~o</B>, fancy-dress ball. <B>~ejo, ~ĉambro, ~salono</B>, ball-room. <B>~robo, ~vesto</B>, ball-dress.", "0"],
["balono", "balon-o", "[OA] <B>1</B> Balloon (<I>aerostato), ~o direktebla, libera, ligita</I>. <B>Pilot~o</B>, pilot-b. <B>Sond-o</B>, sounding-b. <B>2</B> (gm) large rubber ball. <B>Boks-o</B>, punching-ball. <B>3</B> b-flask, bulb. ➞ <I>retort</I>, <B>f Prov~o</B>, feeler, <B>~eto</B>, child’s toy balloon. <B>~isto</B>, -ist.", "0"],
["baloteo", "balote-o", "(bot) black horehound (<I>Ballota</I>). ➞ <I>marubi</I>.", "0"],
["baloti", "balot-i", "(<I>-n, por, pri, kontraŭ, abs</I>) [OA], (<I>elekti</I> <B>~e)</B>, (vote by) Ballot, secret vote. <B>~(ad)o</B>, (election by b.) <B>~ilo</B>, <B>-globo</B>, <B>-papero</B>, b-ball, voting paper. <B>~ujo</B>, b-box. <B>~rajto</B>, franchise. ➞ <I>elekt, voĉdon</I>.", "0"],
["balteo", "balte-o", "(<I>ŝultrorimeno</I>), baldrick, shoulder belt (for sword, etc.). <I>Kartoĉa ~o,</I> bandolier.", "0"],
["balustrado", "balustrad-o", "[UV] (<I>apoga relo, balustraro</I>), banisters (of balcony, staircase, etc), balustrade, hand-rail(ing), side-rail(ing).", "0"],
["balustro", "balustr-o", "banister, baluster, short pillar supporting rail, usually pearshaped in middle. <B>~aro</B> = balustrado.", "0"],
["balzaminacoj", "balzamin-acoj", "[OA] Balsams (<I>Impatiens</I>) &gt; touch-me-not (<I>I. noli-tangere</I>).", "0"],
["balzamito", "balzamit-o", "(bot) costmary (<I>Chrysanthemum balsamita</I>).", "0"],
["balzamo", "balzam-o", "[OA] Balsam, balm. <B>1</B> natural resin. <I>~o Kanada, kopaiva, Perua, tolua</I>. <B>2</B> (phar) ointment from this. <I>~o trankviliga</I>. <B>f</B> consolation, something with soothing influence. <I>Laboro estas ~o kontraŭ ĉagreno</I>. <B>~a</B>, balmy (➞ <I>ambrozi</I>). <B>~i (en~igi)</B>, embalm (Ge 50/2). <B>~arbo</B>, b-tree, any tree yielding b. ➞ <I>mirh</I>.", "0"],
["balzo", "balz-o", "balsa (corkwood) tree (<I>Ochroma). ~a ligno</I>, b-wood.", "0"],
["bambuo", "bambu-o", "[UV] bamboo (<I>Bambusa</I>). <B>~a</B> <I>bastono, kano</I>.", "0"],
["banala", "banal-a", "[OA] Banal, Commonplace; everyday, hackneyed, stale, trite. <I>Paroli pri ~aj aferoj</I>, engage in small talk. <B>~a</B> <I>vero</I>, truism. <B>~e</B>, in a b. (c.) manner. <B>~aĵo</B>, something c., trite, etc., platitude. <I>~aĵo el la ĉiutaga vivo</I>. <B>~eco</B>, b-ity. ➞ <I>gurd, ordinar, seninteres, stereotip, ŝablon, trivial</I>.", "0"],
["banano", "banan-o", "[OA] banana, fruit of <B>~arbo</B> (<I>Musa sapientum</I>).", "0"],
["bandaĝo", "bandaĝ-o", "(<I>ĉirkaŭligaĵo</I>) [OA], Bandage, binding band (strip). <B>Hernia ~o</B>, truss. <B>Perioda</B> <B>~o</B>, sanitary towel. <B>~i</B> <I>vund(it)on,</I> b., bind up (Ij 5/18). <I>~i brakon, vundon</I> (Ho 6/1). <I>~i la okulojn</I>, blindfold. ➞ <I>pans, vind</I>.", "0"],
["banderolo,", "banderol-o,", "[OA] <B>1</B> ribbon-like scroll, band, streamer, (mil) lance-pennon. <B>2</B> strip for closing or wrapping, adhesive tape, especially postal wrapper. <B>~eto</B>, cigar-band, etc. <I>Sub ~o</I>, in a wrapper. ➞ <I>bend, ruband, stri</I>.", "0"],
["bandito", "bandit-o", "(<I>vojrabisto</I>) [OA], bandit, gangster, highwayman, outlaw.", "0"],
["bando", "band-o", "[UV] Band, party, set, troop (Ho 7/1) (us. contemptuous). <I>~o de junuloj</I>. La tuta <B>~o</B>, the whole gang, crew. <B>~estro</B>, leader of the b. <B>~iĝi</B> club together. <B>2</B> (mus) b., ludantaro. <I>~o faza, latuna, mandolina</I>. ➞ <I>grup, hord, trup, orkestret</I>.", "0"],
["bangalo", "bangal-o", "bungalow, one-storied house.", "0"],
["Bangladeŝo", "Bangladeŝ-o", "BD.", "0"],
["banĝo", "banĝ-o", "Banjo. <B>Citra ~o</B>, zither-b. Variants: <B>~olino</B>, <B>~ulelo</B>.", "0"],
["bani", "ban-i", "(<I>-n, en, per</I>), [UV] bathe (someone), immerse. <I>~i infanon</I>. <B>f</B> <I>~ata de la maro, larmoj, lumo, roso. La ondoj ~is la marbordon</I>. <B>~o</B>, Bath. <I>~o (mal)varma</I>. <B>Aer~o</B>, <B>pied~o</B>, <B>sun~o</B>, <B>ŝpruc~o. Pluv~o</B>, <B>duŝ~o</B>, douche, shower-b. <B>Sid~o</B>, hip-(sitz-)b. <B>S]Jong~o</B>, tub. <B>Ŝvit~o</B>, <B>vapor~o</B>, Turkish b. <B>Ŝlim~o</B>, mud-b. (phot) <B>Fiks~o</B>, <B>rivel~o</B>, <B>ton~o. ~ejo (~domo)</B>, the baths. <B>~iĝi (sin ~i)</B>, have a b., bathe. <B>Okul~ilo</B>, eye b. <B>~ujo</B>, <B>~kuvo</B>, b-tub. <B>~ĉambro</B>, b-room. <B>~gasto</B> (<I>~eja paciento</I>). <B>~kostumo</B>, <I>~vesto</I>, -ing dress. ➞ <I>duŝ, lav, macer, ru, tremp</I>.", "0"],
["banjano", "banjan-o", "Banyan, Indian fig-tree (<I>Ficus</I> indica).", "0"],
["bankedo", "banked-o", "Banquet, dinner with speeches. <B>~ejo</B>, b-ing hall.", "0"],
["bankiero", "bankier-o", "[OA] (<I>bankestro, bankposedanto</I>), banker. ➞ <I>bank</I>.", "0"],
["bankizo", "bankiz-o", "(<I>glacia kampo polusa</I>), ice-bank (-floe, -pack).", "0"],
["banko", "bank-o", "[OA] (com) Bank (firm or building). <B>Akcia ~o</B>, joint-stock b. <B>Diskonta ~o</B>, discount b. <B>Eldona ~o</B>, b. of issue. <B>Ŝpar~o</B>, savings b. <B>~estro</B>, -er, b-manager. <B>~(ofic)isto</B>, b-clerk (-official). <B>~bileto</B>, <B>~konto</B>, <B>~libro. En~igi</B>, pay in (➞ <I>invest, lok</I>, ➞ <I>bankier, kas.</I>)", "0"],
["bankroti", "bankrot-i", "(<I>nt</I>), [OA], go Bankrupt, default, fail, smash, <B>f</B> <I>Ĉiu peno ~is</I>. <B>~o</B>, -cy, collapse, failure. <I>Fraŭda ~o</I>, fraudulent -cy. <B>~(int)a</B>, (<I>insolventa</I>), b., insolvent. <B>~into</B>, <B>~ulo</B>, b. <B>~aranĝo</B>, composition.", "0"],
["bantamo", "bantam-o", "(zool) bantam cock.", "0"],
["banto", "bant-o", "[UV] Knot, bow (of ribbon, etc.). <B>Am~o</B>, love-k. <B>Kap~o</B>, top-k. <B>~igi</B> (tie) <I>kravaton</I>. ➞ <I>kokard, laĉ, maŝ, nod, rozet</I>.", "0"],
["baobabo", "baobab-o", "baobab (monkey-bread) tree (<I>Adamsonia digitata</I>).", "0"],
["bapti", "bapt-i", "(<I>-n</I>), [UV] Bapt/ize, christen. <B>1</B> (rel) (Mt 28/9). <B>2 f</B> (<I>nomi), ~i sonorilon, ŝipon</I>. (fac) water: <I>~i lakton, vinon</I>. ➞ <I>dilu</I>. <B>~o</B>, -ism. <B>~a</B>, -ismal. ~a <I>atesto, registro</I>. <B>~a nomo</B> (<I>antaŭnomo</I>), Christian name, <B>~an(in)o</B>, [UV] co-sponsor, fellow godparent, gossip. <B>~ejo</B>, -istry. <B>~isto</B>, -ist. (a) member of rel. sect, (b) -izer. <I>Johano la ~isto</I>, <B>~ujo</B>, <B>~a baseno</B>, <B>pelvo</B>, font. <B>~ofilo</B>, [UV] godson. <B>~opatro</B>, [UV] godfather. ➞ <I>anabapt, aspering</I>.", "0"],
["barako", "barak-o", "[OA] barrack, hut, temporary shanty for soldiers, workmen etc. <B>~aĉo</B>, wretched hovel. <B>~aro</B>, barracks, hut camp, huttage, shedding. ➞ <I>bud, kaban, kazern</I>.", "0"],
["barakti", "barakt-i", "[UV]. Struggle (against), contend (grapple) with, flounder, kick (fling one’s) about, move convulsively, writhe. <I>~i kontraŭ la morto. ~i kiel fiŝo ekster akvo. ~i</I> (splash about) <I>en akvo. ~i</I> (wallow, welter) <I>en koto</I>, <B>f</B> <I>Nova ideo ~is en lia kapo</I>. <B>~a</B> (<I>konvulsia</I>), convulsive. <B>~ado</B>, kicking, struggle. <B>~eti</B>, fidget. ➞ <I>agoni, lukt, rezist, tordiĝ</I>.", "0"],
["baraterio", "barateri-o", "(jur) (mar), barratry.", "0"],
["Barato", "Barat-o", "(= Hindujo, Hindio) IN.", "0"],
["Barbado", "Barbad-o", "BB, Barbados.", "0"],
["barbareo", "barbare-o", "(bot) winter cress (<I>Barbarea</I>).", "0"],
["barbaro", "barbar-o", "[OA] Barbar/ian. <B>1</B> (orig) = <I>negreko</I>. Hence 2 (<I>~a ulo</I>), coarse, cruel, rough, rude, vulgar, uncivilized, uncultured, wild, person. <B>~a</B>, -ic, inhuman, uncouth, etc. <I>~a kutimo, lingvo</I>. <B>~aĵo</B>, <B>~eco</B>, barbarity, savagery, etc. <B>~ismo</B>, (lit) (➞ <I>solecism</I>), unclassical (unorthodox) use of language. ➞ <I>huligan, kruel, sovaĝ, vandal</I>.", "0"],
["barbastelo", "barbastel-o", "barbastelle bat (<I>Barbastella</I>).", "0"],
["barbedo", "barbed-o", "(mil) barbette.", "0"],
["barbikano", "barbikan-o", "(mil) barbican, outer defence, outwork.", "0"],
["barbiro", "barbir-o", "[UV] Barber, hairdresser (Jeĥ 5/1). <B>~a</B>, tonsorial. <B>~ejo</B>, b’s shop, toilet saloon. <B>~i</B>, work as a barber. ➞ <I>barbist, frizist, kombist, razist</I>.", "0"],
["barbiturato", "barbiturat-o", "(phar), barbiturate.", "0"],
["barbo", "barb-o", "[UV] Beard. <I>~o pinta</I>, goatee. <I>~o potenca, sed kapo sensenca. Ridi en sia ~o</I>, laugh in one’s sleeve, (bot) awn (a. <I>aristo). Kapra ~o</I>, goat’s beard (bot) = <I>tragopogo</I>. <B>~ulo</B>, -ed man. <I>Blank~ulo, griz~ulo</I>, grey-b. <I>Blu~ulo</I>, blue-b. <B>~umo</B>, barb (of <I>anchor, fish-hook</I>, etc.). <B>~fiŝo</B>, barbel (Barbus).<I> <B>Plen~a</B>, fullbearded. Ruĝ~a, redbearded, <B>Sen~a</B>, beardless, smooth-faced</I>.", "0"],
["barĉo", "barĉ-o", "[UV] borsch, Russian red beetroot soup.", "0"],
["bardo", "bard-o", "[OA] bard. <B>1</B> Celtic minstrel. <B>2</B> (wide sense) lyric singer, poet. <I>Skandinava ~o</I>, scald.", "0"],
["Barejno", "Barejn-o", "BH.", "0"],
["bareliefo", "barelief-o", "[OA] = malaltreliefo.", "0"],
["barelo", "barel-o", "[UV] Barrel, cask, drum. <I>~o malplena sonas plej laŭte. Haring~o,</I> herring-b. (tech) b., cylinder (<I>de horloĝo, kapstano, revolvero</I>). <B>~ego</B>, hogshead, tun. <B>~ero</B>, <B>~daŭbo</B>, <B>~tabulo</B>, stave. <B>~eto</B>, firkin, keg. <B>~igi</B> (<I>ventrodikiĝi</I>), bulge, swell out. <B>~isto</B>, cooper. <B>~bendo</B>, <B>~ringo</B>, hoop. <B>Naĝ~o</B>, <B>signo~o</B>, (<I>buo</I>), buoy.", "0"],
["baremo", "barem-o", "ready-reckoner, scale (of prices, etc.).", "0"],
["barĝo", "barĝ-o", "(<I>platfunda ŝarĝboato</I>), Barge, lighter, scow. <B>~isto</B>, -ee.", "0"],
["bari", "bar-i", "(<I>-n</I>), [UV] (<I>fermi vojon, malhelpi trairon</I>), Bar, block (up), dam, obstruct, stop up. <I>~i eniron, fluon, komunikon, progreson, straton</I>. <B>~i</B> (<I>al iu) la vojon</I> (1 Sa 15/2). Oppose, prevent progress, stand in the way of, thwart. <B>~o</B>, <B>1</B> b. (Mi 2/13), hindrance, impediment, restraint, stop, <I>Lingvaj ~oj</I>. <B>2</B> bar, rail, rod. (sp) <I>~oj horizontalaj, paralelaj. ~o de trinkejo (tribunalo</I>), bar in public-house (court of justice). <B>~aĵo</B> (concrete sense), b., dam, obstruction, weir, (mar) (<I>sabla) ~aĵo</I>. sand-bank, mud deposit. <B>~ilo</B>, [UV] barrier, fence, etc. (a. <I>bariero</I>) (Ps <B>62/3). Balon~ilo</B>, balloon barrage. <B>Dorn~ilo</B>, <B>drat~ilo</B>, barbed wire fence. <B>Flotanta ~ilo</B>, boom. <B>Inter-ilo</B>, partition. <B>Plekto~ilo</B> (<I>hurdo</I>), hurdle, wattle fence. <B>Ŝtup~ilo</B>, stile. <B>~ludo</B> (gm), prisoner’s base. <B>Cirkaŭ~i</B>, enclose, hem in, fence (hedge) around, pen. <B>f</B> bound, circumscribe, limit, restrict (PI <B>3/7)</B>. ➞ <I>bufed, blok, brid, obstrukc, stop; heĝ, palisar</I>.", "0"],
["bariero", "barier-o", "[OA] (<I>barilo, bartrabo</I>) any obstacle barring access, advance, entrance; barrier, fence, gate, toll-bar, turn-pike, <I>~o levebla. Meti ~on inter du personojn</I>. <B>Rul~o</B>, <B>Turn~o</B>, swing-gate, turn-stile. <B>~isto</B>, gate-keeper, toll-keeper. (geog) <I>Granda ~a Rifo</I>. ➞ <I>apartigil</I>.", "0"],
["barikado", "barikad-o", "[OA] barricade, defence barrier against attack. <I>Detrui ĉiun ~on</I>, break dp all opposition. <B>~i</B> <I>straton</I>. ➞ <I>baraĵ</I>.", "0"],
["baringtonio", "baringtoni-o", "(bot) barringtonia (<I>Barring- tonia</I>).", "0"],
["bario", "bari-o", "barium (Ba). <B>~a sulfato (~a spato)</B>, barytes (Ba So<SUB>4</SUB>). ➞ <I>barit</I>.", "0"],
["barito", "barit-o", "baryta (Ba O). <B>~papero</B>, art paper.", "0"],
["baritono", "bariton-o", "[OA] baritone (voice, part, singer).", "0"],
["barkarolo", "barkarol-o", "(gondola kanto), barcarolle, boat-song.", "0"],
["barko", "bark-o", "[UV] barque. <B>1</B> 3-5-masted vessel, mainly square-rigged. <B>2</B> (wide sense) (<I>boato</I>), any small sailing-boat or ship. <I>~o fiŝista. Ceremonia ~o</I>, state barge. <I>~o de Ĥaron,</I> Charon’s ferry.", "0"],
["barografo", "barograf-o", "barograph, recording barometer.", "0"],
["baroko", "barok-o", "(arch) baroque, 17th century ornate style. <B>~a</B>, <B>f</B> grotesque, irreg-ly shaped, odd, quaint, whimsical. ➞ <I>fantazi, strang</I><B></B>, <I>rokok</I>.", "0"],
["barometro", "barometr-o", "[OA] barometer, weather glass. ➞ <I>anerojd, barograf</I>.", "0"],
["barono", "baron-o", "[OA] Baron (title). <B>~eco</B>, <B>~lando</B>, -y. <B>~(edz)ino</B>, -ess. <B>~eto</B>, -et.", "0"],
["baroskopo", "baroskop-o", "(met) baroscope.", "0"],
["barto (", "bart-o (", "<I>balenosto</I>), whalebone, (cl) (corset) busk.", "0"],
["baseno", "basen-o", "[OA] Basin (wide space for water). <B>1</B> (<I>pelvego). ~o de fontano, da akvo</I> (Na 2/8). <B>2</B> wet dock, reservoir, etc. <I>~o havena, kluza, tajda</I>. <B>3</B> (geol) <I>~o rivera</I>, river b. ➞ <I>akvuj, cistern, kolektuj, kuv. [Ne= pelv, lavovaz.]</I>", "0"],
["basetkorno", "", "(<I>tenora klarneto</I>), (mus) basset horn.", "0"],
["baseto", "baset-o", "basset (dog).", "0"],
["basio", "basi-o", "(<I>buterarbo</I>), butter-tree (<I>Bassia</I>).", "0"],
["basko", "bask-o", "[UV] (coat) tail, loose pt under waist, skirt. <I>Liaj ~oj</I> (his train) <I>plenigis la templon</I> (Jes <B>6/1). f</B> apron-strings.", "0"],
["baskulo", "baskul-o", "(<I>balanctabulo</I>), rocker, see-saw. <I>~a ĉevalo (seĝo</I>), rocking horse (chair). <I>~a vagono</I>, tip wagon. <B>~i</B>, rock, tilt, tip.", "0"],
["baso", "bas-o", "[OA] (mus) <B>1</B> Bass (voice, part, singer). <I>~o obstin-(ripet-)a</I>, basso ostin- ato, ground-b. <B>~a</B> <I>voĉo</I>, <B>~ulo. 2</B> Lowest of a class of instruments. <B>~(violon)o</B> (<I>kontrabaso</I>), double- b. similar <B>~klarneto</B>, <B>-tamburo</B>, <B>~trombono</B>, <B>~trumpeto</B>. ➞ <I>burd, cifer, kief, stri</I>.", "0"],
["bastardo", "bastard-o", "[OA] Bastard, person born out of wedlock. <B>~a</B>, b., <B>f</B> hybrid, counterfeit. ➞ <I>eksteredz, neleĝ; fals, hibrid</I>.", "0"],
["bastilo", "bastil-o", "(hist) bastille, Parisian state prison.", "0"],
["bastiono", "bastion-o", "[UV] (mil) bastion, <B>f</B> bulwark, defence stronghold (Ij 13/12), e.g., <I>~o de libereco</I>. ➞ <I>defendil, rempar, ŝirmil</I>.", "0"],
["basto", "bast-o", "[UV] Bast, inner bark. <B>~aĵo</B>, something made of bast, matting, rope, etc. <I>~a mato,</I> b. mat.", "0"],
["bastono", "baston-o", "[UV] Stick, staff (usually wooden). <I>~o de pilgrimanto. ~o ombrela, paŝtista, policana</I>. <B>Apog~o</B>, <B>lam~o</B>, [UV] crutch. <B>Bilard~o</B>, cue. <B>Hok~o</B>, crook, crosier. <B>Montra ~o</B>, pointer, <B>Mont~o</B>, alpenstock. <B>Pik~o</B>, ice-axe. <B>Promen~o</B>, walkg-s. <B>Reĝ~o</B>, sceptre. <B>Rul~o</B>, (cul), rollg-pin. <B>Spad~o</B>, sword-s. <B>Ŝpin~o</B>, distaff. <B>Takt~o (</B><I>taktilo</I>), baton. <B>~i</B> (<I>-n</I>), baste, beat, cane. <B>~ado</B>, bastinado, caning on soles of feet. <B>~ego (</B><I>klabo</I>), bludgeon, club, cudgel, truncheon. <B>~eto</B>, cane, rod, switch, stick, e.g., <I>de vakso</I>. <B>Manĝ~etoj</B>, chop-ss. <B>Ung~eto</B>, orange-s. ➞ <I>apog-(bat-)il, fost, kan, paliset, stang, vering</I>.", "0"],
["batali", "batal-i", "[UV] (nt, <I>inter, por, pro; kun A kontraŭ B;</I> sometimes <I>kun B</I>), do Battle, combat, fight. <I>~i kontraŭ la sorto. ~o,</I> b., engagement. <B>Aer~(klas~mar~)o. Fin~o</B> (<I>agonio</I>). <B>Lud~o</B>, match. <B>Miks~o</B>, melde, fray, scrimmage, scrum. <B>Vet~o</B>, fight for wager, prize-fight. <B>~e</B>, (1 Sa 14/22). <B>~anto</B>, combatant, fighter, warrior. <B>~ejo</B>, <B>~kampo</B>, b-field. <B>~ema</B>, combative, pugnacious, quarrelsome. <B>~eto</B>, skirmish. <B>~ilo</B>, [UV] weapon (Ij <B>20/24). ~preta</B>, up in arms. <B>Ek~i</B>, join b. <B>Kontraŭ~i</B>, oppose, resist. <B>Kun~anto</B>, comrade-in-arms. <B>Pro- anto</B>, champion, defendant. ➞ <I>atak, barakt, konflikt, lukt, milit</I>.", "0"],
["bataliono", "batalion-o", "[OA] battalion, unit of infantry.", "0"],
["batato", "batat-o", "sweet potato (<I>Ipomoea batatas</I>).", "0"],
["baterio", "bateri-o", "[OA] battery. <B>1</B> (mil) = kanon-aro- ejo. <B>2</B> (el) = pilaro. <I>~o alttensia (anoda</I>), H T b. <I>Plenigi (Ŝargi) ~on</I>.", "0"],
["bati", "bat-i", "(<I>-n</I>, abs), [UV] Beat (wide sense) smite, strike: <B>~i</B> <I>hundon, kremon, tamburon, la bruston, horon. ~u la feron, dum ĝi estas varmega</I>. <B>~i</B> la takton (takti</I>), b. time. (<I>Pun)-i infanon. Altan arbon ~as la fulmo</I>. <B>~ita</B> (buffeted) <I>de la ondoj</I>. <B>2</B></I> (nt) <I>La pulso ~as. Lia koro ~is vivege. La maro ~as kontraŭ la klifojn</I>. <B>~o</B>, <B>1</B> blow, hit, knock. <I>~o mortiga. ~o de la sorto. ~o finfara</I>, finishing stroke, quietus, (ac) <I>~oj</I>, beats (from interference). <B>~ado</B>, -ing, (battering, throbbing, rolling) of (drum, wings); hitting, licking, trouncing; palpitation. (mus) <I>~anta anĉo</I>, beating reed. <B>~egi</B>, bash, flog, hit violently, thrash. <B>~ilo</B>, bat, battledore, mallet, racquet. <B>Ov~ilo</B>, egg beater whisk <B>Tambur~ilo</B>, drumstick. <B>Ter~ ilo</B>, rammer. <B>Al~iĝi</B>, collide. <B>Dis~i</B>, smash to pieces (➞ <I>dispecig, frakas, venk</I>). <B>El~i</B>, knock out. <B>En~i</B>, stave in. <B>Inter-iĝo</B>, brawl, fray, scrimmage, scuffle. <B>Kun~i</B>, clap (<I>manojn</I>), gnash (<I>dentojn</I>). <B>Re~o</B>, repercussion. <B>Tra~i (</B><I>vojon</I>), force (make) a way through. <B>Korno~i</B>, butt, gore. <B>Pied~i</B>, kick. <B>Pugno~i</B>, fisticuff, punch, thump. <B>Venko~i</B>, smite (in battle) (➞ <I>konker</I>). ➞ <I>baston, verg, vip</I>. <B>H Bat</B>, denotes continuous, repeated action; frap, a single blow.", "0"],
["batiko", "batik-o", "(tex) batik.", "0"],
["batisto", "batist-o", "[OA] (tex) batiste, species of cambric. <I>Delikata ~o</I>, lawn.", "0"],
["batologio", "batologi-o", "(rh) vain repetitions (Mt 6/7).", "0"],
["batoso", "batos-o", "(rh) bathos, fall from sublime to ridiculous; descent after a flight of eloquence into the commonplace.", "0"],
["batrako", "batrak-o", "batrachian, frog-like animal.", "0"],
["baŭdruĉo", "baŭdruĉ-o", "(<I>orbatista haŭto</I>), goldbeater’s skin.", "0"],
["baŭksito", "baŭksit-o", "(min) bauxite.", "0"],
["baŭmi", "baŭm-i", "(of horse) rear, rise on hind feet.", "0"],
["bavi", "bav-i", "(<I>salivi</I>), dribble, slaver, slobber; foam (froth) at mouth (of horse, mad dog). <B>~o</B> spittle (of toad), slime (of snail).", "0"],
["bazalto", "bazalt-o", "[OA] (min) basalt. <B>~a</B>, -ic.", "0"],
["bazaro", "bazar-o", "[UV]. <B>1</B> bazaar, oriental marketplace. <B>2</B> (covered) market. <I>~o fiŝa, flora, legoma. ~o de malnovaĵoj</I>. <B>~a</B> <I>tago,</I> market-day. <B>~ulo</B>, street hawker, itinerant vendor, cheap-jack. <B>3</B> fancy fair; bring and buy, jumble sale, sale of work. ➞ <I>foir, merkat, vendhal</I>.", "0"],
["bazelo", "bazel-o", "Malabar nightshade (<I>Basella</I>).", "0"],
["bazidio", "bazidi-o", "(<I>spor-klabo</I>), basidium, <B>~a</B> <I>fungo</I> <B>(~omiceto)</B>. ➞ <I>ask</I>.", "0"],
["baziliko", "bazilik-o", "[OA] (arch) basilica.", "0"],
["bazilio", "bazili-o", "sweet basil (<I>Osimum basilicum</I>). ➞ <I>ocim</I>.", "0"],
["bazilisko", "bazilisk-o", "[OA] basilisk. <B>1</B> fabulous reptile, cockatrice. <B>2</B> small American lizard (<I>Basiliscus</I>). <B>f</B> <I>~a rigardo</I>, b-glance, evil eye.", "0"],
["bazo", "baz-o", "[OA] Bas/e, basis, starting-point, foundation, common ground, determining principle, main ingredient. <I>~o de kolono, monto, triangulo</I> (Ij 28/9). (baseball) b„ home, (chem) b. of salt, (mil) basis of operations. <I>~o aera, mara</I>. (surv) b-line. <B>f</B> <I>~o de argument-(kred-sistem-teori-)o;</I> ground (<I>de suspekto</I>). <B>~a</B>, -ic. <I>~a hipotez-(sal-)o. Argumento</I> <B>~e</B> <I>falsa,</I> fundamentally unsound. <B>~i (<I>-n</I>)</B> (<I>fundamenti</I>), b., found. <I>~i opinion, sin</I>. <B>~iĝi</B> (<I>sur</I>), rest on. <I>Ŝtono</I> -angula, cornerstone (Ps 118/22). <B>Sen~a</B>, b-less, ungrounded. ➞ <I>fund(ament), grund, starej, ter; piedestal, plint, sokl; pilk</I>.", "0"],
["ba!", "", "(interjection) denotes contempt, indifference, unbelief. Bah! Fiddlesticks! Nonsense! Pish! Pooh! Pshaw! Rubbish!", "0"],
["beata", "beat-a", "blessed, blissful. <B>~(ec)o</B>, bliss, perfect joy, supreme happiness. <B>~iga</B>, beatific. ➞ <I>ben</I>.", "0"],
["bebo", "beb-o", "(ordinary language) Baby, babe, infant-in-arms. <B>~zorganto</B>, b-sitter. <B>~ovestoj</B>, b-linen.", "0"],
["bedaŭri", "bedaŭr-i", "(<I>-n, ke;</I> abs), [UV] Regret, be sorry (about, for) (Na 3/7), <B>~o</B>, r. <I>~o kaj ĉagreno ŝuldon ne kovras</I>. <B>~egi</B>, bewail, deplore, lament. <B>~inda</B>, -table, deplor- (lament-)able, unfortunate. <B>~inde</B> (<I>dom- aĝe</I>), r-tably, to (my) sorrow. <B>~esprimo</B>, excuse. <B>Sen~e</B>, with composure. ➞ <I>domaĝ, lament, malĝoj, pet, plor</I>.", "0"],
["bedelio", "bedeli-o", "bedellium. <B>1</B> species of balsam-tree (<I>Commiphora</I>), <B>2</B> its resin (No 11/7).", "0"],
["bedo", "bed-o", "[UV] (garden) Bed, plot (Alt 6/2).", "0"],
["bedueno", "beduen-o", "bedouin, Arab of the desert.", "0"],
["begino", "begin-o", "Beguin/e, Flemish lay nun. <B>~ejo</B>, -age.", "0"],
["begonio", "begoni-o", "(bot) begonia (<I>Begonia</I>).", "0"],
["bei", "be-i", "(a. <I>ba-i</I>), baa, bleat (sheep, goat, calf).", "0"],
["beja", "bej-a", "(<I>ruĝbruna</I>), bay (of horses).", "0"],
["bejlo", "bejl-o", "(cricket) bail, cross-piece.", "0"],
["bejo", "bej-o", "bey, Turkish governor.", "0"],
["bekabungo", "bekabung-o", "(bot) brooklime (<I>Veronica beccabunga</I>).", "0"],
["beko", "bek-o", "[UV] Beak, bill (of bird); nose, nozzle, snout, tip. <I>~o de ankro</I>. <B>Flam~ (gas~)o</B> (<I>flamingo</I>), gas burner, beak (<I>ambosa</I>); lip (<I>pokala</I>); mouthpiece (<I>klarneta</I>); nib (<I>pluma</I>); peak (<I>sela</I>); prow (<I>boata)’</I>, spout (<I>kafkruĉa</I>). <B>~(pik)i</B>, peck, f <B>~eti</B> (<I>kiseti</I>), peck. <B>Kruc~o</B> (orn) cross-bill (<I>Loksio</I>).", "0"],
["bela", "bel-a", "[UV] Beaut/iful, charming, fair, handsome, lovely, noble. <I>~a ago, infano, kanto, penso, sekso, tago. ~aj vortoj, ~a okazo</I>, fine opportunity. <I>~a kruro,</I> shapely leg. <B>~o</B>, -y. <I>La</I> <B>~aĵoj</B> (b-ties) <I>de la lando</I>. <B>~aĉa</B>, tawdry. <B>~eco</B>, loveliness. <B>~ega</B>, glorious, gorgeous, magnificent, splendid. <B>~egeco</B> (Ĥg <B>2/3). ~eta</B> (<I>plaĉa</I>), agreeable, comely, nice, pretty (Alt <B>1/5). (Pll)~igi</B>, -ify, adorn, embellish, smarten, <B>f</B> gloss (draw a veil) over. <B>~igaĵo</B>, e.g., <I>kremo, pudro, ŝminko</I> (Es <B>2/9)</B>. <I>~igejo, ~igistino</I>. <B>~ulo</B>, [UV] -y. <I>La dormanta ~ulino</I>. <B>~aspekta</B>, fair (Ge <B>24/16). ~forma</B> (Ge <B>29/17). ~sona</B>, euphonious. <B>Mal~a</B>, ugly. <I>~~ega</I>, hideous. <I>~~ulo,</I> fright. <I>~~ulino</I>, hag. <B>Super~a</B> (<I>sublima</I>), superb. ➞ <I>admirind, elegant, plat, rav</I>.", "0"],
["beladono", "beladon-o", "[UV] belladonna. <B>1</B> deadly nightshade (<I>Atropa belladonna</I>), <B>2</B> drug from this.", "0"],
["belemnito", "belemnit-o", "belemnite, fingerstone, cuttlefish fossil.", "0"],
["beletro", "beletr-o", "(= <B>beletristiko</B> [OA]), belles- lettres, literary works, <B>~isto</B>, man of letters.", "0"],
["belfrido", "belfrid-o", "(<I>sonorilejo</I>), belfry. ➞ <I>kampanil</I>.", "0"],
["Belgujo, Belgio", "Belg-ujo, Belgio", "[OA 8] BE.", "0"],
["Belizo", "Beliz-o", "BZ", "0"],
["belono", "belon-o", "garfish, needlefish, gar-pike, etc. (<I>Belone</I>).", "0"],
["Belorusujo, Belorusio", "Belorus-ujo, Belorusio", "BY.", "0"],
["belvedero", "belveder-o", "(<I>belvidejo homkonstruita</I>), belvedere, raised ground (point) from which to view scenery. ➞ <I>altan, balkon</I>.", "0"],
["bembeko", "bembek-o", "bembex wasp (<I>Bembex</I>).", "0"],
["bemerio", "bemeri-o", "(bot) boehmeria &lt; <I>ramio</I>.", "0"],
["bemolo", "bemol-o", "(mus) flat. (ordinary language abbreviation be, which see).", "0"],
["bendo", "bend-o", "Band, tape, ribbon (narrow strip of material with parallel edges). <I>~o el kaŭĉuko, papero, ledo, tolo. ~o de filmo</I>. <B>Brak~o</B>, arm-band, brassard. <B>Har~o</B>, bandeau, head band. <B>Lad~o</B>, hoop-iron. <B>Mentona ~o</B>, bonnet-string, chin-strap. <B>Mezura ~o</B>, tape measure. <B>Pans~o</B> (<I>bandaĝo</I>). <B>Rad~o</B>, tyre. <B>Solida ~o</B>, solid tyre. <B>Son~o</B>, magnetic tape (recording). <B>Spektra ~o</B>, spectrum b. <B>Ŝtal~o</B>, steel tape, <B>Tapiŝa ~o</B>, carpet strip. <B>Vic~o</B>, spare tyre, (mec) <B>Kuranta (transporta) ~o</B>, belt conveyor. <B>~i</B> <I>la har-(okul-)ojn</I>. ➞ <I>ĉirkaŭlig, ĉirkaŭvolv</I>. <B>Sur~igo</B>, tape recording. ➞ <I>banderol, ligil, stri, zon</I>.", "0"],
["benediktano", "benediktan-o", "benedictine monk.", "0"],
["benefico", "benefic-o", "(ecc) Benef/ice; living, (th) -it, charity performance. <I>~a nokto (prezento</I>). <B>~ulo</B>, -iciary, incumbent.", "0"],
["bengalo", "bengal-o", "<B>~a</B>, Bengali (<I>person, language</I>). <B>Bengali-o</B>, Bengal.", "0"],
["beni", "ben-i", "(<I>-n</I>, abs) [OA], Bless. <B>1</B> invoke God’s favour on: <I>Pastro ~as kunvenon, patro ~as filon</I>. <B>2</B> praise, laud: <I>~i ies memoron. ~ata estu Dio</I>. <B>3</B> <I>konsekri; ~ita akvo</I>, holy water. <I>~i panon, preĝejon</I>. <B>4</B> (feliĉigi), <I>Dio min ~is per sano, infanoj</I>. <B>~(ad)o</B>, blessing, benediction, benison. <B>~(aĵ</B>)<B>o</B>, blessing, gift, godsend. <B>~iĝi</B> (Ge 12/3). <B>~peti</B>, ask a blessing. <B>Mal~i</B>, curse, ➞ <I>anatem, ekskomunik, kondamn; blasfem, bat, frap</I>. curse, execration, imprecation, malison. <B>Malben’</B>! (interjection) Hang it all! <B>~~inda</B>, <B>~~ita</B>, accursed</I>.", "0"],
["benigna", "benign-a", "benign, gentle, gracious; kindly, mild, salutary.", "0"],
["Benino", "Benin-o", "BJ", "0"],
["benjeto", "benjet-o", "(<I>fritaĵo</I>), (cul) fritter. <I>Pom~o</I>.", "0"],
["benko", "benk-o", "[UV] Bench, form, long wooden seat: <I>~o lerneja</I>. Working-table: <I>Ĉarpentista (rabota) ~o</I>. <B>Labor~o</B>, workbench. <B>Preĝ~o</B>, pew. <B>Rem~o</B>, thwart. <B>Ŝtup~oj</B> <I>de amfiteatro</I>. <B>~eto</B>, stool. <B>Pied~eto</B> (<I>skabelo</I>), foot-stool. <B>~ĉaro</B> (<I>~veturilo</I>), char-a-banc. ➞ <I>taburet</I>.", "0"],
["benz", "benz-", "(ch pfx) Benz-. <B>~eno</B>, -ene (C<SUB>6</SUB>H<SUB>6</SUB>)- <I>Nitro~eno</I>. <B>~idino</B>, -idine. <B>~ilo</B>, -yl.", "0"],
["benzino", "benzin-o", "[OA] motor-spirit, petrol (Am gasoline) for cars, motors, etc. <I>Rafinita ~ino,</I> benzine. <B>~inujo</B>, <B>~inpumpilo. ~instacio</B>, filling-station.", "0"],
["benzinoato", "benzinoat-o", "-oate. <B>~oino</B>, -oin. <B>~olo</B>, -ole (trade name for crude -ene).", "0"],
["benzoo", "benzo-o", "gum benzoin (Benjamin), resin from <B>~arbo</B> benjamin tree (<I>Styrax benzoin</I>). ➞ <I>storak</I>.", "0"],
["beo", "be-o", "(a. <I>bemolo</I>). (mus) Flat. <B>A-be</B>, A b- <B>Bebeo</B>, double f. <B>~igi</B>, flatten, lower a semitone. <I>Unu~a tonalo</I>, F. <B>~flanke</B>, first f. key. <B>~gamoj</B>, <B>~tonaloj</B>, f-keys. <I>Tonalo</I> <B>du~a</B>, key of two ff. (Bt&gt;, G min). opposite <I>-is (=dies</I>).", "0"],
["berberiso", "berberis-o", "barberry (<I>Berberis). ~a bero</I>. ➞ <I>mahoni</I>.", "0"],
["bereto", "beret-o", "beret. <I>Skota ~o</I>, tam-o-shanter.", "0"],
["bergamot", "", "-o, Bergamot orange, fruit of <B>~arbo</B> (b-tree) (<I>Citrus bergamia</I>). <B>~oleo</B>, b-oil, essence of b. <B>~piro</B>, b-pear.", "0"],
["beribero", "beriber-o", "(med) beriberi.", "0"],
["berilio", "berili-o", "(chem) berylium (Be).", "0"],
["berilo", "beril-o", "[OA] (min) beryl &gt; aquamarina.", "0"],
["bero", "ber-o", "[UV] berry. <B>~aro</B>, bunch, cluster (<I>grapolo</I>). <B>vin~o</B>, [UV] grape. <B>sekvin~o</B> [UV] (<I>rosino</I>), raisin; <B>sekvin~eto</B> (<I>korinto</I>), (grocer’s) currant.", "0"],
["berserko", "berserk-o", "berserk(er), Norse warrior. <B>i~</B> (nt), go b., strike at random (with frenzied fury), run amok.", "0"],
["besto", "best-o", "[UV] (<I>animalo nehoma</I>), Animal, Beast. <I>~o dom-(sovaĝ-)a</I>. <B>Poŝ~o</B>, marsupial (<I>marsupialo</I>). <B>Rabo~o</B>, b. of prey. <B>Ŝarĝ~o</B>, b. of burden, <B>f</B> brutal (brutish) person. <B>~a</B>, of an a. <B>~aĉa</B> (a. <I>bestia</I>), bestial, beastly. <B>~aro</B>, collection of aa., herd, fauna. <I>Kin timas ~aron, ne iru arbaron</I>. <B>~ejo</B>, menagery, zl-ical gardens or park. <B>~eto</B>, animalcule, insect, etc. <B>~igi.</B> brutalize. <B>~kuracisto (</B><I>veterinaro</I>), veterinary surgeon. <B>Fi~etoj</B>, vermin. ➞ <I>faŭn</I>.", "0"],
["betlo", "betl-o", "betel (<I>Piper betle). ~ofolioj</I>.", "0"],
["beto", "bet-o", "[UV] Beet (<I>Beta</I>). <B>Ruĝa ~o</B>, b-root. <B>Blanka ~o</B>, chard, spinach b. (<I>B. cicla</I>). <B>Furaĝa ~o</B>, fodder-b., mangle-wurzel. <B>Mara ~o</B>, sea-b. (<I>B. maritima</I>). <B>Suker~o</B>, sugar-b. ➞ <I>bare</I>. [Ne= <I>veto</I>].", "0"],
["betoniko", "betonik-o", "wood betony (<I>Betonica</I>). ➞ <I>stakis</I>.", "0"],
["betono", "beton-o", "(arch) concrete. <B>~i</B>, c. <B>Armita ~o</B> (<I>fer~o</I>), reinforced c. <B>Cel~o</B>, cellular c. <B>~miksilo</B>, cement-mixer. <B>En~igi</B>, set in c. ➞ <I>konkret</I>.", "0"],
["betulo", "betul-o", "[UV] Birch (tree) (<I>Betula). ~o nana</I>, dwarf b. <B>~aro</B>, <B>~ejo</B>, b-forest.", "0"],
["bevelo", "bevel-o", "(<I>klinrando</I>), Bevel, sloping edge. <B>~i</B>, b., slope. <B>~ita</B> (<I>~e tranĉita) spegulo</I>. <B>~ilo</B>. b. ➞ <I>oblikv</I>.", "0"],
["bezoaro", "bezoar-o", "(phar) goat-stone.", "0"],
["bezoni", "bezon-i", "[UV] <B>1</B> (<I>-n</I>), (stand in) Need (of), be short of, require, suffer from lack of, want. <I>~i monon, ripozon. ~i trinki</I>. <B>2</B> be under obligation to. <I>Ni ne ~as iri (Ne necesas, ke ni iru</I>), we n. not go. <I>La infanoj ne devis (kompreni), ĉar infanoj ne ~as ĉion scii</I> (3 FA 11 /22) (didn’t have to understand, they need not know every- thing). <B>~a</B> (<I>necesa</I>), -ful, necessary, requisite. <B>~(aĵ)o</B>, n., emergency, necessity, requirement, want. <I>En okazo de ~o</I>. <B>~aĵoj</B>, requirements. <B>~egi</B> (<I>urĝe ~i</I>). <B>Laŭ~e</B>, at n. <B>Ne</B>~a, <B>sen</B>~a. n-less, superfluous. <B>Mon~a</B>, necessitous. ➞ <I>dezir, mank, postul</I>.", "0"],
["bi", "bi-", "(ppfx) = rf«. (chem) Bi-, denotes acid salts e.g., <I>bikarbonato</I>.", "0"],
["bibio", "bibi-o", "dung fly (<I>Bibio</I>).", "0"],
["biblio", "bibli-o", "[OA] (<I>Sankta Skribo</I>). Bibl/e. <B>~a</B>, -ic<B>al</B>, Scriptural. <I>~a Societo</I>, B- Society.", "0"],
["biblio", "biblio-", "(ppfx) (= <I>libro-</I>), biblio-.", "0"],
["bibliofilo", "", "(<I>libramanto</I>), bibliophile.", "0"],
["bibliografio", "bibliograf-io", "[OA] <B>-o</B>, [OA] bibliography, bibliographer.", "0"],
["biblioteko", "bibliotek-o", "[OA] Librar/y. <B>1</B> (<I>librejo</I>), library, reading-room. <I>~o cirkulanta, publika, prunta</I>. <B>2</B> (<I>librujo</I>), book-case. <B>3</B> collection of books. <B>4</B> title of series. <I>La ~o \"Epoko\"</I>.", "0"],
["bicepso", "biceps-o", "(anat) biceps.", "1"],
["biciklo", "bicikl-o", "[OA] (ordinary language abbreviation <I>ciklo</I>), (bi)cycle. <B>Motor~o. ~i</B>, ride this. <B>~eto</B>, child’s b. <B>~isto</B>, -ist<B></B>. ➞ <I>tandem, velociped</I>.", "0"],
["bidento", "bident-o", "bur-marigold, (<I>Bidens</I>).", "0"],
["bido", "bid-o", "bead. <B>1</B> (<I>tru-globeto). ~oj lignaj, vitraj; de abako, rozario, sur vesto</I>. <B>2</B> globule.", "0"],
["bieno", "bien-o", "[UV] Estate, grounds, land(ed property). <B>Reĝa ~o</B>, crown land. <B>~aro</B>, domain, manor, territory. <B>~eto (Farm~o)</B>, croft, farm. <B>~etulo</B>, crofter, etc. <B>~ulo</B>, landowner, man of property, laird, squire. <B>~administranto</B> (<I>ekonomo</I>), steward of e. <B>~domo</B>, manor house. <B>~etato</B> (<I>kadastro</I>). <B>Sen~igi</B>, dispossess, evict, oust from.", "0"],
["biero", "bier-o", "[UV] Beer, Ale. <B>Malforta ~o</B>, small a. <B>Nigra ~o</B>, stout, <B>Pala ~o</B>, pale ale. <B>Zingibra ~o</B>, ginger beer. <B>~(vend)ejo</B>, a-house, b-shop. <B>~farejo</B>, brewery. ➞ <I>porter</I>.", "0"],
["bifsteko", "bifstek-o", "[OA] (<I>bovaĵ-tranĉo</I>), beef-steak.", "0"],
["bigamio", "bigami-o", "bigamy. <B>~ulo</B>, bigamist. ➞ <I>monogami, poligami</I>.", "0"],
["bigarado", "bigarad-o", "(<I>maldolĉa oranĝo</I>), Seville (bitter) orange (<I>Citrus bigaradia</I>).", "0"],
["biglo", "bigl-o", "beagle (dog).", "0"],
["bignonio", "bignoni-o", "(<I>trumpeta floro</I>), bignonia, trumpet flower (<I>Bignonia</I>).", "0"],
["bigota", "bigot-a", "[OA] (<I>ekscese, neracie, fervora, fanatika</I>), bigoted, intolerant, narrow-minded. <I><B>~eco</B>,</I> bigotry. <I><B>~ulo</B>,</I> bigot.", "0"],
["bikino", "bikin-o", "(cl) bikini.", "0"],
["bikso", "biks-o", "arnotto tree (<I>Bixa</I>).", "0"],
["bikŝuo", "bikŝu-o", "monk (Southern Buddhism). ➞ <I>bonz</I>.", "0"],
["bikvadrata", "bikvadrat-a", "(mat) biquadratic.", "0"],
["bilanco", "bilanc-o", "[OA] Balance(-sheet). <B>Prov~o</B>, trial b. <B>~a</B> <I>konto, kalkulo</I>, b-account, <B>~i</B> <I>konton (fari ~on</I>), strike a b. ➞ <I>balanc, inventar, kont, said</I>.", "0"],
["bilardo", "bilard-o", "[OA], Billiards. <I><B>~i</B>,</I> play b. <I><B>~a</B> bastono, globo, tablo. <B>~ejo</B> (</I><B>~</B>salono), broom. ➞ <I><B>~eto</B>, bagatelle</I>.", "1"],
["bilboko", "bilbok-o", "(kaptotaso), (gm) cup and ball.", "1"],
["bildo", "bild-o", "[OA] Picture, delineation, image, likeness, representation, view. <B>Mov~oj</B>, moving pictures. <B>Lum~o</B>, screen projection (➞ <I>diapozitiv</I>). <B>Sankta ~o</B> (<I>ikono</I>). <B>Transigebla ~o</B>, transfer. <B>Vitro~o</B> (<I>diafana ~o</I>), stained glass. <B>Vort~o</B>, word-p. <B>~aro (~libro)</B>, p-book. <B>~igi</B> <I>al si</I>, p. to one’s. <B>~flanke</B>, on the p-side. ➞ <I>desegn, figur, ilustr, kinem, kopi, pentr, portret, prezent</I>.", "0"],
["bileto", "bilet-o", "[OA] Ticket <I>[Ne= letero], ~o enira, fervoja, loteria, sezona, teatra</I>. <B>Bank~o</B>, bank note. <B>Kontrol~o</B>, check-t. <B>Pas~o</B>, pass-check. <B>Reven~o</B>, return-t. <B>Ŝanĝ~o</B>, transfer (through) t. <I>Aĉeti, fordoni, trui ~on</I>. <B>~(vend)ejo</B>, t-office. <I>~eja fenestro (giĉeto</I>). <B>~ujo</B>, t-case, card-case. <B>~kontrolisto</B>, t-collector. ➞ <I>bil, kontrol</I>.", "0"],
["bilĝo", "bilĝ-o", "(<I>drenangulo de holdo</I>), (mar) bilge. <B>~akvo</B>, bilge-water.", "0"],
["bilharzio", "bilharzi-o", "bilharzia, parasitic flat-worm.", "0"],
["biliono", "bilion-o", "billion. <B>Rim.:</B> Avoid as vague, unless defined. In USA, Italy, France, = 10<SUP>9 </SUP>(<I>miliardo</I>). In England, Germany, = 10<SUP>12</SUP>. ➞ <I>miliard</I>.", "0"],
["bilo", "bil-o", "(<I>negocebla valorpapero</I>), (<I>com) bill, note, security</I>. ➞ <I>akci, bilet, obligaci</I>.", "0"],
["binara", "binar-a", "(<I>duelementa, duera, duparta, dutema</I>), binary.", "0"],
["bindi", "bind-i", "(<I>-n</I>), [UV] Bind (books, etc.). <I>~i kartone, lede, tole</I>. <B>~ado (~arto)</B>, -ing. <I>Libro~ado</I>, <B>~(aĵ)o</B> (<I>kovrilo</I>), binding, cover. <I>~o bovidleda, plasta</I>. <B>~ejo</B>, -ing works. <B>~ilo</B>, -ing appliance (tool). <B>~isto</B>, binder. <B>Duon~aĵo</B>, half-ing (leather at back and corners only).", "0"],
["binoklo", "binokl-o", "[OA] binoculars, field glass. <I>~o kun tenilo</I>, lorgnette. <I>~o kampa, prisma, teatra</I>. <B>~eto</B>, opera glass.", "0"],
["binomo", "binom-o", "binomial. <B>1</B> (mat) (<I>duterma</I>), <B>~a</B> <I>koeficiento, teoremo</I>. <B>2</B> (<I>dunoma</I>), <B>~a</B> <I>nomenklaturo, sistemo</I>.", "0"],
["bio", "", "- (Gk ppfx = viv-) bio-.", "0"],
["biogenezo", "", "biogenesis.", "0"],
["biografio", "biografi-o", "[OA] <B>-o</B>, [OA] biograph/y, -er.", "0"],
["biokemio", "biokemi-o", "biochemistry.", "0"],
["biologio", "biolog/io", "<B>-o</B>, biolog/y, -ist.", "0"],
["biontologio", "biontologi-o", "natural history.", "0"],
["biplano", "biplan-o", "biplane. ➞ <I>aeroplan, monoplan</I>.", "0"],
["birdo", "bird-o", "[UV] Bird, Fowl. <I>~o doma, hejma, sovaĝa</I>. <B>~a</B>, avian. <B>Akvo~o</B>, water-f. <B>Fajr~o (</B><I>fenikso</I>), phoenix. <B>Kat~oj</B>, catbirds (<I>Aeluredo, Dumetelo, Galeoskopto</I>). <B>Kan-o (</B><I>akrocefalo</I>), warbler. <B>Kort~oj</B>, AT., poultry. <B>Lir~o</B> (<I>menuro</I>), lyre-b. <B>Log~o</B>, decoy. <B>Miel~o</B> (<I>melifago</I>), honey-sucker. <B>Ombrela ~o</B> (<I>cefaloptero</I>) umbrella-b. <B>Rabo~o</B>, b. of prey. <B>Ŝtorm~o</B> (<I>petrelo</I>), petrel. <B>Zum~o</B> (<I>kolibro</I>), humming-bird. <B>~aro</B>, flock (flight) of birds, birds. in gen. <B>~ejo</B>, aviary. <B>~ido</B>, fleding-(nest-)ling. <B>~ino</B>, hen-b. <B>~bano</B>, <B>~nesto</B>, <B>~kaptisto</B>, b- catcher. <B>~timigilo</B>, scare-crow. <B>Vir~o</B>, cock-b.", "0"],
["bireto", "biret-o", "[OA] biretta, square cap of some clerics.", "0"],
["birgo", "birg-o", "thief-crab (<I>Birgus) &lt; paguro</I>.", "0"],
["Birmo", "Birm-o", "[OA 8] MM, Burma (former name of Myanmar).", "0"],
["biro", "bir-o", "(mar) (met) bearing, <B>~i</B>, determine the direction of an object. <B>~ilo</B>, direction finder. <I>Radio~ilo (radaro</I>), radar.", "0"],
["bisekci", "bisekc-i", "(<I>-n</I>), (mat) bisect.", "0"],
["bisino", "bisin-o", "(tex) byssus, ”fine linen” (El 39/27, Lk 16/19). <B>~aj</B> <I>vestoj</I> (Ge 41/42). ➞ <I>bisus</I>.", "0"],
["biskoto", "biskot-o", "(<I>rebakita pano</I>), rusk.", "0"],
["biskvito", "biskvit-o", "[UV] <B>1</B> Biscuit, (Am) cracker. <I>Ŝipa ~o</I>, ship’s b. <B>2</B> bisque, unglazed white porcelain.", "0"],
["bismuto", "bismut-o", "[UV] (chem) Bismuth (Bi).", "0"],
["bisono (a", "bison-o (a", ". bizono), Bison (<I>Bos bison</I>). <B>Eŭropa ~o</B>, wisent (<I>B. bonasus</I>). ➞ <I>bubal</I>.", "0"],
["bistorto", "bistort-o", "adderwort, bistort, snake-weed (<I>Poligonum bistorta</I>).", "0"],
["bistro", "bistr-o", "bistre (brown pigment from soot). <B>~a</B>, blackish-brown, swarthy.", "0"],
["bisturio", "bisturi-o", "[OA] (surg), bistoury, small slender knife, straight or curved, sharp- or probe-pointed &gt; <I>lancet, skalpel</I>.", "0"],
["bisuso", "bisus-o", "(<I>mar-silko</I>), byssus, mussel silk. ➞ <I>bisin</I>.", "0"],
["bis!", "", "[OA] (<I>ankoraŭ unu fojon! Denove! Ripetu!</I>) (interjection), Again! Encore! Once more! Repeat! <B>~i</B> (<I>ion, iun</I>), Encore, recall. <B>~aĵo</B>, an e. item.", "0"],
["bitiso", "bitis-o", "(zoo) puff adder (<I>Bitis</I>).", "0"],
["bito", "bit-o", "(mar) bitt, mooring-pin on ship. <B>~eto</B>, cleat. ➞ <I>bolard</I>.", "0"],
["bitumo", "bitum-o", "[OA] (<I>teroleo, tervakso</I>), (ordinary language) bitumen, <B>~a</B> <I>karbo</I>, soft coal (opposite <I>antracit</I>), <B>~aj</B> <I>kavoj</I> (Ge 14/10). <I>~aj substancoj = asfalto, gudro, peĉo</I>. <B>~(iz)i</B>, bituminize.", "0"],
["bivako", "bivak-o", "[OA] bivouac, encampment, night’s resting-place in open camp out without tents (2 Sa 11/11). <B>~a</B> <I>fajro</I>, watch fire. ➞ <I>barak, tend</I>.", "0"],
["bivalvo", "bivalv-o", "(<I>ordinary language klapkonko) (molusko duklapa</I>), bivalve.", "0"],
["bizanca", "bizanc-a", "(arch) (art) Byzantine.", "0"],
["bizara", "bizar-a", "bizarre, eccentric, fantastic, grotesque, mixed in style, queer, semibarbaric, strange, whimsical. <B>~aĵo</B>, whim.", "0"],
["blago", "blag-o", "(<I>ŝerca mensogo</I>), blarney, cajoling talk, fib, humbug, pretentious nonsense, tall story, trick. <B>~i</B>, hoax, play a trick on, pull one’s leg. <I>Li nur ~as</I>, talks with his tongue in his cheek. <B>~ulo</B>, joker, wag. <B>Sen~e!</B> honest Injun! No joking! Really! ➞ <I>bluf, ŝaĵnig</I>.", "0"],
["blakstonio", "blakstoni-o", "yellow-wort (<I>Blackstonia</I>).", "0"],
["blamanĝo", "blamanĝ-o", "(cul) blancmange.", "0"],
["blanka", "blank-a", "[UV] <B>1</B> White. <I>~a lumo, raso, ~a klavo de piano, ~a Monto</I>, Mt. Blanc. <I>~a vermo (larvo melolonta</I>), larva of cockchafer. <I>Neĝe ~a</I>, snow-w. <B>2</B> clean, pure, stainless, <I>~a tolo;</I> colourless, <I>~a fono</I>, unused, <I>~a paĝo</I>. (com) Blank, <I>~a akcepto, ĉeko, kredito, subskribo</I>. <B>~o</B>, white (colour, paint, etc.), <I>~o de la okuloj</I>. (gm) w. (side or pieces), (dominoes) <I>duobla ~o</I>, double w. (typ) space. <B>Balen~o</B> (<I>spermaceto</I>). <B>ov~o</B>, [UV] w. of egg. <B>Plumbo~o</B> (<I>ceruzo</I>), w~lead. <B>Zink~o</B> (<I>zinkoksido</I>), zinc-w. <I>~e vestita</I>, dressed in w. <B>~aĵo</B>, something w. <B>~eta</B>, w-ish. <B>~igi</B>, -en, blanch, bleach, w-wash, etc. <I>Nigran kornikon sapo ne ~igas</I>. <B>f</B> (<I>senkulpigi</I>), excuse, w-wash. <B>~(haŭt)ulo</B>, w. man. <B>~arda</B>, <B>~e varma</B>, w-hot, incandescent. <B>~barba</B>, <B>~hara</B>, hoary-headed, w-haired.", "0"],
["blankedo", "blanked-o", "form (to be filled up).", "0"],
["blapso", "blaps-o", "(<I>Blaps</I>) &gt; churchyard beetle. ➞ <I>blat</I>.", "0"],
["blasfemi", "blasfem-i", "[OA] blaspheme (Ij 1/5), (curse and) swear, talk impiously, use bad language <I>[Ne= profan]</I>, <B>~a</B>, blasphemous, profane. <B>~aĵo</B>, oath, profanity. <B>~anto</B>, <B>~ulo</B>, blasphemer (Se 1/22). ➞ <I>fur, sakr</I>.", "0"],
["blato", "blat-o", "[UV] cockroach (<I>Blatta) &gt;</I> the “blackbeetle” of the kitchen.", "0"],
["blazono", "blazon-o", "[OA] heraldic shield, (coat of) arms, armorial bearings, crest. <B>~i</B>, describe heraldically, inscribe with arms, <B>f</B> proclaim. <B>~scienco</B> (<I>heraldiko</I>). <B>~ŝildo</B>, escutcheon, heraldic shield. ➞ <I>heraldik, insign</I>.", "0"],
["blefarito", "blefarit-o", "(<I>palpebra inflamo</I>), blepharitis.", "0"],
["bleki", "blek-i", "[UV] (<I>krii</I>), (utter its) cry (any prolonged sound made by an animal). <B>Bov~i</B>, low, moo. <B>ĉeval~i</B>, neigh, whinny. <B>Hund~i</B>, howl. <B>Kat~i</B>, caterwaul (➞ <I>miaŭ</I>), <B>Kapro~i</B>, bleat. <B>Korv~i</B>, croak. <B>Ŝaf~i</B>, baa. <B>~egi</B>, bellow, howl, roar (Jes 5/30). <B>f</B> shout, yell, etc. <I>Ŝi ne kantas, ŝi nur ~as</I>. <B>~o</B>, cry (as above).", "0"],
["blekno", "blekn-o", "hard fern (<I>Blechnum</I>).", "0"],
["blendo", "blend-o", "blende, zinc sulphate ore.", "0"],
["blenio", "bleni-o", "(ich) blenny (<I>Blennius</I>).", "0"],
["blesboko", "blesbok-o", "blesbok (<I>Damaliscus</I>).", "0"],
["bletio", "bleti-o", "bletia orchid.", "0"],
["blinda", "blind-a", "[UV] (<I>senvida</I>), Blind, sightless, <B>f</B> (without discernment, fanatic), <I>~a dogmo, fervoro, furiozo, konfido, obeo</I>. <B>~(ul</B>)e, -ly. <B>~e</B> <I>imiti, pafi, sekvi. ~e palpi</I>, grope, (av) <I>Flugi ~e</I>. <B>~eco</B> (Ge 19/11). <B>~igi</B> (Jes 6/10). <B>f</B> <I>~igita de pasio</I>. <B>~ulo</B>, b. man. <I>~ularo</I>, the b. <I>~ulejo</I>, b-institution. <B>~(ul)igi</B>, bandage (in gm). <B>~umi</B> (<I>lum~igi, dazli</I>), dazzle. <B>~umo</B>, <B>1</B> glare. <B>2</B> black-out. <B>~kapto</B>, <B>~ludo</B> (gm) b-man’s buff. <B>~okaze</B>, by chance (1 Sa 6/9). <B>Mal~igi</B> (<I>vidigi</I>), open eyes of b. (also figuratively). <B>Kolor~a</B>, colour-blind.", "0"],
["blito", "blit-o", "strawberry blite (<I>Blitum capitatus</I>).", "0"],
["blizardo", "blizard-o", "(<I>blindiga neĝoŝtormo</I>), blizzard.", "0"],
["blokado", "blokad-o", "[OA] <B>~i</B> (<I>= blok-ad</I>), (mil, mar), blockade. ➞ <I>bojkot</I>.", "0"],
["blokhaŭso", "blokhaŭs-o", "(mil) blockhouse, detached fort, log rampart, (mar) armoured conning-tower.", "0"],
["bloko", "blok-o", "[OA] <B>1</B> (<I>unupeca maso</I>), Block, boulder, chunk, bulky unhewn piece, lump. <I>~o betona. ~o de amboso</I>. (mec) <B>Glit~o</B>, slide b. <B>Ligna ~o</B> (<I>ŝtipo</I>). <B>Rul~o</B> (<I>pulio</I>). (vn) block. <B>2</B> (<I>komplekso, tutaĵo</I>), several things compressed into or regarded as one. (el) <I>~o de plakoj,</I> element, (pol) coalition of parties. <B>Dom~o</B>, b. of houses. <B>Kalendara ~o</B>, tear-off calendar. <B>Not~o</B>, scribbling-pad. <B>Skiz~o</B>, sketching-b. <B>~a</B>, massive, <B>~e</B>, in one piece (the lump), <B>~i</B> (<I>haltigi, obstrukci, senmovigi</I>), b. (entry, etc.) (cricket) b. (ball), (mil) barricade, close, (ry) b. (line). <B>~ado</B>, -ing, <B>~aĵo</B>, (typ) reversed type £). <B>~ilo</B>, clamping device. <B>~litero</B> (typ) b-letter. (ry) <B>~sistemo</B>. <B>~stano</B>, b-tin. <B>Mal~i</B>, release, set free. ➞ <I>bar, bul, mas(iv</I>).", "0"],
["blonda", "blond-a", "[UV] blond(e), fair; (<I>orbruna</I>), light auburn. <I>~o platina</I>, platinum b. <B>~igi</B> <I>la harojn</I>. <B>~ul(in)o</B>, b. <B>~hara</B>, flaxen-haired.", "0"],
["blovi", "blov-i", "(<I>-n</I>), [UV] Blow. <I>~i teon, trumpeton, vitron. ~(ekscit)i la fajron</I>. (nt) <I>~i sur teon, (per trumpeto). La vento ~as (moviĝas</I>). <B>~o</B>, blow(ing). <B>~a</B>, -y, windswept. <B>~ado</B> de venteto. <I>Neĝa ~ado,</I> snowstorm. <I>Neĝa</I> <B>~aĵo</B>, snow-drift. <B>~ega</B>, boisterous. <I>~ego</I>, blast. <B>~eto</B>, breeze. <B>~ilo</B> (Jer 6/29), bellows. <I>Balga ~ilo,</I> (pair of) bellows. <I>Orgen<B>~</B></I><B>isto</B>, organ-er. Ki’fro~isto. <B>~estingi</B> (<I>kandelon</I>), b. out. (org) <B>~meĥanismo</B>. <B>Dis~i</B> (<I>nubojn</I>), disperse. <B>En~i</B> (Ge 2/7), inflate, insufflate. <B>Ek~o</B>, gust, puff, squall. <I>La eksplodo</I> <B>el~is</B> <I>la ŝtopilon</I>. <B>For~i</B> <I>ĉapelon, fumon, polvon</I>. <B>Kontraŭ~o</B>, down draught. <B>Sen~a</B> (<I>aero) (kalma</I>), calm, still. <B>Tra~o</B>, air current, draught. <B>Tro~i</B> (<I>instrumenton</I>), over-b (= <I>senintence sonigi harmonon</I>). <B>Plen~i</B> <I>vangon, velon</I>, b. up. distend, inflate, puff out. <I>Plen~itaj</I> (pursed) <I>lipoj</I>. <B>Turn~o</B> (<I>polva</I>), eddy (of dust). ➞ <I>briz, vent</I>.", "0"],
["blua", "blu-a", "[UV] Blu/e. <I>~a ĉielo, okulo</I>. <B>f</B> <I>~a sango. ~a krajono. Kontuz~a</I>, black and blue. <I>Mallume ~a</I>, dark b. <I>Nigre ~a</I>, livid. <B>~o</B>, blue (colour). <B>Cejana ~o</B>, cornflower b. <B>Ferocianida (Prusa) ~o</B>, Prussian b. <B>Marista ~o</B>, navy b. <B>~i</B>, be blue. <I>Bati</I> <B>~aĵon</B> <I>subokule</I>, give a black eye. <B>~ega</B>, deep b. <B>~eta</B>, -ish. <B>~igi</B>, make b. <B>~igaĵo</B> (<I>lav~o</I>), laundry b. ➞ <I>cejan, kobalt, safir, ultramar; endimion, kampanol</I>.", "0"],
["blufi", "bluf-i", "(nt), bluff, act or speak so as to deceive one’s opponent. <I>Nur ~o</I>, mere bluff (2 FA 60/25). <B>~anto</B>, <B>~ulo</B>, bluffer. ➞ <I>blag, bombast, ĉarlatan</I>.", "0"],
["bluti", "blut-i", "(<I>farunon</I>), bolt, sift.", "0"],
["bluzo", "bluz-o", "[OA] (<I>mallonga kitelo</I>), blouse (male or fem.), loose linen or cotton upper garment, belted at waist, or tucked in the skirt. <I>Ĉemiza ~o</I>, jumper. <B>~eto</B>, smock-frock.", "0"],
["Bo", "B-o", "[F], letter B. (ac) 493 -8<B> <I>vibroj sekunde</I></B>.", "0"],
["bo", "bo-", "[UV] (pfx) = In Law, rein By Marriage to the relatives of one’s husband (wife). <I>Parenci</I> <B>~e</B>, be related b.m. <B>~patr(in)o</B>, father (mother) i.l. <B>~gepatroj</B>, parents i.l. <B>~nevo</B>, nephew b.m. <B>~parenciĝi</B> <I>kun,</I> ally one’s b.m. (Ge 34/9). ➞ <I>stif</I>.", "0"],
["boaco", "boac-o", "[OA 9] (<I>norda cervo</I> [UV]<I>, rangifero</I>), reindeer. (Am) caribou. (<I>Rangifer</I>).", "0"],
["boao", "boa-o", "[UV] <B>1</B> tree boa (<I>Boa</I>). Also (ordinary language) other great crushing snakes. ➞ <I>anakond, konstriktor, piton</I>. <B>2</B> (<I>kolpelto</I>), boa (fur).", "0"],
["boardo", "board-o", "(<I>velado</I>) board; the course and distance made by turning to windward (between tacks). ➞ <I>lof, tak</I>.", "0"],
["boato", "boat-o", "[UV] Boat, craft, small open oared or sailing vessel. <I>Balen~o, flug~o, kanal~o, motor~o, rem~o, sav~o</I>, whale (flying, canal, motor, rowing, life) boat. <B>Faldebla ~o. Korba ~o</B> (<I>koraklo</I>), coracle. <B>Plat~o</B>, punt, wherry. <B>Ŝlim~o</B>, mud barge. <B>~ado</B>, -ing. <B>~ano</B>, b-man. <B>~ejo (~remizo)</B>, b-house. <B>~estro</B>, cox(swain). <B>~eto</B>, dinghy, jolly-b. <B>~isto</B>, b-man. ➞ <I>bark, gondol, kanot, ŝipet</I>.", "0"],
["bobeli", "bobel-i", "(nt) (onom) Bubbl/e, be -ing. <B>~o</B>, bubble. <B>~ado</B>, -ing. ➞ <I>efervesk</I>.", "0"],
["bobeno", "boben-o", "[UV] Bobbin, Coil, drum, reel, spool; roll (<I>de filmo, papero, kotono, rubando); (dratvolvaĵo): ~o indukta</I>, inductor. <B>Bar~o</B>, choke coil. <B>Esplora ~o</B>, search c. <B>(Glit)~o</B>, shuttle (Ij 7/6). <B>~i</B>, spool, wind. <B>~(vind)ilo</B>, b-winder. <B>~istino</B>, b-winder. ➞ <I>ĉirkaŭrul, vine, vind, volv</I>.", "0"],
["bobolinko", "bobolink-o", "bobolink, rice-bunting (<I>Dolichonyx oryzivora</I>).", "0"],
["Bocvano", "Bocvan-o", "BW, Botswana.", "0"],
["boĝio", "boĝi-o", "(ry) bogie, truck under locomotive.", "0"],
["boji", "boj-i", "[UV] (<I>hundobleki</I>), bark, bay, howl. <I>Hundo ~as, homo vojas</I> (P.). <B>f ~i</B> <I>kontraŭ,</I> attack. <B>~o</B>, bark, (interjection) <I>Boj, boj!</I> (a. <I>baŭ, ŭaŭ</I>), Bow wow. <B>~aĉi</B>, snarl. <B>~eti</B>, yap. <B>f</B> grouse, whine. ➞ <I>blek, jelp</I>.", "0"],
["bojkoti", "bojkot-i", "(<I>-n</I>) [OA], <B>~o</B>, boycott. ➞ <I>evit, proskript</I>.", "0"],
["bokalo", "bokal-o", "wide-mouthed short-necked bottle or jar, carboy, glass jar, fish- globe.", "0"],
["boko", "bok-o", "(<I>tondil-argano</I>), (mar) sheer legs.", "0"],
["boksi", "boks-i", "[OA] (<I>pugnobatali</I>), Box, spar. <B>~ado</B>, <B>~arto</B>, -ing, pugilism. <B>~isto</B>, boxer, prizefighter.", "0"],
["bolardo", "bolard-o", "(mar) bollard, mooring-post on quay. ➞ <I>bit, fost</I>.", "0"],
["bolero", "boler-o", "bolero (dance and music).", "0"],
["boleto", "bolet-o", "bolet fungus (<I>Boletus) &gt;</I> cep (<I>B. edulis</I>). <B>~o amara</B>, bitter bolet. (<I>B. felleus</I>).", "0"],
["boli", "bol-i", "(nt), [UV] Boil, bubble up, foam, seethe. <I>La akvo (poto) ~as</I> (Ps 46/3; Ij 41/20). <B>f</B> <I>mia sango ~as. ~i de kolero, senpacienco</I>. ➞ <I>ekflam, ekscitiĝ</I>. <B>~(ad)o</B>, ebullition, effervescence. <B>~egi</B>, boil furiously, bubble over. <B>~eti</B>, simmer, sing. <B>~igi</B> (<I>-n</I>), (cause to) b., cook by -ing. <I>~igi akvon (ovojn, terpomojn</I>). <B>~ilo</B>, (<I>kaldrono</I>), -er, kettle, etc. <B>~ujo</B>, water heater, copper. <B>~grado</B>, <B>~punkto</B>, -ing point. <B>~varma</B>, -ing hot. <B>f Ek~o</B>, sudden outburst. Super b. over. ➞ <I>bobel, brog</I>.", "0"],
["bolido", "bolid-o", "(ordinary language) bolide, globular lightning, fire-ball, large explosive meteor. ➞ <I>meteor</I>.", "0"],
["Bolivio", "Bolivi-o", "[OA 8] BO, Bolivia.", "0"],
["bolŝevismo", "bolŝev-ismo", "<B>~isto</B>, Bolshevism, -ist. <B>~ista</B>, -ic.", "0"],
["bolto", "bolt-o", "Bolt, pin, sliding bar. <B>Ekspansia ~o</B>, expan sion b. <B>Fundamenta ~o</B>, king b. <B>Ŝekla</B> shackle. <B>Ŝraŭba ~o</B>, screw bolt. <B>~ingo</B>, nut. <B>Mal~i</B>, unbolt. ➞ <I>aks, ralik, rigl, spindel, ŝpal</I>.", "0"],
["boluso", "bolus-o", "<B>1</B> (<I>pilolego</I>), bolus, large pill (for animal). <B>2</B> (min) bole, coarse red pigment.", "0"],
["bombardi", "bombard-i", "(<I>-n</I>) [OA] (<I>bombadi, kanonadi</I>), bombard, shell, <B>f</B> <I>~i per ŝtonoj. ~i per demandoj, komplimentoj, konfetoj, petoj</I>. (org) <B>~a sekcio</B> (<I>por laŭtegaj vicoj</I>). <B>~ilo</B>, howitzer (<I>haŭbizo</I>), mortar. <B>~isto</B>, bombardier.", "0"],
["bombardono", "bombardon-o", "(<I>bastubjo</I>), (m.i.) bombardon.", "0"],
["bombasto", "bombast-o", "[OA] Bombast, pompous talk. <B>~a</B>, -ic, inflated, turgid. speak -ically. ➞ <I>fanfaron, parad, pav, pomp, ŝvelparol</I>.", "0"],
["bombazeno", "bombazen-o", "(tex) bombazine (silk and wool twill).", "0"],
["bombeno", "bomben-o", "fire-bellied toad (<I>Bombina</I>).", "0"],
["bombicelo", "bombicel-o", "(<I>silkvostulo</I>), waxwing (<I>Bombycilla garrulus</I>).", "0"],
["bombikso", "bombiks-o", "mulberry silkworm moth (<I>Bombix</I>).", "0"],
["bombilio", "bombili-o", "bumble-fly, bee-fly (<I>Bombilius</I>). ➞ <I>burd</I>.", "0"],
["bombo", "bomb-o", "[OA] Bomb. <B>Atoma ~o</B>, atom b- <B>Fuzea ~o</B>, time b. <B>Gas-o</B>, gas b. <B>Kiraspika ~o</B>, armour-piercing b. <B>Supereksploda ~o</B>, H.E.b. <B>Artileria ~o</B>, shell. <B>Bruliga (incendia) ~o</B>, incendiary b. <B>Submara ~o</B>, depth charge. ➞ <I>burd, grenad, obus</I>.", "0"],
["bombono", "bombon-o", "[OA] sweet (meat), comfit, lollipop. <I>Ĉokolada ~o</I>. <B>~ujo</B>, sweetmeat- box. ➞ <I>dolĉaĵ, konfitaĵ, sukeraĵ, pastel, pralin</I>.", "0"],
["bona", "bon-a", "[UV] Good (wide sense). <B>1</B> admirable, nice, pleasing, satisfactory: <I>~a edzino, faro, konsilo, libro, manĝo, stilo, tero. Tio eble estas la plej ~a</I>, perhaps that is best <B>(4</B> FA/20). <I>~an tagon!</I> Good day! <I>Ne sufiĉe ~a</I>, not g. enough. <B>2</B> praiseworthy, upright, well-behaved, virtuous: <I>~a homo, infano, konduto</I>. <B>3</B> expedient, proper right: <I>Estas ~e tion fari</I>. <B>4</B> benevolent, kind: <I>~a humoro, koro. Estu tiel ~a, kiel</I>, Be so good as to. <B>5</B> beneficial: <I>~a dormo. ~a por la sano</I>. <B>6</B> capable, clever, efficient: <I>~a instruisto, pianisto, ŝoforo</I>. <B>7</B> sound, valid: <I>~a ekskuzo</I>. <B>~e</B>, [UV] well, rightly, properly. <I>~e (dirite)!</I> Well said! (interjection) Agreed! Bravo! Hear, hear! O.K.! Right! <B>~o</B>, good (Ge 2/17, Ps 13/6, 23/6). ➞ <B>~eco</B>, [UV] -ness (abs, quality). <B>~aĵo</B>, g. thing. <B>~ega</B>, Al, capital, excellent, fine, first class. <B>~egulo</B>, jolly g. fellow. <B>~ege!</B> Splendid! <B>~eta</B>, fair, so so, tolerable. <B>~ulo</B>, g. man. <B>mal~a</B>, [UV] bad. <I>Ne ~~a,</I> not bad.<I> <B>~</B><B>~e</B></I>, badly, ill. <B>~~(aĵ)o</B>, evil, mischief. <B>~~igi</B>, injure, spoil (➞ <I>difekt</I>). <B>~~iĝi</B>, deteriorate. <B>Pli~a</B>, better. <B>~~igi</B>, ameliorate, amend, improve, make better. <B>~~igisto</B> (us. pej), reformer. <B>Re~igi</B>, repair, restore. <B>Super~i</B> (4 FA/76). ➞ <I>admirind, aprobind, afabl, ĝust, kompetent, prav, taŭg, traf, valid, virt</I>.", "0"],
["bonedo", "boned-o", "(<I>~a velo</I>), (mar) studding sail, stunsail.", "0"],
["bonibakso", "bonibaks-o", "silk-cotton tree (<I>Bombax</I>).", "0"],
["bonito", "bonit-o", "(ich) bonito, allied to <I>skombro</I> and <I>tinuso</I>.", "0"],
["bonti", "bont-i", "(nt), (av) bont. <B>~o</B> -ing. ➞ <I>lop</I>.", "0"],
["bonzo", "bonz-o", "bonze, Japanese or Chinese Buddhist priest. ➞ <I>bikŝu</I>.", "0"],
["borago", "borag-o", "(bot) borage (<I>Borago</I>).", "0"],
["borakso", "boraks-o", "[UV] (chem) (min) borax, hydrated sodium borate. <I>Kruda ~o</I>, tincal.", "0"],
["bordelo", "bordel-o", "[OA] brothel, <B>~ulino</B>. ➞ <I>malĉast, prostitu</I>.", "0"],
["borderi", "border-i", "(<I>-n</I>), [UV] (be or put a) border, edge, fringe, line, skirt. (bind). <I>~i poŝtukon. ~i maton per franĝo, rubando. Vojo ~ita de foso, parapeto, de poploj. Okuloj ~itaj de nigraj haroj</I>. <B>~(aĵ)o</B>, braid, edging, list, selvedge, welt; (hort) border, continuous bed round garden or pt of garden. ➞ <I>bord, kadr, orl, zon</I>.", "0"],
["bordo", "bord-o", "[UV] <B>1</B> border, boundary, frontier, margin, side. <I>~o de abismo, arbaro, ŝipo</I>. (brim) <I>~o de ĉapelo, glaso</I>. <B>2</B> bank, brink, edge, shore. <I>~o de lago, maro, rivero</I> (Jos 3/15). <B>~a</B>, adjacent. adjoin, be contiguous, <B>~e de</B>, on the border of, along. <B>~ulo</B>, lands-(shore-)man. <B>~ŝipo</B>, coaster. <B>Al~(Sur~)iĝi</B> (nt), land. <B>Al~iĝejo</B>, landg- place, jetty, pier. <B>Apud~a</B>, coast(al). <B>Sen~a</B>, shoreless, open, vast. <B>Super~iĝi</B> (<I>superakvi</I>), overflow (banks). <B>Mar~o</B> (<I>plaĝo, strando</I>), beach, coast, sea-front (-shore-side), strand. <B>River~a</B>, riparian. ➞ <I>border, edr, eg, flank, kaj, later, lim, marĝen, rand, sojl</I>.", "0"],
["bori", "bor-i", "[UV] (<I>tratrui) (-n, tra</I>), Bore, drill (No 21/18). <I>~i truon, vojon</I>. <B>~i (~fosi) grundon</B>, burrow, tunnel; sink a shaft. <B>~ilo</B>, auger, bit, piercer. <B>~ilo ekspansiebla</B>, expansion bit. <B>Klik~ilo</B>, ratchet-bit. <B>Kork-ilo</B>, corkscrew. <B>Kubut~ilo</B>, bitbrace. <B>Najl~(Turn~)ilo</B>, bradawl, gimlet. (bot) <B>Neĝ~ulo</B> (<I>galanto</I>), snowdrop. <B>~maŝino</B>, -ing machine. <B>Tra~i</B> <I>barelon, lignon, monton</I> (lj 30/17), b. through, broach, perforate, <B>f</B> (<I>la koron</I>). <B>Ŝraŭb~i</B>, threadcut. <B>Verm~ita</B>, worm-eaten. ➞ <I>dril</I>.", "0"],
["borno", "born-o", "= klemo.", "0"],
["Boro", "Bor-o", "(chem) Bor/on (B). <B>~ato</B>, -ate. <B>~atacido</B>, -ic acid.", "0"],
["borso", "bors-o", "[UV] (Stock) Exchange, money- market (<I>loko aŭ negocado</I>). <B>Labor~o</B>, Labour E. <B>~isto</B>, member of S.-E. ➞ <I>aĝiot, makler, merkat</I>.", "0"],
["boselafo", "boselaf-o", "(zoo) nilgai (<I>Boselaphus</I>).", "0"],
["bosko", "bosk-o", "[OA] grove, clump of trees, shrubbery, spinney, thicket.", "0"],
["Bosnujo, Bosnio kaj Hercegovino", "", "BA, Bosnia-Herzegovina.", "0"],
["boso", "bos-o", "boss, bump, bruise, hump, protuberance, swelling, (arch) embossment, (phren) bump. <B>~i</B>, bag at the knees (<I>pantalono</I>). <B>~igi</B>, emboss, <B>f</B> bring into relief, heighten, set off. ➞ <I>elstaraj, ĝib, konveks, relief, tuber</I>.", "0"],
["bostono", "boston-o", "boston. <B>1</B> cgm. <B>2</B> dance.", "0"],
["botaniko", "botanik-o", "[OA] botany. <B>~a</B>, botanical. <I>~a ĝardeno</I>. <B>~i</B>, botanize, collect plants. <B>~isto</B>, botanist.", "0"],
["botaŭro", "botaŭr-o", "(<I>bovbirdo</I>), bittern (<I>Botaurus</I>) (Ce 2/14; Jes 14/23). <I>Amerika ~o,</I> American bittern. <I>Malgranda ~o</I>, little bittern.", "0"],
["botelo", "botel-o", "[UV] Bottle. <I>~o da lakto</I>. <B>Akvo~o</B> (<I>karaĵo</I>). <B>Gas~o</B>, gas cylinder. <B>Gut~o, sifon~o, suĉ~o</B>, drop (syphon, baby’s) b. <B>Parfum~o</B>, scent-b. <B>Ŝpruc~o</B>, vaporizer. <B>Varm~o</B>, hot-water b. <B>~ego</B> (<I>korba ~o</I>) carboy. <B>~eto</B>, flask, phial. <B>~ujo</B>, b-straw, <B>En-igi</B>, b. <B>Trans~igi</B>, decant. <B>Plen~o (da)</B>, b-ful. ➞ <I>bokal, flakon, karaf termos</I>.", "0"],
["boto", "bot-o", "[UV] Boot (above ankle). <B>~isto</B>, [UV] b-maker. <B>Alta ~o</B>, high b. <B>Elasta ~o</B>, springside b. <B>Laĉ~o</B>, lace-up b. <B>Rajd~o</B>, Hessian. <B>Sepmejlaj ~oj. Vad~o</B>, wader.", "0"],
["botrikio", "botriki-o", "(bot) moonwort fern (<I>Botry- chiuvri</I>).", "0"],
["botropo", "botrop-o", "various species of Viper (<I>Bothrops</I>) &gt; fer de lance, crossed v., pit v.", "0"],
["botulismo", "botulism-o", "(med) botulism.", "0"],
["bovlo", "bovl-o", "Bowl, large basin, <B>Fingra ~o</B>, finger-b. <B>~ego</B>, pan (for milk, etc.). ➞ <I>basen</I>.", "0"],
["bovo", "bov-o", "[UV] ox (<I>Bos</I>), <B>~a</B>, bovine <B>~aĵo</B>, beef. <I>~aĵo bolig-(rost-)ita</I>. <B>~aro</B>, herd of oxen. <B>~ejo</B>, <B>~stalo</B>, cattle shed, stall. <B>~ido</B>, [UV] calf. <I>~ida ledo</I>, calf (leather). <B>~idaĵo</B>, veal. <B>~ino</B>, [UV] Cow. <I>Lakta ~ino,</I> milch-c. <B>-inejo</B>, c-shed, byre. <B>~isto</B>, herdsman, <B>~birdo</B> (<I>botaŭro</I>). <B>~bleki</B>, moo, low. <B>Gibo~o</B> (<I>zebuo</I>), zebu. <B>Mar~o</B> (<I>sirenio</I>), sea-c. <B>Mosk~o</B> (<I>ovibovo</I>), musk- ox. <B>Tibeta- ~o</B>, yak. <B>Vir~o</B>, bull. <B>~~ido</B><I>,</I> steer. ➞ <I>bison, bubal, poefag, tragelaf</I>.", "0"],
["braceleto", "bracelet-o", "[OA] bracelet, bangle; anklet, armlet, wristlet (Ge 24/22).", "0"],
["bradipo", "bradip-o", "sloth (<I>Bradypus</I>) (1 FA 80/34).", "0"],
["brajli", "brajl-i", "(<I>velon) (faldi sur jardori</I>) (mar) brail, draw in, haul up. <I>Malfermi la ~ojn. Angula ~ilo</I>, clew (garnet) line. <I>~ilo flanka</I>, leech line. <I>Funda (meza) ~ilo</I>, bunt line.", "0"],
["brajlo", "brajl-o", "Braille characters, <B>~i</B>, b. <B>~e</B>, in b.", "0"],
["brakeno", "braken-o", "bombadier beetle (<I>Brachinus</I>).", "0"],
["brakiopodo", "brakiopod-o", "(<I>brakpiedulo</I>), (zoo) brachio- pod.", "0"],
["brakipodio", "brakipodi-o", "(bot) false brome grass (<I>Brachypodium</I>).", "0"],
["brako", "brak-o", "[UV] (anat) Arm. <I>~o ĉe ~o</I> (4 FA/50) a in a. <I>En (inter) la ~oj, sub ~ (sur~)e,</I> in one’s aa. <B>f</B> branch, etc. <I>~o de cirkel- (levil-river-seĝ-)o</I>, limb (<I>de krueo</I>), sound (<I>de maro</I>), <B>~umi</B> (<I>ĉirkaŭ~i, ~ĉirkaŭpremi, en~igi</I>), embrace, take into one’s aa. <B>Antaŭ~o</B>, fore-a. <B>Kontakt~(son~)o</B> (<I>gramofona</I>), pick-up. <B>Plen~o (da)</B>, -ful. <B>Sen~a</B>, a-less, <B>Sub~o (</B><I>akselo</I>), a-pit. <B>Unu~a</B>, one-ed. ➞ <I>brant, bret, humer</I>.", "0"],
["brakteo", "brakte-o", "(bot) bract. <B>~eto</B>, -eole.", "0"],
["bramano", "braman-o", "[OA] (Hin) brahm-an, -in.", "0"],
["bramo", "bram-o", "[UV] (ich) common Bream, sea-bream (<I>Abramis brama</I>). ➞ <I>pagel</I>.", "0"],
["bramo", "bram-o", "(<I>bramvelo</I>), top-gallant sail.", "0"],
["branĉo", "branĉ-o", "[UV] Branch, bough (limb, offshoot) (<I>de arbo.</I>). <B>f</B> lateral extension or subdivision, department, ramification. <I>~o de familio, industrio, rivero, scienco, temo, vojo</I>. <B>~aĵo</B> (4 FA 78/4). <B>~aro</B>, <B>~fasko</B>, brushwood, bundle of sticks, faggot. <B>~eto</B>, <B>~ido</B>, shoot, sprout, twig (➞ <I>tig</I>). <B>Dis~i</B>, break out (diverge) into, put out (forth) branches, spread forth, ramify. <I>Dis~a (mult~a, ~oplena),</I> divaricate, spreadg, straggling. <B>Sen~igi</B>, cut back, pollard. ➞ <I>al, brak, fak, fasĉin, fask, fili, fork, vering</I>.", "0"],
["brando", "brand-o", "[UV] brandy, spirit, <B>~faristo</B>, distiller. <B>ĉeriz~o</B> (<I>kirŝo</I>), cherry brandy.", "0"],
["brankardo", "brankard-o", "(<I>homportilo, portlito</I>), stretcher. <B>~isto</B>, s-bearer.", "0"],
["branko", "brank-o", "[UV] gill (of fish), <B>~oklapo</B> (<I>operklo</I>), gill cover. <B>Lameno~a, nud~a</B>, lameli-branchiate, nudi-branchiate.", "0"],
["brano", "bran-o", "[UV] Bran, grain husks. <B>~akvo</B>, b-water.", "0"],
["brasi", "bras-i", "(<I>jardon</I>), (mar) brace (a yard) <I>ĉe la vento</I>, hug the wind. <B>~o</B>, b., guy, vang.", "0"],
["Brasika ~o", "", "cabbage patch. <B>Flor~o</B>, flower b. <B>Fram~o</B>, cold frame. <B>Sem~o</B>, <B>Varm~o</B>, hot-b. <B>En~igi</B>, b. out. <I>[Ne= lit.]</I>", "0"],
["brasiko", "brasik-o", "[UV] Cabbage (<I>Brassica). from ~o sovaĝa = colewort, sea c., wild navew (B.o. oleracea or eampestris), come the following</I> vrties of “greens”: <B>~o kapa</B> and <B>~o ruĝa</B>, the usually garden cabbage (<I>B.o. var. capitata</I>); <B>Flor~o</B>, cauliflower (<I>B.o. subvar. eauliflora</I>); <B>~o Savoja</B> (<I>sabeliko</I>), Savoy c. (<I>B.o. var. bullata subvar. subauda</I>); <B>~o senkapa</B>, borecole, collards, curly kale, (<I>B.o. var. acephala</I>); <B>Brokolio</B>, broccoli (<I>B.o. subvar. botrytes)-,</I> <B>Bruselaj ~etoj</B>, Brussels sprouts (<I>B.o. var. bullata subvar. gemmiflora</I>); <B>Kaŭlorapo</B>, Kohlrabi (<I>B.o. caulorapa</I>). ➞ <I>diplotaks, kolz, kramb, nap, rap, sinap; pierid</I>.", "0"],
["brava", "brav-a", "[UV] capable, fine, grand, gallant, worthy, valiant. [Ne= brave (<I>kuraĝa, sentima</I>)] <B>~ulo</B>, <B>~a homo</B>, able man, fine (honest, gallant) fellow, good sort, worthy. (El 18/21, 25; Jes 5/22; l Rĝ 1/42, 52). <B>~ulaĉo</B>, daring villain. <B>~ulino</B>, <B>~a virino</B> (Se 31/29; Ru 3/11). <B>~e</B>, boldly, stoutly. (interjection) <B>Bravo!</B> Splendid! Well done! <B>~afia</B>, impudent. <B>~ega</B>, first class, intrepid.", "0"],
["bravura", "bravur-a", "(mus) bravura (a) brilliant execution, display, (b) passage requiring great skill and spirit in performance.", "0"],
["brazi", "braz-i", "braze; solder with alloy of brass and tin. <B>~ilo</B>, -ing-iron. ➞ <I>lut</I>.", "0"],
["Brazilo", "Brazil-o", "[OA-8] BR, Brazil.", "0"],
["breĉio", "breĉi-o", "(min) breccia, composite rock of angular fragments.", "0"],
["breĉo", "breĉ-o", "[OA] (<I>trarompo</I>), breach; blank, gap, hiatus, hole, interstice, opening. <I>~o en heĝo, linio, muro, ŝipo</I> (Ne 4/7; Am 4/3). <B>f</B> <I>fari ~on en la poŝo</I>, make a hole in one’s fortune. break through, make a gap in. <B>~eto</B> (<I>randrompo</I>), chip, dent, jag, notch. ➞ <I>noĉ</I>.", "0"],
["bredi", "bred-i", "(<I>-n</I>), (bi, hort), Breed, propagate, raise, train. <B>~(ad)o</B>, -ing, stock, strain. <B>~isto</B>, -er. ➞ <I>kultiv, kultur, selekt</I>.", "0"],
["breloko", "brelok-o", "(<I>horloĝĉena pendaĵo</I>), charm, pendant, trinket.", "0"],
["bremso", "brems-o", "[OA] (<I>haltigilo</I>), Brake. ~o <I>aera, benda, kluĉa, konusa, mana, pieda, vakua</I>. <B>Danĝer~o</B>, <B>rezerv~o</B>, emergency b. <B>Su~o</B>, shoe (block) b. <B>Duŝua ~o</B>, clasp-b. (apply a) b. <B>f</B> restrain. <B>~isto</B>, -sman. ➞ <I>blok, malakcel</I>.", "0"],
["breto", "bret-o", "[UV] Shelf. <I>~o de biblioteko, ŝranko</I> <B>Ĉerpa ~o</B>, ladle-board (of mill-wheel). <B>Fenestra ~o</B> (<I>sojlo</I>), window-sill. <B>Kamen~o</B>, mantle piece. <B>Pied~o</B>, foot-board, running-board, pedal, treadle. <B>~aro</B>, shelving, stand with shelfs. <I>Plad~aro, teler~aro, plada rako</I>, dresser, plate-rack. <B>~eto</B>, ledge. ➞ <I>etaĝer, rak, tabul, trab</I>.", "0"],
["breveto", "brevet-o", "appointment, certificate, licence, warrant, (mil) commission. ➞ <I>patent, diplom</I>.", "0"],
["breviero", "brevier-o", "(rc) breviary. ➞ <I>preĝaret</I>.", "0"],
["brevo", "brev-o", "(<I>ueto</I>), (typ) breve, the sign over the letter ŭ.", "0"],
["brido", "brid-o", "[UV] (<I>kaprimeno</I>), Bridle. <B>Kol~o</B>, halter. <B>~i</B>, b. <I>~i buŝon, ĉevalon</I>, <B>f</B> curb, hold in, keep under, master, repress, restrain. <I>~i koleron, la pasiojn</I>. <B>~eto</B>, snaffle. <B>~rimeno</B>, b-rein(-strap). <B>Mal~i</B>, <B>give</B> rein to, let run wild. <B>Ne~ebla</B>, un- controll(-govern-manage-tame)able, indomitable. <B>Sen~a (</B><I>senmodera, trolibera</I>), un-ed. <I>~~a ambicio, fantazio, kolero</I>. ➞ <I>brems, jung, katen, kvietig, moderig, obeig, reg</I>.", "0"],
["brigado", "brigad-o", "[OA] <B>1</B> (mil) Brigad/e (us. = 3 battalions). <B>2</B> organized uniformed band, body, detachment, gang, party, squad, troop. <I>Knaba ~o</I>, boys’ b. <B>~estro</B>, brigadier. <B>Fajr~o</B>, fire b.", "0"],
["brigantino", "brigantin-o", "brigantine, (square-rigged on the foremast and with fore-and-aft sails on the aftermast).", "0"],
["brigo", "brig-o", "brig, two-masted square-rigged vessel.", "0"],
["briĝo", "briĝ-o", "(cgm) bridge.", "0"],
["briko", "brik-o", "[UV] (bid) Brick (Ge 11/3), ingot (<I>ora</I>), pig (<I>fera, plumba</I>). <B>~o bakita</B> (baked, fired); <B>glazura</B> (glazed), <B>kojna, volba ~o</B>, radial b. <B>Lig~o</B>, header. <B>Tegmenta ~o</B> (<I>tegolo</I>), tile. <B>Ventola ~o</B>, ventilation b. <B>~i</B> (<I>-n</I>), block up with bricks. <B>~ejo</B>, b-field. <B>~ero</B>, b-bat. <B>~eto</B>, small b. briquette. <I>Brul~eto, karb~eto;</I> bar (<I>ĉokolado</I>), cake (<I>sapo</I>). <B>~aranĝo</B>, bond. <B>~metisto</B>, b-layer. <B>~portisto</B>, hodman. ➞ <I>blok, mason, ŝton</I>.", "0"],
["brilantino", "brilantin-o", "brilliantine, hair-cosmetic.", "0"],
["brili", "bril-i", "(nt), [UV] Shin/e, beam, emit (reflect) light, gleam. <I>La okuloj (suno) ~as</I>. <B>f</B> (be conspicuous). <B>~a</B>, -ing, bright, brilliant, glossy, lustrous, showy. <I>~a</I> (radiant) <I>juneco, sano. ~a festo, lumo, oratoro, venko. ~a sprito</I>, sparkling wit. <B>~e</B>, brilliantly. <B>~o</B>, shine, lustre, vividness. <B>~aĉa</B>, flashy, loud, meretricious, showy. <B>~aĵeto</B> (Jes 3/20), spangle, tinsel. <B>~ega</B>, brilliant, dazzling, glorious, radiant, resplendent, <B>~ego</B>, brilliance. <B>~egi</B>, glare. <B>~eti (~eto)</B>, gleam, glimmer, glisten, glitter, sparkle. <B>~igi</B> (<I>-n</I>), (make s.) brighten, polish. <B>Ek~i</B>, flash. <B>Ek~a lumo</B>, flashlight. <B>Ne~a, mal~a, sen~a</B>, dim. dull, lustreless; (phot) matt. <B>Pli~igi</B>, burnish. <B>Re~i</B> (<I>reflekti</I>), shine back. <B>Sen~iĝi</B>, tarnish. <B>Super~i</B>, out-s. <B>Ŝanĝ~o</B>, change in colour. colour-play (➞ <I>iriz, opal</I>). <B>Trem~i</B> (<I>ŝajntremi</I>), scintillate, shimmer, sparkle, twinkle. ➞ <I>flagr, flam, fluoresk, fosforesk, glim, hel, lum, radi, scintil</I>.", "0"],
["brilianto", "briliant-o", "[UV] brilliant, fine-cut gem. ➞ <I>gem, juvel</I>.", "0"],
["brio", "bri-o", "Bryum moss (<I>Bryum</I>).", "0"],
["brionio", "brioni-o", "white bryony (<I>Bryonia</I>). ➞ <I>tamus</I>.", "0"],
["Britujo, Britio", "Brit-ujo, Britio", "[OA-9] GB, Britain.", "0"],
["brizo", "briz-o", "<B>1</B> (met) Breeze, gentle wind. <B>Mar~o</B>, sea b. <B>2</B> (bot) quaking-grass (<I>Briza</I>).", "0"],
["broĉo", "broĉ-o", "[OA] brooch, ornamental safety-pin. ➞ <I>agraf, buk</I>.", "0"],
["brodi", "brod-i", "(<I>-n</I>) (nwk), [UV] Embroider. <I>~ poŝtukon, florojn sur tukon</I>. <B>f</B> embellish (narrative) with rhetorical ornament and fictitious additions. <B>~ado, (~art)o</B>, -y. <B>~aĵo</B>, piece of -y. <I>Rakonti</I> <B>sen~e</B>, tell the bare facts. ➞ <I>brok</I>.", "0"],
["brodkasti", "brodkast-i", "(<I>-n</I>), (<I>radie disaŭdigi</I>), Broadcast (also figuratively). <I>Brita ~a Korporacio</I>, B.B.C. <B>~ilo</B>, transmitter. <B>~ejo</B>, -ing station.", "0"],
["brogi", "brog-i", "(<I>-n, abs</I>), [UV] Scald, s. out (<I>bol- poton</I>), wash with (dip in) boiling water; blanch (<I>migdalojn). Propra supo ~as, fremda allogas</I>. <B>~aĵo</B>, broth (Jĝ 6/19). <B>~vundo</B>, burn, s. <B>f</B> <I>sin ~i</I>, burn one’s fingers, be fleeced.", "0"],
["brokanti", "brokant-i", "[OA] deal in Second-Hand goods, barter. <I>Aĉet-(vend-)i ~e</I>. <B>~(ad)o</B>, s-h trade, bartering. <B>~a|o</B>, s-h goods, bric-a-brac, old clothes, etc. <B>~ejo</B>, s-h shop. <B>~isto</B>, dealer in s-h goods. ➞ <I>revend</I>.", "0"],
["broki", "brok-i", "(<I>brode teksi</I>), (tex) Brocade. <B>~aĵo</B>, b., fabric with raised pattern, or interwoven with gold or silver thread. ➞ <I>orŝtof</I>.", "0"],
["brokolio", "brokoli-o", "broccoli (➞ <I>brasik</I>).", "0"],
["bromelio", "bromeli-o", "(bot) bromelia (<I>Bromelia</I>).", "0"],
["bromo", "brom-o", "[OA] <B>1</B> Brom/ine (Br). <B>~ato</B>, -ate. <B>~ido</B>, -ide. <I>Arĝenta ~ido</I>, silver -ide. <B>~aeido</B>, hydro-ic acid. <B>2</B> Brome grass (<I>Bromus). Mola ~o</I>, soft b. <I>Sekala ~o,</I> rye b. <I>Sterila ~o</I>, barren b.", "0"],
["bronkito", "", "[OA] -itis. <B>~oskopo</B>.", "0"],
["bronko", "bronk-o", "[OA] (anat) Bronch/ial tube. <B>~a</B>, -ial.", "0"],
["brontosaŭro", "brontosaŭr-o", "brontosaurus.", "0"],
["bronzo", "bronz-o", "[UV] Bronze, alloy of copper and tin, or similar alloy; used for British \"copper\" coins. <B>Alumin-(Fosfor)a ~o</B>, aluminium (phosfor) b. <B>Kanona -o</B>, gun metal. <B>Sonorila ~o</B>, bell metal. <B>~a</B> <I>statuo</I>. <B>~i</B>, (coat with) b. <B>f</B> tan (face in sun). <B>~aĵo</B>, b-ware. <B>~frunt~(vizaĝ)a</B>, brazen-faced. <B>~kolora</B>, <B>~verda</B>.", "0"],
["brosimo", "brosim-o", "breadnut (cow) tree, etc. (<I>Brosimum</I>).", "0"],
["brosmio", "brosmi-o", "(ich) torsk, rusk, brismak (<I>Brosmius</I>).", "0"],
["broso", "bros-o", "[UV] <B>Brush.</B> <I>Cir</I><B><I>~o</I></B>, <B><I>ĉapel</I></B><I>~o, dent~o, har~o, ŝu~o, ung~o, vest~o. Drata (metala) -o</I>, <B>wire b. Frot~o</B>, <B>friction (scrubbing) b. ~i (<I>-rt</I>)</B>, <B>b</B>., <B>scrub. <I>~i la</I> harojn. For~i (b. away) <I>polvon</I></B>. ➞ <B><I>balail</I></B>, <B><I>penik</I></B>.", "0"],
["broŝuro", "broŝur-o", "[OA] Stitch/ed booklet, brochure, pamphlet (not cloth-bound). <B>~i</B>, sew (s., staple) together. <B>Drat~i</B>, staple, wire-s. <B>-ita</B>, paper-covered, sewn. ➞ <I>bind, kunkudr</I>.", "0"],
["brovo", "brov-o", "[UV] eyebrow. <I>Kuntiri la ~ojn (=sulkigi la fronton</I>), knit the brows (➞ <I>frunt, okulharoj.</I>)", "0"],
["brr!", "", "(interjection) brr! Ugh! <I>Kiel malvarme!</I> ➞ <I>at, fi</I>.", "0"],
["bruko", "bruk-o", "pea-beetle(-weevil), bean beetle (<I>Bruchus</I>).", "0"],
["bruli", "brul-i", "(nt), [UV] Burn, be on fire. <I>Fajr- (kandel-lign-)o ~as</I>. <B>f</B> be feverish, hot; eager, impassioned, impatient. <I>de am-(febr-scivol-senpacienc-)o</I>. ➞ <I>ard, flam. La afero ne ~as</I> (is not urgent). <B>~a</B> <I>materialo</I>. <B>~(ad)o</B>, blaze, etc. <I>Kia ~o!</I> <B>~aĵo</B>, fuel, (av) <B>~aĵindikilo</B>, fuel contents gauge. <B>~ajistoj</B>, wood party. ~TGT (<I>-n</I>), b., consume by fire, scorch, etc. ~~i <I>karbon, lignon</I>. <B>~iga vitro</B>, -ing glass. <B>~ilo</B>, (<I>flamingo</I>), -er. <I>~ilo de Bunsen (bunseno</I>), Bunsen-er. <B>~pova</B>, <B>-iva</B>, combustible. (med) <B>~umo</B> [UV] (<I>inflamo</I>), in- flammation (Le 13/28). <B>-dezertigi</B>, <B>~difekti</B> (Da 3/27). <B>~dolor(~vund)i</B> (Jes 43/2), b. finger, etc. <B>~gusta</B>, burnt (taste). <B>~odoro</B>, smell of -ing. <B>Ek~i</B>, catch fire. <I>~~igi</I>, set on fire, light (<I>kandelon</I>, etc.). <B>For~i</B>, (<I>konsumi</I>) (El 3/2). <I>For~igi</I>, b. up. <B>Ne~igebla</B> (<I>fajrimuna, fajrorezista</I>), fireproof. <B>Sub~i</B>, glow, smoulder, <B>Krim~igo</B>, arson. ➞ <I>cindr, incendi</I>.", "0"],
["bruna", "brun-a", "[UV] Brown. <I>~a ĉevalo, pano, papero, sukero</I>. Dark, dusky (complexn). <B>Flav~a</B>, yellowish brown, fawn. <B>Griz~a</B>, dun. <B>Kaŝtan~a</B>, chestnut. <B>Nigre ~a</B>, blackish b. <B>Or~a</B>, auburn. <B>Ruĝ~a</B>, bay, russet, sorrel, <B>~eta</B>, -ish. <B>~(haŭt)igi</B>, b., tan. <I>Sun~igo</I>, sunburn. <B>~haŭtulino</B>, <B>~harulino</B>, brunette. ➞ <I>bej, fulv</I>.", "0"],
["Brunejo", "Brunej-o", "BN.", "0"],
["brunelo", "brunel-o", "(bot) self-heal (<I>Brunella, Prunella</I>). ➞ <I>prunel</I>.", "0"],
["brunfelsio", "brunfelsi-o", "(bot) brunfelsia (evergreen flowering shrub).", "0"],
["bruo", "bru-o", "[UV] Nois/e, din (wide sense); clatter (dishes), report (gun). <B>Eksplod~o</B>, detonation. <B>Ferm~o</B>, <B>~fermi</B>, slam. <B>Fon~o</B>, background noun. <B>Paf~o</B>, bang. <B>Paŝ-o</B>, patter (feet). <B>Surda ~o</B>, thud, thump, <B>f</B> fame, sensation. <I>Pit da ~o, ol da faro</I>. <B>-i</B> (<I>fari ~on</I>), make a n., be -y. <B>f</B> make a fuss. <I>La tuta mondo ~is pri tio</I>. <B>~a</B>, -y, boisterous, loud. <B>~e</B>, -ily, loudly. <B>~aĉo</B>, <B>~ado</B>, <B>~ego</B>, clamour, din, hubbub, racket, row, uproar (➞ <I>eksplod, tondr</I>). <B>~egi</B>, roar, etc. <B>~ema</B>, -y., clamorous (Se 9/13). <B>~eti</B>, murmur, purl, ripple, rustle etc. (Le 26/36). <I>murmur, plaŭd, susur, tint</I>. <B>Dis-igi</B>, n. abroad. <B>Mal~o</B>, quiet, still. <B>Sen~a</B>, -less, silent. ~<B>~e</B>, quietly, without fuss. ~~igilo, silencer. ➞ klak, krak, muĝ, plaŭd.", "0"],
["bruska", "brusk-a", "Brusque, (offensively) abrupt, blunt, curt, off-hand, sharp, short. <I>Paroli</I> <B>~e</B>, bluntly, <B>~eco</B>, brusqueness, bluntness. <B>~i</B>, be sharp, uncivil, treat with scant courtesy. ➞ <I>abrupt, krud, maldelikat, neĝentil</I>.", "0"],
["brusto", "brust-o", "[UV] <B>1</B> (anat) Breast, Chest. <B>2</B> (<I>sino</I>), bosom. <I>Sur la ~o de Abraham, de la patrino</I>. <B>3</B> b. of coat, etc. <B>~a</B>, pectoral, (mus) <I>~a registro</I>, c-register. <B>~aĵo</B>, (cul) b. <B>~osto</B> (<I>sternumo</I>), b-bone, brisket. <B>~peco</B>, <B>~otuko</B>, bib. <B>-oŝveli</B>, throw out the c., swagger. ➞ <I>bust, mam, sin</I>.", "0"],
["brutala", "brutal-a", "Brutal, savagely cruel. <B>~eco</B>, brutality, violence. ➞ <I>perfort, senbrid</I>.", "0"],
["bruto", "brut-o", "[UV] Brute. <B>1</B> (<I>paŝtobesto</I>), beast, e.g., <I>bovo, ĉevalo, kapro, porko. Paŝti ~ojn,</I> feed cattle. <B>2</B> sometimes in singular, with collective meaning. <I>Ili estas ~o</I> (Pr 3/18, K 118/7, 197/7). <B>3</B> Lower nature in man. <B>f</B> Stupid, unspiritual person., ➞ <I>azen, ŝaf</I>. <B>~a</B>, of a brute, brutish, stupid. <I>~a forto</I>. <B>~aro</B>, (herd of) cattle, <B>~ejo</B>, shed, sty, etc. <B>~ido</B> (No 15/11). <B>~igi</B>, brutalize. <B>~isto</B>, drover. <B>~edukado</B> (Jeĥ 38/12). ➞ <I>besti, brutal, greg</I>.", "0"],
["bubaliso", "bubalis-o", "(<I>Bubalis</I>), Asiatic (or Water) Buffalo.", "0"],
["bubalo", "bubal-o", "[UV] Indian buffalo (<I>Bubalus bubalis</I>), and similar animals. <B>~ido</B> (Ps 29/6). ➞ <I>bison</I>.", "0"],
["bubo", "bub-o", "[UV] boy, lad, urchin (slightly pej). <B>Serv~o</B>, cabin-page-boy. <B>Strat~o</B>, gamin, street-urchin, (cgm) jack, knave. <B>~a</B> mischievous, etc. <B>~aĉo</B>, rascal, scamp. <B>~aĵo</B>, silly prank. <B>~aro</B>, kids, noisy little brats. <B>~ego</B>, awkward fellow, booby, bumpkin, lout. <B>~ino</B>, hoyden, tom-boy; hussy, jade, little minx. ➞ <I>knab, petol; guf</I>.", "0"],
["bucero", "bucer-o", "(orn) Hornbill (<I>Buceros</I>, etc.). <I>~o dukorna</I>, Great Indian h.", "0"],
["buĉi", "buĉ-i", "(<I>-n</I>), [UV] Butcher, Slaughter, slay. <B>~(ad)o</B>, carnage, s. (Jer 12/3). <B>~ejo</B>, s-house. <B>~isto</B>, b. <B>Amas~i</B> (<I>masakri</I>), massacre. <B>Ofer~i</B>, immolate, sacrifice. ➞ <I>eksterm, hekatomb, mortbat, murd</I>.", "0"],
["budĝeto", "budĝet-o", "[OA] (evit) (unpronounceable!) <B>= buĝeto</B> [OA-8].", "0"],
["budhismo", "budh-ismo", "<B>~isto</B>, (a. <I>Buda-</I>), Buddh-ism, -ist.", "0"],
["budi", "bud-i", "(nt) sulk, be sullen, morose. <B>~ema</B>, sulky.", "0"],
["budleo", "budle-o", "butterfly bush (<I>Buddleia</I>).", "0"],
["budo", "bud-o", "[UV] temporary shelter, booth, kiosk, stall, stand. <I>~o gazeta, libra,</I> bookstall, <I>~o garda, postena, sentinela,</I> sentry box. <I>~o signala, telefona</I>. (pej) poky little room, (col) digs, sanctum (<I>studenta</I>). ➞ <I>barak, kaban, kajut</I>.", "0"],
["buduaro", "buduar-o", "[OA] boudoir, lady’s small private room or sanctum.", "0"],
["bufago", "bufag-o", "(orn) beef-eater, ox-pecker (<I>Buphaga</I>).", "0"],
["bufedo", "bufed-o", "[UV] <B>1</B> Bar, buffet, refreshment room. <B>2</B> sideboard (<I>telermeblo</I><B>)</B>, <B>~ist(in)o</B>, b-man (-maid), b-tender.", "0"],
["bufo", "buf-o", "[UV] toad, puddock (<I>Bufo</I>). <B>~o akuŝa</B>, midwife toad.", "0"],
["bufro", "bufr-o", "(mot) (ry) (<I>ŝokamortizilo</I>), Buffer, bumper. <B>~a</B> <I>bloko</I>, buffer stop, terminal buffer. <B>~eto</B>, door-stop. <B>~a</B> <I>ŝtato</I>. <B>~i</B>, bump (run) into.", "0"],
["buftalmo", "buftalm-o", "(bot) yellow ox-eye (<I>Buphthalmum</I>).", "0"],
["buĝeto", "buĝet-o", "[OA-8] (<I>spezkalkulo</I>), Budget, estimate, <I>~o armea, mastruma, ŝtata</I>. <B>~i</B>, make a budget, plan. ➞ <I>bilanc, ekonomi, financ</I>.", "0"],
["buĝio", "buĝi-o", "(<I>tubesplorilo</I>), (surg) bougie. ➞ <I>kateter, sondil</I>.", "0"],
["bukceno", "bukcen-o", "(zoo) whelk (<I>Buccinum</I>).", "0"],
["bukedo", "buked-o", "[UV] bouquet bunch of flowers, nosegay, posy (also figuratively). <I>Ĵeti ~on</I>.", "0"],
["buklo", "bukl-o", "[UV] (<I>spiraleca hartufo</I>), Curl, lock, wisp, wave. <I>Blondaj ~oj</I>. <B>Frunt~o</B>, forelock. <B>Konstantaj ~oj</B>, “perm”. <B>Log~o</B>, kiss-curl. <B>~i</B> (<I>-n</I>), curl. <I>~itaj haroj</I>, (Alt 5/11). <B>~aro</B>, locks. <B>~eto</B>, ringlet. <B>~iĝemaj</B> (<I>krispaj) haroj de negro</I>. <B>~ilo</B>, hair curler. <B>Sen~igi</B> (<I>malfrizi</I>), straighten, uncurl. ➞ <I>bant, buk, friz, maŝ, tuf</I>.", "0"],
["buko", "buk-o", "[UV] Buckle. <I>Glit~o</I>, slide. <B>~i</B> (<I>-n</I>), b., <I>~i rimenon, zonon</I>. <B>~a</B> <I>pinglo</I>, pin or tongue of b. <B>Mal~i</B>, unbuckle. ➞ <I>agraf</I>.", "0"],
["bukolika", "bukolik-a", "Bucolic, pastoral, rustic. <B>~a (paŝtista) poemo</B>, b. ➞ <I>idili, pastoral, past</I>.", "0"],
["bukso", "buks-o", "[OA] (bot) Box (<I>Buxus</I>). <B>~a ligno</B>, b-wood.", "0"],
["bulbo", "bulb-o", "[UV] <B>1</B> Bulb, corm, e.g., of lily, onion, tulip. <B>2</B> anything b-shaped; puff, swelling, tuber, (ordinary language) onion (No. 11/5) (more precisely <I>cepo</I>). <B>~ero</B>, scale, shell, (mec) <B>~fero</B>, b-bar. ➞ <I>ampol, bos, bul, glob, tuber</I>.", "0"],
["bulbulo", "bulbul-o", "(ordinary language) bulbul, Eastern song-thrush (many species).", "0"],
["buldogo", "buldog-o", "bulldog (1 FA 40/23; 2 FA 67/32). ➞ <I>dog</I>.", "0"],
["buldozo", "buldoz-o", "(<I>terebenigilo</I>), bulldozer, tractor-driven machine for clearing land, <B>f ~i</B>, force one’s way against obstruction by intimidation or threat.", "0"],
["buleito", "buleit-o", "(mar) bowline.", "0"],
["buleo", "bule-o", "(a. <I>bullo</I>), papal edict: <I>la Ora B~o</I>.", "0"],
["Bulgarujo, Bulgario", "Bulgar-ujo, Bulgario", "[OA-8] BG.", "0"],
["buljono", "buljon-o", "[UV] bouillon, broth, soup.", "0"],
["bulko", "bulk-o", "[UV] roll (bread), breakfast (French, Vienna) roll. <B>Buter~o</B>, brioche. ➞ <I>kresĉento</I>.", "0"],
["bulo", "bul-o", "[UV] <B>1</B> Ball, clod, lump, roundish mass. <I>~o de (el) karno, tero</I> (Ps 65/10). ~o <I>da pano</I> (2 Sa 6/19). <I>~o dikfingra</I>, b. of thumb. <B>Faden~o, lan~o</B>, ball of thread (wool). <B>Farun~o</B>, <B>past~o</B>, dough-nut, dumpling. <B>Frit~o</B>, rissole, <B>Har~o</B>, “bun” (M/125). <B>Neĝ~o</B>, snowball. <B>Pan~o</B>, round loaf. ~~<B>eto</B>, roll. <B>Puf~o</B>, puff-ball. <B>Sang~o</B>, clot of blood. <B>~a</B>, clotted, lumpy. <B>~eto</B>, pellet. <B>~igi</B>, make into a b., clench (fist). <B>~iĝi</B>, curl up (in bed). <B>~pieda</B>, club-footed. ➞ <I>glob, ĝib, kugl, mas, pilk, sfer</I>. <B>2</B> (<I>ĵet~o</I>), Bowl (gm of balls). <B>~(rul)ado</B>, <B>~ejo</B>, -ing green.", "0"],
["bulteno", "bulten-o", "[OA] (<I>perioda informilo</I>), Bulletin, short official report (summary of information). <I>~o meteorologi-(veter-)a</I>, weather report. ➞ <I>kronik</I>.", "0"],
["bulvardo", "bulvard-o", "[OA] boulevard, wide tree- lined street. <B>Ring~o</B>, ring-road. <B>~ulo</B>, man about town. ➞ <I>avenu</I>.", "0"],
["bumerango", "bumerang-o", "boomerang.", "0"],
["bumo", "bum-o", "(mar) boom (wide sense), especially spar supporting a sail, (av) <I>enpena ~o</I>. <B>!.cv~o</B>, derrick.", "0"],
["bungaro", "bungar-o", "(zoo) krait (Indian snake) (<I>Bungarus</I>). ➞ <I>kobr</I>.", "0"],
["bunkro", "bunkr-o", "(golf) bunker, hollow.", "0"],
["buno", "bun-o", "(<I>Angla kuketo</I>), bun (small soft round sweet cake with currants). ➞ <I>bul</I>.", "0"],
["bunta", "bunt-a", "(<I>divers-, miks-, vari-kolora</I>), many- colored, motley, variegated; piebald (<I>ĉevalo). ~a vesto</I>.", "0"],
["buo", "bu-o", "Buoy. <B>Alliga ~o</B>, mooring b. <B>Sav~o</B>, life b. <B>Sonorila ~o</B>, bell b. <B>~i</B> (<I>-n</I>) (also figuratively) <B>1</B> <I>= flotigi, subteni</I>. <B>2</B> = beacon, mark out.", "0"],
["bupleŭro", "bupleŭr-o", "(bot) hares-ear, thorow-wax (<I>Bupleurum</I>).", "0"],
["bupresto", "buprest-o", "buprestis beetle (<I>Buprestis</I>).", "0"],
["burdo", "burd-o", "[UV] Bumble (humble) bee (<I>Bombus</I>). <B>~ado</B>, buzz-(humm-)ing (of insects).", "0"],
["burdono", "burdon-o", "(mus) Bourdon. <B>1</B> Drone (of bagpipes). <I>~a baso</I>, d-bass (persistent tonic or dominant pedal, or both). <B>2</B> (org) b-stop. ➞ <I>burdado</I>.", "0"],
["bureo", "bure-o", "bourree (dee and music).", "0"],
["bureto", "buret-o", "(chem) burette (graduated measurg- tube). ➞ <I>pipet, provtub</I>.", "0"],
["burĝo", "burĝ-o", "[UV] <B>1</B> burgess, citizen, freeman, voter. <B>2</B> commoner, tradesman, (art, col) Philistine. <B>~a</B>, homely, middle-class. <B>~aro</B>, the bourgeosie, middle-class. <B>~ino</B>. ➞ <I>civitan, urban</I>.", "0"],
["burĝono", "burĝon-o", "[UV] Bud. <I>~o ftor-(foli-)a</I>. <B>~i</B>, (produce a) b. (Alt 2/15, 7/12). <B>f</B> (<I>ekaperi). Esperanto ~as en la vilaĝo</I>.", "0"],
["Burkino", "Burkin-o", "BF, Burkina, Burkina Faso.", "0"],
["burko", "burk-o", "small Russian or Polish felt mantle.", "0"],
["burleska", "burlesk-a", "[OA] Burlesque, mock-serious, <I>~a poemo</I>. <B>~o</B>, b., caricature derisv imitation, exaggerated parody. <B>~i</B>, b., caricature, travesty. <B>~aĵo</B>, clownery, farce. <B>~ulo</B>, -er. ➞ <I>fars, grotesk. histrion, karikatur, mok</I>.", "0"],
["burnuso", "burnus-o", "[OA] burnous, Arab hooded cloak.", "0"],
["burokrato", "burokrat-o", "[OA-9], Bureaucra/t. <B>~a</B>, -tic. <B>~aro</B>, <B>~ismo</B> [OA-9], bureaucracy.", "0"],
["Burundo", "", "BI, Burundi.", "0"],
["buselafo", "buselaf-o", "hartebeest (<I>Bucelaphus</I>)", "0"],
["buso", "bus-o", "(col. abbreviation of aŭtobuso or omnibuso).", "0"],
["busprito", "busprit-o", "(mar) bowsprit. <B>Bum~o</B>, jib boom.", "0"],
["busto", "bust-o", "[OA] (anat) bust.", "0"],
["buŝelo", "buŝel-o", "[UV] bushel (metr). <I>~o da mono</I> (1 FA 10/37).", "0"],
["buŝo", "buŝ-o", "[UV] Mouth. <B>1</B> (anat) lips, snout, etc. <I>Fermi, ŝtopi la ~on. Teni la ~on fermita</I>. <B>f</B> <I>Malsinceran ~on mi malamas</I> (Se 8/13). <B>2</B> Opening, outlet; nozzle, spout; mouth (estuary) of river. <B>~a</B>, buccal, oral, verbal. <B>~ego</B> (<I>faŭko</I>). <B>~umo</B>, [UV] muzzle. <I>~umi hundon</I>. <B>El~igi</B>, ➞ <I>paroleg, vom</I>. <B>En~aĵo</B>, bit(horse). <B>~aĵo</B>, <B>~peco</B>, m-piece e.g., of musical instrument or pipe. <B>Post~o</B> (<I>faringo</I>). <B>Plen~o</B> (<I>da</I>), mouthful. ➞ <I>muzel</I> (of an animal).", "0"],
["butano", "butan-o", "(chem) Butan/e. <B>~olo</B>, -ol, <B>~ono</B>, -one.", "0"],
["Butano", "Butan-o", "BT, Bhutan.", "0"],
["buteo", "bute-o", "(orn) buzzard (<I>Buteo</I>). <B>Vilkrura ~o</B>, rough-legged buzzard.", "0"],
["butero", "buter-o", "[UV] Butter. <I>Vivi kiel kuko en ~o. ~o kokosa, migdala. ~i panon</I>. <B>~igi</B> (<I>lakton</I>), churn. <B>~igilo</B>, churn. <B>~ujo</B>, b-dish, -tub. ➞ <I>butirat, margarin</I>.", "0"],
["buti", "but-i", "(<I>-n</I>) (hort) (cover with) earth, earth up, ridge, tump. <I>~i terpomojn</I>.", "0"],
["butiko", "butik-o", "[UV] (<I>podetala vendejo</I>), Shop. <I>Buter~o</I>, creamery. <B>~aĵoj</B>, shopping, s-goods. <B>~eto</B>, stall. <B>~isto</B>, s-keeper, tradesman. <B>~umi</B>, (nt) do shopping. ➞ <I>bazar, bud, magazen</I>.", "0"],
["butirato", "butir/at-o", "butyrate. <B>-acido</B>, butyric acid.", "0"],
["butlero", "butler-o", "(<I>etym. botelisto</I>), butler, head male servant, especially one in charge of wine-cellar and plate. ➞ <I>vinisto</I> (Ge 41 /9), <I>ĉefservist, kelist, verŝist</I>.", "0"],
["butomo", "butom-o", "flowering rush (<I>Butomus</I>).", "0"],
["butono", "buton-o", "[UV] <B>1</B> Button (disk or knob), <I>~o ĉemiza, ganta, ŝua, vesta. ~o koluma, manuma</I>, collar stud, cuff link. <B>2</B> anything b-shaped, e.g., bell push, door-knob, peg. (harp) peg. (vn) tail-pin. (mar) truck (at masthead). <B>Flor~o</B>, flower-b. similar, unopened mushroom. <B>Prem~o</B>, press- stud, snap-fastener. <B>~umi</B> [OA] <B>(~i)</B>, button up. <B>Mal~(um)i</B>, unbutton.", "0"],
["C", "", "-o [F], letter C. <B>(ac) 523 • 2</B> <I>vibroj sekunde</I>. Meza C, middle C. C-is (C diesa)<B></B>, C sharp. C-be (C bemola), C flat. ➞ <I>kief</I>.", "0"],
["caro", "car-o", "[OA] Czar, Tsar. <B>~ido</B>, -evitch. <B>-idino</B>, -evna. <B>~(edz)ino</B>, -ina.", "0"],
["cebo", "ceb-o", "(<I>kapuĉa simio</I>), capuchin monkey (Cebus).", "0"],
["cecidomio", "cecidomi-o", "gall midge (<I>Cecidomyia) &gt;</I> Hessian fly.", "0"],
["cedi", "ced-i", "[UV] Yield. <B>1</B> (nt) (<I>al, antaŭ</I>), give way (under pressure), succumb: ➞ <I>fleksiĝ, kliniĝ, subiĝ. ~i al deziro, forto, kutimo, peto. ~i al cirkonstancoj. La neĝo ~is sub mia piedo</I>. <B>2</B> give in (way), knuckle under, submit: <I>Ĉio ~is antaŭ ni. Li ~is al nia peto</I>, (gave in to us). <B>3</B> (<I>ke</I>), admit (concede, grant) (that): <I>~u, kaj sciu, ke mi estas Dio</I>. <B>4</B> (<I>-n</I>), assign, cede (grant, make over, transfer) to, part with relinquish, surrender; give up (<I>sidejon). ~i lokon, pretendon, rajton, tronon. Mi volonte ~os la honoron al vi</I>. ➞ <I>abdik, koncesi</I>. <B>~(ad)o</B>, yielding, compliance. <B>~aĵo</B>, concession. <B>~ema</B>, accomodating, amenable, compliant, conciliatory. ➞ <I>mol</I>. <B>~eti</B>, waver. <B>~igi</B>, cause to yield, conquer, overrule, persuade. ➞ <I>fleks, persvad, subig</I>. <B>Inter~i</B>, ➞ <I>kompromis</I>. <B>Mal~i</B>, resist. <I>~~ema</I>, hard, intransigeant, obdurate, resistant, stubborn. <B>Ne~ema</B>, <B>Sen~a</B>, unyielding, firm, insistent. ➞ <I>firm, insist, kontraŭstar, rezist</I>.", "0"],
["cedilo", "cedil-o", "(<I>subkomo, subsigno</I>), cedilla.", "0"],
["cedrato", "", "citron, fruit of <B>~arbo</B> (<I>Citrus medica). Linn</I> Fr. <I>cedrat</I> (larger, less acid, and with thicker skin, than lemon). ➞ <I>citron, limed, limon</I>.", "0"],
["cedrelo", "cedrel-o", "various species of Cedar (<I>Cedrela). ~o odora</I>, Barbadoes (bastard) c.", "0"],
["cedro", "cedr-o", "[UV] Cedar (tree) (<I>Cedrus). ~o Libana</I>, c. of Lebanon, ~a <I>ligno</I>, c-wood. <I>~a trabo</I> (Alt 1/17). ➞ <I>abi, cedrel, juniper, pin</I>.", "0"],
["cefalanto", "cefalant-o", "button-bush (-wood) (<I>Cephalanthus</I>).", "0"],
["cefalofo", "cefalof-o", "duiker (antelope) (<I>Cephalophus</I>).", "0"],
["cefalopodo", "cefalopod-o", "cephalopod. &gt; <I>argonaut, naŭtil, polip, polp, sepi</I>.", "0"],
["cefaloptero", "cefalopter-o", "(<I>ombrela birdo</I>), umbrella bird (<I>Cephalopterus</I>).", "0"],
["cejano", "cejan-o", "[UV] corn-bottle (corn-flower) (<I>Centaurea cyanus</I>).", "0"],
["cekumo", "cekum-o", "caecum, blind gut. ➞ <I>apendic</I>.", "0"],
["celebri", "celebr-i", "(<I>-n</I>), Celebr/ate, <B>1</B> Keep, observe, perform (duly and publicly). <I>ceremonion, datrevenon, sabaton</I>. <B>2</B> Officiate at, solemnize. <I>~i edziĝon, funebron, meson</I>. <B>~(ad)o</B>, -ation. <I>~ado de festo</I> (Jes 30/29). <B>~anto</B>, -ant, officiating priest, etc. ➞ <I>fam, fest, ofic, plenum, solen [Ne= fama]</I>.", "0"],
["celerio", "celeri-o", "[OA] Celery (<I>Apium graveolens</I>). ➞ <I>api</I>. <B>~o rapradika</B>, celeriac, turnip-rooted c.", "0"],
["celesto", "celest-o", "(m.i.) celesta (with steel plates and piano keyboard).", "0"],
["celi", "cel-i", "(<I>-n, -i; ke -u; al</I> Jes 60/9, <I>kontraŭ</I> Ps 35/4) [UV] (<I>strebi al</I>), (take) Aim, direct (point) at; aim at getting, design (intend, purpose) to, (make an) attempt to, have in view, make (strive) for. <I>~i Bristolon, feliĉon, paseron, justecon</I> (Jes 1/17). <I>~i malsame</I>, be at cross purposes. <I>~i anseron, trafi aeron. Kion vi ~as?</I> What are you driving at? <I>Ĉu tio ~as min?</I> Does that mean (is that intended for) me? <I>~i profiti (=profiton, al profito). ~i, ke io okazu</I>. <B>~a</B>, pointed. ~e <I>dirite</I>, said with a purpose. <B>~o</B>, aim (in view), design, end, goal, objective, purpose. <I>Trafi la ~on</I>, hit the mark, reach the goal, (mar) <B>~anta</B> <I>al</I>, bound for. (<I>Rezulto</I>) <B>~enda</B>, to be aimed at. <B>~igi</B> (<I>aldirekti) pafilon,</I> a., point, present. <B>~(rigard)ilo</B>, <B>~hava</B>, with definite aim. <B>~konforma</B>, fitted for the purpose, <B>-punkto</B>, bull’s eye, white spot, <B>~tabulo (~ataĵo)</B>, butt, target. <B>~truo</B>, (gun) sight, (phot) view-finder. AI<B>~a</B>, conscious. <B>Ekster~a</B>, beside the mark, irrelevant. <B>Fin~o</B>, final goal. <B>Laŭ~a (~taŭga)</B>, adequate, rational, to the point (purpose). <B>Sen~a</B> (<I>vana</I>), aimless, objectless, pointless, purposeless, gratuituous, in the air. <B>Supren~i</B>, aspire, strive upwards. <B>Tiu~e</B>, with that object. ➞ <I>ambici, aspir, direkt, streb</I>.", "0"],
["celofano", "celofan-o", "cellophane.", "0"],
["celtido", "celtid-o", "hack-(sugar-)berry, nettle-tree (<I>Celtis</I>).", "0"],
["celto", "celt-o", "(ant) celt, axe-head.", "0"],
["celulozo", "celuloz-o", "[OA] cellul/ose. <B>~ojdo</B>, -oid.", "0"],
["cembro", "cembr-o", "cembra (or arolla) pine (<I>Pinus cembra</I>). ➞ <I>pin, pini</I>.", "0"],
["cemento", "cement-o", "[UV] cement (wide sense) <B>1</B> (bid) various mixtures of lime and clay, hardened by mixing with water. <I>~o Portlanda</I>. <B>~i</B> <I>trotuaron</I>. <B>2</B> adhesive material used to mend small articles of china, glass, etc. <B>~i</B> (<I>kunglui</I>), c. <B>3 (f)</B> bond of union, link <B>~i</B>, consolidate, strengthen. <I>~i aliancon, amikecon</I>. ➞ <I>beton, cement, lut, mastik, morter, plombaĵ</I>.", "0"],
["cendo", "cend-o", "[OA] (num) cent.", "0"],
["cenotafo", "cenotaf-o", "cenotaph, monument to person buried elsewhere.", "0"],
["censo", "cens-o", "census, official enumeration.", "0"],
["cent", "", "[UV] Cent- (Hundred). <B>~o</B>, century (cricket, etc.). <B>~oj</B> <I>da</I>, hundreds of. <B>~estro</B>, centurion, <B>~obla</B>, h-fold. <B>~oble</B>, a h. times (multiplication). <B>~ono</B>, 1/100. <I>~ona</I>, centesimal. <B>~ope</B>, in (by) hundreds. <B>~foje</B>, a h. times (repetition). <B>~funto</B>, c-al. <B>~jara</B>, centenary. <I>~~a datreveno, festo</I>. <B>~~ulo</B>, centenarian. (<I>Ĉiu)~jara</I>, centennial. <B>El~o, Pro~o</B>, per cent. <B>Jar~o</B> (e. w. <I>~jaro</I>), century (100-year period). <I>La</I> 20<I>-a jar~o. La mezaj jar~oj</I>, the middle ages.", "0"],
["centaŭreo", "centaŭre-o", "knapweed, star thistle (<I>Centaurea</I>). <B>Granda ~o</B>, Gtr. k. (C. <I>scabiosa</I>). <B>Nigra ~o</B>, black k., hard-head. ➞ <I>cejan</I>.", "0"],
["centaŭrio", "centaŭri-o", "(bot) centaury (<I>Centaurium</I>).", "0"],
["centaŭro", "centaŭr-o", "(as, myth) centaur.", "0"],
["centavo", "centav-o", "(num) centavo.", "0"],
["centi", "centi-", "(ppfx), centi-.", "0"],
["centigrada", "centigrad-a", "centigrade.", "0"],
["centigramo", "centigram-o", "[OA] centigram.", "0"],
["centilitro", "centilitr-o", "[OA] centilitre.", "0"],
["centimetro", "centimetr-o", "[OA] centimeter.", "0"],
["centimo", "centim-o", "[UV] (num) centime, centimo.", "0"],
["centipedo", "centiped-o", "(<I>centpiedulo</I>), centipede.", "0"],
["centralizi", "centraliz-i", "[OA] (<I>centrigi</I>) (<I>-n</I>), Centraliz/e, unite in (relate to) a centre. <B>~o</B>, -ation. <B>~iĝi</B>, be -ed. <B>Mal~i</B> (<I>decentrigi</I>), de-c. ➞ <I>feder, organiz, unuecig</I>.", "0"],
["centralo", "central-o", "(<I>centrejo</I>), centre, central station, generating station, telephone exchange, etc.", "0"],
["centranto", "centrant-o", "(bot) red valerian (<I>Centranthus ruber</I>). ➞ <I>valerian</I>.", "0"],
["centrifuga", "centrifug-a", "(<I>decentra</I>), centrifugal. <I>~a forto, maŝino, pumpilo</I>. (bot) <I>~a infloresko</I>. ➞ <I>racem</I>.", "0"],
["centripeta", "centripet-a", "(<I>elcentra</I>), centripetal.", "0"],
["centro", "centr-o", "[F] (<I>mezpunkto</I>), Centr/e, Middle. <B>1</B> (geom) <I>~o de cirklo, rado</I>. (opt) ~o <I>de lenso</I>. <B>2</B> (pol) c., m-party. <B>3</B> (<I>~a punkto</I>), central point. <I>~o de komerco, movado, ribelo, urbo</I>. <B>~a</B>, central, middle, c., adjust. <B>C~-Afriko</B> CF. <B>~ismo</B>, -alism. <B>Ekster~a</B>, (mec) eccentric. ➞ <I>ekscentrik</I>. <B>Mal~i</B>, decentre, put out of c. (true). <B>Pez~o</B>, c. of gravity. <B>Sam~a</B>, concentric. <B>Ŝtorm~o</B> ➞ <I>central(iz), centrifug, centripet, ĉef, fokus, koncentr, nukle</I>.", "0"],
["cenzuri", "cenzur-i", "(<I>-n</I>) [OA], Censor (books, papers, etc.), officialy inspect (suppress or pass). <B>~o</B>, -ship. <B>~i</B>, c. <B>~isto</B>, censor. <I>Drama (filma) ~isto</I>.", "0"],
["cepo", "cep-o", "onion (<I>Allium cepum</I>). ➞ <I>bulb</I>.", "0"],
["cepolo", "cepol-o", "bandfish (<I>Cepola</I>).", "0"],
["cerambiko", "cerambik-o", "longhorn beetle (<I>Cerambix</I>). If At 2 FA 103/1 mistakenly used instead of <I>kokcinelo</I> (BE Nov. 1945).", "0"],
["ceramiko", "ceramik-o", "[OA] ceramics, art of pottery, <B>~a</B>, ceramic. <I>~a industrio</I>. <B>~aĵo</B>, <B>~isto.</B>", "0"],
["cerastio", "cerasti-o", "(<I>musorelo</I>), mouse-ear (<I>Cerastium) &gt; snow-in-summer (C. tomentosum</I>).", "0"],
["cerasto", "cerast-o", "horned viper (<I>Cerastes</I>). (Ge 49/17).", "0"],
["ceratofilo", "ceratofil-o", "(bot) hornwort (<I>Ceratophyllum</I>).", "0"],
["ceratonio", "ceratoni-o", "<B>(</B><I>Ceratonia</I>), locust bean (ordinary language <I>karobarbo</I>).", "0"],
["cerbo", "cerb-o", "[UV] Brain. <B>1</B> (anat) <B>Granda ~o</B>, cerebrum, <B>f</B> <I>Tiu vino iras al la ~o</I>, goes to one’s head. 2 <B>f</B> brains, head, intellect, mind. <I>Lia ~o iris promeni</I>, his mind wandered, he was wool-gathering. <I>Venis al mi en la ~on, ke</I>, It occurred to me that, <B>f Osta ~o</B> (<I>medolo</I>), marrow. <B>~a</B> cerebral, mental, intellectual. <I>~a malsano</I>. mental disorder. <I>~a febro, inflamo,</I> b-fever. <B>~eco</B>, mentality, quality of mind. <B>~eto</B> (<I>cerebelo</I>), cerebellum. <B>~oza</B>, brainy. <B>~ujo</B> (<I>kranio</I>), b-pan, cranium. <B>~ularo</B>, “brains-trust”. <B>~umi</B>, (nt) rack (use) one’s bb, brood, cerebrate, ruminate. <I>Ne valoras ~umi pri tio</I>. <B>~ospina</B>, cerebrospinal. <B>En~igi</B> (<I>-n</I>), get into one’s head. <B>Sen~a</B>, brainless, henwitted. <I>~~ulo</I>, empty-head, imbecile, noodle. <B>Klar~a</B>, clear-headed. ➞ <I>malsaĝ</I>.", "0"],
["cerciso", "cercis-o", "Judas tree (<I>Cercis</I>). ~o <I>Kanada,</I> redbud.", "0"],
["cerealoj", "cereal-oj", "cereals, edible grain (grass or seed). <I>~aj leĝoj</I>, corn laws.", "0"],
["cerefolio", "", "garden chervil (<I>Anthriscus cerefolium</I>). ➞ <I>antrisk, kerofil</I>.", "0"],
["ceremonio", "ceremoni-o", "[OA] Ceremon/y. <B>1</B> outward rite or observance. <B>2</B> usage of courtesy or civility. <B>3</B> form(ality). <I>Fari ~ojn,</I> stand on c., insist on punctilious observance, e.g., <I>Lasu la ~ojn. Edziĝa, funebra ~o</I>, <B>~a</B>, ceremonial, formal. <I>~a vesto,</I> full dress. <I>~a vizito</I>, formal call. <B>~aĵo</B>, <B>~aro</B>, -ial, etiquette, ritual. <B>~ema</B>, -ious, <B>~estro</B>, M.C. <B>~ismo</B>, -ialism. <B>~ulo</B>, -ialist. <B>Mal~a</B>, <B>Sen~a</B>, un-ious, familiar, simple. <I>Sen~a vizito</I>. ➞ <I>familiar, simpl</I>. ➞ <I>etiket, form(al), konvenci, liturgi, rit, solen</I>.", "0"],
["cerezino", "cerezin-o", "ceresin wax.", "0"],
["cerio", "ceri-o", "(chem) cerium (Ce) Combining form Cer-.", "0"],
["cerkopitekoj", "cerkopitek-oj", "guenons &gt; Diana and other monkeys (<I>Cercopithecus</I>).", "0"],
["cerkopo", "cerkop-o", "(<I>ŝaŭmcikado</I>), froth fly, cuckoo spit, froghopper (<I>Cerkopis</I>).", "0"],
["certa", "cert-a", "[UV] Certain, Sure. <B>1</B> (<I>pri iu, (nedubanta</I>), confident, convinced (of, that), positive. <I>Mi estas ~a (ke, pri</I>), <B>2</B> (<I>pri io) (nedubebla</I>). (a) Indisputable, infallible, reliable, safe, settled, unquestionable. <I>~a novaĵo, pruvo, rimedo</I>. (b) sure to happen, assured, unfailing. <I>~a sukceso. Estas</I> <B>~e</B>, <I>ke</I>. ➞ <I>definitiv, tiepr, pozitiv</I>. [<B>3</B> “a certain” (indefinite). Z., and international, but better avoided, as highly ambiguous; e.g., <I>~a aŭtoritato, pozicio, salajro, signifo (= nedubebla? iu?</I>) Better use <I>unu, ia, iu, kelka, ioma, iom da</I>.] <B>~e</B>, certainly, surely, for c., etc. (In answer): No doubt, Yes, That is so.<I> <B>~e</B>, kiel duoble du kvar</I>, as sure as 2 2’s are 4. <B>~aĵo</B>, sure thing, certainty. <B>~eco</B>, certainty, certitude, conviction. <I>~eca (aplomba, memcerta</I>), assured, positive, safe. <B>~ega</B>, s. and c., inevitable. <B>~igi</B> [UV] (<I>ion al iu, iun pri io, ke</I>). <B>1</B> (<I>atesti</I>), attest, certify, formally declare; from which <B>2</B> (<I>garantio</I>) make certain, assure, establish, secure. ➞ <I>asekur</I>. <B>~igo</B>, assurance. <B>~iĝi</B> (<I>pri</I>), make sure, ascertain (l Rĝ 20/33) <B>Mal~a</B>, <B>Ne~a</B> (<I>duba</I>), doubtful, dubious, uncertain, precarious, problematic, shaky. <B>Mal~e</B> (<I>apenaŭ</I>), with difficulty, hardly; doubtfully.", "0"],
["certio", "certi-o", "(<I>arbogrimpulo</I>), (orn) tree creeper (<I>Certhia</I>).", "0"],
["cerumeno", "cerumen-o", "(<I>orelvakso</I>), cerumen, ear-wax.", "0"],
["ceruzo", "ceruz-o", "(<I>plumba blankaĵo</I>), white lead; white flake white.", "0"],
["cerviko", "cervik-o", "(<I>kolo</I>), (anat, tech), cervix, narrow part, neck. <I>~o utera</I>. (ent) cervicum. <B>~a</B>, cervical. <I>~a vertebro</I>.", "0"],
["cervo", "cerv-o", "[UV] Deer (<I>Cervus</I>) <B>Kanada ~o</B>, wapiti, (Am) elk. <B>Moska ~o</B>, musk-d. <B>norda ~o</B> [UV] (<I>boaco</I>), rein-d. <B>Ruĝa ~o</B>, red d. (C. <I>elaphus</I>). <B>~a</B>, cervine. <I>~a parko,</I> d-park. <B>~aĵo</B>, venison. <B>~(kuŝ)ejo</B>, form. <B>~ido</B>, fawn. <B>~ino</B>, hind (Se 5/19). <B>~bleki</B>, troat. <B>~kolora</B>, fawn-colored, dark tawny. <B>~korn(aĵ)o</B>. hart’s horn. <B>Vir~o</B>, hart, stag. ➞ <I>aksis, alk, dama, kapreol, muntjak; hund, skarab</I>.", "0"],
["cesabro", "cesabr-o", "[UV] cinnabar, red mercuric sulphide (HgS), (min) mercury ore. <B>~(ruĝ)a</B>, vermillion. ➞ <I>vermiljon</I>.", "0"],
["cestodo", "cestod-o", "(<I>rubanda vermo</I>), tape-worm, etc. (<I>Cestoda) &gt; teni</I>.", "0"],
["cetacoj", "cetac-oj", "<I>cetacea &gt; balenoj, delfenoj, fokenoj</I>.", "0"],
["cetera", "ceter-a", "[UV] (<I>ĉiu alia, tio restanta; ankoraŭ ne menciita</I>), other, remaing, remainder. <I>La ~a historio</I> (IRĝ 15/7). <I>La ~aj</I>, the others, rest (of them left over). <B>Kaj ~e (~aj)</B> (k.c.), <I>et cetera</I>, and the rest, and so on. <B>~e</B>, as for the rest, besides, for the matter of that, however, in other respects. <B>~o</B>, rest, remainder. <I>Faru vian aferon, Dio zorgos ~on</I>. <B>~aĵoj</B>, extras, other things. ➞ <I>ali, krom, plu</I>.", "0"],
["ceterako", "ceterak-o", "rusty-back fern (<I>Ceterach</I>).", "0"],
["cetonio", "cetoni-o", "rose beetle, rose chafer (<I>Cetonia</I>).", "0"],
["cetrario", "cetrari-o", "(<I>Islanda musko</I>), cetraria lichen, Iceland moss. Vd <I>karagen</I>.", "0"],
["cezio", "cezi-o", "(chem) caesium (Cs).", "0"],
["cezuro", "cezur-o", "(pros) caesura, break in line.", "0"],
["ci", "", "(pron), [UV] thou. <I>Al</I> to thee. <I>Mi ~n amas</I>, I love thee. <B>~a</B>, thy. <B>~diri</B>, say “thou”. <B>Rim</B>.: The use of <I>ci</I> denotes affection, intimacy.", "0"],
["cianeo", "ciane-o", "(zoo) cyanea medusa (<I>Cyanea</I>).", "0"],
["ciano", "cian-o", "Cyan/ogen (C<SUB>2</SUB>N<SUB>2</SUB>). <B>~atacido</B>, -ic acid (HCNO). <B>-idacido</B>, Prussic (hydrocyanic) acid (HCN). <I>Kalia</I> <B>~ido</B>, potassium -ide (KCN). <B>~ozo</B>, (med) -osis, blue jaundice.", "0"],
["cibernetiko", "cibernetik-o", "(ph) cybernetics.", "0"],
["cibeto", "cibet-o", "civet (substance), from <B>~kato</B>, civet (cat) (<I>Viverra</I>). <B>~kato Afrika</B>, African c. <B>~kato Hinda</B>, Indian c., zibeth. ➞ <I>genot</I>.", "0"],
["ciborio", "cibori-o", "(<I>hostia vazo</I>), ciborium, pyx.", "0"],
["cicero", "cicer-o", "(typ) pica, 12-point type. ➞ <I>kiker</I>.", "0"],
["cicindelo", "cicindel-o", "tiger beetle (<I>Cicendela</I>).", "0"],
["cidaro", "cidar-o", "<B>1</B> tiara (of Persian king). <B>2</B> turban (of high priest) (Le 8/9, Jeĥ 21/26). ➞ <I>mitr</I>. <B>3</B> (zoo) genus of sea-urchins (<I>Cidaris</I>).", "0"],
["cidonio", "cidoni-o", "[OA] quince, fruit of <B>~arbo</B>, q-tree (Cydonia).", "0"],
["cidro", "cidr-o", "[OA] (<I>pomvino</I>), cyder. ➞ <I>pirvin</I>.", "0"],
["cifero", "cifer-o", "[UV] (<I>nombrosigno</I>), Figure; cypher, digit, numeral, numerical symbol, <B>f</B> number. <I>Atingi altan ~on</I>. <B>~a</B> <I>notacio</I> (mus) f-notation. <B>~i</B>, calculate, reckon, number (<I>paĝojn</I>), page (<I>libron</I>), work out (<I>kvanton</I>). (mus) <B>~ita</B> <I>baso</I>, -ed bass. <B>Kvar~a</B> <I>nombro</I>. <B>Rond-e</B>, roughly. ➞ <I>figur, numer(al), nombr, nul, plat</I>.", "0"],
["cigano", "cigan-o", "[OA] Gypsy, romany. <B>~a</B> <I>lingvo</I>. <B>~ino</B>, g-woman. ➞ <I>nomad</I>.", "0"],
["cigaredo", "cigared-o", "[UV] Cigarette, <B>-ingo</B>, c-holder <B>~ujo</B>, c-case.", "0"],
["cigaro", "cigar-o", "[UV] Cigar. <I>~o forta</I>, strong c. <B>~eto</B>, small c. <B>~ingo</B>, c- holder. <B>~ujo</B>, [UV] c-case. ➞ <I>cigared</I>.", "0"],
["cigno", "cign-o", "[UV] Swan (<I>Cygnus</I>). <B>Kanta ~o</B>, whooper s. <B>Malgranda kant~o</B>, Bewick’s s. <B>Nigra ~o</B>, black s. <B>Tubera ~o</B>, mute s. <B>~a</B> <I>kanto</I>, s- song, <B>f</B> last work. <I>~a markado,</I> s-upping. <B>~ejo</B>, -nery. <B>~ido</B>, cygnet. <B>~ino</B>, pen-s. Vir<B>~o</B>, cob-s.", "0"],
["cikado", "cikad-o", "[OA] cicada. <B>Ŝaŭm~o</B>, vd. <I>cerkop</I>. ➞ <I>akrid, gril, lokust</I>.", "0"],
["cikaso (", "cikas-o (", "<I>saguarbo</I>), cycad, sago palm (Cycas).", "0"],
["cikatro", "cikatr-o", "[UV] (bot, med) Scar, cicatrice. <B>~iĝi</B>, close (of wound), form a crust (skin) over, heal up. <B>~oplena</B>, -red.", "0"],
["ciklameno", "ciklamen-o", "sow-bread (Cyclamen).", "1"],
["ciklo", "cikl-o", "[OA] (<I>periodo, rondiro</I>), Cycl/e (wide sense) (as, el, hist, mat, lit). <B>1</B> Recurrent period (round, series) of events (phenomena). <I>~o de festoj</I> (Jes 29/1), <I>de eklips-(poem -sezon-)oj, de la jaro. Luna ~o</I>. <B>2</B> (chem) ring. <B>~a</B> (<I>ringa</I>). -ic. ➞ <I>rond, seri. <B>3</B> (velocipedo)-, bi~(motor~ tri~)o</I>. <B>~i</B>, (bi)-cycle. <B>~ismo</B>, -ing. <B>~isto</B>, -ist. <B>~ometro</B>, -ometer. <B>~ojdo</B>, -oid.", "0"],
["ciklono", "ciklon-o", "[OA] Cyclone. <B>1</B> (<I>turnventego, kirla uragano), whirlwind</I>. ➞ <I>tifon, tornad, uragan</I>. 2 (met) (<I>depresio) (malaltprema sistemo kun maldekstrena aercirkulado). <B>Anti~o</B>, anti-c</I>.", "0"],
["ciklopo", "ciklop-o", "[OA] <B>1</B> (myth) Cyclop/s. <B>~a</B>, -ean, gigantic. <B>2</B> (zoo) cyclops, water-flea (<I>Cyclops</I>).", "0"],
["ciklostilo", "ciklostil-o", "cyclostyle, duplicator, <B>ciklotron-o</B>, (ph) cyclotron.", "0"],
["cikonio", "cikoni-o", "[UV] Stork (<I>Ciconia</I>). <B>~o blank- (nigr-)a</B>, white (black) s. <B>~a</B>, ciconian. ➞ <I>arde, leptopil, marabu, skop</I>.", "0"],
["cikorio", "cikori-o", "[UV] succory. (<I>Cichorium intybus</I>). The bleached head of <I>C.i. var</I>. <B>is</B> English \"chicory\" (Fr \"endive\"). Its roasted rts are mixed with coffee. ➞ <I>endivi</I>.", "0"],
["cikuto", "cikut-o", "[OA] cowbane, water hemlock (<I>Cikuta</I>). ➞ <I>enant, koni</I>.", "0"],
["cilindro", "cilindr-o", "[OA] <B>1</B> (geom) Cylind/er, drum. <B>2</B> similar object., e.g., barrel of pump or revolver. <I>Lampaiyitra) ~o</I>, lampglass. (eng) piston c. <I>Du~a motoro</I>. <B>~a. (~oforma)</B>. -rical. <B>~a ĉapelo</B>, top-hat <B>~a lagro</B>, roller bearing. <B>~a presilo</B>, c- press. <B>~ojdo</B>, cylindroid. <B>Prem~o</B>, <B>rul~o</B>, barrel, roller, etc. e.g., of barrel-organ, clockwork (2 FA 29/7), mangle, roll-top desk, steam (garden) roller, typewriter. <B>Pres~o</B>, printer’s drum. ➞ <I>barel, tambur, tub</I>.", "0"],
["cilio", "cili-o", "(bot) (zoo), Cili/um, hair-like filament, barbicel (of feather, etc.). <B>~oj</B>, cilia. <B>~a</B>, -ary. <I>~a ganglio</I>. <B>~ohava</B>, <B>~oza</B>, -ated. ➞ <I>fiagel</I>. <B>Rim</B>.: For \"eyelashes\" use <I>okulharoj</I>.", "0"],
["cimatio", "cimati-o", "(arch), <B>1</B> cyma, moulding with double continuous curve. <I>~o inversa,</I> ogee moulding. <B>2</B> picture rail. <I>Lokita sur la ~o</I>, hung \"on the line\".", "0"],
["cimbalario", "cimbalari-o", "(<I>linario hedera</I>), ivy-leaved toadflax, mother-of-thousands. (<I>Linaria cymbalaria</I>).", "0"],
["cimbalo", "cimbal-o", "[UV] (m.i.) cymbal (Ps 150/5).", "0"],
["cimicifugo", "cimicifug-o", "bug-wort, snake-root. Ŝ", "0"],
["cimo", "cim-o", "[UV] bed bug (<I>Cimex</I>).", "0"],
["cinamo", "cinam-o", "[UV] Cinnamon, bark of <B>~arbo</B> (<I>Cinnamomum). ~o Cejlona, kasia</I>, etc. <B>~kolora</B> (<I>flavbruna</I>), c-colored. <B>~oleo</B>.", "0"],
["cindro", "cindr-o", "[UV] Cinder(s), Ash(es), slag. <I>~o karba(ligna</I>) (El 9/10). <I>Kunfandita ~o,</I> clinker, <B>f</B> remains of the departed. <I>Paco al lia ~o!</I> <B>~a</B>, ashen, cinerary. <I>~a merkredo</I>, Ash Wednesday. <I>~a vojeto,</I> c-path. <B>~ogriza</B>, <B>~okolora</B>, ashen-gray, cinerous. <B>~ejo</B> (Le 1/16), place for aa. <B>~ero</B>, c. <B>~igi</B> (<I>forbruligi</I>), reduce to (lay in) aa., calcine, incinerate. <I>~igi</I> (cremate) <I>kadavron</I>. ➞ <I>kremaci</I>. <B>~igejo</B>, crematorium. <B>~ujo</B>, <B>~kesto</B>, <B>~otelero</B>, a-box (-hole-pan-pit-tray), c-bin, dust-bin. <B>~ulino</B>, Cinderella. ➞ <I>ardaf, urn</I>.", "0"],
["cinerario", "cinerari-o", "(bot) cineraria.", "0"],
["ciniko", "cinik-o", "[OA] (phi) Cynic; from which <B>~a</B>, -al. <B>1</B> sarcastically incredulous of sincerity or goodness of human motives, sneering. <B>2</B> barefaced, brazen, impudent, indecent, shameless, unblushing. <B>~eco, ~ismo</B>, -ism. <B>1</B> contempt for what others value. <B>2</B> effrontery, shamelessness. <B>~ulo</B>, -al person., sneering fault-finder. IT <B>1</B> is the English usage, <B>2</B> the French.", "0"],
["cinipo", "cinip-o", "(<I>gajlinsekto</I>), gall-wasp (<I>Cynips</I>).", "0"],
["cinklo", "cinkl-o", "(orn) (<I>akvomerlo</I>), dipper (<I>Cinclus</I>).", "0"],
["cinodonto", "cinodont-o", "(<I>hunda dento</I>), dog’s-tooth (Bermuda, creeping finger) grass (<I>Cyno- don</I>). ➞ <I>agropir</I>.", "0"],
["cinogloso", "cinoglos-o", "(<I>hunda lango</I>), houndstongue (Cynoglossum).", "0"],
["cinozuro", "cinozur-o", "(<I>hunda vosto</I>), dogstail grass (<I>Cynosurus</I>).", "0"],
["cipero", "ciper-o", "galingale (sedge) (<I>Cyperus</I>). ➞ <I>papirus</I>.", "0"],
["cipo", "cip-o", "(ant) cippus, inscribed pillar or gravestone.", "0"],
["ciprenoj", "cipren-oj", "(ich) carp fam. (<I>Ciprinidae) &gt; alburn, barbfiŝ, bram, foksen, gobi, karas, karp, leŭcisk, rutel, skardini, tink</I>.", "0"],
["cipreo", "cipre-o", "Cowry (<I>Cypraea). ~a konko (kaŭrio, monkonko), c-shell</I>.", "0"],
["cipreso", "cipres-o", "[UV] Cypress (<I>Cupressus) (Jes 41/19). ~o funebra. <B>~a</B> ligno. Vd cug, eŭforbi</I>.", "0"],
["cipripedio", "cipripedi-o", "(<I>Venusa ŝuo</I>), Lady’s slipper (orchid) (<I>Cypripedium</I>).", "0"],
["circeo", "circe-o", "(bot) enchanter’s nightshade (<I>&lt;Circaea</I>).", "0"],
["ciripedoj", "ciriped-oj", "(zoo) cirripeds, barnacles (<I>Cirri- pedia) &gt; balan, lepad</I>.", "0"],
["cirkelo", "cirkel-o", "[UV] (pair of) Compass(es) (Jes 44/13). <B>1 Desegna ~o</B> (<I>cirklilo</I>) (to draw circles). 2 <B>Kalibra (mezura) ~o</B>, dividers, caliper(s). <B>Proporcia (redukta) ~o</B>, Proportional cc. <B>Risorta ~o</B>, spring-bow cc. <B>Stanga ~o</B>, beam cc., trammels. draw (measure) with cc. <B>~ujo</B>, c-box. ➞ <I>kompas</I>.", "0"],
["cirklo", "cirkl-o", "(ordinary language <I>rondo</I>), (geom) Circ/le, round; outer rim (felloe) of wheel. <I>Stari en ~o. ~o (ant)arkta, polusa. ~o de longitudo</I>. <B>f</B> <I>~o de devoj</I>. (log) <I>Rezona ~o,</I> vicious c. (mus) <I>~o de kvintoj</I>, c. of 5ths. (keys). (<B>Ne)-ĉef-a</B> <I>~o</I>, great (small) c. <B>~a</B>, -ular, round. <B>En~iga</B> <I>politiko</I>, policy of encirclement. <B>Duon~a</B>, semi-ular. Vd <I>ring; ekvator, ekliptik; eikl, orbit</I>.", "0"],
["cirko", "cirk-o", "[OA] Circus. <B>1</B> show of acrobats, animals, clowns, etc. <B>~isto</B>, c-performer. <B>2</B> circular open space in town, with streets converging on it.", "0"],
["cirkonferenco", "cirkonferenc-o", "circumference (of circle, sphere), encompassing boundary, girth (of tree). ➞ <I>perimetr</I>.", "0"],
["cirkonstanco", "cirkonstanc-o", "[UV] Circumstan/ce, case, fact, incident (cause, place, manner, surroundings, time, of each occurrance). <I>~o favora, klariga, kompensa, neatendita</I>. <B>~oj</B>, <B>~aro</B>, cc., conditions, conjuncture, situation, state of things. <I>Profiti</I> (make the most of) <I>la ~ojn. Tio dependas de la ~oj. Sub tiaj ~oj</I>. <B>~a</B>, -tial. <I>~a atesto</I>. <B>Laŭ~e</B>, <B>pro~e</B>, according to (by reason of) cc., as the case may be. ➞ <I>aferstat, detal, konjunktur, medi, situaei</I>.", "0"],
["cirkulero", "cirkuler-o", "[UV] Circular (letter, notice). <B>~izi</B> <I>iun</I>, -ize, send cc. to.", "0"],
["cirkuli", "cirkul-i", "[OA] (<I>nt</I>). <B>1</B> (<I>rondiri</I>), Circul/ate, flow (go, move) round, get about, e.g., <I>famo en mondo, gazeto en legrondo, sango en vejnoj, vino sur tablo</I>. <B>2</B> (<I>rondiri kaj reveni</I>), come and go, move. <I>Mono (trafiko) ~as</I>. <B>3</B> Spread (<I>pasi de unu al alia), Epidemio, famo, onidiro ~as</I>. <B>~a</B>. -atory. <I>~a pumpilo, sistemo</I>. <B>~(ad)o</B>, -ation, distribute (books, etc). <I>~ado atmosfera, sanga. Retiri el ~ado,</I> call in, withdraw from -ation. <I>Rakontoj, kiuj ~adas</I> (4 FA 37/12). <B>~anta</B> <I>biblioteko</I>. <B>~igi</B> (<I>-n</I>), c., give currency to, put into action, send round. <I>~igi aeron, novaĵon</I>.", "0"],
["cirkumcidi", "cirkumcid-i", "Circumcis/e (Jos 5/3). <B>Ne~ita</B>, un -ed.", "0"],
["cirkumflekso", "cirkumfleks-o", "[OA] (<I>ĉapelo, tegmenta supersigno</I>), circumflex (accent) (‘).", "0"],
["cirkuo", "cirku-o", "(orn) Harrier (<I>Circus</I>). <B>Blua ~o</B>, hen h. <B>Cindra ~o</B>, Montagu’s h. <B>Marĉa ~o</B>, marsh h. <B>Stepa ~o</B>, pallid h.", "0"],
["cirkvito", "cirkvit-o", "(<I>flurondo</I>), (el) Circuit, path of current. <B>Elektra ~o</B>, electric c. <B>Indukta ~o</B>, inductive c. <B>Magneta ~o</B>, magnetic c. <B>Mallonga ~o</B>, short c. <B>Terkonekta ~o</B>, earthed c. <I>Fermi ~on</I>, close a c. <B>f</B> (<I>rondiro) (de io, de iu), e.g., of Methodist minister</I>. ➞ <I>komut, konekt, kontakt, kupl, rond</I>.", "0"],
["ciro", "cir-o", "[UV] polishing wax (for floor, leather, etc.) blacking, polish (for shoes), waxing (for thread). <B>Mebla ~o</B> (<I>polura pasto</I>), furniture polish, <B>~i</B>, beeswax (floor), black, polish (shoes). <B>~ita</B> <I>tolo,</I> oil cloth. <B>(Ŝu)~isto</B>, shoe-black. <B>~broso</B>, <B>~tuko</B>.", "0"],
["cirozo", "ciroz-o", "(<I>kronika hepatinflamo</I>), cirrhosis.", "0"],
["cirsio", "cirsi-o", "(plume-)Thistle (<I>Cirsium</I>). <B>Gren- kampa ~o</B>, corn or creeping t. <B>Lanca ~o</B>, spear t. <B>Marĉa ~o</B>, marsh t. <B>Sentiga ~o</B>, dwarf or ground t.", "0"],
["ciruso", "cirus-o", "(<I>plumnuboj</I>), (met) cirrus, mare’s tail, feathery (streaky) cloud. ➞ <I>ĉir, kumulus, stratus</I>.", "0"],
["cis", "cis-", "(<I>maltrans, ĉi-flanke de</I>), (pfx) = on this side of. <B>~alpa</B>, <B>~atlanta</B>, <B>~monta</B>.", "0"],
["cisterno", "cistern-o", "[OA] (<I>pluvujo, rezervujo</I>), cistern, reservoir, tank (Se 5/15). <I>~a ŝipo</I>, tanker<I>. ~a vagono,</I> tank-car.", "0"],
["cisto", "cist-o", "(bot) rock-rose (<I>Cistus</I>).", "0"],
["cistoptero", "cistopter-o", "(<I>vezika filiko</I>), bladder fern (<I>Cystopteris</I>).", "0"],
["citadelo", "citadel-o", "[OA] citadel, fortress guarding a city.", "0"],
["citelo", "citel-o", "(zoo) souslik (<I>Citellus</I>).", "0"],
["citi", "cit-i", "(<I>-n</I>),, [UV] <B>1</B> (<I>laŭvorte ripeti</I>), Quot/e, cite. <I>~i vorton, tekston</I>. <B>2</B> (<I>mencii</I>), adduce, (make) mention (of), name. <I>~i ĉiun nomon; kiel ekzemplon; similan fakton. Supre~ita</I>, -ed above, above-mentioned. <B>~ado</B>, quoting. <B>~aĵo</B>, quotation, passage -ed <I>~aĵaro</I>, book of -ations. <B>~ato</B>, person -ed. <B>~iloj</B> (<I>~aj signoj</I>), -ation marks (\"…\"). <B>~inda</B>, notable, worthy of note. <B>Mis~i</B>, mis-q. <B>Prez~o</B>, -ation.", "0"],
["citrato", "citrat-o", "citrate. <B>~acido</B> (<I>citronacido</I>), citric acid.", "0"],
["citro", "citr-o", "[OA] cither, cittern, old m.i. with 4-6 strings or pairs of strings (F. <I>cistre,</I> I <I>citera</I>). ➞ <I>ziter</I>.", "0"],
["citrolo", "citrol-o", "(<I>akvomelono</I>), water melon (<I>Citrullus</I>). ➞ <I>kolocint, kukurb</I>.", "0"],
["citronelo", "citronel-o", "citronelle. Australian “rough lemon”, hybrid lemon. ➞ <I>limon</I>.", "0"],
["citrono", "citron-o", "[OA] In ordinary language this word (like <I>L. Citrus medica</I>) is often used to cover both Citrons and Lemons (<I>Cedratoj</I> and <I>Limonoj</I>). See these words. <B>~flava</B>, lemon yellow. <I>Kandita</I> <B>~ŝelo</B>, candied peel. <B>~premilo</B>, 1-squeezer. ➞ <I>limonad</I>.", "0"],
["citruso", "citrus-o", "(<I>Citrus</I>), generic name for any citrus-fruit &gt; <I>bergamot, cedrat, limed, limon, mandaren, oranĝ,pampelm,pomel</I>, <I>tangel</I>. <B>~o Japana</B>, kumquat (<I>Fortunella japonica</I>).", "0"],
["civila", "civil-a", "[OA] civil (wide sense) <I>[Ne= ĝentila]</I>. <B>1</B> (opp <I>militista</I>); civilian, non-military. <I>~a vesto</I>, civvies, mufti, plain clothes. <I>~a inĝeniero. ~a (interna) milito</I>. <B>2</B> (opposite <I>eklezia): ~a edziĝo</I>. <B>3</B> (<I>civitana</I>), civic, civil, common. <I>~a devo, kod(eks)o, rajto</I>.", "0"],
["civilizi", "civiliz-i", "(<I>-n</I>), [UV] Civiliz/e, bring out of barbarism. <I>~ita mondo</I>. <B>~a</B> (<I>kultura), -ing</I>. <B>~(ad)o</B>, <B>~(it)eco</B>, <B>~acio</B>, [OA] -ation, culture. <B>~ito</B>, -ed being. ➞ <I>klerig, kultur</I>. Opp <I>barbar, sovaĝ</I>.", "0"],
["civito", "civit-o", "city ( = corporate town, commonwealth, state) with pol. rights (Jes 1/26). <B>f</B> <I>=</I> regnanaro, urbanaro. <I>~o de Dio. Ĉiela ~o</I>, heavenly city. <B>~a</B>, civic. <B>~ano</B>, citizen. <I>Brita ~ano. ~ana</I>, civic, common, corporate. <I>~ana devo, rajto, virto. ~aneco</I>, citizenship. ➞ <I>burĝ, metropol</I>.", "1"],
["cizeli", "cizel-i", "(<B>&lt;</B> <I>ĉizi, enstampf</I>), chase, engrave (<I>metalon</I>), emboss, punch (<I>ledori</I>). <B>~ilo</B>, punch, chasing tool, graver. ➞ <I>ĉiz, gravur, patric</I>.", "0"],
["colo", "col-o", "[UV] inch. 12 -oj = <I>futo</I>. <B>f</B> <I>Cedi neniun ~on</I>.", "0"],
["cugo", "cug-o", "hemlock spruce (<I>Tsuga</I>). <B>Pseŭdo~o</B> (<I>duglasio</I>), Douglas fir. (<I>Pseudotsuga</I>).", "0"],
["ĉabrako", "ĉabrak-o", "(<I>selkovro</I>), saddle-cloth.", "0"],
["Ĉado", "Ĉad-o", "TD, Chad.", "0"],
["ĉagreni", "ĉagren-i", "(<I>-n</I>) [UV]. <B>1</B> afflict, distress, grieve, mortify (Ps 78/40). <B>2</B> annoy, chagrin, displease, trouble, ruffle, vex (Jona 4/1). <I>Tio ~as!</I> (4 FA 58/3). <B>~o</B>, grief, sorrow, trouble, vexation (Ij 17/7). <I>Kia ~o! Kiel ~e!</I> How annoying! What a nuisance! <I>Eluzita de ~oj</I>, careworn. <I>Dom-(hejm-)aj ~oj</I>, domestic worries. <B>~a</B>, distressing, galling, sad, vexatious. <B>~e</B>, peevishly, sadly. <B>~aĵo</B>, cross, plague, nuisance, trouble. <B>~eti</B>, tease, worry. <B>~iĝi</B> (<I>senti ~on) (pri</I>), fret, be vexed. <B>~oplena</B>, <B>~ita</B>, doleful, sorrowful, vexed, etc. <B>Sen~a</B>, care-free, jaunty, unconcerned. ➞ <I>aflikt, desapont, dolor, malĝoj, ted</I>.", "0"],
["ĉako", "ĉak-o", "(cl) shako, military cap.", "0"],
["ĉakono", "ĉakon-o", "(Sp dee) chaconne.", "0"],
["ĉambelano", "ĉambelan-o", "[UV] (<I>palaca ĉambristo</I>), chamberlain.", "0"],
["ĉambro", "ĉambr-o", "[UV] <B>1</B> Chamber, Room: (<I>Mai) Antaŭa ~o</I>, front r., ante-c; (back-r.) <I>~o dulita, unulita</I>, Double (single) r. <I>Ban~o, juĝ~o, klas~o, lego~o, manĝo~o</I>. (phot) Malluma <B>~o</B>, dark-r. <B>2</B> Hall used by deliberative body, hence that body: <B>~o de Komerco</B>. (pol) <B>Malsupera ~o</B>, <I>~o de deputitoj</I>, House of Commons, Lower H. <B>Supera ~o</B>, House of Lords. <B>3</B> compartment, space. <I>Aer~o, eksplod~o, pulv~o, vapor~o</I>, <B>Fos ~o</B>, dug-out. <B>~a</B> <I>muziko</I>, c-music. <B>~aĵo</B>, garret, hole, etc. <B>~aro</B>, <B>~oj</B>, (<I>apartamento</I>), cc., set of rooms., flat. <B>~ego</B>, hall, saloon. <B>~eto</B>, attic, cabin, cell, closet (Jĝ 3/20). <B>~isto</B>, valet de chambre. <B>~istino</B>, c-maid. <I>Reĝa ~istino</I>, lady of the c. (in waiting), maid of honour. ➞ <I>korteganin</I>. <B>Lu~ano</B>, lodger. <B>Sam~ano</B>, r-mate. ➞ <I>atendej, hal, kabinet, kamer, kel, mansard, salon, vestibl</I>.", "0"],
["ĉamo", "ĉam-o", "[UV] Chamois, mountain goat (<I>Rupicapra</I>). <B>~(kolor)a</B>, c-coloured. <I>~aj ganto</I>), buff- coloured gloves. <B>~ino</B>, doe. <B>~felo</B>, <B>~ledo</B>, c-skin. <B>Vir~o</B>, buck. ➞ <I>ŝam</I>.", "0"],
["ĉampano", "ĉampan-o", "[UV] (<I>ŝaŭmvino</I>), champagne.", "0"],
["ĉampiono", "ĉampion-o", "Champion. <B>1</B> (<I>porbatalanto</I>). <B>2</B> (<I>majstro, rekordulo, venkinto), ~a boksist-(roz-)o</I>. <B>~eco</B>, -ship.", "0"],
["ĉano", "ĉan-o", "[UV] (<I>frapilo</I>), cock (of gun), lever released by trigger.", "0"],
["ĉantaĝi", "ĉantaĝ-i", "(<I>-n</I>, abs) (<I>postuli per skandal- minaco</I>), Blackmail, extort by threat of exposure. <B>~o</B>, b., extortion. <B>~isto</B>, -er.", "0"],
["ĉanto", "ĉant-o", "(mus) Chant, melody-form for psalms and canticles. <B>~o anglikana</B>, anglican c. <B>~(ad)o Gregoria</B> (<I>=plejn- kanto</I>), Gregorian c., plainsong. <B>~i</B>, (sing to a) c.", "0"],
["ĉapelo", "ĉapel-o", "[UV] <B>1</B> Hat, bonnet (headgear with brim). <I>Depreni, levi, surlasi, surmeti ~on. Saluti per ~o. ~ojn for!</I> Hats off! <B>Bul~o</B>, billicock, bowler. <B>Cilindra ~o</B>, high (top) hat. <B>Kardinala ~o. Klak~o</B>, collapsible hat. <B>Sun~o</B>, sunbonnet. <B>2</B> cover, lid. <I>~ita litero</I> (ĉ ĝ ĥ ĵ ŝ). (fac) <B>~ino</B>, <B>(in~o)</B> (<I>= virina ~o</I>), woman’s hat. <B>~faristo</B>, <B>~vendisto</B>, -ter. <B>~istino</B>, milliner. ➞ <I>modistin</I>. <B>~ujo</B>, h-box. <B>Sen~a</B>, h-less. ➞ <I>kask, kep, kuf, turban</I>.", "0"],
["ĉapitro", "ĉapitr-o", "[UV] chapter (of book or treatise).", "0"],
["ĉapo", "ĉap-o", "[UV] <B>1</B> Cap, brimless headgear, toque, etc. <B>Dorma (nokta) ~o</B>, night-c. <B>Fald~o</B>, forage-c. <B>Fel~(pelt~)o</B>, fur-c. <B>Verta ~o</B>, scull-c. <B>Skota ~o</B>, Scottish bonnet, tam-o-shanter. <B>2</B> special headdress denotes membership of. <I>~o kolegia, kriketa, milita, polica</I>. <B>3</B> c-like covering. ~o agarika, genua. <B>4</B> Similar added object., cap (<I>de fontplumo, nabo, tubo, valvo</I>); capsule (seal) <I>de botelo</I>. (phot) <B>Fermo~o</B>. ➞ <I>fermilo, kovrilo, ŝtopilo; ĉapel, fez, kasked</I>.", "0"],
["ĉar", "", "(conj), [UV] (weak form of <I>tial, ke; pro tio, ke</I>), Because, for, seeing <B>that</B>, since, whereas. <I>Ŝi ploris, ~ li ne venis. ~ se</I>, for if. <I>~ tio estas</I>, that being so.", "0"],
["ĉardaso", "ĉardas-o", "czardas, Hungarian dee.", "0"],
["ĉarlatano", "ĉarlatan-o", "[UV] Quack, Charlatan, ignorant pretender to knowledge or skill, pretentious impostor. <B>~i</B>, gull, <B>~aĵo</B>, q-ery, humbug. <B>~eco</B>, <B>~ismo</B>, c-ism. <B>~reklamo</B>, patter, puff. ➞ <I>blag, tromp</I>.", "0"],
["ĉarma", "ĉarm-a", "[UV] Charm/ing, agreeable, attractive, delightful, graceful, fascinating, nice, pleasant, pleasing, taking, winsome. <I>~a kamparo, rakonto, maniero, virino, voĉo</I>. <B>El tio ĝia ~o</B>, That is the beauty of it. <B>~o</B>, c., allure, attraction -ivness, fascination, glamour, spell. <B>Esti sub la ~o de</B>, be spellbound by. <I>La ~oj</I> (seductiveness) <I>de bela virino</I>. <B>~e</B>, delightfully. <B>~i</B>, c., bewitch, captivate, delight, fascinate, give pleasure, influence as by magic, please. <I>~i</I> (appeal to) <I>la imagon</I>. <B>Esti ~ata</B>, be delighted. <B>~aĵo</B> (PI 1/7). <B>~ega</B>, adorable, bewitching, enchanting, exquisite. <I>Serpent~isto</I>, snake -er. <B>~ulino</B>, -er. <B>Mal~a</B>, repulsive, repugnant. ➞ <I>mallog, repuŝ</I>. <B>Ne~a</B>, <B>Sen~a</B>, unattractive, ➞ <I>agrabl, plat, log, rav, (en)sorĉ</I>.", "0"],
["ĉarniro", "ĉarnir-o", "[UV] <B>1</B> hinge, moveable joint, (mec) <I>Universala ~o</I>, universal joint. <B>2</B> Natural similar joint, e.g., ligament of bivalve, <B>f</B> central principle, critical point, on which all turns. ➞ <I>artik, depend, pordhok</I>.", "0"],
["ĉaro,", "ĉar-o,", "[OA] Cart, Waggon, car (wide sense) <B>1</B> (ant) chariot. <B>2</B> buggy, dog-c, trap. <B>Akvuma ~o</B>, water-c. <B>Aŭto~o</B>, motor-coach (for excursns). <B>Benk~o</B>, char-a-banc. <B>Bov~o</B>, ox-w. <B>Flank~o</B>, side-c. <B>Funebra ~o</B>, hearse. <B>Infan~o</B>, baby carriage, pram. <B>Plen~o</B> (<I>da</I>), c-(w-)load. <B>Man~o</B>, hand-c. <B>Puŝ~o</B>, push-c. <B>Rub~o</B>, dust-c. <B>Ŝarĝ~o</B>, tip-c. <B>~estro</B> (1 Rĝ 22/32). <B>~eto</B>, small c. (mec) carriage (e.g., of typewriter). <B>~isto</B>, c-(w-)er, carman, carrier, charioteer. <B>~umo</B>, wheelbarrow. <B>Plen~~o</B> (<I>da</I>), barrow-load. <B>~faristo</B>, wheelwright. <B>~levilo</B>, (<I>veturila kriko</I>), jack. ➞ <I>kamion, vagon, veturil</I>.", "0"],
["ĉarpenti", "ĉarpent-i", "[UV] carpenter (Se 9/1). <B>~ado</B>, <B>arto</B>, <B>~aĵo</B>, carpentry. <B>~isto</B>, [UV] carpenter. ➞ <B><I>lignaĵ, rabot, seg, torn, trabar</I>.</B>", "0"],
["ĉarpio", "ĉarpi-o", "[UV] lint, soft cotton material for dressing wounds. ➞ <I>bandaĝ, pans</I>.", "0"],
["ĉarto", "ĉart-o", "Charter. <B>1</B> written grant of rights, deed, title. <I>Granda ~o</I>, Magna Charta. <B>2</B> (<I>lukontrakto</I>), (mar) c-party. <B>~i</B> (<I>-n</I>), <B>1</B> grant c. to, license, privilege. <I>~ita kompanio, kontisto</I>, -ed company (accountant). <B>2</B> (<I>lui), ~i ŝipon</I>.", "0"],
["ĉasi", "ĉas-i", "(<I>-n</I>, abs), [UV] Chase, Hunt, pursue, seek after. <I>Iri ~i. ~i malamikon, ŝipon, urson</I>. <B>f</B> <I>~i edzon, favoron, fianĉon, honoron, monon</I>. <B>~o</B>, c., pursuit. <B>~ado</B>, h-ing, venery. <I>Bird~ado,</I> fowling. <I>Vulp~ado</I>, fox-hunting. (mar) <B>~anto</B>, c-er, fast launch. <B>~aĵo</B>, [UV] game. <B>~ejo</B>, h ing ground. <B>~isto</B>, h-er, h-sman. <I>Titol~isto</I>, tuft h-er. <B>~leĝaro</B>, game laws. <B>~permeso</B>, game license. <B>For~i</B>, clear out, drive away (from, out of). <I>~~i fumon el ĉambro</I>. <B>Kur~i</B>, run after, <B>Pel~o</B>, battue. <B>Ŝtel~i</B>, poach. ➞ <I>pel, persekut, postkur</I>.", "0"],
["ĉasio", "ĉasi-o", "chassis, base frame (undercarriage) of vehicle, etc.", "0"],
["ĉasta", "ĉast-a", "[UV] chaste, innocent, modest, pure, virgin. <I>~a junulo, konduto, romano, stilo</I>. <B>~(ec)o</B>, chastity. ➞ <I>dec, pur, senkulp, virg, virt</I>. <B>Mal~a</B>, dissolute, impure, indecent, lascivious, lewd, licentious, obscene, wanton. <B>Ne~a</B> (<I>karaktero, konduto</I>), unchaste. ➞ <I>diboĉ, obscen, senmor, volupt</I>.", "0"],
["ĉatnio", "ĉatni-o", "chutney, pungent Indian condiment.", "0"],
["ĉatoj", "ĉat-oj", "(orn) Chats (word proposed by Stojan) &gt; bush-(stone-whin-)chats, wheat-ears. ➞ <I>enant, saksikol</I>.", "0"],
["ĉe", "", "[UV] (prep) At, denotes coincidence. <DIV> PLACE (<I>samlokeco</I>): (a) in general. <I>Sidi</I> ~(at, by) <I>la fajr-(fenestr-tabl-)o. Profesoro ~ la universitato. Konto ~ la banko. Havebla ~ la BEA. Li restis ~ si</I> (at home). <I> W. ~ la maro</I>, W-on-sea. <I>Res tti</I> ~ (Stick to) <I> via metio. Koro ~ koro</I>, heart to heart. <I> Ŝtelo</I> ~(from) <I> ŝtelisto. Sidi</I> ~(over) <I> la vino</I>; (b) at a definite place or point: <I>Kapti iun</I> ~(by) <I>la brak-(kol-)o. Dika ~ la kokso. Vundita</I>~(in) <I>la genuo</I>.</DIV> <DIV> TIME (<I>samtempeco</I>): At, on. <I>~ lia veno. ~ la koka krio</I>. <B>3</B>(CIRCUMSTANCE) (<I>interrilato</I>). At, among(st), in the case of, with. <I>Tio ne okazas ~ ni la Francof). ~ ĉiu vorto,</I> at (with) every word. <I> ~lamplumo,</I> by lamplight. <I>~ tio</I>, on that, thereupon. ~(under) <I> tiuj kondiĉoj</I>. <B> ~esti</B> (<I>-n</I>), attend, be present at. <I> ~estantaro</I>, audience, gatherg, meeting. <I> Teni</I> <B> ~mane</B>, ➞ <I>al, apud, en, inter, kun, per</I> 11 Do not use ĉe with accusative of direction. Say <I>Iru al li</I>, (not: <I> ce liri</I>). 11 Do not translate \"at\" by ĉe when \"at\" means \"in\". Say <B></B> li naskiĝis (vivis, mortis) en Parizo; la kongreso en Parizo<B></B>. </DIV>", "0"],
["ĉef", "ĉef-", "[OA] (pfx) cardinal, chief, grand, paramount, primary, principal, staple, etc. <B>~anĝelo</B>, archangel. <B>~artikolo</B>, leader, <B>~episkopo</B>, archbishop, primate. <B>~grava</B>, of first importance. <B>~juĝejo</B>, supreme court. <B>~kelnero</B>, h. waiter. <B>~libro</B>, ledger. <B>~ministro</B>, prime minister. <B>~orgeno</B>, Great Organ. <B>~pastro</B>, c. (high) priest, (mus) <B>~pulso</B>, strong pulse, down-beat. <B>~strato</B>, high (main) street. <B>~ŝlosilo</B>, master key. <B>-urbo</B>, capital. <B>~urbestro</B>, lord mayor. <B>~violonisto</B>, leader (orchestra). ➞ <I>estr, mastr, majstr, regant</I>.", "0"],
["ĉefo", "ĉef-o", "[UV] Head, Chief(tain); conductor (<I>orkestro</I>), foreman(/«n’o), head (<I>familio</I>), leader (<I>bando</I>), principal (<I>firmo</I>). <B>~e</B>, above all, principally, <B>~a</B>, c., h., most important, first in rank, foremost, leading., preeminent, principal (in comparison with others) (➞ <I>plej grava, precipa</I>). be at the h. of, first in rank. <B>~eco</B>, supremacy. <B>~ulo</B>, principal person. <B>Ne~a</B>, accessory, secondary.", "0"],
["Ĉeĥoslovakujo, Ĉeĥoslovakio", "Ĉeĥoslovak-ujo, Ĉeĥoslovakio", "CS.", "0"],
["Ĉeĥujo, Ĉeĥio", "Ĉeĥ-ujo, Ĉeĥio", "CZ.", "0"],
["ĉeko", "ĉek-o", "[OA] Cheque. <I>~o blanka, strekita,</I> blank (crossed) c. <I>Bank~o</I>, banker’s draft. <I>Vojaĝa ~o</I>, traveller’s c. <I>~o al portanto</I>, open c., to bearer. <B>~banko</B>, <B>~libro. Poŝt~a</B> <I>konto</I>. ➞ <I>kambi, transpagil, trat</I>.", "0"],
["ĉelo", "ĉel-o", "[UV] Cell, compartment separated from others by partitions. <B>1</B> room enclosed on all sides: <I>~o monaĥeja, mallibereja. Telefona ~o</I>. telephone box. 2 <I>Vaksa ~o,</I> honeycomb c. <B>3</B> (bio) (<I>elemento, histero</I>), c. <B>4</B> (chs, drs), square. <B>5</B> (col) (<I>violori)~o,</I> ‘cello. ~a, <B>~ara</B>, <B>~hava</B>, <B>~plena</B>, <B>~oza</B>, -ullar, honeycombed. <B>~aro</B>, honeycomb, network of cc. <I>~araj mielgutoj</I> (Ps 19/10). <B>~eto (</B><I>alveolo</I>), -lie. <I>ov~eto</I>, ovule. <B>~ito</B> (med) -ulitis. ➞ <I>alveol, ĉambret, kabinet, kamer, karcer, kel, pil</I>.", "0"],
["ĉemento", "ĉement-o", "cement (<I>malmola ekstera tavolo</I>). <B>1</B> outer layer of root of tooth. 2 <B>~i</B>, c., case-harden, carbonize. <B>~a</B> <I>pulvoro</I>, ➞ <I>cement, hard</I>.", "0"],
["ĉemizo", "ĉemiz-o", "[UV] Shirt. <I>Virina ~o</I>, (fac) <I>~ino, in~o</I>, chemise, shift. <B>Har~(Pent~)o</B>, hair-s. <B>Nokta ~o</B>, night-s(-gown). <B>Sub~o</B>, under-s, vest. <B>Sur~o (</B><I>duon~o, brusta tolaĵo</I>), dicky, s-front. ➞ <I>kamizol, korsaj</I>.", "0"],
["ĉenilo", "ĉenil-o", "(tex) chenille, yarn with protruding pile; fabric from this.", "0"],
["ĉeno", "ĉen-o", "[UV] Chain. <B>1</B> connected series of links. <B>~o</B> <I>argan-(fer-horloĝ-hund-hokmaŝ -krank-longmaŝ-or-ŝlosit-)a</I><B>. ~o senfina</B>, <B><I>Formi ~on</I></B>, (e.g., pass buckets). <B>Ankra ~o</B>, anchor cable. <B>Flor~o</B>, garland. <B>Kol~o</B> <B>(<I>koliero</I></B>), necklace. <B>Porto~o</B>, conveyer belt. <B>Rul<B>~o</B>,</B> roller c.<B> <B>Saŭm~o</B>,</B> curb-c (horse). ~oj, cc., bonds. <B>2</B> concatennation, line, sequence, series.<B> <I>~o de eventoj, ideoj, insuloj, montoj, sukcesoj</I>. 3</B> (ch, geom) <B><I>Karbona ~o</I></B>. <B>~a <I>reakcio</I></B>. <B>~i</B> (<B><I>en~igi</I></B>), c., confine, secure with cc., fetter. <B>~ero</B>, <B>~ringo</B>, link. <B>~ujo</B>, crank-(gear)case. <B>Mal~i</B>, <B>De~igi</B>, <B>El~igi</B>, <B>Sen~igi</B> (<B><I>liberigi</I></B>), unchain, loose. <B>Sen~a</B>, loose, unfettered. ➞ <B><I>katen</I>.</B>", "0"],
["ĉerizo", "ĉeriz-o", "[UV] Cherry, fruit of <B>~arbo (</B><I>Prunus cerasus). ~o blanka, nigra</I>. <B>~kolora (~ruĝ)a</B>, c-colored, cerise. <B>~ejo</B>, c-garden (-orchard). <B>~ligno</B>, c-wood. ➞ <I>meriz, padus</I>.", "0"],
["ĉerko", "ĉerk-o", "[UV] coffin. <B>~a</B>, funereal, sepulchral (<I>etoso</I>). <B>~veturilo</B>, hearse.", "0"],
["ĉerpi", "ĉerp-i", "[UV] (<I>elpreni, eltiri), (-n, el). 1</I> Draw (water etc.), bale, ladle, scoop. 2 <B>f</B> derive, extract, gather, obtain. <I>~i esper-(fort - inform - inspir- instru-kuraĝ -mon-)on el</I>. <B>~o</B>, dip. <B>~aĵo</B>, bucket- (ladle-spoon-)ful; excerpt, extract. <B>~eto</B> <I>da akvo</I>. <B>-kulero</B>, <B>~ilo</B>, ladle, scoop, etc. <B>El~i</B>, bale (ladle, scoop) out. <B>f</B> exhaust, strain. <B>~~ita</B>, done up, exhausted, spent, used up; out of print (<I>libro</I>), worked out (<I>grundo</I>). ➞ <I>elsuĉ, foruz, konsum, trostreĉ</I>. <B>Neel~ebla</B>, inexhaustible. <B>De~i</B>, d. olf, rack (<I>virion</I>), tap (<I>elektron</I>). <B>f</B> squeeze, wheedle (out of a dupe).", "0"],
["ĉesi", "ĉes-i", "(nt), [UV] before an infinity expressed or implied: (<I>ĉesi = ne plu -i</I>), cease, desist from (have done with, leave off, stop...) -ing. <I>~i esperi ( ~~ ne plu esperi, forlasi esperon</I>), give up hope. <I>~u paroli, plori. ~u serĉi min plu</I> (1 Sa 27/1). (abs) <I>Ĉesu! ( = ĉesu –i!</I>), forbear. Leave off! (Ij 16/6; 30/27; Ps 35/15). [Never use with a direct object., e.g., <I>ĉesi -on]</I>, <B>~o</B>, cessation, discontinuance, stop, termination. <B>~igi</B> (<I>-n</I>), bring to an end, discontinue, give up, put an end to, put down, stop; break off (relations), suspend (payment) <I>~igi babiladon, bruon, kurson, laboron, pafadon</I> (Na 2/13, 3/1). <B>~iĝi</B> (nt) (<I>= komenci ne esti</I>), come to an end, fall (leave) off, give over, stop. <I>La pluvo ~iĝis ( = ~is fall</I>), the rain stopped, it left off raining. <I>~iĝis la vento</I>, the wind died down (El 9/28-34; Ge 8/2, 22; Ne 6/3; Se 22/10, 26/20; Jes 24/8). <I>Kiam li ~is drinki, kaj</I> <B>~igis</B> <I>la diboĉadon, lia malsano</I> <B>~iĝis. Sen~a</B> (<I>daŭra, konstanta, persista, seninterrompa</I>), ceaseless, continued, persistent, unremitting. <I>Sen~a lumo</I>, fixed light. ➞ <I>fin, forlas, halt, romp</I>. <B>De~igi</B> (<B>~iĝi</B>), un-h, dismount. ➞ <I>karusel, kaval-eri(-ir</I>).", "0"],
["ĉevalo", "ĉeval-o", "[OA] <B>1</B> Horse (<I>Equus</I>). <B>Baskul~o</B>, rocking-h. <B>Baston~o</B>, hobby h. <B>Batal~o</B>, charger. <B>Ĉas~o</B>, hunter. <B>Kur~o</B>, racer. <B>Ligna ~o</B>, wooden h. <B>Mar~o</B> (<I>rosmaro</I>), walrus. <B>Plug~o</B>, <B>ŝarĝ~o</B>, cart-h. <B>Rajd~o</B>, <B>sel~o</B>, saddle-h. <B>Tir~o</B>, draught-h. <B>Vir~o</B>, stallion. <B>2</B> (chs) knight. <I>~ira problemo</I>. <B>3</B> (ph, mec) <I>~(pov)o</I>, h-power. <I>Dudek~a</I>, 20 h-p. <B>~a</B>, equine. <B>~aĉo</B>, sorry nag, rosinante. <B>~aĵo</B>, <B>~viando</B>, h-flesh. <B>~ejo</B> (<I>stalo</I>), stable, mews. <B>~eto</B>, nag, pony. <I>Amata ~eto</I>, fad, hobby. <B>~ido</B>, colt, foal, <B>~idino</B>, filly. <B>~ino</B>, mare. <B>~(ej)isto</B>, <B>~servisto</B>, ostler, stableman; equerry, groom (<I>grumo</I>). <B>~bleki</B>, neigh. <I>~~eti</I>, whinny. <B>~rajdisto</B>, h-man. <B>~ŝanĝo</B>, relay, <B>~bredisto. ~haroj. ~ŝuo</B> (<I>hufumo</I>). ➞ <I>pone</I>.", "0"],
["ĉevro", "ĉevr-o", "spar, small square timber. Vd <I>lign</I>.", "0"],
["ĉevrono", "ĉevron-o", "[OA] (<I>tegmenta trabo</I>), Rafter, beam. <I>~oj abiaj</I> (Alt 1/17). (des, her, mil) chevron, shaped figure (band, mark). <B>~a</B> (<I>zigzaga) modluro</I>, chevron moulding. (nwk) <I>~a</I>, herring-bone. <B>~i</B>, r.", "0"],
["ĉi", "", "[UV] denotes proximity, with <B>ti</B>-correlatives changes \"that\" to \"this\". <B>Tio</B>, that thing; <B>ĉi tio</B> (no hyphen), this thing. <B>Ĉi tie</B>, here; <B>ĉi tien</B>, hither; <B>ĉi-tiea</B>, local, of this place, <B>ĉi-tieuloj</B>, locals, natives, pple here. <B>Tiu ... ĉi tiu</B>, the former ... the latter (last-named). <B>2</B> abbreviation for <B>ĉi tiu(j).</B> <I>Prenu ~ librojn</I> (these books). <I>~ fojon</I> (4 FA 64/36). <B>3</B> Abbreviation for <B>ĉi tie</B> (If 75/24); <B>1</B> FA 75/20; 96/36; 99/29; <B>2</B> FA 56/19; 66/12,119/28, 121/6; <B>3</B> FA 29/11; <B>4</B> FA 10/31,202/7). E.g., <B>ĉi</B> <I>ne estas akvo; ni ankaŭ</I> <B>ĉi</B> <I>estas</I>. This experimental form has apparently found no following. <B>4</B> ĈI- (pfx) denotes (a) \"this\". <B>Ĉi-matene</B> (<I>hodiaŭ matene</I>), this morning; <I>ĉi-flanka, ĉi-jara, ĉi-foje, ~momente, ~rilate</I>. (b) Here: <B>ĉi-kune</B>, herewith. <I>Venn</I> <B>ĉi-transen</B>, Come over here, <B>ĉi-sube</B>, hereunder. <B>Ĉi-supre.</B>", "0"],
["ĉia", "", "[UV] (<I>ĉiuspeca</I>), of every kind, every kind (sort) of a, all kinds (manner) of. <I>~ vivo</I> (all life) <I>malaperis. Fari ~n</I> (all sorts of) <I>laboron. ~ dono estas bono</I>. <B>~maniere</B>, in all sorts of ways, <B>~vetere</B>, whatever the weather. ➞ <I>iu, kiu ajn</I>. <B>tcial</B> (<I>ĉiukaŭze, ĉiumotive, pro ĉio</I>), for every reason, on all grounds. <I>Tio estas ~ konsilinda</I>.", "0"],
["ĉiam", "", "[UV] (<I>ĉiutempe</I>), Ever, at each (every) time, al all times, always, (<I>Por) ~ kaj eterne</I>, for e. and e. <I>~ nova</I>, e. new. <B>~a</B> (<I>konstanta</I>), constant, continual, permanent (El 29/42). <B>~e</B>, perpetually. <B>~eco</B>, permanence. <B>~igi</B>, perpetuate. <B>~ulo</B>, a regular (guest, etc.), <B>~daŭra</B>, e-lasting, permanent, <B>~verda</B>, e-green. <B>Ne~a</B> (<I>portempa</I>), impermanent, temporary. <B>Por~a</B> (eternal, perpetual) <I>posedaĵo. ~~a mor- tinto</I> (PI 3/6). ➞ <I>ĉiufoje, kiam ajn</I>.", "0"],
["ĉie", "", "[UV] (<I>ĉiuloke</I>), Everywhere, in each (every) place, in all places. <I>Nenie semata, tie trovata. ~</I> <B>ajn</B>, absolutely e. ~ <B>£i</B>, e. here. <B>~n</B>, (to) e., everywhither, in all directns. <I>Vi povas iri ~n</I>, you can go e. (anywhere) <B>~a (</B><I>universala</I>), general, prevalent, ubiquitous. <B>~eco (~esto)</B>, omnipresence, ubiquity. ➞ <I>hie ajn</I>.", "0"],
["ĉiel", "", "[UV] (<I>ĉiumaniere, -rilate</I>), in every way, in all sorts of ways. <I>Li min helpis</I>", "0"],
["ĉielo", "ĉiel-o", "[UV] <B>1</B> Sky, Heaven; firmament, welkin. (<I>La suno brilas) sur la ~o</I>, in the s. <I>~o nuboza</I> (overcast), <I>blu-(klar-seren-)a. Sub la libera</I> (open) <I>~o. Pendi inter ~o kaj tero</I>, in mid-air. <B>f</B> in the clouds. <I>La ~oj</I> (the hh) <I>rakontas la gloron de Dio</I>. <B>f</B> climate, the s. <I>Sub fremda ~o</I>, in foreign climes. <B>2</B> (rel) Heaven. <I>En la ~o,</I> in h. <I>La ~o de la ~oj</I>. f <I>Ĉi tie la infano estas en sia ~o</I>. <B>3</B> f (<I>=Dio) La ~o donu, ke!</I> H. grant that! <I>Pro la ~o!</I> In H’s name <B>~o!</B> Heavens! <B>~a</B>, h-ly, celestial, sky-. <I>~a estaĵo, regno, volbo</I>. ~en, h-(s-)wards. <I>La ~ena vojo</I>, the h-ward path. <B>~ano</B>, <B>~ulo</B>, celestial being. ~arka (<I>iriza</I>). <B>~blua</B> (<I>lazura</I>), s-blue, azure, cerulean. <B>~ruĝo</B> <I>de mateno</I>, aurora, morng red. Gis<B>~e</B>, sky high. <B>Sub~e</B>, out of doors, in the open air. ➞ <I>elizi, eter, olimp, paradiz, superter</I>.", "0"],
["ĉies", "", "(<I> = de ĉiu, de ĉiuj</I>) (Ps 145/15), every (each) one’s (body’s). <I>~admiro, devo, opinio, propraĵo</I>. <B>~igi</B> (<I>kolektivigi</I>). <B>~ulino</B> (<I>publikulino</I>).", "0"],
["ĉifĉafo", "ĉifĉaf-o", "(orn) chiffchaff (<I>Phylloscopus colly bit a</I>). ➞ <I>filoskop</I>.", "0"],
["ĉifi", "ĉif-i", "(<I>-n</I>), [UV] Crease, crumple, rumple, tumble, wrinkle. <I>~i vest-(lit-paper -teksaĵ-)on</I>. <B>~aĵo</B>, something c-ed or tumbled. <I>Paper~afo</I>, scrap of paper. <B>~ita</B>, (c)rumpled, tumbled. <B>Mal~i</B>, smooth out. ➞ <I>bulig, ĉifon, krisp, plis, sulk, taŭz</I>.", "0"],
["ĉifono", "ĉifon-o", "[UV] Rag, Tatter, scrap, shred. <B>Lav~o</B>, dish-r. <B>~oj</B>, frippery, pieces of lace, etc. <I>Ami ~ojn</I>, be fond of frills and furbelows. <I>Babili pri ~oj</I>, talk dress. <B>~a</B>, t-ed, torn, in rags. <B>~i</B>, tear to pieces. <B>~e</B> <I>vestita (en ~oj</I>), in rags, seedy-looking, shabbily dressed. <B>~aĉo</B>, r., clout, duster, etc. <B>~aĵo</B>, <B>~aro</B>, old rr., t-ed garments. <B>~eca</B>, ragged, frayed, torn. <B>~(aĵ)isto</B>, r-picker, r-and-bone man. <B>~ujo</B>, r-bag. <B>~ulo</B>, ragamuffin, t-demalion. <B>~ularo</B>, riff-raff. ➞ <I>brokant, ĉifaĵ, sir; liknid, seneci</I>.", "0"],
["ĉifro", "ĉifr-o", "[OA] (<I>sekreta kodo</I>), Cipher, code, secret writing. <B>~a</B> <I>telegramo</I>, c-telegram. <B>~ado</B>, coding, ciphering. <B>~i</B>, put into (write in) c. <B>~aĵo</B>, c-message. ➞ <I>cifer, deĉifr, kod, kript, sigl</I>.", "0"],
["ĉikani", "ĉikan-i", "[UV] Carp (at), Quibble; cavil at (about), haggle (over). <B>1</B> (<I>fendi harojn, pedanti, tro subtili</I>), use frivolous subterfuges (quirks, shifts), <B>2</B> (<I>pedante disputadi, subtile kritikaĉi</I>), dispute, find fault, try to pick a quarrel. <B>~ema</B>, c-ing, faultfinding, pettifogging. <B>~(et)o</B>, c., q., evasion, \"get-out\", trumpery complaint. <B>~(ad)o</B>, <B>~aĵo</B>, c-ing, q-ing, captiousness, chicanery, sophistry, etc. ➞ <I>piket</I>.", "0"],
["ĉiko", "ĉik-o", "chigoe, jigger (sand flea) (<I>Sarcopsylla penetrans</I>).", "0"],
["Ĉilio", "Ĉili-o", "CL, Chile.", "0"],
["ĉilo", "ĉil-o", "chyle", "0"],
["ĉimo", "ĉim-o", "chyme.", "0"],
["ĉimpanzo", "ĉimpanz-o", "chimpanzee, African ape (<I>Pan</I>).", "0"],
["ĉinĉilo", "ĉinĉil-o", ". (zoo) chinchilla (<I>Chinchilla</I>).", "0"],
["Ĉinujo, Ĉinio", "Ĉin-ujo, Ĉinio", "[OA-9] CN, China.", "0"],
["ĉio", "", "[UV] (<I>ĉiu afero</I>), all, everything, all (things). <I>Al ~ oni povas kutimiĝi. Pliol~</I>, above all. <I>Ne ~ brilanta estas diamanto</I>. <B>~manga</B>, omnivorous. <B>~pardona</B>, forgiving all. <B>~potenca. ~pova</B>, almighty, all powerful, omnipotent. <B>~scia</B>, omniscient. <B>~taŭga</B>, for all purposes. ➞ <I>tiom</I>.", "0"],
["ĉiom", "", "[F] (<I>tutkvante, la tuto</I>), The whole quantity, all (the whole) of it, the lot. <I>Li prenis ~da, ~el la (=la tuta, ĉiuj</I>), all the . <B>. . ~a</B>, total. ➞ <I>komplet, plen, sum, tut</I>.", "0"],
["ĉirkaŭ", "", "[UV] <B>1</B> (prep) Around, Round. <I>Stari ~ arbo, Planti ~ la kampon. Meti sakaĵon ~ sian lumbon</I> (Ge 37/34), <I>brakon ~ ies kolon</I>. <B>~a</B>, surrounding. <B>~e</B>, a., r., about. <I>Danci ~e. Rigard-(send-)i</I> <B>~en</B>. <B>~i</B> (<I>-n</I>), [UV] surround, be a., encircle. <I>Galerio ~is la korton. Urbo ~ita de muro</I>. <B>~o</B> [UV] (<I>periferio</I>), circuit, circumference. ➞ <I>zon</I>. <B>~aĵo</B>, [UV] environment, surroundings. <B>~igi</B> (encircle, encompass) <I>urbon per muro</I>. <B>~antaro</B>, attendants, circle, entourage. <B>~parolado</B>, circumlocution. <B>~polusa</B>, circumpolar. <I>~zoni</I> (Ps 18/32). <I>~iri, ~ligi, ~rigardi, ~stari, ~tranĉi</I>. <B>2</B> (adv) (a) (<I>proksimume je</I>), approximately at. Stari ~ la mezo. ~ la vespero, vesperiĝo), twrd evening. ~ Majo, (b) (proksimume), about. La libro kostis ~ <B>3</B> ŝilingojn. Li havas ~ 50 jarojn. La koncerto daŭris ~ du horojn. <B>Rim</B>.: For 2, <I>proksimume</I> is more often used.", "0"],
["ĉiro", "ĉir-o", "cirr/us (wide sense). (bot) (<I>volvrampajo</I>), tendril, (zoo) slender filamentary appendage; barbel (beard) of fish, foot (tentacle) of -iped. <B>~oforma</B>, -ous. <B>~opiedulo</B>, cirriped (<I>ciripedo</I>). ➞ <I>cirus</I>.", "0"],
["ĉirpi", "ĉirp-i", "chirp, cheep, twitter (as cricket, grasshopper). ➞ <I>pep, zum</I>.", "0"],
["ĉiu", "", "[UV] <B>1</B> (pron) Everyone (body), <I>~ mortis. Ankoraŭ neniu plaĉis al</I> (anyone) <I>povas iri.~</I> <B>ajn</B>, absolutely e. <B>~j</B>, all. <I>Ni ~j</I>, we all. <I>~(j) diras</I>, e. says. <I>~j ĉi</I>, all these. <I>~por si, por ~j Di’! Stari sola kontraŭ ~j</I>. <B>2</B> (adj) Every, each. <I>Mi legis ~n libron sur la breto. Li povus veni en ~ minuto</I> (at any time). <I>~n duan tagon,</I> e. other day. <I>ovoj</I>, all the eggs. <B>~foje</B>, <B>kiam</B>, Whenever (El 17/11). <B>~flanke</B>, on all sides. <B>~homa</B>, general, universal. <B>~jara</B>, annual, yearly. <B>~taga</B>. e-day, daily (PI 3/14). <B>~jare</B> (Ne 10/35). <B>~matene</B>, e. morning. <B>~dimanĉe</B>, <B>~hore</B>, <B>~momente</B>, <B>~nokte</B>, <B>~rilate</B>. ➞ <I>ĉia, tut</I>.", "0"],
["ĉizi", "ĉiz-i", "(<I>-n</I>) [UV] (El 35/33), Chisel, carve, chip, grave (<I>lignon, ŝtonon</I>). <B>~ilo</B>, c., graver (Jes 44/12). <B>Plata ~ilo</B>, flat c. <B>Bekforma (morteza) ~ilo</B>, mortise c. <B>Kruco~ilo</B>, cross-cut c. <B>Ligno~ilo</B>, wood- carvg c. <B>Metal~ilo</B>, cold c. <I>~o bevelranda, folda, kava, kojna, mana, tranĉa</I>. ➞ <I>cizel, hak, mortez, rabot, tajl, tenon</I>.", "0"],
["ĉj", "-ĉj", "[UV] sfx forming affectionate diminutvs for masc. names, placed after any of the first few letters in the name. <B>Vilĉjo</B>, <B>Viĉjo</B>, Will, Bill(ie). <B>Toĉjo</B>, Tom(mie). <B>Paĉjo</B>, papa, dad(dy). <B>Oĉjo</B>, nunk, (col) \"old chap, old man\", pal. ➞ <I>et, nj</I>.", "0"],
["Ĉo", "Ĉ-o", "[F], letter Ĉ.", "0"],
["ĉokolado", "ĉokolad-o", "[UV] Chocolate, prepared cocoa. <I>Briko (taso) da ~o</I>. <B>~(kolor)a</B>, <B>~obruna</B>, c-colored, dark brown. <I>~a kremo,</I> c. cream. <B>~ita</B>, flavoured with c.", "0"],
["ĉoto", "ĉot-o", "(ich) bullhead, miller’s thumb (<I>Cottus</I>).", "0"],
["ĉu", "", "[UV] (conj). <B>1</B> Whether. <I>Diru al mi, ĉu pluvos</I>, Tell me whether ( = if) it will rain. <B>2</B> Forms questions answerable by \"Yes\" or \"No\". (<I>Diru al mi) Ĉu li venis?</I> Did he come? <I>Ĉu mi iru?</I> Shall I (am I to) go? <I>Ĉu esti, aŭ ne esti?</I> <B>3</B> (col) Sometimes omitted. (<I>Ĉu) Li dormas?</I> He is asleep? <I>Vere?</I> Really? (Ge 24/39, No 16/22). <B>4</B> Used alone. Ĉu? (= <I>Ĉu jes? Ĉu vere?</I>) Is that so? Do you agree? <B>Ĉu ne?</B> Isn’t that so? <B>5</B> \"Question-tags\" at the end of a sentence. <I>Li iros</I>, ĉu ne? = He’ll go, won’t he? <I>Li ne iros</I>, ĉu ? = He won’t go, will he? 6 Ĉu ... (aŭ) ĉu, whether ... or. <I>Ĉu pluvos, (aŭ) ĉu ne, estos egale por mi,</I> Whether it rains or not, that will be all the same to me. <I>Ĉu ĝi estas bovo, ĉu azeno, ĉu ŝafo</I>, Whether it be ox, or ass, or sheep. <B>Rim</B>.: Do not say ĉu .. . ĉu (doubt) query, uncertainty), i. o. aŭ … aŭ (alternatives), or <B>jen ... jen</B> (alternations). ➞ <I>aŭ, jen, se</I> <B>Rim</B>.: ➞ If <B>= se</B> ( = supposing that); If = ĉu (= whether). <I>IT Negative questions</I> <B>(Cu … ne?).</B> In reply to Ĉu <B>vi ne iris?</B> Didn’t you go?) An Englishman and most Westerners word reply Ne (=No, I didn’t), or <B>Jes</B> (=Yes, I did). But the Japanese and many other nations feel this illogical, and word reply <B>Jes</B> (=Yes, I didn’t), or Ne ( = No, I did). It is wise therefore either to avoid negative questions, or else to make the reply clear: Mi iris. Mi ne iris.", "0"],
["da", "", "[UV] (prep) (quantity) of. Between two words denotes that the list measures the second; answers tile question \"How much (many)?\" (a) After word of quantity: <I>Funto ~ fromaĝo. Jardo ~ drapo</I> (b) After other words. <I>Guto ~ mielo. Maro ~ mizeroj. Marĉo ~ sango. Ombro ~ dubo</I>. Sim: <I>amaso ~, dozo ~, garbo ~, peco ~, provizo ~, serio ~, torento ~</I>. (c) (<I>Plen)taso ~ teo</I>, cup(ful) of tea. Sim: (<I>pleri)glas-(kuler-teler-)o</I> (d) Time: <I>Horo ~ ripozo. Tago ~ ĝojo. Vivo ~ mizero</I>. (e) After a numeral noun: <I>dudeko ~ paĝoj, miloj ~ mejloj</I>. (f) <I>Kiotion (iom, (mal)multe, (mal)pli, sufiĉe, tro</I>) ~ ,v«/o = How much (some, a lot of, a little, more-less, enough, too much) salt, (g) (col. elision): <I>Prenu (iom) ~ butero,</I> take some butter. <I>Cu vi havas ~ mono?</I> Have you any money? <B>Rim</B>.: Between (a<B>) kelkaj (multaj) el</B> (individuals), and (b) <B>kelke</B>, <B>multe (multo)</B> ~ (collective), the difference is that between twelve (individuals) and a dozen (in the lump). Multaj homoj, many persons (individuals). Multe ~ homoj, a number of people (in the mass). <B>Rim</B>.: Do not use <B>da</B> before a defining. limiting word, e.g., la, tiu, du: Taso ~(~~de ia) kafo, but taso <B>de la (mia</B>, <B>tiu)</B> kafo. Aro ~ birdoj, aro <B>de mil</B> birdoj. Sumo ~ mono, <B>de tri</B> pencoj. Kiom ~ mono (ovoj)? Kiom <B>el la</B> mono (ovoj)? <B>Rim</B>.: After <B>-ono</B> ( = proportion) use <B>de</B>. Duono <B>de</B> funto <B>da</B> teo; kvarono <B>de</B> horo\\ du estas triono <B>de</B> ses. But: Kvar kaj duono (quantity) <B>da</B> frankoj. <B>Rim</B>.: ➞ folio <B>da</B> papero (quantity); <B>de</B> arbo (genitive); <B>el</B> papero (material).", "0"],
["dabi", "dab-i", "(<I>-n) (frapeti, premeti</I>), dab, strike lightly, tap. <B>~o</B>, d.", "0"],
["dacelo", "dacel-o", "(orn) laughing jackass (<I>Dacelo</I>).", "0"],
["dafnio", "dafni-o", "(<I>akva pulo</I>), daphnia water-flea (<I>Daphnia</I>).", "0"],
["dafno", "dafn-o", "(bot) daphne shrub (<I>Daphne) &gt; laŭreolo</I>, spurge laurel (<I>D. laureola); mezereo</I>, mezereon (<I>D. mezereum</I>).", "0"],
["dafodilo", "dafodil-o", "daffodil (<I>Narcissus pseudo- narcissus</I>). ➞ <I>narcis</I>.", "0"],
["dagerotipo", "dagerotip-o", "(phot) daguerreotype.", "0"],
["daktilido", "daktilid-o", "(bot) (<I>kokpiedo</I>), cocksfoot grass (<I>Dactylis</I>).", "0"],
["daktilo", "daktil-o", "[UV] <B>1</B> Date, fruit of <I>-arbo,</I> d-palm (El 15/27) (<I>Phoenix dactylifera</I>). <B>2</B> (pros) dactyl (<I>-\"</I>)", "0"],
["daktiloskopio", "daktiloskopi-o", "finger-printing.", "0"],
["dalio", "dali-o", "[OA] dahlia (<I>Dahlia</I>).", "0"],
["daltonismo", "daltonism-o", "Daltonism, congenital colour-blindness.", "0"],
["damaĝi", "damaĝ-i", "(-rt), damage, harm, hurt, injure. <B>~o</B>, detriment. ➞ <I>difekt, domaĝ</I>.", "0"],
["damao", "dama-o", "(<I>damcervo</I>), fallow deer (<I>Dama</I>).", "0"],
["damaro", "damar-o", "dammar pine (<I>Dammara</I>). <B>~o blanka</B>, Amboyne <B>p. ~o suda (</B><I>kaŭrio</I>). kauri p; from which <I>~a gumo</I>, d-rezin.", "0"],
["damaskeni", "damasken-i", "damas-cene, -keen; inlay metal with gold or silver, or with watered pattern produced in welding. <I>~ita klingo (ŝtalo</I>), Damask blade (steel). ➞ <I>inkrust, niel</I>.", "0"],
["damasko", "damask-o", "[UV] (tex) damask (linen or silk).", "0"],
["damaso", "damas-o", "(<I>Damaska pruno</I>), damson.", "0"],
["damni", "damn-i", "(-rt), Damn, (a) doom to hell, (b) condemn as a failure, <B>~a</B>, -atory, -ing. <B>~inda</B>, -able. <B>~ita</B>, -ed.", "0"],
["damo", "dam-o", "<B>1</B> (drs) King. <B>~oj</B>, [UV] <B>~ludo</B>, draughts. <I>Ludi~ojn</I>. ~igi <I>pecon</I>, make a k. <B>~tabul-o</B>, draught-board. <B>2</B> (chs) Queen. <B>~igi</B> <I>peonon</I>, q. a pawn. <B>3</B> (cgm), q. <I>Kera ~o</I>, q. of hearts. <B>4</B> dame, (noble) lady.", "0"],
["dampi", "damp-i", "(<I>-n</I>), (mus) Damp, choke, dull, deaden, extinguish, muffle, stifle. <I>fajron, kordojn de piano, violono, tamburo, ziteron. ~itaj sonoj</I> (harp) sons etouffes. <B>f</B> d., check, depress, discourage (<I>esper-fervor-iniciativ-)on</I>. <B>~ilo</B> (<I>sordino</I>), mute (horn, vn), damper (<I>mutigilo</I>) (piano), silencer (car, revolver).", "0"],
["danci", "danc-i", "[UV] Danc/e. <I>~i polkon. Ami ~i,</I> like (be fond of) -ing. <B>f</B> bob up and down, be rocked (on waves). <B>~o</B>, d. <B>~ado</B>, [UV] <B>~arto</B>, -ing. <B>~ejo</B>, ~halo, -ing saloon, ball-room. <B>~eto</B>, hop. <B>~istino</B>, female- dancer. <B>~kunveno</B>, <B>~rondo</B> (PI 5/15). <B>Kun~anto</B>, partner. <B>Ŝnur~isto</B>, rope -er. ➞ <I>bal, salt, vals</I>.", "0"],
["dando", "dand-o", "[UV] dandy, buck, coxcomb, exquisite, fop, \"masher\". <I>Maljuna ~o,</I> old beau. <B>~a</B> (~e <I>vestita</I>), smartly dressed. <B>~i</B>, cut a dash, flaunt. ➞ <I>koket, pav</I>.", "0"],
["danĝero", "danĝer-o", "[UV] Danger, liability or exposure to harm, jeopardy, peril, risk; something causing d. <I>~o fali</I>, d. of falling. <I>Eviti, fronti ~on. Fali, meti en ~on. Ekster ~o</I>, out of d. <I>Nenia ~o!</I> No fear! Not likely! <I>Viv~o</I>, d. of death. <B>~a</B>, -ous, critical. <I>~a situacio, vojo</I>. <B>~eco</B>, insecurity. <B>En~igi</B>, expose to d., imperil, jeopardize. <B>Sen~a</B>, safe. ➞ <I>sekur</I>.", "0"],
["danki", "dank-i", "(<I>-n, ke, pro</I>), [UV] Thank. <B>1</B> be Grateful, t-ful, express gratitude, return thanks. <I>Mi ~as vin (al vi</I>), t. you. <B>2</B> (<I>ion al iu = ŝuldi</I>), owe, be indebted. <I>~i la vivon al</I>. <B>~a</B>, g., t-ful, obliged. <I>Esti ~a al</I>. <B>~o</B>, tt., gratitude. <I>Multan ~on</I>, many tt. <B>Dank!</B> (2 FA 145/27). <I>Dank’ al ( = ~o estu al</I>), tt. to, owing to (Ne <B>9/25). ~e</B> (<I>kun ~o, akcepti, ricevi, rifuzi</I>. <B>~eco</B>, t-fulness. <B>~ema</B>, of a g. disposition. <B>~festo</B>, t-sgiving feast, -okanto (Ne 12(46). -letero, letter of tt. <B>Antaŭ~i</B>, t. in anticipation. <B>For~i</B>, refuse with thanks. <B>Mal~i</B>, resent. <B>Ne~a</B>, ung-ful. <I>Ne~inde!</I> That’s nothing! <B>Sen~a</B>, t-less. <I>Sen~a laboro</I>.", "0"],
["Danujo, Danio", "Dan-ujo, Danio", "[OA-8] DK.", "0"],
["dartro", "dartr-o", "(med) scurf, tetter; any light dry skin affection.", "0"],
["dativo", "dativ-o", "[UV] (gram) dative (case).", "0"],
["dato", "dat-o", "[UV] Dat/e. <I>Kun (sub) ~o</I> 2 <I>Nov.</I>, -ed. <B>2</B> Nov. <I>Kiun ~on ni havas?</I> What d. is it? <I>~i leteron = surmeti ~on</I>, d. <B>~iĝi (-umi)</B> (nt), d. from, begin on. <B>~ilo</B>, d-stamp. <B>~fest(~reven)o</B>, anniversary (➞ <I>jubile, naskotag</I>). <B>Antaŭ~i</B>, ante-d. <B>Freŝ~a</B>, recent. <B>Mis~i</B>, mis-d. <B>Pag~o</B>, d. of payment, maturity. <B>Post~i</B>, post-d. <B>Sam~a</B>, of the same d. <B>Sen~a</B>, un-ed.", "0"],
["daturo", "datur-o", "[UV] (bot) thorn-apple (<I>Datura</I>), ~arbo (M 4/5). ➞ <I>stramoni</I>.", "0"],
["daŭbo", "daŭb-o", "<B>1</B> (<I>barelero</I>), stave of barrel. <B>2</B> (arch) shaped stone of arch (vault). <B>3</B> (av) panel, section of gore. <B>4</B> (nwk) gore, gusset.", "0"],
["daŭri", "daŭr-i", "(nt), [UV] Continu/e, endure, go on, last. <I>Ne ĉiam ~os la somero. La kunven- (koncert-)o ~is du horojn, ĝis la oka. Se via ŝanco ~os</I> (holds), (cl) <I>~i bone,</I> wear well. <B>~o</B>, -ance, course, duration, length. <I>En la -o de (=dum</I>), in the course of, during, for (Ne 5/18). <I>En la ~o de monato</I>, within a month. <B>Viv~o</B>, span of life. <B>~(em)a</B>, -ous, durable, lasting; fast (colour), perennial (plant). ~e <I>labori</I>, work steadily. <B>~igi</B> (<I>-n</I>), [UV] c., go on with, not put an end to. <I>~igi abonon, koleron, migradon</I> (Ge 13/3). <I>\"Nu!\" li ~igis</I>. \"Well!\" he -ed. <I>~igu!</I> Go on! (mar) Carry on! <B>~igo</B>, -ation. <B>-igota</B>, to be -ed. <B>Mal~a</B>, <B>Ne~a</B>, ephemeral, fleeting, fugitive, short-lived, transient. <I>Ne~a kolero, momento, pluvo</I>. <B>Jar~ulo</B>, (hort) annual. <B>Longe~a</B>, lengthy, prolonged, protracted. <B>Preter~i</B>, outlast. <B>Viv~a</B> (<I>dumviva</I>), life-, (sentence, etc.). ➞ <I>ekzist, okazad, rest; ĉiam, konstant, senĉes</I>. opposite <I>ĉesiĝ, halt, forges</I>. <I>[Say Li ~igis la kantadon; li ~e kantis;</I> not: <I>Li ~igis kanti, li ~is la kantadon!]</I>", "0"],
["davito", "davit-o", "(<I>boatlevilo</I>), (mar) davit.", "0"],
["dazibato", "dazibat-o", "(zoo) sting-ray (<I>Dasybatis</I>).", "0"],
["dazipo", "dazip-o", "species of armadillo (<I>Dasypus</I>).", "0"],
["daziuro", "daziur-o", "(zoo) dasyure, Australian jnative cat (<I>Dasyurus</I>).", "0"],
["dazli (o)", "dazl-i (-o)", "(<I>lumblindetigi</I>), dazzle, confuse eye (person) with excess of light, etc.", "0"],
["de", "", "(prep), [UV] of, from, by (three aspects of the one idea: <I>ORIGIN</I>. <B>1</B> OF: <B>(a) possession</B>: <I>La libro ~ M</I>, M’s book, <B>(b) Event</B>: <I>Lamorto ~ Nelson</I>, <B>(c) Character</B>: Kampo ~ batalo (batala)] Trono ~ gloro (<I>glora). Bukedo ~(el) floroj (flora). Kongreso ~(en) Hago (Haga). Homo ~(kun) talento (talenta). Historio ~(pri) Ameriko (Amerika</I>). If Do not use <I>de</I> if <I>nomita</I> (apposition) is understood. <I>La urbo (nomita) Oslo</I>, the city of Oslo. <B>2</B> FROM: <B>(a) commencing with, starting from. (Place)</B>: <I>~ loko al loko. Rigardi ~ (mal)proksime</I>, closely (from a distance). <I>~ post</I> (two words) ( = from behind) <I>Jurnalo</I>. <B>(b) Time</B> (<I> = detempe de): ~ kiam?</I> How long? Since when? <I>~ tiam</I>, since then. <I>~ longe</I>, for a long time. <I>~ nun,</I> henceforth. <I>~ lundo</I>, since Monday [Not <I>~ post lundo</I>, which means \"starting from some time subsequent to Monday\"]. If For (a) and (b) sometimes ekde is used for greater clarity. <I>Li kuris ekde</I> (starting from) <I>la ponto ĝis la preĝejo. Ciuj ĉeestantoj, ekde</I> (starting with) <I>la prezidanto</I>. <B>(c) Origin</B>: <I>Ĉio bona venas ~ Dio</I>. <B>(d) Separation</B>: <I>Kurt (for) de</I> (away from). <I>Ŝteli (for)~,</I> steal from. <I>Savu min ~ kontrait</I>, save me from. <I>Levu la okulojn ~ sur</I> (from off) <I>la paĝo. Apartigi (Distingi) A</I> ~ (a. <B>disde)</B> <I>B= distingi inter A kaj B</I> (Ge 1/4). <B>(e) As regards</B> (<I>pri, rilate at): libera</I> free from. <B>(f) Dependence</B>: <I>dependi</I> depend on (lit. hang from). <B>(g) Cause</B>: (<I>kaŭze de): Ruĝiĝi ~ honto</I>, blush with shame, <I>Morti ~ timo</I>, die from fright. <I>Malpura ~ laboro. Salti ~ surprizo. Morti - glavo pro amo al la patrujo</I>. <B>3 BY</B> (after <I>-at -it -ota</I>): <B>(a) (fare de)</B>: Amata - mi,</I> loved by me. <I>Batita ~ li per vergo</I>. <B>(b) (farita de)</B>: Poemo ~ Milton. Vizito ~ la reĝo (al Oslo). La konkero al Anglujo (fare, flanke) - la Normandoj</I>. 1T As <I>de</I> has a wide range of meaning, sometimes an alternative word will avoid ambiguity.", "0"],
["debati", "debat-i", "(<I>-n</I>) [OA] (<I>diskutesplori</I>), debate, discuss formally. <B>~a societo</B>, debating society. ➞ <I>diskut, disput</I>.", "0"],
["debeto", "debet-o", "[OA] = debito.", "0"],
["debila", "debil-a", "(med) Feeble, weak. <B>~eco</B>, debility. <I>Mensa ~eco</I>, mental deficiency. <B>~igi</B>, debilitate, en-f, weaken.", "0"],
["debito", "debit-o", "(<I>malkredito, ŝuldo) [Ne= ven- dado]</I>, Debit (of a/c). <B>~i</B>, d. to, charge against, place to d. of. <I>~i ion (al iu), iun (pri io). ~u la afrankon</I> (charge the postage) <I>al mi</I>. ~a <I>flank-(kont-sald-)o,</I> d. side (a/c, balance). ~oro (~ulo) (<I>ŝuldanto</I>), debtor. ➞ <I>deficit, mank, minus, pasiv</I>.", "0"],
["debuti", "debut-i", "(nt) (<I>unuafoji</I>), come out, make first appearance (in court, on stage), (cgm) play (throw) first. <B>~o</B>, debut, first appearance. ~a <I>parolo</I>, maiden speech. ~anto, tyro, <I>~antino</I>, debutante. ~igi (bring out) <I>fraŭlinon</I>.", "0"],
["Decembro", "Decembr-o", "[UV] December.", "0"],
["deci", "dec-i", "(nt) (<I>al, por</I>), [UV] be becoming (correct, proper, the right thing to do). <I>~as -i,</I> one ought to. <I>Ja ~as, ke</I>, it is only right that. <I>Ne ~as al infano -i</I>, a child should not. <I>Ne ~as fumi en preĝejo</I>. <B>~a</B>, as should be, becomg; decent, decorous, due, fitting, meet, proper, respectable, right, seemly, well-behaved (-bred). <I>~a akcept-(kondut -respekt-sinten-vest-)o. ~a (rekompenco</I>), adequate, just. <I>En ~a tempo</I>, in due course, at the proper time. <B>~e</B>, duly, in a fitting manner. <I>~e kaj bonmore</I>, decently and in order. <B>~eco</B>, decorum, propriety. <I>Elementa ~eco</I>, common decency. <B>Mal~a</B> <I>hasto</I>, indecent haste. <B>Ne~a</B>, undue. ➞ <I>dev, konven, taŭg</I>.", "0"],
["decibel (gramo litro metro)", "deci-bel (-gramo -litro -metro)", "deci -bel(-gram, -litre, -metre).", "0"],
["decidi", "decid-i", "[UV] Decide. 1 (<I>-n, iu</I>, abs), determine, make up one’s mind, resolve. <I>~i iri</I>. 2 (<I>inter, ke, kontraŭ, por, pri</I>): give judgment, rule, settle (<I>demandon, disputon</I>). ~(aĵ)o, decision, resolve. <I>Fari ~on. Ŝanĝi sian ~on (intencon</I>), change one’s mind. <I>Lasu la ~on al mi</I>. <B>Juĝa ~o</B>, judgment, sentence, verdict. <B>~a</B>, definite, final, firm. <I>~a paroltono</I>. <B>~ema</B>, resolute, <B>~enda</B>, at issue. <B>~igi</B> (<I>konvinki, persvadi</I>) convince, prevail on. <I>Tio min ~igis</I>. ~iga, conclusive, decisive. <I>~iga argumento, batalo, cirkonstanco, venko. ~iga voĉdono</I>, casting vote. <B>~iĝi</B>, be convinced, come to a decision. <B>Antaŭ~o</B>, foregone conclusion. <B>For~i</B>, give up (<I>projekton</I>) (Ĥb 2/3). <B>Mem~o</B>, self- determination, <B>Mis~i</B>, <B>ne~ema</B> (<I>dubema</I>), irresolute. <B>Ne~ita</B>, <B>Sen~a</B>, (<I>necerta</I>), in the air, un-ed. ➞ <I>fiks, determin, rezoluci, solv, verdikt</I>. decidu-a (<I>periode aŭ normale defalema</I>), deciduous, e.g., <I>dento, folio</I>.", "0"],
["decimala", "decimal-a", "[OA] (<I>dekuma, podeka</I>), (mat) Decimal. <I>~a frakcio, klasifo, punkto, sistemo</I>. <B>~o</B>, d. <B>~igi</B>, -ize.", "0"],
["deĉifri", "deĉifr-i", "(<I>-n</I>), [UV] Decipher. <B>1</B> (<I>malĉifri</I>), convert cipher into ordinary writing. <B>2</B> make out meaning. <I>~i adreson, dokumenton, papiruson, skribaĉon</I>. <B>Ne~ebla</B>, un-able.", "0"],
["dediĉi", "dediĉ-i", "(<I>-n</I>), [UV] Dedica/te. <B>1</B> give up, devote, offer (to person, purpose). <I>~i atent-(labor-tag-temp-viv-)on, sin, (al</I>). 2 (<I>adresi, autograft</I>), inscribe to friend or patron. <I>~i libr-(poem-verk-)on (al</I>). <B>~o</B>, -tion. ➞ <I>apartig, fordon, konsekr, ofer, sanktig</I>.", "0"],
["dedukti", "dedukt-i", "(<I>-n</I>) [OA], Deduc/e, draw a conclusion, infer. <I>El tio mi ~as, ke …</I> . <B>~a</B>, -tive, inferential. <I>~a logiko, rezonado</I>. <B>~o</B>, -tion, conclusion, inference. ➞ <I>aprior, konklud, rezon</I>. Opp <I>indukt. [Ne= depren, subtrah.]</I>", "0"],
["defendi", "defend-i", "(<I>-n, antaŭ, kontraŭ, per</I>) [UV]. Defen/d. <B>1</B> Guard, keep safe, protect against, shield, ward off attack from. <I>~i la patrujon (teron</I>). <B>2</B> justify, speak (write) in favour of, stand up for, uphold <I>~i amikon (projekton</I>). <B>3</B> (jur) appear for, conduct -ce of. <I>~i akuziton, opinion, rajton</I>. <B>~o</B>, -ce, justification, plea, protection. <B>~a</B> (defensive) <I>milito</I>. <B>~e</B>, in -ce. <B>~ebla</B>, -sible. <B>~isto</B>, advocate for the -ce. Sen<B>~a</B>, -celess. Sin<B>~o</B>, self-ce. ➞ <I>advokat, apologi, pled, ŝirm</I>.", "0"],
["defensiva", "defensiv-a", "Defensive, protective. <B>~e</B>, on the d. <I>~a kaj ofensiva defendoj (Cezaro</I> 311/14).", "0"],
["deficito", "deficit-o", "[OA] (<I>manko, minuso</I>). deficit, shortage. <I>~o bilanca, peza</I>.", "0"],
["defii", "defi-i", "(-n, <I>al</I>), Def/y. <B>1</B> challenge: <I>~i al duel-(lud-pruv-)o</I>. 2 (<I>spiti</I>), brave, face, resist boldly and openly, set at -iance: <I>~i la venton</I>. <B>3</B> (things) be beyond power of: <I>~i atak-(difin-kapt-)on</I>. <B>~o</B>, -iance, challenge. <B>~e</B>, -iantly. ➞ <I>kontrau, spit</I>.", "0"],
["defilo", "defil-o", "defile. <B>1</B> narrow gorge or pass. <B>2 ~i</B>, march in file.", "0"],
["definitiva", "definitiv-a", "[OA] Definit(iv)e, decisive, final, fixed, unconditional. ~a <I>decido, eldono, juĝo, mendo, prezo, respondo, teksto, verdikto</I>. <B>~e</B>, -ly, finally, once and for all. <B>~igi</B>, confirm, ratify. ➞ <I>findecid, malprovizor</I>. deflaci-o, (com) deflation. Opp <I>inflaci</I>.", "0"],
["deformi", "deform-i", "(<I>de-form-igi, formdifekti</I>), deform, deface, disfigure, put out of shape. <I>Onda ~iĝo</I>. ➞ <I>distord</I>.", "0"],
["degeli", "degel-i", "(<I>nt</I>), [UV] Thaw; dissolve, liquify, melt/away. <I>La glacio, neĝo ~as</I> (Ps 147/18). (impersonal) <I>~as!</I> It is t-ing.<B>f</B> become genial, unbend. <B>~(ad)o</B>, t-ing. <B>~a</B> <I>vetero</I>. <B>~aĵo</B>, slush. <B>~igi</B> (<I>-n</I>), (cause to) t., melt, <B>f</B> loosen tongue of. ➞ <I>fandig, fluidig, likvig</I>.", "0"],
["degeneri", "degener-i", "(nt), [UV] Degenera/te, deteriorate, fall off, sink from former excellence. <I>Libero ne ~u en anarkion</I>. (bio) revert to lower type. <B>~(ad) (~iĝ)o</B>, -cy, -ation, morbid change. <I>Grasa ~o</I>. <B>~inta</B>, d., debased, effete. <B>~igi</B>, enervate, etc. ~into, <B>-ulo</B>, d. ➞ <I>dekadenc, malpliboniĝ</I>.", "0"],
["degni", "degn-i", "= dejni.", "0"],
["degradi", "degrad-i", "(<I>-n</I>) [UV] ( = <I>de-grad-igi</I>), Degrad/e, debase, lower in quality, tone down, (person) depose, deprive of rank. <I>klerikon, oficiron</I>. <B>~o</B> -ation. -a -ing.", "0"],
["dehiski", "dehisk-i", "(nt) (bot) Dehisc/e, burst open, gape, split asunder. <B>~a</B>, -ent. <I>~a frukto</I>. <B>~o</B> -escence.", "0"],
["deismo", "deism-o", "(phi) deism. <B>deist-o</B>, deist.", "0"],
["dejni", "dejn-i", "deign, condescend, think fit, vouchsafe (to). <I>~i doni, permesim respondi</I>. <B>Mal~i</B>, <B>ne</B> disdain, scorn, turn up one’s nose at.", "0"],
["deĵori", "deĵor-i", "(nt), [UV] be on Duty (in attendance), officiate, serve. <I>~i ok horojn</I>. <B>~(ad)o</B>, (spell of) d. <I>Nokta ~o</I>. <B>~a</B> <I>oficiro</I>, officer of the watch. <B>~anto</B>, one on d. (attendant, etc.). <B>~ejo</B>, post. ➞ <I>dev, gard, ofic, serv</I>.", "0"],
["dek", "", "[UV] ten. <B>~a</B>, 10th. <B>~e</B>, 10thly. <B>~o</B> (<I>da</I>), half a score, group of 10 (cards etc.). <B>-estro</B> (El <B>18</B>/21). <B>-oble</B>, <B>10</B> times (multiplication) (Da <B>1/20). ~obligi</B>, multiply by <B>10. ~ono</B>, <I>Mortigi ~onon</I>, decimate, <B>-onajo</B>, tithe. <B>~ope</B>, by <B>10s. dek-duo</B>, dozen (➞ <B>dek du</B>, 12, <B>dudek</B> 20). <B>~foje</B>, <B>10</B> times over. <B>~jara</B>, 10 years old. <B>~sesono</B>, <B>1/16th. Du~o</B>, score. <B>Jar~o</B>, decade. <B>Po~a (~uma</B><I>) = decimala</I>, decimal, with 10 as base. <B>~umi</B>, decimate. <B>~kelkjaruloj</B> (<I>adoleskuloj</I>), teen-agers.", "0"],
["deka", "deka-", "(Gk ppfx), deca- (=10). <B>-GRAMO</B>, <B>-LITRO</B>, <B>-logo</B>, <B>-METRO</B>, deca- <B>gram</B>(-litre, -logue, -metre). <B>~podo</B> (<I>dek- pieda krustaco</I>), -pod.", "0"],
["dekadenco", "dekadenc-o", "[OA] Decad/ence, decay, decline, deterioration, fall, wane, <B>~a</B>, -ent, on the down-grade. <I>~a imperio</I>. <B>~i</B>, be -ent, fall away, <B>-ulo</B>, -ent. ➞ <I>aŭtun, defal, degener, kaduk</I>.", "0"],
["dekano", "dekan-o", "[OA] <B>1</B> (college, ecc) Dean, (mus) <B>~a</B>, decani, south side of choir, <B>~ejo</B>, -ery. II (chem) decane. ➞ <I>diakon,fakultestr</I>.", "0"],
["dekanti", "dekant-i", "(<I>-n</I>), (<I>de-trans-verŝi</I>), decant, pour off gently.", "0"],
["deklami", "deklam-i", "(<I>-n</I>) [OA], Decla/im, speak rhetorically, \"spout\". <I>~i versojn</I>. <B>~a</B>, -matory, high-flown, impassioned. <B>~(ad)o</B>, -mation, oratory, <B>-aĵo</B>, harangue, <B>-arto</B>, elocution. ➞ <I>recit</I>.", "0"],
["deklari", "deklar-i", "(<I>-n, ke</I>) [OA], Declar/e. <B>1</B> Assert (make known, proclaim) explicit(formal- open-)ly. <I>~i am-(dividend-milit-)on. ~i sin amiko</I>. (cgm) call, <B>~ado</B>, <B>~aĵo</B>, <B>deklaracio</B>, [OA] -ation, announcement, manifesto, proclamation. <I>~o pri sendependeco</I>. (jur) -ation. <B>Jur~o</B>, affidavit. Ŝipestra <B>~o</B>, captain’s entry. <B>2</B> (customs) acknowledge posses sion of dutiable goods. <I>Cu vi havas ion</I> <B>~endan</B> (to declare)? ➞ <I>anonc, proklam, seiig</I>.", "0"],
["deklin(aci)i", "deklin(aci)-i", "[UV] (<I>kazfleksii</I>) (<I>-n</I>), (gram) Declin/e, inflect, <B>~ado</B>, <B>~aĵo</B>, declension. (astr) (<I>astra latitudo</I>), -ation. (ph) <B>magneta ~o</B>, magnetic -ation. <B>Ne~ebla</B>, in-able. <I>\\Ne = ri]uz.\\</I> ➞ <I>kaduk, marasm</I>.", "0"],
["deklivo", "dekliv-o", "[UV] (<I>klinita tereno</I>). Inclin/e. Slop /e, declivity, slant. (No 21<B>/15</B>, Jos 7/5). <I>~o (mal)suprena</I>, rise (fall), as-(des-)cending gradient, <B>~a</B>, i-ed, s-ing, declivitous, ris-(fall-)ing. <I>~a ebeno</I>, i-ed plane, -a <I>vojo</I>. <B>~aĵo</B>, s ing approach, as-(des-)cent, bank, ramp. <B>~i</B>, dip, rise, slant, <B>-eeo</B>, i-ation. <B>-eta</B>, gently s-ing. <B>-angulo</B>, <B>-indikilo</B>, gradient-meter. ➞ <I>glacis, klin, oblikv, talus</I>. <B>dekokt-i</B> (<I>-n</I>), Decoc/t, boil to extract essence. <B>~(aĵ)o</B>, -tion, extract. ➞ <I>ekstrakt, infuz, macer, ru</I>.", "0"],
["dekolti", "dekolt-i", "[OA] expose neck and shoulders. ~i <I>veston</I>, cut low. <B>-ita</B>, bare-necked, low-cut.", "0"],
["dekori, dekoracii", "dekor-i, dekoraci-i", "[dekoraci-i [OA]] (<I>-n</I>), Decorat/e. <B>1</B> embellish, <I>-i domon per flagoj, preĝejon per floroj</I> paper, paint (<I>ĉambron</I>). <B>2</B> invest with medal, order, etc. <B>~a</B>, -ive, <B>~ado</B>, <B>~aĵo</B>, <B>1</B> -ion, embellishment, painted work, etc. <B>2</B> (<I>distingaĵo, honor- signo</I>), distinction (badge of honour, insignia, order, ribbon, star, etc.). <B>~oj</B>, regalia (freemasonry). <B>3</B> (th) set(ting), arrangement of stage. <B>~isto</B>, (house) -or. (scene) painter. <B>~ita</B>, -ed. ➞ <I>belig, garn, ornam; medal, orden</I>.", "0"],
["dekremento", "dekrement-o", "decrement, loss by wastage.", "0"],
["dekrepiti", "dekrepit-i", "(nt) (chem) decrepitate, crackle under heat. ➞ <I>kalcin</I>.", "0"],
["dekreto", "dekret-o", "[OA] Decree, enactment, fiat, ordinance (by authty) <B>~i</B> (<I>-n, ke</I>), ordain by d., enact, order. ➞ <I>edikt, proklam, reskript</I>.", "0"],
["dekstra", "dekstr-a", "[UV]<B></B>, Right. <B>1</B> Right-Hand: <I>~a flank-(man-)o</I>, (her) dexter, (piano) <I>~a (subtend) pedalo</I>, r-h (sustaing) pedal. <B>2</B> (pol), conservative. <B>~e (de)</B>, on the r. (of). <B>~en</B>, to the r. <I>Mi iris ~en, kaj li mal~en</I>. (Se 4/27). <B>~ema</B>, <B>~uma</B>, (mec) clockwise. <I>~ena movo</I>. <B>~eco</B>, dexterity, skill. <B>~amana</B>, r-handed. <B>mal~a</B>,, [UV] left (hand), port <I>~~ema (~~uma</I>), anti-clockwise. <B>Ambaŭ~a</B>, ambidexterous. <B>IT</B> (mil) A proposal to use the abbreviationss <B>Mal! Dek!</B> for the monosyllabic commands <I>Left! Right!</I> seems worth consideration.", "0"],
["dekstrino", "dekstrin-o", "(<I>amela gumo</I>), dextrin.", "0"],
["dekto", "dekt-o", "(<I>= trit-okto</I>), (intvl), 10th. <I>~o maĵora, minora</I>.", "0"],
["delegi", "deleg-i", "(<I>-n</I>) [OA], Delegat/e, authorize as agent, commit authty (hand over one’s powers) to, depute, send as representative. <B>~(aĵ)o</B>, assignment. <B>~ito</B>, d., deputy, elected representative. <I>~o de UEA</I>. <B>~itaro</B> [<B>~acio</B> [OA] ], -tion, body of dd., commission. ➞ <I>deput, komisiion), legal, reprezent</I>.", "0"],
["delfeno", "delfen-o", "[UV] (as) (zoo), dolphin (<I>Delphinus</I>).", "0"],
["delfinio", "delfini-o", "(<I>alaŭda sprono</I>), (bot) larkspur (<I>Delphinium</I>).", "0"],
["delfto", "delft-o", "(<I>~a fajenco</I>), Delft<B>. ~aĵoj</B>, d-ware.", "0"],
["delikata", "delikat-a", "[UV] delicate. <B>1</B> (<I>milda, malforta</I>). Gentle, light, mild, pale, slight, soft, subdued. <I>~a koloro, nebulo, paŝo, spiro, tuŝo, venteto</I>. (<I>El 16/14, 1 Rĝ 19/12</I>). <B>2</B> (<I>altkvalita, subtila</I>): <I>Dainty, exquisite, fine, nice, refined. (Le 7/12). ~a atento, diferenco, distingo, faruno, gusto, mango, nuance,</I> parfumo, punto, tolo, trajto.<I> <B>3</B> (</I>facile difektebla, malfort(ik)a): <I>brittle, feeble, fragile, frail, tender</I>, ~a floro, haŭto, korpo, planto, sano, vazo.<I> <B>4</B></I> (komprenema, sentema) (<I>Rd 28/56) dainty, fastidious, sensitive, squeamish, tender:</I> ~a konscienco, orelo, pesilo, sento, virino.<I> <B>5</B> (</I>takta) <I>avoiding offence, considerate, honeyed, punctilious, tactful, with good taste (Ps 55/21</I>), ~a ago, aludo, konduto, vorto. <I><B>6</B></I> (embarasa, tikla) <I>awkward, embarrassing, requiring nice handling, ticklish:</I> ~a afero, cirkonstanco, demand, problem, situacio. <I><B>~eco</B>, daintiness, fineness, softness, refinement, tact. <B>~iĝo</B> </I>de moroj (<I>K 190/13). <B>Mal~a</B>, clumsy, coarse, crude, gross, heavy, raw, tough</I>. <B>~~ulo</B>, <I>boor, churl. ➞ dole, fajn</I>. <I>➞ barbar, krud</I>.", "0"],
["delikto", "delikt-o", "Delinqu/ency, minor crime, misdeed, misdemeanour, offence, neglect of duty. <B>~a</B>, -ent, defaulting, guilty. <B>~ulo</B>, -ent, offender. ➞ <I>krimet, kulp</I>.", "0"],
["delikveska", "delikvesk-a", "Deliques/cent, <B>~i</B>, -ce. <B>~eco</B>, -cence.", "0"],
["deliri", "delir-i", "(<I>nt</I>), [UV] be Deliri/ous, rave, wander. <B>~a</B>, -ious, frenzied, lightheaded, wildly excited. <B>~(ad)o</B>, -ium, ecstasy (of joy), frenzy (of despair). <I>Drinkula ~o</I>, delirium tremens. <B>~aĵo</B>, maunderings, incoherent mutternings of a madman. ➞ <I>ekstaz, frenez, halucin. [Ne= fantazi, rev.]</I>", "0"],
["delto", "delt-o", "Delt/a. <B>1</B> Gk letter D. <B>2</B> (geog) triangular tract. ~o <I>de Nilo</I>. <B>~ojda</B> (<I>triangula</I>), -oid. <I>~ojda muskolo (~ojdo</I>).", "0"],
["demagogo,", "demagog-o,", "[OA] Demagog/ue, agitator, mob orator. <B>~a</B>, -ic, appealing to mass prejudice. <B>~eco [~io</B> [OA]<B>]</B>, -y. ➞ <I>agit, popolflat</I>.", "0"],
["demandi", "demand-i", "(<I>al, pri; ĉu</I>), [UV] Ask (a question, for information), enquire, query. <I>~i ies opinion; pri la horo. Sin ~i (~i al si) ĉu,</I> ask one’s, wonder. <I>Oni povas ~i</I>, it may be asked. <B>~o</B>, <B>1</B> question, enquiry, query. <I>Sugesta ~o</I>, leading question. <I>La ~o restas</I> (it remains to be -ed), <I>ĉu</I>. 2 (<I>problemo, temo): ~o pri vivo aŭ morto</I>. <B>~a</B>, interro- gative. <B>~a pronomo</B>, <B>vorto. ~a signo</B>, question-mark. <B>~anto</B>, interrogator, questioner. <B>~aro</B>, questionnaire, list of questions, examination paper. ~ema, inquisit-ive-orial. <B>~ilo</B>, enquiry form. <B>Pri~i</B>, examine, submit to interro- gation. Sen-e, unquestioningly. ➞ <I>pet, postul</I>.", "0"],
["demarki", "demark-i", "Demarc/ate, mark boundary or limits. <B>~o</B>, -ation.", "0"],
["demenco", "demenc-o", "(med) dementia, insanity through brain failure. <I>~o frua, senila</I>.", "0"],
["demografio", "demograf-io", "Demograph/y. <B>~(iist)o</B>, -er.", "0"],
["demokrato", "demokrat-o", "[OA] Democra/t. <B>~a</B>, -tic. <I>~a reĝimo</I>, gvt by the people. <B>~aro</B>, <B>~eco</B>, <B>~io</B>, <B>~ismo</B>, -cy.", "0"],
["demono", "demon-o", "[UV] Demon. <B>1</B> (myth) divinity (good or evil), genius. <B>2</B> evil spirit, devil, fiend. <I>Elpeli ~ojn</I>. f <I>~o de ĵaluzo</I>. <B>~(ec)a</B>, -iac, devilish, <B>~ismo</B>, (phi) (okult), -ism. <B>~eto</B>, little imp. <B>~ulo (~havanto)</B>, -iac. Ĉef<B>~o</B>, arch-fiend. ➞ <I>anim, diabl, spirit</I>.", "0"],
["demonstrativo", "demonstrativ-o", "[OA] (<I>montra vorto</I>), (gram) demonstrative.", "0"],
["demonstri", "demonstr-i", "(<I>-n, ke</I>), Demonstr/ate. <B>1</B> Show, describe, explain (by examples or experiments), establish truth of, prove. <B>~o</B>, -tion, conclusv experiment, exhibition, explanation. <B>~anto</B>, <B>~isto</B>, -ator, lecturer. <B>~ebla</B>, -able, capable of being shown or proved. 2(pol) (a. ~ACI-i), make a -ion by public meeting, etc. ➞ <I>manifest, montr, parad, pruv</I>.", "0"],
["demoralizi", "demoraliz-i", "demoralize, corrupt, deprave, dishearten; undermine discipline (courage, spirit) of. ➞ <I>sendisciplinig, senkuraĝig</I>.", "0"],
["demotik", "", "-a, (arch) demotic (of Egyptian script). ➞ <I>hieratik</I>.", "0"],
["denaro", "denar-o", "[UV] denarius, Roman coin (from which \"d\" = penny).", "0"],
["dendrito", "dendrit-o", "(anat), (min), dendrite, with tree- or moss-like marking.", "0"],
["dendrolago", "dendrolag-o", "tree kangaroo (<I>Dendrolagus</I>).", "0"],
["dengo", "deng-o", "dengue (fever).", "0"],
["denominatoro", "denominator-o", "(<I>dividanto</I>), (mat) denominator. Opp <I>numerator</I>.", "0"],
["densa", "dens-a", "[UV] Dens/e. <B>1</B> compact, thick. <B>2</B> close (crowded) together, impenetrable, massed, serried. <I>~a arbaro, foliaro, mallumo, loĝantaro, nebulo, solvaĵo. ~aj haroj, nuboj, spikoj</I>. (typ) <I>kun ~aj linioj, literoj,</I> set solid. <B>~e</B> <I>loĝata</I>, populous. <I>~e plantita,</I> thick-set. <I>~e premita</I>, pressed tight. <B>~(ec)o</B>, -ity, relation of mass to volume, consistency, crowded state. <I>Aera ~o, Meza ~o</I>, mean (specific) -ity. <B>~ejo</B>, brake, bush, jungle, thicket (Jes 9/18). ~igi (<I>-n</I>), concentrate, condense, congeal, crowd together, thicken, <B>~igilo</B>, (phot) intensifier. <B>~iĝis</B> (El 15/8). <B>Kun~igi</B>, curdle (Ij 10/10). <B>Mal~a</B>, thin, light, loose, scanty, spare, sparse. <B>~~ega</B>, rarified (air). ~~<B>ejo</B>, clearing, glade. <B>~ometro</B>, -imeter.", "0"],
["dentalo", "dental-o", "(phon) (<I>denta konsonanto</I>), dental.", "0"],
["dentario", "dentari-o", "(bot) toothwort, coral-root (<I>Dentaria</I>).", "0"],
["dento", "dent-o", "[UV] Tooth, Dent-. <B>1</B> (anat) <I>~o karia, kava. ~o (mal)supra</I>, upper (lower) t. <B>~o Lakta</B> (<I>unua</I>), milk t. <B>~o Malfrua</B> (<I>saĝa</I>), wisdom t. <B>~o Muela</B> (<I>vanga) (molaro</I>), grinder, molar. <B>OkuKo</B> (<I>kanino</I>), canine (eye) t. <B>~o Premolara</B>, bicuspid, premolar. <B>~o Tranĉa</B> (<I>incizivo</I>) incisor. <I>La ~oj klakas</I> (chatter). <I>Agaci, grincigi, kunpremi, montri, nudigi, perdi, plombi la ~ojn</I>, set on edge, gnash (grind), grit (set), bare, lose, fill (stop), the tt. <B>~aro</B>, tt. <I>~aro artefarita</I>, d-ures. <B>~ego</B>, fang, tusk. <B>~eto</B>, denticle. <B>~ino</B>, dentine. <B>~ingo</B> (<I>alveolo</I>), t-socket. <B>~isto</B>, dentist. <B>~izi</B> (<I>iuri</I>), supply with tt. <B>~ologio</B>, odontology. <B>~apero</B>, <B>~aranĝo</B>, d-ition. <B>~kuraco</B>, dentistry. <B>~purigaĵo</B>, <B>~pasto</B>. <B>~pulvoro</B>, dentifrice. <I>Paroli</I> <B>interne</B> <I>mumble</I>. <B>Sen~a</B>, t-less. II <B>2</B> (of obj). Cog (<I>rada</I>), peak (<I>monta</I>), prong (<I>forka, rastila</I>), tooth (<I>kombila, segila</I>). <B>Rand~oj</B> (phlt) perforata. <B>~ado</B>, crenelation, indentation, perforation, serration. <B>~aĵo</B>, gearing, scalloping. <B>~(um)ita</B>, cogged, indented, notched, scalloped, toothed. <I>~ita frontono</I> (mec) (4 FA 87/8). <B>~izi</B> <I>ion</I>, cut (mill) tt in. <B>~rado</B>, cog-(gear-) wheel. <B>~radaro</B>, t-ed gearing. (ry) <B>~relo</B>, cog-rail. <B>~stango</B>, t-ed rack, ratchet. <B>En~igi</B> <I>la ~aron</I>, engage (enmesh) gears. <B>Leon~o</B> (bot) (ordinary language) <I>= leontodo</I> and <I>taraksako</I> (which see). <B>Tri~o</B>, trident. ➞ <I>cinodont, klik, krenel, not, stop</I>.", "0"],
["denunci", "denunc-i", "(<I>-n, ke</I>), [UV] denounce, accuse, inform (inveigh) against, (im)peach. <I>~i krimulon</I>. <B>~anto</B>, accuser. <B>~antaĉo</B>, <B>fi~anto</B>, malicious informer, tale-bearer, tell-tale, sneak. <B>~ema</B>, denunciatory, <B>deodar-o</B> (<I>Himalaja cedro</I>), deodar (<I>Cedrus deodara</I>).", "0"],
["departemento", "departement-o", "[OA] department (<I>administra</I>). 1 (<I>ministrejo</I>), ministerial department (office), branch of municipal or state administrate, ministry. <I>~o de milito</I>, War Office. <B>2</B> (<I>prefektejo</I>), French administrative district. <B>~a</B>, -al. <B>~estro</B>, prefect. <B>Sub~o</B>. arrondissement, ward.", "0"],
["dependi", "depend-i", "(<I>de</I>) [OA], Depend (on). <B>1</B> Count (reckon, rely, rest) upon, have confidence in. <B>2</B> be -ent (contingent) on, hang^hinge, turn (on), be at the mercy of. <I>Cio ~as</I> (It all depends) <I>de cirkonstancoj, la vetero, lia respondo. De tio ~as, iu … La decido ne ~as de mi</I>. <B>~o</B>, -ence, confidence, reliance, trust, (gr.) <B>~a</B> (subordinate) <I>klaŭzo, propozicio</I>. <B>~e de</B>, -ing on. <B>~aĵo</B> (<I>~a lando</I>), -ency. <B>~anto</B>, -ant. <B>~inda</B>, -able. <B>Ne~a</B>, in-ent. ➞ <I>pend, submetiĝ</I>.", "0"],
["depeŝo", "depeŝ-o", "[OA] Dispatch, offi communicate on state affairs, urgent written message. <B>~i</B>, send a d. ➞ <I>telegram, kabl</I>.", "0"],
["deploji", "deploj-i", "(<I>-n</I>), (mil) Deploy, draw up in line, arrange in battle formation. <B>~o</B>, -ment.", "0"],
["deponi", "depon-i", "(<I>-n, ĉe, en</I>) [OA] (<I>konfidi valoraĵon</I>), Deposit, entrust, place, leave, lodge, store (Le 6/4, Ne 13/5). <I>~i plendon</I>, lay a complaint. <I>~i monon en bankon</I>. <B>~a</B> <I>konto</I>, d. a/c. <B>~(it)aĵo</B>, d. <B>~anto</B>, -or. <B>~ejo (</B><I>tenejo</I>), safe d., cloakroom, de-(re-)pository, warehouse. ➞ <I>demet, konserv, lok, tavol</I>.", "0"],
["deporti", "deport-i", "Deport (undesirable person). <B>~ado</B>, -ation. <B>~ito</B>, -ed p.", "0"],
["depresio", "depresi-o", "(econ, met), depression. ➞ <I>ciklon, deprim</I>.", "0"],
["deprimi", "deprim-i", "(<I>-n</I>), (med) Depress, dispirit, lower (reduce) vitality. <I>~ita de malsano</I>. <B>~o</B>, <B>~iteco</B>, -ion, dejecta. ➞ <I>malgaj, prem</I>.", "0"],
["deputi", "deput-i", "(<I>-n</I>), [UV] Deput/e, appoint as substitute or representative, commit authty (task) to. <B>~ito</B>, -y, proxy, representative, understudy. <B>~itaro</B>, -ation, body of representatvs. ➞ <I>deleg, parlament, senat, reprezent</I>.", "0"],
["deriso", "deris-o", "(bot) derris (<I>Derris</I>). ~a <I>pulvoro</I>, from its root.", "0"],
["derivi", "deriv-i", "(<I>-n</I>) [OA], (chem) (gram) (mat), Derive, draw, get, obtain (from source). <I>Esti ~ita de</I>, be -ed (formed), come (from original). <B>~(ad)o</B>, -ation. <B>~aĵo</B><I>=~ita vorto (substanco</I>), -ative, -ed form. ➞ <I>devenig</I>.", "0"],
["dermesto", "dermest-o", "bacon (larder) beetle (<I>Dermestes</I>).", "0"],
["dermo", "derm-o", "(<I>subhaŭto</I>), Derm/is, true (under) skin. <B>~a</B>, -ic. <B>~atito (</B><I>haŭtinflamo</I>), -atitis. <B>~atolog-io</B>, <B>~o</B>, -atolog-y, -ist. <B>~atozo</B> (med) -atosis.", "0"],
["derviŝo", "derviŝ-o", "dervish.", "0"],
["des", "", "(<I>mal)pli</I>, [UV] (adv) the more (less). <B>1</B> in combination with <I>ju. Ju pli multaj, ~ pli gaje</I>! The more, the merrier! <I>Ju pli da folio], ~ malpli da fruktoj</I>. <B>2</B> (alon<I>e = tiom</I>), so much the (Ij 4/19, 9/14). <I>~ pli bone</I>, so much the better. <I>~ pli, ke</I>, the more (so), that.", "0"],
["desaponti", "desapont-i", "(<I>inn) (trompi esperon</I>), Disappoint, let down, not fulfil desire (expectation, hope). <B>~iĝo</B>, -ment. <B>Rim</B>.: <B>Z</B>. used <I>~ata, ~iĝi</I> (fac?). Vd BE 1945/79.", "0"],
["descend", "", "-i (<I>-n, de) (malsupreniri</I>), descend, come (go) down. <I>~i de alto</I>. <B>~a</B> (-ing) <I>aerfluo</I>. ➞ <I>dejn, deven</I>. opposite <I>ascend</I>.", "0"],
["desegni", "desegn-i", "(<I>-n</I>), [UV] Design; depict, draw, deliniate, sketch; describe (<I>cirklon</I>), paint, portray (<I>karakteron</I>). <B>~a</B> <I>papero, tabulo</I>, drawing-paper (board). <B>~(ad)o</B>, <B>~arto</B>, drawing. <B>~(aĵ)o</B>, d., drawing, diagram, plan, sketch, (➞ <I>diagram). ~o kolora, krajona</I>. <B>~isto</B>, -er, artist, etc. ➞ <I>bild, figur, lini, kontur, pentr, strek</I>. [<I>Ne = celi, intend, plani</I>, have dd. on.]", "0"],
["deserto", "desert-o", "[OA] Dessert. <B>~a</B> <I>kulero, pomo,</I> d-spoon (-apple). ➞ <I>dezert</I>.", "0"],
["desinfekti", "desinfekt-i", "(<I>-n per) (malinfekti, seninfektigi</I>), Disinfect, cleanse from infection, destroy disease germs. <I>~i ĉambron, vundon</I>. <B>~aĵo</B>, -ant. <B>~ilo</B>, -or.", "0"],
["desmodio", "desmodi-o", "moving (telegraph) plant (<I>Desmodium</I>).", "0"],
["despoto", "despot-o", "[OA] Despot, absolute or tyrannical ruler. <B>~i</B>, act as d., oppress, tyrannize. <B>~a</B>, -ic. <B>~eco</B>, <B>~ismo</B>, -ism, arbitrary rule. ➞ <I>absolut, diktator, tiran</I>.", "0"],
["destini", "destin-i", "(<I>-n, al, por, -i</I>) [OA] (<I>antaŭdecidi</I>), Destin/e. <B>1</B> (for purpose): appoint, devote, foreordain, intend, reserve, set apart. <I>~i kolekton al muzeo (lokon por io). 1</I> doom, fate, fix the -y of. <B>~iĝo</B> <I>morti (al morto</I>), doomed to death. <I>La sorto ~is, ke</I>, fate has determined. <B>~o</B>, <B>~(it)aĵo</B>, -ation, -y, appointed fate or place, intended purpose, lot, predetermined event (Le 6/18, 7/34). <B>Antaŭ~i</B>, <B>~~o</B>, <B>~~ism</B>, pre-ateation. ➞ <I>asign, decid, determin, disport, fatal, rezerv, sort</I>.", "0"],
["destrojero", "destrojer-o", "(mil, mar) destroyer.", "0"],
["detalo", "detal-o", "[UV] (<I>ereto</I>), <B>1</B> Detail, circumstance, item, particular, minutia. <I>Droni en ~oj. Memori ĉiun ~on</I>. <B>~a</B>, -ed, circumstantial, close, full, precise. <I>~a analizo, inspekto, raporto. ~a rakonto,</I> minute account, <B>~e</B>, in d., item by item. <I>Raporti, skribi ~e</I>. <B>~i</B> (<I>-n</I>), enumerate, go into (give) dd, relate in full. <B>~ado</B>, enumeration, etc. <B>~a]o</B> (<I>bagatelo</I>). <B>~ema</B>, prolix. <B>~eto</B>, trifling d. <I>Priskribi</I> <B>sen~e</B>, <B>give</B> a gen. impression, rough idea. ➞ <I>bagatel, cirkonstanc, speci</I>. <B>2</B> (com) -a (<I>pomalgranda</I>), Retail. <I>~komerco. Vendi (po)~e</I>. <B>~isto</B>, r-er.", "0"],
["detekti", "detekt-i", "Detect. <B>1</B> discover, find out fact, (presence, existce) of. <B>2</B> (ph, rad) <B>~ilo</B>, -or, high frequency rectifier, <B>~ilo</B> kristala, magneta, valva.", "0"],
["detektivo", "detektiv-o", "(<I>detektisto</I>), (police) detective. <B>~a</B> <I>romano</I>.", "0"],
["determini", "determin-i", "(<I>-n</I>) [OA], Determin/e, ascertain precisely, decide, define, fix, limit in scope, resolve, settle (dispute, question, uncertainty). <I>~i distancon, kaŭzon de akcidento, motivon de ago, pozicion, punkton, signifon de vorto, specion de planto</I>. <B>~o</B>, -ation. <B>~a</B>. -ant, -ing, deciding. <B>~anto</B>, (mat) -ant. <B>~ismo</B>, <B>~isto</B>, -ism. -ist. Ne<B>~ebla</B>, in-able. ➞ <I>decid, fiks</I>.", "0"],
["detrui", "detru-i", "(<I>-n</I>), [UV] Destr/oy, break up, demolish, pull down, overthrow, ruin, shatter (ij 12/14). <I>~i armeon, domon, esperon, peston, rikolton, sanon, vivon</I>. <B>~(em)a</B>, -uctive, deadly, subversive; merely negative (<I>~a kritiko</I>). <B>~o</B>, <B>(~it)aĵo</B>, destruction (Jeh 36/36). <B>~emo</B>, (<I>huliganismo</I>) vandalism. <B>~enda</B>, that must be -ed. <B>~iĝi</B>, perish. <B>For~i</B>, annihilate, efface, raze to the ground. <B>Ne~ebla</B>, indestructible. ➞ <I>disbat, eksterm, dezertig, falig, neniig, pereig, ruinig</I>.", "0"],
["deŭterio", "deŭteri-o", "deuterium, isotope of hydrogen.", "0"],
["deŭterono", "deŭteron-o", "deuteron.", "0"],
["deŭtzio", "deŭtzi-o", "(bot) deutzia, oriental shrub.", "0"],
["devaluti", "devalut-i", "devaluate, cheapen (currency). <B>~o</B>, devaluation.", "0"],
["devii", "devi-i", "(etim. <I>devojiĝi</I>), Deviat/e, digress, diverge, swerve, turn aside (from normal). <I>de celo, principo, vojo, vorto</I>. <B>~o</B>, deviation, deflection, declination, divergence, variation. <I>~o de kompasa montrilo</I>, <B>Angula ~o</B>, angle of -ion. <I>~o probabla, venta</I>. <B>~igi</B>, deflect, divert, turn aside. ➞ <I>aberaci, deklin, driv, ekart</I>.", "0"],
["devizo", "deviz-o", "[UV] device, emblematic, heraldic design, motto. ➞ <I>emblem, mot</I>.", "0"],
["devo", "dev-o", "[UV] (<I>farendaĵo</I>), Duty, Oblig/ation. <I>Fari sian ~on</I>, do one’s d. <B>~i</B>, have the d. of -ing. <I>Mi ~as iri</I>, It is my d. (I am bound, o-ed), to go, I have (got) to go, I must go, it is incumbent on me to go. <I>Necese ~as,</I> needs must. <I>Mi ~is iri</I>, It was my d., I had (was bound, o-ed) to go. <I>Mi ~os iri morgaŭ</I>, I am (shall have) to go tomorrow. <I>Mi ~us iri, se</I>, I should have to go, if… . IT <I>Li</I> ne <B>-as</B> <I>iri</I>=it is not his d. to go, he is not o-ed (hasn’t got) to go, need not go (unless he wants to). <I>Ili</I> <B>ne ~is</B> (didn’t have to) (3 FA/11). <I>Li~as</I> <B>ne Iri =</B> it is his d. not to go (he must not go). <I>Mi ~is ne dormi</I>, I had to keep awake, <I>Ni faris tion, kion ni ~is ne fari</I> (➞ Jona 4/11). II Z. and early writings often ignore this distinction. II <I>Devus</I> is used also (without a following <I>se</I>) for <I>ought, should. Vi ~us iri,</I> you ought to (should) go. <B>~igi</B>, [UV] <B>~ligi</B> (<I>fun iri</I>), compel, constrain, force, necessitate. <B>Prem~igi (Trud~igi)</B>, exert pressure on, coerce. <B>~igu</B> <I>ŝin</I> (make her) <I>manĝi. Sin</I> <B>~(ont)igi</B>, bind one’s, engage. <B>~igo</B>, coercion, compulsion, force, pressure, etc. <B>~iga</B>, <B>1</B> o-atory, compulsory. <I>~iga formalaĵo</I>. <B>2</B> essential, indispensable. <I>~iga fako</I>. <B>-libera</B>, free of dd. <B>El~igi</B> (<I>ion de iu</I>), extort, wrest. <B>Kontraŭ~a</B>, contrary to d., disloyal, undutiful. <B>Laŭ~a</B>, as in d. bound, due, loyal. <B>Ne~iga</B>, facultative, optnl. <B>Preter~a</B>, supererogatory. ➞ <I>deĵor, end, neces, nepr, ofic, task, it</I>.", "0"],
["devonio", "devoni-o", "(geol) (<I>~a periodo</I>), devonian.", "0"],
["dezerto", "dezert-o", "[UV] Desert, waste, wilderness; barren, tree- and water-less place. <I>Prediki en ~o</I>, speak to the wind, talk to deaf ears. <B>~a</B>, barren, desolate, uncultivated, unfrequented, uninhabited, unoccupied (Ge 1/2). <B>~ano</B>, <B>~ulo</B>, d-dweller. ➞ <I>ermit</I>. <B>~eco</B>, desolation (Mt 24/15). <B>~igi</B>, devastate, lay waste, ravage (Le 26/32). <B>~iĝi</B> (Ps 69/25). ➞ <I>ĥaos, kaos, senhom, senviv, solec, sovaĝej, step</I>.", "0"],
["deziri", "dezir-i", "(<I>-n, -i, ke -u</I>), [UV] Desire, want, wish (for) (to). <I>Mi ~as dormon (dormi), manĝon (manĝi). Kion vi ~as?</I> What do you want? What word you like? What can I do for (show) you? <I>Mi ~as al vi feliĉon (ke vi estu feliĉa</I>), I wish you happiness, want you to be happy. <B>~o</B>, wish, etc. <I>Bon~oj</I>, good wishes, respects. <I>Kama ~o</I>, concupiscence, sexual appetite. <B>~egi</B>, crave, hanker after, long (yearn) for. ➞ <I>ard, sopir</I>. <B>~ema</B>, -ous, anxious, eager. <B>~igi</B>, make one long for. <B>~inda</B>, -able (Ge <B>3/6)</B>. <I>~inda celo</I>. <B>Laŭ~e</B>. to one’s liking. <B>Mal~i</B>, disdain, reject with scorn. ➞ <I>ambici, aspir, soif, vol</I>.", "0"],
["di", "di-", "(ch pfx), di-, denotes compounds connecting two atoms of an element in one substance, e.g., <I>diklorido, dioksido, disulfido</I>. ➞ <I>bi-</I>.", "0"],
["diabeto", "diabet-o", "[OA] Diabet/es. <B>~a (~ulo)</B>, -ic.", "0"],
["diablo", "diabl-o", "[UV] devil. <B>~a</B>, -ish, diabolic, fiendish, infernal, satanic. <B>~aĵo</B>, -ry. <B>~eto</B>, imp. <B>~ino</B>, she-d. <B>f</B> shrew, virago, vixen. ➞ <I>furi, meger</I>. <B>diabol-o</B>, (gm) diabolo.", "0"],
["diademo", "diadem-o", "[OA] diadem, crown, plain or jewelled fillet (headband), denotes distinction or glory. ➞ <I>tiar</I>.", "0"],
["diafana", "diafan-a", "[OA] (<I>lumtralasa, sed ne necese travidebla</I>), diaphanous, semi-transparent, translucent. <I>~a materialo, ondo, vazo,</I> <B>Mal~a</B>, opaque.", "0"],
["diafragmo", "diafragm-o", "[OA] diaphragm (wide sense). <B>1</B> (anat) midriff. <B>2</B> (bot) (zoo) (tech) (<I>disigilo</I>), thin lamina or plate, partition. <B>3</B> (opt) (phot) stop (opaque disc with circular hole). <I>~o irisa</I>. <B>~i</B> (stop down) <I>lenson</I>. ➞ <I>pari, vand</I>.", "0"],
["diagnozi", "diagnoz-i", "(<I>-n</I>) [OA], Diagnos/e. <B>1</B> determine from symptoms the nature of disease. opposite <I>prognoz</I>. <B>2</B> (bot. zool), formally describe (plant, etc.) <B>~o</B>, -is. <B>~a</B> <I>scienco</I>, -tics.", "0"],
["diagonalo", "diagonal-o", "[OA] <B>~a</B>, diagonal, (typ) shilling-stroke (/).", "0"],
["diagramo", "diagram-o", "Diagram, illustrative linear figure (representation, sketch), (rad) <I>~o cirkvita, kalibra, konekta</I>. <B>~a</B>, -matic.", "0"],
["diakono", "diakon-o", "[OA] Deacon (wide sense). <B>~a</B>, diaconal. <B>~(ad)o</B>, <B>~(ar)o</B>, diaconate, <B>~eco</B>, -ship. <B>~ino</B>, -ess. <B>Ĉef~o</B>, arch-d.", "0"],
["diakrita", "diakrit-a", "diacritical, distinguishing, distinctive, <B>~o</B> (<I>~a signo</I>), sign added to letter (accent, cedilla, circumflex, etc.).", "0"],
["dialektiko", "dialektik-o", "[OA] dialect/ics, critical examination, investigation by discussion into truth of opinion. <B>~isto</B>, -ician.", "0"],
["dialekto", "dialekt-o", "[OA] Dialect, patois, special form of speech, subordinate variety of language peculiar to district, class, or person. <B>~a</B>, -al, <B>~ologio</B>. ➞ <I>idiom, ĵargon, slang</I>.", "0"],
["dializi", "dializ-i", "(<I>-n</I>), (chem) Dialys/e, separate by diffu sion through a parchment membrane. <B>~o</B> (<I>osmoza disiĝo</I>). -is. <B>~ilo</B>, -er.", "0"],
["dialogo", "dialog-o", "[OA] dialogue, colloquy. <B>1</B> talk between two or more persons. ➞ <I>monolog</I>. 2 (lit) work in conversationl form.", "0"],
["diamanto", "diamant-o", "[UV] diamond. <B>~a</B> <I>ringo</I> (with dd). (typ) d., pt. <B>~eca</B>, sparkling. <I>~a rosguto</I>. ➞ <I>briliant, karo, lozanĝ, romb</I>.", "0"],
["diametro", "diametr-o", "[OA] Diamet/er, straight line through centre. <B>Interna ~o</B>, bore (➞ <I>kalibr</I>). <B>~a</B>, -rical. ➞ <I>radius</I>.", "0"],
["dianto", "diant-o", "[OA] Pink (<I>Dianthus</I>). <B>Barba ~o</B>, sweet William. <B>Kariofil~o</B>, clove-p., carnation. (<I>D. caryophillus</I>). <B>~(kolor)a</B>, P-", "0"],
["diapazono", "diapazon-o", "[OA] diapason. Best reserved for the meaning (org) diapason (= <I>fundamento</I>) tone. For its many other meanings in various langs, use <I>akord, ampleks, harmoni, okt(av), piĉnorm, skal, tonfork,</I> as the case may be.", "0"],
["diapozitivo", "diapozitiv-o", "lantern slide, transparency (positive photo).", "0"],
["diareo", "diare-o", "(med) diarrhoea &gt; <I>laks</I>.", "0"],
["diastazo", "diastaz-o", "(chem) diastase, enzyme converting starch to sugar. ➞ <I>enzim</I>.", "0"],
["diastolo", "diastol-o", "diastole, dilation of heart or artery. Opp <I>sistol</I>.", "0"],
["diatomo", "diatom-o", "(bot) diatom (<I>Diatoma</I>).", "0"],
["diatona", "diaton-a", "(<I>laŭgamsigna</I>), (mus) diatonic. <I>~a akord-(interval-skal-)o</I>. Opp <I>kromat</I>.", "0"],
["diatribo", "diatrib-o", "diatribe, abusive tirade, bitter criticism (denunciation, invective).", "0"],
["diboĉi", "diboĉ-i", "(nt), [UV] give one’s up to (indulge in) excess, be licentious (dissolute), go to the dogs, sow wild oats. ~(em)a, dissipated, dissolute, profligate. <B>~o</B>, sensual indulgce. <B>~eto</B>, spree. ~igi (<I>-n</I>), debauch, corrupt, deprave, lead astray, pervert. <B>~ulo</B>, libertine, rake, roue. ~ulino, wanton. Per~(Tra~)i, spend in riotous livg, squander. ➞ <I>fordrink, malŝpar</I>). Mal<B>~i</B>, ➞ <I>asket</I>.", "0"],
["didaktika", "didaktik-a", "[OA] (<I>instrua</I>), meant to instruct. <B>~e</B>, didactically, as a teacher. ~ema, too much inclined to lay down the law. Aŭto~a <I>= sininstrua</I>. ➞ <I>pedagogi</I>.", "0"],
["didelfo", "didelf-o", "(zoo), [UV] opossum (<I>Didelphus</I>). ➞ <I>oposum</I>.", "0"],
["dido", "did-o", "dodo (extinct bird) (<I>Didus ineptus</I>).", "0"],
["dielektra", "dielektr-a", "(ph) dielectric, insulating, non- conducting. ~o, <I>~a substanco</I>.", "0"],
["diereso", "dieres-o", "(<I>dusilabigo</I>), diaeresis. <B>1</B> separation between two vowels. 2 (<I>~a signo, tremao</I>). ➞ <I>aferez, diftong</I>.", "0"],
["dieso", "dies-o", "(wo), (mus) Sharp. Du~o (<I>isiso</I>), double s. ~igi (<I>isigi</I>), -en.", "0"],
["dieto", "diet-o", "[OA] <B>1</B> Diet, habitual fare (food). <B>2</B> -ary, regimen. <I>~o frukta, miksita, vegetara</I>. <B>~a</B>, -etic. <I>~a regularo</I>. <B>~i</B>, be on a d. <B>~ado</B>, -ing. <B>~isto</B>, -ician. <B>~oscienco</B>, -etics. <B>3</B> (in some countries) parliament.", "0"],
["difekti", "difekt-i", "(<I>-n</I>), [UV] damage, blight, hurt, impair, injure, spoil. <I>~i brakon, Qam, honoron, manĝon, objekton, sanon. Unu ovo malbona tutan manĝon ~as</I>. <B>~(et)o</B>, blemish, failing, fault, flaw, imperfecta, shortcoming, weak spot (Ne 6/1). <I>En ĉiu objekto troviĝas ~o</I>. (el) <I>~o terkonekta</I>, earth fault, <B>~aĵo</B>, throw-out. <B>~ebla</B>, fragile, vulnerable. <B>~iĝi</B> (nt), deteriorate, spoil, suffer d. <B>~iĝema</B>, perishable. <B>~(it)a</B>, addled, chipped, damaged, spoiled, tainted, defective, faulty, unsound. <B>Ne~ita</B>, <B>Sen~a</B>, flawless, intact, inviolate, safe and sound, unaffected (unhurt, uninjured), whole. <B>Bat~i</B>, batter. <B>Skrap~o</B>, abrasion. ➞ <I>damaĝ, kriplig, malutil, romp, vund; malper- fektaĵ, mank. [Ne= domaĝ]</I>.", "0"],
["diferenci", "diferenc-i", "(nt) (<I>de, inter, je, per</I>) [UV] (<I>malsami</I>), Differ, be -ent (distinguishable from). <I>~i inter si</I>, be -ent from one another. <B>~a</B>, -ent, not the same, unlike, <I>~a de = alia ol, malsama ol</I>. <B>~o</B>, difference, contrast, disagreement, discrepancy, diversity, unlikeness (Ge 1/18). ➞ <I>distanc, kontrast. ~o inter A kaj B. ~o de gusto. Tio faras ~on. Ne ~as</I>, it makes no odds, (rad) <I>~o potencialo, tensia</I>. <B>~igi</B> (<I>fari ~on</I>), -iate, discriminate, distinguish, keep apart. ➞ <I>disting, malkonfuz</I>. <B>~igilo</B>, distinguishing mark. <B>Sen~a</B>, without exception. <B>~otono</B> (<I>subtono</I>), (ac) difference tone.", "0"],
["diferencialo", "diferencial-o", "(wide sense), (mat) (mec) (ph), differential. <I>~a kalkulo, tabelo</I>.", "0"],
["difini", "difin-i", "(<I>-n</I>), [UV] Defin/e, settle limits of, give exact meaning, make clear (early writings also = <I>determini, destini). ~i celon, salajron, sencon</I>. <B>~a</B>, -ing. <B>~ita</B>, -ed, -ite, fixed, precise, set, with exact limits, not vague. <I>~ita cello, formo, konturo, signifo. Sen kialo ~ita,</I> for no particular reason. <B>~(aĵ)o</B>, -ition. <B>~eco</B>, degree of distinctness, (gram) <B>Ne~a</B>, <B>Sen~a</B>, in-ite (article, pronoun, etc.). <B>Ne~ebla</B>, in-able. <B>Ne~ita</B>, un-ed, unsettled, vague. ➞ <I>definitiv, fiks, precizig</I>.", "0"],
["difrakti", "difrakt-i", "(<I>-n</I>), (opt) Diffract, deflect and break up (as with light passed through a slit). <B>~o</B> -ion. <B>~a</B> <I>krado</I>, -ion grating. ➞ <I>dispers, interfer</I>.", "0"],
["difterito", "", "[OA] diphteria. <I>~a sufoko</I>.", "0"],
["diftongo", "diftong-o", "[OA] (<I>vokalglito</I>), Diphthong, two vowels glided into one syllable (<I>aj, ej, oj, uj; aŭ, eŭ, oŭ</I>). <B>~i</B>, -ize.", "0"],
["difuzi", "difuz-i", "(<I>-n</I>) (<I>malkoncentri</I>), Diffus/e, shed abroad, spread widely. <I>~i lumon, varmon</I>. ~ita, -ed, not localized, <I>~ita lumo, radiado, reflekto, sono, stimulo</I>. <B>~o</B>, -ion, scattering. <I>~o gasa, luma, radia</I>. <B>~igi</B>, run (of dye in washing). <B>~ilo</B>, -or. ➞ <I>dializ, osmoz</I>.", "0"],
["digesti", "digest-i", "(<I>-n</I>), [UV] Digest. <B>1</B> prepare food for assimilation. <B>2</B> (tech) soften and prepare by heat, etc. <B>f</B> absorb mentally, take in, think over. <I>~i ideon, libron</I>. <B>~a</B>, -ive, <B>~o</B>, -ion. <B>~ebla</B>, -ible. <I>Ofendo malfacile <B>~ebla</B></I>, difficult to stomach (swallow). <B>~aĵo</B>, -ive, stomachic, peptic. <B>Mis~o</B>, in-ion. ➞ <I>dispepsi</I>.", "0"],
["digitalo", "digital-o", "(bot) foxglove (<I>Digitalis</I>), from which <B>~ino</B>, digitalin.", "0"],
["digno", "dign-o", "[OA] (Ge 49/3), Digni/ty, high (honourable) position, worth. <B>~(oplen)a</B>, -fled, elevated, stately, <I>~a parolmaniero, sinteno. Fari ~oplenan eniron</I>, sail into the room. <B>~igi</B>, -ify. <B>~ulo</B>, -itary, someone -fled, (col) big-wig. <B>Ne~a</B>, <B>Sen~a</B>, infra dig., un-ified. ➞ <I>grandsinjor, indkonsci, majest, sinrespekt</I>.", "0"],
["digo", "dig-o", "[UV] (<I>remparo kontraŭakva</I>), breakwater, dam, dyke, embankment, jetty, mole, sea-wall, weir, <B>f</B> (<I>defenda barilo</I>), barrier, bulwark, defence. <I>~o de prudento</I>. <B>~i</B> dam, confine, embank, shut in. <I>~i akvon, riveron</I>. (Ij 12/15). <B>f</B> <I>~i koleron</I>. ➞ <I>bar, brid, haltig. (Ne~~fos.\\</I>", "0"],
["digramo", "digram-o", "digraph, two letters for one sound, e.g., <I>sh = ŝ, ea</I> in <I>head</I>.", "0"],
["dika", "dik-a", "[UV]. <B>1</B> Thick: <I>~a fingro, libro, papero, trance, volumo</I>. <B>2</B> (person) (<I>vastkorpa</I>). corpulent, fat, stout. <B>3</B> (mus) <I>~a registro</I> (t. register) <I>de la voto</I>. <B>4</B> (<I>obtuza</I>): indistinct, muffled. <I>~a voĉo</I>. <B>5</B> (<I>firm-konsista); ~a pasto, supo</I>. 6 crowded, closely set: <I>~a arbaro. heĝo</I>. <B>~(ec)o</B>, -ness. <B>~e</B> <I>ŝmiri, tranĉi. ~e muelita,</I> coarse-ground. <I>~e presita</I>, in bold (clarendon) type. <I>Arboj kreskas (neĝo falas) ~e</I>. <B>~aĉa</B>, bloated. <B>~aĵo</B>, chunk, etc. <B>~eta</B>, plump. <B>~igi</B> (phot) intensify. <B>~iĝo</B> (Re 32/15). <B>~ulo</B>, fat man. <B>~malalta</B>, dumpy, squat, stocky. <B>Mal~a</B>, thin, lean, meagre, slender, slim, tenuous; weak (<I>fluido</I>). ➞ <I>diluit. ~~e muelita</I>, fine ground. <B>~~</B><I><B>ega</B></I>, fine (<I>hard</I>), thin (<I>lato</I>). ➞ <I>dens, gras, larĝ, ŝvel</I>.", "0"],
["dikruro", "dikrur-o", "(technical language) = <B>drongo</B> (ordinary language).", "0"],
["diktamno", "diktamn-o", "ditanny (<I>Dictamnus Creticus). Blanka ~o</I> (<I>D</I>. <I>alba</I>) is the \"burning bush\" of the garden.", "0"],
["diktatoro", "diktator-o", "[OA] Dictator, absolute ruler, <B>f</B> person with absolute authty. be master of, domineer, govern absolutely, hector, lord it over. <B>~ado</B>, <B>~eco</B>, -ship. <B>~(em)a</B>, d-ial, domineering, imperious, masterful, overbearg, peremptory. <I>~a tono</I>. ➞ <I>arbitr, aŭtokrat, despot, tiran</I>.", "0"],
["dikti", "dikt-i", "(<I>-n, abs</I>) [UV]. Dictat/e. <B>1</B> (to writer): <I>~i leteron</I>, <B>2</B> (<I>or done altrudi</I>): enjoin, give (impose, prescribe) orders, lay down (the law). <I>~i kondiĉon, konduton, prezon, regulon</I>. <B>3</B> (<I>instigi</I>): suggest, tell. <I>Faru, kion ~as al vi la koro</I> (what your heart tells you). <B>~(ad)o</B>, d., -ion, authtive direction (of conscience, reason, etc.). <I>Skribi laŭ (sub) ~o</I>, <B>~aĵo</B> (early writings <I>~ato</I>), -ion, matter -ed. <B>~ilo</B> = <B>1 ~afono</B>, -aphone. <B>2 ~ografo</B>, -ograph.", "0"],
["dilati", "dilat-i", "(<I>-n</I>) (<I>pli-larĝ-vast-igi</I>), Dilat/e, (ph) distend, enlarge, expand, extend, stretch, widen. <I>~i amplekson, aperturon, koron, stomakon, okulon</I>. <B>~a</B> <I>muskolo</I>, -or. <B>~(iĝ)o</B>, -ation, elongation, expansion. <B>~ebla</B>, -able. <B>~iĝi</B> (nt), d., expand, swell. <I>La poroj, pupiloj ~iĝis</I>. <B>Mal~(iĝ)i</B>, contract, shrink. ➞ <I>duktil, elast, etend, varik</I>.", "0"],
["dilemo", "dilem-o", "[OA] dilemma, choice between two alternatvs (evils), <B>f (</B><I>embaraso) \"inter martelo kaj amboso\"</I>, difficulty, fix, quandary, straits. <B>En~igi</B>, drive into a corner, put into a fix.", "0"],
["dilenio", "dileni-o", "dilenia, tropical Asian tree (<I>Dilenia</I>).", "0"],
["dileti", "dilet-i", "(nt), dabble, toy with as a hobby. <B>~a</B>, amateurish, not thorough, trifig. <B>~anto</B>, [OA] dabbler, dilettante, smatterer. <B>~(ant)eco</B>, <B>~(ant)ismo</B>, amateurism. ➞ <I>amator, hobi</I>.", "0"],
["diligenta", "diligent-a", "[UV] Diligen/t, assiduous, hard-working, industrious, painstaking, sedulous, steady in application. <I>~a atento, laboro, lernanto, mano</I>. <B>~i</B>, be d. <B>~o</B>, -ce, application, industry, persistent effort. <B>~ulo</B> (Se 10/4). <B>Mal~a</B>, inactive, indolent, inert, lax, lazy, slothful. <B>~~i</B>, idle, laze. <B>~~ulo</B>, lazy-bones, sluggard. ➞ <I>agem, atent, fervor, inert</I>.", "0"],
["diliĝenco", "diliĝenc-o", "(hist) diligence, public stagecoach.", "0"],
["dilo", "dil-o", "deal, plank. Vd <I>lign</I>.", "0"],
["dilui", "dilu-i", "(<I>-n</I>) Dilu/te, reduce strength of, thin, weaken (fluid by adding water), <B>f</B> water down, diminish brilliance, etc. <I>~i doktrinon, fervoron, koloron</I>. <B>~ita</B>, -ted, weak. <B>~(aĵ)o</B>, -tion. <B>~ilo</B>, -ent.", "0"],
["diluvio", "diluvi-o", "(geol) diluvium. <B>~a</B>, diluvial.", "0"],
["diluvo", "diluv-o", "[OA] (<I>inundego</I>), deluge, great flood (Ge 6/17). <B>f</B> <I>Pluvi</I> <B>~e</B>. <B>~a</B>, diluvia. <B>Antaŭ~a</B>, antediluvian, <B>f</B> old-fashioned.", "0"],
["dimanĉo", "dimanĉ-o", "[UV] Sunday, the Lord’s day. <I>Palma ~o</I>. <B>~a</B>, <B>~e</B>, on S. <I>Observi la ~on. ~aj vestoj</I>, S-best. <B>Ĉiu~a</B>, <B>~e</B>, every S. ➞ <I>sabat</I>.", "0"],
["dimensio", "dimensi-o", "[OA] Dimension, measurable extent, size (area, breadth, length, thickness, volume). <I>La tri ~oj, La kvara ~o</I>. <B>Tri~a</B>, three-al. ➞ <I>grad, grand, mezur</I>. <B>Rim</B>.: Vd la libron <I>Platlando</I> en la BEA Biblioteko.", "0"],
["diminuendo", "diminuend-o", "<B>~a</B>, <B>~e</B>, (mus) diminuendo.", "0"],
["diminutivo", "diminutiv-o", "(<I>etiga vorto</I>), (gram) diminutive, <B>e.g.</B>, <I>et</I>.", "0"],
["dinamiko", "dinamik-o", "[OA] -ics. <I>Aero~iko, astro~iko, elektro~iko, hidro~iko</I>. <B>~ika</B>, -ic. <B>~ismo</B>, -ism. <B>f</B> vitality.", "0"],
["dinamito", "dinamit-o", "[OA] <B>~i</B>, dinamite. ➞ <I>nitroglicerin</I>.", "0"],
["dinamo", "dinam-o", "dynamo.", "0"],
["dinamometro", "dinamometr-o", "[OA] dinamometer.", "0"],
["dinastio", "dinasti-o", "[OA] dynasty, line of hereditary rulers. ➞ <I>dom, famili</I>.", "0"],
["dingo", "ding-o", "dingo, Australian wild dog (<I>Canis dingo</I>).", "0"],
["dino", "din-o", "(<I>fortunuo</I>), (ph) dyne, unit of force. Mega~o.", "0"],
["dinosaŭro", "dinosaŭr-o", "(pal) dinosaur.", "0"],
["dinoterio", "", "dinothere.", "0"],
["dio", "di-o", "[UV] God, a god. <I>~o vin benu</I>, G. bless you. <I>~o volu!</I> May G. grant! <I>Se ~o volos</I>, G. willing, please G. <I>Hejmaj ~oj,</I> household gg. <B>~a</B>. divine. <I>La ~a regn- (yol-)o. Erari estas home, pardoni ~e</I>. <B>~aĵo</B>, <B>~eco</B>, deity, divinity. <B>~igi (</B><I>apoteozi</I>), apotheosize, deify, <B>f</B> idolize, make a little <B>g</B>. of. <B>~ino</B>, -dess. <B>~ismo</B>, deism. <B>~isto</B>, deist. <B>~favoro</B>, grace, divine favour. <B>~servo</B>, divine service, public worship (➞ <I>kult</I>). <B>~otima</B>, -fearing. <B>Sen~a</B>, atheistic, godless.", "0"],
["diocezo", "diocez-o", "(<I>episkopa distrikto</I>), Dioces/e. <B>~a</B>, -an. <B>~ano</B>, <B>~estro</B>, -an. ➞ <I>eparĥi</I>.", "0"],
["diodo", "diod-o", "(<I>duelektroda valvo</I>), (rad) diode.", "0"],
["diodonto", "diodont-o", "globe-(porcupine-) fish, prickly glove, sea-hedgehog. (<I>Diodon</I>).", "0"],
["dioneo", "dione-o", "(bot) catch-fly, Venus’ flytrap (<I>filonaea</I>).", "0"],
["dioptro", "dioptr-o", "(opt) diopter.", "0"],
["dioramo", "dioram-o", "diorama, peep-show. ➞ panoram.", "0"],
["diorito", "diorit-o", "(min) diorite.", "0"],
["dioskoreo", "dioskore-o", "yam (<I>Dioscorea</I>). ➞ <I>batat, ignam</I>.", "0"],
["diospiro", "diospir-o", "persimmon pear (<I>Diospyrus virginiana</I>).", "0"],
["dioto", "diot-o", "cotton weed (<I>Diotis</I>).", "0"],
["dipleksa", "dipleks-a", "(<I>dusenda samdirekte</I>), (<I>tel) diplex</I>.", "0"],
["diplomato", "diplomat-o", "[F], diplomat(ist), adroit negotiator. <B>~a</B>, -ic, adroit, non-commital. <I>~a ago, karaktero, parolo, procedo, respondo, servo</I>. <B>~eco</B>. <B>~io</B> [F], (pol) diplomacy. management by negotiation. <B>f</B> adroitness, discretion.", "0"],
["diplomo", "diplom-o", "[OA] diploma, certificate conferring honour, licence, privilege. <I>~o doktora, profesora. ~o pri nobeleco,</I> patent of nobility. (<I>iun</I>), grant a diploma to. <B>~ita</B> <I>instruisto</I>, certificated teacher. <B>~ito</B>, qualified person. ➞ <I>atest, brevet, cart, patent</I>.", "0"],
["diplotakso", "diplotaks-o", "(bot) sand-rocket, wall-rocket (<I>Diplotaxis</I>). <B>~o mura</B>, stinkweed.", "0"],
["dipodo", "dipod-o", "(<I>a. ĝerboso), &gt;</I> jerboa (<I>Dipus, Jaeulus</I>), jumping-mouse <I>Zapus</I>).", "0"],
["dipsako", "dipsak-o", "Teazel (<I>Dipsaeus</I>). <B>Ful~o</B>, fuller’s t. (<I>D. sativus</I>).", "0"],
["dipsomanio", "dipsomani-o", "dipsomania, craving for alkohol. <B>~ulo</B>, <B>~a</B>, dipsomaniac.", "0"],
["dipteroj", "dipter-oj", "diptera (= flies, gnats, midges).", "0"],
["diptiko", "diptik-o", "(<I>bildo, skribo, dupanela</I>), diptych. ➞ <I>triptik</I>.", "0"],
["direkti", "direkt-i", "(<I>-n, al, kontraŭ</I>), [UV] Direct. <B>1</B> Turn (a make go) towards: <I>~i atenton, iron, parolon, rigardon, okulojn. ~i la paŝojn,</I> bend one’s steps<I>. Sin ~i al</I>, head (make) for, wend one’s way to. <B>2</B> Administer, control, manage, run, superintend (➞ <I>estr, reg</I>): <I>~i firmon, laboron. Homo projektas, Dio ~as</I>. <I>Conduct (orkestron), edit</I> (<I>ĵurnalon</I>). <B>3</B> (al~i, celigi), <I>address, aim, level;</I> ~i <I>akuzon, demandon, peton, sarkasmon</I>; <I>bring to bear, point, train</I>. ~i <I>pafilon, teleskopon</I>. <B>4</B> Drive, guide, lead, steer (a. <I>stiri</I>): <I>~i aŭton, diskuton, ŝipon, venton</I> (El 10/13) <B>~o</B>, [UV] direction, bearing, course, guiding line. <I>~o horizontala, vertikala. Doni ~on al la vivo. Ŝanĝi la ~on, alter one’s course</I>. En (Laŭ, Sur) la ~o al (~e al), <I>towards, (mar</I>) <I>~o kompasa, magneta, vera</I>. <B>~a</B>, directing, guiding, ruling, directorial <I>[Ne= rekta]. ~a anteno</I>, (av) -ional aerial. <I>~a magneto</I>, control magnet. <I>~a pedalo</I> (av) rudder pedal. <I>~a (rudra) stango</I>, driving rod, helm, tiller. <B>~ado</B>, conduct, control, guidance, management etc. <I>Labori sub ies ~ado</I>. <B>~ebla</B> (<I>balono</I>), dirigible, <B>f</B> docile, tractable. (<I>Kompasa</I>) <B>~i ĝo</B>, orientation. <B>~ilo</B> [UV] (<I>stirilo</I>), handlebar, helm, rudder (<I>rudro</I>). <B>~ila rado</B>, <I>steering wheel</I>. <B>~ilisto</B>, <I>helmsman</I>. <B>~iloj</B>, <I>reins</I>. <B>~isto</B> (<B>~oro</B> [OA]), -or, conductor, editor, governor, head, leader, manager, principal, superintendent (➞ <I>estr</I>). <B>~~aro</B>, -orate, administrative staff, board, management. <B>~alo</B>, (av) tail fin. <B>~montrilo</B> (<B>~otrovilo</B>), -ion finder. <B>~osendilo</B>, radio beacon. <B>For~i</B>, turn aside. <B>Sen~a</B> (<B>Ne~ebla</B>), adrift, without -ion. <B>Unu~a</B> (one-way) <I>trafiko</I>. ➞ gvid, konduk, orient, stir, turn, veturig.", "0"],
["direktivo", "direktiv-o", "directive, guiding principle, statement of policy. <B>~oj</B>, broad lines (<I>de konduto, politiko</I>).", "0"],
["diri", "dir-i", "(<I>-n, ke</I>), [UV] Say, assert, remark, speak, state. <I>Ni ~u, ke</I>, Let us s. that.... <I>~u al mi, cu</I>, Tell me. <I>Oni ~as</I>, it <B>is</B> said. <I>Kiel oni ~as</I>, as the phrase goes, so to speak. <I>Kion oni ~os?</I> What will people s.? <I>Tio ~as</I> (conveys) <I>nenion al mi. ~i, ke jes (ne</I>), affirm (deny). <I>~i sian penson,</I> (one’s mind). <I>Lasu al mi ~i vorton</I> (get a word in). <I>Mi forgesis ~i</I> (mention), <I>ke. Kiel tion ~i?</I> How can I put it? <I>Ne bezone ~i</I>, it goes without s -ing. <I>Se tiel ~i,</I> as it were. <I>~ante tion</I>, with these words. <B>~o</B>, s-ing, remark, statemnt, utterance. <I>Laŭ via ~o</I>, according to you. <B>~aĵo</B>, dictum, s-ing. <B>~enda</B>, that must be said. <B>~maniero</B>, expression, turn of speech. <B>Al~i</B>, <B>Krom~i</B>, s. further, add. <B>Antaŭ~i</B>, foretell, predict, prophesy (➞ <I>anonc, aŭgur, profet, prognoz</I>). <B>El~i</B>, declare, express, pronounce (➞ <I>deklar, formul, vortig</I>). <B>Kontraŭ~i</B> (<I>oponi</I>), contr-adict, -overt, gain-s, oppose. <I>Ne~<B>~ebla</B></I>, in-contest (-disput)able, un-deni(-question)able. <I>Sin ~~a</I>, self-contradictory. <B>Laŭ~a</B>, alleged, ostensible, so-called, pretended. <B>Mal~i</B>, disavow, recant, take back, un-s., withdraw. <B>Ne~ebla</B>, ineffable, un-speak (-utter)able. <B>Pri~i</B>, speak of. <I>Nepri<B>~ebla</B></I>, indescribable. <B>Re~i</B> (<I>ripeti</I>), s. again, repeat. <B>Sub~i</B>, s. covertly, whisper. <B>Duon~ (Kvazaŭ~)i</B>, imply, insinuate, suggest, throw out hints. <B>Ĝusta~e</B>, to be accurate. <B>Oni~o</B>, hear-s., report, rumour (➞ <I>klaĉ, Oni~e (laŭ~e</I>), the story goes, the report is afloat, it is rumoured. <B>Popol~o</B>, popular -ing, saw. <B>Supre~ita</B>, above-mentioned, <B>Trans~i</B>, convey, pass on, transmit (<I>novaĵon, ordonon</I>). <B>Ver~e</B>, to tell the truth, truth to s., in truth. ➞ <I>asert, esprim, parol, rakont, rimarkig, sciig</I>.", "0"],
["dis", "dis-", "[UV] (<I>malkune</I>), (pfx) denotes <B>1</B> (<I>apartigo</I>): Separ/ation, breaking into parts (pieces), (<I>aparteco</I>): separateness, divergence. <I>~bati, ~fali, ~fendi, ~frakasi, ~haki, ~pecigi, ~premi, ~rompi, ~ŝiri, ~tranĉi</I>. <B>2</B> Dispersal: = <I>ĉie(n), ĉiuflanke(n), diversloke(n), diversdirekte(n</I>): about, in all directions; here, there, and everywhere; N, S, E, and W. <I>~babili, ~blovi, ~doni, ~aŭdigi, ~konigi, ~kreski, ~kuri, ~peli, ~perdi, ~porti, ~semi, ~sendi</I>. <B>~a</B>, separate, apart, loose, not united, scattered (➞ <I>sporad). ~aj dometoj</I>, straggling cottages. <B>~e</B>, separately, here and there, scattered about (➞ <I>de-, for-</I>). <B>~en!</B> Dismiss! Disperse! <B>~igi</B>, [UV] separate, disjoin, part, sunder, open (<I>kurtenojn</I>). <B>Ne~igebla</B>, inseparable, indivisible. <B>~igilo</B>, separator. <B>~iĝo</B>, separation, division, parting, schism, split <I>~iĝi de</I>, part company with. [Ne= mal-. Say <I>Malaranĝi</I>, not <I>disaranĝi, elrevigi, senrevigi, seniluziigi</I>, not <I>disrevigi. Disvolvi (= malvolvi</I>) is, however, an established idiom.] <B>Rim</B>.: Disde (occasional variant of <I>de</I>) should be used, if at all, only to avoid ambiguity. <I>Distingi A disde B</I> (better: <I>inter A kaj B</I>. ➞ Ge 1/4).", "0"],
["disciplino", "disciplin-o", "[OA] discipline, rules for conduct. <I>~o eklezia, intelekta, lerneja, milita, rigora</I>. <B>~a</B>, disciplinary. bring under control, train to obedience. <I>~i impulsojn, lernantojn</I>. <B>~ita</B>, accustomed to discipline, well-trained. <B>~ebla</B>, tractable. <B>~isto</B>, -arian. <B>Sen~a</B>, un-ed, insubordinate, out of control, raw. <B>Sen~igi</B>, demoralize (El 32/25). ➞ <I>brid, eduk, ord</I>.", "0"],
["disĉipl(in)o", "disĉipl-(in)-o", "[OA] disciple, adherent, follower (Mai 2/12, Mt 10/1). ➞ <I>an, lernant, sekvant</I>.", "0"],
["disenterio", "disenteri-o", "[OA] dysentery.", "0"],
["diserti", "disert-i", "(nt, <I>pri</I>), dissertate, expatiate, treat a subject at length. <B>~(aĵ)o</B>, dissertation, discourse, disquisition, thesis. <I>Doktora ~aĵo</I>. ➞ <I>referat, tez, traktaĵ</I>.", "0"],
["disipi", "disip-i", "dissipate. <B>1</B> (<I>forblovi</I>): bring to nothing, dispel. <I>~i iluzion, mallumon, nebulon, nubon, vaporon</I>. <B>2</B> (<I>malŝpari</I>): fritter away, squander. <I>~i atenton, energion, forton, havon, monon</I>. <B>~aĵo</B>, dissipation, frivolous amusement. ➞ <I>dispers</I>.", "0"],
["disko", "disk-o", "[OA] Disc. <B>1</B> (<I>rondo</I>), round flat object. <I>~o luna, suna. Numera ~o (telefono</I>); face (<I>horloĝa</I>); piece (drs); record (<I>gramofona). Akriga ~o</I>, grindstone. <B>Puŝ~o</B> (gm) shove-halfpenny. <B>Salt~oj</B> (gm) tiddly-winks. <B>Signal~o</B>, (ry) signal disc. <B>~i</B>, (tel) dial. <B>~eto</B>, ring, washer, etc. <I>Glu~eto (oblato</I>), wafer. <B>~ludo</B>, quoits.", "0"],
["diskomicetoj", "diskomicet-oj", "(<I>diskofungoj</I>), cup fungi (<I>Discomycetes</I>).", "0"],
["diskonto", "diskont-o", "[UV] (com) Discount, rebate, deduction, e.g., for early payment. <I>2 ½ % <SUB> </SUB>de ~o</I>. ~i <I>kambion</I>, d. a bill, <B>f</B> allow for exaggerate, take with a grain of salt. <B>~ebla</B>. <B>~isto</B>, -er, d-broker. <B>~procento</B>, rate of d., bank rate.", "0"],
["diskoteko", "", "<B>1</B> library of gramophone records. <B>2</B> (<I>dancejo</I>).", "0"],
["diskreta", "diskret-a", "[OA] Discre/et, cautious, circumspect, guarded, judicious, prudent, sane, tactful, unobtrusive. <I>~a konduto, letero, parolo, silento. Agi</I> <B>~e. ~(ec)o</B>, -tion, caution, circumspection, judgment, prudence, reserve, <B>~ulo. Mal~a</B>, in-d., rash, thoughtless, unguarded. ➞ <I>malmoder, senkonsider, sentakt</I>. <B>~~aĵo</B>, <B>~~eco</B>, in-tion. <B>Tro~a</B>, reticent. ➞ <I>nesintrud, silentem, sindeten, taktoplen</I>.", "0"],
["diskriminanto", "", "(mat) discriminant.", "0"],
["diskrimini", "diskrimin-i", "(<I>diferencigi, fari distingon) (inter, kontraŭ</I>), Discrimin/ate, make a distinction between, distinguish (us. unfavourably). <I>Socia</I> <B>~ado</B>, -ation.", "0"],
["diskuti", "diskut-i", "(<I>-n, pri</I>) [OA], Discuss, debate, examine by argument, deliberate on, take point by point, talk over. <I>~i demandon, proponon, situacion</I>. <B>~o</B>, -ion, controversy. <B>~aĉi</B>, wrangle. <I>Senfina</I> <B>~ado. ~ebla</B>, controversial, debat-(question-) able. <I>~ebla demando</I>, open question. <B>Ne~ebla</B>, beyond dispute. <B>~ema</B>, argumentative. <B>~inda</B>, worth -ion. <B>~igi</B>, raise the question. ➞ <I>argument, debat, disput, polemik</I>.", "0"],
["disonanco", "disonanc-o", "disson/ance, discord, (ac) the disagreeable effect of beats. <B>~a</B>, -ant, harsh-toned, incongruous. <B>~i</B>, -ate, jar. ➞ <I>mal-akord(-bonson-harmoni</I>). Opp <I>konsonanc</I>.", "0"],
["dispensi", "dispens-i", "Dispens/e, give out, (pharm) make a prescription. <I>~i medikamentojn-</I> <B>~ejo</B> (<I>hospitala apoteko</I>), -ary. <B>~isto</B>, -er. ➞ <I>disdon, distribu</I>.", "0"],
["dispepsio", "dispepsi-o", "[OA] dyspep/sia, indigestion, <B>~a</B> <B>~ulo</B>, -tic.", "0"],
["dispers", "", "-i (<I>-rt</I>), <B>1</B> Dispers/e, send in different directions, dispel, scatter, (opt) spread beam into spectrum, <B>f</B> <I>~i armeon, homamason</I>. <B>~o</B>, -al, disseminata. <I>~a angulo</I>. <B>~iĝi</B>, disperse. <B>~iva</B>, -ive. ➞ <I>difuz, kromat, osmoz, spektr</I>.", "0"],
["dispneo", "dispne-o", "(<I>med) (malfacila spirado</I>), dispnaea.", "0"],
["disponi", "dispon-i", "[UV] <B>1</B> have available (at one’s Dispos/al) (command): <I>~i armeon, lokon, monon, seĝon, tempon. Se muso nur unu truon ~as</I> (P). <B>2</B> (<I>fari ~on pri</I>), dispose of, decide, determine (course of events), settle: <I>Homo proponas, Dio ~as. ~i (ke</I>), arrange. <I>~i pri vivo kaj morto. ~u pri mi,</I> I am at your service. <I>~u helpon al Jakob</I> (Ps 44/4). ➞ <I>aranĝ, determin, direkt</I>). <B>~o</B>, -al, -ition, arrangement, assignment, management, control. <I>Je (sub) via</I> <B>~o</B></I>, at your service, yours to command. Meti sub ~on de (at the -al of) (2 Sa 18/2). <I>Fari ~ojn</I>, make arrangements. <B>~ebla</B>, at -al, available, disengaged, unoccupied, vacant. <B>~igi al</B>, place at the -al of. <B>~ita al</B>, reserved for. <B>Sin~o</B>, self- determination</I>.", "0"],
["disprozio", "disprozi-o", "(chem) Dysprosium (Dy).", "0"],
["disputi", "disput-i", "[UV] Disput/e. <B>1</B> (<I>pri) (akre diskuti</I>), argue, contend, wrangle. <B>2</B> (<I>-n) (kontesti</I>), call in question, challenge. <B>~o</B>, -ation, controversy, difference of opinion, heated contention, <B>~aĉi</B> (<I>kun, pri</I>) bandy words, have altercation, quarrel, squabble. <B>~anto</B>, -ant. <B>(Pri)~ebla</B>, contentious, debatable, in dispute. <B>Ne~ebla</B>, in-able, unquestionable. <I>Ne~ebla aŭtoritato</I>. <B>~eti</B>, bicker. <B>~ema</B>, contentious, quarrelsome. <I>Stulte</I> <B>inter~i. Ne~ita</B>, unquestioned. <B>Sen~e</B>, with common consent. ➞ <I>diskut, konflikt, kontest, malpac, polemik</I>.", "0"],
["distiko", "distik-o", "(<I>versduo</I>), (pros) distich, couplet.", "0"],
["distili", "distil-i", "(<I>-n</I>), [UV] Distil. <B>1</B> condense liquid. <I>~ita akvo</I>. <B>2</B> extract essence (of plant, etc.). <I>parfumon el rozoj, saĝon el parolo</I>. <B>3</B> Make by -lation. <I>~i brandon</I>. <B>~(ad)o</B>, -lation. <B>~aĵo</B>, -late. <B>~ejo</B>, -lery. <B>~iĝi</B>, drop by condensation. <B>~ilo</B>, <B>~aparato</B> (<I>alambiko</I>), still. <B>~isto</B>, -ler. ➞ <I>rafin</I>.", "0"],
["distingi", "disting-i", "[UV] Distin/guish. <B>1</B> (<I>kontrastigi, malkonfuzi</I>) differentiate, note the difference between, separate: (Jona 4/11): <I>~i inter A kaj B; ~i A de B. ~i kolorojn, voĉojn; ~i veron de malvero;</I> recognize: <I>~i la sonon de hobojo</I>. <B>2</B> (<I>trakti malsame</I>) make a distinction, differentiate, discriminate, draw a line: <I>Morto ne ~as: ĉiujn egale atingas. ~i la teron de Goŝen</I> (El 8/22). <I>Ne ~u vizaĝojn ĉe la juĝo</I>. <B>3</B> (<I>klare percepti</I>) discern, make out, perceive: <I>Ne povi ~i detalojn, vizaĝojn en nebulo</I>. <B>4</B> (<I>karakterizi</I>) characterize, make prominent, mark, single out: <I>Lia ĉapo, staturo lin ~as</I>. <B>~o</B>, distinction, etc. <B>~a</B>, -ing. <I>~a flago</I>. <B>~aĵo</B> (mark of) -ction, characteristic. <B>~iĝi</B> (<I>per</I>), be -ed, conspicuous (➞ <I>bril, elstar, kon- trasi). Akre ~iĝanta ĉe</I>, sharply standing out against. ~(ig<B>)a</B>, -ctive, outstanding. <B>~ebla</B>, perceptible. <B>~ilo</B>, -ing sign (➞ <I>rekonilo</I>). <B>~inda</B> (Alt 5/10). <B>~lta</B>, -ed, eminent, famous, remarkable. <I>~ita homo, kvalito, merito, servo</I>. <B>~ito</B>, eminent man, person of -ction. <B>Mal~i</B>, confound, confuse, mix up. <B>Sen~e</B>, pell-mell, promiscuously.", "0"],
["distordi", "distord-i", "(<I>-n</I>), (opt, rad), Distort, put out of shape. <B>~o</B>, -ion, <I>de bild-(ond-son-)o, elektr-(magnet-)a kampo</I>. <B>f</B> misrepresent. ➞ <I>tord</I>.", "0"],
["distri", "distr-i", "(<I>-n</I>) [OA], Distract, divert. <B>1</B> (<I>deturni la atenton, penson</I>). Draw away, divide, interrupt, take one’s mind off from. ➞ <I>malabsorb, malatentig, malkoncentr. Tiu brueto min ~as</I>. <B>2</B> amuse. ➞ <I>amuz, malenuig, malstreĉ</I>). <B>~a</B>. -ing. <B>~o</B>, <B>~aĵo</B>, <B>~ilo</B>, -ion, change, diversion, recreation, relief. <B>~iĝi</B> (<I>sin ~i</I>), be -ed, amuse one’s, let one’s mind wander, pass the time, relax. <B>~iĝo</B>, inadvertence, inattention. <B>~iĝema</B>, <B>~ita</B>, absent-minded, distrait, inattentive, listless, woolgatherg, vacant, wandering.", "0"],
["distribui", "distribu-i", "(<I>-n</I>), Distribut/e, deal, give (portion, share) out, dispense, issue (Ne 13/13). <I>~i monon, kartojn, rolojn;</I> deliver (<I>leterojn, varojn</I>, (typ) d. type, (log) <I>~ita termino</I>, -ed term. <B>~(ad)o</B>, -ion. <B>~a</B>, -ive. <I>La vorto \"po\" estas ~a prepozicio</I>. (tel) <I>~a framo, reto, tabulo</I>, -ion frame (network, board). <I>~a linio</I>, -or main. <B>~ilo</B>, -or. <B>Akvo~ilo</B>, water-works. ➞ <I>disdon, dismet, dissend, porciig</I>.", "0"],
["distrikto", "distrikt-o", "[UV] District (us. administrative area), division, region, section, territory (Ce <I>215). Juĝa ~o</I>, circuit, jurisdiction. <B>~a</B> <I>juĝejo</I>, d. court. <B>Duon~o</B> (Ne 3/9). ➞ <I>kvartal,provinc, region, sekci, subdepartement</I>.", "0"],
["dist(anc)o", "dist(anc)-o", "[OA] Distan/ce (of space or time), interval, range, remoteness. <I>~o de A ĝis B, inter A kaj B. Je kioma ~o?</I> How far off? <I>Je dekmejla, granda, kelka, longa ~o. Je mallonga ~o</I>, within easy reach, <I>konservi sian ~on, teni je ~o. Kur~on de sep tagoj (</I>Ge 31/23). <I>Eksploda ~o</I>, spark gap. <I>Fokusa ~o</I>, focal length. <I>Meza ~o</I>, middle d. <B>~a</B> (<I>fora, malproksima</I>), -t, far away. <I>~a komando</I>, remote control, <B>f</B> aloof, cool, reserved, stand-off. <B>~e</B>, at a distance, from afar. (<I>esti ~a, havi ~on), Kiom ~as</I> (How far is) <I>A de B?</I> <B>Preter~i</B>, out-d. out-pace, out-run. <B>Egal~a</B>, equi-t. <B>Long~a</B> <I>trafiko</I>. ➞ <I>forec, interspac, interval</I>.", "0"],
["ditirambo", "ditiramb-o", "[OA] dithyramb; inflated vehement poem, speech, or writing. <B>f</B> extravagant eulogy.", "0"],
["ditisko", "ditisk-o", "(great brown) diving beetle (<I>Dytiscus). ~a larvo</I>, water tiger.", "0"],
["diurezo", "diurez-o", "(med) diuresis. <B>~a</B> (<I>uriniga, ~igaĵo</I>), diuresistic.", "0"],
["diurno", "diurn-o", "day (24 hours). <B>~a</B>, diurnal. <B>1</B> (<I>plentaga, 24-hora). ~a movo, paralakso, variado</I>. <B>2</B> (<I>tagluma</I>), of the day, daytime (opposite nocturnal). <I>~a birdo, insekto</I>.", "0"],
["divano", "divan-o", "[OA] divan. <B>1</B> oriental council. <B>2</B> (<I>Turka kanapo</I>), armless backless low cushioned seat against wall, ottoman.", "0"],
["diveni", "diven-i", "(<I>-n, el, ĉu, ke, kiel, kion</I>) [UV]. <B>1</B> (make a) Guess, conjecture, estimate without measurement or calculate, hazard an opinion, surmise. (➞ <I>hipotez, konjekt, supoz, suspeki</I>). <B>2</B> guess right, hit on, make out, read, solve. <B>Provi ~on</B> (<I>~i</I>), have (<I>hazard</I>) a guess. <I>~i enigmon, kaŭzon, penson, sekreton</I>. ➞ <I>eltrov, solv, traf</I>. <B>3</B> (<I>sortodiveni</I>), divine, make out by intuition, magic, etc.; foresee, predict, read, tell fortunes. <I>~i per kartoj, tefolioj</I>, etc. ➞ <I>aŭgur, rabd, signifoklarig</I>. <B>~(em)a</B>, sharpwitted, sympathetic. <B>~o</B>, guess, conjecture, surmise, etc. <B>~e</B>, at a guess. <B>Astro~o, bird~o, karto~o, sonĝo~o, sorto~o</B>, divination. <B>Man~o</B>, palmistry. <B>~igi</B>, (<I>helpi ~i</I>) cause to guess, give a clue (hint), suggest. <B>~isto</B>, diviner (Da 2/27).", "0"],
["diverĝi (", "diverĝ-i (", "<I>disiĝi</I>) (nt), (mat, opt), diverge, branch off, proceed in different directions, spread out (lines, rays), take different courses, <B>f</B> differ (of opinions, etc.), ➞ <I>malakord</I>. <B>~a</B>, divergent, diverging, <B>~eco</B>, divergence. <I>~iga lens-(spegul-)o</I>. ➞ <I>disir, dispers, fokus</I>. Opp <I>konverĝ</I>.", "0"],
["diversa(j)", "divers-a(j)", "[UV] various. <B>1</B> diverse, different, dissimilar, varying, -ed: <I>Ŝtonoj de ~a grando. ~aj gradoj, opinioj, specoj</I>. ➞ <I>diferenc, malsam, vari</I>. <B>2</B> divers, several, sundry: <I>~aj detaloj, eldonoj, lokoj, okazoj</I>. ➞ <I>kelkaj, pluraj</I>. <B>~i</B> (<I>esti ~a</I>). <B>~aĵo</B>, variety, miscellany. <B>~aĵoj</B>, odds and ends, sundries. <B>~eco</B>, diversity, variety. <B>~igi</B>, diversify, variegate, vary. ➞ <I>Sang, variig</I>. <B>~forma</B>, <B>~speca</B>, of various kinds, different sorts. <B>~kolora</B>, variegated, of divers colours (many shades), motley. ➞ <I>bunt</I>. <B>~maniere</B>, in various (sundry) ways.", "0"],
["dividendo", "dividend-o", "(com) dividend, share (in profits etc.). ➞ <I>tantiem</I>.", "0"],
["dividi", "divid-i", "(<I>-n</I>), [UV] divide. <B>1</B> Separate into pts, break up, come between, disunite, part, split up. <B>f</B> cause to disagree, set at variance: <I>La homaro sin ~is ŝakale</I>. ➞ <I>apartig, disfend, disig, distranĉ</I>. <B>2</B> (<I>onigi</I>): <I>~i 6 per 3</I>. <I>~i en tri partojn</I> (Re 19/3). <B>3</B> (<I>~i kun aliaj, inter si</I>): portion (share) out, distribute. <I>heredaĵon. Ili ~as miajn vestojn inter si</I> (Ps 22/18). ➞ <I>disdon, distribu</I>. <B>~a</B>, divisive. <B>~o</B>, division, distribute, sharing, partition. <I>~o de laboro, vorto</I>. <B>~aĵo</B>, division, section (➞ <I>brant, fak, part, segment, sekci</I>). <B>~anto</B>, (mat) divisor. <B>~ato</B>, numerator. <B>~ebla</B>, divisible, separable. <B>~enda</B> (➞ <I>dividend</I>). <B>~iĝi</B>, divide, break up, split. <B>~ilo</B>, diviser. (rad) <I>vidaj~ilo</I>, image dissector. <B>Dis~i (Inter~i)</B>, cut up, dismember, partition. <I>Dis~i la landon</I>. <B>Ne~ita</B>, <B>Sen~a</B>, undivided, entire, one, whole (➞ <I>blok, ĉiom, entjer</I>). <B>Sub~i</B>, subdividd, classify. <B>Akvo~ejo</B> (<I>Val~o</I>), watershed. [Say <I>Mi same pensas, Mi konsentas kun vi;</I> not <I>Mi dividas vian opinion</I>].", "0"],
["divizio", "divizi-o", "[OA] (mil) division.", "0"],
["divorci", "divorc-i", "= eksedz(in)igi, divorce. <B>~o</B>, divorce. <B>~ito</B>, <B>-iĝinto</B>, divorced person.", "0"],
["dizelo", "dizel-o", "diesel engine.", "0"],
["dizerti", "dizert-i", "(<I>-n</I>), desert, run away from. <I>~i armeon, partion, postenon, servon, ŝipon</I>. <I>~i</I> (go over) <I>al la malamiko</I>. <B>f</B> (<I>forlasi</I>), abandon, forsake, quit. <I>~i edzinon, eklezion, laboron</I>. <B>~o</B>, desertion. <B>~into</B>, deserter. ➞ <I>forkur, transkur</I>.", "0"],
["Do", "D-o", "[UV] letter D. (ac) 587 • 3 <I>vibroj sekunde</I>. <B>D-is (D diesa)</B>, D sharp. <B>D-be (D bemola)</B>, D flat. <B>D-kordo</B>, D string. ➞ <I>delt</I>.", "0"],
["do", "", "(conj), [UV] <B>1</B> So (referring to preceding or implied statement (= a weak form of <I>tial</I>) (denotes conclusion, consequence (and) so, accordingly, consequently, hence, so it follows that, therefore: <I>Mi pensas, ~ mi ekzistas, Mi ~ iris</I>, so I went. <B>2</B> Then (of reasoning, not time), so. <B>(a)</B> (In that case): <I>Do kion fari?</I> So what was one to do? <B>(b)</B> (concession): <I>Do prenu ĝin</I>, Take it then. <B>(c)</B> (expostulate, surprise): <I>Nu do!</I> Well, then! <I>~ vi ne iros?</I> Then (so) you won’t go? <I>Kio do?</I> What then? So what? <B>(d)</B> (insistence): <I>Aŭskultu</I> Listen then (I tell you). E.g., (resumption): thereupon. <I>~ li venis, kaj</I> ... So (as I said) he came. <B>3</B> (as interjection): <I>Do!</I> So there! So that’s that! ➞ <I>sekve, tial</I>.", "0"],
["docento", "docent-o", "(<I>subprofesoro</I>) (university) lecturer, reader. be (speak as) a lecturer. ➞ <I>lektor, preleg, katedr</I>.", "0"],
["dogano", "dogan-o", "[OA] Customs (institution). <I>Trapasi</I> (get through) <I>la ~on</I>. <B>~aĵo</B>, <B>~pago</B>, (<I>limimposto</I>), c-duty, toll. <B>~ejo</B>, customhouse. <B>~isto</B>, customhouse officer. <B>~libera</B>, free of duty. <B>~tarifo</B>, list of duties. <B>~unio</B>, C-Union. ➞ <I>akciz, deklar</I>.", "0"],
["dogmo", "dogm-o", "[F], dogma, principle, tenet; article of faith, <B>~a</B>, dogmatic, authtive, <B>~i</B> (<I>paroli ~e</I>), dogmatize, lay down the law, make positive unsupported assertion. <B>~aro</B>, (body of) doctrine, teachg; especially on the authy of the Church. <B>~ema</B>, dictatorial, peremptory. <B>~emo</B>, dogmatism. <B>~ismo</B>, dogmatics, system of d. <B>~isto</B>, <B>~ulo</B>, dogmatist.", "0"],
["dogo", "dog-o", "[OA] mastiff.", "0"],
["doĝo", "doĝ-o", "doge.", "0"],
["doko", "dok-o", "[OA] (mar) dock, ship-basin. <B>1</B> <I>Flosanta ~o</I>, floating dock. <I>Ripara (Seka) ~o</I>, dry (graving) dock. <I>Tajda (Malseka) ~o</I>, wet dock. <B>2</B> <I>~oj</I>, dockyard, the docks. <B>~estro</B>, dockmaster. <B>~(labor)isto</B>, docker. <B>~mono</B>, <B>~pago</B>, dockage, dock dues. <B>En~igi</B>, <B>~iĝi</B>, dock.", "0"],
["doksologio", "doksologi-o", "doxology, traditional liturgical formula of praise to God.", "0"],
["doktoro", "doktor-o", "[F], doctor (title). <B>1</B> holder of highest university degree in any faculty. <I>~o de filozofio, de juro, de medicino, de teologio</I>. <B>2</B> (ordinary language) = <I>~o medicina, kuracisto</I>, physician. <B>~a</B> doctoral, doctorial. <B>~ado</B>, doctoring. <B>~eco</B>, doctorate. <B>~edzino</B>, doctor’s wife. <B>~ino</B>, lady doctor. <B>Honor~o</B>, (<I>de honoris causa</I>).", "0"],
["doktrino", "doktrin-o", "[OA] (<I>dogmaro</I>) (pol, rel) doctrine; body of instruction, beliefs, teaching, tenets. <I>Kristana ~o</I>. <B>~a</B>, doctrinal. <B>~ano</B>, adherent of a doctrine. <B>~ema</B>, doctrinaire, narrow minded, one sided, partial. <B>~ulo</B>, doctrinaire, pedantic theorist.", "0"],
["dokumento", "dokument-o", "[F], Document, written statement (diploma, testimonial, title, voucher, etc.). <I>~o geneologia, jura</I> (Ne 7/64). <I>La \"Fundamento\" estas historia ~o</I>. <B>~i</B>, d., prove or support by documents. <I>Bone ~ita,</I> posted, well-briefed, <B>~a</B>, -ary. <I>~a filmo</I>. <B>~ado</B>, -ation. <B>~aĵo</B>, -ary evidence. <B>~aro</B>, archives, dossier, file, records. ➞ <I>akt, arĥiv (arkiv), atest, aŭtent</I>.", "0"],
["dolaro", "dolar-o", "[OA] (num) dollar (wide sense).", "0"],
["dolĉa", "dolĉ-a", "[UV] Sweet, (of taste): <I>~a gusto, pomo, teo</I>. (of smell): fragrant, <I>~a odoro, parfumo</I>. (of sound): pleasant. <I>~a kanto, parolo, sono, voĉo</I>. Agreeable, charming, nice: <I>~a knabino, memoro, rideto, sonĝo, vojaĝo</I>. Fresh: <I>~a akvo</I> (El 15/25). Gentle, light: <I>~a movo, paŝo, vento</I>. Meek, mild: <I>~a karaktero, naturo</I>. Peaceful: <I>~a dormo</I>. Subdued: <I>~a koloro, lumo</I>. Tender: <I>~a verdo de folioj</I>. <B>~e!</B> Gently! Easy does it! <B>~aĉa</B>, sickly. <B>~aĵo</B>, s. thing (➞ <I>bombon, sukeraĵ</I>). <B>f</B> <I>Flustri ~aĵojn</I>. <B>~eco</B>, -ness, suavity. <B>~ega</B> (<I>miela</I>), honeyed, syrupy; delicious, delightful. ~eta, s-ish, <B>~igi</B>, -en. <B>f</B> assuage, moderate, soften, tone down (➞ <I>moderig</I>). <B>~ul(in)o</B>, s-heart. <B>~amaro</B>, bitter-s, woody nightshade (<I>Solatium dolcamara</I>). <B>~anima.</B> s-tempered. <B>Mal~a</B>, bitter, cutting, harsh, sharp, sour, stale (➞ <I>akr, amar</I>). <B>~~igi</B>, embitter, mar, sour. ➞ <I>agrabl, amind, bonodor, ĉarm, delikat, kares, miel, mild, plat, suker</I>.", "0"],
["doldrumo", "doldrum-o", "(<I>ekvatora kalmo</I>), doldrums (tropical zone between NE and SE trade winds), <B>f</B> depression, dumps.", "0"],
["dolmeno", "dolmen-o", "(<I>megalita tombo</I>), dolmen. ➞ <I>kromlek, menhir</I>.", "0"],
["dolomito", "dolomit-o", "(min) dolomite, pearl spar (double carbonate of Ca and Mg).", "0"],
["dolori", "dolor-i", "[UV] Pain. <B>1</B> (abs) be -ful (sore), ache, hurt, smart. <I>Tio ~as</I>, that hurts. <I>La koro ~as</I>, aches, is sorrowful (Se 14/13). <I>Al mi ~as ĉi tie (mi sentas ~on</I>), it aches, hurts me (I have a p.) here. <B>2</B> (<I>-n</I>), p., give p. to, distress, hurt. <I>La vundo ~as min (al mi</I>) (Ij 14/22, Jer 4/19, Se 23/35). <B>Rim</B>.: The simple form <I>dolori</I> is usual when the idea is subjective. But objectively <I>dolorigi</I> is more often used. <I>Ĉu mi ~igis vin? Espero prokrastata ~igas la koron</I> (Se 13/12). <I>Kurante, mi ~igis la piedon. ~o,</I> ache, hurt, pang, throe. <B>Dent~o, intest~o, orel~o, kap~o, kor~o</B>, tooth-ache, etc. <B>Nerv~o</B>, neuralgia. <B>Lumb~o</B>, lumbago. <B>Ren~o</B>, nephritis, <B>f</B> grief, sorrow, woe. <I>Partopreni ies ~on</I>, sympathize. <I>En ~o vi naskados</I> (Ge 3/16). <B>~(oplen)a</B>, aching, sore, tender; sad. <B>~e</B>, painfully. <B>~ego</B>, agony, anguish. <B>~eto</B>, slight (touch of) pain, smart. <B>~iga</B> <I>ulcero</I>. <B>~ige</B> (cruelly) <I>frapi</I> (Mi 6/13). <B>~iĝi</B>, become painful. <B>Ek~o</B>, twinge. <B>Sen~a</B>, -less. <B>Sen~igilo</B>, analgesic, anodyne (➞ <I>anestez</I>). ➞ <I>aflikt, agoni, angor, ĉagren, turment</I>.", "0"],
["domaĝi", "domaĝ-i", "(<I>-n, -i</I>), [UV] wish to keep intact (unspoiled, whole); fear (think it word be a pity, wish not) to damage (lose, spend, spoil) (see LR/22; BE 1940/187). <B>1</B> (<I>ne voli elspezi</I>): (be)grudge, withhold (from). <I>Li ne aĉetis la libron, ĉar li ~is la monon, elspezon, koston. ~i bonon</I> (Ps 84/11), <I>groŝon</I> (P), <I>sagojn</I>, Jer 50/14); <I>~ipreni el siaj ŝafoj</I> (2 Sa 12/4). <B>2</B> husband, look after, make the most of, spare (<I>kapitalon, sanon). ~i nenion por</I>, go all out for, leave no stone unturned, not boggle Gib, stick) at, not shrink from. <B>3</B> (<I>ne voli perdi aŭ difekti</I>), be anxious about, concerned for, fear for (Jeĥ 36/21). <I>Li ne eliris en la pluvo, ĉar li ~is sian veston. Li forkuris el la batalo, ĉar li ~is sian vivon</I>. <B>4</B> (<I>indulgi, kompati</I>): have mercy on, pity, spare. <I>~i patron, popolon, Sirianon,</I> (P), (2 Rĝ 5/20, <B>2</B> Kr 36/15). <B>5</B> regret the loss or death of (<I>bedaŭri): (lin) mi ~as</I> (H 109/11) <I>[Ne= damage (damaĝi, difekti).] Dio ~is Nineven</I> (therefore did not damage it) (Jon 4/10, 11). <B>~o</B>, <B>~e</B>, = (approximately) <I>bedaŭrind~aĵo, ~e. Kia ~o! Kiel ~e!</I> What a pity! (Estas) <B>~e</B>, <B>~o</B>, (<I>ke, pri</I>), It is a pity (I am sorry) (that) (about). <I>Post ~o venas saĝo</I>.", "0"],
["domeno", "domen-o", "[UV] Domino. <B>1</B> masquerade dress. <B>2</B> (gm) <I>~ludo</I>, dd. <B>~a</B> <I>peco</I>, d-brick.", "0"],
["domicilo", "domicil-o", "(place of) permanent abode, dwelling-place, home residence, (jur) domicile. <B>~i</B> (<I>-n</I>), establish in a place, (fin) ~i <I>bilon</I>, make payable at a place.", "0"],
["dominanto", "dominant-o", "(mus) dominant (<I>gamkvinto</I>). <B>Sub~anto</B>, [subdominant (<I>gamkvarto</I>).", "0"],
["domini", "domin-i", "(<I>-n) (superregi</I>), Domin/ate, have command influence (position), lord it (over), <B>f</B> overlook, tower above (over). <B>~ado</B>, -ation, ascendancy, sway. <B>~anta</B> <I>religio, sento, trajto</I>, (pre)dominant, dominating, commanding, outstanding, prevailing, reigning, ruling. <B>~ema</B>. domineering, imperious, masterful, overbearing.", "0"],
["Dominika Respubliko", "Dominik-a Respublik-o", "DO.", "0"],
["Dominiko", "Dominik-o", "DM.", "0"],
["dominio", "domini-o", "(pol) dominion.", "0"],
["domo", "dom-o", "[UV] House. <B>1</B> (building). <I>~o kampara, urba. Kokina ~o</I>, hen-h. <I>~o luebla</I>, h. to let. <I>~o el kartoj</I>, card castle. <I>La ~o de Dio (preĝejo). La Blanka Domo</I> (U.S.A.). <B>2</B> (<I>hejmo</I>), home. <I>En la ~o. Resti en~e</I>. <B>Rul~o</B>, caravan. <B>3</B> (<I>= anaro</I>): family’ household. <I>Mi kaj mia ~o servos al la Eternulo. La ~o de Jakob. Edzoligiĝi kun ~o de nobelo</I> (➞ <I>dinasti, famili, gent</I>). <B>4</B> (com) firm. <B>~a</B>, of a h., household. <I>~a ekonomio, servisto</I>, domestic economy (servant). <I>~aj devoj, ŝuoj. Iri</I> <B>~en</B>, go h. <B>~aĉo</B>, tumbledown h., hovel, <B>~aĉaro</B>, slum, <B>~amulo</B>, recluse, stay-at-home. <B>~ano</B>, member of h-hold (Ge 34/19). <B>~anaro</B> (Se 31/21). <B>~aro</B>, hamlet (➞ <I>vilaĝ</I>). <B>~ego</B> (➞ <I>nubskrapul</I>), mansion. <B>~estro</B>, head of h, host, master. <B>~eto</B>, cottage, maisonette. <B>Ekster~a</B>, out of doors, open-air. <B>En~a</B>, indoor. <B>En~igi</B>, h. <B>Fi~o</B>, h. of ill fame. <B>ĉas~o</B>, hunting-box. <B>Flor~o, Plant~o</B>, conservatory, greenhouse. <B>Krom~o(j)</B>, annex, out-buildg(s). <B>Lu~o</B>, rented house. <B>Pun~o</B>, penitentiary. <B>Somer~o</B>, summer-h. <B>staci~o</B>, [UV] station (building). <B>Ter~eto</B>, mud hut. <B>Urb~o</B>, mansion-h, town hall. ➞ <I>kaban, loĝej</I>.", "0"],
["donaci", "donac-i", "(<I>-n, al</I>), [UV] Donat/e, make a gift (without return or equivalent), bestow, (make a) present (of). as a gift. <B>~o</B>, -ion (Da 2/6), allowance, gift, grant, present. <I>~o Novjara. Fari ~on. Al ĉevalo</I> <B>~ita</B> (gift-horse) <I>oni buŝon ne esploras</I>. <B>~ema</B> (<I>malavara</I>), free-handed, generous, liberal, <B>~into</B>, donor. ➞ <I>dediĉ, don, testament</I>.", "0"],
["doni", "don-i", "(<I>-n, al</I>), [UV] Give, bestow, confer. <I>~i helpon, konsilon, koron, libron, manon, nomon, punon, rekompencon. (Fari): ~i honoron, lecionon, ordon, prelegon, signon</I>. Afford, furnish, offer, present, provide: <I>fakton, ideon, krediton, lumon, materialon, profiton, pruvon</I>. Bear, produce, yield: <I>~i frukton, rikolton</I>. Communicate, impart: <I>~i febron, plezuron, varmon</I>. Dedicate, devote (<I>vivon</I>). Express: <I>~i dankon, konsenton, laŭdon, opinion</I>. Grant (<I>intervjuon). Dio ~u, ke . .</I> . Pass (<I>la salon</I>). Pledge (<I>sian vorton</I>). Show (<I>ekzemplon</I>). <B>~(aĵ)o</B>, gift, present. <B>~anto</B>, -er, donor. <I>Sango~anto</I>. <B>~ema</B>, bountiful, generous, open-handed. <B>~ita</B>, given. <I>En la ~ita okazo</I>. <B>~itaĵo</B>, datum. <B>al~i</B>,, [UV] <B>1</B> add. <I>~~e al</I>, in addition to <I>~~(aĵ)o (apendico, suplemento</I>), addition, appendix, supplement. <I>Oficiala ~~o al la UV (OA</I>). <B>2</B> <I>aldonita al</I>, attached (devoted) to. <B>Dis~i</B> (<I>distribui</I>), dispense, distribute, (cgm) deal. <B>El~i</B>, <B>1</B> emit, give out, produce. <B>2</B> Publi/sh. <I>~~i verkon. ~~a Societo. ~~o,</I> edition, emission, issue, output. <I>Ekstra (tria</I>) <B>~~</B><I>o</I>. <B>~~aĵo</B>, publication. <B>~~ejo</B>, publishing house. <B>~~kvanto</B>, issue. <B>~~rajto</B>, right of publication. <B>For~i</B>, abandon, give away (up) ➞ <I>forlas, liver, ofer, rezign. Sin ~i al, give</I> one’s up to, abandon one’s to. <B>Re~i</B>, <B>1</B> give back, repay, restore, return. ➞ <I>reciprok, repag</I>. <B>2</B> render, express, reproduce (<I>originalon</I>). ➞ <I>spegul</I>. <I>~~o</I>, return; restitution; requital, retaliate. <B>Sin~(em)a</B>, devoted, self-sacrificing. <B>Trans~i</B>, hand down (over), deliver, surrender, transfer, transmit. <I>Trompe ~~i</I>, palm off. <B>~~atesto</B>, conveyance, deed of transfer. <B>Form~a</B>, formative. <B>Karbo~a</B>, carboniferous. <B>Mon ~a</B>, lucrative. <B>Ofer~i</B>, offer, present. ~~<B>o</B>, free gift, offering, offertory. <B>Voĉ~i</B>, give one’s vote (for). ~~<B>ado</B>, voting. ~~<B>anto</B>, voter. <B>~~ejo</B>, polling booth. ~~<B>rajto</B>, franchise, suffrage. ~~<B>rajtigi</B>, enfranchise.", "0"],
["doreo", "dore-o", "(ich) (John) Dory (<I>Zeus faber</I>).", "0"],
["doria", "dori-a", "(arch) Doric, (mus) Dorian, ~a <I>modalo</I>, Dorian mode,", "0"],
["dorido", "dorid-o", "(zoo) sea lemon (slug) (<I>Doris</I>).", "0"],
["dorloti", "dorlot-i", "(<I>-n</I>), [UV] coddle, fondle, make a fuss (much) of, over-indulge, pamper, pet, spoil. <I>~i infanon</I>. <B>f</B> pander (to), <I>~i apetit-(kapric-)on</I>. <B>~ato</B>, pet. <B>~ema</B>, indulgent. <B>~iĝi</B>, be coddled. <B>~ita. ~iteco.</B> (Re 28/56). <I>~ita de la Naturo</I>. <B>Mal~i</B>, be austere, hard, severe, stern, rough. <B>Sin~a</B>, self-indulgent (➞ <I>sibarit</I>). <B>Tro~i</B>, molly-coddle. ➞ <I>induling, kares, malhard, molig</I>.", "0"],
["dormi", "dorm-i", "(nt), [UV] Sleep, be asleep, slumber. <I>~i bone (dolĉe, kun malfermitaj okuloj). Iru</I> -i, go to bed. <I>~i alidome, eksterdome</I> (s. <I>out), profunde</I> (soundly), <B>f</B> lie dormant (idle, still), do nothing. <B>f</B> <I>~i (entombe) kun siaj patroj</I> (1 Rĝ 2/10, 11/21). <B>~o</B>, s. <I>Paroli en la ~o. ~o eterna (de la morto</I>). <B>~adi</B>, have a long s. <B>~anta</B>, -ing. <B>f</B> dormant, dull, inactive, stagnant, undeveloped. <I>~anta akvo, komerco, mono, semo, tero</I>. <B>~ego</B>, deep (heavy) sleep (1 Sa 26/12). <B>~ejo</B>, dormitory. <B>~ema</B>, sleepy, drowsy, somnolent. <B>~~ulo</B>, -yhead, sluggard. <B>~eto</B> (Ps 132/4), doze, nap, snooze, take forty winks. ➞ <I>siest</I>. <B>Ek~eti</B>, grow drowsy. <B>~iga</B>, narcotic, somniferous, soporific. <B>Ek~igi</B>, <B>en~igi</B>, put (send) to sleep. <I>~igi suspektojn. ~igi per kantado</I>, sing to s. <B>~igilo</B>, opiate, -ing draught (➞ <I>hipnot, lul, narkot</I>). <B>~ĉambro</B> (<I>litĉambro</I>), bedroom. <B>~kanto</B>, <B>~vesto</B>, slumber-wear, song-wear. <B>~omalsano</B> (<I>beribero</I>). <B>~marŝulo</B>, somnambulist. <B>Duon~a</B>, half-asleep. <B>Ek~i (En~iĝi)</B>, fall asleep, go to sleep. <B>f</B> <I>Mia piedo en~igis</I>. <B>For~i</B> (<I>kapdoloron, okazon</I>), sleep away (off). <B>Mal~i</B> (Alt <B>5/2)</B>, be (keep lie) awake, sit up, watch, be on the look-out for. <I>Pasigi la nokton ~~e. ~~o</I>, vigil, wake. <I>Noktaj ~~oj</I>, night watches. <B>~~ema</B>, alert, vigilant, watchful. <B>Post~aj</B> <I>okuloj</I>, eyes full of sleep. <B>Sat~i</B>, s. one’s fill. <B>Sen~a</B>, sleepless, restless. <B>~~eco</B>. insomnia. <B>Tra~i</B> <I>la nokton</I>. <B>Tro~i</B>, over-s. <B>Vintro~i</B>, hibernate. ➞ <I>letargi, vek</I>.", "0"],
["dorno", "dorn-o", "[UV] (<I>pikilo</I>). <B>1</B> (bot) Thorn, prickle, spike. <I>Rozo sen ~oj. Fali inter ~ojn (= dornplantojn</I>). <B>2</B> something -like: bristle (<I>fiŝa</I>); pin (<I>buka, kurtena</I>); quill (<I>histrika</I>). <B>~hava</B>, <B>~plena</B>, <B>~oza</B>, -y, bristly, prickly, spiny, <B>f</B> (<I>temo</I>) controversial, ticklish. <B>~ego</B> <I>por la karno</I> (2 Ko 12/7). <B>~arbet(aĵ)o</B> (Se 15/19, Mi 7/4). ~arbusto (Jĝ 9/14), t-bush. <B>~barilo</B>, prickly hedge. <B>~fiŝeto</B> (<I>gasterosteo</I>), stickleback. ➞ <I>pik, spin</I>.", "0"],
["doroniko", "doronik-o", "(bot) leopardsbane (<I>Doronicum</I>).", "0"],
["dorso", "dors-o", "[UV] (<I>posta flanko</I>), Back. <B>1</B> (anat): <I>~o ĉe ~o</I>, b. to b. <I>Montr-(turn-)i la ~on al,</I> turn one’s b. on, turn tail. <I>Post la ~o (kaŝe, perfide</I>), behind one’s b. <I>~o de ĉevalo</I>, <B>2</B> (of flesh): chine, loin, saddle. <B>3</B> (of obj): b. (<I>de foli-kart-kling-)o;</I> opposite <I>tranĉrando); de mano</I> (opp <I>plato); de seĝo (~apogilo</I>). Bridge (<I>nazo</I>), crest, ridge (<I>monto, ondo</I>); spine (<I>libro</I>); tail (<I>monero</I>). <B>~a</B>, dorsal. <B>~e</B>, behind, in the rear. ~en, ~direkte, backwards, to the rear, with b. to goal. <I>Fali ~en</I> (➞ <I>retro). Sidi</I> ~antaŭe. ~flanke, b., reverse. Sur<B>~igi</B>, put on one’s b. Rond<B>~a</B>, round -shouldered. dosier-o (<I>dokumentaro</I>), dossier. ~ujo, file, folder. ➞ <I>tek</I>.", "0"],
["doto", "dot-o", "[UV] Dowry, dot, marriage-portion, f <I>Natura ~o</I>, gift, talent. <B>~a</B>, dotal. <B>~e</B>, as a d. <I>Doni (ricevi) ~e</I>. <B>~i</B> (<I>iun</I>), [UV] endow, give d. (m-p) to. <B>~aĵo</B>, endowment, <B>f</B> ~ita <I>per</I>, blessed (endowed) with <I>infanoj, inteligent-(saĝ-san-voĉ-)o. Lando ~ita per floroj</I>. ~ulino, heiress. Sen<B>~a</B>, portionless.", "0"],
["dovelo", "dovel-o", "<B>1</B> (<I>volbŝtono</I>), stone of arch. <B>2</B> (<I>kolombvosta tenono</I>), dovetail (tenon joint). <B>~i</B>, dovetail, fit tghr closely (compactly). Ĉefa <B>~o</B>, keystone.", "0"],
["dozeno", "dozen-o", "(<I>dek-duo</I>), dozen, -a (duodecimal) <I>numerado</I>.", "0"],
["dozo", "doz-o", "(<I>da</I>) [OA], (pharm) Dos/e (of medicine), definite quantity, measure, porta. ~o <I>grand-(homeopati)a</I>. f <I>~o da bonvolo, ĉarmo, poezio, prudento</I>. <B>~i</B>, (give a) d. (to), gauge, measure off. <B>~ado</B>, -age. <B>~eto</B>, modicum, particle. ~ilo, medicine glass.", "0"],
["drabo", "drab-o", "whitlow-grass (<I>Draba</I>).", "0"],
["draceno", "dracen-o", "(<I>drak-arbo</I>), dragon-tree (<I>Dracaena</I>).", "0"],
["dragi", "drag-i", "(<I>-n</I>), Drag, dredge, search bottom with grapnels, sweep. <I>~i riveron</I>. ~ilo (~maŝino), dredger. ~boato, ~ŝipo, dredger, trawler. ~reto, d-net. Mina <I>~ŝipo,</I> minesweeper. ➞ <I>forskrap, tren</I>.", "0"],
["dragono", "dragon-o", "[OA] (mil) dragoon. <B>~i</B>, d., set dd on. <B>f</B> force into course by persecution. drajv-i (cricket, golf, tennis), drive, strike ball hard.", "0"],
["draĵo", "draĵ-o", "(bot) (<I>radikido</I>), sucker, e.g., of bramble, lilac, rose, rising from root- formation. <B>~i</B>, throw up ss. ➞ <I>markot, stolon, ŝos</I>.", "0"],
["drakmo", "drakm-o", "[OA] drachma. <B>1</B> (num). <B>2</B> (pharm) dram, 1/16 oz.", "0"],
["drako", "drak-o", "[UV] Dragon (Jeĥ 29/3). <B>1</B> (myth) winged serpent, <B>f</B> ~(in)o, shrew, termagant, virago, vixen. <B>2</B> (zoo) ordinary language for the agami lizard (<I>agamo</I>). <B>3</B> Flug~o (<I>kajto</I>), kite. <I>Draka sango</I>, d’s blood, red resin from various trees: <I>Draceno, Kalamo, Pterokarpo</I>. ➞ <I>dragon, drakon</I>.", "0"],
["drakocefalo", "drakocefal-o", "(bot) dragon’s head (<I>Draco- cephalus</I>).", "0"],
["drakona", "drakon-a", "dracon-ian, -ic. <B>f</B> cruelly harsh, severe. <I>~a regularo</I>.", "0"],
["drakontio", "drakonti-o", "(bot) dragon’s wort (<I>Dracon- tium</I>).", "0"],
["drakunkolo", "drakunkol-o", "tarragon (<I>Artemisia dracunculus</I>). Vd <I>artemizi</I>.", "0"],
["dramo", "dram-o", "[OA] Dram/a. <B>1</B> (<I>teatraĵo</I>), stage play. <B>2</B> -atic event, sensational affair, tragedy. <B>~a</B>, -atic. <B>1</B> theatrical. <B>2 ~(ec)a</B> (<I>emociiga</I>), impressive, sudden, tense. <I>~a situacio</I>. <B>~igi</B>, -atize. <B>~arto</B>, play-writing, -aturgy. <B>~(verk)isto</B>, <B>~aŭtoro</B>, -atist, playwright. ➞ <I>tragedi</I>.", "0"],
["drapiri", "drapir-i", "(<I>-n, per</I>), [UV] Drap/e, adorn (cover, hang) with cloth, etc., arrange (decorate) with graceful folds, hang tastefully, <B>f</B> cover (envelope, veil). <I>~i muron, statuon</I>. <B>~(ad)o, (aĵ)o</B>, -ing, hangings. ➞ <I>dekor, feston, gam, ornam, tapet</I>.", "0"],
["drapo", "drap-o", "[UV] (tex) (woollen) Cloth, c- fabric. <I>Kia ~o, tia vesto</I>. <B>~a</B>, of woollen material. <B>~aĵoj</B>, drapery, c- goods (Jes 63/2). <B>~(far)isto</B>, c-maker. <B>~(vend)isto</B>, draper, c-merchant. -okomerco, drapery business, c-trade. <B>~rando</B>, list, selvedge. ~resto, remnant. ➞ <I>lan, tol, tuk</I>.", "0"],
["drasta", "drast-a", "drastic; energetic, sharp, strong, vigorous, violent; <I>~a admonom, redukto, laksigilo, rimedo</I>. <B>~e</B> <I>ŝpari</I>. ➞ <I>fortefik, seninduling, senkompat</I>.", "0"],
["draŝi", "draŝ-i", "(<I>-n</I>), [UV] Thresh (<I>grenon</I>); (Jes 28/38). (fac) <I>~i fojnon</I>. <B>f</B> beat, thrash. <I>~i la dorson (= tani la haŭton) al iu. ~i</I> (thump) <I>la pianon</I>. <B>~ejo</B>, -ing floor (Rut 3/2), <B>~ilo</B>, flail (Am 1/3). <B>~maŝino</B>, -ing machine.", "0"],
["drato", "drat-o", "(<I>metalfadeno</I>), Wire, (av) <I>~o armit-(flugrezist-incid-lev-)a</I>. sheathed (drag, incidence, lift) w. (rad) <B>Enkon- duka ~o</B>, lead. <B>Fand-o</B>, fuse-w. <B>Latuna ~o</B>, brass w. <B>Pilkil~o</B>, barbed w. <B>~(iz)i</B>, w. (building, etc.). <B>~aĵo</B>, w-goods. <B>~eto</B>, thin w. ~igi (<I>fadenigi</I><B>). ~igebla</B>, ductile. <B>~isto</B>, w-worker. <B>~barajo</B>, w-entanglement. <B>Sen~a</B>, w-less.", "0"],
["dreliko", "drelik-o", "(tex) drill(ing), ticking (for tents, sacks, etc.). coarse twill(ed), cotton fabric, canvas (linen or cotton) cloth, sacking, clothing.", "0"],
["dreni", "dren-i", "(<I>-rt), (senakvigi</I>), <B>1</B> Drain, dry, draw liquid away (off), empty to the dregs. <I>kampon, minon, teron, tubon</I>. <B>2</B> (surg) d. (cavities in body). <B>~o</B> drain, outlet, <B>~ado</B>, -ing. <B>~ilo</B>, <B>~puto</B>, <B>~tubo</B>, drain-pipe, etc. ➞ <I>kloak</I>.", "0"],
["dresi", "dres-i", "[UV] Train (animal). <B>1</B> coach, teach (tricks, etc.) <I>~i hundon, pulojn</I>. <B>2</B> (gen) drill. <B>3</B> <I>kvietigi, malsovaĝigi</I>, break in, tame (Jer 31/18). ~i <I>ĉevalon</I>, (fac) <I>edz(in)on</I>. <B>~ado</B>, dressage. <B>~isto</B>, -er. <B>Leon-isto</B>, lion-tamer. <B>Serpent-isto</B>, snake-charmer. <B>Voĉ-ado</B>, voice-ing. <I>[Ne= \\est.]</I> ➞ <I>trejn</I>.", "0"],
["driado", "driad-o", "(<I>arbara nimfo</I>), (myth) dryad, wood nymph.", "0"],
["driaso", "drias-o", "(bot) mountain avens (<I>Dryas</I>).", "0"],
["dribli", "dribl-i", "(football) dribble.", "0"],
["drilo", "dril-o", "Drill, pointed steel borer. <I>Brust- (man-tordit-)a ~o</I>, breast (hand, twisted) d. <B>~i</B>, bore with a d. <I>[Ne ~~ dresi.]</I>", "0"],
["drinki", "drink-i", "(<I>-n</I>, abs) [UV] (<I>malmodere trinki</I>), Drink hard (to excess), booze, swill, tipple. <I>~i la tutan nokton</I>. <B>~ado</B>, -ing bout, carusal, orgy (Ho 4/18). ➞ <I>bakanal, orgi</I>. <B>~aĵo</B>, liquor (Jes 28/7). <B>-antaro</B>, circle of revellers. <B>~ejo</B>, [UV] d-shop, pub., tavern. <B>~ejestro</B>, publican. <B>Star~ejo</B>, bar. <B>~ema</B>, sottish. <B>~(em)ulo</B>, soaker, tippler, toper, sot, winebibber. <B>~igi</B>, ply with liquor (Ĥb 2/15). <B>~ĉambro</B>, bar, taproom. <B>For~i</B>, d. away, waste in d. <B>Post~a</B> <I>doloro</I>, morning-after feeling. ➞ <I>ebri, malsobr, trink</I>.", "0"],
["drioptero", "driopter-o", "(<I>Dryopteris</I>), buckler fern &gt; male fern.", "0"],
["drivi", "driv-i", "(nt), Drift. <B>1</B> (mar) be carried by current of air or water. <B>2</B> be deflected from path, <B>f</B> be carried aimlessly or passively. <I>~i de loko al loko</I>. <B>~o</B>, d., leeway; deviation, swerve. <B>~ado</B>, -ing. <B>f</B> policy of inaction, waiting on events. <B>Neĝ~ado</B>, snow-d. <B>~anta</B>, adrift. <I>~anta pluvo</I>, d-ing rain. ~angulo, angle of swerve, leeway, <B>-glacio</B>, <B>-ligno</B>, d-ice, d-wood. <B>-korekto</B>, (<I>horizontala ekarto</I>). <B>~tabulo</B>, leeboard. ➞ <I>aberaci, devoj- (deklin-flanken-)iĝ, diverĝ. [Ne= drajv, vetur.]</I>", "0"],
["drizelo", "drizel-o", "(<I>nebula pluvo</I>), drizzle. <B>~eto</B>, Scotch mist.", "0"],
["drogo", "drog-o", "[UV] drug, medical substance. <B>~i</B> (<I>iun</I>), <B>1</B> drug, administer drugs to. <B>2</B> dope, nobble. <B>~ejo</B>, drugstore. <B>~(vend)isto</B>, druggist, chemist. <B>~ujo</B>, medical chest, etc. ➞ <I>apotek, farmaciaĵ, medikament</I>.", "0"],
["drola", "drol-a", "droll, amusing, queer, odd.", "0"],
["dromedaro", "dromedar-o", "[OA] (<I>kamelo unuĝiba</I>), dromedary (Arabian camel) (<I>Camelus dromedarius</I>).", "0"],
["drongo", "drong-o", "(orn) drongo (<I>Dicrurus</I>).", "0"],
["droni", "dron-i", "(nt), [UV] Drown. <B>1</B> be -ed,. perish by -ing. <B>2</B> be swallowed up, founder, go down, sink (to the bottom), <B>f</B> be engulfed (lost). <I>~i en bruo, ĉielbluo, krepusko, koto, mallumo, silento</I>. <B>3</B> be overwhelmed: drown (in details), be snowed under (by work), head over heels (in debt); wallow (in luxury). <B>4</B> be deep (immersed, lost) (in dreams, tears, thought). <B>~igi</B> (<I>-n</I>), drown, kill by -ing, submerge. <I>~igi katon (sin</I>). <B>f</B> deaden (<I>doloron</I>). <B>For~igi</B> (Ij 14/19). <B>~into</B>, -ed person. ➞ <I>alfundiĝ, embarasiĝ, enabismiĝ, perdiĝ, superŝutiĝ, subakviĝ, submergiĝ</I>.", "0"],
["droso", "dros-o", "(mar) tiller-rope, rudder-chain.", "0"],
["droŝko", "droŝk-o", "(<I>Rusa fiakro</I>), droshky.", "0"],
["drozero", "drozer-o", "(bot) sundew (<I>Drosera</I>).", "0"],
["druido", "druid-o", "Druid. <B>~a</B>, -ic(al), <B>ĉef~o</B>, arch-d.", "0"],
["drupo", "drup-o", "(<I>kernofrukto</I>), drupe, stone fruit, e.g., <I>Ĉerizo, abrikoto, olivo, pruno</I>. ➞ <I>kern</I>.", "0"],
["du", "", "[UV] Two (➞ <I>ambaŭ</I>), <B>~a</B>, second. <I>~afoje</I>, for the second time. <I>~a grado, klaso</I>. <B>~e</B>, secondly, in the second place. <B>~o</B> (<I>da</I>), couple, pair (➞ <I>par). Vers~o</I>, distich. <B>~eco</B> (<I>dualeco</I>), duality. <B>~era</B>, <B>~elementa</B>, binary, duplex, <B>~(part)igi</B>, divide into two parts. <I>Faldi</I> <B>~ige</B>, fold in two (half). <B>~uma</B>, <B>(po~a)</B> <I>nombrosistemo,</I> with basis of two. <B>DU-</B>, bi-, di-, two-. <B>~atoma</B>, diatomic. <B>~ĉevala</B>, two-horse. <B>IT ~dek</B>, 20 (one word). <B>dek du</B> (12) (two words). <B>~foje</B>, twice (over) (repetition). <B>~jarulo</B>, a two-year-old; (hort) biennial. <B>~monata</B>, bimonthly, <B>~parta</B>, bipartite, two-piece. <B>Dek~o</B>, dozen. <I>~~uma (podekdua</I>), duodecimal. <I>~~nota skalo</I>, 12-note scale. <B>Duobl-a</B>, Double, two-fold. (mus) <I>~a kontrapunkto</I>, d-counterpoint. <I>~a (dusubjekta) fugo</I>, d-fugue. <I>~a noto</I>, breve. <B>~e</B>, twice, doubly (multiplication). <I>~e du, kvar. ~e (pli) (ol</I>), twice as much (as). <B>~o</B>, d. <B>~aĵo</B>, duplicate. <B>~igi</B>, d., multiply by two. <B>Duon-a</B>, Half. <I>~a noto, silento</I>, minim (rest). <B>~e</B> <I>farita</I>, h-done. <B>~o</B>, half. 3 <I>estas ~o de</I> 6. <I>Funto kaj ~o (da</I>), 1| lbs. <I>Je la tria kaj ~o</I>, at 3.30. <B>~igi</B>, halve. <B>Po~e</B>, by halfs. <B>DUON-</B> (pfx) Half-, hemi-, semi-, partly. <B>~duto</B>, semitone. <B>~frato (=</B> <I>duonsanga</I>), half-brother (➞ <I>stif-</I>). <B>~sfero</B>, hemisphere. <B>~bakita</B>, <B>~kovrita</B>, <B>~nuda</B>, <B>~oficiala</B>, <B>~plena; ~dormi</B>, <B>~fermi; ~cirklo</B>, <B>~horo</B>, <B>~lumo</B>, <B>~luno; ~voĉe</B>, <B>~voje</B>. ➞ <I>pair</I>. <B>Duop-a</B>, two together. (mus) <I>~a anĉo, pedalo, suspendo</I>, double reed (pedal, suspension). (tel) duplex. <B>~e</B>, by twos, in double file, two by two. ➞ <I>dipleks, dupleks</I>.", "0"],
["duala", "dual-a", "[OA] Dual, <B>~eco</B>, -ity. <B>~ismo</B>, -ism. <B>~isto</B>, -ist.", "0"],
["dubi", "dub-i", "(<I>-n, ĉu, ke, pri; abs</I>), [UV] Doubt, be in d. (uncertain, undecided) about, hesitate to believe. <B>~o</B>, doubt, hesitation, uncertainty. <I>Esti en ~o. Forigi (senti) ~on</I>. <B>~a</B>, -ful, in d., dubious, problematic, uncertain, undecided. 1 (<I><B>pri</B><B>~ebla</B>, <B>~inda</B></I>) questionable (of uncertain meaning, character, or truth. <I>~a aserto, lojaleco, okazo, plibonigo, rezulto</I>. <B>~e</B>, with d. <B>~eco</B>, dubiety. <B>Ekster~a</B>, beyond doubt. <B>Ne~ebla</B>, <B>Sen~a</B>, un-ed, certain, indubitable. <B>Pri~i</B>, call in question, cast doubts on. <B>Sen~e</B>, certainly, no doubt. <I>Sen~e vi iris</I>, you must have gone. ➞ <I>hezit, sin demand, skeptik, skrupul, ŝanceliĝ</I>. opposite <I>cert, decid, fid, kred</I>.", "0"],
["dublo", "dubl-o", "(carp, mec), dowel, headless pin, peg, plug. (us. of wood), fitting hole. ➞ <I>ŝtopil, tampon</I>.", "0"],
["duelbirdo", "", "(a. <I>pugnako</I>) (orn.), ruff (<I>Philomachus pugnax</I>). <B>~~ino</B>, reeve.", "0"],
["duelo", "duel-o", "[OA] (<I>dubatalo</I>), Duel, contest (encounter) between two, affair of honour. <B>~i</B>, (fight a) duel. <B>~ado</B>, -ling. <B>~ejo</B>, -ling ground. <B>~isto</B>, -list. <B>~atestanto</B>, second. <B>~invito</B>, challenge. ➞ <I>kartel</I>.", "0"],
["duenjo", "duenj-o", "duenna, elderly governess and chaperon in charge of girls.", "0"],
["dueto", "duet-o", "[OA] (<I>duteto</I>), duet, piece for two voices or performers.", "0"],
["duglasio", "duglasi-o", "(<I>pseŭdocugo</I>), Douglas fir. (➞ <I>cug</I>).", "0"],
["dugongo", "dugong-o", "(zoo) dugong (<I>Dugong</I>).", "0"],
["dukato", "dukat-o", "[OA] (num) ducat.", "0"],
["dukdalbo", "dukdalb-o", "(mar) mooring-pile.", "0"],
["duko", "duk-o", "[UV] Duk/e (wide sense) <B>~a</B>,-al. <B>~eco</B> -dom. <B>~ejo</B>, <B>~lando</B>, duchy. <B>~ino</B>, duchess. <B>ĉef~o</B>, arch-d. <B>Granda ~o</B>, Grand d.", "0"],
["duktila", "duktil-a", "(<I>= etendebla, fadenigebla</I>), ductile, <I>malleable, tensile, (of clay) plastic</I>. <B>~eco</B><I>, extensibility</I>.", "0"],
["dukto", "dukt-o", "(anat) (bot) (el), Duct. <I>Ov~o,</I> oviduct. <I>Glando</I> sen<B>~a</B>, d-less.", "0"],
["dulcitono", "dulciton-o", "(<I>tipofono</I>), (m.i.) dulcitone, celeste with tuning-forks.", "0"],
["dum", "", "[UV] <B>1</B> (prep) (<I>=en la daŭro (tempo) de</I>), during. <I>~ lia dormo</I>, d. his sleep. <B>2</B> (conj) (= <I>tiel longe, kiel; en la tempo, kiam</I>), while, whilst (2 Rĝ 2/11). <I>~ ŝi parolis</I>, while (astr) she spoke. <I>Dum</I> (during) <I>la laboro, dum</I> (while) <I>ni laboras</I> [Do not say <I>dum kiam</I>]. <B>3</B> (conj) denotes contrast (<I>sed, kontraŭe</I>), While, but, on the other hand. <I>Vi estas riĉa, ~ mi, bedaŭrinde, estas malriĉa</I>. <B>~a</B>, provisional, interim. <B>dume</B>, [UV] <B>1</B> (<I>intertempe</I>), meanwhile in the meantime (Jona 4/6). <B>2</B> (<I>provizore</I>), for the moment (time being). <I>Ni ~e lasu la demandon</I>.", "0"],
["dumpi", "dump-i", "(<I>-n</I>), Dump. <B>1</B> deposit, shoot (rubbish). <B>2</B> send (goods) to foreign countries for sale at low price. <B>~ado</B>, -ing.", "0"],
["dungi", "dung-i", "(<I>iun, kiel</I>), [UV] Employ, Hire, engage (services of), take on (into service). <I>~i laboriston, serviston, vartistinon</I> (Ne 13/2, Jg 18/4). ~<B>anto</B>, <B>~isto</B>, employer. <B>~ito</B>. employee, hired man, h-ling, worker. <B>~itaro</B>, personelle. <B>~iĝi</B> <I>kiel</I>, be e-ed (take a situation) as. <B>Sin~igi</B> (1 Sa 2/5), hire one’s out. <B>~agentejo</B>, <B>~oficejo</B>, employment agency. <B>~mono</B>, h., wages. <B>~soldato</B>, hired soldier, mercenary. <B>Mal~i</B>, discharge, dismiss, disband, pay off, release, set free. ➞ <I>eksig, forliberig</I>. <B>Mal~o</B>, discharge. ➞ <I>labordon, varb</I>.", "0"],
["duno", "dun-o", "(<I>sabla monteto</I>), dune, sand hill, mound or ridge of loose sand on coast. ➞ <I>kun kunblovitaj sablaj montetoj</I> (4 FA 184/23).", "0"],
["duodeno", "", "(anat) duodenum. <B>~a</B>, -al. <B>~ito</B>, -itis.", "0"],
["duolo", "duol-o", "(mus) duplet.", "0"],
["dupleksa", "dupleks-a", "(tel) duplex (<I>sendo kaj ricevo samtempe</I>). ➞ <I>dipleks</I>.", "0"],
["duplikato", "duplikat-o", "Duplicate, one of two things exactly alike, copy. <I>~o de fakturo</I>. <B>~a</B>, d., with two corresponding parts, existing in two examples. <B>~e</B>, in duplicates, make exact copy, produce copies of.", "0"],
["dura", "dur-a", "= malmola. ➞ <I>major</I>.", "0"],
["durio", "duri-o", "durian tree (<I>Durio</I>).", "0"],
["duro", "dur-o", "(num) douro.", "0"],
["duŝi", "duŝ-i", "[OA] (<I>-n</I>), douche, (hort) spray. <B>~o</B>, d., Shower-bath, etc. <I>Surĵeti malvarman ~on</I>, throw cold water on. <I>Intesta ~o (klistero). Naz~o. Pluv~o, spruco. Sin ~i,</I> take a s-b. <B>~ado</B>, <B>~ejo. ~ilo</B>, (hort) rose spreader.", "0"],
["duto", "dut-o", "(mus. intvl), Second, <B>Dek~o</B> (<I>kvintokto</I>), 12th. <B>Majora ~o</B>, major s. <B>Minora ~o</B>, minor s. <B>Rim</B>.: Oni povas uzi <I>Plen~o, duon~o, kvaron~o, tri~o</I>, whole (semi- quarter-tri-)tone, por eviti la ambiguecon de la radiko ton. (which see).", "0"],
["E", "", "[F], letter E. (ac) 659 • 3 <I>vibroj sekunde</I>. <B>E-be</B>, <B>E bemola</B>, E flat. <B>E-kordo</B>, E-string.", "0"],
["e", "-e", "[UV] ending of derived advbs. <B>1</B> Den. (a) HOW<I>. Bone</I>, well. <I>Kune</I>, together, <I>Unue</I>, first. <I>Somere vestita</I>, in summer dress, (b) WHERE. <I>Hejme</I>, at home. <I>Antaŭe</I>, in front. <I>Alte</I>, on high, (c) WHEN<I>. Nokte</I>, at night. <I>Matene</I>, in the morning. <I>Dimanĉe</I>, on Sundays. <B>2</B> Replaces <B>-a</B> in impersonal phrases (without a noun or pronoun with which an adj. could agree). <I>Estas bone</I>, it is well. <I>Estu lume kaj gaje</I>, let there be light and gaiety. <B>3</B> An adverb often replaces an English phrase, e.g. (actual telegram): <I>Tutvoje sardinis koridore</I>, (Travelled) the whole way packed like sardines in the corridor. <B>~vorto</B> (<I>adverbo</I>), adverb.", "0"],
["easto", "east-o", "east (proposed compass direction), ordinary language <I>oriento</I>.", "0"],
["ebena", "eben-a", "[UV] Even, Level, in same Plane, smooth. <I>~a tero, vojo. (voj~)o</I>. (geom, mat), p. <B>~aĵo</B>, <B>~eco</B>, <B>~ejo</B>, plane-surface, 1. tract of country, plain. <B>Alt~aĵo</B>, plateau. <B>~igi</B>, (make) 1. (smooth), 1. out. <I>~igi la herbon. vojon</I>, roll, <B>f</B> pave (the way). <B>Mal~a</B>, bumpy, hilly, rough. <B>Ne~a</B>, uneven. (av) <B>Akvo~o</B>, sheet of water. <B>Klin~o</B>, inclined p. ➞ <I>glat, nivel, plan, plat, sensulk</I>.", "0"],
["ebl", "-ebl", "[UV] (sfx) denotes possibility, = able to (that can or may) be -ed; -able, -ible (in this sense) (➞ <I>audible, portable). Mallumo</I> <B>palp-a</B>, that may be felt (El <B>10/21)</B>. <I>Facile</I> <B>lern~a</B>, easy to learn. <B>Vid~a</B> = able to be seen [not: able to see]. <B>Rim</B>.: Cannot follow an intransitive vb (<I>bol, brul, ĉes …</I>), unless this is made transitive by <B>-ig</B>. Thus: <B>boligebla</B> [not <I>boleblal</I>. So also with an adj root: <B>sanigebla</B> [not: <I>sanebla</I>]. <B>Rim</B>.: Cannot follow vbs with <B>-iĝ</B>, because these are intransitv: <B>-iĝebla</B> has no meaning. Thus: <B>Fleksebla</B>, or <B>flek- siĝema</B> [not: <I>jleksiĝebla</I>]. But when a prepositional prefix is expressed or implied, the verb becomes transitive, and <B>-ebla</B> can then <B>be</B> used, e.g., <I>Strato (sur</I>) <B>vetur~a</B> (➞ <I>surveturi straton); truo (en</I>) <B>ramp~a;</B> <I>vojo (laŭ</I>) <B>ir~a;</B> <I>lando (en</I>) <B>loĝ~a;</B> <I>vojo</I> <B>nereven-a</B> (Ij <B>16/22). Rim</B>.: <B>~ebla</B>, <B>~inda</B>, imply the passive sense; <B>~em</B>, <B>-iv</B>, the active, e.g., <B>amebla</B>, <B>aminda</B> = able (worthy) to be loved; but <B>amema, amiva</B> (or <B>ampova</B>), = inclined (able) to love. [Common errors: <I>Mi neeble povis respondi, Mi ne eblis respondi</I>. Correct to <B>Mi ne povis</B> (or <B>Ne estis eble) respondi.]</B> <I>AS A ROOT</I>. <B>~a</B>, Possib/le, that may be. <I>Mi faros mian ~on</I>, what I can. <B>~e</B>, [UV] -ly, may be, perhaps (1 Sa 6/5). <B>~eco</B>, -ility. <B>~ete</B>, there is a faint -ility. <I>Ĉu</I> <B>~as</B> (<I>estas ~e) iri?</I> Is it p. to go? <B>~igi</B>, enable. <B>Laŭ~e</B>, as far as p.", "0"],
["ebolo", "ebol-o", "dwarf elder, danewort (<I>Sambucus ebulus</I>).", "0"],
["ebono", "ebon-o", "[UV] Ebon/y (wood), <I>~a skatolo</I>. <B>~e</B> <I>nigra</I>, e-black. <B>~arbo</B>, e-tree (&gt; <I>Diospyros</I>). <B>~ito</B>, -ite, vulcanite.", "0"],
["ebria", "ebri-a", "[OA] Intoxic/ated, Drunk, inebriated, the worse for drink, tipsy, <B>f</B> <I>~a de amo, feliĉo, furiozo, sukceso, vino</I> (Na 1/10). <B>~(ec)o</B>, intoxication. <I>Vera opinio montriĝas en ~o</I>. <B>~ega</B>, blind (dead) drunk. <B>~eta</B>, fuddled, half-d. <B>~igi</B>, intoxicate, make d. <B>~igaĵo</B>, intoxicant, strong drink (1 Sa 1/15). <B>~ulo</B>, s-o drunk (Ps 107/27). <B>Mal~iĝi</B>, sober down. ➞ <I>drink, malsobr. Kun kapo</I> <B>post~e</B> <I>peza</I>, \"the morning after the night before\".", "0"],
["eburo", "ebur-o", "[OA] (<I>elefantosto</I>), Ivory. <B>~a</B> <I>statuo, ~a Bordo CI</I>. Ivory Coast. <I>~a nigr(aĵ)o</I>, i-black. <B>~aĵo</B>, i-ware. ➞ <I>dentin</I>.", "0"],
["ec", "-ec", "[UV] sfx denotes quality, state (in abstract form). ➞ <I>-ety, -ice, -ness</I>, etc. <B>I</B>. (adj. root). <B>Ali~o</B>, difference. <B>Oft~o</B>, frequency. <B>Sol~o</B>, solitude. <B>Vast~o</B>, extent. <B>Rim</B>.: <B>-eco</B> and <B>-o</B> are often used as synonymns. But there is a difference: <B>-o</B> = a mild form of <B>~aĵo; ~eco</B> = quality, \"nessness\". <I>Utilo</I>, use; <I>utileco</I>, usefulness. <I>Vero</I>, truth; <B>vereco</B>, truthfulness. <I>Fari bonon pro korboneco. Feliĉeco, kontenteco, kuraĝeco</I> are needlessly heavy, if what is meant is <I>feliĉo, kontento, kuraĝo</I>. <B>II</B>. (noun root) = quality, office, state. <B>Amik~o</B>, friendship, friendliness. <B>Reĝ~o</B>, kingship, royalty. <B>Vir~o</B>, manhood, manliness, virility. <B>III</B>. (verb root). The sense is usually <I>active</I>. <B>Nutr~o</B>, nutritiousness. <B>Posed~o</B>, ownership. <B>Dank~o</B>, thankfulness. (➞ <B>dankemo</B>, disposition to give thanks). For the passive it is usual to insert -it (-ot, -at). Difin(it)~o, eduk(it)~o, kapt(it)~o. <B>Rim</B>.: The form -emeco is pleonastic: penetremo or penetreco suffices instead of penetremeco. <B>Rim</B>.: Stms ~eco = aĝo. <I>En mia jun~o (= junaĝo). <B>~</B></I><B>eca</B> [OA]. <B>1</B> (noun <I>it) = -simila, kvazaŭ-a</I>. <B>Risort~a</B> (springy, resilient) <I>matraco</I>. <B>Dezert~a</B> <I>silento;</I> <B>fraŭl~a</B> <I>vivo;</I> <B>hejm~a</B> <I>sento;</I> <B>vitr~aj</B> <I>okuloj</I>. <B>2</B> (verb root). <B>Viv~a</B> (<I>vivoplena</I>), animated, lively, vivacious. <B>3</B> (adj root). Here <B>~eca</B> would be pleonastic (<I>= a-a-a</I>), and seldom useful. Note, however, <B>sol~a</B>, lonesome, solitary (opp <B>sola</B>, alone); <B>verd~a</B> (or <B>verdeta)</B>, greenish. <I>AS A ROOT</I>. <B>~o</B>, quality, attribute. <I>Peko kaj eraro estas ~oj de l’ homaro</I>. <B>~a</B>, [UV] qualitative. <B>~aro</B>, character, nature. <B>Rim</B>.: Sometimes English -ism = E. <B>-eco. Hero~o</B>, heroism. <B>Fanatik~o</B>, fanaticism. But there is a difference between <B>katolikeco =</B> catholic-ism, -icity (quality), and <B>katolikismo</B> = catholicism (doctrine, system). ➞ <B>~a</B>, <I>-em, -ism, kvalit</I>.", "0"],
["eĉ", "", "(adv), [UV] Even. Invites comparison with another statement understood. <I>Mi neniam ~ vidis la libron</I> (much less did I read it). <I>Cu li ~ suspektas</I> (not to say realize) <I>la danĝeron? Ŝi kantas ~ pli bone ol li</I> (though he sings quite well). <I>~ ne unu</I>, not e. one, not a single. <I>Se ~ malmulte</I>, if only a little. <I>Li ne mortis’, mi ~ (kontraŭe) povas diri, ke li sanegas</I>.", "0"],
["edelvejso", "edelvejs-o", "(<I>neĝfloro</I>), edelweiss (<I>Leontopodium alpinum</I>).", "0"],
["edemo", "edem-o", "(<I>akva ŝvelo</I>), (med) oedema, local dropsy. ➞ <I>vezik</I>.", "0"],
["EDENo", "EDEN-o", "<B>1</B> Eden (Ge 2/8). ~a <I>ĝardeno. <B>2</B></I> Delightful abode. ➞ <I>elize, paradiz</I>.", "0"],
["edifi", "edif-i", "(<I>-n</I>), [UV] Edif/y, benefit spiritually, strengthen, support. <B>~a</B>, -ying. <I>~a kanto, libro, sperto</I> (Ps 47/7, Se 6/23). <B>~(ad)o</B>, -ication. <B>Mal~a</B>, un-ying, debasing, scandalous. Ne<B>~a</B>, unprofitable. ➞ <I>konstru, skandal</I>.", "0"],
["edikto", "edikt-o", "[OA] edict, proclamation by authority, order by ruler to subjs. <B>~i</B>, decree, enact. ➞ <I>dekret, ukaz</I>.", "0"],
["edoj", "-ed-oj", "(zool sfx) den family (-<I>idae</I>). <B>Cerv~oj</B>, cervidae.", "0"],
["edro", "edr-o", "(geom) face. Dek<B>~o</B>, decahedron. <B>Mult~o</B>, polyhedron. ➞ <I>fac, fiank, surfac</I>.", "0"],
["eduki", "eduk-i", "(<I>-n</I>), [UV] Educat/e, Train. <B>1</B> Bring up, provide schoolg for. <I>infanon</I>. 2 cultivate. <I>~i kapabl-(talent-)on</I>. <B>3</B> (early writings) breed, raise, rear. <I>~i hund-(heder-)on</I> (Jona 4/10). ~(ad)o, e-ion, development of powers., instruction, t-ing. <I>Don-(ricev-)i bonan ~on. ~o orela, profesia. Manko de ~o</I> (Se 5/23). <B>~a</B>, e-ional, tutorial. <I>~a ŝipo</I>, t-ing ship. <B>~ato</B>, pupil. <B>~ejo</B>, institute, school, etc. ~iĝo, ~iteco, e-ion (reed). <B>~isto</B>, e-or, t-er, mentor. <I>Ĉeval ~isto</I>, horse t-er. Ne~ita, badly brought up, ill-bred, unpolished. Ne<B>~ebla</B>, difficult, not amenable to discipline (➞ <I>obstin, senbrid</I>). ➞ <I>bred, disciplin, dres, guvern, instru, kultur, trejn, vart</I>.", "0"],
["edzo", "edz-o", "[UV] husband, spouse. <B>~iĝo</B>, Marriage. <B>~ino</B>, wife. Possible derivatives run in threes: <I>edzo, edzino, geedzoj</I>. <B>~a</B> (<I>~ina geedza) vivo</I>, wedded life. As there can be no wedding without a wife, <I>ge</I> is often omitted, and <I>edziĝo</I> is more usual than <I>geedziĝo</I>. <B>~eco</B> [UV] (~ineco, ge~eco), matrimony, wedlock. <B>~(ec)a</B>, conjugal, connubial, marital, matrimonial. <B>~eca</B> <I>feliĉo</I>, -ied happiness. <B>~ece</B> <I>feliĉa</I>, happily -ied. <B>~(in)igi</B> (<I>-n, al</I>), marry, give in marriage, perform the -iage ceremony. <B>~igita</B>, -ied. <B>~inigi</B>, -y (as a husband) (Mai 2/11). <B>~(in)igebla</B>, marriageable. <B>~(in)igi</B> (<I>al, je, kun</I>), [UV] (<I>preni kiel edz(in)on</I>), -y, get -ied. <B>f</B> <I>~(olig)iĝi en familion. ~iĝi pro amo (mono). Proponi ~iĝon</I>. ~iĝa, hymeneal, nuptial. <I>~iĝa promeso, soleno, ringo, vesto</I>. <B>Bo~eco</B>, levirate. <I>Bo~iĝi (kun fratedzino</I>) (Ge 38/8). <B>Ekster~eca</B> (<I>natura, neleĝa</I>), bastard, illegitimate. <B>Eks~iĝo</B> (<I>divorco</I>), divorce. <B>Krom~ino</B>, second wife (in polygamy), <B>Mis~iĝo</B>, mesalliance. <B>Ne~igita</B>, ne~iĝinta (<I>fraŭla</I>), unmarried. <B>Nov~ino</B>, young bride, Mrs Newly-Wed. <B>Pastr~ino</B> (<I>edzino de pastro</I>). <B>Pastrin~o</B> (<I>edzo de pastrino</I>). <B>Prov~iĝo</B>, trial marriage. <B>Sen~eco</B>, celibacy. ➞ <I>divorc, nupt</I>.", "0"],
["efedrino", "efedrin-o", "(pharm) ephedrine.", "0"],
["efektiva", "efektiv-a", "[UV] (<I>vere ekzistanta</I>), Real, actual, matter-of-fact, positive, true. <I>~a forto, neceso, rimedo, ŝuldo, valoro. ~a najtingalo</I> (opposite <I>artefarita</I>) (2 FA /28) <B>~e</B>, -ly, indeed, in reality; actually, as a matter (in point) of fact, as it happens. Ĉu ~? Is that -ly so? Really? <B>~e!</B> (col) Sure enough! That is so! <B>~aĵo</B>, -ity, fact, <I>fait accompli</I> (Jes25/1). <B>~igi</B>, realize, accomplish, bring about, carry into effect, consummate, (give) effect (to), execute, perform. <I>~igi intencon, planon</I> (➞ <I>ating, elfar, plenum, realig</I>). <B>~igebla</B>, practicable. <B>~iĝi</B>, be -ized, come to pass (Jes 14/24). ➞ <I>aktual, efik, fakt, real, ver [Ne= efika]</I>.", "0"],
["efekto", "efekt-o", "[OA] (<I>forta impreso</I>), Effect (produced), impres sion made. ~o <I>bona, bela, sensacia</I>. <B>~i</B> (<I>fari ~on</I>), produce an e., be -ive. <B>(Grand)~a</B>, -ive, impressive, showy, telling. <B>~ama</B>, posing. <B>Ne~a</B>, <B>Sen~a</B>, futile, without e. <B>Lum~oj</B> (<I>en pentraĵo</I>). <B>Son~oj</B>, (cin) sound effects. ➞ <I>efik, impres, potenc, rezult, sensaci, sukces</I>.", "0"],
["efemerido", "efemerid-o", "ephemeris, astronomical almanac or table.", "0"],
["efemero,", "efemer-o,", "[OA] may-fly (<I>unutaga muŝo</I>) (4 FA 5/13) (<I>Ephemera</I>), <B>~a</B> ephemeral, fleeting, passing, short-lived, transitory. <I>~a populareco</I>. ➞ <I>nedaŭr, unutag</I>.", "0"],
["eferveski", "efervesk-i", "(nt) effervesce. <B>~o</B>, effervescence. <B>~a</B> <I>pulvoro</I>. ➞ <I>bobel, ŝaŭm</I>.", "0"],
["efiki", "efik-i", "(<I>al, sur, kiel</I>, abs) [UV] (<I>havi rezulton</I>). have Effect (act, operate, work) upon, avail, be -ive (-ual, efficacious); produce a result, tell upon (nerves, etc.). <B>~ita</B>, affected, moved (3 FA 85/31) <B>~a</B> (<I>rezultiga</I>), effective, -ual, availing, efficaceous, effecient; operative. <I>~a admono, averto, forto, laboro, rezisto, rimedo</I>. <B>~o</B>, effect, influence, operation, working. <I>Kaŭzo kaj ~o. ~o de bombado</I>. <B>~eco</B>, <B>~ivo</B>, efficacy, efficiency, potency, power, virtue. <B>Bon~a</B>, good (for), <B>Fort~a</B> (<I>drasta</I>), <B>Ne~a</B>, <B>Sen~a</B>, in-ual, unavailing. <I>Sen~a protesto</I>. <B>Post~oj</B>, after-effects. <B>Retro~i</B>, have retrospective effect. ➞ <I>ag, aktiv, efektiv, kapabl, valid</I>.", "0"],
["efloreski", "efloresk-i", "(nt) effloresce, (chem) form powder, (bot) burst into flower. <B>~o</B>, effloresence, bloom. ➞ <I>pulvoriĝ</I>.", "0"],
["efluvo", "efluv-o", "(el) effluence, glow discharge. <B>Kron~o</B>, corona effect.", "0"],
["efodo", "efod-o", "ephod, garment of Jewish High Priest (El 28/4,6).", "0"],
["eg", "-eg", "[UV] (➞ Gr <I>mega-</I>), augmentative sfx. To a high degree strengthens (increases, intensifies) the root idea. With noun root = <I>granda;</I> with adj. or verb root <I>= forte, multe, tre;</I> but superlatively, more strongly than these words. In national langs. a new root is usual. Ega, deep, intense. <B>Dolor~o</B>, agony, anguish, torment. <B>Dom~o</B>, mansion. <B>Bel~a</B>, splendid, superb. <B>Blu~a</B>, deep blue. <B>Grand~a</B>, enormous, immense. <B>Malsan~a</B>, at death’s door. <B>Am~i</B>, love passionately. <B>Malam~i</B>, detest, abhor. Opp <I>et</I>.", "0"],
["egala", "egal-a", "(<I>al</I>), [UV] Equal. <B>1</B> <I>= sam-granda, samkvanta, samranga, samvalora</I>, equivalent, same in number (size, value). <I>~a ŝanco</I>. <B>2</B> (<I>senvaria</I>), constant, even, smooth, uniform, unvarying. <I>~a animo, humoro, paŝo, pulso, voĉo</I>. <B>3</B> (<I>indiferenta</I>), indifferent. <I>Estas <B>~e</B></I>, it is all the same. <I>Tute <B>~e</B></I>, it matters little, is of no moment. <B>4</B> (ac) <I>~a temperado</I>, eqal temperament. <B>~e</B>, -ly, alike, uniformly. <I>~e bone, kiel</I>, just as good as. <B>~i</B> (<I>al, -n</I>), (be) e. (to), come up to, match. <B>~aĵo</B>, equivalent. <B>~eco</B>, -ity, parity. <I>Tagnokt~eco (ekvinokso</I>), equinox. <B>~igi</B>, -ize, level, smooth, square (a/c), (rad) <I>~iga bobeno</I>, equalizing coil. <B>~ulo</B> (<I>samrangulo</I>), e., match, peer. <B>Egal-</B> (<I>sam-</I>), equi-. <B>Mal~a</B>, <B>ne~a</B>, unequal, different, uneven. <B>Mal~eco</B>, disparity. <I>Ne~aj pesiloj</I>. <B>Sen~a</B> (<I>unika</I>), matchless, peerless, unique, unrivalled. ➞ <I>eben, ekvaci, ident, kompens, par, sam</I>.", "0"],
["egido", "egid-o", "[OA] (myth) aegis, shield, <B>f</B> patronage, protection. ➞ <I>aŭspici, protekt, ŝild, ŝirm</I>.", "0"],
["Egiptujo, Egiptio", "", "EG {1989: <B>Egipto</B>}.", "0"],
["eglanterio", "eglanteri-o", "(<I>sovaĝa rozo</I>), wild rose, sweet brier (<I>Rosa eglanteria</I>).", "0"],
["eglefino", "eglefin-o", "haddock (<I>Gadus eglefinus). ~o fumaĵita</I>.", "0"],
["egoo", "ego-o", "(<I>mio</I>), Ego, the Self. <B>~ismo</B> [OA] (<I>sinamo</I>), egoism, self-interest, selfishness. <B>~isto</B>, [OA] egoist. <B>~ema</B>, <B>~ista</B>, selfish, selfcentred, self-seeking. <B>Mal~ismo</B>, (<I>altruismo</I>), altruism, unselfishness. <B>Ne~ista</B>, <B>sen~isma</B>, disinterested.", "0"],
["egopodio", "egopodi-o", "(bot) gout-weed, bishop’s weed, ground alder, herb Gerard (<I>Aegopodium podagraria</I>).", "0"],
["egreto", "egret-o", "<B>1</B> (orn) egret (<I>Egretta</I>). ~o blanka, Great white heron. <B>2</B> (~a tufo, <I>plumtufo</I>), aigrette, plume, tuft (feathers), spray (gems). ➞ <I>arde, tuf</I>.", "0"],
["eĝo", "eĝ-o", "(<I>angulrando</I>), Edge, arris, corner; bead, rib (<I>muldaĵa</I>); bridge (<I>naza</I>); brink (<I>klifa</I>); crest (<I>montara</I>); groin (<I>volba</I>), ridge (<I>kolona</I>); rim (<I>tasa). ~o de klingo, kristalo, tablo, tegmento</I>. (av) <B>Front~o</B>, leading edge. <B>Post~o</B>, trailing e. <B>Teks~o</B> <I>= rubando</I>. <B>~e(n)</B>, edgeways, edgewise. <B>~igi</B>, give an e. to. <B>~ingo</B>, groove, socket cutting. ➞ <I>akrig, krest, rand</I>.", "0"],
["ehe!", "", "(interjection) denotes comprehension, perception. <I>~! nun mi komprenas!</I> Eh! is found at Rz 6/23.", "0"],
["eĥo", "eĥ-o", "[UV] Echo. <B>~i</B> (<I>-n, abs</I>), echo, resound. <I>~e resoni</I>. <B>f</B> imitate, repeat, (org) <I>~a sekcio</I>, echo-organ. <B>~iĝi</B>, resound, reverberate, ring. <B>Sen~a</B>, echoless, without response.", "0"],
["ej", "-ej", "[UV] (sfx) denotes Place <B>1</B> (with verb root): = p. (building, establishment, room etc.) where an action occurs; allotted to (used for) the action. <I>Naĝejo, dormejo, lernejo, preĝejo</I>, swimming-bath, dormitory, school, church. <B>2</B> (with noun root): p. for (of) some preceding verb, e.g., <I>est, kresk, loĝ, lud, manĝ, vend</I>, being understood. <B>Erik~o</B>, heath. <B>Golf~o</B>, golf course. <B>Kaf~o</B>, cafe. <B>Orf~o</B>, orphanage. <B>Tend~o</B>, encampment. Greater precision may be given by adding the vb implied. Thus: teejo may <I>= teplantejo, tekreskejo, tekultivejo, tetenejo, tevendejo, tetrinkejo</I>, etc. With context the shorter form usually suffices. <B>Rim</B>.: ➞ -ejo (locality) with -ujo = container (of obj). Cigarejo, cigar-depot, cigar-shop; cigarujo, c-case (box). <B>Rim</B>.: In <I>oficejo, ministrejo, policejo, poŝtejo</I>, and the like, -ejo is used by metonymy both for the department and also for its personelle. <B>Ministr~o</B> <I>de Sano</I>, Ministry of Health.", "0"],
["ej!", "", "(interjection) Eh! denotes <B>1</B> mild disapproval or protest. <I>Ej! Ne tro! 2</I> (a. <I>ĉu ne?</I>) ejaculation of enquiry or surprise, or inviting assent.", "0"],
["ek", "ek-", "[UV] (pfx), denotes <B>1</B> the commencement of a continuous action = begin, start. <B>~aŭdi</B>, come to hear. <B>~batali</B>, join battle. <B>~bruli</B>, catch fire. <B>~dormi</B>, fall asleep. <B>~flami</B>, burst into flames. <B>~flugi</B>, take wing. <B>~iri</B>, set off. <B>~vidi</B>, catch sight of. <B>Rim</B>.: Do not use ~komenci (begin to begin!) if you mean komenci. <B>2</B> Sudden or momentary action. ~brili, ~fulmi, flash. ~kapti, snatch. ~krii, exclaim. ~preni, grasp, seize. ~rigardi, glance. ~salti, start. ~tremi, shudder. Eki (<I> = komenciĝi). ~is la pluvo ( = ekpluvis) ~is vigla diskuto</I>. <B>Rim</B>.: ➞ sidi, be seated (in sitting position); sidiĝi, take one’s seat, sit down; eksidi, start to sit. <I>Eksidante, li rimarkis pinglon sur la seĝo, do li ne</I> sidiĝis (<I>= ne finis sidigi</I>). <B>Rim</B>.: <B>Ek!</B> (interj) = Forwards! Now! On! etc. <I>~ al</I> (Off to) <I>Philadelphia!</I> <B>Rim</B>.: <B>Ekde</B> <I>tiam =</I> since (starting from) then. <I>De tiam</I> usually suffices.", "0"],
["ekarto", "ekart-o", "(mat) approximate error, deflection, deviation, digression, swerve. <I>~o de observo. ~o horizontala, vertikala</I>. <B>Kompas~o</B>, compass error, (cbnd effect of deviation and variation). <B>~o de kronometro</B>, etc. ➞ driv, direkt.", "0"],
["ekbalio", "ekbali-o", "(bot) (<I>Ecbalium) &gt;</I> squirting (wild) cucumber.", "0"],
["ekidno", "ekidn-o", "spiny ant-eater (<I>Echidna</I>).", "0"],
["ekido", "ekid-o", "(zoo) carpet viper (<I>Echis</I>).", "0"],
["ekino", "ekin-o", "(<I>mara erinaco</I>), sea-egg (-hedgehog, -urchin) (<I>Echinus</I>).", "0"],
["ekinospermo", "ekinosperm-o", "burseed, stick-seed (<I>Echinospermum</I>).", "0"],
["ekio", "eki-o", "(<I>vipura herbo</I>), viper’s bugloss (<I>Echium</I>). Vd. <I>likop</I>.", "0"],
["ekipi", "ekip-i", "(<I>-n</I>) [OA], Equip, accoutre, fit out, furnish, provide with requisites. <I>~i armeon. homon, ŝipon</I>. <B>~(ad)o</B>, <B>~(aĵ)o</B>, equipage, -ment, accoutrement, gear, outfit. <B>~estro</B>, (mar) boatswain. <B>~isto</B>, outfitter. <B>Ŝip~isto</B>, ship-chandler. <B>Vir~i</B>, man (ship, etc.). ➞ <I>arm, proviz</I>.", "0"],
["eklampsio", "eklampsi-o", "(med) eclampsia.", "0"],
["eklektika", "eklektik-a", "(phi) eclectic. <B>~ismo</B>. <B>~ulo</B>. ➞ elektem.", "0"],
["eklezio", "eklezi-o", "[OA] (<I>kredantaro</I>), Church (body of believers, religious society). [Ne= <I>preĝejo</I>.] <I>~o Anglikana, Grek-Metodista, Roma</I>. <B>~ano</B>, c-man. <B>~(ec)a</B>, <B>~eco</B>, ecclesiastical, ecclesiasticism. <B>~ulo</B>, ecclesiastic, priest, etc. <B>Alt~a</B> (<I>ritisma</I>), High c. <B>Ekster~a</B>, <B>Ne~a</B>, secular. ➞ <I>civil, sekular</I>. <B>Sam~ano</B>, co-religionist. ➞ <I>kongregaci</I>.", "0"],
["eklipsi", "eklips-i", "(<I>-n</I>) [OA], (astr) eclipse, <B>f</B> out-do, out-shine, surpass, throw into shade. <I>~i konkurantojn</I>. <B>~o</B> <I>luna, suna; parta, plena, ringforma. ~oj de tago</I> (Ij 3/5). <B>~a</B> <I>lumo</I>, intermittent (occulting) light. <I>~a lumturo</I>. ➞ <I>kaŝ</I>.", "0"],
["ekliptiko", "ekliptik-o", "(<I>sunvojo</I>), Ecliptic. <B>~a</B> <I>ebeno,</I> plane of ecliptic.", "0"],
["eklogo", "eklog-o", "[OA] eclogue, short pastoral poem. ➞ <I>bukolik</I>.", "0"],
["ekologio", "ekologi-o", "(bot) ecology, rein to environment. <B>ekolog-o</B>, ecologist.", "0"],
["ekonomiko", "ekonomik-o", "(pol) (<I>ekonomia scienco, sistemo</I>), economics. <B>~isto</B>, economist.", "0"],
["ekonomio", "ekonomi-o", "[OA] economy. <B>1</B> (<I>mastrumo</I>), administration of concerns and resources), management. <I>~o agrikultura</I>, husbandry. <I>~o hejma</I>, housekeeping. <B>2</B> (<I>ŝparemo</I>), frugality, saving, thrift. <I>~o de forto, laboro, tempo</I>. <B>~a</B>, economic(al). <I>~a pri vortoj. ~a konkurado (krizo), Vivi</I> <B>~e</B>, live frugally.", "0"],
["ekonomo", "ekonom-o", "bursar, manager, steward, treasurer (of estate or institution).", "0"],
["ekrano", "ekran-o", "Screen. <B>1</B> (<I>ŝirmilo</I>), guard, shelter (against, from) draught, heat, light, observation, etc. <I>Fajr~o, vent~o. ~ofaldebla,</I> folding screen. <I>~o tualeta</I>, splash-guard. <B>2</B> (for projections): <I>~o kina, lumbilda</I>. <B>3</B> (opt) ➞ <I>filtril</I>.", "0"],
["eks", "eks-", "[UV] (<I>iama, ne plu</I>), pfx den ex-, former, late, once (but not now), quondam. <B>~a</B> (<I>iama</I>). <B>~u!</B> Down with! <B>~igi</B> (<I>-n</I>), discharge, dismiss, get rid of, turn out. <B>~iĝi</B>, leave office, resign, retire (<I>vole aŭ nevole</I>). <B>~edz(in)iĝo</B> (<I>divorco</I>), divorce. <I>~amiko, ~Esperantisto, ~oficisto, ~samideano</I>. <B>Ne~igebla</B>, irremovable. ➞ <I>abdik, antaŭ, divorc, emerit, iam, pasint</I>.", "0"],
["ekscelenco", "ekscelenc-o", "(<I>ministra moŝto</I>) [OA], Excellency (title). ➞ <I>moŝt</I>.", "0"],
["ekscentra", "ekscentr-a", "(<I>strangakaraktera</I>), Eccentric, cranky, irregular, odd, whimsical, unbalanced. <B>~ulo</B>, eccentric (person), crank. ➞ <I>ekstravaganc, fantazi, strang</I>.", "0"],
["ekscentriko", "ekscentrik-o", "(<I>ekstercentra</I>), (mec) Eccentric, displaced with reference to centre. <I>~a disko, pulio, ringo, stango</I>. <B>~o</B>, eccentric.", "0"],
["eksceso", "eksces-o", "[OA] (<I>troo</I>), Excess, intemperance, overstepping of limit, want of restraint. <B>~a</B>, -ive, exaggerated, exorbitant, immoderate, inordinate, too much. <B>~i</B>, exceed, go beyond one’s rights, kick over the traces, etc. ➞ <I>ekstrem, supermezur</I>.", "0"],
["eksciti", "ekscit-i", "(<I>-n</I>), [UV] Excit/e. <B>1</B> (<I>naski</I>) awaken, call forth, inspire, prompt, rouse, stir up. <I>~i apetiton, envion, ribelon, scivolon, soifon, spiriton</I> (Ez 1/1). <B>2</B> (<I>intensigi</I>): fan, inflame, intensify, quicken. <I>Fervoron, koleron</I>. <B>3</B> (<I>stimuli</I>): egg (spur, urge) on, stimulate, <I>~i (koron, nervojn</I>); poke, stir (<I>fajron</I>). <B>4</B> (<I>emocii, kormovi</I>): agitate, affect, animate, move, thrill (Jg 13/25). <B>5</B> (<I>funkciigi</I>): bring into action, set in motion. <I>~i dinamon, sifonon</I>. <B>~a</B>, exciting, thrilling. <B>~(ec)o</B>, <B>~(iĝ)o</B> (Pr 5/17), -ation, excitement, ardour, heat, passion. <I>La ~o de la ĉaso</I>. <B>~iĝi</B>, \"carry on\", get excited (worked up), make a fuss. <B>~iĝema</B>, -able. <B>~ilo</B> (<I>stimulilo</I> etc.), <B>Blov~i</B> (blow, fan) <I>la fajron</I>. <B>Tro~i</B>, over-e. (el) <B>~maŝino</B>, -er. ➞ <I>agit, akcel, ardig, instig, plivigl, plivivig</I>.", "0"],
["ekskludi", "eksklud-i", "(<I>-n</I>) (<I>elbari, forfermi, eksterlasi</I>), exclude, (de)bar, except, shut out. <I>~i de loko, privilegio, societo</I>. <B>~a</B>, exclusive. <I>Teorioj reciproke ~aj</I>. <B>~e de</B>, not counting, not including, let alone. <B>~o</B>, exclusion. ➞ <I>escept, fermit, malakcept, malenloĝ, malpermes, unik</I>. opposite <I>inklud</I>.", "0"],
["ekskluziva", "ekskluziv-a", "[OA] (<I>ekskludema</I>), Exclusive, excluding all others, select. <I>~a privilegio, rajto, societo</I>. <B>~e</B>, -ly, solely. <I>Per tio sin okupas ~e viroj</I>. <B>~i</B> (<I>= ekskludi</I>). Opp <I>inkluziv</I>.", "0"],
["ekskomuniki", "ekskomunik-i", "(<I>-n</I>) [OA], <B>1</B> excommunicate, cut off from sacraments or church membership, <B>f</B> put a ban on, proscribe (Ez 10/8). <B>~o</B>, excommunication. <B>~ito</B>, -ed person. ➞ <I>anatem, eksklud, ekzil, elfet, elpel, pari, proskrib</I>.", "0"],
["ekskremento", "ekskrement-o", "[OA] (<I>ekskretaĵo, fekaĵo</I>), excrement, dung, ordure, waste matter, <B>f</B> scum. <B>~i</B> (<I>eligi ~on</I>). ➞ <I>sterk</I>.", "0"],
["ekskreti", "ekskret-i", "(bio) excrete, expel from system, ~<B>ado</B>, excretion. <B>~aĵoj</B>, excreta, excrement.", "0"],
["ekskurso", "ekskurs-o", "[UV] excursion, jaunt, pleasure or exploratory outing, ramble, trip, <B>f</B> (lit) digression. <I>~o akva, kampa, monta</I>, <B>Pied~o</B>, hike. <B>~a</B> <I>bileto, vagonaro</I>. <B>~i</B>, (<I>fari ~on</I>), <B>~ano</B>, <B>~anto</B>, excursionist, tripper. ➞ <I>piknik</I>.", "0"],
["ekskuzi", "ekskuz-i", "(<I>-n</I>), excuse (for, from), clear from blame or obligation, condone, exculpate, overlook, <I>~u min!</I> Pardon me! <B>~o</B>, excuse, mild apology. <I>Fari ~on (sin ~i</I>), apologize, make excuses, excuse one’s from. <I>Akcepti ~on</I>. <B>Ne~ebla</B>, inexcusable. ➞ <I>pardon, senkulpig</I>.", "0"],
["ekslibriso", "ekslibris-o", "(lit) ex-libris, bookplate.", "0"],
["ekspansio", "ekspansi-o", "(ph) (pol), expansion, enlargement, extension, spread. <I>~o ekonomia, kolonia, luma, politika, volumena</I>. <B>Tri~a</B> (<I>kun triobla ~o</I>). triple expansion. <B>~a</B>, effusive, exuberant, <B>~i</B>, increase in one or more dimensions. <I>La ~anta universo</I>. ➞ <I>dilat, kresk, (pli)vastiĝ</I>.", "0"],
["ekspedi", "eksped-i", "(<I>-n</I>) [UV] (<I>sendi al difinita adreso</I>), Despatch, dispatch, consign, forward, send off. ~i <I>armeon, kurieron, leteron, pakaĵon</I>. <B>f</B> <I>~i iun en la ĉielon</I>. <B>~(ad)o</B>, d., clearance, <B>~ejo</B>, forwarding office. <B>~isto</B>, carrier, forwarding agent, shipper. ➞ <I>forsend, post, transport</I>.", "0"],
["ekspedicio", "ekspedici-o", "expedition, journey (voyage) for definite purpose; (mil) campaign. <I>~o (esplorvojaĝo) al la poluso; de Nansen</I>.", "0"],
["ekspekti", "ekspekt-i", "(<I>-n, ke -os, -i), (opinii, ke io okazos</I>), expect, count on, look forward to as due or likely to happen. <I>~i pagon, pluvon, sukceson. Mi ne ~os vin (= mi apenaŭ supozas, ke vi venos). Ne ~u miraklojn ( = ne kredu, ke ili okazos</I>). <B>~o</B>, expectancy, expectation. <B>~a</B>, expectant (<I>mieno</I>). <B>Ne~ita</B>, un expected. <I>Atendi</I> <B>sen~e</B>. ➞ <I>atend; anticip, antaŭvid, kredi,supozi, ke -os</I>.", "0"],
["eksperimento", "eksperiment-o", "[OA] experiment, essay, test. <I>Fari ~on</I>. <B>~a</B>, experimental. <I>~a scienco</I>. <B>~e</B>, as an e. <I>Faru tion ~e.</I>, <B>~ejo</B>, field of e. <B>~ita</B>, tried. ➞ <I>prov</I>.", "0"],
["ekspertizi", "ekspertiz-i", "= <I>esplori (taksi) fakule</I>, expertly (officialy) Apprais/e, examine, report, survey, value. <I>La patrino faris ~on pri mia tualeto</I>. <B>~o</B>, appraisal report, valuation. <B>~isto</B>, offi surveyor. (➞ <I>aprezi</I>).", "0"],
["eksperto", "ekspert-o", "expert, person with a special skill or knowledge, competent authty on (judge of), specialist, <B>~a</B>, expert, skilled, trained by experience or practice. ➞ <I>fakul. kompetentul, spertul, specialist</I>.", "0"],
["eksplicita", "eksplicit-a", "explicit, definite, express, leaving nothing merely implied, plain, stated in detail, (person) outspoken. Opp <I>implicit</I>.", "0"],
["ekspliki", "eksplik-i", "account for, explain (<I>agon</I>); give details of, unfold (<I>ideon, planon</I>), elucidate, explain (<I>doktrinon, temon). Ne ĉiam ~o estas klarigo</I>.", "0"],
["eksplodi", "eksplod-i", "(<I>nt</I>),, [UV] Explo/de, blow up, burst, go off, break out (<I>milito). La bombo, gaso, pulvo ~is</I>. <B>f</B> <I>~i de furiozo, kolero</I>. <B>~o</B>, explosion. <I>~o antaŭtempa,</I> backfire, <B>f</B> out-break, out-burst. <I>~o de batalo, kolero, milito, ribelo, rido</I>. <B>~a</B>, explosive, detonating. <B>~aĵo</B>, explosive substance. e.g., <I>dinamito. Frakasa (supera) ~aĵo</I>, H.E. <I>~aĵo malrapida</I>, propellant -sive. <B>~ema</B>, -sive, liable to e. <I>~ema kiel pulvo</I>. <B>f</B> (<I>flamiĝema</I>), irritable, passionate, <B>~igi</B> (<I>-n</I>), (cause to) e., detonate, fire. <I>~igi pulvon</I>. <B>f</B> bring into disrepute, expose, wreck. <I>~igi teorion. Rok~igo</I>, rock blasting. <B>~igilo</B>, detonator, fuse, priming (➞ <I>fuzil, prajm</I>). <B>~ilo</B>, mine, petard, (➞ <I>min</I>). <B>~iva</B> (<B>~ipova</B>), explosible. <B>~ujo</B>, <B>~kamero</B>, explosion chamber. <B>~bruo</B>, bang, <B>~puŝo</B>, -sion, stroke, (ry) <B>~signalo</B>, detonator. ➞ <I>ekflam, krev</I>.", "0"],
["ekspluati", "ekspluat-i", "(<I>-n</I>) [OA], exploit (wide sense). <B>1</B> Cultivate, manage, run, work. <I>~i bienon, fervojon, minejon</I>. <B>2</B> draw profit from, make use (the most) of, take advantage of, turn to account, utilize for one’s own ends. <I>~i cirkonstancon, homon, landon, talenton</I>. <B>3</B> (a. <I>~aĉi, fi~i</I>), take unfair advantage of, trade upon, sweat. <B>~isto</B>, sweater. <B>El~i</B>, <B>tro~i</B> (<I>trouzi</I>), exhaust, wear out. <I>~~i paciencon, teron</I>. ➞ <I>profit, utilig</I>.", "0"],
["eksponento", "eksponent-o", "(mat) exponent, index. <B>~a</B>, -ial.", "0"],
["eksponi", "ekspon-i", "(com., education), demonstrate. <B>1</B> describe, expound (as lecturer to students). <B>2</B> show for demonstration or sale, as commercial traveller. <B>~a</B> <I>budo, stando</I>. <B>~aĵoj</B>, objs for sale, etc. <B>~isto</B>, demonstrator.", "0"],
["eksporti", "eksport-i", "(<I>-n</I>) [OA], Export. <I>~i karbon</I>. <B>~a</B> bilanco, komerco. <B>~(ad)o</B>, -ation. <B>~aĵoj</B>, exports. <B>~isto</B>, -er.", "0"],
["ekspozi", "ekspoz-i", "(a. <I>espozi</I>), expose (to). <B>1</B> (phot) e. to light. <I>Sur~i, super~i, tro~i</I>. <I>Trisekunda ~o, ~o daŭra, momenta. Kalkulo de ~a tempo</I>. <I>~tabelo</I>. 2 (<I>elmeti, malkovri, nudigi</I>), expose to (leave unprotected from or open to) action of air (cold, danger, weather, etc.). <B>~o</B>, exposure. ➞ <I>ekspon, ekspozici</I>.", "0"],
["ekspozicio", "ekspozici-o", "[UV] (<I>montraĵo</I>), Exhibition, public display, show. <B>~i</B>, exhibit for view or visit. <B>~ejo</B>, e-hall, -ground. ➞ <I>ekspon</I>.", "0"],
["ekspresa", "ekspres-a", "[OA] Express. <B>1</B> very rapid. <B>2</B> for special purpose. <I>~a kuriero, letero, telegramo, vagonaro</I>. <B>~o</B>, e., special delivery (messenger, train). <B>~i</B> (<I>-n) (sendi per e.</I>), send by express. ➞ <I>rapideg</I>.", "0"],
["ekspresionismo", "ekspresionism-o", "expressionism.", "0"],
["ekstazo", "ekstaz-o", "[OA] ecstacy, delight, rapture, transport. <I>Ama, admira ~o</I>. <B>~a</B>, ecstatic, enraptured, in raptures. <I>~a feliĉo, mieno</I>. <B>~i</B>, be entranced, filled with rapture. ➞ <I>entuziasm, raveg</I>.", "0"],
["ekstemporalo", "ekstemporal-o", "school impromptu translation. ➞ <I>improviz, senprepar</I>.", "0"],
["ekstensoro", "ekstensor-o", "(anat) extensor (muscle).", "0"],
["ekster", "", "[UV] (prep) Outside (a limit, boundary), out of (in this sense). <B>Rim</B>.: ➞ el = out of (origin). <B>1</B> (Place): <I>~la domo,</I> o. the house. <I>~ danĝero</I>, out of danger. <I>~ la ĉambro, kaĝo, urbo</I>. <B>f</B> <I>~ ĉia dubo,</I> beyond all (any) doubt. <I>Fiŝo ~ akvo</I>, a fish out of water, (<I>almovo): Meti ~ dubon, flugi ~ la kaĝon, iri ~ la rondon</I>. <B>2</B> (<I>time): Studi ~ la leciona periodo. Labori ~ oficialaj horoj</I>. 3 (<I>= krom): Diru nenion ~ tio</I> (beside, more than, that). <B>~o</B>, outside, exterior. <B>~a</B>, o., external, outer. <I>~a flanko, mondo, pieco</I>. <B>~e</B>, o., externally, outwardly. <I>Stari (esti bela) ~e. ~e de</I>, on the o. of. <I>Iri ~en</I>, go o. <I>Elirigi ~en</I> (Ge 15/5). <B>~aĵo</B>, exterior, outer pt, appearance. <I>Impona, ~aĵo</I>. <B>~igi</B> <I>la internon,</I> turn inside out. <B>~ulo</B>, -er, (hospital) out-patient, (school) day pupil. ➞ <I>el, preter</I>. opposite <I>dum, en, interne de</I>.", "0"],
["ekstermi", "eksterm-i", "(<I>-n</I>) [OA], Exterminat/e, annihilate, destroy utterly, extirpate, root (wipe) out. <B>~i</B> <I>memoron, opinion, popolon, urbon</I> (Re 21/21). <B>~a</B> <I>milito</I>, war of extermination. <B>~(ad)o</B>, extermination (Est 7/4). <B>~iĝi</B>, be -ed. (Ge 7/23). ➞ <I>buĉ, detru, elradik, forviŝ, neniig, pereig</I>.", "0"],
["ekstra", "ekstr-a", "[OA] (<I>pli ol kutima, plua</I>), Extra, additnl, more than normal, supplementary. <I>~a eldono</I>, e. (special) edition. <I>~a laboro, vagonaro</I>, special train, etc. <B>~e</B>, extra, in addition, into the bargain. <I>~e bona,</I> e-fine, superfine. <B>~aĵo</B>, (something) extra, addition. <B>~aĵoj</B> <I>pagendaj</I>. ➞ <I>akcesor, aldon, apart, eksterordinar, flank, krom</I>.", "0"],
["ekstraditi", "ekstradit-i", "(<I>-n</I>), (jur) extradite, give up to authties. <B>~o</B>, extradition.", "0"],
["ekstrakti", "ekstrakt-i", "[OA] (chem) (cul), Extract, obtain essence (juice, etc.) (by boiling, pressure, suction, etc.). <I>~i gudron el karbo</I>. <B>~o</B>, e. <I>~o de malto, viando. ~o fluida, seka</I>. ➞ <I>distil, elĉerp, eltir, esenc, infuz, macer, tinktur</I>.", "0"],
["ekstrapoli", "ekstrapol-i", "(mat) extrapolate. <B>~ado</B>, extrapolation.", "0"],
["ekstravaganco", "ekstravaganc-o", "extravaganza, absurdity, eccentricity, prank, something fantastic (act, composition, speech). <B>~a</B>, extravagant, exceeding bounds of reason, eccentric, frolicsm, wild. ➞ <I>eksces, frenez, eksterlim, petol, troig</I>.", "0"],
["ekstraverta", "ekstravert-a", "(psy) extrovert. <B>~o</B>, extrovesion. <B>~ulo</B>. Opp <I>introvert</I>.", "0"],
["ekstrema", "ekstrem-a", "[UV] Extrem/e, <B>1</B> farthest from centre, outermost. <I>~a distanco, oriento</I>. <B>2</B> (highest grade): ultra-, utmost. <I>~a bezono, danĝero, embaraso, maljuneco, plezuro. ~a mizero</I>, dire misery, <B>f</B> going to great length, immoderate, severe, stringent. <I>~a opinio, rimedo, situacio</I>. <B>~e</B> (<I>plej, treege</I>), extremly, to the last degree. <B>~o</B>, e., -ity, very end. <I>Peli, puŝi ĝis la ~o. En ~o (en ~a okazo</I>), at the worst, in extremis, <B>~aĵo</B>, -ity, end, e., point, tip. <B>~ismo</B>, <B>~isto</B>. <B>Ĝis~e</B>, <B>plej~a</B>, outermost, uttermost. ➞ <I>altgrad, finfin, lim, plej malproksim</I>.", "0"],
["ekstrorsa", "ekstrors-a", "(<I>eksterena</I>), (bot) extrorse, turned outwards. Opp <I>intrors</I>.", "0"],
["eksudi", "eksud-i", "(<I>-n) (elŝviti</I>), exude, give off like sweat. <B>~(aĵ)o</B>, exudation.", "0"],
["ektomio", "-ektomi-o", "(<I>fortranĉo</I>), (med sfx). <I>apendic~o, splen~o, tonsil~o</I>.", "0"],
["ektopio", "ektopi-o", "(<I>mislokiĝo</I>) (med) ectopy, displacement.", "0"],
["ektoplasmo", "ektoplasm-o", "ectoplasm. <B>~iĝo</B>, materialization.", "0"],
["ektropio", "ektropi-o", "(<I>eksteriĝo</I>), (med) ectropy, eversion, e.g., of eyelid.", "0"],
["ekumena", "ekumen-a", "(<I>tutkristanara</I>), (o)ecumenical, representing the whole Christian world. <I>~a movado</I>.", "0"],
["ekvacio", "ekvaci-o", "[OA] (chem) (mat) equation, formula. <I>Algebra ~o</I>. <B>~igi</B> <I>problemon</I>. ➞ <I>egalaĵ, egalig</I>.", "0"],
["Ekvadoro", "Ekvador-o", "[OA-8] EC.", "0"],
["ekvatorialo", "ekvatorial-o", "equatorial telescope.", "0"],
["ekvatoro", "ekvator-o", "[OA] equator. <I>~o ĉiela, magneta, tera</I>. <B>~a</B> <I>ebeno</I>, equatorial plane. <I>E~a Gvineo</I> [OA-8] <I>GQ, ~a senvento,</I> doldrum.", "0"],
["ekvilibro", "ekvilibr-o", "[OA] Equilibrium, (state of equal) Balance, (equipoise, between opposing forces), (mar) trim. <I>~o firma, stabila. ~o anima, buĝeta. ~o politika</I>, b. of power. <I>Konservi, perdi, teni la ~on</I>. <B>~a</B>, b-ed, compensated. <B>~i</B> (<I>esti en ~o, egalpezi</I>), be in e., b. <B>f ~eca</B>, level-headed. <B>~igi</B> (<I>meti en ~on). ~igi buĝeton</I>. ➞ <I>egalig, kompens, kontraŭpez</I>. <B>~ismo</B>, <B>~isto</B>, rope-dancer, etc. <B>Mal~igi</B>, upset the b. of (➞ <I>ŝancel</I>). <B>Sen~a</B>, unbalanced. <B>f</B> cranky. ➞ <I>aplomb, egalfort, egalpez, stabil</I>.", "0"],
["ekvilo", "ekvil-o", "(<I>sablofiŝo</I>), sand-eel, launce (<I>Am- modytes</I>) (Fr <I>equille</I>).", "0"],
["ekvinokso", "ekvinoks-o", "equinox, time at which sun crosses equator. <I>~o aŭtuna, printempa</I>. <B>~a</B> <I>punkto</I>, equinoctial point. <I>~a tajdo, vento,</I> equinoctial tide, gale. <I>~a fruiĝo</I>. ➞ <I>egal, precesi</I>.", "0"],
["ekviseto", "ekviset-o", "(bot) horsetail (<I>Equisetum</I>).", "0"],
["ekvivalenta", "ekvivalent-a", "(<I>egalvalora</I>): Equivalen/t, corresponding, tantamount; (<I>samsignifa</I>): synonymous, with same meaning. <B>~o</B>, e. (amount, thing), substitute; (gram) e. expression, phrase, term. <B>~eco</B>, -ce. ➞ <I>ident, sinonim, surogat</I>.", "0"],
["ekzakta", "ekzakt-a", "[OA] (<I>severe preciza</I>), exact, precise, strictly accurate (correct). <I>~a difino, historio, kalkulo, senco. ~aj sciencoj</I>. <B>~emo</B>, exactitude. ➞ <I>ĝust, senerar, strikt</I>. opposite <I>proksimum</I>.", "0"],
["ekzalti", "ekzalt-i", "(<I>-n</I>), exalt. <B>1</B> elevate, excite, inflame. <B>2</B> glorify, magnify, praise. <B>~a</B>, electrifying, exciting, stirring. <B>~o</B>, exaltation, elation, rapturous emotion. <B>~iĝi</B> (<I>esti ekster si, ekstazi), ~iĝo</I>, transport. <B>~ita</B>, exalted, uplifted. ➞ <I>altig, flamig, pasiig, ekstaz. elektr</I>.", "0"],
["ekzameni", "ekzamen-i", "(<I>-n</I>), [UV] Examin/e. <B>1</B> (<I>iun) (elprovi scion, testi</I>), test by questions. <I>~i kandidaton. ~i torture</I>. <B>2</B> (<I>ion) (detale esplori, pririgardi</I>), enquire into, inspect, investigate, scrutinize, survey, vet., weigh (Ps 17/3) <I>~i konton, pacienton, pakaĵon, proponon</I>. <B>~a</B> <I>ĉambro, demandaro</I>. <B>~o</B>, examination, audita, minute inspection, test of knowledge or ability, trial. <I>~o de koro, sano, vido. Sukcesi ĉe ~o; plenumi (trapasi) ~on</I>. <B>~anto</B>, <B>~isto</B>, -er. <B>~ato</B>, -ee, candidate. <B>~iĝi</B>, be e-ed. <B>Kontraŭ~i</B>, cross-e, cross-question. ➞ <I>enket, esplor, inspekt, kandidat, kontrol, revizi</I>.", "0"],
["ekzantemo", "ekzantem-o", "(<I>surhaŭta ruĝa erupto</I>), exanthema, rash, e.g., <I>morbilo, skarlatino. Tifa ~o</I>. ➞ <I>ekzem, eritem, erupt</I>.", "0"],
["ekzegezo", "ekzegez-o", "(<I>klarigo</I>), exegesis, exposition, interpretation. <B>~a</B>, exegetical. <B>~isto</B>, commentator.", "0"],
["ekzekucio", "ekzekuci-o", "(jur) execution = distraint, seizure in default of payment.", "0"],
["ekzekuti", "ekzekut-i", "[UV] (<I>punmortigi) (-n</I>), execut/e, inflict Capital Punishment. <I>Elektre ~i. Pekinto ~ata</I> (1 FA 6/26). <B>~o</B>, execution, c-p. ~a <I>ŝtipo</I> (➞ <I>eŝafod</I>). <B>~isto</B>, executioner. hangman, etc. ➞ <I>elektrokut, line, mortpun; plenum, validig</I>.", "0"],
["ekzekutivo", "ekzekutiv-o", "(<I>plenuma komitato</I>), executive (committee).", "0"],
["ekzemo", "ekzem-o", "[OA] (<I>juka haŭtinflamo</I>), eczema. ➞ <I>ekzantem, erupt</I>.", "0"],
["ekzemplero", "ekzempler-o", "[UV] Copy, sample, specimen (<I>de gazeto, laboro, libro</I>). <B>Prov~o</B>, specimen (trial) c. <B>Recenz~o</B>, review copy.", "0"],
["ekzemplo", "ekzempl-o", "[UV] Exampl/e. <B>1</B> (<I>iu, io, imitinda</I>): conduct, object., person as pattern, model for imitation. <I>~o de virto. ~o bona, instrua. Citi, doni, preni, sekvi ~on, kiel ~on, por ~o</I>. <B>2</B> Caution, warning. <I>Esti ~o kontraŭ. ~o averta</I>.<I> <B>3</B> illustrate, parallel case, typical instance. <B>~a</B>, illustrative, model, typical</I>. <I>~a frazo, konduto. <B>~e</B>, by way of e., for e. (instance), such as, viz. <B>~igi</B>, -ify, <B>~odona</B>, -ary. <B>Sen~a</B></I> (<I>neniam ĝis nun okazinta</I>), <I>un-ed, unheard of, unparalleled, unprecedented. ➞ ilustr, imit, model, paradigm, tip</I>.", "0"],
["ekzerci", "ekzerc-i", "(<I>-n, per, pri</I>) [UV] (<I>lertiĝi per praktiko</I>), Exercis/e, Practise, exert(tax) powers, train. <I>~i langon, muskolon, memoron, orelon, povon</I>. <B>Sin ~i</B>, <B>~iĝi</B>, take e., p. <B>Rim</B>.: Applies to the <I>aganto</I>, not to the <I>temo de agado. ~i sin (la fingrojn</I>), not: <I>~i la lingvon, pianon</I>. <B>~(ad)o</B>, e., p. <I>~o gimnastika. Fari ~ojn</I>, <B>~aro</B>, <B>~olibro</B>, e-book. <I>\"La Ekzercaro\" (de Z.</I>). <B>~ejo</B>, (<B>~a</B> <I>korto</I>), drill (parade) ground. <B>~igo</B>, p. <B>~ilo</B>, -er (apparatus). <B>~ita</B>, practised, trained, <I>~ita aktorino</I>. <B>~itoj</B> (Ge 14/14). <B>~iteco</B>, facility through p. <I>La fingroj perdis ~itecon</I>. <B>Antaŭ~o</B>, preliminary p., rehearsal. <B>Spir~o</B>, <B>voĉ~o</B>, breathing-exercise, voice-e. ➞ <I>dres, etud, manovr, praktik, trejn, rutin, uz</I>.", "0"],
["ekzergo", "ekzerg-o", "(num) exergue.", "0"],
["ekzili", "ekzil-i", "(<I>-n; al, de</I>), [UV] Exil/e, banish, proscribe, <B>f</B> Dismiss, relegate. <B>Sin~i</B>, exile. (withdraw) one’s. <B>~o</B>, excile, banishment. <B>~ejo</B>, place of e. <B>~iĝi</B>, be -ed. <B>~ito</B>, e. ➞ <I>ekskomunik, elpel, forpel, proskrib</I>.", "0"],
["ekzistadismo", "ekzistad/ismo", "<B>~isto</B>, (phi) existential/ism, -ist.", "0"],
["ekzisti", "ekzist-i", "(nt), [UV] Exist, be in -ence, be found, have being, last, live, occur, subsist. <I>Li ne vivas, nur~as. La Sensaĝulo diris: \"Dio ne ~as\"</I> (Ps 14/1). <I>Ne plu ~as,</I> has died out, is extinct. <B>~o</B>, existence, being. <B>~aĵo</B> (Ge 7/4), <B>1</B> (<I>ento, estaĵo</I>), entity, something -ing. <B>2</B> (<I>vivantaĵo</I>), being. ~anta (<I>nuna, reala</I>), actual, current, extant, in being (force). <B>Kun~i</B>, co-exist. ➞ <I>daŭr, ent, est, veget, viv</I>.", "0"],
["ekzoceto", "ekzocet-o", "(<I>flugfiŝo) (Exocoetus</I>) &lt; flying- fish.", "0"],
["ekzorci", "ekzorc-i", "(<I>iun, lokon) (elpeli demonojn el</I>), Exorc/ise, cast out, expel (evil spirit) from person or place. <B>~o</B>, ~ismo, exorcism. <B>~isto</B>, -ist.", "0"],
["ekzotika", "ekzotik-a", "exotic, foreign, introduced from abroad. <I>~a modo, planto, vorto</I>.", "0"],
["el", "", "[UV] (prep) out of, from, of (in this sense). <B>1</B> (motion, change of position): <I>Fali, guti, iri, kuri, peli, salti, veni, malaperi ~ la mondo, ~ antaŭ</I> (Le 9/24); <I>~ inter</I> (Ge 12/1, 42/24); <I>~ interne</I>, from inside; <I>~ meze de</I> (Re 4/12); <I>~ sub</I> (El 6/7); <I>~ sur,</I> from off, <B>2</B> (origin): <I>Belaj rakontoj ~ trans la montoj. Rakonto ~ Genezo. Traduko ~ Esp-o. Smith ~ Bristolo. Legi ~ libro. Rigardi ~ la fenestro</I>. <B>3</B> (change of state): <I>Ĉerpi ~ puto. Eksiĝi ~ servo. Levi ~ mizero. Veki ~ dormo</I>. <B>4</B> (Cause, source): <I>Agi ~ kaprico. Ami ~ tuta koro. Desegni ~ memoro. Fari virton ~ neceso. Sekvas (mi konkludas) ~ tio, ke</I>. ➞ <I>laŭ, per, pro</I>. <B>5</B> (made, consisting, of): <I>Kesto ~ kanoj. Kolono ~ salo. Ringo ~ oro. Tablo ~ ligno. Ĉizita ~ ŝtono. Forĝita ~ fero. Taĉmento da soldatoj ~ 200 viroj. Labori ~ oro</I>, work in gold (El 35/32). <B>6</B> (Comparison, selection): <I>Unu (kelkaj, multaj, la plej bela, la plimulto) ~ ili. Iom ~ ĝi</I>, any of it (El 12/10). <I>Kiom ~ vi?</I> How many of you? Iri ~en (<I>eliri</I>), go out, leave, etc. <B>~igi</B>, emit, give forth, etc. <B>~iĝi</B>, emerge, issue, come out. <I>PFX</I>. <B>1</B> ~ĵeti, cast out. ~tiri, extract. ~iro, exit, exodus. <I>~lasi, ~migri, ~peli, ~piki, ~preni, ~spiri, ~veni</I>. <B>f</B> ~stari, stand out. <B>2</B> (<I>montro</I>): ~meti, ~montri. display, exhibit. <B>3</B> (<I>kreo, realigo</I>): ~kovi, hatch out. <I>~labori, ~pensi, ~tranĉi</I>. <B>4</B> (<I>akiro, atingo</I>): ~almozi, extort by begging. ~devigi, ~logi, ~peti. <B>5</B> (<I>= ĝisfine, plene, tute, fin-, tra-</I>): completely, thoroughly, out, up. ~ĉerpi, exhaust. ~lacigi, ~lerni, ~trinki. ~pagi, pay off (up), settle. ~uzi, use up, wear out. <B>6</B> (idiomatic) ~teni, endure.", "0"],
["elano", "elan-o", "elan; bound, dash, impetus, rush. ➞ <I>impet</I>.", "0"],
["elasta", "elast-a", "[UV] elastic, springy. <I>~a fibro, histo, teksaĵo, ringo, ŝelko</I>. <B>f</B> buoyant, flexible; accomodating, obliging, yielding, compliant. <I>~a konscienco, limo, paŝo, signifo. ~a talio</I>, supple waist. <B>~(aĵ)o</B>, elastic (substance). <B>~aĵoj</B>, stretch (<I>ŝuo</I>). <B>~eco</B>, elasticity, spring, tension. ➞ <I>adaptem, cedem, fleksebl, kaŭĉuk, malrigid</I>.", "0"],
["elateno", "elaten-o", "(bot) water-wort (<I>Elatine</I>).", "0"],
["elatero", "elater-o", "click beetle, skip-jack (<I>Elater</I>). ~a larvo, wireworm.", "0"],
["eldorado", "eldorad-o", "(<I>fabela lando</I>, or <I>urbo orriĉa</I>), El Dorado.", "0"],
["eleagno", "eleagn-o", "oleaster, wild olive-tree (<I>Elaeagnus</I>). <B>~o arĝenta</B>, silver-berry.", "0"],
["elefantiazo", "", "(med) elephantiasis.", "0"],
["elefanto", "elefant-o", "[UV] Elephant. <I>~o Afrika, Hinda</I>. <B>~(ec)a</B>, -ine. <B>~osto</B> (<I>eburo</I>) ivory. <B>Vir~o</B>, bull-e. <B>~bleki</B>, trumpet.", "0"],
["eleganta", "elegant-a", "[OA] elegant, graceful, handsome, of refined luxury, stylish, tastefully ornate. <I>~a fasono</I>, smart cut. <I>~a homo, movo, stilo, vesto</I>. <B>~(ec)o</B>, elegance. <B>~igi</B>, dandify. <B>~ulo</B>, dandy, exquisite, man of fashion, swell. <B>~ulaĉo</B>, dude, fop. <B>Mal~a</B>, <B>Ne~a</B>, inelegant, clumsy, coarse, dowdy, plain, rough, tasteless, uncouth (➞ <I>krud</I>). <B>Mal~ulino</B>, frump. ➞ <I>belstil, dand, delikat, mod, plaĉ, ŝik</I>.", "0"],
["elegio", "elegi-o", "[OA] (lit) elegy, song of lamentation (especially for the dead), <B>~a</B>, elegaic, <I>~a parolo, poemo</I>. ➞ <I>malgaj, melankoli</I>.", "0"],
["elekti", "elekt-i", "(<I>-n, el, inter; abs</I>), [UV] Choose, Elect. <B>1</B> fix on, opt, pick (single) out, select. <I>~i libron, seĝon</I>. <B>2</B> choose by vote. <I>membron, prezidenton</I>. <B>~(aĵ)o</B>, choice, option, preferance, selection, vote. <I>Fari ~on. Ĝenerala ~o</I>. <B>~a</B>, elective, electoral. <B>~ado</B>, e-tion <B>~anto</B>, e-or, voter, <B>~antaro</B>, electorate. <B>~ebla</B>, eligible. <B>~ema</B>, dainty, fussy, fastidious, particular. <B>~ita</B>, choice, chosen, select. <I>~itaj militestroj</I> (El 15/4), <I>~ito</I>, the one chosen. <I>Multaj vokitoj, malmultaj ~itoĵ</I>. <B>~orajto</B>, franchise, suffrage. <B>Al~i</B> (<I>koopti</I>), coopt. <B>El~i</B> (<I>selekti</I>), select. <B>Ne~ebla</B>, ineligible. <B>Por~a</B>, on approval. <B>Sen~e</B>, at random, haphazard, without a vote. ➞ <I>alternativ, dilem, kribr, selekt; balot, voĉdon</I>.", "0"],
["elektoniko", "elektonik-o", "electronics.", "0"],
["elektro", "elektr-o", "[OA] electricity. <I>~o atmosfera, negativa, pozitiva. Doni, tranĉi la ~on</I>. <B>~a</B>, electric. <I>~a fluo, forno, lampo, lumo, motoro, sonorilo, ŝarĝo, ŝoko. ~a fiŝo</I>, ➞ <I>elektrofor, torped</I>. <B>~a</B> <I>inĝeniero</I>, electrical engineer. <B>~e</B> <I>metaligi (arĝentizi</I>), electroplate, <I>~e ekzekuti (elektrokuti</I>), electrocute. <B>~(iz)i</B>, <B>~igi</B>, electrify, equip with e. power, give an e. shock to. <B>~izi</B> <I>fervojon</I>. <B>~izado</B>, -ization. <B>~isto</B>, -ician.", "0"],
["elektro", "elektro-", "(international ppfx) ~analizo, ~biologio, ~dinamiko, ~grafo, ~gravuro, ~kemio, ~kinetiko, ~kuto, ~lito, ~lizo. ~magneto, ~metalurgio, ~metro, ~motoro, ~patio, ~skopo, ~statiko, ~tekniko, ~terapio, ~tipo, ~tona.", "0"],
["elektrodo", "elektrod-o", "electrode. <I>~o pozitiva (anodo). ~o negativa (katodo</I>).", "0"],
["elektroforo", "elektrofor-o", "(ich) electric eel (<I>Electro- phorus</I>). ➞ <I>gimnot</I>.", "0"],
["elektrono", "elektron-o", "electron. ➞ <I>atom, neutron, proton</I>.", "0"],
["elektuario", "elektuari-o", "(pharm) electuary, medicine with honey or syrup.", "0"],
["elemento", "element-o", "[OA] Element. <B>1</B> (chem) simple body, substance defying analysis. <B>2</B> elementary principle, rudiment: <I>~oj de gramatiko, scienco. Parol~o</I>, pt of speech. <B>3</B> (<I>ero</I>), component pt, constituent, ingredient: <I>~o de feliĉo, medikamento, necerteco, situacio</I>. <B>4</B> (phi) original matter of substance, power of nature: <I>La kvar ~oj (aero, akvo, fajro, tero</I>). <B>f</B> <I>la ~oj (vetero) sovaĝis</I>. 5 (<I>medio</I>) ordinary range of activity, surroundings: <I>Akvo estas la ~o de fiŝoj. Esti en (ekster) sia ~o,</I> be quite at home (feel out of water). <B>~a</B>, -al, -ary, constituent, fundamental, rudimentary, simple. <I>~a aritmetiko, instruo, lernejo, scio, teorio, vero</I>. ➞ <I>aboc, faktor, komenc, princip, rudiment</I>.", "0"],
["elevatoro", "elevator-o", "(<I>ŝarĝlevilo</I>), elevator, hoist, machine for raising goods. ~o baskula, tip. ~o sitela, bucket e. ➞ <I>lift</I>.", "0"],
["elf(in)o", "", "[OA] elf, supernatural mischievous little creature, dwarf, etc. ➞ <I>gnomo (aera), nimfo (akva), salamandro (fajra); fe, kobold</I>.", "0"],
["eliksiro", "eliksir-o", "[OA] (pharm) elixir. <B>1</B> (alchemy) preparation to change metals to gold, or to prolong life indefinitely. <I>~o de junec-(viv-)o</I>. <B>2</B> (pharm) <I>alkoholato kun siropo</I>). <B>f</B> sovereign remedy. ➞ <I>tinktur</I>.", "0"],
["elimini", "elimin-i", "(<I>-n), (forigi, malaperigi</I>); Elimin/ ate, delete, discard, remove; drive, (throw strike) out, exclude, ignore, reject (hypothesis); (alg) e. quantities from equation; (chem) (ph), get clear (rid) of, expel (substance, waste matter). ~(ad)o, -ation. ~ilo, -ator. ➞ <I>ekskrement, elig, elfet, malakcept</I>.", "0"],
["elimo", "elim-o", "lyme-grass (<I>Elymus</I>).", "0"],
["elipso", "elips-o", "[OA] <B>1</B> (geom) Ellip/se, oval. <B>2</B> (rh) Ellip/sis, gap, omis sion of word(s) understood. <B>~a</B>, -tical. ➞ <I>elizi</I>, Opp <I>pleonasm</I>. II ~ojdo, -soid.", "0"],
["elito", "elit-o", "elite, best (of), choice (pt), select (class or group); cream, pick. <B>~a</B>, choice, crack, high-class, picked, select. <I>~a animo</I>. ➞ <I>elektit, kern, plejbon, superec</I>.", "0"],
["elitro", "elitr-o", "(<I>flugilingo</I>), elitron, horny fore- wing, wing-case (-cover) of beetle.", "0"],
["elizeo", "elize-o", "(myth) Elys/ium. <B>f</B> place of ideal happiness. <B>~a</B>, -ian, blissful. <I>La ~aj kampoj. ~a pac-(rav-)o</I>. ➞ <I>eden, paradiz</I>.", "0"],
["elizii", "elizi-i", "(<I>-n</I>) [OA], (gram) elide, omit syllable or vowel. <B>~o</B>, elision. ➞ <I>apostrof, elips</I>.", "0"],
["elo", "el-o", "ale.", "0"],
["elodeo", "elode-o", "(bot) water thyme, Canadian waterweed (<I>Elodea</I>).", "0"],
["elokucio", "elokuci-o", "elocution.", "0"],
["elokventa", "elokvent-a", "[UV] (<I>belparola, fluparola</I>), eloquent, apt, fluent (in use of language) (El 4/10). <I>~a parolo, rigardo, stilo. ~aj okuloj</I>. <B>~o</B>, eloquence. <I>Sciu ~i, sciu ankaŭ silenti</I>. ➞ <I>orator, retorik</I>.", "0"],
["em", "-em", "[UV] sfx denotes <B>1</B> (subjective tendency): Inclin/ation, bent, bias, disposition, fondness, leang, proclivity, proneness, propensity, taste, turn of mind, wont, etc. <B>Babil~a</B>, <B>parol~a</B>, <B>rakont~a</B>, garrulous, loquacious, talkative. <B>Ced~a</B>, <B>konsent~a</B>, accomodating, compliant. <B>Indulg~a</B>, <B>kompat~a</B>, <B>pardon~a</B>, merciful. <B>Tim~a</B> kaj <B>trem~a</B>, fearful and trembling (Jĝ 7/3). <B>Rim</B>.: <B>-o</B> is usually preferable to <B>-emeco</B> (pleon). <B>2</B> (objective tendency) = apt (liable, subject) to, in danger of, <B>Mort~a</B>, mortal, subject to death. ➞ <B>mortonta</B>, that will die; <B>mort(ec)a</B>, appertaing to death; <B>mort-iva (-pova)</B>, able to die. <B>Eksplod~a</B>, explosive; <B>erar~a</B>, fallible; <B>fal~a</B>, unsteady; <B>pas~a</B>, transient; <B>pere~a</B>, perishable. <B>~a</B> (<I>je, -i</I>); addicted (disposed, given, inclined, prone, wont) to. <I>~a labori</I>, of a mind to work. <B>~o</B>, -ation, bent, propensity, tendency, etc. <I>~o al</I>, leaning towards. <B>~i</B>, -e, be -ed to. <B>~igi</B> <I>dun al io</I>), i., dispose, induce. <B>Mal~a</B>, dis-ed, averse, indisposed, loth, reluctant, unwilling. <B>Rim.:</B> (transit v roots): Compare kaŝ<B>~a</B>, -ed to hide things, close, secretive, with <B>kaŝiĝ~a</B>, -ed to hide one’s. Sim: Compare <B>fleksiĝ~a</B>, lithe, pliant, supple; <B>rompiĝ~a</B>, breakable, brittle, fragile; <B>ŝanĝiĝ</B>~a changeable, fickle, inconstant; with <B>fleks~a</B>, <B>romp~a</B>, <B>ŝanĝ~a</B>, -ed to bend (break, change) something else. <B>Rim.:</B> (intransitive rts): Compare <B>brul~a</B>, -ed to burn (nt) with <B>brulig~a</B>, -ed to burn something else (tr). ➞ <I>ebl, ind, iv</I>.", "0"],
["emajlo", "emajl-o", "[UV] Enamel. <B>1</B> hard oil-paint drying glossy. <B>2</B> (anat) smooth hard coating, e.g., <I>denta ~o</I>. <B>Ĉel~o</B> (<I>klozoneo</I>). <B>~a</B>, of e., -led. <B>~i</B> (<I>-n</I>), (cover <B>with)</B> e, <B>eman-i</B> (<I>de, el</I>), Emanat/e, issue, originate (especially of gas, light), (ph, phi), proceed, rise (from person or source). <B>~(aĵ)o</B>, -ion, efflux. <I>Radiuma ~aĵo</I>. ➞ <I>elir, haladz, spir</I>.", "0"],
["emancipi", "emancip-i", "[OA] (<I>-n) (liberigi</I>), Emancipat/e, (set) free (from control, restraint); release (from power of). <I>~i menson, popolon, sklavon, virinojn</I>. <B>~ita</B>, freed. <B>~(ad)o</B>, -ion. <B>~isto</B>, -ionist.", "0"],
["embarasi", "embaras-i", "(<I>-n, per</I>), [UV] Embarrass, (en)cumber, entangle, hamper, hinder, hold up, impede, inconvenience, perplex, put in difficulty, trouble. <B>~ita</B> (<I>en ~o</I>), -ed, at a loss, constrained, disconcerted, encumbered, nonplused, perplexed, puzzled. <I>~ita per demando, pakaĵo, ŝuldo</I>. <B>~a</B>, embarrassing, awkward, cumbersome, puzzling, troublesome. <I>~a demando, situacio</I>. <B>~o</B>, embarrassment, complication, difficulty, dilemma, impediment, fix, perplexity, quandary. <I>Financa ~o. Fari (kaŭzi) ~on (al), meti en ~on</I> (in a hole), <I>Tiri el ~o</I>, help out of a difficulty. <I>~o de riĉeco</I>. <B>~aĵo</B>, encumbrance, hindrance. <B>~iĝi</B>, be -ed. <B>Mal~i</B> (<I>en, de</I>), disembarrass, clear, free, lighten. <I>Mal~i ĉambron, la straton</I>. ➞ <I>dilem, ĝen, malfacilig, malhelp, obstrukc</I>.", "0"],
["embargo", "embarg-o", "Embargo, suspension of commerce, <B>~i</B>, lay an e. on (under e.), suspend. ➞ <I>arest, konfisk, sekvestr</I>.", "0"],
["emberizo", "emberiz-o", "(orn) Bunting (<I>Emberiza</I>). <B>Flava ~o</B>, yellowhammer. <B>Flavbrusta ~o</B>, yellow-breasted b. <B>Grena ~o</B> corn b. <B>Kana ~o</B>, reed b. <B>Malgranda ~o</B>, little b. <B>Neĝa ~o</B>, snow b. <B>Rustika ~o</B>, rustic b. ➞ <I>hortulan</I>.", "0"],
["emblemo", "emblem-o", "[OA] Emblem. <B>1</B> sign, symbol, typical representation of a quality, (her) device of a person or fam. <I>Pesilo, ~o de justeco</I>. (cgm) suit. <I>La kvar ~oj ĉe ludkartoj</I>. <B>~a</B>, -atic, serving as a type. <B>2</B> badge, crest. ➞ <I>figur, insign, simbol</I>.", "0"],
["embolio", "emboli-o", "embolism, obstruction of bloodvessel. <I>Cerba ~o</I>, clot on the brain. ➞ <I>tromboz</I>.", "0"],
["embrazuro", "embrazur-o", "embrasure. <B>1</B> bevelling off (splaying) of wall, or at sides of door (jamb, window); inward chamfer, window recess. <B>2</B> (mil) crenel, loop-hole, notch, (mar) gunport. ➞ <I>krenel, paftru</I>.", "0"],
["embrio", "embri-o", "[UV] (bot) (zoo), Embry/o, offspring before birth, <B>f</B> thing in rudimentary stage, bud, first draft, germ, initial project, rough sketch, <B>~a</B>, -onic, immature, undeveloped. <B>~eco</B> (Ps 71/6). <B>~igi</B> (No 11/12). <B>~ologio</B>, -ology. <B>~ologo</B>, -ologist. ➞ <I>ĵet, ĝerm, rudiment, skiz</I>.", "0"],
["embrokacio", "embrokaci-o", "(med) embrocation.", "0"],
["embusko", "embusk-o", "[UV] Ambush (PI 3/10). ~i (<I>-n, kontraŭ;</I> abs). <I>Fari ~on</I> (Jĝ 9/32), lay a snare, trap; lie in wait (for), stalk. <B>~e</B>, in ambush. <B>~ejo</B>, embuscade, lurking-place. <B>~ulo</B>, (Jĝ 16/9). <B>~igi</B>, place in a. <B>~iĝi</B>, take cover. ➞ <I>insid</I>.", "0"],
["emerĝi", "emerĝ-i", "(nt) (<I>eliri el medio</I>), opposite <I>enfal, incid</I>. (ph) Emerg/e, come into view from, come (crop) up (issue, loom, rise) out of. <B>f</B> come out (through investigation), issue, rise (from obscurity). <B>~o</B>, -ence. <B>~a</B> <I>angulo, ebeno, punkto</I>.", "0"],
["emerito", "emerit-o", "ex-official, etc. (➞ <I>veteran</I>). <B>~a</B>, honourably discharged, past active work, retired, superannuated. <I>~a profesoro. ~a pensio, salajro</I>. retiring allowance, superannuate. <I>Vivi</I> <B>~e</B>. <B>~igi</B>, pension off, retire, superannuate. <B>~iĝi</B>, be retired.", "0"],
["emetiko", "emetik-o", "(<I>vomigilo</I>), (pharm) emetic (especially <I>tartratoj kalia kaj antimona</I>). <B>~a</B> <I>vino</I>. ➞ <I>ipekakuan</I>.", "0"],
["emfazo", "emfaz-o", "[OA] Empha/sis (importance assigned), force, intensity, stress, vigour, weight (of style). <B>~a</B>, -tic, forcible, impressive. <I>~a ago, esprimo, gesto, tono</I>. <B>~i</B> (<I>-n, pri) (paroli -e) (~~ substreki</I>), be emphatic, emphasize, accentuate, lay stress on. <I>~ita (vorto</I>), stressed. ➞ <I>insist, reliefig</I>. ➞ <I>akcent</I>.", "0"],
["emfizemo", "emfizem-o", "(<I>ŝvelo prograsa</I>), (med) emphysema. <I>~o haŭt-(pulm-)a</I>.", "0"],
["emido", "emid-o", "soft-shelled turtle (<I>Emida</I>).", "0"],
["eminenco", "eminenc-o", "[OA] Eminence (title). <I>Via ~o</I>.", "0"],
["eminenta", "eminent-a", "[UV] Eminen/t, distinguished, exalted, highly placed, illustrious; noteworthy, outstandg, prominent, signal (in degree). <I>~a kapabl-(orator-profesor -rang-rol-serv-)o</I>. <B>~(ec)o</B>, -ce, distinction, high rank. <B>~igi</B> (Es 3/1), <B>~ulo</B>, e. person, big Pott, grandee, leading spirit, shing light, etc. (Ps 146/3). <B>~ularo (</B>elito, kremo). <B>Mal~ulo</B>, nobody. <B>Ne</B>~<B>a</B>, homely, ordinary, simple. ➞ altrang, disting-lrimark-) ind, elstar, fam, glor, most, super.", "0"],
["emiro", "emir-o", "emir (Islamic title). <B>Unuiĝintaj Arabaj Emir-landoj</B> AE.", "0"],
["emisii", "emisi-i", "<B>1</B> (ph) emit, give out, send forth <I>~i lumon, sonon, varmon, radiojn</I>. <B>2</B> (fin) (<I>eldoni</I>), issue. <I>~i bilojn, ĉekojn, monerojn</I>. <B>~o</B>, emission, issue. <B>~a</B> <I>banko</I>. ➞ <I>brodkast</I>.", "0"],
["emiso", "emis-o", "pond tortoise (<I>Emys</I>).", "0"],
["emocio", "emoci-o", "[OA] Emotion, agitata of mind, excited mental state, feeling. <I>Tremi de ~o</I>. <B>~a</B>, -al. <I>~a gest-(rakont-situaci-)o</I>. <B>~i (<I>-n</I>)</B> (<I>kormovi</I>), affect (excite, stir) the feelings, take hold of, thrill. <I>~i ĝislarme</I>, move to tears. <B>~iĝi</B>, feel e. <B>Sen~a</B>, cold, impassive, unimpressnbl. ➞ <I>afekci, agit, kortuŝ, sentimental, sku</I>.", "0"],
["empeno", "empen-o", "(av) tail unit. <I>~o ala, buma, glitila</I>, tail plane (boom, skid).", "0"],
["emperono", "emperon-o", "(av) elevator.", "0"],
["empetro", "empetr-o", "(bot) crowberry (<I>Empetrum</I>).", "0"],
["empir(i)a", "empir(i)-a", "[OA] Empiric/al, based on experience and observation, experimental, rule of thumb, <B>~ismo</B>, -ism. <B>~isto (~ulo)</B>, -ist. ➞ <I>aposterior, eksperiment, praktik</I>. <B>Rim</B>.: Z. used both <I>empirism, empiristo</I> and <I>empiri-a</I>.", "0"],
["emulsio", "emulsi-o", "[OA] Emuls/ion, colloidal suspension of one liquid in another. <I>~o migdala, moruhepata</I>. <B>~i</B>, -ify. <B>~ilo</B>, -ifier.", "0"],
["emuo", "emu-o", "(orn) emu. (<I>Dromiceus</I>). ➞ <I>kazuar</I>.", "0"],
["en", "", "[UV] (<I>prep) (opposite ekster, el</I>), in. <B>1</B> (<I>loko</I>): (a) (<I>interne de</I>): <I>i</I>n, inside, within. <I>~ la ĉambro (domo). ~ ĝi</I>, therein. <I>Fiŝo ~ akvo, mano ~ mano, loĝi</I> ~ (at) <I>Parizo</I>. <B>f</B> <I>Loĝi ~ malproksimo (la sudo</I>). (With accusative): into: <I>iri (de ekstere) ~ la ĉambron, domon</I>. <B>f</B> <I>dividi ~ provincojn; konduki ~ mizeron; rompi ~ pecojn; traduki ~ Esperanton</I>. (b) (<I>inter</I>), in, among: <I>~ la brakoj, branĉoj;</I> (c) (<I>vestita, volvita): virino ~ atlasaĵoj; sendi ~ k over to</I>. (d) (<I>aneco): ~ la grupo</I>. <B>2</B> (<I>tempo): ~ bona vetero; ~ printempo; ~ la mateno, tago; ~ tempo oportuna</I>, at a suitable time. ~ (on) <I>la unua de Majo. ~ eterneco</I>, for ever and ever. <I>~ la komenco,</I> (Ge 1/1): (<I> = antaŭ paso de): lerni ~ unu monato</I>. <B>3</B> (<I>maniero) (laŭ): paroli ~ unu (~ alia) maniero</I> (Ij 33/14); <I>bati ~ takto; ~ niaj okuloj</I> (No 13/33); <I>bona ~ ĉiu rilato</I>. <B>4</B> (<I>konsisto) (el, per): haroj - plektoj; pendi - girlandoj; vesti - tri pecoj; atingi ~ du saltoj; ~ kio konsistas lia forto</I> (Jĝ 16/5). <B>5</B> (<I>stato): naski ~ doloro</I> (Ge 3/16); <I>esti ~ amo, dubo, mizero, ordo, sano, turmento</I>. <B>6</B> (<I>aliaj rilatoj): Esperu ~(al) Dio. ~(ĉe) okazo de neceso. Rebrili ~ (el) la maro. ~ (je) mia ago</I>, at my age. <I>Paroli ~ la nomo de. Lerta ~ (pri) sia arto. Pardonu ~ jena afero</I> (2 Rĝ 5/18). <B>~a</B> (<I>interna</I>) (opp <I>ekstera</I>), inner, inside, <B>~e</B> (<I>interne</I>), inside, within. <I>Iri</I> <B>~en. ~igi</B>, insert, introduce. <B>~iĝi</B>, enter, penetrate, work in, etc. (➞ <I>enir, interven, penetr</I>). ➞ <I>al, ĉe, dum, ekster, el, inter(n), je, laŭ, per, post, sur</I>.", "0"],
["en", "-en-", "(ch sfx) denotes unsaturated hydrocarbon (e.g., <I>benzeno, metileno</I>).", "0"],
["enado", "enad-o", "(orn) stock dove (<I>Colomba oenas</I>).", "0"],
["enanto", "enant-o", "<B>1</B> (bot) water dropwort (<I>Oenanthe</I>). <B>2</B> (orn) wheatear (<I>oenanthe</I>). <B>enartroz-o</B>, (anat) enarthrosis, ball and socket joint.", "0"],
["encefalo", "encefal-o", "(technical language) (= ordinary language <I>cerbo</I>), brain. <B>~ito</B>, (<I>cerbinflamo</I>), b-fever. <B>~ito letargia</B>, sleepy-sickness. ➞ <I>cerebel</I>.", "0"],
["encikliko", "enciklik-o", "(rc) encyclical, papal epistle.", "0"],
["enciklopedio,", "enciklopedi-o,", "[OA] encyclopaedia. <I>~o ĝenerala, speciala</I>. <B>~a</B>, -ic. <I>~a vortaro</I>.", "0"],
["end", "-end-", "sfx officialized in 1953 = which is (has) to, must (should) be -ed (passive sense of verb). <B>Far~a</B> <I>laboro</I>, work to (that must) be done. <I>Problemo</I> <B>solv~a</B> (to be solved). <I>La kotizaĵo estas nun</I> <B>pag~a</B> (obligation), is payable (due, should be paid), <B>Rim</B>.: ➞ <B>pagebla</B> (possibility), able to be paid; <B>pagota</B> (prophecy) will be paid. <I>Rezulto</I> <B>cel~a;</B> <I>vorto</I> <B>dir~a;</B> <I>lumo</I> <B>esting~a;</B> <I>eraro</I> <B>evit~a;</B> <I>ŝtrumpo</I> <B>flik~a;</B> <I>modelo</I> <B>imit~a;</B> <I>fakto</I> <B>memor~a;</B> <I>tasko</I> <B>plenum~a;</B> <I>ekzemplo</I> <B>sekv~a;</B> <I>letero</I> <B>skrib~a</B>. (<I>Tio</I>) <B>Endas!</B> It has to (must) be; is imperative (necessary)! <I>Estas</I> <B>kompren~e</B> (It must be understood), <I>ke</I>. <B>Rim</B>.: Distinguish between <B>lav-enda</B>, <B>lavend-a; leg-enda</B>, <B>legend-a</B>.", "0"],
["endemio", "endemi-o", "(<I>regiona malsano</I>), endemic. <B>~a</B>, -ic. ➞ <I>epidemi</I>.", "0"],
["endimiono", "endimion-o", "(<I>arbara hiacinto</I>), (English) bluebell, wild hyacinth (<I>Endymion non- scriptus</I>). ➞ <I>kampanol</I>.", "0"],
["endivio,", "endivi-o,", "[OA] endive (<I>Chicorium endivia</I>). The curly greenish leaves of C.e. <I>var. crispus</I> are eaten as a salad (Fr \"chicoree\"). ➞ <I>cikori</I>.", "0"],
["endo", "endo-", "(Gk. ppfx = <I>interne</I>), Endo-. ~ <B>gamio</B>, -gamy, inbreedg, <B>~gena</B>, -egenous. <B>~kardo</B>, (anat) -cardium. <B>~karpo</B>, -carp. <B>~krino</B>, -crine. (<I>sendukta</I><B>). ~smozo</B> (chem) -smosis.", "0"],
["energio", "energi-o", "[F], Energ/y, force, strength, vigour (of action, person, speech), (ph) power, working capacity; <I>~o elektra, materia, mekanika, muskola</I>. <B>~a</B>, -etic, emphatic, forcible, full of go (dash, grit, pep), strenuous, vigorous. <I>~a agado, karaktero, laboro, parolo, rimedo. Labori</I> <B>~e</B>, with heart and soul. <B>~igi</B>, -ize. <B>Mov~o</B> (<I>puŝforto</I>), force, impetus. <B>Sen~a</B>, feeble, flabby, ineffectual, limp, listless, powerless, toneless, slack, sluggish. <B>Sen~igi</B>, debilitate, enervate, weaken. ➞ <I>efik, fort, impet, karakter</I>.", "0"],
["enfili", "enfil-i", "(<I>-n</I>), enfilade, fire (sweeping from end to end), rake.", "0"],
["engraŭlo", "engraŭl-o", "(ich) anchovy (<I>Engraŭlis</I>) in its natural state. ➞ <I>anĉov</I>.", "0"],
["enharmona", "enharmon-a", "(mus) enharmonic change of letter-name, e.g., Cb = <B>B.</B>", "0"],
["enigmo", "enigm-o", "[UV] Enigm/a. <B>1</B> conundrum, puzzle, riddle, <I>Proponi (solvi) ~on</I> <B>(Jĝ</B> 14/12). <B>2</B> dark saying (wide sense). (Ps 49/4, 78/2; Se <B>1</B> /6, Ĥb 2/6). <I>~oj de la naturo</I>. <B>~a</B>, -atic, dark, mysterious, not clear, obscure, problematic, veiled. <I>~a fraz-(karakter -rigard-sort-)o. Paroli</I> <B>~e</B> (<I>per ~oj</I>). <B>Bild~o</B> (<I>rebuso</I>), <B>Krucvort~o</B>, crossword puzzle. <B>Vort~o</B>, logogriph, anagrammatic word- puzzle. ➞ <I>mister, problem</I>.", "0"],
["enketo", "enket-o", "[OA] (official) Inquiry, investigation, research (Le 19/20). <I>~o scienca</I>. <B>~i</B> (<I>fari ~on</I>) (pri), make (conduct, hold) a judicial or official i. into. <B>~isto</B>, investigator, coroner, magistrate. <B>Mort~o</B>, coroner’s inquest. ➞ <I>esplor</I>.", "0"],
["enklitiko", "enklitik-o", "(<I>senemfaza postvorto</I>), enclitic, e.g., <I>one</I> in <I>anyone</I>.", "0"],
["enoj", "-enoj", "(zool sfx) denotes family (-<I>itiae</I>); e.g., <I>mustel-enoj</I>.", "0"],
["enotero", "enoter-o", "evening primrose (<I>Oenothera</I>).", "0"],
["ensemblo", "ensembl-o", "(<I>tutaĵo</I>), ensemble, thing viewed as a whole, gen. combined (concerted, massed) effect, entirety (mus) united performance.", "0"],
["enterito", "enterit-o", "enteritis, inflammation of small intestine.", "0"],
["entimemo", "entimem-o", "(log) enthymeme, sylloĝism with one premiss omitted.", "0"],
["entjero", "entjer-o", "(mat) integ/er, whole number, undivided quantity. <B>~a</B>, -ral, complete, entire, whole. <I>~a parto (~ono</I>), aliquot pt. ➞ <I>faktor, pleti, tut</I>. Opp <I>frakci</I>.", "0"],
["ento", "ent-o", "(=-o, <I>estajo</I>), (phi) entity, thing with real existce, being.", "0"],
["entomologio", "entomologi-o", "[OA] entomolog/y.", "0"],
["entomologo", "entomolog-o", "entomologist.", "0"],
["entozoo", "entozo-o", "entozo/on. <B>1</B> (<I>interna parazito</I>). <B>2</B> (<I>intesta vermo</I>). ~a -ic, living inside an animal.", "0"],
["entrepreni", "entrepren-i", "(<I>-n, -i</I>), [UV] Undertak/e, accept obligation, agree to do, contract for, engage in, embark (enter) upon, go in for, get one’s hand in, take in hand, (Mi 2/3). <I>~i laboron, respondecon, tradukon</I>. <B>~(aĵ)o</B>, -ing, concern, enterprise, venture. <I>~o industria, komerca</I>. ➞ <I>establaĵ, firm</I>. <B>~anto</B>, <B>~isto</B>, contractor. <B>~ema</B> (<I>aventurema, riskema</I>), enterprising. ➞ <I>ekspluat, iniciat, komenc, kontrakt, preni sur sin</I>.", "0"],
["entropio", "entropi-o", "entropy. <B>1</B> (ph) <B>2</B> (med) inver sion of eyelid. opposite <I>ektropi</I>.", "0"],
["entuziasmo", "entuziasm-o", "(<I>por, pri</I>), [UV] Enthusias/m, ardent zeal, passionate eagerness. <I>Blinda ~o</I>. <B>~a</B>, -tic. <B>~i</B> (<I>esti ~a</I>), <B>~igi</B> (<I>-n</I>), enthuse. <B>~iga</B>, inspiring, stirring. <B>~ulo</B>, -t. <B>Sen~a</B>, half-hearted. <B>Tro~a</B>, extravagant, immoderate, etc. ➞ <I>anim, ekseit, inspir</I>.", "0"],
["enui", "enu-i", "(nt), [UV] be bored, fed up, feel (find it) dull, find time drag, lose interest, mope, not know what to do with one’s. <I>Atendante, mi ~is la tutan tagon</I>. <B>~o</B>, mental weariness from lack of occupation or interest, boredom, ennui, languor, lassitude, listlessness, tedium. <B>~(ig)a</B>, dull, irksome, prosy, tedious, tiresm, tiring, trying, wearism. <I>~iga homo, laboro, libro, sono</I>. <B>~igi</B> (<I>-n</I>), bore, bother, be tiresome to, weary. <B>~igaĵo</B>, nuisance. <B>~igita</B>, bored, wearied. <B>Mal~igi</B>, amuse, entertain, etc. (➞ <I>amuz, distr</I>). <B>Viv~o</B>, weariness of life, satiety, etc. ➞ <I>lac, tediĝ, splen</I>.", "0"],
["enuklei", "enukle-i", "(<I>-n) (eltranĉi</I>), (surg) Enucleat/e, cut out whole. <B>~o</B>, -ion.", "0"],
["enverguro", "envergur-o", "(<I>larĝo</I>), breadth, span, spread, e.g., of wings,, (av) envergure. <I>~a ŝarĝo,</I> span loading. (mar) breadth, extent, head (sails to yard).", "0"],
["envio", "envi-o", "[UV] Env/y, grudging contemplation of more fortunate persons or their advantages. <B>~i</B> (<I>iun pri io, ion al iu</I>), e., be -ious of, begrudge, covet. <B>~(em)a</B>, -ious. <B>~igi</B>, make -ious. <B>~inda</B>, -able. <I>~~a homo, sano, sorto</I>. <B>Mal~i</B>, allow willingly, not be envious of. <B>Sen~e</B>, ungrudgingly. ➞ <I>avid, domaĝ, ĵaluz</I>.", "0"],
["enzimo", "enzim-o", "(chem) enzyme, <B>eocen-o</B>, <B>~a</B>, (geol) eocene.", "0"],
["Eola", "Eol-a", "(mus) Aeolian. <I>~a harpo (vento, harpo</I>).", "0"],
["eolita", "eolit-a", "(hist) eolithic.", "0"],
["eono", "eon-o", "(a)eon, an age, immeasurable period, eternity.", "0"],
["epakto", "epakt-o", "(astr) epact, age of moon on 1 Jan.", "0"],
["eparĥio", "eparĥi-o", "eparchy. <B>1</B> division of Greece. <B>2</B> diocese of Gk. church.", "0"],
["epi", "epi-", "(Gk. ppfx = upon, at, in addn to), epi-.", "0"],
["epiciklo", "", "<B>~ciklojdo</B>, (geom) epicycle, epicycloid.", "0"],
["epidemio", "epidemi-o", "[OA] (med) epidemic, pestilence (Ps 91/6, 106/29), widespread outbreak of infectious disease. <I>Besta ~o</I>. f <I>~a entuziasmo</I>. <B>~aĵo</B> (Rd 7/15). ➞ <I>endemi, pest</I>.", "0"],
["epidendro", "", "epidendron (orchid).", "0"],
["epidermo", "epiderm-o", "[OA] (anat, bot), epidermis, cuticle, outer layer, top skin. <B>~diaskopo</B>, -diascope. <B>~fito</B>, (bot) -phyte. <B>~fizo</B> (anat) -physis. <B>~gastro</B>, (anat) -gastrium. <B>~gloto</B>, (anat) ~glottis.", "0"],
["epifanio", "epifani-o", "[OA] Epiphany, manifestation of Christ to the magi.", "0"],
["epigrafo", "epigraf-o", "[OA] (<I>surskribo</I>), epigraph, inscription (on stone, coin, etc.). <B>~karpo</B>, (bot) -carp. <B>~stilo</B>, (arch) -style.", "0"],
["epigramo", "epigram-o", "[OA] (<I>diro frapa, pika</I>), Epigram, short poem or inscription with witty ending, pungent saying or expression. <B>~a</B>, -attic, pithy, terse.", "0"],
["epikuro", "epikur-o", "(<I>frandemulo</I>), Epicur/e. <B>~a</B>, -ean, devoted to pleasure or refined sensuous enjoyment. <B>~ano</B>, -ean, follower of Epicurus. <B>~ismo</B>, -eanism.", "0"],
["epilepsio", "epilepsi-o", "[OA] Epilep/sy. <B>~a</B>, <B>~ulo</B>, -tic.", "0"],
["epilobio", "epilobi-o", "willow-herb, fire-weed, rose-bay (<I>Epilobium</I>).", "0"],
["epilogo", "epilog-o", "[OA] epilogue, final part of literary work, short poem at end of play.", "0"],
["epipakto", "epipakt-o", "(bot) helleborine (<I>Epipactis</I>).", "0"],
["episkopo", "episkop-o", "[UV] Bishop. <B>~a</B>, episcopal. <I>~a bastono</I>, crosier, pastoral staff. <I>Lia ~a Moŝto</I>. <B>~ano (~aro</B>, <B>~eco</B>, <B>~ismo)</B>, episcopalian (-ate, -acy, -alianism). <B>ĉef~o</B>, [UV] arch-b. <B>Sub~o</B>, suffragan b. ➞ <I>diocezestr, eparĥiestr, patriark, prelat, primat</I>.", "0"],
["epistolo", "epistol-o", "Epist/le, letter. <B>1</B> apostolic (Bb). <B>2</B> (pros) <I>~oj de Horacio</I>. <B>3</B> (fac) lengthy letter. <B>~a</B>, -olatory. ➞ <I>leter</I>.", "0"],
["epistrofo", "epistrof-o", "(rh) epistrophe, ending of several sentences or clauses with same word(s) (Ap 7/5-8, 2 Ko 11/22).", "0"],
["epitafo", "epitaf-o", "(<I>tomba surskribo</I>), epitaph.", "0"],
["epitelio", "", "(anat, bot), epithelium.", "0"],
["epiteto", "epitet-o", "[OA] ephithet, attributive (qualifying) adj. or noun. ➞ <I>atribut</I>.", "0"],
["epitom", "", "-o, epitome, abstract (of book etc.), condensed account, summary, <B>f</B> representation in miniature. ➞ <I>kompendi, resum</I>.", "0"],
["epizodo", "epizod-o", "[OA] Episod/e. <B>1</B> (<I>flanka agado</I>), incidental narrative in poem, story, etc. (mus) <I>~o de fugo</I>. <B>2</B> (<I>aparta fakto, interokazo</I>), event, occurrence. <I>~o de kongreso</I>. <B>~a</B>, -al, incidental. ➞ <I>akcesor, efemer, flank, incident, malĉef, parentez</I>.", "0"],
["epoko", "epok-o", "[UV] Epoch. <B>1</B> (geol, pol) (<I>gram moinento</I>), begining of era, red-letter day, turning-point (in history, life, etc.). <B>2</B> (<I>periodo, temp-aĝo</I>), age, period (marked by special events). <I>~o antaŭhistoria, glacia</I>. <B>Silik~o</B>, stone age, <B>-ofara</B>, e-waking. <B>Mez~a</B>, mediaeval (475-1453). <B>Sam~a</B>, co-epocheval.", "0"],
["epoleto", "epolet-o", "[UV] (<I>surŝultra ornamaĵo</I>), epaulette), shoulder-piece.", "0"],
["epopeo", "epope-o", "[OA] (a. <I>eposo</I>), epic poem, e.g., <I>Iliado, Eneido, Rolandkanto</I>. <B>~a</B>, epic.", "0"],
["er", "-er-", "[UV] sfx (opposite <I>-ar</I>), denotes element, unit, of a homogeneous whole. <B>Akv~o</B>, <B>pluv~o</B>, drop of water (rain); <B>ĉen~o</B>, link; <B>fulg~o</B>, smut; <B>herb~o</B>, blade of grass; <B>mon~o</B>, coin; <B>neĝ-o</B>, snowflake; <B>pajl~o</B>, straw; <B>pan~o</B>, crumb; <B>program~o</B>, item; <B>sem~o</B>, grain (seed); <B>ŝvit-o</B>, bead of perspiration. <B>~o</B>, element, unit; grain. <B>~eto</B>, small pt, particle, speck, etc. <B>Dis~igi</B>, separate into its elements. <B>Du~a</B>, binary. <B>Grand~a</B>, coarse (in grain). ➞ <I>an, ar, atom, element, flok, gut, pecet</I>. <B>Rim.:</B> An <I>er-</I>word denotes something complete in itself. For irregular fragment, <I>pec, split</I>, etc., are more appropriate.", "0"],
["erantido", "erantid-o", "(bot) winter aconite (<I>Eranthis</I>).", "0"],
["erao", "era-o", "era, age, historical period or epoch. <I>La Kristana ~o</I>. ➞ <I>dat, epok</I>.", "0"],
["erari", "erar-i", "(<I>en, pri</I>), [UV] <I>= malĝuste agi, paroli, pensi</I>, Err. <B>1</B> be incorrect (mistaken, wrong), make mistake(s). <I>~i en kalkulo, pri nomo. ~i estas home. Nur tiu ne ~as, kiu neniam ion faras</I>. <B>f</B> (<I>morale</I>) go astray. <B>2</B> (early writings) lose one’s way, stray (better <I>devojiĝi, perdi la vojon, vojerari</I>). <B>~o</B>, error, blunder, erratum, false step, fault, lapse, mistake. <I>~o gramatika. Fari, korekti ~on. Persisti, resti en</I> ~o. <B>Juĝ~o</B>, error of judgment. <B>Kolor~o</B>, ➞ <I>daltonism</I>. <B>Sent~o</B>, error of sense, hallucinate (➞ <I>halucin, iluzi). Plum~o, pres~o, skrib~o</I>. (mat) deviation from accuracy, <B>~a</B>, erroneous, incorrect, mistaken, wrong. <I>~a kalkulo, metodo, respondo, teksto, vojo</I>. <B>~e</B>, in error, amiss, by mistake, mis-. <B>~ego</B>, bloomer, howler. <B>~ema</B>, <B>~ipova</B>, erring, fallible. <B>~eto</B>, slip. <B>~igi</B> (deceive, lead astray, misinform, mislead. ➞ <I>tromp</I> (Re 27/18). <B>~lumo</B> (<I>vaglumo</I>), Will o’ the wisp, <I>ignis fatuis</I>. <B>Mal~igi</B>, set right, undeceive. <B>Ne~em</B>, <B>~iva</B>, <B>~ipova</B>, certain, infallible, sure, unerring. <B>Sen~a</B>, correct. ➞ <I>flankiĝ, ekart, malbon, malĝust, malprav, maltraf, mis, peket, solecism, vag</I>.", "0"],
["erbio", "erbi-o", "(chem) erbium (Er).", "0"],
["erco", "erc-o", "(<I>minajo</I>), Ore. <I>Stan~o</I>. tin o.", "0"],
["erekt", "", "-i (bio) Erect (<I>rigidigi</I>). <B>~o</B>, -ion (of hair, muscle, organ, tissue). <B>~iĝema</B>, -ile.", "0"],
["ergo", "erg-o", "(el) erg, unit of work or energy,", "0"],
["ergoto", "ergot-o", "(bot) Ergot (<I>Claviceps purpurea</I>). <B>Sekal~o</B>, disease of rye. <B>~ino</B>, -ine. <B>~ismo</B>, (med) -ism.", "0"],
["erigerono", "erigeron-o", "(bot) fleabane (<I>Erigeron</I>).", "0"],
["eriko", "erik-o", "[OA] (bot) Heath (<I>Erica</I>). <B>Arb~o</B>, tree-h, from which the wood for briar pipes. <B>~ejo</B>, h., moor. ➞ <I>kalun, step</I>.", "0"],
["erinaco", "erinac-o", "[UV] hedgehog (<I>Erinaceus</I>). <B>Mar~o</B> (<I>ekino</I>), sea-urchin.", "0"],
["eringio", "eringi-o", "sea holly (<I>Eryngium</I>).", "0"],
["eriobotrio", "eriobotri-o", "loquat (<I>Eriobolrya</I>).", "0"],
["erioforo", "eriofor-o", "(bot) cotton-grass, harestail (<I>Eriophorum</I>).", "0"],
["eritemo", "eritem-o", "(med) erythema, redness of skin.", "0"],
["eritreno", "eritren-o", "(bot) coral tree, Kaffir boom, etc. (<I>Erythrina</I>).", "0"],
["Eritreo", "Eritre-o", "ER.", "0"],
["eritronio", "eritroni-o", "(hort) Erythronium <I>&lt;</I> dog’s tooth violet <I>)E. dens-canis</I>).", "0"],
["erizimo", "erizim-o", "(bot) treacle-mustard (<I>Erysimum</I>). ➞ <I>sizimbri</I>.", "0"],
["erizipelo", "erizipel-o", "[OA] (med) erysipelas, St. Anthony’s fire.", "0"],
["ermeno", "ermen-o", "[UV] (zoo) Ermine, stoat (<I>Mustela erminea</I>). <B>~felo</B>, e-skin (applied to many species of <I>putoro</I> and <I>mustelo</I>). ➞ <I>mustel</I>.", "0"],
["ermito", "ermit-o", "[UV] Hermit, <B>f</B> person living all alone, recluse. ~a <I>vivo</I>. <B>~ejo</B>, -age. ➞ <I>dezertul, izolul, pagur</I>.", "0"],
["erodi", "erod-i", "(geol, mec), Ero/de, destroy surface of, eat away (metal by acid), grind, wear, away (by ice, water, wind). <I>Klifoj ~itaj de la maro</I>. <B>~o</B>, erosion, attrition, wear and tear, e.g., of coin, (mot) running-in. ➞ <I>abrad, (ko)rod</I>.", "0"],
["erodio", "erodi-o", "(bot) storksbill (<I>Erodium</I>).", "0"],
["erofilo", "erofil-o", "common whitlow grass (<I>Erophila</I>).", "0"],
["erotika", "erotik-a", "[OA] Erotic, amatory, of love. <I>~a poemo</I>. <B>~o</B>, -ism, sexual excitement. <B>~i</B>, act erotically. <B>~ulo</B>, erotic. person. ➞ <I>am, amor, seks, volupt</I>.", "0"],
["erotomanio", "erotomani-o", "(med) erotomania, excessive or morbid erotic desire, preoccupation with sexual passion.", "0"],
["erpi", "erp-i", "(<I>-n</I>), [UV] (agr) Harrow. <I>~i kampon</I> (U 39/10, Ho 10/11). <B>~ilo</B>, h.", "0"],
["erudicio", "erudici-o", "[OA] Erud/ition, learning, profound scholarship. <B>~a</B>, -ite, scholarly, well-read. <B>~ulo</B>, scholar. ➞ <I>kler, multesci, sciplen</I>. <B>Rim</B>.: Also <B>erudit-o</B> (<I>erudiciulo</I>), <B>~a</B>, <B>~eco</B>.", "0"],
["erupti", "erupt-i", "(a. <B>erupci-i</B> [OA]), (nt) Erupt, break out, burst forth, emit lava, etc. (<I>vulkano</I>), spurt out water (<I>gejsero</I>). <B>~o</B>, eruption, outbreak, outburst. <I>~o de milito, pasio, rido</I>. (med) breaking-out (<I>haŭtinflamo</I>), cutting (<I>dentoj). ~o zona (zostro</I>). <B>~a</B>, -ive. ➞ <I>ekzantem, elsput</I>.", "0"],
["escepti", "escept-i", "(<I>-n</I>) [UV] (<I>apartigi, ne inkludi</I>), Except, exempt, exclude (from enumeration, statement). <B>~o</B>, -ion (Ge 14/24). <I>~o gramatika. Regulo sen ~o</I>. <B>~a</B> (<I>neodinara</I>), -ional, out of the ordinary rut, uncommon. <I>~a kapablo, okazo. ~a prezo,</I> bargain price. <B>~e</B> (<I>kiel ~o, en ~a okazo</I>) -ionally, as an -ion. <I>Hodiaŭ, <B>~e</B>, mi restos hejme. ~e bona</I>. [Ne= except.] <B>Rim</B>.: (early writings) Till 1906, Z used <I>~e</I> with the meaning <I>ekskluzive). <B>~e de</B> (kun escepto de), ~ante, ~inte, krom</I>), e., barring, save, with the -ion of. <I><B>Sen~e</B>,</I> without (admitting of no) -ion, in every case, universally. ➞ <I>eksklud, ekskluziv; ekster, krom</I>.", "0"],
["esenco", "esenc-o", "[UV] Essen/ce. <B>1</B> (<I>ento, karaktero, naturo</I>), indispensable element (Ps 103/14, 119/160, Ij 16/7). <B>f</B> gist, heart, main point, pith, root. <I>La ~o de la afero. La ~o de Dio</I>. (Ij 11/7). <B>2</B> Extract (by distillation), of perfume, etc.; volatile oil, tincture; concentrate, (opp dilution). <I>~o de rozoj</I>, attar of roses. <B>~a</B> (<I>proprana- tura, vera</I>), -tial, distinguishg, intrinsic, real, true. <I>~a bono</I> (Se 8/21). <B>~e</B> (<I>aparte</I>), in e., -tially, at the bottom (root). <B>Ne~a</B>, accessory, subordinate. <B>Sen~a</B>, un-tial. <B>Viv~a</B>, vital. ➞ <I>ec, fundament, kern, kvalit, kvintesenc, precip, tinktur</I>. Opp <I>akcesor, flank</I>.", "0"],
["eseo", "ese-o", "essay, short literary composition. ➞ <I>etud, traktaĵ</I>.", "0"],
["eskadro", "eskadr-o", "[UV] (mil, mar) squadron (of ships or aeroplanes). ➞ <I>skadr</I>.", "0"],
["eskalatoro", "eskalator-o", "escalator, moving staircase.", "0"],
["eskalo", "eskal-o", "(<I> = ŝtupetaro</I>), Ladder. <B>~o duobla</B>, <B>simpla. ~o flanka</B>, gangway. 1. <B>~ado</B>, (mil) escalade. <B>Sav~o</B>, fire-escape. <B>Ŝnur ~o</B>, rope <B>1. (tex) 1</B>. in stocking. <B>-imuna</B>, 1-proof.", "0"],
["eskalono", "eskalon-o", "(mil) Echelon, troop formation. <B>~i</B>, dispose in e. <B>f</B> space out, spread (objs); stagger (holidays).", "0"],
["eskapi", "eskap-i", "(<I>al, de, el</I>) Escap/e, gain liberty, get free, find a way out, leak. <B>~ismo</B>, -ism.", "0"],
["eskarpo", "eskarp-o", "(<I>interna deklivo</I>), (fort, geol, etc.) escarp(ment), abrupt descent, scarp, steep slope. <B>Kontraŭ~o</B>, counterscarp.", "0"],
["eskatologio", "eskatologi-o", "eschatology, doctrine of last things (death and after).", "0"],
["eskorto", "eskort-o", "[OA] Escort (for persons or things), (mil) guard, (mar) convoy; <B>f</B> attendants, retinue, train. <B>~i</B> (<I>-n</I>), accompany, attend, conduct. <B>~anto</B>, e. <B>~ŝipo</B>, convoy. ➞ <I>akompan, gard, gvid</I>.", "0"],
["eskudo", "eskud-o", "(num) escudo.", "0"],
["esotera", "esoter-a", "(<I>sekreta</I>), (phi) Esoteric, for the initiated only, private. <I>~a doktrino</I>. <B>~ismo</B>. -ism. <B>Mal~a</B>, exoteric, common to all, ordinary (➞ <I>profan, publik</I>). ➞ <I>adept, inic, privat</I>.", "0"],
["esparto", "espart-o", "esparto grass (<I>Stipa tenacissima</I>).", "0"],
["Esperanto", "Esperant-o", "[F], Esperanto. <I>Parolu</I> <B>~e</B>, (<I>en ~o</I>). Traduku <B>~en</B> (<I>en ~on</I>). <B>~a</B>, in or rel. to E. <I>~a gramatiko, klubo, kongreso, literaturo, movado, vortaro</I>. <B>Rim</B>.: A recent fashion of boycotting the adj. <I>Esperanto</I> and replacing it by an invariable <I>Esperanto- (Ĉe la E-oklubo li legis E-olibron kaj kantis E-okantojn pri la E-omovado kun E-oamikoj!!</I>) is a <I>\"malsano ekstermenda\"</I>. <B>~aĵo</B>, something in E. <B>~ano</B>, adherent (friend, partisan) of E. <B>~igi</B>, put into E. <B>~ismo</B>, <B>1</B> The \"interna ideo\" of E, defined in the Boulogne Declaration. <B>2</B> An E idiom or form of speech. <B>~isto</B>, -ist. <B>-istaro (~ujo)</B>, E-land, the E. world. <B>Ek~isto</B>, beginner, newly-baked E-ist. <B>Ne~isto</B>, non-E-ist. <I>Agado</I> <B>per~a</B>, <B>por~a</B>, <B>pri~a. ~olog(i)o</B>, student (study) of E (language and movement).", "0"],
["esperi", "esper-i", "(<I>-a, al, je, pri, -i</I>), [UV] Hop/e, be <B>-</B>ful, expect, hope (look) for, trust. <I>Mi~as, ke li venos</I>, I h. he is coming. <I>~i feliĉon, venkon, vizitanton. Mi ~as iri. ~i al iu,</I> put one’s h. in. <I>~u al Dio</I> (Ps 42/5). <B>~o</B>, <B>1</B> have confidence, expectation, reliance, trust. <I>Meti sian ~on en,</I> pin one’s hopes on. <I>Doni (detrui) ~on. Mia ~o estas al vi. (Ps 39/7</I>). <B>f</B> (<I>= ~ataĵo), Vi estas mia ~o</I> (Ps 71/5). <I><B>~(em)a</B>, <B>~oplena</B>,</I> h-ful. <I><B>~ata</B>,</I> -ed for. <I><B>~eble</B>,</I> it is to be -ed; I (let us, we may) hope (so) (that). <I><B>~igi</B> (iun, ke</I>) = <I>inspiri, naski ~on</I>, (give) promise (of), bid fair to. <I><B>~iga</B> (~odona, bonaŭgura</I>), hopeful, promising. <I><B>~inda</B> (dezirinda</I>), desirable. <I><B>mal~i</B></I> [UV] (<I>perdi ~on</I>) despair, despond. <I>Fali en mal~on</I>. <I><B>Mal~a</B>, <B>Sen~a</B>,</I> hopeless, despairing, desperate. <I><B>Ne~ita</B>,</I> unhoped for, unexpected. ➞ <I>atend, antaŭvid, dezir, ekspekt, perspektiv, sopir</I>.", "0"],
["esplanado", "esplanad-o", "esplanade, level piece of ground, promenade. ➞ <I>plac, promenej</I>.", "0"],
["esplori", "esplor-i", "(<I>-n</I>) [UV] (<I>detale pririgardi</I>). <B>1</B> Explor/e (for discovery). <I>~i landon</I>. <B>2</B> Investig/ate, examine, go (inquire, look, probe) into, scrutinize, make a study of. <I>~i buŝon, demandon, fenomenon</I> (Rd 19/18). <I>~i popolon</I> (El 16/4). <B>~(ad)o</B>, exploration, investigation, research, study. <B>~a</B>, exploratory, investigatory. <I>~a komitato</I>. <B>~anto</B>, <B>~isto</B>, -er. <B>~ema</B>, inquisitive, inquisitorial. <B>~ilo</B>, probe, etc. ➞ <I>buĝi</I>. <B>~rigardi</B>, reconnoitre. <B>~vojaĝo</B> (➞ <I>ekspedici</I>). <B>Antaŭ~o</B>, reconnaisance. <B>El~i</B>, fathom, get to the bottom of, thrash out. <B>Ne~ebla</B>, unfathomable, impenetrable, inscrutable. <B>Sin~ema</B>, introspective. <B>Ter~isto</B>, prospector. ➞ <I>ekzamen, enket, prov, serĉ, skoll, sond, spion</I>.", "0"],
["esprimi", "esprim-i", "(<I>-n</I>), [UV] Express (by word, gesture, etc.), convey, represent, reveal, signify, utter. <I>~i dankon, ĝojon, penson, senton, sin</I>. <B>~o</B>, -ion. 1 (<I>ago ~i, montro): ~o de doloro, opinio. (aspekto): ~o malmola kaj severa</I>. <B>2 ~(aĵ)o</B> (<I>dirmaniero, stilo</I>), diction, phrase, word(ing): <B>Dank~o</B>, -ion of thanks. <B>3</B> (mus) interpret feeling of a passage. <B>4</B> (mat) symbols -ing a quantity. <B>~(oplen)a</B>, <B>~iva</B>. expressive. <B>~ilo</B>, means of -ion. <B>Ne~ebla</B> (<I>nedirebla</I>), inexpressible, ineffable. <B>Sen~a</B>, -less, poker-faced, unexpressive. <B>Sin~o</B>, self-ion. <B>Vizaĝ~o</B>, -ion of face, countenance (➞ <I>fizionomi, mien</I>). ➞ <I>dir, elmontr, figur, prezent, simbol, termin, fortig</I>.", "0"],
["establi", "establ-i", "(<I>-n</I>) [OA], Establish, erect, found, institute, set up. <I>~i domon, filion, firmon, kolonion, registaron, rekordon;</I> place beyond dispute, prove, substantiate. <I>la fakton, ke;</I> lay down, prescribe, secure acceptance for. <I>~i kutimon, precedenton, regulon</I>. <B>Sin ~i</B>, settle, set up for one’s, take up residce. <B>~o</B>, setting-up. <B>~aĵo</B>, -ment, business, household, institution, works, etc. ➞ <I>dom, entrepren, firm</I>.", "0"],
["estero", "ester-o", "(chem) ester.", "0"],
["estetiko", "estetik-o", "[OA] Aesthet/ics, appreciation of (feeling for) beauty, good taste. <B>~a</B>, -ic, tasteful. <B>~ismo</B>, -ism. <B>~ulo</B>, -e.", "0"],
["esti", "est-i", "[UV] Be. <B>1</B> independent verb. (a) (<I>Ekzisti): ~u lumo!</I> Let there be light! <I>Ĉu ~i, aŭ ne ~i?</I> (b) (<I>Okazi): Morgaŭ ~os la edziĝo. Tiel ~u!</I> May it be so! So be it! <I>Kio ~as (al vi)?</I> What is the matter (with you)? What is up? (c) (<I>Troviĝi): ~i en Parizo (hejme, en dubo). Neniu ~is tie (ĉeestis</I>). (d) (<I>Temi): Pri kio ~as la afero?</I> What is it all about? (e) (<I>Veni, skribiĝi): La letero ~is de Mario</I>. <B>2</B> Copula (a) joining predicate to subject <I>Tio ~as rozo. Mi ~as laca</I>. Or (b) forming compound tense. <I>~i amata</I>. <B>3</B> Impersonal, <I>~is dimanĉo</I>, It was Sunday, <I>~as nenio!</I> It is nothing! <I>~as bone!</I> It is well. <B>4</B> Occasional use for emphasis. <I>Estis Petro, kiu</I> ... It was P who … H Often omitted (col. or in proverbs). <I>Jen mi!</I> Here am I! <I>Finite!</I> All is over! <I>Proksima (estas) kubuto, sed ne por la buŝo</I>. <B>Rim</B>.: Always followed by the nominative. Note, however, an apparent exception after the expression <B>Tio estas</B> (<I>t.e. = nome). La akuzativo montras direkton: t.e., (= ĝi montras) movadon al iu loko. Mi ricevis duoblan pagon: t.e., dek frankojn</I>. <B>~(ad)o</B>, being, existence. <B>~aĵo</B>, a being. <B>~anta</B> (<I>aktuala, nuna</I>), extant, present. <I>~ante juna</I>, while young. <B>~anteco</B> (<I>as-tempo, nuntempo</I>), the present. similar <B>~inteco</B>, <B>-onteco</B>. the past (future) (Jes 33/6, 45/11). <B>~ejo</B>, abode, domicile. <B>~ebleco</B>, possibility, <B>~igi</B> (<I>-n</I>), bring into being, create, make, etc. (➞ <I>kaŭz, kre, nask, okazig, produkt, vek</I>). (2 Rg 21/4). <B>~iĝi</B>, come into being, (➞ <I>genez,ĝerm, iĝ</I>). <B>~inta</B>, former, late, old, past. <B>~ontece</B>, hereafter. <B>Al~i</B>, <B>Ĉe~i</B>, (<I>-n, ĉe -o</I>), be (present) at, attend. <B>Ĉe~antaro</B>, audience, those present. <B>Apud~i</B>, be by (present, with). <B>For~i</B>, be absent (away), <B>For~eco</B>, absenteeism. <B>Pensfor~o</B>, absence of mind. <B>Kun~o</B>, being with, association, company. <B>Kun~anta</B>, concomitant. <B>Mal~o</B>, <B>Ne~o</B> (<I>manko</I>), absence, default, lack, non-existence. <B>Verd~i</B> (Ps 92/7, 12, 13). <B>~konfesi</B>, acknowledge, avow, recognize (existance of). ➞ <I>egal, ekzist, fart, troviĝ; iĝ (= ekest), rest (= estad</I>).", "0"],
["estimi", "estim-i", "(<I>-n</I>) [UV] (<I>ŝati pro morala aŭ spirita valoro</I>), Esteem, regard, respect, think highly of. <B>~ata</B>, -ed, valued, worthy. <I>~ata sinjoro</I>, Dear Sir. <B>~o</B> (<I>por</I>), esteem, regard. <B>~inda</B>, estimable. <B>mal~i</B>, [UV] despise. <B>~~o</B>, contempt, disdain. <B>~~inda</B>, contemptible, despicable, mean. <B>~~igi</B>, bring into disrepute, cast discredit (a slur) on. ➞ <I>aprob, honor, respekt, ŝat, taks; renom, reputaci</I>.", "0"],
["estingi", "esting-i", "(<I>-n</I>) [OA], Extinguish. <B>1</B> put out, quench. <I>~i bridon, fajron, kandelon, lumon</I>. Opp <I>ekbrulig, eklumig</I>. <B>2</B> (<I>dampi</I>) cool, damp, destroy, kill. <I>~i ardon, esperon, entuziasmon, fervoron, soifon, vivon</I>. Discharge (liquidate, wipe out) (<I>ŝuldon</I>); obliterate (<I>memoron</I>); put an end to (<I>vivon</I>), quell, suppress (<I>ribelon</I>), silence (<I>kontraŭulon</I>); slake (<I>soifon</I>). <B>~o</B>, extinction, suppression. <B>~iĝi</B>, become -ed (exhausted), die, go out, expire. <B>~iĝinta</B>, extinct. <B>~ilo</B>, -er. <I>Fajr~ilo</I>. <B>Blov~i</B>, blow out. <B>Fajr~a</B> <I>tubo</I>, firehose. <B>~~isto</B>, fireman. ➞ <I>detru; ĉesig, forig, kvietig, mortig, neniig, velkig, sufok</I>.", "0"],
["Estonujo, Estonio", "Eston-ujo, Estonio", "[OA-8] EE, Estonia, a. Esthonia.", "0"],
["estrado", "estrad-o", "[OA] platform, dais, stage. ➞ <I>podi, tribun</I>.", "0"],
["estro", "estr-o", "[UV] (person at the) Head (in command); \"boss\", chief, commander, director, leader, master, principal, ruler. <B>Cent~o</B>, centurion; <B>famili~o</B>, h. of the family; <B>imperi~o</B>, emperor; <B>paroĥ~o</B> incumbent; <B>parti~o</B>, party leader; <B>sub~o</B>, foreman; <B>ŝip~o</B>, captain; <B>urb~o</B>, mayor, provost. <B>~o</B>, <B>~ino</B>, head. <B>~a</B> <I>rigardo. Paroli</I><B>~e. ~i</B>, boss, head, etc. <B>~aro</B>, [UV] governing body, executive. etc. <B>~ema</B>, h-strong, masterful. <B>~igi</B> (Ge 39/4). ➞ <I>ĉef, direkt, komand, mastr, reg</I>.", "0"],
["estuaro", "estuar-o", "(<I>riverbuŝa golfo</I>), estuary, firth, tidal mouth of large river: <I>La ~o de Elbo</I>.➞ <I>delto</I>.", "0"],
["eŝafodo", "eŝafod-o", "[UV] scaffold (for executions).", "0"],
["et", "-et-", "[UV] sfx, to a high degree weakens (diminishes) the idea in the root. With noun-roots <I>= malgranda;</I> with adj- or verb-roots = <I>iomete, malforte</I>, but more strongly than these words. <B>Dolor~o</B>, chafe, discomfort, smart; <B>ŝton~o</B>, pebble; <B>vent~o</B>, light breeze, zephyr. <B>Blu~a</B>, bluish; <B>malsan~a</B>, off colour, out of sorts. <B>Bol~i</B>, simmer. <B>~a</B> <I>Tim</I>, Tiny Tim. <B>~igi</B>, diminish, dwarf. <B>~ul(in)o</B>, little one. <B>Rim</B>.: Sometimes denotes a nuance of affection or caress: <B>patrin~o</B>, <B>man~o. Rim</B>.: Sometimes as pf<I>x = malgrand-:</I> narrow, restricted, small in extent or application. <B>~anima</B>, <B>~burĝo</B>, <B>~industrio</B>, <B>~komerco</B>, <B>~skala.</B>", "0"],
["etaĝero =", "etaĝer-o =", "<I>bretareto, etaĝareto</I>, what-not, (set of) shelves.", "0"],
["etaĝo", "etaĝ-o", "[UV] (bid) Floor, storey, flight (stairs), tier (seats), layer, level, stage (geol, min) (➞ <I>epok, tavol</I>). <B>Dua ~o</B>, second f. <B>~i</B>, arrange in tiers. <B>Inter~o</B>, entresol, mezzanine floor (<I>inter tera kaj unua</I>). <B>Kel~o (subtera ~o)</B>, basement, cellarage. <B>Ter~o</B> (<I>partero</I>), ground f. (th) the pit. <B>Unu~a</B> <I>domo (bangalo</I>), bungalow.", "0"],
["etano", "etan-o", "ethane (C<SUB>2</SUB>H<SUB>6</SUB>). <B>~olo</B>, etanol, ethyl alcohol (C<SUB>2</SUB>H<SUB>5</SUB>OH).", "0"],
["etapo", "etap-o", "Stage. <B>1</B> (of journey), halt, station, regular stopping-place. <I>Facilaj ~oj,</I> easy stages. <B>2</B> distance between two of these. <B>3</B> (gms), distance covered, lap, length, round. ➞ <I>nivel, staci</I>.", "0"],
["etato", "etat-o", "[UV] register, list, inventory. <B>1</B> (fin, etc.) account, report, return, statement. <I>Financa ~o</I>. ➞ <I>bilanc, buĝet, inventar</I>. <B>2</B> roll, number of persons, strength. <I>Oficira ~o</I>, roll of officers. <I>~o de la ŝipanoj,</I> crew list. <B>Ekster~a</B>, unattached, supernumerary, surplus. <B>(Laŭ)~a</B>, on the establishment. ➞ <I>kadastr, nomar, list</I>.", "0"],
["etendi", "etend-i", "(<I>-n</I>), [UV] Exten/d, spread (stretch) out. <B>1</B> (in all directions) (<I>malvolvi, sterni): ~i kolon, kurtenon, reton, tendon, tolon; brakojn, flugilojn</I>. lay (<I>tapiŝon, tukon</I>); set (<I>velojn). ~i la ĉielon</I> (Jes 44/24). <B>2</B> (<I>vastigi</I>) enlarge, widen: <I>~i amplekson, limon, povon, programon, regulon, rigardon, scion, signifon</I>. propagate <I>malsanon, opinion</I>. <B>3</B> (<I>proponi</I>) stretch, hold (out): <I>~i la brakojn, manojn</I>. <B>4</B> <I>Sin~i</I>, lie prone, at full length. <B>5</B> (mil) spread out in open order. <B>~a</B> <I>muskolo,</I> extensor. <B>~o</B>, <B>~ado</B>, <B>~eco</B>, extension, range, stretch, (➞ <I>spac</I>). <B>~ebla</B>, extensible, etc. <B>~iĝi</B> (<I>ĝis</I>), reach (to), e., expand, run, spread (mus) <B>~ita</B> (<I>disa) harmonio</I>, -ded harmony. <B>Dis~i</B>, open, spread out (<I>la brakojn. krurojn</I>). <B>El~i</B>, reach out to the full. <I>~~i la langon</I>. <B>Tir~i</B>, draw out (<I>elaston</I>). ➞ <I>ampleks, dimensi, pliig, grandig, longig, streĉ</I>.", "0"],
["eterna", "etern-a", "[UV] (<I>ĉiama</I>), <B>1</B> Etern/al, that always has existed and always will exist. <B>2</B> endless, everlasting, unending. <I>~a dormo, neĝo, urbo</I>. <B>3</B> incessant, perpetual. <I>~a demandado</I>. <B>~e</B>, everlastingly. <I>De <B>~e</B>, from</I> time immemorial. <I>De nun kaj ~e</I> (Ps 131/3). <I>Por ~e (senfine</I>), for ever, evermore. <B>~(ec)o</B>, -ity, infinite time, future life. <I>~a ~eco</I> (Da 7/18). <B>~igi</B>, immortalize, perpetuate. La <B>E~ulo</B>, the LORD.", "0"],
["etero", "eter-o", "[UV] ether. <B>1</B> (ph) elastic fluid permeating space. <B>2</B> (chem) airless volatile liquid, <B>f</B> clear sky, upper region beyond clouds. <B>~a</B>, -ial, -ic, airy, light, of unearthly delicacy (➞ <I>delikat, superter</I>). <B>~izi</B> (➞ <I>anestez</I>). <B>Tra~a</B>, celestial, heavenly. ➞ <I>atmosfer, ĉiel, lazur</I>.", "0"],
["etikedo", "etiked-o", "Label, ticket, tag (denotes contents or address). <I>~o gumita</I>, stick-on l. <I>~o vitrina</I>, show-card. <B>~i</B>, to label.", "0"],
["etiketo", "etiket-o", "[OA] etiquette, ceremonial, code of conduct, conventional rules of personal behaviour. <I>Kontraŭ~a</I>, bad form. ➞ <I>bonton, ceremoni, konvenci</I>.", "0"],
["etiko", "etik-o", "[OA] ethics, science of morals, moral principles (rules). <B>~a</B>, ethical. <B>1</B> dealing with questions of right and wrong. <B>2</B> (<I>morale bona) ~a principo, societo</I>. ➞ <I>moral</I>.", "0"],
["etilo", "etil-o", "(chem) Ethyl (C<SUB>2</SUB>H<SUB>5</SUB>). <B>~acetato</B>, e. acetate, acetic ether. <B>~alkoholo</B>, e. alcohol, ethanol. <B>~eno</B>, -ene (C2H4).", "0"],
["etimologio", "etimolog-io", "<B>~o</B>, [OA] etymolog/y, -ist.", "0"],
["etiologio", "etiolog-io", "<B>~o</B>, [OA] etiolog-y, -ist.", "0"],
["Etiopujo, Etiopio", "Etiop-ujo, Etiopio", "[OA-8] ET.", "0"],
["etnografio", "etnograf-io", "<B>~o</B>, [OA] ethnography, -ist.", "0"],
["etnologio", "etnolog-io", "<B>~o</B>, [OA] ethnolog-y, -ist.", "0"],
["etn(ik)a", "", "(<I>rasa</I>), ethnic(al).", "0"],
["etoso", "etos-o", "ethos, charistic atmosphere (nature, spirit). <I>La ~o de grupo, katedralo, popolo, sistemo</I>.", "0"],
["etudo", "etud-o", "study, (art) sketch. <I>~o de kapo, de la nudo</I>. (mus) etude, short composite or exercise. <I>~o koncerta, violona</I>. ➞ <I>ekzerc, studaĵ</I>.", "0"],
["etuzo", "etuz-o", "(bot) fool’s parsley (<I>Aethusa</I>).", "0"],
["eŭfemismo", "eŭfemism-o", "(rh) Euphem/ism, softened expression (Ge 15/15; Jĝ 3/24, Jn 11/11). <B>~a</B>, -istic.", "0"],
["eŭfoniumo", "eŭfonium-o", "(<I>tenora tubjo</I>), euphonium.", "0"],
["eŭforbio", "eŭforbi-o", "Spurge (<I>Euphorbia</I>). <B>Cipresa ~o</B>, Cypress s.", "0"],
["eŭforio", "eŭfori-o", "(<I>sento de bonfarto</I>), euphoria.", "0"],
["eŭfrazio", "eŭfrazi-o", "(bot) eyebright (<I>Euphrasia</I>). <B>eŭgenik-o</B>, eugenics.", "0"],
["eŭkalipto", "eŭkalipt-o", "eucaliptus, jarrah. <I>~aj folioj. ~a esenco</I>.", "0"],
["eŭkaristio", "eŭkaristi-o", "[OA] eucharist, the Lord’s Supper.", "0"],
["eŭmeno", "eŭmen-o", "(ent) potter wasp (<I>Eumenes</I>).", "0"],
["eŭnuko", "eŭnuk-o", "[OA] (<I>kastrito</I>), eunuch (Es 1/10).", "0"],
["eŭpatorio", "eŭpatori-o", "(bot) eupatorium. <B>~o kanaba</B>, hemp agrimony. ➞ <I>ajapan</I>.", "0"],
["eŭrialo", "eŭrial-o", "<B>1</B> (bot) species of water-lily (<I>Euryale,</I> ➞ <I>nimfe</I>). <B>2</B> (zoo) Gorgon’s head.", "0"],
["eŭropio", "eŭropi-o", "(chem) europium (Eu).", "0"],
["eŭtanazio", "eŭtanazi-o", "euthanasia, painless death.", "0"],
["evakui", "evaku-i", "(<I>-n</I>), Evacu/ate (wide sense) 1 (<I>ion) (eligi el</I>): discharge, exhaust, void (from). <I>~i materi-(vapor-)on el. <B>2</B> (malokupi ejon</I>): clear, empty, vacate. <I>ĉambron, domon, lokon, teritorion</I>. 3 (<I>iuri) (forsendi el loko</I>), clear out, evict, withdraw. <I>~i loĝantojn, ŝuldantojn, vunditojn</I>. <B>~iĝi</B>, be -ed. <B>~ito</B>, -ee. ➞ <I>evikt</I>.", "0"],
["evangelio", "evangeli-o", "[OA] Gospel, Evangel. <B>1</B> Christian glad tidings, religious truth. <B>2</B> each of the four gospels in the N.T. <B>~a</B>, <B>1</B> of the gospel. <B>2</B> e-ical, protestant. <B>~ano</B>, <B>~ulo</B>, e-ical, protestant.", "0"],
["evangelismo", "evangel-ismo", "<B>-isto</B>, Evangel-ism, -ist. <B>~izi</B>, -ize (preach the g.).", "0"],
["evento", "event-o", "(<I>okazaĵo</I>), Event, happening, incident, occurrence. <I>~oj de la tago</I>. <B>~oplena</B>, e-ful. <I>La</I> <B>ĉef~o</B> <I>de mia vivo</I>. <B>Sen~a</B>, -less.", "0"],
["eventuala", "eventual-a", "[OA] (<I>eble okazonta</I>), Contingen/t, eventual, liable to (that may) happen (occur) in certain circumstances. <I>~a akcidento, profito. ~a elirejo</I>, emergency exit. <B>~e</B> (<I>en okazo de bezono</I>), if necessary, in case of need, on occasion, should the occasion arise.<I> <B>~e</B></I>, on occasion. <I>~e telegrafu</I>. <B>~(aĵ)o</B> (<I>eblaĵo</I>), -cy, eventuality, possible happening. <I>Por ĉiu ~o,</I> against every emergency. ➞ <I>ebl, hazard, okaz [Ne= fina, rezultanta]</I>.", "0"],
["evidenta", "evident-a", "[OA] (<I>videblega</I>), Evident, obvious (to eye or mind), clear, manifest, plain, unmistakable. <I>~a eraro</I>, obvious mistake, palpable error. <B>~e</B>, -ly, it stands to reason that. <B>~(ec)o</B>, obviousness. <B>~igi</B>, make clear (manifest), serve to show. ➞ <I>cert, klar, okulfrap</I>.", "0"],
["evikti", "evikt-i", "(<I>iun</I>) (a. <I>evikcii</I>), Evict, dispossess (especially tenant from land or house) by legal procedure, eject. <B>~o</B>, -ion. ➞ <I>elpel, evaku</I>.", "0"],
["eviti", "evit-i", "(<I>-n, -i</I>) [UV] (<I>peni ne renkonti</I>), Avoid, restrain one’s (from thing or action), elude, escape from, eschew, evade, give a wide berth to, fight shy of, go round, keep clear (out of the way) of, shirk, shun. <I>~i danĝeron, devon, eraron, homon, kolizion, respondon, servon. ~i frapon</I>, dodge a blow. <I>Mi ne povas ~i tion</I>, I can’t help that. <B>~o</B>, -ance. <I>~ado de malbono</I> (Ij 28/28). ~(em)a (<I>malpreciza, singarda</I>), evasive, cautious, reticent. <I>\"Nu!\" li diris</I> ~e. <B>~ebla</B>, -able. ~enda, to be -ed. <B>~igi</B> (<I>ion al iu</I>), keep (preserve, prevent, save) someone from. <B>Antaŭ~i</B>, anticipate, avert, forestall, stave (ward) off. <B>Mal~i</B> (<I>fronti, spiti</I>), brave, face, (con)front, meet, tackle. <B>Ne~ebla</B> (<I>nepra</I>), inevitable, unable. ➞ <I>cedi lokon al, elturniĝ, forkur, fuĝ, sin gard, sin eltir, sin forsav</I>.", "0"],
["evolu(ci)i", "evolu(ci)-i", "(<I>nt</I>) [OA], (<I>iom post iom malvolviĝi</I>) (opp <I>revoluci</I>), Evol/ve, develop, open out. <B>~(ad)o</B>, -ution, development. <I>Natura ~o. ~o de besto, karaktero, lingvo, teorio</I>, (th) denouement, unfolding (of plot). <B>~ismo</B>, <B>~isto</B>, evolution, -ism, -ist. <B>~ipova</B>, <B>(~iv)a</B>, capable (susceptible) of evolution.", "0"],
["evonimo", "evonim-o", "spindle-tree (<I>Euonymus</I>).", "0"],
["ezofago", "ezofag-o", "[OA] (anat) gullet, aesophagus.", "0"],
["ezoko", "ezok-o", "[UV] (ich) jack, pike (<I>Esox</I>).", "0"],
["fabelo", "fabel-o", "[UV] (ferakonto, mirrakonto), Fairy-tale (-story). <I>~oj de Andersen</I>, <B>f</B> something fictitious. <I>~o por infanoj</I>, nursery tale. <I>~o de maljunaj virinoj</I>. <B>Vintro~o</B>, fireside yarn. <B>~a</B>, <I>fabled, fabulous</I>, <B>f</B> (<I>miriga), ~a propono</I>. <B>~i</B>, tell ff. <B>~aĵo</B>, tosh, nonsense, fisherman’s yarn. <B>~aro</B>, book of ff. ➞ <I>fabl, legend, mit, novel</I>.", "0"],
["fablo", "fabl-o", "[UV] (<I>alegorieto</I>), Fable, animal story with moral. <I>~oj de Ezopo</I>. <B>~a</B>, fabled, of f. <I>~a besto</I>, mythical creature. <B>~i</B>, tell fables. <B>~aro</B>, collection of fables. <B>~isto</B>, fabulist. ➞ <I>alegori, fabel, mit</I>.", "0"],
["fabo", "fab-o", "[UV] <B>1</B> broad Bean (plant or seed) (<I>Vicia faba). ~o kampa</I>, field (horse) b. <B>2</B> gen. name for any b-shaped seed. <B>~acoj</B>, leguminous plants, pulse, <B>~eca</B>, fabaceous. <B>~stango</B>, b-stick. <B>~trunko</B>, b-stalk. ➞ <I>fazeol</I>.", "0"],
["fabriki", "fabrik-i", "[UV] (<I>produkti</I>), Manufactur/e, make, <B>f</B> fabricate, invent, trump up (<I>akuzon, kalumnion</I>); coin, mint (<I>novan vorton</I>). <B>~(ad)o</B>, m., make, production. <B>~a</B> <I>marko</I>, brand, trade mark. <B>~aĵo</B>, -ed article, product; fabrication. <B>~anto</B>, <B>~isto</B>, -er, <B>~ejo</B>, Factory, works. <B>~ejestro</B>, f- owner, etc. <B>~ejano</B>, f-worker. ➞ <I>far, product, uzin</I>, <B>Rim</B>.: Some (and Z.) treat <I>fabrik-</I> as a noun-root, and use <I>fabriko = fabrikejo</I>).", "0"],
["facila", "facil-a", "[UV] Easy (wide sense), Facil/e, Light- <B>1</B> (simple, opposite difficult): <I>~a laboro, lingvo, problemo, tasko, vojo</I>. <B>2</B> light (<I>malpeza): ~a mano, movo, paŝo, plumo, vento</I>. <B>3</B> (<I>neforta, neintensa): ~a dormo, rideto, suspiro</I>. <B>4</B> easy, frail, weak: <I>~a moro, virto</I>. <B>~e</B> [F], lightly, readily, with facility. <I>~e forgesi, pardoni, paroli. <B>~e lernebla</B>, easy to learn. <B>~aĵo</B>, facility, convenience. <B>~eco</B>, ease. <B>(pli)~igi</B>, facilitate, lighten, simplify, <B>f</B> alleviate, ease, mitigate. <I>~~i koron, laboron</I>. <B>~igo</B>, <B>~iĝo</B>, relief, respite, simplification (El 8/15). <B>~anima</B> [F], airy, frivolous, reckless (Jĝ 9/4). <B>~kora</B>, light-hearted. <B>~mova</B>, agile, nimble, quick, spry. <B>~pieda</B>, light-footed. <B>Mal~a</B>, difficult, arduous, hard, knotty, tough, trying. <I>~~e (apenaŭ, pene</I>), with difficulty. <B>~~aĵo</B> (<I>baro</I>), difficulty, obstacle. <B>~~igi</B>, hinder.", "0"],
["faco", "fac-o", "[OA8], Face (wide sense), outer (upper, workg) surface, face (of anvil, clock, disk, hammer); flat (of sword); head (of coin). ➞ <I>front, vizaĝ</I>. <B>~eto</B>, [UV] facet (of crystal, gem, prism). <B>Mult~eta</B> <I>brilianto</I>. <B>~eti</B>, cut (diamonds etc.). ➞ <I>edr, later, surfac</I>.", "0"],
["fadeno", "faden-o", "[UV] Thread, line. <I>~o kotona, lana, lina, ora, silka, ŝpinita, ŝtala. Enkudriligi ~on,</I> t. a needle (➞ <I>tred</I>) <B>Enkonduka ~o</B>, lead-in wire. <B>Fiŝista ~o</B>, angler’s line. <B>metal~o</B> [UV] (<I>drato</I>), wire. <B>Plumba</B>, <B>sonda ~o</B>, plumb-line. <B>Ŝuist~a</B>, <B>vaksit~a ~o</B>, cobbler’s thread. <B>Vel~o</B>, seaming-twine. <B>f</B> <I>~o de ideoj, de parolo, penso</I>, line, train. <B>~aro</B>, <B>~fasko</B>, hank, skein. <B>~eca</B>, <B>~forma</B>, thready, ropy. <B>~ego (</B><I>ŝnuro</I>), string. <B>~eto</B> (➞ <I>fibr, filament</I>), <B>~igi</B>, draw into t. (➞ <I>spin</I>). <B>~igebla</B>, ductile. <B>~isto</B>, <B>=</B> <I>merceristo</I>. <B>~bulo</B>, <B>~volvaĵo</B>, ball of thread. <B>~eltirado</B>, drawn-t work. <B>~omontra</B>, t-bare. <B>Sen~a</B> (<I>sendrata</I>), wireless. <B>Sub~aĵo</B>, warp. <B>Sur~igi</B> (<I>-n</I>), thread, wire. <B>Dis~igi</B>, unravel. ➞ <I>filament</I>.", "0"],
["Faden~o", "", "hank, skein. <B>Fe~o</B> (<I>sorĉistina balailo</I>), witch’s broom. <B>Lum~o</B>, beam of light, pencil of rays. <B>Plum~o</B>, aigret, plume. <B>Stup~o</B>, hank of tow. <B>Spik~o</B>, sheaf. <B>Verg~o</B>, faggot, b. of sticks. <B>~eto</B>, tassel, tuft. <B>~igi</B>, bind, bunch, tie up, truss. ➞ <I>garb, tuf</I>.", "0"],
["fadi", "fad-i", "(cin, rad), Fad/e. <B>~(ad)o</B>, -ing. <I>Flagra ~o</I>, flickering, flashing.", "0"],
["faetono", "faeton-o", "phaeton, light open two-horse carriage. ➞ <I>fiakr, kaleŝ</I>.", "0"],
["fago", "fag-o", "[UV] Beech (tree) (<I>Fagus</I>). <B>Sanga ~o</B>, copper b. <B>~a</B> <I>frukto, nukso</I>, b-mast, b-nut. <B>~aro</B>, <B>~ejo</B>, b-grove.", "0"],
["fagocito", "fagocit-o", "(bio) phagocyte.", "0"],
["fagopiro", "fagopir-o", "buckwheat (<I>Fagopyrum</I>).", "0"],
["fagoto", "fagot-o", "[OA] (m.i.) bassoon. ➞ <I>hoboj, kontrafagot</I>.", "0"],
["fajenco", "fajenc-o", "[UV] china, faience. <B>~aĵo</B>, crockery, stone-ware, etc. ➞ <I>argil, ceramik, delft, kahel, majolik, poreelan</I>.", "0"],
["fajfi", "fajf-i", "(<I>-n, abs</I>), [UV] Whistl/e, pipe. <B>1</B> (with lips or instrument). <I>~i arion. La knabo, lokomotivo, merlo ~is. ~i perfingre</I>. <B>2</B> w., howl, sough, whiz (<I>kuglo, sago, vento</I>). <B>3</B> (<I>mok~i, pri~i</I>) express disapproval, catcall, hiss. <B>~(ad)o</B>, -ing. <B>~ilo</B> [F], w. (wide sense), <I>Danci laŭ ies ~ilo. Alarm~ilo, log~ilo, vapor~ilo</I>. <B>Sak~ilo</B> (better <I>sakŝalmo</I>), bagpipes. <B>~ilego</B>, hooter, siren. ➞ <I>flut, sibl</I>.", "0"],
["fajli", "fajl-i", "(<I>-n</I>), [UV] Fil/e. <B>f</B> (<I>poluri, rafini). ~i poemon</I>. <B>~aĵo</B>, -ings. <B>~ilo</B>, file. <B>~ilo benda</B>, band f; <B>plata</B>, flat f; <B>kvadrata</B>, square f; <B>pintigita</B>, taper f; <B>ronda</B>, round file; <B>triangula</B>, 3-cornered f. <B>Ungo~ilo. Tra~i. fajn-a</B>, fine. <B>1</B> (<I>eteta</I>), in small particles. <I>~a pluvo, pulvoro</I>. <B>2</B> dainty, delicate, slender, thin. <I>~a distingo, kaligrafio, plumo, streko</I>. ➞ <I>delikat, malgrander</I>.", "0"],
["fajro", "fajr-o", "[UV] Fir/e. <I>Ekbruligi, estingi, fari ~on</I>. <B>f</B> <I>~o de ardo, entuziasmo, kolero, pasio</I>. <B>Elma ~o</B>, St Elmone’s fire. <B>Ĝoj~o</B>, bonfire. <B>Signal~o</B>, <B>Tend~o</B>, camp-f. <B>~a</B>, fiery, passionate. <I>~a ardo, brilo, deziro, karbo, koloro, rigardo, okulo</I>. <B>~e</B> <I>ami, paroli</I>. <B>~i</B> (nt), burn, flame. <B>~aĵo</B>, -ing, fuel. <I>Arta ~aĵo,</I> f-work. <B>Krak~o</B>, <B>salt~aĵo</B>, cracker. <B>Serpent~aĵo</B>, serpent. <B>Turn~aĵo</B>, Catherine wheel. <B>~ejo</B>, -place, hearth. <B>~ero</B> [F], spark. <B>~(far)ilo</B>, lighter. <B>~ujo</B>, -box, brazier, grate (Jes 30/14). <B>~breto</B>, <B>~plato</B>, hob. <B>~devena</B>, igneous. <B>~imuna</B>, <B>~rezista</B>, fireproof. <B>~gardilo</B>, -guard. <B>~prenilo</B>, tongs. <B>~ŝtalo</B>, flint-steel, tinder-box. ➞ <I>ard, brul, entuziasm, flam; alarm, brigad</I>.", "0"],
["fakiro", "fakir-o", "[OA] fakir. ➞ <I>derviŝ</I>.", "0"],
["fako", "fak-o", "[UV] Compartment, Department (<I>agada, metia</I>); competence, district, domain, line, province, speciality, sphere, subject. <I>Divers~a komerco. (kofra, ŝranka</I>) division, section, shelf; (<I>fenestra, porda</I>) panel; (<I>organiza</I>) branch, bureau; (chs) square. <B>Poŝt~o</B>, <B>P.O</B>. Box. <B>~a</B>, d-al, sectional, technical, specialist. <I>~a gazeto, societo</I>. <B>~aro</B>, nest of drawers, pigeonholes, rack. <B>~eto</B>, box (of type-case). <B>(En)~igi</B>, divide into cc (dd), file. <B>~isto</B>, <B>~ulo</B>, expert, specialist (➞ <I>ekspert, kompetent, special, spertul</I>). <B>~esprimo</B>, tech. expression. <B>Mult~a</B>, complex. <B>Ne~a</B>, non-specialist, unskilled. ➞ <I>klas, kupe rubrik, sekci, specialaĵ, teritori</I>.", "0"],
["fakoĉero", "fakoĉer-o", "(<I>veruka apro</I>), wart-hog (<I>Phacocherus</I>). ➞ <I>apr</I>.", "0"],
["faksimilo", "faksimil-o", "[OA] facsimile. exact copy, e.g., of painting, picture, writing. ➞ <I>duplikat, kopi</I>.", "0"],
["faktitivo", "faktitiv-o", "(gram) factitive, causative, e.g., <I>ig</I>.", "0"],
["fakto", "fakt-o", "[OA] fact, thing certainly known to be true, or have occurred. <I>~o historia. Jama ~o, fait accompli</I>. <B>~oj</B> <I>donitaj,</I> data. <B>~a</B>, factual, actual, based on fact, <I>de facto</I>. <B>~e</B>, actually, in (as a) fact. <I>Dum <B>~e</B></I>, whereas. ➞ <I>efektiv, real</I>.", "0"],
["faktorialo", "faktorial-o", "(mat) factorial.", "0"],
["faktoro", "faktor-o", "[OA] Factor. <B>1</B> (mat) ➞ <I>koefi- cient</I>. <B>2</B> something contributing to a result. <I>~o de sukceso</I>. <B>3</B> (rad) <I>~o amplifa, potenca, transforma</I>. <B>4</B> (com) agent.", "0"],
["fakturo", "faktur-o", "[UV] Invoice. <I>~o prova</I>, pro forma invoice. <B>~i</B>, to invoice.", "0"],
["fakultativa", "fakultativ-a", "(<I>libervola, nedeviga</I>), optional, permissive.", "0"],
["fakultato", "fakultat-o", "[OA] (<I>fako, profesoraro</I>), faculty (law, letters, medicine, etc.). <I>~o jura, medicina, scienca</I>. <B>~estro</B>, dean of faculty.", "0"],
["falangio", "falangi-o", "&lt; harvestman spider (<I>Phalangium</I>).", "0"],
["falango", "falang-o", "[OA] phalanx. <B>1</B> fighting line. <B>2</B> finger-bone, toe-bone</I>.", "0"],
["falaro", "falar-o", "reed-grass (<I>Phalaris). ~o</I> <B>kanaria</B>, = canary grass. <I>P. arundinacea</I> is the ribbon grass (lady’s garters) of the garden.", "0"],
["falaropo", "falarop-o", "(orn) phalarope (<I>Phalaropus</I>). <B>Arkta ~o</B>, grey phalarope.", "0"],
["falbalo", "falbal-o", "[UV] flounce, pleated trimming; frill, furbelow. <B>~i</B>, trim with flounces. <I>~a jupo,</I> flounced skirt.", "0"],
["falĉi", "falĉ-i", "(<I>-n</I>), [UV] mow, reap, cut (grass etc.). <I>~i greson, grenon</I>. <B>f</B> <I>La morto ~as homajn vivojn</I>. <B>~iĝi (Ps</B> 102/4). <B>~ilo</B> [UV] scythe. <I>~ilforma</I>, falcate, sickle-shaped. <B>~ileto</B> (<I>rikoltilo</I>), reaping hook. <B>~isto</B>, mower, reaper. <B>~maŝino</B>, mowing machine, reaping machine, grass-cutter. <I>~a strio</I>, swath. <B>Pri~i</B> <I>kampon</I>. ➞ <I>serp, tond</I>.", "0"],
["faldi", "fald-i", "(<I>-n</I>), [UV] Fold, double, lay one pt over another. <I>~i ĵurnalon, leteron, tukon, veston. ~ita</I> (turned-up) <I>maniko. ~i duonige</I>. <B>~o</B><I>,</I> f. ripple (of water). ~e <I>levita</I> (turn-up) <I>pantalono. ~e kunligita robo</I> (Alt 7/5) <B>~eto</B> (a. <I>falto</I>), crease, pucker, wrinkle. <B>~ilo</B>, -er. <B>-umi</B> (a. <I>plisi</I>), pleat, (mec) <B>Kun~i</B>, fold together, welt. <B>Mal~i</B>. (➞ <I>malvolv</I>), spread out, unfold, unfurl. <B>Re~i</B>, fold back. <B>~~o</B>, reverse, turned-back edge, lapel. <B>Du~o</B>, pleat (<I>ekstera, interna</I>), <B>Kol-o</B>, dewlap, double chin, wattle. <B>Supren-i</B>, turn up (hat-brim), etc. (2 FA 60/17). ➞ <I>af, fold, imbrik, krisp, kunmet, sulkig</I>.", "0"],
["faleno", "falen-o", "<B>1</B> (ordinary language) Moth in gen. <B>2</B> (ent) Gothic m. (<I>Phalaena</I>). ➞ <I>lepidopter, tine</I>.", "0"],
["fali", "fal-i", "(nt), [UV] fall (wide sense). <B>1</B> drop, tumble down. <I>Ĝi ~is el mia mano. La folio, kurteno, muro, neĝo ~is. ~i en riveron, sub la radojn</I> [F]. <I>Lasu ~i</I> (drop, let fall), <I>vazon, la manojn. ~i dorsen, teren</I> (Jes 28/13). <B>2</B> go down diminish, lose position, sink, subside. <I>La akvo, barometro, febro, prezo ~is</I>. <B>f</B> <I>Lia vizaĝo (la melodio) ~is</I>. <B>3</B> (<I>morti): de glavo</I> (by the sword), <I>en batalo, sur la batalkampo</I>. <B>4</B> (<I>fiaski</I>): break down, collapse, have a fall. <I>La imperio, movado, registaro, teorio ~is</I>. <B>5</B> come, go (into a position). <I>La dormo, nokto ~as. ~i en danĝeron, mediton. (trafi): La devo, elekto, loto, lumo, malbono ~is sur min</I>. <B>f</B> <I>~i en la manojn (okulojn</I>). <B>~o</B>, fall, drop, tumble. <I>La ~o de Adam</I> (Ge 3), <I>de Jeriĥo</I> (Jos 6). <B>Akvo~o</B>, waterfall (➞ <I>kaskad</I>). <B>Ter~o</B>, caving in, landslide, <B>~egi</B>, crash down (➞ <I>kraŝ</I>), <B>~ema</B>, rickety, unsteady. <B>~eti</B> [UV] slip, stumble, trip (➞ <I>stumbl</I>). <B>~igi</B>, fell, lay low, knock down. <I>~~i arbon</I>. <B>~ilo</B> (<I>kaptilo</I>), catch, snare, stumbling-block, trick (Ij 18/10). <B>De~i, for~i</B>, fall away (from, off) e.g., <I>frukto de arbo</I>. <B>f</B> <B>De~o</B>, rebellion, sedition (Ne 6/6, Ez 4/19). <B>Kia de~o!</B> What a downfall! (<I>de)~i de instruo, virto. ~inta virino</I>. <B>Dis~i</B> [F] (<I>ruiniĝi</I>), fall to pieces, break up (down). <B>~~i</B> <I>en dialektojn</I>. <B>~~o</B> <I>de grupo</I>. <B>El~i</B> [F] (<I>dento</I>). <B>En~i</B> [F], fall into (<I>kavon, mizeron</I>). <I>Kun en~intaj okuloj</I> (hollow-eyed), <I>vangoj</I> (haggard). <B>Kun~i</B>, (<I>koincidi</I>). <B>Re~i</B>, relapse, etc. <B>Sub~i</B>, subside. <B>Super~i</B> (Ij 27/20). <B>Rul~i</B>, topple over, tumble head over heels. ➞ <I>atavism, fiask, malalt, mallev, malsupr, pane, sink</I>.", "0"],
["falko", "falk-o", "[UV] Falcon (<I>Falco</I>). <B>Kolomba ~o</B>, merlin. <B>Pilgrima ~o</B>, peregrine f. <B>Vesper ~o</B>, red-footed f. <B>~ado</B>, -ry. <B>~isto</B>, -er. ➞ <I>girfalk, lanari, niz, subute, tinunkol</I>.", "0"],
["falseto", "falset-o", "falsetto, \"head voice\", as of male alto.", "0"],
["falsi", "fals-i", "(<I>-n</I>), [UV] falsify, debase, counterfeit, tamper with, cook, fraudulently alter (<I>konton), forge (monon, skribori). ~i (adulterate) vinon, load (ĵetkubojn), mark (kartojn), misrepresent (faktojn) ~ita dokumento</I>. <B>~a</B> (<I>neaŭtenta), counterfeit, false, forged, insincere, sham, spurious. ~a atestanto (Se 19/9). ~a alarmo, dentaro, diamanto, fundo, kalkulo, pretendo, situacio, starto. ~a akuŝo, false pains. ~a mono, spurious coins. ~a nomo,</I> alias<I>. ~a nolo,</I> wrong note. <I>Kanti, ludi</I> <B>~e</B> (mis-sub-super-pice), sing (play) out of tune. <B>~aĵo</B>, counterfeit, forgery, imitation, sham. <I>Enmeti ~aĵon,</I> adulterate. <B>~emo</B> (Se 4/24), (<I>➞ hipokrit, jezuit, malsincer</I>). <B>~into</B>, <B>~isto</B>, <B>~ulo</B>, cheat, double-dealer forger, sharper. <B>Mon~isto</B>, coiner. <B>Vin~isto</B>. ➞ <I>fraŭd, malver, mis</I>.", "0"],
["falto", "falt-o", "(<I>faldeto, sulketo</I>), crease, pucker, ruck, wrinkle; line (on hand). <B>~iĝi</B>, become lined, (nwk) <B>pint~eto</B>, close gather, pin- tuck, tiny pleat. <B>~arigo</B>, smocking. ➞ <I>plis</I>.", "0"],
["familiara", "familiar-a", "[OA] (<I>intime senceremonia</I>), Familiar, extremely friendly, free, intimate, unceremonious, unconstrained. <I>~a esprimo, gesto, stilo, tono. Esti ~a kun</I>, be on familiar terms (hobnob) with. <I>Paroli kun iu</I> <B>~e. ~aĵo</B>, -ity, liberty. <B>~eco</B>, absence of ceremony. <B>Mal~a</B>, formal, reserved, starchy, stiff. <I>Esti</I> <B>tro~a</B> (<B>~aĉa</B>), be brazen, cheeky, impudent, over-free, pert; take liberties with. ➞ <I>senĝen. [Ne= bone konata.]</I>", "0"],
["familio", "famili-o", "[UV] Family. X (parents with children): <I>Vivi en ~o</I>. <B>2</B> (<I>domo, gento</I>): house, lineage. <I>Nobela ~o</I>. <B>3</B> (<I>idaro</I>): (Ps 113/9). <B>4</B> (<I>lingvo): ~o Hindeŭropa, Slava. Vort~o</I>. <B>5</B> (bot <I>= -ac, zool = -ed</I>), <B>f</B> (in classification). <I>~o de rozacoj (cervedoj</I>). <B>~a</B> <I>afero, domo, nomo, portreto, rondo, simio, leco, vivo</I>. <B>~a ĉambro</B>, living-room. <B>~ano</B>, member of the f. <B>~eca</B> (<I>hejmeca, intima</I>). <B>~ejo</B>, homestead. <B>~estro</B>, head of the f. (Jos 21/1). <B>~ulo</B>, f. man. <B>Ekster~a</B>, outside the f. <B>Sam~ano</B>. ➞ <I>dom, anar, gent, parenc</I>.", "0"],
["famo", "fam-o", "[UV] Fam/e (wide sense). <B>1</B> (<I>onidiro</I>): hearsay, report, rumour. <I>Disvastigi ~on. La ~o kuras, ke</I>. ... <B>2</B> (<I>renomo, reputacio</I>): character, repute, reputation, standing. <I>Havi (mal)bonan ~on</I>. <B>3</B> (<I>gloro</I>): fame, distinction, glory, honour. <B>(Mond)~a</B>, -ous, well-known. <B>~e konata (~ega)</B>, celebrated, illustrious, renowned. <B>~i</B>, be famous. <B>~igi</B>, make -ous, <B>~ulo</B>, celebrity, man of note. <B>~brilo</B>, prestige. <B>Bon~a</B>, of good repute. <B>Malbon~a</B>, infamous, ill-famed, notorious, of ill repute. <B>Sen~a</B>, inglorious, obscure. ➞ <I>glor, eminent, klaĉ, opini, prestiĝ</I>.", "0"],
["fanatika", "fanatik-a", "[OA] (<I>blinde fervora</I>), Fanatic/al, filled with excessive enthusiasm, stubborn. <B>~(ec)o</B>, -ism. <B>~ulo</B>, f. ➞ <I>bigot, dogm, fervoraĉ, obstinaĉ, zelot</I>.", "0"],
["fandango", "fandang-o", "fandango, lively Spanish dee.", "0"],
["fandi", "fand-i", "(<I>-n</I>), [UV] <B>1</B> (s)melt by heat, blend, fuse, liquify. <I>~i buter-(glaci-metal-neĝ -vaks-)on. <B>2</B> (~fari</I>), cast, founder, make by smelting. <I>~i sonorilon, statuon. ~ita bovo</I>. <B>~(ad)o</B>, casting. <B>~(it)aĵo</B>, casting, ingot, molten image, etc. <B>~ebla</B>, fusible. <B>~ejo</B>, foundry. <I>Vitro~ejo</I>, glass-works. <B>~iĝi</B>, melt (nt), become molten,^ dissolve, fuse, run, ➞ <I>degel, solviĝ</I>, <B>f</B> <I>Sia koro ~iĝis de kompato. (malaperi kuniĝante): la nuboj ~iĝis kun la horizonto</I>. <B>~isto</B>, smelter. <B>Fer~isto</B> (<I>gisisto</I>), iron-founder. <B>Liter~ ~isto</B>, type-founder. <B>~uj(~forn~vaz)o</B>, smeltg-pot, crucible (a. <I>krizolo</I>). <B>~odrato</B>, <B>~fadeno</B>, fuse wire. <B>~fornego</B>. blast furnace. <B>~punkto</B>, point of fusion. <B>~restaĵo</B> (<I>skorio</I>), <B>~verŝi</B> (<I>gisi</I>), cast, pour in mould, <B>f For~i</B>, disperse, dissolve (<I>antaŭjuĝojri</I>). <B>Kun~aĵo</B>, alloy (➞ <I>aloj</I>). <B>Kun~igi</B>, coalesce, mingle.", "0"],
["fanerogamo", "fanerogam-o", "(bot) phanerogam. ➞ <I>kriptogram</I>.", "0"],
["fanfaro", "fanfar-o", "[OA] (mus) fanfare, flourish, gay passage for brass (Jes 58/1).", "0"],
["fanfaroni", "fanfaron-i", "(nt) (<I>ke, pri, kontraŭ; abs</I>), [UV] Boast, bluster, brag, give one’s airs about, flaunt, make a parade of, plume one’s on, swagger, talk big (Jes 30/7). <B>~a</B>, boastful, vainglorious. <B>~(ad)o</B>, -ing, arrogant talk, braggadocio, fanfaronade. <I>~adi</I> (Ce 2/8). <B>~eco</B> (<I>bombasto</I>), -fulness. <B>~ulo</B>, -er, braggart, swashbuckler. ➞ <I>fier, parad, pav, sin glori</I>.", "0"],
["fantasmagorio", "fantasmagori-o", "phantasmagoria, dissolvg view.", "0"],
["fantasta", "fantast-a", "fantastic, eerie, extravagantly fanciful, grotesque.", "0"],
["fantazio", "fantazi-o", "[OA] Fanc/y. <B>1</B> fantasy, mental image, whimsical flight of imagination. <B>2</B> (mus) fantasia. <B>~a</B>, -y, -iful (<I>imagoplena</I>): full of imagination. (<I>kaprica</I>): capricious. <I>~a prezo. (imagita, nereala</I>): shadowy, un-real(-substantial). <B>~i</B>, let one’s f. run freely, indulge in dreams (-ies, whims), (mus) improvise. <B>~aĵo</B>, -y, freak, whimsey, <B>~eca</B>, <B>~oplena</B>, imaginative. <B>~ulo</B>, dreamer, crank, visionary. <B>Sen~a</B>, cold, matter of fact, prosaic (➞ <I>proz, sobr</I>). ➞ <I>bizar, delir, fantom, imag, kapric, iluzi, rev, utopi</I>.", "0"],
["fanto", "fant-o", "(cgm) jack, knave.", "0"],
["fantomo", "fantom-o", "[UV] Ghost, apparition, phantom, spectre, spirit, spook, wraith. <I>~o de mortinto</I>. <B>f</B> mental illusion, unreal appearance; dummy (cgm). <B>~a</B>, -ly, spectral, <I>~a aperaĵo</I>. <B>f</B> illusive, imaginary. ~(vizit)i haunt (a. /ian?i).~rakonto, g-story. ~ŝipo. ➞ <I>aperaf, iluzi, ombr, reaperant, spirit, vizi</I>.", "0"],
["farado", "farad-o", "(el) farad. <B>~izi</B>, -ize. <B>~ismo</B>, -ism.", "0"],
["farandolo", "farandol-o", "farandole (Spanish dee),", "0"],
["farao", "fara-o", "faro (cgm).", "1"],
["faraono", "faraon-o", "pharaoh.", "0"],
["farbo", "farb-o", "[OA8], Colour(ing matter), Paint, pigment. <B>Akva ~o</B>, water-c. <B>Fon~o</B>, ground-coat, under-coat. <B>Kalk~o</B>. lime wash. <B>Lak~o</B>, lacquer. <B>Pistol~i</B>, spray. <I>~~ilo</I>, p-sprayer, spray diffuser. <B>~i</B> (<I>-n) (kolorigi</I>), <B>2</B> FA 4/33 c., p. <I>Ruĝe ~ita domo</I>. <B>~isto</B>, c-dealer. <B>~sitelo</B>, painter’s kettle. <B>~skatolo</B>, p-box. <B>~tavolo</B>, coat(ing). ➞ <I>akvarel, pentr, ŝmink</I>.", "0"],
["farĉo", "farĉ-o", "(cul) Stuff/ing, forcemeat, minced seasong (of meat, vegetables, or fruit). <B>~i</B>, stuff. <I>kokinon</I>. <B>f</B> cram. ~i <I>parolon per spritaĵoj; infanon per bombonoj (latino</I>).", "0"],
["fari", "far-i", "(<I>-n</I>), [UV] do, make. <B>1</B> Perform an action (~i <I>atakon = ataki): ~i decidon, distingon, eraron, escepton, komplezon, konfeson, peton, promeson, servon; (alpreni) decidon; (elt iri) konkludon; (liveri) impreson, juĝon; (proponi) demandon</I>. <B>2</B> (<I>plenumi</I>): Do. <I>~i aferon, devon, taskon. Kion ~i?</I> What is to be done? can one do? <B>3</B> (abs) (<I>agi</I>): Act. <I>Ne parolu, sed ~u</I>. <B>4</B> (<I>estigi, formi, krei, produkti</I>): Make (create, form, produce): <I>~i (mal)bonon, fajron, ordon, rondon, tablon, vojon</I>. <I>2 + 2 ~as 4. Du botoj ~as paron</I>. <B>5</B> (<I>komponi, verki): ~i poemon, romanon, tradukon, verkon</I>. <B>6</B> (<I>igi</I>): Make (cause to be): <I>~i iun ĝoja (estro</I>). <B>~o</B>, act(ion). <I>Ĉe la</I> <B>~o</B> <I>mem</I>, caught in the act, red-handed. <I>Pli da bruo ol da ~o</I>. <B>~e de</B> (= <I>farita de) la uzo de Esperanto fare de la registaro</I>. <B>~aĉi</B>, botch, scamp. <I>~aĉe</I>, slipshod. <B>Vers</B><I>~</I><B>ado</B>, versification. <I>Vort~ado</I>, word-formation. <B>~(it)aĵo</B>, deed, exploit, something done, <B>~ebla</B>, feasible, possible, practicable. <I>Mon~</I><B>ejo</B>, mint. <B>~enda</B>, to (that must) be done (made). <B>~igi</B>, [UV] <B>1</B> be done (made): <I>La laboro ~iĝis. ~iĝi reĝo</I>. <B>2</B> (<I>okazi</I>), come to pass, happen, take place: <I>~iĝis lumo</I> (Ge 1/3). <B>3</B> (early writings) (<I> = iĝi</I>). become, get. <I>~iĝi fama. ~iĝo</I>, event, happening. <B>~inda</B>, worth doing. <I>Jam</I> <B>~ita</B>, ready-made. <B>Al~i</B> (<I>adapti</I>), adapt, fit, suit. <B>El~i</B> (<I>plenumi, efektivigi</I>): accomplish, achieve, execute. <B>Mal-i</B>, undo. <B>Mis~o</B>, misdeed. <B>Ne~ebla</B>, impossible, impracticable. <B>Re~i</B>, do again, remake, repeat, restore. <I>~~i la mapon de Azio</I>. <I><B>Sen~a</B>, inactive</I>. <I>Vivi sen~e</I>. <I><B>Tra~i</B> al si vojon, make one’s way through (4 FA 29/29) <B>(Mal)bon~anto</B>, benefactor, malefactor</I>. <I>~~emo, charity. <B>Ĉio~anto</B>, factotum, man of all work. <B>Man~ita</B>, hand-made. <B>Mem~ita</B>, self-made, <B>Nenio~ado</B>, idleness, inactivity. ➞ ag, estig, fabrik</I>.", "0"],
["faringo", "faring-o", "[UV] Pharyn/x. <B>~ito</B>, -gitis. <B>~oskopo</B>, -goscope. ➞ <I>ezofag, faŭk, gorĝ, laring</I>.", "0"],
["fariseo", "farise-o", "Pharis/ee. <B>1</B> member of ancient Jewish sect. <B>2</B> formalist, self-righteous person. <B>~a</B> (<I>piafekta, hipokrita</I>), -aic. <B>~eco</B>, <B>~ismo</B>, -aism.", "0"],
["farmacio", "farmaci-o", "[OA] Pharmac/eutics, dispensing. <B>~a</B>, -eutical. <B>~aĵo</B> (<I>medikamento</I>) -eutical preparation. <B>-ejo</B> (<I>apoteko</I>), -y, dispensary, druggist’s shop, <B>-isto</B> (<I>apotekisto</I>), chemist. ➞ <I>ĥemi</I>.", "0"],
["farmakologio", "farmako/log-io", "<B>~o</B>, pharmaco/log-y, -ist.", "0"],
["farmakopeo", "farmakope-o", "pharmacopoeia (<I>drog-aro-listo</I>).", "0"],
["farmi", "farm-i", "(<I>-n</I>), [UV] Farm. <B>1</B> (take on, hold under) Lease. <I>ter(pec)on</I>. 2 (<I>prilabori</I>) cultivate and work on it. <B>~anto</B>, <B>~isto</B>, tenant f-er. <B>~ejo</B>, <B>~bieno</B>, f. <B>~igi (-doni)</B>, f. out, let on 1. <B>~domo</B>, f-house, f-stead. <B>-korto</B>. ➞ <I>ekspluat, kultiv, lupren</I>.", "0"],
["farso", "fars-o", "[OA] Farc/e. <B>f</B> absurdly futile proceeding. <B>~a</B> -ical. <B>~isto</B>, buffoon. <B>~ulo</B>, joker, etc.", "0"],
["farti", "fart-i", "(nt), [UV] (<I>sanstati</I>), be (in good or bad health), do, fare, feel, get on. <I>Kiel vi ~as?</I> How do you do? How are you? <B>-u</B> <I>bone!</I> Your good health! <B>~o</B>, [UV] condition, state of health (Ge 43/27, Es 2/11). <B>Bon~a</B>, all right, in good health, well (Da 4/4). <I>Bon~o (sano</I>), well-being, welfare. ➞ <I>est, san, stat</I> (Vd BE 1952, p. 129).", "0"],
["faruno", "farun-o", "[UV] (<I>grenmuelaĵo</I>), Flour, Meal. <I>~o avena, hordea, tritika, sinapa</I>. <B>Linsema ~o</B>, linseed-m. <B>Piz~o</B>, pea-f. <B>Riz~o</B>, ground rice. <B>~aĵo</B>, gruel, pap, paste. <B>~(ec)a</B>, farinaceous, f-y, m-y. <B>~ejo</B>, f-mill. <B>~vermo</B>, m-worm (larva of <I>tenebrio molitor</I>). ➞ <I>bul, glu, pudr, pulvor</I>.", "0"],
["fasado", "fasad-o", "[OA] facade, face of building, front (age), <B>f</B> outward appearance. ➞ <I>front</I>.", "0"],
["fascini", "fascin-i", "Fascinate, enchant. ➞ <I>ĉarm, sort</I>.", "0"],
["fasciolo", "fasciol-o", "liver fluke, fluke worm (<I>Fas- ciola</I>).", "0"],
["fasĉino", "fasĉin-o", "(<I>branĉfasko</I>) (bid, mil) fascine. <B>~aro</B>, (<I>branĉremparo</I>). ➞ <I>brant, hurd, gabi</I>.", "0"],
["fasko", "fask-o", "[UV] bundle, bunch, cluster, handful, sheaf, stack, truss, etc. <I>~o de brandoj, floroj, haroj, pafiloj, rafanoj, rubandoj, da hisopo</I> (El 12/22); <I>de mirho</I> (Alt 1/13).", "0"],
["fasmo", "fasm-o", "Stick-insect (<I>Phasma). Folia ~o,</I> leaf-insect. ➞ <I>akrid</I>.", "0"],
["fasono", "fason-o", "[UV] cut, fashion, make, model, pattern, shape (of garment etc.). <I>~o eleganta, moda, nova, Pariza</I>. <B>~i</B> (<I>-n</I>), fashion, fit, make to measure. <I>~ita vesto,</I> tailor-made. ➞ <I>altranĉ, form, mod, tajl</I>.", "0"],
["fasti", "fast-i", "(nt), [UV] Fast, abstain from <B>1</B> food, <B>2</B> (rel) certain foods. <B>~(ad)o</B>, fast(ing). <I>Granda ~o</I>, Lent. <I>Por riĉulo ~o, por malriĉulo festeno</I>. <B>~otago</B>, f-day (Ze 8/19).", "0"],
["faŝismo", "", "<B>faŝisto</B>, (pol) fascism, fascist.", "0"],
["fatala", "fatal-a", "Fatal. <B>1</B> of fate, fated, inevitable, sure to happen. <B>2</B> disastrous, ruinous. <I>~a hor-(pasi-)o;</I> deadly, sure to kill. <I>~a dozo</I>. <B>~e</B>, -ly, inevitably. <B>~aĵo</B>, -ity, calamity, death. <B>~eco</B>, -ity, f. influence. <B>~ismo</B>, <B>~isto</B>, -ism, -ist (➞ <I>determinism</I>). <B>~oplena</B>, accursed, fateful, fraught with misfortune. ➞ <I>destin, katastrof, mortig, plag, sort</I>.", "0"],
["fato", "fat-o", "fate, destiny, appointed lot, ultimate condition. <I>Regas la ~o tirana</I>. La <B>~oj</B>, the Fates. ➞ <I>kismet</I>.", "0"],
["fatraso", "fatras-o", "(<I>aĉajaro</I>), jumble, junk, litter, rubbish, trash.", "0"],
["faŭko", "faŭk-o", "[UV] <B>1</B> jaws (de leono). <B>2</B> entrance, aperture, mouth (<I>de kanono, kaverno, tunelo. ~o de la maro, morto</I>. <B>3</B> (<I>abismo, glutejo, senfundejo</I>), gorge, gulf, pit, vortex, yawning abyss (Jes 5/14). <B>~i</B> (nt) gape (yawn) open. <I>La groto ~is</I>. ➞ <I>bus, fendeg, makzel</I>.", "0"],
["faŭli", "faŭl-i", "<B>~o</B>, (sp) foul.", "0"],
["faŭno", "faŭn-o", "<B>1</B> (myth) faun. <B>2</B> (<I>regiona bestaro</I>), fauna, animal life.", "0"],
["favo", "fav-o", "[UV] (med) favus, contagious depilatory skin disease caused by a fungus (e.g., <I>akorio</I>) occuring on human head, and causing scabs &gt; ringworm (Le 13/30). <B>1T</B> In technical language ringworm~<I>~ tinio. ~o besta</I>. <B>~a</B>, scabby, verminous. <I>~a krusto</I>. <B>f ~ulo</B>, scurvy rascal.", "0"],
["favoro", "favor-o", "[UV] Favour, generous treatment, goodwill, kindness, <I>Akiri (trovi) ~on (ĉe</I>), find f. (in the sight of), come into vogue. <I>Serĉi ~on</I>, court f. <B>~a</B> (<I>al, por</I>), <B>1</B> (<I>bonvola, indulga, inklina</I>): -able to, -ing, friendly, well-disposed. <I>~a impres-(opini-)o. Dio estu al vi -a</I>. <B>2</B> advantageous, auspic- (propit-)ious, fair, promising. <I>~a cirkonstanco, vetero, vento. Person~a</I>, partial. <B>~e</B>, -ably, with f. <I>Parolu -e por mi. ~e al,</I> in f. of. <B>~i (-n</B>, <I>al) (agi ~e</I>) f., befriend, be partial to, encourage, patronize. <I>~i iun per mendo. ~ita de la sorto, per beta vetero</I>. <B>~aĵo</B> (<I>~faro</I>), f., concession, kindness, privilege. <B>~anto</B>, patron (➞ <I>mecen</I>). <B>~ato</B>, <B>~ito</B>, -ite, preferred person. ➞ <I>preferata, plej amata. ŝatata</I>. <B>~emo</B>, -itism, partiality. <B>~igi</B> <I>al si</I>, win over, gain f. with, get into the good graces (of). <B>~ismo</B>, -itism. ~tagoj, days of grace. <B>Mal~a</B> (<I>kontraŭ</I>) un-able, adverse, contrary, opposed to. ~<B>~o</B>, dis-grace(-favour). <B>Kor~i</B> (Ps 135/14), deal kindly with, be gracious to. <I>Dio vin ~~u!</I> ➞ <I>grac, interes, komplez, prefer</I>.", "0"],
["fazano", "fazan-o", "[UV] Pheasant (<I>Phasianus), Ora ~o</I>, golden p. <B>~ejo. ~ido. ~ino</B>, hen p. <B>Vir~o</B>, cock pheasant.", "0"],
["fazeolo", "fazeol-o", "[OA] (kidney) Bean, haricot (<I>Phaseolus</I><B>). ~o granda</B>, butter (Lima) b. (<I>P. limensis</I>). <B>~o multekolora</B>, runner b., scarlet runner, <B>-o verda</B>, French or dwarf b. ➞ <I>fab</I>.", "0"],
["fazo", "faz-o", "[OA] phase. <B>1</B> stage of development or sequence, period, ➞ <I>stadi</I>. <I>~o de evoluo, de malsano, de milito</I>. <I>Du~a, tri~a, unu~a</I>. (rad) <I>~angulo</I>, <I>~diferenco</I>, <I>~rapido</I>. <B>2</B> (astr) aspect of illumination. <I>~o de luno, planedo</I>.", "0"],
["febla", "", "= malforta.", "0"],
["febro", "febr-o", "[UV] Fever. <B>1</B> (med) <I>~o cerb- (intermit-)a</I>. <B>Akuta ~o</B>, high f. <B>Fojn~o</B> (<I>fojnastmo</I>), hay f. <B>Flava ~o</B>, yellow-f. <B>Intesta ~o</B>, gastric(enteric) f. <B>Marĉa ~o</B> (<I>malario</I>). <B>Trem~o</B>, ague. <B>Vund~o</B>, traumatic f. <B>f</B> (<I>forta ekscito, pasia ardo). ~o ama, politika</I>. <B>~i</B> (<I>havi ~on</I>), be -ish, have a high temperature. <B>~(ec)a</B>, -ish. <B>f</B> (<I>arda): ~a deziro, laboro, penado</I>. <B>~eto</B>, mild f. <B>~ulejo</B>, f-hospital. <B>Kontraŭ~a</B>, <B>Sen-igilo</B>, febrifuge.", "0"],
["Februaro", "Februar-o", "[UV] February.", "0"],
["feĉo", "feĉ-o", "[UV] (<I>surfundaĵo</I>), dregs, grounds, lees, sediment. <I>Bier~o</I>, barm. <I>~o de kaf- (vin-)o</I> (Ps 75/8). <B>f</B> refuse, scum. <I>~o de la popolo</I>. ➞ <I>rekrement, sediment</I>.", "0"],
["federacio", "federaci-o", "[OA] = feder(aĵ)o.", "0"],
["federi", "feder-i", "(<I>-n</I>) [OA8], Feder/ate. <B>~(ad) (aĵ) (iĝ)o</B>, -ation. <B>~a</B>, -al. <B>~ismo</B>, <B>~isto</B>, federalism, federalist. <B>Kun~aĵo</B>, confederation. <I><B>~~</B></I><B>ito</B>, confederate. ➞ <I>alianc, asoci, kartel</I>.", "0"],
["feki", "fek-i", "(<I>elpuriĝi</I>), (med) Defecate. <B>~(ad)o</B>, -ion, stool. <B>Muŝ~o</B>, fly-dirt. ➞ <I>ekskrement, kot, sterk</I>.", "0"],
["fekunda", "fekund-a", "(<I>fruktema, multnaska, naskema</I>), Fruitful, fertile, prolific. <I>~a ĝardeno, tero, virino</I>. ~a <I>aŭtoro, ideo, imago, verkisto</I>. <B>~eco</B>, -ness, fecundity, fertility. <B>~igi</B>, make f., fertilize (teron per sterko). <B>Mal~a</B>, <B>Ne~a</B>, (<I>senfrukta, sterila</I>), barren.", "0"],
["feldspato", "feldspat-o", "(min) fel(d)spar. ➞ <I>spat</I>.", "0"],
["feliĉa", "feliĉ-a", "[UV] Happ/y. <B>1</B> (<I>ĝoja, kontenta</I>): contented, joyful, pleased. <I>~a edzo, infano, vizaĝo. Mi estas ~a vin renkonti</I>. <B>2</B> (<I>bonokaza, kontentiga</I>): auspicious, felicitous, lucky. <I>~a cirkonstanco, fino, ideo, sekvo, situacio. Vivi</I> <B>~e</B>. <I>Ĉio iris ~e. Estas <B>~e</B>, ke… . </I> <B>~(ec)o</B>, h-iness, felicity. <I>Ebria de (Sopiri al) ~o</I>, <B>~ego</B>, bliss, delight (➞ <I>beat, rav</I>). <B>~ega</B>, blessed, <B>~ejo</B> (➞ <I>paradiz</I>). <B>~igi</B> (<I>-n</I>), delight. <B>Mal~a</B> (<I>malĝoja, bedaŭrinda</I>), un-h., sad, wretched, unfortunate, unlucky. <I>~~a amo</I>. <B>~~aĵo</B>, accident, mischance, misfortune, mishap). <I><B>~~</B></I><B>ego</B>, calamity, catastrophe, disaster.", "0"],
["felietono", "felieton-o", "[OA] feuilleton, serial feature.", "0"],
["felisoj", "felis-oj", "felidae, the smaller cats.", "0"],
["felo", "fel-o", "[OA] hide (fur, pelt, skin) of animal, with the wool or hair. <I>~o ermena, fibera, foka, leona, lupa, talpa. Ŝafa ~o</I>, sheepskin. <B>~a</B> <I>ĉapo</I>, fur cap. <B>~(vend)isto</B>, fell-monger.", "0"],
["felpo", "felp-o", "(tex) velveteen. ➞ <I>plus, velur</I>.", "0"],
["felto", "felt-o", "[UV]. <B>1</B> (tex) Felt. ~a <I>ŝuo</I>. <B>2</B> similar material. <I>Tegmenta ~o</I>. <B>~(iz)i</B>, cover (line) with felt.", "0"],
["feluko", "feluk-o", "felucca, small Mediterranean coasting vessel.", "0"],
["feminismo", "femin-ismo", "[OA] <B>-isto</B>, [OA] femin-ism, -ist.", "0"],
["femuro", "femur-o", "[UV] (Ge 32/25, Ps 147/10). Thigh, femur, ham, upper part of leg. <I>Kokin ~o</I>, drumstick, (cul) <I>Porka ~o</I>, gammon. ➞ <I>ŝink. Ŝafa ~o</I>, leg of mutton. <B>~a</B>, femoral. <B>~osto</B>, t-bone. ➞ <I>koks, krur, sur, tibi</I>.", "0"],
["fenacetino", "fenacetin-o", "phenacetin.", "0"],
["fendi", "fend-i", "(<I>-n</I>), [UV] Split (Ge 22/3), cut open. <I>~i atomon, lignon, ŝtonon. ~i en du partojn</I>. <B>f</B> <I>~i la aeron, koron, mallumon, maron</I>. <B>~o</B> (Jes 2/21), s., cleft, crack, fissure, gap, slit, slot, e.g., <I>de leterkesto</I>. <B>f</B> (<I>skismo): ~o en la movado</I>. <B>~ego</B>, chasm, crevasse, gorge, ravine, etc. <B>~eto</B>, chink, crack, cranny, crevice, rift. <B>~iĝi</B>, (nt) gape (s.) open, branch off, divide, open, spring a leak, etc. <B>~ita</B> <I>jupo</I>, divided skirt. <B>~ilo</B>, chopper. <B>~hava</B>, cracked, leaky. <B>Dis~i</B>, s. asunder (in two). <B>~~ita</B> (<I>hufo</I>, etc.), s., cleft, cloven, riven. <B>En~o</B> (<I>entranĉo</I>), nick, notch, score. <B>Cel~o</B>, sight-slit, vision slot. <B>Fal~o</B>, (geog) fault. <B>Frot~eto (Haŭt~eto)</B>, chap. <B>Har~a</B> (<I>trosubtila</I>), hairs-ing. <B>Kor~a</B>, heart-rending. ➞ <I>hak, kliv, krev, romp, split, ŝir, tranĉ</I>.", "0"],
["fendro", "fendr-o", "(<I>cindroŝirmilo</I>), fender (around hearth).", "0"],
["feneko", "fenek-o", "fennec fox (<I>Fennecus</I>).", "0"],
["fenestro", "fenestr-o", "[UV] Window. <I>Rigardi tra la ~o</I>. <B>Baskula ~o</B>, pivoted w. <B>Bed~o</B> (hort) light sash. <B>Elstara ~o</B>, bow w. <B>Klap~o</B>, hinged sky-light. <B>Lev~o</B>, <B>glit~o</B>, sash w. <B>Montra ~o</B>, show w. <B>Tegment~o</B>, dormer. <B>Ŝip~o</B>, port hole. <B>~a</B> <I>breto (sojlo</I>), w-sill. <I>~a fosto</I>, w-post, mullion. <I>~a kruco,</I> cross bars. <I>~a vitro</I>, w-pane. <I>~a kovrilo (ŝirmilo) (ŝutro</I>), shutter. <B>~eto</B>. ➞ <I>giĉet, luk</I>. <B>Sen~a</B>, w-less, blind. ➞ <I>apertur, fram, klap, vitrin</I>.", "0"],
["fenikoptero", "fenikopter-o", "(ordinary language <I>flambirdo, flamengo</I>), flamingo (<I>Phoenicopterus</I>).", "0"],
["fenikso", "feniks-o", "[OA] phoenix (myth. bird).", "0"],
["fenikuro", "fenikur-o", "(<I>ruĝvosto</I>), (orn) Redstart, firetail (<I>Phoenicurus). Nigra ~o</I>, black r.", "0"],
["fenilo", "fenil-o", "(chem) phenyl.", "0"],
["fenkolo", "fenkol-o", "[UV] (bot) fennel (<I>Foeniculum</I>).", "0"],
["feno", "fen-o", "(met) fohn, hot dry south wind (Switzerland).", "0"],
["fenolo", "fenol-o", "(chem) phenol. ➞ <I>karbol</I>.", "0"],
["fenomeno", "fenomen-o", "[OA] Phenomen/on (El 3/3). (<I>aperaĵo, perceptaĵo</I>), appearance, occurrence, vision. <I>~o astronoma, fizika, spirita</I>. <B>~a</B>, -al. <B>~aĵo</B>, <B>~ulo</B>, remarkable thing or person, curiosity, marvel, prodigy, rarity, wonder. ➞ <I>aper, eksterordinar, maloft, mirakl, mirind</I>.", "0"],
["fenugreko", "fenugrek-o", "(bot) fenugreek (<I>Trigonella foenum graecum</I>).", "0"],
["feo", "fe-o", "<B>~ino</B> [UV] fairy, fay. <I>Akva ~(in)o,</I> water sprite. <B>~a</B>, fairy, faerie, <B>f</B> (<I>mirinde bela</I>), beautiful, delicate, visionary. <B>~lando</B>, f-land. <B>~lampo</B>, -light. <B>~rakonto</B>, f-tale. <B>f</B> incredible story, <B>~ringo</B>. ➞ <I>marasmi</I>.", "0"],
["ferdeko", "ferdek-o", "[UV] (mar) Deck. <B>Antaŭ~o</B>, forecastle head. <B>Boat~o</B>, boat d. <B>Ĉefa (Dua) ~o</B>, main-d. <B>Duon~o</B>, half-d. <B>Flug~o</B>, flying d. <B>Inter~o</B>, steerage, tween-dd. <B>Kanon-o</B>, gun d. <B>Kvarona (Oficira) ~o</B>, quarter-d. <B>Post-o</B>, bridge. <B>Promen~o</B>, promenade d. <B>Suba (Tria) ~o</B>, lower d. <B>Supra (Unua) ~o</B>, upper d. <B>Sen~a</B>, open. <B>Tri~ulo</B>, three-er.", "0"],
["ferio", "feri-o", "[OA] Holiday. <I>Banka ~o</I>, bank h. <B>~oj</B>, hh., vacation. <B>~i</B>, be on h. <I>Kiam vi ~os?</I> When do you break up? <B>~a</B>, ferial, free. ➞ <I>festotag, forpermes, libertemp</I>.", "0"],
["feri(fero)cianido", "feri-(fero-)cianido", "ferri-(ferro-)cyanide.", "0"],
["ferli", "ferl-i", "(<I>volvi</I>) (<I>-n</I>), furl, roll up, take in (<I>velon</I>). <B>~ilo</B>, gasket (for square sail), tie (for fore-and-aft sail). <B>~ŝnuro</B>, clew-line: <B>(Angula</B>, clew garnet; <B>Flanka</B>, leech line; <B>Meza</B>, bunt line). <B>Duon~i</B>, half-mast. <B>Mal~i</B>, unfurl. ➞ <I>aljardig, brajl</I>.", "0"],
["fermato", "fermat-o", "(mus) hold, pause (<SUP>r:</SUP>’).", "0"],
["fermenti", "ferment-i", "(nt) [F], Ferment, rise (of dough), work, <B>f</B> <I>piano ~is en mia kapo</I>. <B>~inta</B> (El 12/20). <I>-inta vino</I>, -ed wine. <B>~(ad)o</B>, -ation. <B>~aĵo</B> (El 12/19). <B>~ilo</B>, barm, leaven, yeast. <I>Pan~ilo</I>. <B>~ema</B>, <B>~iva</B>, <B>~ipova</B>, -able, <B>~igi</B> (<I>-n</I>), cause to f., excite, foment, stir up. <B>Ne~inta</B>, <B>Sen~a</B>, un-ed, unleavened (➞ <I>mac</I>) (Jes 25/6). ➞ <I>enzim</I>.", "0"],
["fermi", "ferm-i", "(<I>-n</I>), [UV] Clos/e, shut (up), forbid access to. <I>breĉon, buŝon, domon, libron, manon, pordon, vojon; dentojn, lipojn, okulojn. ~i hermetike</I>, make air-tight. Bring to an end: <I>diskuton, kongreson, kunvenon</I>. ➞ <I>ĉesig, fin</I>. Close (<I>fabrikejon</I>); conclude (<I>aranĝon</I>); cork (<I>botelon</I>); seal (<I>leteron</I>); stop up (<I>truon</I>); switch, turn off (<I>elektron, gason, lumon</I>). ➞ <I>for-kran(-komut), salt</I>. <B>~o</B>, close, breaking-up. <B>~a</B> <I>kunveno</I>, -ing meeting. <B>~eti</B> (<I>duon~i</I>), half-c. <B>~iĝi</B>, (nt) c., break up, end (<I>kurso</I>). <B>~ilo</B>, fastening, fastener, (bottle) cap, cover, latch, lid, lock, shutter, etc. <B>Klik~ilo</B> (➞ <I>agraf, prembuton</I>), clasp, hasp, snap (bracelet, etc.). <B>Tir~ilo. glit~ilo</B>, zip (a. <I>zipo</I>) <B>~ita</B>, c-ed, shut. <I>~ita silabo</I>, c-ed syllable (ending with a consonant). <I>~itaj</I> (clenched) <I>dentoj</I>. <B>~plato</B> (<I>klap~ilo, kovrilo</I>), cover, lid. <B>Ĉirkaŭ~i</B>, enclose. <B>En~i</B> (<I>iun en ĉambron</I>), confine. <B>~~iĝema</B>, close, uncommunicative. <B>Ne~ita</B> letero, open letter. <B>Bru~i</B>, <B>frap~i</B>, bang, slam. <B>Fru~o</B>, early closing. <B>Ŝtop~ita</B> (Ij 32/19). ➞ <I>kaŝ, kovr, obtur, ŝlos, stop</I>. <B>malferm-i</B>, [UV] Open. <I>~i la brakojn, pordon, kunvenon. ~i vojon</I>, pave the way. <I>Larĝe ~ita</I>, gaping wide o. <I>Kun ~itaj okuloj</I>, o-eyed. <B>~a</B> <I>kunveno</I>, -ing meeting. <B>~(aĵ)o</B>, -ing, aperture, gap, mouth, orifice, outlet. <I>Solena ~o</I>, inauguration. <B>Tranĉ~~i</B> (open up) <I>fiŝon</I>, (4 FA 174/34). ➞ <I>enkonduk, inaŭgur, komenc</I>.", "0"],
["fero", "fer-o", "[UV] <B>1</B> Iron (Fe). <B>2</B> (<I>f</I><B><I>~</I></B><I>aĵo</I>), metallic object. (fastening, fitting). <I>Du~a rabotilo</I>. <B>Angul~o</B>, angle-i. <B>Bend~o</B>, hoop-i. <B>Fand~o</B>, <B>gis~o</B>, cast-iron. <B>Forĝ~o</B>, <B>mol~o</B>, soft-i. <B>Huf~o</B>. horse-shoe (<I>hufumo</I>). <B>I~o</B>, I-beam. <B>Laĉ~(aĵ)o</B>, fetter, <B>Pint~o (</B><I>pintingo</I>), ferrule, tip (of stick, umbrella). <B>U~o</B>, channel-iron. <B>Zum~o</B>, Jew’s harp. <B>~a</B>, i. <I>~a riglilo</I> (Jes 45/2). <I>~a oksido</I>. <B>f</B> (<I>neindulga, senceda, severa): ~a disciplino, leĝo, mano, neceso, volo</I>. <B>~i</B>, cover (overlay, spread) with iron. <B>~aĵoj</B>, hardware. <B>~aĵisto</B>, i-monger. <B>~eto</B>, tag (of shoe-lace). <B>~ika</B>, ferric. <I>~ika oksido</I>. <B>~oza</B>, ferrous. <I>~oza sulfato,</I> copperas. <B>~bendo</B>, iron-band. <B>~dona</B>, <B>~hava</B>, ferruginous. <B>~laborejo</B>, i-works. <B>~pirito</B>, iron-pirite, \"fool’s gold\", <B>~ŝtono</B>, i-stone. <B>~vojo</B>, [UV] railway. <B>Ne~a</B>, non-ferrous. ➞ <I>fand, gis, glad, lad</I>.", "0"],
["feroca", "feroc-a", "(<I>sovaĝe atakema</I>), ferocious, cruel, fierce, savage.", "0"],
["ferolo", "ferol-o", "(bot) giant fennel (<I>Ferula</I>). ➞ <I>asafetid, galban</I>.", "0"],
["fervoro", "fervor-o", "[UV] Ferv/our, Zeal; ardour. <I>Blinda ~o</I>. <B>~a</B>, f-ent, zealous; ardent, eager, warm. <B>~e</B> <I>labori</I>. <B>~i</B> (<I>pri, pro) (agi ~e</I>), be zealous, interest one’s warmly (1 Rĝ 19/14; <B>Ze</B> 1/14). <I>Tro ~i estas danĝere</I>. <B>~aĉa</B>, fanatical, over-z-ous. <B>~ega</B>, f-id, glowg, vehement. <I>~ego</I>, passion. <B>~ulo</B>, enthusiast, z-ot. <B>Mal~a</B> (<I>indiferenta</I>), cold. <B>Ne~a</B>, half-hearted, luke-warm. ➞ <I>ard, bol, entuziasm, flam, pasi, sindon, varm</I>.", "0"],
["festeni", "festen-i", "(nt) [UV] (<I>manĝi feste, formale, lukse</I>), Banquet, Feast (Es 7/1). <B>~o</B>, b., f. <I>Por unu ~o, por alia ĉagreno. Tro da ~o estas veneno. ~o postenteriga</I>, wake (4 FA 167/3). <B>~ado</B>, -ing. <B>~ejo</B>, b-ing hall. <B>~ema</B>, convivial. ➞ <I>banked, fest, regal</I>.", "0"],
["festivalo", "festival-o", "festival.", "0"],
["festo", "fest-o", "[UV] Fest/ival, celebration, holiday. <B>1</B> in gen. <I>Aŭ ~o, aŭ fasto!</I> <B>2</B> special anniversary. <I>~o de Sankta X. ~o movebla,</I> movable feast. <I>~o Kristnaska, Paska, Pentekosta</I>. <B>Edziĝo~o</B> (Alt 3/11). <B>Kandel~o</B>, candlemas. <B>Memor~o</B> (<I>soleno</I>), commemoration f., feast of remembrance. <B>Rikolta dank~o</B>, harvest thanksgiving. <B>3</B> Entertainment, fete. <B>Sport~o</B>, sports day. <B>~a</B>. festal, -ival, -ive. <B>~salono</B>, f-hall. <I>~a tago,</I> holiday. <I>~a prezento</I>, gala performance, <B>~e</B> <I>aranĝita tablo. (-n. pro) = celebri, fari, observi, soleni ~on</I>; celebrate (hold, keep, observe) a f., birthday, etc. <I>~i datrevenon, edziĝon, jubileon, venkon</I>. <B>~eto</B>, party. ➞ <I>festen, festival</I>.", "0"],
["festono", "feston-o", "[OA] Festoon. <B>1</B> chain (loop) of flowers (branches, leaves etc.). <B>2</B> any looped ornament. <B>~i</B>, f., arrange in ff. ➞ <I>girland, kron</I>.", "0"],
["festuko", "festuk-o", "(bot) fescue grass (<I>Festuca</I>).", "0"],
["fetiĉo", "fetiĉ-o", "[OA] Fetish, object. of blind admiration. <B>~ismo</B>, -ism. <B>~isto</B>, f-worshipper. ➞ <I>amulet, talisman</I>.", "0"],
["feto", "fet-o", "(bio) f(o)etus, embryo, fruit of womb. ➞ <I>ĝerm</I>.", "0"],
["fetori", "fetor-i", "<B>~o</B>, Stink, reek, stench. <B>~a</B>, stinking, fetid, noism, rank. <I>~a bulo</I>, s-bomb. ➞ <I>haladz, miasm</I>.", "0"],
["feŭdo", "feŭd-o", "<I>[OA],</I> Feud(al tenure), fee, fief. <B>~a -al</B>, -atory. ~a sinjoro, -al lord. ~a bien -(rajt-reĝim-)o. <B>~ulo</B> (vasalo), vassal. [,V&lt;?= vendetta],", "0"],
["fezo", "fez-o", "fez (Eastern felt cap). ➞ <I>turban</I>.", "0"],
["fiakro", "fiakr-o", "[OA] (<I>lukaleŝo</I>), cab, hackney-coach. <B>~isto</B>, cab-man, -by. ➞ <I>droŝk, kaleŝ</I>.", "0"],
["fianĉo", "fianĉ-o", "[UV] <B>~ino</B>, [UV] Engage/d (affianced, betrothed) person, fiancee, sweetheart. <B>~eco</B>, <B>~iĝo</B>, -ment, betrothal. <B>~(in)iĝi</B> (<I>kun</I>), get -ed, plight troth (Rd 28/30). <I>~ina vualo</I>. <B>Eks-iĝi</B>, break off -ment. <B>Ge~oj</B>, -d couple.", "0"],
["fiasko", "fiask-o", "[OA] (<I>plena malsukceso</I>), fiasco, break-down, failure. <B>~i</B> (<I>renkonti ~on</I>), fail, be a failure, mis-carry-fire, miss the mark. ➞ <I>fal, pane</I>.", "0"],
["fibolo", "fibol-o", "safety-pin.", "0"],
["fibro", "fibr-o", "[UV] Fibr/e. <B>1</B> (bot) (zoo) <I>~o ligna, muskola, silka. <B>f</B> Ami per ĉiu ~o de la koro</I>. <B>2</B> gen. any textile filament. <B>~(ec)a</B>, ~oza, ~oplena, -ous. <B>~eto</B>, fibril. <B>~iĝi</B>, fray. <B>~ino</B>, -in. <B>~ojda</B>, -oid. <B>~omo</B>, -oma (<I>~ohista tumoro</I>). ➞ <I>fadenet, filament</I>.", "0"],
["fibulo", "fibul-o", "(anat) fibula (bone).", "0"],
["fidela", "fidel-a", "[UV] Faith/ful, true. <B>1</B> (<I>fidinda, lojala</I>), keeping f., loyal, trusty. <I>~a edzino, hundo, servisto. Ni restu ~aj!</I> 2 (<I>ekzakta, ĝusta</I>), accurate. <I>~a bildo, memoro, raporto, teksto, traduko</I>. <B>~eco</B>, fidelity. <B>~uloj</B>, believers, the faithful. <B>~rompo</B>, breach of f., disloyalty, perfidy. <B>Mal~a</B>, -less, un-ful, perfidious (➞ <I>apostat). ~~eco</I>, infidelity. <I>~~iĝi</I>, be un-ful.", "0"],
["fidi", "fid-i", "(<I>-n, al, je, pri, ke</I>) [UV]. <B>1</B> Trust, have Faith (Confid/ence), put t. (in). <B>2</B> Count (depend, reckon, rely) on. <I>~i Dion (al Dio</I>). t. in God. <I>~i sin (al si); ies vorton; propran okulon</I>. <B>~o</B> f., c., reliance. <B>~(em)a</B>, <B>(~plen</B>)<B>a</B>. c-ing, full of c., t-y(-ing), <B>-ebla</B>, <B>~inda</B>, t-y, t-worthy, that can be t-ed, dependable, reliable, sure. <I>~inda konsilo, metodo, persono</I>. <B>Bon-e</B>, in good f., [sincerely. <B>Mal~i</B> (<I>tute ne</I> ~i), dis- (mis-)t. ‘ <B>Mal~ema</B> (<I>skeptika</I>), of little f., suspicious. <B>Ne~inda</B>, insecure, precarious, unsafe, untrustworthy. <B>~~indulo</B> (Jes 48/8). <B>Sin~o</B>, assurance, self-c (-reliance). <B>Tro~ema</B>, over t-ful, unsuspicious. <B>Trosin~a</B>, over c-ent, presumptuous. ➞ <I>konfid</I>.", "0"],
["fidro", "fidr-o", "(<I>nutra kablo, kondukilo</I>) (el., tech), conductor, feeder.", "0"],
["fiera", "fier-a", "[UV] Proud. <B>1</B> arrogant, haughty (➞ <I>arogant, fanfaron, malhumil, malmodest, parad, pav, vant</I>) (Ne 9/16). <B>2</B> fine, gallant, splendid, stately (➞ <I>glor, impon). ~a mieno, obstino, palmo, rigardo, sinteno, spirito</I>. <B>~(ec)o</B>, pride. <B>~i</B> (<I>pri, abs</I>), be proud (of), glory (take pride) in, plume one’s (on). <B>~aĵo</B>, arrogance (1 Sa 2/3). <B>~igi</B>, puff up. <B>~inda</B>, to be p. of. <I>~indaĵo</I>, (Jes 60/15). <B>Mal~a</B>, humble, modest. <B>Tro~igi</B>, intoxicate, puff up (with pride, success). ➞ <I>arogant</I>.", "0"],
["fifro", "fifr-o", "(Bb <I>fluteto</I>), (m.i.) fife, ➞ <I>flut</I>.", "0"],
["figo", "fig-o", "[UV] fig. <B>~arbo</B>, f-tree (<I>Ficus</I>). <B>~birdo</B> (ordinary language) f-eater, any f-eating bird. ➞ <I>banjan, opunti</I>.", "0"],
["figuro", "figur-o", "[UV] Figur/e (wide sense), image, outline, presentment. [Ne= cifer- ]. <B>1</B> form, shape. ~o <I>homa, virina. Sankt(ul)a ~o (ikono</I>). <B>Stel~o</B>, constellation. <B>2</B> (geom) = grafikaĵo. <B>3</B> (gram) <B>Parol~o</B>, ~o retorika (<I>tropo</I>), figure of speech. <B>4</B> (log) <I>La ~oj de silogismo</I>. <B>5</B> (mus) (a) = notgrupo, ternero. (b) formo de akompano. <B>6</B> = danc~o. <I><B>~a</B> -ative, allegorical, etc. ~a senco de vorto. <B>~e</B>, by (in) figures, figuratively. <B>~i</B>, <B>1</B> (bildigi, prezenti), depict, portray, represent, typify. ~i ideon, personon, objekton</I>. <B>2</B> <I>aktori, pozi, roli (kiel), play the part of. <B>~ado</B>, portrayal. <B>-(aĵ)o</B>, f., diagram, image, representation, etc. <B>~eto</B> (statueto), -ine, knick-nack, mantelpiece ornament. <B>Antaŭ~i</B>, foreshadow. ~~o, (mar) f-head. <B>Bel~a</B> (belkreska, gracila), handsome, of fine f. <B>Ĉifon~o</B>, scarecrow. <B>Trans~i</B>, trans-f, glorify, ~~iĝo, transfiguration. <B>Tut~a</B>, full-length. ➞ bild, diagram, form, ilustr, kontur, prezent, reprodukt</I>.", "0"],
["Fiĝio", "", "FJ.", "1"],
["fikario", "fikari-o", "(bot) lesser celandine (Ficaria). ➞ <I>ranunkol</I>.", "1"],
["fikcio", "fikci-o", "[OA] (lit) Fiction, <B>~a</B>, of f. <I>~a hero-(rakont-)o</I>. ➞ <I>fabel, fiktivaj, mit</I>.", "0"],
["fiksi", "fiks-i", "(<I>-n, al, sur</I>) [OA] (<I>senmovigi</I>), Fix. <B>1</B> fasten, make firm or fast, secure, steady. <I>~i ankr-(tabul-)on. -i kojn-(najl-)e</I>. <B>f</B> <I>~i la atenton (okulojn) sur. <B>2</B> (aranĝi, decidi</I>): decide, settle, lay down, settle. <I>~i dat -(hor-prez-rendevu-senc-)on</I>. <B>3</B> (phot) <I>~i bildon</I>. <B>~o</B>, fixation. <B>~e</B> <I>rigardi</I> (2 Rĝ 8/11). <B>~aĵo</B>, -ture. <B>~eco</B>, -ity. <B>~iĝi</B>, be -ed (established), gain a footing, settle. <B>~ilo</B>, <B>means</B> of -ing, -ative, -er, vice, etc. <B>~ita</B>, -ed, fast, firm, <I>~ita dato, ideo, koloro, prezo</I>. <B>-aranĝi</B>, ➞ <I>stiv</I>. <B>Kun~i</B>, fasten (pin) together. <B>Mal~i</B>, loosen. <B>Lok-ita</B>, stationary, (phot) <B>-bano</B>, -er, -ing bath. <B>~tonigilo</B>, combined -ing and toning bath.", "0"],
["fiktiva", "fiktiv-a", "[OA] (<I>nereala, imagita, konvencia</I>), Fict/itious, assumed, imaginary, put on, make-believe, not genuine, sham, <I>~a forto, mono, aloro, voĉo</I>. <B>~aĵo</B>, fiction, figment, invention, something existing only in imagination. <I>Jurista ~aĵo</I>, legal -ion. ➞ <I>fikci</I>. <B>Opp</B>. <I>efektiv, real, ŝajnig, ver</I>.", "0"],
["filadelfo", "filadelf-o", "(bot) mock orange (<I>Phila- delphus</I>) (sometimes miscalled \"syringa\"). ➞ <I>siring</I>.", "0"],
["filago", "filag-o", "common cudweed (<I>Filago</I>). ➞ <I>gnafali</I>.", "0"],
["filakterio", "filakteri-o", "phylactery <B>(Mt</B> 23/5). ➞ <I>amulet</I>.", "0"],
["filamento", "filament-o", "Filament (zoo), something slender and threadlike. <B>2</B> (bot) stalk of stamen. <B>3</B> (el. rad) high resistance wire. <I>Inkan- deska ~o</I>. <B>4</B> (t<I>ex</I>) <I>= fibro</I>. <B>~(ec) (oz)a</B>, -ary. ➞ <I>fadenet, fibr</I>.", "0"],
["filandro", "filandr-o", "gossamer, light filmy spider- web (floating on air or spread on grass), <B>f</B> Something flimsy, e.g. delicate gauze. <B>~a</B>, light and flimsy.", "0"],
["filanto", "filant-o", "<I>Phyllanthus</I>, genus of Indian trees.", "0"],
["filantropo", "filantrop-o", "[OA] (<I>homamanto</I>), Philanthropist. <B>~a</B>, -ic. <B>~eco (~IO)</B>, -y. ➞ <I>bonfar, helpem, kompat</I>.", "0"],
["filario", "filari-o", "(<I>Filaria</I>) &gt; hair-worm.", "0"],
["filatelo", "filatel-o", "Philatel/y, stamp-collecting. <B>~a</B>, -ic, <I>~a borso</I>. <B>~isto</B>, -ist.", "0"],
["filiko", "filik-o", "[UV] Fern<I>ifilix</I>). <B>Har~o (</B><I>adianto</I>). <B>In~o (</B><I>atirio</I><B>). Ŝild~o (</B><I>aspidio</I><B>). Vir~o</B> (<I>lastreo</I>). <B>~ejo</B>, -ery. <B>~oscienco</B>, filicology.", "0"],
["filio", "fili-o", "[OA] (<I>flanka institucio, subfirmo</I>), branch (of business, establishment, firm, house, office); affiliated body. <B>~igi</B>, <B>~iĝi</B>, affiliate.", "0"],
["filipendolo", "filipendol-o", "drop wort (<I>Filipendula</I>). ➞ <I>spire, ulmari</I>.", "0"],
["Filipinoj", "Filipin-oj", "PH.", "0"],
["filistro", "filistr-o", "Philistin/e, vulgarian, outsider. <B>~a (</B><I>mallarĝanima, senideala</I>), p., commonplace, uncultured, without ideals. <B>~eco ~ismo</B>, -ism. ➞ <I>Filiŝt, profan, proz, senideal, senkultur</I>.", "0"],
["Filiŝto", "Filiŝt-o", "(Bb, hist) Philistine.", "0"],
["filito", "filit-o", "hartstongue (fern) (<I>Phyllitis scolopendrium</I>).", "0"],
["filmo", "film-o", "[OA8], Film (wide sense, cin, phot, etc), thin coating (layer, skin). <B>Parol~o</B>, <B>Son~o</B>, sound film. <B>~o silenta. Rul~o (~o kartoĉa). ~i</B> (<I>fotografi</I>), film. <I>~i aktoron, scenon</I>. <B>~aktoro</B>, <B>~stelo</B>, ~<B>strio. ~prezento. ~inda. ~isto.</B> ➞ <I>membran, tavolet</I>.", "0"],
["filo", "fil-o", "[UV] Son, boy. <I>Liaj ~oj post li</I>. <B>~a</B> filial. <I>~a am-(dev-)o</I>. <B>-ĉjo</B>, -ny. <B>~eco</B>, -ship, <B>-eto</B>, -ny, youngster, <B>~igi</B>, adopt. <B>~ino</B>, daughter, <B>-ineto</B>, little daughter. <B>~inurbo</B> (2 Kr 13/19). <B>Bo~o</B>, s-in-law. <B>Ge~oj</B>, -(s) and daughter(s). <B>Pra~o</B>, descendant. <B>Sol~o</B>, only s. <B>Stifa ~o (Sti~o)</B>, step-s<B></B>. ➞ <I>adopt, fili</I>.", "0"],
["filoksero", "filokser-o", "(ent) phylloxera (species of plant louse).", "0"],
["filologio", "filolog-io", "[OA] philolog/y. <B>~o</B>, [OA] -ist.</B>", "0"],
["filoskopo", "filoskop-o", "(<I>fajfsilvio</I>), (species of) Warbler. <B>Norda ~o</B>, arctic w. <B>Sibla ~o</B>, wood w. <B>Verda ~o</B>, greenish w. ➞ <I>ĉifĉaf, fitis, silvi</I>.", "0"],
["filozofo", "filozof-o", "[OA] Philosoph/er, lover of wisdom. <B>~a</B> <I>ŝtono</I>. <B>~i</B>, -ize, be -ical. <B>~aĉo</B>, sham p. ➞ <I>sofist</I>. <B>~ado</B>, -izing. <B>~io</B>, [OA] philosophy. <I>~io stoika</I>. <B>~ia</B>, -ical. ➞ <I>egalanim, logik, metafizik</I>.", "0"],
["filtri", "filtr-i", "(<I>-n</I>), [UV] Filt/er, strain (wide sense). <I>~i fluidaĵon</I>. <B>~(ad)o</B>, -ation. <B>~(it)aĵo</B>, -ate. <B>~ilo</B> filter, strainer, (phot) screen. <I>~ilo papera, tuka. ~ilo por kafo</I>. (el) <I>~ilo de frekvenco</I>, frequency filter. <B>Lum~ilo</B>, light f., orthochromatic screen. <B>~opaper (-otuk)o. ~iĝi</B>, f., percolate. <B>En~iĝi</B> (<I>penetri</I>), infiltrate (wide sense)<I> <B>~</B><B>~aĵo</B></I>, infiltration. <B>Tra~iĝi</B>, percolate. ➞ <I>ekran, kribri (solidojn), trafluet</I>.", "0"],
["finalo", "final-o", "[OA] (mus, th), finale, last movement (scene), (sp) final.", "0"],
["financo", "financ-o", "<I>[OA],</I> Financ/e; <B>~o</B>, <B>~oj</B> (monaferoj, monrimedoj), -es, funds, means, resources. <B>~a</B>, -ial. ~a <I>ministro, situacio</I>. <B>~i</B> (<I>subteni ~e</I>), f. ~i <I>entreprenon</I>. <B>Regna ~estro</B>, <I>Chancellor of the Exchequer. <B>~isto</B>, -ier. ➞ bilanc, buĝet, ekonomi, kapital</I>.", "0"],
["fingro", "fingr-o", "[UV] Finger, digit. <B>dik~o</B> (polekso), thumb; montra, fore-f; longa (meza); ringa; malgranda (~eto). <B>f</B> La ~o de Dio (la sorto). Bruligi la ~ojn. Meti ~on sur ion. <B>Pied~o</B>, toe. Pieda dik~o (halukso), great toe. Martela pied~o, hammer-toe. Pied<B>~e</B>, on tiptoe. <B>~a</B>, digital. <I>~a alfabeto</I>. <I><B>~i</B> (mus) finger. <B>~o -metado, -notado</B>, fingering. <B>~ingo</B>, thimble, (med) fingerstall. <B>~ujo</B>, <B>f</B> (of glove). <B>~ulo</B>, Hop-o’my-thumb. <B>~umi</B>, fiddle, finger, paw, prod. <B>~oludo</B> (morao), mora (gm). <B>~opinto</B>, f-tip. <B>Inter~igi</B> (kunplekti</I>) la manojn, <I>clasp one’s hands together. ➞ falang</I>.", "1"],
["fini", "fin-i", "[UV] Fin/ish. <B>1</B> (<I>maldaŭrigi</I>): Conclu/de, (bring to an) end, have done with, terminate. <I>~i sian vivon. ~i paroli</I>. (abs) (<I>ĉesi agi): Mi ~is!</I> <B>2</B> (<I>plenumi, tutfari</I>) complete. <I>~i kurson, laboron, taskon</I>. <B>~o</B>, <B>1</B> finish, end, c-sion (<I>ĉeso de agado): Fari (meti) ~on al io. Ĉio havos ~on</I>. <B>2</B> (<I>posta parto, ekstremaĵo): ~o de bastono, kanto, vivo</I>. ~a (<I>ĉe la ~o</I>), final, c-ding, bringing to an end (with no more to follow), terminal (➞ <I>decid, last): ~a bato, batalilo, parto, vorto</I>. <B>~e</B>, finally, at length (last), in c-sion, in the long run (end), ultimately. <I>~e li venis! ~e de</I>, at the end of. <B>~(aĵ)o</B> (early writings <I>~iĝo</I>), (gram) ending, termination. <I>La ~aĵo</I> “«”. (mus) coda. <B>~aĵeto</B>, codetta. <B>~iĝi</B> (<I>per) (ĉesiĝi, havi finon</I>) (come to an) end, f., etc. (➞ <I>estingiĝ, forpas, mort</I>). <B>~ita</B>, <B>1</B> -ed. <B>2</B> (mat) -ite (opp <I>infinita</I>). <B>~ofara</B> (<I>definitiva</I>), -al. <I>~ofara bato</I>, coup de grace. <B>~fine</B>, at long last, at the very end. <B>~peco</B>, (vn) (<I>korda tenilo</I>), tailpiece. <B>El~i</B>, finish off, complete. <B>Ĝis~e</B>, to the end. <B>Mond~o</B>, world’s end. <I>Mondfina juĝo</I>, last judgment. <B>Ne~ita</B>, unfinished.<I> <B>~</B><B>~aĵo</B>,</I> rough draft. <B>Parol~o</B>, peroration. <B>Sen~a</B> (<I>senlima</I>), endless, interminable, perpetual, unending. <I>~~a ĉeno, prediko, spaco. Ĝis ~~eco</I>, to infinity. <I>PFX:</I> <B>Fin~i = el~i</B>, f. completely, to the end. <I>~kanti, ~legi, ~pagi, ~paroli, ~trinki</I>. ➞ <I>ĉes, detru, ekstrem, esting, nulig, lim</I>.", "0"],
["finialo", "finial-o", "(arch) finial (ornamental finish of roof apex).", "0"],
["finitivo", "finitiv-o", "(gram) finite verb (ends in <I>as, is, os, us</I>, or <I>u</I>).", "0"],
["finko", "fink-o", "(proposed by Stojan) (ordinary language) finch (G. <I>Fink) &gt; fringelo</I>, and many related birds. ➞ <I>kardel, fring(el</I>).", "0"],
["Finnlando", "Finnland-o", "FI, Finland.", "0"],
["finto", "fint-o", "<B>-i</B>, feint, pretence, sham attack. ➞ <I>artifik</I>.", "0"],
["fiolo", "fiol-o", "phial, small glass medicine-bottle. ➞ <I>ampol</I>.", "0"],
["firma", "firm-a", "[UV] Firm. <B>1</B> stable, steady, strong (Ij 11/15): <I>~a apogilo, muro, vojo. ~a tero,</I> dry ground, solid earth, terra firma. <B>2</B> close (dense) in structure: <I>~a korpo, pano, viando</I>. <B>3</B> resolute, steadfast: <I>~a decido, karaktero, paŝo, situacio, voĉo, volo</I>. <B>4</B> definite, final: <I>~a ofico, prezo, propono. Stari</I> <B>~e. ~aĵo</B> (Ps 150/1). <B>~eco</B>, firmness, constancy, solidity. <B>~igi</B> (Ru 4/7) make firm, clinch, confirm, consolidate, establish, fix. <I>~igilo</I> (➞ <I>ste</I>). <B>~iĝi</B>, harden, set. <I>~iĝado (hardiĝo</I>) of mortar, sett(ing). <B>Mal~a</B>, <B>Ne~a</B>, inconstant, loose, shaky, soft, unstable, unsteady, yielding. <I>Mal~igi</I>, loosen, unsettle. ➞ <I>daŭr, definitiv, fer, kompakt, konfirm, konstant, neskuebl, neŝancelebl, nerompebl, persist, stabil</I>.", "0"],
["firmamento", "firmament-o", "firmament, vault of heaven (Am 9/6). ➞ <I>firmaĵ</I> (Ge 1/7).", "0"],
["firmo", "firm-o", "[UV] (<I>komerca entrepreno</I>) <I>[Sin</I>. <I>firma-o]</I>. Firm, house of business. <I>~o fidinda</I>. <B>~ano</B>, member of firm. <B>~estro</B> (<I>ĉefo</I>), head, principal.", "0"],
["firsto", "first-o", "(<I>tegmenta supra eĝo</I>), housetop, ridge (of roof), (geol) crest. <B>~linio</B>, watershed.", "0"],
["fisko", "fisk-o", "[OA] (<I>regna kaso</I>), exchequer, state treasury. <B>~a</B>, fiscal, of public revenue. <I>~a jaro. ~a marko</I>, revenue stamp. ➞ <I>financ</I>.", "0"],
["fistuleno", "", "beef-steak fungus (<I>Fistulina</I>).", "0"],
["fistulo", "fistul-o", "[UV] fistula, (med) pipe-like ulcer.", "0"],
["fiŝo", "fiŝ-o", "[UV] Fish. <I>~o mara, rivera. ~o ekster akvo! Naĝi kiel ~o</I>. <B>Blanka ~o</B> (<I>alburno, leŭeisko</I>). <B>Dorn~eto</B> (<I>gasterosteo</I>). <B>Elektra ~o</B> (<I>gimnoto, elektroforo</I>). <B>Flug~o</B> (<I>ekzoceto</I>). <B>Glav~o (Spad~o)</B>, (<I>kisifio</I>). <B>Kat~o. Or~o. Plat~o</B> (<I>pleŭronekto</I>). <B>Sablo~o</B> (<I>ekvilo</I>). <B>Seg~o</B> (<I>pristo</I>). <B>~(kapt)i</B>, fish. <B>~a</B>, fishy, piscine. <B>~ado</B>, -ing. <B>~aĵo</B>, f-(dish). <B>~aro</B>, school of f. <B>~ido</B>, young f. <B>~ejo</B>, -ery. <B>~idaro</B>, fry (➞ <I>fraj</I>). <B>~ilaro</B>, -ing tackle. <B>~ino</B>, spawner. <B>~(kapt)isto</B>, fisherman. <B>~ujo</B>, f-pond (➞ <I>akvari</I>). <B>~bredisto</B>, <B>~fadeno</B>, <B>~hoko</B>, <B>~kano</B>, <B>~kulturo. ~oleo</B>, [UV] <B>~ovoj. ~vendejo</B>, <B>~vosto. Kan~i</B>, angle. <B>Perl~ado</B>, pearl fishing. <B>Ret~i. Vir~o</B>, milter, (astr) <B>~oj</B>, Pisces.", "0"],
["fiteŭmo", "fiteŭm-o", "(bot) rampion (<I>Phyteuma</I>).", "0"],
["fitiso", "fitis-o", "willow warbler (<I>Phylloscopus trochilus</I>). ➞ <I>filoskop, silvi</I>.", "0"],
["fitolako", "fitolak-o", "inkberry, red-ink plant, poke-weed (<I>Phytolacca</I>). <B>~a</B> <I>bero</I>, pokeberry.", "0"],
["fizalido", "fizalid-o", "(<I>Physalis), &gt; alkekengo,</I> Chinese lantern, winter cherry.", "0"],
["fizalio", "fizali-o", "bladder, jelly-fish (<I>Physalis). ~o urtika</I>, Portuguese man-of-war.", "0"],
["fiziko", "fizik-o", "[F], physics, physical science [Ne= <I>medikamento</I>]. <B>~a</B> <I>forto, leĝo, morto, neebla</I>. <B>~isto</B>, physicist. <B>Astro~o.</B>", "0"],
["fizio", "fizio-", "(ppfx) Physio-. <B>~grafio</B>, -graphy.", "0"],
["fiziologio", "fiziologi-o", "[OA] physiology. <B>fiziolog-o</B>, [OA] physiologist.", "0"],
["fizionomio", "fizionomi-o", "[OA] (<I>vizaĝaspekto</I>), physionomy, look, type of face. ➞ <I>aspekt, eksteraĵ, mien, trajtar, vizaĝ</I>.", "0"],
["fizioterapio", "fizioterapi-o", "physiotherapy.", "0"],
["fizostigmo", "fizostigm-o", "(bot) Calabar bean (<I>Physostigma</I>).", "0"],
["fjordo", "fjord-o", "[OA] fjord, firth, inlet. <I>~o Norvega</I>.", "0"],
["flabelo", "flabel-o", "(bot) (zoo), flabellum, <B>~a</B>, flabellate, fan-shaped.", "0"],
["flagelo", "flagel-o", "(bot) (zoo) flagellum, lash-like filament. <B>~uloj</B>, flagellates. ➞ cili.", "1"],
["flago", "flag-o", "[UV] Flag (&gt; standardo) (Jes 30/17). <I>Hisi (levi) ~on</I>. <B>~o</B> <I>kompania, linia, house flag. ~o kluba, bargee. ~o nacia, colours, ensign. ~o pilota. ~o pirata, Jolly Roger. <B>Vent~o</B> (ventmontrilo), weather-cock, weather-vane. <B>~(ornam)i</B> (-n), bedeck, deck with flags</I>. <B>~ita</B> <I>domo, ŝipo</I>. <I><B>~aĵo</B>, <B>~ŝtofo</B>, bunting, flag-cloth. <B>~signali</B>, flag, signal. <B>~ŝipo</B>, -ship. ➞ ruband. <B>~stango</B>, flag-staff</I>.", "0"],
["Flagri", "Flagr-i", "<B>~o</B>, [OA] (nt) (brili, bruli, treme aŭ intermite): Flicker, flare. <I>La fajro, flamo, lampo, torĉo; pasioj, ribelo ~as</I>. (<I>➞ ard, bol). <B>~ado</B>, conflagration</I>. <I>La kandelo ~adis en la vento. <B>~aĵo</B>, flare, <B>~et(ad)i</B>, flicker, twinkle. Ĉe lia vizaĝo ~etis rideto. <B>Ek~i</B>, flare up</I>. <B>~~o</B>, <I>outburst</I> (<I>de flamo, kolero</I>). <I>➞ fajrer, flirtet, flamet, trembril</I>.", "1"],
["flaĝoleto", "flaĝolet-o", "(m.i.) flageolet.", "1"],
["flako", "flak-o", "puddle, pool. <B>~a</B> (plashy, sloppy) tero. ~o de neĝo, patch of snow.", "1"],
["flakono", "flakon-o", "flagon, large glass vessel or wine-bottle (us. with handle, spout, and lid). ➞ hotel, flask.", "1"],
["flamo", "flam-o", "[UV] <B>1</B> Flame, blaze. <I>~o de fajro, gaso, lampo. Esti en ~oj</I>. <B>f</B> Passion, violent emotion. <I>~o de kolero</I>. <B>2</B> (<I>flagrubando</I>), streamer. <B>Gardo~o</B>, pilot jet. <B>Sag~o</B>, jet of f. <B>~(ant)a</B>, -ing, aflame, blazing, in flames. <B>f</B> fiery, vehement, wild (➞ <I>ard, entuziasm, fajr, fervoreg, pasi</I>). <B>~a</B> <I>deziro, kapo, kolero, okulo, parolo</I>. <B>~e</B> <I>ruĝa</I>. <B>~i</B>, blaze, be in flames. <I>La arbaro ~as</I>. <B>f</B> be red-hot, beam with rapture, flush, glow, etc. <I>~i de fervoro, honto, kolero. La okuloj, vangoj ~as</I>. <B>~eco</B>, ardour, spirit, vehemence. <B>~igi</B>, inflame, <I>~igo,</I> ignition. <I>Spark~igo</I>, spark ignition. <I>~iga bobeno, kandelo</I>, ignition coil (plug). <B>~iĝema</B>, passionate, fiery, hasty, hot-headed, inflammable. <I>~iĝema karaktero, substanco</I>. <B>~ingo</B>, (<I>~beko, gasbeko</I>), burner. <B>~birdo</B> (<I>flamengo</I>), flamingo (<I>Vd. fenikopter</I>). <B>~forma</B>, <B>~stila</B>, -iform. <B>~ĵetilo</B>, (mil) flame-thrower. <B>Ek~i</B>, break forth (burst into flames, catch fire). <B>~~igi</B>, light, set on fire. <I>~~igi deziron, fajron, lampon, ribelon</I>. <B>~igilo</B>, lighter. ➞ <I>brul</I>.", "0"],
["flanelo", "flanel-o", "[UV] flannel. <I>~a vesto</I>. <B>~eto</B>, -ette.", "0"],
["flanĝo", "flanĝ-o", "(<I>rand-elstaraĵo</I>), (mec) Flange, projecting flat rim (rib), beading, collar, fillet, shoulder (of nut, pipe, pulley, tube, etc). <I>~o fiksita, movebla</I>. <B>~junto</B>, f-joint. <B>~kuplado</B>, f-coupling. <B>~tubo</B>, -ed pipe. ➞ <I>bordaĵ, eĝ, kolum, rand</I>.", "0"],
["flanko", "flank-o", "[UV] <B>1</B> Sid/e, flank: <I>~o ĉe ~o,</I> abreast. <I>Prezenti la ~on</I>, be broadside on. <I>~o dekstra, verda</I>, r.h., starboard; <I>~o maldekstra, ruĝa</I>, l.h., port. <I>~o venta,</I> windward, weather; <I>~o malventa</I>, lee, sheltered. <B>2</B> (<I>surfaco); ~o de folio, monero, monto, muro, pordo. Ĉiu medalo du ~ojn posedas</I>. ➞ <I>edr, fac, supraĵ</I>. <B>3</B> (<I>direkto): ~o de sunleviĝo</I> (Jos 1/15). <I>Je kiu ~o mi staru?</I> <B>4</B> (<I>partio): Aŭdu ambaŭ ~ojn. Esti sur la ~o de ..</I>. <B>5</B> (geom) (<I>latero): ~o de triangulo</I>. <B>6</B> (<I>aspekto): la homa ~o de la demando</I>. <B>~a</B> side, <I>~a ĉambro, lumo. (akcesora, neĉefa) ~a detalo, persono</I>. <B>~e</B> (<I>ĉe la ~o</I>). <B>1</B> alongside, at the side of. <I>Kun manoj ĉe~e</I>. <B>2</B> s-ways, abeam, askance, laterally. <B>3</B> aside, apart from the rest, by the way. <I>Lasi, resti ~e (ignori, malatenti</I>), leave (stand) aside. <I>Mi ~e sidis, nek aŭdis, nek vidis. (Iru</I>) <B>~en</B>, Aside! Make way! Stand back! <I>Gliti, iri, meti, paŝi, rigardi ~en</I> (Ij 21/30). <B>~ema</B> (oblique, s-long) <I>rigardo</I>. <B>~i</B> be at the side of, flank. <B>~aĵo</B> (<I>io ~a</I>), <B>1</B> minor matter, s-issue. <B>2</B> (<I>alo</I>), wing, etc. <B>~iĝi</B>, deviate, fall (turn) away, sheer (Se 7/25). (a. <I>de~iĝi</I>, Ps 44/18). <B>~glito</B>, side-slip. <B>Ali~e</B>, <B>ĉi~e</B>, <B>ĉiu~e</B>, on the other (this, every) side. <B>Ambaŭ~e</B>, on both sides. <B>Du~a</B>, twosided, bilateral. <B>Mia~e</B>, as for me, for my part. <B>Mult~a</B>, many sided, versatile. <B>Unu~a</B>, on one side, partial, unfair, unilateral. <B>Voj-o</B>, wayside.", "0"],
["flano", "flan-o", "[UV] thin flat pastry. <B>1</B> (Bb) (Fr. <I>galette</I>), very thin cake or wafer. <B>Mac~o</B>, unleavened wafer (El 29/2; Le 2/4, 7/12, 8/26; No 6/15, 19). <B>2</B> (Fr. <I>flan</I>), soft flattish pastry case (with or wht filling). <B>Rim</B>.: The root <I>flan</I> has several meanings in various langs. [Ne= <I>kresp, kustard</I>]. ➞ <I>puding</I>.", "0"],
["flari", "flar-i", "(<I>-n</I>, abs), [UV] Smell (at), perceive by the nose. <I>~i floron, odoron</I>. <B>f</B> (<I>diveni, percepti, suspekti</I>): scent, suspect. <B>~a</B>, olfactory. <I>~a nervo</I>. <B>~ilo</B> (fac) nose. <B>~esplori</B> (<I>ĉirkaŭ~i, el~i, pri~i</I>), smell out, trace, track. <B>~sento</B>, sense of smell. <B>Antaŭ~i</B>, suspect. <B>En~i</B> (<I>nazenspiri, snufi</I>), sniff up. <I>En~i tabakon</I>. <B>Ek~i</B>, sniff, snort. <B>Akre~a</B>, keen-scented. <B>Post~i</B>, follow the scent of. ➞ <I>naz, odor, tabak</I>.", "0"],
["flasko", "flask-o", "Flask, leather or metal case, e.g., powder-horn; traveller’s wickered or leather-covered pocket bottle. <B>Varm~o</B>, hot-water bottle. <B>Vakua ~o</B>, vacuum flask (➞ <I>termos</I>).", "0"],
["flati", "flat-i", "(<I>-n, al</I>, abs), [UV] Flatter. <I>Vi min ~as, Spegulo ne ~as</I>. <B>~a</B>, -ing. <I>~a portreto, vorto</I>. <B>~(ad)o</B>, flattery, adulation, blandishment. <I>Komenci per ~o kaj fini per bato</I>. <B>~aĉi</B> (fi~i), fawn, toady. <B>~aĵo</B>, blarney, piece of -y (Jes 30/10, Da 11/32) (➞ <I>blag, kompliment</I>). <B>~ema</B>, adulatory. <B>~akiri</B>, <B>el~i</B>, <B>per~i</B>, win by flattery. <B>~logi</B>, cajole, coax, inveigle, wheedle. <B>Fi~ulo</B>, lickspittle, sycophant. ➞ <I>ramp</I>.", "0"],
["flaŭro", "flaŭr-o", "(<I>plantaro regiona</I>), flora. ➞ <I>faŭn</I>.", "0"],
["flava (~o)", "flav-a (~o)", "[UV] Yellow. <B>~a febro</B>, y-fever. <B>~malsano</B> (<I>iktero</I>), jaundice. (Ova) <B>~(aĵ)o</B>, yolk. <B>~eta</B>, -ish, pale yellow. <B>~iĝo</B> <I>de folio, papero</I> (Rd 28/22). <B>~haŭtulo</B>, mongol. <B>Brun~a</B>, buff, fallow, fulvous. <B>Griz~a</B>, beige. <B>Hel~a</B>, bright y. <B>Krom~o</B>, chrome y. (<I>plumba kromato</I>). ➞ <I>bej, fulv, oranĝ</I>.", "0"],
["flebito", "flebit-o", "= vejninflamo.", "0"],
["flegi", "fleg-i", "(<I>-n</I>), [UV] Nurs/e, look after, tend (invalid), <B>f</B> <I>~i ĝardenon, vojon, siajn interesojn</I>. <B>~(ad)o</B>, -ing. <I>Man~ado</I>, manicure. <B>~ato</B>, charge, patient. <B>~ejo</B>, infirmary. <B>~ist(in)o</B>, nurse, orderly. ➞ <I>nutr, vart, zoring</I>.", "0"],
["flegma", "flegm-a", "[UV] phlegmatic, cold-blooded, impassive, sluggish, stolid. <I>~a homo, karaktero, temperamento. Diskuti</I> <B>~e</B>. <B>~o</B>, apathy, stolidity. [Ne <I>= muko</I>]. <B>~ulo</B>, phlegmatic, dry stick. ➞ <I>apart, indiferent, inert, senpasi, malvarmsang, pez</I>.", "0"],
["flegmono", "flegmon-o", "(<I>abscesego</I>), phlegmon, inflammatory tumour. ➞ <I>furunk</I>.", "0"],
["fleksi", "fleks-i", "(<I>-n</I>) [UV] (<I>malrektigi</I>), (cause to) Bend, Curv/e, bow, flex, warp. <I>~i arbon, branĉon, dorson, korpon</I>. <B>f</B> break in, tame (<I>humiligi, malfierigi), cedigi, kormovigi, obeigi; ŝanceli</I>. <B>~a</B> <I>muskolo</I>, flexor. <B>~(ad)o</B>, bend, curve, flexion, turn, winding. <I>~o de muro, rivero, vojo</I>. <B>~aĵo</B> (<I>de vojo</I>) camber, curvature, hump. <B>~ebla</B>, <B>~iĝema</B>, flexible, pliable, yielding; lithe, pliant, supple, e.g., <I>kablo, kano, karaktero, kolo, lingvo, stilo</I>. <B>f</B> adaptable, docile, soft, tractable (➞ <I>duktil, elast, mol</I>). <B>~iĝi</B> (<I>nt) (kurbiĝi, sin fleksi</I>), accommodate one’s to, bow, give away, submit, warp, yield. <I>La branĉo, vojo ~iĝas. ~iĝi antaŭ forto, sub premo (Jes 42/4</I>). <B>~iĝo</B> <I>laŭaksa (proprema</I>), buckle. ➞ c<I>ed, submetiĝ</I>. <B>~iĝema</B> (<I>supple) kolo, spino</I>. <B>~ilo</B>, pliers, wire-er. <B>~ita</B>, c-ed arched, bent. <B>De~i</B>, deflect, <B>Ne~ebla</B>, inflexible, stiff, unbending. <B>Retro ~i</B>, straighten (<I>dorson</I>), throw out (<I>bruston</I>), <B>~~o</B>, retroflexion. <B>Sub~i</B>, bend down, depress, overwhelm, <B>Genu~i</B> (<I>surgenuiĝi</I>), kneel down. ➞ <I>arkig, fald, fleksi, inklin, klin, kurbiĝ, refleks(iv</I>).", "0"],
["fleksio", "fleksi-o", "[OA] (gram) inflexion. <B>~a</B>, inflected. <I>~a lingvo</I>. <B>~i</B> (<I>-n</I>), inflect. <I>~i vorton</I>. <B>Sen~a</B>, uninflected. ➞ <I>fleks</I>. opposite <I>aglutin, izol</I>.", "0"],
["fleo", "fle-o", "catstail (Timothy) grass (<I>Phleum</I>).", "0"],
["fleso", "fles-o", "(ich) flounder (<I>Pleuronectes flesus</I>).", "0"],
["fliki", "flik-i", "(<I>-n</I>), [UV] Patch, Darn, mend by -ing, piece together, repair. ~i <I>pacon, mapon de Eŭropo. Unu ~o sur alia. ~o nevidebla</I>. <B>~a</B> <I>frazo, vorto</I>, serving to fill gap. <B>~aĉi</B>, <B>fuŝ~i</B>, botch, bungle, tinker. <B>~aĵo</B>, <B>~peco</B>, patch, darn. <B>~aĵaro</B>, <B>~itaĵo</B>, patchwork. <B>Al~aĵo</B>, applique (trimming). <B>~eca</B>, <B>~oza</B>, patchy. <B>~ilo</B>, darning needle. <B>~ilujo</B>, housewife. <B>(Ŝu)~isto</B>, cobbler. <B>Kun~i</B>, piece together.", "0"],
["flikteno", "flikten-o", "(med) (&lt; <I>veziketo</I>), bleb, water-blister, vesicle.", "0"],
["flinto", "flint-o", "flint glass.", "0"],
["flirti", "flirt-i", "(nt) (<I>antaŭ, ĉe, de, kun, super, sur</I>) [UV]. <B>1</B> (<I>flugeti, flugilbati</I>): flit, flutter. <I>Birdo, insekto, papilio ~as</I>. <B>2</B> (<I>disbloviĝi</I>); float, fly, stream<I>. Flago, plumo, tuko, haroj ~as. ~i en la vento</I> (➞ <I>flagr</I>). <B>3</B> Flirt, coquet, dally, toy (➞ <I>amindum, koket, okulum</I>). <B>~ado</B>, flirtation. <B>~ul(in)o</B>, flirt. <B>~ado</B>, fluttering. <B>~igi</B> (<I>-n) (disblov, sving</I>): wave (flag, etc.). <B>~eca</B>, <B>~anima</B>, (<I>malkonstanta, malserioza</I>), fickle, flighty, mercurial. <B>Ĉirkaŭ~i</B>, flutter round.", "0"],
["flligrano", "flligran-o", "Filigree. <B>1</B> fine metal openwork. <B>2</B> similar frail delicate tracery. <B>~i</B>, ornament with f. <B>3</B> (<I>akvomark-o, -i</I>), watermark. <I>~o de bankbileto</I>.", "0"],
["floko", "flok-o", "[UV] Flak/e, flock, fluff, lock, wisp. <I>~o de fulgo, lano, vato</I>. <B>~(ec)a</B>, flaky, flocculent. <I>~a lito</I>, flock bed. <I>~aj nuboj,</I> fleecy clouds. <I>~a silko</I>, floss silk, silk waste. <B>~igi</B>, <B>-iĝi</B>, flake, flocculate. <B>Neĝ~o</B>, (<I>neĝero</I>), snow-f. <B>Sap~oj</B>, soap-flakes.", "0"],
["flokso", "floks-o", "Phlox, flame-flower.", "0"],
["floreno", "floren-o", "[OA] (num) florin (wide sense). <I>Brita ~o = du ŝilingoj</I>.", "0"],
["floro", "flor-o", "[UV] Flower, bloom, blossom, <I>~o apudvoja, kampa, sovaĝa</I>, wayside (field, wild) f. <B>f</B> <I>La ~o</I> (prime) <I>de juneco (la vivo</I>), <B>~a</B>, <B>~kovrita</B>, <B>~oplena</B>, -y, floral. <I>~a girlando, kampo</I>, <B>f</B> elaborately ornate, florid. <I>~a parolo, stilo</I>. <B>~i</B>, [UV] (<I>naski ~ojn</I>), bloom, blossom, <B>f</B> (<I>prosperi</I>), flourish. <I>Vivu kaj ~u! Unu ~as, alia ploras. Esperanto ~as ĉe ni</I>. <B>~ado</B>, -ing, <I>Plena ~ado,</I> full bloom. <B>~aro</B>, cluster of flower, raceme, etc. <B>~eco</B>, inflorescence, <B>~ejo</B>, f-garden. <B>~eto</B>, floret (Jes. 40/6). <B>~ingo</B>, f-holder. <B>~ujo</B>, <B>~poto</B>, <B>~vazo</B>, f-pot, f-vase. <B>~desegna</B>, -ed. <B>~domo</B>, greenhouse. <B>~vendisto</B>, florist, f-seller. <B>~bedo</B>, <B>~butiko</B>, <B>~ĝardeno</B>, <B>~kultivo. Dis~i</B>, <B>ek~i</B>, burst into f, open. <B>For~i</B>, lose bloom, shed flowers. <B>Sen~a</B>, -less. ➞ <I>kriptogam</I>. <B>Kruc~oj</B> (<I>kruciferoj</I>). <B>Memor~o</B> (<I>miozoto</I>). <B>Neĝ~o</B> (<I>edelvejso</I>). <B>sun~o</B> [UV] (<I>helianto</I>), sun-f.", "0"],
["floso", "flos-o", "[UV] raft, float, etc. Sendi per <I>~oj</I> (2 Kr 2/16). <B>~i</B> (<I>-n</I>), convey by raft or float. <I>~i ilin sur la maro</I> (1 Rĝ 5/9). <I>[Ne= flot]</I>. <B>~isto</B>, raftsman, <B>~ado</B>, rafting, timber-floating. <B>~ita</B> <I>ligno</I>, floated timber. <B>~umi</B> (<I>= floti</I>). ➞ <I>flot, naĝ</I>.", "0"],
["floti", "flot-i", "(nt) (<I>malsinki, resti aŭ drivi sur supro de likvaĵo</I>), Float (on something). <B>~anta</B>, -ing, afloat. <I>~anta bobelo, folio, ligno</I>. <B>f</B> <I>~anta doko, kargo, kapitalo</I>. <B>~aĵo</B>, something -ing, (fisherman’s) float, flotsam. <B>~igi</B> (<I>-n</I>), (cause to) float, launch, set afloat. <B>Nere~igebla</B>, hard and fast, <B>~ilo</B>, = <I>flotigaĵo de aviadilo, amfibio</I>. <B>~ekipaĵo</B>, (av) floatation gear. <B>~forto</B>, buoyancy. <B>~linio</B>, <B>~nivelo</B>, waterline mark. <B>~kapabla</B>, able to float. <B>~reta</B> <I>ŝipo</I>, drifter. <B>En~i</B>, float in. <B>For~i</B>, f. away. <B>Dors~i</B>, f. on one’s back. ➞ <I>driv, flos, naĝ, ŝveb</I>.", "0"],
["floto", "flot-o", "= ŝiparo, fleet.", "0"],
["flugi", "flug-i", "(nt), [UV] Fly. <I>Aviadisto, birdo, in sekto, nubo ~as</I>. <B>f</B> (<I>~kuri, ~veturi, ~rapidegi</I>), rush. <B>~(ad)o</B>, flight, flying. <B>~e</B>, in flight. <B>(For)~ema</B>, evanescent, fugitiv. <B>1</B> (<I>kiel birdo</I>). <B>2</B> (<I>vaporiĝema</I>). <B>~eti</B> (<I>Duon~i</I>), flutter. <B>~igi</B> <I>kajton</I>, fly a kite. <B>~ilo</B>,, [UV] pinion, wing. <I>~ilhava</I>, winged (Ge 7/14). <I>Insekto duflugila, senflugila, skvamflugila</I> = dipterous, apterous, lepidopterous. <I>Riĉeco faras al si ~ilojn</I> (Se 23/5). <B>~isto</B> (<I>aviadisto</I>), airman, <B>~boato</B>, -ing boat. <B>~maŝino</B> (<I>aviadilo</I>). <B>~pova</B>, capable of flight. <B>Dis~i</B>, <B>El~i</B>, <B>En~i</B>, <B>Super~i</B>, <B>Tra~i</B>, <B>Trans~i</B>, fly in all directions, (out, in, over, through, across). <B>Ek~i</B>, take flight (wing) <B>For~i</B>, fly away. (<I>malaperi). Juneco, vivo ~~as. ~~igi</I> put to flight. <B>Glit~i</B> (<I>glisi</I>). <B>Plen~e</B>, in full flight. <B>Supren~i</B>, soar (➞ <I>sor</I>). ➞ <I>aervetur, flirt, flor, flu, fuĝ, kur, naĝ, ŝveb</I>.", "0"],
["flui", "flu-i", "(nt), [UV] Flow, glide along, move easily, stream (pass) away. <I>~i rivere, torente. ~as rivero, sango, la vivo, larmoj, ondoj, vortoj. ~anta akvo</I>, running water. <B>~o</B>, <B>1</B> flow, current, flux. <I>Akva ~o,</I> current of water, <B>f</B> <I>~o de penso, tempo. Elektra ~o (kurento). Kirl~o</I>, eddy. <B>2</B> gush, stream. <I>Mara ~o (tajdo</I>). <B>~a</B>, flowing, easy, fluent, smooth. <I>~a stilo</I>. <B>~e</B> <I>legi, paroli</I>. <B>~eco</B>, fluency, -idity. <B>~ego</B>, flood, rush, torrent, <B>~ejo</B>, bed, channel, course, ditch. <B>~eti</B>, drip, trickle. <B>~forma</B>, <B>~linia</B>, stream-lined. <B>(Ek)~igi</B> (<I>alkrani, malfermi</I>), turn on (gas, water), <B>~ilo</B>, gully, spout. <B>Al~o</B>, f., flood, rising (➞ <I>flus). Al~a</I>, affluent. <I>Sang~~o</I>, congestion of blood. <B>De~o</B>, <B>for~o</B>, ebb. <I>Al- kaj forfluo</I>. <B>de~ilo</B>, [UV] drain, gutter. <B>El-o</B>, out-f, effusion, issue. <I>Sang~~o</I>, hemorrhage, <I>~~ejo</I>, discharge, outlet. <I>~~eti,</I> ooze, seep. <B>En~o</B>, influx. <B>For~i</B>, elapse (time). <B>Kontraŭ~e</B> (<I>monten</I>), upstream. <B>Kun~i</B>, unite. <B>Laŭ~e</B>, down-stream. <B>Post~o</B>, wake. <B>Preter~i</B>, flow past. <B>Re~o</B>, ➞ <I>malflus</I>. <B>Sen~a</B> (<I>stagna</I>), stagnant, still. <B>super~a</B> [UV] (<I>malmanka</I>), in excess, overflowing, superfluous (El 16/23). <B>Tra~eti</B>, leak, percolate (<I>liki</I>). <B>Netra~ebla</B>, water-tight. <B>Trans~iĝo</B>, transfusion. <B>Rapid~o</B>, swift flowing, rushing.", "0"],
["fluida", "fluid-a", "[UV] Fluid, running, that flows. <B>~o</B>, fluid (<I>gaso, likvaĵo</I>). <I>Akvo kaj aero estas ~oj</I>. <B>~aĵo</B> (Alt 5/5). <B>~igi</B>, melt. ~~i <I>glacion, neĝon</I> (➞ <I>degel, fand, likvig</I>). <B>~iĝi</B>, become fluid, melt. <B>Mal~a</B> (<I>densa, kompakta, solida</I>). <B>~~iĝi</B>, coagulate. ➞ <I>koagul, likv</I>.", "0"],
["flukso", "fluks-o", "(ph) Flux. ~o <I>elektra, luma, magneta, vektora</I>. <B>~denso</B>, flux-density.", "0"],
["fluktui", "fluktu-i", "fluctuate, vary irreg-ly, rise and fall, waver. <B>~(ad)o</B> <I>de temperaturo</I>.", "0"],
["fluoreski", "fluoresk-i", "(opt) be Fluorescen/t, <B>~o</B>, -ce. <B>~a</B>, -t. <I>~a ekrano</I>. ➞ <I>fosforesk, reftekt</I>.", "0"],
["fluoro", "fluor-o", "(chem) Fluor/ine (F). <B>-ito</B>, <B>-spato</B>, -ite, -spar (<I>kalcia ~ido</I>).", "0"],
["fluso", "flus-o", "(<I>alflua tajdo</I>), flood (tide), <B>~i</B>, flow (tide), <B>~akvo</B>, <B>~fluo</B>, tidal water. <B>Mal~o</B> (<I>forfluo</I>), ebb. ➞ <I>almar, flu, tajd</I>.", "0"],
["flustri", "flustr-i", "(<I>-n, al, pri, abs</I>) [OA], Whisper. <B>~o</B>, w. <I>Lia voĉo estas nur ~o en uragano</I>. <B>f</B> hint, rumour. <B>~ado</B>, soft rustling sound. <I>~ado de folioj, ondo</I>. <B>~isto</B>, (Jes 8/19). ➞ <I>murmuret, suflor, susur</I>.", "0"],
["fluto", "flut-o", "[UV] Flute. <I>~o paŝtista</I>, reed, shepherd’s pipe (Ge 4/21). <B>~i</B>, (play the) f. <B>~eca</B>, <B>~sona</B>, -y. <B>-eto (</B><I>okta ~o</I>), piccolo. B b<I>~eto, (fifro</I>), fife. <B>~isto</B>, flautist. <B>Bas~o</B>, bass f. Bek<B>~o</B>, recorder, Apple f. (opposite <I>~o transversa</I>) (➞ <I>flaĝolet). Bek~o lerneja</I>, school recorder. <B>Lad~o</B> (<I>metala bek~o</I>), tin whistle. <B>Pan~o</B>, Pan’s pipes.", "0"],
["Fo", "F-o", "[F], letter F. (ac) 698 • 46 vibroj sekunde. <B>F-is (F diesa)</B>, F sharp. <B>~klefo</B>, (<I>basklefo</I>), bass clef. <B>~truoj</B>, (vn) F-(sound-)holes.", "0"],
["fobio", "", "phobia (<I>= timo</I>). <B>Hidro~o</B> (<I>akvo- timo</I>), hydro-p. similar, <B>agorafobio</B>, <B>klostrofobio</B>.", "0"],
["foceno", "focen-o", "(<I>marporko</I>), porpoise (<I>Phoe- caena</I>). <B>Pilota(or nigra )~o</B>, pilot whale, round-headed p. (<I>Globicephala</I>). ➞ <I>delfen, balen</I>.", "0"],
["foino", "foin-o", "beech (or stone) marten (<I>Martes foina</I>). ➞ <I>martes</I>.", "0"],
["foiro", "foir-o", "[UV] (periodical) Fair, Market. <I>Brut~o, ĉeval~o, Universala ~o</I>, universal exhibition. ~a <I>halo</I>, covered market. <I>~a prezo</I>, current price, m-rate. ~ejo, (<I>~a placo</I>), f-ground, m-place. ➞ <I>bazar, merkat</I>.", "0"],
["fojno", "fojn-o", "[UV] Hay. <B>~(far)i</B>, make hay. <B>~ado</B>, h-making. <B>~ejo</B>, hay-loft. <B>~isto</B>, hay-maker. <B>~ujo</B> (<I>raŭfo</I>), h-rack. <B>~amaso (~stako)</B>, hayrick (haystack). <B>~amaseto</B>, h-cock. <B>~astmo</B>, <B>~febro</B>, h-fever. <B>~</B><I>forko, ~kampo, ~rikolto, ~sako</I> <B>~sezono</B>, h-making season. <B>~fomo</B>, h-box. <B>Post~o</B>, late hay, aftermath, second crop.", "0"],
["fojo", "foj-o", "[UV] Time (of occurrce, repetition), Occasion. <I>~on post ~o</I>, t. after t. <I>Unu ~on por ciam</I>, once and for all. <I>Cxiun ~on,</I> on every o. <B>Ali~e</B>, at another t., on another o. <B>Ankoraŭ~e</B>, once more. <B>Cxi~e</B>, this t. <B>ĉiu~e</B> kiam, when ever. <B>Dek~e</B>, ten times. (Ge 31/7, 41). <B>Divers~e</B>, on various oo, many a time. <B>Du~e</B>, twice. <B>iu~e</B>, at times, from t. to t., now and then, o-ally, sometimes. <B>Kelk~e</B>, repeatedly, several times. <B>Kiom~e</B>, how often? <B>Last~e</B>, for the last t., on the last o. <B>Mil~e</B>, a thousand times. <B>Mult~e</B>, many times, often, repeatedly. <B>Plur~e</B>, more than once. <B>Re~e</B> (<I>denove</I>), once again (more). <B>Tiom~e</B>, so often. <B>Unu~a</B>, single. <I>~~a kuro</I> (4 FA 63/2). <B>~~e</B>, once, on one o. <B>Unua~e</B>, at the first, on the first o. <B>Rim</B>.: Sometimes foje is used alone (<I>= iam</I>) This is not Z, and is inadvisable; though perhaps <I>foje kaj refoje</I> might translate \"t. and t. again\". If difference between -foje and fojo(j): fojo(j) is stronger = times over, one after the other (➞ <I>dozen</I> and <I>twelve). Tio okazis tri ~ojn</I>. ➞ <I>hor, obi, temp</I>. <B>Rim</B>.: <I>Ne unu~e (Ne unu ~on</I>) may mean (a) More than once, (b) Not even once. Say (a) <I>Pli ol (or Ne nur) unu<B>~e</B></I>, (b) <I>Eĉ ne unu~e</I>.", "0"],
["foko", "fok-o", "[UV] Seal (<I>Phoea</I>). <B>Elefanta ~o</B> (elephant-s, s-elephant). <B>Griza ~o</B>, grey s. (<I>Haliehoerus</I>). <B>~o Gronlanda. ~o ringa. ~ĉasado. ~ŝipo</B> -er. <B>~felo</B>, s-skin. <B>~oleo</B>, s-oil. ➞ <I>haliker, otari</I>.", "0"],
["fokseno", "foksen-o", "(ich) minnow (<I>Phoxinus</I>).", "0"],
["fokstroto", "fokstrot-o", "(dance) fox-trot.", "0"],
["fokuso", "fokus-o", "[UV] Foc/us (wide sense) <B>f</B> (<I>centra punkto), centro de atak-(atent-interes -viv-)o</I>. <B>~i</B> (put in) f. <B>~a</B>, -al. <I>~a ebeno,</I> -al plane. <I>~a distanc-(lini-)o</I>. <B>Du~a</B>, bi-al. <B>En~igi</B> (<I>objektori). En~iga lenso</I>. <B>Sam~a</B> <I>distanco, longo, profundo, punkto</I>.", "0"],
["folado", "folad-o", "(<I>borkonko</I>), (zoo) piddock (<I>Pholas</I>).", "0"],
["foldo", "fold-o", "(<I>laŭlonga entranĉo, ŝovsulko</I>), Groove, slot (in metal, wood, etc.), channel, furrow, rabbet, (astr) rille on moon [N<I>e~~fald</I>], <B>Glit~o (ŝov~o)</B>, slide-groove, slipper-guide (<I>por kuliso, tabulo, tirkesto</I>). ➞ <I>glitrel</I>. <B>Lubrika ~o</B>, oil g. <B>Piŝta ~o</B>, piston groove. <B>~i</B>, groove, rabbet. <B>En~igi</B>, embed, set (tail) in. ➞ <I>junt, kanel, mortez, sulk, tenon</I>.", "0"],
["folianto", "", "(typ) in-folio.", "0"],
["foliklo", "folikl-o", "follicle.", "0"],
["folio", "foli-o", "[UV] Leaf (of plant, paper); flap, shutter (of screen, table); foil (<I>metal</I>); folio (2 opposite pages with same number); sheet, (typ) <I>~o interrnita</I>, interleaf, slip sheet. <B>~(oriĉ)a</B>, leafy, covered with leafs, verdant. <B>~aĵo</B>, <B>~aro</B>, foliage. <B>~ego</B> (<I>plen~o</I>). folio (size). <B>~ero</B>, follicule (<I>foliolo</I>). <B>~eto</B>, 1-let, blade (small 1), slip of paper (➞ <I>slip</I>). <B>~igi</B> (<I>platigi) metalon</I>. <B>(Ek)~iĝi</B>, burst into 1. <B>~ingo</B>, 1-sheath. <B>~umi</B>, turn over leaves (of book), <B>Al~(Krom~)o</B> (<I>alonĝo). Kun</I> <B>inter~oj</B>, inter-ed. <B>Sen-a</B> (<I>nuda</I>), -less, bare. <I>Sen~iĝi</I>, shed 11. <B>Du~a</B>, double -ed, e.g., table. <B>Flor~o</B> (<I>Petalo</I>). <B>Flug-o</B>, fly-1, handbill, tract. <B>KaIik~o</B> (<I>sepalo</I>). <B>Kon- traŭ~o</B>, <B>kontrol~o</B>, counterfoil. <B>Kvaron~o</B>, quarto. <B>Kvin~o</B> (<I>potentelo</I>). <B>Larĝ~a</B>, broad<B>-ed</B>. (<I>Libro</I>) <B>liber~a</B>, loose-1. <B>Mil~o</B>, milfoil, yarrow (<I>akileo</I><B>). Model~o</B>, (dress) pattern. <B>Okon~o</B>, octavo. <B>Pinglo~o</B>, pine-needle. <B>Stan~o (</B><I>staniolo</I>), silver- paper, tinfoil.", "0"],
["foliolo (", "", "<I>foliero</I>), (bot) foliole.", "0"],
["folkloro", "folklor-o", "folk-lore. ➞ <I>etnologi, tradici</I>. <B>foment-i</B> (<I>-n</I>), (med) Foment, <B>f</B> foster, stimulate. <B>~aĵo</B> (<I>~a kompreso</I>), -ation.", "0"],
["fondi", "fond-i", "(<I>-n</I>) [UV]. Found. <B>1</B> (<I>estigi, krei</I>): establish, institute. <I>~i famili-(urb-)on. <B>2</B> (bazi, fundamenti, motivi</I>): base, ground. <I>~i argument-(ppini-)on (sur</I>). <B>~aĵo</B>, (a) -ation. (b) fund (<I>fonduso</I>). <B>~igi</B>, be -ed (rely, rest) on. <B>~into</B>. -er. ➞ <I>dediĉ, fundament, konstituci, starig</I>.", "0"],
["fonduso", "fondus-o", "Fund, reserve for special purpose. <I>~o amortiza</I>, sinking f. <I>~o sekreta,</I> secret service f.", "0"],
["fonemo", "fonem-o", "(phon) phoneme.", "0"],
["fonetiko", "fonetik-o", "[OA] Phonet/ics. <B>~a</B>, -ic. <I>~a alfabet-(skrib-)o</I>. <B>~ismo</B>, sound of words, <B>as</B> compared with spelling. ➞ <I>grafism</I>. <B>fono-</B> Phono- (Gr ppfx). <B>-GRAFO</B> (<I>parolmaŝino</I>), -graph (➞ <I>gramofori</I>). <B>II</B> similar <B>~grafio</B>, <B>~gramo</B>, <B>~logio</B>, <B>~metro</B>.", "0"],
["fono", "fon-o", "[OA] <B>1 (</B><I>malantaŭo</I>), (background, (her) field. <B>2</B> (ac) phon. <B>3</B> Abbreviation for (<I>tele)fono</I>.", "0"],
["fontanelo", "fontanel-o", "fontanelle, gap in baby’s cranium.", "0"],
["fontano", "fontan-o", "[UV] Fountain (artificial, spouting, throwing a jet). <B>Ŝpruc~o</B>, jet of water. ➞ <I>font, spruc</I>.", "0"],
["fonto", "font-o", "[UV] Fount(ain-head), (well) Spring, source. <B>~o de petrolo</B>, <B>rivero. ~oj de la abismo</B>, f-ains of the deep, <B>f</B> <I>~o de energio, enspezo, inspiro, vivo</I>. <B>~i</B> (el) (deveni de), arise, sring (well) out (of), up (from). <B>Olea ~o</B>, oil-s. <B>Sal~o</B>, salt-spring. <B>Ŝpruc~o</B> (gejzero). ➞ <I>deven, fontan, origin, plum, put</I>.", "0"],
["for", "", "[UV] (adv) Away, forth, off (denotes disappearance or distance). <I>Du paŝojn</I> two steps away. <I>La digo estis</I> the dyke was gone. ~ (<I>de ĉi tie)!</I> Away with you! Avaunt! Begone! Be off! Depart! Get out! (Jes 30/22). <I>~ de danĝero, la koro, mondo. ~ kun milito! (~ militon!</I>), Away (Down) with war. <I>~ la manoj(n)!</I> Hands off! <B>~a</B>, distant. <I>~a angulo, horizonto, kolonio. Veni de</I> <B>~e</B> (from far a.). <I>Vojaĝi</I> <B>~en. ~aĵo</B>, <B>~eco</B>, distance. <B>~igi</B>, abolish, clear away, eliminate, get rid of, remove. <I>~igi dubon, makulon, timon. Neĝ~igilo</I>, snow-plough. ➞ <I>likvid</I>. <B>~iĝi</B>, pass a., disappear, vanish. <B>Antaŭ~iga</B>, preventive, prophylactic. <B>Ne~igebla</B>, fixed, indelible, irremovable. <I>PFX</I> <B>For-</B>, Away. <B>1</B> (<I>malproksime</I>, answers Kie?): ~esti, ~resti, = <I>esti (resti) for. ~esto</I>, absence. <B>2</B> (<I>malproksimen</I>, answers Kien?): forth, into the (to a) distance. <B>~iri</B>, depart; <B>~kuri</B>, flee. <B>~naĝi</B>, <B>~vojaĝi. ~blovi</B>, <B>~doni</B> (<I>-n) = iri, blovi… foren</I>. <B>3</B> (<I>malapero): ~bruli, ~morti, ~pasi, ~velki</I>. <B>4</B> (<I>malaperigo): ~dormi, ~froti, ~ludi, ~streki (-n</I>), <B><I>~</I>akrigi</B> <I>noĉetoĵn</I>, sharpen away notches. <B>~perdi</B> <I>tempon</I>, waste time. <B>~aĉeti</B>, <B>~bruligi</B>, <B>~manĝi</B>, <B>~trinki</B> (<I>-n</I>), buy (burn, eat, drink) up. somewhat idiomatic expressions: <B>~lasi (a)</B> = abandon, forsake, leave; <B>(b)</B> (<I>= eksterlasi</I>): leave out, omit. <B>~permesi</B> (<I>-n</I>) [OA], give leave (of absence) to. <B>~regali</B>, give a send-off to. ➞ <I>perd, pas</I>.", "0"],
["foralio", "forali-o", "(bot) New Zealand flax (<I>Phormium tenax</I>).", "0"],
["forcepso", "forceps-o", "forceps (➞ <I>akuŝil, eltiril</I>).", "0"],
["forci", "forc-i", "(artificially hasten maturity), (hort) Forc/e. <B>~ado</B>, -ing. <B>~ejo</B>, -ing house, <I>Varma ~ejo</I>, hothouse. <I>Unuflanka ~ejo</I>. lean-to-house.", "0"],
["forfikolo", "forfikol-o", "earwig (<I>Forficula</I>).", "0"],
["forgesi", "forges-i", "(<I>-n, pri, abs</I>), [UV] Forget. <B>1</B> (<I>perdi memoron, ne memori</I>): <I>~i averton, daton, instruon. Buŝo promesas, mano ~as</I>. <B>2</B> <I>ne atenti, pensi, zorgi pri, preterlasi</I>: neglect, overlook. ~i <I>amikon, devon, Dion, patrinon, sperton</I>. <B>3</B> forget and leave: <I>monujon en la domo, hejme</I>. <B>~o</B>, forgetfulness, forgetting, oblivion. <I>Plena ~o</I>. <B>~ejo</B>, oubliette. <I>Meti en ~ejon</I>, consign to oblivion. <B>~ema</B>, with short memory. <B>~igi</B> (<I>iun pri io, ion al iu</I>), cause to f. (be forgotten), blot out, efface (obliterate) from memory. <B>~inda</B>, not worth remembering. <B>Ne~ebla</B>, unforgettable. <B>Nemin~u</B> (<I>miozoto</I>). <B>Sin~o</B> (<I>altruismo, malegoismo</I>), self-forgetfulness. ➞ <I>enterig, entombig</I>.", "0"],
["forĝi", "forĝ-i", "(<I>-n</I>), [UV] Forge, work in metal. ~i <I>glavon, hufferon</I>. <B>~ita</B> <I>fero</I>, wrought iron, <B>f</B> (<I>Ellabori, krei</I>); <I>~i argumenton, sian sorton</I>. <B>f</B> (<I>hardi, malmoligi</I>): <I>~i karakteron</I>. <B>~ebla</B>, forgeable, malleable (➞ <I>duktil</I>). <B>~ejo</B>, f. smithy. <B>~isto</B>, (black)smith. <B>Al-i</B> (<I>-n</I>) (fiksi, firmigi, senmovigi), forge (weld) to. <B>~ita</B> <I>al la lito</I>, bedridden. <B>Kun~i (</B>veldi), weld together. <B>Ŝu~isto</B>, farrier.", "0"],
["forko", "fork-o", "[UV] Fork, prong, <B>f</B> (duiĝejo); ~o de arbo, branĉo, relo. <B>Manĝ~o</B> (<B>~eto</B>), table-fork. <B>Piĉ~o</B>, <B>son~o</B>, tuning-f. <B>Rem~o</B>, rowlock. <B>Trak~o</B>, (ry). <B>~~isto</B>, pointsman, <B>Tri~o (</B>tridento), trident. <B>Voj~o</B>, junction. <B>~i</B> (<I>-n</I>), (pick up with) f. Star-(sid-)i <B>~e</B>, stand (sit) astride, straddle. <B>~eca</B>, <B>~hava</B>, -ed. <B>~ego (</B>fojn~o), pitch-f. <B>-dento</B>, point, prong, tine. <B>(Dis)~iĝi</B>, bifurcate, branch off, split. ➞ <I>brak, brant, kruc</I>.", "0"],
["formacio", "formaci-o", "(<I>formitaĵo</I>), formation. <B>1</B> (geol., ➞ <I>epok, tavol</I>). <B>2</B> (mil) ➞ <I>ord</I>.", "0"],
["formala", "formal-a", "<I>[OA],</I> Formal. <B>1</B> (<I>laŭforma, priforma, de formo</I>; opp <I>esenc</I>), of outward form. ~a <I>demando, diskuto, rajto</I>. <B>2</B> (<I>laŭkutima, laŭregula</I>), <I>conforming to rule</I>. ~a <I>kontrakto, raporto</I>. <B>3</B> (<I>ceremonia, konvencia</I>), <I>conventional, perfunctory, prim, stiff</I>. ~a <I>akcepto, vizito</I>. <B>4</B> (<I>precize esprimita</I>), ~a <I>opinio</I>.<I> <B>~e</B>, formally, in due form. <B>~aĵo</B>, -ity, requirement</I>. <I>Jura</I> <B>~aĵo</B>. <I><B>~eco</B>, -ity, precision, propriety. <B>~ema</B>, ceremonious. <B>~igi</B>, -ize. <B>~ismo</B>, -ism. <B>~isto</B>, <B>~ulo</B>, -ist (➞ pedant</I>).", "0"],
["formaldehido", "formal/-dehido", "<B>~ino</B>, (chem) formal-de- hyde, -in.", "0"],
["formato", "format-o", "[OA] (<I>dimensioj</I>), format, shape and size of book, etc. <B>Dekduon~o</B>, duodecimo. <B>Duon~o</B>, dufolio. <B>Kvaron~o</B>, quarto. <B>Okon~o</B>, octavo. <B>Poŝ~o</B>, pocket size.", "0"],
["formiko", "formik-o", "[UV] Ant, emmet (<I>Formica</I>). <B>Blanka ~o</B> (<I>termito</I>), white ant. <B>~a</B> <I>laboremo, persisto</I>. <B>~aro</B>, swarm of ants. <B>~ejo</B>, a-hill. <B>~leono</B>, a-lion (<I>mirmeleono</I>), <B>~ovoj</B>, <B>~larvoj</B>, a’s eggs, <B>~osento</B>, (med) formication, pins and needles. <B>~urso</B>, a-bear (<I>mirmekofago</I>).", "0"],
["formo", "form-o", "[UV] Form. <B>1</B> shape, exterior, visible aspect. <I>~o de meblo, objekto, vazo. En (sub) ~o de alegorio, karikaturo, piramido</I>. <B>2</B> Manner (mode) of presentation, arrangement, style; method, order; kind, species, variety. <I>~o de parolo, rigardo, puno, vorto. ~o gramatika</I>. <B>3</B> (good, proper), form, customary behaviour. <I>Observi la ~ojn</I>. <I>Pro~a protesto</I>. <B>4</B> (mus) ~o <I>muzika, rondela, sonata</I>. ~o <I>duera, duparta, dusekcia</I>, binary form. <B>5</B> (phi) form, opposite <I>materio</I>. <B>~i</B> (<I>-n</I>), <B>1</B> (<I>estigi, krei, fari</I>) (Jes 44/24); form, fashion, make, mould: <I>~i aliancon, poemon, poton, vorton</I>. conceive; ~i <I>ideon, juĝon</I>. discipline, train; ~i <I>karakteron</I>. <B>2</B> (<I>konsistigi</I>): assume, take the form of. <I>Stratoj ~as angulon, infanoj rondon, vicon, vaporo nubon</I>. (<I>esti</I>): <I>~i parton</I> (= <I>esti parto</I>) de. <B>~ado</B>, <B>(~aĵo)</B>, <B>~iĝo</B>, formation (➞ <I>formaci</I>). <B>~iĝi</B>, take f. <B>~ilo</B> (<I>matrico, muldilo</I>). <B>Ŝu~ilo</B>, shoe-last. <B>~ujo</B>, mould (for jellies, etc.) (➞ <I>muld</I>). <B>Ali~iĝi</B> (<I>ŝanĝiĝi</I>), change form. <B>Pra~o</B> (<I>~o originala, primitiva</I>). <B>Re~i</B>, f. again, reconstitute, remodel, (➞ <I>reform</I>). <B>Laŭf~a</B> (<I>formala</I>). <B>Mis~i</B>, misform. <B>Mis~a</B>, misshapen, <B>Trans~i</B> (<I>en -n</I>), transform; (el) <B>~~ilo</B>, tranformer. <B>Sen~a</B>, f<B>-</B>less, chaotic. <B>Ark~a</B>, <B>kor~a</B>, <B>pir~a</B>, <B>tas~a</B> etc.; -form, -shaped, -like. (➞ <I>-ojd</I>). <B>Unu~a</B>, uniform (➞ <I>homogen, monoton, senvari, uniform</I>). <B>Unu~eco</B> <I>de stilo</I>. ➞ <I>aranĝ, blanked, deform, eksteraj, fason, figur, manier, model, ord, reform, stil</I>.", "0"],
["formulo", "formul-o", "[OA] formula. <B>1</B> (ch, mat, etc.) definition, principle, rule, tabulation, etc., expressed in figures and symbols, (cul) recipe. <B>2</B> set form of words. <I>~o de furo</I>. <B>~i</B> (<I>formdoni, tekstigi, vortigi</I>), formulate, express in (reduce to) formula, set forth systematically. <I>~i demandon, deziron, opinion, respondon</I>. <B>~aro</B>, -ary, collection of formulas, book of prescribed forms. ➞ <I>blanked, formal, redakt</I>.", "0"],
["fornelo", "fornel-o", "cooking-stove or oven. ➞ <I>forn</I>.", "0"],
["fornikso", "forniks-o", "(anat, zl), fornix. ➞ <I>arkaĵ, volb</I>.", "0"],
["forno", "forn-o", "[UV] (wide sense) Furnace, Oven, Stove. <I>Gas~o, Elektra, petrola ~o</I>. <B>1</B> (<I>kuir~o</I>) (a. <I>fornelo): bak~o</I>, oven. <B>2</B> (<I>industria): Blov~o</I>, blast-f. <I>Fand~o</I>, smelting-furnace. <I>Forĝ~o, lut~o, pudlo~o, ŝakt~o</I>. <B>3</B> (<I>sekiga</I>): Kiln. <I>Brik~o</I>. <B>4</B> (<I>hejt~o</I>, a. <I>stovo</I>): stove. <B>~a</B> <I>fero, forko, fumo</I> (Ge 15/17). <B>~ego</B>, fiery furnace. <B>~ejo</B>, bake-house, wash-house with copper, <B>~kesto</B> (<I>bakujo</I>). <B>~sida</B>, chilly, stay-at-home. <B>Rim</B>.: Waringhien proposes (a) <B>fornelo</B> (<I>kuira ~o</I>), cooking o. or s. <I>~o alkohola</I>, spirit s. <I>~o Angla (~bloko</I>), kitchener, kitchen range. <I>~a plato</I>, chafing dish, plate warmer, kitchener top. (b) <B>stovo</B> (<I>hejt~o</I>), heating s. (c) <B>primuso</B>, \"primus\", s. using vaporized oil for cooking.", "0"],
["forsitio", "forsiti-o", "(bot) golden bell, (<I>Forsythia</I>).", "0"],
["forsto", "forst-o", "cultivated forest. <B>~umi</B>, afforest. <B>Re~umo</B>, reafforestation. <B>-kulturo</B>, sylviculture.", "0"],
["forta", "fort-a", "[UV] Strong (wide sense). <B>1</B> (<I>efika, potenca</I>): efficacious, energetic, forcible, powerful. <I>~a argumento, brako, esprimo, homo. Mano, memoro, vento, volo</I>. <B>2</B> (<I>daŭrema, fortika, firma</I>): durable, firm, robust, solid, stable, stout, tough. ~a <I>bastono, karaktero, kofro, konstitucio, sano. ~aj nervoj</I>. <B>3</B> (<I>altgrada, intensa</I>): heavy, vigorous, violent; bad, severe (<I>doloro</I>), hearty (<I>apetito). ~a bezono, diferenco, febro, grado, kolero, lumo, sento, tuŝo, voĉo</I>. <B>4</B> (opp <I>diluita): ~a biero, cigaro, dozo, kafo, teo</I>. <B>5</B> (<I>akcentita</I>): (mus, pros) <I>~a puko, silabo</I>. <B>~e</B> (<I>altgrade, multe</I>) -ly, emphatically, greatly, hard, very much. <I>~e ami, dubi, senti, voli; ~e pluvis</I>, it rained hard. <I>Staru (tenu vin) <B>~e</B></I>, Stand firm (Jes 35/4). (mus) <I>forte!</I> <B>~o</B> force, might, power, strength, etc. <I>Havi (montri) ~on. Mankas la ~o. Hodiaŭ ~o, morgaŭ morto. Per ĉiuj ~oj (tut~e</I>), with all one’s strength, might and main, <I>Per propra (tuta) ~o. ~o alcentrokura, decentrokura</I>. (ph) anything able to make or modify movement. <I>~o elektromova, inerta, mekanika, molekula, prema</I>. <B>Akvo~o</B>, hydraulic power. <B>Ĉeval~o</B> (<I>ĉevalpovo</I>), H.P. <B>Lig~o</B>, cohesion. <B>Pez~o</B> (<I>gravito</I>). (pol) <I>~o mara, milita</I>. <B>~aĵo</B> (<I>~a flanko</I>), forte, strong point. <B>~eco</B>, intensity. <B>~ega</B>, mighty, vehement, violent. <B>~ege</B> (mus) fortissimo. <B>~egulo</B>, ➞ <I>Herkul</I>. <B>~igi</B>, fortify, strengthen. <I>~igilo</I> (med, phot, tech). <B>~uzo</B>, exertion, effort. <B>Mal~a</B>, Weak; dim, dull, faint, feeble, infirm, tender. <I>~~a ĉe muziko</I>, weak in music.<I> <B>~</B><B>~aĵo</B></I>, weakness. <B>Ne~a</B> (<I>delikata, malfortika</I>): delicate, frail, gentle, (s)light. <I>~~a framo</I>. <B>Per~a</B>, forcible, outrageous. <I>~~a morto</I>, violent death. <I>~~o</I>, violence. <I><B>~</B><B>~e</B></I>, by force, perforce. <I>Eniri</I> <B>~~e</B>, break in. <I>Postuli ~~e. ~~i (= ~~e devigi</I>) assault, do (offer) violence to, force, outrage, violate. <I>~~i infanon, virinon, volon. ~~ulo</I>, tyrant. <B>Re~iĝi</B>, recover strength. <B>Sen~a</B>, impotent. <I>~~igi</I>, debilitate, enervate, enfeeble, weaken. <B>Super~i</B>, master, overcome, overpower, overwhelm), prevail against, subdue. <B>~~o</B>, pre-dominance, pre-ponderance. ➞ <I>fortik pov</I>.", "0"],
["fortepiano", "", "[UV] (col. abbreviation piano), piano(forte).", "0"],
["fortika", "fortik-a", "[UV] (<I>rezistokapabla</I>), firm, hefty, resistent, robust, solid, stable, stalwart, strapping, sturdy, <B>f</B> <I>~a amikeco, firmo, sano, volo. Ligi, stari</I> <B>~e</B>. <B>~aĵo</B> [UV] (a. <I>fortreso</I>), fortress, fortification, <B>f</B> stronghold. <B>~aĵeto</B>, fort. <B>~eco</B>, power of resistance. <B>~igi</B>, strengthen structurally, mentally, morally, confirm, consolidate, corroborate, fortify, intensify, stiffen. <I>~igi armeon, muron, opinion, urbon</I>. <B>Mal~a</B> (<I>delikata, kaduka, neforta</I>), frail, infirm, shaky, unsubstantial. <I>Mal~ulo</I>, weakling. <B>Pli~igi</B>, reinforce. ➞ <I>fer, fort, rok, ŝtal</I>.", "0"],
["fortuno", "fortun-o", "fortune. <B>1</B> goddess of chance. <B>2</B> chance, hap, luck; especially good luck, prosperity. <I>Provi, serĉi sian ~on</I>, try one’s luck, risk it. ➞ <I>destin, hazard, fat(al), feliĉ, sort, sane</I>.", "0"],
["forumo", "forum-o", "[OA] forum. <B>1</B> (Roman). <B>2</B> place of public discussion. <B>f</B> <I>la ~o de konscienco, scienco, publika opinio</I>. <B>~a</B>, forensic. <I>~a elokvento</I>. ➞ <I>kortum, tribunal</I>.", "0"],
["fosforo", "fosfor-o", "[UV] (chem) Phosphor/us (P). <I>~o blanka, ruĝa</I>, white (red) p. <B>II ~eska</B>, -escent. <B>~eski</B> (nt), be -escent. ➞ <I>fluoresk, luminesk, reflekt</I>. Combining form: <B>fosf-</B>, Phosph-. <B>~ato</B>, -ate. <I>Super~ato</I>. <B>~atacido</B>, -oric acid. <B>~ido</B>, -ide. <B>~aturio</B>, (med) -aturia. <B>~ino</B>, -ine. <B>~ito</B>, -ite. <I>~itacido</I>, -orous acid. <B>Hipo~ito</B>, hypo- ite.", "0"],
["fosgeno", "fosgen-o", "(chem) phosgene COCl<SUB>2</SUB> (<I>karbonila klorido</I>).", "0"],
["fosi", "fos-i", "(<I>-n, abs</I>), [UV] Dig, delve. <I>~i kanalon, kavon, puton, rokon, sablon, teron</I>. <B>f</B> (<I>profunde esplori, serĉi): ~i en aktaro, libro, en la cerbo, poŝo</I>. <B>~(aĵ)o</B>, ditch, fosse, hole, pit (➞ <I>put, sulk, tomb, tranĉe</I>) (1 Rĝ 18/35, Ps <I>5116</I>). <B>~ejo</B>, (➞ <I>minej</I>), diggings, excavations, mine, etc. <B>~ilo</B>, [UV] digging implement, e.g., spade (<I>plat~ilo</I>, a. <I>ŝpato</I>), <B>~ileto</B>, scoop, trowel. <B>Pik~ilo</B> (<I>pioĉo</I>). <B>~isto</B>, digger, ditcher. <B>~besto</B>, <B>~insekto. El~i</B> (<I>elterigi</I>), dig up, excavate. <I>Mekanika el~ilo, ~maŝino</I>, excavator. <B>En~i</B>, bury, dig in. <B>Pri~i</B> (<I>kampon</I>). <B>Sub~i</B> (-n, abs) (<I>sapei, submini</I>), insidiously attack, sap, undermine, <I>aŭtoritaton, potencon, reputacion, sanon</I>. <B>Bor~i</B>, burrow. <B>Fund~i</B>, dig deeply. ➞ <I>bor, fosili, kavig, min, plug, ŝovel</I>.", "0"],
["fosilio", "fosili-o", "(pal) Fossil. <B>~a</B> <I>eburo, konko, restaĵo</I>. <B>~iĝi</B>, -ize. <B>~hava</B>, <B>~oza</B>, -iferous.", "0"],
["fosto", "fost-o", "[UV] Post, vertical wooden or metal support, upright beam resting in ground; pier, pillar, pole, prop; upright (<I>de dratbarilo, palisaro</I>). <B>Alliga ~o</B>, (mar) ➞ <I>bit, bolard</I>. <B>Apoga ~o</B>, shore. <B>Enakva(grunda) ~o</B>, pile. <B>Funda ~o</B>, foundation pillar. Gol<B>~o</B>, goal p. (ry) <B>Gradienta ~o. Lamp~(Lum~)o</B>, lamp-p. (standard). <B>Lim~o</B>, frontier-p. <B>Lupola ~o</B>, hop-pole. <B>Montra ~o</B>, sign-p. <B>Pord~o</B>, jamb. <B>Retaja ~o</B>, (mar) trellis-mast. <B>Salt~o</B>, jumpg-pole. <B>Son~o</B>, (vn) sound-p. <B>Start~o</B>, startg-p. <B>Telegrafa ~o</B>, tel. pole. <B>Ten-o</B>, (bid) central p. (king truss). <B>~eto</B>, picket, stake, etc. <B>Sur~a</B> <I>domo</I>, pile dwelling. ➞ <I>baston, palis, stang</I>.", "0"],
["fotelo", "fotel-o", "[OA-8] (<I>brakseĝo</I>), arm-chair, (th) stall.", "0"],
["foti", "fot-i", "[OA-9].", "0"],
["foto", "foto-", "(Gr. ppfx = light), Photo-. <B>~elektra</B>, <B>~fobio</B>, <B>~gena</B>, <B>~gravuri</B>, <B>~kemio</B>, <B>~lito</B>. <B>~metri(i)o</B>, <B>~no</B> (photon, light quantum), <B>~sfero</B>, <B>~sintezo</B>, <B>~stato</B>, <B>~tele- grafo</B>, <B>~terapio</B> (<I>lumkuraco</I>) <B>-tipio</B>.", "0"],
["fotografi", "fotograf-i", "[F] (col. <I>fot-i) (-n</I>). Photograph. <B>~ado</B>, <B>~arto</B>, <B>~io</B>, -y. <B>~(aĵ)o</B>, (col) <I>foto</I>, p. <I>~o momenta, tempa</I>. <B>~ejo</B>, -ic studio. <B>~ilo</B> (<I>kamero</I>), -ic apparatus, camera. <B>~isto</B>, -er. <B>Kolor~o</B>, colour-p. ➞ <I>fot, kamer, kodak</I>.", "0"],
["fotografio", "fotografi-o", "[OA-8], photography.", "0"],
["foveo", "fove-o", "(<I>kaveto</I>), (anat) fovea, small pit (cavity, depression).", "0"],
["fragmento", "fragment-o", "[UV] Fragment, bit, fraction, scrap, shred, splinter, etc. (part broken off, incomplete, isolated). <I>~o de interparolo, osto, poemo, vazo, vitro, vivo</I>. <B>~oj</B> (<I>rompaĵo</I>), debris, ruins, wreckage. <B>~a</B>, fragmentary, jerky. <I>~a scio, stilo</I>. <B>~igi</B> (<I>dispecigi</I>), break into fragments. ➞ <I>er, part, pec, split, stump</I>.", "0"],
["fragmito", "fragmit-o", "(bot) reed (<I>Phragmites</I>). ➞ <I>kan, kareks</I>.", "0"],
["frago", "frag-o", "[UV] Strawberry. <I>~o arbara (sovaĝa</I>), wild s. <B>~aĵo</B> (<I>~a konfitaĵo</I>), s-jam, etc. <B>~ejo</B>, <B>~bedo</B>, s-bed. <B>~ujo</B>, <B>~planto</B>, s-plant (<I>Fragaria</I>). <B>f ~marko</B>, s-mark, birth mark, naevus.", "0"],
["fraĝila", "fraĝil-a", "(a. <B>fragila</B>), (facile rompebla, tuŝotima), fragile, frail.", "0"],
["frajo", "fraj-o", "[UV] Spawn, (hard) roe, eggs of fish (frogs, molluscs), <B>f</B> issue, fry. <B>Sturga ~o</B> (kaviaro<B>). ~i</B> (<I>demeti ~on</I>), s. <B>~ejo</B>, breeding-pond. <B>~tempo</B>, s-ing time.", "0"],
["frajti", "frajt-i", "(<I>-n</I>) (<I>ekspedi kontraŭpage</I>), Freight. ~i <I>aeroplane, ŝipe</I>. <B>~(ad)o</B>, load, goods loaded. <B>Ŝip~o</B> (<I>kargo</I>), cargo. <B>~(ad)o</B>, freightage. <B>~o</B> <I>ekspresa, ordinara, rapida</I>. <B>~isto</B>, -er, carrier, <B>~kosto</B> (<I>portpago</I>). <B>~letero</B>. ➞ <I>fret, ŝip-lu, transport</I>.", "0"],
["frakasi", "frakas-i", "(<I>-n</I>) [UV] (<I>disrompi, fragmentigi</I>). <B>1</B> Shatter, break suddenly and violently, dash to pieces, demolish: <I>~i kranion, teleron</I>. <B>2</B> (<I>plenvenki</I>): confound, overwhelm, rout. ~i <I>armeon</I>. <B>3</B> (<I>detrui, ruinigi</I>): <I>~i nacion, kuraĝon, sanon</I>. <B>4</B> (<I>afliktegi</I>): <I>~i la koron</I>. <B>5</B> (<I>nuligi, refuti</I>): <I>argumenton</I>. <B>~o</B> (<I>bru-krako</I>): crash, etc. <B>Dis~i</B> (<I>-n</I>), utterly s., smash to pieces. <B>~iĝi</B> (<I>kontraŭ</I>), crash, shatter. (av) <B>fal~iĝi</B> (<I>kraŝi</I>), crash. <B>~ilo</B>, stone-breaker, stone-crasher.", "0"],
["frakcio", "frakci-o", "[OA] Fraction. <B>1</B> (mat) <I>~o decimala</I>. <B>ĉen~o</B>, continued fraction. <B>f</B> = <I>peceto, <B>~a</B>, -al, <B>~igi</B> (-n), -ize, express in fractions</I>.", "0"],
["frako", "frak-o", "[UV] Dress-Coat (suit), evening dress, tails, <B>~ulo</B>, person in dress-coat.", "0"],
["frakseno", "fraksen-o", "[UV] ash (tree) (<I>Fraxinus</I>). <B>~o Amerika</B>, white a. <B>~o ornama</B>, flowering (manna) ash.", "0"],
["framasono", "framason-o", "[UV] freemason. <I>~a loĝio</I>. <B>~aro</B>, <B>~eco</B>, <B>~ismo</B>, freemasonry.", "0"],
["frambesio", "frambesi-o", "(med) framboesia, yaws.", "0"],
["frambo", "framb-o", "[UV] Raspberry (fruit). <I>~a siropo, vino</I>. <B>~ujo</B>, <B>~arbusto</B>, r-cane (<I>Rubus idaeus</I>). ➞ <I>rubus</I>. <B>Rubusa ~o</B> (logano), loganberry.", "0"],
["framo", "fram-o", "(tech) Frame(work), base, substructure (rigid part, skeleton) of apparatus. ~o <I>de biciklo, pordo, lito, seĝo</I>. <B>Brod~o</B>, <B>Fenestra ~o</B>, window sash, (typ) <B>kopia ~o</B>, printing f. <B>Spar~o</B>, (av) spar-f. ➞ <I>ĉasi, kadr, skelet, trabar</I>.", "0"],
["francio", "franci-o", "(chem) francium (Fr).", "0"],
["franciskano", "franciskan-o", "Franciscan monk.", "0"],
["Francujo, Francio", "Franc-ujo, Francio", "[F] FR, France.", "0"],
["franĉo", "franĉ-o", "[UV] Fring/e, ornamental border (edging), usually thread or tasselled. <B>2</B> (similar obj). <B>Har~o</B>, front hair brushed over forehead and cut short. <B>~i</B>, f., border. <B>~hava</B>, <B>~ita</B>, fringed, fimbriate. ➞ <I>galon, kvast, penik</I>.", "0"],
["frandi", "frand-i", "(<I>-n</I>) [UV] (<I>plenĝue sin regali per</I>), be fond of (partial to), enjoy, like, have a taste for. <I>~i bombonon, kukon, sukeraĵon. La vermoj ~u lin</I> (Ij 24/20). <B>~a</B> (<I>alloga</I>), appetizing, delicate, nice, tasty. <B>~aĵo</B>, dainty, delicacy, tasty morsel, titbit (PI 4/5, Ge 49/20, Se 26/22). <B>~ema</B>, sweet-toothed. <B>~(em)ulo</B>, dainty person, epicure, gourmet. ➞ <I>regal</I>.", "0"],
["frangipano", "frangipan-o", "(cul) frangipane, filling cream.", "0"],
["frangolo", "frangol-o", "[UV] (bot) alder buckthorn (<I>Frangula</I>). ➞ <I>ramn</I>.", "0"],
["franko", "frank-o", "[F], (num) franc.", "0"],
["frankoleno", "frankolen-o", "(orn) francolin, black partridge (<I>Franco linus</I>).", "0"],
["frapi", "frap-i", "(<I>-n</I>) [UV]. <B>1</B> Strike, deal a blow, beat, knock, hit, rap, slap, smack. ~i <I>iun per bastono, ion por gin rompi; al si la kapon. ~ita de fulmo. ~i kontraŭ (sur) -n</I>, s. against, lash, pound (<I>aero vizaĝon, ondoj rokori</I>). <B>2</B> Knock (make a sound): <I>~i ĉe la pordo (sur la pordon), Oni ~as</I>, someone is knocking. <I>La koro (pulso) ~as</I>. <B>3</B> (<I>ek-atentigi, mirigi, trafi</I>): strike. <I>~i atent-(okul-)on. Penso min ~is. 4 (plagi, venkobati): ~ita de blindeco, malamikeco. Mi ~as kaj resanigas</I> (Rd 32/39). <B>Frap!</B> Bang! Rat tat! Slap! <B>~o</B>, blow, hit, knock, rap, slap, stroke. <I>~o ĉe la pordo</I>. <B>Elektra ~o</B> (<I>skuo</I>), shock. <B>Sun~o</B>, sunstroke. (mus) <I>~o de disonanco</I>, beat (percussion) of discord. <B>~(ant)a</B> (<I>evidenta</I>), powerful, striking. <I>~a argumento, ekzemplo, simileco</I>. <B>~e</B> <I>bela</I>. <B>~aĉi</B>, thump (<I>pianon</I>). <B>~ego</B>, heavy blow. <B>~eti</B>, dab, pat, rap, tap (➞ <I>dab</I>). <B>~iĝi</B> <I>kontraŭ</I> (➞ <I>karambol, kolizi, kunpuŝiĝ</I>). <B>~ilo</B>, drumstick, knocker (<I>pordo</I>), striker (<I>horloĝo</I>), tongue (<I>sonorilo). Muŝ~ilo</I>, fly-swatter, <B>~obrui (klak~i)</B>, clatter, rattle (as objs in box). <B>Inter~i (Kun~i)</B> <I>la manojn</I>, clap one’s hands. <I>Liaj dentoj inter~iĝis</I> (chattered). <B>Kontraŭ~o</B>, rebound, recoil, repercussion). <B>Kun~i</B> (<I>tintigi) glasojn. Kun~iĝo</I>, collision, shock. <B>Okul~a</B>, evident, loud, glarg, showy, striking. <B>Panik~ita</B>, panic-stricken. <B>Pied~i</B>, kick, stamp. ➞ <I>male, perkut, survang, vip</I>. <B>Rim</B>.: <I>Frap</I> denotes single blow; <I>bat</I> denotes blows continued, repeated. Sometimes both are applicable.", "0"],
["fraterkolo", "fraterkol-o", "(<I>marpapago</I>), (orn) puffin (<I>Fratercula</I>). ➞ <I>pufen</I>.", "0"],
["frato", "frat-o", "[UV] <B>1</B> Brother. <B>2</B> companion, fellow. <I>~o en milito, mizero. Milit~o,</I> b. in arms. <B>3</B> member of church, guild, order, etc. <I>Laika ~o</I>, lay brother. <I>~o Laŭrenco</I>. <B>~(ec)a</B>, -ly, fraternal. <I>Ami~e</I>. <B>~aro</B>, -hood, fraternity. <B>~eco</B>, -liness. <I>Esperanto nin ~igas</I>. <B>~ino</B>, sister. <B>~ulo</B>, <B>1</B> -ly person. <B>2</B> Fellow, e.g., de B.E.A. <B>~mortigo</B>, <I>fratricide</I>. <B>bo~o</B> [UV] (<I>frato de edz(in)o, edzo de fratino</I>), b-in-law. <B>Ge~oj</B>, b(s) and sister(s). <B>(Inter)~iĝi</B>, fraternize. <B>Kun~o</B>, b. (in the faith, etc.), chum, colleague, confrere, mate, partner. <B>Duon~o</B>, half-brother (half-blood relationship). <I>Frato alipatr(in)a</I>. <B>Lakto~o</B>, <B>mam~o</B>, foster-b. <B>Stifa ~o (Stif~o)</B>, Step-brother (by remarriage of a parent: no blood-relationship).", "0"],
["fraŭdo", "fraŭd-o", "Fraud, criminal deception, dishonest artifice, piece of trickery. <I>Bonintenca</I> <B>~o</B>, (col) pious fraud. <B>~a</B>, fraudulent. <I>~a bankroto</I> <B>~e</B> (<I>per ~o</I>), by f., under false pretences, <B>~i</B> (<I>agi ~e</I>), cheat, swindle, etc. <I>ĉe ekzameno</I>. <B>De~i</B>, <B>Pri~i</B>, Defraud (<I>ion de iu, iun pri io).~~i la doganon,</I> d. the customs. <B>~ulo</B>, cheat, swindler.", "0"],
["fraŭlo", "fraŭl-o", "[UV] Bachelor, single (unmarried) man. (wedding) <B>Honora ~(in)o</B>, best man, (bridesmaid). <B>Persista ~o</B>, confirmed b. <B>~a</B>, celibate, single. <B>~a patrino</B>, unmarried mother. <B>~eco</B>, b-hood, celibacy. <B>~ino</B>, [UV] spinster; damsel, maid(en), miss, single woman. <B>~ineto</B>, lassie, little maid, young miss. <B>Maljuna ~ino</B>, old maid. ➞ <I>junul; needz(in)igit, -igint; senedz, sinjor, viring</I>.", "0"],
["frazo", "fraz-o", "[OA] <B>1</B> (gram) Sentence (assertion, question, wish, or exclamation): &gt; <I>propozicio</I>. A <B>simpla ~o</B> (simple s.) has only one finite verb. A <B>malsimpla ~o</B> (compound s.) consists of two or more clauses. A <B>kompleksa ~o</B> (complex s.) has one or more dependent clauses. <B>2 ~o</B>, <B>~ero</B> (<I>parolturno, vortgrupo</I>), Phras/e, locution, small, verbless expression. <I>~o kutima, konvencia, moda</I>. <B>~i</B>, p. <B>~ado</B>, (mus) phrasing. <B>~aro</B> (<I>frazlibro</I>), p-book. <B>~isto</B>, word-spinner. <I>~ista sensencaĵo</I>, verbiage. <B>ĉirkaŭ~o</B>, circumlocution, periphrasis (➞ <I>elturniĝ, malrekt, pretekst</I>). <B>Ĵet~o</B> (<I>slogano</I>), slogan (➞ <I>deviz, sibolet</I>). <B>steneografio</B> (<I>vortkunligo</I>), phraseography. <B>~eologio</B>, p-eology, study of forms of speech. ➞ <I>esprim, propozici, sentenc</I>.", "0"],
["fregato", "fregat-o", "[OA] <B>1</B> (mar) frigate. <B>2</B> (orn) frigate-bird, man-of-war-bird (<I>Fregata</I>).", "0"],
["frekvenco", "", "(<I>vibrorapido</I>), (ac, ph), Frequency, rate of recurrce. <I>~o (mal)alta, supersona</I>, etc. <I>Flagro~o</I>, flicker-f. <B>~ometro</B>, f-meter. <B>Alt~a</B> <I>fluo</I>, (el) f- current.", "0"],
["frekventi", "frekvent-i", "(<I>vizitadi</I>) (<I>-n</I>), frequent, habitually go to (visit). <I>~i kurson, lernejon, teatron. ~ita</I> (busy) <I>strato</I>. ➞ <I>oft</I>.", "0"],
["fremda", "fremd-a", "[UV] Foreign. <B>1</B> (<I>aliula, nepro- pra</I>): extraneous, not one’s own, other people’s, someone else’s. <I>Ne ŝovu nazon en ~an vazon, ŝajnigi sin ~a al siaj fratoj</I>. (Ge 42/7). <I>El ~a poŝo oni facile pagas</I>. <B>2</B> (<I>alilanda</I>): alien, coming from elsewhere. <I>~a kutimo, lingvo. Ministro por ~aj Aferoj</I>. <B>~eco</B>, strangeness. <B>~iĝo</B>, estrangement. <B>~ulo</B>, foreigner, stranger. <I>~ulo en ~a lando</I> (El 18/3). <B>~lande</B>, abroad. <B>Mal~a</B>, <B>Ne~a</B>, familiar, home, intimate. ➞ <I>alilanda, eksterlanda, malsamlanda</I>.", "0"],
["fremito", "fremit-o", "(<I>vibretado</I>), (med) fremitus, tremor, <B>f</B> purring, quivering, rustling, shuddering, soughing, trembling (of leaves, water in the kettle, wind, etc.). <I>Kora ~o</I>. <B>~i</B>, (nt) quiver, etc.", "0"],
["freneza", "frenez-a", "[UV] (<I>mense malsana</I>), Mad; crazy, insane, out of one’s mind, raving, <B>f</B> (<I>ekster si, furioza, malsaĝega</I>): beside one’s, demented, frantic, frenzied, furious, senseless, wild. <I>~a de ĝojo, ĵaluzo. ~a amo, deziro, elspezo, ideo</I>. <B>~e</B>, -ly, very foolishly, etc. <B>~aĵo</B>, <B>~eco</B>, craze, folly, insanity, lunacy. <B>~i</B> (<I>agi ~e</I>). <B>~eta</B> (<I>duon~a</I>), cracked, not quite right in the head, queer, touched, etc. <B>~igi</B> (<I>-n</I>), -den, craze. <B>~ulo</B>, -cap, -man, fool, lunatic. <B>~ulejo</B>, mental hospital. <B>~umi</B> (H 51/12), play the role of a -man. ➞ <I>delir, ekstravaganc, idiot, mani</I>.", "0"],
["frenologio", "frenologi-o", "phrenolog/y. <B>~o</B>, -ist.", "0"],
["fresko", "fresk-o", "[OA] fresco, painting on wet plaster. <B>~(opentr)isto</B>.", "0"],
["freŝa", "freŝ-a", "[UV] Fresh (wide sense) <B>1</B> Pure, refreshing, not stale or musty: <I>~a aero, akvo;</I> bracing (<I>vento</I>); just caught (<I>fiŝo</I>), laid (ovo), or made (<I>pano</I>); mint (<I>monero</I>). <B>2</B> Unspoilt, unsullied by age or use: <I>~a entuziasmo, vizaĝo;</I> not cooked or preserved (<I>frukto</I>); not faded or withered (<I>gloro, memoro</I>); not hackneyed (<I>stilo</I>); not salted (<I>butero</I>). 3 (<I>ĵusa, nova</I>) just arrived, new, not previously known or used, novel, recent: <I>~a modo, tombo, vidpunkto</I>. <B>4</B> additnl, different, further (<I>~a argumento, lumo): Plej~a</I>, latest, <B>~e</B>, -ly, just, lately. <I>~e falinta neĝo. Printempa</I> <B>~(ec)o. (Re)~igi</B>, refresh,revive. <I>~igi aeron, koloron, memoron, sin</I>. <B>~igaĵo</B>, refreshment. <B>~aspekta</B>, f-looking. <B>~brila</B> (sparkling) <I>roso</I>. <B>~data</B>, of recent date, latest, <B>Mal~a</B>, stale, decayed, flat, hackneyed, insipid, out of date, rotten, withered. ➞ <I>arkaik, kaduk, lac, malnov, mucid, putr, velk</I>.", "0"],
["freto", "fret-o", "Fret. <B>1</B> (arch) f., meander, ornamental pattern, usually of right angles. <B>2</B> (tech) binding, collar, ferrule, hoop; (mus) f., bar or ridge on fingerboard (etym. <I>= fer-et</I>). <B>~ita</B>, ferrul-(hoop-iron-band-)ed)", "0"],
["frezi", "frez-i", "(<I>-n</I>), (mec) Mill, remove metal by revolvg multiple-toothed cutter to produce flat or profiled surfaces (grooves, slots). <I>~i foldon, moneron</I>. <B>~ado</B>, milling. <B>~ilo</B> (<I>turnĉizilo</I>), milling cutter (for grooving, slotting, surfacing). <B>~maŝino</B>, milling machine.", "0"],
["frida", "frid-a", "<I><B>=</B> malvarma (tech</I>), <I>~a ĉizilo, kamero, nitado</I>. <B>~igi</B>, refrigerate<I>. ~igita viando. ~igitaj pizoj</I>. <B>~igilo</B>, <B>~ujo</B>, icebox, refrigerator.", "0"],
["frikasi", "frikas-i", "(<I>-n</I>), (cul) Fricassee, make mincemeat stew. <B>~(aĵ)o</B>. fricassee.", "0"],
["frikativo", "frikativ-o", "(<I>frota konsonanto</I>), (phon) fricative.", "0"],
["frikcio", "frikci-o", "(mec, ph), friction. <B>~a</B> <I>bremsrezisto, diskrezisto, kupladrezisto</I>.", "0"],
["fringelo", "fringel-o", "[UV] siskin (<I>Carduelis spinus</I>). <B>Rim.:</B> These are the meanings apparently given by F. to the roots <I>fring, fringel</I>. Stojan proposes the word <I>finkoj</I> (finches) in ordinary language for all the <I>Fringillidae</I>.", "0"],
["fringo", "fring-o", "[UV] chaffinch (<I>Fringilla coelebs</I>). <B>Monta ~o</B>, brambling (<I>F. monti-frangula</I>). <B>Verda ~o</B>, greenfinch (<I>Chloris</I>). ➞ <I>fringel, kanaben, kardel, kokotraŭst, pirol</I>.", "0"],
["fripono", "fripon-o", "[UV] Rascal. <B>1</B> knave, rogue, scamp. <B>2</B> sharper, swindler., <B>~a</B>, -ly, knavish. (<I>agi ~e</I>). <B>~aĵo</B>, <B>~eco</B>, -ity, knavery. <B>~eta</B>, roguish. <B>~eto</B> (<I>petolulo</I>) (col., of a child), little r. <B>Pri~i</B> (<I>fraŭdi, ~e trompi</I>), cheat, swindle. ➞ <I>fraŭd, kanajl, ruz, tromp</I>.", "0"],
["friso", "fris-o", "[OA] frieze. <B>1</B> (arch) part above architrave and below cornice. <B>2</B> (orn) decorative band at top of wall, vase, etc. <B>3</B> (tex) coarse woollen fabric. <I>~a supervesto, peajacket</I>. ➞ <I>dekor, kulis</I>.", "0"],
["friti", "frit-i", "[OA] (<I>patkuiri</I>), Fry. <I>~i fiŝojn, ovojn, terpomojn</I>. <B>~aĵo</B>, fritter, anything fried. <B>~ilo</B> (<I>pato</I>), -ing pan. ➞ <I>bak, kresp, patkuk, risol, rost</I>.", "0"],
["fritilario", "fritilari-o", "(<I>imperiestra krono</I>), (bot) fritillary (<I>Fritillaria</I>). ➞ <I>argen</I>.", "0"],
["frivola", "frivol-a", "[OA] Frivol/ous: giddy, light, not serious, paltry, silly, trifling, trumpery, volatile. <B>~a</B> <I>konduto, penso, preteksto, virino</I>. <B>~e</B>, -ously, with levity. <B>~aĵo</B>, <B>~eco</B>, -ity. <B>~ulo</B>, giddyhead. ➞ <I>bagatel, facilanim, malserioz, vant</I>.", "0"],
["frizi", "friz-i", "(<I>-n</I>), [UV] Curl (crimp, wave) hair, etc. <I>~i barbon, kapon, harojn</I>. <B>~(aĵ)o</B> (<I>hararanĝo</I>), friz, wave, etc. <I>Konstanta ~o</I>, permanent wave. <B>~ejo</B>, hair-dressing saloon. <B>~ilo</B>, -er, <B>~isto</B>, h-dresser. <B>~fero</B>, curling-iron (tongs). <B>~papero</B>, c- paper. ➞ <I>barbir, bukl, komb, krisp, tond, raz</I>.", "0"],
["frogo", "frog-o", "(ry) frog, point of intersection of inner rails.", "0"],
["fromaĝo", "fromaĝ-o", "[UV] cheese. <I>~o kaprina, krema, Nederlanda, Svisa</I>.", "0"],
["frondo", "frond-o", "frond (leaf of fern, thallus of seaweed, etc.).", "0"],
["frontispico", "frontispic-o", "<B>1</B> (typ) frontispiece, illustrate facing title-page, etc. 2= <I>fronton</I>.", "0"],
["fronto", "front-o", "[UV] (<I>antaŭo, maldorso</I>), Front (of building), face, foremost part, head; <I>onda ~o</I>, wave f. (<I>Mal)varma ~o</I>, warm, (cold) f. (mil) f., line of battle, van (1 Sa 17/21), <I>Ĉe la ~o de</I> (at the head of). <B>~a</B> <I>ĉambro, fenestro, paĝo, pordo, rado</I>, front room, etc. <B>~e</B>, in f. ~e <I>al</I>, facing. <B>~en</B>, to the f. <B>(al)~i</B> (<I>-n), (kontraŭ</I>), front, brave, confront, face (look) towards, meet, oppose, stand opposite (up) to (➞ <I>defi, spit) ~i ~danĝeron, malamikon, sorton, kontraŭ la parko</I>. <B>~aĵo</B>, -age. <B>Mal~a</B>, back, rear. ➞ <I>antaŭ, fasad, fronton, frunt</I>. <B>Front!</B> (mil) 4 FA 210/10).", "0"],
["frontono", "fronton-o", "[OA] (arch) fronton, pediment, <I>~o ronda, triangula. ~o direktita al la strato</I> (4 FA 207/14). ➞ <I>fasad, front,</I> iabi", "0"],
["frosto", "frost-o", "[UV] Frost. <I>La ~o ĉion detruis</I>. Blanka <B>~o</B>, hoar-f. Surgrunda <B>~o</B>, ground f. <B>f</B> severe cold. <B>~i</B>, <B>1</B> (impersonal) freeze, be freezing: <I>~as (estas ~e</I>)! It is freezing. <B>2</B> be frozen, icy, stiff with cold: <I>La membroj (planto, tero) ~as</I>. <B>3</B> feel cold: <I>Mi ~as (sentas ~on) (Al mi estas ~e</I>), I am freezing. <B>~a</B>, frosty, frigid, cold. <I>~a tago, vento, vetero</I>. ~e <I>malvarma</I>, freezing cold. <B>~aĵo</B>, f-picture (on window). <B>~igi</B> (<I>lagon, teron</I>), congeal, freeze over. <I>~igilo</I>, freezer. <B>~iĝi</B>, freeze, get chilled. <I>La fingroj (tero) ~iĝis. ~iĝinta</I>, benumbed, f-bitten, f-bound. <B>Mal~i</B> (<I>el~igi</I>), unfreeze. <B>~absceso</B>, <B>~oŝvelo</B>, chilblain. <B>~difekto</B>, <B>~vundo</B>, f-bite, nip. <B>~kovri</B>, <B>~izi</B>, (cover as with) frost. <I>~izita</I> (frosted) <I>fenestro, kuko, lampo</I>. ➞ <I>frid, glaci, malvarm, prujn</I>.", "0"],
["froti", "frot-i", "(<I>-n</I>, abs),, [UV] Rub. <I>la haŭton, pargeton</I>. <B>~a</B>, abrasive. <I>~a</I> (fricative) <I>konsonanto</I>. <B>~(ad)o</B>, -bing, friction. <B>~eti</B>, rub lightly. <B>~iĝi</B>, chafe, get rubbed. <B>~ilo, ~tuko</B>, rubber. <B>~isto</B>, (floor) polisher. <B>~lavi, ~purigi</B>, scrub. <B>~poluri</B>, grind, polish, smooth. <B>~skrapi</B>, <B>~vundi</B>, abrade, gall, graze. <B>De~i</B>, rub off, excoriate. <B>Dis~i</B>, triturate. <B>El~I, For~i</B>, rub out, erase, erode. <B>Preter~i</B>, brush against (past). ➞ <I>abrad, frikci, grat, polur, skrap, ŝlif, viŝ</I>.", "0"],
["frua", "fru-a", "[UV] Earl/y, forward. <I>~a floro, mateno, maturiĝo, veno</I>. <B>~e</B>, early. <I>Leviĝi, veni ~e. Pli bone <B>~e</B>, ol neniam</I>. <B>Plej~e</B> (<I>unue</I>), first. <B>Pli~e</B>, earlier, before, sooner. <I>Ne pli ~e ol (ne antaŭ) Majo</I>, not before (till) May. <I>Pli-malpli <B>~e</B></I>, sooner or later. <B>~i</B>, be early, ripen e. <B>~aĵo</B>, e. product. <B>~igi</B>, advance, put forward. <B>~sezona</B>, e. in the season. <B>Mal~a</B>, late; backward, behindhand, behind time, belated, slow, tardy. <I>~~a gasto, horo, rikolto. La horloĝo ~~as</I>. is too slow; <B>~~iĝas</B>, loses time. <B>~~igi</B>, delay, retard, set back. ~~<B>sezona</B>, belated (El 9/32). <B>Tro~a</B> (<I>antaŭtempa</I>), premature, untimely. <I>La horloĝo tro~as</I> (is too fast). ➞ <I>antaŭ, ĝis, unua</I>.", "0"],
["frugilego", "frugileg-o", "[UV] (<I>kampa korvo</I>), rook (<I>Corvus frugilegus</I>) <B>~aro</B>, <B>~ejo</B>, rookery. ➞ <I>kornik</I>.", "0"],
["frukto", "frukt-o", "[UV] Fruit. <B>1</B> (bot) (e.g., <I>ĉerizo, frago, glano, porno). ~oj de la tero. Radik~oj</I>, root crops. <B>2 f</B> offspring. <I>~o de la ventro</I>. <B>3</B> product of action, consequence, effect, result. <I>~o de ago, imago, laboro, legado, sperto</I>. <B>~oj</B>, <B>~aro</B>, harvest proceeds, produce, revenue, yield. <B>~(odon)i</B>, be fruitful, bear f. <I>~u kaj multiĝu</I> (Ge 1/28), <B>f</B> give results. <I>La piano bone</I> <B>\"-is. ~aĵo</B>, (cul) something made from f., jam. <B>~(arb)ejo</B>, orchard. <B>~ema. ~odona, ~oriĉa</B> (<I>fekunda</I>), fruitful, fertile, prolific. <B>~igi</B>, make -ful, fructify (Ge 48/4). <B>~(vend)isto</B>, -erer. <B>~ujo</B>, f-dish, f-jar. <B>~arbo</B>, f-tree. <B>~ogusta</B>, -y. <B>-omanĝa</B>, frugivorous. <B>~opor- ta</B> (Ps 128/3). <B>~sukero</B> (<I>fruktozo, glukozo</I>). (jur.). <B>~uzo</B>, usufruct. <B>~vendejo</B>, f-shop. <B>Sen~a</B>, f-less, barren, sterile, <B>f</B> (<I>senefika, senrezulta, vana</I>), unproductive, unprofitable. <I>Sen~a laboro, provo, tero. ~~ulino</I> (Ps 113/9). <B>Kerno~o</B> (<I>drupo</I>), drupe. ➞ <I>dehisk, produkt, rezult, sem</I>.", "0"],
["frunto", "frunt-o", "[UV] Brow, forehead. <I>~o amika, glata, nebulita. Sulkigi la ~on</I>, furrow the brow. <I>Rigardi</I> <B>~en</B>, look straight in the face. <B>~osto</B>, frontal bone. ➞ <I>brov, fac, front</I>.", "0"],
["ftiro", "ftir-o", "crab louse (<I>Phthirus</I>).", "0"],
["ftizo", "ftiz-o", "[UV] (med) phthisis, (ordinary language) consumption (Rd 28/22) <B>1</B> pulmonary tuberculosis. <I>~o galopanta</I>. <B>2</B> (<I>marasmo</I>), wasting of the body. <I>~a ruĝo sur la vizaĝo</I>. Vd <I>tuberkuloz</I>.", "0"],
["fugo", "fug-o", "(mus) fugue. <B>~o duobla</B> (<I>dusubjekta</I>), double fugue; <B>strikta</B> (strict); <B>tonala</B> (tonal); <B>triobla</B> (triple); <B>trivoĉa</B> (for 3 voices). <B>~eca</B>, fugato. <B>~eto</B>, fugetta.", "0"],
["fuĝi", "fuĝ-i", "(nt, <I>de, el, en</I>) [OA-8], flee, fly, run away, seek safety in flight. <I>~i antaŭ la malamiko; el Egiptujo; en Palestinon; (for) de danĝero</I>. <B>~o</B>, flight. <B>~anto</B>, fugitive. <B>~igi</B>, put to flight. <B>~into</B>, refugee. <B>Trans~into</B>, deserter. ➞ <I>dizert, evit, forkur, rifuĝ</I>.", "0"],
["fuko", "fuk-o", "[OA] focus, species of brown algae &lt; kelp, wrack. ➞ <I>aling, koragen, zoster</I>.", "0"],
["fuksino", "fuksin-o", "fuchsine, aniline red, magenta.", "0"],
["fuksio", "fuksi-o", "(bot) fuchsia, lady’s ear-rings.", "0"],
["fulardo", "fulard-o", "foulard. <B>1</B> thin silk (and cotton) material. <B>2</B> (<I>~a koltuko</I>), scarf or handkerchief made from this. ➞ <I>kravat</I>.", "0"],
["fulgo", "fulg-o", "[UV] Soot, deposit, smoke black. <B>~okovrita, ~oplena, ~oza</B>, sootty, smutty. <B>~i</B> (nt) be -ty. <B>~eca</B>, <B>~okolora</B>, <B>~osimila</B>, black as s. <B>~ero</B>, flake of s., smut, <B>~(onigr)igi</B> (<I>-n</I>), blacken, smut. <B>~isto</B>, sweep. <B>Sen~igi</B>, sweep (<I>kamentubon</I>), decarbonize (<I>aŭton</I>). ➞ <I>bistr, fum</I>.", "0"],
["fulgoro", "fulgor-o", "firefly, lantern fly (<I>Fulgora) &lt; cikad</I>.", "0"],
["fuli", "ful-i", "(<I>-n</I>), Full (cloth). <B>~ado</B>, -ing, <B>~ejo</B>, -ing mill. <B>~isto</B>, -er (Jes 36/2, Mai 3/2). <B>~argilo</B>, -ers’ earth. <B>~maŝino</B>. ➞ <I>apretur, dipsak</I>.", "0"],
["fuligolo", "fuligol-o", "(<I>hupanaso</I>), tufted duck (Aytha fuligula). ➞ <I>anas, nirok</I>.", "0"],
["fuliko", "fulik-o", "(orn) coot (<I>Fulica</I>).", "0"],
["fulmaro", "fulmar-o", "(<I>glacipetrelo</I>), (orn) fulmar (<I>Fulmarus</I>). ➞ <I>petrel</I>.", "0"],
["fulminato", "fulminat-o", "(chem) fulminate (salt).", "0"],
["fulmo", "fulm-o", "[UV] Lightning. <I>~o sentondra,</I> distant (heat, summer) 1. <I>Glob~o,</I> globular 1., fireball. <I>~o magnezia. ~o tavola</I>, sheet <B>l</B>. <I>~o zigzaga</I>, forked <B>1. f</B> flash. (<I>Ek)~o de genio</I>. <B>~e</B> (<I>~orapide</I>), in a flash, like 1. <B>~i</B>, lightning, flash, <I>~as</I> (impersonal), it is 1. <I>~is lancoj</I>. <B>~aĵo</B>, <B>~ofajro</B>, thunderbolt. <B>~et(ad)i</B>. ➞ <I>flagr, trembril</I>. <B>~odaŭra</B>, instantaneous, momentary. <B>~ofrapi</B>, strike by l. <B>~osuĉilo</B>, l-conductor, l-rod. <B>~otondro</B>, thunderstorm. <B>Ek~o</B>, <B>~i</B>, flash. ➞ <I>ŝtorm, tondr</I>.", "0"],
["fulva", "fulv-a", "(<I>brunflava, ruĝflava</I>), brownish, reddish yellow, buff, fallow, fulvous.", "0"],
["fumario", "fumari-o", "(bot) fumitory (<I>Fumaria</I>).", "0"],
["fumo", "fum-o", "[UV] Smok/e; fume, reek. <I>~o de ligno, pipo. Ne ekzistas ~o sen fajro. Pleniĝi je ~o</I>. <B>-plena</B>, <B>~oza</B>, smoky. <B>~i</B>, [UV] <B>1</B> (emit) s., fume, reek. <I>La kameno, lampo, vulkano ~as</I>. <B>f</B> <I>Kial ~as via kolero?</I> ➞ <I>bol</I>. <B>2</B> (-n, abs). <I>~i cigaron, pipon, tabakon</I>. <B>~ado</B>, -ing. <B>~aĵo</B>, something -ed (<I>fiŝo, tabako</I>). <B>~anta</B>, <B>~ema</B>, fuming (acid, etc.). <B>~anto</B>, -er. <B>~egi</B> (<I>~i kiel kamentubo</I>). <B>~ejo</B>, -ing-room. <B>~iĝi</B> (Ps 104/32). <B>~ilo</B>, censer. <B>~izi</B>, <B>1</B> (<I>~aĵi, ~sekigi), ~i haringon</I>. <B>2</B> (<I>purigi</I>): fumigate (<I>ĉambron</I>). <B>3</B> (<I>~kovri, ~nigrigi): ~i vitron</I>. <B>~ujo</B>, <B>~kamero</B>, <B>~kesto</B>, s-box. <B>~difektita</B>, <B>~gusta</B>, (cul) -y. <B>~kupeo</B>, -ing compartment. <B>~nigro</B>, lamp-black, smoke-black. <I>~nigrigita</I>, s-begrimed. <B>~nubo</B>, wreath of s. <B>~tub(ar)o</B>, chimney, s- funnel (stack). <B>El~i</B> (<I>cigaron</I>), s. to the end. <B>Ne~anto</B>, nons-er. <B>Sen~a</B>, s-less. <I>Sen~a karbo, pulvo</I>.", "0"],
["fundamento", "fundament-o", "[UV] Foundation. <B>1</B> Bas/is, base, solid ground (Ps 18/7, Mi 1/6). <I>Meti la ~ojn</I>, lay the foundations. <B>2</B> Essential basis, underlying principle. <I>~o de ŝtato, teorio</I>. <B>3</B> <I>La \"Fundamento\"</I> (1905) <I>de E-o (= ĝenerala interkonsendo pri la bazaj ecoj de la lingvo</I>). <B>4</B> (ac) <I>~a tono = ĉefa vibrofrekvenco</I> (in harmonic series). <B>~a</B> (<I>baza, esenca</I>), basic, cardinal, fundamental, ground. <I>~a ŝtono</I>, f-stone. (<I>Esperanto) ~a vorto</I>, word in the F. <I>~a argumento, dokumento, grando, numeralo, regulo</I>. (ph) <I>~a salo</I>. <B>~i</B> (<I>bazi, starigi</I>) (Ps 89/2, Am 9/6), (lay the) basis (foundation) (of), establish, found, ground, set up. <I>~i metodon sur sperto. Kredo bone ~ita</I> (well-founded, on firm basis) <B>~aĵo</B>, groundwork. <B>1</B> warp. <B>2</B> (<I>~a parto aŭ principo</I>), fundamental. <B>~ano</B>, <B>~isto</B>, (E-o) one loyal to the F. (rel) Fundamentalist. <I>Esprimo</I> <B>kontraŭ~a</B>, <B>laŭ~a</B>. <B>Sen~a</B>, without f., baseless. <B>Plat~a</B>, flat-bottomed. ➞ <I>baz, firmaĵ, fond, fund, grund, starej, subaĵ, ter</I>.", "0"],
["fundo", "fund-o", "[UV] Bottom. <B>1</B> Lowest part, base, basis, depth, floor, ground, foundation; trough (<I>de ondo): ~o de barelo, maro, puto, valo, Abismaj ~oj</I>, abysmal depths. <I>La ~on supre</I>, bottom upwards. <I>Esplori la ~on de la glaso (ebrietiĝi</I>). <B>2</B> back, far end, rear: <I>~o de arbaro, ĉambro, koridoro, ŝranko</I>. <B>3</B> (<I>fono</I>): background: ~o <I>de bildo, horizonto, pejzaĝo</I>. <B>4</B> inmost (hidden) part: <I>~o de la animo, koro</I>. <B>5</B> (<I>abismo, ekstremo</I>): depth, height. <I>~o de malespero, mizero</I>. <B>~a</B>, <B>f</B> <I>~a klarigo</I>, thorough explanation (➞ <I>kern, fundament</I>). <B>~e</B>, at (the) bottom. <B>f</B> (<I>ĝisoste, plendetale</I>), thoroughly. <I>Lerni, scii (lingvon) (ĝis) ~e</I>. <B>~en</B>, to the bottom. <B>Al~iĝi</B>, go to the b. Sen~a (<I>senbaza</I>), bottomless, groundless. <I>Sen~aĵo (abismo</I>), abyss, gulf. <I>~~igi</I> (knock the b. out of) <I>argumenton</I>. <B>Sur~aĵo</B>, deposit, dregs, grounds, sediment. (➞ <I>fee, rekrement, sediment</I>). ➞ <I>baz, fon, fundament, grund, plank, profundaĵ, ter [Ne= kaso, fonduso]</I>.", "0"],
["funebro", "funebr-o", "[UV] Mourn/ing. <B>1</B> grief. <I>Estis ~o en la lando</I>. <B>2</B> (<I>~a ceremonio, funeralo). Ĉeesti ~on</I>. <B>3</B> (<I>~aj vestoj</I>): weeds. <I>Porti ~on</I>. <B>Duon~o</B>, half-m. <B>~a</B>, [UV] dark, dismal, doleful, funereal, gloomy. <I>~a marŝo, parolo, saluto, soleno, torĉo, vesto. ~a saliko,</I> weeping willow. <I>~a veturilo</I>, -ing coach. <B>~i</B> (abs, <I>pri, pro</I>), mourn (weep) for, bewail (person or thing), be in -ing (Ge 23/2, <B>2</B> Sa 14/2). <B>~ado</B>, -ing (Rd 34/8). <B>~aĵoj</B>, (<I>~a ceremonio, vesto</I>, etc.). <B>~antaro</B>, <I>~a procesio</I>. ~igi (PI 2/8). <B>~isto</B>, mute, professional -er. <B>~ulo</B>, (Ij 29/25). ➞ <I>ĉerk, enterig, funeral, malĝoj, priplor, ve</I>.", "0"],
["funelo", "funel-o", "[UV] Funnel (utensil), mouth, openg. <I>~o de gramofono, korno, mikrofono. <B>~i</B> (<I>-n</I>) (enverŝi per ~o</I>), pour by funnel. <B>~(form)a</B>, funneled, bell-mouthed. ➞ <I>buŝpec, laŭtparolil</I>.", "0"],
["funeralo", "funeral-o", "(<I>funebra soleno</I>), funeral. <B>~isto</B>, undertaker. (American mortician). ➞ <I>enterig, kremati, sepult</I>.", "0"],
["fungo", "fung-o", "[UV] (bot) Fung/us. <B>1</B> (gen) &gt; mildew, mould, etc. <B>2</B> mushroom and toadstool fam.. <I>~o manĝebla</I>, ➞ ŝampinjon. <I>~o venena</I>, toadstool. <B>Buter~o</B> (<I>boleto</I>); <B>Muŝ~o</B> (<I>amanito</I>); <B>Orel~o</B> (<I>aŭrikulario</I>); <B>Polvo~o</B> (<I>likoperdo</I>); <B>Sak~o</B>, (<I>askomiceto</I>). <B>~(ec)a</B>, fungal. <B>~aĵo</B>, <B>~eco</B>, -osity. <B>~ejo</B> mushroom bed. <B>~ojda</B>, -oid. <B>~ologio</B>, micology. ➞ <I>agarik, amanit, bolet, geastr, gist, kantarel, kopren, klavari, laktari, likoperd, marasm, meldu, morhel, ŝampinjon, rusol, <B>ŝ</B>im, truf</I>.", "0"],
["funguso", "fungus-o", "(med) fungus (<I>disease</I>).", "0"],
["funiklo", "funikl-o", "funicle. <B>1</B> (bot) <B>2</B> (anat) (<I>umbelika ŝnuro</I>).", "0"],
["funikularo", "funikular-o", "(<I>kabla fervojo</I>), funicular ry.", "0"],
["funkcii", "funkci-i", "(<I>nt</I>) [OA], Function, act, operate, work. <B>1</B> (person): act as, discharge the duties (do the work, fill the office) of. ~i <I>kiel agent-(instruist-kasist-)o</I>. <B>2</B> (thing): <I>La cerbo, kruro, kurso, maŝino, po<B>ŝ</B>to, sistemo ~as</I> (1 Rĝ 14/4). <B>~o</B> (<I>agado, devo, ofico, tasko</I>): function, normal activity, calling, duty, employment, office, operation, working. <I>~o de stomako, vorto en frazo</I>. <B>3</B> (mat) variable quantity in relation to others. <B>~a</B>, functional. <I>~a malsano</I>. <B>~ado</B>, working (e.g., of watch, institution) (el) <I>kontinua ~ado</I>, continuous duty. <B>Ne~anta</B>, not working. <B>~igi.</B> cause to act, make go, operate, set going, start off. <B>~isto</B>, <B>~ulo</B>, -ary, operator. <B>Ek~i</B>, come into play. <B>Mal~igo</B>, closing-down. ➞ <I>ag, defor, labor, serv</I>.", "0"],
["funto", "funt-o", "[UV] pound (Weight) (lb.). <B>Cent~o</B>, hundred-w. ➞ <I>pundo (£</I>).", "0"],
["fuorto", "fuort-o", "(mil) fort. ➞ <I>fortres, fortikaĵ</I>. <B>fiir-o</B> (<I>ĉasputoro</I>), the domestic ferret, a vrty of the polecat (<I>Mustela putorius</I>).", "0"],
["furaĝo", "furaĝ-o", "[UV] (<I>nutraĵo</I>), Forag/e, fodder, food, provender (especially for animals) (Ge 24/25). ~i go -ing, bring in (search for, supply with) f., <B>f</B> rummage. <B>~isto</B>, -er.", "0"],
["furio", "furi-o", "[OA] (myth), Fury, goddess of vengeance. <I>La tri ~oj</I>. <B>f</B> angry or malignant woman, virago. ➞ <I>furioz, meger</I>.", "0"],
["furioza", "furioz-a", "[UV] full of Fury, furious, raging, savage, violent. <I>~a ag-(nom-hund -veni)o. 1 (kolerega</I>): enraged. <B>2</B> (<I>sovaĝa</I>): intractable, wild. <B>3</B> (<I>freneza</I>): crazy, frantic, insane, mad, raving. <B>~o</B>, f„ rage, wrath (Ge 27/44). <B>~eco</B>, fierceness, etc. <B>~i (</B><I>agi ~e</I>), be in a f., rage, rave. <I>La batal-(edzin-vent-)o ~as</I>. <B>~igi</B>, enrage, madden, infuriate. <B>~iĝi</B>, see red. <B>~ulo</B>, madman. <I>~ulino</I>, f., termagant. ➞ <I>beserk, flam, frenez, furi, koler, pasi, senbrid, tumult</I>.", "0"],
["furnario", "furnari-o", "(orn) oven-bird, (<I>Furnarius</I>).", "0"],
["furoro", "furor-o", "[OA] (<I>momenta ĉiea modo aŭ sukceso</I>), furore, craze, sensation, vogue. <B>~i</B>, be all the rage (in vogue), come in. <I>Ami <B>~e</B></I>, have a craze for, be mad about. ➞ <I>sensaci</I>.", "0"],
["furunko", "furunk-o", "[UV] (med) Furunc/le, boil. <B>~a</B>, -ular, -ulous. <B>~eco</B>, <B>~ozo</B>, -ulosis. ➞ <I>absces, tumor</I>.", "0"],
["furzi", "furz-i", "(<I>nt</I>) emit intestinal gases, fart. <I>Senbrua ~o</I>. <B>~eco</B>, flatulence.", "0"],
["fusilo", "fusil-o", "Rifle. <B>~ado</B>, fusillade, r-fire. <B>~isto</B>, fusilier. ➞ <I>karaben, musked,pafil</I>.", "0"],
["fuso", "fus-o", "wide-mouthed whelk (<I>Fusus</I>).", "0"],
["fusteno", "fusten-o", "[UV] (tex) fustian, thick twilled cotton cloth with short nap. ➞ <I>korduroj</I>. <B>~jupo</B>, fustanella (Greek <I>kilt</I>).", "0"],
["fusto", "fust-o", "<B>1</B> shaft (of pillar). <B>2</B> part of object. which one takes hold of, fust, main pt: haft (of axe); handle (of broom, saw); stave (of spear); stem (of candelabra); stock (of gun, plane).", "0"],
["fuŝ", "fuŝ-", "[UV] (pfx), similar meaning to <I>aĉ</I>, but applied to actions only. <B>~haki</B>, hack. <B>~palpi</B>, fumble. <B>~pentri</B>, daub. <B>~uzi</B>, use clumsily.", "0"],
["fuŝi", "fuŝ-i", "(<I>-n</I>. abs) [UV] (<I>= faraĉi, plenumaĉi, uzaĉi</I>), do awkwardly (blunderingly, clumsily), be a duffer at, boss, blotch, bungle, flounder, fumble, make a hash of, tinker at. <I>~i laboron, metion, taskon, sian vivon. Intence ~i (saboti</I>). <B>Fuŝ!</B> (interj) Boss! Duffer! Mucked it! Muff! <B>~a</B>, awkd, blundering, bungling, clumsy, unskilful, unworkmanlike. <B>~e</B>, clumsily. <B>~(aĵ)o</B>, botch, hash, mess. <B>Ne~ebla</B>, foolproof. <B>~isto</B>, <B>~ulo</B>, bungler, duffer, muff, etc. <B>Mal~i</B>, make a workmanlike job of, straighten out (what was in a mess). <B>Lud~anto</B>, spoil-sport. ➞ <I>aĉ, maltraf, mis</I>.", "0"],
["futbalo", "futbal-o", "(<I>piedpilko</I>), football. <B>~isto. ~ejo</B>, <B>f -ground</B>.", "0"],
["futo", "fut-o", "[UV] (metr) foot (measure). <I>Kuba ~o</I>. ➞ <I>pied</I>.", "0"],
["futur", "", "-o (<I>estonteco, os-tempo</I>), future, (gram) <I>~a tempo</I>, f. tense. ~ismo, ~isto.", "0"],
["fuzelaĝo", "", "(av) fuselage, body or framework of aeroplane.", "0"],
["fuzeo", "fuze-o", "(<I>eksplodigilo</I>) (mil, min) Fuse. <B>Frap~o</B>, percussion fuse. <B>Fuza ~o</B>, <B>tempa ~o</B>, time fuse. <B>Prokrasta ~o</B>, delayed-action f. ➞ <I>fanda drato, fadeno, prajm</I>.", "0"],
["fuzi", "fuz-i", "fuse, melt; crackle, deflagrate, fizz, (pyr) burn slowly. <B>~aviadilo</B>, rocket plane.", "0"],
["fu!", "", "Phew! denotes impatience; strain, weariness; disgust.", "0"],
["gabardino", "gabardin-o", "(tex) gabardine, twill woven cloth of fine worsted.", "0"],
["gabio", "gabi-o", "(mil) gabion.", "0"],
["gablo", "gabl-o", "(bid) gable, vertical triangular upper pt of wall at end of ridged roof, or over door or window. ➞ <I>fronton, pinjon</I>.", "0"],
["Gabono", "Gabon-o", "GA.", "0"],
["gado", "gad-o", "[UV] (ich) member of the cod fam. (Gadus) &gt; eglefin, lusk, merlang, moru, polak. (G. vi&gt;e«.? = coalfish).", "0"],
["gadolinio", "gadolin/io", "gadolin/ium (Gd). <B>~ito</B>, (min) -ite.", "0"],
["gafo", "gaf-o", "Gaff. <B>1</B> (mar) spar. <B>2</B> (<I>hokstango</I>), boat-(gaff-)hook. <B>~velo</B> (<I>aŭrika velo</I>), g-sail. ➞ <I>his</I>.", "0"],
["gagato", "gagat-o", "(&lt; nigra lignito), <B>Jet. ~e</B> (karbe) nigra, j-black.", "0"],
["gageo", "gage-o", "(orstelo), yellow star of Bethlehem (Gagea). ➞ ornitogal.", "0"],
["gaino", "gain-o", "tight-fitting undergarment. <B>~a</B> <I>jup-(korset-)o</I>, sheath skirt (corset).", "0"],
["gaja", "gaj-a", "[UV] (<I>ĝojmiena, ridhumora</I>), Gay, Merry; blithesome, cheerful, lighthearted, lively; bright, brilliant, showy. <I>~a homo, horo, kanto, koloro, spektaklo, urbo, vizaĝo</I>. <B>~(ec)o</B>, cheerfulness, gaiety, merriment, mirth. <B>~i</B> (<I>agi ~e</I>) (Pr 8/15). <B>~aĉa</B>, dissolute. <B>~aĵo</B> (Jes 30/10). <B>~ega</B>, hilarious, in high spirits. <B>~ema</B>, jovial. <B>~eta</B>, in a good humour. <B>~igi</B>, brighten up, cheer, enliven, exhilarate, gladden. <I>~iga</I>, amusing, funny. <B>~ulo</B>, jolly chap, m-fellow (Jer 31/4). ➞ <I>ĝoj, komik, petol, rid</I>. <B>Malgaj-a</B>, <B>(</B><I>deprimita, melankolia</I>), melanchol/y, dejected, dismal, doleful, dull, gloomy, glum, overcast, sad, sombre, sorrowful. <I>~a kanto, tago, vetero</I>. <B>~o</B>, dejection, depression, dullness, gloom. <B>~i</B>, be in the dumps, brood, have the blues. <I>~ega (morte ~a), ~ema</I>, depressed, in low spirits, m-ic, out of tune, morose, peevish, sullen. <B>~igi</B>, depress.", "0"],
["gajako", "gajak-o", "Guaiac(um), (<I>Guaiacum</I><B>). ~a</B> <I>ligno</I>, lignum vitae. <B>~olo</B>, -ol. <B>~rezino</B>, g-gum.", "0"],
["gajlo", "gajl-o", "[UV] Gall(nut). Kverka <B>~o</B>, oak apple. Roz~o. <B>~i</B>, prepare with gg. <B>~ato</B>, -ate. <B>~atacido</B>, -ic acid (from gg). <B>~insekto</B>, g-fly (&gt; cecidomio, cinipo .. .).", "0"],
["gajni", "gajn-i", "(-n, abs) [UV] (<I>akiri per peno, favoro, sorto</I>), Gain, make, obtain; acquire, earn, secure, win. ~i aŭskulton, batalon, favoron, konfidon, koron, premion, proceson, sperton, tempon. Kiu ~us (profitus) el tio? Pli bone malmulte <B>~i</B>, ol multe perdi. ~i ĉe loteri-(lud-)o. Kiu ne riskas, tiu ne ~as. ~i teron ( = antaŭeniri). ~i (varbi) iun, win over. <B>~a</B> numero, winning nmbr. <B>~(aĵ)o</B>, gains, (increase in) earnings (profit, winnings). <B>~iga</B>, lucrative, remunerative. <B>~anto</B>, winner. <B>Mal~i</B>, forfeit, lose (➞ perd). ~~(af)o, casualty, loss, waste. <B>Re~i</B>, re-g, win back. Re~a ŝipo, salvage ship. <B>Super~o</B>, surplus. ➞ <I>ating, enspez, havig, konker, obten, profit, ricev</I>.", "0"],
["gaki", "gak-i", "(<I>anserbleki</I>), cackle, gabble.", "0"],
["galago", "galag-o", "(<I>Afrika lemuro</I>), bush baby (<I>Galago</I>).", "0"],
["galaksio", "galaksi-o", "galaxy, island universe., e.g., the milky way (<I>lakta vojo</I>). <B>f</B> brilliant assemblage.", "0"],
["galaktito", "galaktit-o", "(min) galactite.", "0"],
["galanta", "galant-a", "Gallant, markedly attentive to women. <B>~i</B>, play the g., flirt. <B>~aĵo</B>, <B>~eco</B>, -ry, compliment, politeness to a lady. <B>~ulo</B>, g., fine gentleman, ladies’ man. ➞ <I>afabl, brav, dand, elegant, ĝentil</I>.", "0"],
["galanterio", "galanteri-o", "[UV] fancy goods, small wares, accesories of clothing and toilet: combs, ribbons, powder, rouge, etc. ➞ <I>merceraĵ</I>.", "0"],
["galantino", "galantin-o", "[OA] (cul) galantine (meat in jelly). ➞ <I>aspik</I>.", "0"],
["galanto", "galant-o", "[OA] (<I>neĝborulo, Z.</I>), snowdrop (Galanthus).", "0"],
["galbano", "galban-o", "galbanum, gum from <I>Ferula galbanifera</I> (El 30/34). ➞ <I>feral</I>.", "0"],
["galbolo", "galbol-o", "(orn) Jacamar (<I>Galbula</I>).", "0"],
["galego", "galeg-o", "(bot) goat’s rue (<I>Galega</I>).", "0"],
["galeno", "galen-o", "(<I>plumba sulfido</I>), galena, native lead sulphide (ore), (rad) <B>~a</B> <I>ricevilo,</I> crystal set.", "0"],
["galeo", "gale-o", "tope, dogfish (<I>Galeus</I>).", "0"],
["galeopso", "galeops-o", "hemp-(stinking-)nettle (Ga- <I>leopsis</I>).", "0"],
["galerido", "galerid-o", "(<I>tufalaŭdo</I>), crested lark (<I>Galerida</I>).", "0"],
["galerio", "galeri-o", "[UV] Gallery. <B>1</B> covered path (ptly open at side), colonnade, portico, etc. ➞ <I>koridor</I>. <B>2</B> (mil, min) (<I>subtera koridoro, trairejo</I>), adit, tunnel. <I>~o mineja</I>. ➞ <I>tunel, subterej</I>. <B>3</B> long room for showing works of art, especially <B>Art~g. Portreta ~o</B>. ➞ <I>muze</I>. <B>4</B> (bid) (<I>alta balkono</I>), platform from inner wall. ➞ <I>amfiteatr, balkon</I>. (th) <B>Dua ~o</B>, upper circle. Tria (lasta) <B>~o</B>, the gods. <B>Unua ~o</B>, dress circle.", "0"],
["galero", "galer-o", "[OA] <B>1</B> (hist) Galley (<I>remŝipo</I>). <B>2</B> (<I>punŝipo</I>), gg., convict ship, hulks, <B>f</B> <I>vera ~o</I>, hell on earth. ~ano, (<I>~a sklavo</I>), g-slave.", "0"],
["galicismo", "galicism-o", "(= Francismo), gallicism, French idiom.", "0"],
["galimatio", "galimati-o", "farrago, balderdash, gibberish, pompous nonsense.", "0"],
["galinago", "galinag-o", "(<I>marta skolopo</I>), (orn) Snipe (<I>Gallinago</I>). <B>~eto</B>, Jack s. (<I>Lymnocryptes</I>). ➞ <I>skolop</I>.", "0"],
["galino", "galin-o", "(<I>ĝangala koko</I>), Jungle-fowl (<I>Gallus</I>). <B>Ruĝa ~o</B>, red j-f.", "0"],
["galinolo", "galinol-o", "moorhen (<I>Gallinula</I>).", "0"],
["galio", "gali-o", "(bot) bedstraw (<I>Galium</I>) &gt; cleavers (goosegrass), crosswort.", "0"],
["galiono", "galion-o", "(mar) galleon, treasure-ship.", "0"],
["gali(um)o", "gali(um)-o", "(chem) Gallium (Ga).", "0"],
["galo", "gal-o", "[UV] (<I>hepata sekrecio</I>), Bil/e, Gall. <I>Bov~o</I>. <B>f</B> asperity, bitterness, rancour, spite, spleen, venom (PI 3/19). <I>Inciti al iu la ~on</I>, provoke, rile. <I>Mia ~o krevas</I>. <B>~(em)a</B>, <B>~humora</B>, ~plena, rancorous, spiteful, <B>~oza</B>, b-ious. <B>~acido. ~atako</B>, <B>~malsano</B>, b-ious complaint. <B>~dukto</B>. <B>~ŝtono. ~veziko</B>, g-bladder. <B>Nigre~a</B>, atrabilious, melancholic. ➞ <I>splen</I>.", "0"],
["galono", "galon-o", "[UV] <B>1</B> (tex) cord, lace, (mil) piping, stripe (close-woven braid for bordering or trimming). ŝnur-o, frogging. <B>~i</B>, bind (ornament, trim) with braid or lace. <I>~ita lakeo</I>, laced flunkey. <I>~ita vesto</I>. ➞ <I>border, kordon, pasament</I>. <B>2</B> gallon (= 4 <I>kvartoj</I>, 8 <I>pajntoj</I>).", "0"],
["galopi", "galop-i", "[OA] Gallop <B>1</B> (of a horse). <B>~e</B>, at a g., <B>f</B> in a rush. <I>Kuri <B>~e</B></I>, scamper. <B>~anta</B> (med) (<I>rapide evoluanta</I>). <B>~ege</B> (<I>plen~e</I>), at full g. <B>For~i</B>, gallop away. <B>2</B> g. (dance) (mus).", "0"],
["galoŝo", "galoŝ-o", "[UV] (<I>superŝuo</I>), galosh, overshoe (us. of rubber).", "0"],
["galvana", "galvan-a", "(el) Galvan/ic. <B>~aĵo</B> (<I>~a kliŝo,</I> ➞ <I>stereotip</I>). <B>~ismo</B>. <B>~izi</B> (<I>apliki elektron</I>) (also figuratively), -ize (➞ <I>zinkizi</I>). <B>~ometro</B>, <B>~oplastiko</B>, <B>~oskopo</B>, <B>~otipo</B>.", "0"],
["gamaŝo", "gamaŝ-o", "[UV] Gaiter. <I>Kun ~oj</I>, -ed. Vind~oj, (<I>surobendoj</I>); puttees. ➞ <I>tibling</I>.", "0"],
["Gambio", "Gambi-o", "GM.", "0"],
["gambito", "gambit-o", "(<I>ludkomenca ofero</I>), (chs) gambit.", "0"],
["gambo", "", "= kruro.", "0"],
["gamelo", "gamel-o", "billy-can, dixie, pannikin, mess-tin.", "0"],
["gameto", "gamet-o", "(<I>generoĉelo</I>), (bot) gamete. <B>~a</B> -al.", "0"],
["gamo", "gam-o", "[UV] (wide sense) in ordinary language vaguely = <B>1</B> (<I>amplekso</I>): gamut, full range. <I>~o de rido</I>, peal (ripple) of laughter. <I>~o de koloroj. Senfinaj ~oj</I>, infinite modulations. <B>2</B> (mus) ( = <I>tonalo</I>), key. <B>3</B> (mus) (<I>= skalo</I>), scale. ~noto (<I>=toniko</I>), key note, tonic. ~signo (<I>=tonalsigno</I>), key- signature. ~ŝanĝo (<I>modulado</I>), change of key. Ali~igi (<I>alipiĉigi, transponi</I>), transpose. Laŭ~(sign)a (<I>laŭtonala</I>), diatonic (<I>diatona</I>).", "0"],
["Ganao", "Gana-o", "GH.", "0"],
["ganglio", "gangli-o", "[OA] Gangli/on. <B>1</B> (anat) g-cell, nervous centre, <B>f</B> centre of activity (interest). <B>2</B> (med) cyst-like swelling on tendon. <B>~a</B>, -onic. <B>~forma</B>, -form.", "0"],
["gango", "gang-o", "(geol) gangue, valueless earthy matter in ore.", "0"],
["gangreno", "gangren-o", "[OA] (med) Gangren/e, canker, mortification, <B>~a</B>, -ous. <B>f</B> <I>~o morala</I>. <B>~i</B> (<I>esti ~a</I>). <B>~igi</B>, corrupt, mortify. ➞ <I>degener, infekt, kari, malvirteg, putr</I>.", "0"],
["gangstero", "gangster-o", "Gangster, member of gang of criminals. <B>~ismo</B>, -ism.", "0"],
["ganto", "gant-o", "[UV] Glove. <I>~o senfingra. Sur-met (-tir)i ~on. Ĵeti la ~on</I>, throw down the gauntlet, challenge, defy. <I>Levi la ~on,</I> accept a challenge. <B>~i</B>, En~igi <I>la manojn</I>. Sen<B>~igi</B>, un-g. Boks<B>~o</B>, boxg-g. Duon<B>~o</B>, Muf<B>~o</B>, mitten. Fer<B>~o</B>, gauntlet. Frot<B>~o</B>, friction-g.", "0"],
["gapi", "gap-i", "(nt) (<I>rigardaĉi</I>), Gap/e, stand -ing, stare open-mouthed. ~anto, ~(em)ulo, gaper, idler, looker-on. ~vagi, mouch around . ➞ <I>osced</I>. II <B>~ado</B>, the gapes (<I>birda malsano</I>).", "0"],
["garaĝo", "garaĝ-o", "[OA-8] (<I>remizo aŭta, bicikla, boata, vagona</I>), garage.", "0"],
["garantii", "garanti-i", "(<I>-n, por, pri, kontraŭ, ke</I>), [UV] Guarant/ee, engage, pledge, promise, undertake (to do); answer (go bail, make one’s responsible, vouch) for; assure (permanence, possessn), secure (<I>ion, al iu, iun pri io). Mi ~os por li (pri tio) (ke). ~i pag-(progres-sukces-)on</I>. <B>~o</B>, g., safeguard, warranty. <I>~o de sukceso, pri kvalito. Vendi kun (sen) ~o</I>. ~a <I>kapital-(kas-)o</I>. g. capital (fund). <I>Doni</I> ~e (as a g.) <B>~aĵo</B>, [UV] g., thing given sum pledged) as g. (mortgage, security Jes 33/6). <I>~aĵigi, ~doni (doni prunte, kiel ~on</I>) (Am 2/8). pawn, pledge. <B>~anto</B>, -or. <B>~ulo</B>,, [UV] hostage, surety. ➞ <I>asekur, aserti vera, certig, hipotek, kaŭci, lombard, prirespond, promes</I>.", "0"],
["garbo", "garb-o", "[UV] Sheaf; bundle, cluster, of things bound or laid lengthwise (Ge 37/7). <I>~o da fojno, pajlo, sagoj</I>. <B>~aro</B>, shock, stook. <B>~arego</B>, rick, stack (➞ <I>stak</I>). <B>~ejo</B>, barn (➞ <I>fojnejo, grenejo</I>) (Rd 15/14), ~eto (Rut 2/16). <B>~igi</B>, bind into sheafs. <B>~igilo</B>, s-binder. ➞ <I>fask</I>.", "0"],
["garcinio", "garcini-o", "(bot) garcinia. ➞ <I>gumigut, mangostan</I>.", "0"],
["gardenio", "gardeni-o", "[OA] (bot) gardenia.", "0"],
["gardi", "gard-i", "(<I>-n, abs, de, kontraŭ, ke</I>), [UV] Guard; keep, take precautions. <B>1</B> be in charge of, defend, keep (from harm), look after, mind, protect, save, watch over (➞ <I>atent, defend, prizorg, protekt, Sirm): ~i kontraŭ risko. ~i honoron, lingvon, trezoron, vojon. ~i kiel la pupilon de la okulo. (Vin) ~u, ke vi ne falu</I>, Mind (Take care) you don’t (Beware lest you) fall). <B>2</B> keep in check, restrain: <I>~i lang -(malliberul-parol-pens-)on</I> (➞ <I>kontrol</I>). 3 Hold, keep safe, maintain, preserve, put by, secure, retain: <I>~i dokumenton, esperon, fidelon, junecon, memoron, monon, oficon, sekreton, sintenon, unuecon</I>. ➞ <I>konserv, Spar, ten</I>. <B>~o</B>, g., custody, vigil, ward, watch. <B>~e</B>, on g„ prepared against attack (surprise). <I>Stari <B>~e</B></I>, be on sentry duty. <B>~anto</B>, <B>~isto</B>, -ian. caretaker, custodian, keeper, protector, warden, watchman (Ge 4/9). <B>Brut~isto</B> (<I>paŝtisto</I>), shepherd. <B>Korp-isto</B>, body-g. <B>Nokta ~isto</B>, night watchman. <I>~isjejo</I>, g-room, lock-up. <I>~ista posteno</I> (Ĥb 2/1). <B>~ilo</B> (<I>sekurig-Sirm-ilo</I>), fender, safe-g., ward, etc. <I>Fand~ilo (fanda drato</I>), (el) fuse, fusible cut-out (<I>fuzaĵo</I><B>). ~ostaranto</B>, sentinel, sentry. <B>Antaŭ~i</B> (<I>antaŭSirmi kontrau</I>), preserve from, prevent, ward off. ~<B>~a</B>, preservative, preventive, prophylactic. <I>~~err.a</I>, careful, provident. Sin~(em)a, -ed, careful, cautious, circumspect, discreet, prudent. <I>Nesin~a</I>, careless, imprudent, in-cautious(-discreet). <I>Sin~o,</I> caution, etc. <B>Pri~(Super~)i</B>, keep an eye on, super-intend(-vise), watch over. ➞ <I>fleg, gvardi, ŝirm</I>.", "0"],
["gargari", "gargar-i", "(<I>-n</I>), [UV] <B>1</B> (<I>frotlavi, skulavi</I>), rinse (<I>glason, tukon</I>). <B>2</B> Gargle (<I>la gorĝon</I>). ~e <I>paroli</I>. <B>~aĵo</B>, g., throat-wash. <B>~isto</B>, dish-(bottle-)washer, washer-up. <B>~a</B> <I>bruo</I>, bubbl-(gurg-)ling; rumbling (<I>intesta</I>).", "0"],
["gargojlo", "gargojl-o", "(<I>akvosputilo</I>), (arch) gargoyle, grotesque gutterspout.", "0"],
["gario", "gari-o", "(bot) Garrya (shrub).", "0"],
["garni", "garn-i", "(<I>-n per, almeti ion al</I>) [OA], garnish, add accessories. <B>1</B> adorn, decorate, embellish, trim (dress with lace; speech with jokes, hat with ribbons). <B>2</B> complete, equip, furnish, line, provide (coat with buttons; dish with sauce, hook with bait; nest with moss; picture with frame; shop with goods). <B>3</B> stud: (door with nails). <B>~aĵo (garnitur-o</B> [OA]<B>)</B>, equipment, accessories, fittings, furnishings, mountings, trimmings, gear, kit, outfit, service. <B>Fer~ita</B>, iron-studded. ➞ <I>akcesor, aldon, ekip, kovr, ornam, proviz</I>.", "0"],
["garnizono", "garnizon-o", "[OA] Garrison. <B>~i</B>, furnish with (occupy as) g. <I>~i urbon</I>.", "0"],
["garolo", "garol-o", "[OA] (orn) jay (<I>Garrulus</I>). ➞ garrulous.", "0"],
["gaso", "gas-o", "[UV] Gas. <I>Brul~o, karb~o, lum~o</I>, coal gas (<I>Mal)Fermi la ~on</I>, turn (on) off the gas. <B>~o afiksia</B>, lethal gas. <B>Larmiga ~o</B>, tear gas. <B>Marĉ~o</B>, <B>Min~o</B> (<I>metano</I>), marsh-gas, firedamp. <I>Brulinta min~o</I>, after- (choke-) damp. <B>Mustarda ~o</B> (<I>iperito</I>). <B>Olea ~o</B>, oil-gas. <B>Rid~o</B>, laughing-gas (nitrous oxide). <B>2</B> (med) wind. ~o intesta, stomaka. <B>3</B> (col) empty talk. <I>~ulo</I>, gas-bag. ~(ec)a, -eous, -sy. <B>~igi</B>, -ify (➞ <I>vaporig</I>). <B>~isto</B>, g-fitter(-man), ~akvo, ~atako, ~kamero, ~lampo, ~lumo, ~masko, ~motoro, ~ringo. ~beko, g-jet. ~flamigilo, gas-lighter. ~fornelo, g-oven. ~ometro, gasometer ( = 1 <I>~komputilo</I>, <B>2</B> <I>~(rezerv)ujo</I>, gas-tank). ~venenita, -sed. ➞ <I>benzin</I>.", "0"],
["gasterosteo", "gasteroste-o", "(<I>dornfiŝeto</I>), stickleback (<I>Gasterosteus). ~o 3-(\\0-\\5-)dorna</I>.", "0"],
["gasto", "gast-o", "[UV] Guest. <I>~o kutima, regula,</I> habitual visitor. <I>~o paganta</I>, boarder. <I>Akcepti ~ojn, Por ~o nepetita mankas kulero. ~o sen avizo~~malagrabla sur- prizo</I>. <B>~i</B> (<I>esti ~o) (ĉe, en</I>), be a g., board, put up, receive hospitality, stay (Ps 5/4, 15/1). <B>~ado</B>, stay. <B>~ej(~dom)o</B>, g-house, inn, hostel (➞ <I>hotel, migrulej, pension, pasloĝej). ~ejestro</I>, inn-keeper, landlord. <B>~igi</B>, entertain, give hospitality, put up, take in. <I>Ka<B>ŝ</B>e ~igi</I>, harbour. <I>~iganto</I>, host. <B>~ama (~igema)</B>, hospitable. <I>Ne~ama</I>, in-h. <B>~oĉambro</B>, g-chamber, visitor’s room. <B>~prezo</B>, board. <B>Kun~o</B>, fellow-g. <B>Dorm~o</B>, night lodger. ➞ <I>klient, invit, loĝ, parazit, regal, rest</I>.", "0"],
["gastro", "gastro-", "(ppfx) (<I> ~~ stomak-</I>), gastro-. <B>~enterito</B>, (<I>s-inflamo</I>), -itis. <B>~nom/o</B>, -onom/er, epicure. <I>~~io</I>, -y. <B>-pieduloj (~podoj)</B>, gasteropods &gt; <I>bukcen-(helik -limak-patelyoj</I>.", "0"],
["gastrofilo", "gastrofil-o", "horse bot-fly (<I>Gastrophilus</I>).", "0"],
["gastropako", "gastropak-o", "lappet moth (<I>Gastropacha</I>). <B>gaŭĉ-o</B>, gaucho, S. American mounted herdsman.", "0"],
["gaŭĝo", "gaŭĝ-o", "Gauge. <B>1</B> (standard) Measure. <B>2</B> instrument to measure dimensions, or test conformity with standard. <B>~i</B> g. <B>1</B> m. exactly (capacity, size), etc. <B>2</B> bring to standard size or shape, make uniform. ➞ <I>kalibr, norm. Profund~o. Marka morteza) ~o</I>, marking (mortise) g. <B>Rim</B>.: Rosher (\"ĉarpentiloj\") proposes <B>gaĝ-o</B>, <B>~i</B>, and uses <B>gaŭĝ-i</B> = to gouge, <I>~ilo</I>, gouger (<I>kurba ĉizilo</I>).", "0"],
["gaŭlterio", "gaŭlteri-o", "winter-green (<I>Gaultheria) &gt;</I> checkerberry, shallon. ➞ <I>pirol</I>.", "0"],
["gaŭlto", "gaŭlt-o", "(geol) gault (species of bluish-gray clay).", "0"],
["gaŭro", "gaŭr-o", "gaur, Indian bison (<I>JBibosgaurus</I>). <B>gaŭs-o</B>, (ph) gauss. <I>~a unuo</I>.", "0"],
["gavialo", "gavial-o", "(zoo) gavial, gharial (<I>Gavialis</I>). ➞ <I>krokodil</I>.", "0"],
["gavoto", "gavot-o", "(dee, mus) gavoste.", "0"],
["gazelo", "gazel-o", "[UV] gazelle (<I>Gazella</I>) <B>~ino</B>, (Alt 7/3). ➞ <I>antidork, antilop</I>.", "0"],
["gazeto", "gazet-o", "[UV] gazette, magazine, <I>~o ĉiumonata, dimanĉa, faka, ilustrita</I>. ~aĉo, rag. <B>~aro</B>, ~istaro, the Press. <B>~isto</B>, m-writer, journalist, pressman, ~eltranĉaĵo, press cutting. <B>~anonco</B>, <B>~artikolo</B>, <B>~servo</B>, <B>~vendisto</B>. ➞ <I>bulten, ĵurnal, kiosk, periodaĵ, revu</I>.", "0"],
["gazo", "gaz-o", "[OA] (tex) Gauze, thin transparent fabric of cotton, silk, wire, etc. <B>~a</B>, g. <I>~a litkovrilo (kulevitilo</I>).", "0"],
["ge", "ge-", "[UV] (pfx) denotes both sexes (used in the plural only). <B>~fratoj</B> = brother(s) and sister(s) = one or more of each. <B>~patroj</B>, parents (a) in gen., (b) of a family. <B>1</B> relations: <I>~av(~fil)oj</I>. <B>2</B> other classes: <B>~sinjoroj</B>, ladies and gentlemen. <B>~amik(~knab)oj.</B> <B>3</B> animals: <I>~katoj</I>. <B>4</B> (a couple): <B>~fianĉoj. ~sinjoroj</B> B, Mr. and Mrs. B. <B>5</B> (col) <B>~edukado</B>, coeducation. <B>~lernejo</B>, mixed school. <B>~koroj. ~o</B>, a pair. <B>~a (</B><I>ambaŭseksa</I>), mixed. <I>Vivi</I> <B>~e</B>. IT <B>Ge</B> may be omitted if understood from context, <B>(ge)edziĝo</B>, marriage. <I>Abraham kaj Sara estis</I> <B>(ge)maljunuloj</B> (Ge 18/11). ➞ \"Dearly beloved <I>brethren\"</I>. IT The experimental forms <B>geedzo</B> (<I>spouse</I>), <B>gepatro</B> (<I>parent</I>) are theoretically indefensible, but have occasionally been found useful.", "0"],
["geastro", "geastr-o", "(<I>terastro</I>), (bot) earth star (fungus) (<I>Geaster</I>).", "0"],
["gebio", "gebi-o", "(zoo) gebia (long-tailed crab).", "0"],
["geheno", "gehen-o", "gehenna (➞ <I>hades, infer</I>).", "0"],
["gejsero", "gejser-o", "(<I>ŝpruefonto</I>), <B>1</B> (geol) geyser, hot spring. <B>2</B> apparatus for rapidly heating water.", "0"],
["gejŝo", "gejŝ-o", "geisha, Japanese dancing girl.", "0"],
["geko", "gek-o", "gecko (various species) (Le 11/30).", "0"],
["gelateno", "gelaten-o", "[UV] Gelatin/e. <B>~i</B>, coat with g., -ize. ~aĵo ➞ <I>ĝel,ĵele</I>, ~(ec)a, -ous.", "0"],
["gemo", "gem-o", "[OA] gem, jewel, precious stone (cut and polished), <B>f</B> prized object. <B>~eca</B> (~brila). <B>~isto</B>, lapidary. ➞ <I>kame</I>.", "0"],
["genciano", "gencian-o", "[OA] (bot) gentian, felwort (<I>Gentiana</I>).", "0"],
["genealogio", "genealog-io", "[OA] (<I>deventabelo, generaciaro, prapatraro</I>), Genealog/y, fam. descent, pedigree; investigation of this. <B>~ia</B> <I>arbo, dokumento, listo, registro, tabelo</I> (Ez 2/62) <B>~o</B>, -ist.", "0"],
["generacio", "generaci-o", "[UV] generation, step in descent or pedigree. <I>En la dua ~o, de ~o al ~o, por ĉiuj ~oj</I> (Ps 103/13; Pr 1/4). <I>La</I> ~aro <I>de Ŝem</I> (Ge 11/10). ➞ <I>geneologi</I>.", "0"],
["generalo", "general-o", "[F] [OA], (mil) General, Commander. <B>~edzino</B>. <B>Ĉef~o</B>, g-issimo, c-in-chief.", "0"],
["generi", "gener-i", "(<I>-n</I>), Generat/e, beget, bring into existce, engender, procreate, produce. <I>~i elektron, gason, lumon, varmon</I>. <B>~a</B>, -ive. <I>~aj organoj</I>, genitals. <B>~(ad)o</B>, -ion, production. <I>Sponta ~ado</I>. (ac) <B>~anto</B>, -or. <I>Du ~antoj, kunsonante, produktas sub- kaj sumtonojn</I>. <B>~into</B>, genitor, sire. <B>~ejo</B> (<I>~a stacio</I>), -ing station. <B>~ema</B>, prolific, (tech) <B>~ilo</B> (a. ~atoro,) -or. <I>Turbina ~ilo</I>. ~gepatroj (3 FA 48/30). <B>~ipova</B>, <B>~iva</B>, potent. <B>Re~i</B>, <B>f 1</B> renew, <B>2</B> freshen, rejuvenate, <I>~~ado</I>, regeneration. ➞ <I>nask, produkt</I>.", "0"],
["genetiko", "genetik-o", "(<I>heredoscienco</I>), genetics. <B>~a</B>, genetic.", "0"],
["Genezo", "Genez-o", "(Bb) Genesis, <B>f</B> (<I>deveno, origino</I>), genesis, mode of origin. <I>Ciklon~o, ŝtorm~o</I>.", "0"],
["genio", "geni-o", "[OA] Genius. <B>1</B> guardian spirit, <B>f</B> person influencing for good or ill: (<I>mal)bona ~o</I>. <B>2</B> (<I>supera inteligento, natura doto</I>); inborn power, mental endowment, natural crea-(imagina-inven-)tive ability. <I>Montri ~on</I>. <B>3</B> prevalent character, quality: <I>~o de aŭtor-(lingv-lok-naci-)o</I>. <B>~a</B>, of g., brilliant, highly gifted, of inspired cleverness, masterly. <I>~a aranĝ-(sistem-verk-)o</I>. <B>~aĵo</B>, stroke (work) of g. <B>~ulo</B>, man of g. ➞ <I>anim, etos, spirit, talent</I>.", "0"],
["genisto", "genist-o", "[OA] petty whin, needle furze, greenweed (<I>Genista</I>). ➞ <I>laburn, saro- tamn, uleks</I>.", "0"],
["genitivo", "genitiv-o", "[UV] (gram) genitive case.", "0"],
["geno", "gen-o", "(bio) gene.", "0"],
["genocido", "genocid-o", "genocide.", "0"],
["genoto", "genot-o", "[UV] genet (<I>Genetta</I>). <B>Rim.:</B> The \"o\" from the Russian word. ➞ <I>viver</I>.", "0"],
["genro", "genr-o", "<B>1</B> (bio) Genus. <B>~a</B>, generic. <B>Sub~o</B>, sub-g. ➞ <I>gent, grup, ĝenr</I>. <B>2</B> (gram) gender. <I>~o vira, ina, neŭtra</I>.", "0"],
["genro", "genr-o", "(art) genre, especially of art or literature. <I>~a pentraĵo</I>, picture of ordinary life, especially of a particular class.", "0"],
["gento", "gent-o", "[UV] Family, People, Race, kin (dred), (zoo) breed, strain, stock. <I>~o de Priamo</I>, house of P. <I>Homa ~o</I>, human r., genus homo. <B>~a</B>, f., r-ial, generic. <B>~e</B>, by birth (r.). <B>~ano</B>, one of a p. <B>~estro</B>, chieftain, leader of a p. <B>Sam~ano</B>, compatriot, kinsman, one of same r. <B>~patro</B>, founder, progenitor (of r. or f.). ➞ <I>famili, klan, naci, ord, ras, trib</I>.", "0"],
["genuo", "genu-o", "[UV] <B>1</B> (anat) Knee. <I>Fali sur la ~ojn. Sidi sur ies ~oj</I> (lap). <B>2</B> (tech) knuckle (ball and socket) joint. ~a <I>kavo (sub~o, poplito</I>), hough. (Sur<B>)~e</B>, on bended k. <B>~i</B>, -1, be -ling. <B>~ado</B>, -ling (1 <B>Rĝ</B> 8/54). (Sur<B>)-iĝi</B>, <B>-fleksi</B>, -1. down, bend (bow) the k„ genuflect (Ge 49/9). <B>~igi</B> <I>kamelojn</I> (Ge 24/11). <B>~inge</B>, <B>~ŝirmilo</B>, k-guard(-pad). <B>~artiko</B>, k-joint. <B>~osto</B> (<I>patelo</I>), k-bone(-cap-pan). <B>~tendeno</B>, hamstring. Gis<B>~e</B>, k-deep. <I>Ĝis~a panta- lono</I>, k-shorts. <B>Inter~aĵo</B>, lap. ➞ <I>kulot</I>.", "0"],
["geo", "geo-", "(ppfx) (<I>~~mond-, ter-</I>), geo-. <B>-centra</B>, -centric.", "0"],
["geodezio", "geodezi-o", "[OA] (<I>termezurado</I>), geodesy.", "0"],
["geodinamiko", "", "geodynamics. <B>~fiziko.</B>", "0"],
["geodo", "geod-o", "(min) geode. ➞ <I>agios ton, gang</I>.", "0"],
["geografio", "geograf/io", "[UV] geography. <B>-o</B>, [OA] -er.", "0"],
["geologio", "geolog/io", "[OA] -logy; <B>~o</B>, [OA] -ist.", "0"],
["geometrio", "geometr-io", "[OA] geometry; <B>~o</B>, [OA] ~ician.", "0"],
["geotrupo", "geotrup-o", "(<B>sterkoskarabo</B>), dung-(dor-) beetle (<I>Geotrupes</I>).", "0"],
["gepardo", "gepard-o", "(<I>ĉasleopardo</I>), Cheetah, hunting leopard (<I>Acinonyx jubatus</I>).", "0"],
["geranio", "gerani-o", "[OA] Geranium, cranesbill. <B>Robert~o</B>, herb Robert. <B>Rim.:</B> The ordinary language \"g\" of English flouwer-pots is <B>pelargonio</B>. For this Fulcher and Long propose <I>geraniumo</I>.", "0"],
["geriatra", "geriatr-a", "(med) geriatric. <B>~isto</B> (<I>geron- tologo</I>), gerontologist. <B>geril-o</B>, guerilla, irregular independent war. <B>~ano</B>, <B>~i</B> (<I>kontraŭ</I>). <B>gerlen-o</B> (mar) (<I>kableto</I>), warp.", "0"],
["germanio", "germani-o", "(chem) germanium (Ge).", "0"],
["Germanujo, Germanio", "German-ujo, Germanio", "[F] DE.", "0"],
["gerundio", "gerundi-o", "[OA] (gram) gerund (meaning varies with language and author).", "0"],
["gesto", "gest-o", "[UV] (<I>movo esprima, signifa</I>) Gest/ ure. <I>~o indign-(Jes-ne-)a, ~o de koler -(surpriz-)o</I>. <B>f</B> (<I>ago): nobla ~o</I>. <B>~i (</B><I>fari -on</I>): -iculate (➞ <I>man-signi</I>). <B>~a</B> <I>lingvo,</I> sign language (➞ <I>mimik</I>). <B>~aĉo</B>, antic, caper, <B>~ado</B>, -iculation. <B>~ema</B>, demonstrative. <B>Ne~ema (Sen</B>~a), undemonstrative, ex- pressnless, stiff. <B>Spit~i</B>, cock a snook. ➞ <I>formal, mimik, rigid</I>.", "0"],
["geto", "get-o", "(<I>Juda kvartalo</I>), ghetto.", "0"],
["geŭmo", "geŭm-o", "(bot) water avens, herb Bennet (<I>Geum</I>).", "0"],
["gibeto", "gibet-o", "(<I>aperturo en fenestro, muro, pordo</I>); (ry) booking-ofEce; pay-desk, position (at counter), spy-hole. <I>por biletoj, pakaĵoj. ~o fermita</I>, position closed. <B>Teler~o</B>, service hatch. ➞ <I>fenestret, luk</I>. <B>gig-o</B>, (mar) gig, narrow light boat. <B>gigant-o</B> [OA] (<I>grandegulo</I>), Giant (Ge 6/4). <B>~ino. f</B> something of abnormal size. <B>~a</B>, g., gigantic, of extraordinary size or force. <I>~a laboro, monto</I>. ➞ <I>kolos, mamut, ogr, titan</I>.", "0"],
["gibono", "gibon-o", "(zoo) Gibbon (<I>Hylobates</I>).", "0"],
["gildo", "gild-o", "(<I>metia korporacio</I>), Guild, craft- association, society for mutual aid or common object., corporation. <B>~ano</B>, -sman. <B>~estro</B>, g-master. <B>~halo</B>, g-hall.", "0"],
["giloŝo", "giloŝ-o", "(arch) guilloche, ornament imitating braided ribbons, chequered pattern of gold or silver with interlacg curves. <B>~i</B> <I>desegnafon</I>. <B>~a</B> <I>fono</I>, figured background.", "0"],
["gilotino", "gilotin-o", "[OA] Guillotine (also surg). <B>2</B> (binding) trimming machine. <B>~i</B>, g.", "0"],
["gilumo", "gilum-o", "(orn) guillemot (<I>Uria</I>). ➞ <I>alka, fraterkol, mergol</I>.", "0"],
["gimnastiko", "gimnastik-o", "[OA] Gymnast/ics. <B>~i</B>, do g. <B>~a</B> <I>ekzerco</I>. <B>~ejo</B>, gymnasium <I>[Ne= gimnazio]</I>. <B>~ilo</B>, -ic apparatus. <B>~isto</B> (a. <I>gimnasto</I>), gymnast. ➞ <I>akrobat, atlet</I>.", "0"],
["gimnazio", "gimnazi-o", "[OA] Public (grammar) School, first-class classical school preparatory to university. <B>~ano</B>, p-s. boy. <B>~estro</B>, head of p-s. <B>~a diplomito</B>, <B>(</B><I>abituriento</I>). <B>Knabina ~o</B>, High School for girls. ➞ <I>kolegi</I>. <B>Rim.:</B> In some lands <B>lice-o</B> is used with same meaning.", "0"],
["gimnoto", "gimnot-o", "(ich) (<I>Gymnotus</I>), similar to <I>elektroforo</I>, but not electric.", "0"],
["gineceo", "ginece-o", "gynaeceum. <B>1</B> (hist). <B>2</B> (bot) fem. organs of a flower.", "0"],
["ginekologio", "ginekolog/io", "gynaecolog/y. <B>~(iist)o</B>, -ist.", "0"],
["gineo", "gine-o", "guinea (21 shillings).", "0"],
["gingivo", "gingiv-o", "(<I>dentkarno</I>), Gum(s). <B>~ito</B>, in- flammation of the gg. (phon) <B>~alo (</B><I>gingiva konsonanto</I>), postdental.", "0"],
["ginglimo", "ginglim-o", "(<I>ĉarnirartiko</I>), (anat) gingly- mus, hinge-joint.", "0"],
["ginko", "gink-o", "(bot) gingko, maiden-hair tree.", "0"],
["ginsengo", "ginseng-o", "ginseng (Panax shinsheng). (pharm) <B>~a</B> radiko.", "0"],
["gipaeto", "gipaet-o", "bearded vulture, lammergeyer (<I>Gypaetus</I>) (Le 11/13, Rd 14/12).", "0"],
["gipo", "gip-o", "griffon vulture (<I>Gyps</I>).", "0"],
["gipso", "gips-o", "[UV] Gypsum. <I>Stuka ~o, Plaster (of Paris), (med</I>) ~a bandaĝo; en~igi kruron. <I><B>~i</B></I> (coat with) p. ~i muron, plafonon. <I><B>~(ad)isto</B>,</I> p-er. <B>~aĵo</B>, p-cast, p-ware, ➞ <I>alabastr, selenit, stuk</I>. [Ne= cigano, plastro].", "0"],
["gipsofilo", "gipsofil-o", "(bot) chalk plant, baby’s breath (Gypsophila).", "0"],
["girfalko", "girfalk-o", "(<I>iasfalko</I>), gyrfalcon (<I>Falco</I> rusticolus).", "0"],
["giri", "gir-i", "gyrate, go round in circle or spiral, whirl. ~oskopo, ~ostato. <B>ll</B>~eno, (ent) whirligig beetle (<I>Gyrinus</I>).", "0"],
["girlando", "girland-o", "[OA] (<I>florkrono</I>), Garland, wreath (of flowers, leaves, etc.). <I>~o el rozoj</I>. ~i (<I>-n</I>), crown (deck) with gg. Kap<B>~o</B>, chaplet. ➞ <I>feston</I>.", "0"],
["giso", "gis-o", "an alloy of carbon with a metal. ➞ <I>fand, muld</I>.", "0"],
["gisto", "gist-o", "(<I>bierfeĉo</I>), yeast, <B>~aĵo</B>, leaven. <B>~pulvoro</B>, baking-powder. ,Sen~a (unleavened) <I>pano</I>.", "0"],
["gitaro", "gitar-o", "[UV] Guitar. ~o elektra, Hispana, plektra. Havaja ~o (ŝtala ~o), Hawaian g. Pra<B>~o</B>, gittern. ➞ <I>ukulel</I>.", "0"],
["glacea", "glace-a", ". Glaze/d, with high gloss finish, satin, shiny, smooth. <I>~a karton-(paper -tol-)o, ~a ledo</I>, glace kid. <B>~igi. 1</B> g. ➞ <I>glazur. 2</I> (cul) g., crystallize, gloss, ice, satin (<I>fruktojn</I>, etc.).", "0"],
["glacio", "glaci-o", "[UV] <B>1</B> Ice. <I>~o artefarita</I>. <B>f</B> <I>Rompi la ~on. 2</I> similar object. <I>Kokosa ~o,</I> coconut i. <B>~a</B>, icy, very cold. <I>~a epoko</I>. <B>f</B> (malvarma, frosta): <I>~a akcepto</I>. <B>~aĵo</B>, [UV] (cul). i-cream. <I>Vanila ~aĵo. ~aĵisto</I>, i-c man. <B>~ejo</B> (<I>~amaso</I>), glacier (a. <I>gleĉero</I>). <B>~ero</B>, piece of i. <B>~igi</B>, turn to i., freeze. <I>~igilo</I>, freezing-machine. <I>~iga punkto</I>. <B>~iĝi</B>, freeze, congeal, <B>f</B> <I>~iĝi de timo</I>. <B>~ujo</B>, <B>~ŝrank(~tenej)o</B>, -cellar, -safe, cold store. <B>~flota}o</B>, <B>~tavolo</B>, -floe. <B>~benko</B>, <B>~tavolaro</B>, (<I>bankizo</I>), -pack. <B>~kampo</B>, -field. <B>~monto</B>, -bering. <B>~pendajo</B>, icicle. <B>~rompajo</B>, break-up. <B>~rompilo</B>, -breaker. <B>~ĉirkaŭ(~ten)ita</B>, -bound. <B>Antaŭ~a</B>, preglacial. <B>Sen~a</B>, i-free. ➞ <I>sukerkovri (kukori</I>).", "0"],
["glaciso", "glacis-o", "(mil) glacis.", "0"],
["glaco", "glac-o", "(spegula vitro), (plate) Glass. <B>~isto</B>, glazier. <B>~izi</B> fenestr-(dom-)on, fit (furnish) with g. ➞ flint, vitr(at).", "0"],
["gladi", "glad-i", "(-n), [UV] Iron (clothes), smooth with an i. <B>~ilo</B>, <B>~ist(in)o</B>, -er. <B>~felto. ~maŝino. ~otablo</B>, -ing board.", "0"],
["gladiator", "", "-o [OA], (hist) gladiator, sword- fighter.", "0"],
["gladiolo", "gladiol-o", "(bot) corn-flag, sword-lily (<I>Gladiolus) &lt; irid</I>.", "0"],
["glando", "gland-o", "[UV] (anat), Gland. <I>~o limfa, sekrecia, saliva, ŝvita</I>. <B>~(ec)a</B>, <B>~hava</B>, -ular, -ulous. <B>~a</B> tumoro (<I>adenomo</I>). <B>~forma</B> (<I>adenojda</I>), glandiform. <B>~inflamo. ~omalsano</B>, glanders, etc. ➞ <I>tonsil</I>.", "0"],
["glano", "glan-o", "[UV] <B>1</B> (<I>kverka frukto</I>), Acorn, oak mast. <B>~ingo</B>, a-cup. <B>~forma</B>, glandiform. <B>Mar~o</B> (<I>balano</I>). <B>2</B> (anat) <I>penisa pinto</I>. ➞ <I>gland, nuks</I>.", "0"],
["glareolo", "glareol-o", "(orn) pratincole (<I>Glareola</I>).", "0"],
["glaso", "glas-o", "[UV] (drinking) Glass, tumbler. <I>Vin-o</I>. (Plen)~o da, g-(ful) of. <I>Trinki el ~o. Trinki du ~ojn</I>. (col) <I>Esplori la fundon de la ~o</I>, drink to the dregs. Muzikaj ~oj (<B>~aro</B>, ~harmoniko), musical gg. <B>~ego</B>, beer-mug, tankard. ➞ <I>kalik, pokal, vaz, vitr</I>.", "0"],
["glata", "glat-a", "[UV] Smooth. <B>1</B> s-surfaced, bright, sleek, soft, velvety: <I>~a kiel spegulo. Jakob estis homo ~a. ~a akvo, haŭto, surfaco, ŝtofo, vitro</I> (1 Sa 17/40, Ps 55/21). <B>2</B> (<I>facila, senobstrukca</I>): easy, equable, unruffled, without difficulty (hindrance, hitch, impediment). <I>~a laboro, parolo, stilo, vojo</I>. <B>3</B> (<I>dolĉa, ĝentila</I>): bland, conciliatory, honeyed, winning. <I>~a bus-dang -parol-)o</I>. <B>~e</B>, easily, evenly, smoothly. <I>La afero iras (vivo fluas) ~e. ~e mensogi. Vivi sate kaj ~e. 4</I> (mus) legato. ~aĉa, glib, hypocritical. ~(ec)o, -ness, gloss. <B>~aĵo</B>, s. spot. <B>~igi</B>, (make) s., plane. <I>~igi harojn, lignon, vivon, vojon</I>. <B>~umi</B> (<I>karesi</I>): caress, pass the hand over. <I>~umi barbon, katon</I>. ~langa, ~parola, ~vizaĝa. s-spoken(-tongued, -faced). For~igi (<I>diferencon, malfacilaĵon</I>), s. away (out, over). ➞ <I>eben, glad, glazur, glit, plan, plat</I>. <B>Mal~a</B>, <B>ne~a</B>, Rough; bumpy, clumsy, coarses, hairy, rude, rugged, unpolished, etc. <B>f</B> awkward. <I>~~a lango, versaĵo, viro, vojo</I>. <B>~~aĵo</B>, r-ness, asperity, bump, inequality. ~~igi -en, rasp.", "0"],
["glaŭbera", "glaŭber-a", "<I>salo</I>, Glauber’s salt (<I>natria sulfato</I>).", "0"],
["glaŭcio", "glaŭci-o", "yellow horned poppy (<I>Glaucium</I>). ➞ <I>papav</I>.", "0"],
["glaŭka", "glaŭk-a", "(<I>bluverda, marverda, verdgriza</I>), Glauc/ous, dull, greyish green (with whitish bloom). ~a <I>folio</I>.", "0"],
["glaŭkomo", "glaŭkom-o", "(med) glaucoma. ➞ <I>katar- akt</I>.", "0"],
["glaŭkonito", "", "(min) -onite.", "0"],
["glavo", "glav-o", "[UV] sword. <I>Nuda ~o</I>, cold steel. <B>~ingo</B>, scabbard. <B>~ofrapo</B>, sword-blow, sword-stroke, accolade. <B>~fiŝo</B>, <B>~forma</B>, <B>~mortigi</B>, <B>~piko</B>, <B>~puŝo</B>, <B>~plato</B> (<I>klingo</I>), <B>~portilo</B> (<I>portepeo</I>). ➞ <I>ksifi, sabr, spad, rapir</I>.", "0"],
["glazuro,", "glazur-o,", "[OA] Glaz/e (of ceramics), vitreous coating. <B>~i</B>, g. <I>~ita briko (tegolo, vazo</I>). <B>~isto</B>, -ier. ➞ <I>apret, emajl, glace, lak, polur, verniz</I>. <B>gleĉer-o</B>, glacier.", "0"],
["gledicio", "gledici-o", "honey locust (tree), (<I>Gleditsia</I>). <B>glekom-o</B>, ground ivy (<I>Glechoma</I>) ➞ <I>nepet</I>.", "0"],
["glicerino", "glicerin-o", "[OA] (a. <I>glicerolo</I>), Glycerin. Nitro<B>~o</B>, nitro-g. ➞ <I>dinamit</I>. glicin-o, (ch, phot) glycine. ➞ <I>soj</I>.", "0"],
["glicerio", "gliceri-o", "sweet grass (<I>Glyceria). ~o flotanta</I>, flote grass.", "0"],
["glicirizo,", "gliciriz-o,", "[OA] Liquorice (<I>Glycyrrhiza), ~a radik-(suk-)o</I>.", "0"],
["glikozo", "glikoz-o", "[OA] (ark), = glukozo [OA].", "0"],
["glimo", "glim-o", "[UV] (min) Mic/a. ~(bril)i, gleam, glimmer, glow. ~(ec)a, ~hava, ~oza, -aceous. ~skisto, m-slate. ➞ <I>skist</I>. gliptik-o, glyptics. <B>~aĵo</B>, engraved gem <I>&gt; intajl, kame</I>.", "0"],
["glio", "gli-o", "(mus) glee (English form of pt-song for male voices).", "0"],
["gliptodonto", "gliptodont-o", "(pal) glyptodon.", "0"],
["gliptoteko", "gliptotek-o", "glyptotheca, museum of <B>1</B> carved gems, <B>2</B> sculpture.", "0"],
["gliro", "glir-o", "(<I>dormomuso) &gt;</I> fat dormouse, seven-sleeper (<I>Glis</I>).", "0"],
["glisi", "glis-i", "(nt) (<I>Glitflugi</I>), (av) Glid/e, fly without engine. ~ilo, -er. <I>Akvo~ilo</I>, hydroplane, speedboat. ~anguIo, -ing angle. ➞ <I>glit, ŝveb</I>.", "0"],
["gliti", "glit-i", "(nt), [UV] Slid/e. <B>1</B> slip. <I>~i sur vaksita pargeto</I>. <B>2</B> (<I>~kuri</I>), s., as boys on ice. <B>3</B> (<I>~iri</I>), Glide, flow, move gently, pass, steal. <I>Nub-(ole-serpent-sunradi-temp-)o ~as. Boato ~as sur lago. ~i (fall) en mizeron. Li ~is el la cambro. 4 (~fali, el~i</I>), slip. <I>La tranĉilo ~is el miaj manoj</I>. <B>~o</B>, s., slip, (phon) g. from one sound to another. Flank<B>~o</B>, side-slip. Ter<B>~o</B>, earth-s. Vost~o (av) tail-s. ~a <I>tubo (de trombono</I>). ~e (mus) glissando, portamento. <B>~ado</B>, glissade. <B>~aĵo</B>, ~peco (<I>ŝovpeco</I>), (mec) s-er, carriage, -ing „ ring, (umbrella) runner. (Kur) ~ejo, s. <I>Ŝip~eĵo (klinebeno</I>), (mar) slips, slip-way, stocks. ~emigi, lubricate, etc. ~iga (slippery) <I>angul -(parget-voj-)o. ~igi (-n</I>), cause to s. or slip (PI 4/18). ~umi (<I>sketi</I>), skate. <B>~ilo</B> [UV] (<I>~umilo, sketilo</I>), skate. ~bobeno (<I>tiavedo</I>), shuttle. ~ŝuo, drag-shoe, shoe (of brake), skidpan. <B>~veturilo</B> [UV] (<I>sledo</I>) sledge, sleigh. <I>Mana ~veturilo,</I> toboggan. El<B>~i</B>, For<B>~i</B>, slip (steal) away (out). En<B>~i</B>, steal in. <I>La pejzaĝo</I> preter~is. <B>Tra~i</B> <I>inter la amaso</I>. ➞ <I>flu, glat, glis, jor, preterportiĝ, ŝov</I>.", "0"],
["globo", "glob-o", "[UV] Glob/e; orb, sphere. <B>Bilarda</B> (<I>kroketa</I>) <B>~o. Okul~o</B> (➞ <I>pupil</I>), eyeball, apple of the eye. <B>Ter~o</B>, (geog) terrestrial g. <B>~(form)a</B>, orbicular, spherical. (<I>Tut)~a milito</I>, global war. <B>~aĵo</B> (2 Kr 4/12). <B>~eto</B>, -ule. <B>Aer~eto</B>, <B>gas~eto</B>, bubble (➞ <I>bobel</I>). <B>Rip~eto</B> (umbrella), tip. <B>(Rul)~etoj</B> (gm) marbles. <B>Sang~eto</B>, corpuscule. <B>~ludo</B>, bowls. ➞ <I>artik, bul, globus, kloŝ, krajon, sfer. [tie~~pilko]</I>.", "0"],
["globuso", "globus-o", "Globe (spherical map). <I>~o ĉiela, tera</I>, astronomical (terrestrial) g.", "0"],
["gloro", "glor-o", "[UV]. Glor/y. <B>1</B> high fame, honour, lustre, renown (➞ <I>fam, honor, prestiĝ, renom): Sen laboro nenia ~o</I>. <B>2</B> effulgence, grandeur, magnificence, majesty, splendour, ➞ <I>belego, brilego, majestego: La ~o de Dio (la ĉielo</I>). 3 (<I>fierind-aĵo, -ulo</I>), ornament, subject for pride: La <I>~o de la nacio</I>. <B>~i</B> (<I>-n</I>) (<I>laŭdegi</I>), -ify, extol, laud, magnify, praise. <I>~i Dion</I> (Ps 148, 150). <I>~ata estu (=estu ~o al) Dio</I>, praise be to God. <I>Sin~i (fanfaroni</I>), Blow one’s own trum &gt;et, plume one’s. <I>Kiu sin ~as, malbone odorus</I>. <B>~a</B>, glorious, celebrated, famous, great, illustrious, renowned. <I>~a poeto, venko. Morti</I> <B>~e. ~ado</B>, glorification. <B>~igi</B>, make glorious, exalt, invest with radiance, transform into something splendid (➞ <I>apoteoz</I>). <B>~inda</B>, grand, magnificent, praiseworthy. <B>~amo</B>, <B>~avido</B>, ambition, love of fame. <B>~himno</B>, <B>~kanto</B>. (Ne 12/27, 46). <B>Mal~o</B>, disgrace, dishonour, ignominy, infamy, opprobrium, shame. <B>~~i</B> (<I>malhonori</I>), abuse, defame. <B>Sen~a</B>, in-ious.", "0"],
["glosino", "glosin-o", "Glossina &gt; tsetse-fly.", "0"],
["gloso", "glos-o", "Gloss (words), elucidatory annotate, comment, note, remark. <I>Marĝena ~o</I>, marginal note. <I>Diri la tutan veron sen ~o</I> (the whole truth and nothing but the truth). <B>~i</B> (<I>-n</I>), comment on, expound, supply with notes. <B>For~i</B>, explain away. <B>~aro</B>, glossary. <B>~isto</B>, commentator, critic. ➞ <I>interpret, koment, signifoklarig</I>.", "0"],
["gloto", "glot-o", "(anat) Glott/is. <B>~a</B>, -al. <I>~a fendo. ~a plosivo</I>, -al stop.", "0"],
["glugli", "glugl-i", "(nt) (onom), gurgle (as water bubblg out of bottle or runng over stones); gobble-gobble (turkey).", "0"],
["glui", "glu-i", "(<I>-n</I>), [UV] Glue, Paste, Stick, fasten (join) with adhesive material. (Jes 44/18). <I>~i markon al koverto</I>. <B>f</B> turn firmly. <I>Okulo, orelo ~ita al la ŝlosilo</I>. <B>~o</B>, glue, paste. <B>Amela ~o</B>, starch, p., stiffening. <B>Bird~o</B>, bird lime. <B>Faruna ~o</B>, p. <B>Fiŝ~o</B>, fish-glue, isinglass. <I>Ĝelatena, hufa ~o</I>, g. <B>Grajn~o</B>, granulated g. <B>~oj</B>, adhesives. <B>~(ec)a</B>, glutinous, sticky, tacky. <B>~aĉa</B>, clammy. <B>~aĵo</B>, <B>~ilo</B>, sticky (adhesive) substance. <B>~eto</B>, size. (4/w)~&gt;<SUP>sto</SUP>t bill s-er. <B>~izi</B>, g., gum, size (paper, wood, etc.). <B>Al-iĝi</B> <I>al= alkroĉiĝi al, alligiĝi al</I>, stick, adhere closely; <B>f</B> attach one’s., cling close (to). <I>Al~iĝema,</I> adhesive, agglutinative. <B>Kun~i</B>, s. tight. <B>Mal~i</B>, unstick. <B>Kun~i</B>, s. together. ➞ <I>gum, lut, mastik</I>.", "0"],
["glukozo", "glukoz-o", "[OA 8] (<I>vinbera sukero</I>), glucose, dextrose, grape-sugar. ➞ <I>glikoz</I> (ark).", "0"],
["glumo", "glum-o", "(bot) glume, husk. ➞ <I>lodikl, pale</I>.", "0"],
["gluteno", "gluten-o", "gluten. ~eca, glutinous.", "0"],
["gluti", "glut-i", "[UV] Swallow, absorb. <I>~i pilolon, teon</I>. <B>f</B> consume, devour. <I>~iper la okuloj. Ne ~u!</I> Not to be taken! For external use only! <B>~(aĵ)o</B>, bite, draught, gulp, mouthful. <I>Per unu ~o. Trinku unu ~on</I> (3 FA 74/2) (➞ <I>plenbuŝ</I>). <B>~ado</B>, -ing. <B>~ejo</B>, s., gullet, throat. <B>~ema</B>, gluttonous, greedy. <I>~emulo</I>, glutton. <B>~enda</B>, for internal use. <B>~eto</B>, sip. <B>~igi</B>, cram down the throat. <B>En~i</B>, <B>For~i</B>, s. (drink) down, consume, devour, eat (drink) up (Ps 124/3). <B>f</B> 1, engulf. <I>Ilin en~is la mar-(ter-)o</I> (El 15/12). <B>2</B> (<I>konsumi, kosti, postuli): ~i oron. Ĵete en~i</I>, gulp down. <B>Mis~i</B>, s. the wrong way. ➞ <I>gorĝ, gul,</I> <B>glute-o (</B><I>sidvango</I>), gluteal muscle, buttock, rump. <B>~oj (</B><I>postaĵo</I>), bottom. ➞ <I>pug</I>.", "0"],
["Glu! glu!", "", "(abbreviation) sound of water flowing out of a bottle.", "0"],
["gnafalio", "gnafali-o", "(bot) cudweed (<I>Gnafalium</I>). <B>Rim</B>.: Some cudweeds are <I>gnafalioj</I>, others are <I>filagoj</I>).", "0"],
["gnejso", "gnejs-o", "(min) gneiss.", "0"],
["gnomo", "gnom-o", "[OA] (<I>minkoboldo</I>), (myth) gnome, elemental spirit of earth.", "0"],
["gnomono", "gnomon-o", "gnomon; style, pillar (of sundial, etc.); (a. geom.).", "0"],
["gnostika", "gnostik-a", "<B>~ulo</B>, <B>(rel) gnostic. ~ismo</B>, <B>-ism</B>.", "0"],
["gnuo", "gnu-o", "gnu, wildebeest (<I>Connochaestes</I>).", "0"],
["Go", "G-o", "[F], letter G. (ac) 784 <I>vibroj sekunde</I>. <B>G-be (G bemola)</B>, G flat. <B>G-is (G diesa)</B>, G sharp. <B>G-klefo. G-kordo</B>, G string, <B>gabar-o</B>, lighter, flat-bottom barge (non self-propelled, usually towed).", "0"],
["gobio", "gobi-o", "[UV] (ich) gudgeon (<I>Gobio</I>).", "0"],
["gobiuso", "gobius-o", "(ich) Goby (<I>Gobius). ~o nigra,</I> black g.", "0"],
["goeleto", "goelet-o", "= <I>skuno</I>.", "0"],
["gofri", "gofr-i", "(<I>-n</I>), Go(ff)(ph)er, crimp, flute, wave (edge, trimmg) with hot iron. <B>~ilo</B>, -ing iron.", "0"],
["golfo", "golf-o", "[UV] <B>1</B> (geog) Gulf, large narrow- mouthed bay (Jos 18/19). <I>~o intermonta (fjordo</I>), fjord. <B>~a fluo</B>, g-stream. <B>~eto</B>, creek. <B>2 ~(lud)o</B>, <B>~i</B>, (sp) golf. <B>~ejo</B>, g-links. <B>~eto</B>, putting <B>(gm). ~isto</B>, -er. <B>goliat-o</B>, goliath beetle (<I>Goliathus</I>).", "0"],
["golo", "gol-o", "(sp) Goal. <B>~i (</B><I>trafi ~on)</I>) <B>~ejo</B>, <B>~ulo</B>, g-keeper. <B>~fosto</B>, g-post. ➞ <I>cel</I>.", "0"],
["gondolo", "gondol-o", "[OA] Gondol/a, Venetian canal- boat. <I>~a kanto</I>, Vn boat-song. ➞ <I>barkarol</I>. <B>~isto</B>, -ier.", "0"],
["gongo", "gong-o", "(<I>sonora metala disko</I>), (mus) Gong. to g., e.g., <I>ĉe boksado, tagmanĝo</I>. ➞ <I>tamtam</I>.", "0"],
["goniometro", "goniometr-o", "(<I>angulmezurilo</I>), Goniomet/ er. <B>~io</B>, -ry.", "0"],
["gonokoko", "gonokok-o", "gonococcus.", "0"],
["gonoreo", "gonore-o", "gonorrhoea, clap. ➞ <I>blenore</I>.", "0"],
["gopako", "gopak-o", "gopak, Russian dee.", "0"],
["gorĝo", "gorĝ-o", "[UV] <B>1</B> Throat, gullet, throttle, wind-pipe. <I>Teni ĉe la ~o. Meti trantilon al ies ~o. Premi al iu la ~on(strangoli</I>), strangle, throttle. <B>2</B> <I>Monta ~o</I>, defile, gorge, gully, ravine. <B>3</B> (mar) narrows. <B>~a</B>, guttural, throaty. <B>~a</B> <I>liter-(sori)-o,</I> guttural. <B>~doloro</B>, sore <B>t. ~ŝirmilo</B>, (arm) gorget. <B>El~igi (</B><I>el-ĵet-sput-vom-i</I>), disgorge. <B>Plen~e</B> (<I>el tuta ~o</I>), lustily. <B>Ruĝ~o (</B><I>rubekolo</I>), robin.", "0"],
["gorilo", "goril-o", "[OA] gorilla (<I>Gorilla</I>). ➞ <I>timpani</I>.", "0"],
["gotika", "gotik-a", "[OA] Gothic. <B>1</B> (arch) (<I>ogiva, pintarka</I>). <B>Fru~a</B>, early g. <B>2</B> (typ) <I>~a litero (sono</I>), g. type (character).", "0"],
["graci", "", "<B>-a</B>, [UV] Graceful (of form, manner, movement, etc.) attractive, charmg, dainty, elegant, pretty, refined. <I>~a stilo, vazo, virino, Jozef estis ~ kaj bela</I> (Ge 39/6). <B>~(ec)o</B>, -ness, charm. <B>~ulino</B>, graceful (charming) girl. <B>Mal~a</B>, awkward, clumsy, coarse, gauche, gawkish, hulking, uncouth, ungainly. <B>Mal~ulo</B>, gawk, lout. <B>Sen~a</B>, devoid of grace. ➞ <I>carm, delikat, elegant, gracil, harmoni</I>.", "0"],
["gracila", "gracil-a", "gracefully slender, slight, slim, thin, willowy. <I>~a kiel kano</I>. ➞ <I>beltali [Ne= malsaneta]</I>. <B>Mal~a</B> lumpy, solid, thickset. ➞ <I>diktrunk, masiv, vastkorp</I>.", "0"],
["gracilario", "gracilari-o", "(<I>Gracilaria) (ruĝa algo) &gt; Cejlona musko</I>. ➞ <I>agaragar</I>.", "0"],
["graco", "grac-o", "(thl) grace, unmerited favour (help, influence) from God. ➞ <I>graci, kompat, korfavor, plat. [Ne= danko temanĝa]</I>.", "0"],
["gradiento", "gradient-o", "gradient, amount of slope (rise or fall). <I>~o aerprema, temperatura, traka, voja</I>. ➞ <I>klin</I>.", "0"],
["grado", "grad-o", "[UV] Degree, Grade. <B>1</B> stage (measure) of proficiency, quality, strength, etc.: <I>~o de kapablo, perfekto. En tia ~o</I>, to such ad <I>.La plej forta ~o</I>. (gram) <I>~oj de komparo</I>. <B>2</B> (<I>mezuro</I>): d. of scale, pressure, temperature, etc. <I>Kvin ~oj super nulo</I>. (mat) 1/360 of a circle. <I>Angulo de 30 ~oj</I>. <B>3</B> (<I>rango</I>): g., rank. <B>(Laŭ)~a</B> (<I>iompostioma, malsubita</I>), gradual. <B>~e</B>, gradually, by dd. <B>~igi</B>, arrange in gg., class, graduate, sort. <I>~igi ekzercojn, instruon</I>. <B>~izi</B> (make marks on) <I>termometron</I>. <B>~ado</B>, <B>~aro</B>, <B>~eco</B>, <B>~izo</B>, grad(u)ation, scale. <B>Alt~e</B>, to a high d. <I>Plej alt<B>~e</B></I>, consummately, highly. <B>De~i</B> (opp <I>alt igi</I>), degrade. <B>Laŭ</B>~e (<I>proporcie</I>). <B>Valor~o</B>, (phlt) denominate. <B>Varm~o</B>, temperature. <B>Unua~(Dua~)a</B>, primary, secondary. ➞ <I>etap, klas, nivel, stadi, ŝtup</I>.", "0"],
["grafiko", "grafik-o", "pictorial presentation, especially by diagrams or symbolic curves. <I>~aj artoj</I>. <B>~i</B>, plot. <B>~aĵo</B>, graph. ➞ <I>desegn, grafism, gravur, skrib</I>. grafism-o, (gram) written form of words, ➞d. with sound (opp<I>.fonetism</I>).", "0"],
["grafito,", "grafit-o,", "[OA] graphite, blacklead (for pencils), <I>plumbago</I>.", "0"],
["grafo", "graf-o", "[UV] Earl (England), Count (abroad). <I>Via ~a Moŝto!</I> <B>~ejo</B>, <B>~lando</B>, county, e-dom (➞ <I>provinc</I>). <B>~igi</B> <I>iun</I>. <B>~ino</B>, c-ess. <B>Vic~o</B>, viscount.", "0"],
["grafologio", "grafolog/io", "[OA] grapholog/y. <B>-o</B>, [OA] handwriting expert.", "0"],
["grajlo", "grajl-o", "(met) frozen snow-pellets, sleet.", "0"],
["grajno", "grajn-o", "[UV] Grain. <B>1</B> small seed: <I>~o de aveno, pipro, tritiko, rizo</I> (1 Sa 17/17); pip (<I>de pomo, oranĝo, piro</I>). <B>2</B> small particle: <I>~o de oro, pulvo, salo</I>. <B>3</B> (<I>iometo</I>): smallest possible quantity. <I>~o da saĝo, vero</I>. ➞ <I>gut, ombr</I>. <B>~(ec)a</B>, <B>-plena</B>, <B>~ita</B>, -y, granul-ar-ated. <B>~aĵo</B> (Le 2/16). <B>~eto</B>, granule, jot, particle. <I>~etoj da sablo</I> (Jes 48/19). <B>~igi</B>, granulate. <B>~ledo</B>, shagreen, grained leather (<I>ŝagrino</I>). <B>~omanĝa</B>, graminivorous. <B>Tut~a</B> (<I>pano</I>), wholemeal. ➞ <I>er, gran, gren, kern, sem</I>.", "0"],
["grajpo", "grajp-o", "(mar), gripe, lashing claw.", "0"],
["graki", "grak-i", "<B>caw</B>, croak (as crow, raven, rook, frog) (also figuratively) <B>~a</B> <I>voĉo</I>, harsh, hoarse, raucous, scratchy. ➞ <I>raŭk</I>.", "0"],
["gramatiko", "gramatik-o", "[UV] Gramm/ar. <I>~o ĝenerala, kompara, historia</I>. ➞ <I>fonetik, morfo- logi, sintaks</I>. <B>~a</B>, -atical. <B>~isto</B>, -arian. <B>Kontraŭ~a</B>, <B>Ne~a</B>, un-atical.", "0"],
["gramenoj", "gramen-oj", "<B>-acoj</B>, grain plants (<I>Grami- neae</I>). ➞ <I>gren, gres</I>.", "0"],
["gramo", "gram-o", "[OA] gram(me), unit of mass. <B>Centi-(deci-kilo-mili-)gramo.</B>", "0"],
["gramofono", "gramofon-o", "[OA] gramophone. <B>~a</B> <I>disko,</I> record. ➞ <I>fonograf, parolmaŝin</I>.", "0"],
["granato", "granat-o", "[UV] Pomegranate (1 Rĝ 7/18). <B>~arbo</B>, p-tree (<I>Punica granatum). ~a floro, siropo</I>.", "0"],
["granda", "grand-a", "[UV] <B>1</B> great; big, large, vast. <I>~a ĉambr(kamp - kun ven - liter-mont)o</I>. <B>2</B> (amount, quantity): <I>~a kapitalo, komerco, profito</I>. (el) <I>~o altern-(oscilant-period -pulsant-)a</I>, alternating (oscillating, periodic, pulsatg) quantity. <B>3</B> (quality): (a) (<I>altgrada, supera</I>), major, noble, of high standing (remarkable quality), weighty: <I>~a intelekto, koro, spirito, talento, valoro, venko, vorto</I>. (b) (<I>forta, intensa, profunda, trea): ~a doloro, ĝojo, kolero</I>. (c) (<I>Altranga, emi- nenta, grava, potenca): ~a homo</I>. <B>5</B> (mus) (<I>majora): ~a trito</I>, major third (5/4). <B>~(ec)o</B>, size, bulk, magnitude, mass, quantity. <I>Natura ~o</I>, life size. ➞ <I>kvant, nombr, valor</I>. <B>~i</B>, (<I>aspekti</I> <B>~a</B>), loom, tower, etc. <B>~aĉa</B>, unwieldy. <B>~ega</B>, enormous, gigantic, huge, immense, mighty. <B>~egulo</B>, giant, monster. ➞ <I>gigant, grandioz, elefant, kolos, mamut, titan</I>. <B>~eta</B> (<I>iom ~a</I>), fairly big, largish. <B>~iĝi</B>, grow (up). <B>~ulo</B>, g.man (wide sense) <B>~aĝa</B> (<I>multjara</I>), aged. <B>~anima</B>, [UV] high- souled, magnanimous. <B>~era</B>, <B>~peca</B>, coarse. <I>~ere muelita</I>, coarse ground. <B>~sinjora</B>, lordly. <B>~industrio</B>, <B>-skala</B>, <B>~urbo</B>. Ne<B>~a</B>, scanty, etc. <B>Pli~igi</B>, augment, enlarge, extend, increase, magnify. <B>Malpli~igi</B> (<I>redukti</I>), belittle, decrease, diminish, lessen, mitigate, reduce. <B>Po~a (~kvanta)</B>, wholesale. <I>Po~a komerco</I>. <B>Tro~a</B>, excessive, exorbitant, extravagant, immoderate. <B>Tro~igi (troigi)</B>, carry too far, exaggerate. ➞ <I>ampleks, dikeg, glor, grandioz, nobl, vast</I>. <B>Malgranda</B>, Small, insignificant, little, slight. <I>~a infano</I>. (mus) (<I>minora), ~a trito,</I> minor 3rd, 6/5. <I>~a duto</I>, minor tone (10/9). <B>~aĉa</B>, mean, paltry, petty. <B>~aĵo</B> (<I>bagatelo</I>), s. matter, trifle. <B>~ega</B>, diminutive, miniature, minute, tiny, (➞ <I>et, liliput, malgrav, miniatur, minimum</I>). <B>~egulo</B> (<I>pigmeo, nano</I>), dwarf, pigmy. <B>~iĝi</B> (<I>malkreski, ŝrumpi</I>), grow s., contract, shrink. <B>Po~isto</B>, retail daler. <B>~anima</B>, narrow-minded, niggling, of cramped ideas, petty.", "0"],
["grandioza", "grandioz-a", "[OA] (<I>impone granda</I>), Grand (iose), fine, gorgeous, imposing, magnificent, noble, splendid. <B>~aĉa</B>, pompous, tawdry. ~(ec<B>)o</B>, -eur, etc. <B>~e</B>, magnificently. <B>Mal~a</B>, sordid, squalid. ➞ <I>grand, impon, pomp, sublim</I>.", "0"],
["granito", "granit-o", "[UV] granite. <I>Malmola kiel ~o</I>. <B>~a</B> <I>monto</I>. <B>f</B> <I>~a volo</I>.", "0"],
["grano", "gran-o", "(pharm) grain (weight) (0-06 gr.).", "0"],
["granulo", "granul-o", "(pharm) granule. ➞ <I>grajn</I>.", "0"],
["grapfrukto = pomelo", "", "(➞ <I>pampelm</I>).", "0"],
["graplo", "grapl-o", "(mar) grapnel, grapplg iron. <I>~aj hokoj</I>. <B>~i</B> grab, grapple.", "0"],
["grapolo", "grapol-o", "bunch, cluster, e.g., <I>de cepoj. korintoj, vinberoj</I>.", "0"],
["graso", "gras-o", "[UV] Greas/e, Fat; butter, cream, oily matter. <I>~o besta, minerala, planta</I>. <B>Kandel~o</B>, tallow, candle-grease. <B>Gut~o</B>, dripping. <B>Lan~o</B>, wool-g. <B>Pork~o</B>, lard. <B>Ren~o</B> (<I>sebo</I>), suet. <B>ŝmir~o</B>, lubricating g. <B>~a</B>, fat, greasy, oily (land, cake), rich; (person) adipose, obese; (typ) bold. <B>~(dik)a</B> <I>bovino</I>. <B>~eca</B>, <B>~oza</B>, <B>mult~a</B>, g-y, fatty. <B>~i</B> (<I>~ŝmiri</I>), g. (➞ <I>lubrik, ole</I>). <B>~aĉa</B>, g-y, smeary. <B>~aĵo</B>, fat part. <B>f</B> <I>Manĝi la ~aĵon de la lando</I>. <B>~ega</B>, obese, swollen. <B>~eta</B>, plump. <B>~igi</B>, <B>~iĝi</B> (Rd 32/15) f-ten. <B>~histo</B>, adipose tissue. <B>~makuli</B>, soil with g. <B>~okuloj</B> (in soup). <B>Mal~a</B>, without fat, lean, meagre, poor, spare. <I>~~ega</I>, emaciated, scraggy. <B>Sen~a</B>, without fat. <I>Sen~aĵo</I>, lean (of meat), <B>Tro~a</B>, obese, pot-bellied. ➞ <I>dik, ole, vazelin</I>.", "0"],
["grateni", "graten-i", "(cul) bake with cheese and breadcrumbs. <B>~e</B>, au gratin.", "0"],
["grati", "grat-i", "(<I>-n</I>), [UV] Scratch; claw, score, scrape. <I>~i la kapon, surfacon; je la pordo; per fingro la haŭton, per hufo la teron. ~i la gorĝon</I>, tickle the throat. <I>Kie jukas, tie ni ~as</I>. <B>~(aĵ)o</B>, s., graze, scar. <I>En unu sako du katoj, tiam mordoj kaj ~oj</I>. <B>~eto</B>, slight s. ~ilo, scraper, etc. ~vundi, s. open. El~i (s. out) <I>ies okulojn</I>. <B>De~i</B>, <B>for~i</B>, efface. <B>Ungo~i</B> (<I>ungi</I>). ➞ <I>fend, rasp, skrap</I>.", "0"],
["gratif(ik)i", "", "give a bonus (tip). <B>~o</B>, bonus. ➞ <I>kromsalajr, trinkmon</I>.", "0"],
["gratuli", "gratul-i", "(<I>-n,pri,pro</I>), [UV] Congratulat/e, express sympathetic joy. <I>Sin ~i</I>, think one’s fortunate. <I>Kun sincera</I> <B>~o</B>, -ion. ~a (-ory) <I>leter-(parol-)o</I>.", "0"],
["graŭli", "graŭl-i", "(-nt) Growl (as a dog), murmur angrily. <B>~o</B>, g., guttural sound of displeasure, rumble, snarl, <B>f</B> complaint. ➞ <I>murmur</I>.", "0"],
["graŭvako", "graŭvak-o", "(geol) greywacke.", "0"],
["grava", "grav-a", "[UV] (<I>atentinda</I>), Import/ant, grave, impressive, momentous, serious, weighty. <I>~a decido, dokumento, evento, nomo, kunveno, tago. Plej ~a afero (plej~aĵo</I>), main thing. <I>Ne (estas) ~e!</I> It doesn’t matter! No matter! Never mind! <B>~e</B> (seriously) <I>vundita</I>. <B>~i</B> (impersonal) (<I>ke</I>), be i., count, have weight. <I>~as, ke vi iru. Kiom ~as?</I> What does it matter? <B>~(ec)o</B>, -ance, gravity, moment, stress, weight. <I>Afekti</I> ~econ, put on airs. <B>~ega</B>, critical, decisive, momentous, solemn. <B>~igi</B> (<I>bagatelon</I>), make a fuss about. <B>~ulo</B>, person of -ance. <B>~aspekta</B>, i-looking. <B>~miene</B>, gravely, solemnly. <B>ĉef~a</B>, of prime -ance. <B>Mal~a</B> (<I>bagatela</I>), un-ant, of no -ance (consequence), futile, trifling, trivial. <I>~~aĵo (bagatelo</I>). <B>Ne~a</B>, of little -ance. <B>Pli~aĵo</B>, (med) complication. <B>Malpli~igi</B>, extenuate, palliate. <B>Viv~a</B>, vital, ➞ <I>alt, eminent, influ, pez, serioz, signif(oplen</I>).", "0"],
["graveda", "graved-a", "[UV] Pregn/ant, enceinte, in the family way, with child (young). <I>Profunde ~a</I>, far advanced. <I>Trimonate ~a</I>, <B>f</B> ~a <I>de ideoj, de pluvo</I>, teeming with ideas, big with rain. <B>~(ec)o</B>, -ancy, gestation. ~igi (<I>patrinigi</I>), fertilize, im-ate. <B>~iĝi</B>, conceive (Ge 4/1). <I>Monto ~iĝis, muso naskiĝis. ~iĝema</I>, prolific. <B>~ulino</B>, woman with child. ➞ <I>akuŝ, nask</I>.", "0"],
["gravito", "gravit-o", "(<I>pezforto</I>), Gravit/y, -ation. ~i (nt) -ate. <B>f</B> circle (revolve) round, move towards. <B>~a</B>, -ational. ➞ <I>pivot</I>.", "0"],
["gravuri", "gravur-i", "(<I>-n, en, sur</I>), [UV] (En)grave; carve, cut, etch, incise (with instrument or acid). <I>~i en la kor-(memor-)o</I>. ➞ <I>enskrib, konserv, not</I>. ~ad(~aj~art)o, -ing (2 Kr 2/7). Foto<B>~o</B>, photogravure. Gem-ado (<I>gliptiko</I>). Streka <B>~ado</B>, line- work. Ligna <B>~aĵo</B>, woodcut. Elektro~ (kupro~zinko~)aĵo. Ŝtal<B>~aĵo</B>, steeling, ~ilo, gravg tool, burin, style (➞ <I>grifel</I>). <B>~isto</B>, -er. ➞ <I>akvafort, tiz(el), entrant, giloŝ, strek</I>.", "0"],
["grebo", "greb-o", "(a. <I>podicipo</I>), Grebe (<I>Podiceps</I>). ~o nigrakola, black-necked g. ~o orela, Slavonian or horned g. ~o ruĝgorĝa, red-necked g. ~o tufa, great crested g. Malgranda <B>~o</B>, little g., dabchick.", "0"],
["grefti", "greft-i", "(<I>-n, en, sur</I>). Graft. <I>~i arbon, branĉon en trunkon</I>. (surg) <I>sur~i haŭton</I>. <B>~(ad)o</B>, grafting. (nwk) invisible mending. <I>Burĝona (okula) ~o</I>, budding, <I>Fenda (flanka, kojna, kopula) ~o</I>, Cleft (side, notch, splice) g-ing. <B>Suĉ~o</B>, inarching. <B>ŝel~o</B>, barking, rinding. ~a <I>bazo (baztrunko</I>), parent stock, wildling. <I>~a vakso,</I> g-ing wax. <B>~aĵo</B> (<I>~a branĉeto</I>), scion, shoot. <B>~ilo</B>, g-ing knife. ➞ <I>markot, transplant</I>.", "0"],
["grego", "greg-o", "[OA] (<I>brutaro</I>), Herd, drove, flock. <I>~o da anseroj, bovoj, ŝafoj</I> (Ge 29/2-8, 32/16). <B>f</B> (<I>senorda attaro</I>) crowd, multitude. ~a <I>instinkto</I>, herd instinct. <B>~ejo</B>, fold, pasture (Mi 2/12; Jn 10/16). <B>~ema</B>, gregarious. <B>~igi</B>, <B>~iĝi</B>, herd together. ➞ <I>band, hord, trup</I>.", "0"],
["grejso", "grejs-o", "(<I>sabloŝtono</I>), sandstone.", "0"],
["greko", "grek-o", "[OA 8]. <B>G~ujo, G~io</B> [OA-8] GR.", "0"],
["grenado", "grenad-o", "[UV] (<I>obuseto</I>), (mil) Grenad/e. <B>Fusil~o</B>, <B>man~o</B>, rifle-grenade, hand-g. <B>~isto</B>, -ier.", "0"],
["Grenado", "Grenad-o", "GD.", "0"],
["grenato", "grenat-o", "(min) garnet. ➞ <I>ruben</I>.", "0"],
["greno", "gren-o", "[UV] Corn, Grain; cereals. <I>Kia ~o, tia pano</I>. <B>~a</B>, cereal, corn. <B>~ejo</B>, [UV] c-loft, garner, granary (Ge 41/56). <B>~ero</B>, genus of c., seed. <B>~ujo</B>, c-bin (➞ <I>si I</I>), <B>~kampo</B>, c-field. <B>~planto</B>, cereal. <B>~rikolto</B> (Jes 16/9). <B>~ventumaĵo</B>, chaff, husks. <B>~ventumilo</B>, winnow, ➞ <I>cereal, grajn, gran</I>.", "0"],
["greso", "gres-o", "Grass. ~ejo, herbage, pasture. ~landoj, g-lands. -tapiŝo (<I>razeno</I>). ➞ <I>herb</I>.", "0"],
["grifelo", "grifel-o", "[UV] <B>1</B> slate-pencil. <B>2</B> (<I>gravurilo</I>), graver, stylus, etc. (Jes 44/13).", "0"],
["grifo", "grif-o", "(myth) griffin, gryphon. ➞ <I>gip</I>.", "0"],
["grifono", "grifon-o", "(<I>grifhundo</I>), griffon (dog).", "0"],
["grilo", "gril-o", "[UV] (ent) Cricket (<I>Gryllus</I>). Dom~o (Hejma ~o), house c. Kampa <B>~o</B>, field c. Talpo<B>~o</B>, mole-c (<I>Gryllotaepa</I>). ➞ <I>lokustel</I>.", "0"],
["grimaco", "grimac-o", "[UV] Grimac/e, affected or ugly look, wry face. <I>~o de doloro (moko</I>). ~i (<I>fari ~on</I>) (Se 10/10), g., make a face. Lip~i (<I>fari dikan Upon) (paŭti</I>). pout, make a lip. Rid<B>~i</B>, grin. ~(ant)a, ~ema, -ing, grinning. ➞ <I>ridetaĉ, rikan, tik</I>.", "0"],
["grimpi", "grimp-i", "(<I>-n, abs</I>) [OA], Climb; especially clamber, scale, scramble with hands and feet (Jer 4/29, J1 2/7). <I>~i malsupren tra la kamentubo. ~i sur arbo, al la supro. Rok~nio</I>, rock c-ing. ~aĵo (<I>~a planto</I>), -ing plant, creeper. <I>~a rozo</I>, rambler. <B>~anto</B>, <B>~isto</B>, -er. <B>~ulo</B>, -er (beast, bird, plant). <I>Mur~ulo</I>, (orn) wall-creeper (<I>Tichodroma</I>). El<B>~i</B>, supren<B>~i</B>, sur<B>~i</B>, trans~i. ➞ <I>ascend, suprenir</I>.", "0"],
["grinci", "grinc-i", "(<I>nt</I>), [UV] make a grat-(grind-)ing noise, creak, grate, squeak (<I>kiel grifelo sur ardezo; grilo, maŝino</I>). ~(ad)o, grating, <I>-ado de ĉarnir-(segil-)o</I>. ~igi <I>la dentojn</I>, gnash one’s teeth (Ij 16/9). ➞ <I>ĉirp, grat, klak, knar, skrap</I>.", "0"],
["grio", "gri-o", "[UV] grits, groats (coarse grain, hulled or crushed, especially oats) (Se 27/22). Hordea <B>~o</B>, pearl barley. Maiza <B>~o</B>, hominy, <B>~aĵo</B>, gruel, porridge. ➞ <I>aven, kaĉ</I>.", "0"],
["gripo", "grip-o", "[OA] (med) influenza. ~ulo.", "0"],
["griza", "griz-a", "[UV] Gray, grey, <B>1</B> (between black and white) <I>~a ĉevalo, lupo, nubo, okulo, vesto. Perl~a</I>, pearl g. <B>2</B> between light and dark, clouded, depressing, drab, dull, overcast. <I>~a tago (vetero</I>). <B>3</B> white with age, ancient, hoary. <B>~i</B>, look g. ~(ec)o, gray(ness). ~igi (~iĝi), make (turn) g. (1 Sa 12/2) ~(barb)ulo, -beard. ~hara, ~kapa, -haired, grizzled.", "0"],
["groco", "groc-o", "gross, 12 dozen (144). <I>~o da ovoj</I>.", "0"],
["grogo", "grog-o", "[OA] grog, drink of rum and water, grond-i, (a. <I>grundi, algrundiĝi</I>), (mar) ground, run ashore, strand.", "0"],
["Gronlando", "Gronland-o", "GL.", "0"],
["groso", "gros-o", "[UV] Gooseberry (<I>Ribes grossul- aria</I>). ~ujo, ~arbusto, g-bush. ➞ <I>rib</I>.", "0"],
["groŝo", "groŝ-o", "[UV] groschen (various species). (➞ English groat), <B>f</B> low-value coin. <I>Sen ~o en poŝo</I>. ➞ <I>sold</I>.", "0"],
["groteska", "grotesk-a", "[OA] (<I>ridinde stranga</I>), bizarre, comically distorted, grotesque, ludicrous from incongruity. <I>~a art-(danc-gest -vizaĝ-)o</I>. <B>~aĵo</B>, antic, etc. <B>~ulo</B>, comic figure.", "0"],
["groto", "grot-o", "[UV] grotto, artificial cavern, picturesque cave. ➞ <I>kavern</I>.", "0"],
["grujero", "grujer-o", "(cul) gruyere cheese.", "0"],
["grumbli", "grumbl-i", "[OA] (<I>plendmurmuri</I>), (nt) Grumbl/e, grouse, growl faintly, murmur complainingly. ~(ad)o, g., -ing. <B>f</B> (<I>intesta bruo</I>), rumble. ~ema, -ing, faultfindg, grumpy, peevish, querulous. <I>Vekiĝi ~ema</I>, get out of bed the wrong way. <B>~ulo</B>, -er. ➞ <I>graŭl, grunt, murmur, plend</I>.", "0"],
["grumo", "grum-o", "groom, stable-lad.", "0"],
["grundo", "grund-o", "[OA] Ground. <B>1</B> Earth, Soil; ~o <I>akveca, argila, batpremita, disfalema, facila. fekunda, firma, gruza, kalka, kompakta, malfekunda, loma, sabla, seka, ŝton(oz)a</I>, marshy, clayey, tamped, loose, light, fertile, firm, gravelly (gritty), chalky, heavy, barren, loam, sandy, dry, stony (g., e., s.). (1 FA 106/29, 108/27). <I>Torfa ~o,</I> peat. <B>2</B> (<I>terposedaĵo</I>): ground(s), land estate (<I>biend</I>). 3 <I>bazo, fundamento, starejo</I>, bottom, basis, foundation, substratum, underlying part (Ij 22/16): <I>Stari sur neŭtrala ~o. Firma ~o de faktoj</I>. <B>~i</B> (<I>ensabliĝi, grondi, surteriĝi</I>), (run a-)ground. <B>Sub~o</B>, sub-s. ➞ <I>bien, fon, fund, hum, parcel, teren</I>. <B>Rim</B>.: <I>Ter</I> and <I>grund</I> are sometimes used synonymously without clear distinction.", "0"],
["grunti", "grunt-i", "(nt), grunt, make a low gruff sound as a pig. <B>f</B> express discontent, dissent, etc., by this. ➞ <I>graŭl, ronk</I>.", "0"],
["gruo", "gru-o", "[UV] Crane. <B>1</B> (orn) Crane (<I>Megalornis grus</I>). <B>Pav~o</B> (<B>Kron~o</B>), crowned c. <B>Virgulina ~o</B>, demoiselle c. <B>~aro</B>, flight of cc. <B>2</B> (mec) = <I>argano</I>.", "0"],
["grupo", "grup-o", "[UV] Group; body, cluster (number of persons or things belonging or classed together): <I>~o Esperanta, familia, loka. ~o de dokumentoj. Lingvo ~o</I>, language group. <I>Liter~</I>o, (e.g., <I>kl, spr</I>). <B>2</B> (soc) (<I>partieto): ~o politika</I>. <B>3</B> irregular or unofficial cross- division. ~a <I>kunveno. Sidi</I> ~e. <B>~ano</B>, member of a g. ~ejo, meetg-place. <B>~eto</B>, clique, small g. (mus) (<I>turno</I><B>)</B>, <B>~igi</B> (<I>arigi</I><B>). ~iĝi (</B><I>ariĝi</I>). (come together in a) g., rally. <I>Marŝi</I> <B>-ope. ~estro</B>, (sctg) g- leader. ➞ <I>ar, band, koteri, parti, sekt</I>.", "0"],
["gruzo", "gruz-o", "[OA] (<I>ŝtonetaĵo</I>), Gravel, coarse sand. <B>2</B> anything in small pieces, e.g., <I>karba ~o</I>. <B>~a</B>, -ly, gritty. <B>~igi</B>, break into small pieces. <B>~malsano</B>, (med) gravel. ➞ <I>pirit, silik</I>.", "0"],
["guanako", "guanak-o", "(zoo) guanaco, llama (<I>Lama guanicoe</I>).", "0"],
["guano", "guan-o", "(<I>marbirda ekskremento</I>), Guana. <B>~i</B>, (manure with) g.", "0"],
["guaŝo", "guaŝ-o", "gouache, painting in opaque water-colour.", "0"],
["gubernio", "guberni-o", "[OA] Russian administrative district. <B>~estro</B>, governor. ➞ <I>departement, distrikt, provinc</I>.", "0"],
["gudro", "gudr-o", "[UV] Tar, pitch, bituminous product from distillation of carbonaceous matters. <B>Karba ~o</B>, coal-t. <B>~o olea</B>, <B>(pina). ~(ec)a</B>, -ry. <B>-i</B> (<I>~oŝmiri</I>), spray t. <B>~ita</B>, tarred. <I>~ita pavimo (ŝipo). ~ila kartono</I>, t-board. <B>~oakvo</B>, t-water. <B>-openiko</B>, t-brush. <B>-otuko</B>, -paulin.", "0"],
["gufo", "guf-o", "[UV] Eagle owl, grand duke (<I>Bubo</I>) (Jes 13/21, 34/11).", "0"],
["Gujano", "Gujan-o", "GY", "0"],
["gujavo", "gujav-o", "Guava (fruit). <B>~arbo</B>, g-tree (<I>Psidium). ~a ĵeleo</I>, g-jelly.", "0"],
["gulaŝo", "gulaŝ-o", "goulash (Hungarian highly seasoned ragout).", "0"],
["guldeno", "gulden-o", "[OA] (num) gulden (various species). ➞ <I>floren</I>.", "0"],
["gulo", "gul-o", "(zoo) glutton, wolverine (<I>Gulo</I>).", "0"],
["gumiguto", "gumigut-o", "Gamboge, resin from <B>~arbo</B>, <I>-tree</I> <B>(</B><I>Garcinia cambogia</I>).", "0"],
["gumo", "gum-o", "[UV] Gum. <B>1</B> rezinous material. <B>Amela ~o</B> (<I>dekstrino</I>). <B>Araba (akacia) ~o</B>, g. arabic. <B>Junipera ~o</B>, sandarac-gum. <B>Maĉ~o</B>, chewing-gum. <B>Traganta ~o</B>, g. tragacanth, gum dragon (➞ <I>astragal</I>). <B>~i</B> (<I>&lt;glui</I>), (smear with) gum. <B>~(ec)a.</B> -ita, -my, -med. <B>~arbo</B>, gumtree, indiarubber tree (various species, also ordinary language for <I>eŭkalipto</I>). <B>~solvaĵo</B>. <B>2</B> (<I>elasta ~o, kaŭĉuko</I>), <B>(a)</B> (substance), indiarubber. <B>(b)</B> (<I>grat~o, skrap~o</I>), eraser (<I>inka, krajona</I>). ➞ <I>glu</I>.", "0"],
["gurdo", "gurd-o", "[UV] hurdy-gurdy. <B>Diska ~o</B>, juke-box. <B>Piano~o</B> (<I>stratpiano</I>), barrel-organ. <B>Pingla ~eto</B>, musical box. <B>~i</B> (<I>ludi -on</I>), <B>f</B> (<I>fari automate, maŝine, rutine</I>): grind out, strum. <I>~ita (tede ripetita) frazo</I>, hackneyed phrase. <B>~isto</B>, h-g man.", "0"],
["gurnardo", "gurnard-o", "(ich) grey gurnard (<I>Trigla gurnardus</I>). ➞ <I>trigl</I>.", "0"],
["gusto", "gust-o", "[UV] Tast/e. <B>1</B> (<I>impreso surpalata</I>), flavour, relish, savour: <I>~o acida, amara, bona, sala, sukera. ~o de cepoj, de fumo. Ordonita kiso havas ~on maldolĉan</I>. <B>2</B> (<I>senso</I>): organoj de ~o. Havi delikatan ~on. <B>f</B> homo kun ~o, man of (good) taste.<I> <B>3</B> (inklino, plaĉo, prefero): fancy, liking, predilection</I>. <I>~o por sukeraĵoj. ~o nacia, persona. Pri ~oj ne disputu. Laŭ mia ~o, just as I like it</I>. <I>Kiom da homoj, tiom da ~oj. ~oj kaj ~etoj, fads and fancies</I>. <B>~i</B> (<I>nt), (have the) t. (of). ~i acide, dolĉe, sape, taste sour (sweet, like soap). <B>~(hav)a</B>, tastful, tasty, stylish,</I> <B>~igi</B>, <I>season, give t. to. <B>~umi</B> (-n</I>), [UV] <I>taste (something) <B>1</B> (~provi), test by -ing. <B>2</B> (~manĝi, manĝeti), have a t. of</I>. <B>f</B> (<I>ĝui, sperti): ~i morton, plezuron, sperton, sukceson</I>. <B>Mima</B>, <I>gustatory. <B>Te~</B></I><B>umisto</B>, <I>tea-er. <B>Akre~a</B>, sharp. <B>Antaŭ~o</B>, fore-t. <B>Bon~a</B>, <B>1</B> (palatoplaĉa): delicious, nice, palatable, savoury, t-y, toothsome (Alt 2/3) (➞ frandaj</I>). <B>2</B> <I><B>Bon~ulo</B>, person with good t. <B>Brul~a</B>, burnt. <B>Fi~a</B>, unsavoury. <B>Krom-o</B> </I>(~eto), <I>tinge, twang. <B>Malbon~a</B>, nasty, in bad taste. <B>Post~o</B>, after-t. <B>Sen~a</B>, -less, insipid</I>. <I>Sen~a homo, person without taste</I>. <I>Sen~a konduto, parolo</I>.", "0"],
["guŝo", "guŝ-o", "pod (of beans, peas, etc.). ➞ <I>silikv</I>.", "0"],
["gutaperko", "gutaperk-o", "[OA] gutta-percha (latex from various Malayan trees). <I>~a pilko</I>.", "0"],
["guto", "gut-o", "[UV] <B>1</B> Drop: <I>~o da inko, pluvo, sango, ŝvito</I>. <B>2</B> (<I>iometo</I>) small quantity: <I>~o da feliĉo, logiko, saĝo, senco</I>. ➞ <I>er, grajn</I>. <B>3</B> (arch, pharm), gutta (pi guttae). <B>~i</B> (nt), [UV] drop, drip, run down. <I>Larmoj ~as de okuloj, roso ~as de folioj. Ne ~as mielo el la ĉielo</I>. <B>~e</B> (<I>iom post iom). Feliĉo venas ~e, malfeliĉo flue</I>. <B>~ado</B>, dropping, dripping (Se 19/13). <B>Rost~aĵo</B>, <B>viand~aĵo</B>, dripping. <I>Maro estas nur</I> <B>~aro. -eti</B>, trickle, dribble. <B>~igi</B> (<I>verŝi po~e</I>). (Jĝ 5/4, Rd 33/28). <B>~igilo</B> (<I>-botelo, ~komputilo</I>), burette, dropper, etc. <B>De~igilo</B>, drainer, plate-rack, etc. (➞ <I>rak</I>). <B>~ujo</B>, dripping-pan. ➞ <I>defluilo</I>. <B>El~i</B>, exude, leak, ooze out. <B>Po~e</B> (<I>~on post ~o</I>), a d. at a time. <B>Tra~i</B>, percolate.", "0"],
["guturalo", "gutural-o", "(<I>a. velaro), sono gorĝa, vela</I>. (phon) guttural.", "0"],
["guverni", "guvern-i", "[UV] act as tutor, bring up (coach, educate, train) at home, give private tuition. <I>~i per korespondado</I> (K 207/1) <I>[Ne= regi, reĝi]</I>. <B>~ado</B>, tutelage. <B>~at(in)o</B>, pupil, ward. <B>~anto</B>, <B>~isto</B>, preceptor, tutor. <I>~istino</I>, governess. ➞ <I>direkt, instru, reg, vart</I>.", "0"],
["guzlo", "guzl-o", "(m.i.) guzla (<I>Slava unukorda violono</I>).", "0"],
["gvardio", "gvardi-o", "[UV] (<I>gardistaro</I>), (mil) (the) Guard(s). <I>Meti ~on antaŭ la pordon</I>. <B>~a</B> <I>regimento</I>. <B>~ano</B>, -sman. <B>~ejo</B>, -house, -room. <B>Antaŭ~o</B>, advance-g., van-g <B>Post~o</B>, rear-g.", "0"],
["Gvatemalo", "Gvatemal-o", "[OA-8] GT.", "0"],
["gvati", "gvat-i", "(be on the) Watch (look-out) for, lie in wait for, waylay. <B>~ejo</B>, look-out, crow’s nest (mar), <B>~isto</B>, look-out (man). <I>~istaro</I>, watch. <I>Nokta ~istaro</I>, night watch. ➞ <I>gard, insid, observ, sekv, spion, spur</I>.", "0"],
["gvidi", "gvid-i", "(<I>-n</I>), [UV] Guid/e, Lead (show) the way, conduct, direct, steer. <I>~i blindulon, konduton, kurson, vizitant-)on. Sin ~i per kompaso. Aliajn ~as, kaj mem ne vidas</I>. <B>~(ad)o</B>, -ance. <I>Sub Dia ~o</I>. <B>~a</B>, -ing (<I>principo, stelo</I>). <B>~anto</B>, <B>~isto</B>, g., conductor, leader. <B>~ato</B> (Jes 9/16). <B>~ilo</B>, g. <B>1</B> standard. <B>2</B> -ing bar (rail, rope). ➞ <I>direktil, stiril</I>. (av) <I>Radio~ilo</I>, radio-beacon. <B>~folio</B>, <B>~libro</B>, ~<B>plako. ~mark ~(sign)o</B>, guide, landmark, referencemark. <B>Mis~i</B>, misguide, mislead. <B>Naz~i</B>, lead by the nose. ➞ <I>direkt, epitom, informil, konduk, mentor, stir</I>.", "0"],
["Gvineo", "Gvine-o", "[OA-8] GN. <B>Gvine-o-Bisaŭ-o</B> [OA-8] GW. <B>Papu-o-Nov-Gvine-o</B> PG.", "0"],
["ĝaino", "ĝain-o", "(rel) jain. <B>~ismo.</B>", "0"],
["ĝajbi", "ĝajb-i", "(<I>velado</I>) gybe, swing across (alter course as when tacking, but so that the wind crosses round the stern (making the boom cross from side to side, possibly violently if not controlled). An accidental <B>~o</B> (gybe) can have serious results. ➞ <I>tak</I>.", "0"],
["ĝangalo", "ĝangal-o", "jungle, (the) bush. <B>~a</B> <I>febro</I>.", "0"],
["ĝardeno", "ĝarden-o", "[OA] Garden. <I>~o botanika, Edena, pejzaĝa, publika, roka, vintra, zoologia. Flor~o, frukto~o, legom~o</I>. <B>~a</B> <I>floro</I>. <B>~iloj</B>, garden-tools. <B>~isto</B>, -er. <B>Ĉef~isto</B>, head -er. <B>~(um)i</B>, do -ing. <B>~kultivo</B>, (<I>hortikulturo</I>), -ing. ➞ <I>paradiz, park</I>.", "0"],
["ĝelo", "ĝel-o", "(chem) gel, semi-solid colloidal solution, <I>~o agaragara</I>. <B>~a</B>, colloid. <B>~igi</B>, <B>~iĝi</B>, congeal, set (as jelly). ➞ gelatenjele.", "0"],
["ĝemelo", "ĝemel-o", "[OA] <B>1</B> (<I>kunnaskito</I>), twin. <I>~oj de gazelino</I> (Alt 4/5). <B>2</B> (astr) <I>la</I> <B>~oj</B>, Gemini. <B>~ino. f ~a urbo</B>, twin city. <B>~a ŝipo</B>, sister ship. <B>Kvin-(Tri-)-(an)o</B>, quintu-(tri-)plet. <B>f</B> <I>~aj urboj</I>.", "0"],
["ĝemi", "ĝem-i", "(nt), [UV] <B>~o</B>, Groan, moan, wail. (Mi 1/8). <B>f</B> <I>La arbaro, vento ~as</I>. <B>~egado</B> (Ce 1/10, 11) <B>Ek~o</B>, sigh. <B>El~i</B>, g. out. <B>For~i</B> <I>la vivon</I>. <B>Pri~i</B>, bewail, mourn for. <B>Dolor~i</B> g. with pain. <B>Plor~i (~krii)</B>, blubber, sob. ➞ <I>lament, plend, sopir, suspir, ve</I>.", "0"],
["ĝendarmo", "ĝendarm-o", "[OA] (<I>polica solidato</I>), (mil) Gendarm/e, armed policeman. <I>Rajda ~o,</I> mounted policeman. <B>~aro</B>, -erie. <B>~ejo</B>, g. headquarters.", "0"],
["ĝenerala", "ĝeneral-a", "[OA] (<I>tutampleksa</I>), General, affecting (relating to) all or nearly all, to a whole class (Not individual, limited, local, sectional, or specialized). <I>~a amnestio, bildo, kunveno, opinio, pardo, prognozo, regulo</I>. (log) <I>~a propozicio</I>. <B>~e</B>, for the most part, in g., in a g. way, on g. grounds, speaking g-ly <I>[Ne= kutime, ordinate, plej ofte]</I>. <B>~aĵo</B>, -ity, g. principle (law, statement). <B>~igi</B>, -ize. ➞ <I>komun, universal</I>. (M 2/16, 40/16, 93/24, 186/24, 187/12; 1 FA 9/4, LR 9/13).", "0"],
["ĝeni", "ĝen-i", "(<I>-n</I>),, [UV] Embarrass; annoy, be in one’s way, bother, cramp, disturb, grate, hamper, incommode, inconvenience, make uncomfortable (uneasy), trouble. <B>Sin~i</B>, feel restraint, put one’s out, stand on ceremony. <I>Ne ~u vin!</I> Don’t bother (fash yourself)! (abs) <I>Tio ne ~as</I>, It’s no trouble, <B>~a</B>, -ing, awkward, disagreeable, troublesome, vexg. <I>~a prokrasto</I>. <B>~(aĵ)o</B>, bother, inconvenience, nuisance, restraint, trouble. <I>Kiom da ~o mi kaŭzis!</I> <B>~ata</B>, -ed, bothered, ill at ease, etc. <I>~ateco</I>, -ment, uneasiness, etc. <B>~eca</B>, constrained, prim, <I>~eca sinteno</I>. <B>~ulo</B>, intruder, nuisance, troublesome person. <B>Sen~a (Sen~ata)</B> (<I>hejmeca, intimeca, negliĝa, neformala, senceremonia</I>), at home, at one’s ease, cool, frank, free and easy, off-handed, unceremonious, unconstrained, unreserved, unrestricted. <B>Trosen~a</B> (<I>maldeca, malkonvena, senhonta</I>), unabashed, imperturbable. ➞ <I>enuig, ted</I>.", "0"],
["ĝenio", "ĝeni-o", "djinn (of Arabian nights).", "0"],
["ĝentila", "ĝentil-a", "[UV] Courte/ous, Polite; civil, considerate, cultured, of refined manners, well-bred. <I>[Ne= </I>genteel, gentle]. <I>~a ag-(Jtom-kondut-)o</I>. <B>~aĵo</B>, c-sy. <I>~aĵoj,</I> compliments. <B>~eco</B>, p-ness, civility, urbanity. <B>~ulo</B>, p. person, gentleman. <B>Mal~a</B>, Rude; boor-(churl-lout-)ish, dis-c, im-p, uncivil. <B>~~ulo</B>, boor, rough. <B>~~ulino</B>, impudent hussy. <B>Ne~a</B>, im-p. ➞ <I>afabl</I>.", "0"],
["ĝermana", "ĝerman-a", "(<I>pragermana, germaneca</I>). Germanic, Teutonic. <I>~aj lingvoj</I>.", "0"],
["ĝermo", "ĝerm-o", "[UV] Germ. <B>1</B> (bio) embryo, first stage. <B>2</B> microbe, especially one capable of causing disease. <B>3</B> begining, elementary principle, rudiment, seed. <I>~o de disput -(malsan-revoluci-)o</I>. <B>~i</B>, -inate, bud, put forth shoots. <I>La semo ~is</I>. <B>f</B> (<I>deveni, fonti, origini, naskiĝi</I>), arise, spring up. <I>Tiu dezir-(dub-ide-)o ~is el..</I>. <B>~ado</B>, -ination. <B>~igi</B>, cause to -ate. <I>~igi semon</I>. <B>~iva</B>, -inable. <B>Sen~a (</B><I>sterila, nesepsa, senmikroba</I>), sterile. <I>Sen~igi</I>, sterilize.", "0"],
["ĝero", "ĝer-o", "pond-skater, water-bug. (<I>Gerris</I>).", "0"],
["ĝeto", "ĝet-o", "(mar) jetty, groyne, (landing) Pier, protecting mole. <B>Flotanta ~o</B>, boom. <B>Promena ~o</B>, (a. <I>piero</I>), seaside pier. <B>~a</B> <I>kajo</I>, landing-stage, wharf. <B>~kapo</B>, j-(p-) head.", "0"],
["ĝi", "", "[UV] (pron) It. Used <B>1</B> for objs (a) without sex. (b) of indeterminate sex (=// aŭ Si). Se iu venos, diru al ke… La infano ploras, ĉar ~ volas manĝi. Ĉu ~ estas knabo aŭ knabino? <B>2</B> For non-human animals, unless personified. <B>3</B> as a synonym of tio. ~ ne estas li. Ĉu ~ estas vi, kiu …? ~ estas virino. Ne kredu ~n. Ho, ~ estas ja tro vera: <B>~a</B>, its, of it, thereof. En therein. Sur thereon.", "0"],
["ĝibo", "ĝib-o", "[UV] hump, hunch. <B>1</B> of man or beast. <I>Propran ~on neniu vidas. Unu~a kamelo (dromedaro</I>). <B>2</B> boss, bump, protuberance. <B>~a</B>, <B>~hava</B>, humped, bulging, hunch-backed, (astr) gibbous. <B>~aĵo</B>, <B>~eco</B>, gibbosity. <I>La kato</I> <B>~igis</B> (arched) <I>la dorson</I>. <B>~igi</B>, become bent, stoop. <B>~ulo</B>, hunchback (Le 21/20). ➞ <I>bos, elstaraf, konveks, protuberanc, ŝveltuber</I>. ĝig<B>-o</B>, (mus) gigue, jig.", "0"],
["Ĝibutio", "Ĝibuti-o", "DJ.", "0"],
["ĝigolo", "", "gigolo.", "0"],
["ĝimkano", "ĝimkan-o", "(sp) gymkhana.", "0"],
["ĝino", "ĝin-o", "[OA] gin, liquor from grain or malt, usually juniper-flavoured.", "0"],
["ĝirafo", "ĝiraf-o", "[UV] giraffe (<I>Giraffa camelopardalis</I>).", "0"],
["ĝiri", "ĝir-i", "[OA 8], (com) (<I>subskribi dorse</I>), Endors/e, back, negotiate (bill or cheque) (<I>transpagi</I>): make over, transfer. <I>~i ĉekon al iu</I>. <B>~o</B>, -ment. <I>~o blanka</I>, blank (open) -ment. <B>~anto</B>, -er. <B>~ebla</B>, negotiable. <B>~ato</B>, -ee. ➞ <I>debit, kredit, trat</I>. <B>~banko</B>, clearing bank.", "0"],
["ĝis", "", "., [UV] (prep). <B>1</B> (<I>loko</I>), as far as, down to, up to: <I>~ ilia domo. ~ (la loko), kie. ~ tie,</I> as (so) far as there, to there. <I>~ ĉi tie</I> (Ij 38/11). <I>~ ii tiu loko</I> (1 Sa 7/12), hitherto. <I>Nur</I> no further than, <B>f</B> <I>ami ~ frenezo</I>, love to distraction. <I>Kortuŝite ~ larmoj. Proponi</I> ~ (as much as, up to) <I>10s. La prezo falis ~</I> (to) 3<I>p</I>. 11 (with accusatv). <I>Atendu du jarojn</I> <B>= dum</B> <I>du jaroj</I>. Sim: <I>Atendu du ĝis tri jarojn</I> (or) <B>dum</B> <I>inter du kaj tri jaroj</I> (➞ <I>proksimume du aŭ tri jarojn). Iru du ~ tri paŝojn</I>, <B>2</B> (<I>inkludo, mezuro): de kapo ĝis piedoj, from</I> head to foot. <I>De matene ~ vespere, from</I> morn to night. <I>De majesta ~ ridinda estas nur unu paŝo</I>. 3 (<I>tempo</I>), till, until: <I>~ nun</I>, till (up to) now, as yet. <I>~ revido! Au revoir! ~ tiam</I>, till then. <I>~ kiam?</I> How long? Till when? <I>~ kiam li atendu?</I> How long must he wait? (El 10/3; Ps 13/1, 2; No 14/11). <B>4</B> (conj): <I>~ mi venos,</I> till I come (1 Rĝ 10/7). <I>~ ili ĉesos paroli</I> (Ij 32/16) (1 Rĝ 22/27; <B>1</B> Kr 28/20, Ez 10/14, Ij 14/14, Ps 73/17, 132/5; Alt 2/17; Jer 32/5; Mi 7/9). ITHere Z never used <I>ĝis kiam:</I> possible, but heavy and inadvisable: but see <B>3</B> above. In the only exception (No 14/33) the superfluous <I>kiam</I> may have been added by an editor. <I>PFX:</I> <B>~alpa</B>, cisalpine. ~nuna <I>kutimo,</I> up to the present. <B>~morta</B>, life-long. <I>Trinki (Manĝi</I>) -ebrie (~sate) (Jeĥ 39/19). ~funde. <I>Vadi</I> ~genue. <I>Labori</I> ~morte. <I>Plena</I> ~rande (to the brim). ~vivi, live till. ➞ <I>al, antaŭ ol, ne plifrue ol</I>.", "0"],
["Ĝo", "Ĝ-o", "[F], letter Ĝ.", "0"],
["ĝoji", "", "(nt) (<I>pri, pro, ke, i</I>), [UV] Rejoic/e, be delighted (glad, happy, pleased). <I>Mi ~as vin vidi</I>. <B>~o</B>, Joy, delight, gladness, pleasure. <I>Amiko en ~o kaj ploro. Difekti ies ~on. Fari (kaŭzi) ~on al iu. Havi (senti) ~on</I>. ~(plen)a, j-ful, j-ous, blithesome, bright, delighted, gay, glad, merry. <I>~a kor-(kri-okaz-rid-vizaĝ-)o. ~an feston!</I> <B>~e</B>, j-fully, gladly, fain. <B>~ado</B>, -ing (Jes 43/14). <B>~egi</B> (<I>jubili</I>), r. greatly, exult, triumph. ~igi (<I>-n</I>), cheer, delight, gladden. ~krii, shout for j. Sen<B>~a</B>, dull, j-less. Viv<B>~o</B>, j. of life. Mal~i (<I>afiiktiĝi</I>), grieve, be sad (sorry, unhappy). <B>~o</B>, affliction, grief, sorrow. <B>~a</B>, dismal, doleful, melancholy, sad, sorrowful, wretched. ~iga, distressg. <B>~igi</B>, afflict, grieve. ~ulo (Jes 61/2). ➞ <I>aflikt, ĉagren, gaj, ĝu, kontent</I>.", "0"],
["ĝui", "ĝu-i", "(<I>-n</I>), [UV] <B>1</B> Enjoy; find pleasure in, relish (experience) posses sion (use) of. <I>~i koncerton, manĝon, promenon</I> (Pr 2/24). <B>2 (</B><I>posedi, sperti, uzi; profiti el</I>) have benefit (use) of. <B>~iga</B>, <B>~plena</B>, -able, delicious, delightful, nice, pleasant. <B>~(ad)o</B>, -ment, delight, gratification, satisfaction. <B>~egi</B>, delight (revel) in. ~emulo, pleasure-seeker. <B>~igi</B> (<I>-n</I>), fill with delight (Se 5/19). <B>~ilo</B>, means of -ment. <B>~ama</B>, epicurean, pleasure-loving, sensuous. ➞ <I>ĝoj, frand, plezur</I>.", "0"],
["ĝusta", "ĝust-a", "[UV] Right (<I>konforma al regulo aŭ vero</I>), accurate, correct, exact, fair, in order, just (what should be), proper, very. <I>La ~a homo en la ~a loko. ~a pezilo,</I> just balance. <I>~a respondo</I>, correct answer. <I>Uzi la ~an nomon</I>, call a spade a spade. <I>~a ag-(esprim-kalkul-manier-metod-\\oj ■vort-)o</I>. <B>~e</B>, just r., correctly, exactly, precisely. <I>~e difini, juĝi, paroli. Dio ~e faras, neniam eraras. ~e pro tio</I>, just for that, for that very reason. <I>~e tie</I>, r. there. <I>~e same</I>, just the same. <I>~e hodiaŭ,</I> this very day. <I>~e antaŭ mi</I>, just (r., exactly) in front of me. <I>Jen ~e la viro,</I> the very man. <I>~e en tiu tago</I> (Ge 7/13), on the very day, the same day exactly. <I>Pli <B>~e</B></I>, rather. <B>~(ec)o</B>, r-ness, correctness, exactness. <I>Fari ~aĵon</I>, the r. thing. <B>~igi</B> (<I>ordigi, reguligi</I>), put r. (in order). <I>~igi horloĝon, kravaton, iun;</I> amend, rectify; correct (<I>erarori</I>), settle (<I>disputori</I>). ~igilo (tech) balance-(fiy-)wheel, governor, regulator, etc. ~adire, strictly speaking. ~atempa, opportune, seasonable, timely. <B>Al~igi</B>, adapt, adjust. ➞ <I>adapt, akomod, akord-(konform-konven-)ig</I>. <B>Mal~a</B>, erroneus, wrong. <I>~a opinio, vojo</I>. ~<B>~aĵo</B>, error, etc. ~<B>~igi</B>, falsify, pervert. Ne~si, in-accurate(-correct-exact). <B>Re~igi</B> (<I>re- bonigi, ripari</I>), readjust, put r. ➞ <I>ekzakt, just, jus, konven, korekt, nur,prav,preciz, tuj, ver</I>.", "0"],
["haĉi", "haĉ-i", "(<I>ombrostreki</I>), (des) hatch, shade with parallel or (kruc~i) intersecting lines. <I>Fono</I> sen<B>~a</B>, solid background. <B>~aĵo</B>, ~ilo.", "0"],
["hafnio", "hafni-o", "(chem) hafnium (Hf).", "0"],
["hagiografio", "hagio-grafio", "-logio, hagio-graphy, -logy.", "0"],
["Haitio", "Haiti-o", "HT, Haiti.", "0"],
["hajlo", "hajl-o", "[UV] Hail, <B>f</B> shower. <I>~o da batoj, kugloj. Ŝtona ~o</I> (Jes 30/30). ~a <I>pluvego</I> (Jes 28/2). <B>~i</B>, (impersonal) <I>~as</I>, It -s. <B>f</B> <I>Minacoj ~is sur lin</I>. ~ero, -stone. ~neĝo, ~pluvo. ➞ <I>grajl</I>. ~ŝtormo.", "0"],
["haki", "hak-i", "(<I>-n</I>), [UV] Chop, hew (<I>arbon, lignon, viandori</I>). <B>f</B> <I>~i la klavojn</I>, thump the piano. ~ata (jerky) <I>parolo, stilo, vorto</I>. <B>~o</B>, c., blow. <I>~o post ~o</I>. <B>~(it)aĵo</B>, -ped material, hash, etc. ~eti, c. small, mince. <B>~ilo</B>, [UV] axe, hatchet. Batal~ilo, battle axe. <B>Pajl~ilo</B>, chaff-cutter, -ileto, chopper. <B>~tranĉilo</B>, pruning-bill, etc. (arb) <B>~isto</B>, lumber-jack, woodcutter. <I>Ŝton ~isto</I>, quarryman, stone-mason. <B>De~i</B>, <B>For~i</B>, hew down, fell, lop off. <I>De~aĵoj,</I> chips. <B>Fuŝ~i</B>, hack. <B>Pri~i</B>, <B>Ĉirkaŭ~i</B>, dress, rough-hew, square, trim (<I>lignon, Stonori</I>), poll (<I>arbojri</I>). <B>Tra~i</B> (<I>vojon</I>). ➞ <I>fend, noĉ, tranĉ</I>.", "0"],
["haladzo", "haladz-o", "[UV] (<I>fetora emanaĵo</I>). <B>1</B> noxious, unhealthy, unpleasant, unwholesome), exhalation (fume, vapour). <B>2</B> bad smell, stench, stink <I>, ~o forna, kloaka, marĉa, strata. ~o de spiro, de putra viando</I>. <B>~a</B>, f(o)etid, olfensive, stinking. <B>~i</B> (nt) emit sulfocating vapour, fume, infect (taint) the air, reek. ~igi <I>oleon</I> (Pr 10/1). ➞ <I>infekt, malbonodor, meftt, miasm, mucid, naŭz, sufok</I>.", "0"],
["halebardo", "halebard-o", "[OA] Halberd (combined spear and battleaxe). <B>~isto</B>, -ier.", "0"],
["haleluja!", "", "(<I>=Laŭdu Dion!</I>), Halleluja! Alleluia!", "0"],
["haliaeto", "haliaet-o", "(<I>maraglo</I>), sea eagle, white- tailed eagle (<I>Haliaetus</I>).", "0"],
["halikero", "haliker-o", "(<I>Halichoerus</I>), grey seal.", "0"],
["halioto", "haliot-o", "(<I>marorelo</I>), (zoo) ear-shell, ormer (Haliotis).", "0"],
["halmo", "halm-o", "(gm) halma.", "0"],
["halo", "hal-o", "[UV] (bid) hall, <B>1</B> great roofed space, covered market-place, usually supported by pillars. <I>~o fest-(foir-stacidom-templ-)a</I>. <B>2</B> great room. Koncerta ~o. Trink<B>~o</B>, pump-room of spa.", "0"],
["halogeno", "halogen-o", "(chem) halogen (F, CI, Br, I).", "0"],
["halo! hola!", "", "(interjection) hullo! (to call attention, or answer the telephone), <B>halo-o</B>, (opt, phot), Halo. <I>~o lun-(sun-)a</I>. <B>Kontraŭ~a</B>, anti-h. <B>~ado</B>, halation. ➞ <I>kron, htm-ring(-rond), nimb</I>.", "0"],
["halso", "hals-o", "(mar) tack, lashing line. <B>~i</B> <I>velon</I>. <B>~angulo</B>.", "0"],
["haltero", "halter-o", "(sp) dumb-bell.", "0"],
["haltero", "halter-o", "(ent) haltere, balancer (of diptera).", "0"],
["halti", "halt-i", "(nt) [UV] (<I>ĉesi agi</I>), (come to a) Halt, Stop; cease to move, (make a) pause, etc. <I>La horloĝo, vagonaro ~is</I>. <B>~u!</B> (a. Halt!) (4 FA 210/10) (<I> = estu ~o</I>), Halt! Stop! Hold! Stay! (Na 2/8). <I>Ne ~u!</I> Go on! Continue! <B>~o</B>, halt, stop, cessation, pause, (mus) (<I>= silento</I>), rest. <B>Batal~o</B>, truce, armistice, suspension of hostilities. <B>Spir~o</B>, pause for breath. <B>~e</B>, -ingly. <B>~adi</B>, keep on s-ing, loiter. <B>~ejo</B>, h., s-ing place, station, ➞ <I>etap, staci. Nokta ~(ej)o</I>, night lodging (quarters) (Ge 42/47). <I>Ŝip~ejo</I>, port of call. <B>~eti</B>, hesitate. <B>~igi</B> (<I>-n) (ĉesigi agon</I>), (cause to) halt, stop, bring to rest, to a stand-still. <I>~igi ĉevalon, maŝinon, oratoron;</I> keep back (<I>larmojn</I>); hold (<I>spiron). ~iga ĉeno, ŝuo,</I> brake-shoe, drag, skid. <I>~iga ŝraŭbo,</I> s-screw. <I>Sang~iga</I>, styptic. <B>Ne~igebla</B>, irrepressible, irresistable, uncontrollable. <B>~igilo</B>, brake (➞ <I>brems, brid, klik</I>), s-catch (gun, etc.); check, control, escapement (<I>horloĝo</I>). <B>~igisto</B>, brakesman. <B>Antaŭ~igi</B>, check, prevent. <B>Sen~a</B>, continuous, uninterrupted, non-stop, through (train). <I>Sen~a flugo, laboro, parolo</I>. ➞ <I>daŭr, kontinu, konstant, senĉes, seninterromp</I>, ➞ <I>ĉes, pane, paŭz, ripoz</I>.", "0"],
["halucino", "halucin-o", "(<I>sensa trompiĝo</I>), (psy) Hallucinate, apparent perception of something not actually present, illusion. ~i (<I>kaŭzi ~on</I>). <B>~aĵo</B>, h., false image, mirage, phantom vision, etc. <B>~ato</B>, <B>~ulo</B>, person with h. ~iĝi (<I>senti ~on</I>).", "0"],
["halukso", "haluks-o", "(anat) big toe.", "0"],
["hamadriado", "hamadriad-o", "hamadryad. <B>1</B> (myth) (<I>arba nimfo</I>), tree-(wood-)nymph. <B>2</B> (zoo) large Arabian baboon, tartarin (<I>Cynocephalus hamadryas</I>). ➞ <I>naj</I>.", "0"],
["hamako", "hamak-o", "[OA] (<I>pendlito</I>), hammock, hanging bed (Jes 24/20).", "0"],
["hamamel(id)o", "", "(bot) (<I>Hamamelis</I>) &gt; witch hazel (<I>H. virginica</I>).", "0"],
["hamstro", "hamstr-o", "[UV] (zoo) Hamster (<I>Cricetus). Ora ~o</I>, golden h. <B>f ~i</B>, hoard (in time of scarcity).", "0"],
["handikapi", "handikap-i", "(-/;), Handicap, impose a h. on, place at a disadvantage. ~(aĵ)o, h., increased difficulty or burden. ~a <I>kurado</I>. ~isto. ~ita. Sen<B>~a</B>, scratch, handspik-o, (mar) handspike, levering shaft.", "0"],
["hangaro", "hangar-o", "[OA-8], hangar (<I>remizo por veturiloj, aviadiloj</I>). <B>~eto</B>, shed. ➞ <I>ŝed</I>.", "0"],
["hanti", "hant-i", "(<I>-n</I>) haunt (wide sense). <I>Domo, loko ~ata. ~i iun (lokon). ~ita ideo (vidaĵo) min ~as</I>. <B>~a</B> <I>memoro</I>. ➞ <I>fantomvizit, frekvent, vizitad</I>.", "0"],
["hapalo", "hapal-o", "(<I>Hapale</I>), marmoset.", "0"],
["haplologio", "haplologi-o", "(rh) haplology, syllabic syncope e.g., <I>praps, Wensday, tragi(ko) komedio. mineral(lo)logio</I>.", "0"],
["harakiro", "harakir-o", "Harakiri. <B>~i</B>, commit h.", "0"],
["hardi", "hard-i", "(<I>-n, kontraŭ</I>) [UV] (<I>malmoligi</I>), Hard/en, toughen, (tech), anneal, chill, temper (➞ <I>tremp), ~i fandaĵon, feron, glavon. <B>f</B> ~i animon, karakteron, koron</I>. ~i <I>kontraŭ frosto, marmalsano</I>. <B>~ita</B> (de), -ened, -y, seasoned, weather-beaten (➞ <I>fortikig</I>). Provita, ~ita! ~ita (~iĝinta) krimulo. <B>~eco</B>, <B>~iĝi. Mal~i</B>, enervate, soften, weaken. <B>Rapid~a</B>, quick-setting (<I>mortero</I>). ➞ <I>cement</I>.", "0"],
["haremo", "harem-o", "<I>[OA]</I> (<I>Islama edzinaro, edzinejo</I>), harem. ➞ <I>ginece</I>.", "0"],
["haringo", "haring-o", "[UV] Herring (<I>Clupea harengus</I>). <I>~o fumizita kaj salizita</I>, bloater. <I>~o marinita</I>. pickled h. ➞ <I>kiper</I>.", "0"],
["harmoniko", "harmonik-o", "[OA] (m. i.) mouth-organ (<I>=buŝ~o, anĉ~o, buŝakordiono</I>). <B>Rim</B>.: The root <I>harmonik</I> has various meanings in various langs. (a) <B>Buŝ~o</B>. (b) <B>Tir~o</B> (<I>akordiono, koncertino</I>). (c) <B>Glas~o (</B><I>frot~o, glasaro</I>), musical glasses, (d) <B>Frap~o</B>, <B>Perkut~o</B>, various instruments of marimba fam., with or without keybord: &gt; <I>celesto, kampaneto (ŝtal~o), ksilofono, marimbo, tipofono</I>. <B>Rim</B>.: Recommendation: Use these names, and reserve <I>harmoniko</I> for mouthorgan.", "0"],
["harmonio", "harmoni-o", "[OA] Harmon/y. <B>1</B> agreement, consonance, agreeable combination of colours, forms, sounds. <I>2</I> (mus) (<I>~scienco</I>), branch of music dealg with chords. <B>~a</B>, -ious, concordant, euphonious, free from dissent, <B>f</B> <I>~a vivo. Vivi</I> ~e (<I>en ~o</I>), live in concord. ~i (<I>esti en ~o) (kun</I>), -ize, agree (go well) with, match. <I>Lia vivo ~as kun liaj vortoj</I>. <B>~igi</B>, -ize, bring into h., make -ious. ~scienco (<I>harmonizo</I>), -y. <B>Mal~a</B>, <B>ne~a</B>, in-ious, discordant.", "0"],
["harmoniumo", "harmonium-o", "[OA] (<I>anĉorgeno</I>), harmonium. <B>Suĉ~o</B> (<I>suĉorgeno</I>). American (cabinet) organ.", "0"],
["harmonizi", "harmoniz-i", "(<I>-n) (almeti akordojn</I>), (mus) harmon/ize. ~i melodion, h. (put harmony to) a melody. <B>~o</B>, -y, -ization. ~o diatona, kromata, trivoĉa; etendita, kom- pakta.", "0"],
["harmono", "harmon-o", "Harmonic. <B>1</B> In acoustics = \"partial\" (<I>sonero): okt(av)o = la dua -o</I>. 2 For the musician = \"upper partial\" (<I>supertono</I>), and <I>okt(av)o = la unua ~o!</I> <B>~a serio</B> (la fundamenta vibro kaj ĝiaj obloj), h-series. (org) <B>~aro</B> (<I>miksaĵo</I>), mixture.", "0"],
["haro", "har-o", "[UV] Hair. 1 <I>~oj</I>, hair(s). <B>kol~oj</B>, [UV] mane. <B>lip~oj</B>, [UV] moustache. <B>okul~oj</B>, [UV] eyelashes. <B>vang~oj</B>, [UV] side-whiskers. <I>Pub~oj, vost~oj</I>. <B>2</B> (bot) (zoo) fur, wool, etc. <B>3</B> nap, pile. <I>Brosi, hirtigi, kombi, tondi la ~ojn. La ~oj stariĝis</I> (stood on end). <I>Karesi kontraŭ la ~oj</I>, stroke the wrong way. f <I>Fendi ~ojn (tro subtili</I>), split hairs. <I>Ŝanĝi la ~ojn (pri lupo</I>). <B>Blank~a</B>, <B>ruĝ~a. ĉeval~a</B>, <B>kamel~a</B>, <B>Dens~a</B> (<I>~kovrita, ~plena, ~oza</I>), -y, of h., bristly, shaggy. <B>Mol~a</B>, fluffy, silky. <B>~aĵo</B>, coat, fleece, <B>etc. ~aro</B>, [UV] mop, thick head of h. <B>~ego</B>, [UV] stiff (strong) h., bristle, <I>-egoj de histriko</I>. <B>~eto</B>, fine h., down (➞ <I>cili, filament, lanug, vil</I>). <B>f</B> <I>pendi de ~eto</I>, be in extreme danger. <B>~aranĝo</B>, coiffure. <B>~dika</B>, capillary. <B>~disiĝo</B>, parting. <B>~fasketo. ~ligo</B> [UV]. <B>~vosto</B>, lock, pigtail, plait, queue, tress (➞ <I>bukl</I>). <B>~stariga</B>, creepy, h-raising, horrible. <B>~tubero</B>, bun, chignon, pad. <B>~tufo</B>, topknot, toupee, tuft. <B>Sen~a</B>, -less, bald (➞ <I>kalv</I>). <B>~~aĵo</B><I>,</I> bald spot, tonsure. <B>~~iga</B>, delapidatory. <B>~~ulo</B>, bald-head. ➞ <I>adiant, faden, fibr, lan, peruk</I>.", "0"],
["harpio", "harpi-o", "[OA] Harpy. <B>1 (myth)</B>, <B>f rapacious woman. 2 (orn) h-eagle (<I>Harpia harpya</I>).</B>", "0"],
["harpo", "harp-o", "[UV] Harp. Eola <B>~o</B>, Vent<B>~o</B>, Aeolian h. ~o kromata. ~o pedala <B>(<I>unu-</I> aŭ <I>du-mova</I>), single-(double-) action h</B>. ~(lud)i, ~ist(in)o, <B>-er, -ist.</B> ~ujo, <B>h-case. ➞ <I>zumfer</I>.</B>", "0"],
["harpuno", "harpun-o", "[OA], (<I>ŝnurlanco</I>), harpoon. ~i. ~isto. ~ĵetilo (~kanono).", "0"],
["hasti", "hast-i", "(<I>nt</I>) (denotes urgency). Hast/e, -en, make h., (be in a) hurry, rush (to do something). <I>Ne ~u!</I> Don’t hurry!</B> <B>~o</B>, <B>haste, hurry</B>. <B>~a</B>, <B>hasty, hurried, quick-tempered, <I>rush. ~a adiaŭo, manĝo. ~e decidi, skribi</I>. Sen~e, at leisure</B>. <B>Tro~a</B>, <B>precipitate. ➞ <I>rapid</I></B>.", "0"],
["haŝiŝo", "haŝiŝ-o", "(<I>kanaba fumaĵo</I>), hashish, bhang, marijuana.", "0"],
["haŭbizo", "haŭbiz-o", "(mil) howitzer.", "0"],
["haŭli", "haŭl-i", "(mar) haul, drag, forcibly pull at, tow, tug. <I>~i je la ŝnuro</I>. <B>~a</B> <I>vojo</I>, tow-path,", "0"],
["haŭsero", "haŭser-o", "(mar) hawser, large rope, small cable, for towing; sometimes for mooring.", "0"],
["haŭto", "haŭt-o", "[UV] (anat) Skin, cuticle, <B>f</B> sim, covering; film, rind, scum, skim. <B>~(et)o</B> <I>sur lakto, de banano, kolbaso, terpomo</I>. <B>Vaks~o</B> (<I>birdmembrano</I>), cere. <B>~a</B>, s., cutaneous. <I>~a malsano</I>. <B>~eca</B>, s-like. <B>~ero</B>, scale, scurf, pellicule, (➞ <I>skvam</I>). <B>~inflamo</B>, dermatitis. <B>Sen~a</B>, raw (<I>vundo). Sen~igi</I>, s., ➞ <I>senfelig</I> (also figuratively). <B>Sub~a</B>, subcutaneous. <B>Dik~a</B>, thick s-ned. <B>Ruĝ~ulo</B>, ➞ <I>derm, epiderm, fel, membran, cel, tavol</I>.", "0"],
["haveno", "haven-o", "[UV] Harbour, Port, haven. <I>~o komerca, milita, ŝipa. Flug~o</I>, air-p. <I>La ~o dezirata</I> (\"where they would be\"), <B>f</B> <I>~o de rifuĝo</I>. <B>~eto</B>, creek. <B>~isto</B>, docker. <B>~digo</B> (<I>moleo</I>), h-bar, mole. <B>~imposto</B>, h-dues, anchorage. <B>~urbo</B>, seaside p. ➞ <I>basen, rod, varf</I>.", "0"],
["havi", "hav-i", "[UV] Hav/e (wide sense) <B>1</B> (disponi, posedi): <I>~i domon, monon, planon; filon, patron; (kiel) amikon. Mi ne ~as (ion), per kio pagi. Kiu ~as nenion, estas nenio</I>. <B>2</B> (posedi en aŭ sur si): <B>~i</B> <I>aknon, barbon, fundamenton, muron; etaĝojn, paĝojn</I>. <B>3</B> (posedi econ): <B>~i</B> <I>devon, fidon, intereson, povon, signifon</I>. <B>4</B> (senti): <B>~i</B> <I>amon, apetiton, deziron, esperon, plezuron</I>. <B>5</B> (esti -a): ~i f<I>ebron, paciencon</I>, ~i <I>du colojn, jarojn</I>, ( = esti febra, dujara). <B>6</B> (porti, teni): <I>~i bastonon, ĉapelon</I>. <B>7</B> (produkti): <I>~i florojn, fruktojn</I>. <B>8</B> (various): (akcepti, preni, ricevi): <I>~i aprobon, gaston, okazon</I>. (scii): <I>~i nenion por diri</I> (respondi). ~i <I>nenion kontraŭ iu</I>. (trinki): <I>~i tason da teo</I>. <I>Kiun daton (Kian veteron) ni ~as? Jen vi ~as!</I> Here’s a pretty kettle of fish! <B>~(aĵ)o</B>, assets, property. ~o hereda, patrimony. Pli da <B>~o</B>, pli da klopodo. <B>~ebla ĉe</B>, obtainable at. <B>~igi</B> (<I>-n</I>) (alporti, venigi) al, get (obtain, procure) for, provide with. <B>~inda</B>, desirable, worth having. <B>En~i</B> (Ij 21/34), contain, comprise, hold. ➞ <I>enten, enferm, enkalkul, ampleks, uj</I>. <B>~~o</B>, contents. <B>~~kapablo</B>, capacity, tonnage, etc. <B>Mal~i</B>, <B>Ne~i</B> (senti mankon de), lack, miss (be) want(ing in). <B>Nemal~ebla</B> (<B>havenda</B>), indispensable. <B>Sen~a</B>, penurious, destitute, indigent, needy, necessitous. <B>~~eco</B>, penury. <B>~~igi</B>, impoverish. ➞ <I>malriĉigi, ruinigi, senmonigi</I>. <B>~~ulo</B>, lack-all. <B>Senen~a</B>, empty, hollow, vacant. ➞ <I>malplen, sensignif, vant</I>. <B>Sur~i</B> (<I>porti</I>), have on, wear. <B>Bon~a</B> (<I>bonstata, riĉeta</I>), comfortably (well) off, in easy circumstances, well-to-do. SFX: <B>-hava =</B> kun-(mult-)a; ~oza, ~plena, ~riĉa. <B>Argil~a</B>, <B>dorn~a</B>, <B>fer~a</B>, <B>mon~a</B>.", "0"],
["hazardo", "hazard-o", "[OA] Chance, Hazard. <I>Blinda ~o</I>. <B>~a</B>, h-ous, dangerous, dependent on c., risky, uncertain. <I>Ludo</I> <B>~a</B>, game of c. <B>~e</B>, by c., at random. <B>~i</B> (<I>-n</I>), c., h., venture on (action, guess, statement). ➞ <I>akcident, lot, risk, sane</I>.", "0"],
["ha!", "", "[UV] (interjection) <B>1</B> Ah! denotes sudden emotion (surprise, wonder, etc.). <I>kiel bele! terure!</I> <B>2</B> denotes laughter. Haha! ha ha! ➞ <I>aha, ah</I>.", "0"],
["hebreo", "hebre-o", "[OA] <B>~a</B>, Hebrew.", "0"],
["hedero", "heder-o", "[UV] Ivy (<I>Hedera</I>) ~(ec)a, hederaceous. <B>-okovrita</B>, ivied, i-mantled. <I>~o venena</I>. ➞ <I>sumak</I>.", "0"],
["hedonismo", "hedon-ismo", "<B>~isto</B>, (phi) hedon-ism, -ist.", "0"],
["hegemonio,", "hegemoni-o,", "[OA] (pol) hegemony, leadership, predominance, supremacy, <B>~a</B>, ruling, supreme. ➞ <I>domin, konduk, super</I>.", "0"],
["hegiro", "hegir-o", "(Islama era-aro), hegira.", "0"],
["heĝo", "heĝ-o", "[OA-8] (<I>barilo arbusta</I>), Hedge(row). h. <B>~isto</B>, <B>~birdo</B> (➞ pronel).", "0"],
["hej ho!", "", "(interjection) heigh ho! denotes boredom, disappointment.", "0"],
["hejmo", "hejm-o", "[UV] Home, fixed residence. <B>Pra~o</B>, ancestral h. <B>-a</B> (<I>malfremda</I>), of h., domestic, native. <I>~a besto, kuirado lingvo. ~a bieno</I>, -stead. <B>~e</B>, at h., at one’s ease. <I>~e vestita!</I> <B>~en</B>, -wards (1 <B>Rĝ</B> 21/4). <I>Iru ~en!</I> <B>~ena</B> <I>vojo</I>, -ward path, <B>-i</B>, dwell, be at h. <I>~anaro(~a rondo</I>), h-circle. <B>~eca</B>, -ly, -like. (➞ <I>intimec, komfort, sengen</I>). <B>~ama</B>, <B>~restema</B>, -loving, recluse, stay-at-home, <B>-cela</B>, -ing (pigeon). <B>~edukita</B>, h-bred. <B>~ir(ont)a</B>, -ward bound. <B>~lando</B>, native land, <B>-sida</B>, stay-at-home, <B>-sopiro</B> (<I>nostalgio</I>), -sickness. El<B>-igi</B>, evict. <B>Re~igi</B>, repatriate. <B>Sen~a</B>, -less, <B>~~ulo</B> (<I>vagulo,</I>) vagrant. ➞ <I>dom(icil), famili(ar), loĝej, penat</I>.", "0"],
["hejti", "hejt-i", "(<I>-n) (varmigi</I>) [UV] (Ho 7/4). <B>1</B> Fire, Stok/e. <I>~i fornon, [vapor-]lokomotivon</I>. <B>2</B> Heat. <I>~i ĉambron, domon, lokon. Centra, vapora</I> <B>~ado. ~aĵo</B>, fuel, <B>~ejo</B>, s-hole. <B>~ilo</B>, <B>~aparato</B> (Jes 44/15). <I>Ban~ilo</I>, bath-heater. (el) <I>Merga ~ilo</I>, immersion heater. <B>~isto</B> fireman, stoker. <B>~forno</B> (<I>stovo</I>), stove. <B>~ligno</B>, firewood. <B>Super~i</B>, overheat. ➞ <I>forn(el), radi, stov</I>.", "0"],
["hekatombo", "hekatomb-o", "[OA] (ant) great public sacrifice. ➞ <I>masakr</I>.", "0"],
["hekelfono", "hekelfon-o", "(m.i.) heckelphone.", "0"],
["hekli", "hekl-i", "(pol) heckl/e, <I>ĝeni (interrompi) per embarasaj demandoj</I>. <B>~ado</B>, -ing. ➞ <I>interpel</I>.", "0"],
["heksa", "heksa-", "(ppfx denotes ,se.s-), hexa-. <B>~gono</B>, -gon.", "0"],
["heksametro", "heksametr-o", "[OA] hexameter.", "0"],
["heksano", "", "hexane (CjH<SUB>14</SUB>).", "0"],
["heksapodo", "", "hexapod (<I>sespieda insekto</I>).", "0"],
["heksodo", "", "hexode.", "0"],
["hektaro", "hektar-o", "[OA] hectare.", "0"],
["hekto", "hekto-", "(ppfx denotes <I>cent.</I>), hecto-. ~graf-o, <B>~i</B>, -graph. <B>~gram-o</B> [OA].", "0"],
["hektolitro", "hektolitr-o", "[OA].", "0"],
["hektometro", "hektometr-o", "[OA]. ~ŭato.", "0"],
["hela", "hel-a", "[UV] Bright. <B>1</B> brilliant, luminous: <I>~a tago</I>, sunny day. <I>~a ĉambro, ĉielo, fajro, lumo, vetero</I>. 2 (<I>~kolora</I>): b., light. ~blua, b. blue. ➞ <I>pal</I>. <B>3</B> (sound) (<I>sonora</I>): clear, ringing, <I>~a voĉo</I>. <B>~(ec)o</B>. -ness, splendour. <B>~igi</B>, -en, clarify, poke (stir) (<I>la fajron</I>), (phot) <I>~iga bano. ~igilo</I>, reducer. <B>~iĝi</B>, -en, clear, -imprescco, ~intenso, luminosity. <B>Mal~a</B>, Dark; dull, dusky, overcast, sombre: <I>~~a arbaro, nokto, vetero. ~~a bluo</I>, d. blue. <I>~~a tago</I>, dull (gloomy) day. ➞ <I>dens, intens, nub. ~~eco</I>, d-ness, gloom, obscurity. <I>~~igi</I>, d-en, obscure. <I>~~iĝi</I>, cloud over. <B>Rim</B>.: ➞ hela (bright), klara (distinct).", "0"],
["heleborino", "heleborin-o", "(chem) helleborine. ➞ <I>veratr</I>.", "0"],
["heleboro", "helebor-o", "Hellebore (<I>Helleborus</I>). <B>~o fetida</B>, stinking h. <B>~o nigra</B>, black h., Christmas rose. <B>~o verda</B>, green h., bear’s foot.", "0"],
["heliantemo", "heliantem-o", "(bot) rock (sun) rose (<I>Helianthemum). ~o Kanada</I>, frostweed.", "0"],
["helianto", "heliant-o", "(sunfloro), <I>sunflower</I> (Helianthus). <B>Tubera ~o</B> (<I>terpiro</I>), Jerusalem artichoke (<I>H. tuberosns</I>). ➞ <I>artiŝok</I>.", "0"],
["helico", "helic-o", "[OA] helix. <B>1</B> (geom) &lt; spiral curve, coil (thread, wire, etc.). 2 (<I>ŝraŭb ~forma ilo</I>), screw, propeller. <I>Aer~o,</I> air-screw. <B>~a</B>, spiral, winding. <I>~a risorto, ŝtuparo, ŝafto</I>. (av) <I>~a postfluo,</I> slipstream. <B>~ero</B>, spire, turn (of screw). <B>~oida</B>, -oid. ➞ <I>heliks</I>.", "0"],
["heliko", "helik-o", "[OA] snail (<I>Helix</I>). ➞ <I>helic, limak</I>.", "0"],
["helikoptero", "helikopter-o", "[OA-8], (av) helicopter.", "0"],
["helikrizo", "helikriz-o", "= imortelo (<I>Helichrysum</I>).", "0"],
["helikso", "heliks-o", "helix, rim of outer ear.", "0"],
["helio", "helio-", "(ppfx = sun-), helio-. ~grafo, ~kromio, ~skopo, ~stato, ~terapio.", "0"],
["heliotropo", "heliotrop-o", "[OA] heliotrope, cherry pie (<I>Heliotropium</I>). <B>~a</B>, h.", "0"],
["heliumo", "helium-o", "(chem) helium (He).", "0"],
["helminto", "helmint-o", "helminth, species of tapeworm, (med) ~oza, helminthous.", "0"],
["helodermo", "heloderm-o", "gila monster, bearded lizard (<I>Heloderma</I>).", "0"],
["helpi", "help-i", "(<I>-n;</I> abs, <I>al, kontraŭ</I>), [UV] Help; aid, assist, rescue, succour. Help! ~on! ~u! (interjection) <I>Help! ~i al si</I>, look after one’s. 2 (<I>efiki, rimedi, utili): Kontraŭ kalumnio ~as nenio. Ne ~is petoj, nek minacoj</I>. <B>~o</B>, h., aid, assistance, succour. <I>Peti ~on (por ~o). Unua (sukuro), ~o,</I> first aid. <B>~a</B>, auxiliary. <I>~a lingvo. ~a mono</I>, relief, grant in aid, subsidy. <I>~a paraŝuto</I>, pilot parachute. <B>~anto</B>, <B>~isto</B>, -er, assistant. ~ema, -ful, obliging. <B>~ilo</B> (<I>~rimedo</I>), aid, means of assistance. Inter<B>~i</B>, Kun<B>~i</B>, cooperate. <I>~~anto</I>, -mate. <B>mal~i</B>, [UV] hinder, handicap, impede, thwart. ➞ <I>embaras, obstrukc, maloportun. ~~(af)o</I>, barrier, hindrance, obstacle, set-back. Ne~eble! It is past h.! <B>Sen~a</B>, <B>~e</B>, in distress, alone, by one’s, unaided, without h. <B>Mon~o</B>, financial aid, support, subsidy. ➞ <I>asist, favor, komplez, kunlabor, serv, subten, util</I>. <B>Rim</B>.: <I>Mi ne povas ne iri =</I> I can’t help going. [Do not write <I>Mi ne povas ~i tion</I>. instead of <I>ne povas eviti (malhelpi) tion</I>].", "0"],
["hemanto", "hemant-o", "(sanglilio), blood-lily (Hae- manthus).", "0"],
["hematito", "hematit-o", "(<I>ferŝtono</I>), haematite (Fe<SUB>2</SUB>0<SUB>3</SUB>). ~o ruĝa, red iron ore.", "0"],
["hematopo", "hematop-o", "(orn) (<I>ostrobirdo</I>), Oyster-catcher (<I>Haematopus ostralegus</I>).", "0"],
["hematozo", "hemat/ozo", "haemat-osis. II ~urio, -uria &gt; blackwater fever.", "0"],
["hemerokalo", "hemerokal-o", "(<I>taglilio</I>), day lily (<I>Hemerocallis</I>).", "0"],
["hemi", "hemi-", "(ppf<I>x = duon-</I>), hemi-. ~kranio, (<I>migreno</I>), -crania. ~plegio, -plegia = <I>unuflanka kapdoloro (paralizo</I>), (ent) ~pteroj, -ptera. ~sfero, -sphere (<I>norda, sudd</I>), -stiko, -stitch.", "0"],
["hemiono", "hemion-o", "(zoo) kulan (<I>Equus hemionus</I>). ➞ <I>azen</I>.", "0"],
["hemipo", "hemip-o", "Syrian wild ass (<I>Equus hemip- pus</I>). ➞ <I>azen</I>.", "0"],
["hemo", "hemo-", "(Gk ppfx = <I>sang-</I>), haemo-. ~fUio, -philia. ~globino, -globin. -ragio, -rrhage (<I>sangado</I>). ~rojdoj, -rrhoids, piles. ~stazo, -stasis.", "0"],
["henao", "hena-o", "henna. <B>1</B> Egyptian privet (<I>Lawsonia</I>). <B>2</B> preparation from this. <I>la harojn</I>.", "0"],
["hendiadiso", "hendiadis-o", "(rh) hendiadys, two nouns instead of noun and adj., e.g., <I>tasoj kaj oro = oraj tasoj</I>.", "0"],
["heni", "hen-i", "(nt) (<I>ĉevalbleki</I>), neigh, whinny.", "0"],
["henro", "henr-o", "(el) henry, unit of inductance.", "0"],
["hepatiko", "hepatik-o", "(<I>hepata herbo</I>), liver-wort (<I>Hepatica</I>).", "0"],
["hepato", "hepat-o", "[UV] (anat) Liver (Se 7/23). ~o <I>morua</I>. <B>~a</B>, Hepat/ic. <I>~a malsano. (Gras</I>) <B>~aĵo</B>, pate de foie gras. ~ito. <B>1</B> (<I>~inflamo</I>), h-itis, inflammation of the 1. II <B>2</B> (min) hepatite. II", "0"],
["hepialoj", "hepial-oj", "(ent) swift and ghost moths (<I>Hepialus</I>).", "0"],
["heptodo", "heptod-o", "(rad) heptode.", "0"],
["heraatio", "heraati-o", "red blood corpuscle.", "0"],
["herakleo", "herakle-o", "cow-parsnip, hog-weed (<I>Heracleum</I>).", "0"],
["heraldiko", "heraldik-o", "(<I>blazonscienco</I>), Herald/ry. <B>~a</B>, -ic, armorial. ➞ <I>herold</I>.", "0"],
["herbo", "herb-o", "[UV] Herb. <B>1</B> -aceous (green’ one-year) plant. <B>2</B> (cul, pharm), herb- <I>~o kuir-(medicin-)a</I>. <B>3</B> Grass (➞ <I>gramen&gt; gres). Vojon batitan ~o ne kovras</I>. Bird~o (<I>stelario</I>). Drog<B>~o</B>, simple. Hund ~o (<I>agropiro</I>). Kat~o (<I>katario</I>). Lup~o (<I>akonito</I>). Pot~(Spic~)oj, dried (mixed) hh. Pul~o (<I>pulikario</I>). Tern-o (<I>ptarmiko</I>). Vipur~o (<I>ekio</I>). ~(ec)a, -al, h-aceous., g-y. ~aĉo (<I>trud~o</I>), weed. <B>~aĵo</B>, h-age (Ge 1/30). II ~ario (<I>~kolekto</I>) (3 FA 17/10), h-arium. <B>~ejo</B>, [UV] (<I>~kampo</I>) (Jes 19/7), grass (green) field, meadow. ➞ <I>razen. ~eja reĝino (ulmario). Paŝt~ejo,</I> pasturage, pasture. <B>~ero</B>, blade of grass (➞ <I>kulm, tig</I>). <B>~isto</B>, h-alist. <B>~obedo</B>, g-plot. <B>~okovri</B>, turf. <B>~omanĝa</B>, -ivorous. <B>~tondmaŝino</B>, g-cutter, lawn-mower.", "0"],
["herco", "herc-o", "(ph) hertz.", "0"],
["heredi", "hered-i", "(<I>ion de iu</I>), [UV] Inherit, (jur) receive by descent or succession, come in for, succeed to. <I>~i bienon, ŝuldon</I>. (med) <I>malsanon, ruĝajn harojn</I>. <B>f</B> <I>~i honoron, kutimon</I>. <B>~(it)a</B>, -ed, hereditary, transmitted. <I>~a havo</I>, patrimony, <I>~a ordo, rajto</I>. <B>~(aĵ)o</B>, -ance, estate, heritage. <I>Dividi ~on. ~aĵo de pasinteco</I>, heirloom. <B>~anto</B>, heir. <B>~ebla</B>, heritable, real. <B>~eco</B>, heredity, germinal constitution. ~igi (<I>ion al iu</I>): leave. ➞ <I>postlas, testament. (iun pro io</I>): make heir to. <B>~ordo</B>, order of succession. <B>Kun~anto</B>, co-heir. <B>Pri~a</B> <I>juro</I>. <B>Sen~igi</B>, dis-i, cut off.", "0"],
["herezo", "herez-o", "[UV] (<I>opinio neortodoksa</I>), Here/sy. <B>~a</B>, -tical, heterodox. <I>~a doktrino, kredo</I>. ~i (<I>~e opinii</I>). -ulo, -tic. <B>ĉef~ulo</B>, arch-tic.", "0"],
["hermafrodito", "hermafrodit-o", "[OA] (<I>duseksulo</I>), Hermaphrodite. <B>~a</B>, -ic. <I>~a besto, planto</I>. ➞ <I>hibrid</I>.", "0"],
["hermet(ik)a", "", "Hermetic, air-tight. <I>~e fermita</I>, -ally sealed.", "0"],
["herniario", "herniari-o", "(bot) rupture-wort (<I>Herniaria</I>).", "0"],
["hernio", "herni-o", "[UV] Hernia, rupture. ~o ingvena. ~o entordita (strangolita), strangulated h. ~a bendo (bandaĝo), truss. ~ulo (Le <B>21/20)</B>.", "0"],
["heroino", "heroin-o", "(chem) heroin.", "0"],
["heroldo", "herold-o", "[OA] Herald. <B>~i</B>, h., proclaim. ➞ <I>anonc, distrumpet, proklam</I>.", "0"],
["heroo", "hero-o", "[UV] Hero. <B>1</B> (grandfarulo): ~o de land-(scienc-)o. <B>2</B> (ĉefrolulo): ~o de aventur-(histori-)o. <B>~a</B>, -ic. ~a konduto. -a (rimedo), -ic, kill-or-cure. <B>~eco</B>, -ism. <B>~ino</B>, -ine. <B>Mal~o</B> (timulo), coward, poltroon.", "0"],
["herpesto", "herpest-o", "(<I>Herpestes</I>). Mongoose (and many related animals). ➞ <I>iĥneŭmon, mung</I>.", "0"],
["herpeto", "herpet-o", "(med) herp/es. <B>~a</B>, -etic. <I>~o</I> zona (zostro), shingles.", "0"],
["herso", "hers-o", "(mil) portcullis.", "0"],
["hesperido", "hesperid-o", "Dame’s violet, sweet rocket (<I>Hesperis</I>).", "0"],
["hesperio", "hesperi-o", "(ent) skipper butterfly (<I>Hesperia</I>).", "0"],
["hetero", "hetero-", "(ppfx = <I>ali-</I>), hetero-, other, different. (rad). ~dino, -dyne. ~doksa = <I>neortodoksa</I>. ~gena (<I>diverskonsista</I>).", "0"],
["hetmano", "hetman-o", "[OA] (<I>kozakestro</I>), hetman, Polish military commander.", "0"],
["heziti", "hezit-i", "(nt) (<I>pri, ĉu</I>) [OA], Hesit/ate, show (act, speak, with) indecision, be reluctant, falter, have misgivings (scruples), hold back, shrink (from), waver. <I>~i inter alternativoj</I>. <B>~a</B> <I>paŝo, respondo</I>. <B>~(ad)o</B>, -ation, -ancy. <I>Ne sen ~o</I>, not without misgivings. <B>~(em)a</B>, (<I>nedecidema</I>), -ant, -ating, doubtful, irresolute, undecided. <B>Sen~a</B>, unhesitating. ➞ <I>dub</I>. <B>Rim</B>.: <I>Heziti</I> denotes mental, <I>ŝanceliĝi</I>, physical, wobbling.", "0"],
["he!", "", "[OA] (a. hola!). (interjection) (<I>atentigo</I>): <B>1</B> Hey! <I>Hi there! <B>2</B> Hold on! Enough! Not so fast! Stop!</I>", "0"],
["hiacinto", "hiacint-o", "[OA] Hyacinth (<I>Hyacinthus</I>). ➞ <I>endimion, kampanol, skil</I>.", "0"],
["hialito", "hialit-o", "(min) hyalite, water (colourless vrty of) opal.", "0"],
["hiato", "hiat-o", "hiatus, break, gap. <B>1</B> in a series or chain of argument. <B>2</B> between two vowels.", "0"],
["hibisko", "hibisk-o", "(bot) bush (or shrubby) mallow, (<I>Hibiscus</I>). ➞ <I>alte</I>.", "0"],
["hibrido", "hibrid-o", "(bio) Hybrid (offspring of union between different races, species, or varieties), mongrel. <B>~a</B>, h., crossbred, composed of incongruous elements. <B>~igi</B> (<I>krucigi</I>), -ize, cross-fertilize, (gram). <I>~a radiko</I>, e.g., <I>korekt</I>. (see p. 10).", "0"],
["hida", "hid-a", "= malbelega.", "0"],
["hidr", "hidr-", "(ch pfx) hydr-. <B>~aeido</B>, <B>~ato</B>, <B>~ido</B>, <B>-okarbido</B>, <B>-oksido</B>, <B>~osulflto.</B>", "0"],
["hidrangeo", "hidrange-o", "(bot) hydrangea. ➞ <I>hortensi</I>.", "0"],
["hidranto", "hidrant-o", "hydrant, pipe nozzle for hose.", "0"],
["hidrargo", "hidrarg-o", "[UV] Mercur/y, quicksilver (Hg). <B>f</B> <I>Li estas vera ~o!</I> <B>~a</B>, -ial. <I>~a spegulo</I>. <B>~aĵo</B>, preparation of m. <B>-ika</B>, -ic. <I>~ika klorido</I>, corrosive sublimate (Hg Cl<SUB>2</SUB>). <B>~ujo</B>, m-cup. ➞ <I>merkurial</I>.", "0"],
["hidrastido", "hidrastid-o", "(bot) golden seal (<I>Hydrastis</I>).", "0"],
["hidraŭlika", "hidraŭlik-a", "hydraulic.-a h. crane (brake).", "0"],
["hidro", "hidr-o", "[OA] hydra. <B>1</B> (as, myth) many- headed serpent, <B>f</B> thing hard to extirpate. <B>2</B> freshwater polyp (<I>Hydra</I>).", "0"],
["hidro", "hidro-", "(ppfx = akvo), hydro-. <B>~cefala</B>, -cephalous, with water on the brain. <B>~dinamiko</B>. <B>-elektra.</B>", "0"],
["hidrofilo", "", "(zoo) waterlover, water-scavenger beetle (<I>hydrophilus</I>).", "0"],
["hidrofobio", "hidrofobi-o", "[OA] hydrophobia (<I>akvotimo</I>) (➞ <I>rabi</I>).", "0"],
["hidrogeno", "", "[UV] hydrogen (H). <B>-grafio.</B>", "0"],
["hidrokarido", "", "frog-bit (<I>-charis</I>).", "0"],
["hidrokinono", "", "(phot) hydroquinone.", "0"],
["hidrokotilo", "", "(bot) marsh pennywort (-cotyle). <B>-lizo. -meĥaniko. ~metr(i)o.</B>", "0"],
["hidropipro", "", "(<I>akvopipro</I>), (bot) water-pepper (<I>Polygonum -piper</I>).", "0"],
["hidroplano", "hidroplan-o", "sea-plane. <B>Flot-plano</B>, float-plane.", "0"],
["hidroponiko", "", "-ponies.", "0"],
["hidropso", "hidrops-o", "dropsy. <B>~ulo.</B>", "0"],
["hidrostateko", "", "[OA].", "0"],
["hidroterapio", "hidroterapi-o", "[OA] (<I>akvokuraco</I>). <B>~ejo</B>, hydropathic establishment.", "0"],
["hieno", "hien-o", "[OA] hy(a)ena.", "0"],
["hieracio", "hieraci-o", "hawkweed (<I>Hieracium</I>).", "0"],
["hierarĥio", "hierar/ĥi-o", "<I>[OA],</I> (a. <B>~kio</B> <I>[OA]</I>), hierarchy. ~o <I>eklezia, politika, socia</I>.", "0"],
["hieratika", "hieratik-a", "hieratic, priestly. <I>~a skribo</I>.", "0"],
["hieraŭ", "", "[UV] Yesterday. <I>De</I> since y. <I>~ nokte</I>, last night. <I>~ vesper</I>e, yester-eve. <B>~a</B>, of y. <B>Antaŭ~</B>, <B>post~</B>, the day before (after) y.", "0"],
["hieroglifo", "hieroglif-o", "[OA] (<I>skribsimbolo</I>). Hieroglyph. <B>1</B> figure of an object. representing an idea or sound. <B>~a</B>, -ic. <B>2</B> secret symbol, writing difficult to make out. ➞ <I>ideograf, nedeĉifrebl, nelegebl</I>.", "0"],
["hifo", "", "(<I>funga fadeno</I>), hypha.", "0"],
["higieno", "higien-o", "[OA] (<I>sanscienco</I>), Hygien/e, principles of health. <B>~a</B>, -ic. <B>Ne~a</B>, insanitary. ➞ <I>sanitar</I>.", "0"],
["higro", "higro-", "(<I>ppix=malsek</I>), <B>hygro-. ~grafo. higrometr-o</B> <B>[OA]. ~skopo</B>.", "0"],
["hikorio", "hikori-o", "hickory wood. ➞ <I>karj, pekan</I>.", "0"],
["hik!", "", "(interjection) sound of hiccough. <B>~i</B>, h. ➞ <I>singult</I>.", "0"],
["hilo", "hil-o", "<B>1</B> (<I>arba rano</I>) tree-frog (<I>Hyla</I>). <B>2</B> (anat) hilus.", "0"],
["hilumo", "", "(bot) hilum.", "0"],
["himantopo", "himantop-o", "(orn) stilt (<I>Himantopus</I>).", "0"],
["himenio", "", "(bot) hymenium.", "0"],
["himeno", "himen-o", "Hymen, (anat) maidenhead, <B>~a</B>, -eal.", "0"],
["himenofilo", "", "filmy fern (<I>Himenophyllum</I>).", "0"],
["himenopteroj", "", "hymenoptera.", "0"],
["himno", "himn-o", "[OA] Hymn, song of praise or prayer, (rel) hymn (Mt 26/30). <I>~o naeia</I>. <B>~i</B> (<I>laŭdkanti</I>), h., sing hh. <B>~aro</B>, -ary, h-book. <B>~olog-o</B>, <B>-io</B>, -olog-ist, -y. ➞ <I>glorkant, kantik, pean, psalm</I>.", "0"],
["Hindujo, Hindio", "Hind-ujo, Hindio", "(= Barato) IN.", "0"],
["hinduo", "hindu-o", "hindu. <B>~ismo</B>, -ism.", "0"],
["hindustanio", "hindustani-o", "hindustani.", "0"],
["hiosciamino", "hiosciamin-o", "(a. <I>hiskiamino</I>), hyoscyamine, hyoscine.", "0"],
["hipalageo", "hipalage-o", "(rh) hypallage, epithet transference, e.g., \"the body of this death\" (Ro <B>7/24)</B> = this mortal body.", "0"],
["hiper", "hiper-", "(Gk pf<I>x=super, tro</I>), hyper-, over-, <B>-bato</B>, (rh) -baton, unusual word-order for emphasis, e.g., <I>Akre blovis la vento; Paŭlon mi konas; Li estas~~kie?</I> <B>~bolo</B>, <B>1</B> (geom) -bola. <B>2</B> (rh) -bole, exaggerate. <B>~a</B>, -ic, e.g., <B>Ij. 6/3</B>, <B>41/12-34;</B> Ps <B>119/136</B>, Mt <B>5/29</B>, Lk <B>14/26. ~kritika. ~metropa</B>, longsighted.", "0"],
["hiperiko", "hiperik-o", "St John’s wort (<I>Hypericum</I>) (3 FA 108/40) <B>&gt;</B> <I>androsem. H. calysimum</I> = Rose of Sharon.", "0"],
["hipertrofio", "hipertrofi-o", "[OA] (<I>trokresko</I>), hypertrophy, excessive development.", "0"],
["hipnoto", "hipnot-o", "[OA] Hypnot/ic sleep, hypnosis- <B>~a</B>, <B>-iga</B>, -ic. <B>~igi (~izi)</B>, -ize. <B>f</B> charm. <B>~(iĝ)i</B>, be(come) -ized. <B>-ismo</B>, -ism. <B>-isto</B>, -ist. <B>-igito</B>, <B>~iĝinto</B>, -ic sleeper.", "0"],
["hipo", "hipo-", "(Gk <B>pf</B><I>\\=sub-</I>), hypo-. <B>~derma</B> (<I>subhaŭta</I>) -dermic. <B>Il-dermo</B>, (ent) warble fly (<I>Hypoderma</I>). <B>~gastro</B>, -gastrium. <B>~kondri/o</B>, -chondria, morbid depression, low spirits. <I>~ulo</I>. <B>ll</B>(phot) = \"hypo\" (<I>natria tiosulfato</I>, Na<SUB>2</SUB>S<SUB>2</SUB>0<SUB>3</SUB>, 5H<SUB>a</SUB>O).", "0"],
["hipodromo", "hipodrom-o", "[OA] (<I>ĉevalkurejo</I>), hippodrome, circus.", "0"],
["hipogloso", "hipoglos-o", "(ich) halibut (<I>Hippoglossus</I>).", "0"],
["hipokampo", "hipokamp-o", "(<I>mara ĉevaleto</I>), (ich) seahorse (<I>Hippocampus</I>). ➞ <I>rosmar</I>.", "0"],
["hipokaŝtano", "hipokaŝtan-o", "horse chestnut (<I>Aesculus hippocastanum</I>). <B>~arbo</B>.", "0"],
["hipokerido", "hipokerid-o", "(bot) catsear (<I>Hypochaeris</I>).", "0"],
["hipokorismo", "hipokorism-o", "(rh) hypocorism, nursery expression, pet name, e.g., <I>hanky, nosey- posey, ĉj, nj</I>.", "0"],
["hipokriti", "hipokrit-i", "[UV] (nt) play the Hypocri/te, dissemble, (dissimulate, pretend to be what one is not. <B>~a</B>, -ical, canting, feigned, put on. <B>~(ad)o</B>, <B>~aĵo</B>, <B>~eco</B>, -isy, cant, <B>~ulo</B>. ➞ <I>afekt, farise, malsincer, kiso Judasa</I>.", "0"],
["hipolao", "hipola-o", "(<I>Hippolais</I>), species of Warbler &gt; melodious, olivaceous, and olive-tree ww. <B>~o fiava</B>, icterine w. ➞ <I>silvi</I>.", "0"],
["hipopotamo,", "hipopotam-o,", "[OA] Hippopotamus.", "0"],
["hipoteko", "hipotek-o", "[OA] Mortgage, <I>Havi, porpagi ~on</I>. <B>~a</B> <I>banko</I>, loan bank. <I>~a ŝuldo</I>. <B>~e</B>, on m. <B>~i</B>, <B>1</B> mortgage. <B>2</B> secure (debt) by m. <B>Sen~a</B> (unencumbered) <I>bieno</I>. <B>Ŝip~o</B>, bottomry.", "0"],
["hipotenuzo", "hipotenuz-o", "(geom) hypotenuse, side opposite right angle.", "0"],
["hipotezo", "hipotez-o", "[OA] Hypothe/sis, assumption, supposition. <B>~a</B>, -tical. <B>~i</B>, assume. ➞ <I>supoz, teori</I>.", "0"],
["hipurido", "hipurid-o", "(bot) marestail (<I>Hippuris</I>). ➞ <I>ekviset</I>.", "0"],
["hirako", "hirak-o", "(zoo) coney (Se <B>30/26) = prokavio</B> (<I>Procavia</I>, olim <I>Hyrax</I>).", "0"],
["hirta", "hirt-a", "[OA] Brist/ly, -ling, hirsute, rough, scrubby, shaggy, spiky, unkempt. <I>~aj haroj. ~a plumo</I>. <B>~igi</B> (<I>harojn</I>), make stand on end. <B>-iĝi</B>, -le up.", "0"],
["hirudo", "hirud-o", "<I>[UV],</I> (zoo) Leech (<I>Hirudo</I>). <B>~bredado</B>, 1-breeding. <B>f</B> bloodsucker. ➞ <I>ekspluat, sangosuĉ, vampir</I>.", "0"],
["hirundo", "hirund-o", "[UV] (orn) Swallow (<I>Hirundo</I>). <B>Dom~o</B>, house martin (<I>Delichon</I>). <B>Sablo~o</B>, sand-martin (<I>Riparia</I>). <B>~a</B> <I>nesto</I>. <B>~vosto</B> (tech) dovetail, s-tail. ➞ <I>dovel, stern</I>.", "0"],
["hisi", "his-i", "(<I>suprentiri</I>) (mar) hoist, raise, run up. <I>~i flagon, signalon, velon</I>. <B>f</B> <I>Sin ~i</I> (pull one’s up) <I>ĝis la supro</I>. <B>~ilo</B>, halyard. <B>Duon~ita</B>, at half-mast. <B>Mal~i</B> (<I>mallevi</I>), haul down, lower.", "0"],
["hiskiamo", "hiskiam-o", "[UV] henbane (<I>Hyoscyamus</I>). Il-ino = hiosciamino.", "0"],
["hisopo", "hisop-o", "[OA] (bot) hyssop (<I>Hyssopus</I>) (El 12/22, Ps 51/7).", "0"],
["Hispanujo, Hispanio", "", "[F], ES.", "0"],
["hispo", "hisp-o", "(ent) hispa beetle (<I>Hispa</I>).", "0"],
["histerezo", "histerez-o", "(ph) Hysteresis, lagging, retardation. <I>Magneta ~o</I>, magnetic h.", "0"],
["histerio", "histeri-o", "[OA] (med) Hyster/ia. <B>f</B> morbid excitement. <B>~a</B>, -ical. <B>~ul(in)o.</B>", "0"],
["histo", "hist-o", "(organic) tissue. <B>-ologio</B>, histology.", "0"],
["historio", "histori-o", "(<I>de, pri</I>), [UV] Histor/y. <B>1</B> (<I>kroniko</I>) continuous record: career, course of affairs, train of events: <I>~o de mia vivo, de Anglujo. Biblia ~o. ~o por infanoj. Bela ~o</I>, pretty business. <I>La tuta ~o</I>, the whole affair. <I>Malnova ~o,</I> old story. <I>Mond~o</I>. 2 (<I>scienco): Natura ~o</I>. <B>~a</B>, -ical. <I>~a fakto</I>. <B>~eco</B>, -icity, authenticity, <B>~eto</B> (<I>anekdoto</I>). <B>-isto</B>, -ian. <B>Antaŭ~a</B>, pre-ic. <B>Pra~o</B>, ancient h. ➞ <I>evolu, rakont</I>.", "0"],
["histriko", "histrik-o", "[UV] porcupine (<I>Hystrix</I>).", "0"],
["histriono", "histrion-o", "(<I>aktoraĉo</I>), strolling player, third-rate actor.", "0"],
["hm!", "", "(interjection) He! Hm! Hum! denotes <B>1</B> polite dissent. <B>2</B> hesitation. <B>3</B> Ahem! simulated cough to attract attention. ➞ <I>um!</I>", "0"],
["Ho", "H-o", "[F], letter H.", "0"],
["hobio", "hobi-o", "(ŝatokupo, amata ĉevaleto), hobby.", "0"],
["hobojo", "hoboj-o", "<I>[OA],</I> (m.i.) oboe, hautboy. <B>Ald~o</B> (Angla korno), English horn.", "0"],
["hodiaŭ", "", "[UV] Today. ~ forto, morgaŭ morto! ~ matene, this morning, ~ nokte, tonight. ~ vespere (ĉi-vespere), this evening. ~ post monato, a month from today, <B>~a</B>, today’s. En la ~a tago.", "0"],
["hoj!", "", "(interjection) Ahoy! Hi! (to call attention). <B>~i</B>, call, hail (from a distance). <B>~ilo</B>, hailer.", "0"],
["hokeo", "hoke-o", "(gm) hockey.", "0"],
["hoko", "hok-o", "[UV] Hook, claw, fluke (anchor), tendril (vine), (box) <I>~o dekstra</I>, right hook (sten) <I>~o dekstrena (horloĝmova</I>). <B>Boat</B><B>~o</B>, boat-h. <B>Buton~o</B> (<I>butontirilo</I>), button-h. <B>fiŝ~o</B>, [UV] <B>Kurten~o</B>, curtain-h. <B>Pend~o</B>, <B>Vest~o</B>, hanger, coat-peg, hat-peg. <B>pord~o</B>, [UV] door-hinge, gate-hinge. <B>Serur~o</B>, skeleton key. <B>Ŝaf~o</B>, shepherd’s crook, <B>f</B> snare, trap. <B>~(kapt)i</B>, hook, catch. <B>~ego</B>, crook (umbrella). ➞ <I>grapl</I>. <B>~eto</B> (<I>ueto</I>), (typ) = breve over <I>ŭ</I>. <B>~ingo</B>, eye. <B>~fadeno</B>, <B>~ŝnuro</B>, fishing-line. <B>Mal~i</B>, unhook. (mar). <I>La ankro ~~iĝis</I>, is aweigh. <B>Sur~i</B>, attach by hook. ➞ <I>agraf, krot</I>.", "0"],
["holdo", "hold-o", "(<I>ŝipkelo</I>), hold.", "0"],
["holko", "holk-o", "soft grass (Holcus). Lana ~o, <I>\"Yorkshire fog\"</I>.", "0"],
["holmio", "holmi-o", "(chem) holmium (Ho).", "0"],
["holografo", "holograf-o", "holograph.", "0"],
["holosteo", "holoste-o", "(bot) jagged chick-weed (<I>Holosteum</I>).", "0"],
["holoturio", "holoturi-o", "(<I>markolbaso, markukumo</I>), sea-cucumber (-slug) (Holothuria). &gt; beche de mer, trepang. ➞ <I>aŭrikulari, tripang, tritoni</I>.", "0"],
["homeopatio", "homeopat/io", "[OA] Homoepath/y. <B>~a</B>, -ic. <B>f</B> (<I>eta</I>) tiny. <I>~a dozo</I>. <B>~(iist)o</B>, homoepath. opposite <I>alopati</I>.", "0"],
["homilio", "homili-o", "Homil/y, lecture, sermon, <B>~a</B>, -etic. ➞ <I>admon, predik</I>.", "0"],
["hominio", "homini-o", "(<I>maiza grio</I>), hominy.", "0"],
["homo", "hom-o", "[UV] Man (in gen.), Human (being), person. <I>~o proponas, Dio dis- ponas</I>. Kvazaŭ<B>~o</B>, dummy, lay-figure. Neĝ<B>~o</B>, snow-m. <B>Pajl~o</B>, m. of straw, scare-crow (➞ <I>birdotimigil</I>). <B>~a</B>, h., of m. <I>~a figuro, parolo, memoro</I>. <B>~aĉo</B>, creature, wretch. <B>~aro</B>, h-ity, h-race, mankind. <B>~arano</B>, citizen of the world (➞ <I>kosmopolit). ~~ismo</I>, doctrine of universal brotherhood, <B>~eco</B>, h-nature. <B>~ego</B>, giant (➞ <I>gigant</I>). <B>~eto</B>, little person, homuncule, mannikin (➞ <I>pigme, nan</I>). <B>~idoj</B> (Bb) children of men (Pr 1/13). <B>~ino</B> (col) female h-being, woman. <I>Mia bona ~ino!</I> (H /148). <B>~izi</B>, m. (boat, gun). <B>~ama</B>, benevolent, philanthropic. <B>~amaso</B>, crowd, populace (Da 11/11). <B>~evit(em)a</B>, misanthropic, unsociable (➞ <I>mizantrop</I>). <B>~mortigo</B>, m-slaughter, homicide. <B>~manĝa</B>, m-eating. <B>~plena</B>, <B>multe~a</B>, crowded, populous. <B>Fi~o</B>, blackguard, villain (➞ <I>fripon, kanajl</I>). <B>Liter~a</B>, social. <B>Mal~a</B>, in-h, barbarous. (➞ <I>barbar, monstr</I>). <B>Ne~a</B>, non-h. <B>Pra~o</B>, primitive m. <B>Sen~a</B> (<I>dezerta</I>), empty, forsaken, uninhabited. <B>~~igi</B>, depopulate. <B>Super~o</B>, superman. <I>~~a</I>, super-h. <B>Ĉiu~a</B> (<I>ĉies, komuna, tuthomara, universala</I>), universal. <B>Du~a</B> <I>segilo</I>. <B>Unu</B><B>~a</B>, one-m. ➞ <I>human, vir</I>.", "0"],
["homo", "homo-", "(Gk pfx = .vam-), homo-. ~gama.", "0"],
["homogena", "homogen-a", "= <I>samkonsista, samspeca</I>, homogenous, uniform (opp <I>heterogen). ~a miksaĵo</I>.", "0"],
["homologa", "homolog-a", "(<I>samrilata</I>), homologous, corresponding. <I>~a serio. ~aj elementoj</I>.", "0"],
["homonimo", "homonim-o", "[OA] homonym, word with same sound but different meaning. <B>~a</B>, -nymous.", "0"],
["homopteroj", "homopter-oj", "(insects with similar wing-pairs), -ptera. -seksa.", "0"],
["Honduro", "Hondur-o", "HN, Honduras.", "0"],
["honesta", "honest-a", "[UV] Honest. <B>1</B> not cheating, not stealing. <I>~a ago, gajno</I>. <B>2</B> fair, moderate, reasonable. <I>~a prezo</I>. <B>3</B> decent, honourable, straight, truthful. <I>~a intenco, knabino, konduto, respondo. ~aj homoj</I>. <B>4</B> chaste, virtuous. <I>~a virino</I>. <B>~(ec)o</B>, honesty, integrity. <I>Paroli</I> ~e. <B>~ulo</B>. <B>Mal~a</B>, <B>Ne~a</B>, dis-h, crooked, dishonourable. ➞ <I>ĉast, fidind, honorind, lojal, rekt, virt</I>.", "0"],
["honorario", "honorari-o", "[OA] fee, emolument, honorarium, remuneration for professional services, retainer. <B>~i</B> <I>iun</I>. ➞ <I>pag, rekompenc, salajr</I>.", "0"],
["honoro", "honor-o", "[UV] Honour. <B>1</B> high respect (distinction, position). <I>Loko, seĝo de ~o. ~o al</I>, all honour to <I>Rigardi kiel ~on. Ne venas ~o sen laboro. Mi havas la ~on diri</I>, have the h. (beg) to state. <B>2</B> good name, nobleness of mind, repute, <I>Afero, ŝuldo de ~o</I>, matter (debt) of h. <I>~o perdita, ĉio perdita</I>. <B>3</B> credit, person (thing) reflecting h. on. <I>Esti ~o</I> (be a credit) <I>al la lando</I>. <B>4</B> (<I>~aĵo</I>), mark of esteem. <I>Fari la lastajn ~ojn</I>, pay the last (funereal) honours. (<I>al</I>). <B>~a</B> <I>devo, gvardio, parolo</I>, debt (guard word) of h. <I>~a (senpaga, titola</I>), honorary. <I>~a sekretario</I>. <B>~e</B> al, in h. of. <I>Sukcesi ~e,</I> with credit, flying colours. <B>~i</B> (<I>-n</I>), [UV] (<I>fari ~on al</I>), (treat with) honour, do h. to. <I>~i traton</I>, meet a bill. <B>~ata</B>, -ed, distinguished, respected. <B>~igi</B>, confer dignity on. <B>~inda</B>, -able, worthy of h., of high standing. <I>~~a homo</I>. <B>Mal~o</B>, affront, disgrace, ignominy, insult, outrage. <I>~~a</I> dis-ing, derogatory. <B>~~i</B>, dis-h, besmirch’ defame, discredit, sully (Mai 2/11). <B>Sen~a</B>, without h., unhonoured. ➞ <I>dign, glor, honest, respekt, rever</I>.", "0"],
["honti", "hont-i", "(<I>antaŭ, je, pri, pro</I>), [UV] be Ashamed, feel Shame (Ge 2/25). <I>siajn larmojn</I> (M 26/30). <B>~anta</B>, a., abashed. <B>~u!</B> S. on you! <B>~o</B>, s., ignominy, infamy, opprobrium, reproach. <I>Lia ~o ne forgesiĝos. Ne diru</I> \"~o!\" (H 105/ 17). <B>~ema</B>, s-faced, ashamed, bashful, embarrassed, timid, shy. <I>Foriri</I> <B>~e</B>, slink away. <B>~igi</B> (<I>kaŭzi ~on al</I>), (put to) s., abash, confound, humiliate (➞ <I>humilig</I>). <B>~iĝi</B> (Ps 25/2). <B>~inda</B>, s-ful, despicable, dishonourable, infamous, scandalous. <B>~~aĵo</B>, ignominy, turpitude. <I>~~ulino (sen~ulino</I>) (PI l/8), hussy, profligate, jade, strumpet. <B>Sen~a</B>, s-less, impudent, un-a. ➞ <I>impertinent</I>. <B>Sen~eco</B>, effrontery, impudence. ➞ <I>konfuziĝ, malglor, malhonor, malrespekt, prud, pudor</I>.", "0"],
["hopi", "hop-i", "(<I>salteti</I>) <B>~o</B>, Hop. <B>~u!</B> Hop! (interjection) Hop! Now then, jump! Out you go! Hop it! <I>Ne diru \"Hop\" antaŭ la salto</I>. <B>For~i</B>, hop away. <B>~ludo</B> (<I>marelo</I>), h-scotch.", "0"],
["hordeo", "horde-o", "[UV] Barley. <B>1</B> grain. <B>2</B> b-grass (<I>Hordeum</I>). <B>Perl~o</B>, pearl b. <B>Vintra</B> <B>~o</B>, winter b.", "0"],
["hordeolo", "hordeol-o", "(med) sty (on eyelid).", "0"],
["hordo", "hord-o", "horde, band (of nomads, etc.). <I>~o da Sirianoj</I> (2 Rĝ 24/2). <B>f</B> swarm. <I>~o da kreditoroj</I>. ➞ <I>apaĉ, band, svarm</I>.", "0"],
["horizontala", "", "[UV] Horizontal, level (at right angles to vertical). <I>~o =~a linio (ebeno</I>), h. <B>~iĝo</B>, (av) recovery.", "0"],
["horizonto", "horizont-o", "[OA] Horizon, sky-line. <I>Ĉe la ~o. ~o videbla (vera</I>), true (apparent, visible) h. <B>f</B> bounds, limit, outlook. <I>~o politika. Vastigi sian ~on</I>. <B>~a</B> <I>ebeno,</I> plane of the h. <I>~a linio</I>, vanishing line.", "0"],
["horloĝo", "horloĝ-o", "[UV] Clock, Watch, timepiece. <I>~o akva, elektra, kukola, mura, pezila, pendola, risorta</I>. <B>Brak~o</B>, <B>Pojn~o</B>, wrist-w. <B>Kontrol~o</B>, timing-c, stop-w. <B>Ripet~o</B>, repeater. <B>Sablo~o</B>, hour-glass, sand-glass. <B>Sun~o</B>, sundial. <B>vek~o</B>, alarm-c. <B>~a</B> <I>ĉeno, vitro</I>. <B>~eto</B> (<B>Poŝ~o</B>), watch. <I>Klik~eto</I>, lever-w. <B>~isto</B>, horologist. <B>~okesto</B>, <B>~ujo</B>, c-case, w-case.", "0"],
["hormono", "hormon-o", "hormone.", "0"],
["horo", "hor-o", "[UV] (<I>tempkalkulo</I>), Hour, Time. <B>1</B> 60 minutes. <I>Ĉiu<B>~e</B>,</I> h-ly. <I>Duon~o</I>, half- an-h. <I>Ok~a tago. Po~a laboro</I>, t-work. <I>Unu~a distanco</I>. <B>2</B> t-measurement. <I>~o meza</I>, mean t. <I>~o norma</I>, standard t. <I>~o astronomi-(somer-sun-ver-)a. ~angul (~zon)o</I>. <B>3</B> t. of day, o’clock. <I>Kioma ~o estas?</I> What is the t.? <I>La dua(~o</I>) =2.0. <I>Kvinahora teo</I>, <B>5</B> o’clock tea. <I>~montrilo,</I> h-hand. <B>4</B> appointed t., moment. <I>Atendi konvenan ~on</I>, bide one’s t. <I>Venis la ~o</I>, the t. has come. <I>Last~a</I> (latest, stop- press) <I>novaĵo. Lumiga (manĝ-)~o</I>, lightg- up (meal) t. <I>Oficejaj, lernejaj ~oj</I>. <B>~aro</B>, <B>~libro</B>, <B>~tabelo</B>, t-table, ry guide. <B>~eto</B>, less than an h., only a short t. <B>~montra</B> <I>ombro</I> (Jes 38/8).", "0"],
["hororo", "horor-o", "Horr/or, (feeling of) abhorrence, detestation, disgust, repugnance, terror. <B>~(aj)o</B>, horror, <I>La ~oj de milito</I>. <B>~(ig)a</B>, -ible, -ifying, awful, creepy, dreadful, fearful, frightful, ghastly, gruesome, hair-raising, shocking. <B>~i</B> (nt) be horrified, feel (have) a h. (dread) of, (aversion to), shudder. <B>~igi</B> (<I>teruri</I>), inspire h., -ify, shock.", "0"],
["horoskopo", "horoskop-o", "[OA] horoscope.", "0"],
["hortensio", "hortensi-o", "[OA] (bot) hortensia (<I>Hydrangea hortensis</I>). ➞ <I>hidrange</I>.", "0"],
["hortikulturo", "hortikultur-o", "(<I>ĝardenkultivo</I>), Horticulture. <B>~a</B> <I>ekspozicio</I>, flower show, <B>~ejo</B>, market garden, nursery, etc. <B>~isto</B>, -ist.", "0"],
["hortulano", "hortulan-o", "[UV] (<I>ĝardena emberizo</I>), (orn) ortolan (<I>Emberiza hortulana</I>).", "0"],
["Hosana!", "", "(interjection) Hosanna! shout of adoration (Mt 21/9).", "0"],
["hospitalo", "hospital-o", "[OA] (<I>flegejo, malsanulejo</I>), Hospital. <I>~o kampa</I>, field h. <B>~a</B> <I>ŝipo, vagonaro</I>.", "0"],
["hostio", "hosti-o", "[UV] host, consecrated wafer, <B>~ujo</B>, ciborium.", "0"],
["hosto", "host-o", "plantain lily, funkia (<I>Hosta</I>).", "0"],
["hotelo", "hotel-o", "[UV] Hotel, hostelry, inn. <I>Motorista, aŭtista</I> ~o (<I>motelo</I>), motel, <B>~isto</B>, -keeper, -proprietor.", "0"],
["hotonio", "hotoni-o", "water-violet, featherfoil (<I>Hottonia</I>).", "0"],
["hot!", "", "(interjection) Gee up! (to horse, cow).", "0"],
["ho!", "", "[UV] (interjection) O! Oh! <B>1</B> (vocative, no comma). - <I>Dio\\ - mia karal</I> <B>2</B> denotes emotion, grief, indignation, protest. -/ <I>Kion vi faras! - ve!</I> Alas! - ~! Ho, ho! ne! terure! ➞ oho.", "0"],
["hubaro", "hubar-o", "(orn) houbara bustard (<I>Chlamydotis</I>).", "0"],
["hubo", "hub-o", "hide (of land) (G <I>Hube, Hufe</I>), obsolete, but Z. Usable for \"small holding, croft, homestead\". <B>~ulo</B>, crofter.", "0"],
["hufo", "huf-o", "[UV] Hoof. <I>~o fenda, havita</I>, cloven h. <B>~uloj</B>, ungulata, -ed animals. <B>~bat (~frap)i</B>, kick (➞ <I>stampf</I>). <B>~fero</B>, <B>~umo</B> (4 FA 219/1), horse-shoe. <B>(~)feri</B> <I>ĉevalon</I>. shoe. <I>~feristo</I>, farrier. <B>~signo</B>, -mark. <B>Supei-aĵo</B>, fetlock.", "0"],
["hugenoto", "hugenot-o", "(hist) huguenot, French protestant.", "0"],
["hulo", "hul-o", "(<I>ŝip-fram-korp-ŝel-o</I>), hull (of ship, plane). ➞ <I>ŝvel</I>.", "0"],
["humana", "human-a", "[OA] (<I>malkruela</I>), Human/e, compassionate, considerate, kind, -itarian. <B>~(ec)o</B>, -ity. <B>~igi</B>, ~ize. <B>Mal~a</B>, <B>Ne~a</B>, cruel, inhuman, savage, unfeeling, <B>2</B> (phi) <B>~ismo</B>, <B>~isto</B>, -ism, -ist.", "0"],
["humero", "humer-o", "[OA] (anat) humerus, bone of upper arm. <B>~a</B>, -al.", "0"],
["humida", "humid-a", "[OA-8] (<I>malseketa, vaporeca</I>), Humid, damp, dank, moist. <I>~a aero, domo, vetero</I>. <B>~(ec)o</B>, -ity, moisture. <I>Gradoj de ~eco</I>.", "0"],
["humila", "humil-a", "[UV] (<I>malfiera</I>), hum|ble. <B>1</B> modest, unpretending, with a low estimate of one’s own importance. <I>~a koro, peto</I>. <B>2</B> lowly, mean (condition in life). <B>~(ec)o</B>, -ility (Ce 2/3). <I>Paroli</I> <B>~e. ~aĉa</B>, <B>~ega</B>, cringing, grovelling. <B>~igi</B>, (<I>hontigi</I>), h., abase, humiliate, mortify (Ps 136/23) <B>~iĝi</B> (<I>antaŭ</I>), h. (submit) one’s, eat h. pie, stoop. <I>Al li ~iĝos la popoloj</I> (El 10/3) <B>~ulo. Mal~(eg)a</B>, arrogant, haughty, high-handed, imperious, proud.", "0"],
["humo", "hum-o", "[OA] Humus. <B>1</B> vegetable mould. <I>Folia ~o</I>, leaf mould. <B>2</B> (o.l<I>. = ĝardena tero</I>), garden mould (soil). <B>~acido</B>, humic acid. ➞ <I>kompoŝt</I>.", "0"],
["humoresko", "humoresk-o", "(<I>~a muzikaĵo</I>), humoresque.", "0"],
["humoro", "humor-o", "[UV] Humour. <B>1</B> Temper, frame of mind, mood, spirits, vein (➞ <I>agordiĝ). ~o gaja, trankvila. Acida ~o</I>, sharp t. <I>Nigra ~o</I>, depression, fit of the blues. <B>2</B> (a. <I>humuro</I>), jocose imagination. <B>~a</B>, h-ous, amusing, droll, facetious, jocular, playful. <B>~aĵo</B>, funny story, joke, pleasantry, witticism. <B>~isto</B>, -ist. <B>Bon~a</B>, good t-ed, in a good h. <B>Malbon~a</B>, bad t-ed, cross, grumpy, peevish, out of t., snappy, testy. ➞ <I>em, splen</I>.", "0"],
["hundo", "hund-o", "[UV] Dog, Hound (<I>Canis). ~o bojas, homo vojas. Vivi kiel ~o kun kato,</I> <B>~a</B>, canine. <I>~a dento, vivo</I>. <B>Dalmata ~o</B>, Dalmatian, coach-d. <B>Dan~o</B>, Dane. <B>Eskima ~o (Sled~o)</B>, husky, sleigh-d. <B>Kimra ~o</B>, corgi. <B>Novlanda ~o</B>, Newfoundland. <B>Pekina ~o</B>, Pekinese. <B>Rusa lup~o</B>, borsoi. <B>ĉas~o</B>, hound. <B>Cerv~o</B>, deer-h. <B>Fos~o</B> (<I>teriero</I>), terrier. <I>Pembroka ~~o</I>, sealyham. <B>Gard~o</B>, <B>kort~o</B>, <B>ĉen~o</B> (4 FA 236/1), watch-(yard-)d, mastiff. <B>Kaŝ~o</B>, setter. <B>Kur~o</B>, grey-h. <B>~~eto</B>, whippet. <B>Lepor~o</B>, hare-h, harrier. <B>Lutro ~o</B>, otter-h. <B>Mel~o</B>, badger-dog, dachs-hound. <B>Montro~o (Halt~o)</B>, pointer. <B>Rat~o</B>, setter. <B>Sang~o (Spur~o)</B>, blood-h. <B>Ŝaf~o</B>, sheep-d. <I>~~o Australia</I>, kelpie; <I>Germana</I>, Alsatian; <I>Skota</I>, collie. <B>Trov~o</B>, retriever. <B>~aĉo</B>, cur. <B>~aro</B>, pack of hh. <B>~ido</B>, puppy. <B>~ino</B>, bitch. <B>~ujo</B>, kennel. <B>~herbo</B> (<I>agropiro</I>). <B>~lango</B> (<I>cinogloso</I>). <B>~ŝnuro (~vipo)</B>, d-lead (whip), <B>~vosto</B> (<I>cinozuro</I>). <B>Vir~o</B>, male d. ➞ <I>baset, bigl, buldog, ding, dog, grifon, mops, pudel, spaniel, ŝpic, terier</I>.", "0"],
["hungaro", "hungar-o", "[OA-8], Hungarian. <B>H~ujo, H~io</B> [OA-8] HU, Hungary.", "0"],
["hupo", "hup-o", "<B>1</B> (zoo) crest, tuft; top-knot (➞ <I>tup</I>). <B>2</B> (mot) <B>~i</B>, hoot, sound the horn. <B>~ilo</B>, hooter, horn, klaxon.", "0"],
["hura!", "", "[OA] (interjection) (accent: hura’), Hurah! Hooray! <B>~i</B>, cheer, shout (with approbate, exultation).", "0"],
["hurdo", "hurd-o", "<B>1</B> (<I>plektobarilo</I>), Hurdle, wattling. 2 (<I>ĉirkaŭbarilo</I>), fold, pen. <B>~kurado</B>, h-race, steeplechase. ➞ <I>heĝ, latis</I>.", "0"],
["hurio", "huri-o", "houri, nymph of Islamic paradise.", "0"],
["hurli", "hurl-i", "<B>~o</B>, Howl. <B>1</B> (make) long doleful cry as of dog or wolf. <B>2</B> long cry of pain, yell of derision. <B>f</B> h., bawl, roar, yell. <I>~i kun la lupoj</I>, cry with the pack.", "0"],
["husaro", "husar-o", "[UV] hussar, soldier of light cavalry regiment.", "0"],
["huŝ!", "", "(a. Ŝŝ!), Hush! Be silent! Quiet! Silence! <I>~a</I>, h-h, highly confidential, very secret.", "0"],
["huzo", "huz-o", "[UV] Great (White) sturgeon, hausen. (<I>Accipenser huso</I>). ➞ <I>sterled, sturing</I>.", "0"],
["hu!", "", "(interjection) Coo! (denotes start, or jocular wonder) (Rj /115). <B>~i 1</B> (owl), hoot; (crowd) boo, jeer, hoot, shout, derisively. <I>~i krimulon</I>. Also <B>2</B> noise of wind! <I>Hu! HU-U’U</I> (4 FA 76/15, 78/25, 84/28).", "0"],
["ĥameleono", "ĥameleon-o", "(a. <I>kam-</I>), chameleon (Le 11/30) (<I>Chamaeleo</I>).", "0"],
["ĥamsino", "ĥamsin-o", "(met) khamsin, Egyptian sandy wind from Sahara.", "0"],
["ĥano", "ĥan-o", "Khan (Asiatic ruler).", "0"],
["ĥaoso", "ĥaos-o", "[UV] (a. <I>kaoso</I>), chao/s. <B>1</B> formless void. <B>2</B> utter confusion. <B>~a</B>, -tic.", "0"],
["ĥemio", "ĥemi-o", "[UV] (a. <I>kemio</I>), Chem/istry. <B>~a</B>, -ical. <B>~aĵo</B>, -ical. <B>~isto</B>, -ist. [Ne= apotekisto]. ➞ <I>apotek, drog</I>.", "0"],
["ĥetoj", "ĥet-oj", "(a. <I>ketoj</I>), bristles of some worms. <B>~uloj</B>, chaetopods.", "0"],
["ĥimero", "ĥimer-o", "[UV] Chimer/a. <B>1</B> (<I>monstro leonkapa, kaprokorpa, serpentvosta</I>). <B>2</B> bogy, fanciful conception. <B>~a</B>, -ical. <B>~ulo</B>, visionary.", "0"],
["ĥirurgo, ~io", "ĥirurg-o, ~io", "<I>, =</I> kirurg-o, ~io.", "0"],
["ĥitono", "ĥiton-o", "(Le 8/7), robe, tunic. ➞ <I>kiton</I>.", "0"],
["Ĥo", "Ĥ-o", "[F], letter Ĥ.", "0"],
["ĥolero", "ĥoler-o", "[UV] Cholera. <B>Kokina ~o</B>, fowl-c., fowl-pest.", "0"],
["ĥoralo", "ĥoral-o", "chorale, slow German hymn-tune.", "0"],
["ĥoreo", "ĥore-o", "(med) chorea, St. Vitus’ dance.", "0"],
["ĥoro", "ĥor-o", "[UV] (<I>kantistaro;</I> a. <I>koruso</I>), Chor/us, choir. <I>~o infana, miksita, vira, virina; anĝe1a, birda</I>. <B>~a</B>, -al. <B>~e</B>, in c., all together. <I>Deklami, paroli ~e</I>. <B>~i</B>, sing in c., as choir. <B>~aĵo</B>, -al work, music for c. <B>~ejo</B>, c-chancel (➞ <I>absid, galeri</I>). <B>~estro</B>, c-master. <B>~an(~ist)o</B>, -ister, member of c. (especially <B>~knabo</B>, c-boy). <B>~orgeno</B>, c-organ. <B>~societo</B> (<I>kantsocieto</I>), -al society. ➞ <I>refren, rekantaĵ</I>.", "0"],
["i", "-i", "[UV] ending of infinitive verb. With verb root = to. Mi volas lerni kanti, I want to learn to sing. With other roots denotes state or action. <B>I</B> (adj root) ~~ impresi, stati; Verdi, be green. Abundi, avari, egali, kuraĝi, necesi, pravi, sani, simili; anstataŭi, superi. <B>II</B> (noun root) <B>1</B> = use, utilize: Ankri, brosi, ĉeni, harpi, najli, veli, vipi. <B>2</B> = izi, supply with. Adresi, gudri, kroni, sali, seli. <B>3</B> = produce: Flori, fumi, plani, radii, sangi, streki. <B>4</B> = act as: Dandi, estri, profeti, serpenti. <B>5</B> (various): Fronti, kongresi, nesti, nombri, ondi, tranokti. <B>6</B> = diri. Adiaŭi, bisi, hurai, jesi, nei.", "0"],
["ia", "", "[UV] (<I>iuspeca</I>), of some (indefinite) kind (sort) or other, some kind of a, a sort of. <I>Ĝi estas ~ hundo. Nur ~ abomena acidaĵo. Sen ~ kaŭzo</I>, without any reason. <B>~ ajn</B>, of any kind (whatever) (you like). ➞ <I>iu, kelka, unu</I>.", "0"],
["ial", "", "[UV] (<I>iukaŭze, iumotive</I>), for some (a certain) reason. <I>~ ŝi ne venis. Se</I> if for some reason … <B>~ ajn</B>, for any reason (whatever).", "0"],
["iam", "", "[UV] (<I>iutempe</I>), at some time (or other). (Past): once (upon a time). <I>~ estis reĝo. Vi amis min ~ ! Ĉu vi</I> <I>~ ?</I> Did you ever? (Future): some day. <I>Se</I> if ever. <I>Venu ~ ajn</I>, at any time (whenever) you like. <B>~a</B>, [UV] (past): erstwhile, once enjoyed, one-tm, quondam. <I>Memori ~an feliĉon</I>. (future): to come. <I>Esperi ~an sukceson</I>. ➞ <I>iufoje, unu tagon</I>.", "0"],
["ibekso", "ibeks-o", "Ibex, wild goat (Ps 104/18). (<I>Capra ibex</I>). <B>~ino</B> (Se 5/19).", "0"],
["iberido", "iberid-o", "(bot) candytuft (<I>Iberis</I>).", "0"],
["ibiso", "ibis-o", "[UV] Ibis (<I>Ibis ibis</I>) and various related species (Re 14/16).", "0"],
["icido", "-icid-o", "(unoff. sfx), -icide. <B>1</B> <B>mortigaĵo</B>. <I>fungicido, herbicido, insekticido, pesticido</I>. <B>2</B> <B>mortiginto</B>. <I>Fraticido, patricido, reĝicido</I>. <B>~a</B>, -icidal (<I>mortiga, ~inta</I>).", "0"],
["id", "-id", "[UV] (sfx), <B>1</B> Child, son, young, of (a) Human beings: <B>reg~o</B>, prince of the blood royal, (b) Other animals: <B>kat~o</B>, kitten, <B>pav~o</B>, pea-chick, (c) Plants: <B>arb~o</B>, seedlg tree; <B>plant~o</B>. (d) Other things: <B>Latin~aj</B> (romance) <I>lingvoj</I>. (e) (astr) Meteors: Perse<B>~oj</B>, Perseids. <B>2</B> Offspring, descendant, scion, in gen., irrespective of age (El 20/5). Reĝ<B>~oj =</B> <I>filoj, nepoj, kaj pranepoj de reĝo</I>. <B>Izrael-o</B>, Israelite. <B>Hom~oj</B>, sons of men (No 23/19, Ps 4/2). <B>~o</B>, c., cub, whelp, etc. <B>~aro</B>, children, descendants, issue, posterity, progeny, seed (Ge 9/9); brood, litter, young. Sen<B>~a</B>, c-less, barren. ➞ <I>fil, infan, naskit, posteular</I>. ➞ English <I>-ite</I>, Gr. <I>-id</I>, R. <I>-(ov)iĉ</I>. Mnemonics: <I>kid, seed</I>. <B>II Ido</B> (i.l. project).", "0"],
["idealo", "ideal-o", "<I>[OA],</I> Ideal, high aim, model of perfection, vision. Atingi, celi, havi ~on. ~o neatingebla. <B>~a</B>, ideal, perfect. ~a formo, plano, viro. <B>~e</B> bela. <B>~igi</B>, -ize. <B>~ismo</B> <I>[OA],</I> -ism. <B>~isma</B> (nobla, malegoisma). <B>~isto</B>, (~emulo), -ist. <B>~ulo</B>, model, paragon. <B>Sen~a</B> (proza), without ideals, drab, matter-of-fact. ➞ <I>ide, model, perfekt, rev, subjektiv</I>.", "0"],
["identa", "ident-a", "(<I>kun</I>) [OA], <B>1</B> (of one thing): Ident/ical, one and the same, self-(the very) same. <B>2</B> (of several things): agreeing in every detail, counterpart, duplicate, synonymous. <B>~(ec)o</B>, -ity. <I>Atesto pri ~eco</I>. <B>~igi</B> (<I>pruv -rekon-i</I>), -ify, establish -ity of, name, recognize. <I>~igi krimul-(lok-)on, A kun B</I>. <B>~iĝi</B>, be -ied. ➞ <I>egal, sam, tute simil</I>.", "0"],
["ideo", "ide-o", "[F], Ide/a, concept, fancy, mental image, notion. ~o <I>falsa, ĝusta, klara</I>. <I>Bona ~o</I>, happy thought. <I>Fiksita ~o</I>, fixed idea. <I>Genia ~o</I>, brainwave. <I>Havi (nenian) ~on. Kia ~o!</I> The idea! <I>Venis al mi la ~o</I> (It occurred to me), <I>ke</I>. <I>Ĉeno de ~oj</I>. <I>La interna ~o de Esp</I>. <B>~a</B>, of ideas. ~a mondo. <B>~ismo</B>, (phi) -ism (opposite <I>materiismo, realismo</I>). <B>Sam~ano</B>, fellow-thinker. ➞ <I>samcelano, samidealano</I>. <B>Sen~a</B>, barren of ideas, dull. ➞ <I>imag, komprenaĵ, koncept, noci, opini, pensaĵ, pensbild</I>.", "0"],
["ideografio", "ideografi-o", "<I>[OA]</I> (~oskribo), -ography, picture-writing. <B>-ogramo</B>, -ogram, -ograph, e.g., Chinese script.", "0"],
["ideologio", "", "(<I>idearo</I>), ideology.", "0"],
["idilio", "idili-o", "[UV] (paŝtista poemo aŭ priskribo), <I>Idyll, e.g., Georgie de Virgilio. <B>f</B>.</I> ~o de juneco. <I><B>~a</B>,</I> -ic<I>, bucolic, pastoral, peaceful, pleasant</I>. ~a pejzaĝo, vivo. ➞ eklog, pastoral.", "0"],
["idiomo", "idiom-o", "[OA] Idiom, vernacular (dialect, speech), peculiar to place or age. <B>~a</B>. -atic, characteristic, colloquial. <B>~aĵo</B> &gt; <I>idiotismo</I>. ➞ <I>dialekt, lingvaj, slang</I>.", "0"],
["idiosinkrazio", "idiosinkrazi-o", "Idiosyncr/asy, personal peculiarity, <B>~a</B>, atic.", "0"],
["idiotismo", "idiotism-o", "[OA] (<I>idiomaĵo</I>), (gram) Idiomatic expression or phrase, lingual peculiarity, (often) illogicality. <I>Uzi la ~ojn de</I> (forms peculiar to) <I>la idiomo</I> (the language used). Perhaps <I>Estas bele!; kiel eble plej; aldoni, eldoni, elteni, elpensi, eltrovi, rideti, subteni;</I> may be called <I>~oj</I> de Esperanto", "0"],
["idioto", "idiot-o", "[OA] Idio/t, cretin, imbecile, natural fool, <B>f</B> blockhead, booby, dunce, silly ass, simpleton. <B>~a</B>, -tic, senseless. <B>~aĵo</B>, <B>~eco</B>, -cy, rank stupidity, <B>~eta</B>, feebleminded. ➞ <I>malsaĝ</I>.", "0"],
["ido", "-ido", "(ch. sfx), -ide. <B>Brom-(klor-sulf-)ido. Klor~a</B> <I>acido</I>, hydrochloric acid.", "0"],
["idolo", "idol-o", "[UV] Idol, false god or its image. <I>~o el arĝento, ligno, oro</I>. (Rd 5/8). <B>f</B> (<I>io, iu, amegata</I>), darling, favourite. <I>Esti la ~o de la nacio, patrino, tago. Mono estis lia ~o</I>. <B>~ano</B>, <B>~isto</B>, -ater, heathen. <I>~ana,</I> pagan. <I>~isteco</I> (Jeĥ 14/4). <B>~ejo</B> (<I>~ana preĝejo</I>), heathen temple, <B>~igi</B>, -ize, be passionately fond of, worship, <B>~kulto</B>, ~<B>servo</B>, -atry. ➞ <I>fetiĉ</I>.", "0"],
["ie", "", "[UV] (<I>iuloke</I>), in some (a certain) place, somewhere (or other). <I>Li loĝas ~ en Kent. ~ kaj</I> here and there. <I>Ĉu ĝi estas ~</I> (anywhere) <I>en la domo? Ĝi ne estas ~ ajn,</I> not anywhere (at all), <B>~n</B>, somewhither. <I>Iru ~n ajn</I>, anywhere (you like).", "0"],
["iel", "", "[UV] (<I>iumaniere</I>), by some means, in some manner (way), somehow or other. <I>~ ni sukcesos. Ĉu mi povus</I> ~ (in any way) <I>vin helpi? Faru ĝin ~ ajn</I>, anyhow, in any way (whatever) (you like). <B>~e</B> (pleon) (M 115/2).", "0"],
["ies", "", "[UV] (<I>de iu, de iuj</I>), a certain person’s, somebody’s (-one’s), of some one (or other), of some people. <I>Mi aŭdis ~ voĉon. Ĉu tio estas ~</I> (anyone’s) <I>propraĵo? Prenu ~ajn,</I> (anyone’s you like, it doesn’t matter whose).", "0"],
["ig", "-ig", "[UV] (sfx) make, cause to be, render. <B>Duon~i</B>, halve. <B>Unu~i</B>, unite. I (adj. root): = make <I>-a</I>. <B>Blank~i</B> (<I>igi blanka</I>), bleach. If ➞ English <I>-en</I>, e.g., <B>akr~i</B>, sharpen; <I>-ify,</I> e.g., <B>cert~i</B>, <B>divers~i</B>, <B>klar~i</B>, <B>sankt~i;</B> <I>-itate,</I> e.g., <I>facil<B>~</B>i, neces</I><B><I>~</I></B><I>i</I><B>;</B> <I>-ize</I>, e.g., <B>util~i.</B> II (noun root): = make <I>-o;</I> or <I>-a</I>. <B>Buter~i</B> <I>lakton;</I> <B>Esperant~i</B> <I>romanon;</I> <B>nul~i</B> <I>mendon</I>. Rim.: For \"to make use of\" use <B>-i</B>, not <B>~igi</B> (vd -I II). e.g. <B>marteli</B>, <B>kroni</B>, <B>veli. Rim</B>.: Compounds: <B>albord~i</B> <I>Upon;</I> <B>detron~i</B> <I>reĝon;</I> <B>elter~i</B> <I>trezoron;</I> <B>enlit~i</B> <I>infanon</I>, <B>senkap~i</B> <I>krimulon</I>. Ill (intransitive verb root): makes a transitive vb. <I>La akvo bolas: mi</I> <B>bol~is</B> <I>ĝin</I>. <B>Pere~i</B> <I>urbon;</I> <B>ven~i</B> <I>pastron</I>. IV (transitive verb root): = <I>igi -ata</I> or <I>-anta</I> according to context. <B>Sci~i</B> <I>amikon pri novaĵo</I> (or, <I>novaĵon al amiko</I>). <B>Kred~i</B> <I>iun pri io (ion al iu</I>). To avoid ambiguity one may use <B>-at</B> or <B>~ant</B>, e.g., <B>manĝ-at(-ant)igi</B> <I>katon</I>. [Do not use <B>-ig</B> needlessly. <B>Fermi</B> (not: <B>fermigi)</B> <I>fenestron;</I> <B>fini</B> <I>laboron</I> <B>veki</B> <I>dormanton</I>. ➞ <B>interesi</B> = to interest; <B>interesigi</B> = to make interesting], <B>Rim</B>.: Sometimes either <B>igi</B> or <B>fari</B> can be used. <I>Tio igis</I> (or <I>faris) lin ruĝa</I>. But they are not synonymous. <I>Mi faris</I> (not <I>igis) mian laboron. Mi igis</I> (not <I>faris) lin labori</I>. ➞ <I>far, iĝ, instig, kaŭz;</I> G <I>einigen</I>, L <I>fumigare</I>.", "0"],
["igluo", "iglu-o", "igloo, Eskimo dome-shaped hut.", "0"],
["ignamo", "ignam-o", "(bot) yam (<I>Diosocorea</I>).", "0"],
["ignori", "ignor-i", "(<I>-n</I>) [OA] (<I>intence flankenlasi, preterlasi, malatenti</I>), ignore, act as if ignorant of, avoid noticing, cut, disregard, leave out of view, not take into account, pass over, pretend not to see, regard as unknown, shut one’s eyes to, take no notice of <I>[Ne= </I> be ignorant, <I>ne scii], Saĝulo ~as ofendon</I>. (Se 12/16). <I>Li (Ĝi) ne estas</I> <B>~ebla</B>. ➞ <I>forsilent, ne konsider, strut</I>.", "0"],
["igvano", "igvan-o", "(zoo) Iguan/a (<I>Iguana</I>), and related genera.", "0"],
["igvanodonto", "igvanodont-o", "(zoo) iguanodon.", "0"],
["iĝ", "-iĝ", "[UV] (sfx) become, come to be, get, grow, turn. Shows change, whether voluntary, or due to external force. <BR> <SUP>I.</SUP> (adj root): <B>Verdi</B>, be green <B>verd~i</B>, turn green. <B>pal~i</B> <I>de timo</I>.<BR> <SUP>II.</SUP> (noun root): = -<B>&lt;</B> <I>-o</I> or <I>-a</I>. <I>Amik~i, maten~i, ruin~i, vesper~i</I>. Compounds: altabM; <B>derel ~i; enlit~i; subakv~i; surmar~i</B>.<BR> <SUP>III</SUP> (intransitive verb root) = <I> iĝi -anta</I>. <B>Sidi</B>, sit (be seated), <B>sid~i</B>, sit down, become seated. <BR>If the vb itself denotes change or momentary action, <I>-iĝi</I> is pleonastic, <I>Droni, fali, halti, kreski, velki</I> (not <B>-iĝi)</B>. <BR>If <B>Mort~i </B> (E 39) is possible, but unusual. See <I> ĉes</I>. <BR> <SUP>IV</SUP> (transitive vb root): Makes an intransitive vb; <I>-iĝas = estas</I> (or <I>iĝas</I>) <I>-ata</I> (passive) <I>= oni -as -on</I>. <I> Mi rulas la ŝtonon, ĝi rul~as</I>. <I> La kunveno ferm~as (= estas fermata, oni fermas la kunvenon</I>). <BR> <SUP>V</SUP> Strictly speaking, <B>-iĝi</B> and <B>esti -ata</B> are not exact synonyms. La <I>ŝtono rul~as</I> asserts change of position, however caused: <I>La ŝtono estas rulata = oni rulas la ŝtonon</I>. <BR> <SUP>VI</SUP> <B>-iĝi</B> is a useful variant of <B>sin -i</B>. <B>Klin~i</B>, <I>sin klini</I>. <B>Lev~i</B>, <I>sin levi</I>. The form with <I> sin</I> is, the other may or may not be, reflex v. <BR> <SUP>VII</SUP> Such expressions as <I> La muroj ban~as en la lago; la tero turn~as</I>, conventionally denote state rather than action. <BR> <SUP>VIII</SUP> There is a diffce between <B>vundo</B> and <B>vund~o</B>. When both forms are possible, <B>-o</B> is better. A <I>bato</I> may be given or received. <I>La komenco, fino, fermo (</I>not:<I> -iĝo) de kunveno</I>. <BR> <I>Rim</I>.: <B>Fariĝi</B> is sometimes used as a synonym of <B>-iĝi</B>. There is, however, a difference: <B>-iĝi</B> = become, get, grow, turn, and <B>fariĝi</B> be made, e.g., <I>iĝi maljuna fariĝi reĝo</I>. ➞ <I>ek</I>. Do not say <I>-iĝita</I> (because verbs with <I>-iĝi</I>, being intransitive, cannot be used in the passive); nor <I>-iĝebla, -iĝinda</I> (for these imply a passive verb). Instead of <I>rompiĝita</I>, say <I>rompita</I> or <I>rompiĝinta</I>; Instead of <I>edziĝebla</I>, say <I>edzigebla</I> or <I>edziĝipova]</I>.", "0"],
["iĥtio", "iĥtio-", "(a. <I>iktio-</I>), (ppfx) ichthyo-, fish.", "0"],
["iĥtiokolo", "", "(<I>fiŝgluo</I>), [UV] isinglass. <B>~logio</B>, -logy. <B>~saŭro</B> (<I>fiŝdrako</I>), (pal) -saurus.", "0"],
["II. antaŭ", "", "PFX. Ante-, fore-, pre-. X <B>~brako</B>, forearm. <B>~ĉambro</B>, anteroom. <B>~klarigo</B>, preamble. <B>2 ~dati</B>, antedate. <B>~historia</B>, <I>prehistoric</I>. ➞ <I>anticip, baldaŭ, fru, iam, pra; opp post</I>.", "0"],
["III", "", ". <B>antaŭ ol</B> (rarely, <I>antaŭ kiam</I>): (conj) = before, ere. ~<I>~ mi venis</I>, b. I came. <I>~~ vi iros</I>, b. you go. ~<I>~ morti</I>, b. dying. <I>Parolu ~~ li (parolas</I>), speak b. he does.", "0"],
["ik", "-ik", "(ch sfx) -ic, denotes a salt with maximum valency. <B>Fer~a</B> (ferric) <I>sulfato</I>.", "0"],
["ikneŭmono", "ikneŭmon-o", "(a. -iĥx), <B>1</B> ichneumon -(cuckoo-)fly (<I>Ichneumon</I>) &gt; ofiono (<I>Ophiori</I>). <B>2</B> icheumon, Egyptian mongoose (<I>Herpestes ichneumon</I>). Vd <I>herpest</I>.", "0"],
["ikono", "ikon-o", "(<I>sankta bildo</I>), icon, image (representation) of sacred personage. <B>~adoro</B>, <B>~rompo. ~oklasto</B> (<I>idolrompisto</I>).", "0"],
["iksio", "iksi-o", "corn lily (<I>Ixia</I>).", "0"],
["ikso", "iks-o", "name of letter X. ~radioj.", "0"],
["iksodo", "iksod-o", "(<B>&lt;</B> <I>akaro</I>), (ent) tick (<I>Ixodes,</I> etc.).", "0"],
["iktero", "ikter-o", "(<I>flava malsano</I>), jaundice, (vet) yellows. <B>~ulo</B>.", "0"],
["il", "-il", "[UL] (sfx) <B>1</B> object. used to perform an action; appliance, implement, instrument, tool, utensil: <B>Skrib~o</B>, anything used for writing (<I>krajono, plumo</I>, etp.). <B>Hak~o</B>, axe; <B>lud~o</B>, toy; <B>rem~o</B>, oar. <B>2</B> means (in gen.): <B>Demand~o</B>, enquiry form; <B>indik~o</B>, sign; transports, means of transport. <B>3</B> medium (substance used as means): <B>Solv~o</B>, solvent. <B>Ilo</B>, tool, instrument. <B>~aro</B>, set of tools. <B>~ujo</B>, tool-bag(-box). <B>Rim.:</B> With an intransitive root, both <B>~ilo</B> and <B>~igilo</B> are used, according to viewpoint (objective or subjective). The sleeper uses his bed as a <B>dorm~o;</B> the nurse gives the patient a <B>dormig-o. Pend~o</B> relates to the criminal; <B>pendig-o</B> to the hangman. <B>Rim.:</B> With a noun root: (a) <B>-ilo=</B>//o <I>por -i, ilo de -ado</I>. <B>Muzik-o</B>, mus. instrument. (b) <B>-igilo =</B> <I>ilo igi -a</I> (-o). <B>Pulvorig~o</B>, pulverizer. <B>Rim</B>.: <B>Ilo</B> = a tool; <B>maŝino</B>, a larger, more complicated piece of machinery. <B>Kudrilo</B>, needle; <B>kudromaŝino</B>, sewing-machine. <B>IT</B> If the root itself denotes the tool, <B>-il</B> is pleonastic. <B>Baston-(bros-)o</B>, not <I>-ilo</I>. <B>ile-o</B>, ileum, pt of small intestine.", "0"],
["ilekso", "ileks-o", "[OA] holly (<I>Ilex</I>) (Jes 44/14).", "0"],
["ili", "", "[UV] they, <I>Al</I> to them. <I>Mi vidis ~n</I>, I saw them. <B>~a</B>, their, theirs, of them.", "0"],
["ilicio", "ilici-o", "(bot) (<I>stelanizo</I>), star anise. (<I>Ilicium</I>).", "0"],
["iliumo", "ilium-o", "ilium &lt; hip-bone.", "0"],
["ilumini", "ilumin-i", "(<I>-n</I>), [UV] Illuminat<B>/e. 1</B> (supply or decorate with) Light(s), 1. up, shed 1. (lustre) on, brighten. <I>~i dom-(strat-)on</I>. 2 decorate with colored initials. <I>~i manuskripton</I>. <B>3</B> enlighten, give insight. <I>inteligenton, spiriton</I>. <B>~ado</B>, <B>~aĵo</B>, -ion. <B>~ilo</B>, <B>-itoj</B>, illuminati. ➞ <I>ilustr, lamp(ion), lantern, lumig</I>.", "0"],
["ilustri", "ilustr-i", "(<I>-n</I>), [OA], Illustrat/e. <B>1</B> with pictures. <I>~ita libro, po<B>ŝ</B>tkarto, revuo</I>. <B>2</B> elucidate, explain, exemplify, make clear. <I>~i regulon (sian penson) per ekzemplo</I>. <B>~a</B> -ive. <B>~ado</B>, <B>~aĵo</B>, -ion, example, picture, <B>~isto</B>, illustrator.", "0"],
["iluzio", "iluzi-o", "[OA] (<I>sens-eraro</I>), Illus/ion, deception of the senses. <I>~o akustika, optika</I>. <B>f</B> <I>Fari al si ~ojn. ~oj de juneco</I>. <B>~i</B> (<I>-n) (trompi</I>), deceive, delude, hoodwink. (M 141/4). <B>~a</B>, -ive, -ory, deceptive, phantom, sham, unreal. <I>~a espero, projekto, promeso</I>. <B>~aĵo</B>, illusion, castle in the air, soap-bubble. <B>~iĝi</B>, have an illusion. <B>~iĝulo</B>, cloudwalker, visionary. <B>~isto</B>, illusionist (➞ <I>ĵongl</I>). <B>Sen~igi</B>, <B>dis~i</B>, disenchant, undeceive. <B>Sen~iĝo</B>, disappointment (M 141/5). ➞ <I>fantazi, halucin, ĥimer, miraĝ, sonĝ</I>.", "0"],
["imagi", "imag-i", "[UV] (<I>mense bildigi</I>), Imagin/e, conceive, fancy, form a mental image, get into one’s head, picture to one’s. <I>~u mian ĝojon (la scenon)! ~u vin sur mia loko! ~u al vi, ke… . </I> <B>~(it)a</B> (<I>nereala</I>), -ary, fancied, hypothetical, illusory, shadowy, supposed. <I>~ita malsano</I>. <B>~(aĵ)o</B>, -ation, fancy. <I>Forta ~o. \"La Malsanulo pro ~o\"</I>. <B>~e</B>, in -ation. <B>~ebla</B>, -able. <B>Ne~ebla</B> (inconceivable, unthinkable) <I>ĝojo, sufero</I>. <B>~ema</B>, -ative, fanciful. ➞ <I>bild, fantazi, supoz, rev</I>.", "0"],
["imagino", "imagin-o", "(insekto seksmatura), (ent) imago.", "0"],
["imanenta", "imanent-a", "(phil) immanent, indwelling, inherent (in), intrinsic.", "0"],
["imbriki", "imbrik-i", "imbricate, overlap, e.g., of bandages, slates, tiles. <B>~ita</B> (<I>tegolaranĝa</I>), overlapping.", "0"],
["imiti", "imit-i", "(<I>-n</I>) [UV] Imit/ate. <B>1</B> be modelled on, copy, follow, reproduce. <I>~i ekzemplon, geston, mod(el)on, patron. ~i fidele, simie</I>. 2 (<I>burleski, ~aĉi, mok~i</I>), ape, take off, mimic, parody, travesty. <B>3</B> counterfeit, forge. <I>~i diamanton, subskribon</I>. <B>~(aĵ)o</B>, -ation. <I>~ado al Kristo</I>. (mus) repetition at another pitch, <B>~anto</B>, <B>~isto</B>, -ator, impressionist. <B>~(em)a</B>, -ative. <B>~enda</B>, <B>~inda</B>, to be -ated, exemplary, model, pattern. <B>Ne~ebla</B>, in-able. <B>Son~a</B>, onomatopoeic. ➞ <I>faksimil, fals, kopi, surogat</I>.", "0"],
["imortelo", "imortel-o", "(a. <I>helikrizo</I>), everlasting flower, immortelle.", "0"],
["impedaneo", "impedane-o", "(el) impedance. <I>~a bobeno,</I> choke coil.", "0"],
["imperativo", "imperativ-o", "[OA] (<I>u-modo</I>), (gram) imperative (volitive) mood, <B>f</B> <I>~o (devigo) de la konscienco</I>. <B>~a</B>, i. (also figuratively).", "0"],
["imperfekto", "imperfekt-o", "[OA] (gram) imperfect (tense).", "0"],
["imperialo", "imperial-o", "[OA] top deck, outside (of bus, tram, cab, etc.).", "0"],
["imperio", "imperi-o", "[UV] empire. <B>1</B> dominion, territory. <I>~o Brita, kolonia</I>. <B>2</B> command, sovereign authty (rule, sway). <B>~a.</B> Imperial. <B>~estr(in)o</B>, emperor, empress, <B>~ismo [imperialism-o</B> [OA]], -alism. <B>~isto</B>, -alist.", "0"],
["impertinenta", "impertinent-a", "[OA] Impertinen/t, cheeky, \"fresh\", forward, impudent, insolent, pert, rude, saucy. <I>~a konduto, letero, parolo, rigardo</I>. <B>~(ec)o</B>, -ce, cheek, effontery, impudence. <B>~ulo</B>, cheeky rascal, saucy fellow. ➞ <I>malĝentil, malrespekt</I>.", "0"],
["impeti", "impet-i", "[OA-8], be impetuous, bound, dash. <B>~o</B>, impetus, (on)rush, energy (force) of motion, impulse, momentum<B>.</B> <I>~o de rivero</I>. <B>~a</B>, impetuous, acting (moving) with rash or sudden energy. <I>~a gesto, karaktero, parolo, torento, vento</I>. ➞ <I>ard, fervor, impuls, sinĵet, very</I>.", "0"],
["implici", "implic-i", "(<I>-n, ke</I>), Impl/y, involve, hint, insinuate (the truth of something not expressly asserted). <B>~ita</B>, -icit, -ied, tacit, understood but not expressed. <I>~ita ideo, kondiĉo, senco. ~ita fido</I>, unreserved faith, (mus) <I>~ita cifero</I>, -ied figure. <B>~o</B>, -ication, suggested meaning. (rh) hypocatastasis = -ied metaphor, e.g., \"Go tell that fox\". <B>Mal~a</B>, definite, explicit, express, stated in detail. ➞ <I>insinu, implik</I>.", "0"],
["impliki", "implik-i", "(-n, <I>en, per</I>), [UV] Implic/ate, entangle, entwine. <I>~i fiŝon en reton, piedon en draton. ~ita</I> (caught) <I>per la kornoj. ~itaj</I> (matted, tangled) <I>fadenoj, haroj</I>. <B>f</B> involve, embroil. <I>~i iun en disputon, krimon, respondecon</I>. <B>~o</B>, -ation. <B>~a</B>, -ative, <B>~aĵo</B>, entanglement, complication, labirinth. <I>Politika ~aĵo</I>. <B>~ema</B>, captious. <B>~igi</B>, be affected by (drawn into), get embroiled, entangled, implicated, involved, mixed (tied) up in (Gen 22/13). <B>~ilo</B>, (Ps 140/5). <B>Mal~i</B>, clear up, comb out, disentangle, free, unravel. ➞ <I>implic, lig, vind, volv; komplik, konfuz, labirint</I>.", "0"],
["imponi", "impon-i", "(<I>al, per</I>) <B>[OA]</B> (<I>trudi respekton</I>), Impress, command respect, make a strong impres sion (on). <I>~i al la publiko, al simplulo. Li ne ~as per la eksteraĵo</I>, is not much to look at. <B>~a</B>, -ive, commanding, imposing, striking, venerable. <I>~a aspekto, fasado, monto, ordeno, ruino, personeco</I>. <B>~eco</B>, majesty, prestige. <B>~ega</B>, overwhelming. <B>Ne~a</B>, unimpressive, feeble, insignificant, plain, unpretentious. ➞ <I>altrud, efekt, grandioz, impres, majest, okulfrap, solen. [Ne= tromp]</I>.", "0"],
["importi", "import-i", "(<I>-n</I>) [OA], Import. <I>~i karbon, ideojn, varojn</I>. <B>~(ad)o</B>, -ation. <B>~a</B> <I>komerco</I>. <B>~oj</B>, <B>~aĵo</B>, -ed goods. <B>~isto</B>, -er.", "0"],
["imposto", "impost-o", "[OA] Duty, Tax (Ez 7/24). <I>Libera de ~o</I>, t-free. <I>Kolekti, pagi ~on. ~o (ne)rekta</I>. <B>Enspez~o</B>, income-t. <B>Haven~o</B>, harbour due. <B>Hund~o</B>, dog-t. <B>Kap~o</B>, poll-t, capitation. <B>Komerc-o</B>, customs. <B>Lim~o</B> (<I>dogano</I>), <B>Spez~o</B>, purchase-t. <B>Ter~o</B>, land-t. <B>Urb~o</B>, rate. <B>Voj~o</B>, toll. <B>~i</B> (<I>-n</I>), tax, <B>~ata</B>, <B>~ebla</B>, assessable, dutiable, rateable. <B>~ejo</B>, custom-house. <I>En ~ejo</I>, in bond. <B>~(kolekt)isto</B>, t-collector. <B>~evitulo</B>, t-dodger. <B>~kvoto</B>, assessment, <B>~paganto</B>, t-payer. <B>Sen~a</B>, d-free. ➞ <I>akciz, dogan, tribut</I>.", "0"],
["impoŝto", "impoŝt-o", "(arch) impost, upper course of pillar, bearing arch.", "0"],
["impotenta", "impotent-a", "(<I>sekse senpova</I>), (med) impotent. <B>~(ec)o</B>, <B>-ulo</B>.", "0"],
["impozi", "impoz-i", "(<I>-n</I>), (typ) impose, arrange, lay and secure papers.", "0"],
["impregni", "impregn-i", "(<I>-n</I>) (<I>sorbigi</I>), impregnate, permeate, saturate, (bio) fecundate, <B>f</B> imbue. <B>01e~ita</B> <I>ŝtofo</I>, <B>oilskin</B>, <B>etc.</B>", "0"],
["impresario", "impresari-o", "[OA] impresario, manager (organizer) of public entertainment.", "0"],
["impreso", "impres-o", "[UV] <B>1</B> mental Impress/ion, effect produced on mind or feelings: <I>~o de sufokiĝo, varmo. ~o forta, profunda. Fari, ricevi, senti ~on</I>. <B>2</B> (phot) impress, effect of light on film, sensitized plate. <B>3</B> (typ) print. <B>~i</B> (<I>-n, kiel, kvazaŭ</I>), <B>i</B>., make an -ion on, affect, influence. <I>~i favore, neforgeseble. Esti ~ata de. Tio ne ~as min</I>, it leaves me cold, <B>~a</B>, impressive<B></B>. <I>~a parolo, programo, spektaklo</I>. <B>~ebla</B>, <B>~iĝema</B>, impressible, -ionable, easily influenced, persuasible, sensitive, susceptible. <I>~~a karaktero, naturo, plato</I>. <B>~ebligi</B>, sensitize, -<B>ismo</B>, -ionism. ➞ <I>aktiv, efekt, efik, impon, pres</I>.", "0"],
["improvizi", "improviz-i", "(<I>-n, abs</I>) [OA], Improv/ise, compose (perform, utter) without prepar- ation. <B>1</B> Extempor/ize. <I>~i parolon, poemon</I>. (mus) <I>akompanon</I>, vamp. <B>2</B> (<I>organizi</I>), get up, provide, think out extempore. <I>~i ekskurson, manĝon, rimedon</I>. <B>~e</B>, at a moment’s notice, off-hand, on the spur of the moment, without premeditation. <B>~(it)a</B>, e-ized, improvised, e-aneous, impromptu. <B>~ado</B>, <B>~aĵo</B>, e-, improvization, makeshift. (mus) impromptu.", "0"],
["impulso", "impuls-o", "[OA] impulse; (mech) impulsion, momentary force, propulsion, push; (phi), mental incitement, sudden tendency to act without reflection. <I>~o de kolero, konscienco. Agi laŭ ~o</I>. <B>~i</B> (<I>-n</I>), drive, force, impel, move. <B>~(iĝem)a</B>, impulsive, hot-headed. <I>~a karaktero, viro</I>. ➞ <I>ekmov, ekpuŝ, impet, incit, instig, pel</I>.", "0"],
["imputi", "imput-i", "(<I>-n</I>), Imput/e, ascribe, attribute, put down to. <I>~i Iculpon al</I>, lay the blame on. <B>~ado</B>, <B>~aĵo</B>, -ation. ➞ <I>al-juĝ-kalkul, atribu</I>.", "0"],
["imuna", "imun-a", "(<I>kontraŭ</I>) [OA], Immun/e, exempt, not liable (for), protected (proof) against. <B>Akv~a</B>, impermeable. <B>Brul~a</B>, incombustible. <B>Lik~a</B>, water-tight. <B>Pluv~a</B>, rain-proof. <B>Rust~a</B>, rust-proof. <B>~eco</B>, -ity, freedom (from), protection, security (against). <I>~eco de iu kontraŭ io</I>. <B>~igi</B>, -ize. ➞ <I>ne … -ebla, liber, ŝirmit</I>.", "0"],
["in", "-in", "[UV] (sfx) denotes Female, Feminine, (a) Human being: <I>avino, edzino, fratino; amikino, profetino, skoltino</I>. (b) National or personal name: <I>Anglino, Jozefino</I>. (c) Animal: <I>bovino, pavino</I>. (d) Other beings:. <I>Anĝelino, diablino, feino</I> [FE]<I>, niksino</I>. (e) (Col). <B>Ĉapel~o</B> (or <B>~ĉapelo)</B>, woman’s hat. similar <B>ĉemiz~o</B>, chemise; <B>duet-(fantom-kadavr-voĉ-)ino. Vidv~aĵoj</B>, widow’s weeds. <B>Vidv~eco</B>, widowhood. <I>AS A ROOT:</I> <B>Ino</B>, female; <I>Virbesto kaj</I> <B>ino</B> (Ge 7/2, 9). <I>Du viroj, kvar inoj</I>. <B>~a</B>, <B>~seksa</B>, feminine. <I>~a floro, konduto, rideto, sekso</I>. (pros) feminine, ending with unaccented syllable. <I>~a rimo, verso</I>. <B>Rim</B>.: If the root itself denotes fem. sex, <I>-in</I> is pleonastic. <I>Amazono, madono, matrono, Sofio</I> (not: <I>-ino). Ŝi (F-ino B.) estas aŭtoro, sekretario;</I> not <I>~ino,</I> unless it is desired to emphasize the sex. ➞ she is my secretary.", "0"],
["in", "-in", "(chem. sfx), -yne, denotes triple chain.", "0"],
["inaŭgur[aci]i", "inaŭgur[aci]-i", "(<I>-n</I>) [OA], inaugurate, celebrate the institution of, formally open, institute, introduce with fitting ceremonies, set going, usher in. <I>~i ekspozicion, kurson</I>. <B>f</B> introduce, start. <I>~i epokon, reĝimon</I>. <B>~o</B>, inauguration (2 Kr 7/5, 9; Ne 12/27). <B>~a</B>, inaugural (No 7/10, 84). ➞ <I>dediĉ, enkonduk, inic(iat), komenc, malferm, senvualig</I>.", "0"],
["incendio", "incendi-o", "(outbreak of) fire, conflagration. <B>~a</B>, incendiary, <B>f</B> inflammatory. <B>~into</B>, <B>~isto</B>, firebrand, incendiary.", "0"],
["incenso", "incens-o", "Incense, various aromatic gums agreeable when burned. <B>~i</B> <I>-n per, (fumizi</I>), (in)cense, burn incense. <I>~i altaron</I>. <B>~ado</B>, <B>f</B> flattery, praise, (M 1/24). <B>~ilo</B>, <B>~ujo</B>, censer, thurible (Le 16/12). <B>~(port)isto</B>, thurifer. ➞ <I>parfum, oliban, timian; flat, laŭd</I>.", "0"],
["incesto", "incest-o", "(<I>sangadulto</I>), incest. <B>~a</B>, incestuous.", "0"],
["incidento", "incident-o", "(<I>eventeto flanka</I>), incident, circumstance, subordinate event or occurrence. <I>~oj de kongreso, vojaĝo</I>. <B>~a</B>, incidental, adventitious, fortuitious.", "0"],
["incidi", "incid-i", ". (nt) (opt) (ph), fall on (a surface), strike. <B>~o</B>, Incidence, range. <B>~a</B> <I>angulo,</I> angle of i. <I>~a ebeno, punkto, radio</I>.", "0"],
["incit", "", "-i (<I>-n</I>), [UV] Incit/e, provoke. <B>1</B> badger, bait, fret, harass, irritate, torment (l Sa 1/7). <I>~i abelojn, hundon. ~ita voĉo</I>. <B>2</B> awaken, rouse, stir up. <I>~i al kolero, pasio, ribelo. ~i koleron</I>. egg, (spur, urge) on to action. <I>~i la fajron, galon, nervojn</I>. <B>~a</B>, pungent. <B>~(ad)o</B> (2 Rĝ 23/26), irritation, provocation. <B>~aĵo</B>, irritant, red rag. <B>~egi</B>, exacerbate, exasperate, infuriate, overstimulate. <B>~eti</B>, fret, tease. <B>~iĝi</B>, fret, fume, get annoyed (cross, peeved). <B>~iĝema</B>, cross-grained, easily provoked, fretful, irritable, peevish, susceptible, testy (Se 14/16). <B>~ilo</B>, incentive, spur, stimulus. <B>Frot~i</B>, chafe, fret, gall. <B>Log~i</B>, inflame, lead on (with curiosity, etc.). ➞ <I>instig, pik, provok, stimul, turment, vek</I>.", "0"],
["incizivo", "inciziv-o", "(tranĉdento), incisor.", "0"],
["inda", "-ind-a", "[UV] (sfx) Worth/y, deservg of (to be … ed, … -worthy). <B>Fid~a</B>, trust-w; <B>Hont~a</B>, shameful; <B>Kompat~a</B>, poor; <B>Lern~a</B>, w. learning; Prez<B>~a</B>, w. the price; <B>Rid~a</B>, ridiculous. <B>Rim</B>.: Sometimes =-able (in this sense only), e.g., <B>admir~a</B>, <B>honor~a</B>, admirable, honourable <I>[Ne= ~ebla]</I>. <B>~o</B>, <B>1</B> -iness, merit. <B>2</B> w., value. <B>~a</B>, -y of, deserving. <I>La afero ne</I> <B>~as</B> <I>penon</I>, is not w. troubling about. <B>~eca</B>, dignified. <B>Mal~a</B>, base. <B>Ne~a</B>, un-y. undeserving. <B>Sen~ulo</B>, un-y person. ➞ <I>ebl, end, digit, merit, taŭg, valor</I>.", "0"],
["indekso", "indeks-o", "[OA] Index, alphabetical list of names, subjs, etc. <B>~i</B>, i., make an i. of. ➞ <I>indic</I>.", "0"],
["indico", "indic-o", "(gvidsigneto, indikaĵo, signero), (mat) index, characteristic, exponent, mark, sign. <I>~o bibliografia, logaritma, preza, refrakta, vivkosta</I>. ➞ <I>indeks</I>.", "0"],
["indieno", "indien-o", "indienne, chintz, printed cotton goods, calico printing. ➞ <I>kalikot, meblokatun</I>.", "0"],
["indiferenta", "indiferent-a", "[UV] Indifferen/t. <B>1</B> (objective) (<I>tutegala</I>), of no consequence, immaterial, all the same, unimportant. <I>La rezulto estas por mi ~a</I> (all the same either way.) <B>2</B> (subjective) (having no preferce for or against), i. to, neutral, taking no interest in, unaffected by, unconcerned as to: <I>Por mi estas ~e</I> (I don’t care, it makes no difference to me) <I>kiam li venos. ~a koro, spirito, ~aj okuloj. ~a por (pri) tio</I> (to that), <I>kontraŭ li</I> (towards him). <B>~e</B> <I>rigardi fremdan mizeron</I>. <B>~ismo</B>, -ism.", "0"],
["indigni", "indign-i", "(<I>kontraŭ iu, pri io</I>), [UV] be Indign/ant (at, with), (Da 2/12), be moved by mingled anger and scorn, or feeling of injured innocence; be shocked at, resent. <I>Pri kio vi ~as?</I> <B>~o</B>, indignation, anger excited by meanness (injustice, misconduct), resentment. <B>~a</B>, -ant. <I>~a rigardo, tono</I>. <B>~ema</B> (<I>ofendiĝema</I>), resentful, touchy. <B>~igi</B>, rouse to -ation. <B>~iga</B>, <B>~inda</B>, revolting, shocking. <I>~~a konduto, perfido, trompo</I>. <B>~indaĵo</B>, indignity.", "0"],
["indigo", "indig-o", "[OA] (chem) Indigo, blue powder from i-plant (3 FA 100/7). <B>~a</B> <I>bluo</I>, i-blue. <B>~oplanto</B>, i-plant (<I>Indigofera</I>).", "0"],
["indiĝeno", "indiĝen-o", "[OA] (<I>landido, praloĝanto</I>). Native, aboriginal (No 15/13,1 Kr7/21). <B>~a</B> native, indigenous. <I>~a besto, homo, planto</I>.", "0"],
["indikativo,", "indikativ-o,", "[OA] (gram) indicative (mood).", "0"],
["indiki", "indik-i", "[OA] (<I>precize montri</I>), Indic/ate, be a sign of, betoken, denote, evince, notify, point out, show, specify. <I>~i adreson, horon, kvaliton, rimedon, vojon</I>. <B>~(aĵ)o</B>, -ation. <B>~a</B>, -ative, <I>~a fosto</I>, sign-post. <B>~ilo</B>, -ator, -ing apparatus, recording instrument. <B>Brulaj ~ilo</B>, fuel contents gauge. <B>Direkt~ilo</B>, direction finder. <B>Driv~ilo</B>, drift sight. <B>Prem~ilo</B>, pressure gauge. <B>Rapid~ilo</B>, speedometer. <B>Turn~ilo</B>, (mot) turn-indicator. ➞ <I>inform, montri, sugest, sign</I>.", "0"],
["indio", "indi-o", "(chem) Indium (In).", "0"],
["individuo", "individu-o", "[OA] <B>1</B> Individual, fellow, single human being, person (opposite <I>grup</I>). <B>2</B> single member of class. ~a (<I>aparta, persona, propra</I>), i., of one person, particular, single, separate. <I>~a instruo, gusto, laboro, libero, opinio</I>. <B>~e</B>, -ly, in person. <B>~eco</B>, -ity, separate existence, i. character. <B>~igi</B>, -ize, specify. <B>~ismo</B>, <B>~isto</B>, -ism, -ist.", "0"],
["Indonezio", "Indonezi-o", "ID, Indonesia.", "0"],
["induktanco", "induktanc-o", "inductance, -ive resistance. <I>Antena ~o</I>, aerial -ance.", "0"],
["indukti", "indukt-i", "[OA] (log) Infer, generalize, reason <I>a posteriori</I> (from cause to effect, from isolated facts to gen. statement, from parts to whole). <B>~o</B>, -ence, induction. <B>~a</B>, inductive. <I>~a metodo, rezonado</I>. ➞ <I>dedukt</I>.", "0"],
["indukto", "indukt-o", "(el) Induct/ion. <I>~o elektro- magneta</I>. <B>Inter~o</B>, mutual i. <B>Mem~o</B>, self-i. <B>~a</B> <I>kurento</I>, induced current. <B>~ado</B> <I>kontinua</I>, continuous loading. <B>~eco</B>, -ivity. <B>~ilo</B> (<I>~a bobeno</I>), -or, i-coil. <I>~ilo agorda (variigebla</I>). <B>Ne~a</B>, <B>Sen~a</B>, non-ive.", "0"],
["indulgenco", "indulgenc-o", "(rc) indulgence. <I>Vendo de ~oj</I>.", "0"],
["indulgi", "indulg-i", "(<I>-n, al;</I> abs) [UV] (<I>trakti malsevere, milde, pardoneme</I>). be Indulg/ent (forbearing, lenient, merciful) to, bear with, excuse, let off lightly, make allowance for, pass over, spare. <I>~i kulpon (pri kulpo). Dio ~u al mi (min). ~i filon</I> (Ge 22/16), <I>malvirtulon</I> (Jes 26/10), <I>malforton, maljunulon, orelojn de infano</I>. <B>~(em)a</B>, -ent, clement, lenient, magnanimous, merciful, patient. <B>~o</B>, -ence, clemency, forbearance. <I>Peti ~on</I>. <B>~inda</B>, excusable, venial. <B>Mal~a</B>, <B>Sen~a</B>, exacting, hard, implacable, inexorable, pitiless, relentless, severe, stern, tough, unsparing. ➞ <I>domaĝ, dorlot, fer, kompat, malsever</I>.", "0"],
["industrio", "industri-o", "[UV] Industr/y, productive trade. <I>~o libra, mina, peza, de la lando</I>. <B>~a</B>, -ial, of i. <I>~a arto, lernejo, urbo</I>. <B>~aĵo</B>, -ial product. <B>~isto</B>, -ialist. ➞ <I>fabrik, komerc, meti</I>.", "0"],
["inercio", "inerci-o", "( = inerteco), (ph) inertia. <B>~a</B> fort-(moment-)o. ~a rado, fly-wheel.", "0"],
["inerta", "inert-a", "[OA] Inert. 1 (<I>sen propra movo), without</I> inherent power of action, motion, or resistance, <I>~a gaso, maso</I>. <B>2</B> apathetic, dull, heavy, inactive, lethargic, slow, sluggish. <I>~a inteligento, spirito. ~a rezisto</I>, passive resistance. <B>3</B> chemically inactive. <B>~eco</B> = <I>inercio</I>. ➞ <I>apati, neagem, pasiv</I>.", "0"],
["infano", "infan-o", "[UV] Child. <B>1</B> (<I>opp</I> plenaĝulo). <B>2</B> son or daughter. <I>Adopt(it)a ~o. Al malriĉulo ~oj ne mankas</I>. <B>~a</B>, c’s, for cc., of a c. <B>~a</B> <I>argumento, ĉambro, ludo, vesto, voĉo</I>. <I><B>~aĉo</B>, brat imp, monkey, scamp. ➞ bub</I>,<I> <B>~aĵo</B> (1 Ko 13/11), something childish</I>. <B>~aĵa</B>, <I>puerile. ➞ naiv. <B>~aro</B>, <B>ge~oj</B>, cc., boys and girls. <B>~eco</B> [UV] <B>(~aĝo</B>, <B>~jaroj)</B>, -hood, -ishness, infancy</I>. <I>Dua ~eco, dotage. <B>~eca</B>, -like, -ish, artless, infantile. <B>~ejo</B>, nursery. <B>~eto</B>, tiny c., infant. ➞ etui</I>. <B>~etejo</B>, <I>creche, day (infant) nursery. <B>~iĝi</B>, grow -ish. (col) <B>~ino</B>, girl, lassie. <B>~ismo</B>, infantilism, <B>~istino</B>, (vartistino</I>), <I>nurse (maid). <B>Mir~o</B>, (infant) prodigy. <B>~mortigo</B>, infanticide. <B>~ŝtelisto</B>, kidnapper. <B>Sen~a</B>, -less. <B>Sen ~igi</B>, bereave of cc. (Jeĥ 36/13). <B>Sol~o</B>, only c. <B>Suĉ~o</B> (bebo</I>), <I>infant in arms, <B>Vir~o</B>, male c. ➞ id, knab, naskit</I>.", "0"],
["infanterio", "infanteri-o", "[OA] infantry. <B>~ano</B>, foot- soldier. ➞ landkneĥt.", "1"],
["infekti", "infekt-i", "(<I>-</I>n, <I>per</I>), [UV] Infect. <B>1</B> (<I>komuniki malbonon, malsanon</I>), contaminate, corrupt, pollute, taint, vitiate. <I>~i infanon, ŝafaron, vundon</I>. f <I>~i landon, morojn, iun per herezo</I>. ➞ <I>inokul, kontaĝi</I>. <B>2</B> (<I>komuniki kutimon, penson, senton</I>): communicate, imbue with, pass on to. <I>~i iun per espero, rido, ideoj</I>. ➞ <I>inspir</I>. <B>~a</B>, infectious, catching. <I>~a malsano</I>. <B>~(ad)o</B>, -ion, diffusive influence, <I>~o de lepro, sur la haŭto</I>. <B>~aĵo</B>, infected spot, etc. (Le 13/3). <B>~iĝi</B> (<I>de io, de iu per io</I>), catch. <B>~ito</B>, -ed person (Le 13/4). <B>~itaĵo</B> (Le 13/50). <B>Mal~i</B>, <B>Sen~igi</B>, <B>dis~i. ~~</B><I>i ĉambron, veston</I>. <B>Re~i</B>, reinfect. ➞ <I>astiseps, virus</I>.", "0"],
["infero", "infer-o", "[UV] the infernal regions. <B>1</B> Hell. <I>En ~o loĝante, kun diabloj ne disputu</I>. <B>2</B> (<I>subtera mondo</I>), (myth) underworld. ➞ <I>gehen, hades</I>, <B>f</B> (<I>loko suferiga). Tia vivo estas ~o</I>. <B>~a</B>, <B>~inda</B>, hellish, fiendish, infernal. <I>~a maŝino, turmento</I>. <B>f</B> abominable. <I>~a bruo, karaktero, kruelo</I>. <B>~ano</B>, <B>~ulo</B>, devil, fiend (Se 2/18). (myth) inhabitant of lower regions. ➞ <I>diabl</I>.", "0"],
["infesti", "infest-i", "(<I>-n</I>), Infest, overrun, swarm about or in (of germs, insects, pirates, etc.). <I>Planto, tero ~ita de</I>, <B>-ed</B> (contaminated) with. <B>~o</B>, -ation.", "0"],
["infikso", "infiks-o", "(gram) infix, modifying element in middle of word., e.g., <I>fer-i-cianido, kelk-a- foje, ĉiel-en-a vojo</I>.", "0"],
["infinitezima", "", "(<I>senlime malgranda</I>), (mat) infinitesimal, -ely small in amount. <I>~a kalkulo, kvanto</I>.", "0"],
["infinitivo", "", "[OA] (gram) -itive mood (<I>i-modo</I>).", "0"],
["infinito", "infinit-o", "(<I>senfinaĵo</I>), the Infinit/e, -itude, -y. <B>~a</B>, i., boundless, endless.", "0"],
["inflacio", "inflaci-o", "(fin) inflation.", "0"],
["inflamo", "inflam-o", "[OA] (<I>brulumo, -ito</I>), <B>1</B> (med) Inflam/mation. <B>~i</B>, be -ed. <B>~a</B>, inflammatory, -ed. <B>~igi</B>, inflame, irritate, <B>f</B> aggravate, excite passionately. <B>Kontraŭ~a</B>, antiphlogistic.", "0"],
["infloresko", "infloresk-o", "(bot) inflorescence, arrangement of flowers of plant in relation to axis and each other. ➞ <I>korimb, panikl, racem, umbel</I>.", "0"],
["influi", "influ-i", "(<I>-n, al, super, sur</I>), [UV] Influence, have an effect on, move, sway. <I>~i</I> (affect) <I>rezulton. ~i iun (al iu). ~i decidon, sorton</I>. <B>~o</B>, <B>i</B>., ascendency, pull, weight. <I>Sfero de ~o. Havi, posedi ~on. ~o de lumo al floro, de oratoro sur la publiko(ri</I>). <B>~(hav)a</B>, -tial, with i. <I>~a hom-(Jurnal-)o</I>. <B>~ebla</B>, open to i. <B>Ne~ebla</B>, proof against, refractory, stubborn. <B>Sen~a</B>, without i. ➞ <I>efik</I>.", "0"],
["informi", "inform-i", "(<I>-n, al; ĉu, ke, kiel, pri</I>) [OA], Inform, give -ation, acquaint with, apprise of, enlighten as to, notify, tell. <I>~u lin (al li), ke … Bone ~ita hom -(gazet-)o</I>. <B>~o</B>, -ation, communication, intelligce, particulars. <I>Doni ~o(j)n</I>. <B>~a</B>, <B>-ative</B>. <I>-a bulteno</I>. <B>~ado</B>, publicity, <B>~anto</B>, informant, authority. <B>~(ofic)ejo</B>, -ation bureau, enquiry office. <B>~iĝi</B>, get -ation, investigate, learn, make enquiries. ~ilo, news bulletin, -peto, request for -ation. Mis-i, mis-i. Pri~i (<I>iun</I>), post, supply with full -ation. ➞ <I>anonc, aviz, kon-(sci-)ig</I>.", "0"],
["infuzi", "infuz-i", "(<I>-n</I>), [UV] Infus/e, brew, macerate, steep (in liquid), <B>f</B> in-culcate(-spire-stil). <I>~i herbojn, kafon, teon</I>. <B>~(aĵ)o</B>, -ion, brew, extract. <B>~iĝi</B>, i., draw. ➞ <I>dekokt, ekstrakt, tizan</I>.", "0"],
["infuzorioj", "infuzori-oj", "(zoo) infusoria.", "0"],
["ing", "-ing", "[UV] (sfx) denotes obj in which something is set or put; holder (sheath, socket, stand, etc.) for one object. only. The object. is not completely contained, but fits more or less closely, held usually at one end, the other end being free. <B>Ingo</B>, sheath, socket, stand (El 25/27). <B>Fingr~o</B>, thimble; <B>glan~o</B>, acorn-cup; <B>glav~o</B>, scabbard; <B>ombrel~o</B>, umbrella case; <B>ov-o</B>, egg cup. <B>Ingi</B>, hold, grasp. <B>En-igi</B>, encase, sheathe. <B>El~igi (Mal~i)</B>, unsheathe, draw. <B>IT</B> In gen., an ingo is for <I>one</I> object.; an ujo for <I>some</I> (number or quantity). An ingo holds or grasps pt of an object., usually at one end; an ujo contains the whole. Ij Violonujo = vn-case, though holding only one vn. An ingo usually holds firmly, and is shaped to fit; an ujo contains loosely. An ingo is usually for convenience or protection in use; an ujo for convenience in keeping or carrying. ➞ kandel<B>~o</B>, candle-stick; kandelujo, candle-box.", "0"],
["ingredienco", "ingredienc-o", "[OA] (cul) (pharm) ingredient, component pt (element) of mixture. ➞ <I>element, er, konsistaĵ</I>.", "0"],
["ingveno", "ingven-o", "[OA] (anat) groin. <B>~a</B>, inguinal.", "0"],
["inĝenia", "inĝeni-a", "(<I>elpensema, eltrovema</I>), Ingen/ious, clever at contriving, cleverly contrived, showing invention or resource. <B>~o</B>, <B>-uity.</B>", "0"],
["inĝeniero", "inĝenier-o", "[UV] Engineer. <I>~o civila, elektr a, milita, mineja</I>. <B>~a</B> <I>fako</I>, -ing department. <B>~ado</B>, <B>~arto</B>, -ing.", "0"],
["inhali", "inhal-i", "(<I>-n</I>), <B>(</B><I>enspiri</I>), Inhal/e, breathe in, take into the lungs, <I>~u profunde!</I> <B>~ado</B>, -ation. <B>~aĵo</B>, -ant. <B>~ilo</B>, -or.", "0"],
["inhibi", "inhib-i", "(<I>-n</I>), Inhibit, forbid, (jur) Prohibit (from). <B>~o</B>, inhibition, (psy) blocking of thought or action by mental resistance. ➞ <I>malpermes</I>.", "0"],
["inici", "inic-i", "(<I>iun</I>), Initiat/e (into office, secret, society, etc.) (col) let into. <I>~i en misteron, pri ritoj</I>. <B>~anto</B>, guide, <B>~o</B>, -ion. <B>~a</B>, -ory. <B>~ilo</B>, introduction, guide. ➞ <I>enkonduk, ensekretig, iniciat</I>.", "0"],
["iniciati", "iniciat-i", "(<I>ion</I>), [UV] Initiat/e, be the first to do or propose, begin, institute, instal, introduce, open, originate, set going (on foot), start, take the -ive. <I>~i agadon, eksperimenton, enketon, metodon</I>. <B>~o</B>, -ion, -ive, inception, introduction, start. <I>Manko de ~o,</I> want of push. <I>Laŭ propra ~o</I>, off one’s own bat. <I>Fari (preni) la ~on</I>. <B>~ema</B>, (<I>entreprenema</I>), with -ive, go-ahead. <B>~into</B>, -or, author, pioneer. ➞ <I>debut, entrepren, inaŭgur, inic, spont</I>.", "0"],
["injekti", "injekt-i", "(<I>-n</I>) [OA-8] (<I>enŝprucigi</I>), (med) (tech) Inject, force into, as by syringe. <I>~i morfinon</I>. <B>~a</B> <I>motoro</I>. <B>~(aĵ)o</B>, -ion. <I>Subhaŭta ~o</I>. <B>~ilo</B>, -or, squirt, syringe. ➞ <I>inokul</I>.", "0"],
["inkandeska", "inkandesk-a", "(<I>blankarda</I>), Incandescent, glowing with heat, white-hot. ~a <I>fadeno, korpo, lampo, lumo</I>. <B>~i</B>, be i., glow.", "0"],
["inklino", "inklin-o", "[UV] Inclin/ation. bent, bias, disposition, liking, partiality, penchant, propensity, taste, tendency. <I>~o al ribelo, virto, por muziko, studo</I>. <B>~i</B> (nt) (<I>al, por; -i), (havi, senti, ~on</I>). <B>~e</B>, be -ed (disposed). <I>~i ridi. Forte ~i</I>, have a good mind to. <B>~a</B>, -ed, apt, prone, ready (to). <B>~igi</B> (iun al, por), dispose, incline, induce, make willing, persuade (El 35/22). <B>~iĝi</B>, become -ed. <B>Antaŭ~o</B>, predilection, predisposition). <B>Kor~o</B> (<I>al</I>). affection, fondness, liking (for). ➞ <I>em, klin, simpati, tendenc, volont</I>. <B>Mal~o</B>, dis-ation, aversion, dislike, reluctance, repugnance. <B>Mal~a</B>, averse, hostile. ➞ <I>antipati, malem, malvol</I>.", "0"],
["inkludi", "inklud-i", "include, comprise, count (take) in, cover, embrace, (as part of whole). <I>La prezo ~as trinkaĵojn</I>. <B>~e</B> <I>de</I>, including. ➞ <I>implic, inkluziv, enkalkul, enten</I>. opposite <I>eksklud</I>.", "0"],
["inkluziva", "inkluziv-a", "[OA] (<I>inkluda</I>), Inclu/sive. <I>~e de</I>, -ding. <I>De Marto ĝis Majo</I> <B>~e</B>, (-sively). (1 Sa 18/4). <B>~i =</B> <I>inkludi</I>.", "0"],
["inko", "ink-o", "[UV] Ink. <I>~o anilina</I>; <I>blunigriĝa</I> (blueblack i.); <I>Ĉina</I> (Indian i.,); <I>kopia; marka; sekreta</I> (invisible ink). <B>Pres-o</B>, printers’ i. <B>~i</B>, (<I>-n</I>), ink. <B>~ilo</B>, <B>~cilindro</B>, -er, -ing ball (roller). <B>~ujo</B>, [UV] -pot, -well. ➞ <I>inokul, ruband, sorb</I>.", "0"],
["inkognito", "inkognit-o", "<B>[OA], ~e</B>, incognito, (person) concealed under disguised char, or with another name. <I>Vojaĝi ~e</I>. ➞ <I>anonim, kamufl, kaŝ, vual</I>.", "0"],
["inkrusti", "inkrust-i", "(<I>-n</I>), En-(In-)crust, in-(over -)lay, coat over, form a crust on, cake (with mud), fur (kettle). <I>~ita per argento</I>. <B>~aĵo</B>, -ation, crust, layer, scab. <I>~aĵoj de eburo, perlamoto</I>. ➞ <I>tenajl, imbrik, marketr, mozaik, niel</I>.", "0"],
["inkubacio", "inkubaci-o", "(<I>kovado</I>), Incub/ation, brooding, hatching. <I>~o artefarita</I>. (med) early phase of infection. <B>~ilo</B>, -ator.", "0"],
["inkubo", "inkub-o", "incubus <B>1</B> (myth). <B>2</B> (<I>premsonĝo</I>), nightmare: better <I>koŝmaro</I>. <B>f</B> person or thing oppressing the spirit like a nightmare: burden, dead weight.", "0"],
["inkunablo", "inkunabl-o", "incunable, book printed before 1500.", "0"],
["inkvarto", "inkvart-o", "(a. <I>kvarto</I>), (typ) quarto.", "0"],
["inkvizicio", "inkvizici-o", "<B>[OA]</B> (rc). Inquisit/ion, <B>~a</B>, -orial.", "0"],
["inkvizitoro", "inkvizitor-o", "[OA] inquisitor.", "0"],
["inokuli", "inokul-i", "(<I>-n</I>), [UV] inoculate (<I>per, kontraŭ), ~i hom</I><B><I>on</I></B>, <I>planton</I>. ➞ <I>greft, vakcin</I>. <B>f</B> implant, instil. <B>~i</B> <I>al iu kredon. principon, saĝon, senton</I>. <B>~aĵo</B>, serum. <B>~iĝi. ~ilo</B>. ➞ <I>infekt, inspir, komunik</I>.", "0"],
["insekto", "insekt-o", "[UV] Insect, <B>f</B> insignificant creature. <B>~aĵoj</B>, vermin, e.g., <I>pediko, pulo</I>. ➞ <B>fi~oj</B> (Ps 105/31). <B>~omanĝa</B>, -ivorous. <B>~icido</B> (<I>~mortigilo</I>).", "0"],
["inserti", "insert-i", "Insert, introduce, put (thrust) into, <B>~aĵo</B>, -ion. ➞ <I>aldon, enmet, enŝov</I>.", "0"],
["insibi", "insib-i", "(<I>iun, kontraŭ</I>, abs), [UV] lay a snare (lie in wait, set a trap) for, lurk, work secretly against. <B>f</B> <I>kontraŭ ies bonfamo, la virto de virino</I>. <B>~a</B>, insidious, crafty, secret, treacherous, subtle, underhand. <I>~a demando, kareso, malsano</I>. <B>~e</B>, by stealth. <B>~(aĵ)o</B>, ambush, plot, trap (Jos 8/4). <B>~anoj</B>, <B>~anto</B>j (Jos 8/19, 21). ~ejo, ambushment (Jos 8/9), ~ema, artful, crafty, cunning, intriguing, perfidious, sly, traitorous, underhand. ➞ <I>artifik, ĉikan, embusk, komplot, konspir, kapiil, ret</I>.", "0"],
["insigno", "insign-o", "(<I>distingosigno</I>), [UV] <B>1</B> Badge, emblem of dignity, authority, crest, medal, stripe, etc. <B>2</B> <B>~oj</B>, insignia, armorial beargs, coat of arms, paraphernalia of rank. <I>Reĝaj ~oj</I>. <B>3</B> (<I>rekonilo</I>), b., token of identification, membership, e.g., <I>la verda stelo</I>. ➞ <I>atribut, blazon, emblem, sign, simbol</I>.", "0"],
["insinui", "insinu-i", "insinuate, convey indirectly, hint obliquely, introduce gradually or subtly. <B>~o</B>, insinuation. ➞ <I>pensig, subdir, sugest</I>.", "0"],
["insisti", "insist-i", "(<I>nt) (ĉe iu, pri io</I>) <I>[OA],</I> insist. <B>1</B> (<I>forte aserti aŭ subteni</I>) demand (maintain) positively, dwell on, make a stand on as essential: <I>~i pri regulo</I>. <I>~i, ke io estas vera</I>. <B>2</B> (<I>forte peti</I>), apply pressure, press, urge: <I>~i pri lia veno (ke li venu</I>). <I>Ili ~is longe</I> (2 Rĝ 2/17). <B>3</B> (<I>forte decidi</I>): <I>~i iri</I>. <B>~(em)a</B> (decida, energia), insistent, earnest, emphatic, pressing. <I>~a peto</I>. <B>~(ad)o</B>, insistence. <I>Tedi per ~o</I>. <B>~adi</B> (El 5/13). <B>Sen~e</B>, casually, without rubbing it in. ➞ <I>akcent, devig, obstin, persist, prem, substrek, trud</I>.", "0"],
["inspekti", "inspekt-i", "(<I>-n</I>) [OA], Inspect, officialy examine (look closely into), review, scrutinize. <I>~i armeon, fabrikejon, funkciadon, lernejon</I>. <B>~(ad)o</B>, -ion. <B>~anto</B>, <B>~isto</B>, (<B>~oro</B> [OA]), -or (Da 1/11), overseer, shop-walker, surveyor, etc. <B>~istaro</B>, body of -ors. ➞ <I>ekzamen, kontrol, revizi, revu, superrigard</I>.", "0"],
["inspiri", "inspir-i", "(<I>-n, al, per</I>), [UV] Inspir/e. <B>1</B> lie behind, prompt, suggest: <I>~i artikolon, ideon, projekton</I>. <B>2</B> animate, infuse thought or feeling into, stimulate; <I>~i al iu amon, kuraĝon, respekton. Liaj vortoj ~is la kongreson</I>. <B>3</B> endow with supernatural insight, enlighten, illuminate: <B>~ita</B> <I>de Dio, de la muzoj. Min io el supre ~is. ~ita elokvento, libro, plumo, profeto. ~ita por harpoj</I> (1 Kr 25/1). <B>~a</B>, -ing. <B>~(itec)o</B>, inspiration, afflatus, divine influence. <I>~o de poeto, laŭvorta</I>. <B>~iĝi</B> (<I>de, per</I>) be -ed by, draw -ation from. ➞ <I>dikt, influ, instig, nask, sentig, suflor</I>.", "0"],
["instali", "instal-i", "(<I>-n</I>) <I>[OA],</I> Install, establish, introduce, place, set up (in office, position, for use) (1 Rĝ 12/29). <I>~i banon, elektron, firmon, maŝinon</I>; induct (pastron). <I>Sin ~i</I> (make one’s comfortable) <I>en brakseĝo</I>. <B>~(aĵ)o</B>, -ation, arrangement. <I>~aĵoj de fabrikejo, de hospitalo</I>. ➞ <I>aranĝ, enkonduk, establ, fond, inaŭgur, lok, starig</I>.", "0"],
["instanco", "instanc-o", "[OA] <B>1</B> instance, jurisdiction. <I>Tribunalo de unua ~o</I>, county court; <I>de la plej alta ~o</I>, High Court. <B>2</B> <I>= aŭtoritato decido-pova, juĝo-pova</I>, administrative body, official authty (with power of decision). <I>En la lasta ~o</I>, in the last resort. <I>[Ne= ekzempl, okaz]</I>.", "0"],
["instanto", "instant-o", "Instant, moment, precise point of time, \"twinkling of an eye\". <B>~a</B>, instant, -ancous, snap. <B>~e</B>, at once, in an instant, immediately, in a flash (jiffy, trice), in (less than) no time, presto, quick as lightning (thought), on the spur of the moment. ➞ <I>moment, subit, tuj</I>.", "0"],
["instepo", "instep-o", "instep.", "0"],
["instigi", "instig-i", "(<I>-n, al, por, kontraŭ</I>) [UV] (<I>inciti al ago</I>). Instigat/e, goad, impel, incite, move, rouse, spur, stir up, urge on (to) (1 Rĝ 21/25). ~i al batalo, laboro, ribelo. ~i ĉevalon per vipo, homon kontraŭ homo. <B>~a</B>, impelling. <B>~(ad)o</B>, -ion, prompting. ~o de konscienco. <B>~aĵo</B>, <B>~ilo</B>, goad, incentive, inducement, spur, stimulus. <B>Mal~i</B> (iun de ago) (deturni), dis-courage(-suade). <B>Pluv~o</B>, rain-making. ➞ admon, impuls, incit, infiu, inspir, pel, puŝ, spron, stimul, urĝ.", "0"],
["instinkto", "instinkt-o", "[OA] Instinct. <B>1</B> innate (natural) impulse or propensity. <I>~o de abelo, formiko, homo, tigro. ~o de migrado, sino, konservo</I>. <B>2</B> natural aptitude, intuition, unconscious skill. <I>~o por muziko. <B>~a</B></I>, -ive<I>, automatic. ~a movo</I>. ➞ <I>aŭtomat, impuls, intuici</I>.", "0"],
["institucio", "instituci-o", "[UV] institution. <B>1</B> establishing foundation, organization (for promotion of object.). <I>~o bonfara, jura, publika</I>. <B>2</B> building used by this. ➞ <I>institut, organiz</I>.", "0"],
["instituto", "institut-o", "[UV] = institucio arta, eduka, scienca &lt; edukejo. <B>1</B> Institute, academy, seminary. <B>2</B> Blding used by this. ~o blindula, muzika, scienca. <I>La Franca I~o</I>. <B>~estro</B>, principal. ➞ <I>instituci</I>.", "0"],
["instrui", "instru-i", "(<I>ion al iu, iun pri io, ke, kiel</I>) [UV]: Educat/e, Instruct, Teach. <I>~i gramatik-(infan-)on. La sperto -as. Mi -os al vi kanti (kion fari</I>). <B>~(ad)o</B>, t-ing, i-ion, counsel, tuition. <I>Aŭskult-(don -pren-profit-)i -on. Tio servu kiel -o; Prenu tion kiel -on</I>, let that be a lesson to you. <I>~oj de la vivo</I>. <B>~a</B>, -ive. <I>-a ekzempl-(rakont-)o. Ministro de Publika</I> <B>~ado</B>, Minister of E-ion. <B>~aĵo</B>, t-ing, doctrine, precept. <B>~ato</B>, pupil, scholar, <B>-ebla</B>, t-able, amenable to i-ion. <B>~ejo</B> (<I>&gt; instituto, lernejo</I>). <B>~iĝi</B>, acquire knowledge, learn. <B>~isto</B>, t-er, i-or, master, ment-(precept-tut-)or. ➞ <I>docent, lektor, profesor. La -ista profesio</I>. <B>~ita</B> (early writings) (<I>klera</I>), e-ed, erudite, learned, scholarly, <I>-iteca</I>, high-brow (2 FA 29/26). <B>~arto (</B><I>pedagogio</I><B>). Ĉef~isto</B>, headmaster, principal. <B>Sin~ita</B>, self-taught. <B>Ne~ita</B>, <B>Sen~a</B>, illiterate, une-ed, unlettered, untaught. <B>Pri~a</B>, pedagogic. ➞ <I>dres, eduk, guvern, inform, instrukci, klerig, lecion, lernig, pedagog, predik</I>.", "0"],
["instrukcio", "instrukci-o", "[UV] instructions, directions, orders (1 Rĝ 3/3, 4/28). <I>Laŭ -o,</I> as directed. <I>Doni, sekvi -on pri uzado</I>. give directions, orders. ➞ <I>direkt(iv), instru, komisi, ordon, preskrib</I>.", "0"],
["instrumento", "instrument-o", "[OA] Instrument. <B>1</B> (<I>ilo</I>), object. used in performg action., especially for delicate or scientific work, implement, tool. <I>~o optika</I>. <B>f</B> person so used. <B>2</B> (<I>muzika ~o</I>) <I>~oj [anĉaj, blovaj, kordaj, latunaj, lignaj, perkutaj</I> = with reeds, wind, strings, brass, wood-wind, percussion]. <I>~o mekanika</I>. <B>~a</B>, -al. <I>~a muziko</I>. <B>~isto</B>, -alist. <B>~faristo</B>, i-maker. ➞ <I>aparat, maŝin</I>.", "0"],
["insulino", "insulin-o", "insulin.", "0"],
["insulo", "insul-o", "[UV] Island, isle. <I>La ~o Man</I>. <B>f</B> anything detached or isolated. <B>~ano</B>, -er. <B>~aro</B> (<I>arĥipelago</I>), archipelago. <B>~eto</B>, islet, <B>-anima</B>, insular, narrow-minded. <B>Duon~o</B>, peninsular. <B>Trafik~o</B>, island.", "0"],
["insulti", "insult-i", "(<I>-n</I>) [UV] (<I>parolataki</I>), affront, attack with insulting words, be scornfully abusive, curse, call names, give a piece of one’s mind, inveigh against, mock (rail) at, revile, scold, taunt, upbraid. (2 Sa 16/5-13; 2 Rĝ 19/16, 22; Ps 22/7, 55/12; Ce 2/8). <I>Ŝia patrino ~is ŝin, (demandante) kial ŝi revenis tiel malfrue</I> (E 17). <I>~i la nomon de Dio. Ne rapidu ~i, volu aŭskulti</I>. <B>~(em)a</B>, abusive, insulting, scurrilous. <I>~aj paroloj</I>. <B>~e</B>, (Ij 16/10). <B>~(ad)o</B>, <B>~(aĵ)o</B>, abuse, invective, bad language (PI 3/61). <B>~ataĵo</B>, object. of scorn. <B>~egi</B>, swear at. <I>~egado</I>, tirade, series of invectives. <B>El~i</B> (H 98). <B>Mok~i</B> (Ij 11/3). ➞ <I>malhonor, mallaŭd, ofend, riproĉ</I>.", "0"],
["int", "-int", "[UV] ending of past participle active. <B>Forir~a</B>, departed. <I>Mi estas</I> <B>parol~a</B>, I have spoken. <B>Pek~o</B>, one who has sinned. <B>Dir~e</B> <I>tion, li …</I>, after saying (when he had said) that, he … <I>La</I> <B>est~eco</B>, the past.", "0"],
["intajlo", "intajl-o", "intaglio, intaille. <B>1</B> engraved design, carvg in hard metal. <B>2</B> gem with incised design. Opp <I>kame</I>.", "0"],
["integra", "integr-a", "integral, complete, whole. <B>~i</B>, integrate, make complete, or combine into a whole. <B>~ado</B>, integration. <B>~eco. Mal</B>~<B>i</B>, disintegrate.", "0"],
["integralo", "integral-o", "<B>~a</B>, (mat) integral. ➞ <I>entjer</I>.", "0"],
["intelekto", "intelekt-o", "[OA] Intellect; faculty of thought, brains, mind, reason. <B>~a</B> -ual, appealing to (marked by) i. <I>~a forto, kapablo. Malgranda aspekte, sed granda</I> <B>~e</B>. <B>~ismo</B>, -ualism. <B>~ulo</B> (<I>cerbulo</I>), -ual. ➞ <I>cerb, inteligent, mens, raci, spirit</I>.", "0"],
["inteligenta", "inteligent-a", "[OA] Intelligen/t, brainy, bright, quick, sharp, ”all there”, <I>~a lernanto</I>. <B>f</B> <I>~a respond, vizaĝo</I>. <B>~o</B>, -ce, sagacity. <B>~ulo</B>, i. person. <B>~ularo</B>, -tsia. <B>Mal~a</B>, dense, stupid. <B>Ne</B>~<B>a</B>, un-i, dull, obtuse. ➞ <I>prudent, sagac, saĝ</I>.", "0"],
["intenci", "intenc-i", "(<I>-n</I>), [UV] Inten/d, design, mean, plan, propose, purpose (El 2/14). <I>Mi -as iri. Nepre -i</I>, be set on. <B>~o</B>, -tion, aim, design, end, intent. <I>Havi, kaŝi -on</I>. <B>~(it)a</B>, -ed, -tional; done on purpose. <B>Ek~i</B>, think of doing (plan to do) something. <B>Bon~a</B>, well-disposed (-meaning). <B>Duon~i</B>, have half a mind to. <B>Malbon~o</B>, ill-will, malice. <B>Sen~a</B> (<I>nevolita</I>), unintentional, involuntary, undesigned, (jur) <I>Sen~a mortigo</I>, manslaughter. ➞ <I>cel, plan, projekt, proponi al si, vol</I>.", "0"],
["intendanto", "intendant-o", "[OA] person in charge, administrator, bailiff, curator, manager, steward. <B>Sub~o</B>, under-steward. <B>Super~o</B>, superintendent. <I>~o biena, doma, muzea</I>. ➞ <I>ekonom</I>.", "0"],
["intensa", "intens-a", "<B>[OA]</B> (<I>altgrada</I>), Intens/e, -ive (of action, emotion, quality); to a high degree, ardent, eager, energetic, vehement, vigorous, violent; deep (colour), heavy (gunfire), high (fever), severe (pain). <B><I>~a</I></B> <I>kultivo, laboro, lumo, propagando, varmo</I>. <B>~(ec)o</B>, -ity, force (of wind, etc.). <B>~igi</B>, -ify. <B>~iĝo</B>, increase of -ity. <B>Mal~a</B>, <B>Ne~a</B>, feeble, light, mild. ➞ <I>ard, energi, fort, vigl, viv</I>.", "0"],
["inter", "", "[UV] (prep) (<I>meze de</I>) (position in place or time). <B>1</B> Between, betwixt (two): <I>~ lulilo kaj tombo (mano kaj buŝo; martelo kaj amboso). Kuru ~ ilin. Distanco ~ A kaj B (= de A ĝis B). ~</I> 30 <I>kaj</I> 40. <I>Heziti ~ du devoj. Disting-(decid -divid-elekt-)i</I> <B>2</B> (inclusion), Among(st) (more than two): <I>Sidi ~ amikoj. ~ lupoj kriu lupe. Eĉ ~ piuloj ne mankas pekuloj</I>. <B>3</B> (relation): <I>Batalo ~ bono kaj malbono. Ligitaj ~ si. Kalkulo ~ ni</I>. <B>PFX</B>: <B>1</B> (position): ~doma <I>spaco. Skribi</I> <B>~linie. ~meti</B>, <B>~veni. -tempo</B>, interval. <B>~tempe</B>, meanwhile. <B>2</B> (inclusion): <B>~alie</B>, among other things. <B>3</B> (mutual or reciprocal relation): ~plekti <I>manojn</I>. ~ŝanĝi <I>ideojn. ~agi, batali, kompreni. ~konsenti</I>, agree together.", "0"],
["interdikti", "interdikt-i", "(jur) Interdict, <B>~o</B>, -ion, injunction, prohibition, restraint.", "0"],
["interesi", "interes-i", "(<I>-n</I>), [UV] Interest. <B>1</B> Being (appeal) to, awaken i. in, arrest attention, attract (excite) curiosity: <I>La historio tre ~is min</I> [Ne: interesigis]. <I>~i la publikon pri E-o</I>. <B>2</B> affect, concern: <I>Kiel tio ~as (tuŝas) min?</I> <B>~o</B>, <B>1</B> interest felt in (<I>~o de iu pri io</I>): <I>Havi, gajni, konservi, senti, veki ~on (pri</I>). <B>2</B> i. possessed by (<I>~o de io por iu</I>): attraction, <I>Tio estas sen ~o por mi</I>. <B>3</B> Advantage, profit, welfare: <I>En la ~o de</I>, in the i. of. <I>Zorgi pri sia propra ~o</I>, look after one’s own i. <I>Gardi (servi) la ~ojn de la lando. Ne ekzistas kareso sen ~o. Paroli el la koro, ne pro ~o</I> (on interested grounds), <B>4</B> share, stake; <I>Havi (posedi) ~on en entrepreno</I>. <B>~a</B> (al, por), interesting, of i., attractive. <I>~a persono, propono, romano</I>. <B>~aĵo</B>, object. of i. <B>~ata</B>, -ed, concerned, not impartial. <B>~ega</B>, absorbing, thrilling. <B>~igi</B>, make -ing. <I>~igi libron per ilustraĵoj</I>. <B>~iĝi</B> (sin ~i) (pri), feel (take) an i. (be -ed) in. <B>Mal~a</B>, <B>ne~a</B>, <B>sen~a</B>, dry, uninteresting; disinterested, un-ed. ➞ <I>absorb, interez, koncern, profit, tuŝ, util</I>.", "0"],
["interezo", "interez-o", "(rentumo), (fin) interest. <I>~o simpla, amasiĝa (kunmetita</I>). ➞ <I>invest, procent</I>.", "0"],
["interfero", "interfer-o", "(<I>interkruciĝo de radioj</I>) (opt) (ph) (rad), Interference. <B>~a</B>, interferential, of i. <I>~a franĝo, strio</I>. (ac) <I>~a ŝvelo (sonbato</I>), beat. <B>-ometro</B>, interferometer. ➞ <I>bat, fad, sin intermet</I>.", "0"],
["interjekcio", "interjekci-o", "[UV] (gram) interjection, ejaculate, e.g., <I>Fi! Ve! Dio donu!</I>", "0"],
["intermezo", "intermez-o", "(mus) intermezzo.", "0"],
["intermita", "intermit-a", "[UV] Intermi/ttent, irregular. <I>~a febro, lumo, pafado, pulso. ~a laboro,</I> casual labour. <I>Pluvi</I> <B>~e</B> (off and on). <B>~o</B>, intermission, momentary cessation (gap, pause). <I>Dum la ~oj de lia parolo</I>. <B>~i</B>, be i., occur intermittently, (mot) misfire. <I>La doloro ~is</I>, <B>~igi</B>, intermit, discontinue (stop, suspend) intermittently.", "0"],
["interna", "intern-a", "[UV] (<I>ena, malekstera</I>), Inter-ior, internal, Inside<B>.</B> <I>~a flanko, malsano, organo. ~a lando</I>, interior, hinterland. Boarding, living in, <I>~a studento</I>. Civil, <I>~a milito</I>. (pol) Home, <I>~aj Aferoj</I>. Inland, <I>~a maro</I>. i (<I>anima, escenca</I>): inner, inward; essential, fundamental, intrinsic, real. <I>~a ideo, forto, paco, sento, vivo. Plej ~a,</I> inmost. <B>~e</B>, inside, in the interior, within, indoors. <I>Putra ~e. ~e de la domo. Diri al si (ekridi, senti) ~e</I> (Ge 18/12). <I>Forto de (el) ~e</I>, from within. <B>~en</B>, inwards. <I>Iru ~en</I>, go inside, indoors. <B>~o</B>, i., i-ior. <I>~o de domo, lando</I>. <B>f</B> <I>La ~o</I> (bottom, innermost recesses) <I>de la koro</I>. <B>~aĵo</B>, entrails, viscera, <B>~igi 1</B> (<I>penetrigi</I>) insert, inculcate, thrust in. <B>2</B> confine, shut up. <B>~igejo</B>, concentration camp. <B>~iĝi</B> (<I>penetri</I>). <B>~ulo</B>, boarder, insider. <B>~ulejo</B>, school boarding-house, etc. ➞ <I>en, inter, profund</I>.", "0"],
["interpeli", "interpel-i", "(a. <B>interpelaci-i</B> [OA-8]), (pol) Interpell/ate. <B>~o</B>, -ation, interruption by demanding explanation. <B>~anto.</B> <I>Pasi</I> <B>sen~e</B>, without challenge. ➞ <I>hekl</I>.", "0"],
["interpoli", "interpol-i", "(<I>enŝovi</I>), Interpolat/e. <B>1</B> make insertions (introduce words) in book, etc., especially to give a false impression. <B>2</B> (mat) insert intermediate term in series. <B>~aĵo</B>, -ion. <B>~into</B>. ➞ <I>insert</I>.", "0"],
["interpozitivo", "interpozitiv-o", "a preposition preceded and followed by the same noun, e.g., <I>mano(n) en mano, paŝo(n) post paŝo</I>.", "0"],
["interpreti", "interpret-i", "(<I>-n</I>) [OA], Interpret. <B>1</B> Explain, expound, give (bring out) the meaning of. <I>~i la Fundamenton de Esperanto, leĝ</I><B><I>on</I></B>, <I>parol</I><B><I>on, s</I></B><I>onĝ</I><B><I>on</I></B>, <I>tekston</I>. <B>f</B> render (as an artiste). <I>~i poem</I><B><I>on</I></B>, <I>muzikon</I>. <B>2</B> act as -er, translate (from another language). <I>~i parolon</I>. <B>~ado</B>, -ation, rendering. <B>~anto</B>, <B>~isto</B>, -er, exponent, expositor. <B>Mis~i</B>, mis-i. ➞ <I>ekzegez, komentari, komprenig, traduk</I>.", "0"],
["interpunkcio", "interpunkci-o", "[UV] (<I>punktado</I>), Punctuat/ion. <I>~o Zamenhofa</I>. <B>~i</B>, -e, insert (divide by) stops, <B>f</B> interrupt with exclamations. <I>~a signo (punktilo</I><B>)</B>, <B>p-mark</B>.", "0"],
["interstico", "interstic-o", "(<I>interspaco</I>), intersti/ce, chink, cleft, crevice, intervening space, <B>~a</B>, -tial.", "0"],
["intervalo", "interval-o", "interval. <B>1</B> (mus) (<I>piĉ-diferenco): ~o simpla, kunmetita, invertita; disonanca, konsonanca; maĵora, minora, perfekta, pliigita</I>. <B>2</B> (<I>intertempo</I>), period of time. <B>3</B> (<I>interspaco</I><B>)</B>, distance, gap, space.", "0"],
["intervjui", "intervju-i", "(<I>iun</I>) [OA], Interview, meet face to face. <B>~o</B>, i. <B>~isto</B>, -er.", "0"],
["intesto", "intest-o", "[UV] Intestin/e, bowel, gut. <I>~o (mal)dika</I>, (small) large i. <B>~a</B>, -al, enteric. <I>~a bruo</I>, rumble. <I>~a vermo</I>. <B>~aro</B>, entrails, guts, tripe, viscera, ~<B>inflamo</B>, enteritis.", "0"],
["intima", "intim-a", "[UV] Intima/te. <B>1</B> bosom, close, familiar, heart-to-heart: <I>~a amiko, rilato</I>. <B>2</B> cosy, home-ly-like (➞ <I>famili, hejmec, inter ni, komfort, senceremoni, senĝen): ~a angulo, etoso, festo, parolo, rondo, vizito</I>. <B>3</B> deep-seated, inner, inmost, private (➞ <I>intern, nepublik, privat): ~a afero, penso, sento, taglibro, vivo</I>. <B>~(ec)o</B>, -cy. <I>Paroli ~e (en ~eco</I>). <B>~aĵo</B>, confidence. <B>~eca</B>, familiar, <B>~iĝi</B> (<I>kun</I>), become i., chum up. <B>~ulo</B>, i. (bosom, close) friend, confidant (Ij 19/19). <B>Ne~a</B>, distant. ➞ <I>komunsent, konfidenc, proksim</I>.", "0"],
["intoni", "inton-i", "(-n, abs), <B>1</B> Inton/e, recite in singing voice, especially (mus) chant more or less on one pitch. <I>~i preĝojn</I>. <B>~ado</B>, -ing. <B>2 ~ado</B>, -ation, modulation, ring (of voice).", "0"],
["intrigi", "intrig-i", "(<I>nt; kontraŭ, por -i</I>), [UV] Intrigu/e, (carry on underground) Plot, employ secret influence, scheme. <B>~o</B>, i., p. (lit) p. (of novel, play). <B>Am~o</B>, love affair. ~anto, <B>~ulo</B>, -er, schemer, wirepuller. ~ema, addicted to i. ➞ <I>kaŝag, kombin, komplot, ruz</I>.", "0"],
["introrsa", "intrors-a", "(<I>frontanta internen</I>) (bot) introrse. ➞ <I>ekstrors</I>.", "0"],
["introspekto", "introspekt-o", "(phi) Introspect/ion. <B>~i</B>, examine one’s own thoughts and feelings. <B>~a</B>, -ive.", "0"],
["introverta", "introvert-a", "(psy) introvert. <B>~o</B>, introversion. <B>~ulo</B>. i. Opp <I>ekstrovert</I>.", "0"],
["intu(ici)o", "intu(ici)-o", "Intuit/ion, immediate insight, apprehension without reasoning. <B>~a</B>, -ive, perceived by (possessing) -ion. <B>~e</B> (<I>per ~o</I>) -ively, by -ion. ➞ <I>diven, indukt, inspir, konsci, vizi</I>.", "0"],
["inulo", "inul-o", "(bot) elecampane, golden samphire, ploughman’s spikenard (<I>Inula</I>).", "0"],
["inundi", "inund-i", "(<I>-n</I>) <B>[OA]</B> (<I>superakveg, superver</I><B><I>ŝ</I></B>), Inundat/e, flood, overflow. <I>La rivero ~is la kampojn, siajn bordojn</I> (also figuratively). <B>~o</B> (<I>superbordiĝo</I>), -ion (Na 1/8). <B>~a</B> <I>justeco</I> (Jes 10/22). <B>~ego</B> (Da 9/26).", "0"],
["invadi", "invad-i", "(<I>-n</I>) [OA], Inva/de, make a hostile inroad into. <I>~i landon</I>. <B>f</B> overflow, overgrow, overrun) (<I>gastoj - domon; herbaĉoj - ĝardenon; ratoj - ŝipon</I>); assail, encroach upon (<I>rajtojn</I>). <B>~o</B>, invasion. <I>~o de akridoj</I>. <B>~anto</B>, <B>~ulo</B>, invader. ➞ <I>atak</I>.", "0"],
["invalido", "invalid-o", "[OA] disabled person (soldier, workman, etc.). <B>~a</B>, enfeebled or disabled by illness or injury, incapable of (unfit for) labour (service), infirm <I>[Ne= malsana, nevalida]</I>, ~a <I>pensio</I>, disability pension, <B>f</B> <I>~a</I> (rickety) <I>tablo</I>. <B>~aĵo</B>, defect, disability, infirmity. <I>Asekuro kontraŭ</I> <B>~eco. ~ejo</B>, <I>hospitalo (rifuĝejo) por ~oj</I>. ➞ <I>kaduk, kripl</I>.", "0"],
["inventaro", "inventar-o", "inventory, detailed list (of goods, etc.), stock-sheet. <B>~i</B> (<I>fari ~on</I>), enter (make an i. of) stock. ➞ <I>bilanc</I>.", "0"],
["inventi", "invent-i", "(<I>-n</I>) [OA-8] (<I>&lt; elpensi</I>), Invent; contrive, devise, originate (produce) by original thought). <I>~i instrumenton, maŝinon, metodon, procedon, vorton</I>. <B>f</B> coin (phrase), fabricate (make up) story. <B>~(aĵ)o</B>, -ion, device. <I>~o de pulvo. Utila ~aĵo</I>. <B>~ema</B> (<I>eltrovema, inĝenia</I>). inventive, resourceful. <B>~into</B>, <B>-or, designer</B>. <B>~opatento</B>, <B>(letters) patent</B>.", "0"],
["inversa", "invers-a", "[OA] = <I>en mala direkto, pozicio, rilato</I>. Reverse, contrary, opposite. <I>~a bildo, komo, ordo, pozicio, proporcio, senco, vortaro. ~a direkto</I>, opposite course, (log) Inverse, contrapositive. (mat) <I>~a funkcio</I>, inverse function. <B>~(ec)o</B>, revers (opposite state), vice versa. <B>~igi</B>, reverse (current, image, result), (sewing) turn inside out. <I>~igebla</I>, reversible. <I>~igilo</I>, r-ing lever, change-over switch, (el) <B>~iri</B>. draw (fall, step) back. ➞ <I>invert, kontraŭ, mal, renvers, retr, return</I>.", "0"],
["inversio", "inversi-o", "(gram) inversion, unusually word-order. <B>~i</B> (<I>fari ~on</I>).", "0"],
["invertazo", "", "(chem) invertase.", "0"],
["inverti", "invert-i", "(<I>-n</I>) (meti subon supreri), (mus) Inver/t, place root in upper pt., turn upside down. ~i <I>akordon, intervalon, pedalon</I>. <B>~o</B>, -sion. La dua ~o de triado ( ~~ la tria aŭ „c“ pozieio) estas 6/4-akordo. <B>~ita</B>, -ted. Sesto estas ~ita trito. ~ita pedalo (=persista noto en voĉo alia ol la baso). <B>~ebla</B>, -tible. ~ebla kontrapunkto <B>II</B> (chem) ~ita sukero, i. sugar, (typ) ~ita komo.", "0"],
["investi", "invest-i", "(<I>-n</I>), Invest. <B>1</B> (fin) employ at interest, put money into (stock, etc.). <I>~i kapitalon (en</I>), (col) <I>~i en</I> lay out money on. <B>~o</B>, -ment, <I>~o profita, riska, ruiniga</I>. <B>~aĵoj</B>, -ments. <B>~anto</B>, shareholder, etc. <B>2</B> (enoficigi): <I>~i ambasadoron, episkopon</I>. <B>3</B> endow (with authty, dignity, power, rank). <B>~o</B>, -iture, induction.", "0"],
["inviti", "invit-i", "(<I>-n, -i, al</I>) [OA], Invit/e, politely ask(request). <B>1</B> to attend, (visit), <I>~i iun al kunveno, veni, en sian hejmon</I>. <B>2</B> (to act): <I>~i iun manĝi, prelegi, veni</I>. <B>3</B> (to give): solicit: <I>~i konfidon, opinion, sugeston. f (logi</I>) allure, attract, tempt: <I>Beta vetero ~as al promeno. ~i katastrofon</I>, court disaster. <B>~o</B>, -ation. <I>Akcepti, fari ~on</I>. (cgm), lead. <B>~a</B>, -ing, attractive, engaging, winning. <B>~iĝis</B> 300, <I>sed venis nur</I> 30. <B>~ilo</B>, (card of) -ation. <I>~a karto, letero</I>. <B>~into</B>, convener, host. <B>~ito</B>, guest. <I>Ne~ito</I>, gate-crasher. <I>~itaro</I>, company. <B>~kunveno</B>, reception. <B>Mal~i</B>, call off, cancel, withdraw. <B>Ne~a</B>, un-ing. <B>Sen~e</B>, un-ed. <B>Batal~o</B>, challenge, defiance.", "0"],
["involukro", "involukr-o", "(bot) involucre, bracts round inflorescence.", "0"],
["io", "", "[UV] (<I>iu afero</I>), a certain thing, something (or other). <I>Mi havas ~n por vi. Pli bona ol nenio. Diversaj ioj. Ĉu</I> ~ (anything, aught) <I>mankas?</I> <B>~ ajn</B>, anything whatever. ~ <B>alia</B>, anything (something) else. ➞ <I>iom</I>.", "0"],
["iom", "", "[UV] (<I>iukvante</I>): a certain amount, a little (some) of. <I>~ da salo(tempo). ~ de tiu salo (grado</I>): a little, rather, somewhat, to some extent. <I>~ laea, Mi ~ komprenis vian leteron. Mi ~ kredas</I> (I rather think), <I>ke ... ~ post</I> bit by bit, by degrees, gently, gradually, little by little, pro- gressive, step by step. <I>~post~a</I>, gradual. <B>~a ( = ~</B> <I>da) progreso. ~ ajn</I>, any at all. <B>~eto (~ete)</B> <I>da</I>, a very little, a particle, pinch, touch, trace (Ij <B>26/14)</B>. <I>Nur ~ete!</I> ➞ <I>kelk, part</I>.", "0"],
["ionia", "ioni-a", "(modalo), (mus) Ionian mode (naskis la modernan majoron).", "0"],
["io, iisto", "-io, -iisto", ". If a noun root ends with <I>-grafio, -katio, -manio, -nomio, -patio, -zonio, -iisto</I> can usually be abbreviated to <I>-o</I>. E.g., <I>astronom(iist)o, diplomat(iist)o</I>. Sometimes, however, -io = technique, use of. E.g., <I>stetoskop-io, from</I> the object. <I>stetoskopo</I>. <B>Rim</B>.: Vb rts (<I>fotograf-i, stenograf-i</I>) are in a different class, and form <I>-isto</I>. If <I>Ekonomiisto</I> cannot be reduced to <I>ekonomo</I>, which has a different meaning.", "0"],
["ipekakuano", "ipekakuan-o", "ipecacuanha. <B>1</B> the plant (<I>Cephaelis i.) 2</I> (pharm) preparation from its root.", "0"],
["iperito", "iperit-o", "(mustarda gaso), mustard gas.", "0"],
["ipomeo", "ipome-o", "moon-flower, morning glory (<I>Ipomoea</I>).", "0"],
["ipsilono", "ipsilon-o", "(<I>i-greka</I>), <B>1</B> letter of Gk alphabet. <B>2</B> the letter „y“.", "0"],
["Irako", "Irak-o", "[OA-8] IQ.", "0"],
["Irano", "Iran-o", "[OA-8] IR.", "0"],
["iredentismo", "iredent-ismo", "<B>~isto</B>, irredent-ism, -ist.", "0"],
["iri", "ir-i", "[UV] go. <B>1</B> (in gen): journey, proceed, travel. ~i <I>piede, ŝipe</I>; <I>rapide; sian vojon; sur la strato; tien-reen</I>. <B>2</B> (to definite place): <I>~i de A ĝis B; en la liton; hejmen. Tiu letero ~os al Usono</I>. <B>~onta</B> <I>al</I>, bound for. <B>3</B> (attend, visit): <I>~i en lernejon, preĝejon; al Diservo, kongreso, sia morto</I>. <B>4</B> (extend, reach): <I>la muro, vojo</I> <B>~as</B> <I>al (ĝis) X</I>. <B>5</B> (depart): <I>~u dormi; en paco; kun Dio</I>. <B>6</B> (work) (<I>funkcii</I>): <I>la horloĝo ne ~as: ĝi haltis</I>. <B>7</B> (get on, progress): <I>La afero, entrepreno, negoco bone ~as. Ĉio ~as glate</I>. <B>~(ad)o</B>, going, course, progress, <I>Bileto por ~o kaj reveno. ~ado de afero ma<B>ŝ</B>ino</I>. (chs) move. <B>~adi</B> (Ge 3/14, 5/22). <B>~antaro</B>, procession. <B>~ebla</B> (passable) vojo. <B>Ne~ebla</B>. <B>Ŝip~ebla</B>, navigable. <B>~ejo</B>, path, route, way (Se 7/25). <B>Sen~eja</B>, pathless (<I>vojo</I>, <B>f</B> <I>situacio</I>). <B>~enda</B>, that must be taken. <B>~igi</B>, cause to go, drive, move, propel, send. ~~i <I>horloĝon, veturilon</I>. <B>~ilo</B>, [UV] <B>~stango</B> (<I>stilzo</I>), stilt. <B>~maniero</B>, gait. <B>Al~i</B>, approach. <B>~~ebla</B>, accessible, approachable. <I>Ne~~ebla. ~~ejo</I>, approach, entrance, gateway. <B>Antaŭ~i</B>, advance, go ahead. <B>ĉirkaŭ~i</B>, [UV] <B>rond~i</B>, go round, circle, circulate, revolve, rotate. <I>De~i (de</I>) (Jĝ 4/15), go <I>from</I>, depart, leave, quit, get off. dis~i, [UV] separate. <B>Ek~i</B> (make a) start, set off, put in motion. <B>El~i</B>, go out, leave, <I>El~o</I>, escape, exit. (Bb) Exodus. <I>~~ejo</I>, exit, orifice, outlet, vent, way out. <I>Sav~~ejo</I>, emergency (safety) exit. <I>Sen~~ejo</I>, blind alley, cul de sac, impasse (➞ <I>dilem</I>). <B>Ne~~ebla</B>, with no way out. <B>En~i</B>, enter. <I>~~i cerbon, ĉambron. Trud~~i</I>, force one’s way in. (mus) <I>~~a signo</I>, entry sign (in a round). <B>~~o</B>, entrance, entry. <I>~~ejo</I>, entrance, inlet, loop-hole, way in. <B>For~i</B>, depart, go away, leave. <I>~~igi</I>, dispel, send away. <B>Ĝis~i</B>, reach (➞ <I>ating</I>). <B>Kun~i</B>, go together. <B>Laŭ~i</B> (<I>sekvi</I>), go along (down), coast, follow, skirt, traverse. <I>~~i riveron, vojon. Ne~~ebla,</I> impassable. <B>Post~i</B>, follow, succeed. <B>Preter~i</B>, pass by (Ij 9/11). <I>~~anto</I>, passer-by, (Ps 129/8, Mi 2/8). <I>~~ejo</I>, by-pass. <B>Re~i</B>, go back or again, return. <B>Retro~i</B>, draw (fall) back, move backwards, recoil, retreat. <B>Sub~i</B>, go under, set, sink. <B>Tra~i</B>, pass through, pierce, traverse. <I>~~ejo</I>, passage, thoroughfare. <B>Trans~i</B>, go across, cross, pass over. <I>~~ejo</I>, crossing, passage. <I>~~igi,</I> transfer. <B>Anas~i</B> (4 FA 93/35), waddle. <B>ĉiel~o</B>, [UV] ascension. <B>Flanken~i</B>, turn aside, swerve. <B>Pied~i</B>, go on foot, walk. <I>~~ado</I>, pedestrianism. <I>~~a, ~~anto,</I> pedestrian. <B>Malsupren~i</B> (<I>descendi, sobi</I>), descend. <B>Milit~o</B>, campaign, expedition. <B>Rapid~e</B>, by express. <B>Supren~i</B> (<I>ascendi, sori</I>) ascend, climb, go up, rise. <B>Voj-i</B>, be on the road. <I>~~anto,</I> wayfarer. <I>De~~iri</I>, go astray. <B>Zigzag~o</B>, (mar) course, tacking. ➞ <I>marŝ, migr, pas, paŝ, vetur, vojaĝ</I>.", "0"],
["iridio", "iridi-o", "(chem) iridium (Ir).", "0"],
["irido", "irid-o", "[OA] (bot) Iris, flag (<I>Iris). Flava ~o,</I> yellow i. <I>Haladza ~o</I>, stinking i., roast-beef plant. ~a <I>radiko</I>, orris r. ~acoj, iridaceae.", "0"],
["irigaci", "irigac-i", "(<I>-n</I>), Irrigat/e, flood, spray. <I>~i kampon, dezerton</I>. <B>~o</B>, -ion. <B>~a</B> <I>kanalo</I>. <B>~ilo</B><I>, -or</I>, water-cart, douche, hose, etc.", "0"],
["iriso", "iris-o", "[OA] (anat) iris, (phot) <B>~a</B> <I>diafragmo,</I> i. diaphragm. <B>~ito</B>, iritis.", "0"],
["iriti", "irit-i", "(<I>-n</I>), Irritat/e; annoy, bait, get on one’s nerves, provoke, tease. <B>~ado</B>, <B>~iĝo</B>, -ion. ➞ <I>agar, ĝen, incit, inflam, koleretig, piket</I>.", "0"],
["iriza", "iriz-a", "Iridescen/t, rainbow-colored. <I>~aj nuboj</I>. <B>~i</B>, reflect r-colours, make i. <B>~eco</B>, -ce.", "0"],
["Irlando", "Irland-o", "[OA-8] IE.", "0"],
["ironio", "ironi-o", "[OA] (rh) Iron/y, meaning opposite to what is said. (1 Rĝ 22/15; Am 4/4; Lu 13/33). ~o <I>de la sorto</I>. <B>~a</B>, -ical. <I>~a laŭdo</I>. <B>~i</B>, speak -ically, with one’s tongue in one’s cheek. ➞ <I>sarkasmo (= ~o doloriga, kritika, pika, moka</I>) (Ij 12/2); <I>cinik, mok, pik</I>.", "0"],
["is", "-is", "[UV] ending of past tense. Est~, was, were. <I>Li kur~</I>, he ran, has run, was running. <I>Mi vid~, ke li kur~</I>, I saw that he had run. <B>~formo</B>, (gram) ~tempo (preterite), past tense, <B>~eco</B> (<I>pasinteco</I>), the past,", "0"],
["iskio", "iski-o", "(anat) ischium, <B>~a</B>, (i)sc(h)iatic, of the hip. <I>~a doloro</I>, sciatica. <I>~a nervo</I>.", "0"],
["Islando", "Island-o", "[OA-8] IS.", "0"],
["ism", "-ism", "(sfx, officialed 1914): <B>1</B> doctrine, movement, principle, system, teaching: Ideal~o, imperi~o, komun~o, nud~o, real~o. <B>2</B> School of thought: despot~o, kvaker~o, stoik~o, Budh~o, Darvin~o, Platon~o, Ŝtalin~o. <B>3</B> Peculiarity of speech (dialect, idiom): Angl~o, Latinismo (Better: ~aĵo). <B>4</B> Morbid propensity: Alkohol~o, morfin~o, nikotin~o, <B>~o</B>, an ism, doctrine, movement, etc. ➞ <I>ec, ist</I>. <B>Rim.:</B> Usually <I>-ism</I> and <I>-ist</I> run in pairs: e.g., <I>absolut-ismo, -isto</I>. Sometimes however they are not affixes, but part of the root., e.g., in altruismo, optimismo, sofismo, turismo, -isto; <I>altru.</I> . . are not Esperanto roots.", "0"],
["iso", "is-o", "(<I>dieso</I>), (mus) Sharp. F-is, F sharp. Isiso, double s. <B>~igi</B>, -en, raise a semitone. <I>Unua tonalo</I> <B>~flanka</B>, first-s. key. <B>~gamoj</B>, <B>~tonaloj</B>, s. keys. <I>Tonalo</I> <B>du~a</B>, key with two sharps (D, B min). Opp <I>be(mol</I>).", "0"],
["Israelo", "Israel-o", "[OA-9] IL, Israel.", "0"],
["ist", "-ist", "[UV] (sfx). <B>1</B> person concerned (connected) with, engaged (employed) in, the subject denotes by the root; whether (and usually) by profession (business, calling, vocation), or by habitual or frequent occupation or interest (= English <I>-ist, -er, -ian, -man, -or,</I> in this sense). Flor~o, instru~o, muzik~o, afer~o, mar~o, florist, teacher, musician, business-man, sailor. <B>2</B> (<I>-ismano</I>), adherent (adept, advocate, partisan, supporter, votary) of person or creed. See <I>-ism</I> above. <B>Rim</B>.: A root that itself denotes a person, e.g., <I>doktor, kvaker, lake, profesor</I>, is not followed by <I>-isto</I>, as this word be pleonastic. ➞ <I>adept, an, ant, partian, ill</I>.", "0"],
["istmo", "istm-o", "[OA] (<I>terkolo</I>), isthmus. <I>~o de Suez</I>, <B>f</B> (anat) (bot) (zoo) narrow part connecting two larger parts.", "0"],
["it", "-it", "[UV] ending of past passive participle = -ed<I>, -t, -en</I>. <B>Ben~a</B>, blessed, blest; <B>skrib~a</B>, written; <B>Kapt~o</B>, captive. <B>Dir~e</B>, <B>far~e!</B> No sooner said than done! <B>Dir~aĵo</B>, what has been said. ➞ <I>-at</I>.", "0"],
["it", "-it", "(chem sfx), -ite, denotes -ous acids and their salts. <B>Nitr~a</B> <B><I>acido</I></B>, nitrous acid. <B>Nitr~o</B>, nitrite. similar sulf<B>~a</B>, ~o.", "0"],
["it", "-it", "(med sfx) = <I>organa inflamo</I>. Apendic~o, artr~o, bronk~o, ~inflamo,", "0"],
["it", "-it", "(min) ending with various applications (commercial product): ebonito. (explosive): dinamito. (fossil organism): belemnito. (mineral): antracito.", "0"],
["italo", "ital-o", "[OA-8]. <B>~a</B> <I>opero, pico</I>. <B>Ital-ujo, Ital-io</B> IT.", "0"],
["iterbio", "iterbi-o", "(chem) Ytterbium (Yb).", "0"],
["itrio", "itri-o", "(chem) Ytrium (Yt).", "0"],
["iu", "", "[UV] a certain (individual) one (person or thing). Someone. <B>1</B> (pron) someone (or other). <I>~ alia</I> (El 4/13), someone else. <I>~ vokis</I>, someone called. <I>Ĉu ~ vokis?</I> Did any one call? ~j, c. (some) people. <B>2</B> (adj) some, a certain (Ij 1/1); some (or other). <I>Mi legis tion en ~ libro. ~ amiko mia</I>, one of my friends. ~ ajn, any (one) whatever. ~foje, at times, sometimes, occasionally, now and then. ➞ <I>ia, unu</I>. <B>Rim</B>.: <B>Iu</B> denotes indivuality, <B>ia</B>, quality.", "0"],
["iv", "-iv", "(tech sfx) (<B>-</B><I>ipova, kapabla</I> <B>-</B><I>i</I>) <B>=</B> which can (is able to) do the action denotes by the root. <B>Parol~a</B> (<I>parolpova</I>), able (having the power) to speak. <B>Brul~a</B>, combustible. <B>Elvok~a</B>, evocative. <B>Pag~a</B>, solvent. <B>Sent~a</B>, sentient. <B>Solstar~a</B>, able to stand alone. <B>Konduk~eco</B>, <B>produkt~eco</B>, conductivity, productivity.", "0"],
["iz", "-iz", "(<I>provizi per</I>), (tech. Sfx) = -ize, denotes tech. application. <B>1</B> (of substance or obj). (a) Provide with: Dent~i <I>buŝon;</I> plum~i <I>sagon;</I> ring~i <I>barelon</I>. (b) (<I>-ozigi per -o</I>). Fill (impregnate) with: Fum~i <I>ĉambr</I><B><I>on</I></B>, <I>haringon</I>. Kalk~i <I>grundon</I>, suker~i <I>paston</I>. (c) Cover with: Glu~i (gum) <I>paperon</I>. <B>Or~o</B>, gilt, (d) Bring under the influence of: <B>Elektr~i</B>, <B>hipnot~i</B>, <B>radi</B>~i. <B>2</B> Process named after its author. Galvan-izi, makadam-izi. ➞ <I>garn, proviz, ŝmir, teg</I>. <B>Rim</B>.: In ordinary language prefer the simple form without <I>-iz:</I> buteri panon; kalki muron; pipri (sali) supon; sukeri teon.", "0"],
["izatido", "izatid-o", "(bot) woad (<I>Isatis</I>).", "0"],
["izo", "izo-", "(Gk pfx) iso- (wide sense), <B>1</B> (= <I>egal-, sam-</I>). <B>2</B> (ph). <B>~baro</B>, -bar. <B>~cela</B>, -sceles. <B>~kromata</B>, -chromatic. <B>~mero</B>, -mere. <B>~metra</B>, -metric. <B>~morfa</B>, -morphous. <B>~podo</B>, -pod. <B>~termo</B>, -therm. <B>~topo</B>, -tope. <B>~tropa</B>, -tropic.", "0"],
["izoeto", "izoet-o", "(bot) quillwort (<I>Isoetes</I>).", "0"],
["izoli", "izol-i", "(<I>-n</I>), [UV] <B>1</B> Isolat/e, cut off, detach, dissociate, seclude, separate; maroon, quarantine; (chem) free from combinations: <I>~i fenomen</I><B><I>on</I></B>, <I>land</I><B><I>on</I></B>, <I>radi</I><B><I>on</I></B>, <I>malsanulon</I>. <B>~e</B>, apart, singly. <B>~eco</B>, -ion, seclusion, separation, solitude. <B>~eca, ~ita</B> (<I>soleca, solula</I>); -ed. lonely, retired, secluded; solitary, detached (house), remote (spot). <I>~a frazo, punkto, nubo</I>. <B>~ejo</B>, -ion ward; desert, desolate place (Ij 3/14); place of solitude, retreat. <B>~iĝi</B>, be -ed. ➞ <I>detranĉ, internig, kvarenten</I>. <B>2</B> Insulat/e (<I>pri elektro, sono, varmo</I>, etc.): <B>~a</B>, -ing, non-conducting. <I>~a bendo</I>, -ing tape. <I>~a botelo (termoso</I>), vacuum flask. <B>~aĵo, ~eco</B>, -ion. <B>~ilo</B>, -or. <B>Son~ita</B>, sound-proof. <B>~difekto</B>, -ion fault. <B>~povo</B>, -ing property.", "0"],
["j", "-j", "[UV] plural ending. <I>tiuj bluaj paĝoj</I>, those blue pages.", "0"],
["ja", "", "[UV] (adv) (strengthens an assertion, sometimes <I>= ĉu ne?</I>), assuredly, indeed, in fact, really and truly, to be sure. Den. 1 emphasis, insistce: I TELL you, yes! <I>~ vere</I>, that IS so. <I>Mi ~ iros</I>, I SHALL go. <I>Vi ~ scias</I>, you know very well (of course) (Ps 10/14, 44/21; Ge 4/7, 1 Sa 25/17). <B>2</B> expostulation, remonstrance: <I>Tio ~ estas vera</I>, indeed it IS true (whatever you may think to the contrary). <I>Mi ~ povas tion fari</I>, I CAN do that. <I>Mi ~ skribas</I>, Don’t you see that I AM writing? <I>Mi ~ diris tion</I>, I SAID that, I TOLD you so. <I>Li ~ estas edzo</I>, he is actually married, you see (Ps 55/12, Rd 32/31, Mi 3/1). <B>3</B> (although, I grant you) that is so (but, nevertheless): <I>Li ~ estas kulpa, tamen li estas nur infano</I>. ➞ <I>efektiv, nepr, sendub</I>.", "0"],
["jabiruo", "jabiru-o", "(orn) jabiru (<I>Jabiru</I>).", "0"],
["jaborando", "jaborand-o", "(bot, pharm) jaborandi.", "0"],
["jacinto", "jacint-o", "(min) jacinth (or hyacinth), vrty of zircon (Ap 21/20). <B>Rim</B>.: Ĉe EI 28/18, <I>hiacinto</I>. ➞ <I>hiacint</I>.", "0"],
["jado", "jad-o", "(min) jade, various green mineral substances.", "0"],
["jaguaro", "jaguar-o", "[OA] jaguar (<I>Panthera onca</I>).", "0"],
["jakano", "jakan-o", "<B>(<I>orn) jacana</I></B>.", "0"],
["jakarando", "jakarand-o", "jacaranda (tree) (<I>Jacaranda</I>).", "0"],
["jako", "jak-o", "[UV] (man’s short) Coat, Jacket, tunic. <B>Leda ~o</B>, jerkin. <B>Marista ~o</B>, pea-j, pilot’s c. P<B>erforta ~o</B>, strait-j. <B>Sav~o</B>, life-j. <B>~eto</B>, small c., Eton jacket. <I>~eto kelnera</I>. ➞ <I>ĵaket, ĵerz</I>.", "0"],
["jakto", "jakt-o", "(a. <B><I>jaĥto</I></B><I>), (promena ŝipo</I>), Yacht. <I>~a promeno</I>, -ing cruise.", "0"],
["jalapo", "jalap-o", "(pharm) jalap, drug from root of <B>~ujo</B> (<I>Exogonium purga</I>).", "0"],
["jam", "", "[UV] (adv) Already, by now, by then. Den. change, ff ➞ <I>ankoraŭ</I>, denotes no change. <I>Li ~ manĝas</I>=he (was not, but now) is a. eating. <I>Li ~ est-is-ias-os) tie</I>, he was (is, will be) there a. <I>~ dirite</I>, aforesaid. <I>~ de longe</I>, for a long time past. <I>Mi ~ devas iri</I>, It is now time (the time has now come) for me to go. <I>~ en</I> 1914, as far back as 1914. <B>~a</B>, a. achieved (existing). <B>Rim</B>.: Jam ne, denotes cessation of action or state; no longer. <I>Li j.n. manĝas</I> = He (was eating, but now) has a. left off (stopped) eating (has ceased to eat). <I>Li j.n. manĝis</I> = he had been eating, but had a. left off eating. IT ➞ ne plu, denotes non-repetition of an action: it did (does, will) not occur again (any more). Neniam plu, never more (again). <B>Rim</B>.: Place <I>jam</I> before the negative word. <B>Rim</B>.: Instead of <I>ne jam</I>, use <I>ankoraŭ ne</I>.", "0"],
["Jamajko", "Jamajk-o", "JM.", "0"],
["jambo", "jamb-o", "(pros) jam/bus (u-). <B>~a</B>, -ic.", "0"],
["jamboso", "jambos-o", "(bot) rose-apple. <B>~arbo</B>, r-a. tree (<I>Jambosa</I>).", "0"],
["Januaro", "Januar-o", "January.", "0"],
["Japanujo, Japanio", "Japan-ujo, Japanio", "[OA-9] JP.", "0"],
["jardo", "jard-o", "Yard. <B>1</B> (metr) (3 ft). <I>Kuba ~o</I>, cubic y. <B>2</B> (<I>velstango</I>), (mar) y., spar. <I>~o antaŭa, meza, posta</I>. <B>Bram~o</B>, topgallant y. <B>Reĝ~o</B>, royal y. <B>Top~o</B>, topsail y. <B>Al~(ig)i</B> (clew up) <I>velon</I>. <B>~~ilo</B>, gasket.", "0"],
["jaro", "jar-o", "[UV] Year annual course. <I>La ~o</I> 1966. <I>Havi du ~ojn (esti du~a). Kiom da ~oj vi havas (Kiom~a vi estas)? ~o kalendar-(sider-)a</I>. f <I>Pagas maljunaj ~oj por junaj eraroj. En la tridekaj ~oj</I>, in the 30’s (4 FA 128/25). ~aga, one y. old, -ling. ~cento, century. ~deko, decade. Cent<B>~ulo</B>, centenarian. <I>Cent~a festo (dat-reveno</I>), centenary. ĉi~(Nun~)a<SUB>v</SUB> of the present y. <B>Ĉiu~a</B>, annual. <I>Ĉiudu~a,</I> biennial. <B>Duon~o</B> (~duono), half a y. <B>Laŭ~e</B>, by the y. <B>Mult~a</B>, aged. <B>Nov~o</B>, New Y. <I>~~a nokto</I>, N-Y’s eve (4 FA 106/ <I>16</I>). <B>Plur~a</B>, (bot) perennial. <B>super~o</B>, [UV] leap-y. <B>Unua~a</B>, of the first y.", "0"],
["jasmeno", "jasmen-o", "[UV] jasmine, jessamine (<I>Jasminium</I>). ➞ <I>filadelf, siring</I>.", "0"],
["jaso", "jas-o", "(ent) leaf-hopper (<I>Jassus</I>).", "0"],
["jaspo", "jasp-o", "jasper, vrty of quartz, (a. <I>jaspiso</I>, El 28/18, Ap 21/19).", "0"],
["jatagano", "jatagan-o", "yataghan, Turkish curved sabre without guard or cross-piece.", "0"],
["jaziono", "jazion-o", "(bot) sheep’s bit (<I>Jasione</I>).", "0"],
["je", "", "[UV] (prep) = as regards, in relation to: replaces the accusative to denote any prepositnal relation implied by the context. Mi manĝas ~ pomo, I am eating of (nibbling at) an apple, mi manĝas pomon. <B>Rim</B>.: This vagueness makes it useful when no other preposition seems certainly to meet the case. Mi kredas <I>~ al? pri?</I>) Dio, I believe in God. Sopiri <I>~ (al? por?</I>) feliĉo = sopiri feliĉon. Lament! ~ (<I>pri? pro?</I>) perdo =l amenti perdon. Ridi ~ (<I>al? kontraŭ? pri? pro?</I>) li. ➞ (pri)ridi lin, deride him. Used especially to denotes time of day. ~ kioma horo vi venos? <I>~ la dua</I>. <B>Rim</B>.: Better avoid <I>je</I> when a more precise preposition is available. Its overuse marks the beginner. <I>Akcepto ~ (al) la kongreso. Simili ~ (al) la patro. Vizito ~ (al) Parizo. Konsenti ~ (al, kun, pri) io (iu). Kapti ~ (ĉe) la gorĝo. Morti ~ (de) febro. Plena (proksime) ~ (de). Konduki ~ (per) la mano. Amikiĝi ~ (kun). Pagi ~ (po) tri frankoj. Ĝoji ~ (pri) novajo</I>.", "0"],
["jejuno", "jejun-o", "(anat) jejunum, pt of small intestine.", "0"],
["jelpi", "jelp-i", "(<I>bojeti, plorboji</I>), yelp.", "0"],
["Jemeno", "Jemen-o", "YE.", "0"],
["jen", "", "[UV] (interjection.) (to call attention), Behold! Lo! Look! See! Here! There! <I>~ mi (estas)!</I> Here I am! <I>~ vi havas!</I> Here’s a pretty kettle of fish! ~<B> <I>kion</I></B> (this is what) <B><I>mi faros. ~ kial</I></B>, that (this) is why. <B>..</B>. at one time ..., at another; sometimes..., sometimes; now . .. now (both things true, but alternatevily).<B> <I>Paroli ~ Germane, ~ France. Li parolas ~ al mi, ~ al ŝi</I></B>. <B>~a</B>, the following (2 Rĝ 5/18). <B>~e</B>, as follows, thus (Ge 23/3, 8; El 15/1). <B>~o</B>, the following, what follows (Jĝ 11/37, El 16/12; 2 Sa 14/3).", "0"],
["jeno", "jen-o", "(num) yen, Japanese coin.", "0"],
["jes", "", "[UV] (interjection), Yes, yea (in reply to question) (Mt 5/37). Den. agreement, approval (opposite <I>ne). Ho</I> ~, oh yes! <I>Mi kredas, ke</I> I believe so. <I>Vi ne konas lin, sed mi</I> ~ (but I do). <I>Vi dubas? Sed</I> but it is so, but he did, (etc., according to context). <I>Diri ~i, ~diri</I>, say yes, assent, consent. <I>Ĉu</I> ~? Do you agree? Is that so? <B>~a</B> (affirmative) <I>respondo. Respondi</I> <B>~e</B>, in the affirmative. <B>~igi</B> [UV] (<I>konfirmi</I>), confirm. <B>Kap~i</B>, nod assent. ➞ <I>certig, ja, konsent</I>.", "0"],
["jeto", "jet-o", "(av) jet propelled aircraft.", "0"],
["jezuito,", "jezuit-o,", "[OA] Jesuit. <B>~a</B>, -ical. <B>f</B> practising equivocation or mental reservation of truth, specious.", "0"],
["jida", "jid-a", "(<I>judgermana</I>), Yiddish (language).", "0"],
["jingo", "jing-o", "(<I>koltordulo</I>), (orn) wryneck (<I>Jynx</I>).", "0"],
["Jo", "J-o", "[F], Letter J.", "0"],
["jodli", "jodl-i", "(mus) yodel (1 FA 123/32), sing with interchange of falsetto and normal voice.", "0"],
["jodo", "jod-o", "[OA] Iod/ine (I). <B>~a</B>, -ic. <I>-a tinkturo</I>. <B>~atacido</B>, -ic acid. <B>~ido</B>, -ide. <B>~izi</B>, -ize. <I>~izita (~hava</I>). -ized. <B>~oforma</B>, -oform.", "0"],
["jogo", "jog-o", "yoga. <B>~ano</B>, yogi. <B>~ismo</B>.", "0"],
["jogurto", "jogurt-o", "yog(h)urt.", "0"],
["johimbo", "johimb-o", "(bot) Yohimbe (<I>Corynanthe johimbe</I>).", "0"],
["jolo", "jol-o", "yawl, \"a sailing boat which is decked over, and has a main mast and a small mizzen mast\".", "0"],
["jonkvilo", "jonkvil-o", "(<B>&lt;</B> <I>narciso</I>), jonquil, rush-leaved daffodil (<I>Narcissus jonquilla</I>).", "0"],
["jono", "jon-o", "(chem) Ion. <B>~a</B>, -ic. <B>~igi</B>, -ize. <B>~osfero</B>, -osphere.", "0"],
["Jordanio", "Jordani-o", "JO.", "0"],
["jori", "jor-i", "(nt), (av) (mar), yaw, deviate from straight course owing to action of sea, wind, etc.; lurch, side-slip, skid, sway, swerve, <B>f</B> digress (from subject ). ➞ <I>devi</I>.", "0"],
["joto", "jot-o", "iota (Gk letter), <B>f</B> (<I>detaleto, punkteto</I>) (Mt 5/18).", "0"],
["ju ... des", "", "(adv), [UV] the … the. ~ pli... des pli, the more... the more.", "0"],
["jubeo", "jube-o", "(arch) rood-screen (separating choir and nave).", "0"],
["jubileo", "jubile-o", "[OA] Jubilee, anniversary (Le 25/11). <I>Festi ~on. ~o arĝenta, diamanta, ora</I>, silver (diamond, golden) j. = 25 (60, 50) years (of marriage, etc.). <B>~a</B> <I>jaro, trumpeto</I>, (Le 27/17).", "0"],
["jubili", "jubil-i", "Jubil/ate, exult, make demonstrate of joy. <B>~a</B>, -ant, elated, jolly, merry. <B>~ado</B>, -ation.", "0"],
["jufto", "juft-o", "Russia leather. <B>~e</B> <I>bindita</I>.", "0"],
["juglando", "jugland-o", "[UV] Walnut. <I>~a ŝelo</I>. ~arbo, w-tree (<I>Juglans</I>).", "0"],
["jugo", "jug-o", "[UV] Yoke, cross-bar (for oxen, etc.). <B>f</B> bondage, dependence, servitude, subjection, thraldom (Jes 9/4). <I>Forĵeti la ~on. Esti sub la ~o de. La Romana ~o</I>. <B>~i</B>, (put) y. (on), <B>f</B> (<I>obeigi</I>). <B>~aĵo</B>, <B>~ilaro</B>, harnessing. <B>sub~igi</B> (<I>subpremi</I>), subjugate. ➞ <I>despot, jung, servut, sklav, vekt</I>.", "0"],
["Jugoslavujo, Jugoslavio", "Jugoslav-ujo, Jugoslavio", "YU, Yugoslavia.", "0"],
["juĝi", "juĝ-i", "(<I>-n</I>, abs), [UV] Judg/e. <B>1</B> (jur) act as j., adjudicate, decide, pass (sit in) judgment, pronounce sentence, try. <B>2</B> Form opinion (about), believe, conclude, consider, criticize, reckon, think. <I>~ ion bona. ~i iun freneza. ~i</I> (take in) <I>la situacion. Ne ~u pri afero laŭ ĝia ekstero</I>. ➞ <I>taks</I>. <B>~o</B>, judgment. <B>1</B> award, decree, sentence, trial. <I>La lasta (mondfina) ~o</I>. <B>2</B> conclusion, decision, estimate, <I>~o justa, klara, propra</I>. <B>3</B> discernment, understanding. ➞ <I>diskret, prudent,</I> <B>~a</B>, judicial. <I>~a decido, verdikto</I> (Jes 28/7), verdict. <I>~a ministro</I>, Minister of Justice. <I>~a seĝo</I>, -ment seat, bar, bench. <B>~anto</B>, arbiter, referee, umpire; connoisseur, critic. <B>~antaro</B> (<I>ĵurio</I>), jury. <B>~ato</B>, accused, prisoner at the bar. <B>~ejo</B>, court of justice. <I>Ĉef~ejo</I>, supreme court, <B>~isto</B> <I>arbitracia, distrikta</I>. <B>~istoj</B>, (Bb) Judges. <I>~ista kampo, rajto</I>, jurisdiction. <I>~istaro (tribunalo</I>), bench. <I>Ĉef~isto,</I> Chief Justice. <B>~afero</B> (PI 3/58), action, case, cause, suit. <B>Al~i</B> (<I>asigni</I>), adjudge, award. <B>Antaŭ~(em)o</B>, prejudice. <B>Ne~~a</B>, <B>Sen~~a</B>, open-minded. <B>Pri~i</B>, criticize, examine critically. <B>Mis~i</B>, misjudge. <B>Propra~a</B>, discretionary.", "0"],
["jujubo", "jujub-o", "Jujube. <B>1</B> drupe of various plants, especially of <B>~arbo</B> (<I>zizifo</I>). <B>2</B> jelly lozenge with similar flavour.", "0"],
["jukao", "juka-o", "(<I>Palmlilio</I>), yucca, Adam’s needle, candles of the Lord (<I>Yucca</I>).", "0"],
["juki", "juk-i", "(nt), [UV] Itch, feel irritation in skin. <I>~u la haŭto, sed ne sur mia korpo. Kie ~as, tie oni gratas. ~as al mi</I> (4 FA 222/14). <B>~o</B>, itch. <I>Senti ~on</I>. <B>~ado</B>, -ing, pruritus. <B>~iga</B> (-y) <I>vesto</I>.", "0"],
["julepo", "julep-o", "(pharm) julep, sweet or medicated drink.", "0"],
["Julio", "Juli-o", "[UV] July.", "0"],
["julo", "jul-o", "Yule, the Christmas festival.", "0"],
["juna", "jun-a", "Young, juvenile, youthful. <I>~a arbo, ĉevalo, folio, kapo, Movado, sango, vino. Pli ~a</I>, -er, junior, <B>f</B> green, immature, not far advanced. <I>~aj pizoj</I>. <B>~(ec)o</B>, <B>~aĝo</B>, <B>~uleco</B>, youthfulness, adolescence. <I>~eco rapide pasas. ~eca, ~ula</I>, youthful, of youth, juvenile. <B>~ulo</B>, [UV] y. man. adolescent, lad, teenager. <I>~ulaj jaroj, ~ularo</I>, youth, rising generation. <I>~ulino,</I> damsel, maiden, lass, y. woman. <B>Ge~uloj</B>, y. people. <B>Ne~a</B>, elderly, middle aged. <B>Re~igi</B>, rejuvenate. ➞ <I>freŝ, nov</I>. <B>Mal~a</B> (<I>grandaĝa, multjara</I>, a. <I>olda</I>), old; aged, ancient, hoary, long-established. <B>mal~ulo</B>, [UV] old man. <I>~~ulaj sulkoj</I>, old-age wrinkles. ➞ <I>arka, arkaik, kaduk, malnov, old</I>.", "0"],
["jungi", "jung-i", "(<I>-n</I>), [UV] Harness, hitch, yoke. <I>~i bovon al plugilo, ĉevalon al veturilo</I>. <B>f</B> couple, join, link, unite. <B>~aĵo</B> (1 Rĝ 19/21), <B>~ilaro</B>, equipage, harness. <B>~itaro</B>, team. <B>Kun~ito</B>, yoke-fellow. <B>Mal~i</B>, un-h, outspan. <B>Kol~iloj</B>, hames. ➞ <I>jug</I>.", "0"],
["Junio", "Juni-o", "[UV] June.", "0"],
["junipero", "juniper-o", "[UV] Juniper (<I>Juniperus). ~o nana</I>, dwarf j. <B>~a</B> <I>brando (ĝino</I>), gin. <B>Rim</B>.: <I>J. virginiana</I> is the \"cedar-wood\" used for lead pencils, and in cabinet-making.", "0"],
["junko", "junk-o", "[OA] (bot) rush (<I>Juneus</I>) (Ij 8/11).", "0"],
["junkro", "junkr-o", "junker, young German noble, overbearing member of Prussian aristocracy.", "0"],
["junto", "junt-o", "(tech) Joint, join(ing), connection. <I>~o artika, flanĝa, kabla; boltita, gluita, lutita; de membro, rimeno, ŝnuro, tubo</I>. <B>~o entranĉa</B>, cut-in joint. <B>~o hirundvosta</B>, dovetail j. <B>~o kaŝita</B>, secret j. <B>~o ŝtuda</B>, pin j. <B>~o tenona</B>, tenon j. <B>~o neŝtopita</B>, gaping (open) j. <B>~i</B>, joint connect, fit, interlock, piece together, unite. <B>Mal~i</B>, divide at joint or into joints. <B>~aĵo</B>, gasket. ➞ <I>kunig, mortez, ŝtud, tenon</I>.", "0"],
["jupo", "jup-o", "[UV] Skirt. (<I>mal)longa</I>. <B>Kombin~o</B>, princess slip, petticoat slip. <B>Ringega ~o</B>, hoop-s. <B>f</B> <I>Sin kroĉi al la patrina ~o</I>. <B>~a</B> <I>regado</I>, petticoat rule. (<I>Baleta</I>) <B>~eto</B>, ballet-dancer’s skirt, tutu. <B>~istino</B>, s-hand. <B>~kunveno</B>, hen-party. <B>Sub~o</B>, petticoat, slip, underskirt. ➞ <I>bask, ĉemiz, kilt</I>.", "0"],
["jurisdikcio", "", "(<I>juĝdistrikto</I>), jurisdiction.", "0"],
["juro", "jur-o", "[F] <B>[OA]</B> (<I>leĝoscienco</I>), law, jurisprudence (Es 1/13). <I>Studi ~on</I>. <I>~o administracia, internacia, kanona, kriminala, milita, publika</I>. <B>~o medicina</B>, forensic medicine. <B>~a</B>, juridicial, legal. <B>~isto</B>, jurist, lawyer. ➞ <I>leg, rajt</I>.", "0"],
["justa", "just-a", "[UV] Just. <B>1</B> Equitable, lawful, legitimate, reasonable: <I>~a decido, divido, postulo, kolero</I>. <B>2</B> Fair, impartial: <I>~a al (kontraŭ). Juĝo severa, sed ~a</I>. <B>3</B> Honest, righteous, straightforward, upright: <I>~a ago, homo, konduto</I>. <B>4</B> correct, exact; appropriate, fit, proper, suitable; due: <I>~a prezo, rekompenco. Agi</I> <B>~e</B>, do justice (Mi 6/8). <B>~(ec)o</B>, justice, equity, fairness, etc. (Ez 2/63; Jes 32/17). <B>~aĵo</B>, j. action (decision). <B>~ulo</B>, j. (good, righteous) man. <B>~igi</B> (<I>pravigi</I>), justify, vindicate, warrant. ➞ <I>ĝust, honest, prav, rajt</I>. <B>Mal~a</B>, <B>Ne~a</B>, unjust, bad, evil, iniquitous, unfair, wrongful. <B>~~a</B> <I>ago, homo, profito, puno, suspekto</I>. <B>~~aĵo</B><I>,</I> <B>~~eco</B>, injustice, iniquity (Ge 6/13, Ce 3/5). <B>~~ulo</B>, evil-doer, worker of iniquity.", "0"],
["justico", "justic-o", "law, judicial proceedings or organization. <I>Sin turni al ~o</I>, go to law.", "0"],
["juto", "jut-o", "Jute. <B>1</B> (bot) various E. Indian plants (<I>Corchorus</I>). 2 (<I>~a fibro</I>), fibre from these.", "0"],
["juvelo", "juvel-o", "[UV] Jewel, piece of jewellery, precious stone, ornament containg this, <B>f</B> something or someone highly prized (treasured). <B>~aĉo</B>, bauble, gewgaw, <B>~aro</B>, set of -lery, treasures. <B>~eto</B>, bijou, trinket. <B>~ejo</B>, jeweller’s shop. <B>~izi</B> (<I>poŝhorloĝon</I>). <B>~ujo</B>, j-case (casket). ➞ <I>briliant, perl, stras, trezor</I>.", "0"],
["ĵaboto", "ĵabot-o", "(cl) jabot, frill (ruffle) on front of woman’s bodice (M 90/6).", "0"],
["ĵaketo", "ĵaket-o", "[OA] Jacket (for woman or children), (men) tail-coat, morning coat.", "0"],
["ĵako", "ĵak-o", "(<I>konektilo, kontaktingo</I>) (el) Jack. ~o interrompa, break j. ~o multiga, multiple j. ~o responda, calling j.", "0"],
["ĵaluza", "ĵaluz-a", "[UV] Jealous, anxious for preservation of something, apprehensive of displacement by someone, resentful of preference, suspiciously vigilant. <I>~a okulo, zorgo. ~a pri bonfamo, rajto, sukceso</I>. <B>~e</B>, -ly. <B>~o</B>, jealousy. <I>Amo kaj ~o estas gefratoj. Eksciti ~on (pri, pro) io, kontraŭ iu</I>. <B>~i</B> (<I>esti ~a</I>), be jealous for (of). <B>~ema</B>, <B>~igi</B>, <B>~ulo</B>. ➞ <I>envi</I>.", "0"],
["ĵaluzio", "ĵaluzi-o", "(arch) jalousie, blind, shutter (with holes, or with slats sloping upwards from without, enabling a person inside to see but not be seen).", "0"],
["ĵamboreo", "ĵambore-o", "(sctg) jamboree.", "0"],
["ĵami", "ĵam-i", "(rad) jam, block by interference. <B>~ado</B>, jamming.", "0"],
["ĵargono", "ĵargon-o", "[OA] Jargon, lingo. <B>1</B> (<I>lingvo fuŝita</I>); barbarous, debased, or unintelligible language, gibberish. <B>2</B> (<I>mikslingvo, piĝino</I>); pidgin, e.g., Chinook. <B>3</B> (<I>lingvo faka, klasa, konvencia</I>): technical (class, specialized) language, cant, slang. <I>~o aktora, cigana, jurista, marista, ŝtelista</I>. <B>~i</B>, jabber, talk gibberish. ➞ <I>slang</I>.", "0"],
["ĵaro", "ĵar-o", "large earthern jar.", "0"],
["ĵartelo", "ĵartel-o", "(<I>ŝtrumpŝelko</I>), Suspender (for sock, stocking, etc.). <I>~a zono</I>, suspender-belt.", "0"],
["ĵaŭdo", "ĵaŭd-o", "[UV] Thursday. <I>~o antaŭpaska,</I> Maundy T. <I>En la tri~a semajno ~~ neniam</I>.", "0"],
["ĵazo", "ĵaz-o", "jazz. <B>~bando</B> (<B>~trupo</B>), jazz-band.", "0"],
["ĵeleo", "ĵele-o", "(cul) jelly. <I>~o frukta, vianda</I>. ➞ <I>agaragar, gelaten</I>.", "0"],
["ĵerzo", "ĵerz-o", "(cl) jersey, knitted tunic or undervest, sweater, (woman) close-fitting knitted jacket. <B>~eto</B> (<I>pulovro</I>), pullover.", "0"],
["ĵeti", "ĵet-i", "(<I>-n</I>), [UV] Throw, Cast; chuck, fling, heave, pitch, toss. <I>ion en la maron</I> (jettison) (Jona 1/5), <I>sur la teron</I> (El 4/3). <I>~i kubojn</I>, (t. dice), <B>f</B> <I>Jen, kion li ~is! ~i al iu en la vizaĝon. ~i ganton</I> (challenge). <B>2</B> direct, turn: <I>~i flanken</I>, c. aside. <I>~i okulojn (lumon, rigardon</I>). <B>3</B> produce effect or feeling: <I>~i krion, ombron, timon. ~i en funebron, mizeron</I>. <B>Sin ~i</B> (fall, t. one’s) <I>al ies kolo (sur ies kolon), sur iun;</I> (plunge) <I>en akvon, batalon</I>. <B>~o</B>, throw, cast, pitch, <B>f</B> <I>La ~o (decido) estas farita</I>. <B>~aĵo</B>, missile, projectile. <B>~egi</B>, dash, hurl. ~iĝadi <I>tien-reen sur la lito</I> toss (tumble) about, be restless, <B>~ilo</B>, -rimeno, catapult. <I>Sxton~ilo</I>, sling (1 Sa 17/50). <B>Al~i</B>, bowl. <B>De~i</B>, c. down (off), discard, moult (feathers), shed (leaves, skin), t. (rider). <B>Dis~i</B>, scatter, strew. <B>Ek~i</B>, let fly. EM, <I>lafon, vorton, el la fenestro</I>, t. out(up), c. out, eject, ejaculate, eliminate, emit, expel, vomit (flames). ➞ <I>elsput, elverŝ, elvom</I>. <B>~~aĵo</B>, discharge. <B>~~ulo</B>, outcast. <B>En~i</B>, t. in. <B>For~i</B> <I>instruon, konsilon, projekton, timon</I>, t. away, drive off, jettison, reject. <B>~~a</B> <I>prezo</I>, dirt cheap (ruinous) price. <B>~~aĵo</B>, jetsam, refuse, rubbish. <B>~~inda</B>, useless. <B>Pri~i</B> <I>per ŝtonoj</I>, stone. <B>Re~i</B>, t. back. <B>Sur~i</B>, t. at, (upon), pelt. ➞ <I>kovr, stern</I>. <B>Trans~i</B>, t. over (wall, etc.). <B>Lum~ilo</B> (<I>reflektilo</I>), reflector, searchlight. <B>Supren-i</B>, t. up. ➞ <I>spruc</I>.", "0"],
["ĵibo", "ĵib-o", "(mar) Jib, triangular stay-sail. <B>~stajo</B>, j-stay.", "0"],
["ĵigo", "ĵig-o", "(<I>segita bildo</I>), jigsaw puzzle. ➞ <I>ĝig</I>.", "0"],
["ĵinrikŝo", "ĵinrikŝ-o", "jinrickshaw.", "0"],
["ĵipo", "ĵip-o", "jeep.", "0"],
["Ĵo", "Ĵ-o", "[F], name of letter Ĵ.", "0"],
["ĵokeo", "ĵoke-o", "jockey.", "0"],
["ĵongli", "ĵongl-i", "[UV] <B>1</B> Juggl/e, Conjur/e, use sleight of hand. <B>2</B> practise imposture, cheat, <B>f</B> <I>~i per rimoj, vortoj</I>. <B>~(ad)o</B>, c-ing, legerdemain, <B>~aĵo</B>, c-ing trick; deceit, imposture, trickery, <B>~isto</B>, c-er, j-er. <B>For~i</B>, cause to disappear, c. away, make vanish. ➞ <I>artifik, ĉikan, fraŭd, iluzi, vortlud</I>.", "0"],
["ĵonko", "ĵonk-o", "(mar) (Chinese) junk.", "0"],
["ĵosi", "ĵos-i", "(hort) bed inearth, heel in, plant out.", "0"],
["ĵudo", "ĵud-o", "(sp) judo, jiujitsu.", "0"],
["ĵulo", "ĵul-o", "(el) joule.", "0"],
["ĵurasa", "ĵuras-a", "(geol) jurassic.", "0"],
["ĵuri", "ĵur-i", "(<I>~n, per, pri, ke</I>, abs), [UV] take oath, swear (by); solemnly attest, (declare, promise, state) vow. <I>~i labori. ~i fidelon. ~i per ĉio sankta. ~i false, mensoge. Mi povas ~i (estas certa) pri tio</I>. <B>~o</B>, oath, vow. <I>Fari, nuligi, rompi ~on</I>. <B>~a</B>, <B>~e</B>, on oath. <I>~a interkonsento</I>. <B>~igi</B> (<I>-n</I>), administer (put under) oath. <B>~inta</B>, sworn. <B>~ligi</B>, bind by oath (Alt 2/7). <B>~rompo</B> (Ps 59/12). <B>For~i</B>, adjure, forswear. <B>Inter~i</B>, <I>~i al si reciproke</I> (Ge 26/31). <B>Je~i</B> (<I>kontraŭ</I>), conspire, league together (against). <B>Pri~i</B>, dedicate, vow. ➞ <I>blasfem, malben</I>.", "0"],
["ĵurio", "ĵuri-o", "(<I>ĵurintaro</I>), jury. <B>~ano</B>, juror.", "0"],
["ĵurnalo", "ĵurnal-o", "[F] [OA] (<I>taga gazeto</I>), Journal, Newspaper, daily paper. <B>~aro</B>, papers, daily press. <B>~ismo</B>, -ism. <B>~isto</B>, -ist, newspaper man, reporter. <I>~ista ĵargono</I>, journalese, <B>~vendisto</B>, newsagent. ➞ <I>gazet, revu, taglibr</I>.", "0"],
["ĵus", "", "[UV] (<I>tuj antaŭe</I>) (precedes … <I>-is</I>), just (now), not long ago (before), a little time ago, just. <I>~ batis la dua. Li ~ venis</I>. <B>~a</B>, just made (occurred), last-moment, stop-press, up-to-date. ➞ <I>freŝ, ĝust, just, preciz</I>. [Translate \"just when\" by <I>ĝuste kiam</I>, not by <I>~ kiam</I>]. ➞ <I>tuj</I>.", "0"],
["kabalo", "kabal-o", "[OA] cabal. <B>1</B> secret intrigue. <B>2</B> clique. <B>3</B> mystic science. <B>~a</B>, -istic, dark, mysterious, occult. <I>~aj signoj</I>. <B>~i</B>, intrigue privately. ➞ <I>hieroglif intrig, koteri</I>.", "0"],
["kabano", "kaban-o", "[OA] Cabin, crude humble dwelling, hut, shanty, shelter. <I>~o de montano, por bruto</I> (Ge 33/17, Ps 27/5, Jer 9/10). <B>~ano</B>, cotter. <B>~kvaralo</B>. <B>Ŝtip~o</B>, log cabin. <B>Ter~o</B>, earth hut. ➞ <I>barak, bud, kajut, ŝed</I>.", "0"],
["kabareto", "kabaret-o", "cabaret. <B>1</B> small French inn. 2 (<I>kafeja koncerto</I>), show. ➞ <I>variete</I>.", "0"],
["kabineto", "kabinet-o", "<B>[OA], 1</B> (special) Room (for consultation, work, study). <I>~o jurist, kuracista</I>, consultg-r, chambers. <I>Labor~o,</I> study. <I>Nigra ~o</I> (phot), dark r. <I>Tualeta ~o</I>, dressing-room. <B>~a</B> <I>skribotablo</I>. <B>f ~a</B> (<I>= surpapera, teoria) provo</I>. <B>~e</B>, in camera, privately. <B>2</B> (<I>ministraro</I>), cabinet, ministry. <I>~a sigelilo</I>, privy seal. <I>~a decido, kunveno, krizo, ministro</I>. <B>3</B> case with drawers and shelves. <B>4</B> (phot) c-size (3f\"x 5i\") <I>[Ne= necesejo]</I>.", "0"],
["kablo", "kabl-o", "[OA] Cable. 1 (<I>ŝnurego</I>), strong thick rope (9\" in circumference). <I>Ankro~o. Tren~o</I>, tow-rope. <B>2</B> (el) <I>~o submara, subtera, ŝtala. Proviza ~o</I>, mains. <B>~a</B> <I>depeŝo</I>, -gram. <I>~a tramo</I>, funicular tram. <B>~i</B> (<I>~e telegrafi</I>), c. <B>~eto</B>, hawser.", "0"],
["kabo", "kab-o", "(<I>terkapo</I>), cape, headland. <I>~o de Bonespero</I>. <B>K~overdo</B> CV. ➞ <I>promontor</I>.", "0"],
["kabrioleto", "kabriolet-o", "[OA] cab(riolet), two-wheeled hooded one-horse carriage. ➞ <I>fiakr</I>.", "0"],
["kaĉaloto", "kaĉalot-o", "(<I>spermaceta baleno</I>), cachalot, sperm whale (<I>Physeter macrocephalus</I>).", "0"],
["kaĉo", "kaĉ-o", "[UV] hash, mush, much, pap, pulp, puree. <B>Avena ~o</B>, gruel, porridge. <B>Pan~o</B>, sop. <B>Paper~o</B>, paper-mache. <B>Kot~o</B>, <B>neĝ~o</B>, slush. <B>Piz~o</B>, pease pudding. <B>Riz~o</B>, rice-pudding. <I>~o faruna, terpoma</I>. <B>f</B> (col) (<I>kuiraĉaĵo</I>), hotch-potch, mess. <B>~igi</B> (<I>iun</I>), (col) squash. <B>~ujo</B>, porringer. ➞ <I>gri, kompot, marmelad, sup</I>.", "0"],
["kaĉuo", "kaĉu-o", "cachou (lozenge).", "0"],
["kadastro", "kadastr-o", "fiscal land register, survey and valuation. <B>~a</B>, cadastral.", "0"],
["kadavro", "kadavr-o", "[OA] corpse, (dead) body, carcase, remains. <B>~(ec)a</B>, cadaverous. <I>~a vizaĝo. ~aj okuloj</I>. <B>~e</B> <I>odori. ~e pala</I>. <B>~aĵo</B>, carrion, dead matter (Le 5/2). <B>~ejo</B>, morgue, mortuary. <B>~esploro</B> (<I>nekropsio</I>).", "0"],
["kadenco", "kadenc-o", "<I>[OA]</I> (<I>frazfino</I>). <B>1</B> (mus) cadence<I>,</I> Perfekta, plenfina (<I>V-I</I>). Dominanta, duonfina <I><B>(V)</B>.</I> Plagala, amena <I><B>(IV-I).</B> </I>Surpriza, evitita, interrompita <I><B>(V- plus alid akordo ol I).</B> </I><B>2</B> (<I>voĉfalo), fall of voice</I>.", "0"],
["kadenzo", "kadenz-o", "(<I>solo-pasaĵo koloratura</I>)<I>,</I> (mus) cadenza.", "0"],
["kadeto", "kadet-o", "[OA] student in naval or military college. <I>Mar~o</I>, naval cadet. <I>~a ŝipo,</I> traing ship. <I>~a lernejo</I>.", "0"],
["kadio", "kadi-o", "cadi, Turkish civil judge. ➞ <I>mufti, ulem</I>.", "0"],
["kadmio", "kadmi-o", "Cadmium (Cd). ~a <I>flavo,</I> c-yellow.", "0"],
["kadrato", "kadrat-o", "(<I>interlitero, spaco</I>), (typ) Quadrat, em-q. <B>~eto</B>, en-q.", "0"],
["kadro", "kadr-o", "[UV] <B>1</B> (<I>borderaĵo</I>), Frame, Border. <I>~o de bildo, spegulo</I>. Picture-frame, mirror-f. (phot) <I>Kliŝ~o, ŝanĝ~o</I>, dark slide. <B>2</B> (<I>ĉirkaŭaĵo</I>), setting, surroundings. <I>~o historia</I>. <B>~i</B> (<I>ĉirkaŭi</I>), border, encircle, panel, set off, surround (Alt 5/14). <I>Blue ~itaj</I> (blue- rimmed) <I>okuloj. ~i per cedroj</I> (Jer 22/14). <I>Herbejo ~ita de montoj</I>. <B>En~igi</B> (<I>ĉirkaŭigi</I>), (put in a) frame. <I>En~igi bildon, kameon</I>. <B>~aĵo</B>, <B>~eto</B>, ouch, mounting, setting (El 28/11). ➞ <I>fram</I>.", "0"],
["kaduka", "kaduk-a", "[UV] (<I>malfortiĝa, ruiniĝa</I>), frail, broken-down, impaired, weak, worn-out. 1 (thing) dilapidated, falling to pieces, ramshackle, rickety, shabby, tumble-down, rusty. <I>~a domo, ĉapelo, muro, urbo, vesto</I>. <B>2</B> (person) decrepit, feeble, infirm, sickly. <I>~a homo, maljunulo</I>. <B>f</B> decadent, fading, failing, falling-off, fugitive. <I>~a afero, entrepreno, espero, folio, menso, sano, stato</I>. ➞ <I>falem, nefirm, ŝanĉeliĝ, velkant. (esti ~a</I>). <B>~aĵoj</B> <I>de maljunaĝo</I>. <B>~(ec)o</B>, decay, decline, delapidation, infirmity. <B>~iĝi</B> <I>korpe, mense,</I> break up (Ps 38/8). ➞ <I>konsumiĝ</I>. <B>~ulo</B> (Ps 105/37). <B>~ulejo</B>, infirmary. ➞ <I>azil, maljunulej</I>. <B>Mal~a</B>, bearing years well, in good condition, well-preserved.", "0"],
["kafeino", "kafein-o", "caffeine. <I>Kafo sen~einigita</I> (decaffeinated), \"Hag\" c.", "0"],
["kafo", "kaf-o", "[UV] Coffee. <B>1</B> beverage from <B>~arbo</B>, c-tree (<I>Coffea</I>). 2 <I>~semo</I>, c-bean. <I>~o muelita, rostita</I>. ~ejo, cafe, c-room. <B>~ujo</B>, <B>1</B> (<I>~kruĉo</I>), c-pot. <B>2</B> (<I>~skatolo</I>), c-tin. <B>~bruna</B>, <B>~kolora</B>. <B>~plantejo</B>. <B>~rostilo</B>.", "0"],
["kaftano", "kaftan-o", "(cl) caftan, Eastern long under-tunic with girdle.", "0"],
["kaĝo", "kaĝ-o", "[UV] Cage. <I>Bird~o. Kokina ~o</I>, hen coop, <B>f</B> dungeon, keep, prison. ➞ <I>urskav</I>. <B>El~igi</B>, set free. <B>En~igi</B>, c., confine, coop up, imprison.", "0"],
["kahelo", "kahel-o", "[UV] Tile, paving block (slat), flag. <I>~o asfalta, betona</I>. <B>~i</B> <I>plankon, ifom, muron</I>. tile, cover with tiles. <B>~a</B> <I>forno</I> (1 FA 33/14). <I>~a planko</I>, paved floor. <B>~aro</B>, tiling. <I>Brika</I> <B><I>~aro</I></B>, brick paving. ➞ <I>brik, ceramik, fajenc</I>. ➞ <I>tegol</I>.", "0"],
["kaj", "", "[UV] (conj), And. <I>Manĝi panon ~ lakton. ~ A ~ B</I>, both A and B (Pr 9/6). H Kaj may begin a sentence, e.g., the first word of many paragraphs in <I>Nombroj</I>.", "0"],
["kajako", "kajak-o", "(mar) kayak, Eskimo one-man canoe.", "0"],
["kajero", "kajer-o", "[UV] <B>1</B> (stitched-paper) Book; section (number) of book. <I>Eliradi (po</I>)<B><I>~e</I></B>, in parts. <B>2</B> exercise-b. Skrib<B>~o</B>, copy-book. <B>~eto</B>, memo-b.", "0"],
["kajmano", "kajman-o", "cayman, species of S American alligator <B>(<I>Caiman</I>)</B>.", "0"],
["kajo", "kaj-o", "<B>[OA], 1</B> (mar) Quay, Pier, Wharf. <B>2</B> embankment (along river). <B>3</B> (ry) platform (➞ <I>platform</I>). <B>~pago</B>, p-dues, w-age. <B>Sur~e</B>, on q. ➞ <I>varf</I>.", "0"],
["kajoli", "kajol-i", "cajole, blandish, persuade (soothe) by flattery or deceit, wheedle.", "0"],
["kajto", "kajt-o", "(<I>flugdrako</I>), kite.", "0"],
["kajuto", "kajut-o", "[UV] (mar) cabin, saloon. <I>~o</I> <B><I>pasaĝera, pilota, unuaklasa</I></B>. (av) cockpit. <B>~o <I>unulita</I></B>, single berth, (ry) <B><I>signal~o</I></B>, signal-box.", "0"],
["kakao", "kaka-o", "[OA] Cocoa. 1 (<I>~semo</I>), c-bean. <B>2</B> beverage from -arbo, c-tree (<I>Theobroma cacao</I>). ~ujo, (<I>~skatolo</I>), c-tin. ➞ <I>kokos</I>.", "0"],
["kakatuo", "kakatu-o", "(orn) cockatoo (<I>Kakatoe</I>).", "0"],
["kaki", "kak-i", "(col) (<I>~~feki</I>). ➞ <I>kaki</I>.", "0"],
["kakio", "kaki-o", "<B>~a</B>, khaki, dull brownish yellow.", "0"],
["kakofonio", "kakofoni-o", "cacophony, discord.", "0"],
["kakto", "kakt-o", "[OA-8], cactus. <B>~acoj</B>.", "0"],
["kalabaso", "kalabas-o", "Calabash, bottle-gourd. <B>~arbo</B>, c-tree (<I>Crescentia</I>).", "0"],
["kalaminto", "kalamint-o", "calamint, wild basil (<I>Calamintha</I>).", "0"],
["kalandri", "kalandr-i", "(<I>rulglatigi</I>), Mangle, calender, press, roll out. <B>~ilo</B>, <B>~omaŝino</B>, mangle, wringer. ➞ <I>rulcilindr</I>.", "0"],
["kalandro", "kalandr-o", "<B>1</B> (ent) corn Weevil (<I>Calandra</I>). Riz<B>~o</B>, rice-w. <B>2</B> (orn) Calandra lark (<I>Melanocrypha calandra</I>). ~eto etfingra (a. <I>kalandrelo</I>), short-toed lark (<I>Calandrella</I>).", "0"],
["kalcedonio", "kalcedoni-o", "(min) chalcedony, vrty of silica.", "0"],
["kalceolario", "kalceolari-o", "(bot) calceolaria, slipper- wort.", "0"],
["kalcini", "kalcin-i", "Calcin/e. <B>~o</B>, -ation. ➞ <I>kalkig, rost</I>.", "0"],
["kalcio", "kalci-o", "Calcium (Ca). ~a <I>oksido,</I> quicklime.", "0"],
["kalcitri", "kalcitr-i", "(of horse), Kick, lash out with hind legs, <B>f</B> jib at, k. against. ~ema, recalcitrant, refractory.", "0"],
["kaldrono", "kaldron-o", "[UV] (<I>granda bolpoto</I>), Boiler, cauldron, large kettle (1 Sa 2/14). <I>Lav~o, copper</I>.<B> <I>~o fera, hejta, kuira, tuba</I>. ~(eg)o</B>, boiler (of engine, ship). <B>~isto</B>, b-man.", "0"],
["kalejdoskopo", "kalejdoskop-o", "[OA] kaleidoscop/e. <B>~a</B>, -ic, everchanging. <B>~i</B> (<B><I>ŝanĝiĝadi). Ideoj ~as (svarmas) en lia kapo</I>.</B>", "0"],
["kalendaro", "kalendar-o", "<B>[OA], 1</B> (<B><I>jarkalkulo</I></B>), Calendar. <B>~o (<I>mal)novstila, Gregoria</I>. 2 (<I>almanako</I>)</B>, table of dates. <I>~o</I><B> <I>ŝirfolia (bloka</I>)</B>, tear-off c.<B> <I>~o ĉiama, mura, perfingra, poŝa, reklama</I></B>.", "0"],
["kalendulo", "kalendul-o", "[OA] (<I>kalendolo</I>), marigold (<I>Calendula</I>).", "0"],
["kaleŝo", "kaleŝ-o", "[UV] light 4-wheeled Carriage (chaise, victoria, etc.) (Jĝ 5/28). Balga ~o (<I>landaŭo</I>), landau. Funebra <B>~o</B>, funeral c. Lu~o (<I>fiakro</I>), hackney. <B>~ego</B>, kvarĉevala <B>~o</B>, coach. <B>~eto</B> (<I>durada</I>), buggy, gig. <B>~(far)isto</B>, coach-builder. <B>Duon~o</B>, brougham. ➞ <I>veturil, kabriolet</I>.", "0"],
["kalfatri", "kalfatr-i", "[UV] Caulk, make joint tight with oakum and pitch, <B>f</B> stop up chinks (seams). <I>~i ĉambron</I>, make room draught-proof. <B>~ilo</B>, c-iron. <B>~isto</B>, -er (Jeĥ 27/9). ➞ <I>nepenetreblig</I>.", "0"],
["kalibri", "kalibr-i", "[OA] Calibr/ate. <B>1</B> measure internal or external dimensions. <B>2</B> check graduates on thermometer, etc. <I>~i cilindron, kuglon, tubon</I>. <B>~o</B>, inner diameter, bore, of pipe, <B>f</B> degree of merit. <B>~ado</B>, -ation. <B>~ilo</B>, calliper(s), instrument used for this. <B>Kord~ilo</B>, string-gauge. ➞ <I>gaŭĝ, mezur</I>.", "0"],
["kalicebo", "kaliceb-o", "(zoo) titi-monkey (<I>Callicebus</I>).", "0"],
["kalidro", "kalidr-o", "(orn) (<I>Calidris</I>). Alpa <B>~o</B>, dunlin. Granda ~o (<I>kanuto</I>), knot. Malgranda <B>~o</B>, little stint. Mara <B>~o</B>, purple sandpiper, Sabla <B>~o</B>, sanderling (<I>Crocethia alba</I>). ➞ <I>tring</I>.", "0"],
["kalifo", "kalif-o", "[OA] Caliph, Islamic ruler. <B>~eco</B>, ~ejo, -ate.", "0"],
["kaliforo", "kalifor-o", "blow fly, blue-(green-)bottle (<I>Caliphorus). ~a larvo</I>, gentle.", "0"],
["kaligrafio", "kaligraf/i-o", "(<I>belskribo, skribarto</I>), Cali- graph/y, beautiful handwriting, penmanship. <B>~(iist)o</B>, -ist, writing expert.", "0"],
["kalikanto", "kalikant-o", "Calycanthus, Carolina allspice (<I>Calycanthus</I>).", "0"],
["kaliko", "kalik-o", "[UV], (<I>pokalo luksa, formala, pied-hava), (broad and shallow) Cup, bowl, chalice (Jes 51/17, Mt 26/27). Asperga ~o (Jer 52/18); (bot) flower-calyx, ~oforma, c-like, calyciform. ➞ pokal, tas</I>.", "0"],
["kalikoto", "kalikot-o", "[UV] (tex) Calico, plain white unprinted cotton cloth (In USA printed). ➞ <I>katun, muslin, perkal</I>.", "0"],
["kalio", "kali-o", "[OA] Potassium (K). ➞ <I>potas</I>.", "0"],
["kaliopo", "kaliop-o", "(orn) ruby-throat(ed warbler) (<I>Calliope</I>).", "0"],
["kalistefo", "kalistef-o", "Chinese aster (Callistephus chinensis). ➞ aster.", "0"],
["kalistegio", "kalistegi-o", "(<I>granda konvolvulo</I>). Bindweed (<I>Calystegia sepium</I>). Apudmara <B>~o</B>, sea b. (C. <I>soldanella</I>). Granda <B>~o</B>, American bellbine (C. <I>silvatiea</I>). ➞ <I>konvolvul</I>.", "0"],
["kalistemo", "kalistem-o", "bottle brush (Australian shrub) (<I>Callistemon</I>).", "0"],
["kalitriko", "kalitrik-o", "(bot) water starwort (<I>Callitriche</I>).", "0"],
["kalitrikso", "kalitriks-o", "(zoo) marmoset (<I>Callithrix</I>).", "0"],
["kalkano", "kalkan-o", "[UV] Heel. <I>Sin turni sur la ~o</I>. f h. of rudder, vn-bow, etc. <B>~umo</B>, h. of shoe. <I>Pinta (stileta) ~o</I>, stiletto h. ~osto, h-bone, <I>Sidi</I> sur~e (<I>kaŭri</I>), squat.", "0"],
["kalko", "kalk-o", "[UV] Lime. <I>Klor~o</I>, chloride of lime, bleaching-powder. <I>~o estingita</I>, slaked lime. <I>kaŭstika, anhidra, senakva</I>, quick-1ime. <I>~akvo, ~lumo, ~ŝtono</I>. <B>~eca</B>, <B>~oza</B>, calcareous, limy. ~(blankig)i, whitewash. <I>~i domon, muron</I> (Le 14/42, Da 5/5). <B>~izi</B>, (agr) cover with lime. ~argilo (<I>marno</I>), marl. ~forno, l-kiln. ➞ <I>gips, kret, stuk</I>.", "0"],
["kalkuli", "kalkul-i", "(<I>-n, nt</I>), [UV] Calculat/e. <B>1</B> (<I>komputi</I>) (mat) Reckon, compute, work out: <I>~i distancon, konton, procenton</I>. 2 (<I>nombri</I>) count, enumerate, number: <I>~i ĝis cent; perfingre (kapojn, monon, voĉojn, la stelojn</I>). <B>3</B> consider, deem, judge, look on as, rate, think (to be): <I>~i kiel devon, meriton, pekon, nenion</I>. <B>4</B> (<I>fidi, konfidi</I>) count (depend) on: <I>Mi ~as je via helpo</I>. <B>5</B> reckon with, take into consideration: <I>~i kun cirkonstancoj (la situacio</I>). <B>~o</B>, <B>1</B> (c-ion, r-ing): <I>~o erara, ĝusta. Bonaj ~oj, bonaj amikoj</I>. 2 enumerate, review, survey. <I>Lasi el la ~o</I>. 3 (<I>konto</I>), account, bill, charge: <I>doni, pagi, prezenti ~on. Je mia ~o. Havi ~on kun</I>. ➞ <I>faktur</I>. <B>4</B> sum. <B>~ebla</B> (reputed) <I>kiel nenio</I> (Da 4/35), <B>~ema</B>, c-ing, scheming (in disposition). <B>~ejo</B>, counting-house. <B>~ilo</B> (~aparato), (<I>komputilo</I>) (➞ <I>abako</I>), c-ing machine, r-er. <B>Cel~ilo</B>, <B>distanc~ilo</B>, range finder. <B>Glit~ilo</B>, slide-rule. <B>~isto</B>, accountant. <B>~itoj</B> (No 2/4). <B>Al~i</B>, add, put to a/c, attribute (impute) to. <B>Antaŭ~i</B>, estimate. <B>De~i</B>, subtract (➞ <I>rabat</I>). <B>El~i</B>, count in full (Ps 71/15). <B>En~i</B> (<B>Kun~i</B>), allow for, count in, include. <I>Transdoni</I> laŭ~e (Ez 1/8). <B>Mis~i</B>, mis-c. <B>Ne~ebla</B> (<I>sennombra</I>) (Ij 9/10, J1 1/6). <B>Pri~i</B> <I>la komunumon</I> (No 1/3). <I>Fari pri~on</I> (Le 25/50). <B>Re~i</B>, recount. <B>Fin~i</B> (<I>bilanci, saldi</I>). <B>Kap~o</B>, census. <B>Temp~o</B>, ➞ <I>era, kronolog</I>. ➞ <I>komput, kont, nombr, sumig</I>.", "0"],
["kalma", "kalm-a", "(mar, met), Calm (<I>senventa</I>), smooth, still, undisturbed by abnormal conditions, un-perturbed, unruffled, especially after previous agitation. <I>~a aero, maro, nokto, vetero</I>. <B>~o</B>, c., absence of violent motion or noise, quietude, serenity. <I>Ekvatora ~o (~aj zonoj</I>), doldrums (<I>doldrumo</I>). <B>~igi</B>, c., appease, quieten, still; allay (<I>timori</I>), soothe (<I>nervojn</I>). <B>~iĝi</B>, (of storm), abate, blow over, die down, drop. <I>~iĝu!</I> Gently! ➞ <I>kviet, trankvil</I>.", "0"],
["kalo", "kal-o", "[UV] corn (on hand or foot), <B>~aĵo</B>, callosity. <B>~(ec)a</B>, hardened, horny. ➞ <I>gren, korn</I>.", "0"],
["kalomelo", "kalomel-o", "[OA] calomel (Hg<SUB>2</SUB>Cl<SUB>2</SUB>).", "0"],
["kalorio", "kalori-o", "(<I>varmunuo</I>), calor/y. <B>~a</B>, -ic. -metro.", "0"],
["kalsono", "kalson-o", "[UV] (<I>subpantalono</I>), Drawers (m. or f.), pants, shorts; knickers (fem). <B>Ban~o</B>, bathing-drawers. <B>kombin~o</B> (<I>kombinaĵo</I>), combinations. <B>~eto</B>, panties. ➞ <I>kulot</I>.", "0"],
["kalto", "kalt-o", "marsh marigold (<I>Caltha</I>).", "0"],
["kalumeto", "kalumet-o", "(<I>pa➞ipo</I>), calumet, Indian pipe (of peace).", "0"],
["kalumnii", "kalumni-i", "(-<I>n kontrau, pri</I>), [UV] Calumn/iate, Slander; backbite, blacken the char, of, defame, libel, malign, run down (Ps 15/3). <B>~o</B>, -y, false charge, malicious misrepresentation, s-ous report. <I>Disporti ~ojn</I> (Le 19/16). ~(em)a, defamatory, s-ous. ~anto (Ps 140/11).", "0"],
["kaluno", "kalun-o", "ling, heather (<I>Calluna</I>). ➞ <I>erik</I>.", "0"],
["kalva", "kalv-a", "<B>[OA]</B> (<I>senkaphara</I>), bald-headed. ~o (Jes 3/24, Am 8/10). Se <I>haroj ne mankus, mi ~on ne havus</I> (P.). ~aĵo (Le 13/42), ~ulo (2 Rĝ 2/23). <B>~iĝi</B>, lose one’s hair.", "0"],
["kamao", "kama-o", "(zoo) kaama (<I>Bubalis camaa</I>).", "0"],
["kamarado", "kamarad-o", "[OA] Comrade, chum, companion, fellow, pal, (play)mate. <I>~o lerneja, lita. Voj~o</I>, travelling companion. ~i (<I>kun) (esti ~o de</I>), be chummy (fraternize, walk) with. <B>~aro</B>, band of cc., fellowship. <B>~eco</B>, c-ship. <B>~ema</B>, companionable, sociable. ~ino (Mai 2/14). If ➞ kamarado (<I>pro kunvivo</I>), kolego (<I>pro samokupo</I>). ➞ <I>kunul, kunvivant, militfrat, samlernejan</I>.", "0"],
["kambio", "kambi-o", "[UV] (com) Bill of exchange, -isto, b-broker. ➞ <I>mandat, trat</I>.", "0"],
["Kamboĝo", "Kamboĝ-o", "KH.", "0"],
["kambria", "kambri-a", "(geol) Cambrian (period). <B>Antaŭ~a</B>, pre-c.", "0"],
["kameleono", "kameleon-o", "(a. <I>ham</I>), chameleon (<I>Chamaeleon</I>). <B>f ~a</B>, fickle. ➞ <I>ŝanĝiĝem</I>.", "0"],
["kamelio", "kameli-o", "[OA] (bot) camellia (<I>Camellia</I>).", "0"],
["kamelo", "kamel-o", "[UV] Camel (<I>Camelus</I>); usually = ~o duĝiba, Bactrian (two-humped) c. ~o unuĝiba (<I>dromedaro</I>). <B>~ino</B>, (Jer 2/23). <B>~(pel)isto</B>, c-driver. <B>~haroj</B>, c-hair.", "0"],
["kamemberto", "kamembert-o", "(cul) camembert (cheese).", "0"],
["kameno", "kamen-o", "[UV] fire-place (fire-side), hearth. <I>Sidi ĉe la ~o. Fajro sur la ~o</I>. <B>~a</B> <I>fajro,</I> open fire. ~angulo, chimney corner. ~breto, mantle-piece, ~kapuco, canopy over hearth. <B>~tubo</B>, [UV] chimney (Ho 13/3). <B>~tubisto</B>, stove-setter. <B>~purigisto</B>, <B>~skrapisto</B>, chimney-sweep.", "0"],
["kameo", "kame-o", "[OA] cameo, small relief-carving in stone with colourd background of another colour. Opp <I>intajl</I>.", "0"],
["kamero", "kamer-o", "[UV] (<I>ĉambreto senfenestra</I>), <B>1</B> small dark room, e.g., box-room, camera obscura. <B>2</B> (<I>senluma kesteto,</I> hence = <I>fotografilo</I>), Camera. <I>~o balga, elektronika, stereoskopa</I>. <B>Fald~o</B>, <B>Man~o</B>, <B>Stativ~o</B>. <B>~isto</B>, c-man. <B>3</B> (mil) chamber (of gun). <I>Ses~a revolvero</I>. <B>~eto</B> (anat) (<I>ventriklo) de la koro</I>. ➞ <I>ĉambr, fotil</I>.", "0"],
["Kameruno", "Kamerun-o", "CM.", "0"],
["kamforo", "kamfor-o", "[UV] Camphor, ~arbo (<I>Camphorus</I>). <B>~a</B>, -ic. ~(iz)ita, -ated. -oleo.", "0"],
["kamiono", "kamion-o", "[OA-8], camion, low flat four- wheeled truck or cart for heavy goods, dray, lorry. <I>Ŝut~o</I>, tip-waggon. <B>~isto</B> (<I>ŝoforo de ŝarĝaŭto</I>).", "0"],
["kamizolo", "kamizol-o", "[UV] (wide sense) camisole, woman’s underbodice, often embroidered or trimmed with lace. ➞ <I>tunik, vest</I>.", "0"],
["kamloto", "kamlot-o", "[UV] (tex) camlet, light cloth for cloaks, etc. Originally from camelhair and silk.", "0"],
["kamo", "kam-o", "(mec) Cam, projecting pt of wheel. ~o <I>cilindra, inversa, juga, konusa, pozitiva, tanĝanta, triangula</I>. ~o necentra, off-centre c. ~o fronta, face c.", "0"],
["kamomilo", "kamomil-o", "[UV] chamomile; ordinary language for various species of <I>antemido</I> and <I>matrikario</I>.", "0"],
["kampaneto", "kampanet-o", "(<I>ŝtalharmoniko</I>), glockenspiel. Variants: k. vitra, tubofono, vibrafono.", "0"],
["kampanilo", "kampanil-o", "(arch) campanile, bell- tower, especially one detached from main building. ➞ <I>belfrid, sonorila turo</I>.", "0"],
["kampanjo", "kampanj-o", "<B>~i</B>, (mil) (pol), campaign, organized course of action.", "0"],
["kampanulo", "kampanul-o", "(a. <I>~olo</I>), bell-flower (<I>Campanula</I>) (4 FA 10/29). C. <I>medium</I> is the \"Canterbury bell\". <B>~eto</B> (<I>~o rondfolia</I>), hare-bell (the \"bluebell\" of Scotland). ➞ <I>endimion, hiacint, rapunkol, skil, trakeli</I>.", "0"],
["kampeĉo", "kampeĉ-o", "campeachy, logwood tree (<I>Haematoxylon campechianum</I>). ~a <I>ligno,</I> logwood.", "0"],
["kampo", "kamp-o", "[UV] Field, expanse of land, meadow. <B>1</B> (<I>tero kultivita); gren~o, gres ~o, riz~o</I>. 2 (<I>ejo, tereno): batal~o, flug~o, tend~o</I>. <B>f</B> area, f., scope, sphere. <I>~o de forto, gravito</I>. (el) <I>~o alterna, magneta, magnetiga, rotacia, vektora, vida</I>, alternating (magnetic, magnetizing, rotating, vector) f. (her) <I>Blazon~o. ~o de agado, diskuto, laboro, servo</I>. <B>~(ar)a</B>, country, rural, rustic. <I>~a floro, muso, vojo</I>. <B>~ado</B>, camping. ~adi, (en)camp. ~adejo, camping-ground. <B>~aro</B>, (open) country, land. <I>~arano</I>, countryman, peasant. ~(labor)isto, f-labourer, tiller of soil (Ge 25/27). <B>~ulo</B>, -isto, rustic, swain, man of the fields. ~ulino, land girl. ➞ <I>fak, fon, parcel, sfer, tendar, zon</I>.", "0"],
["kamufli", "kamufl-i", "<B>~(aĵ)o</B>, camouflage, disguise by deceptive appearance. <B>~ilo</B>.", "0"],
["kanabeno", "kanaben-o", "<I>[OA],</I> linnet (<I>Carduelis cannabina</I>).", "0"],
["kanabo", "kanab-o", "[UV] Hemp (<I>Cannabis</I>). <B>~a</B>, -en. <I>~aj folioj</I>, marijuana, <I>~a semo</I>, h-seed. <I>~a tola</I>, -en cloth, canvas. <B>~aĵo</B>, rope- ends, etc. ~ejo, h-field. <B>~fumaĵo</B> (<I>haŝiŝo</I>), hashish. ➞ <I>kanvas</I>.", "0"],
["Kanado", "", "[OA-8] CA.", "0"],
["kanajlo", "kanajl-o", "[UV] (<I>malnobla fripono</I>), Blackguard, knave, rascal, scamp, villain. <B>~a</B>, b-ly, k-ish, r-lly, v-ous; low, smutty, vulgar. <I>~aj homoj</I>, children of Belial (Jĝ 20/13). <B>~aĵo</B>, dirty deal, low-down trick. <B>~aro</B>, rabble, rag tag and bobtail, riff-raff, scum of the populace. ~ino, hussy, jade. ➞ <I>fripon</I>.", "0"],
["kanalo", "kanal-o", "<B>[OA]</B> (<I>akvokondukilo</I>), Canal, artificial water-channel (-course), aqueduct, conduit, etc. (Ge 30/38). <I>~o irigacia</I>. <B>~aro</B>, c-system. <B>~eto</B>, ditch, drain, duct, gutter, rill, trench. <I>~~o spira, uretra</I>. <B>~igi</B>, -ize (<I>riveron</I>), convert into a c. <B>~izi</B>, -ize, furnish with canals (waterways). ➞ <I>kanel, kloak, tub</I>.", "0"],
["kanao", "kana-o", "(bot) canna (<I>Canna). 11 inda ~o,</I> Indian bead.", "0"],
["kanapo", "kanap-o", "[UV] couch, settee, sofa with half-back and one head-end. ➞ <I>divan, sof</I>.", "0"],
["kanario", "kanari-o", "[UV] Canary (<I>Serinus canarius</I>). ~o savaĝa. <B>~kolora</B>, c-yellow. ➞ falar, tropeol.", "0"],
["kanbirdo", "", "<B>(akrocefalo), W</B>arbler <B>(<I>Acrocephalus</I>).</B> ~o akvama, aquatic w. ~o marĉa, marsh warbler. ~o scirpa, reed w. ➞ <I>silvi</I>.", "0"],
["kancelario", "kancelari-o", "[UV] Chancery, office of public records. <B>~ano</B>, <B>~isto</B>, c. official or clerk. ➞ <I>kont, kontor, oficej</I>.", "0"],
["kanceliero", "kancelier-o", "[UV] (wide sense), chancellor, minister of state, state or law official. ➞ <I>financestr</I>.", "0"],
["kancero", "kancer-o", "(bot) (med) cancer. ~i (<I>esti ~a</I>). ~ulo. ➞ <I>kankr</I>.", "0"],
["kandelabro", "kandelabr-o", "<B>[OA]</B> (<I>kandelingaro</I>), Candelabrum (El 25/31; Da 5/5). <B>~a</B>, branched (of candelstick). ➞ <I>lustr</I>.", "0"],
["kandelo", "kandel-o", "[UV] <B>1</B> Candle, waxlight. <I>Nokta ~o</I>, night-light. <I>~o altara, Kristnaska, seba stearina, vaksa</I>.<B> <I>2</I></B> (<I>unuo de lumintenso</I>), c-power. <I>Cent~a lumo</I>. <B>~eto</B>, dip, taper. <B>~ingo</B>, [UV] c-stick, sconce. ~(far)isto ~(vend)isto, chandler. ~brilo, c-light. ~festo, Candlemas (2 Feb). ➞ <I>lumen, sparkil</I>.", "0"],
["kandidato", "kandidat-o", "[OA] Candidat/e (for office or honour), applicant, aspirant. <B>~i</B> (<I>al, por</I>), apply for, aspire to, seek to obtain, be (stand as) a c. for. <B>~eco</B>, -ure. ➞ <I>ambici, aspir, cel, ekzameniĝ, sin prezent</I>.", "0"],
["kando", "kand-o", "[UV] Candy. <I>Suker~o</I>. <B>~i</B>, (coat with) c. <I>~ita (citron)ŝelo</I>, -ed peel. <B>~iĝi</B>, c. crystallize.", "0"],
["kanelo", "kanel-o", "\" Groov/e; chamfer, channel, fluting, thread, rifle (of gun), worm (of screw or nut). <I>~o de gramofona disko. ~o helica, rekta</I>. <B>~ado</B>, g-ing. <B>~aĵo</B>, moulding. <B>~igi</B>, score. ➞ <I>ĉiz, fold, sulk, strek</I>.", "0"],
["kanguruo", "kanguru-o", "(ordinary language) Kangaroo (technical language <I>mak- ropo</I>). Arba ~o (<I>dendrolago</I>), tree k.", "0"],
["kanibalo", "kanibal-o", "[OA] Cannibal, <B>~eco</B>, <B>~ismo</B>, -ism.", "0"],
["kanino", "kanin-o", "= kojndento, eye-tooth.", "0"],
["kanistro", "kanistr-o", "canister, small can or box, usually of metal (for tea, shot, etc.).", "0"],
["kanjono", "kanjon-o", "canyon, deep gorge or ravine formed by river. ➞ <I>fjord, ravin</I>.", "0"],
["kankano", "kankan-o", "(dance) cancan.", "0"],
["kankro", "kankr-o", "[UV] crayfish (various species, <I>astako, kamburo, palinuro</I>, etc.). (astr) Crab (K 236/4). ~a <I>tropiko</I>. ➞ <I>kancer, krab</I>.", "0"],
["kankromo", "kankrom-o", "(orn) boat-bill (<I>Cancroma cochleria</I>).", "0"],
["kano", "kan-o", "[UV] Cane, Reed. <B>1</B> stem of large reeds or grasses (Ij 8/11). <I>Bambu~o, suker~o,</I> bamboo (sugar) cane. <I>Aroma ~o</I> (El 30/23). <B>~aro</B>, <B>~ejo</B>, bed of reeds (Ge 41/2). ~plektita (~reta) seĝo, c-bottomed chair. <B>2</B> (<I>bastono</I>): c., switch, walking-stick, rod. <I>Bati per ~o</I> (Se 23/13-14). ➞ <I>vering</I>. <B>Fiŝ~o</B>, fishing-rod. <B>Skrib~o</B>, reed-pen. f <I>Sin apogi sur ~o rompita</I>. ➞ <I>ant, fragmit, kareks, junk, rotang, tifa</I>.", "0"],
["kanoniko", "kanonik-o", "[OA] (rel) Canon, member of cathedral chapter. <B>~a</B>, -ical. <B>~aro</B>, chapter. <B>~(ar)ejo</B>, chapter house, <B>~ino</B>, -ess.", "0"],
["kanonizi", "kanoniz-i", "canonize.", "0"],
["kanono", "kanon-o", "<B>[OA]</B> (<I>pafilego</I>), Cannon, (mounted) Gun. <I>~o kampa, peza, rapidpafa, siege, ŝipa. ~o kontraŭ-aviadila, -tanka</I>. <B>Bomb~o</B>, mortar. <B>~ado</B>, c-ade, g-fire. <B>~aro</B>, artillery, ordnance. <B>~isto</B>, gunner. <B>~kuglo</B>, c-ball. -pordo, g-port. <B>~ŝipo</B>, g-boat. ➞ <I>haŭbiz, karambol, mitral</I>.", "0"],
["kanono", "kanon-o", "Canon <B>1</B> (mus) composition in which one voice follows another in strict imitation. <I>-o kunfina, senfina</I>, <B>2</B> en <B>1</B> (<I> = du voĉoj, unu temo</I>), inversakcenta, (mal)longa, sekvenca (ronda). Retro-o, \"cancrizans\". ~a <I>imitado</I>. <B>2</B> church decree. <B>3</B> (Bb) list of accepted books. <B>4</B> fundamental standard of authority, rule laid down, prescribed. <B>~a</B>, -ic<B>al</B>, authorized. <I>~a juro</I>, c. law. <B>~eco</B>, -icity, validity. <B>~isto</B>, -ist.", "0"],
["kanoto", "kanot-o", "vaguely = light open boat, dinghy; once used for <I>canoe</I>. ➞ <I>bark, boat, gondol, kanu, korakl</I>.", "0"],
["kantalupo", "kantalup-o", "cantaloup, small species of musk melon with reddish-orange flesh.", "0"],
["kantarelo", "kantarel-o", "(<I>ovofungo</I>), chanterelle, yellow edible fungus (<I>Cantharellus</I>).", "0"],
["kantarido", "kantarid-o", "[UV] sailor (soldier) beetle (<I>Cantharis) &gt;</I> blister beetle, Spanish fly. <I>a plastro</I> (1 FA 85/2).", "0"],
["kantato", "kantat-o", "[OA] cantata, choral work (drama or oratorio), not acted.", "0"],
["kanti", "kant-i", "[UV] Sing, carol, (birds) warble, etc.: <I>~i pro ĝojo. ~i ~on</I> (El 15/1). <B>f</B> <I>Abelo, rivero, ŝpinilo, vento ~as. Ofte ~as la buŝo, kiam ploras la koro</I>. <B>2</B> Celebrate in verse; hymn, praise: <I>~i al Dio. Armojn mi kantas (Eneido</I>). <B>~o</B>, Song, ballad, lay, melody, words with music. <I>~o senvorta</I>. Alta ~o (Bb), S. of SS. <B>Ĉas~o</B>, hunting-s. <B>Funebra ~o</B>, dirge. <B>Lul~o</B>, lullaby, berceuse. <B>Marista ~o</B>, shanty. <B>Moko~o</B> (Jes 14/4). <B>Plor~o</B>, lament, (Bb) Lamentations. <B>Religia ~o</B>, sacred song. <B>Rond~o</B>, <B>Ĉen~o</B> (<I>senfina kanono</I>), (mus) round, ~~o vortluda, catch. <B>Sorĉ~o</B>, incantation. <I>Am~o, bird~o, cigno~o, laŭd~o, part~o, popol~o, sol~o</I>. <B>~aĉi</B>, squall. <B>~aro</B>, (<I>~libro</I>), song-book. <B>~egi</B>, bawl, <B>~eti</B>, hum, sing snatches, <B>~isto</B>, -er, vocalist. <B>~istaro</B> (horo), choir, <B>~birdo</B>, sing-bird, warbler. <B>~societo</B>, choral society. <B>Antaŭ~i</B>, rehearse, try over. <B>ek~i</B>, [UV] break into song, strike up. <B>Pri~i</B> (<I>-n</I>), sing about, make a song of (Mi 2/4). <I>Pri-kantanto</I> (4 FA/212). <B>Re-aĵo</B> (<I>refreno</I>), chorus, refrain (PI 3/14). <B>Plor~i</B>, lament (Am 5/1). <B>Trem~i</B>, sing tremolo. <B>Zum~i</B>, <I>~i duonvoĉe</I>, hum. ➞ <I>blek, ĉant, ĉirp, himn, kanzon, kantor, pep</I>.", "0"],
["kantiko", "kantik-o", "(<I>kanto liturgia</I>), Canticle, e.g., <I>Venite, Magnificat, Te Deum</I>. <B>~aro</B>, \"Service\". ➞ <I>himn</I>.", "0"],
["kantilevro", "kantilevr-o", "(bid) Cantilever (overhung suspension). <I>~a argano, ponto</I>, c-crane (-bridge).", "0"],
["kantino", "kantin-o", "canteen (barracks or factory cafe).", "0"],
["kantono", "kanton-o", "[OA] (geog) canton. <B>1</B> Swiss. <B>2</B> French.", "0"],
["kantoro", "kantor-o", "[UV] precentor, leader of church choir. <I>~a (flanko</I>), cantor-ial, -is. Vic<B>~o</B>, succentor. Opp <I>dekan</I>.", "0"],
["kanulo", "kanul-o", "(med, surg), cannula, douche -(injection-)tube, nozzle.", "0"],
["kanuo", "kanu-o", "(many species), canoe: small light keelless open boat propelled by paddle(s).", "0"],
["kanuto", "kanut-o", "(<I>granda kalidro</I>), (orn) knot (<I>Calidris canutus</I>).", "0"],
["kanvaso", "kanvas-o", "[UV] canvas (wide sense), strong hemp or other coarse cloth. <I>~o artista, tega. ~</I>a <B><I>ŝ</I></B><I>ua</I>. ➞ <I>velaĵ</I>.", "0"],
["kanzono", "kanzon-o", "[OA-8], chanson, little song, ballad, usually with refrain. <B>~eto</B>, -ette, ditty. ➞ <I>kant</I>.", "0"],
["kaolino", "kaolin-o", "(<I>porcelana tero</I>), kaolin, china clay.", "0"],
["kapabla", "kapabl-a", "(<I>je, por; -i</I>), [UV] Capable (of -ing); Able (to); fit (qualified) for; competent, efficient, equal to, gifted. <B>~(ec)o</B>, (cap)ability, etc., power, talent. <I>~o instrui (por instruo</I>). <B>~i</B>, be (cap)able. <I>Ŝi nenion ~as</I>. <B>~ulo</B>, capable person. <B>Mal~a</B>, <B>Ne~a</B>, in-c, un-a, incompetent, unfit, unqualified. <B>Sen~a</B>, without talent. <B>Pens~a</B>, intelligent. <B>Servo~a</B>, able-bodied, fit for service. <B>Ŝarĝ~o</B>, carrying capacity. ➞ <I>geni, kompetent, pov, taŭg</I>.", "0"],
["kapacito", "kapacit-o", "Capacit/y. <B>1</B> (<I>enhavkapablo</I>), possible content, load. <I>~o de vazo</I>. ➞ <I>tonelar, volumen</I>. <B>2</B> (<I>produktivo</I>), power of production. <B>3</B> (el) (a. ~anco), -ance, measure of c. <B>~anco <I>de kondensilo, de</I></B> <B><I>konduktilo</I></B>. ➞ <B><I>kapabl</I></B>.", "0"],
["kapei", "kape-i", "(mar) sail under bare poles, lie to.", "0"],
["kapelo", "kapel-o", "[UV] (bid) Chapel, subordinate church, or pt of church; private church of institution or residance. <I>Tombeja ~o</I>. ~ano (<I>~a pastro</I>), chaplain.", "0"],
["kaperi", "kaper-i", "(<I>rabi korsare</I>), capture (make a prize of) at sea. <B>~isto</B>, freebooter, pirate. <B>~ŝipo</B>, corsair, privateer. ➞ <I>korsar, pirat</I>.", "0"],
["kapibaro", "kapibar-o", "capybara, water-cavy, water-pig (<I>Hydrochoerus</I>).", "0"],
["kapilara", "kapilar-a", "(<I>harforma</I>), Capillary, hairlike, with very minute internal diameter. <I>~a altiro</I>, c. attraction. <I>~a dukto</I>, (anat) c.", "0"],
["kapitalo", "kapital-o", "[OA] (fin) Capital, assets, funds, property, stock. <I>Engluti, havi, investi, posti, lasi, rezervi ~on</I>. <B>Spez~o</B>, cash reserve, working-c. <B>f</B> capitalists (collectively). <B>~a</B> <I>konto</I>, c a/c. <B>~igi</B>, -ize. <B>~ismo</B>, <B>~isto</B>. ➞ <I>ĉefurb, hav, kas, posedaj, riĉ</I>.", "0"],
["kapitano", "kapitan-o", "[UV] Captain. ➞ <I>rotestro, sixpestro, ĉefo, estro</I>.", "0"],
["kapitelo", "kapitel-o", "[UV] (arch) capital, head of pillar or pilaster (Am 9/1; Ce 2/14).", "0"],
["kapitolo", "kapitol-o", "capitol. <B>1</B> Roman. <B>2</B> USA congress-house.", "0"],
["kapitulaci", "kapitulac-i", "(nt), [UV] Capitulat/e, surrender on terms, <B>f</B> (sp) give up, resign. <B>~o</B>, -ion.", "0"],
["kapo", "kap-o", "[UV] <B>1</B> (anat) Head: <I>De ~o ĝis piedoj. Stari sur la ~o. Balanci, klini, levi, skui la ~on</I>. <B>2</B> (individual): <I>Kalkuli ~ojn, (laŭ~e</I>), count heads. <I>Kiom da ~oj, tiom da opinioj. Meti sur (ies) ~on</I>, hold responsible for. <B>3</B> brains, (presence of) mind, intelligence: <I>~o plena, obstina, saĝa. Multo en ~o, sed nenio en poŝo. Venis al mi en la ~on</I>, It occurred to me. <I>Perdi la -on</I>. <B>4</B> chief: <I>~o de la familio</I>. <B>5</B> head, top, upper (fore, front) part; button, knob, etc.: <I>~o de arbo, bastono, brasiko, kometo, kompaso, lito, martelo, monero, muziknoto, paliso, pajlo, paĝo, papavo, pinglo, sago, tamburo</I>. Butt (<I>kolbo</I>); cape (<I>ter~o, kabo</I>); peg box (vn); toe-cap (<I>ŝuo</I>). <B>~a</B>, mental, (of the) head. <I>~a doloro, laboro. Blank~a, griz~a, nud~a. Dik~a</I>, block- headed, stupid. <I>~a registro, voĉo</I>, falsetto, head-voice. <B>~aĉo</B>, noddle, pate. <B>~aĵo</B>, head-piece. <I>Plat</I><B><I>~</I>ulo</B>, flat-head, shallow-pate, -loko, head of bed (1 Rĝ 19/6). <B>~vesto</B>, h-dress. <B>En~igi</B>, get (take) into one’s h. <B>Sen~a</B>, headless. <B>~~igi</B>, behead, (<I>arbon</I>) pollard. <B>Trans~iĝi</B>, turn somersault, tumble head over heels. ➞ <I>cerb, ĉap, ĉapel, ĉef, kab, kapitel, krani</I>.", "0"],
["kapoko", "kapok-o", "kapok, fibre round seeds of the silk cotton tree (<I>Ceiba</I>).", "0"],
["kapolo", "kapol-o", "<B>1</B> tallow-drop (jewel). <B>2</B> (cy) <I>~o ruĝa</I>, red reflector. <B>3</B> stud-nail.", "0"],
["kapono", "kapon-o", "[UV] capon, castrated cock.", "0"],
["kaporalo", "kaporal-o", "[OA] (mil) corporal.", "0"],
["kaporo", "kapor-o", "[UV] Caper, flower-bud of -arbo, c-bush (<I>Capparis spinosa</I>).", "0"],
["kapotasto", "kapotast-o", "(mus) capotasto, barre (of guitar, etc.).", "0"],
["kapoto", "kapot-o", "[UV] (<I>kapuĉmantelo</I>), <B>1</B> capote, large cloak with hood. <B>2</B> (tech) covering, hood (collapsible or fixed); bonnet (of car).", "0"],
["kapreolo", "kapreol-o", "[UV] Roe-deer (<I>Capreolus</I>). ~ido, roe-kid. Vir<B>~o</B>, roe-buck.", "0"],
["kaprico", "kapric-o", "[UV] Capric/e, <B>1</B> unaccountable change of mind or conduct; freak, vagary, wantonness (Ge 49/6). <I>~oj de la modo</I>. <B>2</B> (mus) C. <B>~(em)a</B>, -ious, fitful, incalculable, inconstant, wayward, whimsical. <I>~a infano, modo, sorto, virino</I>. ~i (<I>havi ~ojn</I>), be -ious. <B>~eto</B>, crochet, fad. <B>~ulo</B>. ➞ <I>fantazi, maniet, Strang</I>. <B>Rim</B>.: Curious use of <I>~i, ~o</I> (No 11/4, 34): Moffat and RSV = <I>crave for, craving</I>.", "0"],
["kaprifolioj", "kaprifoli-oj", "honeysuckle fam. (2 FA 12/23, <B>4</B> FA 10/13) &gt; <I>lonicer, sambuk, viburn</I>.", "0"],
["kaprikorno", "kaprikorn-o", "(astr) <I>Capricorn</I> (a. <I>kapro</I> K 236/4). ~a <I>tropiko</I>.", "0"],
["kaprimulgo", "kaprimulg-o", "(orn) nightjar, \"goatsucker\", whip-poor-will (<I>Caprimulgus</I>).", "0"],
["kaprioli", "kapriol-i", "(<I>kaprosalti</I>), caper, frisk, gambol, leap about, prance. <B>~o</B>, <B>~a</B>, antic.", "0"],
["kapro", "kapr-o", "[UV] Goat (<I>Capra). ~o hejma, sovaĝa</I>. <B>Alpa ~o</B>, Alpine ibex, (astr) Capricorn (K 236/4). <B>f</B> <I>~o pekoporta, propeka,</I> scape-goat. <B>~a</B> <I>felo</I>, g-skin. <B>~ido</B>, kid. <B>~ino</B>, nanny-g. <I>~ina lakto</I>, g’s milk. <B>~oledo</B>, kid. <B>Vir~o</B>, buck. ➞ <I>antilokapr, boselaf, kapreol, ibeks, oriks, tragelaf</I>.", "0"],
["kapselo", "kapsel-o", "shepherd’s purse (<I>Capsella bursa-pastoris</I>).", "0"],
["kapsiko", "kapsik-o", "(<I>Capsicum</I>), name of various \"peppers\" (red or green, round or long). <B>~eto</B>, chilli. The powdered pods and seeds of C. <I>annuum</I> are called <I>papriko</I>, or <I>Kajena (ruĝa) pipro</I>.", "0"],
["kapstano", "kapstan-o", "(<I>vertikala vinĉo</I>), capstan, winding gear. ~o <I>ankra, mana</I>. ➞ <I>krik, vind</I>.", "0"],
["kapsulo", "kapsul-o", "[UV] Capsule (wide sense), cap for bottles; cap (firearms); (bot) dry seed-case; (pharm) shell containing drug. ~o <I>amela, gelatina</I>. <B>Eksplod~o</B>, detonator. <B>~i</B>, cap (seal) bottle, etc.", "0"],
["kapti", "kapt-i", "(<I>-n</I>) <I>[UV],</I> Capt/ure, Catch. <B>1</B> (<I>ek~i</I>): Lay (take) hold of, clutch at, grasp, grip, seize, snatch: <I>Dronanto herbeton ~as avide. ~i (iun) ĉe la brako, je la vesto, per la mano. ~i pilkon</I>. <B>f</B> (<I>plenigi): ~is min kolero, timo. (Surprizi, trafi</I>): take unawares, surprise, come suddenly. <I>~is nin pluvo, ŝtormo, ventego. ~i iun ĉe la ago</I>. <B>2</B> c., apprehend, ensnare, get. <I>~i birdon, fiŝon, ŝakpecon, ŝteliston. Virina rideto pli ~as, ol reto</I>. <B>3</B> (<I>logi</I>): captivate, win. <I>~i okulon, rigardon. ~i per flataj vortoj</I>. <B>4</B> (get, obtain, receive): <I>~i la sencon de parolo</I>. <I>~i atenton, malvarmumon, melodion. (phot) ~i grupon. <B>Kapt!</B> Got you! etc. <B>~o</B>, c., seizure, etc. <B>~aĵo</B> (</I>predo<I>), booty, loot, plunder, prey, spoil. <B>~ema</B>, <B>1</B> (avida</I>). <B>2</B> (<I>insida), <B>~iĝi</B> (implikiĝi), get caught. <B>~ilo</B>, [UV] pitfall, gin, snare, trap. ➞ falil, insid, ret</I>. Bird~ilo, mus~ilo, pied~ilo<I>. <B>~(in)isto</B>, trapper, <B>~into</B>, -or. <B>~ito</B>, -ive, prisoner,</I> <B>Milit~ito</B>, <I>p-er of war</I>. <B>~iteco</B>, <I>captivity (Ob/11). <B>~oludi</B>, play c., tag. <B>For~ita</B> (Ps 53/6, Am 6/7). <B>Mal~i</B></I> (<I>malteni</I>), <I>let go. <B>Ne~ebla</B>, impregnable. <B>Re~i</B>, recapture, get back. <B>Ŝnur~i</B></I> (<I>hokfiŝi</I>). <I>➞ ensorb, kurating</I>.", "0"],
["kapuceno", "kapucen-o", "[UV] capuchin monk.", "0"],
["kapuĉo", "kapuĉ-o", "[UV] Hood, cowl. <B>1</B> (cl) <I>~o monaĥon ne faras</I>. 2 (obj) hood of vehicle. <B>Kamen~o</B>, <B>turn~o</B>, <B>vent~o</B>. ➞ <I>kapot</I>.", "0"],
["kapuso", "kapus-o", "(mar) head (course), (opt) <I>~linio</I>, zero alignment.", "0"],
["kara", "kar-a", "[UV] Dear (wide sense) <B>1</B> (<I>amata</I>), Lov/ed, beloved, cherished: <I>~a filo, lingvo, patro</I>. <B>~ega</B>, darling. ~ul(in)o, d. one, beloved, darling, love. ~memora, of precious memory. <B>2</B> (<I>alte ŝatata, grandvalora</I>), highly esteemed, precious, valuable, valued: <I>~a amiko, sinjoro, objekto (2</I> Kr 36/19); <I>oleo</I> (Jes 39/2); <I>saĝo</I> (Se 3/15). <I>Mia ~a</I>, my d., my good fellow. <B>3</B> (<I>altpreza, multekosta</I>), costly, expensive, high-priced: <I>~a hotelo, manĝo. Aĉeti, ami, kosti, pagi</I> <B>~e</B>. <B>Mal~a</B>, cheap, low-priced. <B>Ne~a</B>, inexpensive, reasonable. <B>Pli~iĝi</B>, rise in price. <B>Tro~igi</B>, overcharge, overprice.", "0"],
["karabeno", "karaben-o", "[UV] (mil) carbine, short rifle for cavalry, <B>~isto</B>, carabineer.", "0"],
["karabo", "karab-o", "ground-beetle (<I>Carabus</I>). ➞ <I>skarab</I>.", "0"],
["karadrio", "karadri-o", "(<I>Charadrius</I>), (orn) (Ringed) Plover. ~o blankbrusta, Kentish p. ~o malgranda, little r-p. Montara -o, dotterel. ➞ <I>vanel</I>.", "0"],
["karafo", "karaf-o", "[UV] Carafe, glass water-bottle for table. ➞ <I>flakon</I>.", "0"],
["karageno", "karagen-o", "(<I>Irlanda fuko</I>), (<I>phar</I>) carragheen, Irish moss (<I>Chrondus crispus</I>). ➞ <I>cetrari</I>.", "0"],
["karakalo", "karakal-o", "caracal lynx (<I>Felis caracal</I>).", "0"],
["karakoli", "karakol-i", "<B>~o</B>, half-turn(-wheel) (horse or rider), to right or left.", "0"],
["karakterizi", "karakteriz-i", "(<I>-n</I>), [OA], Character/ize. describe as (the c. of). <B>2</B> be -istic of. <B>~a</B>, -istic, typical. <I>~a gesto, trajto</I>. <B>~aĵo</B>, -istic, idiosyncracy, peculiarity. ➞ <I>disting, mark, sign, stamp</I>.", "0"],
["karaktero", "karakter-o", "[UV] Character. <B>1</B> quality, category, kind, nature. <I>~o de stilo, verko. Gramatika ~o de radiko</I>. <B>2</B> (<I>ecaro</I>), habitual conduct (disposition), individuality, personality, reputation. <I>La ~o de Hamleto. ~o afabla, nobla, viva. Forto de</I> <B>~o</B>, backbone, moral strength. <B>Sen~a</B>, c-less, banal, ordinary, undistinguished, weak. <I>Sen~a pejzaĝo</I>. <B>Divers-a</B> (<I>heterogena</I>). ➞ <I>karakteriz, natur, reputaci</I>.", "0"],
["karamboli", "karambol-i", "(<I>nt</I>), [OA], (billiards) Cannon, collide, strike obliquely, <B>f</B> be jostled, knocked about (in a crowd), encounter. ➞ <I>kolizi</I>.", "0"],
["karamelo", "karamel-o", "[OA] caramel, \"burnt sugar\". Buter<B>~o</B>, butter-scotch.", "0"],
["karapaco", "karapac-o", "(zoo) carapace, upper shell. ~o <I>krokodila, testuda</I>. ➞ <I>kiras, krust, ŝel</I>.", "0"],
["karaso", "karas-o", "[UV] crucian carp (<I>Cyprinus carassius</I>). Or~o (<I>orfiŝo</I>), goldfish.", "0"],
["karato", "karat-o", "[OA] carat: of weight (jewels); of purity (gold).", "0"],
["karavano,", "karavan-o,", "[OA] Caravan. <B>1</B> company of desert travellers (Ge 37/25; Ij 6/19). <B>2</B> conducted travel party. <I>Kongresa ~o. [3 = ruldomo</I>]. ~a <I>gastejo, haltejo</I>, -sery. <B>~estro</B>, party leader.", "0"],
["karbo", "karb-o", "[UV] Coal, us <I>, = ŝton~o, ter~o. Ardantaj ~oj</I> (Se 6/28). <B>Bruna (ligna) ~o</B>, lignite. <B>Ost-o</B>, bone black, <B>f</B> <I>Fajraj ~oj</I> (Se <B>25/22</B>, Ro <B>12/20). ~a</B> <I>polvo</I>. <B>~e</B> <I>nigra,</I> c-black. <B>~ejo</B>, c-bunker(-cellar-hole). <B>~ero</B>, lump of c. (chem) <B>~ido</B>, -ide. <I>Kalcia ~ido</I> (CaC<SUB>2</SUB>). <I>~ida lampo. Hidro~ido,</I> hydro-carbon. <B>~igisto</B>, charcoal burner. <B>~iĝi</B> (cul) burn. <B>~izi</B> <I>ŝipon</I>. <B>~olo (</B><I>fenolo</I>), carbolic acid (C<SUB>6</SUB>H<SUB>6</SUB>OH). <B>~ujo</B>, c-scuttle (El <B>27/3). ~ŝton-(~hav)a</B>, c-bearing, carboniferous. <B>~ohidrato</B>, carbohydrate. <B>~minejo</B>, c-mine. <B>~(min)isto</B>, c-miner, collier, pitman. <B>~(vend)isto</B>, c-merchant. <B>~oleo</B>, kerosene. ➞ <I>antracit, bitum, karbon</I>.", "0"],
["karbono", "karbon-o", "[OA] Carbon (C), (for arc lamp) c-pencil. ~a <I>di-(mon-)oksido</I> (CO<SUB>2</SUB>,CO). <B>~ato</B>, -ate. <I>~atacido</I>, -ic acid. <I>Natria bi~ato</I>, sodium bi-ate. <B>~eca</B>, -aceous. <B>~igi</B>, -ize, character <B>~ilo</B>, -yl. <I>~ila klorido</I>, phosgene. <B>~izi (~kovri)</B> <I>paperon</I>. <B>Sen-a (</B><I>metalo</I>), soft metal. ➞ <I>karb, paper</I>.", "0"],
["karborundo", "karborund-o", "carborundum, <I>silicia karbido</I> (Si C).", "0"],
["karbunklo", "karbunkl-o", "(med) carbuncle, malignant tumour. ➞ <I>antraks, furunk</I>.", "0"],
["karbunkolo", "karbunkol-o", "(min) carbuncle, cabochon garnet, iron-aluminium-silicate.", "0"],
["karburi", "karbur-i", "(chem) Car bur/et, combine with carbon, (mt) -ize. (int. combustion engine) vaporize (fuel). <B>~ilo</B>, -ettor. <B>karcen-o</B>, shore crab (<I>Carcinus</I>).", "0"],
["karcero", "karcer-o", "[OA] <B>1</B> place of detention, punishment room. <I>Du horoj da ~o</I>, two hrs’ detention. <B>2</B> lock-up, cell, prison (Jer 20/2). <B>~ulo</B>, person in detention, jail-bird, prisoner. <B>En~igi</B>, incarcerate, detain, keep in. ➞ <I>arestej, cel</I>.", "0"],
["kardameno", "kardamen-o", "bittercress (<I>Cardamine</I>). <B>Kampa ~o</B>, cuckoo-flower, lady’s smock.", "0"],
["kardamomo", "kardamom-o", "cardamom, spice from seed capsules of various plants.", "0"],
["kardano", "kardan-o", "(mec) universal joint. <I>~a kuplilo, ŝafto</I>.", "0"],
["kardelo", "kardel-o", "[UV] (orn) goldfinch, thistle- finch (<I>Carduelis</I>). <B>~o flama</B>, redpoll. ~o flavbeka, twite. ➞ <I>fring, fringel, kanaben</I>.", "0"],
["kardi", "kard-i", "(tex) Card, comb (wool, flax, hemp), <B>~ilo</B>, -ing comb. <B>~isto</B>, -er. <B>~maŝino</B>, -ing machine. ➞ <I>dipsak, komb, taŭz</I>.", "0"],
["kardinalo", "kardinal-o", "[OA] <B>1</B> (re) Cardinal. <I>~a ĉapelo. ~a Moŝto</I>, Eminence. <B>~aro</B>, college of cardinals. <B>2</B> (orn) c-bird (<I>Cardinalis</I>).", "0"],
["kardio", "kardi-o", "(zoo) cockle (<I>Cardium</I>).", "0"],
["kardiografo", "kardiograf-o", "(med) cardiograph.", "0"],
["kardiogramo", "kardiogram-o", "(med) cardiogram.", "0"],
["kardo", "kard-o", "[UV] thistle (<I>Carduus</I>) (many species) ➞ also centaŭre, cirsi, dipsak, karlen, onopord, sonk [Ne= <I>kart, karton</I>].", "0"],
["kardono", "kardon-o", "(Hispana artiŝoko)<I>,</I> cardoon (<I>Cynara cardunculus</I>).", "0"],
["karekso", "kareks-o", "(bot) sedge (<I>Carex</I>) (many species). ➞ also <I>fragsrat, junk, kan</I>.", "0"],
["kareno", "karen-o", "(<I>ŝipsubo</I>), (mar) Careen, pt under water, <I>-a tabulo</I>, bottom-board. (av) planing board. <B>~i</B> (<I>Siport</I>), c., turn on one side for cleaning, etc.; heel over.", "0"],
["kareo", "kare-o", "(cul) curry.", "0"],
["karesi", "kares-i", "1 (<I>ame tuŝi: man~i</I>) caress, stroke, fondle, pet, touch fondly. <I>~i katon, barbon, lipharojn. ~i kontraŭ la haroj</I>, stroke the wrong way. <I>Hodiaŭ ~as, morgaŭ forgesas</I>. <B>f</B> cherish: <I>~i esperon, iluzion, revon</I>. <B>f</B> fall lightly on; <I>Lumo ~as muron, ondoj la strandon</I>. 2 favour, smile on. <B>3</B> cheer, comfort, solace, soothe. <I>la animon</I>, delight the soul (Ps 94/19). <B>~(ad)o</B>, affection, blandishment (Se 5/19). <I>Ne ekzistas ~o sen intereso</I>. <B>~(em)a</B> (<I>amema</I>), affectionate, clinging, endearing, fond, tender, winning. <I>~a tuŝo. ~aj vortoj</I>, loving words. <B>Mal~i</B>, bully, cuff, knock about, treat roughly. <B>Flat~i</B> (<I>kafoli</I>), cajole. <B>Pri~i</B>, lavish caresses on, make much of. ➞ <I>dorlot, tener</I>.", "0"],
["kargo", "karg-o", "(mar) Cargo, Freight, lading. <B>~i</B> <I>ŝipon</I>. <B>~ŝipo</B>, freighter.", "0"],
["kariatido", "kariatid-o", "(arch) caryatid, fem. figure as column.", "0"],
["kariero", "karier-o", "<I>[OA],</I> Career. <B>1</B> profession. <B>2</B> life<B>.</B> <I>Komenci sian ~on, ~o artista, scienca</I>. ~<B>ismo</B>, <B>~isto</B>. ➞ <I>okup, profesi</I>.", "0"],
["karikaturo", "karikatur-o", "[OA] Caricature, burlesque, ludicrous representation, parody, take-off, travesty. <B>~isto</B>, -ist. <B>~e</B>, in c.", "0"],
["kariljono", "kariljon-o", "(<I>sonorilaro</I>), (m.i.) carillon, set of bells.", "0"],
["kario", "kari-o", "(med) Cari/es, Decay (of bone or tooth). <B>~a</B>, c-ous, d-ed.", "0"],
["kariofilo", "kariofil-o", "[UV] Clove, flower-bud of ~arbo (<I>Caryophyllus aromaticus</I>). ~oleo, oil of cloves. ➞ <I>diant</I>. <B>~acoj</B>, pink fam..", "0"],
["kariolo", "kariol-o", "[OA] light two-wheeled carriage, dog-cart, trap.", "0"],
["karitato", "karitat-o", "(rel) charity, Christian love of fellow-men, benevolence, benignity, good-will <I>[</I><B><I>Ne = almozo]</I></B>.", "0"],
["karjo", "karj-o", "(bot) Hickory (<I>Carja</I>). ➞ <I>hikori, pekan. C. ovata</I> (shagbark h.) is the \"American walnut\" used for pianos and carriages.", "0"],
["karleno", "karlen-o", "Carline thistle (<I>Carlina</I>).", "0"],
["karmezino", "karmezin-o", "crimson, deep red, inclining to purple.", "0"],
["karmino", "karmin-o", "[UV] <B>~a</B>, carmine, crimson red, from cochineal or alizarin.", "0"],
["karmo", "karm-o", "(Bud) karma, doctrine of destiny, cause and effect.", "0"],
["karnavalo", "karnaval-o", "[UV] Carnival. <B>1</B> festival days before Lent. <B>2</B> riotous revelry.", "0"],
["karneolo", "karneol-o", "(min) carnelian, cornelian, red vrty of chalcedony.", "0"],
["karno", "karn-o", "[OA] Flesh. <B>1</B> (anat): of body (Ge 9/4, Se 5/11). <I>Ili estu unu ~o</I> (Ge 2/24). <I>Tibia ~o</I>, calf. <B>2</B> (<I>vivaĵo): Por ekstermi tiun ~on</I> (Ge 6/17). <B>f</B> <I>iri la vojon de tiu ~o (morti</I>). <B>3</B> Body (opposite spirit), natural man (Rom 8/5). <B>4</B> pulpy substance of fruit or plant: <I>~o de melono, pruno</I>. <B>5</B> offspring, stock: <I>Vi estas lia ~o, lia sango</I>. <B>~a</B> <I>brako</I>, arm of flesh. (2 Kr 32/8). <B>f</B> fleshly, carnal, gross, sensual. <B>~(ec)a</B>, <B>~(hav)a</B>, <B>~(plen)a</B>, <B>dik~a</B>, -y, meaty, plump. <B>~e</B>, in the flesh, carnally. <B>~ulo</B>, mortal. <B>~kolora</B>, f-tinted. <B>~omanĝa</B>, carnivorous. <B>~oŝiri</B>, rend. <B>~~a</B>, ravenous (Ge 49/27). <B>En~igi</B>, clothe in flesh, incarnate. <B>~iĝo</B>, <B>reen~iĝo</B>, (re)incarnation. <B>Sen~a</B>, fleshless. <B>Dent~o</B> (<I>gingivo</I>), gum. ➞ <I>viand</I>.", "0"],
["karobo", "karob-o", "[UV] carob, locust-bean, St John’s bread (Lu 15/16), fruit of ~arbo (<I>Ceratonia siliqua</I>).", "0"],
["karolo", "karol-o", "carol, joyous folk-song, usually seasonal and religious, especially for Christmas.", "0"],
["karoo", "karo-o", "(cgm) Diamond. ~a <I>reĝo,</I> king of dd.", "0"],
["karoserio", "karoseri-o", "coach-building. <B>~(ist)o</B>, coach-builder.", "0"],
["karoteno", "", "carotene, yellow colouring matter in cc. and other vegetables, and in butter.", "0"],
["karotido", "karotid-o", "(<I>kolarterio</I>), carotid.", "0"],
["karoto", "karot-o", "[UV] Carrot (<I>Daucus carota</I>).", "0"],
["karpelo", "karpel-o", "(bot) carpel.", "0"],
["karpeno", "karpen-o", "[UV] (bot) hornbeam (<I>Carpinus</I>).", "0"],
["karpeo", "karpe-o", "(<I>pojnostoj</I>), carpus, wrist-bones. <B>~a</B>, carpal.", "0"],
["karpo", "karp-o", "[UV] (ich) carp (<I>Cyprinus carpio</I>).", "0"],
["kartamo", "kartam-o", "(bot) bastard saffron, safflower (<I>Carthamus</I>).", "0"],
["kartav", "", "-i [UV] (<I>knarparoli</I>), speak with a burr. <B>~o</B>, guttural speech, exaggerated rolling of the \"r\".", "0"],
["kartelo", "kartel-o", "(<I>interkonsento</I>), (econ, pol), cartel, agreement for common action. ➞ <I>sindikat, trust</I>.", "0"],
["kartilago", "kartilag-o", "[UV] (anat) Cartilag/e, gristle, elastic tissue. <B>~eca</B>, <B>~oza</B>, -inous.", "0"],
["karto", "kart-o", "Card. <B>1</B> card, thick paper. <I>Domo el ~oj</I>. <B>Not~eto</B> (<I>slipo</I>). Vizit<B>~o</B>, visiting c. <B>2</B> correspondce c. <I>~o ilustrita, Kristnaska, poŝta. Duobla poŝt~o</I>, reply p.c. <B>3</B> (lud~o), playing-card. <I>Ludi ~ojn</I>. 4 (<I>manĝ~o, menuo</I>), bill of fare. <B>5</B> (better <I>mapo</I>), map. <B>(lud)~aro</B>, pack of cards. <B>~ludo</B>, c-game. <I>~ludantaro</I>, c-party. <B>~ujo</B>, c-case. ➞ <I>bilet, ĉart, map</I>.", "0"],
["kartoĉo", "kartoĉ-o", "[UV] Cartridge, ~ingo, c-belt (-holder). ~ujo, c-pouch. <I>~o senkugla,</I> blank c. ➞ <I>prajm, pulv</I>.", "0"],
["kartografio", "kartografi-o", "<B>[OA]</B> (<I>mapado</I>), cartography.", "0"],
["kartografo", "kartograf-o", "<B>[OA]</B> (<I>mapisto</I>), cartographer.", "0"],
["kartono", "karton-o", "[UV] Card-Board, paste-brd. Dika <B>~o</B>, mill-brd. Led<B>~o</B>, leather brds. Ond<B>~o</B>, corrugated c. Pajl<B>~o</B>, straw-brd. <I>~o asfalta, bituma, gudrita, tegmenta, ŝtona</I>. <B>~a</B> <I>skatolo</I>, carton. <I>~a masko</I>. <B>~i</B> (~e <I>bindi</I>). <B>~(bind)aĵo</B>, paper boards.", "0"],
["kartoteko", "kartotek-o", "(<I>= sliparo, slipujo</I>), card index.", "0"],
["kartuno", "kartun-o", "(des) cartoon. <B>1</B> large design. <B>2</B> drawing (humorous, political, topical).", "0"],
["kartuŝo", "kartuŝ-o", "[OA] cartouche. <B>1</B> (arch) scroll ornament, tablet, volute, often with inscription. <B>2</B> (ant) Egyptian oval with hieroglyphics.", "0"],
["karuselo", "karusel-o", "[UV] (sp) merry-go-round, roundabout. <I>[Ne= orgi]</I>, <B>f</B> <I>ĥaosaj pensoj ~is en lia kapo</I>.", "0"],
["karvio", "karvi-o", "Caraway (<I>Carum carvi</I>). <B>~a</B> <I>grajno, semo</I>, c-seed. <I>~a</I> (or <I>kumina) brando</I>, kummel. <I>~a kuko</I>, seed cake. <B>~oleo</B>. ➞ <I>kumin</I>.", "0"],
["kasacii", "kasaci-i", "(<I>nuligi</I>), Annul (legally), declare invalid, quash (decree, will, verdict). <B>~o</B>, -ment.", "0"],
["kasavo", "kasav-o", "cassava, preparation from <I>manihoto</I>. ➞ <I>manihot, maniok</I>.", "0"],
["kaserolo", "kaserol-o", "[UV] casserole, stewpan, heatproof vessel, usually of earthenware or glass, in which food is cooked and served. ➞ <I>bolpot</I>.", "0"],
["kasio", "kasi-o", "cassia (<I>Cinamomum cassia). ~a floro, semo, ŝelo</I> (El 30/24). ➞ <I>sena</I>.", "0"],
["kaskado", "kaskad-o", "(<I>akvofaleto</I>), Cascade, waterfall. <B>~i</B>, fall in cc.", "0"],
["kaskarilo", "kaskaril-o", "(pharm) cascarilla, bark of c. shrub (<I>Croton cluteria</I>).", "0"],
["kaskaro", "kaskar-o", "(<I>ramna ŝelo</I>), (pharm) cascara sagrada.", "0"],
["kaskedo", "kasked-o", "[OA 8], man’s peaked cap.", "0"],
["kasko", "kask-o", "[UV] Helmet (1 Sa 17/38; Ef 6/17). <B>Fera ~o</B>, steel h. <B>Friz~o</B>, hair-drier. <B>Lan~o</B>, Balaclava h. ~tufoj, plumes <I>[Ne= barelo]</I>.", "0"],
["kaso", "kas-o", "[UV] Cash. <B>1</B> (<I>monkesto</I>): c-box, moneybox, till. <I>~o senmona</I>. <B>2</B> fund, reserve, stock. <B>Lud~o</B>, kitty. <B>Regna ~o</B>, Treasury. <B>Ŝpar~o</B>, savings box. <B>~ejo</B>, <B>~tablo</B>, c-counter, pay desk. <B>~isto</B>, -ier, paymaster, treasurer. <B>~libro</B>, c-book. <B>En~aĵo</B>, c. in hand. <B>~~igi</B>, pay in. ➞ <I>buĝet, kontant, mon, spez</I>.", "0"],
["kasono", "kason-o", "(wide sense) (arch) (eng) (mil), caisson, diving-bell, sunk chamber, water-tight compartment. ➞ <I>merĝa kesto</I>.", "0"],
["kastanjeto", "kastanjet-o", "[Bat] <B>[OA]</B> (<I>klakilo</I>), (m.i.) Castanet.", "0"],
["kastelo", "kastel-o", "[UV] Castle. <B>1</B> fortified residence, lordly mansion. <I>~o surmonta</I>. f <I>~o en aero</I>. <B>2</B> stronghold, citadel, small fort. <I>~o kavalira, rabista. ~remparo, ~ruino</I>. 3 (mar) c. <B>Antaŭ~o</B>, fore-c. <B>Post~o</B>, quarterdeck. <B>~ano</B>, c-dweller. <B>~estro</B>, c-governor (Ne 7/2). <B>~urbo</B>, fortified town (Da 8/2). ➞ <I>citadel, ferdek, palac, poŭp, tur</I>.", "0"],
["kasto", "kast-o", "[OA] caste, <B>f</B> exclusive class (grade, order, rank). <I>~o (mal)alta</I>. Sam~ano. ~ismo (<I>~a sistemo</I>). ➞ <I>gild, klas, rang</I>.", "0"],
["kastoro", "kastor-o", "[UV] beaver (<I>Castor). ~o Kanada</I>. ~a <I>ĉapelo, felo, pelto</I>.", "0"],
["kastri", "kastr-i", "[UV] Castrate, emasculate, geld, <B>f</B> bowdlerize, deprive of vigour, expurgate, weaken. <B>~ito</B> (<I>eŭnuko). ~ita bovo,</I> bullock. <I>~ita ĉevalo</I>, gelding.", "0"],
["kasuaro", "kasuar-o", "(orn) cassowary (<I>Casuarius</I>).", "0"],
["kaŝi", "kaŝ-i", "(<I>-n, antaŭ, de, de antaŭ</I>) [UV] (Ge 4/14), Hide, Conceal, Secret/e (from), bury, keep s. <I>t(prisilenti</I>), suppress, pass over in silence; (<I>vuali</I>), cloak, cover, veil. <I>~ita al mi de li per kurteno</I>, hidden from me by him with a curtain. <B>~e</B>, furtively, in s., on the sly, out of sight. <B>~ado</B>, dissimulation. <B>~ebla</B>, <I>Tuso kaj amo ne estas ~eblaj</I>. <B>~eco</B>, obscurity. <B>~ejo</B> (<I>~angulo</I>), h-ing place, s. recess (1 Sa 23/23). ~ema, close, s-ive. <I>~emulo</I>, sly-boots. <B>~iĝi</B>, sin <B>~i</B>, h. one’s, lie hid (c-ed), skulk (Ge 3/8). ~ita, s., c-ed, hidden, latent, <B>f</B> cryptic, dark, <B>mystic, (mus) <I>~itaj kvintoj (oktoj</I>), hidden 5ths (Sves). <I>Mon~itaĵo</I>, hoard. Mal~i</B>, <B>disclose, discover, lay bare, reveal, unveil; (<I>perfidi</I>): betray, divulge, ~~c, openly, without c-ment. Mal~ema, Ne~ema</B>, <B>Sen~a</B>, <B>candid, communicative, frank, free, open, outspoken, plain, unreserved</B>. <B>Ne~ebla</B> (<B>Ne~ita</B>), <B>manifest, overt</B>. <B>Sin~emo</B>, <B>reserved, shy, keeping one’s in the background. <I>Sin~into</I>, stowaway. Tromp~i</B>, <B>suppress fraudently. ➞ <I>sekret</I></B>.", "0"],
["kaŝmiro", "kaŝmir-o", "(tex) cashmere, fine woollen cloth from Kashmir goat-wool.", "0"],
["kaŝtano", "kaŝtan-o", "[UV] Chestnut, fruit of <B>~arbo</B> (Castanea) (Sweet) c-tree. <I>~o rostita</I>. <B>~bruna</B>, <B>~hara</B>, <B>~kolora</B>, nut-brown. <B>Mar~o</B> = ekino. ➞ <I>hipokaŝtan, maron</I>.", "0"],
["kata", "kata-", "(Gk pfx, wide sense) cata-. <B>~bazo</B> (<I>malklimakso</I>), (rh) -basis, gradual descent. ➞ <I>batos</I>. <B>~klismo</B>, -clysm (➞ <I>katastrof</I>).", "0"],
["katafalko", "katafalk-o", "[OA] catafalque, decorated stage for coffin, open hearse.", "0"],
["katakombo", "katakomb-o", "[OA] catacomb (➞ <I>kript</I>).", "0"],
["katakrezo", "", "(rh) catachresis, incongruity; e.g., <I>vidi tondron (voĉon</I>) (El 20/18; Ap 1/12).", "0"],
["katalepsio", "katalepsi-o", "[OA] catalepsy. <I>~ulo</I>. ➞ <I>tetan</I>.", "0"],
["katalizo", "", "(chem) catalysis. <B>~aĵo</B>, <B>~anto</B>, <B>~ilo</B><I>, -ly</I>st. <B>~a</B>, -lytic.", "0"],
["katalogo", "katalog-o", "[OA] (<I>orda listo</I>), catalogue, <B>~i</B>, to c. ➞ <I>etat, indeks, inventor, registr, tabel</I>.", "0"],
["katalpo", "katalp-o", "catalpa (tree), Indian bean.", "0"],
["kataplasmo", "kataplasm-o", "[UV] (pharm) medicated plaster (poultice) to draw out inflammation, etc. <I>~o sinapa</I>, mustard p.", "0"],
["katapulto", "katapult-o", "(<I>ĵetpafilo</I>), catapult. <B>~i</B>.", "0"],
["katarakto", "katarakt-o", "[UV] (med) cataract, opacity of eye-lens. ➞ <I>glaŭkom</I>. [Ne= akvofalo, kaskado].", "0"],
["katario", "katari-o", "(<I>katherbo</I>), (bot) wild catmint (<I>Nepeta cataria</I>).", "0"],
["Kataro", "Katar-o", "QA.", "0"],
["kataro", "katar-o", "[UV] (<I>imflamo mukmembrana</I>), Catarrh. <B>Bronka ~o</B>, bronchial c. ~o intesta (<B><I>disenterio</I>);</B> Naza (<B><I>korizo</I>);</B> Stomaka (<B><I>gastrito</I></B>), Vezika (<B><I>blenoragio</I>).</B>", "0"],
["katastro", "", "= kadastro.", "0"],
["katastrofo", "", "[OA] catastrophe, sudden blow, disaster, ruin, terrible end. <B>~a</B><I>, -ic</I>, crushing, disastrous, overwhelming, shattering. ➞ <I>fatal, kataklism, sortobat</I>.", "0"],
["katedralo", "katedral-o", "[OA] (<I>katedra preĝejo</I>), cathedral, church with episcopal chair.", "0"],
["katedro", "katedr-o", "[OA] seat of authty or office, <B>1</B> University (professorial) chair, lecturer’s desk. <B>2</B> pulpit. <B>3</B> Bishop’s throne, see. <B>El~e</B>, <I>ex cathedra</I>, auth-tive. (<I>El~)a decido</I>, cathedral utterance, ruling from the chair. ➞ <I>podi</I>.", "0"],
["kategorio", "kategori-o", "[OA] <B>1</B> Categor/y, class, head, division, order, (lin) <I>Gramatika ~o</I>. ➞ <I>genr, grup, klas(if), rang</I>. <B>2 ~a</B>, -ical, absolute, down-right, explicit, positive, unconditional. <I>~a rifuzo</I>. <B>~e</B> <I>aserti</I>. ➞ <I>nepr</I>.", "0"],
["kateĥ(k)ismo", "", "Catech/ism, treatise for instruction by question and answer. <B>~isto</B>, [OA] -ist. ➞ <I>demandar, kompendi, kred</I>. <B>~IZI </B>, [OA] -ize, teach (examine) by question and answer. <I> ~ato</I>, -umen, neophyte.", "0"],
["kateno", "katen-o", "[UV] Fetter, Chain, shackle (for prisoners), <B> f</B> f., band, restraint, restriction, tie. <B> ~oj</B>, irons, chains (Ps 105/18). <B> ~i</B>, c., f., put in irons, <B> f</B> <I> Kiu donacon prenas, tiu sin ~as</I>. <B> ~ado</B>, catennation. <B> Kun~i</B>, shackle. <B>Mal~i </B> (<I>Sen~igi</I>). Free from fetters, liberate, loose, unchain. <B> Sen~a</B>, uninhibited. <B> Man~o</B>, handcuff, manacle. <B>Pied~o</B>, hobble-iron. ➞ <I>ten</I>.", "0"],
["katetero", "kateter-o", "(surg) Catheter, bougie. <B>~i</B>, -ize. ➞ <I>buĝi, dilat, sond</I>.", "0"],
["katguto", "katgut-o", "catgut.", "0"],
["katidido", "katidid-o", "(onom) katydid, name (USA) of various large green orthopterous insects.", "0"],
["katizi", "katiz-i", "(tex) Press, give Gloss (lustre) to material. <B>~o</B>, g., lustre, from p-ing, <B>Sen~igi</B>, take the gloss off, unglaze. <B>(mal)varm~i</B>, cold(hot) p. ➞ <I>amel, apretur</I>.", "0"],
["katlejo", "katlej-o", "cattleya, S-Am orchid.", "0"],
["kato", "kat-o", "[UV] Cat, puss. <B>1</B> (<I>feliso</I>), member of c-fam., e.g., lion, tiger, puma. <B>2</B> <I>~o doma, hejma</I>, domestic c. <I>~o arbara, sovaĝa</I>, wild c. (<I>F. silvestris). ~o (mal)longhara; Abisena, Birma, Ĉinĉila, Egipta, Manksa, Persa, Rusa, Siama</I>. <B>Panter~o</B> (<I>pardalo</I>), <B>~eca</B>, <B>~simila</B>, feline, -tish, -ty. <B>~ido</B>, kitten. <I>~idaro</I>, litter. <B>Kanjo</B>, pussy. <B>~inaĉo</B>, grimalkin, old she-c. <B>f</B> spiteful old woman. <B>~bleki</B>, caterwaul. <B>Vir~o</B>, Tom-c. ➞ <I>miaŭ, felis, panter</I>.", "0"],
["katodo", "katod-o", "(el) Cathod/e, negative pole, <I>-a radio</I>, c-ray.", "0"],
["katokalo", "katokal-o", "(ent) red underwing moth (<I>Catocala</I>).", "0"],
["katolika", "katolik-a", "[OA] Catholic. <B>1</B> all-embracing, of wide sympathies, general, universal, world-wide. <I>~a gusto, legado</I>. <B>2</B> (ecc) (<I>tutkristanara</I>), ecumenical. <B>3</B> (rc) of Roman Church, Romish, opposite <I>protestant</I>. ➞ <I>universal</I>. Rom~o.", "0"],
["katuno", "katun-o", "[UV] (<I>kotona tolo</I>), Cotton fabric <I>&gt; indieno, kalikoto, kretono, nankeno, perkalo</I>. <B>~a</B>, of c., print. <B>~aĵo</B>, c-goods. <I>Mebla ~o</I>, chintz, cretonne. ➞ <I>koton</I>.", "0"],
["kaŭcio", "kaŭci-o", "[OA] (jur) <B>1</B> Bail, Caution, security [N <I>t=averto, singardo</I>]. <B>~a</B>, c-ary. <B>2</B> on b., under bond. <B>~i</B> (<I>doni ~on</I>), give bail, go c. for. <B>~aĵo</B> (<I>~a mono</I>), security. ➞ <I>garanti</I>.", "0"],
["kaŭĉuko,", "kaŭĉuk-o,", "[OA] (India) Rubber<I>. Kruda ~o (latekso</I>). <B>~a</B> <I>arbo, bendo, fadeno. ~a mantelo</I>, mackintosh, waterproof. <I>~aj ŝuoj</I>. ➞ <I>edonit, gum, elast. Krepa ~o,</I> crepe rubber.", "0"],
["kaŭkalido", "kaŭkalid-o", "bur-parsley (<I>Caucalis</I>).", "0"],
["kaŭri", "kaŭr-i", "<I>[OA],</I> (<I>sidi surkalkane</I>). Crouch, sit <I>on one’s heels, squat</I>. <B>Tim~i</B>, <I>cower. <B>~iĝi</B>, (cat) crouch (for a spring</I>).", "0"],
["kaŭrio", "kaŭri-o", "<B>1</B> (<I>suda damaro</I>), kaŭri pine <B>(<I>Agathis australis</I>)</B>. <B>2</B> <B>= <I>monkonko</I></B>. ➞ <B><I>cipre</I></B>.", "0"],
["kaŭstika", "kaŭstik-a", "(<I>histokoroda</I>), Caustic, burning, corrosive. <B>f</B> biting, cutting, mordant, sarcastic, (chem) <I>~a potaso</I>, c. potash (KOH). <I>~a sodo</I>, c. soda (NaOH), <B>~aĵo</B>, c-substance. ➞ <I>brul, kaŭteriz, korod</I>.", "0"],
["kaŭterizi", "kaŭteriz-i", "[UV] Cauteriz/e, sear (with hot iron or caustic), kill the nerve (of tooth), render callous. <B>~aĵo</B>, c-ing substance. <B>~ilo</B> (a. <I>kaŭtero</I>), cautery (instrument).", "0"],
["kaŭzo", "kaŭz-o", "[UV] Caus/e. <B>1</B> (producing an effect). <I>de kolero, morto, milito</I>. <B>2</B> Reason, ground, motive, for action. <I>~o financa, por espero, plendo</I>. <B>~i</B>, [UV] c., be the c. of, bring about (on), effect, give rise to, induce, occasion. <I>~i akcidenton, doloron, elspezon, malpacon. Kio ~is, ke li iru</I> (made him go)? <B>~a</B>, oal, causative. <B>~e</B> (<I>sekve) de</I> (Ps 102/10), because (by r.) of, owing to. <B>~ado</B>, causation. <B>~eco</B>, c-ality. <B>Pra~o</B>, first c. <B>Sen~a</B> (<I>senbaza</I>), causeless, groundless. <I>~~a bato. ~~e plendi. Ne sen ~o</I>, not without reason. <B>Ŝajn~o (<I>pretendita</I> ~o) pretext</B>. <B>Tiu~e</B> (tial), for that r. ➞ <B><I>font, motiv, origin, pro, radik</I></B>.", "0"],
["kavalerio,", "kavaleri-o,", "[OA] Cavalry, horse-soldiers, mounted troops. <B>~ano</B>, -man.", "0"],
["kavaliro", "kavalir-o", "[UV] (wide sense) Knight, member of an order, Sir. Kruc<B>~o</B>, crusader. ~o migrants, k-errant. <I>~o de la Verda Stelo = Esperantisto</I>. <B>f</B> escort, protector. ~(ec)a, -ly, chivalrous, gallant. <I>~aj ludoj</I>, tournament. <B>~aĵo</B>, gallant act. <B>~eco</B>, k-hood, chivalry. ~ino, Lady, Dame. <B>~igi</B>, k. <I>~igo</I>, accolade. II (orn) <I>Akva ~o</I> (Stojan) = <I>totano</I>, redshank.", "0"],
["kavalkado", "kavalkad-o", "cavalcade, company of riders, procession on horseback.", "0"],
["kavao", "kava-o", "<B>1</B> (bot) kava (<I>Piper methysticum</I>). <B>2</B> intoxicating beverage from roots of this.", "0"],
["kavatino", "kavatin-o", "cavatina, short simple song, smooth melodious air.", "0"],
["kaverno", "kavern-o", "[UV] Cavern, natural cave in earth or rock (Ge 23/9). <I>Besta ~o</I>, denotes <B>~aĉo</B>, <B>f</B> dirty hole, hovel, pigstye, slum. ~(ec)a (<I>voĉo</I>), -ous. <B>~ulo</B>, cave man. ➞ <I>grot</I>.", "0"],
["kaviaro", "kaviar-o", "[UV] (cul) caviare.", "0"],
["kavio", "kavi-o", "cavy (<I>Cavia</I>); any of various ~edoj (short-tailed rough-haired S-Am rodents) &gt; ➞ <I>kobajo</I>, guinea-pig.", "0"],
["kavo", "kav-o", "[UV] Cav-e-ity, Hollow; hole, pit. ~o <I>de leonoj</I> (Da 6/7). ~o <I>en buĝeto, fromaĝo, pano</I>. <B>Aera ~o</B>, (av) air pocket. <B>Bituma ~o</B> (Ge 14/10). <B>Fos~o</B>, ditch (4 FA 229/21). <B>Man~o</B>, hollow of the hand (Jes 40/12). <B>Okul~o</B>, eye-hole, orbit. <B>Ost~o</B>, socket. <B>Rad~o</B>, wheel-rut. <B>Urs~o</B>, bear-pit. <B>~a</B>, hollow(ed), concave, empty. <I>~a dento. ~aj</I> (sunken) <I>vangoj</I>. <B>f ~(ec)a</B> <I>sono, voĉo</I>, h-sounding. <B>~aĵo</B>, concavity, depression. <I>Profunda ~aĵo</I>, deep cutting. <B>~ego</B> (<I>abismo</I>), abyss, chasm, gulf. <I>Vanga</I> <B>~eto</B>, dimple. <B>~igi</B>, hollow out. <I>~igita mano</I>. <B>~iĝi</B> (<I>enfali</I>), cave (fall) in, sink. <I>En~iĝintaj okuloj. Tera ~iĝo,</I> depression. <B>El~igi</B>, excavate. <B>Mal~a</B>, convex. ➞ <I>fos, grot, kavern, konkav, put, tru</I>.", "0"],
["Kazaĥujo, Kazaĥio", "Kazaĥ-ujo, Kazaĥio", "KZ.", "0"],
["kazeino", "kazein-o", "casein, protein of milk.", "0"],
["kazemato", "kazemat-o", "[OA] (mil) casemate, vaulted chamber, armoured enclosure.", "0"],
["kazeo", "kaze-o", "[UV] Curd. <I>~a fromaĝo</I>, cream cheese. <B>~igi</B>, <B>~iĝi</B>, curdle. <I>~igaĵo</I>, rennet. ➞ <I>kazein, koagl</I>.", "0"],
["kazerno", "kazern-o", "<B>[OA]</B> (<I>soldatejo</I>), barracks, soldiers’ quarters.", "0"],
["kazino", "kazin-o", "[OA] Casino, public room for dancing, gambling, etc.", "0"],
["kazo", "kaz-o", "[UV] Case (wide sense) <B>1</B> (gram) <I>~o nominativa,</I> etc. <B>2</B> (med) occurrence of disease. <I>~o de morbilo</I>. <B>3</B> (jur) cause, suit (for trial, discussion). f <I>~o de konscienco = kazuo. ~o analoga</I>, c. in point. ➞ <I>okaz</I>.", "0"],
["kazublo", "kazubl-o", "(cl) chasuble.", "0"],
["kazuo", "kazu-o", "case of conscience or doubt. <B>~ismo</B>, casuism, -istry. <B>~isto</B>.", "0"],
["ke", "", "[UV] (conj) that. <I>Mi kredas, ~ jes (~ ne</I>), I believe so (not). <I>Vi diris, ~ vi venos,</I> You said you would come. <B>Rim</B>.: Often omitted in English, as here, but not in Esperanto (See however <B>4</B> FA 33/14: <I>mi pensas, (ke) mi rabos). Por</I> in order that. <I>Tiel</I> so as, so that …", "0"],
["keglo", "kegl-o", "[UV] Skittle, nine-pin. <B>~a</B> <I>globo, ludo</I>. <B>~aro</B>, set of ss. <B>~ejo</B>, s-alley.", "0"],
["keiranto", "keirant-o", "wall-flower (<I>Cheiranthus</I>).", "0"],
["kejlo", "kejl-o", "[OA-8], Peg, pin (often wooded and wedge-shaped). <B>Agorda ~o</B> (vn), tuning p. <B>Fer~o</B>, bolt. <B>Haltiga ~o</B>, stop-bolt (-pin). <B>Pinĉ~o</B>, clothes-peg. <B>Tend~o</B>, tent-peg. <B>Stop~o</B>, spigot. ➞ <I>stift</I>.", "0"],
["kelidonio", "kelidoni-o", "(bot) greater celandine (<I>Chelidonium</I>). ➞ <I>papav</I>.", "0"],
["kelka", "kelk-a", "[UV] (indefinite non-numeral adj). <B>1</B> (<I>iom da, ioma)’</I>. Some, a little. <I>Post ~a tempo. Kun ~a hezito</I>. 2 (<I>iu</I>) a certain. <I>~a nombro (de vortoj) (el ili</I>). ~aj (~e <I>da) ( = iuj, unuj</I>): Several, a few, (a) certain (number of), sundry (1 Sa 30/22) (➞ <I>diversaj, pluraj). ~aj vortoj (~e da vortoj). ~aj el ni</I>. ~oble, manifold, several times (multiplication). ~ope, several together. Kelk(a) foje, several times, on various occasions (repetition). <B>Rim</B>.: ➞ iufoje (sometimes). <B>~tempa</B>, provisinal, temporary. <I>~a ĉeso ne estas forgeso</I>. ~deke da, some dozen (=-30-50). Dek~e da, some ten, a dozen or so (=-11-15). Tridek ~jarulo, a man in his thirties.", "0"],
["kelnero", "kelner-o", "[UV] Wait/er, <B>~i</B>, serve as w. <B>~ino</B>, -ress. <B>~aĵo</B> (<I>trinkmono</I>). <B>Ĉef~o</B>, head waiter.", "0"],
["kelo", "kel-o", "[UV] Cellar, underground storeroom. <I>Malfermita ~o tentas al ŝtelo. Vin~o</I>, wine-c. <B>~aro</B>, <B>~ejo</B>, -age, vaults. <B>~isto</B>, c-man. ➞ <I>ĉel, subter</I>.", "0"],
["kelonio", "keloni-o", "(<I>mara testudo</I>), turtle (<I>Chelonia). ~a ŝelo</I>, tortoiseshell. <B>Birdbeka ~o</B>, hawksbill t. <B>Verda ~o</B>, green t.", "0"],
["kemio", "kemi-o", "[OA-8] = ĥemio.", "0"],
["Kenjo", "Kenj-o", "KE.", "0"],
["keno", "ken-o", "[UV] resinous pinewood. <I>~a torĉo</I>.", "0"],
["kenomelo", "kenomel-o", "Japanese quince. \"Japonica\" shrub (<I>Chaenomeles</I>).", "0"],
["kenopo", "kenop-o", "(zoo) pelican’s foot (<I>Chenopus</I>).", "0"],
["kenopodio", "kenopodi-o", "(bot) Goosefoot (<I>Cheno- podium</I>). ~o bonhenrika, good king Henry. ~o blanka, white g., fat hen (C. <I>album</I>). Vp <I>atripl, blit</I>.", "0"],
["keo", "ke-o", "kea (<I>Nestor notabilis</I>), N-Zealand green parrot.", "0"],
["kepo", "kep-o", "[OA] kepi, French military peaked cap.", "0"],
["kepro", "kepr-o", "(tex) Twill, woollen textile with cross-lines. <B>~aĵo</B>, -ed cloth.", "0"],
["keratino", "keratin-o", "(chem) keratin.", "0"],
["kerkedolo", "kerkedol-o", "(<I>marĉanaso</I>), gargany duck (<I>Anas querquedula</I>). ➞ <I>anas</I>.", "0"],
["kermeso", "kermes-o", "kermis, country (village) fair.", "0"],
["kerno", "kern-o", "[UV] kernel; grain, seed (corn), pip, stone (fruit). <I>Nuksa ~o</I>. (tech) core, inner pt, nucleus, etc. <I>~o de atomo, bobeno</I>. <B>f</B> cream, essence, root. <I>La ~o de la demando</I>. <B>~eca</B>, pithy, going to the root of the matter, terse (style). <B>~eto</B>, pip. <B>Sen~igi</B>, stone. ➞ <I>amand, drup</I>.", "0"],
["kero", "ker-o", "[UV] (cgm) Heart. <I>~a darno</I>, question of hh. ➞ <I>kor</I>.", "0"],
["kerofilo", "kerofil-o", "rough chervil (<I>Chaerophyllum</I>). ➞ <I>cerefoli</I>.", "0"],
["keroseno", "kerosen-o", "paraffin oil (American kerosene).", "0"],
["kerubo", "kerub-o", "[UV] Cherub (Ge 3/24). ~oj, -im. ~(osimil)a, -ic.", "0"],
["kesto", "kest-o", "[UV] (strong) Box, Case, chest. (Bb) <I>~o de interligo</I> (Jos 6/6). <I>~o almoza, cigara, letera</I>. Flor<B>~o</B>, window-b. Lat<B>~o</B>, coop, crate. Mon<B>~o</B>, money-b. Pak<B>~o</B>, packing-c. Poŝta <B>~o</B>, letter (pillar) b. Rad<B>~o</B>, paddle-b. Son<B>~o</B>, sounding-board. <B>tir~o</B>, [UV] drawer. <B>Vent~o</B> (org) wind-b. <B>Vojaĝ~o</B>, travelling trunk. ~ego, packing-c. <B>~eto</B>, box, coffer (1 Sa 6/8). En<B>~igi</B>, pack (in c.), post (letter). ➞ <I>arke, kofr</I>.", "0"],
["kestrelo", "kestrel-o", "= tinunkolo. keton-o, (chem) ketone, ketup-o, (orn) fish-owl (<I>Ketupa</I>).", "0"],
["kia", "", "[UV] (<I>kiuspeca</I>), (adj) of what Kind, what k. (Sort) of a. <I>~a bruo!</I> What a noise! <I>~ ĝi estas?</I> What is it like? <I>~n vi volas?</I> What s. do you want? <I>Jen ~ mi estas</I>, That is the s. of man I am. <I>~jn grandajn okulojn vi havas!</I> What big eyes you have! ~<I>~ patro, tia filo</I>, Like (As is the) father, like (so is the) son. <I>~ ajn</I>, What ever k. of a.", "0"],
["kial", "", "[UV] (<I>Pro kio, kiukaŭze, kiumotive</I>), (adv) Why, wherefore, on what grounds, for what reason. (<I>Diru al mi,) ~ vi ploras?</I> What are you crying for? w. are you crying? <I>Mi ne scias</I> I don’t know w. <I>~ ne?</I> W. not? <I>Jen</I> That is w. <I>Ciu tial havas sian ~ ajn vi venis,</I> w. ever did you come? <B>~o</B>, ground, reason. Est~o, <I>raison d’etre</I>.", "0"],
["kiam", "", "[UV] (<I>kiutempe</I>), (adv) When, at what time. (<I>Diru al mi,) ~ vi venos? Ĉiufoje, ~ li venas</I>, w-ever he comes. <I>De (la tempo</I>) ever since. <I>Gis ~ (vi atendos?</I>), Till w.? How long? <I>Post ~ li venis</I>, After he came (had come). <I>Tuj ~ li venos</I>, Directly (As soon as) he comes. <I>Venu ~ ajn (vi volos</I>), Come w-ever you like, at any time.", "0"],
["kiango", "kiang-o", "kiang, Tibetan ass (<I>Equus kiang</I>).", "0"],
["kie", "", "[UV] (<I>kiuloke</I>), (adv) Where, in which (what) place. <I>~ vi estas?</I> where are you? <I>~n (al ~) vi iras?</I> W. are you going to, Whither goest thou? <B>~</B> <I>jukas, tie ni gratas. De (El</I>) Whence, from where. <I>Ĝis ~,</I> How far? to what length? <I>Mi vin sekvos, ~ ajn vi iros</I>, w-ever you go. <B>~o</B>, where-abouts.", "0"],
["kiel", "", "[UV] (<I>kiumaniere</I>), (adv) in what way, by what means, to what degree. <B>1 HOW:</B> <I>Kiel vi faris tion?</I> <I>Kiel bela ŝi estas!</I> <B>2 AS:</B> <I>Faru, ~</I> (as, what) <I>mi diras, ne ~ mi faras</I>. <I>Li komprenas predikon, kiel</I> (just, in the same way, as) <I>bovo muzikon</I>. <I>Mi amas vin kiel filon</I>. <I>Venu</I> <B>kiel eble plej baldaŭ</B> (as soon as possible). <B>(Tiel) forta, kiel leono</B>, (As) strong as a lion. <B>kiel se (kvazaŭ)</B>, as though. <B>3 LIKE:</B> like unto, just like <I>Vivi kiel kuko en butero</I>. <I>Trinki kiel fiŝo</I>. <B>kiel viroj, tiel ankaŭ virinoj</B>, men and women alike. <B>Rim</B>.: The forms <B>~a (= kia)</B>, and <B>~e</B> (pleon), are sometimes used for emphasis.", "0"],
["kies", "", "[UV] (<I>de kiu, de kiuj)</I>, (pron) Whose, which one, of whom, of which. (<I>Diru al mi) ~ infano vi estas?</I> <I>La viro, ~</I> (whose) <I>verkon mi legas</I>. <I>La domo, ~ tegmenton</I> (the roof of which) <I>vi vidas</I>. <B>~ ajn</B>, whose-soever.", "0"],
["kikero", "kiker-o", "chick-pea (<I>Cicer</I>). ➞ <I>cicer, latir</I>.", "0"],
["kilo", "kil-o", "[UV] Keel, Bottom (of ship). <I>~o bilĝa, falsa</I>, bilge k. <I>~o supre</I>, b. up. ~(forma) (hava), k-ed. <I>~mono, ~pago</I>, -age. <I>Larĝ~a</I>, broad b-ed. Antaŭ~o (<I>steveno</I>), stem. Post<B>~o</B>, rudder post.", "0"],
["kilo", "kilo-", "(metr.pfx) kilo-.", "0"],
["kilociklo", "kilocikl-o", "kilocycle.", "0"],
["kilogramo", "kilogram-o", "[F], kilogram.", "0"],
["kilolitro", "kilolitr-o", "kiloliter.", "0"],
["kilometro", "kilometr-o", "[F], kilometer.", "0"],
["kiloŭato", "kiloŭat-o", "kilowatt.", "0"],
["kilsono", "kilson-o", "(av) (mar) keelson.", "0"],
["kilto", "kilt-o", "(<I>virjupo</I>), kilt.", "0"],
["kimo", "kim-o", "(bot) cyme.", "0"],
["kimono", "kimon-o", "kimono, <B>1</B> Japanese woman’s garment. <B>2</B> similar Dressing-gown.", "0"],
["kinematiko", "kinematik-o", "kinemat/ics. <B>~a</B>, -ic. <I>~a</I> <B><I>energio, premo</I></B>.", "0"],
["kinematografio", "kinematografi-o", "cinematograph, film (as an art form). <I>~a lampo</I>, projection lamp. <B>~i</B> (<I>filmi</I>). <B>~aĵo</B>, <B>~a bildo</B>. <B>~ejo</B> (col <B><I>kino</I> [OA-8]) (<I>filmteatro</I>)</B>, cinema.", "0"],
["kineta", "kinet-a", "kinetic. <B>~iko</B>, -ies.", "0"],
["kinino", "kinin-o", "[OA] (pharm) quinine, alkaloid from <B><I>kinkonarbo</I>.</B>", "0"],
["kinkajuo", "kinkaju-o", "(zoo) kinkajou, American potto (<I>Potos flavus</I>).", "0"],
["kinkono", "kinkon-o", "(bot) Peruvian bark, from <B>~arbo</B> (<I>Chinchona</I>).", "0"],
["kio", "", "[UV] (pron) What (thing). <I>~ estas tio?</I> What is that? <I>~ estas ili?</I> What are they? <I>~ estas al vi?</I> What is the matter with you? (<I>Diru al mi) ~n fari?</I> What is to be done? <I>~ do?</I> What then? <I>Li ridis: ~ (= kaj tio) estis netolerebla. Okazu ~ ajn</I>, for better, for worse; what ever may happen. <I>Mi faros ~on ajn vi volos</I> (what ever you want).", "0"],
["kiom", "", "[UV] (<I>kiukvante</I>), (adv, conj) What amount (quantity), how much (many). (<I>Diru al mi), ~ vi deziras? ~ da butero?</I> How much butter? <I>~ da pornoj?</I> How many apples? <I>~mi scias</I>, As far as I know. <I>~ da homoj, tiom da gustoj</I> (So many ... so many). <I>Tio estas pli, ol ~ mi povas porti</I> (more than I can). <I>Kaŝu ~ vi povos</I> (as much as you may), <I>mensogo sin elŝovos. ~ ajn mi provas</I>, how ever much I try. <B>~a</B>, What number (in a series)? = how manyeth? <I>Sur ~a etaĝo li loĝas? ~a horo (tago) (estas)! ~a infano vi est is? ~an jar-(paĝ-)on vi atingis?</I> ~e (pleon) (If/43). <B>~o</B>, amount, quantity. ~ope <I>ni estas?</I> How many are we in all? (Rj 58/30).", "0"],
["kiosko", "kiosk-o", "kiosk. <I>~o flora, gazeta, telefona</I>.", "0"],
["kipero", "kiper-o", "kipper (herring or salmon split open, salted, and dried).", "0"],
["Kipro", "Kipr-o", "CY.", "0"],
["kiraso", "kiras-o", "[UV] (body) Armour, (coat of) Mail, cuirass (Ne 4/16). (tech) iron-case. Brust<B>~o</B>, breastplate. Maŝ<B>~o</B>, coat of (chain-) m. <B>~i</B>, a-plate. ~(it)a, a-ed, m-clad. <I>~a ŝipo</I>, iron-clad. <B>~ulo</B>, cuirassier. <B>~aĵo</B>, a-plating. ➞ <I>arm, karapac, konk, krust, ŝel</I>.", "0"],
["Kirgizujo, Kirgizio", "Kirgiz-ujo, Kirgizio", "KG.", "0"],
["Kiribato", "Kiribat-o", "KI", "0"],
["kirli", "kirl-i", "<B>[OA]</B> (<I>turnmovi</I>) (<I>-n</I>), Whirl, twirl; beat (<I>buteron</I>); churn (<I>lakton</I>); make boil (<I>la maron</I>) (Ij 41/31); stir (<I>teon</I>); whisk (<I>ovon</I>). <B>~fluo</B>, eddy, vortex, <B>~vento</B>, w-wind. Ov<B>~aĵo</B>, ~itaj ovoj, scrambled eggs. <B>~iĝi</B>, w. about. <I>La fumo, maro, nebulo, polvo ~iĝas</I>. f <I>Miaj pensoj ~iĝis</I>. ~ilo, shaker. <I>Ov~ilo</I>, egg-whisk. <B>Kun~iĝi</B>, swirl. ➞ <I>ciklon, tromb</I>.", "0"],
["kirmeso", "kirmes-o", "kermes, scarlet from various cocci.", "0"],
["kiromiso", "kiromis-o", "(a. <I>ajajo</I>), aye-aye (<I>Chiromys</I>). kironom-o, midge (<I>Chironomus). ~a larvo</I>, blood-worm.", "0"],
["kirŝo", "kirŝ-o", "<B>[OA]</B> (<I>ĉerizbrando</I>), kirsh.", "0"],
["kirurgio", "kirurgi-o", "[OA 8] (a. <I>ĥir~</I>), Surgery. <B>~ejo</B>, surgery. <B>kirurg-o</B> [OA 8] (= ~iisto), surgeon.", "0"],
["kisi", "kis-i", "[UV] Kiss (Ge 27/26; Mt 26/48). <I>Doni ~on, ~i la manon al iu. Blovi man~on</I>. <B>f</B> (<I>pri akvo, flamo, sunradio</I>), brush against, graze, lick, skim, touch lightly. ~o <I>de Judas, perfingra</I>. <B>~a</B>, osculatory. <B>~ema</B>, sloppy. <B>~ego</B>, (<I>ŝmaco</I>), smack. <B>~eto</B>, light k., peck. <B>~inda</B>, desirable. <B>Al~i</B>, lap (<I>ondoj ~as la rokon</I>). <B>For~i</B> (<I>doloron</I>). <B>Inter~i</B>, embrace one another. <B>Pac~o</B>, k. of reconciliation.", "0"],
["kisto", "kist-o", "(med) Cyst. <B>~a</B>, -ic. <B>~ito</B>, -itis.", "0"],
["kitelo", "kitel-o", "[UV] long loose covering garment (for workman, etc.), overall, smock. <B>Mort~o</B>, shroud.", "0"],
["kitio", "kiti-o", "(<I>trifingra mevo</I>), kittiwake (<I>Rissa tridactyla</I>).", "0"],
["kitono", "kiton-o", "(zoo) mail-shell, coat of mail (<I>Chiton</I>). ➞ <I>hiton</I>.", "0"],
["kiu", "", "[UV] (adj and pron), Which (one) (thing or person). <I>Kiu el ni</I> (Which of us) <I>povus iri? Kiu scias?</I> Who knows? <I>Kiuj scias?</I> Who know? <I>Kiu</I> (which) <I>el la libroj estas via? La knabo, ~n</I> (whom) <I>vi vidas. La domo, ~n</I> (that) <I>vi vidas. ~ vivos, tiu vidos. ~ ajn,</I> which ever (one), who ever, whosoever, klab-o, Club, bludgeon, mace. <B>~eto</B>, truncheon. ~portisto, mace-bearer, (agr) ~radikozo, c-root.", "0"],
["klaĉi", "klaĉ-i", "[OA] Gossip, clack, prate, tattle. <B>~(ad)o</B>, babble, chit-chat, prattle, tittle-tattle, small talk. <B>~aĵo</B>, piece of gossip. <B>~ema</B>, of a -ing disposition. <B>~ul(in)o</B>, g., idle talker, scandal-monger, tale-bearer. ➞ <I>babilaĉ</I>.", "0"],
["kladonio", "kladoni-o", "(<I>Cladonia) &gt;</I> cup lichen, reindeer moss.", "0"],
["klafto", "klaft-o", "[UV] Fathom. Various meanings: ~o <I>Angla, Franca, Germana, Rusa</I>. <B>~i</B>, fathom, gauge, measure. ➞ <I>sond</I>.", "0"],
["klaki", "klak-i", "[OA] (nt) make short sound by blow: chatter (<I>dentoj</I>); crack (<I>fingroj, vipo</I>) flap (<I>flugiloj</I>) slap, smack. <I>~i per beko, lango, lipoj, manoj</I>. <B>Klak!</B> Crack! Smack! Snap! <I>La cikonio</I> ~adis <I>Egipte</I>. <B>~ado</B>, chatter, clatter. <B>~eti</B>, click, crackle, rattle. <B>~igi</B> (<I>-n</I>), bang, slam (<I>pordon</I>); clap (<I>manojn</I>), crack (<I>vipon</I>); smack (<I>lipojn</I>). <B>~ilo</B>, clapper, rattle. <B>~ileto</B> (<I>kastanjeto</I>). <B>~istaro</B> (<I>aplaŭdistaro</I>), claque. <B>~sono</B>, (phon) click,", "0"],
["klamo", "klam-o", "(ordinary language) clam, various eatable bivalve molluscs (especially <I>Venus mercenaria</I> and <I>Nya arenaria). [Ne= tridakno]</I>.", "0"],
["klangolo", "klangol-o", "long-tailed duck (<I>Clangula</I>).", "0"],
["klano", "klan-o", "clan, Scots with common ancestor. <B>~ano</B>, c-sman. ~ema, -nish. ~estro.", "0"],
["klapo", "klap-o", "[UV] overlapping piece, bit, hinged, jointed, pivoted at one end, free at the other; lappet, lid, shutter, tab; flap (<I>koverta, poŝa</I>); flap-seat (of w.c.); leaf (<I>faldporda, tabid</I>); tongue (<I>poŝlibra</I>); trap door (<I>kamena</I>); valve (<I>kapsula, konka, pumpila). ~o aera, ventola</I>. <B>Glit~o</B>, slide. <B>Orel~o</B>, ear-tab. <B>Sava</B>, <B>sekureca</B> <B>~o</B>, safety-valve. <B>Stringo~o</B>, throttle. <B>Du~a</B>, <B>unu~a</B> (mollusc), bivalve, univalve. ➞ <I>valv</I>.", "0"],
["klara", "klar-a", "Clear. <B>1</B> pure, limpid, pellucid: <I>kristale ~a. ~a akvo, lumo, rivero, sono</I>. ➞ <I>diafan, hel</I>. <B>2</B> distinct; easily audible, seen, or understood; explicit, intelligible, lucid, plain, unambiguous: <I>~a esprimo, penso, skribo, stilo, voĉo, vojo</I>. <B>3</B> serene, unclouded: <I>~a ĉielo</I>. <B>4</B> discerning, penetrating: <I>~a kapo, okulo, vido</I>. <B>~e</B> <I>aŭdi, kompreni, paroli, vidi</I>. <B>~eco</B>, clarity. <B>~ega</B>, evident. <B>~igi</B>, clarify, make clear, elucidate, explain (Da 2/4). ➞ <I>eksplik, komprenig, lumig, koment</I>. <B>Signifo~igi</B>, expound, interpret. <B>Ne~igebla</B>, inexplicable, inscrutable. <B>~igisto</B>, expositor. <B>Signo~igisto</B>, augurer, diviner. <B>Sonĝ~isto</B>. <B>~iga</B>, explanatory. <B>~iĝi</B>, brighten (<I>vetero</I>). <B>~vida</B>, c-sighted. <B>Mal~a</B>, <B>Ne~a</B>, clouded, dark, dull, obscure, thick, turbid. <B>~~aĵo</B>, <B>~~eco</B><I>,</I> obscurity. ➞ <I>enigm, mister, nebul, nub</I>. ➞ <I>evident, hel, lum, seren</I>.", "0"],
["klareto", "klaret-o", "(bev) (<I>Bordoza vino</I>), claret. <I>Ni trinku -on</I> (1 FA 77/30).", "0"],
["klariono", "klarion-o", "clarion. l = buglo. <B>2</B> (org) 4-ft stop of similar quality. <B>~a</B>, f, loud and clear.", "0"],
["klarneto", "klarnet-o", "[UV] <B>1</B> (m.i.) clarinet. <B>2</B> (org) 8-ft stop of similar quality.", "0"],
["klasif(ik)i", "klasif(ik)-i", "<B>[OA]</B> (<I>klasi science, sisteme</I>), Classif/y, reduce to order, sort out. <I>notojn, objektojn</I>. <B>~(ad)o</B>, -ication. <I>~o biografia, botanika, decimala. ~o de temoj</I>. <B>~ebla</B>, -iable. <B>~ita</B>, -ied.", "0"],
["klasika", "klasik-a", "[OA] Classic/(al). <B>1</B> of ancient Gk or L. author or art. <I>~aj lingvoj. ~a edukado. 2</I> in conformity with traditional models, cultured, refined, restrained. <I>~a aŭtoro, poeto, stilo</I>. <B>~ismo</B>. <B>~isto</B>, -ist, -al scholar.", "0"],
["klaso", "klas-o", "[UV] Class. <B>1</B> Grade, order (of society, etc.), rank, status; form (school); kind, sort. ~o <I>burĝa, meza. ~o laborista, popola, reganta, socia</I>. <B>2</B> Category, denominate, division, group. <I>~o unu-(du-tri-)a ĉe lernejo, vagonaro. Kupeo tria~a,</I> 3rd-c. carriage. ➞ <I>Subdivid</I>. <B>~i</B> (<I>en~igi</I>), g., place in a c., form into cc., range, rank. <B>~ado</B>, -ing. <B>~ano</B>, member of c. <B>~ebla</B>, -ifiable. ~instruisto, form master, c-teacher. <B>Alt~a</B>, of superior g. (rank). <B>Bon~a</B>, of good quality. <B>Dua~a</B>, second-g. <B>Mez~a</B>, middle-c. <B>Sam~ano</B>, c-mate, compeer. <B>Unua~a</B>, first-c, first-rate, Al. ➞ <I>fak, kategori, klasif(ik), nivel, rang, soci [Ne= kurs]</I>.", "0"],
["klaŭno", "klaŭn-o", "(circus) clown, jester. ➞ <I>arleken, burleskul</I>.", "0"],
["klaŭzo", "klaŭz-o", "<B>1</B> (gram) (<I>subfrazo</I>), clause, a sentance which is part of a larger sentence. Clauses may be <I>kunorditaj</I> (independent) or <I>suborditaj</I> (dependent, subordinate). ➞ <I>fraz</I>. 2 (jur) section of a document.", "0"],
["klaviceno", "klavicen-o", "(m.i.) harpsichord. <B>~eto</B>, spinet.", "0"],
["klaviklo", "klavikl-o", "(<I>ŝlosilosto</I>), collar-bone, clavicle.", "0"],
["klavikordo", "klavikord-o", "(m.i.) clavichord.", "0"],
["klavo", "klav-o", "[UV] (<I>prembutono</I>), (tech) Key, e.g., of piano, typewriter. <I>Frapi la ĝustan ~on</I>. (el) <I>Senda ~o</I>. ~a <I>instrumento,</I> -board instrument. <B>~aro</B>, -board, manual. ~ara glasaro, musical glasses with -board. Vic<B>~o</B>, (org) stop. ➞ <I>klap, kief, ŝlosil, tonal</I>.", "0"],
["klefo", "klef-o", "(<I>ŝlosilo</I>), (mus) Clef. <I>F-(C-G-)klefo</I>.", "0"],
["klemat(id)o", "", "clematis, old man’s beard, traveller’s joy (C. <I>vitalba</I>).", "0"],
["klemo", "klem-o", "(a. <I>borno</I>), (el) Terminal. <I>~o enira, elira, neŭtrala</I>, input (output, neutral) t.", "0"],
["kleptomanio", "kleptomani/o", "Kleptomani/a. <B>~ulo</B>, -ac.", "0"],
["klera", "kler-a", "[UV] Educat/ed; cultured, enlightened, learned, well-informed. <B>~(ec)o</B>, culture, enlightenment, learning. <I>~eco artista, muzika. ~econ oni ne vendas</I>. <B>~igi</B>, educate (Da 11/33). <B>~ulo</B>, (<I>~a homo</I>), man of -ion or culture. <B>Mal~a</B> (<B>Ne~a</B>), barbarous, ignorant, simple, illiterate, uncultured, unenlightened, unlearned. <B>Mez~a</B>, of fair -ion, <B>Pli~iĝi</B>, grow in wisdom. <B>Sen~eco</B>, lack of -ion or culture. ➞ <I>edukita, instruita, lumigita, scihav</I>.", "0"],
["klerikala", "klerikal-a", "clerical (pol). <B>~ismo</B>, <B>-ism.</B>", "0"],
["kleriko", "klerik-o", "Ecclesiastic, clergyman, divine. <B>~a</B>, -al. <B>~aro</B>, clergy. ➞ <I>eklezi, pastr</I>.", "0"],
["kliento", "klient-o", "<B>[OA], ~ino</B>, Customer, client, patient, patron. <B>~i</B> (<I>iun</I>), patronize as c. <B>~ado</B>, custom, patronage. <B>~aro</B>, circle of cc., clientele. <B>~oplena</B>, with a thriving custom.", "0"],
["klifo", "klif-o", "cliff, crag, steep rock-face or <B>headland</B>.", "0"],
["kliko", "klik-o", "<B>1</B> clique, cotery, set (<I>koterio</I>). <B>2</B> (tech) Ratchet; (safety) catch, claw (of bracelet), click, pawl, pin (to stop motion, or permit it in one direction only). <B>Puŝ~o</B>, push pawl. <B>Tir~o</B>, pull pawl. <B>~aĵo</B>, r-mechanism, (hor) escapement. <B>~tenilo</B>, r-brace. <B>El~igi</B>, disconnect (escapement). <B>En~igi</B>, cog, ratch. ➞ <I>ellasil, kam, krik</I>.", "0"],
["klik!", "", "(interjection) click, snap. <I>Fari ~on, ~sonon</I>.", "0"],
["klimakso", "klimaks-o", "Climax, ascending scale, ascent to culmination. (rh) successive increase of effect (Ps 18/37-8). <B>Mal~o</B> (<I>katabazo</I>), anticlimax, gradual descent (Flp 2/6-8). ➞ <I>apoge, kulmin, zenit; batos</I>.", "0"],
["klimaktero", "klimakter-o", "(med) climacteric, critical period, age 45-60, change of life.", "0"],
["klimatizi", "", "(<I>-n</I>), air-condition.", "0"],
["klimato", "klimat-o", "[UV] Climat/e. <I>~o loka</I>. <B>~a</B>, -ic. <I>~a faktoro, zono</I>. Al<B>~igi</B>, ac-ize. <I>Al~iĝi,</I> get ac-ized.", "0"],
["klimatologio", "klimatologi-o", "-o, -olog-y, -ist.", "0"],
["klingo", "kling-o", "[OA] Blade, flat part, cutting piece (of axe, chisel, knife, plough, saw, scissors, spade, sword). <B>Raz~o</B>, razor-blade.", "0"],
["klini", "klin-i", "(<I>-n</I>), [UV] Inclin/e. <B>1</B> (cause to) bend, incline, slant downwards (Ge 49/15). ~i <I>la kapon</I>, bow the head. <I>Arbo, branĉo ~ita de la vento</I>. <B>f</B> <I>~i la animon, koron, orelon</I> (Ps 31/2, 119/112). <I>Sin ~i antaŭ la vento</I>. <B>~o</B>, bending (<I>de la kapo</I>). (astr) i-ation. <B>~aĵo</B>, declivity, gradient, ramp. <B>~iĝi</B> (<I>sin -i</I>), <B>1</B> bend down (forwards), bow down, crouch, lean, stoop. <I>~iĝi ĝis la tero. ~iĝinta</I>, -ed, leaning, slanting, sloping. <I>~iĝinta turo de Pizo. ~iĝo</I>, heel, list, slant, tilt. <B>2</B> (<I>cedi): give</I> way. <I>~iĝi al la plimulto</I> (El 23/2). <I>~iĝi antaŭ la leĝo</I>. <B>~ilo</B>, elevation pointer. <B>De~i</B> (<I>-n), (deturni, deviigi</I>) turn aside, divert. <I>De~i iun de la ĝusta vojo. De~i koleron, koron, riproĉon, rajton</I>. <B>De~iĝi</B> (<I>sin deturni</I>), turn aside. <I>Sende~iĝe</I>, straight ahead, without deviation. <B>For~i</B>, turn away, avert, divert. <I>la atenton, kapon, koleron, orelon</I> (Ps 106/23). ~~iĝi (Ij 31/7). <B>Ador~iĝi</B>, worship. <B>Retro~i</B>, bend backwards. <B>Turn~i</B>, (av) bank. ➞ <I>apog, dekliv, fleks, inklin</I>.", "0"],
["kliniko", "klinik-o", "[OA] Clinic. <B>1</B> medical teaching to students at bedside. <B>2</B> institution for giving medical advice or treatment. <B>~a</B>, -al, at (of) the bedside. <I>~a fenomeno, termometro</I>.", "0"],
["klinko", "klink-o", "Latch (fastening by bar falling into a catch, and lifted by lever). ~ita (~e <I>fermita</I>), on the 1. <B>2</B> spring-lock catching when door is closed. ➞ <I>ans, klik, fak, skori</I>.", "0"],
["klinopodio", "klinopodi-o", "(bot) wild basil (<I>Clinopodium</I>).", "0"],
["klipero", "kliper-o", "(mar) clipper, \"a fast-sailing ship with fine lines\".", "0"],
["klistero", "klister-o", "[UV] Enema, douche, intestinal injection. ~i (<I>doni ~on</I>), give an e. ~ilo, e-syringe. ➞ <I>ŝprucigil</I>.", "0"],
["kliŝo", "kliŝ-o", "[OA] (typ) Block, plate (electrotype or stereotype cast. <I>Linia ~o</I>, line-block, line engraving, zinco. (phot) negative. <B>~i</B> (<I>fari ~on</I>). <B>~isto</B>, b-maker, electrotyper. <B>~aĵo</B>, <B>f</B> cliche, hackneyed expression, stock phrase.", "0"],
["klitoro", "klitor-o", "(anat) clitoris.", "0"],
["klivi", "kliv-i", "Cleav/e, split. <B>~ebeno</B>, -age plane.", "0"],
["kloako", "kloak-o", "<B>[OA], 1</B> Sewer, drain. <B>2</B> cesspool. <B>~aĵo</B>, sewage, waste, <B>~isto</B>, s-man.", "0"],
["klono", "klon-o", "(med) Clon/us, muscular spasm. <B>~a</B>, -ic.", "0"],
["klopodi", "klopod-i", "[UV] (nt) (R. <I>klopotat</I>), take measures (steps, trouble), make efforts, busy one’s about, set to work; canvas (petition) to realize aim. <I>~i ĉe ministro. ~i (por) atingi, fondi, ricevi ion. ~i pri ĉies favoro</I>, try to gain the good will of everybody. <B>~ado</B>, preliminary action (efforts, endeavours, exertions, measures, steps). <B>~ema</B>, assiduous, bustling, energetic, unwearied. <B>~igi</B> (<I>iun</I>), put to the trouble of, importune, spur. <B>Sen~e</B>, without exertion. ➞ <I>entrepren, pen, streb</I>. <B>Rim.:</B> Cel = aim; klopod = action; zorg = care, responsibility.", "0"],
["kloro", "klor-o", "[OA] Chlor/ine (CI). ~alo, -al. <B>~ato</B>, -ate. ~atacido, -ic acid (HC10<SUB>3</SUB>). ~ido, -ide. <I>Kalcia -ido</I> (CaCl<SUB>2</SUB>). <I>~idacido,</I> hydro-ic acid, spirit of salt. <B>~ito</B>, <B>-ite.</B> <I>~itacido</I>, -ous acid. <B>~izi</B>, -inate. <B>~ozo</B> (bot) (med) -osis, green sickness.", "0"],
["klorofilo", "klorofil-o", "chlorophyll.", "0"],
["kloroformo", "kloroform-o", "chloroform.", "0"],
["klostro", "klostr-o", "(arch) cloister, close, covered walk or arcade between windows and colonnade. <B>~a</B>, <B>f</B> romantic, sheltered.", "0"],
["klostrofobio", "klostrofobi-o", "claustrophobia.", "0"],
["kloŝo", "kloŝ-o", "[UV] <B>1</B> (hort) bell-shaped cover, frame, usually of glass. <B>2</B> similar obj: dish- cover, lampshade, (cl) woman’s hat of similar shape. <B>Merga ~o</B>, diving-bell. <B>~forma</B>, bell-shaped. ➞ <I>sonoril</I>.", "0"],
["klozoneo", "klozone-o", "(<I>ĉel-emajlo</I>), cloisonne, enamel with colours between metal divisions.", "0"],
["klubo", "klub-o", "[UV] Club, circle, meeting periodically for common purpose. <I>~o Esperanta, manĝa, politika, socia, ŝaka. Nokta ~o</I>. <B>~ano</B>, c-man, member of c. <I>Sam~ano</I>. <B>~ejo</B>, c-room. ➞ <I>klab</I>.", "0"],
["kluĉo", "kluĉ-o", "(<I>konekta kuplilo</I>), (mec) Clutch. <I>~o diska, frikcia, konusa</I>, disc-(friction-cone -)c. <B>~i</B>, throw into gear, let in the c. <B>~pedalo</B>, <B>~stango</B>, c-lever. Mal<B>~i</B>, de-c. ➞ <I>kupl, rapidum</I>.", "0"],
["kluki", "kluk-i", "[OA] cluck (as hen). <B>Kluk!</B> Cluck! <B>~ulino</B>, -ing hen (also figuratively). <B>Rid~i</B>, chuckle. ➞ <B><I>gugl</I></B>.", "0"],
["klupeoj", "klupe-oj", "(<I>ich) fam</I>. &gt; alos, haring, pilĉard, sprot.", "0"],
["kluso", "klus-o", "(mar) hawse-hole, hawse-pipe.", "0"],
["kluzo", "kluz-o", "[UV] Lock; dockgate, floodgate, sluicegate. <I>Tajda ~o</I>, tide-gate. <I>~o duobla, unuobla</I>. <B>~isto</B>, lock-keeper. <B>Inter~ejo</B>, level, reach (between locks).", "0"],
["knabo", "knab-o", "[UV] Boy, lad, male child. <I>~o lerneja</I>, school-b. ~a <I>gusto, revo</I>. <B>~aĵo</B>, -ish prank. <B>~eco</B>, b-hood, -ishness. <B>~eca</B>, -like, puerile. ~ego, hefty chap, strapping lad. ~eto (El 2/6). ~ino, girl. <I>~ineto</I>, lassie, little maid. ~ulino, Tomboy. Ge~oj, boy(s) and girl(s). Ŝip<B>~o</B>, cabin-b. ➞ <I>bub, infan, junul</I>.", "0"],
["knali", "knal-i", "(<I>eksplodbrui</I>), make sound of explosion, blow up, burst, explode. <B>~o</B>, bang, detonation, explosive noise, report, (mot) back-fire, knock.", "0"],
["knari", "knar-i", "[OA] make short dry noise of friction, grince, grate, grind, scrape, scratch, squeak, as by <I>ĉarniro, pordo, ledo, ŝuo, plumo, rado. Rado malbona ~as plej multe</I>. <B>~ema</B> (<I>plumo</I>), stratchy pen. <B>Plum~isto</B>, literary hack, quill-driver (Rz 97/1). ➞ <I>grinc, klak, krak</I>.", "0"],
["knedi", "kned-i", "[UV] Knead. <B>1</B> mix. <I>~i farunon, paston</I> (Ge 18/6, 2 Sa 13/8). <B>2</B> give form to. <I>~i argilon</I> (Na 3/14). <B>f</B> (<I>masaĝi): ~i muskolon</I>. <B>~a</B> <I>tabulo</I>, pastry-board. <B>~aĵo</B>, dough. <B>~ilo</B>, rolling-pin. <B>~ujo</B>, kneading trough.", "0"],
["knelo", "knel-o", "(cul) quenelle, forceball, meatball, fishball. ➞ <I>knedlik</I>.", "0"],
["knifofio", "knifofi-o", "(hort) red-hot poker, torch-lily (<I>Kniphofolia</I>).", "0"],
["kniko", "knik-o", "(<I>sankta kardo</I>), holy thistle (<I>Cnicus benedictus</I>).", "0"],
["knoto", "knot-o", "Knot. <B>1</B> (<I>ligtubero</I>, a. <I>nodo</I>), k. <B>Fuŝ~o</B>, granny. <B>Glit~o</B>, running knot. <B>Okforma ~o</B>, figure of eight. <B>Kura ~o</B>, sheepshank. <B>Ref~o</B>, reef knot. <B>Seĝ~o</B>, bowline. <B>Teksista ~o</B>, weaver’s k. <B>Turbana ~o</B>, Turk’s head. <B>~i</B> (<I>fari ~on</I>), make (tie) a knot. <B>Mal~i</B>, undo, unravel, untangle, untie. <B>2</B> (mar) (a. <I>nodo</I>), one nautical mile an hour. <I>Vojaĝi 20~ojn = po</I> 20 <I>marmejloj hore</I>. ➞ <I>nod</I>. <B>Rim</B>.: In various langs knot and node are inextricably confused. I follow <I>Marista Terminaro</I> (De l’lsle) M.C.B.", "0"],
["knuto", "knut-o", "<B>~i</B>, knout (<I>Rusa vipo</I>). ➞ <I>skurĝ</I>.", "0"],
["Ko", "K-o", "[K], the letter K.", "0"],
["koaguli", "koagul-i", "(<I>-n) (malfluidigi</I>), (Cause to) Coagulat/e. <B>~aĵo</B>, -ation. ~iĝi (nt), c., clot, congeal, curdle, thicken. <I>~iĝinta,</I> -ated, clotted. ➞ <I>ĝel, kaze, solid</I>.", "0"],
["koakso", "koaks-o", "[UV] Coke. ~a <I>forno</I>, c-oven.", "0"],
["koalicio", "koalici-o", "Coalition (of parties, states, etc.). <B>~i</B>, be in coalition. <B>~ano</B>, -ist. ➞ <I>alianc, asoci, federaĵ, lig, unuiĝ</I>.", "0"],
["koalo", "koal-o", "(a. <I>faskolakto</I>), (zoo) koala (<I>Phaseolaetus</I>).", "0"],
["kobajo", "kobaj-o", "guinea-pig (<I>Cavia eobaya</I>). ➞ <I>kavi</I>.", "0"],
["kobalto", "kobalt-o", "[UV] Cobalt (Cb). <B>~a</B> <I>blu(aĵ)o,</I> c-blue, smalt.", "0"],
["kobeo", "kobe-o", "(<I>Cobaea), &gt;</I> Mexican (or cup-and-saucer) vine, cathedral bell, mile-a-minute (C. <I>seandens</I>).", "0"],
["kobitido", "kobitid-o", "(ich) loach (<I>Cobitis</I>).", "0"],
["koboldo", "kobold-o", "[UV] (hob)goblin, gnome, imp, evil sprite. <I>Arbara ~o</I>, faun. <I>Hejma ~o,</I> brownie, <B>f</B> (<I>friponeto</I>), little rogue. <B>~aĵo</B>, impish trick. <B>~ino</B>. ➞ <I>gnom, silf</I>.", "0"],
["kobro", "kobr-o", "(zoo) cobra (<I>Naja</I>).", "0"],
["koĉenilo", "koĉenil-o", "[UV] Cochineal, dried bodies of <B>~insekto</B> (<I>kakta koĉo</I>). <B>~(aĵ)o</B>, c-dye. ➞ <I>karmin</I>.", "0"],
["koĉero", "koĉer-o", "(<I>kaleŝisto</I>), coachman, driver.", "0"],
["koĉo", "koĉ-o", "(ent) cocc/us (spherical bacterium). <B>~edoj</B>.", "0"],
["kodako", "kodak-o", "kodak, hand snapshot camera (trade name).", "0"],
["kodeino", "kodein-o", "(pharm) codeine, alkaloid from opium.", "0"],
["kodekso", "kodeks-o", "codex, ancient MS volume.", "0"],
["kodicilo", "kodicil-o", "[OA] (jur) codicil, addition (supplement) to a will.", "0"],
["kodo", "kod-o", "Code. 1 (<I>leĝaro, regularo), ~o civila, komerca, kriminala, kuracista</I>. <B>2</B> conventional figures, letters, symbols, used for brevity. <I>~o telegrafa</I>. (En)<B>~igi</B>, codify. Voj-o, highway c. ➞ <I>cifr, kodeks</I>.", "0"],
["koeficiento", "koeficient-o", "<I>[OA],</I> (mat) (phys), coefficient. ~o <I>binoma, temperatura, de amplifo, disperso, ekspansio, rapido</I>. ➞ <I>faktor, indic, konstant</I>.", "0"],
["koenduo", "koendu-o", "tree-porcupine (<I>Coendou</I>).", "0"],
["koferdamo", "koferdam-o", "(mar) cofferdam, small space between bulkheads or in the tween decks.", "0"],
["kofro", "kofr-o", "<B>[OA]</B> (<I>forta kesto</I>), <B>1</B> Chest, trunk, etc. <I>Vojaĝa ~o</I>, travelling trunk. <B>2</B> money chest, coffer, safe, strong box. ➞ <I>kest, valiz</I>.", "0"],
["koheri", "koher-i", "(<I>kunteniĝi</I>), (ph) Cohe/re, cleave (hold) together. <B>~a</B>, -sive. ~(em)o, -sion. ~ilo, (el) -rer. ➞ <I>adher, kungluiĝ</I>.", "0"],
["kohorto", "kohort-o", "cohort, one tenth of Roman legion.", "0"],
["koincidi", "koincid-i", "[OA] Coincid/e, concur, occur at same time or place. <I>Parte ~i (imbriki</I>), overlap. <B>~a</B>, -ental. ~(aĵ)o, -ence. ➞ <I>kunfal, kongru, kunokaz</I>.", "0"],
["koito", "koit-o", "(med) coitus. <B>~i</B>, have sexual intercourse.", "0"],
["kojlo", "kojl-o", "(<I>dika intesto</I>), (anat) colon. <B>~ito</B>, colitis.", "0"],
["kojno", "kojn-o", "[UV] (➞ corner): Wedge, block, chock, jam. <I>~o fera, ligna, ŝtala</I>. [<I>Ne =</I> coin], <B>~e</B> <I>fiksi</I>. <B>~(um)i</B>, w., (chock, key) up. <I>~e fendi</I>, w., (rive, split) asunder. <B>~dento</B> (<I>kanino</I>) (Da 7/5). <B>~forma</B>, arrow-headed, cuneiform. <I>~~a skribo</I>. <B>~(pec)o</B>, (cl) gore, gusset (of shoe, skirt). ➞ <I>daŭb</I>. <B>~tavoloj</B> (<I>Sxuo</I>), split lifts.", "0"],
["kojoto", "kojot-o", "Coyote, prairie wolf (<I>Canis latrans</I>).", "0"],
["kojpo", "kojp-o", "coypu rat (<I>Myocastor coypus</I>).", "0"],
["kokaino", "kokain-o", "cocaine. <B>~inismo</B>, -inism. <B>~inizi</B>, anaesthetize with cocaine.", "0"],
["kokao", "koka-o", "Coca shrub. <I>~folioj</I>.", "0"],
["Kokardo", "Kokard-o", "[OA] cockade, bow. <B>~eto</B>, rosette, usually of ribbons.", "0"],
["kokcigo", "kokcig-o", "(anat) small bone ending spinal column.", "0"],
["kokcinelo", "kokcinel-o", "[UV] (ent) ladybird (<I>Coccinella</I>).", "0"],
["kokeriko", "kokerik-o", "<B>~i</B>, crow, cock-a-doodle-do.", "0"],
["koketi", "koket-i", "(-n; <I>al, kun</I>), [UV] Coquett/e, flirt, philander (Jes 3/16). <B>f</B> dally, trifle with affection. <B>~a</B>, -ish. <I>Rideti</I> ~e. <B>~ado</B>, <B>~eco</B>, coquetry, affectation of love. <B>~ul(in)o</B>, c., flirt. <B>Mal~(em)a</B>, <B>ne~(em)a</B>, prim, reserved. ➞ <I>flirt, okulum</I>.", "0"],
["kokleario", "kokleari-o", "(scurvy-grass) (<I>Cochlearia) &gt; kreno</I>.", "0"],
["koklo", "kokl-o", "(bot) Indian berry (<I>Cocculus indicus</I>).", "0"],
["kokluŝo", "kokluŝ-o", "[UV] whooping-cough.", "0"],
["koko", "kok-o", "[UV] (<I>jungle</I>) Fowl (<I>Gallus). Hejma ~o</I>, barndoor (domestic) fowl. <B>f</B> <I>trompita ~o,</I> cuckold. ~a <I>krio, kresto</I>. <B>~ido</B>, chicken, pullet. <I>Vir~ido</I>, cockerel. <I>~idaĵo</I> (cul) chicken. <I>~idaro</I>, brood. <I>~ideto</I>, chick. <B>~ino</B>, [UV] hen. <I>~inejo</I>, hen-coop (-house -roost). <B>Vir~o</B>, cock, chanticleer, rooster. <B>Batal~o</B>, game-cock. ➞ <I>bantam, fazan, frankolen, kortbird, kluk, kokerik, kov</I>. <B>Rim</B>.: <I>~ineto</I> (4 FA 220/17), should be <I>kokcinelo</I>. <B>Akvo~o</B>, <B>1</B> (<I>fuliko</I>), coot. <B>2</B> (<I>galinolo</I>), moorhen. <B>Akvo~eto</B>, spotted crake (<I>porzano</I>). <B>Perlo~o</B> (<I>numido</I>), guinea-fowl. <B>Step~o</B> (<I>sirhapto</I>), Pallas’s sand-grouse (<I>Syrrhaptes</I>).", "0"],
["kokolobo", "kokolob-o", "West Indian sea-grape, etc. (<I>Coccoloba</I>).", "0"],
["kokono", "kokon-o", "[OA] Cocoon. <B>~ejo</B>, -ery.", "0"],
["kokoso", "kokos-o", "[UV] Coconut. <I>~o raspita, sekigita</I>. ~eroj, dessicated c. ~arbo (<I>~a palmo) (Cocos nucifera</I>), c. palm. <I>~a butero, fibro, oleo</I>. ➞ <I>kopr</I>.", "0"],
["kokotraŭsto", "kokotraŭst-o", "hawfinch (<I>Cocothraustes</I>).", "0"],
["kokri", "kokr-i", "be unfaithful to, cuckold. <B>~ito</B>, cuckold, deceived husband.", "0"],
["kokso", "koks-o", "[UV] Hip, haunch. <I>Kun manoj sur</I><B><I>~e</I></B>, akimbo. ~doloro (~malsano), h-disease. ~osto, h-bone. ➞ <I>femur, iski(atik), lumb</I>.", "0"],
["koktelo", "koktel-o", "(bev) cocktail.", "0"],
["kolao", "kola-o", "kola (tree) (<I>Cola</I>). <B>Koko~o</B>, (bev) coco-cola. <B>~nukso</B>, c-nut.", "0"],
["kolapso", "kolaps-o", "<B>1</B> (med) Collapse. <B>2</B> extreme or sudden break-down (exhaustion, prostration). <B>~i</B>, collapse, break down. <B>f</B> cave in, come to nothing, fail utterly. <B>~igebla</B> (<I>seĝo</I>), made to fold up.", "0"],
["kolatitudo", "kolatitud-o", "collatitude.", "0"],
["kolbaso", "kolbas-o", "[UV] sausage, salami, saveloy. <I>~o mola, seka</I>. Sang<B>~o</B>, black pudding. Trip<B>~o</B>, chitterling. (bot) Mar~o (<I>holoturio</I>).", "0"],
["kolbo", "kolb-o", "butt (of rifle), grip (of pistol). ➞ <I>kulas</I>.", "0"],
["kolĉikino", "", "(chem) colchicine.", "0"],
["kolĉiko", "kolĉik-o", "meadow saffron, naked ladies (<I>Colchicum</I>). Aŭtuna <B>~o</B>, autumn crocus.", "0"],
["kolegio", "kolegi-o", "[OA] (various meanings in difft countries) Colleg/e, institution of scholarship, seminary of higher learning. <I>La ~oj de Oxford</I>. <B>~ano</B>, -ian. <B>~estro</B>, principal. ➞ <I>gimnazi, lice, universitat</I>.", "0"],
["kolego", "koleg-o", "[UV] (<I>kunulo</I>), Colleague. <B>1</B> holder of same office, partner. <B>2</B> associate, confrere, fellow-worker. <B>3</B> comrade, companion. <I>Voj~o</I>, traveling companion. <I>Ne estas piediranto ~o al rajdanto. ~ de ŝtelistoj</I>. <B>~aro</B>, circle of cc. ~ino (Ps 45/14). ➞ <I>kamarad, kunfrat, kunlaborant, sam-fak(-profesi)an</I>.", "0"],
["kolekti", "kolekt-i", "(<I>-n</I>) [UV] (<I>arigi</I>, wide sense), Collect. <B>1</B> (<I>kunvenigi</I>), assemble, call (gather) together, convene: <I>~i amikojn ĉirkaŭ si. Kokino ~as siajn idojn</I>. <B>2</B> (things) (<I>amasigi</I>), accumulate, amass, compile, heap(pile) up: <I>~i citaĵojn, informojn, librojn, pensojn, poŝtmarkojn, trezorojn</I>. <B>3</B> bring in, gather: <I>~i grenon, lignon, branĉojn</I>. ➞ <I>pluk, rikolt</I>. <B>4</B> make a -ion of: <I>~i florojn, konkojn, poŝtmarkojn</I>. <B>5</B> make a -ion for charitable purposes: <I>~i monoferon</I>. <B>6</B> (<I>enkasigi</I>), receive: <I>~i impostojn, ŝuldojn</I>. <B>~o</B>, -ion. <I>~o de kortkoj</I>. <B>Jar~o</B>, set, yearly volume. ➞ <I>antologi, kompil, seri</I>. <B>Mon~o</B>, offertory, subscription. <B>~isto</B>, -or. <B>~iĝi</B> (<I>amasiĝi, ariĝi, kunveni</I>), assemble, come together, meet (Ge 1/9, 49/1). <I>~iĝas pacaj batalantoj,</I> <B>~iĝo</B><I>,</I> assembly, gathering. <B>~ilo</B>, (el) storage battery. <B>~ujo</B>, offertory plate. <B>Al~iĝi</B> <I>al sia popolo</I> (Ge 25/8). <B>En~i</B>, gather in, reap (Jes 17/5). <B>Post~i</B>, glean. <B>Re~i</B> <I>siajn fortojn</I>, renew one’s strength.", "0"],
["kolektiva", "kolektiv-a", "<B>[OA]</B> (<I>opa</I>), Collectiv/e, common, joint, equally belonging to (coming from, done by) many. <I>~a farmejo, laboro, sekureco, verko</I>. (gram) <I>~a substantivo</I>. <B>~e</B>, -ly. <B>~(aĵ)o</B>, -ity. <B>~ismo</B>, <B>~isto</B>. ➞ <I>komun</I>.", "0"],
["koleoptero", "koleopter-o", "coleopter, beetle.", "0"],
["koleri", "koler-i", "(abs; <I>kontraŭ, pri; -n</I>) [UV] (Da 2/12, Jes 12/1), be Angry, cross, in a temper, incensed, irritated, wrathful. <B>~a</B>, a., heated, irate. <B>~o</B>, anger, choler, hot displeasure, ire, wrath. <B>~eta</B>, annoyed, displeased, irritated, put out. <B>~ega</B>, enraged, furious, rabid. <B>~ema</B> (<I>eksplodema, flamiĝema</I>), hot-tempered, irascible, quick to anger, snappy, testy (Se 15/18). <B>~igi</B>, anger, enrage, exasperate, incense, provoke. <B>Ek~i</B>, get a., flare up, lose one’s temper (Ge 4/5, Est 1/12, Jona 4/1). <B>Post~o</B>, resentment. <B>Sen~e</B>, coldly, dispassionately. <B>Sen~iĝi</B><I>,</I> calm down. ➞ <I>bol, eksplod, flamiĝ furioz</I>.", "0"],
["kolesterolo", "kolesterol-o", "(chem) cholesterol.", "0"],
["koliado", "koliad-o", "clouded yellow butterfly (<I>Colias</I>).", "0"],
["kolibro", "kolibr-o", "[UV] (ordinary language <I>zumbirdo</I>), humming bird (&lt; <B>trokelo)</B>.", "0"],
["koliero", "kolier-o", "(<I>ĉirkaŭkolo</I>), necklace.", "0"],
["koliko", "kolik-o", "[OA] (med) colic, gripes, intestinal cramp.", "0"],
["kolimati", "kolimat-i", "(ph) collimat/e, adjust (<I>lensojn, radiojn</I>). <B>~ado</B>, -ion. <B>~ilo</B>, -or.", "0"],
["kolimbo", "kolimb-o", "[UV] (orn) Diver, loon (<I>Colymbus</I> or <I>Gavia</I>). <B>Arkta ~o</B>, black-throated d. <B>Granda ~o</B>, great northern d. <B>Ruĝgorĝa ~o</B>, red-throated diver.", "0"],
["kolio", "koli-o", "(orn) coly, mouse-bird (<I>Colius</I>).", "0"],
["kolirio", "koliri-o", "eye-salve(-wash).", "0"],
["kolizio", "kolizi-o", "<B>[OA]</B> (<I>kunfrapiĝo</I>), collision, clash, violent encounter, <B>f</B> (<I>konflikto</I>), conflict. <I>~o de interesoj, sentoj</I>. <B>~i</B> (<I>kun</I>), collide, come into collision, crash, knock (strike violently) against, run into, clash with. ➞ <I>karambol</I>.", "0"],
["kolo", "kol-o", "[UV] Neck. <I>Riski, rompi la ~on</I>. <B>f</B> narrow part, e.g., of bottle, violin. <B>Botel~o</B>, bottle-n. <B>Ĉirkaŭ~o</B> (<I>koliero</I>), necklace. <B>Mar~o</B>, Channel. <I>La Manika ~~o</I>, English Channel. <B>~~eto</B>, narrow, sound. <B>Pied~o</B> (<I>instepo</I>). <B>Post~o</B>, withers. <B>ter~o</B> [UV] (<I>terlango, istmo</I>), isthmus. <B>~a</B>, cervical. <I>~a vejno</I>, jugular vein. <B>~umo</B>, [UV] Collar (of coat, shirt). <I>~umo punta, tol</I><I>a. ~umo refalda</I>, turn-down c. <B>Star~umo</B>, stand-up c. ➞ <I>gorĝ, nuk</I>.", "0"],
["kolobo", "kolob-o", "colobus monkey (<I>Colobus</I>).", "0"],
["kolocinto", "kolocint-o", "colocynth, bitter apple (gourd) (<I>Citrullus colocynthis</I>) (2 Rĝ 4/39).", "0"],
["kolodio", "kolodi-o", "[OA] (chem) collodion.", "0"],
["kolofono", "kolofon-o", "[UV] <B>1</B> colophony, dark resin distilled from turpentine (vn) resin. ➞ <I>rezin</I>. <B>2</B> (typ) colophon, decorative device at end of book or MS. ➞ <I>vinjet</I>.", "0"],
["kolojdo", "kolojd-o", "(chem) Colloid. <B>~a</B>, -al, gluey.", "0"],
["Kolombio", "Kolombi-o", "CO.", "0"],
["kolombo", "kolomb-o", "[UV] Dove, Pigeon (<I>Columba</I>) (Ge 8/8). <I>Leter~o, poŝt~o</I>, carrier-p. <B>~ejo</B>, <B>~ujo</B> (Jes 60/8), dove-cote. <B>~umi</B>, coo. <B>f</B> bill and coo. <B>~kolora</B>, d-coloured. ➞ <I>amindum, interkares, kver; enad, livi, palumb, turt</I>.", "0"],
["kolonelo", "kolonel-o", "<B>[OA]</B> (<I>regimentestro</I>), Colonel. <B>Sub~o</B>, lieutenant-c.", "0"],
["kolonio", "koloni-o", "[OA] Colon/y, settlement. <I>La Franca ~o en Londono</I>. (bot) (zoo), <I>~o formika, larva, mikroba, sturna</I>. <B>~a</B>, -ial. <I>~a ministro</I>. <B>~i</B> (<I>fondi ~on</I>), -ize. <B>~aĵoj</B>, -ial produce. <B>~ano</B>, -ial. <B>~ismo</B>, -ialism.", "0"],
["kolono", "kolon-o", "Column, Pillar, monument or other vertical object. in form of c., post, stanchion, upright. <I>~o de (el) akvo, fero, fumo, lingo, ŝalo, ŝtono</I> (Ge 19/26; Jĝ 16/29). <I>~o fajra, nuba</I> (El 13/21). <B>f</B> <I>subtenilo de la ŝtato</I>, p. of state. <B>~aro</B>, colonnade, arcade. <B>~eto</B> (<I>balustro</I>), bannister, etc. ➞ <I>fost, kolum, pilori</I>. ➞ <I>kolumn</I>.", "0"],
["koloraturo", "koloratur-o", "(mus) coloratura, florid passage. ➞ <I>rulad</I>.", "0"],
["koloro", "kolor-o", "????? <I>monochrome</I>. ➞ farb, pentr, ŝmink, tinktur.", "0"],
["Koloseo", "Kolose-o", "(Roman amphitheatre) coliseum. <B>f</B> large theatre.", "0"],
["koloso", "kolos-o", "[OA] Coloss/us, huge dominating figure (➞ <I>gigant, titan</I>). <B>~a</B> (<I>grandega), -al</I>, enormous, gigantic, <I>~a arbo, entreo, preno, viro</I>.", "0"],
["kolostro", "kolostr-o", "colostrum, first milk from mother.", "0"],
["kolporti", "kolport-i", "(<I>-n</I>), [UV] Hawk, carry about for sale, peddle. <B>~ado</B>, colportage. <B>~isto</B>, -er, colporteur, itinerant vendor, pedlar, packman.", "0"],
["kolubro", "kolubr-o", "[UV] genus of harmless snakes &gt; whip (rat) snake (<I>Coluber</I>). ➞ <I>natrik, vipur</I>.", "0"],
["kolumno", "kolumn-o", "[OA 8], <B>1</B> column (of text, page, figures, etc. (Jer 36/23). <B>f</B> pile of plates, etc. <B>2</B> file; (mil) of soldiers; (chs, drs) of pieces. ➞ <I>kolon</I>.", "0"],
["koluteo", "kolute-o", "(<I>vezik-arbedo</I>), bladder senna (<I>Colutea</I>).", "0"],
["koluzio", "koluzi-o", "Collus/ion, fraudulent secret understanding. act in c. <B>~a</B>, -ive. ➞ <I>komplot, konspir</I>.", "0"],
["kolzo", "kolz-o", "[OA] Colza, winter rape (<I>Brassica campestris var. olifera). ~a oleo</I>, c. oil. <I>~a semo</I>, cole-(rape-)seed. ➞ <I>nap</I>.", "0"],
["komandi", "komand-i", "(<I>-n</I>), [UV] <B>1</B> (be in) Command (of), have authty (over). <B>2</B> bid, order. <B>1</B> c., bidding, order. <B>2</B> authty, control, rule. <B>~a</B>, -ing, imperative. <B>~anto</B>, -ing officer, -ant, -er (Jer 51/28). <B>Ĉef~anto</B>, -er in chief. ➞ <I>ordon</I>.", "0"],
["komandito", "komandit-o", "[OA] Sleeping Partner/ship. <I>~a societo</I>, limited liability partnership. <B>~i</B>, finance without administration (as a s.p.). ~anto, <B>~ulo</B>, s.p.", "0"],
["komandoro", "komandor-o", "commander (of an order).", "0"],
["komao", "koma-o", "(ac) comma, interval 80/81.", "0"],
["komato", "komat-o", "Coma, prolonged loss of consciousness, unnatural heavy sleep. <B>~a</B>, -atose, drowsy. ➞ <I>beriberi, letargi, sensent</I>.", "0"],
["komatolo", "komatol-o", "(zoo) feather-star (<I>Comatula</I>).", "0"],
["kombajno", "kombajn-o", "(agr) combine harvester, reaping and threshing machine.", "0"],
["kombi", "komb-i", "[UV] Comb, brush, groom. <I>~i barbon, katon, harojn</I>. <B>2</B> (<I>kardi</I>) card (flax, wool) (Jes 19/9). ~ilo, c. <B>~isto</B>, hair-dresser. ~itaĵoj, -ings. Mal<B>~i</B>, dishevel, take one’s hair down. Ne~ita, bedraggled, slatternly, unkempt. Retro<B>~i</B>, c. to the back. II Venus~ilo (bot) (<I>skandiko</I>). ➞ <I>bukl, friz, strigl</I>.", "0"],
["kombini", "kombin-i", "(<I>-n kun</I>), [UV] Combin/e (wide sense). <B>1</B> amalgamate, blend, compound, join together, pool, unite, (chem) <I>~i elementojn</I> (to form a compound). <B>2</B> arrange, put together in definite order. <I>~i ciferojn, literojn, vortojn</I>. ➞ <I>permut</I>. (ac) ~a tono (<I>rezultanto</I>), -ation tone, resultant. <B>~aĵo</B>, -ation, (cl) -ations. <B>~iĝi</B>, c., coalesce, unite. <I>~iĝemo</I> (chem) affinity. <B>Mal~i</B>, break up, decompose, disintegrate. ➞ <I>kompon, kunig, kunmet, miks, unuig</I>.", "0"],
["komedio", "komedi-o", "[OA] Comed/y, light amusing stage-play. <B>~a</B>, of c. <I>~a sceno, situacio</I>. ~i (<I>ludi) ~on</I> (also figuratively). <B>~aĵo</B>, piece of c. ~anto, player in c. <B>f</B> dissembler. ~ist(in)o, -ian, -ienne. ➞ <I>burlesk, fars, histrion, komik</I>.", "0"],
["komelino", "komelin-o", "(bot) commeline &gt; spiderwort (<I>Tradescantia</I>).", "0"],
["komenci", "komenc-i", "(<I>-n, ce, per, -i</I>, abs), [UV] Begin, Commence, Start (something). <B>1</B> engage in, enter upon, s., set about, take up. <I>~i laboron, parolon, ~i disputi, paroli, varmiĝi. Mi ~os per plendo. ~as pluvi</I>. <B>2</B> be (stand) at the b-ning of; inaugurate, open. <I>Tiu frazo ~as la poemon</I>. <B>~o</B>, b-ning. <B>1</B> c-ment, s. ~o <I>bona, laboro duona. La ~o de sciado</I> (Se 1/7). <B>2</B> first part. <I>~o de jaro, kanto, strato</I>. <B>~a</B>, first, initial, opening, primary. <I>~a elspezo, stadio</I>. ~e (<I>en la ~o</I>) (Ge 1/1), at first, in the b-ning, to s. with. <I>De</I> <B><I>~e</I></B>, from the begining. <I>~e de, (ek de</I>), begining with, s-ing from. ~anto, tyro. <B>~igi</B>, b., initiate, set in operation. <B>~iĝi</B>, (nt) b., c., s. <I>La kunveno ~iĝis per kanto</I> (opposite <I>ĉes, finig</I>). Re<B>~i</B>, restart, resume. ➞ <I>ek, entrepren, inaŭgur, inic(iai), malferm</I>.", "0"],
["komentario", "komentari-o", "[UV] (&lt; <I>komentaro</I>), Comment/ary, expository treatise, notes of elucid-(explan-illustr-)ation. <I>~o pri la Biblio</I>. ~i (<I>fari -on</I>) (Ij 13/4). <B>~isto</B>, -ator.", "0"],
["komenti", "koment-i", "Comment, annotate, make observations (remarks) on. <B>~o</B>, c., gloss, critical or explanatory note, remark, <B>~ado</B>, <B>~aro</B>, (running) -ary, cc., descriptive observations. ➞ <I>komentari</I>.", "0"],
["komerco", "komerc-o", "[UV] Business, Commerce, Trade, exchange of merchandise. <I>~o eksterlanda, enlanda, pogranda</I>. <B>Kaŝ~o</B> (<I>nigra ~o</I>), black market. <B>Libera ~o</B>, free t. <B>Vin~o</B>, wine trade. <B>~i</B> (<I>per, pri</I>), trade, carry on , deal. <B>~a</B>, b., c., t., mercantile. <I>~a centro, ĉambro, firmo, rilato. ~a ŝipo,</I> merchantman. <B>~aĉo</B>, low type of b., e.g., in brummagem ware, junk. <I>~~i</I> (pej), make money out of, trade on. <B>~aĵo</B> [UV] (<I>varo</I>), commodity, goods, merchandise, wares. <B>~ejo</B>, mart, place of b., t-centre. ➞ <I>bazar, foir, merkat</I>. <B>~isto</B>, dealer, merchant, t-r, t-sman (Ze 14/21). ➞ <I>afer, industri, negoc, var</I>.", "0"],
["kometo", "komet-o", "[OA] comet. <I>La kapo, vosto de ~o</I>.", "0"],
["komforto", "komfort-o", "[UV] Comfort, ease, sense of well-being, freedom from trouble. <B>~a</B>, -able, cosy, pleasant, snug. <I>~a domo, vivo. ~aj cirkonstancoj. ~a seĝo</I>, easy chair. <B>~e</B>, in c., at ease. <I>Sidi ~e. Cu estas ~e tie?</I> <B>~i</B>, be -able <I>[Ne= konsoli],</I> ~aĵoj, cc. ~igi (~iĝi), Make (get) -abie. Mal~(Sen~)a, c-less, bleak, cheerless, dreary, unable, uneasy. ➞ <I>hejmec, oportun</I>. Opp <I>ĝen</I>.", "0"],
["komika", "komik-a", "<B>[OA]</B> Comic(al), droll, facetious, funny, humorous, laughable, ludicrous, mirth-provoking. <I>~a aspekto, gesto, kanto, situacio</I>. <B>~aĵo</B>, -ality. <B>~ulo</B>, c. fellow, ~opero. ➞ <I>amuz, komedi, ridig, sere</I>.", "0"],
["komisaro", "komisar-o", "[OA] Commiss-ary, -ioner; deputy, temporary steward (of ball, meeting, etc.). <B>~ejo</B>, -ioner’s office.", "0"],
["komisii", "komisi-i", "[UV] Commission. <B>1</B> (<I>ion</I>): entrust with, commit (confide) to, give into the charge (put into the hands) of: <I>~i aferon, homon, oficon, taskon al</I> (2 Kr 23/18, Se 26/6, Da 1/11). <B>2</B> (<I>iun, al iu</I>); appoint, authorize, empower, warrant: <I>~i iun por pro testi</I> (Ez 1/2, Da 2/24). <I>~i al komitato fari proteston</I>. <B>~o</B>, c., charge, entrusted task, mandate. <I>Plenumi ir~on</I>, run an errand. <I>Preni ~on</I> (1 Sa 17/18). <B>~a</B>, fiduciary, on trust. <I>~a pago,</I> (payment). ~e <I>de mi</I>, on my behalf. <B>~isto</B>, -aire, messenger, etc. ~ito (<I>komisaro</I>), deputy, mandatory representative, trustee. <I>~ite de</I>, on behalf of. <B>~itaro</B>, c., board of trustees. ➞ <I>agent, deleg, konfid, ordon, rajtig, ŝarĝ</I>.", "0"],
["komisiono", "komision-o", "<B>[OA]</B> (<I>komisiitaro</I>), Commission, Board, authorized for special enquiry or study. <B>~ano</B>, -er.", "0"],
["komitato", "komitat-o", "[UV] Committee, body appointed for special function by (and usually out of) a larger body. <I>~o Biblia, eldona, financa, kongresa, lingva, loka, organiza</I>. Plenuma ~o (<I>ekzekutivo</I>). <B>~ano</B>, c- member. ~ejo, c-room. ~estro, chairman of c. Sub~o. ➞ <I>komision</I>.", "0"],
["komizo", "komiz-o", "[UV] (com) shop or office assistant, clerk, employee, salesman. <I>Migra, vojaĝa ~o</I>, commercial traveller. ~tao, shop girl. Ĉef<B>~o</B>, head clerk, head of department. ➞ <I>oficial</I>.", "0"],
["komo", "kom-o", "[UV] (typ) comma. <I>~o invertita. ~forma bacilo</I>, c-bacillus. <B>~a papilio</B>, c-butterfly (<I>Polygonia c-album</I>). <B>punkto~o</B> [UV] (<I>semikolo</I>), semicolon.", "0"],
["komodo", "komod-o", "[UV] (<I>tirkestaro</I>), commode, chest of drawers.", "0"],
["komodoro", "komodor-o", "(<I>subadmiralo</I>), commodore.", "0"],
["Komoroj", "Komor-oj", "KM.", "0"],
["kompakta", "kompakt-a", "compact, closely pressed together, dense, solid; (of man, horse), dumpy, squat, stocky, thick-set. (mus) <I>~a harmonio</I>, close harmony, (style) condensed, terse. <B>~igi</B>, compress, condense, cram, jam firmly together, squeeze (tight). <B>Mal~a</B>, loose, slack. ➞ <I>aglomer, dens, firm, kondens, konglomer</I>.", "0"],
["kompanio", "kompani-o", "[OA] Compan/y. <B>1</B> co-partnership, firm, joint business. X <I>kaj ~o</I>, X &amp; Co. <I>Akcia, anonima ~o</I>, joint stock (limited liability) c. <B>2</B> -ionship, fellowship, social party. <I>En ~o eĉ morto faciliĝas. En ~o de (akompanate de, kune kun</I>). <B>~i</B> <I>kun, fari (havi) ~on kun,</I> associate with, be in the c. of. <B>3</B> (mil) (<I>roto</I>). <B>~ano</B>, member of c. <B>~ema</B>, -able, sociable. <B>~ulo</B> (<I>kunulo</I>), -ion, associate (Jĝ 14/20). ➞ <I>akompan, firm, komandit, societ</I>.", "0"],
["komparativo,", "komparativ-o,", "[OA] (gram) comparative form. <I>~o egaleca, (mal)supereca</I>.", "0"],
["kompari", "kompar-i", "(<I>-n, kun</I>) [UV]. <B>1</B> Compar/e (similarity or diffce) between objs, estimate relatively, make a -ison with, collate. <B>2</B> state sim-ity with, liken to. <I>~i fraŭlinon kun rozo</I>. <B>~a</B>, -ative, relative. <B>~o</B>, -ison, relative estimate. <I>En ~o kun (~e kun</I>) (No 3/46, Jeĥ 16/52), in -ison with, -ed with. <B>~aĵo</B> (<I>similigo</I>), -ison, similitude. <B>~ebla</B>, -able. <B>Sen~a</B>, <B>ne~inda</B> (<I>senegala</I>), in-able, matchless, peerless, unique, unparalleled, without c. (Se 3/15). <I>Ne~eble (sen~e) beta</I>. ➞ <I>egal, komparativ, rilat, simil</I>.", "0"],
["kompaso", "kompas-o", "[OA] (mar) Compass [Ne= <I>cirkel</I>]. ~o <I>azimuta, magneta</I>. ~a <I>devio, ekarto</I>, c-error. <I>~a montrilo, nadlo, rozo</I>, compass-needle, disc. <B>~ujo</B>, binnacle. ➞ <I>ampleks</I>.", "0"],
["kompato", "kompat-o", "[UV] Compassion, Pity; mercy, sympathy. <B>~i</B> (<I>-n, al</I>), pity, have compassion (p.) on, be sorry for, commiserate with. <I>~i (indulgi) la vivon de bruto</I> (Se 12/10). <I>~u (nin</I>), have p. (on us)! <B>~oplena</B>, <B>~(em)a</B>, -ate, sympathetic, tender-hearted. <B>~anto</B>, one showing p. <B>~igi</B> (<I>kortuŝi</I>), move (stir) to c., incite to p. <I>~iga</I>, affecting, moving, touching. <B>~inda</B> (<I>mizera, plorinda, povra</I>); Deplorable, miserable, pitiable, poor. <I>~indulo,</I> poor creature. <B>Mal~a</B>, <B>Sen~a</B>, (<I>senkora</I>), hard, harsh, implacable, pitiless, ruthless, unfeeling. <I>La sen~a morto</I>. ➞ <I>bedaŭr, domaĝ, kondol, kunsent</I>.", "0"],
["kompendio", "kompendi-o", "Compend(ium), abridgment, concise and comprehensive account or treatise. ➞ <I>epitom, resum</I>.", "0"],
["kompensi", "kompens-i", "(<I>-n; al, pri</I>) <B>[OA].</B> Compensat/e. <B>1</B> balance, counterpoise, offset, restore equilibrium. <B>2</B> atone, indemnify, make amends (up) for, requite (for), make good (a loss) (El 22/12). <B>~a</B>, compensating, -ory. <I>~a balancilo, pendolo</I>. <B>~e</B>, in -ion (El 21/26). <B>~(aĵ)o</B>, -ion, amends, reparation, satisfaction (El 22/3). <I>Milita ~o</I>, indemnity. <I>Aljuĝi mon~on, perd~on</I>, award damages. <B>~ilo</B>, -or, -ion balance, equalizing appliance. <B>Sin ~i</B> (per), indemnify one’s by, recoup. ➞ <I>egalvalor, ekvilibr, kovr</I>.", "0"],
["kompetenta", "kompetent-a", "[F] (<I>en, pri</I>), Competen/t; able, adept, capable, efficient, proficient, properly qualified. <I>~a instruisto</I> (Jes 40/20). <I>~(id)a esploro, kritiko</I>. <B>~(ec)o</B>, -ce, ability, qualification. <B>~ulo</B>, c. person, connoisseur, expert (Jes 5/21). <B>Ne~a</B>, in-c., inefficient. ➞ <I>ekspert, fidind, kapabl, lert, specialist, spertul</I>.", "0"],
["kompili", "kompil-i", "[OA] (lit) Compil/e, collect into volume form, draw up from various sources. <I>~i antologion, dokumenton, faktaron, vortaron</I>. <B>~aĵo</B>, -ation, collection, miscellany. <B>~into</B>, <B>~isto</B>, -er. ➞ <I>kolekt, kunmet, redakt, sintez</I>.", "0"],
["komplekso", "kompleks-o", "(geom, mat, med, psy) Complex(us), complication of various factors; network, tangle, whole consisting of several parts. <I>Minusa ~o</I>, inferiority complexus. <B>~a</B> (<I>plurelementa</I>), c., complicated, composite, involved, <I>~a demando, ideo, karaktero. ~a frazo</I>, c. sentence (with subordinate clauses). <B>~eco</B>, -ity. ➞ <I>komplik, kunaĵ</I>. opposite <I>element</I>.", "0"],
["komplemento", "komplement-o", "[OA] complement. <B>1</B> completion, full number or quantity required, quota, <B>~a</B>, -ary, serving to complete. <I>~a faktoro, funkcio, koloro. ~a angulo</I> (making up 90°). ➞ <I>kompletig, plenig</I>. <B>2</B> (gram) complement, object. ➞ <I>adjekt, epitet, objekt, predikativ, prepozitiv, suplement</I>. <B>Sen~a</B>, absolute.", "0"],
["kompleta", "komplet-a", "[OA] Complet/e, all included, entire, finished, having all its parts, lacking nothing of full number. <I>~a kolekto, servico, vortaro</I>. <B>~o</B> (<I>io ~a</I>), c. set, equipment, ensemble, outfit; suit (<I>vestaro</I>) (Jĝ 14/13), suite (<I>mebloj). En plena ~o</I>, in full muster. <B>~eco</B>, c-ess. <B>~igi</B>, c. <I>~igi siajn seiojn. ~iga kurso</I>, finishing course. <B><I>~igo</I></B>, -ion. <B>Ne-a</B> (<I>mankhava</I>), in-c., defective, with gaps, partial. ➞ <I>perfekt, plen(nombr), senmank, tut</I>.", "0"],
["komplezo", "komplez-o", "[UV] Kind/ness, courtesy, favour, good offices, service. <I>Faru al mi la ~on</I>, do me the favour, oblige me. <B>~i</B> (<I>fari -on</I>), oblige, be so kind as to. <I>Ĉu vi ~us?</I> <B>~(em)a</B>, kindly, benevolent, complaisant, courteous, friendly, good-natured, obliging, willing. <B>~e</B>, -ly. ➞ <I>afabl, bonvol, favor, servem, volont</I>.", "0"],
["komplica", "komplic-a", "accessory. <I>Esti ~a</I>, be a party to (evil act), <B>~o</B>, partnership in guilt, <B>~ulo</B>, accomplice, <I>~ido en adulto,</I> co-respondent.", "0"],
["kompliki", "komplik-i", "<B>[OA]</B> (<I>malfaciligi, malsimpligi</I>), Complicat/e, entangle, make complex or intricate. <I>Tio ~as la aferon</I>. <B>f</B> aggravate, <B>~(aĵ)o</B>, -ion, -ing circumstance, entangled state of affairs. <I>~aĵoj politikaj, sociaj, de malsano</I>. <B>~eco</B>, complexity, <B>~ita</B>, -ed, complex, intricate, involved, knotty. <B>Mal~i</B> (<I>klarigi, simpligi</I>). ➞ <I>implik, kompleks</I>.", "0"],
["komplimento", "kompliment-o", "[OA] Compliment, amiable (polite) expres sion of congratulation or praise, civility. <B>~i</B> (<I>fari ~on</I>), c., congratulate. <B>~(em)a</B>, -ary, flattering, laudatory. <B>Sen~e</B>, sincerely, without flattery. ➞ <I>flatet, gratul, omaĝ, salut</I>.", "0"],
["komploti", "komplot-i", "(<I>-n</I>, abs) [OA], contrive, (hatch, weave) a Plot, plan, scheme (for evil purpose). <B>~o</B>, p., intrigue, machination. <B>~into</B>, conspirator. ➞ <I>insid, konspir, intrig, sekrete interkonsenti</I>.", "0"],
["komponi", "kompon-i", "<B>[OA], 1</B> Compos/e (write) music. <I>~i sonaton</I>. <B>~ado</B>, <B>~aĵo</B>, -ition. <B>~isto</B>, -er. <B>2</B> (chem) <I>= kombini. Mal~iĝo</I>, de-ition.", "0"],
["komposti", "kompost-i", "[UV] (typ) Compos/e, set up (in type), assemble. <B>~(ad)o</B>, typesetting. <B>~a</B> <I>framo</I>, -ing frame, <B>~aĵo</B>, matter in type. <B>~endaĵo</B>, copy. <B>~ilo</B>, -ing stick. <B>~isto</B>, -itor. <B>~formato</B>, justification, type area. <B>Mal~i</B>, diss, break up type. <I>[Ne= kompon, kompost]</I>.", "0"],
["kompoŝto", "kompoŝt-o", "(agr) Compost. <B>1</B> organic manure from rotting matter. <B>2</B> soil-mixture for pots or seed-boxes, <B>~i</B>, spread c. <B>~amaso</B>, c-heap. ➞ <I>mule</I>.", "0"],
["kompoto", "kompot-o", "[OA] (cul) compote, fruit cooked or preserved in syrup (keeping wholly or in part its initial form). <I>Poma ~o</I>, stewed apple, <B>~i</B> (<I>malrapide bolet(ig)i</I>), stew. ➞ <I>marmelad</I>.", "0"],
["kompozitoj", "kompozit-oj", "(bot) compositae.", "0"],
["kompreni", "kompren-i", "(<I>-n, ke, kiel</I>, abs) [UV]. <B>1</B> (<I>kapti la sencon</I>): Understand, Comprehen/d; know (grasp) the meaning of, take in. <I>~i lingvon, parolon, malfacilon, ŝercon. El tio mi ~as, ke … </I> <B>2</B> be competent, know (all about, how to deal with). <I>~i matematikon, muzikon, infanojn</I>. <B>3</B> understand the cause of. <I>-i lin, lian konduton, timon</I>. <B>~o</B>, c-sion (Jes 44/19). <B>~aĵo</B>, concept, idea, notion. <B>~ebla</B> [UV] (por), c-sible, clear, evident, intelligible, obvious, perspicuous. <B>~emo</B>, insight, <B>~eti</B>, half u., get a glimmering (inkling, faint idea) of. <B>~igi</B> (<I>ion al iu</I>), clear up, explain, (<I>iun pri io</I>), make understand. <B>Ek-i</B>, apprehend, grasp the idea. I<B>nter~(iĝ)o</B>, mutual u-ing. <B>Mem~ebla</B> (<I>~ebla per si mem</I>), self-evident. <B>Mis~i</B>, mis-u. <B>Ne~ado</B>, lack of u-ing (Jes 5/13). <B>Ne~ebla</B>, inc-sible (Se 30/18). <B>Sub~i</B>, deduce, infer. <I>~~ita,</I> implied, tacit. <I>~~igi (implici</I>), hint, imply, insinuate. ➞ <I>koncept</I>.", "0"],
["kompreso", "kompres-o", "[UV] (surg) Compress, pad of lint or wet cloth to c. artery or relieve inflammation. ➞ <I>bandaĝ, bend, fomentaj, kataplasm. [Ne= kunprem]</I>.", "0"],
["kompromiso", "kompromis-o", "[OA] Compromise, middle course, mutual concession. <B>~i</B> (<I>fari ~on</I>), settle by c. <B>~aĉi</B>, palter (with duty), surrender (principle). ➞ (<I>inter)ced, mezvoj</I>.", "0"],
["kompromiti", "kompromit-i", "[OA] Compromis/e, endanger, imperil, jeopardize, prejudice (by indiscreet action). <I>~i interesojn (reputacion, sanon</I>). Sin <B>~i</B>, bring one’s under suspicion, place one’s in false position. <B>~a</B>, -ing. <I>~a letero, situacio</I>. <B>~iĝi</B>, become c-ed.", "0"],
["kompunda", "kompund-a", "(plurera), (ph) (tech), compound, composite. <I>~a dinamo, generilo, interezo, intervalo, kurbo, okulo, ostrompo, umbelo</I>.", "0"],
["komputi", "komput-i", "(<I>nombri, kalkuli</I>), Comput/e, Reckon (count number or amount). ~(ad)o, -ation, r-ing. <B>~ebla</B>, calculable, numerable. ~ilo, -er. <I>Gas~ilo. Paŝ~ilo,</I> pedometer.", "0"],
["komuna", "komun-a", "(<I>al</I>), [UV] Common (to), collective, general, public, belonging to, known (shared) by, for the use of, all. <I>~a feliĉo, lingvo, konsento, kredo, uzo. Havi nenion ~an kun</I>... ~a ĉambro, c-room. ~a domo (Se 21/9), c. to both. ~a juro, c-law. ~a kunveno, gen. meeting. ~a letero, joint letter, round robin. ~a muro, dividing wall. <I>La Libro de</I> ~a Preĝo. ~a tero, c. (land). ~e (<I>kune</I>), by all, c-ly, in c., jointly. <B>~igi</B>, collectivize, put to c. use. ~ismo, ~isto. <B>~umo</B>, [UV] community, assembly (El 12/3, Ps 22/25). <B>1</B> body politic, borough, c-wealth, township. <B>2</B> group with c. life and interests. <I>~umo religia</I>, congregation. <I>~umo de mortintoj</I> (Se 21/16). <B>Ne~a</B>, personal, private. ➞ <I>ĝeneral, kun, reciprok, vulgar [Ne= triviala]</I>,", "0"],
["komuniki", "komunik-i", "(<I>-n</I>), [UV] Communicat/e. <B>1</B> convey, give, impart, transmit. <I>~i malsanon, movon, varmon</I>. <B>2</B> disclose, divulge, make known, reveal. <I>~i ideon, eltrovon, novaĵon, senton</I>. <B>3</B> hold intercourse, transmit by speech, etc. <B>~a</B>, -ing. <I>~a pordo, ŝnuro, tubo, vojo</I>. <B>~o</B>, -ion. <I>~o de movo</I>. <B>~aĵo</B>, -ion, despatch, information, message. <B>~ebla</B>, communicable, contagious. ~ejo (<I>~a vojo</I>). <B>~ema</B> (<I>konfidencema</I>), -ive, unreserved. ~igi (<I>A kun B</I>), put into -ion. (Inter)~iĝi (<I>kun, per</I>), c., be in connection (Se 20/19). <I>La iambroj inter~iĝas</I>. Tele<B>~o</B>, longdistance (trunk) call. ~ilo, means of -ion. ➞ <I>infekt, rilat, korespond, trans-don (-send), transmisi, sciig</I>. komut-i (<I>alidirektigi</I>), (el, ry), Switch, alter course of current or track, shunt, shift the points, f <I>~i la konversacion</I>. (jur) commute (penalty), (mat) reverse, transpose (order). ~a <I>tabulo</I>, s-board. <B>~ilo</B>, change-over s, commutator (<I>trakforko). Rotacia ~o</I>, collector (of dynamo). <B>~(il)isto</B>, pointsman. ➞ <I>Salt</I>.", "0"],
["komunio", "komuni-o", "[UV] (the Sacrament of Holy) Commun/ion. ~i (<I>iun</I>), administer the s. to. ~a tablo, c-table. <B>~iĝi</B>, -icate, partake of (receive) the s. ~iĝant(-ul)o, -icant. Eks<B>~igi</B>, ex-icate. Inter<B>~iĝi</B>, inter-c.", "0"],
["koncedi", "konced-i", "(<I>-n, ke</I>) [OA-8], concede, admit, allow, grant. <I>~i punkton en argumento</I>. <I>Tion mi ~as, tamen</I> . <B>. . (gram) ~a</B> klaŭzo. ➞ <I>koncesi</I>.", "0"],
["koncentra", "koncentr-a", "<B>[OA] (evit)</B> = samcentra, concentric.", "0"],
["koncentri", "koncentr-i", "(<I>alcentrigi, konverĝigi</I>), Concentr/ate. <B>1</B> Bring to bear, bring to common point or centre, collect, draw to a head. <I>~i atenton, fortojn, pensojn, trupojn</I>. 2 (chem) increase amount of substance in solution. <I>~ita infuzo, solvaĵo</I>. ➞ <I>kondens</I>. <B>~ado</B>, <B>~aĵo</B>, <B>~iĝo</B>, -ation, intensification. <B>~ejo</B>, concentration camp. <B>Mal~i</B>, <B>1</B> (<I>difuzi, dispersi, diverĝigi</I>): disperse, dissipate, scatter. <B>2</B> (<I>dilui, maldensigi</I>): dilute, thin. ➞ <I>densig</I>.", "0"],
["koncepto", "koncept-o", "[OA] (phi) Concept, abstract gen. notion. <B>~i</B>, form a c., conceive. ➞ <I>ide, imag, noci. [He ~~ koncip]</I>,", "0"],
["koncerni", "koncern-i", "(<I>-n</I>), [UV] Concern, affect, bear upon, be the business of, have to do with, interest,relate to,touch (Ps 119/38). <I>Tio ne ~as min</I>. <B>~o</B>, c., business, interest. <I>Senti ~on pri</I>, have a c. about. <B>~a</B>, -ing, on the subject , pertinent. <I>~a literaturo</I>. ~ata, -ed, in question, taking pt. <I>~ata persona (=~ato</I>). ~e (<I>-n</I>) (<I>rilate al</I>), about, as regards, in referee (relation) to (No 3/7; Rd 34/11, 12). <I>~e tion</I>, as to that. ➞ <I>interes, pri, rilat, tuŝ</I>.", "0"],
["koncertino", "koncertin-o", "(m.i.) concertina.", "0"],
["koncerto", "koncert-o", "[OA] (mus) Concert. <I>~o instrumenta, voĉa</I>. <I>~i (fari -on</I>), give (play in) a c. <B>~aĵo</B>, c-piece. ~ejo, c-hall. ~ist(in)o, performer. ➞ <I>kontert</I>.", "0"],
["koncesio", "koncesi-o", "[OA] (jur) (official) Concession, grant, licence, sanction. ~i (<I>fari ~on</I>), confer (grant) a c. <I>~i privilegi-(rajt-ter -)on</I>. <B>~ulo</B>, -naire, licensee. ➞ <I>konced, privilegi, rajtig</I>.", "0"],
["koncilo", "koncil-o", "(a. <I>koncili-o</I>), (ecc, pol) Council,", "0"],
["koncipi", "koncip-i", "(<I>gravediĝi</I>), conceive, become pregnant. <I>Kontraŭ~ilo</I>.", "0"],
["konciza", "konciz-a", "[OA] Concis/e, brief and com- prehensv in expression, laconic, pithy, succinct, terse. <I>~a parolo, raporto, stilo</I>. <B>~(ec)o</B>, -ion. <B>~igi</B>, condense, compress, put briefly. Mal~a (<I>multvorta</I>), diffuse, prolix, wordy, verbose. ➞ <I>mallong, resum, unuvort</I>.", "0"],
["konĉerto", "konĉert-o", "concerto, composition in sonata form for solo instrumt(s) and orchestra.", "0"],
["kondamni", "kondamn-i", "(-n; <I>al; je;</I> abs), [UV] condemn. <B>1</B> (jur) Convict, give judgment against, pronounce guilty, sentence. <I>~i al morto</I>. <B>2</B> Strongly disapprove, blame, censure, deprecate, proscribe, reject. <B>3</B> doom (H/32). <B>~(aĵ)o</B>, condemnation, conviction, sentence. <B>~a</B>, condemnatory. <B>~inda</B>, to be condemned, reprehensible. <B>~ito</B>, condemned person, convict. <B>Mal~i</B>, (<I>absolvi</I>) acquit, clear, discharge, exonerate. ➞ <I>anatem, forĵet, malaprob, mallaŭd</I>.", "0"],
["kondensi", "kondens-i", "(<I>densigi</I>), condense, increase density of, reduce in volume, thicken. <I>~i (likvigi) gason</I>. <I>~ita lakto</I>, condensed milk, <B>f</B> compress into a few words. <B>~aĵo</B>, <B>~iĝo</B>, condensation. <B>~ilo</B>, condenser, capacitor. <I>~ilo agord-(diferencial- elektroliz- krad- variiegebl-)a</I>, (phot) condensing lens. ➞ <I>amasig, intensig, koneentr, kundensig</I> (Ij 10/10).", "0"],
["kondicionalo", "kondicional-o", "<B>[OA]</B> (gram) = us-modo.", "0"],
["kondiĉo", "kondiĉ-o", "[UV] <B>1</B> Condition, qualification, stipulate <I>[Ne ~~ stato]. ~o de kontrakt -(lu-vertd-)o</I>. <B>2</B> needed circumstance (element). <I>La unua ~o de sukceso</I>. <B>~a</B>, -al, hypothetical, qualified. <I>~a modo</I>, -al mood (-us). <I>~a akcepto</I>, qualified acceptance. <I>~a promes-(propon-)o</I>. ~e (<I>~~kun (sub) la ~o) ke</I>, -ally, on c. (provided) that. <I>~i (fari ~on</I>), impose cc., limit as a c., postulate, stipulate. ~oj, <B>~aro</B>, cc., terms. <I>Sub tiuj ~oj</I>, under those circumstances. <I>~oj ekonomiaj (de la vivo</I>). Sen<B>~a</B>, un-al, absolute, free. ➞ <I>postal, premis, rezerv</I>.", "0"],
["kondimento", "kondiment-o", "(<I>spicaĵo</I>), condiment, relish, seasoning, spice (<I>= mustardo, salo, vinagro .</I>..). <B>~i</B>, flavour, season, spice. ~ujo, cruet.", "0"],
["kondol(enc)i", "", "(<I>-n; kun iu pri io</I>), [UV] Condol/e, commiserate, express sorrow (sympathy). <I>~i kun vidvino</I>. <B>~o</B>, -ence. <I>Esprimi ~on</I>. ~a <I>letero, vizito</I>, of -ence. ➞ <I>kompat, kunsent</I>.", "0"],
["kondomo", "kondom-o", "condome, contraceptive sheath.", "0"],
["kondoro", "kondor-o", "[OA] (orn) Condor (<I>Saeorhamphus gryphus</I>). ➞ <I>vultur</I>.", "0"],
["kondro", "kondr-o", "carragheen, Irish moss (<I>Chondrus crispus</I>) (seaweed used for jellies, etc.).", "0"],
["konduki", "konduk-i", "[UV] Conduct, Guid/e, Lead, show the way. <B>~i</B> (gvidi), c., g., <B>1</B>., escort, go before: <I>~i blindulon, ĉevalon, infanon; al la altaro; en batalon, tenton; laŭ (sur) vojo; per mano, ŝnuro; tra la abismoj</I> (Ps 106/9). <B>2</B> (<I>ŝofori</I>), drive, ~i <I>aŭton</I>. <B>3</B> Communicate with, lead. to: l<I>a pordo ~as en la ĝardenon. La vojo ~as de A al B</I>. <B>4</B> (<I>rezultigi</I>): <I>Tio ~os al mizero, nenio, pereo, sukceso</I>. <I><B>5</B> (tech) bring, convey, take, transmit: Kanalo ~as akvon</I>. <I><B>6</B></I> (<I>estri, prizorgi): Direct, be at the head of, look after, manage, preside over</I>. ~i <I>batalon, Diservon, ĥoron, aferojn</I>.<I> <B>~(ad)o</B>, c. leading, leadership, direction, guidance, management. <B>~a</B></I> <B>stango</B> (<I>stirstango), control column. <B>~anto</B>, c-or, d-or, guide, leader (Ps 48/14). (mus) (a) antecedent, dux (in canon); (b) leading-note (in scale). <B>~ebla</B>, amenable, docile, <B>~ilo</B> [UV]</I>, (~a ŝnuro, ~rimeno; direktilo, gvidilo, stirlo), <I>bridle, feed(er), lead(ing string), rein, <B>~isto</B>, g., leader</I>. <B>Brut~isto</B>, <I>drover. <B>Al~i</B>, lead. (conduce) to. <B>f</B> bring about, occasion. <B>El~i</B>, 1. out. En~i (Ge 6/19), 1. in, bring into, inaugurate, introduce</I>. ~i novan mondon. (<I>rad</I>) <B>En~a</B> drato, <I>1-in wire. <B>For~i</B>, 1. away. <B>Ne~ebla</B>, out of control. <B>Re~i</B>, 1. back. <B>Tra~i</B>, lead through. ➞ direkt, gvid, estr, irig, kondukt, persvad, stir, venig</I>.", "0"],
["konduktanco", "konduktanc-o", "-ance (la inverso de rezistanco).", "1"],
["kondukti", "kondukt-i", "(el) (konduki elektron). <I>Conduct, convey, transmit. <B>~anto</B>, -or (material</I>). <B>Duon~anto</B>, <B>(Ne~)anto</B>, <I>semi-conductor, non-conductor. <B>~ilo</B>, -or, circuit (wire</I>). ~ilo unuopa, <I>single-wire -or. <B>~iv(ec)o</B>, -ivity. ➞</I> cirkvit.", "1"],
["konduktoro", "konduktor-o", "[OA] conductor, official in charge of bus, tram, etc. [Ne= kondukisto].", "1"],
["konduti", "kondut-i", "(<I>agi</I>), [UV] (nt) (<I>kontraŭ</I>, abs), Behav/e (well or ill) [Not: <I>~i sin], ~i afable, bone, ĝentile</I>. <B>~o</B>, b-iour, Conduct, demeanour, deportment, manners. <I>Atesto pro bona ~o. Bon~a (ĝentila</I>), civil, courteous, good, polite, well-behaved (bred). Malbon<B>~a</B>, naughty. <B>Mis~o</B>, Mis-b., (-c.).", "0"],
["konekti", "konekt-i", "(<I>kunigi</I>) (<I>-n</I>), (mec) Connect, assemble, couple, join, link together (objs, pts of apparatus), <B>f</B> associate mentally, (el) (<I>ŝalti</I>), put into contact (gear), establish a circuit, switch on. <B>~o</B>, -ion, contact. <I>~a stango</I>, -ing rod. ~ilo (a. <I>ŝaltilo</I>), switch, contactor. <B>Mal~i</B>, disengage, detach, release, switch (turn) off, throw out of gear. Tempa ~ilo, time switch. <B>Ter~o</B> (<B>~i</B>), (rad) earth. ➞ <I>enkliklig, interlig, komut, kontaktig, kupl, salt</I>.", "0"],
["konfeder(aci)i", "konfeder(aci)-i", "[OA] Confederat/e. ~o (<I>kunfederaĵo</I>), -ion, alliance, union, of independent states or organizations. ~ita, -ed. ➞ <I>alianc, feder, lig, unuiĝ</I>.", "0"],
["konfekcio", "konfekci-o", "[OA] (cl) ready-made suit or dress.", "0"],
["konferenco", "konferenc-o", "[OA] conference, discussion, consultation.", "0"],
["konfesi", "konfes-i", "(<I>-n, ke;</I> abs), [UV] Acknowledge, Confess. <B>1</B> plead guilty (own up) to: <I>~i eraron, krimon, kulpon, ŝuldon. Filo ~is, patro forgesis</I>. <B>2</B> a., admit, avow, <I>~i amon, meriton, veron, ricevon de letero</I>. 3 (<I>agnoski</I>), a., recognize as one’s own, the validity of. <I>~i kiel filon</I>. <B>4</B> profess, make declaration (profession) of faith: <I>~i kredon</I>. <B>5</B> (rc) make c-ion (to a priest). <B>~o</B>, a-ment, c-ion, admission, avowal. <I>Fari ~on pri</I> (Le 5/5; Ne 9/2). <B>~a</B>, c-ional. <B>~e</B>, avowedly. <B>~anto</B>, c-or, professor (of faith). ~ejo, c-ional box. <B>~preni</B>, shrive. <I>~prenanto</I>, father c-or. For<B>~i</B>, abjure, abnegate, give up, recant, renounce (something once accepted). <I>~~i eraron, kutimon, suspekton</I>. <B>Mal~i</B>. <B>1</B> deny, disclaim, declare innocence of, deny truth of. ~~i <I>aserton, aŭtorecon, krimon, kulpon, meriton, pretendon, ŝuldon</I>. <B>2</B> refuse to a. or recognize as one’s own., disavow, disown. <I>~~i amikon, patrujon, religion, subskribon, verkon</I>. <B>Nemal~ebla</B>, undeniable. <B>Kred~o</B>, creed. ➞ <I>akcept, konfesi, koneed, konsent, rekon</I>.", "0"],
["konfesio", "konfesi-o", "religious denomination, persuasion, sect. Ali<B>~ano</B>, adherent of another religious body. Inter~a <I>edziĝo</I>, mixed marriage (in this sense).", "0"],
["konfetoj", "konfet-oj", "confetti.", "0"],
["konfidenci", "konfidenc-i", "(<I>al</I>) <B>[OA]</B> (<I>fari ~on</I>), Confid/e, entrust (private matter, secret) to. <I>~i projekton, sekreton, senton</I>. <B>~a</B>, -ntial, intimate, not to be dismissed, private. <I>~a agento</I>. <B>~(aĵ)o</B>, -ence, secret. <B>~e</B>, in -ence, under seal of secrecy. <B>~ema</B> (<I>korelverŝema, malkaŝema</I>), communicat v ■ <B>Mal~ema</B>, reserved, reticent. ➞ <I>komunik, konfid, sekret</I>. Rim.: Z used <I>konfidenci-a</I> at OV 540, 541, 562.", "0"],
["konfidi", "konfid-i", "(<I>-n; al, en</I>), [UV] Confid/e. 1 (<I>havi ~on</I>), bestow -ence (rely) on, have (repose) -ence in, open one’s heart (unbosom one’s) to: <I>~i iun, al iu, al ies vorto. ~u, sed vidu!</I> <B>2</B> (<I>-n) (komisii ion al, ŝarĝi iun pri</I>), commit, entrust, give: <I>~i infanon, laboron, al ies zorgo</I>. <B>3</B> communicate a secret ( = <I>konfidenci</I>), <B>~o</B>, -ence, assured expectation, firm trust (Se 3/29). <I>Havi plenan ~on al iu. Perdi ~on. ~o naskas ~on. Tro da ~o kondukas al perfido</I>. <B>~a</B>, -ent, assured, bold. <B>~ato</B>, -ant, trusted friend, -ential attorney, etc. (No 12/7). ➞ <I>komisiit, rajtigit</I>. ~ema, -ing, trusting. ~inda, worthy of -ence, trust(worth)y. <B>~itaĵo</B>, deposit (Le 6/2). Mal<B>~i</B>, distrust, mistrust. <B>Sen~e</B>, distrustfully. ➞ <I>fid, komisi, konfidenc</I>.", "0"],
["konfirmi", "konfirm-i", "(<I>-n</I>), [UV] Confirm. <B>1</B> encourage, strengthen, remove doubt: <I>esperon, konvinkon, kredon, kutimon, timon</I>. <B>2</B> corroborate, establish, substantiate, verify: <I>~i aserton, ateston, novaĵon, supozon</I>. 3 make valid, endorse, ratify, sanction, seal: <I>~i interkonsenton, leĝon</I> (Da 6/8). <B>~(ad)o</B>, -ation. <B>~a</B>, -atory. <B>4</B> [a. <I>konfirmacii</I>], (rel) administer rite of -ation. <I>Tago de ~o</I> (3 FA 58/25). <I>Esti ~ita</I> (3 FA 48/13). ~ota (4 FA 137/5). <I>~oto</I>, -ation candidate. <B>Mal~i</B>, belie, contest, deny, give the lie to, refute. ➞ <I>apog, certig, jes, pliig, firmig, forig, ratif, verig</I>.", "0"],
["konfiski", "konfisk-i", "(<I>-n</I>) [OA], Confiscat/e. <B>1</B> legally seize, commandeer, distrain, sequestrate. <I>~i bienon, kontrabandaĵon</I>. <B>2</B> appropriate as penalty, take posses sion of something forbidden. <I>~i libron, tranĉilon</I>. <B>~(ad)o</B>, -ion, attachment, embargo, seizure. ➞ <I>sekvestr</I>.", "0"],
["konfiti", "konfit-i", "(<I>-n</I>), [UV] (cul) Preserve (fruit) in syrup. <B>~aĵo</B>, p., jam. ~aĵoj, p-ed (bottled, tinned) fruits. <B>~isto</B>, confectioner. ~ujo, p-dish, jam-jar(-pot). ➞ <I>kompot, marmelad, prezerv, sukeraĵ</I>.", "0"],
["konflikto", "konflikt-o", "[OA] Conflict. <B>1</B> Battle, col- lision. <B>2</B> antagonism, clash. <I>~o de voloj (inter du partioj). Anima ~o</I>, inner discord. ~i (nt; <I>inter, kun;</I> abs) (<I>esti en ~o</I>), c., clash. <B>~a</B>, -ing, at variance, incompatible. <I>~aj interesoj</I>. ➞ <I>antagonism, batal, kolizi, malakord</I>.", "0"],
["konforma", "konform-a", "(<I>al) (law</I>), [UV] Conform/able to, in accordance (compliance) with. <B>1</B> (similar to): <I>kopio ~a al la originalo</I>. <B>2</B> (consistent with): <I>ago ~a al instrukcio, principo</I>. <B>3</B> (adapted to): <I>konsilo, stilo, vesto ~a al la okazo</I>. <B>~e</B> <I>al</I> (Da 9/16), in conformity (keeping) with. <B>~i</B> <I>al (esti ~a</I>) <B>conform, match, correspond to, square</B> (tally) with. <B>~(ec)o</B>, -ity, agreement. <B>~ema</B>, tractable. ~igi (<I>-n</I>), bring into -ity (line) with, accomodate, adapt. ➞ <I>adapt, akomod</I>. <B>~iĝi</B> (<I>sin ~igi</I>), adapt one’s to, comply with. <B>~ismo</B>, -ity. <B>Ne~a</B>, at variance, incompatible, in opposition. <B>Ne~isto</B>, nonconformist, dissenter. ➞ <I>akord, harmoni, konsekvenc, konven, respond, sekv</I>.", "0"],
["konfronti", "konfront-i", "(<I>-n</I>), (jur) confront. ➞ <I>front</I>.", "0"],
["Konfuceo", "Konfuce-o", "<B>k~ano</B>, Confuci/an. <B>~(an)ismo</B>, -anism.", "0"],
["konfuzi", "konfuz-i", "(<I>-n</I>), [UV] Confus/e. <B>1</B> Throw into disorder, confound, disarrange, upset. <I>~i demand-(lingv-)on</I> (Ge 11/7). <I>la pensojn</I>. <B>2</B> mix up mentally. ~i <I>A kun B, objektojn en mallumo</I>. <B>3</B> discomfit, disconcert, embarrass, fluster, nonplus, perplex, put out. <I>la cerbon, kapon, ~i krimulon per demandoj. ~o</I> (<B>~eco</B>, <B>~iĝo</B>), -ed state, -ion; chaos, disorder, jumble, muddle, perplexity, upset (Jĝ 4/15). <B>~a</B>, -ed, chaotic, in disorder, muddled. <I>~a bruo, malreguleco, parolo, stato. ~aj memoroj</I>. ~aĵo (<I>io en ~o</I>). <B>~egi</B>, bewilder, confound, flabbergast (Jos 10/10). <B>~iĝi</B>, be(come) -ed, (troubled), lose one’s head (Da 2/1; Rd 20/3). <B>~iĝema</B>, bashful, diffident, shy. <B>~ita</B>, c-ed, embarrassed, flustered, perplexed, puzzled, put out, taken aback. <B>Inter~i</B>, mix up, tangle. <B>Mal~i</B>, extricate from -ion, clarify, disentangle, distinguish, unravel. ➞ <I>disting</I>. <B>Mal~a</B>, <B>Sen~a</B>, clear, distinct, without complication. <B>Ne~ebla</B>, cool (headed), imperturbable, not to be put out. ➞ <I>aplomb, flegm</I>. ➞ <I>embaras, ĝen, ĥaos, implik, konstern, malord, miks, senordig</I>.", "0"],
["kongesto", "kongest-o", "Congest/ion, abnormal accumulation. <B>~i</B> (<I>-n</I>), (med) c., overcharge with blood. <B>~iĝi</B>, accumulate to excess. ~ita, ~iĝinta, -ed, over-charged.", "0"],
["konglomerato", "konglomerat-o", "<B>[OA], ~aĵo</B>, (geol) pudding-stone.", "0"],
["konglomeri", "konglomer-i", "(<I>-n</I>), Conglomer/ate, collect (pack) into a tight coherent mass. <B>~aĵo</B>, -ation. <B>f</B> heap, pile. <B>~iĝi</B>, c. ➞ <I>aglomer, amasiĝ</I>. II", "0"],
["Kongo", "Kong-o", "<B>1</B> Demokratia Respubliko Kongo, Kongo Kinŝasa. <B>2</B> Respubliko Kongo, Kongo Brazavila CG. <B>3</B> (river).", "0"],
["kongregacio", "kongregaci-o", "[OA] Congregation. <B>1</B> (rel) (<I>Fanny/25) (adorant-preĝejan-aro</I>), body assembled for worship, or habitually attending a particular place of worship. <B>2</B> gen. assembly of qualified members of a university. <B>3</B> (rc) committee of cardinals, etc. ~israo, ~ist, -al-ism(-ist).", "0"],
["kongreso", "kongres-o", "Congress. <I>~o Esperanta, internacia, scienca, universala</I>. ~a <I>komitato</I>. <B>~i</B>, attend (be a member of) a c. <B>~ano</B>, c-member. ~ejo, c-hall. ~estro, c-president. Antaŭ~(Post~)o. ➞ <I>konferenc</I>.", "0"],
["kongro", "kongr-o", "(marargilo), conger eel (Conger).", "0"],
["kongrui", "kongru-i", "(nt) (<I>esti interkonforma</I>), Congru/e, agree. <I>Tiu hipotezo ~as kun la faktoj</I>. <B>~a</B>, -ent, -ous, accordant, coincident, (geom) equal and similar. Ne<B>~a</B>, in-ous. ➞ <I>koincid, konform, respond</I>.", "0"],
["koni", "kon-i", "(<I>ion, iun</I>) [UV] (Rd 34/10), Know (about); be acquainted (familiar) with, aware of; have an idea of, identify, ken. <I>~i aferon, homon, libron. ~i arbon per la frukto. ~i iun intime, laŭnome, kiel Esp-iston, per la voĉo. Mi ~as</I> (have heard of) <I>Esp-on, sed mi ne scias ĝin</I>. <B>f</B> be used to, have experience of. <I>~i dolor-(hont -malsat-milit-)on. Sako ne sonas, amiko ne ~as</I>. ~(ad)o, cognizance. ~anto, connoiseur, expert. ~ata, well-k-n. <I>~ata afer-(histori-poet-)o. Cie ~ata</I>, celebrated, famous, notorious, renowned. <I>~ato. [Ne: ~atulo]</I>, acquaintance (Ps 88/8). <I>~ateco</I>, notoriety, renown. <I>~atiĝi kun,</I> enter into relations with. <B>~igi</B>, introduce, make k-n, put into touch, <B>~iĝi</B>, be k-n, recognized. <I>~iĝas birdo laŭ flugo</I>. Dis<B>~igi</B>, broadcast, circulate, spread (news). Ek<B>~i</B>, 1 get to k., form an opinion about (Se 20/11). <B>2</B> (carnally) (Ge 4/1, 25). Inter-(iĝ)a <I>vespero</I>, get-together evening. Re<B>~i</B>, k. again, recognize (the identity of), k. <I>~~i skribon</I> (PI 4/8, Rut 3/14, Ge 38/25). <I>~~igi sin</I>, make one’s k-n (Ge 45/1). <B>~~ilo</B>, means of identification, badge, distinctive mark. ➞ <I>distingil, insign</I>. <B>Nere~ebla</B>, unrecognizable. Ne~ata (<I>fremda</I>), unk-n. <B>Ne~ato</B>, stranger. <B>Ne~ateco</B><I>,</I> obscurity. ➞ <I>rekon, sci</I>. <B>Rim</B>.: Before <I>iu, ke</I>, or£a A&gt;crltive, use <I>sci</I>, not <I>kon</I>.", "0"],
["konifero", "konifer-o", "(<I>pinglarbo</I>), Conifer. <B>~a</B>, -ous. ➞ <I>konus, strobil</I>.", "0"],
["koniino", "", "con(i)ine. ➞ <I>abio Kanada, cikut, etuz</I>.", "0"],
["koniko", "konik-o", "(<I>konusa franco</I>), conic section, koniv-i (<I>Je</I>), Conniv/e at (in), close one’s eyes to; wink at. <B>~o</B>, -ance, tacit permission.", "0"],
["konio", "koni-o", "hemlock (Conium maculatum).", "0"],
["konjako,", "konjak-o,", "[OA] cognac, French brandy.", "0"],
["konjekti", "konjekt-i", "(<I>~n, pri, ke</I>, abs), [UV] Conjecture, (make a) guess, suppose, surmise. <B>~o</B>, c., inference on incomplete evidence, persumption. ~aĵo (textual criticism), proposed reading. <B>~ebla</B>, presumable. <B>~ema</B>, speculative (in thought). <B>~igi</B>, lead to infer, suggest. ➞ <I>diven, supoz, suspekt</I>.", "0"],
["konjug(aci)i", "konjug(aci)-i", "[UV] (gram) conjug/ate (a vb). <B>~o</B>, <B>~ado</B>, (konjugado Z), -ation.", "0"],
["konjunkcio", "konjunkci-o", "[UV] <B>1</B> (gram) Conjunction. A c. connecting a subordinate clause to the main sentance is sometimes called a subjunkcio. <B>2</B> (astr) apparent proximity of two heavenly bodies. <B>~i</B>, be in c. ➞ <I>kvadratur, samlongitud, sizigi</I>. Opp <I>opozici</I>.", "0"],
["konjunktivo", "konjunktiv-o", "(anat) conjunctiv/a. ~ito, -itis.", "0"],
["konjunkturo", "konjunktur-o", "(<I>cirkonstancaro</I>), conjuncture, combination of events, situation, state of affairs (market, etc.).", "0"],
["konkava", "konkav-a", "<B>[OA]</B> (<I>konverĝiga</I>), Concav/e, <I>~a lensom spegulo</I>. <B>~aĵo</B>, <B>~eco</B>, -ity. Du<B>~a</B>, bi-c. Opp <I>konveks</I>.", "0"],
["konkeri", "konker-i", "[OA] Conquer. <B>1</B> bring to subjection, overcome by force, subjugate. <I>~i land-(urb-)on</I> (Jes 7/1). <B>2</B> gain, win. <I>~i koron</I>. <B>~o</B>, conquest. <B>~iĝi</B>, be -ed. ~into, -er. <B>Ne~ebla</B>, un-able, impregnable, invincible. ➞ <I>venkakir</I>.", "0"],
["konklavo", "konklav-o", "(rc) conclave (for papal electa), <B>f</B> grave private assembly, secret council.", "0"],
["konkludi", "konklud-i", "(<I>-n, el</I>), [UV] Conclu/de, arrive at by reason, deduce (draw consequence, form judgment, gather, infer) from argumts or facts [Ne= /77!i], <I>El tio mi ~as, ke</I>. <B>~o</B>, -sion, deduction, inferce. <I>Fari (tin) ~on, veni al ~o</I> (Pr 7/27). ~iga, -sive, clinchg, convincg, decisive. ➞ <I>argument, decid, dedukt, konvinkiĝ, rezon</I>.", "0"],
["konko", "konk-o", "[UV] Shell. <B>1</B> (mol) <I>~o de helik -(mitul-ostr-)o</I>. Blov<B>~o</B>, conch, triton’s trumpet. Klap<B>~o</B>, bivalve. Mon~o (<I>moncipreo</I>), cowry. <B>2</B> (anat) concha. Naz~o. Oirel~o (external ear). ~ojd (~form)a, conchoid. ~ologio, concho- logy. <B>~ulo</B>, s-fish. ~hava, testacious. ➞ <I>kiras, krust, ŝel</I>.", "0"],
["konkordanco", "konkordanc-o", "concordance. Biblia ~o. ~o de \"Marta\".", "0"],
["konkordato", "konkordat-o", "(rel) concordat (between pope and gvt).", "0"],
["konkordo,", "konkord-o,", "[OA] Concord, (gen) accord, agreement, harmony (between persons or things). <I>Kie regas ~o, regas ordo</I>, (gram) agreement (in case, number), (mus) consonant interval or chord. <B>~a</B>, -ant, harmonious, in c. <B>~i</B>, be in c. Mal<B>~o</B>, dissension. ➞ <I>akord, harmoni, konflikt, konsent, kun- sent, simpati</I>.", "0"],
["konkreta", "konkret-a", "[OA] Concrete, in material form, perceptible by senses, positive, real. <I>~a esprimo de danko. ~a ekzemplo, rezulto. Doni~an formon al idealo. [Ne ~~ betono]</I>. <B>~aĵo</B>, something c. <B>~eco</B>, c-ness. <B>~igi</B>, put into c. form. Opp <I>abstrakt</I>.", "0"],
["konkubo", "konkub-o", "Cohabit/or out of wedlock. ~i (<I>kunkuŝi</I>), to c. <B>~ado</B>, concubinage. ~ino, concubine (<I>kromvirino</I>).", "0"],
["konkurenci", "konkurenc-i", "[OA] Compet/e commercially. <B>~a</B>, -itive.", "0"],
["konkuri", "konkur-i", "(<I>kun, kontraŭ, pri</I>), [UV] Compet/e, (be) Rival (to), contend, enter into c-ition for, vie with. <B>~(ad)o</B>, c-ition, contest (for some obj), r-ry. <B>~e</B>, in c-ition. <I>~e kun</I>, vying with. ~antino (1 Sa 1/6), <I>Am~anto</I>, r. in love. ~ejo, sphere of c-ition. ~ema, emulous. Ne<B>~ebla</B>, incomparable, unsurpassable. ➞ <I>konkurs, kunaspir, kunkur, rival</I>.", "0"],
["konkurso", "konkurs-o", "[UV] (prize) Competit/ion under definite rules; contest, match. Antau<B>~o</B>, prov<B>~o</B>, trial heat. <B>Kur~o</B>, race. Marŝ-o, walking-match. Rem<B>~o</B>, Rowing-match. <B>Ŝak~o</B>, chess tournament, <B>~a</B> <I>ekzameno</I>, -ive examination. <I>~a komitato, premio</I>, ~e <I>egaligi (handikapi</I>), handicap. ~i (<I>~e konkuri</I>), compete (for honour, prize). ~anto, -or. Ekster<B>~a</B>, out of the running. ➞ <I>konkur [Ne= turniro]</I>,", "0"],
["konopodio", "konopodi-o", "pignut (<I>Conopodium</I>).", "0"],
["konscienco", "konscienc-o", "[UV] Conscien/ce, moral sense, inner voice. <I>Riproĉo, voĉo de ~o. ~o elasta. Pura, trankvila. Agi kontraŭ sia ~o. Silentigi, surdigi, ŝargi, la ~on</I>. <B>~a</B>, -tious. <B>1</B> faithful, honourable, scrupulous, upright. <I>~a laboro. Labori</I> ~e. <B>2</B> of c. <I>~a dubo</I>, scruple. <B>Sen~a</B>, without sense of root and wrong, unscrupulous. ➞ <I>skrupul</I>.", "0"],
["konscii", "konsci-i", "(<I>-n, pri, ke;</I> abs), [UV] be Conscious (Aware, sensible) of (mentally or physically). <I>~i sian forton. ~ante, ke,</I> being a. that. <I>~u lin en viaj vojoj</I> (Se 3/6). ~(ec)o, a-ness, c-ness, perception. <I>Perdi (ricevi) ~on</I>. <B>~a</B>, a., c., cognisant, sensible, sentient, with faculties awake. <I>~a pri kulpo</I>, c. of guilt. <I>Agi</I> <B>~e</B>, deliberately, with one’s eyes open (Se 13/16). (Re)<B>~iĝi</B>, (re)gain c-ness, come to. Mem<B>~a</B>, self-c. Ne~(Sen~)a, un-c, insensible. Sen<B>~e</B>, without knowing. <I>Sen~igi,</I> make un-c, stun. ➞ <I>anestez, narkot. Sen~iĝi</I>. ➞ <I>sven</I>. Sub<B>~o</B>, subconsciousness. <B>Duon~a</B>, half-c. Klas<B>~a</B>, class-c. ➞ <I>kompren, sei, sent</I>.", "0"],
["konsekri", "konsekr-i", "[OA] Consecrat/e, dedicate (devote) to religious service, hallow, sanctify, set apart as sacred. <I>~i arbon, pastron, preĝejon, sin</I> (No 6/2). ~ado (Le 8/33). ~(iĝ)o, ~iteco, -ion, dedication. ~ito (2 Sa 2/20, Am 2/11). <B>~itaĵo</B> (Le 27/23). ➞ <I>dediĉ, ordin, sanktig</I>.", "0"],
["konsekvenca", "konsekvenc-a", "[UV] <B>1</B> Consist/ent; accordant, thorough-going, in conformity with established principle: <I>~a ago, homo, konduto, vivo</I>. <B>2</B> logically following: <I>~a konkludo, sekvo el opinio</I>. ➞ <I>dedukt, konklud</I>. ~e (<I>laŭ ~a maniero</I>), -ently, accordingly, logically. ➞ <I>sekve, do. Agi ~e</I>. <B>~o</B>, -ency, logical sequence <I>[Ne ~~ simpla rezulto, sekvo], Havi ~on de ideoj. Pro ~o</I>, for the sake of -ency. Mal~a <I>konduto, stilo</I>. Ne<B>~o</B>, sen<B>~o</B>, inconsistency, inconsequence, irrelevance. ➞ <I>konform</I>.", "0"],
["konsenti", "konsent-i", "(<I>-n; kun, pri, ke;</I> abs), [UV] Agree, Consent. <B>1</B> Unite in feeling, opinion, thought; admit (that), approve (of); concur, be of same mind, in accord or harmony with; give assent (subscribe) to opinion. <I>Mi ~as, ke vi estas prava. ~ite!</I> Agreed! <B>2</B> accede (give c.) to; acquiesce in; comply (fall in) with; permit. <I>~i donacon, favoron, peton, prunton</I>. <B>~o</B>, agreement, consent. <B>1</B> accord, approval, assent, concurrance. <I>Silento estas ~o. Doni ~on</I> (Ge 34/23). <B>2</B> acquiescence, compliance. ~e <I>kun</I>, in agreement (concert) with. <B>~ebla</B>, admissible, that one can agree with. <B>~ema</B>, compliant. <B>~igi</B>, cause to a. or c., gain (win) over, persuade, prevail on. <B>~iĝi</B>, be agreed. <B>Inter~i</B>, a. together, come to an understanding (terms) with. <B>Inter~o</B>, mutual arrangement, covenant, settlement, understanding (1 Sa 22/17). <I>Jura ~~o</I> (Rd 29/14). <I>~~igi</I>, reconcile. <B>Mal~i</B>, deny, disagree, dissent, refuse. <I>~~i inter si</I> (➞ <I>konflikt, kontest, rifuz</I>). ➞ <I>akord, alias, dec, harmoni, konkord, kunsent, samopini, unuec</I>.", "0"],
["konservativa", "konservativ-a", "[OA] (pol) conservative. <B>~ismo</B>, <B>~ulo</B>.", "0"],
["konservatorio", "konservatori-o", "[OA] conservatoire (mus, etc.).", "0"],
["konservi", "konserv-i", "(<I>-n) (de, kontraŭ</I>), [UV] Keep, Conserv/e, Preserv/e. <B>1</B> (from loss): cherish, retain. <I>~i belon, foton, junecon, opinion, sanon, sekreton, valoron, varmon; la dent-(fort-har -)ojn; ~i en la kapo (memoro</I>). <B>2</B> (from harm, safe): <I>~i sian animon</I> (Se 16/17), <I>~i kontraŭ forgeso, morto, perdo, ruino</I>. <B>3</B> maintain, uphold (state of things): <I>~i ordon (pacon</I>), (mus) <I>~i la piĉon</I>, keep the pitch. <B>4</B> (a. <I>prezervi</I>): (from decay), p., bottle, can, tin, etc. <B>~(ad)o</B>, -ation, maintenance, retention, up-keep. <B>~anto</B>, <B>~isto</B>, k-er, curator. ➞ <I>kurator</I>. ~ejo, larder, safe, store, etc. ➞ <I>deponejo, gardejo, tenejo</I>. <B>~(em)a</B>, conservative, retentive. <I>~a kuirado</I>. ➞ <I>konservativ</I>. <B>~iĝi</B>, k., remain safe. <B>~inda</B>, worth keeping. <B>~ismo</B>, c-atism, hostility to change, wish to p. existing state of things. <B>~ujo</B>, receptacle, bin, box, etc. <B>Sin~o</B>, selfp-ation. ➞ <I>gard, konfit, ten</I>. <B>Rim</B>.: Gardi <I>kontrau danĝero;</I> konservi <I>kontraŭ detruo (perdo</I>), prezervi <I>kontraŭ putriĝo, malkomponiĝo</I>.", "0"],
["konsideri", "konsider-i", "(-n, <I>cu, ke</I>) [UV] (<I>pripensi</I>), Consider, weigh (mentally). <B>1</B> deliberate upon, examine, give thought to, keep in view, think over carefully, (nt) cogitate, reflect. <I>~i aferon, proponon, situacion, sugeston, sekvon de ago. Malpli esperu, pli ~u</I>. <B>2</B> Make allowance for, take into -ation (account): <I>~i la junecon de krimulo, la cirkonstancojn. ~i personojn ĉe juĝado</I> (Se 24/23). <B>~(ad)o</B>, c-tion, weighing of pros and cons. <I>Longa ~o savas de sufero. Praktikaj ~oj</I>. ~e <I>tion</I>, in -ation of that. ~(ant)e, ke, -ing (taking into account) that. <B>~eco</B>, -ateness. <B>~ema</B>, -ate, reflective. ~enda, to be -ed. ~inda (<I>grava</I>), -able, weighty, important, worth -ation. Kun<B>~i</B>, take into account. <B>Ne~inda</B>, insignificant, negligible, not worth -ing, trifling. <B>Sen~a</B>, heedless, thoughtless. ➞ <I>kontempl, medit, opini, rigard. [Ne= rigardi kiel]</I>.", "0"],
["konsigni", "konsign-i", "(<I>-n, al</I>), (com) Consign, deliver, hand over; transfer, transmit, send. <B>~aĵo</B>, -ment, ~anto, -er, sender, shipper.", "0"],
["konsili", "konsil-i", "(<I>al iu -i, ion al iu, ke</I>), [UV] Advis/e, (offer) Counsel (to), recomend. <B>~o</B>, (piece of) advice, c„ suggestion. <I>Akcepti, doni, peti ~on. Saĝulo aŭskultas ~on. Restas nek ~o, nek konsolo</I>. ~ano (4 FA 101/11, 186/12, 193/29), better koncilano. <B>~isto</B>, c-lor (Da 3/24). <I>~isto financa, komerca, kortega</I>. <B>~antaro</B>, <B>~istaro</B>, Council, board, committee. <I>Urba ~istaro (magistrato</I>), town counsel. ➞ <I>komision, komitat, koncil</I>. ~ejo, (<I>konsultejo</I>). <B>~eto</B>, tip. ~iĝi (<I>inter si</I>), take c„ confer, hold a conference (for deliberation, discussn) (2 Kr 10/6). <I>~iĝo</I> (Jĝ 20/7). <I>-iĝo de milito</I>, c. of war. <I>Popola ~iĝo</I>, public assembly. ~inda, a-able, best, expedient, prudent, wise. Inter<B>~iĝi</B>, confer. Mal<B>~i</B>, a. against, condemn. Mal~(Ne~)inda, ill- advised, injudicious. Mis<B>~i</B>, give bad advice. Nc~cbla, deaf to advice, Sen<B>~a</B>, helpless, perplexed (Jes 19/11). ➞ <I>admon, help, instig, koncil, konsol</I>.", "0"],
["konsisti", "konsist-i", "(nt), [UV] Consist. 1 <I>el</I>): c. (be composed, formed, made up) of, have various pts as ingredients. <I>Minuto ~as el</I> 60 <I>sekundoj</I>. 2 (<I>~i en</I>): c. (lie) in, be comprised (contained) in. <I>La afero ~as en tio, ke … En kio ~as lia forto</I> (Jĝ 16/5). <I>Muziko ne -as en la sola frapado de klavoj</I>. <B>~o</B>, composition, constitution, makeup, nature. <I>Regno de miksita ~o</I> (Da 2/41). <B>~a</B>, component, constituent. <I>La -ajpartoj de io</I>. <B>~aĵo</B>, element, ingredient. <B>~igi</B>, compose, compound, constitute; form, make up (El 30/33). Divers-a, miks~a (<I>heterogena</I>), diversely constituted), medley, mixed. ➞ <I>konstitu, konstru, kunmet, struktur</I>.", "0"],
["konsistorio", "konsistori-o", "[OA] consistory, ecclesiastical court.", "0"],
["konskripti", "konskript-i", "(a. <I>konskripcii</I>), Conscript. <B>~o</B>, -ion (<I>deviga militservo</I>). ~ito, -ulo, c. ➞ <I>rekrut, varb</I>.", "0"],
["konsoli", "konsol-i", "(<I>-n</I>), [UV] Consol/e, cheer, comfort in sorrow or depression, solace, soothe. <I>~i ploranton</I>, <B>~a</B>, -atory (Ze 1/13). <I>~a premio</I>, -ation prize. <B>~(aĵ)o</B>, -ation, alleviation of sorrow, comfort, solace. <B>~anto</B>, comforter (Ps 69/20). ➞ <I>paraklet</I>. <B>~iĝi</B> (Ge 24/67), be comforted. Ne~ebla (in-able) <I>doloro</I>. <B>Sen~a</B>, dis-ate, desolate, hopeless. ➞ <I>kompens [Ne= komfort]</I>.", "0"],
["konsonanco", "konsonanc-o", "Consonan/ce, accord, harmony. (mus) c-t interval or chord. <B>~a</B>, c-t. <B>~i</B>, blend. ➞ <I>akord, konkord</I>.", "0"],
["konsonanto", "konsonant-o", "[UV] Consonant. Opp vokal. Duobla ~o. <B>Duon~o</B> (duonvokalo), = j, ŭ.", "0"],
["konspiri", "konspir-i", "(<I>fari -on) (kontraŭ</I>), [UV] Conspir/e, form a -acy (against), combine privily, plot, for some (us. evil) purpose, e.g., treason. <B>~o</B>, -acy, clandestine combination, union (for mischief) (2 Rĝ 15/15). <I>~o de silento</I>, ~anto, -ator. ~estro, ringleader. ➞ <I>kabal, komplot</I>.", "0"],
["konstanta", "konstant-a", "[UV] Constant (wide sense). <B>1</B> (<I>daŭra</I>), abiding, enduring, lasting, permanent, stable: <I>~a armeo, ofico. ~a amiko,</I> faithful friend. <B>2</B> <I>Senŝanĝa, senvaria;</I> firm, immutable, inflexible, regular, steadfast, unchanging, undeviating, unswervig, unvarying: <I>~a kurento, nivelo, rapido, ~a prezo</I>, fixed price. <I>~a vetero</I>, settled weather. <B>3</B> (<I>persista, senĉesa</I>); continual, continuous; incessant, perpetual, persistent, sustained, unremitting: <I>~a atento, babilado, dubo, penado. ~a gutado</I> (Se 19/13). <I>~a pluvo,</I> steady rain. <B>~o</B> (mat), constant, unvarying quantity. <B>~e</B>, (Ge 8/5). <B>~eco</B>, constancy, devotion, firmness, stability. <B>Mal~a</B>, <B>Ne~a</B>, <B>(<I>ŝanĝiĝema, ventanima</I>)</B>, inconstant, fickle, fluctuating, unstable. ➞ <B><I>dam, firm, kontinu</I></B>.", "0"],
["konstati", "konstat-i", "(-n, <I>ke</I>), [UV] ascertain (find) to be true by experiment or investigation, establish (prove) to be a fact, declare, state (in this sense). <I>~i morton</I>. <B>~o</B>, verification, etc. ~ita <I>fakto</I>, authenticated, established fact. ➞ <I>atest, konfirm, pruv [Ne= asert]</I>.", "0"],
["konstelacio", "konstelaci-o", "(<I>stelfiguro</I>), constellation.", "0"],
["konsterni", "konstern-i", "(<I>-n</I>), [UV] (fill with) Consternation, dismay, give a shock to. <B>~a</B>, alarming, prostrating. <B>~o</B>, c., dismay. ~egi, appal, stagger, terrify. ~ego, panic, stupefaction. <B>~eti</B>, nonplus, put out, startle, take aback (by surprise). <B>~iĝi</B>, be thunderstruck, stand aghast. <I>~iĝis iliaj koroj</I>, their hearts failed them. <B>Ne~ebla</B>, dauntless, inperturbable, un flinching. ➞ <I>konfuz, senaplombig, terur, timig</I>.", "0"],
["konstipi", "konstip-i", "constipate, render costive. <B>~(ad)o</B>, <B>~eco</B>, ~iĝi. ➞ <I>mallaks</I>.", "0"],
["konstitucio", "konstituci-o", "[OA] (pol) Constitution, system of government. (Laŭ)<B>~a</B>, -al. Kontraŭ<B>~a</B>, un-al.", "0"],
["konstitui", "konstitu-i", "(-71) (<I>konsistigi</I>), Constitu/te, compose, establish, form. <B>~o</B>, -tion, make-up. <B>~a</B>, -tive. ➞ <I>struktur</I>.", "0"],
["konstrikti", "konstrikt-i", "(med) Constrict. <B>~o</B>, -ion. <B>~a</B>, constringent. ➞ <I>boa</I>.", "0"],
["konstrui", "konstru-i", "(<I>-n</I>), [UV] Build, Construct. <B>1</B> (put together points or material), erect, make, set up: <I>domon, neston, orgenon, urbon, vojon. ~i sur roko, sablo</I>. f <I>~i fraz-(dram -lingv-)on</I>. <B>2</B> establish, organize: <I>~i mondpacon, sian vivon</I>. <B>3</B> (gram) construe: <I>~i frazon</I>. ~(ad)o, b-ing, c-ion. <I>La ~o de domo, frazo, homkorpo. Nenia ~o povas esti sen bruo</I>. <B>~aĉi</B>, jerry-b. <B>~aĵo</B>, b-ing, edifice, structure. ~ejo, b<B> ing</B> yard. <B>~igi</B>, be built (Se 24/3). <B>~isto</B>, b-er, c-or. <I>Ŝip~isto</I>, ship b-er, shipwright. ~arto (<I>arkitekturo</I>). Mal~i (<I>detrui, disfaligi</I>), demolish, take to pieces. <I>~~isto</I>, housebreaker. Pri~i (2 Kr 14/7). Sub~(Super~)aĵo, sub-(super-)stractuie. <B>Voj~isto</B>, road-maker. ➞ <B><I>fond, konsistig, kunmet, starig</I></B>.", "0"],
["konsubstancio", "konsubstanci-o", "(<I>kunsubstanciĝo</I>), (thl) consubstantiation.", "0"],
["konsulo", "konsul-o", "[OA] (hist, pol), Consul. ~ec (~ej)o, -ate. ➞ <I>ambasador</I>.", "0"],
["konsulti", "konsult-i", "(<I>-n</I>) <B>[OA]</B> (<I>sin turni al</I>), Consult, ask for advice (help, information) from, confer with, make enquiry (of). <B>~i</B> <I>juriston, kuraciston, speeialiston; kompetentulon, libron, sian koron (poŝori</I>). ~a <I>kuracisto,</I> -ing physician. <I>~a biblioteko</I>, reference library. <B>~ado</B>, -ation. <B>~ejo</B>, (<I>~a kabineto</I>), -ing room. ➞ <I>demand, konsiliĝ</I>.", "0"],
["konsumi", "konsum-i", "(<I>-n</I>), [UV] Consum/e. <B>1</B> burn (drink, eat, use) up, expend. <I>~i energion, forton, heredon, inkon, oleon, provizon, tempon, tagojn</I> (Pr 5/17). <I>Fajro ~as lignon</I>. <B>2</B> Tire, wear out by use. <I>~i la koron, okulojn</I>. <B>3</B> dissipate, fritter away. <B>~(ad)o</B>, -ption. ~anto, -er. (For)<B>~iĝi</B>, waste away, e.g., <I>of akvo</I> (Ge 21/15), <I>beleeo</I> (Ps 39/11), <I>fortoj</I> (Ps 71/9), <I>homo</I> (Ge 25/17), <I>karno</I> (Ps 73/26), <I>lirnako</I> (Ps 58/8), <I>okuloj</I> (1 Sa 2/33); <I>de malĝojo</I> (Ps 31/10), <I>de malsato</I> (Jes 5/13); <I>pro malĝojo</I> (Ps 119/28), <I>pro malpieeo</I> (Jeĥ 4/17). -ita, ~ed, spent. <I>~ita de</I>, eaten up with (exhausted by) <I>envi-(labor-malsan -varmeg-)o. ~iteeo</I>, exhaustion. El~ita, dead beat, dog tired, done up, fagged out. For<B>~i</B>, exhaust, use up (all). <I>la fortojn</I>. <B>Ne~ebla</B>, in-destruct(-ex- haust)ible, uneatable. ➞ <I>elĉerp, elspez, eluz), formanĝ, foruz, ftiz, marasm, neniig, perdig, pereig</I>.", "0"],
["kontaĝo", "kontaĝ-o", "Contagi/on, contamination. communicate (disease, etc.) by contact. <B>~a</B>, -ious, catching, infectious (us. pernicious). <I>~a influo</I>. <B>~aĵo</B>, virus of c. ➞ <I>infekt</I>.", "0"],
["kontakto", "kontakt-o", "[OA] (<I>intertuŝo</I>), Contact, con- nection, touch. <I>~o elektra, de du dratoj</I>. <B>f</B> (<I>interrilato), ~o inter du homoj</I>. ~i (<I>-n, kun) (esti en</I> ~o, <I>havi ~on</I>), be in (have) c., be in touch, <B>f</B> come across, meet. <B>~igi</B>, <B>~iĝi</B>, bring (enter) into c. ~ilo, -or. ~rompilo, c-breaker. <B>Fuŝ~o</B>, short circuit. <B>Mal~igi</B>, break the circuit. ➞ <I>komunik, konekt, tangent</I>.", "0"],
["kontanto", "kontant-o", "[UV] (<I>~a mono</I>), Cash down, ready money. ~a <I>pago, prezo, negoco,</I> c-payment (price, transaction). <I>Aĉet-(vend</I> -)(‘ <B>~e</B>, for c. <I>Pagi</I> <B><I>~e</I></B>, pay (in) c. <B>~aĵo</B>, coin, specie. ➞ <I>kas, mon</I>. Opp <I>kredit</I>.", "0"],
["kontempli", "kontempl-i", "(<I>-n</I>), (<I>rigardi longe kaj medite</I>), Contemplat/e, attentvly <B>1</B> gaze upon (survey, view); <B>2</B> consider, meditate (reflect) on. <B>~(ad)o</B>, -ion, meditation, reflection. <B>~(em)a</B>, -ive. ➞ <I>pripens</I>.", "0"],
["kontenta", "kontent-a", "(<I>pri, pro</I>), [UV] Content/(ed), Satisf/ied, easy in one’s mind, pleased. <I>~a koro</I> (Se 15/15). <B>~o</B>, c-ment, s-action. <B>~igi</B>, s-y, appease (<I>malsaton</I>), quench (<I>soifon). ~i bezonon, postulon, scivolon. Doni, postuli, ricevi ~iĝon</I> (amends, s-action) (Le 26/34). ~iĝi (<I>per</I>), be c-ed (s-ed), s-y one’s. ~iĝema, accommodating in disposition. <B>Mal~a</B>, dis-c.(-s.)ed. <B>~~ulo</B><I>,</I> mal-c. <B>Ne~a</B>, uns-ied. <B>Ne~igebla</B>, insatiable. ➞ <I>ĝoj, plaĉ, sat</I>.", "0"],
["kontesti", "kontest-i", "(<I>-n</I>) [OA-8], Contest. <B>1</B> (call in) question, debate, deny (truth of), gainsay, refuse to accept. ~i <I>aserton, pretendon</I>. <B>~o</B>, contest, bout, controversy, competition, strife, tussle. <B>~ebla</B>, disputable, questionable. <B>Mal~i</B>, acquiesce, admit, agree. ➞ <I>malkonsent, opon, rifuz</I>.", "0"],
["kontinento", "kontinent-o", "[OA] (geog) Continent. <B>~a</B>, -al.", "0"],
["kontingenco", "kontingenc-o", "(phi) Conting/ency, chance (uncertainty of) occurrce. <B>~a</B>, -ent. ➞ <I>eventual</I>.", "0"],
["kontingento", "kontingent-o", "contingent (especially of troops).", "0"],
["kontinua", "kontinu-a", "[OA] Continu/ous (of time or place), always going on, endless, perpetual, unbroken unceasing, unending, uninterrupted) in duration or extent. <I>~a bano, kurento, linio, muro, pluvo, sono</I>. ~i (<I>esti ~a</I>), go (keep) on, last, persist (N<I>e = daŭrigi]</I>. <B>~aĵo</B>, -ation (El 28/8, 39/5). <B>~eco</B>, -ity. <I>Rompi ~econ</I>. Ne<B>~a</B>, dis-ous, disconnected, disjointed, scrappy. ➞ <I>daŭr, konstant, senĉesa, senintermita, senintervala, senmanka</I>.", "0"],
["konto", "kont-o", "[OA] (com) Account, reckoning of debit and credit. <I>~o akordiga, debita, kredita, kapitala, komuna, kuranta. Enskribu tion en mian ~on. Fermi, pagi, posedi, reguligi ~on</I>. <B>~a</B> <I>pago</I>, settlement of a. <B>~(ten)isto</B>, book-keeper. <B>~ulo</B>, depositor. <B>~eltiro</B>, statement of a. ➞ <I>kalkul, librotenad</I>.", "0"],
["kontoro", "kontor-o", "[UV] (com) Counting-house, bureau, office, e.g., of factory. <B>~ano</B>, <B>~isto</B>, clerk. ➞ <I>ofic, kancelari</I>.", "0"],
["kontrabando", "kontraband-o", "[OA] contraband, prohibited traffic, smuggling. <B>~a</B>, c., illegal, illicit. <B>~i</B>, smuggle. <B>~aĵo</B>, c-goods. <B>~isto</B>, <B>~ulo</B>, smuggler.", "0"],
["kontrabaso", "kontrabas-o", "[OA] (a. <I>baso, basviolono</I>), (m.i.) double-bass.", "0"],
["kontrafagoto", "kontrafagot-o", "(<I>basfagoto</I>), (m.i.) double bassoon.", "0"],
["kontrakto", "kontrakt-o", "[UV] Contract, binding promise, covenant (legal agreemt), deal, pact, between parties or states. <I>Rompi ~on</I>. <B>Edziĝ~o</B>, marriage settlement. <B>Lu~o</B>, lease. <B>Pac~o</B>, peace treaty. <B>Ŝiplu~o</B>, charter- party. <B>~i</B> (<I>fari ~on</I>), engage (enter into) a contract, <I>~i aliancon, edziĝon</I>. <B>~antoj</B>, c ing parties. ➞ <I>interkonsent, konkordat, traktat [Ne= malvastiĝ]</I>.", "0"],
["kontralto", "kontralt-o", "[OA] contralto (voice, part, singer, instrument), low female voice. <I>Vir~o (aldo</I>), male alto. ➞ <I>falset</I>.", "0"],
["kontrapunkto", "kontrapunkt-o", "[OA] counterpoint, art of combining melodies. <I>~o duobla, invertebla, kombinita, libera, ornama, strikta, triaspeca</I>. <B>~a</B>, contrapuntal.", "0"],
["kontrasto", "kontrast-o", "[OA] Contrast, Difference (of colours, forms, etc.), antithesis, opposition, set-off. <I>~o inter lumo kaj ombro</I>. <B>~i</B> (<I>-n; kontraŭ, kun;</I> abs), exhibit contrast, show d., stand out against background. <B>~igi</B>, compare, exhibit the differences between, set off by opposition. ➞ <I>disting, kompar</I>.", "0"],
["kontraŭ", "", "[UV] (prep) <B>1</B> Against, in oppos/ition to: Du ~ unu, two to one. Batali unu ~ la alia, fight with one another. Atesti, koleri, militi, pafi, protesti, ribeli, voĉi ~. <B>2</B> (fronte al), facing, opposite, over against. <I>~ mia domo, in front of my house. Vizaĝon ~ vizaĝo, face to face</I>. <B>3</B> (almovo) against: Flugi (sin frapi) ~ muron. <B>4</B> (mallaŭ), in o-ite direction to normal: <I>Naĝi ~ la fluo</I> (upstream). <I>Karesi ~ la haroj</I> (the wrong way). <B>5</B> In defiance of, in disobedience to: Agi ~ sia konscienco. <B>6</B> (direction of feelings): ŝi havis malamon ~ (a spite against, hatred twrds) la pli juna. Estu sincera ~ mi (with me). Kiel li agis ~ mi, tiel mi agos ~ li (Se 24/29). <B>7</B> against, from: Defendi, protekti, ŝirmi ~. Gardi ~ risko. Kuraci ~ febro. Savi ~ leono. <B>8</B> (anstataŭ, por) in exchange for: Ŝanĝi ĉekon ~ moneroj, grenon ~ fero. <B>9</B> (kompare kun) in comparison with: Dio multigu vin multope ~ via nuna nombro (Rd 1/11). La supereco de bruna pano ~ blanka. <B>~a</B>, adverse, contrary, o-ite. ~a <I>direkto, flanko, vento</I>. <B>~e</B>, [UV] <B>1</B> on (to) the contrary, in o.: Agi (paroli) ~e. Tute <B>~e</B>, just the o-ite. ~e al viaj leĝoj (in defiance of) (Ps 119/85). <B>2</B> facing. <B>~i</B> (al), <I>be o-ed (contrary) to. <B>1</B> face. <B>2</B> object to, oppose. Mi ne ~as, I don’t mind. <B>~o</B> (</I>malo), <I>the o-ite, reverse. <B>~aĵo</B>, bar, obstacle, hitch, <B>~eco</B>, o. <B>~ema</B>, contrary, perverse. <B>~igi</B>, antagonize. <B>~ulo</B> (antagonisto, oponanto</I>), <I>adversary, opponent</I>.", "0"],
["kontraŭ", "kontraŭ-", "[OA] (pfx) <B>1</B> against, in opposition to: ~batali, fight against. ~leĝa, illegal. ~starigi, bring face to face. ~veneno, antidote. ~vizito, return visit. <B>2</B> anti-: ~-Brita (~glaciilo, ~militismo), <I>anti-British (-icer, -militarism). <B>3</B></I> Counter-. <I>~marko, ~parto, ~pezo, ~propono, counter-mark (-part, -poise, -proposal). ➞ antagonism, bar, kontrast, mal, malhelp, opozici</I>.", "1"],
["kontribucio", "kontribuci-o", "[OA] (mil) imposition levied on conquered nation for support of occupying army (2 Kr 36/3). ➞ <I>militimpost, militkompensaĵ</I>.", "0"],
["kontribui", "kontribu-i", "[OA] Contribut/e. <B>1</B> (<I>al</I>) furnish, give, offer, supply. <I>~i artikolon al gazeto, eron al programo, monon al kaso</I>. <B>2</B> (nt) bear (pay) a share, help to bring about, join (take part) in. <B>3</B> conduce, tend. <I>~i al diskuto, al la sukceso de</I>. <B>~a</B>, -ive. <B>~o</B>, -ion, participation, share, <B>~aĵo</B>, thing -ed, article, gift, offering, ~anto, -er. ➞ <I>kontingent, kotiz, kunhelp</I>.", "0"],
["kontroli", "kontrol-i", "(<I>-n, ĉu</I>) [F], Control, (but only in the sense) audit, check (up on), (keep a) check (upon), examine, inspect, invigilate, look to, see if correct, supervise, test, verify. <I>[Ne= direkt, reg], ~i bileton, kalkulon, konton, la faktojn, la veron de aserto, la iradon de aferoj</I> (Se 31/27), <I>ĉu</I> (see whether) <I>danĝero minacas</I>. <B>~(ad)o</B>, control, inspection, supervision. <I>Ne kredu al parolo sen propra ~o. Sub la ~o de</I> (El 38/21). <I>Kont~o</I>, audit. <B>~ebla</B>, verifiable. <I>~eblaj faktoj</I>. <B>~ejo</B>, c-room. <B>~ilo</B>, checking machine, gauge, recorder, standard of comparison. <B>~anto</B>, <B>~isto</B> (Se 6/7), controler, overseer, supervisor. <I>Bilet~isto</I>, ticket inspector. <I>Kont~isto,</I> auditor. <B>~iro</B>, round of inspection. ➞ <I>ekzamen, esplor, inspekt, konstat</I>.", "0"],
["kontumaco", "kontumac-o", "Contumac/y, recalcitrance, especially (jur) contempt (disobedience to order) of Court, <B>~a</B>, -ious, insolently disobedient, insubordinate, refractory, wilfully disrespectful.", "0"],
["konturo", "kontur-o", "[UV] Outline, contour, external boundary. <I>~o de desegno, marbordo, mondo, vazo</I> (Jes 44/13). <I>Klara ~o</I>. <B>~i</B> (<I>~e skizi</I>), (sketch in) o., trace, (geog) ~a <I>linio</I>. <B>~e</B>, in outline. <B>f</B> giving main features. <B>~iĝi</B>, assume clear outlines. <I>~iĝi kontraŭ,</I> stand out against. ➞ <I>malnet, profil, siluet, skiz</I>.", "0"],
["kontuzi", "kontuz-i", "[UV] (med) Bruis/e, contuse, discolour by blow without breaking skin. <I>~i frukt-(haŭt) on</I>. <B>~o</B>, b., contusion. <I>Vip~o,</I> wale, weal. <B>~aĵo</B>, bloodshot mark. <B>~iĝi</B>, get -ed, battered.", "0"],
["konuro", "konur-o", "(orn) conure (ordinary language), name of many parrots.", "0"],
["konuso", "konus-o", "[UV] <B>1</B> Con/e (figure or solid). <I>Hakita ~o</I>, truncated c. <B>2</B> c-shaped object. Abia ~o (<I>strobilo</I>), fir-c. (mec) Dorsa <B>~o</B>, back c. Suker<B>~o</B>, sugar-loaf, ŝtorm-o (<I>ŝtormavertilo</I>), (met) storm-c. <B>~a</B>, -ic. <I>~a franco</I>, -ic section. ~(form)a, -ical, tapering. ➞ <I>konik</I>.", "0"],
["konvalo", "konval-o", "[UV] lily of the valley (<I>Convallaria</I>).", "0"],
["konveksa", "konveks-a", "[OA] Convex. <I>~a lenso, spegulo. ~aj kruroj</I>, bandy-legs. <B>~(ec)o</B>, -ity. <B>~aĵo</B> (<I>ĝibaĵo</I>), bow, camber, hump (l Rĝ 7/20). <B>Du~a</B>, bi-c. ➞ <I>bos, volb</I>. Opp <I>konkav</I>.", "0"],
["konvekto", "konvekt-o", "(met) (ph) Convect/ion (heat current, usually upward). <I>~a hejtilo</I>, -or. <I>~a fluo</I>.", "0"],
["konvencio", "konvenci-o", "[OA] Convention. <B>1</B> agreement, arrangement by mutual consent. <B>2</B> gen. usage <I>[Ne= kunveno]. ~o pri normoj. ~o socia</I>. <B>~a</B>, -al, orthodox, stereotyped, traditional, usual. <I>~a signo, simbolo</I>. ~ulo. ➞ <I>formal, interkonsent</I>.", "0"],
["konveni", "konven-i", "(<I>al, por</I>), [UV] be adapted (to character, circumstce, feeling, situation), be conformable, fitting, in keeping (order, place), seemly, suitable; go with, harmonize, match, suit (the case). <I>La vesto ~as al via figuro (domo al bezonoj, ŝtopilo al botelo)</I>. <I>Kio ~as al sciuro ne ~as al vulturo</I>. <I>Inter kornikoj ne ~as predikoj</I>. <B>~a</B>, adapted, etc. (as above). <I>~a momento por ripozo (okupo por fraŭlino, rekompenco por servo, vesto por funebro). ~a vorto</I>, timely word. <B>~e</B>, suitably, etc. <B>~(ec)o</B>, decorum, etiquette, fitness, propriety, <I>Reguloj de ~eco</I>. <B>Mal~a</B> (<B>Ne~a</B>), improper, inappropriate, incongruous, inopportune, out of place, unbecoming, undue, unseemly, unsuitable, unwarranted, untimely. <B>Mal~aĵo</B>, blunder, \"brick\", gaffe, impropriety, something \"simply not done\", <B>~aspekta</B>, decentlooking. ➞ <I>adapt, akomod, dec, konform</I>. <I>kongru, taŭg. [Ne= </I>convenient (<I>oportuna</I>)]. <B>Rim</B>.: <I>Dec</I> and <I>konven</I> somewhat overlap in meaning: <I>dec</I> is stronger, and related more to moral tightness and to generalities; <I>konven</I> to appropriateness for some particular situation.", "0"],
["konverĝi", "konverĝ-i", "Converg/e, blend, draw together, meet (in a point). <B>~a</B>, -ent, -ing. <I>~aj fluoj, linioj, radioj</I>. <B>~o</B>, -ence. <B>~iga</B> (concave) <I>lenso, spegulo</I>. <B>Mal~i</B> (<I>diverĝi</I>), diverge. Opp <I>fokus, konus</I>.", "0"],
["konvers(aci)i", "konvers(aci)-i", "(<I>kun, pri</I>) <B>[OA]</B> (<I>interparoli</I>), Convers/e, chat, talk together. <B>~(ad)o</B>, -ation, interchange of thoughts and words.", "0"],
["konverti", "konvert-i", "(<I>-n, al</I>), [UV] Conver/t. <B>1</B> Transform (transmute), turn into. <B>2</B> change the heart of, regenerate (Rĝ 18/37). <B>3</B> (rel) change the faith (opinion) of, proselytize. <B>4</B> (el) c., transform. <B>~ebla</B>, -table, -tible. ~iĝo, -sion, change, transformation, of object. (heart, religion). <B>~iĝi</B>, become -ted, turn over a new leaf (1 Rĝ 8/47, Jes 6/10). <I>La neĝo ~iĝis en koton</I>. ~ilo, (<I>ŝanĝilo</I>), means of -sion, -tor, transformer. ~ito (~iĝinto), c., proselyte. ➞ <I>aliformig, prozelit, ŝanĝ, transform</I>.", "0"],
["konvikti", "konvikt-i", "(<I>-n</I>), Convict, prove or find guilty. <B>~o</B>, -ion, proof of (detection in) guilt. <B>~aj</B> <I>montraĵoj</I>, exhibits produced in evidence. <B>~ito</B>, -ed person.", "0"],
["konvinki", "konvink-i", "(<I>-n, pri, ke</I>), [UV] Convinc/e, firmly persuade. <I>~i pri eraro</I>. <B>~o</B>, conviction, assured (settled) belief. <B>~ebla</B>, -ible. <B>~iĝi</B> (<I>veni al la ~o</I>), be -ed, see with one’s own eyes. <B>~iĝo</B>, <B>~iteco</B>, -ement. <B>~ilo</B>, means of -ement; argument, proof. <B>~ita</B>, -ed, sure. ➞ <I>evidentig, kredig, persvad</I>.", "0"],
["konvojo", "konvoj-o", "Convoy. <B>1</B> escorting force. <B>2</B> vessels protected. <B>~i</B>, c., escort, accompany for protection.", "0"],
["konvolvulo", "konvolvul-o", "[OA] Convolvulus, field or lesser bindweed (<I>Convolvulus arvensis</I>). ➞ <I>kalistegi</I>.", "0"],
["konvulsio", "konvulsi-o", "[UV] Convuls/ion, Fit, muscular spasm, <B>f</B> violent agitation, disturbance, laughter, etc. <B>~i</B>, be in cc., have fits. <B>~a</B>, -ive, jerky, spasmodic. <I>~a movo</I>. <B>~e</B> <I>tremi</I>. <B>~eto</B>, jerk, spasm, start, wince. <B>~iĝi</B>, convulse. <B>~ulo</B>, sufferer from cc. ➞ <I>epilepsi, paroksism, spasm, tetan, tik</I>.", "0"],
["konzolo", "konzol-o", "(arch) console. <B>1</B> bracket supported by volutes &gt; <I>korbelo</I>. <B>2</B> (org) (<I>orgenistejo</I>), organ-loft.", "0"],
["kooperativo", "kooperativ-o", "(<I>koopera organizo</I>), -ive society.", "0"],
["kooperi", "kooper-i", "(<I>kunagi</I>), Cooperat/e, especially in industry. <B>~a</B>, -ive. <B>~ado</B>, -ation. <B>~ismo</B>, -ive movement. <B>~isto</B>, member of this.", "0"],
["koopti", "koopt-i", "(<I>-n) (alelekti</I>), co-opt, elect into body by vote of members. <B>~o</B>, -ion.", "0"],
["koordinato", "koordinat-o", "Co-ordinate (geom, etc.), e.g., <I>~oj geografiaj (latitudo, longitudo). ~oj de koloro</I>, colour cc. (gram) ~aj (<I>samrangaj) klaŭzoj</I>, c. clauses (of compound sentence).", "0"],
["kopaivo", "kopaiv-o", "copaiba (rezin), from ~arbusto (<I>Copaifera</I>).", "0"],
["kopalo", "kopal-o", "copal, name of various resins used in varnish.", "0"],
["kopeko", "kopek-o", "[UV] copeck, Russian coin, 1/100 of a rouble.", "0"],
["kopii", "kopi-i", "[UV] Copy, make a c. of, duplicate, reproduce, reprint, transcribe. <B>2</B> follow as a pattern, imitate. <I>~i dokumenton, ekzemplon, geston, voĉon</I>. ~(aĵ)o, c. <B>1</B> facsimile, reprint, reproduction (Rd 17/18). <B>2</B> photo, blueprint. <B>~a</B>, -ing <I>~a inko, krajono, papero</I>. (com) <I>~a libro,</I> book with duplicate leaves. <B>~ilo</B>, -ing machine. <B>~isto</B>, -ist. <B>Tra~i</B> (<I>paŭsi</I>), trace. <I>Tra~a papero</I>. <B>Trans~i</B>, transfer. ➞ <I>faksimil, imit, kajer, model, net, reprodukt</I>. Opp <I>original [Ne= ekzempler]</I>.", "0"],
["kopreno", "kopren-o", "ink-cap fungus (<I>Coprinus</I>).", "0"],
["kopro", "kopr-o", "copra, dried coconut fibre.", "0"],
["kopso", "kops-o", "(agr) copse, coppice, with small trees and underwood.", "0"],
["kopulacio", "kopulaci-o", "(<I>sekskuniĝo</I>), (bio) copulation. ➞ <I>koit</I>.", "0"],
["kopulo", "kopul-o", "(gram) copula, the verb <I>esti</I> or a variant of this, e.g., <B>iĝi (= ekesti), resti</B> <B>(= estadi)</B>.", "0"],
["koracio", "koraci-o", "(<I>blukorvo</I>), (orn) roller (<I>Coracias</I>).", "0"],
["korako", "korak-o", "(<I>granda korvo</I>), raven (<I>Corvus corax</I>). ➞ <I>korv</I>.", "0"],
["koralino", "koralin-o", "coralline seaweed (<I>Coralline</I>).", "0"],
["koralo", "koral-o", "[OA] Coral (Ij 28/18). <B>~a</B>, c. <I>~a atolo, insulo</I>, c-island. <I>~a rifo</I>. <B>~eto</B> (<I>~a bido</I>), c-bead. <B>~insekto</B>, <B>~polipo</B>, <B>~kolora</B>, c-red, -line. ➞ <I>madrepor</I>.", "0"],
["korano", "koran-o", "[UV] Koran, Islamic sacred book.", "0"],
["korbelo", "korbel-o", "(arch) corbe(i)l (&lt; <I>konzolo</I>), projection from wall to support weight. <I>~a fenestro</I>, bow-window.", "0"],
["korbo", "korb-o", "[UV] Basket, pannier. <I>~o kun fruktoj</I> (Am 8/1); <I>da macoj</I> (Le 8/2). <B>Bazara ~o</B>, shopping-b. <I>~o por floroj</I>. <B>Lul~o</B>, b-cot, cradle. <B>Paper~o</B>, w.p.b. (fort) <B>Ter~o</B> (<I>gabio</I>), gabion. <B>~aĵo</B>, wicker-work. <B>~ego</B>, crate, hamper. <B>~eto</B>, punnet. <B>~boato</B> (<I>koraklo</I>), coracle. <B>~(far)isto</B>, b-maker.", "0"],
["kordialo", "kordial-o", "cordial (drink, restorative, stimulant).", "0"],
["kordito", "kordit-o", "cordite.", "0"],
["kordo", "kord-o", "[UV] <B>1</B> (mus) string. ~o drata (wire), katguta (gut), premita (stopped), libera (open), silka (silk). <B>~instrumento</B>, <B>~kvarteto</B>. <B>~streĉilo</B>, peg, tuning key. (piano) <B>Kruc~a</B>, overstrung. <B>Tri~a</B>, trichord. <B>Unu~e</B>, with soft pedal. <B>2</B> (anat) <I>voĉa ~o (ligamento</I>), vocal chord. ➞ <I>akord, kordon, medol, ŝnur</I>.", "0"],
["kordono", "kordon-o", "cordon (wide sense). <B>1</B> (arch) stringcourse. <B>2</B> (mil, police), chain, circle (of posts). <B>3</B> braid, ribbon, worn as badge of honour. ➞ <I>kord, laĉ, ruband, ŝnur</I>.", "0"],
["kordurojo", "korduroj-o", "(tex) corduroy, ridged cotton velvet.", "0"],
["koregonoj", "koregon-oj", "various whitefish (lavoret, pollan, etc.) (<I>Coregonus</I>).", "0"],
["korekti", "korekt-i", "[UV] Correct. <B>1</B> (<I>ion</I>), amend, set right, remove errors. <I>~i eraron, mison, kalkulon, taskon</I>. <B>2</B> (<I>iun</I>), admonish, cure of fault. <B>~(ad)o</B>, -ion, rectification. <I>~ado de presprovaĵoj</I>. <B>~isto</B>, -or. <I>Pres~isto,</I> reader for the press. <B>~ejo</B>, place of -ion. <B>~endaĵoj</B>, corrigenda, errata. <B>~ita</B>, -ed. <B>Pun~i</B> <I>krimulon</I>. <B>Rim</B>.: As korekt-i is thus a verbal root, korekt-a should mean <I>corrective,</I> and korekt-e <I>correctively (by way of correction</I>). One may hope that this usage will prevail. In international and Zamenhofan usage, however, <I>korekta</I> is used as a needless synonym of <I>correct (= ĝusta, senerara</I>), korekt being thus treated as an adj. root. In which case, \"to correct\" should be korektigi (which, however, is <I>not</I> used)! In short, <I>korekt-</I> is a \"hybrid\" root.", "0"],
["korelativa", "korelativ-a", "[OA] (<I>interresponda</I>), (gram) Correlative, correlated. <B>~oj</B>, <I>la</I> 45 <I>~aj vortoj</I>. <B>~eco</B>, co-relation. Used especially of words or expressions answering (implying the existence of) each other, e.g., <I>kaŭzo kaj efiko, tiel… kiel, se … tiam</I>.", "0"],
["koreopso", "koreops-o", "coreopsis (tickseed, etc.) (<I>Coreopsis</I>).", "0"],
["korespondi", "korespond-i", "(<I>kun</I>), [UV] Correspond (interchange letters). <B>~(ad)o</B>, -ence, <B>~anto</B>, <B>~isto</B>, -ent. <B>~aĵo</B>, mail, post. <I>[Ne= analog, konform, komunik, respond, rilat, simetri]</I>.", "0"],
["Koreujo", "Kore-ujo", "<B>Koreio</B>, Korea. <B>Nord-K~ujo, Nord-K~io</B> KP, <B>Sud-K~-ujo, Sud-K~io</B> KR.", "0"],
["koriandro", "koriandr-o", "(bot) coriander (<I>Coriandrum). ~a semo</I> (El 16/31).", "0"],
["koridoro", "koridor-o", "[OA] Corridor, galley, (main or outside) passage way. <I>Flanka ~o,</I> aisle. <I>~a vagonaro</I>, c-train. ➞ <I>galeri, irej, pasej</I>.", "0"],
["korifeo", "korife-o", "[OA] (ant) (<I>ĥorestro</I>), coryphaeus, chorus leader, f (<I>eminentulo</I>), leader.", "0"],
["korikso", "koriks-o", "(ent) water-boatman (<I>Corixa</I>). ➞ <I>notonekt</I>.", "0"],
["korimbo", "korimb-o", "(bot) corymb.", "0"],
["korinto", "korint-o", "(<I>~a sekvinbereto</I>), dried currant <I>[Ne= ribo.]</I> ➞ <I>rosin</I>.", "0"],
["korizo", "koriz-o", "(<I>nazkataro</I>), coryza, nasal and sinus catarrh.", "0"],
["korko", "kork-o", "[UV] Cork. 1 (<I>ligno</I>), bark of ~arbo, c-oak (<I>Quercus suber). Floti kiel ~o</I>. <B>2</B> (<I>botelŝtopilo</I>), c., bung, stopper. ~(ec)a, ~ogusta, cork(y). <I>~a savzono,</I> c-lifebelt. ~i <I>botelon</I>. ~adilo, c ing machine. ~farilo. ~flna, c-tipped. ~tirilo, c-screw. Mal<B>~i</B>, un-c. ➞ <I>bast, stop</I>.", "0"],
["kormorano", "kormoran-o", "Cormorant (<I>Phalacrocorax</I>). Granda <B>~o</B>, common c. (<I>P. carbo</I>). Pigmea <B>~o</B>, pigmy c. Tufa <B>~o</B>, shag (P. <I>aristotelia</I>). ➞ <I>sul</I>.", "0"],
["korneo", "korne-o", "[OA] cornea (membrane of the eye). <B>~a</B>, -al.", "0"],
["korneto", "kornet-o", "[OA] (m.i.) Cornet. <B>~isto</B>, c- player.", "0"],
["kornico", "kornic-o", "[UV] (<I>elstaraĵo</I>), (arch) cornice, moulded projection at top of building, window, etc. (El 27/5, 1 FA 128/32).", "0"],
["kornko", "kornk-o", "[OA] Crow. ~o griza (mantela), grey (hooded) c. (<I>Corvus cornix</I>). ~o nigra, carrion c. (C. <I>corone</I>). ➞ <I>korv</I>.", "0"],
["korno", "korn-o", "[UV] Horn. <B>1</B> horn (<I>virbova</I>); antenna (<I>insekta</I>); crest (<I>striga</I>); tentacle (<I>helika</I>). <B>2</B> h-shaped object.: Aŭdiga <B>~o</B>, ear-trumpet. <B>Nebul~o</B>, fog-h. <B>Papera ~o</B>, paper funnel. <B>Polvo~o</B>, powder-h. <B>Ŝu~o</B>, shoe-horn. Tri~a <I>ĉapelo</I>, cocked hat. <B>3</B> (substance): horn. <B>4</B> f (Bb) pride, power. <I>Ilia ~o altiĝis. Levi, retiri la ~ojn. Rompi la ~ojn (de malamiko</I>). <B>5</B> (m.i.) (El 19/16). <B>Alpa ~o</B>, Alpine horn. <B>Baset~o</B>, basset h. <B>Ĉas~o</B>, hunting-h. <B>Flugel~o</B>, Flügel h. <B>Natura</B> (<B>senvalva</B>) <B>~o</B>, natural horn. <B>Orkestra</B> (<B>kromata</B>) <B>~o</B>, French h. <B>Saks~o</B>, sax-h. <B>Signal~o</B> (<I>buglo</I>), bugle. <I>~o aŭtomobila (hupo</I>). <B>~(ec)a</B>, -y. <B>~i</B>, <B>1</B> sound the h. <B>2</B> (mot) (<I>hupi</I>). <B>~eto</B>, cornet, e.g., of paper, or for ice-cream. <B>~aro</B>, horns, antlers. <B>~iĝi</B>, harden (of the skin). <B>~hava</B>, -ed, antlered. <B>~obati</B>, <B>~frapi</B>, <B>~piki</B>, <B>~puŝi</B>, butt, gore (El 21/28, Da 8/4). <B>~opinto</B>, tine. <B>Sen~a</B>, hornless. <B>Unu~ulo</B>, unicorn. ➞ <I>kal</I>.", "0"],
["kornuso", "kornus-o", "dogwood, cornel (<I>Cornus). ~a frukto</I>.", "0"],
["koro", "kor-o", "[UV] Heart. <B>1</B> (anat) <B>2</B> central (inner, vital) part of object., core, essence. ~o <I>de planto (pomo</I>). <B>3</B> feeling, innermost being, mind, soul, will. <I>Ĝis la ~o</I>, to the quick. <I>Doni, gajni, pezigi, penetri, premi, rompi, ŝiri la ~on. ~o bona, gaja, plena. ~o el oro. Havi ~on sur (paroli el) la ~o, meti en la ~on. ~o scias sian propran malĝojon</I> (Se 14/10). <B>~a</B>, of the h., cardiac, (hort) <I>~a putro</I>, h-rot. <B>f</B> (<I>elkora</I>), cordial, hearty, h-felt, sincere, true, unfeigned, warm. <I>~a amo (danko</I>). <B>~eco</B>, cordiality. ~ega (<I>tut~a</I>), <B>~difekto</B>, h-trouble. <B>~malsano</B>, h-disease. <B>Sen~a</B>, -less, cruel. <B>Bon~a</B> (<I>afabla</I>), kind(ly), kind-ed. <B>Facil~a</B>, light-minded. <B>Malbon~a</B>, base, wicked. <B>Malic~a</B> (Se 11/20). <B>Mol~a</B>, <B>1</B> soft-ed, fond, tender. <B>2</B> (<I>senkuraĝa</I>), fainted (2 Kr 13/7). <B>Plen~a</B>, most hearty. <B>Pur~a</B>, pure in h. <B>Tut~a</B>, whole-ed. ➞ <I>centr, emoci, ker, kern, parker</I>.", "0"],
["korodi", "korod-i", "(<I>-n</I>), Corro/de, destroy gradually, eat away (action of disease, chemical, rust, etc.). <B>f</B> blight, embitter. <B>~o</B>, -sion, decay. ~(em)a, -sive, acrid, mordant. <B>~aĵo</B>, -sive. ➞ <I>erod, rod, kaŭstik</I>.", "0"],
["korolario", "korolari-o", "corollary, deduction, inference. ➞ <I>dedukt, konklud</I>.", "0"],
["korolo", "korol-o", "<B>[OA]</B> (<I>petalaro</I>), (bot) corolla.", "0"],
["koronaria", "koronari-a", "(med) coronary (arterio, artrito, okludo, vejrto).", "0"],
["koronelo", "koronel-o", "(bot) crown vetch (<I>Coronilla</I>).", "0"],
["korono", "koron-o", "corona (<I>suna, luna</I>).", "0"],
["koronopo", "koronop-o", "(bot) wart cress (<I>Coronopus</I>).", "0"],
["korpo", "korp-o", "[UV] Body. <B>1</B> of animal. <I>~o fortika, sana. Unu animo en du ~oj</I>. <B>2</B> main part, trunk, etc. <I>~o de violono. Ŝip~o</I>, hull. <B>3</B> material substance. <I>~o organika, simpla</I>. <B>~a</B>, bodily, corporeal, material, physical. <B>~e</B>, in person. <B>~(aĵ)a</B>, carnal, fleshly. <B>~eto</B>, corpuscle. <B>~iĝi</B>, take bodily form, materialize, <B>~ogardisto</B>, b-guard (Ge 37/36). <B>En~iĝi</B>, em-b. <B>En~iĝo</B>, embodiment, incarnation. <B>El~iĝi</B>, disembody. <B>sen~a</B>, [UV] immaterial, incorporeal. <B>Mol~ulo</B>, mollusc (<I>molusko</I>). ➞ <I>kadavr, karn, korpus, materi</I>.", "0"],
["korporacio", "korporaci-o", "[UV] (wide sense) Corporat/ion, incorporated body (company) for public service. <I>~o de kuracistoj, panistoj, ŝipistoj. La Brita Brodkasta ~o</I>. <B>~e</B> <I>starigita</I>, in-ed. ➞ <I>gild, sindikat</I>.", "0"],
["korpulenta", "korpulent-a", "(<I>dikventra, vastkorpa</I>), corpulent, fat, fleshy, obese, stout.", "0"],
["korpusklo", "korpuskl-o", "(<I>eta materiero</I>), corpusc/le (-ule), minute particle (in body, blood). ➞ <I>atom, infinitezim, molekul</I>.", "0"],
["korpuso", "korpus-o", "[UV] (mil) corps, body of troops, division of army.", "0"],
["korsaĵo", "korsaĵ-o", "[OA] bodice, body, corsage (of woman’s dress). <I>~o dekoltita</I>.", "0"],
["korsaro", "korsar-o", "[OA] corsair, privateer, vessel privately owned, with government approval, to raid enemy ships. <B>1</B> (<I>ŝipo</I>). <B>2</B> (<I>ŝipano</I>). ➞ <I>kaper, pirat</I>.", "0"],
["korseto", "korset-o", "[OA] corset, stays. <I>~o strikte laĉita</I> (tight-laced), (agr) <B>Arb~o</B>, tree-guard. <B>~isto</B>, stay-maker.", "0"],
["kortaderio", "kortaderi-o", "pampas grass (<I>Cortaderia</I>).", "0"],
["kortiko", "kortik-o", "cortex (anat) (bot). <B>Sen~a</B>, decorticated.", "0"],
["kortizono", "kortizon-o", "cortisone.", "0"],
["korto", "kort-o", "[UV] Court, Yard, enclosed area, quadrangle. <B>1</B> <I>La morto staras jam en la ~o (= tre proksime</I>). <B>Antaŭ~o</B>, fore-c. <B>Bird~o</B>, farm-y. <B>Lud~o</B>, playground. <B>~ego</B>, [UV] c., princely retinue, royal household. <I>~ega ceremonio. ~egano,</I> c-ier. <I>~eganino</I>, lady of the c. <B>~umo</B>, c. of justice, bar. <I>Ĉef~umo</I>, supreme c.", "0"],
["korundo", "korund-o", "(min) corundum, crystallized ALOj. ➞ <I>safir, smerald, smirg, ruben</I>.", "0"],
["korupti", "korupt-i", "(<I>-n</I>) <B>[OA], 1</B> Bribe, buy over, entice, suborn (by gift or other inducement). <I>~i juĝiston, oficiston</I>. <B>2</B> (<I>aĉigi, difekti</I>), corrupt, taint. <I>~i karakteron, moralon, spiriton, stilon</I>. <B>~ebla</B>, b-able. ➞ <I>putr, subaĉet, ŝmir</I>.", "0"],
["korveto", "korvet-o", "[OA] (mar) corvette, large sloop of war.", "0"],
["korvo", "korv-o", "[UV] (<I>Corvus</I>). <B>1</B> (wide sense) member of the Crow fam (<I>korvedoj) &gt; frugileg, koraci, kornik, moned, pirokorak</I>, which see Esperanto. <B>2</B> raven (C. <I>corax</I>) (technical language <I>korako, korvego</I> St), the largest of the fam (Ge 8/7, Rd 14/14). <B>~a</B>, corvine. ~e <I>nigra,</I> r-black.", "0"],
["kosekanto", "kosekant-o", "(trig) cosecant (cosec).", "0"],
["kosinuso", "kosinus-o", "cosine (cos).", "0"],
["kosmetiko", "kosmetik-o", "[OA] Cosmetic, beauty preparation.", "0"],
["kosmo", "kosm-o", "Cosm/os, the universe as an ordered whole. <B>~a</B>, -ic. <I>~a radiado</I>.", "0"],
["kosmografio", "kosmograf-io", "<B>[OA], ~o</B>, cosmograph-y, -er. <B>~ologio</B>, -ology.", "0"],
["kosmoogonio", "kosmoogoni-o", "<B>[OA], cosm</B>ogony.", "0"],
["kosmopolito", "kosmopolit-o", "<B>[OA], ~a</B>, cosmopolitan. <B>~eco</B>, <B>~ismo</B>, -opolitanism. ➞ <I>homaran, mondcivitan</I>.", "0"],
["kosmoso", "kosmos-o", "(hort) cosmos, Mexican aster (<I>Cosmos</I>).", "0"],
["Kosovo.", "Kosov-o.", "", "0"],
["Kostariko", "Kostarik-o", "[OA-8] CR.", "0"],
["kosti", "kost-i", "(<I>-n</I>), [UV] Cost, involve expenditure (labour, loss). <I>~i tri pencojn, nenion; laboron, tempon, vivon; doloron kaj suferon</I>. <B>~o</B>, c., charge, expense, price. <I>Je mia ~o,</I> at my expense. <I>La ~oj de la vojaĝo. Send~o</I>, carriage. (<I>Multe)~a (altpreza</I>), c-ly, dear, expensive, high-priced. <I>Malpli ~a</I>, cheaper. <B>~preze</B>, at c. price. <B>Sen~e</B>, without charge, free, gratis, for nothing. ➞ <I>kalkul, kar, pag, prez, valor</I>.", "0"],
["kostumo", "kostum-o", "[UV] Costume. <B>1</B> (style of) dress, garb (of class, epoch, nation., etc.). <B>~o</B> <I>bala, fantazia, nacia, vojaĝa</I>. <B>2</B> (<I>kompleto</I>). <B>~isto</B>, -ier.", "0"],
["kosuso", "kosus-o", "(ent) goat-moth (<I>Cossus</I>).", "0"],
["koŝera", "koŝer-a", "kosher, fulfilling requiremts of Jewish law.", "0"],
["koŝmaro", "koŝmar-o", "(inkubsonĝo, premsonĝo), nightmare. ➞ <I>inkub</I>.", "0"],
["koŝo", "koŝ-o", "(mar) thimble, wooden or metal ring with groove for rope.", "0"],
["koterio", "koteri-o", "coterie, exclusive circle, set. ➞ <I>klik</I>.", "0"],
["kotido", "kotid-o", "(ich) bullhead &gt; miller’s thumb, sea scorpion (<I>Cottus</I>).", "0"],
["kotiledono", "kotiledon-o", "cotyledon, primary or seed- leaf. <B>Du~a</B>, <B>Unu~a</B>.", "0"],
["kotizi", "kotiz-i", "[OA] Contribut/e, Subscri/be (give for common obj) <I>[Ne= subskribi]. ~i al kaso, societo, por donaco</I>. <B>~(aĵ)o</B>, c-ion, quota, share, s-ption. ➞ <I>abon, kontingent, kontribu</I>.", "0"],
["kotleto", "kotlet-o", "[OA] cutlet, chop, small piece of meat. <I>~o bovida, lumba, porka</I>.", "0"],
["koto", "kot-o", "[UV] Dirt, Mud; filth, mire, muck. <I>Kiu ludas kun ~o malpurigas la manojn. Trempi en ~o</I> (Ij 9/31). <B>~a</B>, dirty, mudy. <I>~a tago, vetero</I>. <B>~i</B> (<I>feki). Ne ~as besto en sia nesto</I>. <B>~aĵo</B> (K 62/1). <B>~ejo</B>, quagmire, slough. <B>~ero</B>, speck of dirt. <B>Sen~igi</B> (<I>la botojn</I>), clean, scrape. <B>~isto</B>, scavenger. ➞ <I>malpur, marĉ, ŝlim</I>.", "0"],
["Kotoneastro", "Kotoneastr-o", "(bot) cotoneaster shrub (<I>Cotoneaster</I>).", "0"],
["kotono", "koton-o", "[UV] Cotton (Wool) (material). <B>Bril~o</B> (<I>silka ~o</I>), mercerized c. <B>Fulm~o</B>, <B>pulvo~o</B>, gun-c. <B>Sorba</B> <B>~o</B>, absorbent c-w. <B>~a</B> <I>drapo, fadeno</I>. <B>~aĵoj</B>, c-goods. <B>~arbo</B>, c-plant (<I>Gossypium</I>). <B>~sema</B> <I>oleo</I>. ➞ <I>eriofor, katun, vat</I>).", "0"],
["koturno", "koturn-o", "[UV] (orn) quail (<I>Coturnix</I>) (El 16/13).", "0"],
["koverto", "kovert-o", "[UV] envelope. <I>Afranki, disŝiri ~on</I>. <B>En~igi</B> <I>leteron</I>.", "0"],
["kovi", "kov-i", "(<I>-n</I>), [UV] Brood, Hatch, incubate, sit (as hen on eggs), <B>f</B> b. over, dwell on, sullenly meditate (especially with ill intent). <I>~i projekton, perfidon. Lia koro ~as malamon</I>. <B>~ado</B>, incubation. <B>~aĵo</B>, sitting. <B>~ejo</B> <I>de konspiro</I>, hotbed of conspiracy. <B>~ema</B> <I>kokino</I>, b-y hen, sitter. <B>~iĝi</B>, be h-ed out. <B>~igi</B> <I>kokinon</I>, set. <B>~ilo</B> (<B>~aparato</B>), incubator. <B>~itaro</B>, b., covey. <B>Duon~ita</B>, addled. <B>El~i</B>, h. out. <B>f</B> <I>= naski</I>. ➞ <I>elovig</I>.", "0"],
["kovri", "kovr-i", "(<I>-n, per</I>) [UV]. Cover. <B>1</B> clothe, over-lay(-spread), put all over: <B>~i</B> <I>domon per pajlo, infanon per kisoj, plankon per sablo, sin per gloro, tablon per pladoj</I>. <B>2</B> be (extend, lie) on, over: <I>Ĉapelo ~as la kapon, floroj - tombon, masko - vizaĝon, neĝo - teron, nuboj - ĉielon, tuko - tablon</I>. <I><B>3</B> Hide, cloak, conceal, screen, shroud, veil:</I> <B>~i</B> <I>la okulojn, orelojn per la manoj, Amo ~as ĉiujn pekojn</I>.<I> <B>4</B></I> (egali, kompensi), <I>meet:</I> ~i <I>deficiton, elspezon, koston</I>. <I><B>~(aĵo)</B>, -ing, coating</I>. <I>~(aĵ)o el pajlo, tegoloj</I>. <B>Sel~aĵo</B>, <I>saddle-cloth, <B>~igi</B>, be -ed. <B>~ilo</B>, [UV] envelope, lid, cover of book (umbrella), shutter</I> (<I>ŝutro</I>), <I>etc. <B>Lit~ilo</B>, bed-c, blanket, counterpane, sheet. <B>Stebita ~~ilo</B>, quilt. <B>Tir~ilo</B>, roll-top (of desk</I>). <I>Volve <B>~ita</B>, enveloped. <B>mal~i</B>, [UV] uncover. <B>1</B> bare: <B>~~i</B> kapon, ŝultron</I>.<I> <B>2</B></I> (malkaŝi): (<I>a) disclose, reveal; (b) detect, discover, find out</I>. ~~i <I>aŭtoron, kaŝejon, penson, sekreton</I>.<I> <B>Ne~ita</B>, bare. <B>Sen~a</B>, exposed, open. <B>Dom~isto</B>, roofer (slater, thatcher). <B>Ĵet~ita</B> per, strewn with. <B>Ŝut~anta</B> hajlo (4 FA 51/33). ➞ kovert, stern, teg, vest, vual</I>.", "0"],
["kozako", "kozak-o", "[OA] cossack.", "1"],
["krabli", "krabl-i", "crawl, wriggle (as crab, spider, etc.).", "0"],
["krabo", "krab-o", "[OA] Crab (<I>Cancer</I>). <B>Aranea ~o</B>, spider c. (<I>Maia</I>). <B>Ermita ~o</B>, hermit c. (<I>eŭpaguro</I>). The edible c. is <I>paguro (C. pagurus</I>). ➞ <I>kancer, kankr, karcen</I>.", "0"],
["krabro", "krabr-o", "[OA] hornet (<I>Vespa crabro</I>). (El 23/28).", "0"],
["kraĉi", "kraĉ-i", "[UV] Spit. <B>1</B> expectorate, eject from mouth. <B>2</B> make -ing noise (as a cat), ~i <I>sangon, en puton, sur ion</I>. <B>~aĵo</B>, s., sputum. <B>~eti</B>, sp(l)utter. <B>~ujo</B>, cuspidor, spittoon. ➞ <I>bav, saliv, sput, spruc</I>.", "0"],
["krado", "krad-o", "[OA] crossbars, grating; grate, grid, grille, latticed screen or partition (El 38/4; Se 7/6). <B>Ekrana ~o</B>, screen grid. <B>Klap~o</B>, ventilation grating. <B>Paŝ~o</B>, pavement grating. <B>Plat~o</B> (<I>= plat~a brutbarilo</I>), cattle grid, <B>~aĵo</B>, lattice (trellis) work. <B>~ita</B> <I>ŝtofo</I>, tartan. <B>~rosti</B>, grill. <B>~~ilo</B>, gridiron. <B>De~i</B>, separate by grating.", "0"],
["krajono", "krajon-o", "[UV] Pencil <I>[Ne= </I> crayon]. <I>Glob~o</I>, ball-point p. <B>~ingo</B>, p-holder. <B>~ujo</B>, p-box (-case). ➞ <I>grifel, kret, pastel, penik</I>.", "0"],
["krakeno", "kraken-o", "[UV] (1 FA 49/14; 2 FA 66/19), cracknel, light crisp biscuit crackling when bitten. ➞ <I>kring</I>.", "0"],
["kraki", "krak-i", "[UV] (nt) make a sharp dry noise, e.g., of breaking, bursting, tearing. <B>~o</B>, bang, clap, crack, detonation, report. <I>~o de motoro, pordo, tamburo, tondro, survango</I>. Krak\". (<I>sonimito</I>) (2 FA 145/27). <I>Krak! la siliko krevis</I> (Z). <I>La flago ~is</I> (flapped), <B>~ado</B>, clanking, clinking, jingling, rattling (<I>de ŝlosiloj</I>, k.s.). (mot) pinking. <B>~eto</B>, creak, crepitate, chatter (of <I>dentoj</I>); clatter (<I>fajenco</I>); crackle (<I>brulanta ligno</I>); patter (<I>hajlo, pluvo</I>); sputter (<I>bolanta akvo</I>). <B>~eti</B>, crackle, pop, snap. <I>~etado de dornoj</I> (Pr 7/6). <B>~etigi</B>, crackle (<I>fingroartiko</I>), crunch (between teeth, under foot). <I>La vento ~etigis la branĉojn. La imperio</I> <B>dis~iĝis</B> (<I>dispeciĝis). Ligna</I> <B>~ilo</B>, clapper. ➞ <I>krepit, klak, knal, knar, krev</I>.", "0"],
["krakso", "kraks-o", "(orn) curassow (<I>Crax</I>).", "0"],
["krambo", "kramb-o", "sea kale (<I>Crambe maritima</I>).", "0"],
["kramfo", "kramf-o", "(med) cramp.", "0"],
["krampo", "kramp-o", "[UV] <B>1</B> (carp, bid) Cramp(-iron); brace, clamp, (sp) climbg-iron, <I>G~o,</I> G-c. <I>~o kadra, retsegila, stanga</I>, corner (fretsaw, sash) c. ~eto (<I>dunajlo, najl~o</I>), staple (M 212/24). <B>2</B> (typ) bracket, <B>~oj</B> <I>angulaj &lt; &gt;</I> , kunigaj ( }, kvadrataj [ ], rondaj (). <B>~i</B>, hold (fasten) with a c. <I>~i vazon al tablo</I>. <B>f</B> <I>sin ~i al</I>, bore, buttonhole. Interne, in parenthesis. ➞ <I>agraf</I>.", "0"],
["kranio", "krani-o", "[UV] skull, brain-pan, cranium (Jĝ 9/53). <I>Frakasi, trabori la ~on</I>. <B>f</B> head, pate. <I>En ĉiu ~o aparta opinio. Granda ~o, sed interne nenio. ~o longa, pinta, ronda</I>. <B>~a</B>, cranial, <B>-ologio</B>, <B>-ometrio</B>, cranio-logy, -metry.", "0"],
["kranko", "krank-o", "crank, starting-handle. <I>~o mana, sekuriga. ~o plata</I>, disk-c. <B>~i</B> <I>aŭton</I>.", "0"],
["krano", "kran-o", "[UV] Tap, cock, faucet, spigot <I>[Ne= crane (argano, gruo)]. Akvo~o. Gas~o, ~o moderiga</I>, throttle-valve. <B>Flot~o</B>, ball-cock. <I>Turni la ~on</I>, turn the t. (on or off). <I>Fermi (malfermi) la ~on</I>, turn off (on) the tap (gas, water). <B>El~i</B>, draw off. <B>For~i</B>, turn off (<I>akvon</I>).", "0"],
["kraŝi", "kraŝ-i", "<B>~o</B>, (<I>falfrakasiĝi</I>), (av) Crash. <B>~kasko</B> (<I>protekta kasko</I>), c-helmet.", "0"],
["kratago", "kratag-o", "[UV] Hawthorn, may, whitethorn. (<I>Crataegus</I>).", "0"],
["kratero", "krater-o", "[UV] crater. <B>1</B> <I>~o (buŝo) de vulkano</I>. <B>2</B> c-shaped bowl or cavity. <B>~eto</B>, pot-hole. ➞ <I>abism, faŭk</I>.", "0"],
["kraŭlo", "kraŭl-o", "<B>~i</B>, (<I>rampnaĝi</I>), crawl.", "0"],
["kraŭno", "kraŭn-o", "crown-glass. ➞ <I>flint, vitr</I>.", "0"],
["kravato", "kravat-o", "<B>[UV]</B> (<I>kolbendo</I>), cravat, (neck)- tie. <I>~o lana, silka</I>.", "0"],
["krazo", "kraz-o", "(phon) crasis (unuvokaligo de du vokaloj).", "0"],
["kredi", "kred-i", "(<I>-n, al, je, pri</I>) [UV]. <B>1</B> Believ/e (in), be of opinion (that), credit (truth of), give credence (to). <B>2</B> (<I>opinii</I>); think. <I>Mi ~as vin; vian diron; al via promeso; je Dio; pri fantomoj; ke jes (ne</I>). <B>~o</B>, Belief, acceptance as true, faith. <B>~(it)aĵo</B>, thing -ed, article of faith, tenet, <B>~anto</B>, <B>~isto</B>, -er. <I>~antaro</I>, community of -ers, church. <B>~ebla</B>, [UV] credible, likely, <I>~eble</I>, one may suppose that … <B>~ema</B>, credulous. <B>~enda</B>, that must be -ed. <B>~igi</B>, induce (lead) to b., persuade. <I>~igi iun pri io, ion al iu</I>. <B>~inda</B>, trustworthy. <B>Mal~i</B>, dis-b. <B>Ne~ebla</B>, incredible. <B>Sen~eco</B>, un-b. <B>Sen~ulo</B>, infidel. ➞ <I>fid, konfesi, konfid, konsent, opini, pens</I>.", "0"],
["kredito", "kredit-o", "[OA] Credit (wide sense) (com) sum at disposal in books of bank or firm. <I>Enskribi en ies ~on. Havi ~on ĉe la banko</I>. <B>f</B> confidence, <I>Havi ĉe iu ~on kaj meriton</I>. <B>~i</B>, (give) credit, enter on the credit side, place to the credit of. <B>f</B> attribute, ascribe (quality to someone). <B>~a</B>, credit. <I>~a flanko, letero, saldo</I>. <B>~e</B>, on credit. <I>Vendi ~e</I>. <B>~igi</B>, accredit, <B>~ulo</B>, person in credit. <B>Sen~igi</B>, discredit. II (pol) <B>socia</B> <B>~o</B>, social credit. Opp <I>debit</I>.", "0"],
["kreditoro", "kreditor-o", "[OA] creditor (Rd 15/2; Ps 109/11), one to whom a debt is owing. <I>Ne helpas ploro kontraŭ ~o</I>. Opp <I>debitor</I>.", "0"],
["krei", "kre-i", "(<I>-n</I>), [UV] Creat/e. <B>1</B> (<I>estigi</I>): bring into being, call into existence, originate: <I>Dio ~is la ĉielon kaj la teron</I>. <B>2</B> (<I>ellabori, fondi): ~i oficon, modon, rolon, teknikon</I>. <B>3</B> (<I>fari, naski): okazo ~as ŝteliston. La afero ~is sensacion</I>. <B>~(ad)o</B>, -ion (act). <I>La ~o de la tero</I>. <B>~(it)aĵo</B> (Jes 29/16), -ion (obj), -ed thing, production, work. <B>~iĝi</B>, be -ed. <B>~into</B>, -or, author. <B>~ismo</B>, -ionism. <B>~ito</B>, -ed being, -ture. <I>La tuta ~itaro</I>, the whole -ion.", "0"],
["krekso", "kreks-o", "(corn)crake (<I>Crex</I>). ➞ <I>porzan, ral</I>.", "0"],
["kremati", "kremat-i", "(a. <I>kremacii</I>), Cremat/e. <B>~o</B>, -ion. <B>~ejo</B>, -orium. ➞ <I>enterig, funeral, sepult</I>.", "0"],
["kremo", "krem-o", "[UV] Cream. <B>1</B> of milk. <I>Kafo kun ~o</I>. <B>2</B> similar substance. <B>Dent~o</B>, toothpaste. <B>Mebla</B> <B>~o</B>, furniture c. <B>Tualeta ~o</B>. <B>Vizaĝ~o</B>. <B>f</B> best (choice) pt. <B>~ujo</B>, c-jug. <B>~kolora</B>, <B>~riĉa</B>, -y. <B>Sen~igi</B>, c., skim. <I>~~igilo</I>, -er.", "0"],
["krenelo", "krenel-o", "(arch). <B>1</B> crenel, opening in parapet for shooting through. <B>2</B> toothlike masonry at top of wall. <B>3</B> (zoo) crenelle (<I>Crenella</I>). <B>~a</B>, 1, 2, crenellated. <B>3</B> (bot) crenate, notched, scalloped, toothed. <I>~a folio</I>. ➞ <I>embrazur</I>.", "0"],
["kreno", "kren-o", "horseradish (<I>Cochlearia armorica</I>).", "0"],
["kreolo", "kreol-o", "[OA] Creole, -ino. ➞ <I>mestiz</I>.", "0"],
["kreozoto", "kreozot-o", "[OA] creosote.", "0"],
["krepido", "krepid-o", "(bot) hawksbeard (<I>Crepis</I>).", "0"],
["krepiti", "krepit-i", "(<I>kraketadi</I>), crepitate.", "0"],
["krepo", "krep-o", ". <B>1</B> Crape (worsted silk or cotton material, with wrinkled surface). <I>~o Ĉina. ~o sur ĉapelo</I>. <B>2</B> crepe (rubber). <I>~o kaŭĉuka, planduma</I>. <B>~(ec)a</B>, crinkled, wavy. <I>~a papero</I>. <B>~i</B> (<I>~e drapiri</I>), cover (drape) with c. ➞ <I>krisp</I>.", "0"],
["krepusko", "krepusk-o", "Twilight (us. = <I>vespera ~o</I>, dusk, gloamg) (Ij 24/15). <I>Matena ~o,</I> dawn, <B>f</B> <I>La ~o de la vivo</I>, <B>~a</B>, t., dim, glimmering, shadowy. <B>~iĝi</B>. <B>El~iĝi</B> (<I>klariĝi, naskiĝi</I>). ➞ <I>aŭror, ekfiniĝ, ekmalfortiĝ, mateniĝ, vesperiĝ</I>.", "0"],
["krescento", "krescent-o", "Crescent, (astr) Moon in first or last quarter, <B>f</B> Obj, e.g., row of houses, in form of c. <B>~a</B>, c., lunate. ➞ <I>kresk, lunark</I>.", "0"],
["kresĉendo", "kresĉend-o", "(mus) crescendo. <B>Mal~o</B>, diminuendo. ➞ <I>pedal</I>.", "0"],
["kreski", "kresk-i", "(nt), [UV] Grow. <B>1</B> <I>= alt-(fort-mult -vast-)iĝi;</I> Increase (in degree, quantity, size); enlarge, expand, extend, sweil, wax: <I>~as bezono, dubo, intereso, literaturo, luno</I>. <B>2</B> (disvolviĝi) develop (progress) normally: <B>~as best-(har-plant-)oj</B>. <B>3 (troviĝi, vivi) <I>lupoloj ~as abunde en Kent. Tie nenio povas</I></B> <I>~i</I>. <I>~(ad)o</I>, -th, increase, progress, etc. <B><I>Li estas de meza ~o</I></B> (➞ <I>statur</I>). <I>La ~ado de nia literaturo</I>. <B>~aĵo</B> [UV] (<I>us</I> = planto), -th. <B>Mar~aĵo</B>, <I>seaweed</I>. <B>~aĵaro</B>, flora, plant life. ~aĵa regno, vegetable kingdom. <B>~anta</B> luno, first quarter. <B>~ejo</B>, habitat. <B>~igi</B>, (make) g., cultivate, produce, raise, rear (Ge 1/11). <I>La Izraelidoj</I> <B>dis~is</B> <I>kaj multiĝis</I> (El 1/7). <B>Ek~i</B>, start -ing, germinate, spring up, sprout. <B>El~i</B>, <B>1</B> g. out. <I>Novaj projektoj el~adas kiel fungoj</I>. <B>2</B> <I>g. fully. Ne en unu tago el~is Kartago</I>. <B>El~aĵo</B>, <B>sur~aĵo</B>, excrescence, offshoot, out-th. <B>El~igi</B> (<I>put forth</I>) <I>branĉojn</I>. <B>Mal~i</B>, g. smaller, wane. <B>Mis~i</B>, g. amiss. <B>Sub~aĵo</B>, under-th. <B>Super~ita</B>, over-n, overrun. <B>Tro~i</B>, g. too fast (much). <B><I>~~</I>inta</B>, oversize, hypertrophied. <B>Alt~a</B>, tall. <B>Bel~a</B>, shapely. <B>Duon~a</B>, half-n, puny, stunted. <B>Plen~a</B>, -n up, fully -n, adult. ➞ <I>flor, krescent, kultiv, plant, pli-fort(-grand intens)iĝ, veget</I>.", "0"],
["kreso", "kres-o", "<I>[OA],</I> Watercress (<I>Nasturtium officinale</I>). <B>~ejo</B>, w-bed. ➞ <I>lepidi, tropeol</I>.", "0"],
["krespo", "kresp-o", "(<I>patkuko</I>), Pancake. <I>Turnĵeti ~on</I>. <B>~a</B> <I>Tago</I>, p. day, Shrove Tuesday.", "0"],
["kresto", "krest-o", "[OA] Comb, crest (on animal’s head). <I>~o de meleagro. Koka ~o</I>, cock’s c. <B>f</B> long high ridge. <I>~o de monto, ondo. Kun klinita ~o</I>, crest-fallen. <I>~ofloro (rinanto</I>), (bot) cock’s c. (1 FA 19/7). <B>Sen~igi</B>, knock off the top (lower the crest, cut down the slope of).", "0"],
["krestomatio", "krestomati-o", "[OA] chrestomathy, collection of choice passages as models. <I>\"La Fundamenta</I> ~o\". ➞ <I>antologi</I>.", "0"],
["kretaceo", "kretace-o", "(geol) cretaceous period,", "0"],
["kreteno", "kreten-o", "(med) Cretin, deformed idiot, <B>f</B> imbecile. <B>~eco</B>, -ism, congenital failure of mental or physical development. ➞ <I>idiot</I>.", "0"],
["kreto", "kret-o", "[UV] Chalk. <B>1</B> soft limestone (<I>kretŝtono</I>). <B>2</B> stick of c. for writing on blackboard. ~blanko, ~pulvoro, whiting. <B>~a</B>, -y. <B>~eca</B>, -aceous. <B>~izi</B>, cretify.", "0"],
["kretono", "kreton-o", "(tex) cretonne, stout unglazed cloth with painted pattern (<I>varpo kanaba, vefto lina</I>).", "0"],
["krevi", "krev-i", "(nt), [UV] Burst, break up, explode, fly open (by expansion, etc.). f <I>~as la koro. ~i de furiozo. De tro multa scio ~as la kranio</I>. ~o b., disruption, explosn, out-b. <I>Bomb~(radbend~vezik~)o. Nub~o,</I> cloud-b. <B>~aĵo</B>, crack, crevasse, split (Alt 2/14). <B>~eto</B>, crevice. <I>~etajo (sur la mano</I>), chap. <B>~igi</B>, (cause to) b., break (crack) open. <I>~igi absces-(nuks-ŝton-)on</I>. <B>Dis~i</B>, b. asunder. <B>Kor~iga</B>, heart-breaking. <B>Ne~igebla</B>, unpuncturable (<I>bendo</I>). ➞ <I>eksplod, korŝir, krak, fend-(split-)iĝ</I>.", "0"],
["kribaĝo", "kribaĝ-o", "(gm) cribbage.", "0"],
["kribri", "kribr-i", "[UV] Siev/e, sift; bolt, screen, winnow, separate by shakg. <I>~i farun -(gren-sabl-)on</I>. <B>f</B> (<I>senbalastigi), ~i la vortaron</I>, ~(ad)o, -ing. <B>~a</B>, cribriform. <B>~aĵo</B>, screen-(sift-)ings. <B>~iĝi</B>, f <I>La sun- radioj ~iĝis Jrafolie</I>. ~ilo, s., colander, jigger, f <I>Ĉerpi akvon per ~ilo</I> (P) <I>Gren~ilo</I>, riddle. ➞ <I>filtr</I>.", "0"],
["kriĉi", "kriĉ-i", ". <B>1</B> screech (as bird of prey). <B>2</B> chirr, stridulate (as insect).", "0"],
["krii", "kri-i", "[UV] Cry (out), Shout; call, make an outcry, utter a loud sound. <I>~i de doloro, plengorĝe. ~i \"Helpon/\". ~i por venĝo. Inter lupoj ~u lupe</I>. <B>~o</B>, c., loud utterance. <I>~o batala, koka</I>. ~anta (<I>protestinda) maljustaĵo</I>. ~aĉi, screech (<I>kriĉi</I>). <B>~ado</B>, acclamation, clamour. ~egi, s., bawl, howl, yell. <I>~egi ĝisraŭke</I>, s. one’s hoarse. ~ema, noisy, peevish, squalling. ~eti, grouse, squeal, whine. <B>ek~i</B>, [UV] exclaim. <I>Ek~a signo</I>, exclamation mark. El<B>~i</B>, proclaim. Bravo<B>~o</B>, applause, bravo! Dolor<B>~o</B>, scream. Ĝoj<B>~i</B>, s. with joy. Mok<B>~i</B>, boo, hoot. Plor<B>~i</B>, bewail, lament aloud. Post<B>~i</B>, call after. Pri<B>~i</B>, announce, hawk. <I>Pri~i gaze ton</I>. Ve<B>~ado</B>, lamentation. ➞ <I>blek, kriĉ, vok. [Ne= plori]</I>.", "0"],
["kriketo", "kriket-o", "(gm) cricket <I>[Ne= gril]</I>,", "0"],
["kriko", "krik-o", "(mec) Jack, lift. <I>~o hidraŭlika. Sraŭbo~o</I>, screw-j. ➞ <I>kapstan, vine, vindas</I>.", "0"],
["kriminala", "kriminal-a", "[UV] (<I>prikrima</I>), (jur) criminal. <I>~a juĝist-(jur-proces-)o</I>. ~isto. ~ologio.", "0"],
["krimo", "krim-o", "[UV] Crim/e, felony, offence punishable by law. <B>~a</B>, -inal, felonious, sinful, wicked. <I>~a far-(hom-)o</I>. <B>~i</B>, commit a c. <I>Tajloro ~is, botisto pendfrs</I>. <B>~eco</B>, -inality, iniquity. ~ego, atrocity, outrage. ~eto (<I>delikto</I>), delinquency, misdemeanour. ~igi (Mi 1/5). <B>~ulo</B>, -inal, felon, malefactor. Kon<B>~ulo</B>, accomplice. ➞ <I>kriminal, kulp, pek</I>.", "0"],
["kringo", "kring-o", "[UV] (col) twisted ring-shaped bun or biscuit. ➞ <I>kraken</I>.", "0"],
["krinolino", "krinolin-o", "(cl) (4 FA 216/34), crinoline, hooped petticoat,", "0"],
["kripla", "kripl-a", "[UV] Cripple/d, havg lost power to use member or organ, deformed, disabled, lame, maimed, stunted. <I>~a de al-(malsan-)o. ~a seĝo</I> (M 55/22). <B>~aĵo</B>, <B>~eco</B>, (<I>difekto, manko</I>), defect, infirmity, damaged member or part. <B>~igi</B> (<I>iun, ion</I>), c., disable, lame, maim, mutilate. <I>~~i soldaton</I>. <B>f</B> <I>~~i</I> (\"murder\") <I>la lingvon</I>. <B>~ulo</B>, c. <I>Ĉiu familio havas sian ~ulon</I>. ➞ <I>invalid, lez, stumpig</I>.", "0"],
["kripo", "krip-o", "(<I>staltrogo</I>), crib, manger.", "0"],
["kripta", "kript-a", "Crypt/ic, obscure, secret.", "0"],
["kripto", "kript-o", "[OA] (arch) crypt, underground cell, vault, usually for burial,", "0"],
["kriptogramo", "kriptogram-o", "parsley fern (<I>Cryptogramme</I>).", "0"],
["kriptomerio", "kriptomeri-o", "Japanese cedar (<I>Cryptomeria japonica</I>).", "0"],
["kriptono", "kripton-o", "(chem) crypton.", "0"],
["krisolo", "krisol-o", "crucible, melting-pot. ➞ <I>fanduj</I>.", "0"],
["krispo", "krisp-o", "[UV] Frill. <B>1</B> (anat) wattle. <B>2</B> (cl) -ed collar, collarette. <B>Kol~o</B>, f„ ruffle. <B>Tol~o</B>, <B>Tul~o</B>, ruche. <B>~a</B>, -ed, curly, crimped, crinkled, wavy, crisp (this sense only). <I>~aj folioj, plumoj</I> (Jes 3/24). <B>~a</B> <I>ŝtofo</I>. Creased, puckered (<I>papero</I>), frizzy, fuzzy, woolly (<I>haroj</I>). <B>~aĵo</B>, f., pucker. <B>~eco</B>, curliness, rippling. <B>~igi</B>, crimp, curl, wave. <I>~igi harojn, falbalon. Venteto ~igas la akvon</I>. <B>(Har)~igilo</B>, crimping-iron, crisp-iron, curling-tongs, hair-curler. <I>~igita falbalo</I>. <B>~iĝi</B>, become crinkled, f. (as a phot, plate). <I>La grenkampoj, ondoj ~iĝis</I>. <B>~ozo</B> (hort) crinkle, plant disease. ➞ <I>bukl, /aid, falbal, friz, ĵabot, mezenter, ondetiĝ. [Ne= facile rompebla]</I>.", "0"],
["kristalo", "kristal-o", "[UV]. <B>1</B> (chem) Crystal. <I>~o kuba, sukera</I>. <B>2</B> pure colour-less glass. <I>Kaliko el facetita ~o</I>. <B>Rok~o</B>, rock-c. (<I>~iĝinta kvarco</I>). <B>~(aĵ)o</B>, something clear, transparent. <B>~(ec)a</B>, -line, clear, <B>f</B> pellucid, sparkling. <I>~a akvo, vazo</I>. <B>~e</B> <I>pura, klara,</I> limpid, translucent. <B>~igi</B>, <B>~iĝi</B>, -ize. <B>f</B> = <I>koncentriĝi, rigidiĝi</I>. <B>~ografio</B>, -lography. <B>~ojda</B>, -loid.", "0"],
["kriterio", "kriteri-o", "<B>[OA]</B> (<I>prijuĝilo</I>), criterion, measure, rule, standard, touchstone.", "0"],
["kritiki", "kritik-i", "[UV] (<I>prijuĝi</I>), Critic/ize. h <B>1</B> appraise, discuss, examine and estimate, judge. <I>~i estas facile, fari malfacile</I>. <B>2</B> censure, find fault with. <B>~(em)a</B>, censorious, discriminating, exacting [<I>Ne = kriza]. ~a esploro</I>. <B>~(ad)o</B>, <B>~(aĵ)o</B>, -ism. <B>1</B> -al remarks, critique, evaluation, review. <I>~o filologia, justa, kompetenta, senpartia, severa</I>. <B>2</B> expression of disapproval, <I>Eĉ kontraŭ pastra prediko troviĝas ~o</I>. <B>~aĉi</B>, carp, cavil, quibble, split hairs. <B>~anto</B>, <B>~isto</B>, c., judge (of merit). <B>~ebla</B>, open to -ism. <B>Sen~a</B>, un-al. <B>Tro~ema</B>, captious, hyper-al. ➞ <I>ĉikan, mallaŭd, recenz</I>.", "0"],
["kritmo", "kritm-o", "(bot) rock samphire (<I>Crithmum</I>). ➞ <I>inul, salikorni</I>.", "0"],
["krizalido", "krizalid-o", "(ent) chrysalis (pupa). ➞ <I>kokon, imagin, larv, pup, raŭp</I>.", "0"],
["krizantemo,", "krizantem-o,", "[OA] Chrysanthemum, ox-eye daisy fam. &gt; corn marigold (C. <I>segetum</I>); feverfew (C. <I>parthenium); lekanto</I> which see ➞ <I>tanacet</I>.", "0"],
["krizo", "kriz-o", "[UV] Crisis, critical situation, decisive moment, emergency, period of danger or suspense, turning-point. <I>~o financa, komerca, morala, politika. ~o de malsano</I>. <B>~a</B>, of c., critical, dangerous, decisive. <I>[Ne= kritika]. ~a ago, epoko, situacio</I>. <B>~i</B>, be in a critical condition.", "0"],
["krizokalo", "krizokal-o", "(min) pinchbeck.", "0"],
["krizolito", "krizolit-o", "chrysolite = olivine (El 28/20).", "0"],
["krizomelo", "krizomel-o", "(<I>orskarabo</I>), leaf-eater beetle (<I>Chryso- mela) &gt;</I> Colorado beetle.", "0"],
["krizopo", "krizop-o", "(ent) golden-eye, green lace-wing (<I>Chrysopa</I>).", "0"],
["krizoprazo", "krizopraz-o", "chrysoprase, apple-green vrty of chalcedony.", "0"],
["krizosplenio", "krizospleni-o", "(bot) golden saxifrage.", "0"],
["Kroatujo, Kroatio", "Kroat-ujo, Kroatio", "HR.", "0"],
["kroĉeti", "kroĉet-i", "(<I>kroĉtriki</I>), crochet. <B>~aĵo</B>, c-work. <B>~ilo</B>, c-hook.", "0"],
["kroĉi", "kroĉ-i", "(<I>-n</I>), [UV] Hook; fasten, hitch, grapple, seize (on to). <I>~i bildon, ĉapelon, medalon. ~i vagonon al lokomotivo</I>. <B>~ilo</B>, h., (coat-hat-)peg, crook. <B>Buton~ilo</B>, button-h. <B>Haltiga ~ilo</B>, catch, pawl. <B>(Al)~iĝi</B>, catch in, cling (attach one’s; clutch, hang on) to, lay hold of. <I>~iĝi al iu, al io. Hedero ~iĝas al muro</I>. <B>De~i</B>, <B>Mal~i</B>, detach, un-h.(-fasten). <I>De~i veston. De~ita de la patrina jupo</I>. <B>Krur~i</B>, trip up. ➞ <I>kramp, kvaron, trik</I>.", "0"],
["kroketio", "kroketi-o", "(ich) sanderling (<I>Crocethia</I>).", "0"],
["kroketo", "kroket-o", "(sp) croquet,", "0"],
["krokizi", "krokiz-i", "<B>~o</B>, sketch, rough pen-drawing. ➞ <I>skiz</I>.", "0"],
["krokodilo", "krokodil-o", "[UV] Crocodile. <B>~a</B> <I>ledo</I>. <B>f</B> ~aj (<I>hipokritaj) larmoj</I>.", "0"],
["krokuso", "krokus-o", "Crocus. ➞ <I>safran</I>.", "0"],
["krom", "", "[UV] (prep) treats what follows as separate (apart, distinct) from, independent (without speaking) of, other things. It may mean: <B>1</B> (us. after a negative or a universal word) <I>EXCLUSION</I> (not including) (<I>= kun escepto de, esceptinte, ekster</I>); but, except, not counting, save. <I>Mi vidis neniun, ~ li. Mi akceptos nenion, ~ oro</I> (nothing but gold). <I>Via eseo estas perfekta, ~ unu frazo. Mi estos sola, krom se</I> (unless) <I>vi venos (=se vi ne venos). Ĉiu ~ li</I> (all but he) <I>forkuris. Li faris nenion ~ kanti</I> (nothing but sing, except singg). <B>2</B> <I>INCLUSION</I> (including) (<I>= aldone al, inkluzive de, ne nur … sed ankaŭ)’</I>. in addn to, besides, moreover, to boot. <I>Ŝi estas bela, kaj ~ tio tre riĉa. ~ Esperante, mi parolas (ankaŭ) France kaj Angle</I>. <B>~diri</B>, add. <B>~edzino</B>, <B>~virino</B>, concubine (Ge 22/24). ~informo, additional information. ~pago, bonus. ~linio (mus) leger line. ~seĝo, additional chair. ~signo (mus) accidental (see Ge 31/50; 2 Rĝ 5/17; Ne 2/12; Ps 18/31; Pr 2/24, 3/12).", "0"],
["kromata", "kromat-a", "chromatic (colour or sound), (mus) not in the diatonic scale. <I>~a akordo, intervalo, skalo</I>. ➞ <I>diaton, laŭgam</I>.", "0"],
["kromleĥo", "kromleĥ-o", "(arch) cromlech.", "0"],
["kromo", "krom-o", "(chem) Chrom/ium (Cr). <B>~a</B>, -e. <B>~flava</B>, -e yellow. <B>~ato</B>, -ate. <I>~atacido, -ic</I> acid. <I>~ata pigmento</I>, <B>~e</B>. <B>~ika</B>, chromic (salt). <B>~ito</B>, -ite (salt). <B>~oza</B>, -ous (salt). <B>Bi~ato</B>.", "0"],
["Kromofotografio, litografio, sfero, somo, tipio", "Kromo-fotografio, -litografio, -sfero, -somo, -tipio", "chromo-photography, etc.", "0"],
["kronika", "kronik-a", "(<I>longedaŭra, malakuta</I>), (med) chronic, inveterate, lingering. <I>~a kataro</I>.", "0"],
["kroniko", "kronik-o", "[UV] Chronicl/e, annals, continuous narrative (record, register) of events. (Bb) Chronicles. <B>~i</B>, c., record. <B>~isto</B>, -er.", "0"],
["krono", "kron-o", "[UV] Crown. <B>1</B> of monarch. ~o <I>de reĝ(in)o</I>. <B>2</B> regal power (Se 27/24): <I>Aspiri al la ~o. Posedaĵo de la ~o</I>. <B>3</B> similar obj: chaplet, diadem, wreath. <I>~o dorna, ora</I>. (astr) C. <B>f</B> distinction. <I>Brava virino estas ~o por sia edzo</I>. <B>4</B> coin. <B>~i</B>, c. <I>~i per floroj. ~i laŭreaton, reĝon. Sukceso ~is lian penadon</I>. <B>f</B> <I>montoj ~itaj de neĝo</I>. (drs) <I>~i pecon</I>. <B>~ado</B>, coronation, <B>~aĵo</B>, c-work, -ing point. <B>~eto</B>, coronet. <B>Ne~ita</B>, <B>Sen~a</B>, un-ed. <B>Glor~o</B> (<I>de sanktulo</I>), aureole, halo, nimbus. ➞ <I>girland, korol, nimb, rekompenc, tiar</I>.", "0"],
["kronografio", "krono-grafio", "(-LOGIO [OA], -METRO [OA], -metrio), Chrono-graphy(-logy-meter-metry).", "0"],
["kropo", "krop-o", "[UV] (birds), craw, crop, pouch, gullet (Le 1/16). <B>Post~o</B> (<I>maĉstomako</I>).", "0"],
["krotalo", "krotal-o", "(<I>sonserpento</I>), rattlesnake (<I>Crotalus</I>).", "0"],
["krotono", "kroton-o", "(bot) (<I>Crotori</I>). <B>~a</B>, -ic. <B>~oleo</B>, c-oil. ➞ <I>kaskaril</I>.", "0"],
["krozi", "kroz-i", "[UV] Cruis/e, rove over the sea, sail to and fro (for observation, pleasure, etc.). <B>~o</B>, c., <B>~jaĥto</B>, -ing yacht. <B>~ŝipo</B>, -er, ship adapted for -ing. ➞ <I>kruc</I>.", "0"],
["kruciferoj", "kruci-feroj", "(bot) cruciferae.", "0"],
["krucifikso", "krucifiks-o", "[OA] crucifix.", "0"],
["kruco", "kruc-o", "[UV] Cross. <B>1</B> instrument of crucifixation. <I>Morti sur la ~o</I>. <B>2</B> C. of Jesus, <B>f</B> <I>savita per la ~o (= la morto de J</I>). <B>3</B> symbol of this, <I>~o sur preĝeja turo. Signo de la ~o. Porti ~on sur la vesto</I>. <B>4</B> (figure or obj), <I>desegni ~on. La Ruĝa ~o</I>. (astr) <I>La Suda ~o</I>. <B>Turn~o</B>, turn-pike (-stile). <B>5</B> affliction, trial, trouble (to be borne, endured). <I>Oni akceptu kaj portu sian ~on. La ortografio prezentas ~on por la lernanto</I>. <B>~i</B> (<I>trastreki</I>), write a c., draw a line across. <I>~i ĉekon</I>. <B>~(ir)i</B> (<I>transiri, transkuri</I>), c., intersect, traverse. <I>~~i riveron</I>. <B>~a</B>, crucial. <B>~(form)a</B>, crossform, cruciform. <B>(Laŭ)~e</B>, -wise. <I>~e nuligi</I>, c. out. <B>~aĵo</B>, intersection, -ing. <B>~igi</B>, c. fold, place c-wise. <I>~igi la brakojn, krurojn</I>. <B>(Inter)~iĝi</B>, c., interlace (intersect). <I>Leteroj, linioj, rasoj, stratoj ~iĝas</I>. (mus) <I>~iĝo de voĉoj</I>, -ing of parts. <B>Voj~ejo</B><I>,</I> <B>~iĝo</B>, c-roads, road-ing. <I>~iĝo ponta,</I> fly-over. <I>~iĝo rondira</I>, roundabout. <I>Inter~iĝa punkto</I>, point of intersection. <B>~umi</B>, [UV] crucify, (mus) <I>Ludi ~mane</I>, with hands -ed. <I>~milito</I>, crusade. <B>~osigni</B>, make the sign of the c. ➞ <I>interŝanĝ, loksi, pretersalt, trans(ir</I>).", "0"],
["kruĉo", "kruĉ-o", "[UV] Jug, cruse, ewer, pitcher, pot, vessel (Ge 24/46; 1 Rĝ 17/12). <B>~eto</B>, small j. <B>Kaf~o</B>, <B>te~o</B>, [UV] coffee-pot, tea-pot. <B>Trink~o</B>, mug, tankard.", "0"],
["kruda", "krud-a", "[UV] crude. <B>1</B> in natural (primitive, raw) state: Nugget (<I>oro</I>); rough-hewn (<I>ligno</I>); unbleached, beige (<I>lano</I>), uncooked (<I>frukto, viando</I>); uncut (<I>diamanto</I>); undressed, unwrought (<I>ledo, fero, silko</I>), unrefined (<I>sukero</I>); virgin (<I>tero</I>). <B>2</B> blunt, boorish, coarse, rough, gross, harsh, primitive, rough, rude, uncouth, vulgar: <I>~a ago, karaktero, kontrasto, parolo, respond, stilo, vetero, vorto</I>, garish (<I>lumo</I>); gaudy (<I>koloro). ~a edzo</I> (If 6/11). <I>~a forto</I>, brute strength. <B>~e</B>, roughly. <I>Ne tro multe, ne tro ~e!</I> <B>~aĵo</B>, raw material. <B>~eco</B>, crudity. <B>~ulo</B>, boor, churl, clodhopper, lout. ➞ <I>maldelikat, malelegant, malĝentil, senkultur, nekuirit, nepolurit, neprilaborit</I>.", "0"],
["kruela", "kruel-a", "[UV] cruel. <B>1</B> indifferent to another’s pain, brutal, inhuman, relentless, ruthless, sadistic, unfeeling. <I>~a ago, besto, eksperimento, knabo, koro. ~a glavo</I> (Ge 49/5). <B>2</B> painful, bitter, cold, distressing, fell, hard, severe, sharp. <I>~a doloro, laboro, morto, perdo, sorto, sperto, vetero</I>. <B>~aĵo</B>, <B>~eco</B>, cruelty. <B>~ega</B>, atrocious, barbarious, ferocious, savage. <B>~ulo</B>, brute. ➞ <I>brut, sovaĝ, suferig, turment</I>.", "0"],
["krumpeto", "krumpet-o", "(cul) crumpet.", "0"],
["krupiero", "krupier-o", "croupier.", "0"],
["krupo", "krup-o", "[UV] (<I>diftera laringito</I>), croup. <B>~a</B>, -ous, -y.", "0"],
["kruro", "krur-o", "[UV] <B>1</B> Leg (of man or animal). <I>Homo havas du ~ojn, hundo kvar. Fidi al la propraj ~oj. Kun ~oj dismetitaj</I> (spread). <B>2</B> 1eg of table, chair, etc. (us. <I>piedo</I>), 1eg; 1. of compasses. <B>~a</B>, crural, 1. <B>~ingo</B>, leggings. <B>~umo</B>, 1eg of trousers or boot. <B>Inter~igi</B>, bestride, straddle. <B>Kurb~a</B>, bandy-legged, bow-legged, knock-kneed, wobbly. <B>Unu~a</B>, one-legged. ➞ <I>femur, pied, tibi</I>. <B>Rim</B>.: The \"leg\" of a table is <I>piedo</I>.", "0"],
["krusto", "krust-o", "[UV] Crust, hard outer covering, casing, coating, deposit (on surface of something), scale, rind (<I>larda</I>), scab (<I>vunda), Kalka ~o</I>, fur (<I>bolilo). Pan~o</I>, c. of bread. -y, crisp. <B>~eca</B>, -aceous. <B>~aĵo</B>, (pie)-c. <I>En~aĵo</I> (Alt 1/11). <B>~eto</B>, scurf (<I>haŭta</I>). (cul) crisp. <I>Terpoma ~eto</I>. <B>~iĝi</B>, cake. <B>~ecoj</B>, <B>~uloj</B>, -aceans. ➞ <I>inkrust, karapac, kiras, ŝel</I>.", "0"],
["kruta", "krut-a", "[UV] steep, abrupt, sheer. <I>~a bordo, insulo, klifo, monto, ŝtuparo, vojo. ~a valo (ravino</I>). <B>~e</B> <I>dekliva</I>. <B>~i</B> (<I>stari ~e). La roko subite ~is</I>. <B>~aĵo</B>, bluff, cliff, escarpment, steep (Mi 1/4). <B>~ega</B>, precipitous. <I>~egaĵo</I>, precipice, towering peak. <B>Inter~aĵo</B>, gorge. <B>Inter~ejo</B>, defile. <B>Mal~a</B>, gentle (in slope). ➞ <I>abrupt, dekliv, klif, perpendikl, ravin</I>.", "0"],
["ksifio", "ksifi-o", "(<I>glava fiŝo</I>), sword-fish (<I>Xiphias</I>).", "0"],
["ksilofono", "ksilofon-o", "[OA] (m.i.) xylophone (<I>moderna ligna marimbo</I>).", "0"],
["ksilografio", "ksilografi-o", "wood engraving.", "0"],
["kubebo", "kubeb-o", "Cubeb, berry of <B>~arbusto</B>, c-shrub (<I>Piper eubeba</I>).", "0"],
["kubo", "kub-o", "[UV] Cub/e. <B>1</B> (geom) solid contained by six squares. <I>~o de sukero</I>. <B>2</B> (sp) <I>Lud~o, ĵet~o,</I> <B>~eto</B>, die. <I>La ~oj jam falis</I>. <B>3</B> (mat) 3rd power. <I>La ~o de</I> 2 = 8. <I>La ~radiko de 8 estas 2</I>. <B>~a</B>, -ic(al). ~a <I>futo, mezuro. ~a ekvacio</I>. <B>~ismo</B>, <B>~isto</B>, <B>~forma</B>.", "0"],
["Kubo", "Kub-o", "[OA-8] CU.", "0"],
["kubuto", "kubut-o", "[UV] (anat) Elbow. <I>Sin apogi sur la ~oj. Apogi la ~ojn sur la tablo. Proksima <B>~o</B>, sed ne por la buŝo (P</I>). <B>~a</B>, cubital. <B>~(um)i</B>, e. (unu la alian). ➞ uln.", "0"],
["kudri", "kudr-i", "(<I>-n, abs</I>), [UV] Sew, stitch, tack, work with needle and thread. <I>~i butontruon, katunon, tolon</I>. <B>~ado</B>, <B>~aĵo</B>, -ing, needlework. <B>~ejo</B>, -ing room. <B>~ero</B>, stitch. <B>~ilo</B>, needle. <I>~ilego</I>, bodkin, <I>~ilujo,</I> needle-case. <B>En~iligi</B> (<I>tredi) fadenon,</I> thread a needle. <B>Drat~ilo</B>, wire stapler. <B>~~ita</B>, wire-sewn. <B>~istino</B>, sempstress. <B>~omaŝino</B>, -ing machine. <B>ĉirkaŭ~i</B>, border, hem. <B>Duon~i</B>, tack. <B>Kruc~i</B>, cross-stitch. <B>Kun~o</B>, seam, (surg) suture. <B>Mal~i</B>, unsew, rip up. <B>Sur~i</B> (<I>butonon</I>), sew on. ➞ <I>brod, flik, orl, steb, tred. KUDREROJ:</I> <B>Ĉena</B>, chain. <B>Faska</B>, faggot. <B>Fiŝosta</B>, herring-bone. <B>Galopa</B> (<B>kura</B>), running. <B>Muŝpaŝa</B>, cockspur. <B>Petala</B>, petal. <B>Pleniga</B>, basket, filling. <B>Ronda</B>, <B>binda</B>, blanket, button-hole. <B>Retro(ir)a</B>, back.", "0"],
["kufo", "kuf-o", "[UV] coif, simple head-dress (bonnet, wimple) for woman. <I>Papera ~o</I>, paper cap. (obsolete) <I>Feta ~o</I>, caul.", "0"],
["kuglo", "kugl-o", "[UV] Bullet, Shot. <I>~o fajrostreka (spura</I>), tracer b. <B>Rul~o</B>, ball-bearing. <B>~aĵo</B>, s., projectile. (<I>Hajl)~aĵo</I>, grape-s. <B>~ego</B>, cannonball. <B>~eto</B>, small s., pellet. <I>~etaĵo</I>, buck-s. <B>Sen~a</B>, blank. ➞ <I>kegl, paf</I>.", "0"],
["kuiro", "kuir-o", "(<I>-n</I>), [UV] Cook, dress food (El 16/23). <I>~i terpomojn</I>, <B>~(ej)a</B>, culinary. <I>~a forno (fornelo</I>), -ing stove. <B>~ado</B>, <B>~arto</B>, -ing, cuisine. <I>Vapora ~ado</I>. <B>~aĵo</B>, -ed food (Ge 25/29). <B>~ejo</B>, [UV] kitchen. <I>~eja recepto</I>. <B>~ilo</B>, -ing utensil, -er, -pot, etc. <B>~ist(in)o</B>, c. <I>Ĉef~isto</I>, chef. <B>~ita</B>, done. <I>Ne~ita</I>, raw. (Mal)mole <I>~ita</I> (ovo), soft (hard)-boiled. ➞ <I>bak, bolig, frit, stuf</I>.", "0"],
["kuko", "kuk-o", "[UV] Cake (Ge 18/6). <I>Tablon ornamas ne tuko, sed kuko. ~o figa, sponga, tavola</I>. <B>Pat~o</B> (<I>krespo</I>), pan-c. <B>Plat~o</B>, girdle-c (Ho 7/8). <B>Riz~o</B>, rice-c. <B>Miel~o</B>, <B>spic~o</B>, gingerbread. <B>~aĵo</B>, fancy-c., pastry. <B>~isto</B>, pastry-cook. <B>~ejo</B>, c-shop. <B>~eto</B> <I>sekvinbera</I> (1 Sa 30/12).", "0"],
["kukolo", "kukol-o", "[UV] Cuckoo (<I>Cuculus</I>).", "0"],
["kukui", "kuku-i", "call cuckoo.", "0"],
["kukumo", "kukum-o", "[UV] cucumber (<I>Cucumis</I>). <B>~eto</B>, gherkin. <I>~a kampo</I> (Jes 1/8).", "0"],
["kukurbo", "kukurb-o", "[UV] Gourd, Pumpkin, (Am) Squash (<I>Cucurbita). C. maxima</I> is the garden-plant red and yellow gourd (American \"summer s.\"). <B>Medol~o</B>, vegetable marrow (C. <I>pepo</I>). <B>~acoj</B>, cucurbitaceae. ➞ <I>citrol, kolocint, kukum, melon</I>.", "0"],
["kulaso", "kulas-o", "Breech (of gun, rifle). <B>~bloko</B>, b-block. <B>~riglilo</B>, b-bolt.", "0"],
["kulero", "kuler-o", "[UV] Spoon. <I>~o arĝenta, ligna. Kaf~o, ov~o, sal~o, sup~o, te~o. ~o (da</I>), spoonful. <B>~ego</B>, ladle, scoop. ➞ <I>platale</I>.", "0"],
["kulio", "kuli-o", "coolie, native Chinese or Indian hired labourer.", "0"],
["kuliso", "kulis-o", "[OA] (th) slip, wing. <I>Post la ~oj,</I> behind the scenes, secretly. <I>~a timo,</I> funk, stage-fright. <B>~(ŝov)isto</B>, scene-shifter.", "0"],
["kulmini", "kulmin-i", "(nt) (<I>atingi sian ~on, esti ĉe la ~o</I>), Culmin/ate, reach its highest point, (astr) be on the meridian. <B>~o</B>, -ation. <B>1</B> topmost point of standing object. <I>~o de arbo, domo, monto</I>. <B>2</B> highest degree, acme, climax. <I>~o de ekscito, emocio, entuziasmo, gloro</I>. <B>~a</B>, -ating, -ant. <I>~a punkto, momento</I>. ➞ <I>apoge, klimaks, krest, supr, vert, zenit</I>.", "0"],
["kulmo", "kulm-o", "(bot) culm, stem (of grass or sedge). <B>Sen~igi</B>, clear of stubble. ➞ <I>ŝalm</I>.", "0"],
["kulo", "kul-o", "[UV] gnat (<I>Culex pipiens). Morti kiel ~oj</I> (Jes 51/6). <I>~piko, ~vualo</I>. <B>~eto</B>, midge. ➞ <I>kironom, moskit</I>.", "0"],
["kulombo", "kulomb-o", "(el) coulomb.", "0"],
["kuloto", "kulot-o", "(<I>genua pantalono</I>), (cl) (pair of) knee-breeches, knickerbockers. <I>Meti infanon en ~on</I>, breech, (fem) knickers. <B>Fel~o</B>, buckskins. <B>Kamizol~o</B>, <B>kombin~o</B>, camiknickers. <B>Sport~o</B>, shorts. ➞ <I>pantalon</I>.", "0"],
["kulpa", "kulp-a", "(<I>je, pri, pro</I>), [UV] Guilt/y, culpable, remiss; reprehensible, to blame, wrong. <I>~a aspekto, konduto, konscienco</I>. <B>~o</B>, guilt, blame, fault, offence (Jes 44/22). <I>La ~o estas via</I>, it is your fault. <I>Ne metu (ĵetu) la ~on sur min</I>. Don’t blame me. <B>~i</B>, be -y. <I>~i pri ŝtelo</I>. <B>~eco</B>, blameworthiness, remissness. <B>~okonscia</B>, conscious of guilt. <B>~igi</B>, accuse of, blame for, charge with, impeach (➞ <I>akuz). Sin ~igi</I>, blame one’s. <B>~iĝi</B> (Ho 4/15). <B>~ulo</B>, culprit, delinquent, offender. <B>Kun~ulo</B> (<I>komplico</I>), accomplice. <B>Sen~a</B>, -less, innocent. <I>Verŝi sen~an sangon</I>. <B>Sen~igi</B>, acquit, excuplate, excuse, exonerate. ➞ <I>absolv, ekskuz</I>. <B>Sen~igo</B><I>,</I> excuse, apology. ➞ <I>delikt, krim, pek, riproĉ</I>.", "0"],
["kultivi", "kultiv-i", "Cultiv/ate. <B>1</B> till, prepare for crops (➞ <I>plug). ~i grundon, ĝardenon, kampon, teron</I>. <B>~o</B> <I>de la tero. ~o alterna (ŝanĝ~ado</I>), rotation of crops. <I>Arbo~o, frukto~o, pom~o</I>, arboriculture, etc. <B>Ter~o</B>, agriculture, husbandry, tillage (1 Kr 27/26). <I>Ter~a laboro</I> (Ge 9/20). <B>~ado</B>, -ation. <B>~ejo</B>, <B>~ilo</B>, -ator. (Ter) <B>~isto</B>, husbandman (Ze 13/5, Jn 15/1). <I>Vinber~isto</I>, (J1 1/11), vinedresser, <B>~otaĵo</B> (1 Ko 3/9). <B>Ne~ita</B>, un-ated, fallow, untilled. <B>Sen~ejo</B>, fallow ground. <B>2</B> Grow, raise, rear, improve, by husbandry. <I>~i florojn, legomojn; abelojn, fiŝojn, ostrojn; sikomorojn</I> (Am 7/14). ➞ <I>bred, kreskig, kultur, prilabor</I>.", "0"],
["kulto", "kult-o", "[OA] Cult. <B>1</B> system or mode of worship. <I>Ministro pri ~oj</I>, Minister for Public Worship. <B>2</B> devotion, homage, to thing or person. <I>~o al la belo</I>. <B>~i</B> (<I>al</I>), make a c. of, idolize, venerate. ➞ <I>ador, konfesi, omaĝ, religi, rit</I>.", "0"],
["kulturo", "kultur-o", "[OA] Cultur/e, (level of) civilization, education, refinement, training. <I>~o antikva, Eŭropa, fizika, Kristana</I>. <B>~i</B>, develop, discipline, elevate, improve, raise the level of (by education, traing). <I>~i arton, cerbon, memoron, menson, moralon. ~i filozofan sintenon, la muskolojn</I>. <B>~a</B>, of c., -al, intellectual, <I>~a popolo</I>. <B>~aĵo</B> (Se 21/4). <B>~eco</B>, refinement. <B>Sen~a</B>, un-ed (➞ <I>krud, malkler, sovaĝ</I>). ➞ <I>civiliz, eduk, klerig, kult, nutr</I>. <B>Rim</B>.: <I>Kultur-</I> is mental, moral, personal, artistic; <I>civiliz-</I> is also material, economic, social. <B>Rim</B>.: Before Z introduced <I>kultiv-</I> (frequent throughout Bb) <I>kultur-</I> took both meanings of <I>kultiv-</I>.", "0"],
["kulverto", "kulvert-o", "(eng) culvert, covered drain, water-channel under road, etc.", "0"],
["kumino", "kumin-o", "[OA] cum(m)in (Jes 28/25, 27) (<I>Cummin</I>).", "0"],
["kumiso", "kumis-o", "koumiss, fermented liquor from mare’s milk.", "0"],
["kumuluso", "kumulus-o", "(met) Cumulus, woolpack, rounded cloud-masses, thick cloud with well-defined protuberances. <B>Ciro~o</B>, cirro-c., mackerel sky. <B>Alto~o</B>. <B>Strato~o</B>.", "0"],
["kun", "", "[UV] (prep) along (in company, together) With <I>[Ne~~per, by means of]</I>. <B>1</B> (Place): <I>Esti, manĝi, vivi kun iu</I>. <B>2</B> (Time): Together with. <I>Li mortis ~ sia viktimo</I>. <B>3</B> in conjunction (common) with: <I>Diskuti, edziĝi, ludi, paroli ~ iu. Kompari, kontrasti, rilati ~ io</I>. <B>4</B> (possession): <I>Viro ~ ruĝa nazo. Agi ~ saĝo. Fermi pordon ~ bruo. Homo ~ gusto</I>, man of taste. <B>5</B> (relation) (us. better <I>al, el, pri, kontraŭ): Faru ~ mi kion vi volas. ~ (ĉe</I>) (in the case of) <I>arbo estas alia afero</I> (4 FA 5/6). <B>~a</B>, combined, concerted, joint. <I>~a laboro</I>. <B>~e</B>, [UV] in concert jointly, together, unitedly. <I>Ni kantu ~e! Ataki, iri, labori, paroli, vojaĝi ~e. Ĉiuj ~e!</I> All together! <I>Venu ~e kun</I> (along with, together with) <I>mi</I>. <B>~igi</B>, couple, connect, join, unite. <I>~igi</I> (knit) <I>la brovojn</I>. ➞ <I>cement, kunlig, unuig. ~iga</I>, connective. <B>~iĝi</B>, coalesce, combine, come together, join, unite. <I>~iĝemo</I>, affinity, mutual attraction. <B>~ulo</B>, associate, companion, mate. <I>~ularo</I>, circle company. <I>Lit~ulo</I>, bedfellow. ➞ <I>kamarad, koleg</I>. <B>Mal~e</B>, separately. <B>Ne~igema</B> (<B>~igebla</B>), incompatible, incongruous. <I>PREFIKSE</I> (with above meanings). <B>1</B> <I>~ligi, ~meti, ~porti, ~preni, ~sidi, ~veni</I>. <B>2</B> <I>~ekzisti</I>, -co-exist. <B>3</B> <I>~batali, ~labori, ~militi, ~verki</I>. <B>~agado</B>, united action. <B>~regado</B>, condominium. <I>~lernanto, ~vojaĝanto</I>, fellow-student, fellow-traveller. ➞ <I>ĉe, per, sam</I>.", "0"],
["kuniklo", "kunikl-o", "[UV] Rabbit (<I>Cuniculus</I>). <B>~ejo</B>, r-warren. <B>~eto</B>, kunĉjo, bunny. <B>~ido</B>, young rabbit. <B>~ino</B>, doe-r. <B>Vir~o</B>, buck r. ➞ <I>hirak, kavi, lepor</I>.", "0"],
["kuo", "ku-o", "[OA 9], name of letter Q.", "0"],
["kupeo", "kupe-o", "[OA] (ry) Compartment, separate part of car or carriage. <I>~o por fumantoj, sinjorinoj</I>, smoking-c, ladies’ c. <I>Dorm~o</I>, sleeper.", "0"],
["kupli", "kupl-i", "(<I>iri</I>) (tech, el), Coupl/e, unite parts of machinery or elements for common function, connect, fasten (link) together, join up, e.g., ry carriages. <B>~(ad)o</B>, -ing. <I>~o galvana, indukta, kapacita, rigida, variigebla</I>. <B>~ilo</B>, coupler, (org) -er (connecting manuals, pedals), e.g., <I>~ilo okta, ŝvelokta, ŝvel-al-ĉefa</I>. <B>Mal~i</B>, un-c. <B>Ne~ita</B> (rado), free. <B>Ĉen~ado</B>, chain-ing. ➞ <I>kluĉ, komut, konekt, kontakt, kunig, kunig</I>.", "0"],
["kupo", "kup-o", "[UV] (surg) cupping-glass. <B>~i</B>, cup, bleed. [<I>Ne = taso</I>].", "0"],
["kupolo", "kupol-o", "[UV] (arch) cupola, dome (2 FA 90/3), e.g., over roof. ➞ <I>kloŝ</I>.", "0"],
["kupono", "kupon-o", "[OA] Coupon, ticket, warrant, etc. entitling holder to payment, seat, service, etc. <I>Dividend~o, pan~o. Respond~o</I>, reply-c.", "0"],
["kupro", "kupr-o", "[UV] Copper (Cu) <I>[Ne= kuvo]</I>. <B>flava ~o</B> [UV] (<I>latuno</I>), brass alloy of c. and zinc. ➞ <I>bronz</I>. <B>~a</B> <I>mon(er)o,</I> c-coin. <B>~(iz)i</B>, c. <B>~isto</B>, c-smith. <B>~ika</B>, cupric. <I>~(ik)a sulfato</I>, blue vitriol. <B>~oza</B>, cuprous.", "0"],
["kuraci", "kurac-i", "(<I>-n</I>), [UV] (med) Treat (medically), apply remedies, attend (patient), doctor (Pr 3/3). <B>f</B> <I>Ŝuldon tempo ne ~as [Ne= sanigi]</I>. <B>~a</B>, curative, medical, remedial. <B>~(ad)o</B>, (course of) treatment. <I>Akvo~ado (hidroterapio). Ripoz~o</I>, rest cure. <B>~ato</B>, case, patient. <B>~ejo</B>, <B>~loko</B>, health resort, nursing home, sanatorium. <B>~ilo</B>, [UV] means of treatment, remedy, <B>~isto</B>, doctor, physician. <I>Best~isto (veterinario</I>), veterinary surgeon. <I>~istaro</I>, medical profession. <B>~arto</B>, medicinal art, therapeutics. <B>Ne~ebla</B>, not amenable to treatment, incurable. ➞ <I>diet, doktor, medicin, medikament, (re)sanig</I>.", "0"],
["kuraĝa", "kuraĝ-a", "[UV] Courage/ous, bold, brave, dauntless, fearless, intrepid, plucky, lion- hearted. <I>~a ago, entrepreno, homo, parolo</I>. <B>~(ec)o</B>, c., audacity, boldness, bravery, fortitude, mettle, pluck, spirit, valour. <I>Doni, havi, montri, perdi ~on</I>. <B>~e!</B> <B>~on!</B> Have c! <B>~e</B> <I>batali</I>. <B>~i</B> (nt) (<I>havi ~on</I>), be bold enough (to), dare, venture. <I>Kiu ~as tion fari?</I> <B>~ega</B>, audacious, daring, heroic, intrepid. <B>~igi</B>, en-c, cheer on, hearten, inspire (Jes 41/7). <B>~iĝi</B>, pluck up c. (Da 10/19). <B>~ulo</B>, brave man. <B>~oplena</B>, high-spirited, mettlesome, undismayed. <B>Mal~a</B>, cowardly, craven, fearful, pusillanimous, white-livered. <B>Ne~a</B>, nervous, timid, timorous. <B>Sen~a</B>, despondent, faint-hearted, spiritless. <B>Sen~igi</B>, dis-c. <B>Nesen~igebla</B>, indomitable. ➞ <I>aŭdac, brav, hero, sentim</I>.", "0"],
["kuraro", "kurar-o", "(chem) curare.", "0"],
["kuratoro", "kurator-o", "[UV] <B>1</B> (jur) Guardian, trustee, person in charge of (appointed to look after) person or property of another. <B>2</B> Curator, custodian, keeper, superintendent. <I>~o de biblioteko, muzeo</I>. <B>~eco</B>, g-ship, tutelage. <B>~ino</B>, curatrix.", "0"],
["kurbo", "kurb-o", "[UV] Curv/e, -ature, arc, bend, camber, turn. <I>~o hufoforma</I>, horseshoe bend. <I>~o returna</I>, reversing or terminal loop. <B>~a</B>, -ed, bandy, bow, tortuous, winding. <I>~a bastono</I>, crook(ed stick). <I>~a linio</I>, -ed line, <B>~eco</B> (-ature) <I>de arko, sfero, volbo</I>. <B>~igi</B>, <B>~iĝi</B>, c., arch, bend, turn, warp. <I>~igi kanon</I>. <B>~iĝo</B>, turning. <I>~iĝo de rivero, vojo</I>, detour, meandering. <B>~iĝema</B>, sinuous. <B>Sen~igi</B>, flatten out, straighten, true. <B>Probablo~o</B>, probability c.", "0"],
["kurento", "kurent-o", "(<I>elektra fluo</I>), Current. <I>~o alterna, elektrona, jona, kirla, kondukta, kontinua, konvekta, magnetiga, polariga, unudirekta</I>. alternating (electronic, ionic, eddy, conductor, continuous, convection, magnetizing, polarization, unidirectional) current. <I>Rompi la ~on</I>.", "0"],
["kuri", "kur-i", "(nt), [UV] Run (from place to place), hasten, hurry, race, scamper, scurry. <B>1</B> (<I>iu) ~i al la domo, el la ĉambro</I>. <B>f</B> <I>en danĝeron</I>. <B>2</B> (<I>io</I>) move quickly. <I>Nuboj ~as sur la ĉielo</I>. <B>f</B> <I>~as flamoj, larmoj</I>. <B>3</B> go (flow, move, roll) on without a break. <I>Ruĝa fadeno ~as tra la ŝtofo. ~as fervojo, rivero, vojo</I>. <B>~(ad)o</B>, run(ning), course, race. <I>La ~o de la tempo. Ĉeval~ado,</I> horse-racing. <B>~a</B>, running. <I>Akvo kura, akvo pura</I> (P). <B>~e</B>, at a run. <B>~anta</B>, current. <I>~anta jaro, konto, monato, prezo</I>. <B>~egi</B>, career (rush, scud, tear) along. <I>~egado (stampedo</I>), stampede, wild rush. <B>~ege</B>, at full speed, headlong, with a rush. <B>~igi</B>, make r., chase. <B>Dis~i</B>, run in all directions. <B>Dis~igi</B>, rout. <B>~isto</B>, -ner, courier (Ij 9/25). <B>Ek~i</B>, dash, start. <B>For~i</B> <I>de, el</I> (Ge 39/13), run away, decamp, elope, flee, make off. <I>For~i de kreditoro, el malliberejo</I>. ➞ <I>dizert. For~igi</I>, drive away, put to flight. <I>For~into</I>, fugitive, runaway. <B>Laŭ~i</B>, run along, border. <B>Post~i</B>, chase, follow, pursue, run after. <B>Preter~i</B>, out-run, out-strip. <B>Tra~i</B> <I>animon, koron, urbon</I>. <B>Trans~i</B>, pass over. <I>Rideto trans~is lian vizaĝon</I>. <B>Rond~o</B> (<I>hejmpilko</I>), (sp) rounders. <B>Sak~o</B>, sack-race. <B>Vel~ado</B>, sailing regatta. <B>Vet~i</B>, r. for wager, race. ➞ <I>flu, flug, ir, konkur, kurz, rulad</I>.", "0"],
["kuriero", "kurier-o", "[UV] courier, messenger, runner (Ob/1, Es 3/13). (On the continent, person making travel arrangements). <I>~o de morto. Reĝa ~o</I>, King’s messenger, (chs) bishop. ➞ <I>ekspres, herold, leterportist</I>.", "0"],
["kurio", "kuri-o", "curia. <B>1</B> (hist) family group. <B>2</B> division of tribe. <B>3</B>, <B>4</B> senate, senate house. <B>5</B> papal court. ➞ <I>kare</I>.", "0"],
["kurioza", "kurioz-a", "[OA] Curio/us, interesting, odd, out of the way, queer, singular, strange <I>[Ne= scivolema</I>]. <I>~a insekto, horloĝo, rakonto, spektaklo</I>. <B>~aĵo</B>, -sity, curio, singularity. <I>~aĵejo</I>, -sity shop. ➞ <I>Strang</I>.", "0"],
["kuriumo", "kurium-o", "(chem) curium (Cm).", "0"],
["kurkulio", "kurkuli-o", "(<I>bekskarabo</I>), weevil (<I>Cureulio</I>).", "0"],
["kurkumo", "kurkum-o", "(<I>Curcuma</I>). <B>1</B> turmeric. <B>2</B> condiment or dye from its root.", "0"],
["kurlingo", "kurling-o", "(sp) curling, Scottish game on ice.", "0"],
["kursiva", "kursiv-a", "[OA] (<I>klinita</I>), (cal) cursive, slanting. <I>~a skribo</I>, running hand, (typ) Italic. <I>~e presita</I>, in italics. <B>~igi</B>, -ize.", "0"],
["kurso", "kurs-o", "<B>[OA], 1</B> Course (of instruction), series of lessons. <I>Poŝta ~o, ~o pri Esp</I>. <B>Sam~ano</B>, class-mate, fellow-student. <B>2</B> course (<I>vojiro, vojdirekto</I>). ➞ <I>kurz</I> [Ne konfuzu kun <I>klaso</I>],", "0"],
["kurta", "", "= mallonga. <I>~ondoj</I>.", "0"],
["kurtaĝo", "kurtaĝ-o", "(<I>maklera pago</I>), brokerage. ➞ <I>diskont, makler, procent</I>.", "0"],
["kurteno", "kurten-o", "[UV] Curtain, screen, veil. <I>~oj de la fenestro. La ~o en la tabernaklo</I> (Le 24/3). <I>Fermtiri, levi la ~on</I>. <B>f</B> <I>~o el fumo</I>. (pol) <B>Fera K~o</B>. <B>flank~o</B>, [UV] side c. <B>Lat~o</B>, Venetian blind (wooden slats or webbing which can be turned to admit or exclude light). <B>Lit~o</B>, bed-c. <B>Pord~o</B>, door-c. <B>rul~o</B>, [UV] roller-blind. <B>Sun~o</B>, s-blind. <B>~a</B> <I>prediko (litadmono</I>) [ark], c-lecture, wife’s bed-time lecture to husband. <I>~a vergo</I>, c-rod.", "0"],
["kuruko", "kuruk-o", "lesser whitethroat (<I>Silvia eurruca</I>). ➞ <I>silvi</I>.", "0"],
["kurzo", "kurz-o", "(fin) rate (of exchange). <I>Borsa</I> <B>~o</B>, rate on ‘change. <B>~altiĝo</B>, rise. <B>~falo</B>, fall. <B>En~a</B>, (phlt) current. <B>El~igi</B>, withdraw from circulation.", "0"],
["kuseno", "kusen-o", "[UV] Cushion. ~o <I>hara, lanuga, pluma. ~o bilarda. Konscienco senmakula estas ~o plej mola</I>. <B>Aer~o</B>, air-c. <B>Genu~o</B>, <B>pied~o</B>, hassock. <B>Ink~o</B> (<B>stamp~o</B>), ink pad. <B>Kap~o</B>, pillow. <B>Sub~o</B>, bolster. <I>~a tego, ~ujo</I>, pillow-case(-slip). <B>~ego</B>, [UV] large or eider-down c.", "0"],
["kusineto", "kusinet-o", "(mec) bearing.", "0"],
["kuskuto", "kuskut-o", "(bot) dodder (<I>Cuseuta</I>).", "0"],
["kuspo", "kusp-o", "(arch, geom) cusp, horn, peak, tooth, sharp pointed end or prominence. <I>~o de folio, krescento</I>. <B>~a</B>, cusp(id)ate, acute, pointed, sharp.", "0"],
["kustardo", "kustard-o", "(<I>laktovaĵo, ovkremaĵo</I>), (cul) custard. <I>~a pulvoro</I>.", "0"],
["kuŝi", "kuŝ-i", "(nt),, [UV] lie [Ne= mensogi], <B>1</B> (<I>iu</I>) be in horizontal (prostrate, recumbent) position: <B>~i</B> <I>en (sur) lito, sur la tero</I>. <B>2</B> (<I>io</I>) be (laid, placed) on a surface: e.g.<I>, botelo sur tablo, mato sur planko</I>. <B>3</B> (<I>situi</I>) be located (situated), rest, remain: e.g., <I>nebulo sur valo; rideto sur vizaĝo. Kio min ne tuŝas, ~u kiel ~as!</I> (P). <I>Lia merito ~as</I> (konsistas) en <I>tio, ke …</I> <B>~</B><I><B>ado</B> (Se 24/33). <B>~(ant)a</B>, couchant, prone, <B>~ejo</B>, bed, berth, couch, lair, resting-place, (geol) bed. <B>~ema</B>, lolling, lounging</I>. <B>~emulo</B>, <I>lie-abed, sluggard, <B>~igi</B>, lay. ~igi infanon sur lito. <B>~igi</B>, lie down, go to bed (Ru 3/4), set</I> (<I>suno</I>). <I>~<B>ujo</B>, bed (of river, sea) (Ps 18/15). <B>Duon~i</B>, recline, sprawl. <B>sub~i</B>, [UV] underlie. ➞ apog, lit, stern</I>.", "0"],
["kutiklo", "kutikl-o", "(anat) (bot) cuticle.", "0"],
["kutimo", "kutim-o", "[UV] Custom, Habit, Practice, wont. <I>Esti sklavo de ~o. ~o estas dua naturo</I>. <B>~i</B> (<I>al, je, -i</I>), be accustomed, used, wont (to), in the h. (of), make it one’s p. (to). <I>Mi ne ~as mensogi</I>. <B>~e</B>, usually, <B>~aĉo</B>, stupid c., fad, mania, <B>~aĵo</B>, everyday affair, usage, <B>~igi</B>, accustom, h-ituate. <B>(Al)~iĝi</B>, get acc-ed, inured (used) (to). <I>~inta</I>, acc-ed. <B>De~igi</B>, break off h., wean from. <B>De~iĝinta</B>, out of p. <B>Eks~a</B>, antiquated, out of date. <B>Ekster~a</B>, <B>ne~a</B>, unaccustomed, unusual. <B>Fi~o</B>, bad h., malpractice. <B>Laŭ~e</B>, as usual. <B>Mal~i</B>, not have the h. of. ➞ <I>mor, ordinar, praktik, rutin, tradici</I>. <B>Rim</B>.: <I>Kutimo</I> is personal; <I>moro</I> traditional, communal.", "0"],
["kutro", "kutr-o", "(mar) cutter. <B>1</B> small one-masted sailing boat, with gaff and boom. <B>2</B> 12-oared rowing-boat.", "0"],
["Kuvajto", "Kuvajt-o", "KW.", "0"],
["kuvo", "kuv-o", "[UV] Tub, big uncovered bucket, (phot) bath. <B>Ban~o</B>, bath. <B>Bapto~o</B>, font. <B>Lav~o</B>, wash-t., copper. <B>Plen~o</B> (<I>da</I>), t-ful. <B>~ego</B>, vat. <B>~eto</B>, basin, bowl. ➞ <I>tin</I>.", "0"],
["kuzo", "kuz-o", "[UV] (<B>~ino</B>), (First) Cousin, child of uncle or aunt. <B>Ge~oj</B>, cc (m. and f). <B>Pra~o</B>, distant c. <B>Rim</B>.: \"First c. once removed\" = (a) <I>kuzido</I>, (b) <I>kuzo de patr(in)o</I>. \"2nd c<I>.\" = ido de kuzo de patr(in)o</I>.", "0"],
["kvadranto", "kvadrant-o", "quadrant. <B>1</B> quarter of circle. <B>2</B> instrument with 90° angle.", "0"],
["kvadrato", "kvadrat-o", "[OA] Square, <B>f</B> <I>Vort~o</I>, word-s. <B>1</B> (geom). <B>2</B> (mat) number multiplied by itself. <I>[Ne= placo]</I>, <B>~a</B>, s., quadratic. <I>~a folio, mejlo; ~a radiko. ~a du futojn</I>, 2 foot square. <I>Du~aj futoj</I>, 2 square foot. <B>~(iz)i</B>, cover with ss. <I>~ita ŝtofo</I>, check, <B>~aĵo</B>, grid, <B>~igi</B>, make s.", "0"],
["kvadraturo", "kvadratur-o", "[OA] (as) (geom), quadrature.", "0"],
["kvadrilo", "kvadril-o", "[OA] (dance) Quadrill/e.", "0"],
["kvakero", "kvaker-o", "Quaker, Friend, member of The Religious Society of Friends, <B>~ino</B>, -ess. <B>~ismo</B>, -ism.", "0"],
["kvaki", "kvak-i", "<B>~o</B>, croak, quack (of duck or frog) (4 FA 25/15).", "0"],
["kvalifi", "kvalif-i", "Qualif/y. <B>1</B> entitle (to), make fit (competent). <B>2</B> modify statement by limitation or reservation; moderate, narrow, restrict. <B>~o</B>, -ication, condition to be met, modification. <B>~enda</B>, needing -ication. <B>~ita</B>, -ied, competent. <B>3</B> attribute a quality to. (gram) <I>adverbo ~as verbon</I>. <B>~a</B>, -icatory, <B>~iĝi</B>, fulfil necessary conditions.", "0"],
["kvalito", "kvalit-o", "[OA] (<I>eco, stato</I>), Qualit/y (of thing or person). <B>1</B> distinctive property, attribute, characteristic, nature, peculiarity, timbre, trait. <B>2</B> grade of excellence, brand, calibre, class, condition, kind, rank, stamp, standing, station. <I>Ne kvanto, sed ~o, decidas pri merito</I>. <B>~a</B>, -ative. <B>Alt~a</B>, exquisite, A/1. <B>Mez~a</B>, of medium grade, middling.", "0"],
["kvankam", "", "[UV] (<I>malgraŭ tio, ke</I>), (conj). (al)though, even if, granting (notwithstanding the fact) that. <I>Mi ne povas kanti, ~ mi volus tion fari. Mi ja venis, ~ (mi estis) malfrua</I>. <B>Rim</B>.: The correlative is <I>tamen</I>. <I><B>~</B> mi falis, (tamen) mi releviĝos</I> (Mi 7/8).", "0"],
["kvanto", "kvant-o", "[UV] (<I>kiomo</I>), Quantit/y (measure or number), amount, extent, share, size, volume, weight. <I>En la ~o de</I>, to the amount (number) of. <B>~a</B>, -ative. <I>Naskiĝa</I> <B>~o</B>, birth rate. <B>~umo</B>, (ph) quantum. <I>~uma analizo, teorio</I>. ➞ <I>kiom, porci</I>.", "0"],
["kvar", "", "[UV] four. <I>Po</I> (at the rate of) four at a time. <B>~o</B>, a four, quartet. <I>Vers~o</I>, quatrain. <B>~a</B>, fourth (in order). <B>~foje</B>, 4 times (repetition). <B>~obla</B>, 4-fold, quadruple. <I>~obligi</I>, multiply by 4. <B>~olo</B>, (mus), quadruplet. <B>~ono</B>, quarter, (mus) <I>~ona noto (~ono</I>), crotchet. <I>~ona silento,</I> c. rest. <I>~onigi</I>, divide by 4. <B>~onjara</B>, <B>~e</B>, quarterly. <B>~ope</B>, 4 together, in 4s. <I>~opo,</I> foursome. <B>~dek</B>, 40 (➞ <I>dek kvar</I>, 14). <B>~latera</B>, <B>~silaba</B>, quadri-lateral (-syllabic). <B>~voĉa</B> (4-pt) <I>harmonio</I>. <B>Ĉiu~jare</B>, every 4 years. <B>Rim</B>.: Kvar- = quadri-, tetra-.", "0"],
["kvaranteno", "kvaranten-o", "[UV] Quarantine, period of isolation. <B>~i</B>, q.", "0"],
["kvarco", "kvarc-o", "[UV] Quartz, rock crystal; various crystalline silicas &gt; <I>jaspo, kalcedonio, topaz</I>. <B>~oza</B>, -ose. <B>~ito</B>, -ite.", "0"],
["kvariliono", "kvarilion-o", "(mat) -ion, (British) unit of 24 cyphers; (USA) 5th power of a thousand.", "0"],
["kvartalo", "kvartal-o", "[UV] quarter (of town), district, division, locality, ward (Ce 1/10). <I>~o artista, ĉina, juda, komerca, orienta, studenta</I>. <B>~estro</B>, district superintendent, warden.", "0"],
["kvarternaro", "kvarternar-o", "(<I>~a periodo</I>), (geol) quarternary period. ➞ <I>primar, sekundar, terciar</I>.", "0"],
["kvarteto", "kvartet-o", "(mus) quartet(te). <B>1</B> composite for 4 performers. <B>2</B> the 4 performers.", "0"],
["kvarto", "kvart-o", "[UV]. <B>1</B> (intvl) fourth. <I>~oj sinsekvaj</I>, consecutive 4ths. <B>2</B> quart (2 pints) (K 116/7). <B>3</B> quarto (4-mo), size of paper.", "0"],
["kvasio", "kvasi-o", "quassia, drug from root or wood of <B>various trees (Quassia)</B>.", "0"],
["kvaso", "kvas-o", "kvass, Russian rye-beer.", "0"],
["kvasto", "kvast-o", "[OA] tassel, hanging knot or tuft. <I>~o de fezo</I>. <B>Bul~o</B>, pom-pom. <B>Pudro~o</B>, powder-puff.", "0"],
["kvazaŭ", "", "[UV] (<I>same kiel, kiel se</I>). <B>1</B> (conj) as, as if (though), like. <I>~ diri</I>, as if to say. <I>Li kuŝis ~ mortinta; Li batalis ~ leono; Mi edukis lin ~ propran filon</I> (as if/he were). <B>2</B> (adv) (<I>= kvazaŭe\\</I> apparently, as it were, so to speak. <I>Ŝiaj okuloj ~ parolis</I> (seemed to speak). <I>Letero ~</I> (apparently, purporting to be) <I>skribita de mi. Mi sentis ~</I> (something like) <I>envion. Li ~</I> (it seems that he) <I>volas ion komuniki</I> (H/29). <B>~a</B>, (<I>proksimuma, preskaŭa</I>), almost, as it were, a sort of, quasi-, semi-. <B>~homo</B>, dummy. <B>~scienca</B>, quasi-scientific. <B>~vira</B>, mannish. <B>~virina</B>, effeminate. ➞ <I>ke, kiel, pseŭdo, ŝajn</I>. <B>Rim</B>.: The mood after <I>kvazaŭ</I> is a disputed question. Some use an invariable <B>-us</B>. Z. sometimes used <B>-us</B>, sometimes <B>-as</B>, <B>-is</B>. If the idea is clearly past, (present, or future), it seems better to use <B>-as</B> (<B>-is</B>, or <B>-os</B>). (The idea of <I>useco</I> is in the word <I>kvazaŭ</I> itself). <I>Li ŝvitas, ~ li labor</I><B><I>as</I></B> (<I>= kvazaŭ labor</I><B><I>anta</I></B>), as though he is working<SUB>;</SUB> <I>Vi aspektas, ~ vi ĵus vid</I><B><I>is</I></B> (<I>= vid</I><B><I>inta</I></B>) <I>fantomon</I>, as though you had just seen a ghost. <I>La ĉambro aspektas, ~ artisto ĝin aranĝis</I> (had arranged it). <I>Li aspektas</I>, (a) <I>~ li ploros</I> (as though he is going to cry), (b) <I>~ li plorus</I> (as though he would cry if …).", "0"],
["kvereli", "kverel-i", "(<I>kontraŭ, kun</I>) [OA] (<I>kolere kaj brue interdisputi</I>). Quarrel, contend violently, fall out, have words, jangle, squabble, wrangle (El 21/18, Jĝ 8/1). <B>~o</B> q., altercate, brawl, clash, dissention, row, strife. <B>~eto</B>, bickering, jar, tiff. <B>~ema</B>, -some, cantankerous, combative, contentious, disputatious, irritable. ➞ <I>disput, malpac</I>.", "0"],
["kveri", "kver-i", "Coo (as dove, pigeon), <B>f</B> speak lovingly. <B>~ado</B>, -ing.", "0"],
["kverko", "kverk-o", "[UV] Oak (tree) (<I>Quercus</I>) (Ge 12/6). <I>Forta, kiel ~</I> (Am 2/9). <B>Ileksa ~o</B>, holm (holly, evergreen) oak (<I>Q. ilex</I>). <B>Ruĝa ~o</B>, red oak. <B>~aro</B>, o-grove (Jĝ 4/11). ➞ <I>glan, ileks</I>.", "0"],
["kvestoro", "kvestor-o", "[OA] (hist) quaestor.", "0"],
["kvieta", "kviet-a", "[UV] Quiet. <B>1</B> free from annoyance, disturbance, or noise; calm, peaceful, motionless, silent, still: <I>~a domo, menso, nokto, strato, vivo</I>. <B>2</B> modest, retiring, unobtrusive: <I>~a homo, koloro, lumo, tono</I>. (Ge 25/27). <B>~(ec)o</B>, q., freedom from alarm, disturbance; ease of mind, peace (Ij 3/26). <B>~e</B>, -ly, gently, softly (Jes 8/6). <B>~igi</B>, -en, allay, appease, dispel (fears), lull, pacify, silence, still. <I>~igi koleron</I> (Se 15/1). ~igilo (<I>sedativo</I>), sedative. <B>~iĝi</B>, grow calm, abate, subside. <B>~ismo</B>, ism. <B>~ulo</B> (Ps 35/20). <B>Mal~a</B>, boisterous, excited, noisy, restless, turbulent. <I>~~a maro, vento</I> (Jona 1/13). <I>~~eco</I>, agitata, turbulence. ➞ <I>dolt, kalm, mallaŭt, mild, seren, silent, trankvil</I>.", "0"],
["kvilajo", "kvilaj-o", "(<I>saparbo</I>), Soap-bark (<I>Quillaja saponaria</I>). ➞ <I>saponari</I>.", "0"],
["kvin", "", "[UV] Five. <B>Po ~</B> (at the rate of) 5 at a time. <B>~o</B>, a five (cgm). <B>~a</B>, 5th (in order). <B>~e</B>, 5thly. <B>~foje</B>, 5 times (repetition). <B>~obla</B>, 5-fold, quintuple. <I>~obligi</I>, multiply by 5. <B>~olo</B>, (mus) quintuplet. <B>~ono</B>, a 5th (fraction). <B>~ope</B>, 5 together. <B>~dek</B>, 50. (➞ <I>dek kvin</I>, 15). <B>Ĉiu~jara</B>, quintennial. <B>Rim</B>.: <B>Kvin-</B> = quint-, penta-.", "0"],
["kvintesenco", "kvintesenc-o", "[OA] quintessence, essential part, refined extract.", "0"],
["kvinteto", "kvintet-o", "(mus) quintet(te). <B>1</B> composition for 5 performers. <B>2</B> the 5 performers.", "0"],
["kvintiliono", "kvintilion-o", "(mat) quintillion. (Brit) unit with 30 cyphers; (USA, France), with 18 cyphers.", "0"],
["kvinto", "kvint-o", "[OA] (intvl), Fifth. <B>~o ĝusta</B> (just); <B>neplena</B> (bare); <B>perfekta</B>; <B>pliigita</B> (augmented); <B>minimuma</B> (dimished). <B>~oj kaŝitaj</B> (hidden); <B>sinsekvaj</B> (consecutive). (ac) <B>~aĉo</B>, wolf.", "0"],
["kvita", "kvit-a", "[UV]. Quit; clear, free, acquitted, dischargeed, released (from debt, duty, etc.). <I>Bieno ~a de hipotekoj. ~a pri devoj kaj respondeco</I>. <B>~igi</B>, clear, discharge, (set) free, liberate, release, relieve (from). <I>~igi iun de (pri) ŝuldo, vizito</I>. <B>~iĝi</B>, get even. <I>~iĝas servo per reservo</I>.", "0"],
["kvitanco", "kvitanc-o", "[UV] (<I>kvitatesto</I>), Receipt, written acknowledgment (of payment, letter, etc.). <B>~i</B> (give a) receipt, acknowledge the receipt of. <I>~i kalkulon, leteron</I>. <B>~ilo</B>, form of r. <B>~kajero</B>, r-book. <B>~marko</B>, r-stamp. ➞ <I>recept</I>.", "0"],
["kvociento", "kvocient-o", "[OA] (mat) quotient, result of dividing one quantity by another.", "0"],
["kvodlibeto", "kvodlibet-o", "(<I>miksaĵo</I>), (mus) quodlibet, medley, musical switch, pot-pourri.", "0"],
["kvorumo", "kvorum-o", "(<I>agnombro</I>), quorum, number present required to make proceedings valid.", "0"],
["kvoto", "kvot-o", "quota, portion (amount, share, sum) due to be contributed to or recovered from a total. <B>~i</B>, quotation (price, etc.) (on exchange). <B>~igi</B>, allocate, allot (shares, etc.). <I>[Ne= cit]</I>.", "0"],
["l", "", "[F], letter <B>I. -greka</B> (<I>ipsilono</I>), <B>Y. -korelativo</B> (<I> = ia, ial</I>. . <B>.). -fero. -relo. -terpomoj</B>, name given by a child to \"chips\", <B>-vorto (</B><I>[verbo</I>).", "0"],
["la", "", "[UV] the. Possible abbreviation after a preposition ending with a vowel: l’.", "0"],
["laberdano", "laberdan-o", "salt cod.", "0"],
["labialo", "labial-o", "(<I>lipa konsonanto</I>), labi<B>al</B>.", "0"],
["labio", "labi-o", "(bot) Labi/um, lip. <B>~a</B>, -iate. <B>~acoj</B>, -ates.", "0"],
["labirinto", "labirint-o", "[OA] Labyrinth, maze. <I>~o da kanaloj, stratoj</I>. <B>f</B> intricacy. ~o <I>de proceduro</I>. <B>~(ec)a</B>, -ine, complicated, entangled, involved, mazy, tortuous.", "0"],
["laboratorio", "laboratori-o", "laboratory.", "0"],
["labori", "labor-i", "[UV] Labour, Work; drudge, toil. <I>~i en fabrikejo, por la homaro, super tasko</I>. <B>~o</B>, 1., w., exertion, industry, toil. <B>~o Herkulesa</B>. <B>Man~o</B>, manual 1. <B>~o preterdeva</B>, overtime. <B>Peza</B> <B>~o</B>, hard w. <B>Pun~o</B>, hard 1., penal servitude. <I>~~ejo</I>, convict prison. <I>~~isto</I>, convict. <B>~aĵo</B> (El 28/8), piece of work. <B>~egi</B>, slave. <B>~ejo</B>, w-room, studio, etc. <B>~ema</B>, assiduous, hard working, industrious, sedulous. <B>~estro</B>, foreman, overseer (➞ <I>vokt</I>). <B>~iga</B>, arduous, onerous, toilsome. <B>~igi</B>, employ (El 1/13). <B>~ilo</B>, tool. <B>~isto</B>, 1-er, artisan, toiler, w-man. <B>Cerb~isto</B>, brain w-er. <B>Kamp~isto</B>, <B>ter~isto</B>, agricultural 1-er. <B>Ligno~isto</B>, wood worker. <B>Tag~isto</B>, day 1-er. <I>~ista klaso</I>, w ing class, <B>~iteco</B>, w-manship. <B>El~i</B>, work out in detail, develop, ellaborate, treat at length. ~~i <I>metodon, projekton</I>. (mus) <I>Tema el~o</I>, thematic development. <B>Kun~i</B>, collaborate. <B>Mal~i</B> (<I>esti mal~ema</I>), be idle, indolent, lazy, slack, sluggish. <B>~~(em)ulo</B>, drone, lazybones. <B>per~i</B> [UV] (<I>~akiri, ~enspezi</I>), gain by working, earn. <I>~~i vivrimedon</I> (K 112/10). <B>pri~i</B> (<I>-n</I>), [UV] (<I>labori super</I>), bring to perfection, cultivate, treat, work at. <I>~~i kampon, poemon, talenton, temon, verkon</I>. <B>f</B> <I>~~i</I> (belabour) <I>iun per bastono</I>. <B>Sen~a</B>, out of work, unemployed. <B>Tro~i</B>, over-do it. <I>~~igi,</I> over-w. <B>~evitulo</B>, shirker. <B>~kapabla</B>, able-bodied. <B>~perejo</B>, employment bureau, 1-exchange. <B>~tago</B>, w ing day. ➞ <I>okup, peneg, verk</I>.", "0"],
["labrako", "labrak-o", "(ich) bass (<I>Morone labrax</I>).", "0"],
["labro", "labr-o", "(ich) wrasse (<I>Labrus</I>).", "0"],
["laburno", "laburn-o", "(<I>ora pluvo</I>), (bot) laburnum, golden chain (<I>Laburnum</I>).", "0"],
["laca", "lac-a", "[UV] Tir/ed, Wear/y. <B>1</B> fatigued. <I>~a de laboro, pro sendormo</I>. <B>2</B> (<I>tedita</I>): wearied, fed up, jaded. <B>~(ad)o</B>, w-iness, fatigue, languor, lassitude. <B>~ega</B>, dead beat, exhausted, spent, tired (worn) out. <B>~igi</B>, tire, fatigue, knock up. <I>~iga</I> (Pr 1/8), t-ing, irksome, tiresome, wearisome. <B>Ne~igebla</B>, indefatigable. <B>~iĝi</B>, t., grow t-ed, have had enough, be sick of. <I>El~igo,</I> exhaustion. <B>Mal~a</B>, fresh. <I>~~iĝi</I>, refresh. <I>~~iĝo</I>, relaxation, relief. <B>Sen~a</B>, t-less, unw-ied. <I>Sen~a homo, laborado</I>. <B>Tro~igi</B>, exhaust. <B>Pied~a</B>, foot-sore. ➞ <I>enu, malfreŝ, ted</I>.", "0"],
["lacerto", "lacert-o", "[UV] Lizard (<I>Lacerta). Verda ~o</I>, green 1. ➞ <I>heloderm</I>.", "0"],
["laĉo", "laĉ-o", "[UV] Lace, cord, latchet, string, thong (to bind or tighten garment). <I>~o bota, korseta, ŝua; kotona, leda, silka. ~o de bidoj, perloj</I>, string of beads (Alt 1/10). <I>~o el ŝtofo</I> (El 28/37). <B>~i</B>, 1. <I>~i korseton, ŝuojn</I>. <B>f</B> <I>~i sian volon</I>, trammel one’s will (Rj 17/2). <B>~fero</B>, <B>~metalo</B>, tag. <B>~tirilo</B> (<I>tredilo</I>), bodkin. <B>~truo</B>, eyelet. <B>Mal~i</B>, undo, unlace. <B>Inter~i</B>, interlace. ➞ <I>kordon, plekt, punt, ŝnur</I>.", "0"],
["lado", "lad-o", "[UV] sheet metal. <B>Fer~o</B>, sheet-iron. Stan(iz)ita <I>fer~o</I>, tin, tinplate. <B>Ond~o</B>, corrugated iron. <B>Plumb~o</B>, sheet lead. <B>~a</B> <I>skatolo</I>, tin. <B>~aĵoj</B>, tin-ware. <B>~isto</B>, tinsmith, tinker. <B>~bendo</B>, hoop-iron. <B>En~igita</B>, tinned (food). ➞ <I>latun, stan</I>.", "0"],
["lafo", "laf-o", "[UV] lava.", "0"],
["lagenario", "lagenari-o", "bottle (or trumpet) gourd (<I>Lagenaria</I>).", "0"],
["lago", "lag-o", "[UV] Lake, loch, lough. Monta <B>~o</B>, tarn. <B>~eto</B>, [UV] pool, pond, mere. <B>Ros~eto</B>, dew-pond. <B>~ujo</B>, 1-bed. ➞ <I>fjord</I>.", "0"],
["lagopo", "lagop-o", "willow grouse (<I>Lagopus lagopus</I>). ~o monta (muta), ptarmigan (<I>L. mutus</I>). ~o Skota, red grouse (<I>L. scoticus</I>).", "0"],
["lagotriko", "lagotrik-o", "woolly monkey (<I>Lagothrix</I>).", "0"],
["lagro", "lagr-o", "Bearing (friction-bearing part of machine). <I>~o de akso</I>, axle-b. <B>Ĉef~o</B>, main b. <B>Eĝ~o</B>, blade-b. <B>Glob~o</B>, ball-b. <B>Rul~o</B> (<I>~o el rulblokoj</I>), roller-b. ➞ <I>kran, krank</I>.", "0"],
["laguno", "lagun-o", "[OA] lagoon. <B>1</B> enclosed water in atoll. <B>2</B> stretch of salt water separated from sea by strip of land or sand-bank. <I>Pomeria, Stetina L~o</I>.", "0"],
["laika", "laik-a", "[OA] Lay. <B>1</B> secular, non-clerical. <I>Eduko, instruisto, lernejo. ~a frato,</I> -brother. <B>2</B> non-professional (-specialist). <B>~o</B>, layman, outsider (Le 22/10, 12). <I>~o pri medicino</I>. <B>~aro</B>, laity. ➞ <I>nefak, profan</I>.", "0"],
["lakeo", "lake-o", "[UV] lackey, footman, manservant (us. liveried), (pej) flunkey, <B>f</B> toady. <B>~i</B>, behave servilely, dance attendance on. <B>~eto</B>, page-boy. ➞ <I>paĝi</I>.", "0"],
["lakmuso", "lakmus-o", "litmus (from the lichen <I>Roccella tinctoria</I>). <B>~a</B> <I>papero</I>.", "0"],
["lako", "lak-o", "[UV] lacquer, protective varnish, usually from shellac. <B>Nigra (Japana) ~o</B>, japan. <B>Ŝpruc~ado</B>, spray varnishing.", "0"],
["lakona", "lakon-a", "laconic, brief, concise, sententious, succinct, terse. <B>~e</B>, in few words. <B>~aĵo</B>, short pithy saying. <B>~eco</B>, brevity of speech, concise style. ➞ <I>konciz, mal- multvort</I>.", "0"],
["lakroso", "lakros-o", "(gm) lacrosse.", "0"],
["lakso", "laks-o", "[UV] looseness of bowels (<I>&gt; diareo</I>). <B>~i</B>, suffer from this. <B>~iga</B>, laxative. <I>~igilo, (~iga medikamento</I>), aperient, laxative, purgative. <B>Mal~o</B>, (<I>konstipo</I>), constipation.", "0"],
["laktario", "laktari-o", "(<I>Lactarius</I>) &gt; milk cap fungus.", "0"],
["lakto", "lakt-o", "[UV] Milk. <B>1</B> of mammal. <I>~o kaprina, patrina. ~o densigita, kondensita, pulvorigita</I>. <B>Buter~o</B>, butter-m. <B>2</B> m-like fluid. <I>~o kokosa</I>. <B>~(ec)a</B>, -y, of m. lactic. <I>~a dieto, pudingo</I>. <B>f</B> <I>~a vojo, -y</I> way, galaxy. <B>~i</B>, be in m. <I>~anta bovino</I>. <B>~aĵo</B>, m-food. <B>~ato</B>, (chem) lactate. <I>~atacido,</I> lactic acid. <B>~ejo</B>, dairy. <B>~isto</B>, m-man, dairyman. <B>~ozo</B> (<I>~osukero</I>), lactose. <B>~umo</B>, [UV] soft roe, milt. <B>~oblanko</B>, -white. <B>~oporkido</B>, sucking-pig. ➞ <I>dent, fraj, kaviar, melk</I>.", "0"],
["laktuko", "laktuk-o", "[OA] Lettuce (<I>Lactuca</I>). <B>~o longfolia</B>, cos lettuce.", "0"],
["lama", "lam-a", "[UV] Lame; halt, hobbling, limping. <B>f</B> imperfect, unsatisfactory. <I>~a benko, seĝo; ~a argumento, ekskuzo, metriko, verso</I>. <B>~a</B>, with a limp. <I>~e pensi</I>. <B>~i</B> (nt), (<I>iri ~e</I>), be or walk lame, limp (Ge 32/31). <B>f</B> <I>la afero, frazo, ritmo ~as</I>. <B>~etadi</B>, hobble along. <B>~igi</B>, lame, cripple, disable, \"hobble\". <B>~ulo</B>, lame-man. ➞ <I>kripl</I>.", "0"],
["lamao", "lama-o", "[OA] lama, Tibetan Buddhist monk. <B>Ĉef~o</B>, ~ismo.", "0"],
["lameno", "lamen-o", "[OA] Lamin/a, thin plate, film, flake, layer, scale. <I>~o ardeza, barta, ligna, membrane, metala, osta, roka</I>. <B>~a</B>, -ated, lamellate. <B>~igi</B>, -ate, beat (roll, split) into layers. <B>Sur~aĵo</B>, veneer, (zoo) <B>~korna</B>, lamelli-corn. ➞ <I>tavol, skvam</I>.", "0"],
["lamenti", "lament-i", "[OA] Lament, express grief, grieve, mourn, weep. <I>~i pri iu, ies morto</I> (Jer 22/18), (<I>-n</I>), bemoan, bewail, deplore, sorrow for (over). <B>~(ad)o</B>, lament, 1-ation, dirge, plaint (Jeĥ 2/10). (mus) 1. <B>~oj</B> (Am 8/3). <B>~a</B> <I>voĉo</I>. <B>~ado</B> (Jer 51/54). <B>~inda</B>, l-able, regrettable. ➞ <I>elegi, ĝem, priplor, vekri, Plorkanto de Jeremia</I>.", "0"],
["laminarioj", "laminari-oj", "brown seaweeds (kelps, oar- weeds, tangles) (<I>Laminaria</I>).", "0"],
["lamio", "lami-o", "dead-nettle, henbit (<I>Lamium</I>). <B>~o blanka</B>, <B>purpura. ~o flava</B>, yellow archangel.", "0"],
["lamno", "lamn-o", "(ich) porbeagle (shark) (<I>Lamna</I>).", "0"],
["lamo", "lam-o", "(zoo) llama (<I>Lama</I>). ➞ <I>alpak, guanak, vikun</I>.", "0"],
["lampetro", "lampetr-o", "(ich) lampern (<I>Lampetra</I>). ➞ <I>petromiz</I>.", "0"],
["lampiono", "lampion-o", "Chinese-lantern (for ornamental illumination). <B>~eto</B>, fairy-light.", "0"],
["lampiro", "lampir-o", "[UV] (<I>lumraŭpo</I>), glow-worm (<I>Lampyris</I>).", "0"],
["lampo", "lamp-o", "[UV] Lamp. <I>~o elektra, filamenta, fluora, neona, olea, penda, petrola, vakua</I>. <B>Ark~o</B>, arc lamp. <B>Averta</B> <B>~o</B>, indicator 1. <B>Blov~o</B>, blow-1. <B>Dorm~o</B> (<I>nokta ~eto</I>), night light. <B>Fulmo~o</B>, flash-1. <B>Leg~o</B>, reading-1. <B>Min~o</B>, safety-lamp. <B>Pend~o</B> (<I>lustro</I>). <B>Mur~o</B>, bracket-1. <B>Signal~o</B>, pilot-lamp. <B>~a</B> <I>kloŝo. ŝirmilo</I>, 1-shade. <I>Plank</I><B>~aro</B>, footlights. <B>~eto</B>, dim (fairy, tiny) 1. (el) <B>~ingo</B>, bulb-holder, socket. <B>~oŝirmilo</B>. ➞ <I>ampol, lampion, lantern, lucern</I>.", "0"],
["lanario", "lanari-o", "lanner (<I>Falco lanarius</I>).", "0"],
["lanceni", "lancen-i", "(nt) shoot (pain), throb (finger).", "0"],
["lanco", "lanc-o", "[OA] lanc/e, spear (1 Sa 21/8). <I>ĵet~o</I>, assegai, javelin. <B>~eto</B>, -et. ➞ <I>bisturi</I>. <B>~isto</B>, -er, spearman, <B>~forma</B>, -eolate.", "0"],
["lanĉi", "lanĉ-i", "launch (ship), <B>f</B> bring out (<I>aktorinon</I>) deliver (<I>atakon</I>); float (<I>kompanion</I>); set (<I>modon</I>), release (<I>bombon</I>); send up (<I>balonon</I>). ➞ <I>flotig</I>.", "0"],
["lando", "land-o", "[UV] Land. 1 (<I>tero</I>): country. <I>~o Azia, dezerta, fremda, promesita</I>. <B>Duk~o</B>, duchy. <B>Hejm~o</B>, home-1. <B>Mez~o</B>, midlands. <B>Mir~o</B>, wonder-1. <B>Nenies</B> <B>~o</B>, no man’s 1. <B>Patro~o</B> (<I>patrujo</I>), father-1. <B>Princ~o</B>, principality. <B>Reĝ~o</B>, kingdom, monarchy. <B>Rev~o</B>, dream-1. <B>Skot~o</B>, Scotland. <B>2</B> (<I>patrujo): Nia ~o venkos. La ~o prapatra</I>. <B>3</B> (<I>bieno, regiono</I>): district, estate, region. <I>La ĉirkaŭa ~o</I>. <B>~ano</B>, -ido, inhabitant, native. <I>~anaro,</I> people, population. <B>Ali~a</B>, <B>ekster~a</B>, exotic, foreign. <B>~~e</B>, abroad. <I>~~ulo,</I> alien, foreigner. <B>En~a</B>, home, inland, native. <I>Ministro por En~aj Aferoj. En~o</I>, interior. <I>En- kaj ekster</I><B><I>~</I></B><I>e,</I> at home and abroad. <B>Sam~ano</B>, compatriot.", "0"],
["lango", "lang-o", "[UV] (anat) Tongu/e: <I>Bov~o</I>, ox-t. <I>Montru la ~on!</I> <B>f</B> organ or faculty of speech; <I>Perdi, trovi la ~on</I>. ~o <I>akra, falsa, mensogema. Gardi sian ~on. Lia nomo estas sur dies ~o</I>. <B>2</B> t-shaped obj: clapper (<I>sonorilo</I>); pin (<I>buko</I>); neck, point, spit (<I>terkapo). Ŝu~o el ledo</I>. <B>f</B> <I>~o de fajro, flamo</I> (Jes 5/24). (mus) <B>~(et)o</B>, t. of reed or pipe. <B>~a</B>, lingual. <B>~i</B> (<I>blovinstrumento</I>), t. <I>Duobla ~ado</I>, double -ing. <B>~peco</B>, tab, tag. ➞ <I>lek</I>.", "0"],
["langusto", "langust-o", "(ordinary language) = palinuro.", "0"],
["langvoro", "langvor-o", "Langu/or, drooping state, inertia, want of alertness; dullness, heaviness, listlessness, slackness. <B>~a</B>, -id. <B>~i</B>, -ish, flag, mope, pine.", "0"],
["lanio", "lani-o", "(<I>buĉbirdo</I>), Shrike (<I>Lanius</I>). ~o griza, grey s. ~o maskita, masked s. ~o ruĝdorsa, redbacked s. ~o ruĝkapa, woodchat s.", "0"],
["lano", "lan-o", "[UV] Wool, hair of various animals. <B>Ŝaf~o</B>, fleece, lambs-wool. <I>~o alpaca, kapra</I>. <B>Vitra ~o</B>, glass-w. <B>~a</B>, wool-len(-ly). <B>~aĵo</B>, -lens (Ho 2/5). <B>~eca</B>, fleecy. <B>~ero</B>, flock, tuft of wool. <B>Sen~igi</B>, fleece, shear. <B>Tut~a</B>, all-w.", "0"],
["lanolino", "lanolin-o", "lanolin.", "0"],
["lanta", "lant-a", "= malrapida.", "0"],
["lantano", "lantan-o", "(chem) lanthanum (La).", "0"],
["lanterno", "lantern-o", "[UV] Lantern, encased lamp (Jn 18/3). <I>Bicikla, lumtura ~o</I>, cycle (lighthouse) lamp. Gas~(strat~)o, gas (street) lamp. <B>Magia (projekcia)</B> <B>~o</B>, magic 1. <B>Papera (ĉina) ~o</B> (<I>lampiono</I>), Chinese 1. <B>Stel~o</B>, bull’s eye (dark) 1. <B>~a</B> <I>fosto, kolono</I>, lamp-post. <B>~ego</B>, beacon (head) light. <B>~isto</B>, lamp-lighter.", "0"],
["lanugo", "lanug-o", "[UV] Down. <B>1</B> fluff, nap, soft hair: e.g., on young bird, cloth, youth’s chin. <B>Molanasa ~o</B>, eider-d. <B>2</B> similar obj: bloom (<I>persika</I>), d. (<I>karda</I>). <B>~a</B>, -y, fluffy, velvety. <I>~a kuseno. ~aj folioj</I>. <B>Sen~a</B>, clean-shaven, glabrous. ➞ <I>lan</I>.", "0"],
["Laoso", "Laos-o", "LA.", "0"],
["lapiso", "lapis-o", "<I>[OA]</I> (<I>infera ŝtono</I>), lunar caustic (<I>arĝenta nitrato</I>).", "0"],
["lapo", "lap-o", "great burdock (<I>Arctium lappa</I>) (2 FA 35/35, 151/28).", "0"],
["lapsano", "lapsan-o", "(bot) nipplewort (<I>Lapsana</I>).", "0"],
["lardo", "lard-o", "[UV] Bacon. <I>Scias la kato, kies ~on ĝi manĝis</I> (P). <B>~i</B>, lard, stuff with b. ~a <I>tranĉo</I>, rasher of b. <B>~haŭto</B>, b-rind (3 FA 126/20). ➞ <I>porka graso, seb, sink</I>.", "0"],
["largo", "larg-o", "(mus) largo.", "0"],
["larĝa", "larĝ-a", "[UV] Broad, Wide. ~a <I>boato, brusto, marĝeno, pordo, rivero, rubando</I>. <B>2</B> (<I>ampleksa</I>): <I>~a vesto</I>. <B>3</B> (<I>komprenema, tolerema): ~a animo, rigardo</I>. <B>~o</B>, breadth, width. <I>~o de tapiŝo</I> (El 36/9), <I>trotuaro</I> (M 234/129). <I>Plena ~o,</I> full extent. <I>Man~o</I>, hand-breadth. Z usually wrote <I>larĝo,</I> but often <I>larĝeco</I> (e.g., Rd 3/11). <B>~e</B> <I>malfermita, wide open</I>. <I>Oscedi ~e</I>. <I><B>laŭ~e</B>, [UV] across, athwart, b-side(-ways), in width, transversely (Ge 13/17). <B>Mal~a</B>, narrow, strait. ~~a pordo (Mt 7/14). <B>(Pli)~igi</B> (Ĥb 2/5), b-en, w-en, distend, extend. ➞ dik, grand, latitud, vast</I>. [<I>Ne = large]</I>.", "0"],
["laricio", "larici-o", "Corsican (larch) pine (<I>Pinus laricio) &gt;</I> Austrian pine (<I>Pinus austriaca</I>).", "0"],
["lariko", "larik-o", "[OA] larch (<I>Larix</I>).", "0"],
["laringo", "laring-o", "[UV] Laryn/x. <B>~a</B>, -geal. <B>~ito</B>, -itis. <B>~ologio</B>. <B>~oskopio</B>.", "0"],
["larmo", "larm-o", "[UV] Tear (drop). <I>Forviŝi ~ojn</I> (Jes 25/8). <I>Semi kun ~oj</I> (Ps 126/5). <I>~oj de ĝojo</I>. <B>~i</B> (<I>verŝi ~ojn</I>), cry, shed tears, weep (Ij 16/20). <I>~i kaŭze de fumo (senŝeligo de cepoj</I>). <B>~antaj</B> (streaming) <I>okuloj</I>. <B>~a</B>, lachrymal. <B>~e</B> <I>malseka (vango</I>), t-bedewed, t-dimned, t-stained. <B>~ema</B>, lachrymal. <B>~eto</B>, whimper. <B>~iga</B> <I>gaso,</I> t-gas. <B>~oplena</B>, t-ful. <I>Ridi</I> <B>ĝis~e</B>, till one cries. <B>Sen~a</B>, dry, tearless. ➞ <I>plor</I>.", "0"],
["laroj", "lar-oj", "(<I>Laridae</I>), gulls, terns. ➞ <I>mev, ŝtern</I>.", "0"],
["larvo", "larv-o", "[UV] Larv/a, maggot &lt; <I>raŭpo. ~o lignobora</I>, woodworm. <B>~a</B>, -al. ➞ <I>kokon, krizalid, pup</I>.", "0"],
["lasciva", "lasciv-a", "lascivious, lecherous, lewd lustful, prurient, sensual.", "0"],
["lasi", "las-i", "[UV] (wide sense), Leave; allow, let. <B>1</B> (<I>foriri</I>) Leave, depart, go away from: <I>~i la oficon, vojon. La febro lin ~is</I>. <B>2</B> leave behind, let remain: <I>~u vian bastonon tie. ~u tiun taskon al mi</I>. <B>3</B> Allow to be: <I>~u min libera, en paco, sola</I>. <B>4</B> (<I>ĉesi -i</I>): 1. off -ing, cease to. <I>Li ~is sian paroladon (= ĉesis paroli</I>) (K 25/15). <I>~u!</I> Hands off! Stop it! <B>5</B> Allow to act (active sense of inf.), let, permit, suffer: <I>~u la infanojn veni al mi</I> (Mk 10/14). <I>~u min veni (= ~u, ke mi venu</I>), Let me (allow me to) come. <I>Min ~u (iri) for: Mi ~is lin (iri) en la domon</I>. Further examples (from K): <I>~u min (lin) esti sincera, fini, forveturi, paroli, pensi, ricevi, venki la baron. Ne ~u min fali! ~u la ringon brili, la tablon stari</I>. From 4 FA: <I>~u lin iri</I> (168/18). <I>~i ilin pentri</I> (59/13). <I>~i ilin veni, ~i la aliajn vojaĝi</I> (132/19). <B>6</B> (Passive sense of inf.): By <B>5</B> (above) <I>min voki =</I> let me call (active). But sometimes in international and Z-an usage it = Allow me to be called (<I>= ~u min vokiĝi, ke oni min voku</I>). This usage is illogical and ambiguous and should be avoided. ➞ <I>ili ~as siajn brutojn paŝtiĝi</I> (4 FA/174).] <B>Al~i</B>, accept, admit. <I>~~i la veron de aserto. La regulo ne ~~as escepton. ~~ebla (pri tensio, ŝarĝo</I>), allowable. <B>De~i</B>, 1., deposit. <I>~~i palton ĉe la pordo</I>. <B>El~i</B>, allow to (let) escape, let out, emit, release. <I>~~i akvon, krion, spiron, birdon el kaĝo. ~~ilo,</I> (hor) escapement. <I>Sang~~i</I>, bleed, cup. <B>~~o</B>, bloodletting. <B>Ekster~i</B>, 1. out, omit. <B>En~i</B>, admit, let in. <I>~~u min!</I> Let me in. <B>For~i</B>, abandon, desert, forsake, give up, <I>intencon, postenon. ~~ita</I>, abandoned, deserted, derelict, forlorn, forsaken. <I>Ne~~ebla,</I> indispensable. <B>Post~i</B>, leave behind (Rut 2/16), bequeath. <I>~~i infanon, impreson, posedaĵon</I>. <B>Preter~i</B>, let go (pass, slip) by, lose, miss, omit. <I>~i klopodon, okazon, ŝancon</I>, pass over, overlook (<I>kulpon</I>) (Mi 7/18). <I>~~o</I>, oversight. <B>Tra~i</B>, let through. <I>Vitro tra~as lumon,</I> <B>~~iva</B>, permeable. ➞ <I>permes, restig</I>.", "0"],
["lasiokampo", "lasiokamp-o", "(ent) Eggar moth (<I>Lasiocampa</I>). <B>Kverka ~o</B>, oak eggar.", "0"],
["lasta", "last-a", "[UV] Last, after all others. <B>1</B> (time) latest up to the present: <I>La ~a fojo, kiam li venis</I>, the 1. time he came. <I>En la ~aj jaroj</I>, recently, of late years. <I>La ~an mardon, semajnon</I>, last Tuesday (week). <I>En la ~a monato, nokto, tempo</I> (H/3, 25). <I>Plej ~a</I>, latest. <B>2</B> last in order (rank, series), hind(er)most: <I>La ~aj du. La ~a ĉe la konkurso. ~a, sed ne malplej grava</I>. <B>3</B> last of all, only remaing, no more to come, ultimate: <I>La ~a Tago (Juĝa Tago). La ~a limo de mia pacienco. Por la ~a fojo mi vin avertas. Lia ~a horo, krusto, monero, spiro, ŝanco. La ~a (decida) vorto</I>. ➞ <I>fina</I> (final, decisive). <B>~e</B>, 1-ly (often = <I>~foje</I>), after all others (the rest), finally, in the 1. place. <I>Plej bone ridas, kiu ~e ridas</I>. <B>~atempe</B>, in recent years, lately, <I>Mi vidis lin</I> ~foje <I>ĉe … </I> the last time I saw him was at … <B>~vice</B>, 1. in turn. <B>Antaŭ~a</B>, 1. but one, penultimate. <I>Pra~~lasta</I>, antepenultimate.", "0"],
["lastingo", "lasting-o", "(tex) lasting.", "0"],
["lastreo", "lastre-o", "buckler fern &gt; male fern (<I>Lastrea</I>).", "0"],
["latekso", "lateks-o", "latex.", "0"],
["latenta", "latent-a", "latent, dormant, hidden (existent but not developed or manifest). <I>~a deziro, forto, talent, varmo. ~a (sensimptoma) malsano. Kuŝi</I> ~e.", "0"],
["latero", "later-o", "[OA] Side (of geom. figure). <I>Sur unu ~o … sur la dua ~o</I> (El 27/14, 15). <B>~a</B>, lateral, s-, at (from, of, to) the s. <B>Egal~a</B>, <B>tri~a</B>, <B>unu~a</B>, equilateral, trilateral, unilateral. ➞ <I>flank</I>.", "0"],
["latino", "latin-o", "(<I>la latina lingvo</I>), Latin. <I>~aj literoj</I>, Roman (plain upright) type. <I>Lingvo</I> <B>~ida</B>. <B>~isto</B>. <B>Nov~o</B>, neo-1. II (mar) <I>~a velo</I>, lateen sail.", "0"],
["latiro", "latir-o", "vetchling, everlasting (meadow) pea, etc. (<I>Lathyrus</I>). <I>~o aroma, odora</I>. sweet pea.", "0"],
["latiso", "latis-o", "Lattice, Trellis, wooden or metal net-like structure, (map) grid. <I>~o drata</I>, wire netting. <B>~masto</B>, t-mast. <B>~pordo</B>, 1-door. <B>Skrap~o</B>, scraper mat.", "0"],
["latitudo", "latitud-o", "latitude, angular distance (geog) from equator, (astr) from ecliptic. <I>~o meza (vera</I>), middle (true) declination. <B>f</B> climate, reg<SUP>;</SUP>on.", "0"],
["lato", "lat-o", "[OA] Lath, strip (of wood, etc.). <B>Ardeza ~o</B>, roof slate. <B>Fera ~o</B>, iron strip. <B>Fortiga ~o</B>, batten. <B>~i</B>, 1. <B>~aĵo</B>, lattice-work, <B>~kurteno</B> (➞ <I>ĵaluzio</I>), Venetian blind. <B>~ŝutro</B> (<I>persieno</I>). ➞ <I>lamen, lign, tabulet</I>.", "0"],
["latreo", "latre-o", "(bot) toothwort (<I>Lathraea</I>).", "0"],
["latrino", "latrin-o", "(<I>necesejo publika</I>), latrine.", "0"],
["latuno", "latun-o", "[OA] (<I>flava kupro</I>), Brass, alloy of copper and zinc, (mus) (<I>= ~instrumentoj</I>), b. -a <I>kandelingo</I>. <B>~aĵoj</B>, b-ware.", "0"],
["Latvujo, Latvio", "Latv-ujo, Latvio", "[OA-8] LV.", "0"],
["laŭ", "", "[UV] (prep). Accord/ing to, in -ance (conformity) with. <B>1</B> (wish, sentiment): <I>~ mia opinio</I>, in my opinion. <I>Agi ~ ies deziro, ~ sia bontrovo, gusto, plaĉo, konscienco</I>. <B>2</B> (circumstance): <I>kantas birdo ~ sia beko. Trakti iun ~ lia merito. Labori ~ modelo, manĝi ~ la menuo. ~ ordo alfabeta</I>, in alphabetical order. <I><B>~</B> tio, kiel</I>, -ing to how. <I><B>~</B> tio, (se) (ke</I>), -ing to whether. <B>3</B> by means of: <I>Koni arbon ~ la fruktoj, iun ~ la nomo</I> (by name). <I>Ne juĝu pri afero ~ ĝia ekstero</I>. <B>4</B> Along (side of), following: <I>Promeni ~ la rivero, strato, vojo</I>. <B>~a</B>, <B>~e</B>, in conformity with. <I>Estas ~e!</I> It’s all -ing! <B>~igi</B> (<I>konformigi</I>), adapt, bring into line, match. <I>~igi agon al (kun) promeso</I>. ➞ <I>konform</I>.", "0"],
["laŭbo", "laŭb-o", "[UV] arbour, booth, bower, shady retreat, shelter, summer-house (Mt 17/4, Jona 4/5). <I>Festo de ~oj</I> (Le 23/34). <I>Sidi en ~oj</I> (Ne 8/14).", "0"],
["laŭdano", "laŭdan-o", "laudanum, tincture of opium.", "0"],
["laŭdi", "laŭd-i", "[UV] Praise, acclaim, applaud, eulogise, honour. <B>~o</B>, p., approbation, approval; commendation, econium, tribute. <B>~a</B>, of p., adulatory, laŭdatory. <B>~ego</B>, gloriflcation, panegyric. <I>~egi</I>, p. to the skies, exalt, extol, magnify. <B>Mal~i</B>, blame, censure, condemn, decry, find fault with, reprove, reproach, run down (➞ <I>kritik). ~~a</I>, depreciatory, pejorative. <I>~~ema</I>, captious, censorious. <I>~~inda,</I> blameworthy. <I>~~indaĵo</I>, blemish (2 Sa 14/25). <B>Sin~o</B>, self-p, boast, brag, vaunt. ➞ <I>flat, panegir</I>.", "0"],
["laŭracoj", "", ".", "0"],
["laŭreato", "laŭreat-o", "[OA] laureate, crowned victor, winner in competition.", "0"],
["laŭro", "laŭr-o", "[UV] Laurel, bay-tree (<I>Laurus</I>). <B>f</B> symbol of victory or success. <I>Rikolti ~ojn de gloro</I>. <B>Ĉeriz~o</B>, cherry-laurel (<I>Lauro cerasus</I>). <B>~e</B> <I>kroni</I>, crown with. <B>~ofolio</B>, bayleaf (➞ <I>aŭkub</I>).", "0"],
["laŭso", "laŭs-o", "louse (in gen). <I>~o folia, planta (iafido). ~o</I> puba (<I>crab-l.) (ftiro</I>). ~o sangosuĉa (<I>pediko</I>). <B>Ŝild~o</B>, scale insect.", "0"],
["laŭta", "laŭt-a", "[UV] Loud, clamorous, noisy, resounding, sonorous, vociferous. <I>~a bruo, krio, rido, sono, voĉo</I>. <B>f</B> <I>~aj frazoj,</I> blatant talk. <B>~e</B> <I>legi, ridi</I>, read (laugh) aloud. <B>~ega</B>, deafening, stentorian, stunning. <B>~igi</B>, blazon forth, <I>~igi</I> (raise) <I>la voĉon</I>. <B><I>~</I>voĉe</B>, in a 1. voice. <B>Mal~a</B>, gentle, low, quiet, soft. <I>~~el</I> Hush! <I>~~igi</I> (lower) <I>la voĉon. ~~iĝi</I>, be hushed. <B>Ne~a</B>, dull. ➞ <I>bru, flustr, emfaz, silent</I>.", "0"],
["lavango", "lavang-o", "[UV] avalanche.", "0"],
["lavatero", "lavater-o", "(bot) tree-mallow (<I>Lavatera</I>).", "0"],
["lavendo", "lavend-o", "[OA] Lavender (<I>Lavandula). ~</I><B>akvo, 1-water. ~oleo, oil of l</B>.", "0"],
["lavi", "lav-i", "(<I>-n</I>), [UV] Wash, lave, cleanse by -ing. <I>~i teleron, tolaĵon, vizaĝon. Sin ~i</I>, w. one’s. <B>f</B> <I>Ondoj ~is la rokojn. ~i al si la manojn (= rifuzi respondecon) pri io</I>. <B>~ado</B>, -ing, ablution. <B>f</B> <B>Cerb~ado</B>, brainwashing. <B>~aĵo</B>, -ing. <B>~ejo</B>, w-house, laundry, lavatory. <I>Vaz~ejo</I>, scullery. <B>~eti</B>, rinse. <B>~igi</B>, have -ed, send to the w. <B>~ilo</B>, <B>~maŝino</B>, -ing machine, <B>~istino</B>, laundress, -erwoman. <B>~ujo</B> (<I>~kuvo</I>), laver, w-basin or tub. <B>Ŝton~ujo</B> (<I>~trogo</I>), sink. <B>Ŝaf~ujo</B>, sheep-dip. (des) <B>~umi</B> (<I>akvotinti, tuĉi</I>), wash (brush with faint colour). <B>Tra~i</B>, rinse out, flush. <B>El~i</B>, <B>For~i</B>, w. out, remove (<I>makulon</I>). ➞ <I>ban, gargar, lesiv, purig</I>.", "0"],
["lazo", "laz-o", "(<I>kaptoŝnuro</I>), lasso, lariat. <B>~(kapt)i</B>.", "0"],
["lazuro", "lazur-o", "[OA] (<I>ĉielbluo</I>), azure, sky blue. <I>~a ĉielo, okulo</I>.", "0"],
["leciono", "lecion-o", "[UV] (<I>instruo, lernendaĵo</I>), Lesson. <I>Doni, fari, forgesi, lerni, preni ~on</I>. <B>f</B> <I>Tio servu al vi kiel ~o</I>. <B>~aro</B>, course (series) of lessons. ➞ <I>lekci, preleg</I>.", "0"],
["ledo", "led-o", "[UV] Leather, prepared hide, <B>~o bovida</B> (calf); <B>bovina</B> (cowhide); <B>kapra</B> (kid); <B>porka</B> (pigskin); <B>Rusa</B> (Russian); <B>ŝafa</B> (sheep- or buck-skin); <B>ŝama</B> (suede). <B>Lak~o</B>, patent 1. <B>Lav~o</B>, wash 1. <B>Maroka ~o</B> (<I>marokeno</I>), Moroccan 1. <B>Suĉ~o</B>, sucker (of pump, etc.). <B>~a</B>, leather(n). <I>~a boto, rimeno, ŝuo</I>. <B>~aĵoj</B>, 1-goods. <B>~eca</B>, -y, tough. <B>~(pret)igisto</B>, currier. ➞ <I>fel, haŭt, pelt</I>.", "0"],
["legacio", "legaci-o", "legation, body of diplomats, <B>~ejo</B>, 1.", "0"],
["legala", "legal-a", "(jur) legal.", "0"],
["legate", "legat-e", "(<I>glate</I>), (mus) legato, smoothly.", "0"],
["legato", "legat-o", "[OA] papal legate.", "0"],
["legendo", "legend-o", "[UV] Legend, myth. <I>Popola ~o,</I> folklore. <B>~a</B>, -ary, fabulous, fictitious, <B>~oriĉa</B>, romantic. ➞ <I>fabel, folklor, mit</I>.", "0"],
["legi", "leg-i", "(-n, nt), [UV] Read. <B>1</B> con, peruse, study: <I>~i leteron, libron, poemon. Multe ~i lacigas la koron</I> (Pr 12/12). <I>Mi ~as, ke … ~i el libro, profunde</I><B>. 2</B> decipher, interpret, make out, understand: <I>~i enigmon, koron, lingvon, muzikon, penson, sonĝon. ~i en ies vizaĝo. ~i perfingre (blindule). ~i ies manon, la signojn de la ĉielo</I>. <B>~(ad)o</B>, -ing, interpretation, perusal, rendering. <B>~(at)aĵo</B>, -ing matter (Ne 8/8). <B>~ejo</B>, -ing room, <B>~eti</B>, skim. <B>~igi</B> al si, have read to one. <B>~inda</B>, worth -ing. <B>Dis~i</B>, r. here and there, dip into. <B>Ek~i</B>, start -ing. <B>Fuŝ~i</B>, drone (mumble, stumble) through, hum and haw. <B>Mis~i</B>, misread. <B>Laŭt~i</B>, <B>Voĉ</B>~i (3 FA 105/14), r. aloud.", "0"],
["legio", "legi-o", "[UV] (hist, mil), Legion. <I>Fremdula (honora) ~o</I>, Foreign 1., L. of Honour, <B>f</B> multitude. <B>~ano</B>, -ary. <B>Rim</B>.: \"Legiono\" (Rj) estas \"eraro\" (Z).", "0"],
["legitimi", "legitim-i", "(<I>-n</I>) [OA], legitim/ize, prove authenticity or identity of, formally recognize, legalize. <B>Sin ~i</B>, <B>~iĝi</B>, establish one’s identity (No 2/18; K 19/21). <B>~a</B>, -ate, recognized, regular. <B>~ado</B>, official recognition. <B>~ilo</B>, passport, card of identity, etc. ➞ <I>leĝig, pasport, rajtig</I>.", "0"],
["legomo", "legom-o", "[UV] vegetable (Da 1/12). <B>~ejo</B> (<I>~a ĝardeno</I>), v. or kitchen garden. <B>~isto</B>, market gardener. <B>~vendisto</B>, greengrocer. ➞ <I>kreskaĵ, plant, vegetaĵ, vegetal</I>.", "0"],
["legumenoj", "legumen-oj", "pulses (<I>faboj, lentoj, pizoj</I>).", "0"],
["leĝera", "", "= malpeza, light; flimsy, slight; airy, volatile. ➞ <I>kromlini</I>.", "0"],
["leĝo", "leĝ-o", "[UV] Law. <B>1</B> cannon, decree, edict, enactment, order, regulation, statute. <I>Nescio de ~o neniun pravigas. Fari, obei, nuligi ~on</I>. <B>2</B> controlling or universal principle, role. <I>~o de fiziko, fonetiko, gravito, naturo, ~oj de arto, ludo, muziko</I>. <B>3</B> body of rules. <I>La ~o de la lando, de Moseo</I>. <B>~a</B>, <B>1</B> of law, legal. <I>~a decido, forto</I>. <B>2</B> (<I>laŭ~a</I>), lawful, allowed, appointed, legitimate, recognized, rightful, valid. <I>~a edzo, infano</I> (Mai 2/14). <B>~aro</B>, laws, code, statutes. <B>~igi</B>, legalize. <I>~igi la situacion</I>. <B>~isto</B>, man of law, -yer. <B>~doni</B>, legislate, make laws. <B>~forta</B>, legal, by force of law. <B>~obea</B>, law-abiding. <B>~oscienco</B> (<I>juro</I>). <B>Ekster~ulo</B>, out-law. <B>Kontraŭ~a</B>, illicit, illegal. <B>Ne~a</B>, illegitimate. <B>Sen~a</B>, lawless.", "0"],
["lejko", "lejk-o", "lake (pigment).", "0"],
["lekanto", "lekant-o", "[UV] ox-eye-(dog-moon-)daisy, marguerite (<I>Leucanthemum</I>). <B>~eto</B>, daisy, gowan (<I>Bellis perennis</I>).", "0"],
["lekcio", "lekci-o", "[OA] lecture, paper (K 77/7, 258/12). ~i (<I>fari ~on</I>). ➞ <I>legaĵ, lektor, preleg</I>.", "0"],
["leki", "lek-i", "(<I>-n</I>) [UV], Lick, pass the tongue over: <I>~i katidon, poŝtmarkon, vundon</I>. <B>f</B> <I>~i polvon</I> (Ps 72/9). (<I>karesi): oni ~as la manon, sed celas la panon. (tuŝi pasante): flamoj ~as la domon, ondoj la rokon</I>. <B>~(ad)o</B>, -(ing). <B>For~i</B>, lick up. if <B>Teler~isto</B>, parasite, sponger.", "0"],
["leksikografio", "leksikograf-io", "<B>-o</B>, -ograpĥ-y, -er.", "0"],
["leksikono", "leksik/on-o", "[UV] lexic/on, dictionary of classical languages.", "0"],
["lektoro", "lektor-o", "(university) reader, lecturer. ➞ <B><I>preleg, profesor</I></B>.", "0"],
["lemingo", "leming-o", "(zoo) lemming (<I>Lemmus</I>).", "0"],
["lemno", "lemn-o", "(<I>akvolento</I> 3 FA 47/21; 4 FA 68/24), duckweed, lentil-dew (<I>Lemna</I>).", "0"],
["lemuro", "lemur-o", "(zoo) Lemur (<I>Lemur). ~o krispa,</I> ruffed 1. <I>~o ringvosta</I>, ring-tailed 1. ➞ <I>tarsi</I>.", "0"],
["lenso", "lens-o", "[OA] (opt) Lens. <I>~o konkava, konveksa. ~o diverĝiga, zona</I>, diverging (zone) lens. <B>Kontakt~o</B>, contact 1. (anat) <B>Okul~o</B>, crystalline lens. <B>~a</B>, lenticular.", "0"],
["lentisko", "lentisk-o", "(<I>mastik-arbo</I>), mastic-tree (<I>Lentiscus</I>).", "0"],
["lento", "lent-o", "[UV] lentil (Ge 25/34) (<I>Lens</I>).", "0"],
["lentugo", "lentug-o", "[UV] freckl/e, spotted pigmentation. <B>~a</B>, -ed.", "0"],
["leono", "leon-o", "[UV] Lion (<I>Panthera led</I>). <B>~a</B>, -ine. <B>~ido</B>, 1-cub. <B>~ino</B>, -ess. <B>~kora</B>, -hearted, intrepid. <B>Mar~o</B>, sea-1 &gt; <I>otari</I>. ➞ <I>dent</I>.", "0"],
["leontodo", "leontod-o", "[UV] (ordinary language) dandelion (technical language <I>taraksako</I>), which see", "0"],
["leontodono", "leontodon-o", "(bot) hawk-bit (<I>Leontodon</I>). Both plants, having toothed leaves, are called <I>leondentoj</I>.", "0"],
["leonuro", "leonur-o", "Mother-wort (<I>Leonurus</I>).", "0"],
["leopardo", "leopard-o", "[UV] leopard (<I>Panthera pardus</I>). <B>Ĉas~o</B>, cheetah (<I>Acinomyx jubatus</I>). ➞ <I>jaguar, ocelot, panter</I>.", "0"],
["lepado", "lepad-o", "stalked (or goose-) barnacle (<I>Lepas</I>). ➞ <I>balan</I>.", "0"],
["lepadogastro", "lepadogastr-o", "(ich) sucker-fish, cling-fish (<I>Lepadogaster</I>).", "0"],
["lepidio", "lepidi-o", "pepper wort (<I>Lepidium). L. sativum (ĝardenkreso, kreseto), =</I> garden cress, the cress of \"mustard and cress\". ➞ <I>kres</I>.", "0"],
["lepidopteroj", "lepidopter-oj", "(<I>Lepidoptera</I>) (Butterflies and Moths). Of the 2050 British 11, some 35 are called Butterflies (<I>Rhopalocera</I>), (e.g., <I>antiop, apatur, argen, atalant, hesperi, koliad, licen, limeni’t, makaon, polionat, pierid, vanes</I>). The rest are called Moths (<I>Heterocera</I>), (e.g., <I>atropos, arkti, hepial, kosus, lasiokamp, saturni, sfing, zigen</I>). Bb are diurnal, with knobbed antennae. Most moths (not all) are nocturnal, and do not have knobbed antennae. The distinction between bb and mm is not made in all langs. A \"butterfly\" is <I>papilio</I>. For \"moth\" <I>faleno</I> and <I>nokta papilio</I> are used (though strictly <I>faleno =</I> gothic m.) <I>Tineo =</I> clothes m. A proposed word <I>moteo</I> (G <I>Motte</I>) merely = tineid moth.", "0"],
["lepismo", "lepism-o", "silverfish (of the kitchen) (<I>Lepisma</I>).", "0"],
["lepismodo", "lepismod-o", "firebrat (of baker’s oven) (<I>Lepismodes</I>).", "0"],
["leporo", "lepor-o", "[UV] Hare (<I>Lepus). Kiu ĉasas du ~ojn kaptas neniun</I>. <B>~o monta</B>, mountain h. (<I>L. timidus</I>). <B>f</B> <I>~a koro</I> (Rj 26/15). <B>~ejo</B>, form. <B>~ido</B>, leveret. <B>~ino</B>, doe h.", "0"],
["lepro", "lepr-o", "[UV] leprosy. <B>~a</B>, leprous. <B>~ulo</B>, leper. <I>~ulejo</I>, lazaret,", "0"],
["lepto", "lept-o", "(ent) harvest-bug(-mite-tick), harvester, whealworm (<I>Lepta</I>).", "0"],
["lerni", "lern-i", "(<I>-n, -i</I>) [UV], Learn, acquire knowledge of (skill in), make one’s master of. <I>~i arton, lecionon, muzikon. ~i bicikli, kalkuli, legi, obei. ~i diligente, parkere. ~i el la sperto. Por sperto kaj</I> <B>~o</B> <I>ne sufiĉas eterno</I>. <B>~ado</B>, learning, study. <B>~anto</B>, learner, pupil. <I>~antaro</I>, class. <I>Ek~anto</I>, beginner, tyro. <I>Kun~anto</I>, fellow-student. <I>Meti~anto</I>, apprentice. <I>Facile</I> <B>~ebla</B>, easy to learn. <B>~ejo</B>, [UV] school <I>[Ne= skolo], ~ejo elementa, mezgrada, supera. Popol~ejo</I>, primary school, <B>f</B> <I>La ~ejo de la vivo. ~eja ferio</I>, school holidays, vacation. <I>~ejano</I>, scholar, schoolboy. <I>~ejestro,</I> headmaster, principal. <B>~ema</B>, assiduous, studious. <B>~igi</B> (teach) <I>ion al iu; iun pri io</I> (Jer 9/20). <B>El~i</B>, <B>Fin~i</B> (<I>~i funde</I>), learn thoroughly, master. <B>Mal~i</B>, unlearn. <B>Mem~into</B> (<I>aŭtodidakto</I>), self-taught person. ➞ <I>gimnazi, lice, instru</I>.", "0"],
["lerta", "lert-a", "(<I>je, pri</I>) [UV], Clever. <B>1</B> able, adroit, deft, dexterous, good (at), handy, skilful, talented. <I>~a mano, metiisto, oratoro, ŝtelisto</I>. <B>2</B> (<I>~e farita</I>): c., <I>~a evito, imito, laboro, reklamo, respondo</I>. <B>~(ec)o</B>, dexterity, knack, skill. <B>~aĵo</B>, act of skill, dodge. <B>~ego</B>, consummate skill. <B>~igi</B>, train. <B>~iĝi</B>, gain skill. <B>~ulo</B>, c. person, adept, dab (at). <I>~ulino</I> (Jer 9/17). <I>Paf~ulo</I>, good shot, marksman. <B>Mal~a</B>, awkward, clumsy, maladroit, unskilful. ➞ <I>fuŝ. ~~aĵo,</I> blunder, bungle. <I>~~ulo</I>, bungler, fumbler. <B>Mov~a</B> (<I>facilmova</I>), agile. ➞ <I>kapabl, kompetent, spert</I>.", "0"],
["lesivo", "lesiv-o", "[UV] Lye, alkaline detergent solution. <I>Purigi la manojn per ~o</I> (Ij 9/30). <B>~a</B> <I>tago</I>, washing day. <B>~i</B>, boil (steep, wash) in 1. <I>~i (la plankon</I>), scrub, swill. <B>~aĵo</B>, washing. <I>Pendigi la ~aĵon</I>. <B>~ejo</B>, laundry. <B>~istino</B>, washerwoman, <B>~maŝino</B>, washing machine. ➞ <I>lav, purig</I>.", "0"],
["Lesoto", "Lesot-o", "LS.", "0"],
["letargio", "letargi-o", "[OA] Letharg/y, morbid apathy, drowsiness, inertia, torpidity. <B>~a</B>, -ic. ➞ <I>dormem, inert</I>.", "0"],
["letero", "leter-o", "[UV] Letter, epistle, missive. <I>Ricevi, sendi ~on</I>. <B>Ĉen~o</B>. <B>Ordon~o</B>, warrant, writ. <B>Nefermita ~o</B>, open 1. <I>~o registrita</I>. <B>~a</B>, epistolatory. <I>Korespondi</I> <B>~e</B>, by letter. <B>~aro</B>, correspondence. <B>~isto</B>, postman. <B>~ujo</B>, (<B>~kesto</B>), l-box. ➞ <I>epistol, korespond</I>.", "0"],
["leŭcisko", "leŭcisk-o", "dace (<I>Leuciscus</I>). <B>&gt;</B> <I>chub</I> (L. cephalus). ➞ <I>plot</I>.", "0"],
["leŭkocito", "leŭkocit-o", "leucocyte, white blood- corpuscule.", "0"],
["leŭkojo", "leŭkoj-o", "(bot) snowflake (<I>Leucojum</I>).", "0"],
["leŭkoreo", "leŭkore-o", "leucorrhoea, whites.", "0"],
["leŭtenanto", "leŭtenant-o", "[UV] lieutenant. <B>Sub~o</B>.", "0"],
["levi", "lev-i", "(<I>-n</I>), [UV] Lift, Raise. <B>1</B> elevate, hoist: <I>~i ankron, brakon, ĉapelon, standardon; la manon (kontraŭ). ~i falinton, sin el lito</I>. <B>f</B> <I>~i la glason (toste). ~i nacion kontraŭ nacion, iun el la morto</I>. <B>2</B> r., produce, set up: <I>La vento ~as ondojn, polvon. ~i demandon, projekton</I>. <B>3</B> (<I>pliigi): ~i la voĉon (emfaze, kolere, proteste), la prezon</I>. <B>4</B> (<I>suprenigi): ~i la kapon,</I> hold up one’s head, look up: <I>~i la koron (manojn</I>); pull up (<I>fenestron, kurtenori). ~i la okulojn al la ĉielo</I>. <B>~(ad)o</B>, 1., elevation, heave. <B>~eti</B> (<I>la ŝultrojn</I>), shrug. <B>~iĝi</B>, ascend, rise: (a) <I>Fumo ~iĝas al la ĉielo. La suno ~iĝas en la oriento</I>. (b) (a)rise, get (stand) up: <I>~iĝi de seĝo, el dor mo</I>. (c) (<I>naskiĝi): ~iĝas kolero, krio, nacio, urbo, vento. ~iĝo</I>, ascension. <I>Fru~iĝemo</I>, early rising. <I>Popol~iĝo (revolto</I>), revolt, rising. <I>Sun~iĝo</I>, sunrise. (<I>Mal)~iĝejo</I> (Ps 113/3). <B>~ilo</B> [UV] (<I>~aparato, ~maŝino</I>), 1 ing apparatus. <B>Plad~ilo</B>, service-1. <B>Rul~ilo</B> (<I>vindaso</I>), windlass, winch. <B>Sxarĝ~ilo</B>, goods-1., crane, hoist. ➞ <I>argan, lift</I>. <B>~umi</B>, lever. <I>~umilo</I>, lever, crow-bar, jack. ➞ <I>krik</I>. <B>Brems~(um)ilo</B>, brake lever. <B>Ŝraŭb~umilo</B>, screw-jack. <B>El~i</B>, 1. out. <B>Mal~i</B>, drop, let down, lower. <I>~~iĝi</I>, decrease, descend, go down, set, sink. <B>Re~i</B>, rouse, revive. <I>Re~iĝo,</I> resurrection. ➞ <I>his</I>.", "0"],
["levido", "levid-o", "(Bb) Levite. <B>~oj</B>, Leviticus,", "0"],
["levitado", "levitad-o", "(occ) levitation.", "0"],
["levjatano", "levjatan-o", "(Bb) leviathan; probably = crocodile (Ij/41).", "0"],
["levkojo", "levkoj-o", "[UV] gilliflower, stock (<I>Matthiola</I>). ➞ <I>keirant, malkolmi</I>.", "0"],
["lezo", "lez-o", "(med) lesion, damage, injury, especially morbid change in organ. <B>~i</B>, hurt, injure. <B>Sen~a</B>, scatheless, scot-free.", "0"],
["li", "", "[UV] he. <B>~a</B>, [UV] his. <I>Mi amas</I> ~n, I love him. <I>Mi iras al</I> I go to him. kiu <I>= Tiu, kiu</I> (4 FA 45/18; 212/19).", "0"],
["liano", "lian-o", "[UV] liana, tropical climber (creeper).", "0"],
["liaso", "lias-o", "(geol) Lias, blue limestone. <B>~a</B>, -sic.", "0"],
["Libano", "Liban-o", "[OA-8] LB.", "0"],
["libelo", "libel-o", "[UV] &lt; dragon-fly (<I>Libellula</I>). <B>~eto</B>, damsel (demoiselle) fly. <I>[Ne= kalumni]</I>.", "0"],
["libera", "liber-a", "(<I>de</I>) [UV], Free; at Liber/ty (large), exempt (from), independent (of), loose, not bound, uncontrolled, unfettered, unforced, unrestricted, untrammelled, as regards <B>1</B> another’s will; spontaneous, willing: <I>~a akcepto, decido, rifuzo. ~a volo</I>, freewill. <B>2</B> duty, oblign, restraint, ties (material or moral): <I>~a de ĉagreno, doloro, ĵuro, peko, ŝuldo, zorgo. ~a rado</I>, f-wheel. <I>~a amo, fluo, mano, parolo. ~a de katenoj, kiel aero. Lasu lin ~a. Mi estos ~a je la tria</I>. <B>3</B> pol. or social dependence: <I>~a civitano, eklezio, popolo, regno, vivo</I>. <B>4</B> special conditions: <I>~a eniro, eksporto, importo, trafiko. ~a komerco</I>, free trade. <B>5</B> (space or time) (<I>vaka</I>), unoccupied, vacant: <I>~a ĉielo, horo, seĝo, tempo, vespero, vojo. ~a tago</I>, holiday. <I>~a loko</I>, vacancy. <B>6</B> (mus) <I>~a kordo,</I> open string. <B>~e</B>, f-ly, frankly, openly, without let or hindrance. <I>~e decidi, juĝi, paroli, spiri. Ŝiaj haroj falis ~e</I>. <B>~(ec)o</B>, f-dom, 1., immunity, independce, licence (poetic, etc.), right. <I>Britujo, lando de ~o. Doni, gajni ~on. Batali por ~o. ~o politika, presa, religia. Plena ~o, carte blanche</I>, (mec) play. <B>~igi</B>, free, liberate, clear, deliver, disengage, emancipate, exempt, let go, release, relieve (from). <I>~igi de dubo, ŝuldo. ~igi kaptiton, sklavon. Sin ~igi de</I>, free one’s from, get rid of. <I>~iginto</I>, liberator, saviour. <I>~iga pago,</I> ransom. <B>~iĝi</B>, get free. <I>~iĝo</I>, liberation, deliverance. ➞ <I>emancip</I>. <B>~ulo</B>, f-man. <B>~vivulo</B>, libertine. <B>Dis~igi</B>, disband (troops), let down, loose (hair, etc.). <I>~~iĝi</I> (4 FA 81/14). <B>Mal~a</B> (<B>Ne~a</B>), bound, captive, chained, dependent, not free. ➞ <I>brid, buŝum, ten, jug, katen</I>. <I>~~eco</I>, confinement, constraint, detention, duress, imprisonment. <I>~~ejo</I>, jail, prison. ➞ <I>kaĝ, karcer, prizon. ~~igi</I>, confine, deprive of liberty, imprison. <B>Ag~a</B>, with a free hand. <B>Dev~a</B>, exempt from obligations. <B>Pek~igo</B>, absolution from guilt, atonement, remission. <B>Pens~eco</B>, freedom of thought. <B>Tro~a</B>, excessive. ➞ <I>senbar, senceremoni, sendevig, senembaras, senĝen, senmalhelp, senpag</I>.", "0"],
["liberala", "liberal-a", "[OA] (pol, rel), Liberal (in opinion), broad-minded, enlightened, tolerant. <I>~a doktrino, opinio, partio, spirito</I>. <B>~eco</B>, <B>~ismo</B>, -ism. <B>~ulo</B>, 1. <B>~igi</B>, -ize. <B>Tro~a</B>, latitudinarian, lax, loose. <I>[Ne ~~ donacema, malavara]</I>.", "0"],
["Liberio", "Liberi-o", "[OA-8] LR.", "0"],
["libido", "libid-o", "(psy) libido, sex impulse, vital instinct.", "0"],
["Libio", "Libi-o", "[OA-8] LY.", "0"],
["libro", "libr-o", "[UV] Book, work. <B>1</B> (written, printed). <B>2</B> for writing in. Memor~o, not~o. ➞ <I>kajer, registr</I>. <B>Ĉef~o</B>, ledger. <B>Jar~o</B>, annual, year-b. <B>Kas~o</B>, cash-book. <B>Lego~o</B>, reader. <B>Lerno~o</B>, manual, text-b. <B>Poŝ~o</B>. <B>Ring~o</B>, ring-b (loose-leaf). <B>Sorĉ~o</B>, b. of spells. <B>Tag~o</B>, day-b, diary, journal. <B>Vort~o</B> (<I>vortaro</I>), dictionary. <B>~aĉo</B>, rubbishy book of no value. ➞ <B>fi~o</B>, pornographic b. <B>~aro</B>, collection (set) of books. library. <B>~eto</B>, booklet, brochure, (th, mus) libretto (<I>tekstaro</I>). <B>~ujo</B>, b-case. <B>~amanto</B> (<I>bibliofilo</I>), b-lover, bibliophile. <B>~otenanto</B>, [UV] b-keeper. ➞ <I>bibliotek, volum</I>.", "0"],
["licenci", "licenc-i", "License, authorize, give permit (privilege, right, warrant). <B>~o</B>, Licence, authorization, patent, permit. <B>~ito</B>, 1-holder, -ee. <I>Ne~ita</I>, clandestine.", "0"],
["licencio", "licenci-o", "academic rank, degree. <I>Gajni ~on</I>, graduate. <B>~ito</B>, <B>~ulo</B>, -ate, holder of degree.", "0"],
["liceno", "licen-o", "small copper butterfly (<I>Lycaena</I>). <B>~edoj</B> = hairstreaks, blues.", "0"],
["liceo", "lice-o", "[OA] lycee (French) grammar (high) school, state secondary school. <B>~ano</B>, h-s boy. <B>~estro</B>, head, principal. <B>Rim</B>.: The distinction between <I>liceo</I> and <I>gimnazio</I> is not clear: usage differs in various countries.", "0"],
["lici", "lic-i", "(impersonal) (<I>ke, -i) (~~esti permesate, permesiĝi</I>), be allowed (permitted) to, have the right to. <I>Ĉu ~as fumi ĉi tie?</I> May (can) one (is one allowed to) smoke here? <I>Ne ~as</I>, it is not allowed, one may not. <B>~a</B>, licit. <B>Ne~a</B>, illicit.", "0"],
["licio", "lici-o", "box-thorn (<I>Lyciurri</I>).", "0"],
["lidito", "lidit-o", "lyddite.", "0"],
["lieno", "lien-o", "[UV] (anat) spleen, milt. <B>~a</B>, lienal. splenic. <I>[Ne= splen]</I>.", "0"],
["lifto", "lift-o", "[OA] Lift, elevator (for men or goods). <B>~isto</B>, 1-attendant. ➞ <I>elevator</I>.", "0"],
["ligamento", "ligament-o", "(anat) ligament, fibrous tissues joing bones, etc.", "0"],
["ligaturo", "ligatur-o", "(surg, typ) ligature, (mus) (<I>kunliga signo</I>) slur, tie (seven meanings: see <I>Muzika Terminaro</I> 35).", "0"],
["ligi", "lig-i", "(<I>-n</I>), [UV] Bind, fasten, tie. <B>1</B> restrain: <I>~i hundon, frenezulon</I>. <B>f</B> <I>sin ~i</I> (b. one’s, link up) <I>amike, edziĝe, samcele kun</I>. (mus) tie, e.g, <I>du notojn</I>. <B>2</B> tie (do, wrap) up: <I>~i pakajon</I>. <B>3</B> b. up, lash, tie together: <I>~i la harojn, faskon</I>. <B>har~o</B>, [UV] tress. <B>4</B> combine (in order): <I>~i frazojn, ideojn</I>. <B>5</B> put into communication: <I>~i du landojn per fervojo, poŝto</I>. <B>~o</B>, league, alliance, coalition, confederation, union (for common aim). <I>~o de Nacioj. ~o kontraŭmilita</I>. <B>~aĵo</B>, bale, bundle, packet (Ge 42/35). <B>~ano</B>, ally, member of league. <B>~iĝi</B>, band together, join up. <B>~ilo</B>, bond, cord, link. <I>Prem~ilo</I>, garrot, tourniquet, <B>f</B> bond of union, tie. <I>~o de edzeco. Lange</I> <B>~ita</B>, tongue-tied. <B>Al~i</B>, ally, attach, moor (<I>boaton</I>), tether (<I>ĉevalon</I>), tie on (up) to. <I>~~iteco</I>, attachment, constancy, <B>ĉirkaŭ~i</B>, cord (strap, tie) round (<I>brako, pakaĵo</I>). <B>Inter~o</B>, covenant, connection, liaison. <I>~~iteco</I>, interconnection, interdependence. <I>~~iĝi</I>, league together. <B>Kun~i</B>, connect, join (tie) together. (mus) <B>~~aĵo</B><I>,</I> bridge passage. <B>Mal~i</B>, free, unloose, untie. <B>Ne~ita</B>, free, loose, flowing (<I>haroj</I>). <B>Firm~i</B>, lash. <B>ĵur~i</B>, adjure, bind by oath. <B>Prem~i</B> (4 FA 93/36). ➞ <I>bandaĝ, Sen, interplekt, junt, katen, ligatur, zon</I>.", "0"],
["ligno", "lign-o", "[UV] Wood, Timber. <I>~o blanka, dolĉa, (mal-) mola, rezinoza. Flotanta ~o,</I> drift-wood. <B>~a</B>, el <B>~o</B>, of w., t-ed, w-en. <I>~a benko, ŝuo. ~aj blovinstrumentoj,</I> w-wind. <B>Branĉ~o</B>, deadwood. <B>Brul~o</B>, fire-w. <B>Folia (tavola) ~o</B>, ply-w. <B>Roz~o</B>, rose-w, tulip-w. <B>Seg~o</B>, lumber, saw-w. <B>Suk~o</B> (<I>alburno</I>), sap-w. <B>Ŝtip~o</B>, fire- logs. <B>~aĵo</B>, w-work, wooden article. <I>~aĵisto,</I> cabinet-maker, joiner. <B>~aro</B>, stack of t. <B>~eca</B>, w-y. <B>~ejo</B>, t-yard, w-shed. <B>~ero</B>, chip. <B>~isto</B>, t-merchant, w-man. <B>~ito</B>, lignite, brown coal, fossil w. <B>~izi</B>, prop, t. (mine). <B>~okarbo</B>, charcoal. ➞ <I>arbaret, ken, onisk</I>. <B>Rim</B>.: <I>\"Konstruteknika Terminaro\"</I> (1958) gives <I>I RONDLIGNO: &gt;</I> 15 cm, ĉarpenttrunko. 10-15 cm, sparo. 5-10 cm, slano. <B>4</B> cm, paliso. <I>II KVARFACA LIGNO:</I> 10x17-5 cm, trabo. 10-17 • <B>5</B> x 10-17 • <B>5</B> cm, ĉevro. 10-30x5-7-5 cm, dilo. 4-10 X 4-7-5 cm, hafto. 10-25x5 cm, tabulo. 1-8x3-7 cm, lato.", "0"],
["ligurio", "liguri-o", "(Bb) precious stone, probably opal (El 28/19, 39/12).", "0"],
["ligustiko", "ligustik-o", "(bot) lovage (<I>Ligusticum</I>).", "0"],
["ligustro", "ligustr-o", "Privet (<I>Ligustrum). ~a heĝo,</I> p-hedge. ➞ <I>sfinks</I>.", "0"],
["Liĥtenŝtejno", "Liĥtenŝtejn-o", "LI.", "0"],
["likeno", "liken-o", "[UV] <B>1</B> (bot) Lichen. <B>2</B> denotes various skin eruptions <I>[Ne= dartro]</I> (Le 13/6). <B>~a</B>, -ous. ➞ <I>ekzem</I>.", "0"],
["liki", "lik-i", "Leak. <I>La boato, vazo ~as</I>. <B>~o</B>, leak, hole, crack. <B>~a</B>, -y. <B>~aĵo</B>, -age. <B>(Tra)~iĝi</B>, leak through, filter (ooze, percolate, seep, sweat) through. <B>f</B> <I>sekreta informo ~iĝas (estas transdonita</I>). <B>~imuna</B>, air-tight, water-tight.", "0"],
["liknido", "liknid-o", "(bot) ragged robin (<I>Lychnis flos-cuculi</I>), (hort, m. sp).", "0"],
["likoperdo", "likoperd-o", "(<I>polvofungo</I>), puff-ball (<I>Lycoperdon</I>).", "0"],
["likopo", "likop-o", "gipsy-wort (<I>Lycopus</I>).", "0"],
["likopodio", "likopodi-o", "clubmoss (<I>Lycopodium</I>). <B>~a pulvoro</B>, vegetable brimstone (Rj 15/22). <B>~acoj</B>.", "0"],
["likopso", "likops-o", "(bot) bugloss (<I>Lycopsis</I>). ➞ <I>eki</I>.", "0"],
["likva", "likv-a", "(<I>flueca</I>), (ph) Liqui/d. <B>~aĵo</B>, 1. <B>~igi</B>, -fy. <B>~iĝo</B>, -faction. <I>~iĝema,</I> deliquescent. ➞ <I>fluid</I>.", "0"],
["likvidi", "likvid-i", "(<I>-n</I>) [UV], Liquid/ate <I>[Ne= likvigi]</I>. <B>1</B> clear off, discharge, pay. <I>~i konton, ŝuldon</I>. <B>2</B> put an end to, wind up. <I>~i entreprenon, firmon, problemon, situacion</I>. <B>~o</B>, -ation. <B>~ejo</B>, clearing-house. <B>~iĝi</B>, go into -ation. <B>~isto</B>, receiver.", "0"],
["likvido", "likvid-o", "(phon) liquid consonant (<I>I, r</I>).", "0"],
["likvoro", "likvor-o", "[UV] (alcoholic) liqueur. <I>Aniza ~o</I>.", "0"],
["lila", "lil-a", "lilac (colour). ➞ <I>siring</I>.", "0"],
["lilio", "lili-o", "[UV] Lily (<I>Lilium</I>). <B>Akvo~o</B> (<I>nufaro</I>). <B>Tag~o</B> (<I>hemerokalo</I>). <B>~blanka</B>, 1-white. <B>~floro</B>, fleur-de-lis. <B>~acoj</B>.", "0"],
["liliputa", "liliput-a", "lilliputian, diminutive, dwarf, tiny. <I>Saĝo ~a, kapo mamuta</I> (P).", "0"],
["limako", "limak-o", "[UV] Slug (<I>Limax</I>). Konusaj ~oj (<I>eonidae</I>). ~o nigra, black/s. ~a <I>irado</I>, snail’s pace. ➞ <I>helik</I>. <B>Rim</B>.: Ĉe 4 FA 94/17 <I>limako</I> should be <I>kolibro</I>.", "0"],
["limando", "limand-o", "(ich) dab (<I>Pleuroneetes limanda</I>). ➞ <I>sole</I>.", "0"],
["limao", "lima-o", "(mol) file-shell (<I>Lima</I>).", "0"],
["limbo", "limb-o", "limb. <B>1</B> graduated edge of quadrant. <B>2</B> edge of sun, moon, etc. <B>3</B> expanded part of leaf, petal, sepal. <B>4</B> (rc) limbo, <B>f</B> place of oblivion,", "0"],
["limedo", "limed-o", "Lime (fruit) (<I>Citrus aurantifolia Christm</I>). <B>~o acida</B>, acid 1. <B>~a</B> <I>suko</I>, 1-juice. ➞ <I>tili</I>.", "0"],
["limenito", "limenit-o", "white admiral butterfly (<I>Limenitis</I>).", "0"],
["limeriko", "limerik-o", "(<I>versformo</I>), limerick. E.g., <B>\"Step by Step\" 728, 776</B>.", "0"],
["limfo", "limf-o", "(bio) lymph. <B>~a</B>, -atic.", "0"],
["limneo", "limne-o", "pond-snail (<I>Limnaea</I>).", "0"],
["limo", "lim-o", "[UV] Bound, Limit; border, boundary, bounding line, confines. <B>1</B> (space): <I>~o de arbaro, kampo, vojaĝo. Forŝovi ~on</I> (Ho 5/10). <B>2</B> (time): <I>~o de ferio, forpermeso</I>. <B>3</B> (amount): end. <I>~o de forto, monujo, pacienco, povo. Temp~o</I>, term, date of maturity, falling due. <I>Streĉ~o</I>, point of rupture. <B>~i</B> (<I>-n, al) (esti ~o</I>), b., be the b-ary of. <I>Skotlando ~as Anglujon (al Anglujo</I>). <B>~igi</B> [UV] (<I>en, per) (fari ~on</I>). <B>1</B> define (fix, show) the limits of, circumscribe: <I>~i kampon per heĝo, terenon per flagoj</I>. <B>2</B> confine (curb) within limits, restrict, put (set) bb. (11.) to: <I>~igi sin al</I>, confine one’s to. <I>~igi ambicion, esperon, imagon, povon, vidon. ~igi la daŭron de parolado. ~igita scio. ~iga</I>, restrictive. <I>~igo</I>, check, 1-ation, restriction. <I>~igo de armado. Porcia ~igo</I>, rationing, <I>Preter la ~igoj de</I>, beyond the bb. of. <B>~iĝi</B>, be b-ed (1-ed) by, restricted (to). <I>Mia devo ~igas al tio, ke</I>. <B>Apud~a</B>, frontier. <I>~~a tereno</I>, borderland. <B>Ekster~a</B>, <B>Post~a</B>, <B>Preter~a</B>, out-lying, out of bb. <B>Ĝis~i</B>, extend (reach) to. <B>Sam~a</B>, adjacent, bordering, contiguous. <B>Sen~a</B>, borderless, limitless, infinite, unconfined, unlimited. <I>Sen~a fido, povo, spaco, tempo</I>. <B>Trans~iĝi</B>, break bb., cross the boundaries, transgress, trespass. ➞ <I>border, fin, infinit, malvast, senfin</I>.", "0"],
["limolo", "limol-o", "king-crab (<I>Limulus</I>).", "0"],
["limonado", "limonad-o", "[UV] lemonade, (a) 1-juice and water, (b) <I>~o gasa</I>, bottled (fizzy) 1. <I>~ada pulvoro</I>, -ade pwdr.", "0"],
["limonio", "limoni-o", "sea-lavender (<I>Limonium</I>).", "0"],
["limonito", "limonit-o", "(min) limonite, brown iron ore.", "0"],
["limono", "limon-o", "Lemon (<I>Citrus limon</I>) (ordinary language <I>citrono</I>). <B>~a</B> <I>suko</I>, 1-juice. <B>~arbo</B>, 1-tree.", "0"],
["limozo", "limoz-o", "(<I>Ŝlimbirdo</I>), Godwit (<I>Limosa</I>). <B>~o nigravosta</B>, black-tailed g. <B>~o ruĝa</B>, bartailed g.", "0"],
["limuzino", "limuzin-o", "limousine.", "0"],
["linario", "linari-o", "Toad-flax (<I>Linaria</I>). <B>~o hedera</B> (<I>cimbalario</I>), ivy-leaved t.", "0"],
["linĉi", "linĉ-i", "(<I>-n</I>), lynch. <B>~ado</B>, -ing.", "0"],
["lingvo", "lingv-o", "[UV] Language, tongue. <B>1</B> speech, vernacular: <I>~o fremda, nacia, Rusa, vivanta</I>. <B>2</B> (<I>~aĵo, parolmaniero</I>), dialect, form of speech: <I>~o antikva, faka, loka, sekreta; Biblia, ĉiutaga, teknika, aktora, armea, infana, komerca, ŝtelista</I>. <B>3</B> Other means of expression: <I>~o de bestoj, floroj, gestoj, poŝtmarkoj, signoj, surdmutuloj</I>. <B>~a</B>, of 1., lingu/istic. <B>~aĉo</B>, gibberish, jabber, jargon, lingo. <B>~isto</B>, linguist. <B>~istiko</B>, -istics. <I>Inter~istiko</I>. <B>Du~a</B>, bi-lingual. <B>Mond~o</B>. <B>Mult~ulo</B> (<I>poligloto</I>), polyglot. ➞ <I>dialekt, idiom, ĵargon, slang</I>.", "0"],
["linimento", "liniment-o", "liniment, embrocation.", "0"],
["linio", "lini-o", "[UV] Line. <B>1</B> (geom): <I>~o kurba, rekta. Mez~o</I>, median 1ine. <B>2</B> long narrow mark, fold, furrow, seam, etc.: <I>Desegni, streki ~on. ~o sur la mano, vizaĝo. Viv~o</I>, 1ine of life. <I>~o de beleco</I>. (mar) <I>~o egalalta</I>, position line. <B>3</B> direction, demarcate: <I>~o de divido, rezisto, vico</I>. <B>Akvo~o</B>, water-1ine. (mar) <B>Dat~o</B>, date-line, ĉ. 180°. <B>Fort~o</B>, l. of force. <B>Nivel~o</B>, contour-l. <B>Tuŝ~o</B>, (sp) touch-l. <B>Ŝarĝ~o</B>, load-1, plimsoll mark. <B>4</B> connected series, succession: (a) <I>~o fervoja, omnibusa, ŝipa. Aer~o, flug~o,</I> air-1. (b) department of activity: <I>~o komerca</I>. (c) lineage: <I>~o familia, genealogia</I>. <B>5</B> rank, row. <I>~o de arboj, soldatoj</I>. <B>Vic~o</B>, queue. 6 (typ) l. of print. <B>7</B> ruling: <B>Ond~o</B>, wavy rule. <B>Ornam~o</B>, ornamental ruing. <B>Punkt~o</B>, dotted l. <B>Transversal~oj</B>, cross rules. <B>~a</B>, lineal, linear. <I>Inter~a, kurb~a, rekt~a</I>, inter-(curvi -recti-)linear. <B>(laŭ)~e</B>, in line. <B>~i</B> (<I>fari ~ojn). ~ita papero</I>, ruled paper. <B>~aro</B>, (el) installation. (mus) (<I>kvin~o</I>), stave. <I>Granda ~aro,</I> great stave. <I>~ara notacio,</I> staff notation. <B>~eto</B> (<I>Krom~o</I>), (mus) leger-line. <B>(Al)~igi</B>, allign, form in line, line up. <B>~ilo</B> (<I>rektilo</I>), ruler. <B>Super~e</B>, above the line. <B>Flu~a</B>, streamlined. <B>Ond~a</B>, undulating, waving. (mot) <B>Trak~o</B>, white line. ➞ <I>kontur, lim, siluet, strek, sulk, ŝnur, verd, vic</I>.", "0"],
["linko", "link-o", "[UV] (zoo) Lynx (<I>Lynx</I>), <B>~okula</B>, 1-eyed, sharp-sighted. [Ne= <I>ĉener, ligil (interneto)</I>].", "0"],
["lino", "lin-o", "[UV] flax (<I>Linum</I>) (El 9/31, Se 31/13). <B>~aĵo</B>, <B>~tolo</B>, linen(s) (Ho 2/5). <B>~hara</B>, <B>~kolora</B>, flaxen. <B>~oleo</B>, linseed oil, <B>~oleumo</B>, linoleum. <B>~semoj</B>, linseed. <I>~sema kataplasmo</I>, linseed poultice. ➞ <I>ĉarpi, tol</I>.", "0"],
["linoleumo", "linoleum-o", "(<I>vakstapiŝo</I>), linoleum.", "0"],
["linotipo", "linotip-o", "(typ) linotype.", "0"],
["lintelo", "lintel-o", "(arch) lintel, beam, head (over door or window). ➞ <I>supra sojlo</I> (El 12/22).", "0"],
["liparido", "liparid-o", "(ich) sea snail (<I>Liparis</I>).", "0"],
["lipo", "lip-o", "[UV] Lip. <I>~o (mal)supra. ~oj fermitaj, kunpremitaj. Mordi la ~ojn. Ŝmaci per la ~oj. Fari dikan ~on (paŭti). Lepora (fendita) ~o</I>, hare-1. <I>~o de kruĉo</I>. <B>f</B> <I>~oj veramaj. Kiu retenas siajn ~ojn estas saĝa</I>. <B>~a</B> <I>sono (labialo</I>), labial. <B>~i</B> (<I>ĉe blovinstrumento</I>): lip. <B>~ado</B>, lip-ping. <B>~ego</B>, chop (of animal). <B>~legado</B>, l-reading. <B>~servo</B>, l-service. <B>Dik~a</B>, thick-lipped.", "0"],
["liriko", "lirik-o", "[OA] Lyric(al poem). <B>~a</B>, -al. <I>~aj versoj</I>.", "0"],
["liriodendro", "liriodendr-o", "(<I>tuliparbo</I>), tulip-tree (<I>Liliodendron</I>).", "0"],
["lirli", "lirl-i", "babble, purl (<I>rivereto</I>).", "0"],
["liro", "lir-o", "[UV] <B>1</B> (as; obsolete m.i.) Lyr/e. <B>~isto</B>, -ist. <B>~birdo</B> (<I>menuro</I>), l-bird. <B>2</B> lira (former Italian coin).", "0"],
["lisimakio", "lisimaki-o", "(bot) loosestrife (<I>Lysimachia</I>) &gt; creeping Jenny, pennywort, yellow pimpernel.", "0"],
["lisolo", "lisol-o", "Lysol (trade name).", "0"],
["lispi", "lisp-i", "<B>~o</B>, lisp, say \"th\" instead of \"s\".", "0"],
["listelo", "listel-o", "(arch), listel, fillet, band between mouldings or flutes, raised rim or edge, rib (El 25/25; 1 Rĝ 7/28). <B>Angul~o</B>, corner fillet.", "0"],
["listero", "lister-o", "t way blade (orchid) (<I>List era</I>).", "0"],
["listo", "list-o", "[OA] List, catalogue, register, roll (of persons, things). <I>Mank~o</I>, want-1. <I>~o de kandidatoj, membroj, varoj</I>. <B>Prez~o</B>, price-1. <B>~i</B> (<B>en~igi</B>), 1. ➞ <I>indeks, katalog, matrikul, registr</I>.", "0"],
["litanio", "litani-o", "[UV] (rel) litany.", "0"],
["litargiro", "litargir-o", "(chem) litharge (PbO).", "0"],
["literaturo", "literatur-o", "[F], Litera/ture, (realm of) letters, writings. <I>~o de epoko, lingvo, nacio, temo</I>. <B>~a</B>, -ry. <B>~aĵo</B>, piece of l. <B>~isto</B>, -ry man.", "0"],
["litero", "liter-o", "[UV] Letter. <I>[Ne= letero]</I>. <B>1</B> character (of alphabet). <I>~o supersignita</I>. <B>Klin~o</B> (<I>kursiva ~o</I>), cursive letter. <B>Komenc~o</B>, initial. <B>Pres~oj</B>, type. <B>Relief~oj</B>, embossed letters. <B>f</B> <I>malviva ~o</I>, dead letter. <B>2</B> Precise terms, text. <I>La ~o de la leĝo. Ne laŭ ~o, sed laŭ spirito</I> (2 Ko 3/6). <B>(Laŭ)~e</B>, letter by letter, literally, literatim. <I>Traduko laŭ~a</I>. <B>~i</B>, spell. <B>~ado</B>, spelling. <B>~aĵo</B>, 1-ing. <B>~aro</B>, fount, (set) of type. <B>~fandisto</B>, type founder. <B>~kesto</B>, type case. <B>Mis~i</B>, misspell. <B>Trans~i</B>, transcribe into another alphabet.", "0"],
["litio", "liti-o", "(chem) lithium (Li).", "0"],
["lito", "lit-o", "[UV] Bed, couch, resting-place. <I>[Ne= bedo]. Ordigi (pretigi) ~on. Kiu amas la ~on, ne akiros profiton. ~o duloka, klapa, rula, tabula</I>, double (folding, truckle, plank) b. <B>Pend~o</B> (<I>hamako</I>), hammock. <B>Ŝip~o</B>, berth, bunk. <B>~aĉo</B>, pallet, litter. <B>~aĵ(ar)o</B>, b-clothes, -ding. <B>~eto</B>, cot. <B>En~igi</B> (<B>~iĝi</B>), put (get) into b. <B>El~igi</B> (<B>~iĝi</B>), turn (get) out of bed.", "0"],
["litografi", "litograf-i", "[OA] <B>~o</B>, Lithograph, <B>~ado</B>, <B>~io</B>, -y. <B>~isto</B>, -er.", "0"],
["litoreno", "litoren-o", "(zoo) periwinkle, winkle (<I>Littorina</I>).", "0"],
["litorno", "litorn-o", "(<I>sorpa turdo</I>), fieldfare (<I>Tordus pilaris</I>).", "0"],
["litoto", "litot-o", "(rh) litotes, understatement for emphasis, (a) positive: (Ag 5/36), e.g., Rather! He is some lad! (b) negative: e.g., Not bad (Ag 21/38, 2 Rĝ 6/10, 1 Ko 11/17).", "0"],
["Litovujo, Litovio", "Litov-ujo, Litovio", "LT.", "0"],
["litro", "litr-o", "[OA] litre.", "0"],
["liturgio", "liturgi-o", "[OA] Liturg/y, form(ulary) of public worship. <I>~o anglikana, Grek-Roma</I>. <B>~a</B>, -ical. <I>~a kanto, muziko</I>. ➞ <I>kantik</I>.", "0"],
["liuto", "liut-o", "[UV] lut/e, stringed instrument. <B>~eto</B> (<I>mandoro</I>). <B>Bas~o</B> (<I>teorbo</I>).", "0"],
["liveri", "liver-i", "(<I>-n</I>), [UV] Deliver. <B>1</B> distribute: <I>~i lakton, varojn</I>. <B>2</B> furnish, give, present, supply: <I>~i informojn, pruvon, opinion. Ĉe</I> <B>~o</B>, on d-y. <I>Malnova afero en nova ~o</I> (P). <B>~aĵo</B>, d-y. <B>~anto</B>, furnisher, purveyer, supplier. <B>~portisto</B>, roundsman. <I>Leteroj</I> ne~eblaj, dead letters. ➞ <I>prezent, proviz, (trans)don</I>.", "0"],
["livio", "livi-o", "(<I>rokkolombo</I>), rock dove (<I>Columba livia</I>).", "0"],
["livreo", "livre-o", "[UV] Liver/y, servant’s uniform. <B>~e</B> <I>vestita</I>, in 1. <B>~ulo</B>, -ed servant, flunkey.", "0"],
["Lo", "L-o", "[F], letter L.", "0"],
["lobario", "lobari-o", "tree lungwort (lichen) (<I>Lobaria</I>).", "0"],
["lobelio", "lobeli-o", "(bot) lobelia (<I>Lobelia</I>). <B>~o kardinala</B>, cardinal flower.", "0"],
["lobo", "lob-o", "[OA] (anat, arch, bot) Lob/e. <I>~o de hepato, nazo, orelo</I>. <B>~a</B>, -ular. <B>~eto</B>, -ule. <B>~hava</B>, -ed. <B>Tri~uloj</B>, (zoo) trilobites.", "0"],
["lobulario", "lobulari-o", "(bot) sweet alison (<I>Lobularia</I>)<B></B>.", "0"],
["lodiklo", "lodikl-o", "(bot) lodicule, small scale in grass flower. ➞ <I>glum, pale</I>.", "0"],
["lodo", "lod-o", "[UV] (obsolete) half-an-ounce (<I>G. Lot</I>).", "0"],
["lofi", "lof-i", "(sailing) Luff, alter course nearer the wind’s direction. <I>Lofu! (Venten!</I>). <B>Mal~i</B>, turn off the wind; alter course to leeward. <I>Mallofu!</I> (<I>Malventen!</I>).", "0"],
["lofio", "lofi-o", "(<I>mardiablo</I>), angler, frog-fish (<I>Lophius</I>).", "0"],
["lofoforo", "lofofor-o", "<B>1</B> (orn) Impeyan pheasant (<I>Lophophorus</I>). <B>2</B> lophophora cactus.", "0"],
["logano", "logan-o", "loganberry (<I>hibrido inter frambo kaj rubuso</I>).", "0"],
["logaritmo", "logaritm-o", "[OA] logarithm. <B>~a</B> <I>tabelo</I>.", "0"],
["logatomo", "logatom-o", "logatom, artificial word without meaning, for articulation tests.", "0"],
["logi", "log-i", "(<I>as, de, el; -i, -n</I>) [UV]<I>:</I> draw, entice, excite, desire (induce, lure, persuade, tempt) (to). <I>Feliĉo ~as, virto apogas</I>. <B>Seks~o</B>, sex appeal. <B>Al~i</B>, allure, attract, invite. <I>La lumo, muziko, odoro, reklamo, sono min ~~is</I>. <B>~~o</B>, attraction. <B>~~a</B>, alluring, attractive, engaging, inviting, taking, <I>~~a rideto</I>. <B>~~aĵo</B>, attraction. <I>La ĉefa ~~aĵo de la programo</I>. <B>~ilo</B>, bait, inducement, lure, wile. <B>de~i</B> [UV] (<I>For~i</I>), beguile, decoy, lead (lure) away, seduce. <I>De~i virinon. For~i iun de devo, tasko</I>. <B><I>Nede~ebla</I></B>, incorruptible. <B>El~i</B>, draw out, elicit. <B>Mal~i</B>, be repugnant, deter, repel. <B>~~o</B>, deterrant, repellant, repulsive. <B>Flat~i</B>, blandish, cajole, coax, get round, persuade by flattery, wheedle. <B>Tromp~i</B> (Ge 3/13), bamboozle into, cheat, cozen, delude, lead up the garden path. <I>~~ilo</I>, bait. ➞ <I>insid, invit, magnet, tent, sore</I>.", "0"],
["logiko", "logik-o", "[OA] Logic, art of reasoning, correct use of argument. <B>~a</B>, -al, sound, valid (of reasoning). <I>~a konkludo</I>. <B>~aĵo</B>, <B>~eco</B>, -ality. <B>~isto</B>, -ian. <B>Kontraŭ~a</B>, <B>mal~a</B>, <B>ne~a</B>, illogical, unsound, invalid.", "0"],
["logo", "log-o", "(av, mar, mot) Log. <B>~libro</B>, l-book. <B>~ŝnuro</B>, 1-line.", "0"],
["logogrifo", "logogrif-o", "[OA] logogriph, anagrammatic word-puzzle.", "0"],
["loĝi", "loĝ-i", "[UV] <B>1</B> Dwell, Inhabit, live, reside. <I>~i en Parizo</I>. <B>2</B> Lodg/e, put up, stay. <I>~i ĉe amiko, en hotelo</I>. <B>~(ad)o</B>, abode, sojourn, stay. <I>~o kaj nutro</I>, board and l-ing. <I>~adejo (domicilo</I>), domicile, <B>~anto</B>, dweller, inhabiant, occupier, resident. <I>~antaro (populacio</I>), population. <B>~ata</B>, i-ed, occupied, peopled, populated. <I>Dense ~ata</I>, populous. <I>Ne~ata</I>, uni-ed. <I>Tro~ata</I>, overcrowded. <I>Dens~ateco</I>, high population density. <I>~atigi</I>, people. <B>~ebla</B>, habitable (Le 25/29). <B>~ejo</B> (<I>~domo, ~loko</I>), abode, dwelling, habitation, house, l-ings, place of residence, quarters. <B>~igi</B>, accomodate, give a home to, put up. <I>~igi amikon ĉe si</I>. <B>~iĝi</B>, settle (in), take up one’s abode (at). <B>Ek~i</B>, settle in, take up residence. <B>Kun~i</B>, live together. <B>Pas~anto</B>, sojourner, temporary d-er (Ge 23/4). <I>Pas~ejo</I>, lodgings. <B>Pra~anto</B>, aboriginal. <B>Trans~iĝi</B>, change one’s d-ing, move. ➞ <I>ej, gast, pension, rest, viv</I>.", "0"],
["loĝio", "loĝi-o", "[UV] <B>1</B> box (theatre). <B>2</B> lodge (masonic).", "0"],
["lojala", "lojal-a", "[OA] Loyal; devoted, faithful (in allegiance to duty, love, or obligation); leal, staunch, true, trusty. <I>~a amiko, Esperantisto, konduto</I>. <B>~eco</B>, loyalty, allegiance, devction, good faith. <B>~ulo</B>, l-ist. <B>Mal~a</B>, disloyal, dishonourable, unfaithful. ➞ <I>fidel, honest, perfid</I>.", "0"],
["lojto", "lojt-o", "[UV] (ich) burbot, eel pout (<I>Lota</I>).", "0"],
["lokalizi", "lokaliz-i", "(<I>-n</I>), Localize. <B>1</B> confine, restrict (in extent or place). <I>~i epidemion, incendion, militon</I>. <B>2</B> Locate. <I>~i tumoron</I>.", "0"],
["lokalo", "lokal-o", "premises, quarters.", "0"],
["lokaŭto", "lokaŭt-o", "(<I>mastrostriko</I>), lock-out.", "0"],
["loko", "lok-o", "[UV] Plac/e. <B>1</B> position, situation. <I>Okupi ~on. La ĝusta homo en la ĝusta ~o. Jen ~o por sidi (vidi</I>). ~o (pozicio) de ŝipo, <I>ship’s position</I>. <I>~o kalkulita, observita, taksita</I>.<I> <B>f</B> Kion vi farus sur mia ~o (in my shoes)? Havi ~on (okazi</I>); <I>occur, take p</I>. <I>Alia ~o ĉe ekzameno, en ofico, en la koro</I>. <I><B>2</B> district, locality, location, region, territory</I>. <I>~o bela, marborda, trankvila</I>.<I> <B>Kuŝ~o</B>, den, lair, resting-p. <B>Mank~o</B>, gap. <B>Sid~o</B>, p. to sit, room, seat. <B>Ŝut~o</B>, dump, rubbish-heap. <B>~a</B>, local, regional, indigenous</I>. <I>~a gazeto, kutimo, komitato, movado</I>.<I> <B>~i</B> (<I>-n</I>) (ineti</I>), <I>put (in p.) set. ~i gaston ĉe tablo, libron sur breton, iun sur la tronon</I>.<I> <B>~ado</B>, -ing. <B>~aĵo</B>, localism. <B>~eto</B>, small spot, corner, nook. <B>~iĝi</B>, be -ed, situated. <B>Ali~e</B>, elsewhere. <B>~~en</B> (Ru 2/22). <B>De~i</B>, displace, dislocate. <B>Dis~i</B>, p. here and there, disperse, distribute. <B>En~iĝi</B>, settle down. <B>Ĝusta~e</B>, in (proper, right) place. <B>Iu~e</B>, somewhere. <B>Mis~i</B>, misplace. <B>Neĝusta~e</B>, out of p. <B>Trans~i</B>, p. elsewhere, displace, shift, transfer, transport. <B>~~iĝo</B>, displacement</I>. <B>~~iĝi</B>, <I>change p., move. <B>Unu~a</B> (single) lito</I>. <I>➞ ej, invest, met, pozici, region, situaci</I>.", "0"],
["lokomobilo", "lokomobil-o", "[OA] traction engine.", "0"],
["lokomotivo", "lokomotiv-o", "[UV] (ry) engine, locomotive.", "0"],
["loksio", "loksi-o", "(<I>krucbekulo</I>), (orn) cross-bill (<I>Loxia</I>).", "0"],
["lokustelo", "lokustel-o", "(<I>grilbirdo</I>), grasshopper Warbler (<I>Locustella</I>) &gt; moustached and river ww. ➞ <I>silvi</I>.", "0"],
["lokusto", "lokust-o", "Grasshopper (<I>Locusta</I>), fam. of green or meadow gg with long antennae. Granda verda <B>~o</B>, gt. green g. &gt; <I>katididoj</I>. [<I>Ne = akrido</I> (locust)],", "0"],
["loligo", "lolig-o", "squid (<I>Loligo</I>). ➞ <I>sepi</I>.", "0"],
["lolo", "lol-o", "[UV] (<I>Lolium</I>), rye-grass, way-bent (<I>L. perenne</I>). Darnel, tares, (<I>L. temulentum</I>) (Mt 13/25). <I>[Ne= sekal]</I>.", "0"],
["lombardi", "lombard-i", "(<I>-n</I>), Pawn. <B>~o</B>, loan against security. <B>~itaĵo</B>, pledge. <B>~ejo</B>, p-shop. <B>~isto</B>, p-broker.", "0"],
["lomo", "lom-o", "loam, soil of clay, sand, and humus.", "0"],
["longa", "long-a", "[UV] Long, extended. <B>1</B> (space = <I>longforma): ~a frazo, letero, strato. ~a dek futojn (je dek futoj</I>), 10 ft long. <B>2</B> (time, duration <I>= ~edaŭra</I>): lengthy, protracted. <I>~a kunveno, laboro, tago, vivo, vizito, vojaĝo;</I> lingering (<I>malsano</I>); 1-winded, spun out (<I>prelego</I>). <B>3</B> (phon): <I>~a silabo, vokalo</I>. <B>~e</B>, at length, for a 1ong time. <I>~e atendi, vivi. Antaŭ ~e,</I> a long time ago. <I>Antaŭ ne~e,</I> not long ago, recently. (<I>Jam) de ~e,</I> for a 1. time now (past). <I>Post ne ~e,</I> in a short time. <B>~(ec)o</B>, length, duration, extent. Z. usually wrote <B>longo</B> (Jeĥ 48/13), less often <B>longeco</B> (Rd 3/11). <I>Laŭ sia tuta ~eco</I>, at full length (1 Sa 28/20). <I>Ond~o</I>, wave-length. De~a <I>loĝanto</I>, old-time inhabitant. <I>De~e</I> (Jes 30/33). <B>(laŭ)~e</B>, [UV] along(side), endways, lengthways, fore-and-aft, longitudinally. <B>Pli~igi</B>, elongate, lengthen, prolong, protract, stretch. <B>~eta</B>, (<I>iom ~a</I>), -ish. <B>Mal~a</B>, (a. <I>kurta</I>) short, brief. <I>~~a frazo, jupo, kolero, kunsido, vivo. Paroli</I> <B>~~e</B>, briefly, in a few words. (<I>Pli)~~igi</I>, abbreviate, shorten. <B>Tro~a</B>, over-long, prolix. ➞ <I>etern, kurt</I>.", "0"],
["longerono", "longeron-o", "(av) longeron.", "0"],
["longi", "longi-", "(ppfx) longi-. (ent) ~korna, -corn, (orn) ~pena, ~rostra, -pennate, -rostral.", "0"],
["longitudo", "longitud-o", "(as, geog) longitude. <I>Astra ~o</I>, root ascension.", "0"],
["lonicero", "lonicer-o", "[UV] honeysuckle, woodbine <B>(<I>Lonicera</I>)</B>.", "0"],
["lopi", "lop-i", "<B>~o</B>, (av) loop.", "0"],
["lordo", "lord-o", "[OA] Lord, peer, nobleman. <B>~a Ĉambro</B>, House of Lords. <B>Lia ~a moŝto</B>, his lordship. <B>~ino</B>, Lady.", "0"],
["lorio", "lori-o", "<B>(orn) lory (</B>Lorius, Eos, Domicella, etc.).", "0"],
["loriso", "loris-o", "(zoo) loris (<I>Loris</I>). <B>~oj</B> <I>malrapida, svelta</I>. ➞ <I>perodikt</I>.", "0"],
["lorno", "lorn-o", "[UV] field-glass, spy-glass. <B>~eto</B>, opera glasses. <B>Du~eto</B>, binoculars. ➞ <I>binokl, teleskop</I>.", "0"],
["loterio", "loteri-o", "[OA] lottery, <B>f</B> <I>Edziĝo estas ~o</I> (defies calculation). <B>~a</B> <I>bileto</I>, ➞ <I>tombol</I>.", "0"],
["loti", "lot-i", "[UV] (decide by) Lot, cast (draw) lots. <I>~i inter</I> (Sa 14/42), <I>pri</I> (Ps 22/18). <B>~o</B>, lot. (act, result): change, decision, hazard. <I>~o de (por</I>) (Jos 16/1, 18/11). <I>~o ĉesigas disputojn</I> (Se 18/18). <I>~o agrabla</I> (Ps 16/6). <I>La ~o donis, eliris (falis) por, trafis</I> (fell on) (Jos 19/1, Ag 1/26, Jona 1/7). <I>Gajni la grandan ~on</I> (4 FA 149/6). <I>La dua ~o</I> (Jos 19/1). <I>Doni per ~o</I> (Jos 21/4). <I>Fari ~ojn</I> (Le 16/8). <I>Jeti ~on</I> (Se 16/33). <B>2</B> destiny, fate: <I>Tia estis la ~o de</I> (Jes 17/14). <I>Dividi, elekti, mezuri</I> <B>~e</B> (Jeĥ 48/29, 24/6, Mi 2/5). <B>~aĵo</B>, allotment, assignment, portion, share (Jos 17/14). <B>~ilo</B>, object. used for casting lots. <B>~umi</B> (<I>pri~i) (-n</I>) [UV] (Jes 34/17), allot, disposed of by lot, raffle.", "0"],
["lotuso", "lotus-o", "Lotus. <B>1</B> (bot) birdsfoot trefoil (<I>Lotus</I>). <B>2</B> (myth) lotus-tree, whose fruits cause forget feelings of homeland. <B>3</B> Egyptian (Asian) lotus. (4 FA 50/23). ➞ <I>nelumb, nimfe</I>. <B>4</B> (arch) floral ornament. ➞ <I>ornitop</I>.", "0"],
["loza", "loz-a", "= malkompakta, malstreĉata, malstrikta. Loose.", "0"],
["lozango", "lozang-o", "[OA] <B>1</B> diamond, rhomboid figure. <B>2</B> object. of that shape, heraldic figure, cut jewel, lozenge, etc. ➞ <I>pastel</I>.", "0"],
["lubriki", "lubrik-i", "(<I>-n</I>), Lubric/ate, grease, oil, ~(ad)o, -ation. <I>~ado aŭtomat-(eentr -kontinu-man-meĉ-)a</I>. <B>~aĵo</B>, -ant. <I>~aĵo likva (oleo</I>), oil. <B>~aĵo</B> <I>solida (graso</I>), grease. <B>~ilo</B>, <B>~isto</B>. ➞ <I>ŝmir</I>.", "0"],
["lucerno", "lucern-o", "[OA] hanging lamp (as in church or house) (El 25/37, 1 Sa 3/3). <B>f</B> (2 Sa 21/17). <B>~eto</B> (Ij 12/5). ➞ <I>luzern, medikag</I>.", "0"],
["lucida", "lucid-a", "Lucid, clear in style or expression. <B>~eco</B>, -ity.", "0"],
["ludi", "lud-i", "(<I>nt, -n) [UV]</I>, Play. <B>1</B> amuse one’s, frolic, sport: <I>~i kun kato, laŭ la reguloj, per pilko, sur la korto. ~i kartojn</I>. <B>f</B> <I>La vento ~is kun ŝiaj haroj. ~i okule (okulumi</I>). <B>2</B> (mus): <B>~i</B> <I>fluton, harpon, per harpo, sur harpo</I> (Ap 14/2). <I>~i fugon, melodion. <B>3</B> (th) (prezenti), act, perform on stage (H/61</I>): <I>~i Hamleton, rolon</I>. <B>4</B> (<I>imiti, ŝajnigi): ~i militon, p. at soldiers. <B>~o</B>, <B>1</B> p., sport, etc. ~o danĝera. ~o aparte, kaj aferoj aparte. Floraj ~oj, literary competitions in Catalonia. <B>2</B> (mus, th), p., performance. ~o de harpo. <B>3</B> (mec</I>) (<I>movlibero), freedom of movement, play (of joint, etc.). <B>4</B> (gm) <B>bar~o</B>, prisoner’s base. <B>kart~i</B>, p. cards. <B>kaŝ~o</B>, hide and seek. <B>prov~o</B>, rehearsal</I>. <I>lasta prov~o, dress rehearsal. <B>ring~o</B>, hoop-la. <B>ŝak~o</B>, game of chess. <B>tuŝ~o</B>, blind man’s buff, touch. <B>vet~i</B>, gamble. <B>vort~o</B>, play on words, pun</I>. <I>diri (fari) ion <B>~e</B>, in p., not seriously. <B>~anto</B>, <B>~isto</B>, -er, performer. <B>~ejo</B>, p-ground. <B>~ema</B>, p-ful, frolicsm, sportive. <B>~ilo</B>, toy</I>. <B>flug~ilo</B> (<I>kajto</I>), <I>kite. <B>antaŭ~o</B>, <B>inter~o</B>, <B>post~o</B>, (mus) prelude, interlude, postlude. <B>for~i</B> (game away</I>) <I>sian havon</I>.<I> <B>kun~anto</B>, p-fellow, partner</I>.", "0"],
["lufo", "luf-o", "(bot) luffa (<I>Luffa). ~a spongo,</I> loofah.", "0"],
["lugro", "lugr-o", "(mar) lugger, small ship, with 4-cornered sails set fore-and-aft.", "0"],
["lui", "lu-i", "(<I>-n</I>) [UV] (<I>~preni de iu</I>), (take on) Hire, book, rent. <I>~i ĉambron, domon, frakon, veturilon</I>. <B>~ado</B>, h., tenancy. <B>~anto</B>, -er, tenant. <B>~ebla</B>, on h., to (be) let. <I>~ebla domo,</I> house to let. <B>~igi</B> (<I>-n) (~doni al iu</I>), let on h., let out. <I>~igant(in)o</I>, land-lord (-lady). <B>~pago</B>, <B>~prezo</B>, cost of h., rent. <B>Sub~igi</B>, sublet. ➞ <I>dung, farm</I>.", "0"],
["lukano", "lukan-o", "(<I>cervskarabo</I>), stag-beetle (<I>Lucanus cervus</I>).", "0"],
["luko", "luk-o", "skylight, small opening in ceiling, roof, or wall, to admit light, (mar) port-hole. <I>Kav~o, kel~o</I>, air-trap, vent (ilator). <B>Mansarda ~o</B>, attic (dormer) window. <B>~eto</B>, Judas-hole, spyhole in door.", "0"],
["Luksemburgo", "Luksemburg-o", "LU.", "0"],
["lukso", "luks-o", "[UV] Luxur/y, costly comfort or display, ease. <B>~a</B>, -iant, -ious, expensively got up, profuse, sumptuous, sybaritic. <I>~a bindo, loĝejo, manĝo, vivo. ~a vesto, sed malplena poŝo</I>. <B>~e</B>, in clover (1.) on a bed of roses. <I>Vivi larĝe kaj ~e</I>. <B>~(ad)i</B>, -iate, be -ious, enjoy one’s, revel, take keen delight. <B>~aĵo</B>, l. <I>~aĵeto</I>, curio, knick-knack, trinket. <B>~ego</B>, splendour. <B>~ema</B>, -ious. <I>~emulo</I>, sybarite. <B>Mal~a</B>, frugal. <B>Ne~a</B>, <B>Sen~a</B>, (<I>modesta, simpla</I>), homely, plain, simple. ➞ <I>komfort, kost, pomp, riĉ, volupt</I>.", "0"],
["lukti", "lukt-i", "(<I>kun</I>) [OA], (nt) <B>1</B> contend, grapple, strive, struggle, tussle (Ge 30/8, 32/24). <I>~i por ekzisto; kontraŭ fajro, morto, mizero, sorto, timo, malfacilaĵoj. Ŝnurega ~o,</I> tug of war. <B>2</B> (sp) Wrestle. <B>~(ad)o</B>, -ing. <B>~isto</B>, -er. <B>~ejo</B>, arena, ring. ➞ <I>barakt, batal</I>.", "0"],
["luli", "lul-i", "(<I>-n</I>), [UV] Lull, cradle, hush, soothe, rock (send) to sleep. <I>~i infaneton per kantado</I>. <B>f</B> quieten. (<I>For)~i ĉagrenon, suspekton, timon</I>. <B>~e</B> <I>dormigi</I>, 1. to sleep. <B>~ilo</B>, [UV] cradle, rocker, <B>f</B> (<I>kovejo), Arabujo, la ~ilo de astronomio</I>. <B>Brak~i</B>, dandle, nurse in the arms. ➞ <I>balanc, dormig, kvietig</I>.", "0"],
["lumbo", "lumb-o", "[UV] Loin(s). haunch, small of back. <I>Zonu vian ~on</I>, gird up your 11. (Ps 45/3). <B>f</B> (Na 2/10). <B>~a</B> <I>regiono,</I> lumbar region. <B>~aĵo</B>, fillet, haunch, sirloin. <B>~doloro</B>, lumbago. ➞ <I>femur, koks, tali</I>.", "0"],
["lumbriko", "lumbrik-o", "[OA] earthworm (<I>Lumbricus</I>).", "0"],
["lumeno", "lumen-o", "lumen, unit of light energy.", "0"],
["lumineska", "luminesk-a", "luminesc/ent, luminiferous. ➞ <I>fosforesk</I>.", "0"],
["lumo", "lum-o", "[UV] Light. <B>1</B> visible rays, radiance. <I>Estu ~o</I> (Ge 1/3). <I>Ark~o, gas~o, lamp~o, lun~o, sun~o, tag~o. ~o elektra, inkandeska</I>. <B>Eklipsa</B> <B>~o</B>, intermittent light. <B>Flank~o</B> ruĝa, port light; verda, starboard light. <B>Norda ~o</B>, <I>aurora borealis</I>. <B>Plafona ~o</B>, ceiling (roof) l. <B>Plank~o</B>, foot-l. <B>Rotacia</B> <B>~o</B> (<I>turn~o</I>), revolving light. <B>Signal~o</B>, harbour (navigation) 1. <B>Trafik~o</B>, traffic light. <B>Vag~o</B>, Will o’ the wisp. <B>Vost~o</B>, rear l. <B>f</B> <I>Prezenti ion en favora ~o. Preĝi por ~o (gvido). Sekvi la ~on de la evangelio</I>. <B>2</B> luminary, person of eminence, light, and leading: <I>Esti ~o al</I>, be a light to. <B>~i</B>, be radiant, emit (give) l., shine, <B>f</B> <I>Lia vizaĝo ~is de ĝojo. ~radii</I> (El 34/30). ~a (<I>~hela, ~plena</I>), giving or reflecting light, bright, effulgent, luminous, radiant, shining. <I>~a ĉambro, tago. Estas</I> <B>~e!</B> <B>~aĵo</B>, luminous body (Ge 1/14). <B>~eco</B>, luminosity. <B>~egi</B>, glare, be brilliant (resplendent), emit a blinding light. <B>~eto</B>, gleam, glimmer. <B>~igi</B> (<I>doni ~on al</I>) (Ps 18/28). (a) Give l. to, illuminate, lighten, make (provide a) 1.: <I>~igi ĉambron, groton, straton</I>. (b) brighten: <I>La tapeto ~igas la ĉambron, rideto la vizaĝon</I>. <B>f</B> shed 1. upon, help to explain. <I>~igi (ĵeti ~on sur) misteron, problemon. ~igado</I> (No 4/16), illumination, 1-ing. <B>Difuza ~igo</B>, diffused l-ing. <B>Verŝ~igo</B>, flood 1-ing. <B>~(ig)ilo</B>, object. producing l., e.g., <I>lampo, torĉo</I> (Ce 1/12, Ps 18/28, Se 13/9). <B>Gvid~ilo</B>, beacon. <B>Serĉ~ilo</B>, search-light. <B>Ek~i</B>, <B>1</B> dawn, <B>2</B> burst into 1ight, flash out. (<I>Ek)~igi</I>, set alight. <I>Ek~igi elektron, gason, kandelon, lampon</I>. <B>mal~a</B>, [UV] Dark, obscure, sombre. ➞ <I>nebul, nub, ombr. ~~a arbaro, mistero, nokto. ~~aj tagoj</I>. <B>~~o</B>, darkness. <I>~~e verda</I>, d. green. <I>~~igi, ~~iĝi</I>, darken. <I>~~igo</I>, black-out. <B>Mem~a</B>, luminous. <B>Pri~i</B> (<I>= lumigi</I>). <B>Sen~a</B>, dim, unlighted. <I>Sen~igi</I>, turn out the 1. <B>~trairebla</B> (<I>diafana</I>), translucent. ➞ <I>bril, hel, radi</I>. <B>Rim</B>.: At first Z. used <I>lum-i, ~ita</I> (not <I>lumigi</I>): later <I>prilumi,</I> e.g., Ne 9/12; Ij 33/30, and often in 1 FA and 2 FA.", "0"],
["lumpo", "lump-o", "(ich) lumpsucker, sea-hen (<I>Cyclopterus lumpus</I>).", "0"],
["lunario", "lunari-o", "(bot) honesty (<I>Lunaria</I>).", "0"],
["lunatika", "lunatik-a", "[UV] (<I>lunfrapita</I>), <B>~a</B>, moonstruck; In various countries means <B>1</B> <I>kapriculo,</I> <B>2</B> <I>somnambulo</I>, or <B>3</B> <I>frenezulo</I> <B>Rim</B>.: \"Having no definite meaning, and being in any case unneeded, this root may be ignored without loss (B. E. Long).\"", "0"],
["lunĉo", "lunĉ-o", "Lunch, light meal, tiffin. If vague, so better avoided. For those who have their main meal (dinner, <I>tagmanĝo</I>), at midday, <I>~o =</I> mid-morning light refreshment, \"elevenses\". For evening diners, ~o = mid-day meal.", "0"],
["lundo", "lund-o", "[UV] Monday.", "0"],
["lundo", "lund-o", "[UV] Monday.", "0"],
["luno", "lun-o", "[UV] Moon. <I>La ~oj de Marso</I>. <B>f</B> <I>Miel~o</I>, honey-m. <B>~a</B>, lunar. <I>~a fazo, periodo. ~o ĝiba, nova, plena</I>. <B>~eto</B>, (anat) white of nail, (arch) lunette. <B>~forma</B>, lunate. <B>~hela</B>, m-lit. <B>~kvarono</B>, quarter (<I>lasta, unua</I>). ➞ <I>adulari, krescent</I>.", "0"],
["lupeno", "lupen-o", "(bot) lupin (<I>Lupinus</I>).", "0"],
["lupeo", "lupe-o", "(opt) lens, magnifying, reading glass.", "0"],
["lupo", "lup-o", "[UV] Wolf (<I>Canis lupus). Ne por ~o estas supo</I>, It’s too good for the like of you (P). (ac) (<I>kvintaĉo</I>), \"wolf\", 5th out of tune in \"just temperament\". <B>~a</B>, lupine. <B>~e</B> (<I>ege) malsata</I>. <B>~ido</B>, w-cub, whelp. <B>~ino</B>, she-w. ➞ <I>anarik</I>.", "0"],
["lupolo", "lupol-o", "[UV] Hop (<I>Humulus lupulus</I>). <B>~ejo</B>, h-garden. <B>~isto</B>, h-grower. <B>~amento</B>, h-catkin. <B>~plukisto</B>, h-picker.", "0"],
["lupuso", "lupus-o", "(med) lupus, tuberculous infection of membrane.", "0"],
["luscinio", "luscini-o", "(<I>blugorĝulo</I>), (orn) bluethroat (<I>Luscinia</I>) &gt; thrush nightingale,", "0"],
["lusko", "lusk-o", "(ich) whiting pout (<I>Gadus luscus</I>).", "0"],
["lustro", "lustr-o", "[UV] (<I>plurbranĉa pendlumigilo</I>), chandelier (1 FA 34/36). <I>~o elektra, kandela</I>. <B>~ero</B>, lustre, prismatic glass pendant.", "0"],
["lutecio", "luteci-o", "(chem) Lutecium (Lu).", "0"],
["luti", "lut-i", "[UV] Solder, join metals with ~o (<I>~alojo, ~metalo</I>), solder, fused metal alloy. <B>~ado</B>, -ing. <I>~ado malmola</I>, hard ing (<I>brazado). ~ado mola</I>, soft (or tin) -ing. <B>~ilo</B>, -ing iron. ~acido, ~lampo, ~tenajlo, -ing acid (lamp, tongs). <B>Al~i</B>, join by -ing. <B>Kun~i</B>, s. together. <B>Mal~i</B>, un-s. ➞ <B><I>braz, cement, kunforĝ, veld</I></B>.", "0"],
["lutreolo", "lutreol-o", "European mink (<I>Mustela lutreola</I>). ➞ <I>mustel, visor</I>.", "0"],
["lutro", "lutr-o", "[UV] (zoo) otter (<I>Lutra</I>). ➞ <I>fur, mustel, putor, vizon</I>.", "0"],
["luzerno", "luzern-o", "lucerne (<I>Medikago sativa</I>) &lt; medikag. ➞ lucern.", "0"],
["luzolo", "luzol-o", "woodrush (<I>Luzula</I>).", "0"],
["maato", "maat-o", "(<I>suboficiro</I>), (mar) mate.", "0"],
["maceri", "macer-i", "(<I>-n</I>), Macer/ate, soak, soften by soaking, steep. <B>~ado</B>, -ation. <B>~iĝi</B>. ➞ <I>infuz, satur, tremp</I>.", "0"],
["maco", "mac-o", "[UV] matza, unleavened cake or bread (El 12/8). <I>Festo de la ~oj</I> (El 23/15, 34/18). ➞ <I>oblat</I>.", "0"],
["maĉi", "maĉ-i", "(<I>-n</I>), [UV] Mastic/ate, Chew. <I>~i tabakon</I>. <B>f</B> turn over in one’s mind. <B>~aĵo</B>, quid (tobacco). <B>~ado</B>, -ation. <B>Re~i</B>, c. the cud. ~<B>~ulo</B>, ruminant, <I>Engluti, vori</I> <B>sen~e</B>, bolt. <B>Krak~i</B>, crush noisily with the teeth. <B>Paper~aĵo</B>, paste-board, papier-mache.", "0"],
["maĉo", "maĉ-o", "(sp) match, contest of skill, meeting.", "0"],
["Madagaskaro", "Madagaskar-o", "MG, Madagascar.", "0"],
["madio", "madi-o", "(bot) madia, tarweed (<I>Madia</I>).", "0"],
["madono", "madon-o", "[OA] madonna, the Virgin Mary,", "0"],
["madreporo", "madrepor-o", "(<I>stelkoralo</I>), madrepore, perforate coral (<I>Madrepora</I>).", "0"],
["madrigalo", "madrigal-o", "madrigal, contrapuntal unaccompanied secular pt-song.", "0"],
["magazeno", "magazen-o", "[UV] emporium, large shop, departmental stores [<I>Ne = gazeto</I>], <B>~isto</B>, shop-assistant. <B>Ĉen~o</B>, chain stores. ➞ <I>butik, vendej</I>.", "0"],
["magazino", "magazin-o", "illustrated magazine.", "0"],
["magio", "magi-o", "[UV] Magic, mysterious power, witchcraft, <B>f</B> enchantment. <I>~o blanka, nigra</I>. <B>~a</B>, magic(al), with extraordinary powers, occult, <B>f</B> charming, enchanting. <I>~a ĉarmo, kvadrato, lanterno, rondo, vergo, vorto</I>. <B>~aĵo</B>, magic trick, wizardry. <B>~isto</B>, -ian, sorcerer, wizard. ➞ <I>fe, rav, sort</I>.", "0"],
["magistrato", "magistrat-o", "town or city council. <B>~ano</B>, town councillor. <B>~ejo</B>, council offices. ➞ <B><I>konsil. [Ne= juĝist]</I></B>.", "0"],
["magistro", "magistr-o", "(university title), Master (of arts, etc.). ➞ <I>juĝist</I>.", "0"],
["magnato", "magnat-o", "magnate, powerful man in finance, state, etc.", "0"],
["magnetito", "magnetit-o", "manetite, lodestone.", "0"],
["magneto", "magnet-o", "[UV] Magnet. <B>~(ec)a</B>, -ic. <I>~a ekvatoro, devio, fenomeno, forto, montrilo, poluso</I>. <B>f</B> (<I>mistere alloga</I>), very attractive. <I>~a rideto</I>. <B>~igi</B>, <B>~izi</B>, -ize. <B>~ismo</B>, [OA] -ism. <I>Elektro~ismo</I>. <B>f</B> personal charm. <B>Mal~izi</B>, de-ize.", "0"],
["magnetofono", "magnetofon-o", "tape recorder. ➞ <I>sonbend</I>.", "0"],
["magnezio", "magnezi-o", "(ch, phot), magnesium (Mg). <B>~a sulfato</B>, epsom salts. <B>~ito</B>, magnesite, magnesium cabonate (MgCO<SUB>3</SUB>).", "0"],
["magnezo", "magnez-o", "Magnes/ia (ordinary language), -ium oxide (MgO).", "0"],
["magnolio", "magnoli-o", "(bot) magnolia. <B>~o tripetala</B>, umbrella tree.", "0"],
["mago", "mag-o", "magus, ancient Persian priest or astrologer. <I>La tri ~oj, saĝuloĵ el la oriento</I> (Mi 2/1).", "0"],
["magra", "magr-a", "<I>= malabunda, malgrasa</I>, meagre, spare, scanty.", "0"],
["maĝango", "maĝang-o", "mahjong, Chinese game.", "0"],
["mahagono", "mahagon-o", "[OA] mahogany (<I>Swietenia mahagoni</I>). <B>~a</B> <I>ligno, tablo (2</I> FA 32/26). <B>~(kolor)a</B> (<I>ruĝbruna), m</I>.", "0"],
["mahatmo", "mahatm-o", "(Bud) person with supernatural powers.", "0"],
["mahonio", "mahoni-o", "Oregon grape, holly-leaved barberry (<I>Mahonia</I>). ➞ <I>berberis</I>.", "0"],
["maizo", "maiz-o", "[UV] maize, (Indian) Corn, mealies. (<I>Zed). ~a faruno</I>, c-flour.", "0"],
["majesta", "majest-a", "[UV] Majest/ic, august, grand, imposing, stately. <I>~a fasado, paŝo, pejzaĝo, rivero. Kapo ~a, sed cerbo modesta</I>. <B>~(ec)o</B>, -y, grandeur, elevation, loftiness, stateliness. <I>Via ~o</I> (a. <I>via reĝa Moŝto</I>), your M. ➞ <I>grandioz, import, pomp</I>.", "0"],
["Majo", "Maj-o", "[UV] May (month), <I>~a floro (kratago</I>), may, hawthorn. <B>~fosto</B> (<I>~stango</I>), m-pole. <B>~reĝino</B>, M-queen. <B>~skarabo</B> (<I>melolonto</I>), cockchafer, <B>~tago</B>, May-day.", "0"],
["majoliko", "majolik-o", "[OA] Majolica, Italian earthenware covered with white enamel ornamented with metallic colours. <B>~aĵoĵ</B>, m-ware.", "0"],
["majonezo", "majonez-o", "(cul) mayonnaise, creamy sauce with egg-yolk, etc.", "0"],
["majora", "major-a", "Major. <B>1</B> (mus) <I>~a intervalo</I> (greater by a semitone than minor). <I>~a duto, sesto, septo, trito. ~a akordo</I> (with a m. third at bottom). <I>~a modalo, skalo</I>. Opp <I>minor</I>. <B>2</B> (log) <I>~a premiso</I>.", "0"],
["majoro", "major-o", "[OA] (mil. title) Major.", "0"],
["majstro", "majstr-o", "[UV] <B>1</B> Master (of his art or trade), great artist or teacher. <I>~o artista, muzika</I>, maestro. <I>Koniĝas ~o laŭi sia verko</I>. <B>2</B> title applied to Z. in <I>Mirinda Liro</I> (Nauman, 1891), but deprecated by him (OV 409/1, 28). <B>~(ec)a</B>, m-ly. <I>~a pafisto</I>, crack shot. <I>Ludi</I> <B>~e</B>. <B>~i</B>, be a master of. <B>~aĵo</B>, m-stroke, capital performance. <B>~eco</B>, pre-eminence in ability (proficiency, skill). <I>~eca laboro,</I> m-ly work. ~o bakisto, kantisto, m-baker (-singer). <B>~omasonisto</B> (1 Ko 3/10). <B>~overko</B>, m-piece. <B>Pri~i</B> <I>la fortojn de la naturo</I> (4 FA 82/6). <B>sub~o</B>, [UV] foreman. ➞ <I>ĉampion, instruist, magistr, mastr</I>.", "0"],
["majusklo", "majuskl-o", "capital (upper case) letter,", "0"],
["makabra", "makabr-a", "macabre, grim, gruesome.", "0"],
["makadamo", "makadam-o", "[OA] Macadam. <B>~i</B>, -ize. ➞ <B><I>asfalt, bitum</I>.</B>", "0"],
["makako", "makak-o", "(zoo) macaque &gt; Barbary ape, Rhesus monkey (<I>Macaca</I>).", "0"],
["makaono", "makaon-o", "(<I>papilio hirundvosta</I>), swallowtail butterfly (<I>P. machaori</I>).", "0"],
["makaronio", "makaroni-o", "[OA] macaroni, wheaten paste in tube form. <B>~eto</B>, spaghetti,", "0"],
["makarono", "makaron-o", "[OA] macaroon, almond- flavoured biscuit.", "0"],
["Makedonujo, Makedonio", "Makedon-ujo, Makedoni-o", "MK.", "0"],
["makiavela", "makiavel-a", "(pol) machiavellian, cunning, crafty, scheming, tricky, unscrupulous. <B>~eco</B>, -ism, duplicity, pol. double-dealing. ➞ <I>ĉikan</I>.", "0"],
["makintoŝo", "makintoŝ-o", "macintosh. <B>1</B> water-proof mrtl of cloth and rubber. <B>2</B> cloak of this. ➞ <I>pluvmantel</I>.", "0"],
["makleri", "makler-i", "(<I>pri</I>) [UV], act (do business) as a Broker (between buyer and seller). <B>~aĵo</B>, (~a <I>pago</I>), b’s fee, b-age, commission. <B>~isto</B>, dealer, middleman. <I>Akci~isto,</I> stock-b. <I>Kambi~isto</I>, bill-b.", "0"],
["makropo", "makrop-o", "(technical language) macropus, g. &gt; kangaroo, wallaby. ➞ <I>kanguru</I>.", "0"],
["maksimo", "maksim-o", "[OA] maxim, principle (rule) of conduct, drawn from experience or science. ➞ <I>aforism, mot</I>.", "0"],
["maksimumo", "maksimum-o", "[OA] maximum, highest magnitude (degree, quantity, limit). <I>~a grado, prezo, temperaturo</I>. <B>~e</B>, at most, not more than. <I>Tio kostas ~e ŝilingon</I>. (mus) (a. <I>pliigita</I>), augmented. <B>~a</B> <I>kvinto, sesto, septo, triado</I>. (= a semitone more than major or perfect). Opp <I>minimum</I>.", "0"],
["makulaturo", "makulatur-o", "printer’s waste, spoils, waste-sheets.", "0"],
["makulo", "makul-o", "[UV] <B>1</B> Spot, blot, blur, dirty mark, stain. <I>~o en juvelo, sur la haŭto, suno</I>. <B>Gras~o</B>. i<B>nk~o</B>, ink-stain. <B>Rust~o</B>, iron mould. <B>2</B> blemish, defect. <I>Nenia sanktulo estas sen ~o. Nigra ~o</I>. <B>~eto</B>, blotch, speck(le). <B>~i</B> (<I>-n</I>) (<I>fari ~on</I>), blot, smirch, soil, stain, sully, taint, tarnish. <I>~i honoron, pagon, veston</I>. <B>~ita</B>, speckled, spotted, stained. <B>~oza</B>, -ty, covered with ss. <I>Folia ~ozo</I>, (hort) leaf-s. <B>Sen~a</B>, immaculate, s-less, unsullied, without blemish. <I>Sen~a honoro, konduto, tuko</I>. <B>Brul~o</B>, brand (Jes 3/24). <B>Pek~ita</B>. <B>Ŝpruc~i</B>, bespatter, besmirch, splosh, marble (pages of book),", "0"],
["makzelo", "makzel-o", "[UV] jaw (bone), maxilla (Jĝ 15/15). <B>f</B> jaws (of tongs, vice, etc.).", "0"],
["mal", "mal-", "[UV] (pfx), denotes exact opposite of the idea expressed by the word it modifies. <B>Rim</B>.: <I>Ne = malbon-</I>, but usually (though not always) denotes the less desirable of the two ideas. <I>Ami</I>, love, ~ami, hate. <I>Bela,</I> beautiful. ~bela, ugly. <B>~o</B>, the opposite, reverse. <I>Diri la ~on</I>. <B>~a</B>, o. <I>~a direkto</I>. <B>~e</B>, on the contrary. <B>~en</B> (mar) Astern! <B>~ebla</B>, impossible. <B>~igi</B> (<I>movon</I>), reverse. <B>Rim</B>.: ➞ mal- (opposite); mis- (amiss); ne- (negative); sen- (privative). Mal<I>ordo</I>, disorder; mis<I>ordo</I>, wrong order. Mal<I>utila,</I> injurious; ne<I>utila</I>, useless. Mal<I>simila,</I> dissimilar; sen<I>simila</I>, unique. ➞ <I>kontraŭ</I>.", "0"],
["Malajzio", "Malajzi-o", "MY.", "0"],
["malakito", "malakit-o", "[OA] (min) Malachite, hydrated copper carbonate. <I>~a verdo</I>, m-green.", "0"],
["malario", "malari-o", "[OA] (<I>marĉfebro</I>), Malari/a, various kinds of fever. <B>~a</B>, -al.", "0"],
["malata", "malat-a", "(chem) malic. <I>~a acido</I> (C<SUB>4</SUB>H<SUB>6</SUB>0<SUB>5</SUB>). <B>~o</B>, malate. ➞ <I>pom</I>.", "0"],
["Malavio", "Malavi-o", "MW.", "0"],
["Maldivoj", "Maldiv-oj", "MV.", "0"],
["maleo", "male-o", "<B>1</B> Mallet (croquet, etc.). ~i, strike with m. ~ego (a. <I>martelego</I>), maul, beetle. <B>2</B> (anat) malleus (of ear).", "0"],
["maleolo", "maleol-o", "[UV] Ankle. <I>Alia ĝis la ~oj, a-deep (Jeĥ 47/3</I>).", "0"],
["malgraŭ", "", "[UV] (prep) Notwithstanding, in Spite of. <I>~ do</I>, after all. <I>~ tio</I>, in s. of that, nevertheless. ~ (tio) ke, n. the fact that. Rim.: ➞ spite (stronger) = in s. (defiance) of. <I>~ la pluvo, mi spitis la kuraciston</I>, (in s. of (n.) the rain I defied the doctor) <I>kaj eliris</I>.", "0"],
["malico", "malic-o", "[UV] Malic/e, active ill-will, desire to harm, rancour, spite. <B>~a</B>, -ious, malevolent, spiteful, <I>~a homo, karaktero. ~a ago, celo, intenco, parolo</I>. <B>~i</B>, bear m. <B>~aĵo</B>, -ious action. <B>~eta</B>, ill-natured, <I>~eta infano, okulo, rido, ŝerco</I>. <B>~ega</B> (<I>maligna</I>), <B>~ulo</B> (Se 24/8).", "0"],
["maligna", "malign-a", "malignant. <B>1</B> (med) threatening fatal issue, virulent. <I>~a malsano</I>. <B>f</B> feeling or showing intense ill-will. <I>~a satiro</I>. <B>2</B> cancerous. <I>~a ulcero</I>.", "0"],
["Malio", "Mali-o", "ML.", "0"],
["malkolmio", "malkolmi-o", "(hort) Virginian stock (<I>Malcolmia</I>). Named after Wm. Malcolm; no relation to Virginia. ➞ <I>levkoj</I>.", "0"],
["malŝati", "malŝat-i", "[UV] (<I>neglekti, malzorgi</I>), contemn, despise, disdain, have a poor opinion (think little) of, ignore, scorn, slight, treat as if of no consequence (with indiffce). [<I>Ne =</I> dislike], <I>~i konsilon. Ne ~u la instruon de via patro. Ne ~u vian patrinon kiam ŝi maljuniĝas. Sata animo ne ~as dolĉan sukon. ~i la unuenaskitecon (sian landon</I>) (Ge 25/34, No 14/31, Ps 107/11, Se 3/11, 5/12). <B>~o</B>, disdain, depreciation, lack of a-ion. <I>Malestima ~o</I>, contemptuous disregard. <B>~a</B>, depreciative, pejorative, indifferent. ~e <I>rigardi la aferon (montri la dorson</I>). <B>~inda</B>, negligible, not worth considering. paltry. <B>~indaĵo</B> (<I>senvaloraĵo</I>), thing of no worth.", "0"],
["malto", "malt-o", "[OA] Malt. <B>~a</B>, of m. <I>~a likvoro</I>. ~ejo, m-house. <B>~igi</B>, m. <B>~isto</B>, -ster. (chem) <B>~azo</B>, <B>~ozo</B>, -ase, -ose.", "0"],
["Malto", "Malt-o", "MT.", "0"],
["Malvarma", "Malvarm-a", "(a. <B>frida</B>), <I>Cold</I>. ~a <I>ĉambro, mateno</I>. <I>Estas</I> <B>~e</B>, <I>it is cold. <B>f</B></I> (<I>senemocia, senpasia</I>); ~a <I>akcepto, prudento, spuro. Respondi</I> ~e.<I> <B>~(ec)o</B>, c., coolness</I>. <I>Montri al iu ~econ. Seksa ~eco</I>.<I> <B>~ega</B>, bleak, freezing, icy, intensely cold. <B>~eta</B>, cool. <B>~igi</B>, chill, cool</I>. <I>~iga trinkaĵo. <B>f</B></I> <B>~igi</B> <I>entuziasmon, pour c. water on</I>. <B>~igilo</B>, <I>refrigerator. <B>~iĝi</B>, grow c., cool down</I>. <I>Lia amo ~iĝis</I>.<I> <B>~umi</B>, [UV] catch cold, take a chill. ➞ katar, koriz</I>.", "1"],
["malvo", "malv-o", "[OA] (bot) Mallow (<I>Malva</I>). <B>Moska ~o</B>, musk m. <B>~acoj</B>, <B>~(kolor)a</B>, mauve. ➞ <I>alte, lavater</I>.", "0"],
["Mal~a", "", "(a. <I>olda</I>), Old. <B>1</B> long-established, long-existing. <I>~a amiko, kutimo, ŝuldo</I>. <B>2</B> former, previous. <I>~a metodo, modo</I>. <B>3</B> discarded, spoiled by use. <I>~a domo, vesto</I>. <B>~aĵo</B>, [UV] lumber, o-clothes, etc. <B>~ega</B>, ancient. <B>~iĝinta</B>, obsolete.", "0"],
["Mal~a", "", "ill, sick. <I>Cerbe ~a</I>, demented, insane. <B>~o</B>, illness, complaint, disease, malady. <B>Aer~o</B>, <B>Mar~o</B>, air-sickness, sea-sickness. <B>Akvo~o</B> (<I>hidropso</I>). <B>Ren~o</B>, kidney disease. <B>~i</B>, be ill. <B>~eca</B>, <B>~ema</B>, ailing, diseased, morbid, sickly, unsound. <B>~ega</B>, at death’s door. <B>~eta</B>, indisposed, off colour, out of sorts, poorly, unwell. <B>~igi</B>, make ill, upset. <I>~iga</I>, insanitary. <B>~iĝi</B>, fall ill, sicken. <B>Re~iĝo</B>, relapse. <B>~ulo</B>, invalid. <I>~ulejo (hospitalo</I>), hospital. ➞ <I>fart, higien, pacient, medikament</I>.", "0"],
["Mal~o", "", "Bottom, foot (of mountain, etc.). <I>Plej ~a</I>, lowest. <B>~e</B>, below, at the bottom, down-stairs. <I>Pli ~e</I> (still) lower down. <I>De supre ĝis</I> <B><I>~e</I></B>, from top to b. <I>~ena</I>, downward, to the b. <I>Jxeti (rigardi</I>) ~en, throw (look) down. <I>Iri supren kaj ~en</I>, up and down (not of height, Batalo 8/16). (mus) <I>-ena bato, down</I> beat. <I>-enigi, -eniri</I>, go down., descend, fall. ➞ <I>alt, kulmin, pint, sub, super, vert</I>.", "0"],
["mamo", "mam-o", "[UV] breast, udder, <B>~a</B>, mammary. <B>~ito</B>, mastitis. <B>~ulo</B> (<I>~besto</I>), mammal. <I>~ularo</I>, mammalia. <B>~pinto</B>, nipple, pap, teat. <B>De~igi</B>, wean (Ps 131/2). ➞ <I>brust, sin</I>.", "0"],
["mamono", "mamon-o", "(Bb) Mammon, pelf, riches, wealth (regarded as idol, or evil influence of covetousness) (Lk 16(9-13). <B>~servisto</B>, m-worshipper.", "0"],
["mamuto", "mamut-o", "[OA] Mammoth, large extinct elephant. <B>~a</B>, m. <B>f</B> huge, gigantic. <I>Kresko ~a, sed saĝo liliputa</I> (P).", "0"],
["manao", "mana-o", "[UV] Manna. <B>1</B> (Bb) food from heaven (El 16/31), also figuratively. <B>2</B> (pharm) laxative juice from various trees.", "0"],
["manato", "manat-o", "manatee, see-cow (<I>Manatus</I>).", "0"],
["mancinelo", "mancinel-o", "manchineel tree (<I>Hippomane mancinella). ~a frukto</I>.", "0"],
["mandareno", "mandaren-o", "[OA] mandarin, Chinese official. <I>~a lingvo</I>.", "0"],
["mandarino", "mandarin-o", "(bot) mandarin, tangerine (orange). (<I>Citrus reeticulata, Blanco</I>).", "0"],
["mandato", "mandat-o", "[OA] Mandat/e. <B>1</B> official order, charge, commision, instruction. <I>~o de reprezentanto. Kolonia ~o</I>. <B>2</B> (<I>dokumento</I>) written authty, brief, power of attorney, warrant. <B>3</B> order (to pay), draft. <B>Poŝt~o</B>, postal (money) order. <B>~a</B> <I>teritorio</I>, -ed territory. <B>~ulo</B>, -ary, trustee. ➞ <I>ĉek</I>.", "0"],
["mandiblo", "mandibl-o", "mandible. <B>1</B> lower part of jaw. <B>2</B> either part of beak, or of insect’s jaw.", "0"],
["mandolino", "mandolin-o", "[OA] mandoline.", "0"],
["mandolo", "mandol-o", "(m.i.) mandola. <B>~a</B> <I>familio</I> (Vd <I>Muzika Terminaro</I> 23).", "0"],
["mandoro", "mandor-o", "(<I>liuteto</I>), mandora.", "0"],
["mandragoro", "mandragor-o", "mandrake (<I>Mandragora</I>) (Ge 30/14).", "0"],
["mandrelo", "mandrel-o", "(tech) mandrel, mandril, chuck; lathe axis, cylidrical rod.", "0"],
["mandrilo", "mandril-o", "mandrill, drill (<I>Mandrillus</I>).", "0"],
["maneĝo", "maneĝ-o", "manege. <B>1</B> riding school. <B>2</B> horse-training exercise. ➞ <I>dres</I>.", "0"],
["manekeno", "maneken-o", "mannequin. <B>1</B> person. <B>2</B> tailor’s wax lay figure.", "0"],
["manganato", "", "manganate. ~ika <I>salo</I>. ~oza. Per~ato.", "0"],
["mangano", "mangan-o", "[UV] (chem) Mangan/ese (Mn).", "0"],
["manglo", "mangl-o", "Mangrove (<I>Rhizophora mangle</I>). <B>~arbo</B>, m-tree.", "0"],
["mango", "mang-o", "Mango, fruit of <B>~arbo</B>, m-tree (<I>Mangifera indica</I>).", "0"],
["mangostano", "mangostan-o", "(bot) mangosteen (<I>Garcinia mangostana</I>).", "0"],
["manĝi", "manĝ-i", "(<I>-n</I>, nt), [UV] Eat, swallow; feed, take food (a meal), <B>f</B> consume. <I>Rusto ~as la feron, kaj zorgo la homon</I>. <B>~o</B>, meal, repast. <I>~o el verdaĵo</I> (Se 15/17). <B>maten~o</B>, [UV] breakfast. <B>tag~o</B>, [UV] (<I>= ĉefa ~o</I>), dinner. <B>vesper~o</B>, [UV] supper, evening meal. <B>~aĵo</B>, food, dish, eatables, fodder. <I>~aĵisto</I>, grocer, provision merchant. <B>~ebla</B>, edible. <I>~eblaĵoj,</I> provisions, victuals. <B>~egi</B>, fall on, devour, gormandize, stuff one’s, wolf. <I>~egema,</I> voracious. <I>~egulo</I>, glutton. <B>~ejo</B>, dining-room, -ing house, refectory. <B>~ema</B>, hungry. <I>~emega</I>, famishing, ravenous. <B>~eto</B>, slight repast, snack, <I>~eti</I>, nibble, peck at, taste, toy with. <B>~ilaro</B>, -ing utensils, table-service. <I>Forpreni la ~ilaron</I>, clear away. <B>~ujo</B> (Jes 1/3), crib, manger, trough. <B>~restaĵoj</B>, leavings, scraps. <B>Al~aĵo</B>, appetizer, hors-d’oeuvre, side-dish. <B>Ĉirkaŭ~itaj</B> <I>ostoj</I> (4 FA 27/30). <B>Ek~i</B>, set to. <B>For~i</B>, e. up, finish, <B>f</B> <I>For~i monon, tempon, teron</I>. <B>Kun~anto</B>, mess-mate. <B>Ĉef~aĵo</B>, main dish. <B>Ĉio~a</B>, omnivorous. <B>Karno~a</B>, carnivorous. ➞ <I>glut, nutr, past</I>.", "0"],
["maniero", "manier-o", "[UV] <B>1</B> Manner, Way; mode of action. <B>2</B> outward bearing, peculiarity, style. <B>Ag~o</B>, w. of acting. <B>Dir~o</B>, <B>esprim~o</B>, <B>parol~o</B>, diction, m. (turn) of speech, parlance. <B>Ir~o</B>, gait, walk. <B>Pens~o</B>, mentality. <B>Sid~o</B>, seat (horseman). <B>Uz~o</B>, method of use. <B>Vid~o</B>, <B>Viv~o</B>, way of looking at things, of life. <B>~ismo</B>, affectation. <B>Ali~e</B>, in another way, otherwise. <B>Sam~e</B>, likewise. <B>Tia~e</B>, ke, so that. ➞ <I>-iel, mod, mor</I>.", "0"],
["manifestacio", "manifestaci-o", "[OA] = <B>manifest-ado</B>, <B>~aĵo</B>, public demonstration (OV 377, 436, 562).", "0"],
["manifesti", "manifest-i", "(<I>-n</I>) [OA], (make) Manifest, display, exhibit, evidence, evince, show. <I>~i dankon, estimon, ĝojon, indignon, respekton</I>. <B>Sin~i</B>, show one’s. <B>~o</B>, <B>1</B> m-ation, display. <B>2</B> m., public declaration of opinion in writing. <B>3</B> (mar) <B>Ŝarĝ~o</B>, cargo m. ➞ <I>esprim, ekspozici, evidentig, montr, vidig</I>.", "0"],
["manihoto", "manihot-o", "(bot) cassava plant (<I>Manihot</I>). ➞ <I>kasav, maniok, tapiok</I>.", "0"],
["maniko", "manik-o", "[UV] Sleeve. <B>Vent~o</B>. <B>~a</B> <I>truo</I>. <B>Sen~a</B>, s-less. <I>La Maniko</I>, the British Channel.", "0"],
["manikuri", "manikur-i", "= manflegi.", "0"],
["manio", "mani-o", "[OA] mania, craze, abnormal enthusiasm, passion. <B>~(em)a</B>, cranky, deranged, eccentric. <B>~eto</B>, fad. <B>~ulo</B>, crank, faddist. <B>Mono~o</B>, obsession by a single idea. <B>Ŝtel~o</B> (<I>kleptomanio</I>), kleptomania. ➞ <I>frenezet, kapric</I>.", "0"],
["manioko", "maniok-o", "manioc, sweet cassava.", "0"],
["manipuli", "manipul-i", "(<I>-n) (manuzi</I>) [OA]. Manipulat/e, handle, manage, operate, treat (use) with skill, f <I>~i lingvon</I>. <B>~ado</B>, -ion, handling, technique (M 91/27). ➞ <I>manovr</I>.", "0"],
["maniso", "manis-o", "(zoo) pangolin (<I>Manis</I>).", "0"],
["manki", "mank-i", "[UV] (nt) be lacking, missing, wanting. <I>~as butono, helpanto, mono. ~as al li kuraĝo</I>, he lacks (is wanting in) courage, heart fails him. <I>~as al mi tempo</I>, I have no time (Ij 32/15; Ps 107/38). <I>Ne multe ~is, ke li falu</I>, he was not far from falling. <B>~o</B>, dearth, deficiency, insufficiency, lack, scarcity, shortage, shortcoming. <I>Pro ~o de</I>, from want (in default, through lack) of. <I>~o de laboro, pano, penso. Forigi, ŝtopi ~on</I>, fill a gap. <I>Malgraŭ liaj ~oj</I>, in spite of his shortcomings. <B>~anta</B>, missing. <B>~ego</B>, destitute. <B>~igi</B> (<I>preterlasi</I>), leave out, omit (Jos 11/15). <B>~hava</B>, defective, imperfect. <B>Mal~i</B>, abound. ➞ <I>abund, riĉ, sufiĉ</I>. <B>Sen~a</B>, complete perfect. <I>~~a proviso, respondo. Seninter~a</I>, continuous, steady. <B>Mon~a</B>, hard up. <B>Pluv~o</B>, drought. <B>Sango~a</B>, anaemic. <B>Spiro~a</B>, out of breath. ➞ <I>bezon, forest, nesufiĉ, sen-</I>.", "0"],
["mano", "man-o", "[UV] Hand. <I>Konduki, teni per la ~o. Etendi, premi, teni la ~on. ~o en ~o,</I> h. in h. <B>f</B> <I>En bonaj ~oj. En la ~o</I> (power) <I>de. Lasi fali la ~ojn</I>, lose courage, give up. <I>Ligi la ~ojn. Meti la ~on al</I>, set one’s h. to. <I>Peti la ~on de</I>, propose to. <I>Sub la ~o</I>, ready to h. <B>~a</B>, manual. <B>~e</B>, by h. <I>~e farita</I>. <B>~ego</B>, [UV] paw. <I>Kvar~uloj,</I> quadrumana. <B>~umo</B>, [UV] cuff, ruffle. <B>~dorso</B>, <B>~supro</B>, back of h. <B>~kavo</B>, <B>~plato</B> (<I>polmo</I>), palm, <B>~radiko</B>, wrist. <B>ĉirkaŭ~o</B> [UV] (<I>braceleto</I>). <B>En~igi</B> (<I>ion al iu</I>), h. to, deliver into the hands of. <B>Ambaŭ~e</B>, with both hands. <B>Liber~a</B>, free-h. <B>Plen~o</B> (<I>da</I>), h-ful (of). <B>Propra~e</B> (<I>aŭtografe</I>) skribita, with one’s own handwriting.", "0"],
["manometro", "manometr-o", "[OA] manometer, (gas) pressure gauge.", "0"],
["manovro", "manovr-o", "[UV] (mar, mil) Manoeuvre, strategical or tactical movement, skilful plan, scheme, stratagem. <I>~o armea, politika</I>. <B>~i</B> (<I>-n</I>, nt), m., work for desired position. <B>f</B> employ artifice, manage, pull the strings (wires), (ry) shunt, <B>f</B> <I>lerte ~i</I>, adroitly contrive, skilfully arrange. <I>~i kartojn</I>. <B>~ebla</B>. ➞ <I>intrig, manipul</I>.", "0"],
["mansardo", "mansard-o", "[OA] attic, garret. ~a <I>ĉambreto</I>. ➞ <I>subtegment</I>.", "0"],
["mantao", "manta-o", "(<I>diablo-fiŝo</I>), devil fish (<I>Manta</I>).", "0"],
["mantelo", "mantel-o", "[UV] mantle, cape, cloak, long garment with or without sleeves, wrap. <I>~o kortega, vojaĝa</I>. <B>f</B> cloak, cover. <I>Sub la ~o de afableco kaŝi malamon</I>. (mec) casing, jacket (of cylinder, drum, etc.). <B>Pluv~o</B>, mackintosh, peajacket, raincoat, waterproof. <B>Pot~o</B>, pot cover. <B>Pudro~o</B>, peignoir, lady’s dressing-gown. <B>~eto</B>, mantlet, tippet. ➞ <I>kitel, makintoŝ, palt, pelerin, surtut</I>.", "0"],
["mantilo", "mantil-o", "mantilla, Spanish lace veil for woman’s head and shoulders.", "0"],
["mantiso", "mantis-o", "(mat) mantissa, decimal part of logarithm.", "0"],
["manto", "mant-o", "mantis, praying insect (<I>Mantis</I>).", "0"],
["manufakturo", "manufaktur-o", "[OA] = fabrikejo.", "0"],
["manuskripto", "manuskript-o", "[OA] (<I>manskribaĵo</I>), Manuscript, MS, book (document) written by hand. <B>~a</B>, <B>~e</B>, in m.", "0"],
["mapo", "map-o", "Map. <I>~o landa, stela, strata, urba, vetera, voja; gnomona, merkatora</I>. <B>Mara ~o</B>, chart. <B>Mond~o</B>. <B>mur~o</B>. <B>Rul~o</B>, roller-m. <B>~i</B>, <B>f</B> map out, arrange (plan) in detail. <B>~ado</B>, mapping. <B>~aro</B>, atlas. <B>~isto</B>, m-maker, cartographer. <B>~ujo</B>, m-file. ➞ <I>kartografi, kartograf</I>.", "0"],
["marabuo", "marabu-o", "marabou stork, adjutant (<I>Leptopilos</I>) (4 FA 53/30).", "0"],
["maranto", "marant-o", "arrowroot plant (<I>Maranta</I>). Vd <I>arorut</I>.", "0"],
["marasmio", "marasmi-o", "(<I>fe-ronda fungo</I>), fairy-ring fungus (<I>Marasmius oreades</I>).", "0"],
["marasmo", "marasm-o", "[OA] marasmus, decline, wasting away, progressive emaciation, (f) inactivity. ➞ <I>inert, kaduk, stagn</I>.", "0"],
["marcipano", "marcipan-o", "[UV] marzipan, almond paste.", "0"],
["marĉandi", "marĉand-i", "[UV] Bargain, beat down, haggle (over), try to cheapen, <B>~aĵo</B>, b., something got cheaply. Sen~e, without shillyshallying (beating about the bush).", "0"],
["marĉo", "marĉ-o", "[UV] Marsh, low watery land, bog, mire, morass, swamp. [<I>Ne =</I> march], (Ps 69/2). <B>f</B> <I>~o de malespero, mizero, superstiĉo</I>. <B>Sal~o</B>, salt m. <B>~a</B>, -y, fenny, swampy, squashy. ~aĵo (<B>~ejo</B>, <B>~lando</B>) (<I>ŝlimejo</I>), fen, m-land, (quag) mire, slough, swamp. <B>En~iĝi</B>, sink into mire. ➞ <I>metan, ŝlim</I>.", "0"],
["mardo", "mard-o", "[UV] Tuesday. <I>Antaŭfasta ~o,</I> Shrove T.", "0"],
["marelo", "marel-o", "(<I>hopludo</I>), hopscotch.", "0"],
["margarino", "margarin-o", "[OA] margarine, butter substitute. <I>~o besta, vegetara</I>.", "0"],
["marĝeno", "marĝen-o", "[OA] Margin (of page). <B>~a</B>, -al. (<I>sur</I>)<B>~aĵoj</B>, marginalia, -al notes, references (as in a Bible). <B>~tranĉi</B>, trim the edges.", "0"],
["marimbo", "marimb-o", "(<I>perkutharmoniko</I>), (m.i.) Marimba. <I>~o krania, kukurba, ligna, nuksoŝela, ŝtona</I>. <B>2</B> (modern instruments) <I>~a familio &gt; celesto, glasaro, gongaro, kampaneto, ksilofono, tipofono, tubsonoriloj</I>.", "0"],
["marini", "marin-i", "(<I>-n</I>) [OA], marinade, brine, cure, pickle, souse (with wine, vinegar, and spices). <I>~i betojn, haringojn</I>. <B>~aĵo</B>, food thus spiced. ➞ <I>pekl</I>.", "0"],
["marioneto", "marionet-o", "[OA] marionette, jumping-jack, puppet worked by strings. <I>~a teatro</I>, puppet show, <B>f</B> person without a will of his own.", "0"],
["marketri", "marketr-i", "inlay or overlay pieces of wood, ivory, or metal. <B>~aĵo</B>, marquetry. ➞ <I>parget</I>.", "0"],
["markezo", "markez-o", "marquee, large tent; awning, outside shop-blind, overhanging shutter, etc.", "0"],
["markizo", "markiz-o", "[OA] marquis. <B>~ino</B>, marchioness (by right); <B>~edzino</B> (by marriage).", "0"],
["marko", "mark-o", "[UV] Mark. I (any distinguishing) Sign, impress(ion), line, stamp, trace; indication of character, quality, etc. <I>~o en libro, sur tolo</I>. <B>Akvo~o</B> (<I>filigrano</I>), water-m. <B>Fabrika ~o</B>, brand, seal, stamp. <B>Komerca ~o</B>, trade m. <B>2</B> object: label, etc. <B>Bonfara ~o</B>, charity stamp. <B>Glu~o</B>, sticker, \"poster-stamp\". <B>Lud~o</B>, counter. <B>Poŝt~o</B>, postage stamp. <B>Sigel~o</B>, seal-sticker. <B>3</B> (former) coin in various lands (<I>Germana ~o, Finna ~o</I>). <B>~i</B>, (make, put, a) m. or s., distinguish or indicate by a m. <I>~i per krajono, kreto. ~i arbon, paĝon, tolaĵon</I>. <B>~ilo</B>, (av) marker. <B>~isto</B>, scorer. <B>ŝut~i</B> <I>vojon</I>, (lay a trail) <I>per poligona grio</I> (1 FA 5/36). ➞ <I>poent, sign, stamp</I>.", "0"],
["markoti", "markot-i", "(<I>-n</I>), [UV] Layer, propagate by layers. <B>~o</B>, 1. (Jes 11/1, 16/8, 60/21). ➞ <I>draĵ</I>, <B>greft, stolon, ŝos</B>.", "0"],
["marksismo", "marks-ismo", "<B>-isto</B>, marks-ism, -ist.", "0"],
["marmelado", "marmelad-o", "[OA] preserve (jam, jelly, of fruit stewed into a shapeless pulp). <I>Oranĝa ~o</I>, orange marmalade. <I>Poma ~o,</I> apple sauce. ➞ <I>kompot, konfitaj</I>.", "0"],
["marmoro", "marmor-o", "[UV] Marble, crystalline limestone CaCO<SUB>3</SUB>. <I>~a minejo</I>, m-quarry. <B>~isto</B>, mason. <B>~(um)i</B>, marble, mottle, vein. ➞ <I>ŝprucmakul</I>.", "0"],
["marmoto", "marmot-o", "[UV] (zoo) marmot, wood- chuck (<I>Marmota</I>). ➞ <I>tamias</I>.", "0"],
["marno", "marn-o", "Marl, soil or dressing of clay and lime. <B>~i</B>, apply m. to soil,", "0"],
["maro", "mar-o", "[UV] Sea, ocean, the deep. <B>1</B> opposite <I>tero. (Mal)alta ~o</I>, (low) high water. <B>2</B> individual sea. <I>La Kaspia M~o</I>. <B>f</B> great quantity. <I>~o da mizeroj (sango, vizaĝoj</I>). <B>~a</B>, sea-, maritime. <B>~eroj</B>, spray. <B>~isto</B>, [UV] mariner, sailor, s-man, <I>~istaro</I>, marine, sailors. <I>Komerca ~istaro</I>, maritime marine, merchant service. <I>Milita ~istaro</I>, navy, marine forces. <B>~taŭga</B>, s-worthy. <B>Sub~a</B>, submarine. <B>Trans~a</B>, beyond seas. ➞ <I>flus, ocean, tajd</I>.", "0"],
["marodi", "marod-i", "maraud, make a raid on, plunder (American <I>rustle</I>). <B>~anto</B>, freebooter, marauder, pillager, plunderer. <B>~eti</B>, go filching, pilfering. <I>~etanto</I>, petty thief.", "0"],
["marokeno", "maroken-o", "[UV] morocco (leather), grained colored goatskin.", "0"],
["Maroko", "Marok-o", "[OA-8] MA.", "0"],
["marsupialo", "marsupial-o", "(<I>poŝbesto</I>), marsupial.", "0"],
["marŝalo", "marŝal-o", "[UV] (mil) Marshal (wide sense). <B>ĉef~o</B>, field-m.", "0"],
["Marŝaloj", "Marŝal-oj", "MH, <B>M~aj</B> <I>Insuloj</I>.", "0"],
["marŝi", "marŝ-i", "(nt), [UV] March. <B>1</B> (<I>~i takte</I>), as soldiers. <I>Marŝ(u)!</I> (4 FA 210/10). <B>2</B> Walk (step deliberately, to an end). <B>~(ad)i</B>, march(ing), steady walk. <I>En ~o</I>, on the m. <B>Parada ~o</B>, m. past. <B>Returna ~o</B>, retreat, <B>f</B> advance, progressive development. <I>~o de eventoj, de intelekto, menso, tempo</I>. (mus) composition to accompany a m. <I>~o edziĝa, funebra, rapida</I>. <B>~eti</B>, toddle ➞ <I>paŝ, piedir, promen</I>.", "0"],
["martelo", "martel-o", "[UV] Hammer. <I>Ligna ~o</I>, mallet (<I>maleo). ~o ĉarpentista, masonista</I>. <B>~o forka</B>, clew hammer; <B>~o glatiga</B>, smoothing h; <B>~o mana</B>, hand-h; <B>~o pinta</B>, pointed h.; <B>~o plata</B>, flat h; <B>~o ronda</B>, roundset h. <B>~i</B>, hammer, drive, pound, strike, hit. <B>f</B> stamp in (brain, memory), by repetition: <I>~i en la memoron. (Elmarteli</I>): excogitate, work out. <B>~ebla</B>, malleable, mechanically deformable. <B>~ego</B>, beetle. <B>~fiŝo</B>, h-fish, h-headed shark (<I>Sphyrna zigaena</I>). ➞ <I>zigen</I>. <B>~maŝino</B>, mechanical hammer.", "0"],
["marteso", "martes-o", "(pine) Marten (<I>Martes). Amerika ~o</I>, N.-American m. <B>Flavgorĝa ~o</B>, yellow-throated m. ➞ <I>foin, zibel</I>.", "0"],
["martingalo", "martingal-o", "(mar) martingale, stay for jib-boom.", "0"],
["martiro", "martir-o", "[OA] Martyr, one who suffers death or torture for his faith. <I>Kristana ~o</I>. <B>f</B> <I>~o al devo, de scienco</I>. <B>~eco</B>, <B>~igo</B>, -dom. <B>~igi</B>, m., -ize, make a m. of. ➞ <I>persekut, suferig, tortur, turment</I>.", "0"],
["Marto", "Mart-o", "[UV] March (month).", "0"],
["marubio", "marubi-o", "(bot) white horehound (<I>Marrublurri</I>). ➞ <I>balote</I>.", "0"],
["masaĝo", "masaĝ-o", "[OA] massage. (<I>-n</I>), m. <B>~ist(in)o</B>, masseur, masseuse.", "0"],
["masakri", "masakr-i", "(<I>amasbuĉi</I>), Massacre, butcher. <B>~o</B>, m., carnage, gen. slaughter, mass murder, pogrom (<I>pogromo</I>).", "0"],
["masiva", "masiv-a", "[UV] massive, massed, bulky, heavy, large, ponderous, weighty, <B>f</B> solid, substantial. <I>~a masonaĵo</I>, solid masonry. ➞ <I>blok, mas</I>.", "0"],
["masklo", "maskl-o", "(<I>liulo, virseksulo</I>), Male. <B>~a</B>, m., masculine. ➞ <I>vir</I>.", "0"],
["masko", "mask-o", "[UV] Mask. <B>1</B> artificial face. <B>2</B> (for concealment): cloak, disguise. <B>3</B> (for protection): vizor. <I>Gas~o</I>. <B>f</B> disguise, plea, pretence, veil. <I>Sub la ~o de amikeco</I>. <B>~i</B>, (put a) m. (on), conceal. <I>~i la sentojn</I>. <B>~iĝinto</B>, <B>~ito</B>, <B>~ulo</B>, -ed person. <B>~iĝado</B>, false show, masquerade, pretence. <B>~balo</B>, -ed ball. <B>Sen~e</B>, openly, without disguise. <I>Sen~igi</I>, unmask. <B>f</B> show the true character of. ➞ <I>mantel, pretend, pretekst, vual</I>.", "0"],
["maso", "mas-o", "[OA] mass. <B>1</B> (ph) quantity of matter contained in a body. <B>2</B> coherent body of matter, of indefinite shape; bulk, lump. <B>3</B> dense aggregate, sum total of objs. <I>~o da akvo. La malluma ~o de la maro</I>. ➞ <I>amas, blok</I>.", "0"],
["masoĥismo", "masoĥ-ismo", "<B>-isto</B>, masoch-ism, -ist.", "0"],
["masoni", "mason-i", "[UV] bid with brick or stone. <I>~i domon, muron</I>. <B>f</B> <I>~i la pacon</I>. <B>~ado</B>, stonework. <I>~ado per brikoj</I>, bricklaying. <B>~aĵo</B>, masonry, <B>~isto</B>, mason, bricklayer, brickbuilder, worker in stone. <B>Al~i</B>, wall up. ➞ <I>framason, konstru, ŝtonhak</I>.", "0"],
["mastiko", "mastik-o", "[UV] mastic. <B>1</B> putty. <B>2</B> bituminous preparation for building, pointing, to stop holes or join objs. <B>~i</B> (<I>ŝtopi</I>) fill in (cracks), point (wall), putty (window), stop (hole). ➞ <I>lentisk</I>.", "0"],
["masto", "mast-o", "[UV] Mast. <B>1</B> (mar) <B>Antaŭ~o</B>, fore-m. <B>Bram~o</B>, top(gallant) m. <B>Ĉef~o</B>, <B>Mez~o</B>, main m. <B>Malsupra ~o</B>, lower m. <B>Post~o</B>, mizzen-m. <B>Reĝ~o</B>, royal m. <B>Top~o</B>, top m. <B>2</B> long pole for various uses. <B>Grimp~o</B>. <B>Latisa</B> <B>~o</B>, lattice-mast, pylon tower. <B>~izi</B> <I>Upon</I>. <B>Tri~ulo</B>, three-er (ship). (4 FA 163/16). <B>~meze</B>, at half-m.", "0"],
["mastodonto", "mastodont-o", "mastodon (fossil species of large elephant).", "0"],
["mastro", "mastr-o", "[UV] master, person having control. <B>1</B> of servant: boss, employer. <B>2</B> of dog, horse, etc. Owner. <I>Hundo fidela al sia ~o</I>. <B>3</B> of establishment: owner, proprietor. <I>Dom~o</I>, householder. <I>~ino,</I> housewife. <I>Hotel~o</I>, hotel-keeper. <I>Loĝeja ~ino</I>, landlady. <B>4</B> (<I>estro</I>) head, leader, ruler. <B>5</B> (bot) host (plant). <B>~i</B>, (be) master of (over), dominate, rule. <B>~eco</B>, headship, mastery, supremacy, sway. <B>~ema</B>, -ful, domineering, imperious. <B>~ino</B>, mistress, hostess, etc. <B>~umi</B> (<I>-n</I>) [UV], keep house, manage (farm, house, etc.). <I>~uma,</I> domestic. <I>~umado</I>, domestic economy, household affairs. <B>ge~oj</B> [UV]. ➞ <I>estr, instruist, magistr, majstr</I>.", "0"],
["masturbi", "masturb-i", "to masturbate.", "0"],
["maŝino", "maŝin-o", "[UV] Machine, Engine, instrument for applying power. <B>Blov~o</B>, bellows (of forge, organ, etc.). <B>Draŝ~o</B>, threshing m. <B>Il~o</B>, m-tool. <B>Seg~o</B>, <B>Skrib~o</B>, (<I>tajpilo</I>), typewriter. <B>Ŝpin~o</B>, jenny. <B>te~o</B> [UV] (<I>samovaro</I>). <B>Teks~o</B>, loom. <B>Tond~o</B>, (grass)cutter, shearing-m. <B>Vapor~o</B>, steam-e. <B>~a</B>, mechanical. <B>~e</B> (<I>per ~o</I>), by m-ry. <B>f</B> (<I>aŭtomate, meĥanike). Mensogi ~e</I> (P). <B>~aĵo</B>, mechanism. <B>~aro</B>, m-ry. <B>~ejo</B>, engine-house. <B>~estro</B>, chief e-er. <B>~isto</B>, mechanic, person in charge of m-ry, e-er. ➞ <I>aparat, meĥanik, meĥanism, motor, lokomotiv</I>.", "0"],
["maŝo", "maŝ-o", "[UV]. <B>1</B> Loop, bright (El 26/4), (sten) loop. <B>2</B> Stitch (knitting). <I>Lasi fali ~on,</I> drop a s. <B>3</B> lasso, noose, running knot. <I>Pendiga ~o (ŝnuro</I>), hangman’s rope. <B>4</B> (mec) mesh, hole (of netting); link, ring (of chain or mail). <I>Hok~a ĉeno</I>. <B>~aĵo</B>, <B>~aro</B>, netting, network. <B>~eto</B>, <B>~ego</B>, (<I>elips- -eto, -ego</I>), small (large) loop. <B>En~igi</B>, enmesh. <B>Mal~i</B> (<I>malfermi la ~ojn</I>), unravel. ➞ <I>bant, laĉ, laz, nod, ret, steb</I>.", "0"],
["matadoro", "matador-o", "[OA] (<I>bovmortigisto</I>), matador.", "0"],
["matematiko", "matematik-o", "[OA] Mathematic/s. <B>~a</B>, -al. <B>~isto</B>, -ian.", "0"],
["mateno", "maten-o", "[UV] Morn(ing), forenoon. <I>Bonan ~on!</I> <B>~a</B>, m., matin, matutinal. <I>~a Diservo</I>, matins. <I>~a robo</I>, dressing-gown. <B>Fru~a</B>, early morning. <B>~e</B>, in the morning. <I>Hodiaŭ ~e,</I> this m. ~as, it is m. <B>~iĝo</B> (<I>~krepusko, ~ruĝo</I>), aurora.", "0"],
["mateo", "mate-o", "mate (<I>Ilex paraguayensis</I>). <B>1</B> drink. <B>2</B> <I>~arbo. ~aj folioj</I>.", "0"],
["materialo", "material-o", "[F], Material, matter, stuff. <B>1</B> of which something is made or consists. <I>Konstru~o. Kruda) ~oj</I>. <B>2</B> subject of action: <I>Brul~o. Leg~o</I>, reading-matter. <I>Manĝ~o</I>, foodstuffs. <B>3</B> for necessity, work, etc. <I>~o por pripenso, studo. Ĉerpi ~on el siaj spertoj</I>. <B>~a</B>, m. <B>1</B> physical, palpable, visible. <B>2</B> essential, financial, matter-of- fact, positive, practical. <I>~a dependo, eblo, helpo, malfacilo, profito, pruvo, rimedo, subteno</I>. <B>~e</B>, in substance, not merely in form. ➞ <I>afer, aĵ, materi, substanc, ŝtof</I>.", "0"],
["materio", "materi-o", "[OA] Matter, substance perceptible by the senses. <I>~o fluida, solida. ~a,</I> of m., material, corporeal. <I>La ~a mondo. ~aj bezonoj, zorgoj</I>. <B>~e</B> <I>helpi. Medicina</I> <B>~aro</B>, materia medica. <B>~iĝo</B>, materialization. <B>~(al)ismo</B>, <B>~(al)isto</B>, materialism, materialist. <B>Ne~a</B>, immaterial, unsubstantial. ➞ <I>material</I>. Opp <I>ide, mens, spirit</I>.", "0"],
["mato", "mat-o", "[UV] <B>1</B> (<I>tapiŝeto</I>), Mat, covering. <B>Kan~o</B>, reed (rush) m. <B>Pord~o</B>, <B>Skrap~o</B>, door-m. ➞ <I>latis, tapis</I>. <B>2</B> (chs) <B>~o</B>, <B>~igi</B>, (check)mate.", "0"],
["matraco", "matrac-o", "[UV] Mattrass. <I>~o pajla, risorta. Drata ~o</I>, wire m.", "0"],
["matriarko", "matriark-o", "Matriarch. <B>~a</B>, -al. <B>~eco</B>, -y.", "0"],
["matrico", "matric-o", "matrix, mould in which objs are shaped or cast, (min) gangue. Opp <I>patric</I>.", "0"],
["matrikario", "matrikari-o", "Mayweed (<I>Matricaria</I>). <B>~o senodora</B>, corn or scentless m. ➞ <I>antemid, kamomil</I>.", "0"],
["matrikulo", "matrikul-o", "list (register, roll) of members of organization. <B>~i</B> (<I>-n</I>), enroll, register, admit to privileges of university. <B>~iĝi</B>, be admitted, matriculate.", "0"],
["matrono", "matron-o", "matron. <B>1</B> elderly married woman, dame (M 206/12; 1 FA 19/11). <B>2</B> woman managing domestic affairs of institution.", "0"],
["matura", "matur-a", "[UV] Matur/e, Ripe; adult, fullgrown, fully developed, perfected by time. <I>~a aĝo, forto, frukto, inteligento, semo, vino</I>. (com) due (bill), <B>f</B> completed, ready, well considered. <I>~a decido, demando, diskuto, projekto</I>. <B>~eco</B>, m-ity, puberty. <B>~igi</B>, m., r-en, (com) fall due. <B>~igi</B>, m., bring to perfection. <B>~ulo</B>, adult. <B>Fal~a</B>, ready to fall. <B>Fru~a</B>, early, precocious. <B>Mol~a</B>, squashy, dead ripe. <B>Ne~a</B>, immature, green. <B>Tro~a</B>, overripe, sleepy. ➞ <I>plenaĝ, viriĝ</I>.", "0"],
["Maŭricio", "Maŭrici-o", "MU.", "0"],
["Maŭritanio", "Maŭritani-o", "MR.", "0"],
["maŭzoleo", "maŭzole-o", "[OA] mausoleum, magnificent tomb, sepulchral monument.", "0"],
["mazurko", "mazurk-o", "[OA] mazurka, Polish dance.", "0"],
["mazuto", "mazut-o", "fuel oil, mazut.", "0"],
["meandri", "meandr-i", "meander, Wind about (<I>rivero</I>), wander at random. <B>~ado</B>, <B>~oj</B>, sinuous w-ings, w ing paths, (arch) <B>~o</B>, fret pattern (of intertwining lines). <B>~a</B>, sinuous. ➞ <I>serpentum</I>.", "0"],
["meblo", "mebl-o", "[UV] (piece of) Furniture. <B>~oj</B>, f., household goods. <B>~i</B>, furnish, provide with f., stock. <I>~ita ĉambro, loĝejo,</I> furnished apartment. <I>~ita</I> (well stocked) <I>memoro. Teler~o</I>, buffet, sideboard. <B>~aro</B>, suit of f. <B>~isto</B>, f-dealer, upholsterer. <B>~otenejo</B>, f-warehouse. <B>Ne~ita</B>, <B>Sen~a</B>, unfurnished. <B>Sen~igi</B> (clear out) <I>ĉambron</I>.", "0"],
["mecen(at)o", "mecen(at)-o", "generous patron, wealthy supporter (of art, literature, etc.). <B>~eco</B>, munificence, patronage, protection.", "0"],
["meĉo", "meĉ-o", "[UV] Wick (of candle, lamp). <B>~a</B> <I>debrulaĵo</I>, character. <B>~aĵo</B> [UV] (<I>tindro</I>), fuse, slow match, touchwood (for explosive or mine). <B>~ingo</B>, w-holder.", "0"],
["medaliono", "medalion-o", "[UV] Medallion. <B>1</B> locket. <B>2</B> m-shaped panel or tablet. <B>3</B> (<I>medalego</I>).", "0"],
["medalo", "medal-o", "[UV] Medal. <B>~gajninto</B>, <B>~ulo</B>, -list. ➞ <I>orden</I>.", "0"],
["mediano", "median-o", "(geom) median, middle (line).", "0"],
["medianto", "mediant-o", "(mus) Mediant, 3rd of scale. <B>Sub~o</B>, sub-m, 6th of scale.", "0"],
["medicino", "medicin-o", "[OA] (<I>kuracarto</I>), science of Medic/ine, healing art. <I>[Ne= medikamento], ~o jura, sanitara</I>. <B>~a</B>, -al, -inal. <I>~a doktoro</I>. <B>~isto</B>, -al man. ➞ <I>doktor, kurac</I>.", "0"],
["medikago", "medikag-o", "(bot) Medick. <B>Nigra ~o</B>, black-m., nonsuch &gt; <I>luzern</I>.", "0"],
["medikamento", "medikament-o", "[OA] Medicine, curative drug, Physic, f <I>preni sian ~on</I>. <B>~a</B> <I>formulo. ~a kofro</I>, m-chest. <B>~i</B>, to p. <B>Sen~a</B> <I>kuraco</I>, drugless treatment. ➞ <I>drog, farmaciaĵ, kuracil</I>.", "0"],
["medio", "medi-o", "[OA] <B>1</B> sphere (of action, life, circle, environment, habitat, social circumstances (surroundings). <I>~o familia, politika, religia. Sin adapti al sia ~o</I>. <B>~a</B>, ambient, surrounding. <B>Ekster~a</B>, out of one’s element. ➞ <I>atmosfer, etos, kamp, rilat, sfer</I>. <B>2</B> (chem) medium, vehicle. <I>[Ne= medium, mez, peril, rimed]</I>.", "0"],
["mediti", "medit-i", "[UV] (nt) (<I>pri, -n</I>), Meditat/e, collect one’s thoughts, muse, ponder, reflect, ruminate, turn over in the mind (Ps 4/4). (<I>Pri)~i ion</I>, brood over. <B>~(ad)o</B>, <B>~aĵo</B>, -ion, deep thought, musing. <B>~ema</B>, -ive, thoughtful. ➞ c<I>erbum, kontempl, pripens</I>.", "0"],
["mediumo", "medium-o", "[OA] (spiritualist) medium. ➞ <I>medi, mez, perul</I>.", "0"],
["medo", "med-o", "(<I>mielvino</I>), mead.", "0"],
["medolo", "medol-o", "[OA] <B>1</B> marrow (of bones) (Ij 21/24), medulla. <I>Spina ~o</I>, spinal cord. <B>2</B> pith (of plants). <B>Junka ~o. f</B> (<B><I>esenco, plejgravaĵo</I>)</B>. <B>~a</B>, medullary. <I>~a</I><B> <I>kanalo</I>. ➞ <I>kukurb, suk</I></B>.", "0"],
["meduzo", "meduz-o", "[OA] Medusa. <B>1</B> (myth) Gorgon with snakes for hair. <B>2</B> (zoo) jelly-fish, sea-nettle. (<I>Medusa</I>).", "0"],
["mefito", "mefit-o", "skunk (<I>Mephitis</I>). <B>~a</B> <I>felo</I>. <B>f ~a</B>, mephitic, noisome.", "0"],
["mega", "mega-", "(ppfx=great, million), mega-., ~ciklo, -cycle. ~dino, -dyne. ~fono, -phone.", "0"],
["megalito", "", "megalith. ➞ <I>dolmen, kromleh, menhir, tumul</I>.", "0"],
["megalo", "megalo-", "megalo-.", "0"],
["megalomani(ul)o", "", "megalomania(c).", "0"],
["megasaŭro", "megasaŭr-o", "megasaur.", "0"],
["megero", "meger-o", "<B>1</B> (myth) one of the three Furies. <B>2</B> furious hag, scold, shrew, termagant, vixen.", "0"],
["megomo", "megom-o", "(el) megohm, one million ohms.", "0"],
["meĥaniko", "meĥanik-o", "[UV] (a. <B>mek-</B> [OA]), mechanic/s, science of motion or of machinery. <B>~a</B>, -al. <B>1</B> of m. <I>~a leĝo, problemo</I>. <B>2</B> made by machine. <I>~a desegnado, fabrikado</I>. <B>2</B> automatic, lacking originality. <I>~a ago, movo, gesto</I>. <B>~isto</B> (a. <I>mekanisto</I>), mechanic(ian), skilled specialist or workman as regards machinery. ➞ <I>maŝinar, movilar, radar</I>.", "0"],
["meĥanismo", "meĥanism-o", "(a. <B>mek-</B>), mechanism, structure (of machine). <I>~o dentrada, ĝustiga, konekta, kranka</I>, toothed (adjusting, engaging, crank) gear. <B>Blova ~o</B>, blowing m. <B>Klika ~o</B>, lock m. <B>f</B> technique, works (of action, function). <I>~o de digesto, penso, verkado. Orgena ~o (Muzika Terminaro</I> 30).", "0"],
["meiozo", "meioz-o", "(<I>malgrandigo</I>), (rh) meiosis, understatement (1 Sa 24/14). ➞ <I>litot</I>.", "0"],
["mejlo", "mejl-o", "[UV] mile. <I>~o Angla, Franca, Germana, Sveda. Mara ~o</I>, nautical m. <I>~a kiomo</I>, -age. <B>Sep~aj</B> <I>botoj</I>.", "0"],
["meki", "mek-i", "(<I>kaprobleki</I>), bleat (as a goat).", "0"],
["Meksiko", "Meksik-o", "[OA-8] MX.", "0"],
["melampiro", "melampir-o", "(bot) cow-wheat (<I>Melampyrum</I>).", "0"],
["melandrio", "melandri-o", "(bot) Campion (<I>Melandrium</I>). <B>~o blanka</B>, white c. <B>~o ruĝa</B>, red c. ➞ <B><I>liknid, silert</I></B>.", "0"],
["melanito", "melanit-o", "(<I>nigranaso</I>), scoter-duck (<I>Melanitta</I>).", "0"],
["melankolio", "melankoli-o", "[OA] Melanchol/y, -ia, habitual tendency to dejection, depression, low spirits, mental gloom, pensive sadness, the blues. <B>~(em)a</B>, <B>1</B> -ic, -y, dejected, depressed, dismal, doleful, downcast, gloomy, glum. <B>2</B> depressing, sad, sombre. <B>~ulo</B>, -ic. ➞ <I>deprim, hipoĥondri, nigr, splen</I>.", "0"],
["melaso", "melas-o", "[OA] molasses. <I>Rafinita ~o</I>, golden syrup, treacle. ➞ <I>sirop</I>.", "0"],
["melduo", "meldu-o", "(<I>blanka ŝimkovraĵo</I>), (bot) (powdery) Mildew. ➞ <I>folia ŝimo (falsa ~o</I>), downy m.", "0"],
["meleagro", "meleagr-o", "[UV] Turkey (<I>Meleagris</I>). <B>~ejo</B>, t-run. <B>~ino</B>, t-hen. <B>Vir~o</B>, t-cock.", "0"],
["meliko", "melik-o", "(bot) melick grass (<I>Melica</I>).", "0"],
["meliloto", "melilot-o", "(common yellow) Melilot. (<I>Melilotus</I>). <B>Blanka ~o</B>, white m.", "0"],
["melinito", "melinit-o", "melinite (explosive).", "0"],
["meliso", "melis-o", "[OA] Balm (<I>Melissa</I>).", "0"],
["melito", "melit-o", "bastard-balm (<I>Melittis</I>).", "0"],
["melivoro", "melivor-o", "honey badger, ratel (<I>Melli- vora</I>).", "0"],
["melki", "melk-i", "(<I>-n</I>) [UV], (draw) Milk (from), <I>~i bovinon, kaprinon</I>. <B>f</B> (<I>ekspluati</I>) exploit, draw money from. <I>~i la registaron. ~i virkapron (provi neeblaĵon</I>). <B>~ado</B>, -ing. <B>~ejo</B>, -ing shed. <B>~ist(in)o</B>, -er, -maid. <I>~maŝino</I>. ➞ <I>lakt</I>.", "0"],
["melo", "mel-o", "[UV] badger, brock (<I>Meles</I>).", "0"],
["melodio", "melodi-o", "[OA] Melod/y. <B>1</B> pleasing succession of sounds. <B>2</B> air, tune, principal part in harmony. <B>3</B> sweet music. <B>~a</B>, -ic, -ious, of (producing) m., sweet-sounding. ~a <I>kanto de la turdo. ~a minora skalo</I>, -ic minor scale. <B>Sen~a</B>, tuneless. ➞ <I>ari, harmoni</I>.", "0"],
["melodramo", "melodram-o", "[OA] Melodram/a, sensational dramatic piece. <B>~a</B>, -atic. <I>~a konduto, parolo</I>. <B>~isto</B>.", "0"],
["melofago", "", "<I>sheep-tick, ked</I> (<I>Melophagus</I>).", "0"],
["melolonto", "melolont-o", "(<I>Maja skarabo</I>), (ent) cockchafer (<I>Melolontha</I>).", "0"],
["melongeno", "melongen-o", "aubergine, egg-plant (<I>Solanum melongena</I>).", "0"],
["melono", "melon-o", "[UV] Melon (No 11/5). <B>akvo~o</B>, [UV] water-m (<I>Citrullus vulgaris</I>).", "0"],
["meloo", "melo-o", "oil beetle (<I>Meloe</I>).", "0"],
["melopsitako", "melopsitak-o", "(<I>Australia papageto</I>), budgerigar (<I>Melopsittacus</I>).", "0"],
["melurso", "melurs-o", "(<I>mielurso</I>), honey-bear, sloth-bear (<I>Melursus</I>).", "0"],
["mem", "", "[UV] (<I>propra-age, -persone, -vole</I>), Self, selves (throws emphasis on \"self\"): personally, spontaneously, without help. ➞ <I>Mi vestis min</I>, I <I>dressed</I> myself; <I>Mi vestis min</I> I dressed <I>myself. Mi ~ faris ĝin</I>, I did it my<I>self. Si vidis la pupon</I> she saw the doll it<I>self. Mi ~ faris ĝin</I>, I did it my<I>self. Legu</I> ~ (read it <I>yourself). Tio estas komprenebla per si</I> it goes without saying, is a matter of course, stands to reason. <B>~o</B>, self, identity. <I>PFX:</I> <B>~evidenta</B>, s-evident. <B>~stara</B>, [UV] independent, (org) <B>~sonigo</B>, cypher. <B>Rim</B>.: If the idea is reflexive, prefer sin-. <I>Sindefendo = oni defendas sin</I>.", "0"],
["membrano", "membran-o", "[UV] Membran/e. <B>1</B> (anat) sheet-like tissue or lining. <I>Muka ~o. ~o de la stomako</I>. <B>2</B> (tech) thin flexible film (leaf, skin). <I>~o celulojda. ~o de tamburo</I>, drumhead. <B>~(ec)a</B>, -eous. <B>~eto</B>, pellicle, skin (of milk, etc.). ➞ <I>skvam</I>.", "0"],
["membro", "membr-o", "[UV] Member. <B>1</B> organ of body (especially limb), (<I>Mal)supra ~o</I>, arm, leg. <I>Dik~a</I>, big-limbed. <B>2</B> (<I>ano</I>) m. (of family, party, society). <B>3</B> (<I>ero</I>), constituent pt or portion. <I>~o de ekvacio, frazo</I>. <B>Dis~igi</B> <I>beston, frazon, ideon, vorton</I>, dismember.", "0"],
["memorando", "memorand-o", "memo(randum), minute, note, record (for referee, to aid memory).", "0"],
["memori", "memor-i", "[UV] (<I>-n, ke,pri, -i</I>), Rememb/er, retain in Memor/y; bear in mind, not forget. <I>~i amikon, eventon, lecionon, kanton, sperton. ~u iri</I>, r. to go. <B>~o</B> (<I>pri</I>), m. <B>1</B> (faculty); recollection, r-rance: <I>Havi bonan ~on. Desegni el ~o. Enskribi en la ~on. Noti en la ~o</I>, make a mental note. <B>2</B> preservation (representation) of past perception or idea, commemorative record, memorial: <I>Gardi, havi, teni la ~on pri. Pro ~o al</I>, in m. of. <B>~anta</B>, mindful, <B>~e</B> (<I>parkere</I>), by heart. <B>~aĵoj</B>, memoirs, reminiscences. <I>Facile</I> <B>~ebla</B>, easy to r. <B>~enda</B>, to be r-ed. <I>~endaĵoj</I>, memorabilia. <B>~igi</B> (<I>pri</I>), remind, put in mind of. <I>~iga</I>, commemorative, m-ial. <I>~iga Diservo (poŝtmarko). ~igaĵo</I>, something to keep the m. green, keepsake, memento, souvenir. <I>~igilo</I>, reminder, r-rancer. <I>~igisto (sufloro</I>), prompter. <B>~inda</B>, m-able, notable, noteworth, worth r-ing. <B>Mal~i</B> (<I>forgesi</I>), forget. <B>Mis~i</B>, r. wrongly. <B>Ne~ebla</B>, <B>1</B> that cannot be r-ed. <B>2</B> (<I>antaŭ~a</I>), no longer r-ed. <I>De tempo ne~ebla,</I> from time immemorial. <B>Pri~a</B>, reminiscent. <B>Re~i</B>, recall, recollect. <B>Re~o</B> (<B>re~a</B>), reminiscence, reminiscent. <I>Re~igi (ion al iu) (iun pri io</I>) call back, recall; remind. <I>Re~igi eventon, pri devo, rendevuo</I>. <B>Kar~a</B>, of precious m., lamented. ➞ <I>parker</I>.", "0"],
["memuaro", "memuar-o", "memoir, paper (communication, report, statement) by expert before learned society.", "0"],
["menaĝerio", "menaĝeri-o", "collection of animals in captivity, zoo.", "0"],
["mencii", "menci-i", "[OA] (make) Mention (of), allude (refer) to (remark upon, speak of, state, incidentally) (1 Sa 4/18, 2 Kr 28/15). <B>~o</B>, m., cursory allusion, naming, or referee. <I>Honora ~o</I>, honourable m. <B>~inde</B>, especially, in particular, notably. ➞ <I>alud, cit</I>.", "0"],
["mendi", "mend-i", "(<I>-n</I>) [OA], (give an) Order (for), book, commission, requisition. <I>~i varojn; ĉambron, karbon, libron, servon, sidejon. [Ne= ordon, plibonig, ripar]. ~u, atendu! (= vi senfine atendos</I>) (P). <B>~(aĵ)o</B>, o., indent. <I>Farim plenumi ~on. Bilet</I><B>~ejo</B>. <B>~ilo</B>, o-form. <B>Antaŭ~i</B>, order in advance. <B>Kontraŭ~i</B>, <B>Mal~i</B>, cancel (countermand) an o. <B>Laŭ~e</B>, to o.", "0"],
["menhiro", "menhir-o", "(ant) menhir, tall upright monumental stone.", "0"],
["menianto", "meniant-o", "bog (buck) bean, marsh-trefoil (<I>Menyanthus</I>).", "0"],
["meningo", "mening-o", "meninx, membrane round brain or spinal cord. <B>~ito</B>, meningitis.", "0"],
["menisko", "menisk-o", "meniscus, lens concave one side, convex the other.", "0"],
["menopaŭzo", "menopaŭz-o", "(<I>menstrua ĉesiĝo</I>), (med) menopause, change of life.", "0"],
["menso", "mens-o", "[OA] Mind (opp <I>korpo</I>), intellect (ual powers), reason, seat of consciousness (feeling, thought, volition), understanding. <I>Sana ~o en sana korpo</I>. <B>~a</B>, mental. <I>~a konfuzo, stato</I>. <B>~e</B>, in m. <I>~e malsana</I>. <B>Fid~ulo</B> (Jes 26/3). ➞ <I>anim, cerb, imag, pens, prudent</I>.", "0"],
["mensogi", "mensog-i", "[UV] (nt) Lie, speak falsely, tell intentional untruth. <I>~i kiel funebra parolado; maŝine, senhonte</I>. <B>~o</B>, lie, falsehood, untruth. <B>~o blanka</B>, <B>~eto</B>, white lie, fib, polite fiction. <B>~a</B>, false, lying, untrue. <I>~a atest(ant)o</I>. <B>~ego</B>, whopping lie. <B>~ema</B>, mendacious. <B>~ulo</B>, liar, storyteller.", "0"],
["menstrui", "menstru-i", "(nt) menstru/ate. <B>~(ad)o</B>, -ation. <B>~aĵo</B> (<I>monataĵo</I>), menses. <I>~a ĉesiĝo (menopaŭzo</I>), menopause.", "0"],
["mento", "ment-o", "[UV] Mint (<I>Mentha</I>). Akva <B>~o</B>, water-m; Kampa <B>~o</B>, corn m; Pipra <B>~o</B>, pepper-m; Spika <B>~o</B>, spear-m. ➞ <I>nepet</I>.", "0"],
["mentolo", "mentol-o", "menthol.", "0"],
["mentono", "menton-o", "[UV] chin, lower jaw.", "0"],
["mentoro", "mentor-o", "[OA] mentor, experienced trusted adviser to youth, counsellor.", "0"],
["menueto", "menuet-o", "(mus) minuet, slow stately dance in triple time.", "0"],
["menuo", "menu-o", "[OA] menu, bill of fare.", "0"],
["menuro", "menur-o", "(<I>lirobirdo, lirvostulo</I>), lyre-bird (<I>Menura</I>).", "0"],
["mercerizi", "merceriz-i", "(tex) mercerize, treat with caustic potash for dyeing.", "0"],
["mercer(aĵ)o", "", "haberdashery, accessories of dressmaking: buttons, needles, pins, threads, etc. <B>~isto</B>, haberdasher. ➞ <I>galanteri</I>.", "0"],
["mergi", "merg-i", "(<I>-n</I>), Immers/e, submerge in liquid, plunge, <B>f</B> bury, involve, merge. <I>~i la animon en malesperon</I>. <B>~ado</B>, -ion. <B>~iĝi</B> (<I>malfloti, subakviĝi</I>), sink. <B>~profundo</B>, draught. <B>Mal~i</B>, take out of liquid. <B>(Sub)~ebla</B>, submersible. <I>~~ebla ŝipo</I>, submarine. ➞ <I>sink</I>.", "0"],
["merĝo", "merĝ-o", "(<I>merganaso</I>), Merganser (<I>Mergus</I>). <B>Blanka ~o</B> (<B>~eto</B>), smew; <B>Granda ~o</B>, American m., goosander; <B>Hupa ~o</B>, hooded m; <B>Ruĝbrusta</B> (<B>longbeka</B>) <B>~o</B>, redbreasted m.", "0"],
["meridiano", "meridian-o", "[OA] meridian, great circle from pole to pole. <I>~o magneta</I>. <B>f</B> highest altitude, period of greatest splendour (vigour). ➞ <I>longitud</I>.", "0"],
["meringelo", "meringel-o", "(cul) meringue, light cake of egg-white and sugar.", "0"],
["merino", "merin-o", "Merino (sheep). <I>~a lano</I>, m-wool. <B>~aĵo</B>, m.", "0"],
["meriti", "merit-i", "(<I>-n</I>) [UV], Deserve, Merit; be entitled (have a right) to be worthy of, earn, ought to have. ~i <I>atenton, estimon, laŭdon, punon, rekompencon</I>. <B>~a</B> (<I>mult~a, ~oplena</I>), commendable, deserving, meritorious, (praise)worthy. <B>~o</B>, m., excellence, quality of d ing well, worth. <B>~e</B>, d-edly, rightly, with good cause. <I>Prave punite, laŭ-e!</I> <B>Ne~ita</B>, un-ed. <B>Sen~a</B>, undeserving. <B>Mort~a</B> (mortal) <I>peko</I>, (4 FA 107/30). ➞ <I>ind</I>.", "0"],
["merizo", "meriz-o", "[UV] gean, mazard, wild cherry (<I>Prunus avium</I>). Vd <I>prun</I>.", "0"],
["merkato", "merkat-o", "[OA] market, demand (for goods), opening, field, sphere of commercial activity. <I>La grena (kotona) ~o. Serĉi novajn ~ojn</I>. <B>Nigra ~o</B>, <I>~a prezo (valoro). [Ne= foir]</I>.", "0"],
["merkredo", "merkred-o", "[UV] Wednesday. <I>Cindra ~o,</I> Ash Wednesday.", "0"],
["merkurialo", "merkurial-o", "(bot) dog’s mercury (<I>Mercurialis</I>).", "0"],
["merlango", "merlang-o", "[OA] (ich) whiting (<I>Gadus merlangus</I>).", "0"],
["merlo", "merl-o", "[UV] blackbird, merle (<I>Turdus merula). Akva ~o (cinklo</I>), dipper. <I>Blankbrusta ~o</I>, ring ouzel.", "0"],
["merluĉo", "merluĉ-o", "(ich) hake (<I>Merluccius</I>).", "0"],
["meropo", "merop-o", "(<I>abelmanĝanto</I>), (orn) bee-eater (<I>Merops</I>).", "0"],
["mesaĝo", "mesaĝ-o", "Message, communication sent from one person to another, dispatch, <B>~isto</B>, bearer of message, envoy.", "0"],
["mesio", "mesi-o", "[UV] Messia/h. <B>1</B> The promised deliverer of Israel. <B>2</B> Jesus Christ, <B>f</B> liberator, saviour, <B>~a</B>, -nic. <B>~ismo</B>, -nism.", "0"],
["meso", "mes-o", "[UV] (rc) Mass. <I>Fari ~on</I>, <B>~libro</B>, mass-book, missal.", "0"],
["mespilo", "mespil-o", "[OA] Medlar, fruit of <I>~arbo,</I> m-tree (<I>Mespilus</I>).", "0"],
["mestizo", "mestiz-o", "mestizo, (Sp or Port, half-caste), especially offspring of Spaniard and American Indian, ~<B>ino</B>, <B>f ~i</B>, cross. <B>~a</B>, mongrel, cross-bred. <I>~a planto,</I> hibrid.", "0"],
["meta", "meta-", "(Gk pfx wide sense, us = change), meta-. ~bolo, (bio) -bolism.", "0"],
["metacentro", "metacentr-o", "metacentre.", "0"],
["metaebeno", "metaeben-o", ".", "0"],
["metafiziko", "metafizik-o", "[OA] (phi) Metaphysic/s &gt; <I>ontologio</I>. <B>~a</B>, -al. <B>~isto</B>, -ian.", "0"],
["metaforo", "metafor-o", "[OA] Metaphor, figurative representation, application of term to something to which it is not literally applicable. E.g., Ps 13/1, 84/11; Mt 26/26. <I>~oj miksitaj</I>. <B>Sen~e</B>, literally, plainly. <B>~a</B>, -ical, figurative. ➞ <I>parolfigur</I>. <B>Rim</B>.: Compare: He is like a fox (simile); He is a fox (metaphor); Tell that fox (Lk 13/32), implied metaphor (<I>hypocatastasis</I>).", "0"],
["metakarpo", "", "(anat) metacarpus.", "0"],
["metalo", "metal-o", "[F], Metal. <B>Blanka ~o</B>, white m., tin-base alloy. <B>Lut~o</B>, solder. <B>Min~o</B> (<I>erco</I>), ore. <B>~a</B>, -lie. <B>~izi</B>, plate (e.g. <I>arĝentizi</I>, silverplate). <B>~ojdo</B>, -oid. <B>Du~ismo</B>, bimetalism. ➞ <I>drat</I>.", "0"],
["metalurgio", "metalurgi-o", "metalurgy.", "0"],
["metamorfa", "", "(geol) metamorphous.", "0"],
["metamorfozo", "metamorfoz-o", "[OA] Metamorphos/is, change of form, transfiguration, transformation, transmutation, change of one being to another. <I>~o de raŭpo en papilion</I>. <B>f</B> <I>~o de karaktero, stato</I>. <B>~i</B> (<I>-n</I>), <B>~e</B>, transfigure, transform mute).", "0"],
["metano", "metan-o", "methane, marsh gas, fire-damp (CH<SUB>4</SUB>).", "0"],
["metatarso", "", "metatarsus. <I>~tarsa subportilo</I>, arch support (shoe).", "0"],
["metatezo", "", "(phon) metathesis, transposition of sounds in a word, e.g., <I>salkono</I> instead of <I>kalsono; wopse</I> instead of <I>wasp, &gt;</I> \"Spoonerisms\", <I>e.g., Please hush ny brat: it’s roaring with pain outside</I>.", "0"],
["metempsikozo", "metempsikoz-o", "[OA] metempsychosis, transmigration of souls.", "0"],
["meteologo", "meteolog-o", "-ist.", "0"],
["meteorito", "meteorit-o", "meteorite. Of these 90 % are <I>aerolitoj (ŝton~oj</I>), 10% are <I>sideritoj (.fer~oj</I>), of nickel and iron.", "0"],
["meteoro", "meteor-o", "[OA]. <B>1</B> (<I>falstelo</I>), Meteor, shooting star. ~a <I>pluvo</I>, -ic shower. ➞ <I>bolid</I>. [<B>2</B> any atmospheric phenomenon; from which].", "0"],
["meteorologio", "meteorologi-o", "[OA] meteorology. (a. <I>meteologio</I>, Lewin).", "0"],
["meti", "met-i", "(<I>-n</I>), [UV] Put, lay, place, set, station (in situation). <B>1</B> in place: <I>~i libron en la poŝon, sur la tablon. ~i subskribon al letero. ~i flanken</I>. <B>f</B> <I>~i aferojn en ies manojn, finon al diskuto, limon al ambicio, manon al laboro, vortojn en ies buŝon</I>. <B>2</B> in state: <I>~i iun en danĝeron, embarason, mizeron</I>. <B>Al~i</B>, apply. <B>Apud~o</B>, juxtaposition. <B>Antaŭ~i</B>, propose, set forth. <B>Ĉe~i</B> (<I>cementon</I>), set closely. <B>Ĉirkaŭ~i</B>, surround with. <B>De~i</B> (Ij 30/18), p. (take) off, lay down, remove. <I>~i ovon,</I> lay an egg. <B>Dis~i</B>, put all over the place. <I>Akva ~~o</I>, displacement. <B>el~i</B>, [UV] put out. <B>1</B> display, exhibit: <I>~~i en montra fenestro</I>. <B>2</B> expose: <I>~~i sin al mokado, la sunradioj. El~o</I>, output. <B>En~i</B>, enclose, insert. <B>For~i</B>, put away. <B>Sin inter~i</B>, interfere, meddle. <B>Kontraŭ~i</B>, oppose. <B>Kun~i</B>, assemble, combine; fold (hands). <I>~~ita vorto</I>, compound word. <B>Pri~i</B> (lay) <I>la tablon</I>. <B>Mis~i</B>, mislay. <B>Re~i</B>, replace, restore. <B>Sub~i</B> (<I>al, je</I>), subject, subordinate. <I>Sin ~~i (~~iĝi</I>), give way, submit, succomb, yield (<I>al disciplino, la plimulto</I>). <B>Sur~i</B>, put on, don (<I>veston</I>). ➞ <I>lok</I>.", "0"],
["metileno", "metilen-o", "methylene (CH<SUB>2</SUB>).", "0"],
["metilo", "metil-o", "<B>~a</B>, Methyl. <I>~a alkoholo</I>, m- alcohol.", "0"],
["metio", "meti-o", "[UV] handicraft, line, occupation. <B>~ejo</B>, workshop, <B>~isto</B>, artisan, craftsman, mechanic, workman, <B>~lernanto</B>, apprentice. <B>Bon~ista</B>, workmanlike. <B>Ne~a</B> (<I>amatora</I>). <I>Ne~a fotografisto</I>. ➞ <I>fak, ofic, okup, profesi, special</I>.", "0"],
["metodismo", "metodism-o", "<B>~isto</B>, (rel) methodism, -ist.", "0"],
["metodo", "metod-o", "[OA] Method; form of procedure, mode, way (of doing something). <I>~o ĝusta, logika, praktika, scienca. ~o (sen)pere instrui lingvojn</I>. <B>(laŭ)~a</B>, -ical, orderly, regular, systematic. <I>~a aranĝo, gramatiko, laboro</I>. ~<B>~igi</B>, -ize, put in order, systematize. <B>~ulo</B>, man of m. <B>~ologio</B>, -ology, orderly arrangement of ideas (habits). <B>Sen~a</B>, slapdash, slipshod.", "0"],
["metonimio", "metonimi-o", "(<I>nomŝanĝo</I>), (rh) metonymy, substitution of name of attribute for that of the thing meant, or of cause for effect; or vice versa.", "0"],
["metriko", "metrik-o", "[OA] metric/s, metre, measure of verse, poetic rhythm, prosody. <B>~a</B>, -al.", "0"],
["metro", "metr-o", "[F], Metr/e, unit of length. <B>~a</B> <I>sistemo</I>, -ic system. <I>Centi~(deci~hekto ~kilo~mili~)o</I>.", "0"],
["metro", "-metro", "(psfx) -meter (<I>mezurilo</I>).", "0"],
["metronomo", "metronom-o", "[OA] (mus) metronome, instrument marking time by pendulum.", "0"],
["metropolito", "metropolit-o", "(Gk church) metropolitan.", "0"],
["metropolo", "metropol-o", "[OA] Metropol/is, (central) (chief, mother) city, <B>f</B> centre of activity. <B>~a</B>, -itan.", "0"],
["mevo", "mev-o", "[UV] (sea)-Gull, -mew (Le 11/16). <B>~o arĝenta</B>, herring g; <B>~o malgranda</B>, little g; <B>~o mantela</B>, blackbacked g; <B>~o rida</B>, blacknecked g; <B>~o trifingra</B>, kittiwake. ➞ <I>lar, sterkorari</I>.", "0"],
["mezalianco", "mezalianc-o", "(<I>misedziĝo</I>), misalliance.", "0"],
["mezembri(antem)o", "mezembri(antem)-o", "(hort) mesembrianthemum, fig marigold. <I>~o kristala,</I> ice plant.", "0"],
["mezentero", "mezenter-o", "(anat) mesentery.", "0"],
["mezo", "mez-o", "[UV] Middl/e. <B>1</B> central point, centre, intermediate position, midst. <I>La ~o de la strato (rivero); jaro (vivo); kanto (vojaĝo</I>). <B>2</B> mean, medium, compromise between extremes. <I>La vera kuŝas en la ~o. Serĉi oran ~on</I>. <B>~a</B>, (in the) m., average, medium, mid. <I>~a parto, pezo, ~a lernejo</I>, intermediate or secondary school, (log) <I>~a termino</I>, m. term. <I>Somer~a</I> (midsummer) <I>nokto</I>. <B>~e</B> (<I>en la ~o) de</I>, amid(st), among(st), in the m. (midst) of. <B>~e</B> <I>de la nokto. ~e!</I> so-so! <I>~e bona</I>, of -ing quality. <I>~e klera</I>, of fair education. <B>~aĵo</B>, mean. <B>~aga</B>, middle-aged. <I>~bona, ~kvalita, ~nombra, ~valora,</I> average, medium. <B>~grada</B>, m-ing, moderately good, second-rate. <I>~granda, ~kreska,</I> of medium size, <B>~varma</B>, temperate, <B>~voje</B>, half-way. <B>Mar~e</B>, out at (on the high) sea. <B>Nokto~o</B>, <B>tag~o</B>, [UV] mid-night, mid-day. <I>Antaŭtag~o</I>. ➞ <I>averaĝ, centr, inter(n), kern</I>.", "0"],
["mezono", "mezon-o", "(el) meson.", "0"],
["mezotinto", "mezotint-o", "mezzotint.", "0"],
["mezozoiko", "mezozoik-o", "(geol) mesozoic.", "0"],
["mezuri", "mezur-i", "(<I>-n</I>) [UV], Measur/e. <B>1</B> find the degree (quantity, size) of, mete. <I>~i alton, distancon, pezon</I>. <B>f</B> appraise, estimate, gauge, judge. <I>~i la efekton, rezulton</I>. <B>~o</B>, measure. <B>1</B> gauge, standard, rule: <I>~i ĉion laŭ sia ~o</I> (arbitrarily, by one’s own judgment). <B>2</B> degree, extent, intensity, measurement, reading, size. <B>3</B> amount -ed: <I>Tri ~oj da hordeo</I>. <B>4</B> (mus) measure, bar: <I>Tripulsa ~o</I>, 3-pulse m., 3 beats in a bar, triple time. <B>~ado</B>, mensuration. <I>Ter~ado</I>, land survey. <B>~ateco</B>, moderation. <B>~ilo</B> (instrument), m., gauge, meter, scale, standard, rule. <B>Fald~ilo</B>, folding-rule. <B>Pluv~ilo</B>, rain-gauge. <B>Takt~ilo</B> (<I>metronomo</I>). <B>Temp~ilo</B> (<I>kronometro</I>), timepiece. <B>al~i</B>, [UV] take the m. for, adjust, fit (on), suit. <I>~ado</I>, trying-on (of suit). <B>Ĉirkaŭ~o</B> (girth, size) <I>brusta, kapa, talia</I>. <B>Duon~o</B>, half-size. <B>Laŭ~a</B>, well-fitting. <I>Ne esti laŭ~a</I>, be a misfit (2 FA 99/6). <I>Laŭ~e,</I> to measure. <B>Sen~a</B>, <B>super~a</B>, boundless, limitless, excessive, exhorbitant, extreme, outrageous, unbounded, unlimited, vast. <I>Esti</I> <B>bon~a</B>, fit. <B>Egal~a</B>, <B>sam~a</B>, -ed, equable, equal, even, steady, uniform. <B>Ne~ebla</B>, immeasurable, m-less. <B>Nekun~ebla</B>, incommensurable. <B>Okul~e</B>, at a glance (rough estimate), to the eye. <B>Plen~e</B>, in full measure.", "0"],
["mi", "", "[UV] I, me. <I>~ venas</I>, I come. <I>Venu al</I> come to me. <I>Helpu ~n</I>, help me. <B>~a</B>, [UV] my, (of) mine. <I>Pronomoj ~a, ~n, kaj en mondo regas ĉiam tri</I> (P). <B>~aĵo</B>, what is mine.", "0"],
["miasmo", "miasm-o", "[OA] miasma, noxious exhalation (from marches, etc.). ➞ <I>haladz</I>.", "0"],
["miaŭi", "miaŭ-i", "[OA] <B>~o</B>, mew, miaou, cry as of cat. Miaŭ! Miaŭ! ➞ <I>katbleki</I>.", "0"],
["micelio", "miceli-o", "(<I>funga fadenaro</I>), mycelium.", "0"],
["microanalizo", "", ";", "0"],
["microfilmo", "", ";", "0"],
["microfono", "microfon-o", "[OA];", "0"],
["microfoto", "", ";", "0"],
["microkanelo", "", "(<I>gramofona</I>);", "0"],
["microkosmo", "", "; ~organismo.", "0"],
["microstrukturo", "", ";", "0"],
["midŝipmano", "midŝipman-o", "(<I>mara kadeto</I>), midshipman (<I>juna suboficiro en militŝipo</I>).", "0"],
["mielo", "miel-o", "[UV] Honey. <I>Trink~o</I> (4 FA 77/30). <B>~a</B>, of h. <I>~a gusto</I>, bland, dulcet, honied, mellifluous, sweet. <I>Lango ~a, sed koro kruela. ~a tavolo</I>, h-comb. <I>~a tempo, monato</I>, h-moon (2 A 149/14). <I>~a voĉo. ~aj vortoj</I>. <B>~e</B> <I>elokventa</I>, melliloquent. ➞ <I>allog, glat, med, nektar</I>.", "0"],
["mieno", "mien-o", "[UV] <B>1</B> Look, air, expression of face. <I>~o gaja, nigra, ruza, severa, sinfida. Fari ~on</I>, look (as though), put on a look. <B>2</B> aspect, bearing, carriage, manner, outward appearance. <I>Havi la ~on de</I> (look like) <I>fripono. Ne ŝanĝante la ~on</I>, without turning a hair. <B>~i</B> (<I>aspekti) (kiel</I>), appear as, look. like. <I>~i frenezule</I>. <B>Grav~a</B>, grave, serious, 1 ing solemn. <B>Lip~i</B>, purse one’s lips. <B>Rigid~a</B>, stiff. ➞ <I>aspekt, fizionomi, ŝajn, trajt</I>.", "0"],
["migalo", "migal-o", "purse (trapdoor) spider (<I>Mygale</I>). <B><I>~o</I> birdomanĝa</B>, bird-eating spider.", "0"],
["migdalo", "migdal-o", "[UV] Almond, nut of ~arbo <B>(<I>Amygdalus</I>)</B> (Pr 12/5). <B><I>~o amara, dolĉa, sukerita</I></B>. <B>~a sukeraĵo</B>, nougat. <B>~oleo</B>, a-oil.", "0"],
["migreno", "migren-o", "(a. <I>hemikranio</I>), migraine, recurrent fits of headache.", "0"],
["migri", "migr-i", "[UV] Migr/ate. <B>1</B> move from place to place, roam, rove, wander. <B>2</B> (zoo) come and go with the seasons. <B>3</B> travel to far distance. <I>~i tra la mondo</I>. <B>~(ant)a</B>, -ant, -atory, nomadic, roving, unsettled. <I>~anta aktoro</I>, strolling player. <I>~a birdo,</I> bird of passage. <I>~a predikisto</I>, itinerant (peripatetic) preacher. <I>~a raŭpo</I>, processionary caterpillar. <B>~(ad)o</B>, -ation, journeying, wandering, perigrination. <I>~ado de birdoj, fiŝoj, popoloj</I>. <B>~anto</B>, <B>~ulo</B>, globetrotter, traveller, wayfarer. <I>~anto mi estas sur la tero</I>. <B>~ema</B>, fond of roaming. <B>~emo</B>, wanderlust, <B>f</B> <I>~emulo</I>, rolling stone. <B>El~i</B>, emigrate, leave the country. <B>En~i</B>, immigrate. <B>Trans~ado</B>, transmigration. <B>Reen~intoj</B>, returned exiles (Ez 10/8). ➞ <I>ekskurs, turist, vag, vojaĝ</I>.", "0"],
["mikado", "mikad-o", "mikado.", "0"],
["mikologio", "mikologi-o", "(<I>fungologio</I>), mycology.", "0"],
["mikro", "mikro-", "(Gk pfx = small), micro-.", "0"],
["mikro", "mikro-", "<B>~tomo</B>. Unit-names: <B>~ampero</B>, <B>~farado</B>, <B>~gramo</B>, <B>~kulombo</B>, <B>~litro</B>.", "0"],
["mikrobo", "mikrob-o", "[OA] microbe (<I>mikroorganismo</I>).", "0"],
["mikrokoko", "mikrokok-o", "micrococcus;", "0"],
["mikrometro", "mikrometr-o", "[OA] -volto.", "0"],
["mikromuso", "mikromus-o", "harvest mouse. (<I>Micromys</I>).", "0"],
["Mikronezio", "Mikronezi-o", "FM.", "0"],
["mikrono", "mikron-o", "micron.", "0"],
["mikroskopo", "mikroskop-o", "[OA]: <B>~a</B>, -ic = <B>1</B> tiny, <I>~a estaĵo</I>. <B>2</B> by means of a -scope, visible with a m. <I>~a esploro</I>.", "0"],
["mikroto", "mikrot-o", "grass (field) vole (<I>Microtus</I>). ➞ <I>arvikol</I>.", "0"],
["mikseno", "miksen-o", "(ich) hag(fish) (<I>Myxine</I>).", "0"],
["miksi", "miks-i", "[UV] (<I>-n</I>). Mix (objs), amalgamate, blend, combine, compound, mingle, put together. <I>~i akvon kun vino, sablon kun sukero. ~i kolorojn, rasojn. ~i</I> (shuffle) <I>kartojn</I>. <B>f</B> <I>Ĝojo ~ita kun ploro</I>. <B>~ita</B>, -ed, associated, blended, mingled, varied. <B>~aĵo</B>, -ture, blend, jumble, miscellany. <I>~aĵo de ruzo kaj naivo</I>. <B>~ebla</B>, miscible. <B>~iĝi</B> (<I>sin ~i) (en</I>), be -ed up with, associated, blended, joined with, concerned, involved in. <I>Rido ~iĝis kun larmoj</I>. <B>~devena</B>, <B>~rasa</B>, of -ed origin, cross-bred, hybrid, mongrel. <B>Al~i</B>, admix, m. in with. <I>~~aĵo</I>, added matter. <B>Dis~i</B>, (cul) thin out. <B>En~i</B>, m. in, intermix. <B><I>~~</I>iĝi</B> (<I>sin ~i</I>), interfere with, meddle in. <B>~~iĝema</B>, meddlesome, officious, (typ) <B>Fuŝ~o</B>, pie. <B>Inter~i</B>, confuse, m. together, interlard, tangle up. <I>la signifojn de du vortoj</I>. <B>~~iĝi</B>, intermingle. <B><I>~~</I>ita</B><I>,</I> heterogenous, of various kinds. <I>~~ite</I>, in confusion, indiscriminately, pell-mell, promiscuously. <B>Kun~i</B>, m. together, blend (e.g., <I>teojn</I>), triturate. <B>Mal~i</B>, separate, sort out. <B>Sen~a</B> (<I>ne~ita, pura</I>), neat, pure, without alloy, un-ed, unadulterated. <I>Sen~a raso</I>. <B>Bat~i</B>, scramble (<I>ovojn</I>). <B>Ras~i</B>, cross, interbreed. ➞ <I>heterogen, interplekt, kirl, konfuz, kunfand, maldisting</I>.", "0"],
["milda", "mild-a", "[OA]<B>.</B> Mild, Gentle. <B>1</B> affable, bland, kind, meek. ~a karakter-(okul-rigard -vort-)o. <B>2</B> calm, placid, pleasant, soft, tranquil. ~a <I>klimato, lumo, tono, tuŝo, voĉo, vento, vetero</I>. ~a respondo (Se 15/1). <B>3</B> (<I>malsevera, neforta</I>): ~a <I>luno, regulo</I>; <I>biero, medikamento</I>. <B>~e</B>, g-ly, m-ly, lightly. <B>~e</B> <I>paroli, riproĉi</I>. <B>~eco</B>, g- ness. <B>~igi</B>, mitigate, soften, temper, tone down. ~igi <I>disputon, doloron, esprimon, krizon, malamon, mizeron</I>. ~igaj <I>cirkonstancoj</I>. <B>Mal~a</B>, cruel, hard, harsh, severe, stringent. ➞ <I>afabl, dole, induling, kviet, seren</I>.", "0"],
["mili", "mili-", "(ppfx) = 1000th pt, mili-. ~ampero, ~baro.", "0"],
["miliardo", "miliard-o", "[OA] milliard, thousand millions. ➞ <I>bilion</I>.", "0"],
["milico", "milic-o", "Militia, military force. <B>~ano</B>, m- man.", "0"],
["miligramo", "miligram-o", "[OA] ~litro.", "0"],
["milimetro", "", "[OA].", "0"],
["milio", "mili-o", "[UV] (ordinary language) Millet in gen. (Jeĥ 4/9). <B>2</B> strictly = wood (spreading) m. grass (<I>Milius</I>), used only as birdseed. <B>Rim</B>.: The Millet cereals are <B>Eleusine, Panicum, Pennisetum, Setaria, Sorghum… .</B> The Biblical m. is probably <B><I>Panicum miliaceum</I></B> or <B><I>Sorghum vulgare</I></B>. ➞ <B><I>panik, setari, soring</I></B>.", "0"],
["miliono", "milion-o", "[UV] Million (<I>mil miloj</I>). <B>~ulo</B>, -aire.", "0"],
["militarismo", "militarism-o", "<B>militarist-o</B>, militar-ism, -ist.", "0"],
["milito", "milit-o", "[UV] War, hostilities, armed conflict. <I>Deklari, fari, gajni, perdi, proklami ~on. ~o atoma, fulma, monda</I>. <B>Enlanda ~o</B>, civil w. <B>Kruc~o</B>, crusade. <B>~i</B> (nt) (<I>kontraŭ</I>), (make) w. (on), fight. <I>Du ~as, tria profitas</I>. <B>f</B> combat, battle (contend, crusade) against. <B>~(ad)o</B>, w-fare. <B>~a</B>, of w., martial, military. <I>~a kanto, preparo</I>. <B>~anto</B>, belligerant, combatant, warrior. <B>~ema</B>, bellicose. <B>~estro</B>, captain, commander, w-chief. <B>~isto</B>, soldier. <I>~ista,</I> soldierly. <I>~istaro (armeo</I>), army, troops. <I>~istejo</I>, barracks, quarters. <B>~iro</B>, campaign. <B>al~i</B> [UV] (<B>Per~i</B>) (<I>konkeri</I>), acquire by w. <B>Kontraŭ~isto</B>. ➞ <I>arme, batal, soldat</I>.", "0"],
["milvo", "milv-o", "[OA] Kite (<I>Milvus) (</I>Jes 34/15). <B>~o nigra</B>, black k. <B>~a</B>, milvine.", "0"],
["mil(o)", "", "[UV] Thousand, ~ejoj (Mi 5/2). ~obla, t-fold. ~ono, t-th. ~ope, by (in) tt, a t. at a time. <B>~folio</B> (<I>akileo</I>), milfoil. <B>Jar~o</B> (early writings <I>~jaro</I>), millenium (Rj 26/28). <B>Rim</B>.: Write <I>Ducent dudek du</I> (222): i.e., one word for each figure. But not so with <I>mil</I>. Write 25,000 as Dudek kvin mil (or, miloj), not <I>dudek kvinmil</I> (ambiguous). ➞ No 1/21 and the following verses.", "0"],
["mimeografi", "mimeograf-i", "reproduce by stencil.", "0"],
["mimiki", "mimik-i", "[OA] ape, imitate, mimic, take off. <B>~o</B>, mimicry. ➞ <I>mokimit, pantomim</I>.", "0"],
["mimo", "mim-o", "<B>1</B> mocking-bird (<I>Mimus</I>). <B>2</B> (<I>gestlingvo</I>), mime, expression by gesture, dumb show, <B>~i</B> (<I>paroli per ~o</I>), m.", "0"],
["mimolo", "mimol-o", "monkey-flower (<I>Mimulus). ~o moska</I>, musk plant (<I>M. moschatus</I>).", "0"],
["mimozo", "mimoz-o", "[OA] mimosa. <I>~o sentema (sensitivo</I>), sensitive plant.", "0"],
["minaci", "minac-i", "(<I>-n, al, je, per</I>) [UV] (<I>uzi ~ojn</I>), Menace, Threaten, announce intention to damage or hurt, intimidate. <I>~i per pugno. ~i je batado, morto, proceso, puno, venĝo</I>. <B>f</B> (<I>-n</I>), announce approaching misfortune, forebode, portend, presage. (<I>nt</I>) be imminent, impend, lour, overhang. <B>~o</B>, m., threat, <B>f</B> cloud, portent. <B>~a</B>, menacing, baneful, ill-boding, imminent, minatory, ominous, sinister, threatening.", "0"],
["minareto", "minaret-o", "[OA] minaret, turret of mosque.", "0"],
["mineralo", "mineral-o", "[OA] (<I>~aĵo</I>), Mineral. <B>~a</B>, m. <I>~a akvo, oleo, regno</I>.", "0"],
["mineralogio", "mineralogi-o", "mineralogy.", "0"],
["mineralogo", "mineralog-o", "mineralogist.", "0"],
["miniaturo", "miniatur-o", "[OA] Miniature. <B>1</B> small picture or portrait, reduced image. <B>2</B> small delicate art object. <B>~a</B>, m., diminutive, tiny. <B>~e</B>, in m., on a small scale. <B>~i</B>, represent in m.", "0"],
["minimumo", "minimum-o", "[OA] Minimum, least amount obtainable, smallest quantity. <I>Porti la ~on da pakaĵoj</I>. <B>~a</B> <I>elspezo, prezo</I>. <B>~e</B>, at least. <B>~igi</B>, -ize. (mus intvl) <I>~a (malpliigita</I>), diminished. <I>~a kvinto, septo, triado</I>.", "0"],
["minio", "mini-o", "minium, red (oxide of) lead.", "0"],
["ministro", "ministr-o", "[OA] (pol) Minister (of state). [<I>Ne = pastro</I>]. <I>~o pri Eksteraj (Internaj) Aferoj</I>, M. of Foreign (Home) Affairs, (Home Sec). <I>~o pri milito, publika instruado. ~o senpostena</I>, m. without portfolio. <B>~aro</B> (<I>kabineto</I>), cabinet, government, Ministry. <I>~ara krizo</I>, -ial crisis. <B>~ejo</B> (a. <I>ministerio</I>). <B>1</B> -ial offices. <B>2</B> ministry. government, department. <I>Milita</I> ~ejo, War Office. <B>ĉef~o</B>, prime m. <B>Sub~o</B>, undersecretary of state. ➞ <I>ambasador</I>.", "0"],
["mino", "min-o", "[UV] Min/e. 1 (<I>ercejo</I>), excavation, pit, shaft, <B>f</B> well-stocked source (of information, etc.). <B>2</B> (mil) explosive m. (H/110). <B>3</B> (<I>eksplodkesto</I>), (mar) m. to destroy ship by collision. <I>~o flotanta</I>. <B>~i</B>, m. <B>1</B> burrow, dig for ore, obtain from m. <B>2</B> (<I>~bori</I>), lay m., under-m. <I>~i ponton</I>. <B>~a</B>, <I> ing</I>. <B>~aĵo</B> (<I>erco</I>), minerals, ore from m. <I>Fer~aĵo</I>, iron ore. <B>~ejo</B>, m ing field. <I>Fer~ejo, karb~ejo, or~ejo, sal~ejo</I>, coal-m., etc. <I>Sxton ~ejo</I>, quarry. <B>~isto</B>, -er, pitman. <I>Ŝipo</I> <B>~foriga</B> (<B>~sema</B>), m-sweeper, -layer. <B>Kontraŭ~i</B>, <B>Sub~i</B>, counter-(under-)m. <B>Sen~igi</B>, clear of mines.", "0"],
["minora", "minor-a", "Minor, (log) <I>~a premise</I> i. (mus) <I>~a intervalo, trito</I>, m. interval, (third). <I>~a akordo, modalo, skalo, m</I>. chord (mode, scale) (= with m. third at base). ➞ <I>major</I>.", "0"],
["minoritato", "minoritat-o", "minority. <B>1</B> (jur) under age of maturity. <B>2</B> (pol) = <I>malplimulto</I>.", "0"],
["minstrelo", "minstrel-o", "(a. <I>menestralo</I>), Minstrel. <B>~aro</B>, <B>~arto</B>, -sy.", "0"],
["minus", "", "(prep), Minus, less, with the deduction of. 10 ~~ <B>2</B> = 8. ~a <I>signo \"-\"</I>. <B>~o</B>, deficit. <B>~komplekso</B>, inferiority complex. <B>~valoro</B>, depreciation, drop in value. ➞ <I>plus</I>.", "0"],
["minusklo", "minuskl-o", "(typ) small (lower case) letter. Opp <I>majuskl</I>.", "0"],
["minuto", "minut-o", "[UV] Minute (60th of hour or degree). <I>~a montrilo</I>, m-hand. [Ne= <I>protokoler]</I>.", "0"],
["mioceno", "miocen-o", "(<I>~a periodo</I>), miocene period.", "0"],
["miogalo", "miogal-o", "[UV] (zoo) desman (<I>Myogale moschata</I>). ➞ <I>fiber</I>.", "0"],
["miopa", "miop-a", "[UV] (opt) nearsighted, shortsighted, myopic. <B>~(ec)o</B>, myopia, s.s-edness. <B>~ulo</B>, s.s-ed person. <B>Mal~a</B>, long-sighted.", "0"],
["miozoto", "miozot-o", "[UV] (<I>ne-min-forgesu</I>), forget-me-not, scorpion grass (<I>Myosotis</I>).", "0"],
["mirabelo", "mirabel-o", "[OA] mirabelle, sweet yellow plum.", "0"],
["miraĝo", "miraĝ-o", "mirage, optical illusion (especially of water in desert) (also figuratively).", "0"],
["miraklo", "mirakl-o", "[OA] Mirac/le, marvellous work due to supernatural agency. <I>Fari ~ojn,</I> work mm. (Ps 118/23). <B>~a</B>, -ulous, supernatural, <B>f</B> extraordinary (event or obj), remarkable, wonderful. <B>Signo~o</B>, sign.", "0"],
["mirho", "mirh-o", "[UV] myrrh, gum-resin used for incense, medicine, perfume. (Mt 2/11). ➞ <I>balzam, incens</I>.", "0"],
["miri", "mir-i", "(<I>pri, ke</I>) [UV], Marvel, be Astonish/ed, filled with Surprise (Wonder), taken aback. <I>[Ne= scivoli</I>, or <I>sin demandi ĉu]. ~i, ke oni ne respondis. ~i, vidante</I> (be s-ed to see), <I>ke</I>. <B>~o</B>, s., w., mingled with admiration or bewilderment. <I>Je mia ~o</I>, to my s. <I>Rigardi kun ~o</I>. <B>~e</B>, w-ingly. <B>~ego</B>, stupefaction. <B>~egi</B>, be amazed, astonished, astounded. <I>Muta de ~ego</I>, dumbfounded. <B>~eginda</B>, stupendous. <B>~igi</B> (<I>kaŭzi ~on</I>), s., amaze. <B>~iga</B><I>,</I> a-ing, s-ing, startling, wondrous. <B>~inda</B>, m-lous, wonderful, exceeding expectation, remarkable. <I>~inda infano</I>, infant prodigy. <I>Ne ~e!</I>, no wonder, it is not surprising! <B>~indaĵo</B>, m. w., sight, spectacle, something remarkable. <B>~frapite</B> (<I>grand~e</I>), w-struck. ➞ <I>gap, surpriz</I>.", "0"],
["miriado", "miriad-o", "[OA] myriad, 10,000. <B>f</B> any great number (Ps 3/6).", "0"],
["miriametro", "miriametr-o", "[OA] myriameter.", "0"],
["miriapodo", "miriapod-o", "myriapod.", "0"],
["mirido", "mirid-o", "(bot) sweet cicely (<I>Myrrhis odorata</I>).", "0"],
["miriko", "mirik-o", "(bot) bog myrtle, sweet gale (<I>Myrica</I>).", "0"],
["miriofilo", "miriofil-o", "water-milfoil (<I>Myriophilum</I>).", "0"],
["mirlitono", "mirliton-o", "kazoo (toy m.i.).", "0"],
["mirmekofago", "mirmekofag-o", "(<I>formikmanĝulo</I>), ant bear, great anteater (<I>Myrmecophaga</I>).", "0"],
["mirmeleono", "mirmeleon-o", "(ent) ant lion (<I>Myrmeleon</I>).", "0"],
["mirobalano", "mirobalan-o", "cherry plum (<I>Prumis cerasifera</I>).", "0"],
["mirtelo", "mirtel-o", "[UV] bil-(blae-blue-whortle-) berry (<I>Vaccinium myrtillus</I>). ➞ <I>mirt, oksikok, uliginos, vakcini</I>.", "0"],
["mirto", "mirt-o", "[UV] Myrtle (<I>Myrtus</I>). <B>~acoj</B>. <B>~kolora</B> (<I>grizverda</I>), m.", "0"],
["mis", "mis-", "[OA] (<I>erare, malĝuste, maltrafe</I>), (pfx) mis-, amiss, incorrectly, in error, wide of the mark, wrongly. ~citi, ~loki, ~meti, ~presi, ~prezenti, misquote, misplace, mislay, misprint, misrepresent. <B>~paŝo</B>, false step. <B>~proporcia</B>, disproportionate. <B>~a</B> <I>konkludo,</I> wrong conclusion. <B>~o</B> (sp) fault, foul, miss. Mis! butterfingers! <I>Cell (Ludi</I>) <B>sen~e</B>, faultlessly. ➞ <I>fuŝ</I>.", "0"],
["misalo", "misal-o", "(rc) missal.", "0"],
["misio", "misi-o", "[UV] Mission. <B>1</B> body of persons sent to conduct negociations, or (rel). <B>2</B> vocation, charge, errand, trust, work. <B>~ano</B>, member of m. <B>~isto</B>, -ary, -er, evangelist.", "0"],
["mistero", "mister-o", "[UV] Myst/ery, Secret. <B>1</B> rel. truth, s-doctrine, divinely revealed or beyond human reason. <B>2</B> something hidden, not easily explainable or understood. <B>~(aĵ)o</B>, m., obscurity, secrecy. <I>~oj de la oriento. Fari ~on</I> (be very reticent) <I>pri</I>. <B>~a</B>, [UV] full of (wrapped in) m., -erious, s., dark, hidden, inscrutable, obscure, uncanny. <I>~aj signoj, sonoj, vortoj. ~a krimo, lando, ordono, rideto</I>. <B>~ejo</B> (Jeĥ 7/22). <B>~umi</B>, make a m. of, treat as a s. ➞ <I>enigm, mistik, sekret</I>.", "0"],
["mistif(ik)i", "mistif(ik)-i", "(<I>ŝerctrompi</I>) (<I>-n</I>), Mystif/y, bewilder, hoax, make a fool (play on credulity) of, wrap up in mystery. <B>~o</B>, -ication.", "0"],
["mistika", "mistik-a", "[OA] Mystic(al), dark, emblematic (al), esoteric, occult, spiritually allegorical, symbolical, with hidden meaning. <I>~a doktrino, instruo, signifo</I>. <B>~(ec)o</B>, <B>~(ism)o</B>, -ism, quietism. <B>~ulo</B>, m., one who aims to learn truth by contemplation (self-surrender, spiritual apprehension), etc.", "0"],
["mistralo", "mistral-o", "(met) mistral, cold NW wind of S France.", "0"],
["mito", "mit-o", "[OA] Myth, traditional tale of antiquity, usually involving the supernatural. <B>~a</B>, -ical, fabulous, fictitious, imaginary.", "0"],
["mitologio", "", "[UV] mythology. ➞ <I>fabel, fantazi, rev</I>.", "0"],
["mitologo", "", "mythologist.", "0"],
["mitrajlo", "mitrajl-o", "grape-shot. <B>~i</B>, pepper, rake.", "0"],
["mitralo", "mitral-o", "machine-gun.", "0"],
["mitro", "mitr-o", "[OA] mitr/e, head-dress of high-priest (bishop, prelate) (El 28/40). <B>~ita</B>, -ed. ➞ <I>cidar</I>.", "0"],
["mitulo", "mitul-o", "[OA] (mol) Mussel (<I>Mytilus</I>). <B>~ejo</B>, m-bed.", "0"],
["mizantropo", "mizantrop-o", "(<I>homevitulo</I>), Misanthrop/e. <B>~a</B>, -ic. <B>~eco</B>, -y.", "0"],
["mizero", "mizer-o", "[UV] Miser/y, Wretched/ness (of mind or circumstance). <B>1</B> affliction, distress, suffering, trouble. <B>2</B> adversity, destitution, misfortune, need, want. <I>Fremda ~o ne estas sufero. Maro da ~oj</I>. <B>~a</B>, m-able, w., hapless, pitiable, unfortunate, unhappy. <B>2</B> abject, contemptible, despicable, mean, poor in quality. <I>~a aspekto, nutraĵo</I>. <B>~i</B> (<I>esti en ~o). Kiam sako ~as (malplenas), amo malaperas</I>. <B>~eco</B>, <B>~iĝo</B>, destitution, indigence. <B>~ego</B>, deep distress, extremity. <B>~ulo</B>, poor wretch, unfortunate wight. ➞ <I>kompatind, malbonstat</I>.", "0"],
["mizogino", "mizogin-o", "misogynist, woman-hater.", "0"],
["mjelo", "mjel-o", "(anat) spinal chord. <B>~ito</B>, myelitis. <I>Osto~ito, polio~ito</I>.", "0"],
["mnemoniko", "mnemonik-o", "Mnemon/ics, art of aiding memory. <B>~a</B>, -ic, of (for) the memory. <I>~a sistemo</I>.", "0"],
["Mo", "M-o", "[F], letter M.", "0"],
["mobilizi", "mobiliz-i", "(<I>-n</I>) [OA], Mobiliz/e, bring into (collect and train for) active service. <I>~i la armeon, policon, publikan opinion, siajn fortojn</I>. <B>~o</B>, -ation, <I>Ordoni ~on</I>. <B>Mal~i</B>, de-m.", "0"],
["modalo", "modal-o", "(log) (mus) Mod/e. <I>~o aŭtenta, maĵora, minora</I>. <B>~a</B>, -al. <B>~eco</B>, -ality. <B>Sub~o</B> (<I>~o plagala</I>), plagal m.", "0"],
["modelo", "model-o", "[UV] Model. <B>1</B> figure, three- dimensional representation. <B>2</B> design, example (person, thing) for (worthy of) imitation, original. <I>~o de bona gusto (simpleco, stilo</I>). <B>Kontur~o</B>, pattern. <B>Norm~o</B>, standard. <B>3</B> (<I>pozist(in)o</I>), artist’s m. <B>~a</B>, m., exemplary, ideally perfect, <I>~a konduto</I>. <B>~i</B>, m., mould shape. <B>~ilo</B>, block, mould, model. <B>~ino</B>, artist’s m. <I>Servi kiel ~ino</I>. <B>~isto</B>, -ler, pattern-cutter, etc. ➞ <I>ekzempl, kopi, modi, stencil, ŝablon</I>.", "0"],
["modera", "moder-a", "[UV] Moderat/e, judicious, limited, mild, not extreme, reasonable, temperate. <I>~a ambicio, partio, postulo, prezo. Manĝi</I> <B>~e</B>, in -ion. <B>~(ec)o</B>, -ion, sobriety. <I>Vivo sen ~o kondukas al mizero</I>. <B>~igi</B>, m., render less intense; abate, assuage, check, curb, lessen, mitigate, reduce, restrain, soften, temper, <I>~i ardon, koleron, prezon, senpaciencon</I>. <B>~igilo</B>, (phot) restrainer. <B>~iĝi</B>, become less violent, calm down. (wind) die down, subside. ➞ <I>kontent, limig, mez, modest, sobr</I>. <B>Mal~a</B>, im-m, excessive, extravagant. ➞ <I>eksces, ekstrem, senbrid, tro</I>.", "0"],
["moderna", "modern-a", "[OA] Modern, present-day, up-to-date. <I>~a domo, historio, ideo, invento, modo, scienco</I>. <B>~eco</B>, -ity. <B>~ismo</B>, -ism. <B>~ulo</B>, m. <B>~igi</B>, -ize. <B>Mal~a</B>, ancient, antiquated, old, out-of-date. ➞ <I>hodiaŭ, nun(temp</I>). Opp <I>antikv, mezepok</I>.", "0"],
["modesta", "modest-a", "[UV] Modest. <B>1</B> (person) bashful, decorous, retiring, unassuming. <I>~a homo, virino</I>. <B>2</B> (thing) discreet, moderate, simple, unobtrusive, unostentatious, unpretentious), quiet. <I>~a domo, elspezo, postulo, aranĝo, salajro, vivo</I>. <B>~e</B>, in a small way, imply, without conceit. <B>~eco</B>, -y, diffidence, implicity. <B>Mal~a</B>, im-m, bumptious, onceited, egotistic(al), forward, vain, ➞ <I>humil, moder, nepretendem, senbril, senluks, senpomp, simpl</I>.", "0"],
["modifi", "modif-i", "(<I>-n</I>) [OA], Modif/y, alter in detail, nend, change, give new form to, make changes in, vary. <I>~i aranĝon, formon, opinion, projekton, regulon, signifon</I>. <I>~i</I> (qualify) <I>rbon</I>. <B>~(aĵ)o</B>, -ication, alteration, change, riation. <B>~ebla</B>, -iable. <B>~iĝi</B>, be -ed, ered.", "0"],
["modiuro", "modiur-o", "(arch) Moulding (ornamental), ribbon-like shaping in building, furniture, etc. <I>&gt; astragal, cimati, kornic, listel</I>. <B>~i</B>, cut am.", "0"],
["modli", "modl-i", "(<I>-n</I>), (sculpture) Mould, fashion, form, shape (by kneading clay, wax, etc.). <B>~ado</B>, -ing (in clay). <B>~ebla</B>, plastic. <B>~ilo</B>, boaster, paring, roughing chisel.", "0"],
["modo", "mod-o", "[UV] <B>1</B> (the) Fashion (Mode), prevailing custom (style, vogue). <I>En</I> <B>~o</B>, in f., <I>a la mode</I>. <I>La Pariza ~o</I>. <B>~a</B>, f-able, stylish. <I>~a fasono, gazeto, vesto. Estas</I> ~e <I>tion fari</I>. <B>~aĵoj</B>, articles of f. <B>~istino</B>, dressmaker, modiste, milliner. <B>~ulo</B>, man of f. <B>Eks~a</B>, <B>ekster~a</B>, <B>malnov~a</B>, antiquated, obsolete, old-time, out of date. <B>El~iĝi</B>. <B>Nov~a</B>, new fangled, up-to-date. <B>Last~a</B>, in the latest f. <B>Laŭ~a</B>, chic, posh, smart, swell. <B>2</B> (gram) mood. <I>~o kondiĉa, indikativa</I>. ➞ <I>fason, kapric, manier, modal, model, mor</I>.", "0"],
["moduli", "modul-i", "[OA] Modulat/e, <B>1</B> (<I>-n</I>), adjust, inflect, regulate, vary (tone of voice, etc.). <B>2</B> (mus) (<I>ŝanĝi modalon aŭ tonalon</I>), change mode or key. <B>~(ad)o</B>, <B>~aĵo</B>, inflection, m-ion. (mus) change of mode or key, transition. <I>~o abrupta, enharmona, grada</I>. (rad) <B>~o</B> <I>amplituda, faza, frekvenca. La muziko ofte</I> <B>~iĝas</B>.", "0"],
["mohajro", "mohajr-o", "(tex) mohair (from hair of Angora goat, or imitation).", "0"],
["mokaseno", "mokasen-o", "(<I>fela piedvesto</I>), mocassin.", "0"],
["moki", "mok-i", "(<I>-n</I>) [UV], Mock, deride, jeer (scoff) at, make a butt (sport) of, poke fun at, (hold up to) ridicule, taunt. <I>~i maljunulon</I>. <B>f</B> <I>Ne ~u riveron, ne atinginte la teron</I>. <B>~(em)a</B>, bantering, derisive, scornful, sneering. <B>~e</B>, tauntingly. <I>imiti</I>, caricature, mimic. <I>~e krii</I>, boo, hoot. <I>~e ridi</I>, laugh to scorn, scoff at, <B>~ado</B>, -ery, contemptuous mimicry, derision, raillery, ridicule. <B>~(at)aĵo</B>, byword, laughing-stock. <B>~ema</B>, caustic. <B>~eti</B>, banter, chaff, <B>~anto</B>, <B>~ulo</B>, -er. ➞ <I>rid, rikan, sarkasm, satir</I>.", "0"],
["mola", "mol-a", "[UV] Soft. <B>1</B> yielding to pressure, easily cut, plastic, tender: <I>~a kiel butero, vakso. ~a argilo, fero, karbo, muskolo, viando</I>. <B>2</B> downy, spongy, velvety: <I>~a kuseno, lano, lito, tapiŝo</I>. <B>3</B> compliant, irresolute, pliable, submissive, weak: <I>~a kapo, karaktero</I>. <B>4</B> (<I>kompatema</I>) gentle, kind, mild, tender: <I>~a koro</I>. <B>5</B> effeminate, luxurious: <I>~a vivo</I>. <B>6</B> delicate: <I>~a koloro, lumo</I>. <B>7</B> without mineral salts: <I>~a akvo</I>. <B>8</B> <I>~e kuirita ovo</I>. <B>~aĉa</B>, flabby, flaccid, floppy, limp, spineless. ~<B>aĵo</B>, [UV] crumb (<I>pano</I>), pulp (<I>frukto). Ter~aĵo</I>, mould. <B>~igi</B>, -en, mollify. <I>~igi la koron; ~igi vakson per varmigo. ~iga</I>, emollient. <B>~iĝi</B>, -en, grow tender, <B>~ulo</B>, mollycoddle, softy, (novice) tenderfoot, ➞ <I>cedent, facil-ced, mild, nefirm</I>. <B>Mal~a</B>, Hard. <B>1</B> firm, resistant, rigid, tough, unyielding. <I>~~a kiel fero. ~~a lito, ŝtono</I>. <B>2</B> callous, inflexible, unfeeling. <I>~~a koro</I>. ➞ <I>bronz, fer,gard, kruel, nuk, rigid, sever, ŝton</I>.", "0"],
["molao", "mola-o", "(<I>mara felsako</I>), sunfish (<I>Mold</I>).", "0"],
["molaro", "molar-o", "<I>= mueldento</I>.", "0"],
["Moldavujo, Moldavio", "Moldav-ujo, Moldavi-o", "MD.", "0"],
["molekulo", "molekul-o", "[OA] molecul/e. <B>f</B> small particle. <B>~a</B>, molecular. <I>~a modelo, pezo, strukturo</I>. ➞ <I>atom</I>.", "0"],
["moleo", "mole-o", "(mar) breakwater, mole.", "0"],
["molesti", "molest-i", "molest, subject to annoyance, interfere (meddle) with hostilely or injuriously; badger, harass, pester, plague. ➞ <I>ĝeneg, incit, plag</I>.", "0"],
["molibdeno", "molibden-o", "(chem) molybdenum (Mo).", "0"],
["molinio", "molini-o", "moor-grass (<I>Molinid</I>).", "0"],
["moloko", "molok-o", "moloch lizard, thorn-devil (<I>Moloch horridus</I>).", "0"],
["molusko", "molusk-o", "[OA] mollusc. ~oj, -a.", "0"],
["molvo", "molv-o", "(ich) ling (<I>Molva</I>).", "0"],
["momanto", "momant-o", "(mec) moment. <B>1</B> A measure of the rotational effect of a force. <B>2</B> the product of any quantity, and a function of a distance. <I>~o de forto (de inerteco). ~o dupolusa</I>, m. of a dipole. <I>~o magneta</I> magnetic m.", "0"],
["momento", "moment-o", "[UV] Moment (<I>tempero</I>). <B>1</B> point of time: flash, instant, jiffy, second, trice, wink. <I>~o da silento. (Unu) ~on!</I> half a m., wait a bit. <I>Antaŭ ~o,</I> a m. ago. <I>De la m. kiam</I>, ever since the m. when. <I>Post ~o (preskaŭ tuj</I>). <B>2</B> deciding persont (circumstance). <I>~o grava, epokfaranta. En la ĝusta ~o. Elekti sian ~on</I>, choose one’s time. <B>~a</B>, -ary, instananeous, lasting only a m., ephemeral, short-lived, temporary. <I>~a krizo, paŭzo, sono. ~a foto</I>, snap(shot). <I>Edziĝo ~a (tro rapida) estas longapenta</I>. <B>~e</B> (<I>dum</I> ~o), at (for) a m., temporarily. <B>Ĉiu~e</B>, at any m. <B>Last~e</B>. <B>Sam~e</B>. <B>Sam~igi</B>, synchronize. ➞ <I>daŭr, tuj</I>.", "0"],
["momentumo", "momentum-o", "(<I>impulso</I>), (mec) momentum, way: force of a moving body; product of mass multiplied by velocity; impetus gained by movement.", "0"],
["momordiko", "momordik-o", "balsam apple (pear) (<I>Momordica</I>). ➞ <I>ekbali</I>.", "0"],
["monado", "monad-o", "(phi) monad.", "0"],
["monaĥo", "monaĥ-o", "[UV] Monk, friar. ~(ej)a, -ish, monastic. <B>~eco</B>, <B>~ismo</B>, monasticism. <B>~ejo</B>, monastery. <B>~estro</B>, prior, superior. <B>~ino</B>, nun. <I>~~ejo</I>, convent, nunnery. <I>~~iĝi</I>, take the veil. <B>Eks~o</B>, ex-m. ➞ <I>abat, prior</I>.", "0"],
["Monako", "Monak-o", "MC.", "0"],
["monarĥo", "monarĥ-o", "[UV] (<B>monarko</B> [OA]), Monarch. <I>Absoluta, konstitucia</I>. <B>~a</B>, -ic. <B>~isto</B>, -ist. <B>~eco</B>, <B>~ejo</B>, <B>~io</B>, <B>~lando</B>, -y. ➞ <B><I>regnestr, suveren</I></B>.", "0"],
["monato", "monat-o", "[UV] Month, ~o <I>kalendara, luna</I>. <I>~o(n) post hodiaŭ</I>, a m. from today. <B>~aĵoj</B>, menses. ➞ <I>menstru</I>. <B>Ĉiu~e</B>, m-thly, <I>~~a gazeto</I>. <B>Duon~a</B>, <B>~e</B> fortnightly. <B>Po~e</B>, by m-ly instalments. <B>Tri~a</B>, quarterly. <B>Rim</B>.: En F (kaj en tiu ĉi vortaro) la nomoj de monatoj havas majusklon (Januaro, Februaro k.t.p). La ĝenerala uzo en 2014 kutime preferas minusklan skribon (januaro, februaro k.t.p.). Ambaŭ uzoj ŝajnas allaseblaj.", "0"],
["mondo", "mond-o", "[UV] World. <B>1</B> scene of existence: <I>Veni en la ~on (ekaperi, naskiĝi). La spirita, venonta ~o</I>. <B>2</B> mundane interests, (opp <I>ĉiel, spirit</I>): <I>La ~o estas ĉiam kun ni. Tentoj de la ~o, la karno, kaj la diablo. Esti en la ~o, sed ne de la ~o</I>. <B>3</B> (la universo, ĉio): <I>La fino de la ~o</I>. <B>4</B> (<I>la terglobo): Mapo de la ~o. Gajni la tutan ~on. Aliaj ~oj ol nia. <B>5</B> its inhabitants, people: La nova ~o. Federacio de la ~o. La Romana ~o. La tuta ~o scias. Sin retiri de la ~o</I>. <B>6</B> <I>domain, sphere: ~o de sporto (de revoj). La Esperanta, literatura ~o. <B>~(ec)a</B>, w-ly, earthly, mundane. <B>~aĵoj</B>, things of this w. <B>~umo</B>, fashionable life, society circles, the upper ten. <B>~~</B></I><B>ul(in)o</B>, (<I>wo)man of fashion, society lady, socialite</I>. <B>El</B> <I><B>trans~e</B>, from beyond the tomb. <B>Tut~a</B>, w-wide, universal. Tut~a historio, lingvo, religio</I>. <I>➞ ter</I>.", "0"],
["monedo", "moned-o", "<I>[UV] (korveto</I>), jackdaw (<I>Corvus monedula</I>).", "0"],
["Mongolujo, Mongolio", "Mongol-ujo, Mongolio", "MN.", "0"],
["monismo", "monism-o", "<B>monist-o</B> (phi) monism, monist.", "0"],
["monitoro", "monitor-o", "monitor. <B>1</B> of school. <B>2</B> (zoo) species of tropical lizard (<I>Varanus niloticus</I>) (Le 11/30). ➞ <I>varan</I>. <B>3</B> ironclad.", "0"],
["mono", "mon-o", "[UV] Money, currency. <I>~o metala, papera</I>. <B>Poŝ~o</B>. Pun<B>~o</B>, fine. <B>Trink~o</B>, gratuity, tip. <B>~a</B>, financial, monetary, pecuniary. <I>~aj aferoj, interesoj</I>. <B>~aĉo</B>, filthy lucre, pelf. ➞ (Mt 6/24). <B>~ero</B>, coin. <I>~ero falsa, ora. ~eroj</I>, petty cash, small change. <I>~~igi</I>, cash (<I>ĉekon</I>), change. <B>~ujo</B>, purse. <B>Sen~a</B>, m-less, impecunious. <I>~~igi</I>, impoverish.", "0"],
["mono", "mono-", "(ppfx <I>= umi</I>), mono-. ~gamio, -gamy. ~grafio, -graph, specialist treatise.", "0"],
["monogramo", "", "[OA] -gram, design for initials.", "0"],
["monoklo", "monokl-o", "monocle, single eye-glass.", "0"],
["monolito", "monolit-o", "monolith (➞ <I>obelisk</I>).", "0"],
["monologo", "monolog-o", "[OA] -logut soliloquy, scene or speech by one pr <I>-/</I>, m. <I>~ist(in)o</I>, diseur, diseuse.", "0"],
["monomanio", "monomani-o", "[OA] (<I>unuideeco</I>), monomania.", "0"],
["monoplano", "monoplan-o", "(av) monoplane. <I>~o altala, malaltala, mezala, ombrela</I> high-(low-mid-)wing, parasol. ➞ <I>biplan</I>.", "0"],
["monopolo", "monopol-o", "[OA] monopoly, sole right. <I>~o regna, ŝtata</I>. <B>f</B> exclusive possession. <I>Vi ne havas ~on de saĝo</I>. <B>~igi</B>, -ize (<I>havi ~on ~i</I>). <B>~isto</B>.", "0"],
["monorelo", "monorel-o", "monorail.", "0"],
["monoteismo", "monoteism-o", "[OA] <B>monoteisto</B>, monotheism, monotheist.", "0"],
["monotipo", "", "monotype.", "0"],
["monotona", "monoton-a", "[OA] (<I>unutona</I>), monotonous, dull, humdrum<B>. ~eco</B>, monotony, sameness.", "0"],
["monstro", "monstr-o", "[UV] Monst/er, person or thing. <B>1</B> abnormal in form or structure. <B>2</B> abnormally cruel or wicked, <B>f</B> <I>~o de krueleco</I>. <B>~a</B>, -rous, abnormal, huge, outrageous, misshapen, unnatural. <I>~a formo, supozo, vorto</I>. <B>~e</B> <I>granda</I>. <B>~aĵo</B>, <B>~eco</B>, monstrosity. <B>Mar~o</B> (Ps 148/7). ➞ <I>teratologi</I>.", "0"],
["Montenegro", "Montenegr-o", "ME.", "0"],
["monto", "mont-o", "[UV] Mountain. <I>Iri trans ~oj kaj maro</I>. <B>f</B> (<I>amasego, multego). ~o da mizero. Promesi orajn ~ojn</I>. <B>~(ec)a</B>, <B>~riĉa</B>, -ous, hilly. <I>~a dorso</I>, m-ridge. <B>~ano</B>, -eer, highlander, hillsman. <B>~aro</B>, m-chain (range). <I>~egaro</I>, high m-chain, lofty range of peaks. <B>~eto</B>, hill, knoll, mound <I>~eto herba, paŝta</I>, down. <I>~etaro</I>, range of hills. <B>~iĝi</B>, tower (as a m.). <B>~supro</B>, summit. <B>Al~e(n)</B>, upstream. <B>Glaci~o</B>, icebering. <B>Inter~o</B>, <B>~pasejo</B>, defile, glen, gorge. ➞ <I>alp, altaĵ, krutaĵ</I>.", "0"],
["montri", "montr-i", "(<I>-n</I>) [OA], Display, Show: <B>1</B> expose to view, exhibit. <I>~i gajan mienon. ~u al mi vian langon. Sin ~i</I> (s. one’s) <I>ĉe la fenestro</I>. <B>2</B> (<I>al iu, al io</I>), Point (direct the sight) at (to): <I>~i en la direkto al. Fingre ~i</I>. <B>3</B> Manifest: <I>~i amon, ĝojon, kuraĝon, lerton, senton, surprizon. Sin ~i</I> (s. one’s to be) <I>afabla. La estonteco ~os min prava</I>. <B>4</B> indicate, point out. <I>Horloĝo ~as la horon, kompaso la nordon. Mi volas ~i, ke. \"Da\" post vorto ~as, ke… . </I> <B>~(ad)o</B>, d., s., indication, proof. <B>~a</B>, indicative. <I>~a bastono</I>, pointer. <I>~a fenestro</I>, s-window. <I>~a fingro</I>, index finger. <I>~a pronomo</I>, demonstrative pronoun. <B>~aĵo</B>, d., exhibition. <B>~anto</B>, <B>~isto</B>, s-man. <I>Seĝ~istino</I>, usherette. <B>~iĝi</B>, appear, be apparent (evident), prove (turn out) to be. <I>~iĝis, ke… . </I> It become clear that. <B>~ilo</B>, indicator, etc., needle (of compass). <B>Glit~ilo</B>, slide index. <B>Hor~ilo</B>, hand (of clock). <B>Nivel~ilo</B>, water-gauge. <B>Voj~ilo</B>, signpost. <B>~ema</B>, [OA] display, show forth (fully), exhibit, reveal. <I>Sin (el)~ema</I>, exhibitionist, pretentious. <B>Faden~a</B>, shiny, threadbare. ➞ <B><I>demonstr, evidentig, malkaŝ, pruv, vidig</I></B>.", "0"],
["monumento", "monument-o", "[UV] Monument. <B>1</B> memorial building: <I>Tomba ~o</I>. <B>2</B> (<I>memorigaĵo</I>): memorial. <I>Interesa ~o de la pratempo</I>. <B>3</B> (<I>notindaĵo</I>): <I>~o de industrio</I>. <B>4</B> (<I>grava verko</I>): <I>~o literatura, scienca</I>. <B>5</B> (<I>atestilo</I>), <I>Esperanto estas ~o al la genio de Z</I>. <B>~a</B>, monumental.", "0"],
["mopedo", "moped-o", "moped, cycle moved by motor and pedals.", "0"],
["mopso", "mops-o", "[UV] pug (dog) (<I>Mopsus</I>) (1 FA 144/37; 3 FA 43/7).", "0"],
["moralo", "moral-o", "[OA] Moral/s, principles of character, right, and duty. <B>~a</B>, m. <B>1</B> (<I>pri~a): ~a devo, instruo</I>. <B>2</B> (<I>virta): ~a ago, homo</I>. <B>3</B> (<I>etika)\\ ~a apogo, kuraĝo, profito</I>. <B>~e</B>, -ly. <I>~e defendebla</I>. <B>~aĵo</B> (<I>~a instruo, konkludo</I>). m. <I>La ~aĵo de la fablo</I>. <B>~eco</B>, -ity. <B>~igo</B> (Se 5/12). <B>Ne~a</B> (<B>Pen~a</B>), im-m. <I>Sen~igi</I>, deprave, pervert. ➞ <I>forlog, korupt</I>. <B>~instruo</B>, <B>~ordono</B>, precept, rule (Se 108/8; Ps 50/17). ➞ <I>etik, mor</I>.", "0"],
["moratorio", "moratori-o", "(jur) moratorium.", "0"],
["morbilo", "morbil-o", "[UV] measl/es. <B>~a</B>, -y.", "0"],
["mordento", "mordent-o", "(mus) mordent. <I>~o duobla,</I> <B><I>malsupra, supra</I></B>.", "0"],
["mordi", "mord-i", "(<I>-n</I>) [UV], Bite. <I>~i pomon, la lipojn. ~ita de hundo, insekto, serpento</I>. <B>f</B> attack, corrode, pain. <I>Acido, rusto ~as feron, zorgo la koron</I>. <B>~(ant)a</B>, biting, caustic, mordant, pungent. <I>~a sarkasmo</I>. <B>~aĵo</B>, b., morsel. <B>~ema</B>, cantankerous, crusty, snarling (dog), snappy, vicious (horse). <B>~eti</B> [OA] (<I>rodi</I>), gnaw, nibble, (pick) at, toy with. <I>~eti krajonon</I>. <B>Ĉirkaŭ~i</B>, b. round, gnaw. <B>De~i</B>, <B>For~i</B>, b. off, snap up. <B>~vundo</B>, b. ➞ <I>kaŭstik, korod, mat, manĝ</I>.", "0"],
["morelo", "morel-o", "= fajrohundo (andiron).", "0"],
["moreno", "moren-o", "(geol) moraine, debris deposited by glacier.", "0"],
["morfemo", "morfem-o", "(lin) morpheme.", "0"],
["morfino", "morfin-o", "[OA] morphia, morphine. <B>~ismo</B>. <B>~omaniulo</B>.", "0"],
["morfologio", "morfologi-o", "(lin) morphology, study of forms.", "0"],
["morganata", "morganat-a", "(jur) morganatic.", "0"],
["morgaŭ", "", "[UV] (adv) To-morrow. <I>~ mi donos</I> (Se 3/28). <I>Venu</I> <B>~o</B>, the morrow. <B>~a</B>, (Se 27/1), t’s, following, next. <I>Ĉe la ~a festo. ~ post semajno</I>, t-week. <B>~aĵo</B>, coming event. <B>Post~</B>, the day after t. <I>Vivo</I> <B>sen~a</B>, with no future.", "0"],
["morĥelo", "morĥel-o", "(a. <I>-kelo</I>), morel, edible fungus (<I>Morchella</I>).", "0"],
["mormono", "mormon-o", "mormon. <B>~ismo</B>.", "0"],
["morna", "morn-a", "(<I>preme malgaja, malhela</I>), mournful, cheerless, dismal, dreary, dull, gloomy, sombre; dejected (person). <I>~a aspekto, silento. Sidi</I> <B>~e</B>.", "0"],
["moro", "mor-o", "[UV] Manner (of living), gen. (traditional, usual) custom, habitual conduct (practice, usage). <I>Estas la ~o,</I> It is the c. <I>La ~o de kisado. Fariĝis ~o en Izraelo, ke</I> (Jĝ 11/39). <B>~oj</B>, mm., conduct. <I>La ~oj de la tablo</I>, table mm. <I>Aliaj tempoj, aliaj ~oj</I>, other times, other ways. <B>Bon~a</B>, of good character, having high principle, well-behaved. <B>Fi~a</B>, dissolute, profligate. <B>Rigid~a</B>, <B>sever~a</B>, austere, rigid, straight-laced, strict. <B>~pentrado</B>, genre painting. <B>~atesto</B>, certificate of good character. <B>~konforma</B>, decent, decorous, proper, seemly. ➞ <I>kutim, manier, moral, praktik</I>.", "0"],
["moroza", "moroz-a", "(<I>malgajhumora</I>), morose, sour-tempered, sullen, unsocial.", "0"],
["morso", "mors-o", "<B>~a</B>, Morse. <B>~i</B>, transmit in m.", "0"],
["mortero", "morter-o", "[UV] mortar. <B>~isto</B>, bricklayer. <B>~portisto</B>, hodman. ➞ <I>beton, cement, mastik, stuk</I>.", "0"],
["mortezo", "mortez-o", "Mortise, hole, gap, to receive a corresponding projection. <I>~a junto</I>, m. and tenon joint. <I>~a bolto, seruro</I>. ~i (<I>fari ~on</I>), m., slot. <B>~ilo</B>, m-chisel. ➞ <I>tenon</I>.", "0"],
["morti", "mort-i", "(nt), [UV] Die, cease to live, lose one’s life. <I>~i de akcidento, febro. ~inta folio</I>, <B>f</B> be extinct, cease to function, come to an end, no longer exist, pass away. <B>~o</B>, Death. <B>1</B> decease, demise, loss of life: <I>~o frua, paca. Kondamni al ~o</I>. <B>2</B> (personification): <I>la ~o ne distingas, ĉiujn egale atingas. Pala kiel ~o. ~o de arto, civilize, juneco, kulturo, urbo</I>. <B>~a</B> (~rilata, ~simila), of d., d-like, mortal. <I>~a dormo, paleco. ~a kanto</I>, swan song. <I>~a ombro</I>, shadow of d. (Jes 9/2). <I>~a silento</I>, dead silence. <B>~e</B>, fatally, to d. <I>~e malsana, vundita</I>. ~inta, dead. <I>~inta lingvo. La ~intoj</I>, the d. <B>~ado</B> (~kvanto), mortality, d-rate. ~(mt)aĵo, dead matter, carrion (➞ <I>kadavr</I>). <B>~ema</B>, <B>~ideva</B>, <B>~onta</B>, mortal, subject to d. <B>~emulo</B>, mortal. <B>~inda</B> <B>(~omerita</B>), worthy of d. <I>~~a krimo, peko</I>, capital offence. <B>~igi</B>, [UV] butcher, deprive of life, kill, put to d., slaughter, slay, <B>f</B> <I>~igi entuziasmon, movadon</I>. <B>Hom~iginto</B>, homicide, manslayer, murderer. <B>Paf~igi</B>, shoot. <B>Pik~igi</B>, run (spit, stab) through. <B>Reĝ~igo</B>, regicide. <B>Sin~igo</B>, suicide. <B>Ŝton~igi</B>, stone to d. <I>~iga</I>, deadly, lethal, mortal. <I>~iga malsano, veneno, vundo. ~igito</I>, victim. <B>~iĝi</B>, come to one’s d., be killed (E/39). <I>~iĝanta,</I> moribund. ~intejo, cemetery. <B>For~i</B>, d. away (down, out), expire, subside. <B>Ĝis~a</B>, life(long), till d. <I>Batali ĝis</I><B><I>~e</I></B>, to the d. <B>Ne~ema</B> (<B>Sen~a</B>), d-less, immortal. <I>La sen~eco de la animo</I>. <B>Post~a</B>, posthumous. <I>~~a esploro</I>, autopsy, postmortem. <B>Trans~a</B>, from beyond the grave. ➞ <I>agoni, detruiĝ, estingiĝ, ruiniĝ, malaper, senviv; pere, velk</I>.", "0"],
["moruo", "moru-o", "[OA] Cod (fish) (<I>Gadus morrhua</I>). <B>~ido</B>, -ling. <B>~frajo</B>, c-roe. <B>~(hepat)oleo</B>, c-liver-oil. ➞ <I>gad, laberdan</I>.", "0"],
["moruso", "morus-o", "[UV] Mulberry, fruit of <B>~arbo</B>, m-tree (<I>Morus</I>) (2 Sa 5/23). <I>~o blanka, nigra, ruĝa</I>, white (black red) m.", "0"],
["morvo", "morv-o", "(vet) glanders, horse disease.", "0"],
["moskeo", "moske-o", "[OA] mosque, Islamic place of worship.", "0"],
["moskito", "moskit-o", "mosquito (various species of <I>Culex</I> and <I>Anopheles</I>). ➞ <I>kul</I>.", "0"],
["mosko", "mosk-o", "[OA] musk, odiferous substance from various animals. ➞ <I>cerv, musk</I>.", "0"],
["mosto", "most-o", "[UV] must, new wine, unfermented grape-juice (2 Kr 31/5; Se 3/10).", "0"],
["moŝto", "moŝt-o", "[UV] gen. title of politeness and respect for people of rank. <I>Ŝia ~o</I>, Her Ladyship, etc. <I>Via ~o</I>, Your Honour (Worship, etc.). <I>Lia Duka ~o</I>, His Grace. <I>Via Episkopa ~o</I>, My Lord Bishop. <I>Lia Pastra ~o</I>, The Reverend, His Reverence. <I>Via Princa ~o</I>, Your Highness. <I>Lia (Ŝia) Reĝ(in)a ~o</I>, His (Her) (Royal) Majesty. <B>~a</B> <I>sinteno. Plej ~a ~o!</I> (Gm 59/5). <B>~uloj</B>, people of importance, big Potts. <B>~naskita</B> (4 FA 122/1).", "0"],
["motacelo", "motacel-o", "Wagtail. <B>~o blanka</B>, white (pied) w. <B>~o flava</B>, yellow, blue-headed and grey-headed wagtails. <B>~o griza (cindra)</B>, grey w.", "0"],
["moteo", "mote-o", "= tineedo (ordinary language). ➞ <I>tine</I>.", "0"],
["moteto", "motet-o", "(<I>praantemo kontrapunkteca</I>), motet.", "0"],
["motifo", "motif-o", "(art) (mus) motif, distinctive feature, dominant idea, thematic figure.", "0"],
["motivo", "motiv-o", "[OA] Motiv/e, Reason, cause, grounds, incentive (for action). <I>Plend~o,</I> grievance, ground for complaint. <B>~i</B> (<I>-n</I>), -ate, justify, be the r. for. <I>Tio ~as mian proponon</I>. <B>~aĵo</B>, consideration. <B>Sen~a</B>, groundless, unfounded. ➞ <I>kaŭz, kial</I>.", "0"],
["moto", "mot-o", "motto, maxim adopted as rule of conduct, quotation at begining of book or chapter. ➞ <I>deviz</I>.", "0"],
["motoro", "motor-o", "[OA] Engine, Motor, driving-force, machine to produce motion. <I>Elektra ~o,</I> electric m. <I>Gas~o. ~o benzina</I>, petrol m. <I>~o petrola</I>, oil m. <I>~o per kontinua kurento</I>, D.C. motor. <B>~eroj</B>, e-parts. <B>~isto</B>, m-ist, m-man, driver. <B>~izi</B>, -ize, fit with m. <B>~boato</B>, <B>~ciklo</B>, <B>~fiakro</B>, <B>~veturilo</B>. ➞ <I>aŭtist, maŝin, ŝofor</I>.", "0"],
["movi", "mov-i", "(<I>-n</I>) [UV], Move. <B>1</B> (<I>alilokigi</I>) alter place of, displace, shift: <I>~i tablon, ŝtonon</I>. <B>2</B> put in motion: <I>~i la brakojn, okulojn, piedojn. La vento ~is la branĉojn</I>. <B>3</B> (<I>funkciigi</I>), actuate, drive, make go, propel, work: <I>Akvo … muelilon, vaporo … ŝipon</I>. <B>f</B> (<I>influi): facile ~ata de larmoj</I>. <B>~o</B>, -ment, motion. <I>~o de la mano. ~o intermita, kurba, rekta, sfera. ~o libera, unudirekta</I>. (mus) <I>~o kontraŭa, oblikva, paralela, simila</I>. (drs, chs) m. <B>~a</B>, actuating, propulsive. <I>~a forto</I>, motive force. <B>~ado</B>, -ment, bustle, motion. <B>f</B> activity. <I>~ado Esperanta, politika, religia</I>. <B>~ebla</B>, -able, mobile. <B>~aĵoj</B>, -ables, chattels. <I>Ne~aĵoj</I>, fixtures. <B>~eto</B>, slight -ment. <I>~eti</I> (shrug) <I>la ŝultrojn</I>. <B>~iĝi</B>, m. (nt), make a -ment, budge, stir. <I>La folioj ~iĝadas</I>, are in constant motion. <I>~iĝema</I>, fidgety, restless, shifting. <B>~ilo</B> (<I>~ilaro</I>), -ment, mechanism, works. <B>~oplena</B> (multe~a), animated, busy, full of traffic, etc. <B>~ipova</B>, <B>~ebla</B>, mobile. <B>Ek~i</B>, set in motion. <B>Ek~iĝi</B>, start off. <B>For~i</B>, m. away, remove. <B>Sen~a</B>, at rest, becalmed, immobile, motionless, stagnant. <B><I>~</I>eco</B>, inaction. <I>~~igi</I>, immobilize. ➞ <I>haltig, paraliz</I>. <B>Facil~a</B> (<B>Rapid~a</B>), agile, brisk, nimble, tripping. <B>Propra~e</B>, of one’s own accord, off one’s own bat, on one’s own iniciative, spontaneously. <B>Rapid~a</B>, brief, lively, quick, smart, (chs) Tri~a <I>problemo</I>.", "0"],
["movimento", "moviment-o", "(mus) movement, principal division (of sonata, etc.).", "0"],
["mozaiko", "mozaik-o", "[OA] mosaic, tesselation, inlaid work of colored stones, etc. <B>f</B> patchwork <I>~o el diversaj tradukoj. Ligna ~o (marketro</I>).", "0"],
["Mozambiko", "Mozambik-o", "MZ.", "0"],
["muari", "muar-i", "(<I>-n</I>), (tex) Water, give appearance of wavy reflections. <B>~(it)a</B>, -ed. <I>~ita papero, rubando, silko. ~ita metalo,</I> crystal tinplate. <B>~(aĵ)o</B>, -ed fabric.", "0"],
["mucida", "mucid-a", "Mucid, fuggy, fusty, mildewy, mouldy, musty, stale (to smell or taste). <B>~eco</B>, -ity, foulness (of air, etc.). ➞ <I>ranc, ŝim</I>.", "0"],
["mucilago", "mucilag-o", "mucilage. <B>1</B> gum. <B>2</B> viscous substance in plants.", "0"],
["mueli", "muel-i", "(<I>-n</I>) [UV], Mill, bray, grind. <I>grenon, kafon, pipron</I>. <B>f</B> repeat ceaselessly (<I>gurdi). Babili</I> ~e. <B>~ado</B>, -ing. <B>~(it)aĵo</B>, flour, meal. ➞ <I>farun, gri</I>. ~ejo, m. (building). ~endaĵo, corn to be ground, grist. <B>~isto</B>, m-er. <B>~ilo</B>, m. (machine). Akva (venta) ~ilo, water (wind) m. Kaf-~ilo, coffee-m. <B>Tret~ilo</B>, tread-m. (3 FA 135/29). <I>~ileto</I>, vegetable cutter, mincing-machine, nut-m. <I>~ilisto</I>, m-wright. <B>Dis~i</B>, crush, pound, pulverize. ➞ <I>pecetig, pist</I>.", "0"],
["muflo", "mufl-o", "(<I>bakujo</I>), (cer) (chem) muffle (of furnance, kiln). ➞ <I>muf</I>.", "0"],
["muflono", "muflon-o", "moufflon, wild sheep, especially <I>Ovis musinon</I> of Corsica.", "0"],
["mufo", "muf-o", "[UV] muff. <B>1</B> covering to warm hands. <B>2</B> (tech) <I>Gas~o</I>, gas mantle. <I>Tub~o</I>, cas-(laging-lin-)ing, pipe-socket, sheathing, sleeve. <B>~eto</B>, muffetee, worsted cuff worn on wrist.", "0"],
["mugelo", "mugel-o", "(ich) grey mullet (<I>Mugil</I>). ➞ <B><I>mulus</I></B>.", "0"],
["muĝi", "muĝ-i", "(nt) [UV]. <B>1</B> Howl, roar; moan, sough; make a long drawn-out sound (as hooter, waves, wind). <B>2</B> (<I>bovbleki</I>): bellow, low, moo (as cow), snarl (as lion), f <I>La ~anta popolamaso</I>. <B>~ado</B>, din, h-ing. ➞ <I>blek, sibl</I>.", "0"],
["mujiko", "mujik-o", "moujik.", "0"],
["muko", "muk-o", "[UV] Muc/us. <B>~(ec)a</B>, -ous, snuffling, <I>~a membrano. ~aj glandoi</I>. <B>~aĵo</B>, phlegm.", "0"],
["mulat(in)o", "", "(<I>duonnegro</I>), mulatto, cross between black and white. ➞ <I>mestiz</I>.", "0"],
["mulĉo", "mulĉ-o", "(agr) Mulch, half-rotten leaves or straw, loose earth, etc., spread on the ground to protect roots of newly- planted trees, etc. <B>~i</B>, (cover with) m. <I>~i teron</I>. ➞ <I>kompoŝt</I>.", "0"],
["muldi", "muld-i", "(<I>-n</I>), Mould, cast (pour molten material into a m). <I>~i kanonon. ~ita ŝtalo,</I> cast steel. <B>~ilo</B>, m. <I>~ilo butera (ĵelea). Bak~ilo</I>, cake tin. L;7er <B>~isto</B>, typefounder.", "0"],
["mulo", "mul-o", "[UV] (<I>ido de azeno kaj ĉevalino</I>), Mule (<I>Equus mulus). Obstina kiel ~o</I>. <B>~eca</B>, -ish, stubborn. <B>~ino</B>, she-m. <B>~(konduk)isto</B>, m-teer, m-driver.", "0"],
["multa", "mult-a", "[UV] (us. <I>multe da</I>), Much, a lot (large amount) of. <I>~a parolado</I>, m. speaking. <I>~a laboro, pacienco</I>. <B>~aj</B>, Many, a large number of. <I>~aj domoj, libroj, vortoj. Multaj (homoj) diras, ke</I>, many say that. <B>~e</B>, <B>1</B> Much, a lot, great deal: <I>Kiu ~e parolas, ne ~e faras. ~e vojaĝi</I>. <B>2</B> (<I>altgrade, forte, tre): ~e labori, pensi</I>. <B>3</B> <I>~e da (= multa, multo da): ~e da vino</I>, m. wine. <I>~e da vinoj</I>, many wines. <B>~o</B>, m., a mass, large quantity. <I>~o mankas</I>, a great deal is lacking. <B>Malpli~o</B>, minority. <B>~egaj</B> <B>(<I>~enombraj</I>)</B>, multitudinous, numerous. <B>~ege</B> (~ego) da, a great amount (host, multitude) of. <B>~igi</B> (hort) propagate. <B>(Pli)~igi</B>, multiply, increase the number or quantity of, redouble. <B>~iĝi</B>, multiply, swarm. <B>~obligi</B>, multiply, e.g., by stencil. <B>~ope</B>, in crowds. <B>Mal~a</B> (<I>mal~e da) tempo</I>, little time. <I>Per ~~aj vortoj</I> (few words) <I>diri ĉion. ~~o sufiĉas</I>, a little is enough. <I>~~igi</I>, reduce number (quantity) of. <B>f</B> <I>~~ulo</I> (Jes 41/14). <B>Malpli~o</B>, minority. <I>Kontentiĝi per</I> <B>ne~o</B>. <B>Plej~e</B>, above all, mostly, for the most part, principally. <B>Pli~o</B>, majority. <B>~angula</B>, <I>~</I>edra, <I>~</I>silaba, poly-gonal, (-edral-sylla- bic). <B>~forma</B>, <B>~latera</B>, multi-form (-lateral). <B>~(e)speca</B>, multifarious, <I>~</I>ekosta, expensive. ➞ <I>abund, svarm</I>.", "0"],
["multipliki", "multiplik-i", "(<I>obligi</I>), (mat) Multipl/y. <B>~o</B>, -ication. <B>~anto</B>, -er. <B>~ato</B>, -icand.", "0"],
["muluso", "mulus-o", "(ich) red mullet (<I>Mullus</I>). ➞ <I>mugel</I>.", "0"],
["mumio", "mumi-o", "[OA] Mummy. <B>~igi</B>, -ify. ➞ <I>balzam</I>.", "0"],
["mumpso", "mumps-o", "(med) mumps &lt; <I>parotidit</I>.", "0"],
["municio", "munici-o", "[OA] (mil) ammunition, munitions, stock of war material. <B>~ejo</B>, magazine.", "0"],
["municipo", "municip-o", "Municipality, borough (Rn 5/16). <B>~a</B>, -al.", "0"],
["munti", "munt-i", "[OA] Mount. <B>1</B> build, erect, fit together (put into position) parts of apparatus, assemble (<I>maŝinon</I>), hang (<I>pordon</I>), stage (<I>framon</I>). <B>2</B> set (<I>foton, juvelaĵon). ~ado,</I> ~<B>aĵo</B>, -ing, setting. <B>~ejo</B>, erection shop. <B>~isto</B>, -er, fitter. <B>Mal~i</B>, dis-m., break up, take down (to pieces). <B>Sub~aĵo</B>, foundation, support. ➞ <I>kunmet, starig</I>.", "0"],
["muntjako", "muntjak-o", "muntjac (deer) (<I>Muntiacus muntjak</I>).", "0"],
["murdi", "murd-i", "[OA] Murder, assasinate, kill unlawfully. <B>~o</B>, m. <B>~ema</B>, -ous. <B>~into</B>, -er. <B>~ito</B>, victim.", "0"],
["mureko", "murek-o", "(mollusc) murex, Venus’ comb (<I>Mur ex</I>).", "0"],
["mureno", "muren-o", "(ich) murry (<I>Muraena</I>). ➞ <I>angil</I>.", "0"],
["murmuri", "murmur-i", "[UV] (nt) Murmur. <B>1</B> make a gentle noise, bubble, chatter, gurgle, plash (<I>akvo en bolilo, homoj babilantaj, vento trafolie). Sur la ventro veluro, en la ventro ~o</I>. <B>~(ad)o</B>, m-ing. Mur! Mur! Mur! <I>tiel la kolomboj murmuris</I> (Z). <B>2</B> grouse, grumble, mutter (Ps 106/25). <I>~i tra la dentoj. La Izraelidoj ~is kontraŭ Moseo</I>. ➞ <I>grumbl, grunt</I>. <B>~egi</B>, growl. ➞ <I>graŭl, muĝ</I>. <B>~eti</B>, m. softly, babble, chatter, prattle, purl, rustle, sigh, twitter. <B>Ek~i</B> (El 16/2). ➞ <I>bobel, bruetad, flustr, glugl, lirl, susur, suspir, zum</I>.", "0"],
["muro", "mur-o", "[UV] <B>1</B> Wall. <I>~o de domo (ĉirkaŭ kampo). Disigi per ~o</I>, w. off. f <I>Premi al la ~o</I>, pin down to the point. <B>2</B> w-like mass, ➞ <I>dig</I>. <B>3</B> (<I>baro, kontraŭstaro, malhelpo</I>): barrier. <I>~oj de antaŭjuĝoj, miljaroj</I>. <B>Brika ~o</B>. <B>Fak~o</B> (mar), bulkhead. Rand~o (<I>parapeto</I>). Son<B>~o</B>, sound barrier. <B>(Sur)~a</B>, mural. <B>~ego</B>, rampart. <I>Ĉina ~ego</I>. Gt Wall, <B>ĉirkaŭ~igi</B> (<I>en~igi</I>), immure. <B>Ekster~a</B>, extramural. <B>Inter~a</B> <I>vando</I>, inner (partition) w. <B>Sen~a</B> (open) <I>urbo</I>. ➞ <I>vand</I>.", "0"],
["muskato", "muskat-o", "[UV] Nutmeg, <B>~arbo</B> (<I>miristiko</I>), n-tree (<I>Myristica fragrans</I>). <B>~a</B> <I>pulvoro (ŝelo</I>), mace. <I>~a vino</I>, muscat(el) wine (from m., or musk-flavoured grapes).", "0"],
["musketo", "musket-o", "Musket. <B>~isto</B>, -eer.", "0"],
["musko", "musk-o", "[UV] Moss (<I>Muscus</I>). <B>~okovrita</B>, -y. <I>[Ne= mosko]</I>,", "0"],
["muskolo", "muskol-o", "[UV] (anat) Musc/le. <B>Dik~a</B>, <B>fort~a</B>, -ular. <B>~aĵo</B>, brawn. <B>~aro</B>, -ular system, thews. <B>Sen~a</B>, flabby, soft.", "0"],
["muslino", "muslin-o", "[UV] <B>~a</B>, muslin, delicate light fabric of cotton or silk. ➞ <I>gaz</I>.", "0"],
["muso", "mus-o", "[UV] Mouse (<I>Mus</I>). Dorm<B>~o</B>, dormouse. ➞ <I>glir</I>. Kampa <B>~o</B>, field m. Salt<B>~o</B>, jumping m. (<I>Zapus …</I>). <B>~edoj</B>, muridae. <B>~ido</B>, baby m. ➞ <I>dipod</I>.", "0"],
["musono", "muson-o", "(met) monsoon, seasonal wind of S. Asia.", "0"],
["mustardo", "mustard-o", "[UV] Mustard (condiment), powder from crushed seeds of <I>sinapo blanka. Ĝi estas ~o post la manĝo</I>, it comes too late. <B>~ujo</B>, m-pot. ➞ <I>iperit, sinap</I>.", "0"],
["Musteloj", "Mustel-oj", "the Weasel fam. (polecats and minks). Siberia <B>~o</B>, Siberian w. <B>~eto</B>, the common w. (<I>Mustela nivalis</I>). ➞ <I>ermen, fur, lutreol, putor, vizon</I>.", "0"],
["muŝkapt(ul)o", "", "(orn) fly-catcher (<I>Muscicapa</I>) <B>Blankkola ~o</B>, collared f-c; <B>Blanknigra ~o</B>, pied f-c; <B>Griza ~o</B>, spotted f-c; <B>Ruĝbrusta (malgranda) ~o</B>, redbreasted f-c.", "0"],
["muŝo", "muŝ-o", "[UV] Fly (<I>Musca</I>). <B>Doma ~o</B>, house f. ➞ <I>kaliforo (Calliphora</I>), blue-bottle, <B>f</B> <I>Havi ~on en la cerbo</I> (a bee in one’s bonnet). <I>Kalkuli ~ojn</I>, waste time on trifles. <I>Trafi du ~ojn per unu bato</I>. <B>Pik~o</B> (<I>moskito</I>). <B>~eto</B>, midge.", "0"],
["muta", "mut-a", "[UV] <B>1</B> Dumb, mute. <B>2</B> momentarily unable or unwilling to speak, speechless. ~a <I>de emocio, honto, teruro</I>. <B>3</B> without speech. <I>~a respondo, rolo, sceno</I>. <B>~igi</B>, scotch, silence. <I>~igi la voĉon de kalumnio, konscienco</I>. <B>~igilo</B>, (piano) damper, <B>~iĝi</B> <I>de surprizo</I>, be struck d. <B>~ulo</B>, mute. <B>Surd~ulo</B>, deaf-mute. ➞ <I>damp, senvort, silent</I>.", "0"],
["mutacio", "mutaci-o", "(bio) Mut/ation, sport, variation, <B>~i</B>, -ate.", "0"],
["mutili", "mutil-i", "(<I>kripligi, senmembrigi, stumpigi</I>), mutilate, maim.", "0"],
["muzelo", "muzel-o", "muzzle, snout (of animal, fish). <B>~ingo</B> = buŝumo.", "0"],
["muzeo", "muze-o", "[OA] museum.", "0"],
["muziko", "muzik-o", "[F], Music. <B>1</B> art. <B>2</B> sounds. <B>~a</B>, -al. <B>1</B> of (relating to) music. <B>2</B> pleasing (of sound). <B>~i</B>, make (perform, play) m. <B>~aĉo</B>, rubbishy m. <B>~ado</B>, performance, playing, of m., mistrelsy. <B>~aĵo</B>, composite, piece of m. ➞ <I>komponaĵ, verk</I>. <B>~ema</B>, -al. <B>~igi</B> <I>tekston</I>, compose m. for, set to m. <B>~ilo</B>, -al instrument. <B>~isto</B>, -ian. <I>~istaro</I>, orchestra, etc.", "0"],
["muzo", "muz-o", "[OA] muse, Gk goddess.", "0"],
["n", "-n", "[UV] ending. <B>1</B> den, direct object. of transitive vb. <B>2</B> replaces <I>al, je</I>, or other preposition.", "0"],
["nabo", "nab-o", "(<I>aksingo</I>), Hub, centre. <B>1</B> of wheel. <B>2</B> of interest. ~a <I>ĉapo</I>, h. cap.", "0"],
["nacelo", "nacel-o", "basket, cradle, car, gondola (of balloon, etc.).", "0"],
["nacio", "naci-o", "[OA] Nation, <B>~a</B>, -al. <I>~a lingvo, standardo</I>. <B>~e</B>, as a nation. <B>~aĵo</B>, -al idiom (peculiarity, trait). <B>~ano</B>, -al, citizen, native, subject. (Bb) Gentile. <I>~~igi,</I> -alize. <B>~eco</B>, -ality. <B>~ismo</B> (<B>~isto</B>), nationalism (nationalist). <B>(al)~igi</B>, -alize (obj). <B>Inter~a</B>, international. <I>~~a amikeco, juĝo, kongreso, lingvo. ~~ismo, ~~isto</I>. <B>Sen~(ec)a</B>, without -ality. <B>Super~a</B>, supra-al. ➞ <I>komunum, land, popol, ras,</I> <B><I>ŝ</I></B><I>tat</I>.", "0"],
["nadiro", "nadir-o", "(astr) nadir, point of heavens beneath observer. Opp <I>zenit</I>.", "0"],
["nadlo", "nadl-o", "(small metal) hand, indicator, needle, pointer. ~o <I>gramofona, kompasa, magneta</I>. ➞ <I>indikil, kudril, montril</I>.", "0"],
["naftalino", "naftalin-o", "[OA] (a. <I>~eno</I>), naphthalene.", "0"],
["naftalolo", "naftalol-o", "naphthalol.", "0"],
["nafto", "naft-o", "[OA] (<I>kruda petrolo</I>). Naphth/a. This root is international, but obsolescent and ambiguous, with difft meanings in various countries; so better avoided. ➞ <I>parafin, petrol</I>. II", "0"],
["naĝi", "naĝ-i", "[UV] <B>1</B> Swim: <I>~i en (sub) la akvo, al la bordo, kiel fiŝo, kontraŭ (kun) la fluo. Mi povas Jioti, sed ne -/</I>. (fac) ~i kiel ŝtono. <B>f</B> <I>Ŝi ~is en la ĉambron</I>. <B>2</B> (ŝvebi) move, pass, s. by (in the air): <I>La luno ~is tra la nuboj; birdoj, nuboj tra~is la ĉielon</I>. <B>3</B> float (resti surface, malsinki): <B>~anta</B> <I>folio</I> (Better <I>floti</I>). <B>4</B> (<I>iri) (of feelings, ideas</I>): <I>For~is liaj pensoij, revoj. <B>5</B> Bathe in abundance of: en feliĉo, sango, revoj. <B>~a</B>, natatory. <B>~e</B>, by swimming. <B>~ado</B>, swimming</I>. <I>~ado brusta, dorsa, flanka</I>.<I> <B>~anto</B>, <B>~isto</B>, swimmer. <B>~ejo</B>, swimming bath (pool). <B>~ilo</B>, fin. (av</I>) <B>Vost~ilo</B>, <I>tail fin. <B>Ramp~i</B>, crawl. ➞ bu, flot, flu, flug, kur, ŝveb</I>.", "0"],
["naiva", "naiv-a", "[F], Naiv/e, artless, ingenuous, innocent, natural, simple, unaffected, unsophisticated. <I>~a desegno, entuziasmo, espero, knabino, provincano, rakonto</I>. <B>~aĵo</B>, something naive, naivety. <B>~eco</B>, -ety, artlessness, native candour. <B>~ega</B>, green, silly. <B>~ulo</B>, booby, greenhorn, innocent, ninny, simpleton. <B>Mal~a</B>, cute, all there, sharp, knowing, wideawake, \"up to snuff\". ➞ <I>infanec, simpl</I>.", "0"],
["najado", "najad-o", "(myth) naiad, water-nymph.", "0"],
["najbaro", "najbar-o", "[UV] (<I>proksimulo</I>), Neighbour, near dweller. <I>Niaj ~oj transmaraj</I>. <B>f</B> (<I>apudulo</I>). <I>~o ĉe la tablo, en la teatro</I>. <B>~a</B>, -ing, -ly; adjacent, adjoining. ~a <I>domo, insulo, lando, reĝo</I>. <I>Fajro kaj pajlo ne povas</I> <B>~e</B> <I>vivi</I>. <B>~aĵo</B>, <B>~eco</B>, -hood. ➞ <I>apud, ĉirkaŭ</I> (➞ Lk 10/36).", "0"],
["najlo", "najl-o", "[UV] Nail. <B>Egkapa ~o</B>, traffic stud (button). <B>Ligna ~o</B> (<I>kejlo</I>), peg; <B>Pezkapa ~o</B>, hob-nail; <B>Senkapa ~o</B>, brad; <B>Stump~o</B>, club-nail. (ry) <B>Ŝraŭb~o</B>, screw-nail, coach-screw; <B>Tend~o</B>, tent-peg; <B>Trak~o</B>, <B>Rel~o</B>, dog-spike, rail-spike. <B>~i</B> (<I>-n</I>), nail, spike. <I>~i kovrilon sur keston</I>. <B>f</B> (vulg) = <I>fiki</I>. <B>(Al)~i</B> <I>flagon al la masto</I>. <B>f</B> <I>Surprizo (al)~is min al la tero</I>. <B>~ego</B>, clout. <B>~eto</B>, tack. <B>~izi</B>, stud. <B>Mal~i</B>, unnail. <I>Boto</I> <B>ligno~a</B> (pegged). ➞ <I>kramp</I>.", "0"],
["najo", "naj-o", "(<I>Naja) &gt;</I> kobro.", "0"],
["najtingalo", "najtingal-o", "[UV] nightingale (Luscinia).", "0"],
["Namibio", "", "NA, Namibia.", "0"],
["nanduo", "nandu-o", "(orn) nandu, rhea (S. American ostrich) (Rhea).", "0"],
["nankeno", "nanken-o", "[UV] (tex) nankeen, buff-yellow cotton cloth (from Nankin).", "0"],
["nano", "nan-o", "Dwarf, abnormally small being. <B>~a</B>, d. ➞ <I>malgrandegul</I>.", "0"],
["napalmo", "napalm-o", "(mil) napalm. <B>~bombo</B>.", "0"],
["napo", "nap-o", "[UV] Rape (<I>Brassica napus</I>). <B>Sveda</B> <B>~o</B>, swede, rutabaga (<I>B. n. napobrassica</I>). ➞ <I>kolzo</I> (colza, winter-rape), <I>rapo</I>.", "0"],
["nap(oleon)o", "", "(gm) nap.", "0"],
["narcismo", "narcism-o", "narcissism.", "0"],
["narciso", "narcis-o", "[UV] Narciss/us, daffodil. Many cultivated species &gt; <I>dafodiljonkvil</I>.", "0"],
["nardo", "nard-o", "<B>1</B> (spike)nard, Indian plant (<I>Nardostachys</I>), from which <B>2</B> nard, aromatic ointment (Alt 4/13, 14; Mk 14/3). <B>3</B> mat-grass (<I>Nardus</I>).", "0"],
["nargileo", "nargile-o", "hookah, narghile, Turkish pipe.", "0"],
["narkoti", "narkot-i", "(<I>-n</I>) [OA] (<I>droge dormigi</I>), Narcot/ize. <B>~a</B>, -ic. <B>~o</B>, narcosis. <B>~aĵo</B>, -ic., drug inducing abnormal sleep or insensibility, dope, opiate.", "0"],
["narkotiko", "narkotik-o", "[OA] = narkotaĵo.", "0"],
["narvalo", "narval-o", "narwhal, sea unicorn (<I>Monodon</I>).", "0"],
["nasao", "nasa-o", "(zoo) dog-whelk (<I>Nassa</I>).", "0"],
["naski", "nask-i", "(<I>-n</I>), [UV] give Birth to, bear, bring forth (into the world). <I>~i filon</I>. <B>f</B> create, develop, give rise to, produce, provoke. <I>~i amuzon, esperon, scivolon, suspekton, varmon. Konfido ~as konfidon</I>. <B>~antino</B>, <B>~ontino</B> woman in travail. <B>~ita</B>, born, by b. <I>~ita Anglo. ~ita (nee) Jones. Malvive ~ita</I>, stillborn. <I>~itaro (idaro</I>), offspring. <B>~onta</B>, pregnant. <B>~oto</B>, child unborn. <B>~(ad)o</B>, (child)birth, parturition. <I>~o antaŭtempa, spont(ane)a</I>. <B>~a</B>, natal, puerpural. <B>~ema</B>, prolific. <B>~igi</B>, beget, procreate (be the father of) (Rd 28/41; Se 23/23). <I>~~a</I>, generative. <B>~iĝi</B>, [UV] be born, come into the world. <I>Mi ~iĝis en Bath</I>, <B>f</B> arise, blossom out, come into being, crop (turn) up, originate, set in. <I>~~is en mi deziro. ~~a lando</I>, land of birth. <I>~~a loko, tago</I>, birthplace, birthday. <B><I>~~</I>o</B>, begining, rise. <I>~~</I>o, b., nativity. <B>De~a</B>, <B>kun~ita</B>, from b., congenital, lifelong. <I>surdeco. ~~a Esperantisto</I>. <B>Fi~ita</B>, misbegotten. <B>Mis~o</B>, miscarriage. <B>Post~aĵo</B>, after-b. <B>Re~iĝo</B>, new b., renaissance, revival. <B>Sen~a</B>, barren. <B>du~ito</B> [UV] (<I>ĝemelo</I>), twin. Tri~oj. <B>Ĵus~ita</B>, <B>Nov~ita</B>, new-born. <B>krist~o</B>, [UV] Christmas. <B>Unue~ito</B>, firstborn. <I>~~iteco</I>, b-right, primogeniture. <B>Viv~a</B>, viviparous. ➞ <I>akuŝ, gener, kaŭz, kre, okazig, vek</I>.", "0"],
["naso", "nas-o", "[OA] cray-fish net, eel pot, hoop-net (for birds), trap (for rats).", "0"],
["natriko", "natrik-o", "grass snake (<I>Natrix</I>).", "0"],
["natrio", "natri-o", "[OA] (chem) Sodium (Na). <I>~a klorido,</I> common salt. <I>~a sulfato</I>, Glauber’s salt. <I>~a tiosulfato</I>, hypo.", "0"],
["natro", "natr-o", "caustic soda, lye (Jer 2/22). ➞ <I>sod</I>.", "0"],
["naturalismo", "natural-ismo", "[OA] <B>-isto</B>, [OA] (phi) Natural -ism, -ist. II <B>~izi</B> (jur), -ize, admit alien to citizenship.", "0"],
["naturo", "natur-o", "[UV] Natur/e. <B>1</B> creation, universe, world (as a whole): <I>La fortoj (tri regnoj) de la ~o. Leĝo de N. (= de ĝia Kreinto</I>). <B>2</B> accordance (conformity) with truth or reality: <I>~a stato</I>, regular course of things. <I>Desegni laŭ ~o. Lerta kuracisto helpas la ~on</I>. <B>3</B> innate character(istics): <I>Havi afablan ~on. Studi la homan ~on</I>. <B>~a</B>, -al. <B>1</B> of n: <I>~a lingvo, scienco</I>. <B>2</B> normal, regular, in conformity with n: <I>~a dieto, fenomeno, historio, morto, vivo</I>. <B>3</B> (<I>memkomprenebla</I> not surprising, to be expected: <I>~a ideo, reakcio, sugesto, timo</I>. <B>4</B> (not acquired, artificial, or taught): artless, genuine, innate, lifelike, unaffected: <I>~a ĉarmo, elokvento, inklino, saĝo, stato, stilo</I>. <B>5</B> born out of wedlock: <I>~a ftlo</I>. <B>6</B> (mus) natural, neither flat nor sharp, without accidental: white (piano key). <I>A ~a</I> = A natural (All). <B>~e</B>, -ally. <B>1</B> (<I>laŭ~e). parolu ~e</I>, <B>2</B> (<I>kompreneble): ~e, mi ne respondis</I>. <B>~igi</B>, -alize, introduce (animal, plant, word, etc.) from another country. <B>~igilo</B>, (mus) the sign t\\. <B>~(esplor)isto</B>, -alist, lover (student) of n. <B>De~igi</B>, denature. <B>Kontraŭ~a</B>, <B>Ne~a</B>, un-n. <I>~~aĵo</I>, perversity. <B>Super~a</B>, super-n. ➞ <I>instinkt, karakter, naiv, simpl, temperament</I>.", "0"],
["Nauro", "", "NR.", "0"],
["naŭ", "", "[UV] Nine. <B>~a</B>, 9th. <B>~e</B>, -thly. -oble, 9 times (multiplcation). ~ono, 1/9. II (mus) ~to, (a. <I>naŭno</I>), 9th (intvl). ~teto, nonet (music or performers). ~takordo, chord of the 9th.", "0"],
["naŭkoro", "naŭkor-o", "(ent) ship-bug (<I>Naueoris</I>).", "0"],
["naŭkrato", "naŭkrat-o", "(<I>pilotfiŝo</I>), pilot fish (<I>Naucrates</I>).", "0"],
["naŭzi", "naŭz-i", "(<I>-n</I>), [UV] Nauseat/e, disgust, sicken, turn one’s stomach. <I>Tio ~as min (al mi</I>), makes me sick. <I>Liaj kapricoj ~as ĉiujn. ~as!</I> It is -ing! (Rz 26/18). <B>~o</B>, nausea, feeling of heaving (loathing, sickness), qualm; repugnance, <I>Senti ~on al (pri) io</I>, recoil (shrink) from, reject with disgust. <B>~a</B>, -ing, disgusting, nasty, offensive, revolting. <I>~a kutimo, odoro, plendado</I>. ➞ <I>abomenet, malplaĉ, vomemig</I>.", "0"],
["navedo", "naved-o", "(a. <I>~eto) (fadengvidilo</I>), shuttle, quill (loom), spool (sewing-machine).", "0"],
["navigi", "navig-i", "(nt) Navig/ate, cruise, sail, vojage. (<I>-n</I>), direct. <I>~i aviadilon, ŝipon</I>. <B>~ado</B>, ~arto, -ation, seamanship. <B>~ebla</B>, -able. ➞ <I>marvetur, ŝipvetur</I> [<B>navigaci-o</B> [OA] = navigado].", "0"],
["navo", "nav-o", "[OA] (arch) nave. <I>Flanka ~o</I>, aisle. <B>Trans~o</B> (<I>transepto</I>), transept.", "0"],
["nazo", "naz-o", "[UV] <B>1</B> (anat) Nose, proboscis. ~o kurb-(rekt-)a. Purigi la. ~on<B></B>, blow one’s n. <B>f</B> ĝi estas antaŭ (sub) via ~o. Havi bonan ~on = guste konjekti, suspekti. Konduki iun ĉe (je) la <B>~o</B>, lead by the n<B>.</B> <I>Ne ŝovu ~on en fremdan vazon</I>, mind your own business<B></B>. Sekvi sian ~on, keep straight on<B></B>. Teni la ~on supren, turn up one’s n. (at). Vidi nur gis la pinto de sia ~o. <B>2</B> (of obj), projecting pt, nozzle (of tube), spout (of kettle). ~o de plugilo, ŝipo. <B>Ter~o</B>, naze, ness. <B>~a</B>, nazal, (phon) ~a sono (nazalo) (m, n, ng). Paroli <B>~e</B> (tra la ~o), speak through one’s n., with nazal twang. <B>~ego</B>, snout. <B>~umo</B>, [UV] pince-nez. Plat<B>~a</B>, stump<B>~a</B>, pug-(snub-)-ed. ➞ <I>flar, pru, rostr</I>.", "0"],
["nazuo", "nazu-o", "(zoo) coati (<I>Nasua</I>).", "0"],
["ne", "", "[UV] <B>1</B> (adv) Not. <I>~ tie</I>, n. there. <I>Mi iros, sed li ~ respondu</I>, don’t answer. <I>Mi ~ pov-(vol-)as iri, I</I> can’t (won’t) go. <I>Ĉu</I> <I>~ ?</I> Is it not so? <I>Mi timas, ke</I> I’m afraid not. TT Strictly, ne negatives the word it precedes. <I>Mi</I> ne devas <I>iri</I>, I am not bound to (neet not) go. <I>Mi devas</I> ne iri, I must not go (though this distinction is not always observed). Ne tute, not quite (entirely). Tute ne, by no means, not at all. <I>Mi</I> ne povis ne iri, I couldn’t help going. <I>Povus</I> ne rakonti, could omit (3 FA 43/24). 2 (<I>PFX</I>) not, in-, ir-, non-, un-. -deviga, optional. ~klara, indistinct. ~metala, non-metallic. ~muzika, unmusical. ~regula, irregular. ➞ <I>mal-, sen-</I>. <B>3</B> (interj) No. <I>Ne, mi ne povas</I>, No, I can’t. <I>Respondu jes aŭ Pagu, kaj mi vin helpos: se ne, ne!</I> <B>~a</B>, negative. <I>~a respondo</I>. <B>~e</B>, in the negative. ~i (a. <I>negi</I>), deny, say no. <I>~i kulp -(respondec-)on</I>. ~(ad)o, denial. For~i (be false to) <I>Dion</I> (Ij 31/28). ➞ <I>neg</I>. <B>Rim</B>.: A proposal to use no for <B>3</B> has met with little success.", "0"],
["nebulo", "nebul-o", "[UV] <B>1</B> Fog, Mist, vapour: <I>Griza ~o kovras la valon</I>. <B>2</B> object. resembling f: <I>Polva ~o</I>. <B>3</B> obscure, unprecise: <I>Perdita en la ~o de la pasinteco</I>. <B>~a</B>, f-gy, m-y. <I>~a ĉielo, nokto, tago</I>. <B>~aĵo</B>, <B>~eco</B>, cloudiness, nebulosity. <I>~eca</I>, m-y, cloudy, confused, formless, hazy, indistinct, nebulous, vague. <B>~ego</B>, dense fog. <I>~ego fumoza</I>, \"peasoup\", smog. <B>~eto</B>, haze, light m. <I>~etas</I>, It is m-y. <B>~igi</B>, f., cloud, make f-y. <I>La fumo ~igas la vidon</I>. ~iĝas! It is getting f-gy. <I>Mia memoro jam ~iĝis pri tio</I>. <B>Sen~a</B>, clear. <B>Spir~ita</B> <I>vitro</I> (4 FA 190/25). ➞ <I>nub, vapor, vual</I>.", "0"],
["nebulozo", "nebuloz-o", "(astr) Nebul/a. <I>~o planeda, spirala. ~a hipotezo</I>, -ar hypothesis.", "0"],
["necesa", "neces-a", "[UV] Necess/ary. <B>1</B> (<I>havenda, nepre bezonata</I>), essential, indispensable, needful, requisite, that cannot be spared. <I>Faru tion ~an. ~a formalaj-(kompetent -mon-reform-)o</I>. <B>2</B> (<I>nepre okazonta, neevitebla</I>), inevitably produced by (resulting from). <I>Necesa sekvo</I>, n. conseqce. <B>~(ec)o</B>, -ity, exigency, inevitability, indispensability, pressing want, urgency. <I>~o logika, morala, natura. Fari virton el ~o. Ĉe ~o</I>, at a pinch. <I>~o estas la patrino de invento</I>. <B>Rim</B>.: Z. (early writings) used <I>~eco</I>, but sometimes <I>~o</I> (Rd 8/9). ~e <I>sekvas, (ke</I>), it -arily follows. ~as (<I>Estas ~e), ke vi venu</I>, It is n. for you to come. <I>Ne ~as diri</I>, It goes without saying. <I>Ne ~as iri,</I> there is no need to go. <B>~aĵo</B>, -ity, essential, imperative need, requisite, requirement, <I>sine qua non. La ~aĵoj de la vivo. Butiko de ~aĵoj</I>, general shop. <B>~ega</B>, absolutely essential. <B>~ejo</B>, [UV] closet, privy, w.c. <B>~igi</B>, -itate, involve, render n. or unavoidable. <I>Tiu decido ~igas multan pripenson</I>. <B>~ujo</B>, [UV] kit; box, case, with n. implements: tool-(work-)box (<I>de kudristino, kuracisto</I>, etc.). <I>Kudra, ripar)a ~ujo</I>, sewing (repair) outfit. <I>~ujo tualeta</I>, dressing-case. <B>Ne~e</B>, needlessly. ➞ <I>bezon, dev, end, nepr</I>.", "0"],
["Nederlando", "", "[OA-8] NL, Netherlands.", "0"],
["Neebla", "", "could mean (a) deniable, (b) impossible. But (a) <I>negebla</I> or <I>neadebla,</I> (b) <I>malebla</I> or <I>ne ebla</I>, are clear.", "0"],
["nefrito", "nefrit-o", "(<I>reninflamo</I>), nephritis. ➞ <I>jad</I>.", "0"],
["negativa", "negativ-a", "[OA] Negative. 1 (<I>nula), ~a rezulto</I>. <B>2</B> (el, tech), <I>~a elektr-(rezist-)o</I>. 3 (alg) minus. 4 (<I>nega</I>), ~o (phot, typ), n., print of plate with reversed image. ➞ <I>kliŝ</I>. Opp <I>pozitiv</I>. neglekt-i (<I>malzorgi</I>), Neglect, disregard, leave uncared for, pay no attention (heed, regard) to. <B>~o</B>, n., inadvertce, want of attention, negligence, omis sion of duty. <B>~a</B>, -ful, care-(heed-)less, negligent, remiss. <B>~ebla</B>, negligible.", "0"],
["negi", "neg-i", "(a. <I>nei</I>), Negat/ive, contradict, deny, reject, refuse to accept or countenance, say no. <B>~(ad)o</B>, -ion, n. statement, denial. <B>~a</B>, n. <I>~a pronomo, respondo, sinteno</I>. <B>~e</B>, in the n. <B>Ne~ebla</B>, undeniable. <B>Rim</B>.: Negi tends to replace nei.", "0"],
["neglico", "neglic-o", "[UV] dishabille, negligee, boudoir wrap, free and easy (unceremonious) attire.", "0"],
["negoco", "negoc-o", "[UV] Business affair, deal, negotiation, money-making concern, transaction. <I>Pro ~o</I>, on b. <I>Fari bonajn ~ojn</I>, do good b. ~(ad)i, carry on b, trade. <B>~a</B>, b. <I>~a lerteco</I>. ~ema, keen on b. <B>~isto</B>, b-man, dealer, trader. ➞ <I>afer, aranĝ, intertrakt, komerc</I>.", "0"],
["negro", "negr-o", "[OA] (<I>nigrulo</I>), Negr/o. ~ideto, pickanny. ~ino, -ess. ~ojda, -oid. Duon<B>~o</B>, mulatto.", "0"],
["neĝo", "neĝ-o", "[UV] Snow. <I>Blanka kiel ~o. ~o drivinta. ~o pasinterjectionara</I> (of yesteryear). <I>Hajl~o</I>, soft s. ~as (<I>~o falas</I>), It is -ing. ~(kovrit)a, -y, -covered. <B>~ado</B>, fall of s. ~ero, s-flake. ~ulino, Snow-white. Pluv <B>~o</B>, sleet. ➞ <I>flok, galant, opol</I>.", "0"],
["nek … nek", "", "[UV] (conj) Neither . „.. nor, Not ... or (both things denied). <I>Gi estas ~ viando ~ fiŝo. Trinku ~ teon ~ kafon. ~ konsilo, ~ konsolo. ~ eniro, ~ eliro. ~ mi ankaŭ</I>, nor I either. <B>Rim</B>.: Stms <I>nek</I> follows other negative words. <I>Faru nenian laboron: ~vi, ~ via filo. Nenia kulpo ~ krimo estas en li. Ne deziru lian domon, ~ lian kampon. Popolo, kiun vi ne konis hieraŭ ~ antaŭhieraŭ</I> (Rut 2/11).", "0"],
["nekro", "nekro-", "(Gk pfx = corpse), necro-.", "0"],
["nekrofor", "", "-o, burying beetle (<I>Necrophorus</I>).", "0"],
["nekrologo", "nekrolog-o", "[OA] obituary (notice). <B>~aro</B>, necrology, register of deaths. <I>~isto</I>.", "0"],
["nekromancio", "nekromanci-o", "necromancy.", "0"],
["nekropol", "nekropol-", "o, necropolis, cemetery, city of the dead.", "0"],
["nekropsio", "nekropsi-o", "autopsy, postmortem examination.", "0"],
["nekrozo", "nekroz-o", "necrosis. <I>Fosfora ~zo</I>, phossy jaw.", "0"],
["neksta", "nekst-a", "next (G. nächst). <B>1</B> (pri loko) (plej apuda, plej proksima); nearest, closest. En la ~a domo. Mia ~a najbaro. <B>2 (</B>pri ordo, tempo) (tuj posta, tuj venonta); immediately foilowing, n. in order, soonest come to. Turnu vin dekstren ĉe la ~a angulo (Venecia Komercisto 22). La ~a fojo, jaro, kunveno, leciono, lernanto, litero, paĝo, poŝto, vorto. Mi venos ~an (tujvenontan) lundon. La ~a (morgaŭa, tujposta) tago. Kiu ~e? ~e plejbona, n. best. <B>Post~a</B> semajno, week after n. (interjection) <B>Nekst!</B>", "0"],
["nektarino", "nektarin-o", "nectarine (<I>Persica nectarina</I><B>).</B>", "0"],
["nektaro", "nektar-o", "[OA] nectar. <B>1</B> (myth) drink of the gods, <B>f</B> any delicious drink. <B>2</B> sweet juice exuded by plants. ~ujo, nectary.", "0"],
["nelumbo", "nelumb-o", "(<I>sankta lotuso</I>), Egyptian lotus, Nile lily, the sacred lotus of Asia (<I>Nelumbium speciosum</I>). ➞ <I>lotus</I>.", "0"],
["nematodo", "nematod-o", "(zoo) nematode, thread-worn, roundworm.", "0"],
["nenia", "", "[UV] (adj) no, of no kind, no kind(sort) of (a), not any. <I>Mi bezonas ~n helpon</I>, I need no help of any kind. <I>~ rezulto</I>, no result whatever. <I>~ ago sen pcgo. ~ beno sen peno</I>. ~okaze, in no case, under no crcum- stances.", "0"],
["nenial", "", "[F] (adv), for no reason, not for any reason, on no account, without (not for) any reason (cause, motive) whatever. <B>1</B> <I>Tion mi ne konsilus e’c al malamiko, sekve ~ al vi. Li rigardis la geamantojn, sed ~ sentis jaluzon</I>. <B>2</B> <I>Kial vi ploras? Vere, mi ploras ~ ajn</I>, for no reason whatever. <I>Ŝajne li subite koleriĝis</I>. ➞ <I>senkaŭz, senmotiv</I>. <B>Rim</B>.: Some argue that <I>Li neniam</I> (or <I>nenie) kantas means</I> that he is <I>not</I> singing; and that therefore <I>Li ~ kantas</I> should also mean <B>1</B> He is <I>not</I> singing (no matter why not); and not <B>2</B> He <I>is</I> singing (with no reason for doing so). But (as above) both uses are found.", "0"],
["neniam", "", "[UV] (adv), Never, at no time, not ever. <I>~ mensogu I Elefanto ~ forgesas. La tempo pasinta ~ revenos. Kiu ~ eraras, nenion faras. Ankoraŭ</I> n. yet. <I>Preskaŭ</I> hardly (scarcely) ever. <I>~ plu,</I> n-more, n. again. <I>Nu, mi</I> Well, I n,! <I>La ~a lando</I>, that land that n. was. <I>En la tago de la Sankta ~o!</I>", "0"],
["nenie", "", "[UV] (adv), Nowhere, in no case, not anywhere. <I>~ mi povis ĝin trovi</I>, I could find it n. <I>Mi iras ~en</I>, I am going nowhither (to n.).", "0"],
["neniel", "", "[UV] (<I>tute ne</I>), Nohow, by no means, in no way, not in any way, nowise. <I>Mi ~ povas kompreni</I>. I can’t understand at all. <I>Tre strange, kaj ~ kompreneble !</I> (H 39/19).", "0"],
["nenies", "", "[UV] (pron), <I>de neniuQ</I>). Nobody’s, no-one’s, belonging to no one, not anyone’s. <I>Dependi de ~ kaprico. ~ lando (tero</I>), no man’s land. <I>~ okulo</I> (Jeĥ 16/5). <I>~ propraĵo (servanto</I>).", "0"],
["nenio", "neni-o", "(pron), Nothing, naught, none, not any thing. <I>~ ajn</I>, nothing at all. <I>Li manĝis ~n. Per ~ oni faras ~n. Kiu havas ~n, estas</I> <B>~aĵo</B>, <B>1</B> blank, vacuum. <B>2</B> (<I>senvalorajo): Li flustris al ŝi dolĉajn ~aĵojn. Vi estas ~aĵo, kaj via agado estas ~aĵo</I>. <B>~eco</B>, vanity, emptiness, unsubstantiality, vacuity. <I>La ~eco de homa gloro</I>. <B>~igi</B> (Jes 44/25), <B>1</B> annihilate, bring to naught, destroy: <I>~igi vilaĝon</I>. ➞ <I>detru, pereig</I>. <B>2</B> annul, cancel, nullify: <I>~igi decidon</I>. ➞ <I>forig, nulig, senvalorig</I>. <B>~iĝi</B> (Ps 146/4), come to n., fall to the ground. <I>Miaj klopodoj ~iĝis. ~iĝa</I> (Ps 39/4), ephemeral, fleeting, impermanent. <I>Dis~iĝi</I> (Jes 51/6), vanish. <B>~o(n)farado</B>, doing nothing, idleness.", "0"],
["neniom", "", "[F] (adv), none (of it), none (at all), no amount (questionty) no whit, not a bit. <I>~ plu, dankon</I>. No more, thank you. <I>~ ajn</I>, absolutely none. <I>~ da filoj, ~ da filinoj</I>, no sons, no daughters (Rj 50/9). <I>Multe da peno, ~ da pano. Mi ~ komprenis el via parolo</I>.", "0"],
["neniu", "", "[UV] (pron), Nobody, no one, not (any) one. <I>Ankoraŭ ~ venis</I>, n. has come yet. <I>Mi konas ~n en la urbo. Tempo kaj tajdo atendas por ~ ajn</I>, no one at all. <I>Kiu ĉasas du leporojn, kaptas ~n. 2</I> (adj) Not a single. <I>~ horo sen laboro. Li havas ~n amikon</I>.", "0"],
["neo", "neo-", "(Gk pfx = new), neo-.", "0"],
["neofito", "neofit-o", "neophyte. <B>1</B> new convert. <B>2</B> beginner, tyro.", "0"],
["neolitiko", "neolitik-o", "neolithic period, later stone age.", "0"],
["neologismo", "neologism-o", "[OA] neolog/ism, newly coined word; <B>neologist-o</B>, -ist.", "0"],
["neono", "neon-o", "(chem) neon (Ne), <I>~a lampo</I>.", "0"],
["neotio", "neoti-o", "bird’s nest orchid (<I>Neottia</I>).", "0"],
["Nepalo", "Nepal-o", "NP.", "0"],
["nepao", "nepa-o", "(<I>akvoskorpio</I>), (ent) water scorpion (<I>Nepa</I>). ➞ <I>ranatr</I>,", "0"],
["nepento", "nepent-o", "(bot) pitcher-plant (<I>Nepenthes</I>).", "0"],
["nepo", "nep-o", "[UV] grandson. <I>La ~oj vin benos</I>. <B>~ino</B>, grand-daughter. <B>Ge~oj</B>, grandchildren. <B>Pra~o</B>, great-grandson (Ps 103/17).", "0"],
["nepotismo", "nepotism-o", "[OA] nepotism, undue family <B>patronage</B>.", "0"],
["nepre", "nepr-e", "[UV] without fail, absolute-(assured -certain-infallib-positiv-sure-)ly, come what may, in any case. <I>Mi ~e venos,</I> I shan’t fail to come. <I>La kunveno ~ okazos. ~ venu!</I> Come without fail! <I>Vi ~ devas iri,</I> you absolutely <I>must</I> go. <I>~ atingota,</I> certain to be attained. <B>~a</B>, absolute, positive. <I>~a bezon-(dev-kondiĉ-postul-)o. ~a helpo</I>, unfailg help. <B>~igi</B>, make inevitable. ➞ <I>cert, dev, neces, neevitebl, sendub</I>.", "0"],
["nereido", "nereid-o", "rag-worm (<I>Nereis</I>).", "0"],
["nervo", "nerv-o", "[OA] (anat) Nerv/e. <I>Tio agacas miajn ~ojn</I>. <B>f</B> <I>Havi ~ojn el ŝtalo</I>. <B>f</B> (sinew) boldness, self-command, spirit. <I>Perdi sian ~on</I>. <B>~a</B>, -ous, of n. (noun). <I>~a malsano (neŭrozo), ~a ĉelo, tiko. ~aj centroj</I>. <B>~aro</B> (<I>~a sistemo</I>). <B>~izi</B>, innervate. <B>~oza</B>, easily excited, highly strung, timid. ~<B>~e</B>, -ously. <I>~~eco</I>, state of noun (fidgets), irritability. <I>~~igi</I>, fray (get on) noun, give the fidgets, set noun on edge. <B>~doloro</B>, (<I>neŭralgio</I>). <B>~ekscito</B>, tonic. <B>Sen~a</B>, n-less, flabby, weak, wanting in spirit or vigour. ➞ <I>timem</I>.", "0"],
["nervuro", "nervur-o", "rib, vein(ing), of leaf, insect’s wing.", "0"],
["nesto", "nest-o", "[UV] Nest (especially of birds, fishes, insects): <I>~o birda, musa, termita. Al ĉiu birdo plaĉas ĝia ~o</I>. <B>f</B> snug or secluded retreat: <I>La familia ~o. Fari sian ~on</I>. Haunt (<I>de rabistoj</I>); fostering-place (<I>de malvirto</I>). <B>2</B> (mar) crow’s n. <B>~i</B>, have (make) an <I>La birdoj ~as printempe</I>. <B>~ado</B>, nidification. <B>~iĝi</B>, -le, lie close, settle, shelter. <I>Floroj ~iĝas en la fendoj</I> (K 195/19). <B>f</B> settle one’s comfortably, lie half-hidden or embedded, smuggle down. <B>~ego</B>, lair. <B>~ulo</B> (<I>birdido</I>), fledgling. ➞ <I>loĝejo, restadejo, rifuĝejo</I>.", "0"],
["neta", "net-a", "[UV] <B>1</B> Fair, neat; (des, typ), clean, clear (cut), distinct, sharp: <I>~a desegn -(klisaĵ-kontur-skribaĵ-)o</I>. <B>~o</B>, f. copy. <I>Skribi</I> ~e (~igi), make a f.c. <B>mal~o</B>, [UV] (rough) draft. <I>Mal~a</I>, (typ) blurry, smudgy. <B>2</B> <I>= sendeprena, senrabat, sentara</I>, net, clear, final: <I>~a gajno, kosto, pezo, prezo, profit</I><B><I>o</I></B>. <B>Mal~a</B>, gross. ➞ <B><I>fin, ver</I></B>. Opp <B><I>nominal</I></B>.", "0"],
["netbalo", "netbal-o", "(gm) net ball. ➞ <I>pilk</I>.", "0"],
["neŭr", "neŭr-", "(ppfx = nerve). ~algio (<I>nervdoloro</I>), -algia. ~astenio, -asthenia. ~ozo, -osis. ~olog-io, -o; ~opat-io, -o.", "0"],
["neŭtra", "neŭtr-a", "[OA] (gram) Neuter, neither masc. nor fem., sexless or sexually undeveloped. (chem) neutral, neither acid nor alkaline. <I>~a solvaĵo</I>. (el) neither positive nor negative. <B>~igi</B>, -alize. II (chem) ~ino, -ine. (ph) ~ono, -on.", "0"],
["neŭtrala", "neŭtral-a", "[OA] Neutral, impartial, of neither party, taking no side. <I>~a lando, lingvo, sinteno, zono. Resti ~a</I>. <B>~eco</B>, -ity. <B>~igi</B>, -ize, counterpoise. <B>~ulo</B>, n. ➞ <I>senparti, superparti</I>.", "0"],
["nevo", "nev-o", "[UV] Nephew, <B>~ino</B>, niece. <B>Pra~o</B>, grand-n.", "0"],
["nevropteroj", "nevropter-oj", "(ent) lace-wings (<I>Neuroptera</I>).", "0"],
["nevuso", "nevus-o", "(med) naevus, birth-mark.", "0"],
["ni", "", "[UV] (pron) we. ~n, usually <I>Al</I> to us. <B>~a</B>, [UV] our. <B>~atempa</B>, of our time.", "0"],
["niĉo", "niĉ-o", "[UV] (arch) niche, nook, shallow recess in wall to contain statue, etc. <I>Sanktula ~o</I> (Rn 24/10). <B>En~igi</B>, esconce.", "0"],
["nielo", "niel-o", "(tech) Niello, black metallic amalgam on metal. <B>~i</B> (<I>-n</I>), ornament in n. <B>~isto</B>, n-worker. ➞ <I>damasken</I>.", "0"],
["nigelo", "nigel-o", "(bot) <B>1</B> love-in-a-mist, fennel-flower (<I>Nigella damascena</I>). <B>2</B> fitch (<I>N. sativa</I>) (Jes 28/27).", "0"],
["nigra", "nigr-a", "[UV] Black, Dark. <B>1</B> (colour) swarthy: ~a kiel fulgo, inko. ~a haŭto, tabulo, vesto. ~aj haroj, okuloj. Ebone, gagate, karbe ~a. <B>2</B> (malluma), d, gloomy, sombre, sullen: ~a flanko, humoro, maro, nokto. <B>3</B> (abomeninda), hateful, nefarious, wicked: ~a faro, koro, krimo. <B>f</B> dirty, grimy. ~a <I>mano, tolaĵo, ungo</I>. <B>4</B> (showing disapproval): ~a arto, b-magic, (➞ nekromanci). ~a laboro, listo, merkato. ~a marko, b-mark. <B>~o</B>, b. ~o sur blanko (= skribo) pruvas sen manko. (chs, drs) La ~oj, bb. <B>~e</B> vestita. Vidi <B>~e</B>, see the gloomy side. <B>~aĵo</B>, b-spot, smut, etc. <B>Porti ~aĵojn</B>, wear b. <B>Fum~aĵo</B>, lamp-b. <B>~eta</B>, b-ish, d-ish. <B>~igi</B>, b-en, d-en, nigrify. <I>Malsano ~igis lian vivon</I>. i besmirch, sully. ~igi ies karakteron per kalumnio. <B>~iĝi</B>, get (grow) b., d. ~iĝanta (ĉielo), <I>lowering, overcast. Blu~iĝa (</I>inko), <I>blue-b. <B>~ulo</B></I>, (negro), <I>~um-o, <B>~i</B>, b-out</I> (<I>kamuflaĵo</I>). <B>~umi</B> <I>domon, urbon</I>. <B>~umilo</B>, <I>b-out curtain, etc. ➞ blindum</I>. <I>Opp blank</I>.", "0"],
["Niĝerio", "Niĝeri-o", "NG.", "0"],
["Niĝero", "Niĝer-o", "NE.", "0"],
["nihilismo", "nihil-ismo", "[OA] <B>-isto</B>, [OA] Nihil-ism, -ist.", "0"],
["Nikaragvo", "Nikaragv-o", "[OA-8] NI.", "0"],
["nikelo", "nikel-o", "[OA] nickel (Ni) <B>~i</B>, nickel-plate. <B>~(it)aĵo</B>, nickel ware. <B>~ero</B>, nickel-coin. <B>~a</B> triklorido, (NiCl<SUB>3</SUB>) nickelic chloride. <B>~a</B> diklorido, (NiCl<SUB>2</SUB>) nickelous chloride.", "0"],
["nikotiano", "nikot/ian-o", "(bot) tobacco-plant (<I>Nicotiana</I>).", "0"],
["nikotino", "nikotin-o", "[OA] nicotine. <B>~ismo</B>. ➞ <I>fum, tabak</I>.", "0"],
["nikso", "niks-o", "nix, water-elf(-sprite). (4 FA/67). <B>~ino</B>, nixie, ondine, undine.", "0"],
["nikteo", "nikte-o", "(<I>neĝa strigo</I>), snowy owl (<I>Nyctea</I>).", "0"],
["niktereŭto", "niktereŭt-o", "(zoo) racoon-dog (<I>Nyctereutes</I>).", "0"],
["nilono", "nilon-o", "nylon. <I>~a ŝtrumpo. ~hara broso</I>.", "0"],
["nimbo", "nimb-o", "[OA] nimbus. <B>1</B> (<I>aŭreolo, haloo</I>). <B>2</B> (met) glory, halo (<I>difraktitaj lumringoj en nebulo</I>). <B>3</B> ideal glory surrounding person.", "0"],
["nimbuso", "nimbus-o", "(met) nimbus, rain-cloud. <B>Kumulo~o</B>, cumulo-n. ➞ <I>kumulus</I>.", "0"],
["nimfeo", "nimfe-o", "(<I>blanka akvolilio</I>), white water- lily (<I>Nymphaea alba</I>).", "0"],
["nimfo", "nimf-o", "[OA] Nymph. <B>1</B> (myth) goddess (spirit) of waters and mountains. ➞ <I>niks. f</I> (lit) young and beautiful woman, damsel, maiden (H 76/5; If 60/23; M 51/18). <B>2</B> (ent) nympha, immature state of insect. <B>3</B> (anat) <I>vulva lipeto</I>. <B>~omanio</B>.", "0"],
["niobo", "niob-o", "(chem) Niob/ium (Nb). <B>~ato</B>, -ate.", "0"],
["niplo", "nipl-o", "(mec) nipple.", "0"],
["niroko", "nirok-o", "(orn) ferruginous duck, white- eyed pochard (<I>Aytha nyroca</I>).", "0"],
["nirvano", "nirvan-o", "(Bud) nirvana, extinction. <B>1</B> of personal existence. <B>2</B> of all passion and desire.", "0"],
["nito", "nit-o", "Rivet (joining metal plate by hammering). <B>~i</B>, r., clinch (pieces of metal lengths). <B>~isto</B>, -ter. <B>~maŝino</B>, -ting machine. ➞ <I>bolt, vinkt</I>.", "0"],
["nitr", "nitr-", "Nitr-, abbreviation of <I>nitrogen</I> in compounds. <B>~ato</B>, -ate. <I>~atacido</I>, -ic acid, aqua fortis. <B> Klorida ~ato</B>, aqua regis. <B>~ido</B>, -ide. <B>~igi</B>, -ify, ~ito, -ite. <I>~itacido</I>, -ous acid. ~oza, -ous.", "0"],
["nitro", "nitro-", "Nitro-. ~benzeno. ~celulozo. ~glicerino. ~geno, -gen (N).", "0"],
["nivelo", "nivel-o", "[UV] Level (sea, etc.). <B>1</B> horizontal line (plane). <B>2</B> elevation, height. <I>Akvo~o,</I> water-1. <I>Mar~o</I>, sea-level. <I>~o supermara. La inundo atingis la ~on de la plafono</I>. f <I>trovi sian ~on</I>. <B>3</B> degree, standard. <I>La morala ~o de la lando. Levi la ~on de la ekzameno. ~o de instruo, komforto, intelekto, vivo</I>. (<I>-n</I>), test the 1. (of). <B>~ado</B>, -ling. <B>~igi</B> (make) 1. (even, uniform), bring to correct 1. <I>~igi klasojn, salajrojn. Al~igi</I> (PI 2/2). <B>~ilo</B>, level gauge. <B>Aer~ilo</B>, <B>bobel~ilo</B>, air level, spirit l. <B>Akvo~ilo</B>, water-g. <B>Vid~ilo</B>, viewfinder. <B>Sam~a</B> <I>transirejo</I>, 1-crossing. <I>Sam~e kun,</I> on a level (par) with, flush. ➞ <I>eben, plat, ŝtup</I>.", "0"],
["nizo", "niz-o", "[OA] sparrow-hawk (<I>Accipiter nisus</I>) &lt; akcipitr, falk.", "0"],
["nj", "-nj", "[UV] sfx of endearment for fem. names. Kanjo, Kittie. Sonjo, Sophie. By extension: avinjo, grannie; enjo, wif(ey); franjo, Sis; panjo, mamma; mum; and even kanjo, puss; kunjo, bunnie.", "0"],
["No", "N-o", "[F], letter N.", "0"],
["nobelo", "nobel-o", "[UV] Nob/le(man), grandee, lord, peer. <B>~a</B>, (of)n. birth(rank), high lineage. <I>~a bieno</I>, lordly domain. <B>~aro</B>, -ility, peerage. <B>~eco</B>, -ity, eminence by birth or rank. <I>Dokumento de ~eco</I>, patent of -ility. <B>~ido</B>, lordling. <B>~igi</B>, raise to the peerage. <B>~ino</B>, lady of rank. <B>Mal~o</B>, commoner. ➞ <I>aristokrat, lord, magnat, patrici, nobl</I>.", "0"],
["nobla", "nobl-a", "[UV] Nob/le. <B>1</B> generous, great, high-minded, honourable, lofty-souled, warm-hearted. <I>~a ago, karaktero, konduto, viro</I>. <B>2</B> grand, elevating, imposing, splendid. <I>~a konstruaĵo</I>. <B>~eco</B>, -ness, moral excellence. <B>~igi</B>, en-n, dignify, elevate. <B>~ulo</B>, man of high ideals. <B>Mal~a</B>, base, coarse, ignoble, low, mean, vile. <I>~~aĵo</I>, infamy. <I>~~igi</I>, debase, degrade, lower. <I>~~ulo</I>, dirty dog, scoundrel. ➞ <I>ideal, model, nobel</I>.", "0"],
["noci", "noc-i", "(<I>malutili, esti ~a</I>), be detrimental (hurtful, injurious, prejudicial) (to), detract from, do harm to, go against. <I>~i al ies interesoj (sano</I>). <B>~a</B>, noxious. <B>Ne~a</B>, harmless, innoxious,", "0"],
["nocio", "noci-o", "(phi, log) notion. ➞ <I>koncept</I>.", "0"],
["noĉo", "noĉ-o", "notch, gash, jag, groove, nick, slot, V-shaped indentation or incision. <I>~o de sago, segilo</I>. <B>~i</B> (<I>-n</I>), indent, nick. <B>~ado</B>, nicking. ~bastono, tally (stick). ~peco (of umbrella), n. ~stango, rack. ➞ <I>breĉet</I>.", "0"],
["nodo", "nod-o", "[OA] <B>1</B> (<I>kruciĝejo</I>), (as, ph), Node, intersecting point of circles (orbits, vibrating string). <I>Voj~o</I>, road junction. <B>2</B> (bot) point at which leaves spring, knob, knot on root or branch in wood): <B>~a</B>, -al. <B>~eco</B>, -osity. <B>~eto</B>, -ule. <B>3</B> (<I>ligtubero</I>). 4 (mar), Knot, vd <I>knot</I>. <B>Rim</B>.: Some langs. use <I>knot</I>; others, <I>nod</I>, for all four meanings. It word be well to use nod for 1,2; and knot for 3,4, as in English. So in <I>Marista Terminaro</I> (1908).", "0"],
["nokaŭto", "nokaŭt-o", "-i, (sp) knock-out, decisv blow.", "0"],
["noktiluko", "noktiluk-o", "(<I>mara fosforesko</I>), noctiluca (protozoon) (<I>Noctiluca</I>).", "0"],
["nokto", "nokt-o", "[UV] Night. <I>~o somera, stelplena. Resti du ~ojn en Romo</I>. <B>f</B> darkness, obscurity. <I>Foriri en la ~on. La ~o de blindeco, nescio, de la tombo</I>. <B>~a</B> (of) n., nocturnal. <B>~e</B>, at (by, in the) n. <I>~a laboro</I>. <B>~as</B>, it is n. <B>~iĝas</B>, <I>la ~o falas,</I> n. is falling (drawing nigh). <I>~iĝo</I>, n-fall, sundown, (orn) <B>~uloj</B>, n-birds. <B>Ĉiu~e</B>, -ly. Tag~o (<I>diurno</I>), day, 24 hours. <B>Tra~i</B>, pass the n. <B>Tut~a</B>, n-long. Opp <I>tag</I>.", "0"],
["noktolo", "noktol-o", "noctule bat (<I>Nyctalus noctula</I>).", "0"],
["noktuedoj", "noktued-oj", "noctuid moths.", "0"],
["noktuo", "noktu-o", "[OA] little owl (<I>Athene noctua</I>) (Le 11/17; Ps 102/6).", "0"],
["nokturno", "nokturn-o", "nocturne, (art) night scene, (mus) night music.", "0"],
["nomado", "nomad-o", "[OA] Nomad, Wander/er. <B>~a</B>, n-ic. <B>~i</B> (<I>vivi</I> ~e), live a w ing life. <B>~ismo</B>. ➞ <I>migr, vag</I>.", "0"],
["nombro", "nombr-o", "[UV] Number. <B>1</B> amount, aggregate, sum total. <I>Havi la ~on de,</I> amount to. <B>mez~o</B>, [UV] average, mean. <B>2</B> quantity. <I>Granda ~o da libroj</I>, a large n. (multitude) of books. <I>~o (ne)para</I> even (odd) n. ~oj, (Bb) Numbers. <B>~a</B>, <B>1</B> <B>(pri~a)</B>, numerical. <B><I>~a demando, rilato, signo</I>. 2 (prikvanta), <I>Kiom ~aj ili estas?</I> ~i (<I> n</I>)</B>, number. <B>1</B> ascertain (count) how many (n. of), compute, enumerate, reckon. <B><I>Oni ne povis ~i nek kalkuli</I></B> (1 Rĝ 8/5). <B><I>~i la loĝantaron (stelojn</I>). 2</B> amount to, consist of, have (reach) the number of. <I>La grupo ~as 30 membrojn</I>. <B>~ado</B>, count. <B>Popol~ado</B>, census. <B>~ono</B> (<I>frakcio</I>), fraction. <B>Grand~a</B>, <B>multe~a</B>, comprising many units, numerous. <I>~~a klaso, legantaro</I>. <I>Veni</I> <B>mult~e</B>, in large numbers. <B>Plen~e</B>, complete, in full force. <B>Ne~ebla</B>, innumerable. <B>Sen~a</B>, n-less, countless, (gram) <B>unu~o</B> [UV] (<I>singularo</I>), singular. ➞ <I>cifer, kvant, numer, plur(al</I>).", "0"],
["nomenklaturo", "nomenklatur-o", "nomenclature, scientific terminology. ➞ <I>terminar</I>.", "0"],
["nominala", "nominal-a", "[OA] (<I>laŭnoma</I>), Nominal, existing in name only, not actual or real. <I>~a estro, kosto, prezo, valoro</I>. (phi) <B>~ismo</B>, <B>~isto</B>. Opp <I>efektiv</I>.", "0"],
["nominativo", "nominativ-o", "[UV] (gram) nominative (case).", "0"],
["nomo", "nom-o", "[UV] Name, appelate, denomination, designate, title. <I>Diru al mi vian ~on. En (per) la ~o de</I>, in the name of. <B>Al~o</B>, <B>Krom~o</B>, cogmomen. <B>Antaŭ~o</B>, <B>Bapto~o</B>, <B>persona</B> <B>~o</B>, Christian n. <B>Duopa</B> <B>~o</B>, double-barreled n. <B>Familia</B> <B>~o</B>, sur-n. <B>Kaŝ~o</B>, <B>pseŭdo~o</B>, <B>plum~o</B>, [UV] pseudonym, pen-n. <B>Land~o</B>, n. of country. <B>Mok~o</B>, <B>ŝerc~o</B>, nick-n. <B>Propra</B> <B>~o</B>, (gram) proper n. <B>~a</B>, appelative, nominal. <B>~e</B>, [UV] <B>1</B> by n. <I>Voku ilin ~e</I>. <B>2</B> -ly, that is to say, to particularize, to wit, viz. <I>Atentu la kondiĉojn, ~e… . </I> <B>~i</B>, [UV] n. <B>1</B> Call, give n. to, entitle (Ge 2/19): <I>~i katon, infanon Petro</I>. <B>2</B> use n. for, describe by n.: <I>Kiel vi nomas tion? Oni kutime ~is lin \"avo\". Ne sufiĉas ~i lingvon internacia, por ke ĝi estu tia</I>. <B>3</B> (<I>mencii</I>), mention, speak of. <B>4</B> (a. <I>nomumi</I>), choose (for office, etc.), designate, indicate, nominate, specify. <B>~ado</B>, nominate. <B>~aro</B>, panel, list of names. <B>~ata</B>, c-d, n-d, whose n. is. <B>~iĝi</B>, be c-d, have the n. ~ito, nominee. <B>Ali~e</B>, alias. <B>Laŭ~e</B>, nominally. <I>Lando nur ~e Kristana</I>. <B>Ne~ebla</B>, unmentionable. <B>Propra~e</B>, in one’s own name. <B>Sam~ulo</B>, n-sake. <B>Sen~a</B>, n-less, anonymous, obscure. ➞ <I>esprim, menci, termin, titol, vok</I>.", "0"],
["nopalo", "nopal-o", "nopal, cochineal cactus (<I>Nopalea</I>). ➞ <I>opunti</I>.", "0"],
["nordo", "nord-o", "[UV] North. <I>La magneta ~o</I>. <B>~a</B>, -erly, -ern, of (from) the n. <I>~a hemisfero, vento</I>. <B>~e</B>, in (to) the n. <I>Skotlando kuŝas ~e de Anglujo</I>. <B>~en</B>, to the n., -wards. <I>Rigardu ~en!</I> <B>~ano</B>, <B>~ulo</B> (jl 2/20), -erner. <B>De~e</B>, from the n.", "0"],
["norio", "nori-o", "(<I>trogĉeno</I>), noria, chain-pump, bucket-(chain-conveyor-)hoist.", "0"],
["normala", "normal-a", "[OA] Normal; ordinary, regular, typical, usual, (psy) well-adjusted. <I>~a kvanto, nivelo, sano, temperaturo</I>. <B>~eco</B>, -ity. <B>~igi</B>, adjust, regulate, set. <B>Ne~a</B>, abnormal. <B>Preter~a</B>, uncanny. ➞ <I>kutim, ordinar</I>.", "0"],
["normo", "norm-o", "[OA] Norm, Standard, par (of exchange), pattern, type, authtive model or rule. <I>Konformiĝi al la ~o</I>. (mus) <B>Piĉ~o</B>, standard pitch (/4 = 440 <I>vibroj sekunde</I>). <B>(Laŭ)~a</B>, conforming (up) to s., correct to pattern. <I>~a solvaĵo</I>, norm solution. <B>~igi</B>, s-ize. <B>Al~igi</B> (<B>Sam~igi</B>) <I>fabrikaĵojn. ilojn. varojn</I>. <B>Sub~a</B>, below s. ➞ <I>model, ŝablon, tip</I>.", "0"],
["Norvegujo, Norvegio", "", "[OA-8] NO.", "0"],
["nostalgio", "nostalgi-o", "[OA] (<I>hejmensopiro</I>), Nostalg/ia, sorrowful longing for conditions of a past age, wistful memory of earlier times. <B>~a</B>, -ic.", "0"],
["nostoko", "nostok-o", "nostoc, star-holly, witch’s butter (bluegreen alga) (<I>Nostoc</I>).", "0"],
["notacio", "notaci-o", "notation. <I>~o algebra, muzika, ŝaka</I>.", "0"],
["notario", "notari-o", "[UV] Notary. <B>~a</B>, -ial. <B>~ejo</B>, n’s office.", "0"],
["noto", "not-o", "[UV] No/te. <B>1</B> brief record or writing, memorandum: <I>Fari ~on pri adreso, dato, fakto</I>. Ekspeda <B>~o</B>, despatch n. <B>2</B> written remark or comment, annotion. <I>Libro kun klarigaj ~oj</I>. <B>Pied~o</B>, foot-n. <B>3</B> (mus) <B>~o</B>, written sign (letter, number) representing a mus. sound; also, by extensn, the sound itself: <I>~o plena, duona</I>, semibreve (minim). <B>Krom~o</B>, <B>pas~o</B>, <B>ond~o</B>, <B>ŝanĝ~o</B>. <B>Pend~o</B>, hanging note. Vd <I>Muz. Terminaro</I> (p. 17). <B>f</B> (<I>eco, nuanco</I>), characteristic feature. <I>Liaj vortoj portis funebran ~on en la feston</I>. <B>~i</B>, <I>fari ~on</I>, make (take) a n. (of), jot down. <I>~u la daton en via taglibro</I>. <B>f</B> (<I>atenti, memori</I>), notice, observe. <I>~i (al si) en la cerbo (memoro</I>), make a mental note of. <B>~u</B>, <I>ke mi venos marde</I>. <B>~aro</B>, documents, file, records. <B>~inda</B>, n-worthy. <B>~libro</B>, n-book. <B>Kvin~a</B> (pentatonic) <I>skalo (d,r,m,s,l</I>). <B>Pri~i</B>, annotate.", "0"],
["notonekto", "notonekt-o", "(ent) backswimmer, water-<B>bug (</B>Notonecta<B>). ➞</B> <I>koriks</I>.", "0"],
["noumeno", "noumen-o", "(phi) noumenon, object. of intellectual intuition. Opp <I>fenomen</I>. ➞ <I>numen</I>.", "0"],
["nova", "nov-a", "[UV] New. <B>1</B> now first appearing (experienced, introduced), novel, unfamiliar. <I>~a libro, modo, N~a Testamento</I>. <B>2</B> changed, difft, fresh, renewed, replacing previous one. <I>~a luno, regulo, sekretario. ~jara tago</I>, New Year’s Day. <B>3</B> just made, of recent date. <I>~a amiko, domo, vesto, vino. -ly</I>, just recently, <I>~e bakita, demetita, naskita, trovita, falinta, veninta</I>. <B>~aĵo</B>, <B>1</B> novelty, innovation, something new or unusual. <B>2</B> (piece of) news, tidings, report of recent events. <B>~eco</B>, newness, novelty. <B>~igi</B>, innovate. <B>~ulo</B>, newhand, freshman, novice, tyro. <B>De~e</B> (<I>refoje, duan fojon</I>), afresh, again, anew, once more. <B>Re~igi</B>, renew, renovate. <I>~i amikecon, meblon, moron. PFX</I> neo-, new, <B>~jaro</B>, <B>~platonismo</B>. <B>~edzino</B>, Mrs newly-wed, <B>Nov-Zelando</B> NZ. ➞ <I>freŝ, jun, ĵus</I>.", "0"],
["novalo", "noval-o", "(<I>tero nekultivata, ripozanta</I>), fallow ground.", "0"],
["Novao", "Nova-o", "(<I>\"nova stelo\"</I>), (astr) nova.", "0"],
["novelo", "novel-o", "[OA]. novelette, short story of fiction. ➞ <I>fabel, rakont, roman</I>.", "0"],
["Novembro", "Novembr-o", "[UV] <B>November</B>.", "0"],
["novico", "novic-o", "[UV] (<I>novulo</I>), Novic/e, neophyte. <B>1</B> of religious order. <B>2</B> (<I>nespertulo</I>), beginner, tyro. <I>~o ĉe aviado</I>. <B>~eco</B> (<I>~a periodo</I>), -iate.", "0"],
["nu", "", "[UV] (interj), Well! Well now! Come now! and yet it must be admitted, you must know, etc. ~ do, well, then! Gives various tones to the sentence, as suggested by context or tone of voice. (Acquiescence, concession): <I>~ do, venu, se vi vere insistas</I>. (Argument): <I>~, li diris, ke vi eraras. vi konsentos, ke. vi estas homo; do vi povas erari</I>. (Astonishment, surprise): <B>~</B>, <I>Kiu supozus tion? mi neniam!</I> (Calling attention): <I>aŭskultu!</I> (Doubt, hesitation): <B><I>~</I></B><I>, kio pri la hundo?</I> (Explanation): <I>Barabas estis rabisto</I>. (Ending conversation): <I>Bonan nokton!</I> (Expostulation): <I>Kiu povus tion kredi!</I> (Impatience): <I>finfine vi alvenis!</I> (Resignation): <B><I>~</I></B><I>, tia estas la vivo!</I> (Soothing): <I>~! Ne ploru!</I>", "0"],
["nuanco", "nuanc-o", "[UV] Nuance, Shade; delicate diffce in colour (feeling, meaning, etc.), gradation, hue, tinge, tint, touch, suggestion. <I>~o da ĉagreno, signifo, verdo</I>. <B>~i</B> (<I>havi ~on</I>). <B>~igi</B> (<I>aldoni ~on</I>), s., blend, modulate, <I>~igi sian voĉon</I>. <B>~iĝi</B>, s. off, change imperceptibly. <I>La ĉielo ~iĝis per mil koloroj</I>. <B>Sen~e</B>, abruptly, without grad(u)ation. ➞ <I>ombr, ton</I>.", "0"],
["nubo", "nub-o", "[UV] Cloud. <B>1</B> (vapour), haze, mist. <I>~oj kovris la ĉielon</I>. <B>2</B> (dense mass): <I>~o el fumo, incenso, polvo</I>. <B>3</B> multitude, swarm. <I>~o da akridoj, sagoj, vortoj</I>. <B>f</B> gloom, obscurity, shadow. <I>~o aperis sur lia vizaĝo</I>. <B>~a</B>, <B>1</B> (<I>~kovrita, ~oplena, ~oza</I>), c-y, dark, gloomy: <I>~a ĉielo, tago, vetero</I>. <B>2</B> confused, hazy, obscure: <I>~a stilo</I>. <B>3</B> depressed, gloomy, sullen: <I>~a vizaĝo</I>. <B>~ero</B>, speck (wisp) of c. <B>~igi</B>, c., befog, darken, obscure. <B>~iĝi</B>, c. over, become gloomy (overcast). <B>Sen~a</B>, c-less, bright, clear. ➞ <I>cirus, kumulus, nebul, nimbus, stratus, vual</I>.", "0"],
["nuda", "nud-a", "[UV] Bare, Nude. <B>1</B> naked, unclothed: <I>~a kapo, piedo</I>, b-headed, b-footed. <I>Pentri laŭ ~a modelo</I>, from the n. <B>2</B> exposed, un-cover(-drap-furnish-protect -sheath)ed: <I>~a arbo (senfolia); ĉambro (,senmebla); glavo (seninga); okulo (senokulvitra); tero (senkreskaja</I>). <B>3</B> direct, simple, sincere, un-adorn (-disguis)ed: <I>~a logik-(stil-ver-)o, (sendetala): ~a projekto</I>. ~e <I>tondita hundo</I>. <B>~aĵo</B>, b-place. <B>~eco</B>, nudity. <B>~igi</B>, b., denude, expose, lay b., strip, uncover, <I>~igi brakon, glavon</I>. <B>~ismo</B>, -isto. <B>~ulo</B>, n.", "0"],
["nudelo", "nudel-o", "(<I>rubanda vermiĉelo</I>) (cul) noodle.", "0"],
["nufaro", "nufar-o", "(<I>flava akvolilio</I>), Yellow water- lily (<I>Nuphar</I>).", "0"],
["nugato", "nugat-o", "(cul) nougat.", "0"],
["nuko", "nuk-o", "[UV] (<I>kolposto</I>), nape, scruff (of neck), <I>Klini la ~on</I> (bow the neck) <I>antaŭ tirano</I>. ~doloro, (c)rick in the neck, stiff neck. Malmol<B>~a</B>, (Bb) <I>fiere obstina</I>, mulish, stiff-necked, stubborn, <I>Malmoligi sian ~on</I> (Ne 9/17). ➞ <I>kol</I>. nukle-o, Nucle/us, central point. <I>Atoma ~o</I>. ~a <I>ĥemio</I>, -ar chemistry, <B>f</B> centre, core, kernel. <I>~o de kometa kapo, de rezisto</I>.", "0"],
["nukso", "nuks-o", "[UV] Nut. <B>Krevigi ~ojn</B>. <I>~oj venis, kiam dentoj elfalis (tro malfrue)</I>. <I>Brazila ~o, Ter~o (arakido)</I>. <B>~a</B> (<I>~ogusta</I>), nutty. <B>~a butero</B>, n-butter. <B>~rompilo</B>, (pair of) n-crackers. (orn) <B>-rompulo</B>, n-cracker (<I>Nucifraga</I>).", "0"],
["nulo", "nul-o", "[UV] Nought, the figure 0, blank, cipher, nil, nothing, zero. <I>20 gradoj sub ~o</I>. f <I>Rigardata kiel ~o</I> (Jes 40/17). <B>Iu altranga ~o</B>, a highly placed nobody, (gm) <I>~oj kaj krueoj</I>. <B>~a</B>, null, entirely negligible. <I>La rezulto (rikolto) estis ~a</I>. <B>~aĵo</B>, <B>~eco</B>, nullity. <B>~igi</B>, nullify, cancel, declare void, invalidate, quash, rescind. <I>~~ baloton, decid-juĝ-kontrakt-verdikt-)on</I>. (phlt) obliterate. Ne~igebla, irrevocable. ➞ <I>cifer, neni-</I>.", "0"],
["numenio", "numeni-o", "(orn) curlew, whaup (<I>Numenius</I>) (4 FA 53/9). ~o malgranda, whimbrel.", "0"],
["numeno", "numen-o", "(rel) numen, divine force, religious feeling of attraction and awe characteristic of man’s sense of communion with God.", "0"],
["numeralo", "numeral-o", "[OA] (gram) numeral, word or figure(s) denoting a number. <I>~o baza (fundamenta</I>), cardinal. <I>~o orda</I>, ordinal. ➞ <I>obi, on, op, po</I>. IT ➞ cifero (written sign); numero (consecutive number); numeralo (part of speech).", "0"],
["numeratoro", "numerator-o", "(mat) numerator (upper number of fraction). ➞ <I>indie</I>.", "0"],
["numero", "numer-o", "[UV] <B>1</B> (consecutive) Number given to (written on) something to indicate its order among others: <I>~o de bileto, (domo, kajero, paĝo. Skribu la straton kaj ~on. Atoma ~o</I>, atomic n. <I>Telefona ~o</I>. <B>2</B> thing indicated by this: <I>~o de gazeto. Mi loĝas en ~o</I> 36. <B>~i</B> (<I>-n</I>), assign a n. to, put a n. on, page, <I>~i dokumenton, libron, seĝon</I>. <B>~ado</B>, n-ing, numeration, paging, etc. ~ilo, -ing machine, stitch counter, etc.", "0"],
["numido", "numid-o", "(<I>perlokoko</I>), guinea-fowl (<I>Numida</I>).", "0"],
["numismata", "numismat-a", "Numismat/ic. <B>~isto</B>, -ist. <B>~ko</B>, [OA] -ies.", "0"],
["nun", "", "[UV] (adv) Now. <B>1</B> (<I>~tempe</I>), at present, at this (very) moment: <I>~ li dormas. De</I> from n. onwards, for the future, henceforth. <I>Ĝis</I> as yet, till n. <B>2</B> (<I>tuj</I>), immediately, without waiting any longer: <I>Venu Ni devas iri Jam</I> even n. <I>~ aŭ neniam!</I> <B>3</B> (and) now, following what has happened, after this, things being so, under the present circumstances. <I>~ ni transiru al la dua punkto. Kaj ~ ni ĉion forgesu. ~ vidu, kio sekvis. ~</I> <B><I>kiam ni vidis lin, ĉio ŝanĝiĝis</I>. ~(temp)o</B>, the present time. <B>~a</B>, current, present. <B><I>Mia ~a deziro, letero. La ~a aranĝo, sistemo. La</I></B> <I>23</I><B><I>-a de la ~a</I></B>, the 23rd inst. ➞ <B><I>aktual, as, estant, nu, temp</I></B>.", "0"],
["nuncio", "nunci-o", "nuncio, papal ambassador.", "0"],
["nur", "", "[UV] (adv), Only, but (in this sense). <I>~ malmulte</I>, o. a little, b. little. <B>1</B> Not more than, and no more, and nothing besides (else). <I>Gi kostis ~ unu pencon. Venis ~ tri gastoj. Bano ~ varmeta. Knabo ~ sesjara. ~ auskultu!</I> Just listen! <I>~ li ne iris</I>, all but he went. <B>2</B> merely, simply, not otherwise than. <I>Mi povas paroli</I> <B><I>~</I></B> <I>Angle. Mi parolas ~ por via bono. Mi atendos ~ ĝis lundo. Ne ~ A, sed ankaŭ B:</I> not o. A, but also B. <B>3</B> not before, not till: <I>Li venos ~ morgaŭ. ~ tiam vi komprenos</I>. <B>~a</B>, mere, (pure and) simple. <I>~a hazardo</I>. ➞ <I>sole</I>. <B>Rim</B>.: Nur modifies the idea it precedes, <I>~ li (neniu alia) parolis. Li ~ parolis (sed ne laboris). Li parolis ~ al ŝi (ne al alia). ~ se vi iros</I>, o. if (provided that) you go. <I>Se ~ vi iras</I>, if only you go. <B>Rim</B>.: ➞ sola, only, solitary (<I> = nur unu, sen alia</I>). <B>Rim</B>.: <I>Li estas ~ mia edzo</I> (o. my). <I>Li estas mia sola edzo (my only</I>). <B>Rim</B>.: ➞ nura <I>vorto</I>, a mere word, with <I>unu</I> sola <I>vorto,</I> one single (solitary) word. [It is a common error to use <I>nura</I> when <I>sola</I> is meant]. <B>Rim</B>.: Sometimes Z uses <I>nur</I> in a way I do not understand. M.C.B. (e.g., 4 FA 157/20; 230/21; 239/25).", "0"],
["nutacio", "nutaci-o", "(as, bot, etc.), nutation.", "0"],
["nutri", "nutr-i", "(<I>-n</I>), [UV] Nourish. <B>1</B> feed, sustain with food: <I>~i bebon, katon, planton, menson. Sin ~i</I> (feed one’s) <I>per mielo</I>. f <I>La lando ~as la loĝantaron</I>. <B>2</B> encourage, foster: <I>~i ambicion, deziron, senton</I>. <B>~a</B>, nourishing, nutritious, nutritive. <I>Lakto estas pli ~a, ol vino</I>. <B>~(aĵ)o</B>, aliment, food, n-ment, provender, etc. <I>Rezervaj ~aĵoj</I>, emergency rations. <B>~ado</B>, nutrition. <B>Mam~i</B>, nurse, suckle, feed at the breast. <I>~~istino</I>, wet-nurse. <B>Sub~i</B>, under-n. <B>Super~i</B>, overfeed. ➞ <I>manĝ, past, vart</I>.", "0"],
["O", "", "[F], letter O.", "0"],
["o", "-o", "[UV] noun ending; denotes entity (object., person, action, quality) corresponding to the root. (e.g., <I>domo, homo, bato, belo</I>).", "0"],
["oazo", "oaz-o", "[OA] oasis. ~o en la dezerto. <B>f</B> ~o de paco meze de tumulto. ➞ <I>rifuĝej, ripozej, ŝirmej</I>.", "0"],
["obei", "obe-i", "(<I>-n, al</I>) [UV], be obedient to, obey. <B>1</B> do what one is told to by, perform bidding of: <I>~i la patron</I>. <B>2</B> comply with, heed, execute, mind, <I>~i leĝon, ordonon, regulon</I>. <B>~(ad)o</B>, obedience. <I>~opasiva</I>. <B>~(em)a</B>, obedient, compliant, dutiful, submissive. <B>~emo</B>, deference, docility. <I>~emaĉa</I>, fawning, obsequious. <B>~igi</B>, bring into allegiance (to heel), subdue, train (➞ <I>juĝ, ordon, reg</I>). <B>~igema</B>, dictatorial, imperious. <B>Mal~i</B>, disobey, break (rule), defy, transgress, <B>~~ema</B>, defiant, insubordinate, refractory, unruly. <I>~~emo,</I> contumacy. <B>Ne~ebla</B>, impossible (order, rule). <B>Ne~igebla</B>, indomitable, uncontrollable, untameable.", "0"],
["obelisko", "obelisk-o", "[OA] (arch) obelisk. <I>~o de Kleopatro</I>, C’s needle, (typ) the sign (t) <B>Du~o</B>, ©.", "0"],
["objektiva", "objektiv-a", "[OA] (opp <I>subjektiva</I>), Objectiv/e. <B>1</B> (phi) external to thought; with actual or real existce. <B>2</B> independent of one’s own personal feelings or opinions; as seen by another; factual, impartial. <I>~a pritrakto de temo. Rigardi</I> <B>~e</B>, -ely. <B>~eco</B>, -ity.", "0"],
["objektivo", "objektiv-o", "(opt) (phot) object-glass.", "0"],
["objekto", "objekt-o", "[UV] Object. <B>1</B> (<I>aĵo</I>), article, thing. <I>~oj sur la tablo. Leciono pri ~o,</I> o-lesson. <I>Dom~o</I> (Ne 13/8). <B>2</B> (early writings) <I>= temo. ~o de admiro, disputo, intereso, studo</I>. <B>3</B> (gram) Object (of a sentence) (the complement of a transitive verb). The rekta ~o (direct o.) has the accusative ending <I>\"n\"</I>. The nerekta ~o (indirect o.) <I>= prepozitivo</I> (which see). ➞ <I>afer, artikol, cel; subjekt</I>.", "0"],
["obl", "-obl", "[UV] sfx denotes multiplication. <B>~o</B>, multiple. 6,9, <I>estas ~oj de</I> 3. <B>du~a</B>, [UV] duple, twofold. <I>~~a porcio</I>, double portion. Tri<B>~a</B>, triple. <B>Mult~a</B>, manifold. <B>Unu~a</B> (<I>fadeno</I>), simple, single. <B>Kelk~e</B>, several times. <B>~igi</B> (<I>multipliki</I>), multiply. <I>Du~igi</I>, multiply by 2. <I>Mult~igi</I>, duplicate (make many copies). <B>Mult~iĝema</B>, prolific. ➞ <I>foj, mult, op</I>.", "0"],
["oblato", "oblat-o", "[UV] wafer. <B>1</B> for sealing, seal. <B>2</B> (rc) for the host. ➞ <I>vafl</I>.", "0"],
["obligacio", "obligaci-o", "[OA] (com) Bond, debenture. <I>~o fervoja, hipoteka</I>. <B>~ulo</B>, <B>~havanto</B>, b-holder.", "0"],
["oblikva", "oblikv-a", "[OA] Obliqu/e. <B>1</B> aslant, diagonal, inclined, slanting, sloping. <I>~a linio. ~a skribo</I>, running hand. ➞ <I>kursiv</I>. <B>2</B> indirect, not going straight to the point, roundabout, side-ways. <I>~a cito, parolo, rigardo</I>. <B>~e</B>, askance, askew. <I>~e staranta</I> (leaning) <I>turo</I>. <B>~(ir)i</B>, go sideways. <I>La plafono ~is</I>. <B>~aĵo</B>, ramp. <B>~eco</B>, -ity. Opp <I>horizontal, vertikal</I>.", "0"],
["oblonga", "oblong-a", "(<I>pli longa ol larĝa</I>), Oblong. <B>~o</B>, o., rectangle with adjacent sides unequal.", "0"],
["obolo", "obol-o", "[OA] obol (ancient Gk coin).", "0"],
["obscena", "obscen-a", "obscene; coarse, filthy, indecent, lewd.", "0"],
["obsedi", "obsed-i", "(<I>-n</I>), (used of delusion, idea, evil spirit), Obsess: fill the mind, haunt, preoccupy. <I>La ideo lin ~is</I> (seized hold of him). <I>Kio vin ~as?</I> what possesses you? <B>~o</B> (<I>Prem~o, Trud~o</I>), -ion, delusion, fixed idea. <I>~a memoro, penso</I>. <B>~ata</B>, fixated, possessed.", "0"],
["observatorio", "observatori-o", "[OA] (astr) observatory.", "0"],
["observi", "observ-i", "[UV] Observ/e, watch. <B>1</B> Look at with fixed attention, mark, take notice of. <I>la historion, la stelojn</I>. <B>2</B> Keep, adhere to, follow, obey. <I>~i feston, instruon, leĝon, principon, sabaton, silenton</I>. <B>~(ad)o</B>, -ance, -ation. <I>~o de regulo (rito). Bazi teorion sur ~o</I>. <B>~aĵo</B>, -ation, note. <B>~anto</B>, -er. <B>~ejo</B>, -ation post, watch-house, (mar) crow’s nest. <B>~ema</B>, -ant, watchful, vigilant. <B>~isto</B>, look-out, overseer, watcher, watchman. <B>Mal~i</B>, disregard.", "0"],
["obsidiano", "obsidian-o", "(geol) obsidian,", "0"],
["obskura", "obskur-a", "Obscur/e. <B>1</B> (<I>malluma</I>): dark, dim, gloomy, shadowy, sombre. <I>~a angulo, ĉambro</I>. <B>2</B> (<I>neklara</I>): dingy, dull, indefinite, indistinct, vague. <I>~a koloro, demando, fenomeno</I>. <B>3</B> (<I>nekonata, senfama</I>): hidden, humble, remote from observation, secluded, undistinguished, unknown to fame. <I>~a sciencisto, vivo</I>. <B>~(ec)o</B>, -ation, -ity; dimness, humbleness, vagueness, seclusion. <B>~igi</B>, cloud, darken, dim, eclipse, shade.", "0"],
["obskurantismo", "obskurantism-o", ".", "0"],
["obstaklo", "obstakl-o", "Obstacle, bar, hindrance, impediment. <I>~a kuro</I>, obstacle-race, hurdle-race, steeple-chase, etc.", "0"],
["obstetriko", "obstetrik-o", "(<I>akuŝa scienco</I>), Obstetric/s. <B>~a</B>, -al. <B>~isto</B>, -ian.", "0"],
["obstina", "obstin-a", "[UV] Obstin/ate, dogged, persisting in one’s own way, pertinacious, unyielding (Jes 48/4). <I>~a infano, mulo, rezisto</I>. <B>~e</B> <I>silenti</I>, sulk. <I>~e antaŭen!</I> <B>~(ec)o</B>, -acy, determination. <I>Vespero, I’-o, kaj la pacienco</I>. <B>~i</B>, persist, stick to. <I>~i en siaj pekoj</I>. ~aĉa, <B>~ega</B>, pig-headed, refractory, self-willed, stiff-necked, stubborn. ~igi (harden) <I>la koron</I> (El 14/4). ~ulo. ➞ <I>malcedem, nekonvinkebl, persist</I>.", "0"],
["obstrukco", "obstrukc-o", "[UV] obstruction, congestion, hindrance to progress or circulate, stoppage. ~o <I>intesta; ~o ĉe (de, en) kloako, tubo, vejno; sur strato</I>. <B>~i</B>, obstruct, block (the way) (up), choke, clog, fill with impedimenta, jam, make impassable, stand in the way of. <B>f</B> prevent (retard) progress. <I>~i la agadon de la polico</I>. (pol) filibuster. <B>Mal~i</B>, clear. ➞ <I>bar, embaras, Stop</I>.", "0"],
["obteni", "obten-i", "= havigi al si, obtain; achieve, acquire, gain, get, procure, secure. ➞ <I>akir</I>.", "0"],
["obturi", "obtur-i", "obturate, close (off), cover, seal (breech of gun, cavity, orifice), stop up. <I>kamentubon</I>. <B>~o</B>, obturation. ~ilo, closing device, stop-cock, etc. (phot) shutter. <I>Diafragma (fokusa, gilotina) ~ilo</I>, diaphragm, focal plane, (drop) shutter.", "0"],
["obtuza", "obtuz-a", "[OA] obtuse. <B>1</B> (geom) <I>~a angulo,</I> blunt (point), rounded (leaf). <B>2</B> dull, muffled: <I>~a bruo, muĝo, sono, voĉo</I>. <B>f</B> dull- witted, thick-headed. <B>3</B> not clearly felt, unprecise: <I>~a kolero, malĝojo. ~a</I> (gnawing) <I>doloro</I>. <B>~igi</B> (<I>sonori</I>), deaden, dull, muffle &lt; <I>damp</I>. ➞ <I>neakr, neakut, neklar</I>). <B>Sens~o</B>, stupor, dazed (dumbfounded, stunned) condition.", "0"],
["obuso", "obus-o", "(mil) shell. ~e <I>ŝokita</I>, suffering from shell-shock. ➞ <I>grenad</I>.", "0"],
["oceano", "ocean-o", "[OA] Ocean. <B>1</B> The high sea. <B>2</B> each of the five main seas. <I>Atlanta ~o</I>. <B>f</B> vast expanse. <B>~a</B>, -ic. <B>Trans~a</B>, trans-ic. <B>~ografio</B>.", "0"],
["ocelo", "ocel-o", "(ent) (zoo) ocellus, simple (single) eye, eye-like spot.", "0"],
["oceloto", "ocelot-o", "(<I>panterkato</I>), leopard-(tiger-)cat, ocelot (<I>Fells partialis</I>).", "0"],
["ocimo", "ocim-o", "= bazilio.", "0"],
["odo", "od-o", "[OA] Ode, lyrical poem of exalted tone.", "0"],
["odoro", "odor-o", "[UV] Odour (pleasant or unpleasant): Scent; smell. <I>~o dolĉa, mucida. Enspiri, flari ~on de rozo. Brul~o,</I> smell of burning. ~i (<I>-n, je</I>), emit (give forth, have) an o., s. <I>je ajlo, mosko, sterko</I>. <B>f</B> <I>~i je nepotismo</I>. <B>~(ant)a</B>, balmy, fragrant, odoriferous, s-ed. <B>~aĉo</B>, <B>malbon~o</B>, offensive smell, reek, stench, stink. <B>Fi~a</B>, unsavoury. <B>Ek~o</B>, whiff. <B>Sen~a</B>, o-less, s-less. <I>Sen~igi</I>, deodorize. Bon<B>~o</B>, aroma, fragrance, perfume. <I>~~a</I>, sweets-ed. <B>Malbon~a</B>, f(o)etid, malodorous, smelly, stinking. <B>f</B> (<I>mal)bon ~i</I>, be in good (bad) o. or repute. <I>Kiu sin gloras, malbone ~as</I>. ➞ <I>atom, balzam, flar, haladz, parfum</I>.", "0"],
["ofendi", "ofend-i", "[UV] Offend. <B>1</B> give offence to, affront, anger (vex) someone by hurting his dignity, cause resentment; insult (wound the feelings of): <I>Vi ~is lin per via rido. Muso la katon ĉiam ~is</I>. (grate on, shock): <I>~i mian lingvan senton</I> <B>2</B> (<I>malobei): ~i kontraŭ leĝo (regulo</I>). <B>~o</B>, affront, insult; illegal act, misdemeanour, transgression. <I>Kaŝi, pardoni, senti, venĝi ~on</I>. <B>~a</B>, insulting, abusive, cutting, offensive, opprobrious. <I>~a gusto (parolo</I>). <B>~iĝi</B>, be -ed (hurt, piqued, upset), get in a huff, take o. (exception, umbrage) (Mt 15/12). <I>Espereble vi ne ~iĝos, ke mi tion faris,</I> I hope you won’t mind (be hurt by) my doing that. <I>~iĝema</I>, touchy, apt to take o. <B>Sen~a</B>, harmless. ➞ <I>ĉagren, indigniĝ, insult, pik, ŝok, vund</I>.", "0"],
["ofensivo", "ofensiv-o", "(mil) offensive (aggressive) activity, attack. opposite <I>defensiv</I>.", "0"],
["oferi", "ofer-i", "[UV] Offer up, Sacrifice. <B>1</B> (rel) <I>~i bovon sur altaro</I>. <B>2</B> dedicate (devote) to, forego (without hope of return), give up (for service, use), resign one’s to parting with, surrender: <I>~i sian monon, sanon, tempon, vivon al (por) la homaro (patrujo</I>). [Ne= <I>donaci, oferti, proponi</I>]. <B>Rim</B>.: Oferi implies sacrifice or self-denial (Wm Bailey). <B>~(ad)o</B>, -ing, s., oblation. <I>Obeado estas pli bona ol ~ado. Tio postulas grandajn ~ojn de tempo kaj mono</I>. Brul~o, buĉ~o, farim-)~o (Am 5/22, 25). <B>Mon~o</B>, o-tory, alms, donation, subs- cription. <B>Pent~o</B>, expiation. <B>Sin~o</B>, personal devotion, self-s. <B>Trink~o</B>, <B>Verŝ~o</B>, drinking, libation. <B>~aĵo</B>, -ing, oblation, victim. <B>~ejo</B> (<I>altaro</I>), altar. <B>~ema</B>, devoted, generous, selfs-ing, unselfish. <I>~emo</I>, self-denial, self-s. <B>For~i</B>, give up, relinquish.", "0"],
["oferti", "ofert-i", "(<I>proponi</I>), (com) offer (tender) for sale or supply. <I>~o kaj postulo,</I> supply and demand.", "0"],
["oficiala", "oficial-a", "[F], Official, authorized, declared or done by competent authty, formal. <I>~a aldono, decido, dokumento, deklaro, gazeto</I>. <B>~e</B>, -ly. <B>~aĵo</B>, -ism. <B>~ema</B>, bossy, disposed to show one’s authty. <B>~igi</B>, -ize, appoint (No 3/10). <B>Duon~a</B>, <B>kvazaŭ~a</B>, semiofficial. <B>Ne~a</B>, unofficial. ➞ <I>ofic</I>.", "0"],
["oficinala", "oficinal-a", "(herb or drug), officinal, medicinal, used in art, pharmacy, or industry (K/233 footnote).", "0"],
["oficiro", "oficir-o", "[UV] (mil, mar), Officer. <I>Deĵora ~o</I>, o. of the watch. <I>Interrilata ~o,</I> liaison o.", "0"],
["ofico", "ofic-o", "[UV] Offic/e. <B>1</B> responsible occupation (post, rank, situation, sphere) of activity (employment, occupation, service, trust): <I>Akcepti, teni ~on. ~o de kasisto, ministro, pastor, urbestro. Grandaj ~oj, grandaj zorgoj. Senlabora ~o</I>, sinecure. <B>2</B> charge (duty, function) attaching to this: <I>Plenumi ~on</I>. <B>~a</B>, official. <I>~a vesto</I>, official attire (gown, robe, uniform, vestment). <B>~i</B> officiate, act (serve) as, discharge the duties of. <B>~eco</B>, -ialism. <B>~ejo</B>, [UV] office, bureau, place of business. <B>Poŝt-ejo</B>, P.O. <B>Vetur~ejo</B>, coach-o. <B>Vojaĝ~ejo</B>, travel bureau. <I>~ejestro</I>, head of o. <B>~isto</B>, [UV] officer, official, clerk, employee, functionary, o-holder, salesman, secretary, etc. <I>Poŝt~isto,</I> postal clerk or -ial. <I>Ŝtat~isto</I>, civil servant. <I>~istaro</I>, personnel, staff. <B>En~igi</B>, appoint, instal, put into o. <B>Sen~a</B>, out of employment (a post). ➞ <I>oficial</I>.", "0"],
["ofiklejdo", "ofiklejd-o", "(m.i.) ophicleide.", "0"],
["ofiogloso", "ofioglos-o", "adder’s tongue fern (<I>Ophioglossum</I>).", "0"],
["ofiono", "ofion-o", "ophion fly. ➞ <I>iĥneŭmon</I>.", "0"],
["ofiuro", "ofiur-o", "bristle-(sand-)star (<I>Ophiura</I>).", "0"],
["ofriso", "ofris-o", "bee (fly, spider) orchid (<I>Ophrys</I>).", "0"],
["ofseto", "ofset-o", "<B>~a</B>, (typ) offset. <I>Presi</I> ~e.", "0"],
["oftalmito", "oftalmit-o", "(<I>okulinflamo</I>), ophthalmia.", "0"],
["oftalmologio", "oftalmologi-o", "(<I>okulscienco</I>), ophthalmology.", "0"],
["oftalmoskopo", "oftalmoskop-o", "(<I>okulesplorilo</I>), ophthalmoscope.", "0"],
["ofte", "oft-e", "[UV] Oft(en), Frequen/tly, at short intervals, many times. <I>Li ~e skribas, venas</I>. <B>~a</B>, f-t, o-occurring, common, constant, habitual, repeated. <I>~a eraro, foresto, sperto</I>. <B>~aĵo</B>, common occurrence. <B>~eco</B>, frequency, prevalce. <B>Plej~e</B>, for the most part, mostly. (Pli)<B>~igi</B>, increase frequency. <B>~(iĝ)i</B>, be (become) f. <B>Mal~a</B>, rare, few and far between, scarce. <B>~~e</B>, rarely, seldom. <I>~~aĵo</I>, rarity. <I>~~igi</I>, curtail, cut down, restrict. <B>Ne~a</B>, in-f., uncommon. ➞ <I>abund, ĝeneral, komun, rar</I>.", "0"],
["ogivo", "ogiv-o", "[OA] (<I>pintarko</I>), (arch) ogive, ogee, Gothic arch. ~kruciĝo.", "0"],
["ogro", "ogr-o", "Ogr/e, child-eating giant. ~ino, -ess.", "0"],
["oho!", "", "(interj), oho! denotes surprise.", "0"],
["ojda", "-ojda", "(a. -<I>oida</I>), unofficial sfx, denotes unprecise resemblance (<I>=</I> <B><I>~eca</I></B><I>, -forma, -simila, -aspekta, -ŝajna</I>). Elips-(metal -ov-rim-romb-sfer-)ojdo, elipsoid, etc. ➞ -ed.", "0"],
["ojstro", "ojstr-o", "bot-fly, warble-fly (<I>Oestrus). ~a larvo</I>, bot.", "0"],
["ok", "", "[UV] Eight. <B>~a</B>, 8th (in order). <B>~e</B>, 8thly. ~ono, 1/8. (mus) (<I>~ona noto</I>) quaver. ~obla, 8-fold, octuple. ~dekjara, octogenarian. ~teto, octet. <I>PFX:</I> ok- = octa-, octo-. ➞ <I>okt(av</I>).", "0"],
["okapio", "okapi-o", "(zoo) okapi (<I>okapia</I>).", "0"],
["okarino", "okarin-o", "(m.i.) ocarina.", "0"],
["okazi,", "okaz-i,", "(nt) [UV] happen, Occur; befall, chance, come about (off, to pass), take place. <I>La edziĝo ~is hieraŭ. ~is nenio gram. ~is, ke</I>, it h-ed that. <B>~o</B>, [UV] Case, o-rence, event, incident: <I>Stranga ~o min trafis. En la plej bona ~o</I>, at the best. <I>En la ~o, se vi iros</I>, In c. you go. <I>Kion ni faru en tiu ~o?</I> <B>2</B> Opportunity, chance, circumstance: <I>Kapti, profiti, uzi la ~on</I>, seize the opportunity. <I>Li atendas, ke la ~o venu al lia nazo. Mi jam havis ~on vidi, ke...</I>. <B>~a</B>, [UV] accidental, casual, chance, for the moment, fortuituous. <I>~aj cirkonstanc-(vort-)oj</I>. <B>~e</B>, <B>1</B> on occasion: <I>Mi ~e uzos la permeson</I>. <B>2</B> on the occasion: <I>~e de la festo</I>. <B>3</B> as it h-ed, by chance, it h-ed that: <I>~e mi estis en Romo</I>. <I>Se ~e fariĝus</I>, if perchance it should h. [Ne= occasionally (<I>de tempo al tempo</I>)]. <B>~aĵo</B>, h-ing, o-rence, incident. <I>~intaĵo</I>, past event (Ge 22/1). ~ejo, scene of event. <B>~igi</B>, arrange, bring abt, cause, give rise to, occasion. <I>~igi kongreson, militon, morton</I>. ~onta, impending. ~oplena, eventful. Ali<B>~e</B>, otherwise. Blind<B>~e</B>, at random, haphazard. <B>Bon~a</B>, fortunate, lucky. <B>ĉiu~e</B>, at all events, in any c. <B>Kun~i</B>, coincide. <B>Laŭ~e</B>, as opportunity offers, as the c. may be, at need, if (when) required, on occasion. <B>Neniu~e</B>, in no c., on no account, under no circumstances. <B>Tiu~e</B>, if that is so, in that c. ➞ <I>event, fariĝ, hazard, incident, kaz, sane</I>.", "0"],
["okcidento", "okcident-o", "[UV] West, Occident. <B>~a</B>, w-ern, w-erly. <I>~a horizonto, lando. Sud~a vento</I>. ~en, w-wd. <B>~ano</B>, o-al.", "0"],
["okcipito", "okcipit-o", "occiput, back of skull. <B>~a</B>, -ital. ~osto.", "0"],
["okludi", "oklud-i", "(med) (met) occlude. <I>~ita fronto</I>. <B>~o</B>, occlusion.", "0"],
["okro", "okr-o", "(min) Ochr/e. Flava <B>~o</B>, yellow o. <B>~a</B>, -ous.", "0"],
["oksalido", "oksalid-o", "(bot) wood-sorrel (<I>Oxalis</I>). ➞ <I>okzal, trifoli</I>.", "0"],
["okshofto", "okshoft-o", "hogshead, large cask.", "0"],
["oksido", "oksid-o", "[OA] oxide. <B>~iĝi</B>, <B>~izi</B>, oxidize. <I>Per~o hidrogena</I>, (H<SUB>2</SUB>O<SUB>2</SUB>) hydrogen peroxide. <B>~~ulino</B>, platinum blonde. <B>Sen~igi</B>, scale, scour (metal).", "0"],
["oksigeno", "oksigen-o", "[UV] Oxygen (O). Combining form: oks-, e.g., oksid-o, <B>~igi</B>, <B>~iĝi</B>, <B>~izi</B>.", "0"],
["oksikoko", "oksikok-o", "[UV] Cranberry shrub (Vaccinium oxycoccus). <B>~a</B> bero, <B>c.</B> &lt; vakcini.", "0"],
["oktano", "oktan-o", "(chem) octane.", "0"],
["oktanto", "oktant-o", "octant. <B>1</B> 1/8th of circle. <B>2</B> instrument.", "0"],
["oktavo", "oktav-o", "[OA] (a. <I>okto</I>), (intvl) Octave. <B>~a</B>, of an o. <B>~oj</B> <I>kaŝitaj, sinsekvaj</I>.", "0"],
["oktavo", "oktav-o", "<B>~a</B>, (typ) octavo (8vo) = 8 leaves (16 pages) to a sheet. ~a <I>formato (paĝo</I>) (Rj 26/28). <B>Duon~o</B> (sixteenmo, 16mo), sexto-decimo.", "0"],
["Oktobro", "Oktobr-o", "[UV] October.", "0"],
["oktopodo", "oktopod-o", "octopus, octopod (➞ <I>polp</I>).", "0"],
["okulario", "okulari-o", "1 (<I>okulpeco</I>), (opt) eye-piece. <B>2</B> (phot) (<I>vidnivelilo</I>), view-finder.", "0"],
["okulo", "okul-o", "[UV] Eye. <B>1</B> (organ of sight): <I>~o blua, bruna, laca, ruĝranda, vitra. (Mal)fermi la ~ojn. Direkti la ~ojn al. Tio okazis antaŭ miaj ~oj</I>. <B>f</B> <I>Rigardi per amaj ~oj. ~oj pli grandaj ol la ventro. Inter kvar ~oj</I> (between you and me). <I>Ĉarmi la ~ojn. Bov~o</I>, bull’s-e. <B>2</B> attention, notice, observation: <I>Teni ~on sur</I>, keep an e. on. <I>Fermi (kovri) la ~ojn kontraŭ</I>, connive (wink) at, be blind to, shut one’s ee. to. <I>Malfermi la ~ojn</I>, <B>f</B> enlighten. <I>Salti al la ~oj</I>, be obvious. <I>Kie estas viaj ~oj?</I> 2 eye (<I> = truo): de hoko, kudrilo, martelo, ŝnuro;</I> hole (<I>en grujero, pano</I>). (bot) bud (<I>de planto), ~o de terpomo</I>. <B>~a</B>, eye-, ocular, ophthalmic, optic(al), <I>~a kavo, lenso, nervo. Sekvi (per</I>)<B><I>~e</I></B>, with the eye. <B>~(ad)i</B>, e., look at. <B>~eto</B>, -let, e.g., <I>de korseto, ŝuo</I>. <B>~isto</B>, -ist. <B>~umi</B>, make sheep’s eyes at, ogle. <I>~umaĉi,</I> leer. <I>Rigardi</I> <B>~angule</B>, cast a side-long glance at. ~globo (~pomo), e-ball. <B>~mezure</B>, at a glance. <B>~signi</B>, wink. <B>~videbla</B>, visible to the e. <I>Rigardi</I> <B>bon~e</B>, look favourably (<B>grand~e</B>, stare) at. Migdal <B>~a</B>, almond-d. Nigr<B>~a</B>, black-d. <B>Nud~e</B>, with the naked eye. Propr-e, with one’s own eyes. <B>Sam~e</B>, e. to e. <B>Sek~a</B>, dry-d. <B>Unu~a</B>, one-d. ➞ <I>har, iris, oftalm, palpebrum</I>.", "0"],
["okulta", "okult-a", "Occult, esoteric, hidden, secret; magic, mystic. <B>~o</B>, o. <B>~ismo</B>, <B>~isto</B>. ➞ <I>esoter, sekret</I>.", "0"],
["okupi", "okup-i", "[UV] Occup/y, Employ: <B>1</B> engage, fill, take up, use. <I>~i atenton, paĝon, spacon</I>. Last: <I>~i longan tempon, unu horon</I>. <B>2</B> hold, keep (<I>= teni en posedo). ~i lokon, postenon, pozicion</I>. <B>3</B> inhabit, reside in: <I>~i domon (ĉambron</I>). <B>4</B> give o-ation to, e.g., <I>~i la cerbon. Sin ~i pri</I>, carry on (<I>metion</I>). <B>5</B> (a. <I>ek~i) (= preni en posedon</I>), take possession of. <I>~i havenon, landon, urbon</I>. <B>~(ad)o</B>, o-ation. <B>1</B> business, calling, e-ment, pursuit, work (Ge 47/3; Pr 1/13). <I>Havi nenian ~on</I>, nothing to do. <I>Kantado estas agrabla ~o. ~o endoma</I> (sedentary). <B>Ŝat~o</B> (<I>hobio</I>), hobby. <B>2</B> possession, tenure. <I>Armeo de ~o</I>. <B>~anto</B>, o-ant(-ier), holder. <B>~ata</B>, <B>~ita</B>, o-ied, booked, busy (taken up) with, engaged upon; taken (<I>seĝo, telefonlinio). ~ateco,</I> e-ment, having one’s hands full. <B>~iĝi</B> <B>(sin ~i</B>) (<I>je, per, pri</I>), be busy (-ied) with, engaged (interested) in, go in for. <I>~iĝi pri arto. ~iĝo</I>, work (Ps 104/23). <B>Ne~ata</B>, uno-ied, free, vacant, at leisure. Antaŭ<B>~o</B>, pri-ation, prepossession. <B>Mal~i</B> (<I>evakui</I>), evacuate, leave free. <B>Sen~a</B>, at a loose end, out of work. <I>~~ateco</I>, leisure. ➞ <I>absorb, dung, kapt, posed, pren, ŝanĝ</I>.", "0"],
["okzalo", "okzal-o", "[UV] Sorrel (<I>Rumex acetosa</I>), <B>~ato</B>, oxalate. <B>~(at)acido</B>, oxalic acid. ➞ <I>oksalid, rumeks</I>.", "0"],
["ol", "", "[UV] (conj), Than. <B>1</B> (<I>mat) pli</I> more (less) than: <I>Ne pli frue</I>, not till, not before. <B>2 Antaŭ ~</B> before, ere (of time): <I>Antaŭ ~ vi venos</I>, before you come. <B>3</B> Other expressions of comparison or inequality: <I>Alia ~,</I> other than. <I>Ĉe ni oni ne kudras</I> alie, <I>~ per maŝino</I>, Here sewing is done only by machine, <I>Mi opinias</I> malsame ~ (from) vi. <I>Mi</I> preferas, (plivolas) <I>panon</I> ~ (to) <I>kukon</I>. Prefere ~ (rather t.) <I>fari tion</I>. <B>Rim</B>.: <I>Ol</I> before a clause is sometimes followed by <I>ke, kiam, kiel</I>, or <I>kiom</I>. <I>Estas al mi nenio pli bona, ~ ke mi foriru</I>. <B>4</B> <I>Pli granda estas mia puno, ~ kiom mi povos elporti</I> (Ge 4/13; ➞ 4 FA 153/21; 211/26, 28). <I>Ŝi estis alia, ~ kiel li ŝin imagis</I> (➞ 4 FA/51). But not always. <I>Ekzistas pli da aferoj, ~ instruas filozofoj</I> (H 29/23).", "0"],
["olda", "old-a", "= maljuna, malnova.", "0"],
["oleandro", "oleandr-o", "[OA] oleander (<I>Nerium oleander</I>).", "0"],
["oleastro", "oleastr-o", "oleaster (<I>Eleagnus angustifolid). ~a arbo</I> (Ne 8/15).", "0"],
["oleino", "olein-o", "(chem) olein.", "0"],
["oleo", "ole-o", "[UV] Oil. <I>Glata kiel ~o, ~o migdala, minerala, oliva, ricina</I>. <B>fiŝ~o</B> [UV]. <B>Ŝmir~o</B>, embrocation. <B>Viskoza ~o</B>, heavy oil. <B>f</B> <I>Verŝi ~on sur la ondojn</I>. <B>~a</B>, of oil. <I>~a pentraĵo</I>. <B>~eca</B>, oily, greasy, oleaginous. <B>~(iz)i</B> (<I>lubriki</I>), oil, grease, lubricate, impregnate with oil. <I>~i ĉarniron. maŝinon</I>. <B>~ilo</B>, oiler, grease-gun, lubricator. <B>~ujo</B>, oilcan, flask, sump. <B>~odona</B>, <B>~oporta</B>, oilbearing, oleiferous. <B>Sankt~i</B>, anoint with holy oil. <I>Lasta sankt~ado</I>, extreme unction.", "0"],
["olibano", "oliban-o", "frankincense (El 30/34; Mt 2/11). <B>~arbo</B> (Alt 4/14) (<I>Boswellia</I>).", "0"],
["oligarĥo", "oligarĥ-o", "[OA] (a. <B>oligark-o</B> [OA]), Oligarch. <B>~io</B>, [OA] -y.", "0"],
["olivo", "oliv-o", "[UV] Olive, fruit of <B>~arbo</B> (<I>Olea europaea</I>). <B>~(kultiv)isto</B>, o-grower. <B>~(kolor)a</B>, <B>~verda</B>, o-green. <B>f</B> <I>etendi la ~branĉon</I>, hold out the o-branch. <B>f ~branĉoj</B> (<I>= infanoj</I>) (Ps 128/3). <I>Monto</I> <B><I>~</I>arba</B> (Mt 26/30).", "0"],
["olo", "-olo", "(chem) -ol, ending for alcohol (-OH compound), e.g., <I>metanolo, etanolo. pentanolo</I>.", "0"],
["omaĝo", "omaĝ-o", "homage, acknowledgment of allegiance or superiority, dutiful reverence. <I>~i (-n</I>), do h. to.", "0"],
["Omano", "Oman-o", "OM, Oman.", "0"],
["omaro", "omar-o", "[UV] lobster (<I>Homarus</I>). ➞ <I>palinur</I>.", "0"],
["ombrelo", "ombrel-o", "[UV] Umbrella. <B>~ingo</B>, u-case. <B>~ujo</B>, u-stand. <B>Sun~o</B>, parasol, sunshade.", "0"],
["ombro", "ombr-o", "[UV] <B>1</B> Shadow: <I>Timi la propran ~on. Sekvi iun kiel lia ~o. La ~o de sunhorloĝo</I>. (astr) umbra, <B>f</B> (<I>ŝirmo</I>), protection, shade (Ps 17/8). <I>Sub la ~o de nia tegmento</I> (Ge 19/8). <I>Sidi en ~o (sin kaŝi</I>). <B>2</B> Dark part, shade: <I>La ~o de arbo. La ~oj de ĉambro, pentraĵo. Ĵeti ~on</I> (gloom) <I>sur la la feston (= super~i). Vivi en ~o</I> (retirement). <B>3</B> Darkness: <I>La ~oj de la nokto</I>. <B>f</B> <I>La ~o de la morto</I>. <B>4</B> ghost, shade, shadowy figure: <I>La lando de ~oj. Sxia ~o aperis al mi en la nokto. Ni salutas al lia ~o</I>. ➞ <I>fantom, reaperant, spirit</I>. <B>5</B> (<I>nuanco</I>): atom, ghost, hint, particle. <I>Sen ~o de danĝero, dubo, libereco, riproĉo, ŝanco, timo. Li estas nur ~o de si mem</I>. <B>6</B> simulacrum, something unsubstantial, unreal: <I>Kapti ~ojn</I>. <B>~(ec)a</B>, <B>~oza</B>, <B>1</B> -y, shady, umbrageous. <I>~a valo</I>. <I>dark, dim. <B>3</B> impalpable, intangible. <B>~i</B></I> (ĵeti ~on<I>) (Jes 4/6), shade, cast a shadow on; cloud, darken, dim; cover, screen, shelter</I>. <I>~i la palpebrojn. Avenuo ~ata de poploj; frunto … zorgoj. <B>~aĵo</B>, <B>~ejo</B>,</I> shady spot. <I>La tero ~igis (was overcast) de nuboj. (des) ~ostreki</I> (had), <I>shade. En~a temperaturo, in the shade. <B>Sen~a</B>, exposed. <B>Duon~o</B>, (astr) penumbra. <B>Tol~ilo</B>, awning. ➞ krepusk, mallum, nebul, nokt, nub</I>.", "0"],
["omento", "oment-o", "(anat) omentum, caul.", "0"],
["omleto", "omlet-o", "(cul) omelette.", "0"],
["omnibuso", "omnibus-o", "[OA] omnibus (col. abbreviation <I>buso). Hotela ~o. Tramvoja ~o</I>, tram car.", "0"],
["omo", "om-o", "(el) ohm, unit of resistance.", "0"],
["omo", "-omo", "(med, sfx), -ome, tumour of organic tissue.", "0"],
["on", "-on", "[UV] sfx denotes fraction. ~o (a. <I>frakcio</I>), Fraction, aliquot pt. <B>kvar~o</B>, [UV] quarter. Du tri~oj, 2/3. 1T Du~o de <I>[Ne</I> du~o da)] 6=3. 1T In 4 FA we find <B>du~o da</B> used before <I>animo</I> 119, 120; <I>horo</I> 180; <I>jaro</I> 92; <I>paĝo</I> 133; <I>tago</I> 188; <I>tombo</I> 120. These slips should not be followed as models: da precedes a word indefinite in amount (Vd <I>da</I>). <B>~a</B>, -al. Tri~e 6 = 2. <B>Dek~aĵo</B>, tithe. <B>~igi</B>, -alize. <B>Du~igi</B>, halve. <B>Du~fini</B>, half finish. <B>Po~e</B>, by halves.", "0"],
["on", "-on", "(ch sf) -one, denotes ketones (e.g., <I>propanono, butanono</I>).", "0"],
["onagro", "onagr-o", "onager (Bb wild ass) (<I>Equus onager</I>). ➞ <I>azen</I>.", "0"],
["onanismo", "onanism-o", "(med) onanism.", "0"],
["ondatro", "ondatr-o", "(<I>moskrato</I>), muskrat. (American musquash) (<I>Ondatra zibethiea</I>).", "0"],
["ondo", "ond-o", "[UV] Wave, billow. <I>~oj de la maro. Lum~o, son~o. Rul~o</I>, roller, (el, ph) <I>~o kurta (longa, mezlonga). ~o ebena</I>, plane w; <I>~o elektromagneta</I>, electromagnetic w; <I>~o laŭlonga</I>, longitudinal w. <B>3</B> w-like rise and fall, sweep, undulation. <I>~oj de flamo, varmo. Oraj ~oj de grenkampo</I>. <B>f</B> <I>~o da elokvento, entuziasmo, protesto</I>. <B>~(ant)a</B>, wavy, -like, rolling, undulating. <I>~a konturo, kresto, kurbo, linio, movo, trogo. Ataki, flui, rampi</I> <B>~e</B>, in waves. <B>~i</B>, rise and fall with w-like motion, break, fluctuate, heave, roll, swell, surge, undulate. <I>Indigno ~(ig)is en li</I>. <B>~ego</B>, bore, breaker. <I>~egi</I>, be rough, a heavy sea. <B>~ero</B>, -let, ripple. <B>~eroj</B> (<I>~ŝaŭmo</I>), spray, surf. <B>~umi</B>, w (hair). <B>~longo</B>, w-length. <B>~ŝvelo</B>, swell, surge. <I>La muziko nin</I> <B>ĉirkaŭ~is</B>. <B>Dis~o</B>, (mar) wake, wash. ➞ <I>bol, muar, surf, ŝaŭm, ŝvel</I>.", "0"],
["oni", "", "[UV] (pron) One, they, folks, people, men (in gen.). <I>~ tion diras, ~ diras, ke jes</I>, So it is said, so people (they) say, they say so. <I>Kion ~ diras?</I> What do people say? What are people saying? What is being said? <B>~diro</B>, (a piece of) hearsay, rumour, talk. <I>Kiam ~ estas riĉa(j</I>), When o. is (you are) rich. <I>Tion ~ faras ĉiutage</I>, That is done (we do that) every day. <B>Rim</B>.: The forms <B>onia</B>, <B>onin</B>, are good and logical, though not often used. <I>Se</I> <B>~a</B> (one’s) <I>patro venas al kaj batas</I> <B>~n</B>… .", "0"],
["onikso", "oniks-o", "[OA] onyx, vrty of silica. ➞ <I>agar, kalcedoni</I>.", "0"],
["onisko", "onisk-o", "(ent) woodlouse, slater (<I>oniscus</I>).", "0"],
["onklo", "onkl-o", "[UV] Uncle (brother of parent, husband of aunt). <B>~a</B>, avuncular. <B>~ino</B>, aunt. <B>~injo</B>, auntie. <B>Pra~o</B>, great-u.", "0"],
["onobriko", "onobrik-o", "[OA] (bot) sanfoin (<I>Onobrychis</I>).", "0"],
["onomatopeo", "onomatope-o", "(<I>sonimito</I>), onomatopoeia, e.g., <I>gugl, kluk, zum</I>.", "0"],
["onono", "onon-o", "rest-harrow (<I>Ononis</I>).", "0"],
["onopordo", "onopord-o", "(bot) Scottish or cotton thistle (<I>Onopordum</I>).", "0"],
["ont", "-ont", "[UV] ending of future active participle. <I>La ven~a monato</I>, the coming month. <B>Est~a</B>, coming, future. <B>Ir~a</B>, bound for (ship), off to. <B>Forir~e</B>, <I>li ploris</I>, before going away he wept. <I>Mi estis</I> skrib<B>~a</B>, I was about (just going) to write. <B>~eco</B>, future.", "0"],
["ontologio", "ontologi-o", "(phi) ontolog/y. <B>~a</B>, -ical.", "0"],
["oolito", "oolit-o", "(geol) oolite. <B>~a</B>, -ic.", "0"],
["op", "-op", "[UV] (sfx denotes) number of elements in a collectivity, = together, in group(s) of. <B>~a</B>, joint, collective. <B>~e</B>, collectively, en bloc, all together. <B>Unu~e</B>, one at a time, singly. <B>du~e</B>, [UV] in twos (pairs), two by two. <I>Akiro kaj perdo rajdas du~e</I> (together). <B>Kvin~e</B> (all five together, in a bunch of five) <I>Ili sin jetis sur min</I>. <B>Kiom~e</B>, How many at a time? <I>Venu</I> <B>mil~e</B>, Come in your thousands. <B>Tri~igita</B> <I>fadeno</I>, three-ply thread. <I>Verŝi</I> <B>gut~e</B>, drop by drop.", "0"],
["opalo", "opal-o", "[UV] Opal (amorphous vrty of silica). <B>~(ec)a</B>, -ine, -escence.", "0"],
["operacio", "operaci-o", "[OA] Operat/ion. <B>1</B> (surgical): ~a <I>labia (tekniko</I>). ~i (<I>fari ~on</I>), <B>~e</B>, perform an -ion. <B>~ato</B>, patient, <B>~anto</B>, <B>~isto</B>, -or. <B>~ejo</B>, -ing theatre, <B>~iloj</B>, surgical instruments. <B>2</B> action, proceeding, working; (com) transaction. <I>~oj financaj</I>. (mat) calculate; (mil) strategic movement of forces. <B>Post~a</B>, post-ional.", "0"],
["opero", "oper-o", "[OA] (<I>muzika dramo</I>), Oper/a. <B>~ejo</B>, o-house. <B>~eto</B>, -etta.", "0"],
["opilio", "opili-o", "(ent) harvestman (mite, tick) (<I>Opilio</I>).", "0"],
["opinio", "opini-o", "[UV] Opini/on. <B>1</B> personal view, idea, impression, mind, sentiment: <I>Kiom da kapoj, tiom da ~oj. Laŭ mia ~o (Mia ~o estas</I>), as it seems to me. <I>Eldiri sian ~on</I> (Ij 32/10). <I>Ŝanĝi sian ~on</I>, change one’s mind. <I>Afero de ~o</I>, disputable point. <I>Publika ~o</I>. <B>2</B> belief, conviction, tenet: <I>Agi laŭ (esti fidela at) siaj ~oj</I>. <B>3</B> (<I>takso</I>), estimate, judgment: <I>trovi bo nan ~on ĉe</I> (Se 3/4). <B>~i</B> (<I>-n</I>), be of (have) an o., believe, consider, hold, judge, opine, suppose, take it, think. <I>~i sin saga</I> (Se 3/7, Ij 32/1), be wise (righteous) in one’s own eyes. <I>~ata fidela</I>, counted faithful, reckoned reliable (Ne 13/13). <I>Obstina</I> <B>~ulo</B>, -ated (dogmatic) person. <B>Mia~e</B>, in my o., methinks, to my mind. <B>Sam~a</B>, like-minded. ➞ <I>juĝ, pens, rigard, ŝajn</I>.", "0"],
["opio", "opi-o", "[OA] Opium. <B>~a</B> <I>fumejo</I>, o-denotes <B>~aĵo</B>, opiate.", "0"],
["opolo", "opol-o", "(bot) guelder-rose, water-elder (<I>viburnum opulus) &lt; viburn</I>.", "0"],
["oponi", "opon-i", "Oppos/e, be against, object, raise an objection, resist, take the other side, withstand. <B>~o</B>, -ition, objection. <B>~anto</B>, -er, antagonist, opponent. <B>Sen~e</B> <I>akceptita</I>, carried nem. con. ➞ <I>opozici</I>.", "0"],
["opoponako", "opoponak-o", "(pharm) opoponax (<I>gum, rezin</I>).", "0"],
["oportuna", "oportun-a", "[UV] Convenien/t, Hand/y: commodious, easily usable, fitting (suitable, well adapted) for the purpose, serviceable. <I>~a apartamento, formo, momento, seĝo, tempo, vesto. ~a por tiu celo. ~a okazo</I>, suitable moment. ~e (<I>laŭ ~a maniero</I>), at one’s ease, c-ly, easily. <I>Kuŝi ~e sur la tablo. Subtenu la kruĉon, por trinki pli</I> <B>~e</B><I>. Fari al si</I> <B><I>~e</I></B>, make one’s comfortable. <B>~o</B>, c. state. <I>Favora ~o</I>. <B>~aĵo</B>, c-ce, gadget, etc. <B>~eco</B>, c-ce, h-iness; accessibility, practical utility. <I>~eco de breto, meblo, metodo</I>. <B>~ismo</B>, -isto, opportun-ism (time-serving), -ist. <B>Mal~a</B>, <B>Ne~a</B>, awkward, clumsy, ill-timed, incommodious, unadapted, unsuitable for the purpose. <I>Mal~a aranĝo (loko</I>). <B>Mal~i</B>, be in-c. (a nuisance, unwelcome). <B>~~aĵo</B>, drawback, difficulty, disadvantage, discomfort, inc-ce, snag. <I>~~igi</I>, hamper, impede, make in-c. ➞ <I>ĝustatemp, komfort, konven, okaz, tag</I>.", "0"],
["oposumo", "oposum-o", "oppossum fur. ➞ <I>didelf</I>.", "0"],
["opozicio", "opozici-o", "[OA] Opposition. <B>1</B> (pol) to government or party, <I>~o en la parlamento</I>. <B>~a</B>, in o. ~i (➞ <I>opon</I>), be in o. <B>2</B> (as, log), o.", "0"],
["optativo", "optativ-o", "[OA] (a. <I>volitivo</I>), (gram) optative mood. In Esp <I>U-modo</I>.", "0"],
["optiko", "optik-o", "[OA] Optic/s, study of light. <B>~a</B>, optic(al), visual. <I>~a nervo</I>, optic nerve. <I>~a fenomen-(iluzi-vitr-)o</I>, -al phenomenon (illusn, glass). <B>~isto</B>, -ian.", "0"],
["optimismo", "optim-ismo", "[OA] <B>-isto</B>, [OA] optim-ism, -ist. ➞ <I>rozkolor</I>.", "0"],
["opuntio", "opunti-o", "prickly pear cactus (many species) &gt; Indian fig (<I>Hinda figo) (O. ficus indica</I>). ➞ <I>nopal</I>.", "0"],
["orakolo", "orakol-o", "[UV] (myth) Orac/le. <B>1</B> divine communication (revelation). <B>2</B> its source (person, place, thing). <B>~a</B>, -ular, authtive, portentious, sage; ambiguous, obscure, mysterious. <B>~i</B> (<I>paroli ~e</I>), give a profoundly wise or mysterious utterance.", "0"],
["orangutan(g)o", "orangutan(g)-o", "(zoo) orang-utan (<I>Pongo</I>).", "0"],
["oranĝo", "oranĝ-o", "[UV] Orang/e, fruit of <B>~arbo</B>. <B>~o amara (maldolĉa)</B>, Seville or bitter o. (<I>Citrus aurantium</I>). <B>~o bergamota</B>, bergamot (C. <I>bergamia</I>). <B>~o dolĉa</B>, sweet (common) orange. (C. <I>sinensis</I>). <B>~(kolor)a</B>, orange. <B>Brun~a</B>, tawny. <B>~aĵo</B>, <B>1</B> drink. <B>2</B> o-marmalade. <B>~ejo</B>, o-orchard. ➞ <I>cedrat, citron, citrus, limed, limon, mandarin, pampelm, pomel, tangel</I>.", "0"],
["oratorio", "oratori-o", "(mus) oratorio,", "0"],
["oratoro", "orator-o", "[OA] Orator, Eloquent public speaker, <I>~o politika</I>. <B>~a</B>, -ical, rhetorical. <I>~a frazo, gesto</I>. <B>~i</B>, speak as an orator, deliver an oration. <B>~ado</B>, (<I>~a arto</I>), -y, public speaking. <B>~aĵo</B>, public discourse, eloquent language, harangue, oration. ➞ <I>elokvent, parolist</I>.", "0"],
["orbito", "orbit-o", "[OA] Orbit. <B>1</B> (astr) course of planet, etc. <I>Kalkuli la ~on de kometo</I>. <B>2</B> (anat) (<I>okulkavo</I>), eye-socket. <B>~a</B>, orbital. <B>f</B> <I>= agkampo, vidkampo, tereno</I>.", "0"],
["orbo", "orb-o", "(astr) orb.", "0"],
["ordeno", "orden-o", "[UV] <B>1</B> Order (of chivalry, merit, religion), company, fraternity. <B>2</B> its badge (cross, star, etc.): <I>~o de la krurzono, de la Kavaliroj de la Verda Stelo</I>. <B>~i</B> (<I>-n</I>), decorate (honour) with an order. <I>La Franca Ministro ~is Zamenhofon per la Honora Legio</I>.", "0"],
["ordinara", "ordinar-a", "[UV] Ordinary. <B>1</B> (<I>kutima</I>): accustomed, customary, established, regular, usual. <I>~a aspekto, rutino, vesto</I>. <B>2</B> (<I>normala</I>): commonplace, everyday, homely. <I>~a inteligento, mango, maniero, vivo. ~a homo</I>, common man. <I>~a</I> (vulgar) <I>frakcio</I>. <B>~e</B>, generally (habitally, usually). <I>Urbanoj estas ~e pli ruzaj, ol vilaĝanoj</I>. <B>~eco</B>, banality. <I>Torento de la ~eco</I> (4 FA 211/6). <B>~ulo</B>, an anybody, o. person. <I>~uloj,</I> rank and file. <B>Ekster~a</B>, <B>Ne~a</B>, extraordinary, exceptional, remarkable, surprising, uncommon unusual. <I>~~a elspezo, faro, sukceso, talent, vesto, vorto</I>. ➞ <I>ĝeneral, komun</I>.", "0"],
["ordinato", "ordinat-o", "(geom) ordinate.", "0"],
["ordini", "ordin-i", "(rel) ordain, consecrate for the ministry, confer holy orders. <I>~i pastron, episkopon</I>. <B>~(ad)o</B>, ordination. ➞ <I>konsekr</I>.", "0"],
["ordo", "ord-o", "[UV] Order. <B>1</B> Methodical (regular systematic) arrangement (disposition, interrelation) of affairs: <I>Ĉio estas en ~o. ~o de batalo, Diservo</I>. <B>2</B> fit condition, proper state: <I>Sen ~o en afero ne ekzistas prospero. Meti ~on ĉe la financoj. Publika ~o</I>. <B>3</B> manner of following, sequence, succession: <I>~o alfabeta, kronologia, numera</I>. <B>4</B> group in a classification: ~o <I>de arkitekturo</I>. (bot) (zoo) class. <B>~a</B> (<I>en ~o</I>), orderly. <B>1</B> methodical, regular, systematic: <I>~a aranĝo, maniero</I>. <B>2</B> peacable, quiet, well~ed: <B>Bon~e</B> <I>vestita,</I> neatly dressed. <I>~a ĉambro, tirkesto</I>. <B>(Laŭ)~e</B>, in due form and order, in good order. <B>~ema</B>, -ly, methodical, neat, tidy. <I>Esti ~ema ĝis pedanteco</I>. <B>~(ig)i</B>, draw up (put, set) in order, arrange, regulate, systematize, tidy. <I>~igi (siajn pensojn</I>), collect one’s thoughts, make (<I>liton</I>), lay (<I>tablon</I>). <B>Rim</B>.: Ĉe 3 FA 80/16, 144/26, Z. used ordi. <B>Kun~igi</B>, correlate, coordinate. <B>Ekster~a</B>, not in (out of) order. <B>Mal~o</B>, <B>dis~o</B>, confusion. <I>~~(em)a</I>, anyhow, harum-scarum, slovenly, untidy. <I>~~igi,</I> disarrange, throw into disorder, upset. <B>Sen~a</B>, untidy. <I>~~eco</I>, disarray. <I>~~iĝinta,</I> disordered, dishevelled. <B>Sub~o</B>, suborder. <I>~~igi,</I> subordinate. <B>Rang~o</B>, o. of precedence. <I>Transiri al la</I> <B>Tag~o</B> (o. of the day, agenda). <B>Vort~o</B>, order of words.", "0"],
["ordoni", "ordon-i", "(<I>-n</I>), [UV] Command, Order; bid, call upon, direct, instruct, tell to. <I>~u al li, ke li ne babilu. ~ita kiso havas guston maldolĉan</I>. <B>~o</B>, command, order, behest, bidding, injunction, mandate. <I>Laŭ ~o</I>, by order. <I>Obei ~on, La Dek ~oj</I>. <B>~a</B>, imperative. <I>~a rigardo, tono, vorto</I>. <B>~ema</B>, commanding, bossy, authorative, imperious, peremptory. <B>Tro~ema</B>, dictatorial, domineering, overbearing. <B>~itaĵo</B>, regulation. <B>Kontraŭ~i</B>, countermand. <B>Di~o</B>, <B>Moral~o</B>, commandment, precept. <B>Minac~o</B>, summons. ➞ <I>dekret, dikt, instrukci, komand, mend, reg</I>.", "0"],
["orelo", "orel-o", "[UV] Ear. <B>1</B> (anat) <I>Kapti iun je la ~o</I>. <B>f</B> <I>Streti la ~ojn. Nur vorton en via ~oj. Klini la ~on al peto</I>. <B>2</B> attention, hearing. <I>Venis al miaj ~oj, ke. La muroj havas ~ojn</I>. (mus) <I>Dresi la ~on. Havi bonan ~on</I>. (tech) <I>~o de kruĉo</I>. <B>~a</B>, aural, auricular. (<I>Per)~a lernado</I>. <B>~isto</B>, aurist. <B>~umo</B>, (telephone) ear-piece. <B>~forma</B>, ear-shaped. <I>Kanti</I> <B>laŭ~e</B>. <B>Long~a</B>, long-e. <B>Pend~a</B>, lop-eared. <B>Urs~o</B> (<I>aŭrikolo</I>). <B>~inflamo</B>, otitis.", "0"],
["orf(in)o", "", "[UV] Orphan. ~<B>(iĝint)a</B>, orphaned. <B>f</B> <I>La violono kuŝis</I> <B>~e</B> (forsaken) <I>sur la tablo</I>. <B>~ejo</B>, orphanage. <B>~igi</B> (<B>~iĝi</B>), bereave of (lose) one’s parents.", "0"],
["organdio", "organdi-o", "(tex) organdie, book (= fine translucent) muslin.", "0"],
["organika", "organik-a", "(chem) appertaining to an organism. <B>Ne~ika</B> (inorganic) <I>ĥemio</I>.", "0"],
["organismo", "organism-o", "[OA] Organism, organized body, (bio) living animal or plant. <I>La homa ~o</I>. ➞ <I>korp</I>.", "0"],
["organizi", "organiz-i", "(<I>-n</I>) [OA], Organiz/e, frame and put into working order. <I>~i instruon, komercon, kongreson, kurson</I>. Arrange for (get up) a common undertaking. <I>~i debaton, koncerton, societon. Altgrade ~ita,</I> highly -ed. <B>~(ad)o</B>, organization, -ing. <B>~(aĵ)o</B>, -ation, -ed body (society, system). <B>~isto</B>, -er. <B>Mal~i</B>, disorganize. <B>Re~i</B>, re-o. ➞ <I>aranĝ, establ, fond, instal</I>.", "0"],
["organo", "organ-o", "[OA] Organ. <B>1</B> (anat) (phys) (tech) part (means, medium) with a special function: <I>Okulo, la ~o de vido. ~oj de parolo, de lokomotivo</I>. <B>2</B> Medium of communcation, mouthpiece, (expressing the views of a group). <I>Tiu bulteno, gazeto estas la ~o de nia movado</I>. <B>3</B> (jur) (<I>regaj</I>) <B>~o(j)</B> <I>de societo, kompanio</I>. <B>~a</B>, organic, fundamental, inherent, structural. <I>~a difekto (malsano). Digesta</I> <B>~aro</B>, digestive system. <B>Sen~a</B>, without organs. ➞ <I>aparat, il, instrument, orgen</I>.", "0"],
["orgasmo", "orgasm-o", "(med) orgasm.", "0"],
["orgeno", "orgen-o", "[UV] (m.i.) Organ. <I>~o kineja, preĝeja, rektregistra, transregistra</I>. <B>~i</B>, play the organ. <B>~ejo</B> (<I>konzolo</I>), o-loft. <B>~isto</B>, -ist. <B>~meblaro</B>, o-chest. <B>Suĉ~o</B> (<I>suĉharmoniumo</I>), American organ. <B>Rim</B>.: Vd \"Muzika Terminaro\" p. 30 pri <I>klavaroj, kuplioj, pedalaroj, piŝto, registroj, sekcioj, tubo, vicoj</I>.", "0"],
["orgio", "orgi-o", "[OA] (<I>manĝa kaj trinka diboĉo</I>), orgy, carousal, drunken bout, licentious revel, <B>f</B> <I>~o de klaĉado</I>. ➞ <I>diboĉ</I>.", "0"],
["orgojlo", "orgojl-o", "= fieraĉo, arrogance. <B>~a</B>, bumptious, vainglorious.", "0"],
["oriento", "orient-o", "[UV] East, Orient. <B>1</B> (<I>sunleviĝejo</I>), compass direction. <I>Rigardi al la ~o</I>. <B>2</B> The East, O., part of earth e. of Europe. <I>Saĝuloj el la ~o. Ekstrema ~o,</I> far East. <B>~a</B>, eastern, easterly, oriental. <B>O~a Timor-o</B> TL. <I>~a klimato, kulturo, lingvo, popolo, stelo</I>. <B>~e</B>, in the e. <I>De</I> <B><I>~e</I></B>, from the e. <B>~en</B>, eastward. <B>~i</B> <I>mapon, preĝejon</I>, o-ate, build (set, turn) to face the e.; train (<I>pafilon</I>); trim (<I>velojn</I>). <B>~ado</B>, o-ation. <I>~ado (aspekto) de domo</I>. <B>~ano</B>, o-al. <B>~iĝi</B> (<I>sin ~i</I>), determine the direction to be followed, find one’s bearings (how one stands, where one is), get acquainted with a matter (place), learn how the land lies. <I>Sin ~i en arbaro, medio, nebulo, situacio</I>. <B>f</B> <I>Li ne povis ~iĝi</I>, he was all at sea, did not know where he stood, <B>~ilo</B>, compass or similar instrument. <B>Nord~a</B>, N.E.", "0"],
["orient(al)ismo", "orient(al)ism-o", "<B>~isto</B>, oriental/ism, -ist.", "0"],
["origano", "origan-o", "(bot) marjoram (<I>Origanum</I>).", "0"],
["originala", "original-a", "[OA] Original. <B>1</B> earliest, first, primitv: <I>~a form-(lingv-poem-tekst-)o. 2</I> one’s own, fresh, not copi-(imitat-translat -)ed, personal: <I>~a esprim-lide-manier-stil vest-)o</I>. <B>3</B> somewhat odd or strange, unusual: <I>~a hom-(paroi-manier-)o</I>. <B>~o</B>, 1 (object. or person), o., first form: <I>Traduko el la Franca ~o. Mi konas la ~on de tiu portreto. 2</I> model, pattern, type: <I>Kom- pari kopion kun la ~o</I>. ~e <I>verkita de,</I> o-ly composed by. <B>~eco</B>, -ity, freshness. <B>~ulo</B>, eccentric, person with character, (ideas) of his own. <I>Li estas vera ~ulo</I>. ➞ <I>aŭtent</I>. oriks-o, (zoo) oryx (<I>Oryx</I>).", "0"],
["origino", "origin-o", "[OA] Origin. <B>1</B> birth, descent, race: <I>Esti el nobela (slava) ~o</I>. <B>2</B> Fountain-head, root, source, spring, starting-point: <I>La ~o de la mondo (lia riĉo, nia scio</I>). <B>~a</B>, -al, innate, primary, root. <B>~e</B>, in o., -ally. ~i (<I>deveni</I>), -ate, emanate, spring, take rise. ➞ <I>gener</I>.", "0"],
["orikteropo", "orikterop-o", "aardvark (<I>Orycteropus</I>).", "0"],
["oriolo", "oriol-o", "(orn) (European) golden Oriole (<I>Oriolus</I>). (The American oo. are <I>Icterus</I>).", "0"],
["orkestro", "orkestr-o", "[OA] Orchestr/a, band. ~i (<I>arranĝi por o.</I>), -ate. <I>~i valson</I>. <B>~ado</B>, -ation. ~ejo, o. (place). ~estro, conductor of o. II (m.i.), ~iono, -ion, instrument giving impres sion of an o. <I>~iono vapora</I>, steam-o.", "0"],
["orkideoj", "orkide-oj", "[OA] (a. <I>orkidacoj</I>), the orchid fam. (e.g., <I>listero, neotio, ofriso</I>). An orkido, orchid (<I>Orchis</I>) (wide sense) is a typical member of the fam. A wild orchid is sometimes called an <I>orchis</I>.", "0"],
["orko", "ork-o", "grampus, killer whale (<I>Orcinus</I>).", "0"],
["orli", "orl-i", "(<I>kudri randrefalde</I>), Hem. <B>~o</B>, h. <B><I>Poŝtuko kun larĝa ~o</I></B>.", "0"],
["orlopo", "orlop-o", "(<I>~a ferdeko</I>), (mar), orlop deck.", "0"],
["ornami", "ornam-i", "(<I>-n</I>), [UV] Ornamen/t, adorn, beautify, (be)deck, embellish, smarten- <I>&lt; ~i tablon per floroj. Lukse (riĉe) ~ita &gt;</I> ornate. <I>Sin ~i</I>, adorn one’s, titivate. ~(aĵ)o&gt; -ation, adornment, embellishment, trimmg. <I>i~aĵoj sur kamenbreto. Vest~afoj</I>, dress trimmgs. (mus) grace-note. <B>~a</B>, -al, ornate. ~aĉi, bedizen, dress out gaudily. ~ado(~arto), decorative art. Mal<B>~i</B>, disfigure, spoil the look of. ~vestoj, finery. Ne~ita, Sen<B>~a</B>, homely, plain, unadorned. Flag~i <I>dom-(ŝip)on</I>, befiag, deck with flags.", "0"],
["ornato", "ornat-o", "ritual dress, official costume, (ecc) clerical robes (vestmts). <I>Pastroj en ~o</I> (4 FA 172/13).", "0"],
["ornitogalo", "ornitogal-o", "(bot) star of Bethlehem (<I>Ornithogalum</I>). ➞ <I>gage</I>.", "0"],
["ornitologo", "ornitolog-o", "[OA] <B>~io</B>, [OA] ornitholog-ist, -<B>y</B>.", "0"],
["ornitopo", "ornitop-o", "(bot) birdsfoot (<I>Ornithopus</I>). ➞ <I>lotus</I>.", "0"],
["ornitorinko", "ornitorink-o", "(zoo) duck-billed platypus, duck-mole (<I>Ornithoryncus</I>). orobank-o, (bot) broomrape (<I>Orobanche</I>).", "0"],
["orno", "orn-o", "flowering ash (<I>Fraxinus ornus</I>) &lt; fraksen.", "0"],
["oro", "or-o", "[UV] Gold (Au). <B>1</B> the metal. <I>Vazo el ~o</I>. <B>2</B> g-coins, <B>f</B> wealth. <I>Kiu havas ~on, havas honoron</I>. <B>f</B> <I>Koro, voĉo el ~o</I>. <B>~(kolor)a</B>, <B>~simila</B>, gold(en). <I>~a sablaro. (el oro): ~a medalo, ringo. (por ~o) ~a minejo</I>. <B>f</B> <I>~a jubileo</I>, golden jubilee (<I>50-jara datreveno). ~a mezo</I>, -en mean. <I>Promesi ~ajn montojn. ~a ŝlosilo (= mono). ~a epoko (tempo</I>), -en age. <B>~(iz)i</B>, <B>~tegi</B>, gild, plate with gold. <I>~ita</I> (gilt, gilded) <I>braceleto (kadro</I>). <B>~aĵo</B>, goldplate, goldware. <I>~aĵisto</I>, g-smith. <B>~eroj</B> (Ps 119/72). <B>~igi</B> (<I>~e briligi): la suno ~igis la fenestrojn, nubojn</I>. <B>~bataĵo</B>, <B>~folio</B>, goldfoil, goldleaf. <B>~briko</B>, <B>~bulo</B>, g-bar, ingot. <B>~hava</B>, <B>~riĉa</B>, auriferous. <B>~maso</B>, nugget. ➞ <I>baŭdruĉ, brokat</I>.", "0"],
["orografio", "orografi-o", "[OA] orography, geography of mountains.", "0"],
["orta", "ort-a", "(mat) erect, plumb, upright. <B>~igi</B>, square. ~ilo, set-(T-)square. ~(angul)o, right-angle.", "0"],
["ortodoksa", "ortodoks-a", "[OA] Orthodox. <B>1</B> in harmony with conventnl (correct, gen-ly accepted) opinion, sound in doctrine. <I>~a instru-(kred-verk-)o. 2</I> (rel) Eastern or Greek. <I>~a eklezio</I>. <B>~eco</B>, -y. <B>~ulo</B>, o. believer. Mal<B>~a</B>, heretical, heterodox, un-o.", "0"],
["ortografio", "ortografi-o", "[OA] (<I>literado</I>), orthography, correct or conventnl spelling. <I>~o fonetika</I>. <B>~i</B> (<I>literi</I>), spell. ➞ <I>kaligrafi, skribmanier</I>.", "0"],
["ortopedio", "ortopedi-o", "Orthopaed/ics, treatment of deformity. ~ia, -ic. <B>~o</B>, -ist. ortopter-oj, orthoptera (order of insects &gt; cockroaches, crickets, earwigs, grasshoppers, locusts, etc.).", "0"],
["os", "-os", "[UV] ending of future tense. Mi ir~, I shall go. Li ir~, he will go. -tempo, future tense.", "0"],
["oscedi", "osced-i", "[UV] <B>~o</B>, gape, open wide, yawn. <I>~anta abismo</I>.", "0"],
["oscili", "oscil-i", "(met, ph), Oscillat/e, swing like a pendulum, sway (to and fro), rock (<I>boato</I>). <B>f</B> vacillate, vary between extremes of action (opinion). <I>~anta nadlo de kompaso</I>. <B>~ado</B>, -ion. ~ilo, -or. -grafo. osmer-o, (ich) smelt, sparling (<I>Osmerus</I>). <B>osmi-o</B>, (chem) osmium (Os).", "0"],
["osmozo", "osmoz-o", "(ph) osmosis.", "0"],
["osmundo", "osmund-o", "(bot) royal fern (<I>Osmunda</I>).", "0"],
["osto", "ost-o", "[UV] <B>1</B> Bone. <I>Karno kaj ~oj</I>. <B>balen~o</B> [UV] (<I>barto</I>), whale-b. <B>Fiŝ~o</B>. Martel<B>~o</B>, malleus. Ŝultr<B>~o</B>, shoulder-b. <B>f</B> ~oj, remains. <I>2</I> something made from b., e.g., die, stay-rib. ~aro (<I>skeleto</I>), skeleton, frame. <I>~(ar)ejo</I>, charnel-house. <B>~(ec)a</B>, bony, osseous. ~ero, splinter. <B>~eto</B>, ossicle. <I>~etoj</I>, (gm) knuckle-bb. ~igi (~iĝi), ossify, make (become) rigid, <B>f</B> become callous, unprogressive. ~ito, osteitis. ~opatio, osteopathy, b-setting. ~opato, osteopath. <B>Ĝis~ulo</B>, Esp-ist faithful to the Fundamento. <B>Ĵet~o</B>, lud<B>~o</B>, die. ~rompo, fracture.", "0"],
["ostracismo", "ostrac/ism-o", "[OA] Ostrac/ism. <B>~izi</B>, -ize, banish (exclude) from favour (privileges, society), cold-shoulder, send to Coventry.", "0"],
["ostro", "ostr-o", "[UV] Oyster (<I>Ostrea</I>). ~ejo, o-bank (-bed). Perl~o.", "0"],
["ot", "-ot", "[UV] ending of future passive participle. Daŭrig<B>~a</B>, to be continued. Juĝ<B>~o</B>, prisoner at the bar.", "0"],
["otario", "otari-o", "(<I>marleono</I>), sea-lion, eared-(fur-)seal (<I>Otaria</I>). ➞ <I>fok</I>.", "0"],
["otiso", "otis-o", "(orn) Bustard (<I>Otis</I>). Granda <B>~o</B>, great b. Malgranda <B>~o</B>, little b.", "0"],
["otomano", "otoman-o", "ottoman, cushioned seat without back or arms.", "0"],
["otuso", "otus-o", "(orn) scops (long-eared) owl (<I>Otus scops</I>).", "0"],
["ovacio", "ovaci-o", "[OA] ovation, enthusiastic reception, spontaneous applause.", "1"],
["ovalo", "oval-o", "[UV] Oval. <B>~a</B> (<I>ovoforma</I>), o. ➞ <I>elips</I>.", "0"],
["ovario", "ovari-o", "ovary.", "0"],
["ovibovo", "ovibov-o", "musk-ox (<I>Ovibos</I>).", "0"],
["ovo", "ov-o", "[UV] Egg, ~o de birdo, fiŝo, insekto, Teni ĉiujn ~ojn en unu korbo. Demeti ~on, lay an egg. (cul) ~o boligita, fritita, kirlita, poĉita; mole kuirita.<I> <B>~aĵo</B>, e-dish &gt;</I> omleto.<I> <B>~aro</B>, clutch, sitting. ~ingo, e-cup. <B>~ujo</B>, [UV] e-basket. ➞ ovari</I>.<I> <B>~ojda</B>, <B>~oforma</B>, e-shaped, oval, ovate, ovoid. ➞ oval</I>.<I> <B>~naska</B>, oviparous. <B>El~igi</B> (~iĝi), hatch out</I>.", "0"],
["ovolo", "ovol-o", "(bot) ovule.", "0"],
["ovumo", "ovum-o", "(bot) (zoo) ovum.", "0"],
["oza", "-oza", "(unofficial sfx), -ous. <B>1</B> (-<I>hava, -plena, -riĉa; kun-a</I>), abounding in, containing, full of. Argil<B>~a</B>, kalk<B>~a</B>, por~a. Ŝton~a <I>kampo</I>, field full of stones. (➞ ŝtoneca, of a stony nature). 11 Confine to material, technical, sense, e.g., glora, ĝoja (not gloroza, ĝojoza). 11 <B>2</B> (chem) -ous. Fer~a <I>klorido (sulfato</I>). <B>3</B> -ozo, (hort) (mec) (unofficial sfx), -osis, denotes disease caused or characterized by, e.g., Bakteri<B>~o</B>, Pedik<B>~o</B>, Tuberkul~o.", "0"],
["ozono", "ozon-o", "[OA] Ozone (O<SUB>3</SUB>). <B>~igi</B>, -ize, convert to ozone. <B>~igilo</B>, -izer.", "0"],
["pacienco", "pacienc-o", "[UV] Patien/ce. <B>1</B> calm endurance (resignation), quiet perseverance (waiting). <I>Per ~o kaj fervoro sukcesas ĉiu laboro</I>. <B>2</B> (cgm) p. <B>Longe~a</B>, <B>Multe~a</B>, patient, forbearing, long-suffering, resigned, unrepining, slow to anger (Jona 4/2, Na 1/3). <B>~e</B>, -tly. <I>Atendu ~e!</I> <B>~e!</B> <B>~on!</B> Patience! <B>~i</B> (<I>esti ~a, havi ~on</I>), be -t, have p. (GD 49/27). <B>~ulo</B>, -t person. <B>Mal~a</B>, <B>sen~a</B>, impatient, hasty, testy.", "0"],
["paciento", "pacient-o", "[OA] (<I>kuracato</I>), patient (under med. treatment).", "0"],
["pacifismo", "pacif-ismo", "[OA] <B>-isto</B> [OA] = pac-ism-ist-o.", "0"],
["paco", "pac-o", "[UV] Peace. <B>1</B> freedom from war. <B>2</B> Calm, quiet, tranquillity. <I>Iru en ~o. ~o al lia cindro! ~o kun honoro</I>. <B>~a</B>, peaceful, of peace. <I>~a atmosfero, sceno, vivo</I>. <B>~e</B>, peacefully, in p. <I>~e kunvivi</I>. <B>~ama</B>, <B>~ema</B>, -able, p-loving, mild, pacific, placid. <B>~igi</B>, appease, conciliate, pacify, placate, smooth down (Se 16/7). <I>~iga</I>, conciliatory. <I>~iganto</I>, p-maker. (<I>Inter</I>)<B><I>~</I>iĝi</B>, become reconciled, make it up. <B>~ismo</B>, <B>~isto</B>, pacif-ism, -ist. <B>~(em)ulo</B>, man of peace. <B>Mal~o</B>, broil, conflict, contention, discord, dissention, quarrel, strife. <I>Naski</I> (<I>semi</I>) <I>~~on. Konsento konstruas, ~~o detruas. ~~i</I>, be at strife (variance), disagree. <I>~~ema (virino</I>), brawling, contentious (Se 21/9, 19). <I>~~eto</I>, tiff. <I>~~igi</I>, cause strife. embroil, set at loggerheads. <I>~~iĝi</I>, fall out, quarrel. ➞ <I>disput, kverel, milit</I>. <B>Sen~a</B>, agitated, restless. ➞ <I>akord, kalm, konkord, kviet, seren, trankvil</I>.", "0"],
["paĉulo", "paĉul-o", "[OA] patchouli. <B>1</B> Indian plant (<I>Pagostemon</I>). <B>2</B> perfume from this.", "0"],
["padelo", "padel-o", "(<I>plataĵo, tabuleto</I>), Paddle, blade (of oar, mill- paddle- wheel). <B>~i</B>, p., dabble, splash abt (with fingers or feet), ➞ <I>pagaj, vad</I>.", "0"],
["pado", "pad-o", "(<I>piedvojeto</I>), path, footway, track. <I>Milita ~o</I>, war-p. Sen<B>~a</B>, p-less.", "0"],
["paduso", "padus-o", "bird cherry, hagberry (<I>Prunus padus</I>). ➞ <I>ĉeriz, prun</I>.", "0"],
["pafi", "paf-i", "(<I>-n, al; kontraŭ</I>), [UV] fire, shoot, project a missile. <I>~(mortig)i birdon (leporon). ~i kuglon, sagon, ŝtonon</I>. <B>f</B> <I>~i la aeron (vane labori). ~i per la okuloj. ~i sin for (subite malaperi</I>). <B>~o</B>, discharge, shot. <B>Paf!</B> Bang! (K 72/28). <B>~ado</B>, [UV] <B>~aro</B>, firing, cannonade, volley. <I>~ado unuopa, multopa</I>. <B>~ejo</B>, firing ground, shooting gallery (range). <I>Raketoj</I> <B>~iĝis</B> <I>alten</I>. <B>~ilo</B>, [UV] gun, etc. <B>Aer~ilo</B>, airgun. <B>Blov~ilo</B>, blow-pipe. <B>Krak~ilo</B> (popgun) (3 FA 68/18). <B>Meĉ~ilo</B>, matchlock. <B>Piz~ilo</B>, pea shooter. <B>Maŝin~ilo</B>, machine-gun. <B>Pulvo~ilo</B>, firearm. <B>Ripet~ilo</B>, repeating rifle. ➞ <I>pafark, fusil, karaben, mitral, revolver</I>. <B>~ileto</B>, tiny gun. <B>~ilego</B> [UV] (<I>kanono</I>), cannon. <B>~isto</B>, gunner. <B>Ark~isto</B>, <B>Sag~isto</B>, (astr) Sagittarius, <B>~lertulo</B>, good shoot, marksman. <B>Ek~i</B>, discharge (gun). <B>Mis~o</B>, bad shoot, misfire. <B>Preter~i</B>, overshoot (the mark). <B>Mort~i</B>, shoot dead. ➞ <I>fusil, katapult, pistol, revolver</I>.", "0"],
["pagajo", "pagaj-o", "Paddle (for canoe). <B>~i</B>, (ply a) p. <I>Remi du~e,</I> double-paddle. ➞ <I>padel</I>.", "0"],
["pagano", "pagan-o", "pagan, heathen. <B>~ismo</B>.", "0"],
["pagelo", "pagel-o", "(ich) common sea-bream (<I>Pagellus</I>). ➞ <I>bram</I>.", "0"],
["pagi", "pag-i", "(<I>-n, al, por</I>) [UV], Pay. <B>1</B> pay for, bear (defray) the cost of: <I>~i por fremda festeno. ~i salajron. ŝuldon</I>. <B>2</B> Remunerate, reward: <I>~i kelneron, kreditoron. Oni ne pagas per gloro al sia tajloro</I>. <B>f</B> <I>~i mokon per moko</I> (K 166/34). <I>~i (puni) al iu ofendon</I>. <B>3</B> be punished: <I>Kiu rompis, tiu ~u. ~as maljunaj jaroj por junaj eraroj</I>. <B>~o</B>, pay, payment, discharge, reward. <I>Kia ago, tia pago</I>. <B>Jar~o</B>, yearly payment. <B>Kluz~o</B>, lock fee. <B>Kont~o</B>, payment of a/c. <B>Labor~o</B>, remuneration. <B>Part~o</B>, instalment, -ment on a/c. <B>Pek~o</B>, wages of sin. <B>Plen~o</B>, -ment in full. <B>Port~o</B>, carriage, porterage. <B>Poŝt~o</B>, postage. <B>Tro~o</B>, excess -ment. <B>~e</B>, in payment. <B>~anto</B>, payer. <B>~ato</B>, payee. <B>~ebla</B>, -able, that can be paid, <B>~enda</B>, -able, due, that must be paid. <I>~endiĝi</I>, fall due, mature. <B>~igi</B>, charge. <B>~ilo</B>, means of -ment. <B>~isto</B>, payclerk, paymaster, cashier, purser. <B>Al~o</B>, <B>krom~o</B>, bonus, excess, extra. <B>Antaŭ~o</B>, <B>Antaŭ~i</B>, prepay: <I>~i abonon (de gazeto, de poŝtelefonaj servoj</I>). <I>~~ita telefonkarto</I>. <B>de~o</B>, [UV] charge, deduction, duty. <B>El~i</B>, pay up, discharge, settle (square) in full. <B>En~i</B>, pay in. <B>Ne~ita</B>, in arrears. <I>Ne~itaĵo</I>, arrears. <B>Re~i</B>, repay, pay back, reimburse, <B>f</B> <I>Re~o,</I> reprisal, retaliation, retribution. <B>Sen~a</B>, free, gratis, gratuitous, for nothing. <I>Sen~a eniro, ~a laboro, ~a (senkosta) komputila programo</I>. <B>Trans~i</B>, transfer (funds). <B>Tro~i</B>, overpay. ➞ <I>fri, honorari, kost, salajr</I>.", "0"],
["pagodo", "pagod-o", "[OA] (arch) pagoda.", "0"],
["pagofilo", "pagofil-o", "(<I>ebura mevo</I>), ivory gull (<I>Pagophila</I>).", "0"],
["paguro", "pagur-o", "edible crab (<I>Cancer pagurus</I>).", "0"],
["paĝio", "paĝi-o", "[UV] page. <B>1</B> youth in livery, buttons. <I>Armila ~o</I>, knight’s armour-bearer, squire. <B>2</B> (cgm) jack, knave.", "0"],
["paĝo", "paĝ-o", "[UV] Page (of book). <B>1</B> Side of leaf. <I>Libro cent~a. ~o maldekstra, para</I>, L.H. (even) p. <I>~o dekstra, nepara</I>, R.H. (odd) page, recto. <B>2</B> part of book or history. <I>Bela ~o en mia vivo</I>. (en)~igo, ~numerado, ~preparo, paging, make-up, pagination. <B>Front~o</B>. <B>Prov~o</B>, specimen p. <B>Titol~o</B>.", "0"],
["pajaco", "pajac-o", "Fool, buffoon, clown, jester. <B>~aĵo</B>, f-ish trick, tomfoolery. ➞ <I>klaŭn, histrion</I>.", "0"],
["pajlo", "pajl-o", "[UV] Straw. <I>Hakita p.</I>, chaff. <I>~o tritika. Garbo el ~o</I>. <B>~a</B>, (of) s. <I>~a lito,</I> pallet. <I>~a matraco</I>, palliasse. <B>~aĵo</B>, kuŝ<B>~o</B>, litter (for stable). ~ero, a s. ~homo, dummy. ~kolora, s-colored. ~reta (<I>seĝo</I>), s-bottomed. ➞ <I>fojn, stak</I>.", "0"],
["pajnto", "pajnt-o", "pint (measure).", "0"],
["paki", "pak-i", "(<I>-n</I>), [UV] Pack, put together in bag (box, bundle), stow, tie (up), wrap. <I>~i varojn</I>. <B>f</B> <I>Stari prem~itaj en lifto</I>. <B>~(ad)o</B>, packing. <B>~(aĵ)o</B>, bale, bundle, pack(age), parcel. [N<I>e = parcelo</I>], <B>Man~aĵo</B>, hand luggage. <B>Rul~aĵo</B>, roll, scroll. <I>~aĵejo,</I> parcels office. <B>~aĵaro</B>, baggage, luggage. <B>~ejo</B>, -ing room. <I>~(aĵ)eto</I>, packet. <B>~isto</B>, -er. <B>~umo</B> (<I>~materialo</I>). <B>El~i</B>, <B>En~i</B>, <B>Kun~itaj</B> (Ho 13/12). <B>Mal~i</B>, unpack. <B>Ne~ita</B>, <B>Sen~a</B>, higgledy-piggledy, loose. ➞ <I>fask, sendaĵ</I>.", "0"],
["pakidermo", "pakiderm-o", "pachyderm.", "0"],
["pakiso", "pakis-o", "pack-ice. ➞ <I>bankis</I>.", "0"],
["Pakistano", "Pakistan-o", "[OA-8] PK.", "0"],
["pakto", "pakt-o", "(pol) pact, agreement, covenant.", "0"],
["pala", "pal-a", "[UV] Pal/e. <B>1</B> colourless, pallid, wan. <I>~a vizaĝo, ~a de kolero, timo</I>. <B>2</B> dim, dull, faint, weak. <I>~a bildo, koloro, lumo</I>. <B>~eco</B>, -lor. <B>~ega</B>, (<I>mort~a</I>), deathly (ghastly) p., livid. <B>~eta</B>, -ish. <B>~igi</B>, <B>~iĝi</B>, [UV] pale, fade, <B>~blua</B>, p. (light) blue. <B>Mal~a</B>, dark, deep (in colour). <B>Ne~iĝonta</B>, fast-dyed. ➞ <I>griz, malfort, seninteres, senviv</I>.", "0"],
["palaco", "palac-o", "[UV] Pala/ce. <B>~a</B>, -tial.", "0"],
["paladio", "paladi-o", "(chem) palladium (Pd).", "0"],
["palankeno", "palanken-o", "[OA] palanquin, covered litter for one.", "0"],
["palatalo", "", "(phon) palatal (<I>j, nj</I>).", "0"],
["palato", "palat-o", "[UV] Palat/e. <B>1</B> roof of mouth (Ps 137/6, Ij 12/11, Alt 2/3). <B>2</B> taste. <B>~a</B>, -al.", "0"],
["Palaŭo", "Palaŭ-o", "PW.", "0"],
["paleo", "pale-o", "(bot) palea, chaff-like bract or scale.", "0"],
["paleo", "paleo-", "palaeo-, (Gk <I>pfx = pratempa</I>).", "0"],
["paleocena", "paleocen-a", "palaeocene.", "0"],
["paleografio", "paleografi-o", "[OA] <B>paleograf-o</B>, [OA] palaeograph-y, -ist.", "0"],
["paleontologio", "paleontologi-o", "[OA] <B>paleontolog-o</B>, [OA] palaeontolog-y, -ist.", "0"],
["paleozoika", "paleozoik-a", "palaeozoic.", "0"],
["paletro", "paletr-o", "[UV] (painter’s, surgical) pallette.", "0"],
["palia", "pali-a", "Pali (language).", "0"],
["paliativo", "paliativ-o", "Palliative, temporary expedient. <B>~a</B>, p., alleviating (without curing), extenuating, mitigating.", "0"],
["palimpsesto", "palimpsest-o", "palimpsest.", "0"],
["palindromo", "palindrom-o", "palindrome (<I>Frazo inversigebla</I>), e.g., <I>Madam, I’m Adam. A man, a plan, a canal~~Panama</I>.", "0"],
["palinuro", "palinur-o", "[OA] spiny lobster, sea crayfish (<I>Palinura</I>). ➞ <I>langust</I>.", "0"],
["palisandro", "palisandr-o", "[OA] rosewood (from <I>jakarando). ~a tablo</I> (M 226/24).", "0"],
["paliso", "palis-o", "[UV] Pal/e, piece of wood stuck in the ground, pile, post, stake (of fence), stave (of <I>arbkorseto</I>), (hop) pole, (pea) stick. ~o <I>sekiga</I>, clothes-prop. <B>~aro</B>, -isade, fence. <I>Flor~eto</I> (<I>stameno</I>). <B>~umi</B>, impale. <B>Al~igi</B>, prop, stick, stake, support, (pea, vine, etc.). ➞ <I>lign</I>.", "0"],
["palmipedoj", "palmiped-oj", "(<I>~opieduloj</I>), -ipeds.", "0"],
["palmita", "", "<I>acido</I>, -itic acid. <I>~itato</I>, -itate.", "0"],
["palmo", "palm-o", "[UV] Palm (tree), <B>f</B> crown of victory, prize, trophy. ~a <I>branĉo. ~a dimanĉo, festo</I>, P. Sunday.", "0"],
["palpebro", "palpebr-o", "[UV] eyelid. <B>~a</B>, palpebral. <I>En ~uma daŭro</I>, in the twinkling of an eye. <B>~umi</B>, [UV] <B>1</B> blink, quiver (of flame). <B>2</B> (<I>okulsigni</I>), wink. <I>~i per unu okulo</I>. <B>~ito</B>, blepharitis. ➞ <I>okulum</I>.", "0"],
["palpi", "palp-i", "[UV] (<I>tuŝesplori</I>), Feel, Touch, finger, handle. <I>La blindulo ~is la libron</I>. ~i <I>per bastono. ~i al iu la pulson. Mi ne amas la ~ojn</I> (being mauled about), <B>f</B> <I>sian vojon</I>, feel one’s way, grope, proceed cautiously. <B>~(ad)o</B>, -ing. <B>~e</B>, by the feel, by touch. <B>~ebla</B>, palpable, tangible, <B>f</B> <I>~ebla mallumo</I> (El 10/21). <B>~ilo</B>, f-er, antenna, (rad) cat’s whisker. <B>~sento</B>, sense of t. <B>Ĉirkaŭ~i</B> (<I>~e serĉadi</I>), fumble (poke) about, grope after, rummage. <B>Fuŝ~i</B>, dabble, mess about, monkey with, tamper. <B>Fingro~i</B>, prod. ➞ <I>dab, sent, tuŝ</I>.", "0"],
["palpiti", "palpit-i", "Palpit/ate, beat rapidly, flutter, go pit-a-pat, pulsate, throb. <B>~ado</B>, -ation.", "0"],
["palto", "palt-o", "[OA] great-(over-top-)coat. <I>Pilot~a</I> pilot coat. ➞ <I>mantel, supervest, surtut</I>.", "0"],
["palumbo", "palumb-o", "kolombo arbara (ringa), Wood pigeon, ring dove (<I>Columba palumbus</I>).", "0"],
["palustro", "palustr-o", "(<I>marĉa pino</I>), long-leaf pine (Pinus palustris).", "0"],
["pamfleto", "pamflet-o", "[OA] lampoon, (small treatise, usually libellous, satirical, or scurrilous, attacking someone or something), pamphlet (in this sense only). <B>~isto</B>, -eer. ➞ <I>broŝur, paskvil</I>.", "0"],
["pampelm(us)o", "", "shaddock (<I>Citrus grandis Linn</I>). ➞ <I>pomel</I>. <B>Rim</B>.: This is larger than the grapefruit, and slightly pear-shaped.", "0"],
["pampo", "pamp-o", "pampas (S. American vast treeless plain).", "0"],
["panaceo", "panace-o", "panacea, cure-all, universal remedy.", "0"],
["panako", "panak-o", "(bot) panax. ➞ <I>ginseng</I>.", "0"],
["Panamo", "Panam-o", "[OA-8] PA.", "0"],
["panariso", "panaris-o", "(<I>absceseto</I>), felon, whitlow. <I>Bova ~o</I>, bovine panaris.", "0"],
["pandiono", "pandion-o", "(<I>fiŝaglo</I>), osprey, fishing eagle, fish-hawk (<I>Pandion haliaetus</I>) (Le 11/13). ➞ <I>haliaet</I>.", "0"],
["pando", "pand-o", "(zoo) panda, bear-cat. <B>~o giganta</B>. <B>~o ruĝa</B>.", "0"],
["panegiro", "panegir-o", "panegyric, encomium, laudatory discourse. <B>~a</B>, eulogistic.", "0"],
["panei", "pane-i", "break down, be stuck (at a standstill). <B>~o</B>, break-down, mishap; (el) failure; (mot, ry), trouble (engine, etc.). Sen <B>~igi</B>, repair and get going again.", "0"],
["panelo", "panel-o", "[OA] Panel (surface section). <I>~o de pordo, muro, vesto</I>. (mot) dashboard. <I>Reklama ~o</I>, hoarding. <B>~i</B>, dado, wainscot. <B>~aĵo</B>, -ling, wainscotting.", "0"],
["paniklo", "panikl-o", "(bot) panicle, loose compound inflorescence, e.g., of oat.", "0"],
["paniko", "panik-o", "[OA] <B>~i</B>, Panic, infectious fright, scare. ~(ec)a, -y, easily dismayed. ➞ <I>alarm</I>. <B>2</B> millet grass (<I>Panicum) &gt;</I> common or Indian m. (<I>P. miliaceum</I>); little m. (<I>P. miliare</I>).", "0"],
["pankreato", "pankreat-o", "(anat) Pancrea/s, sweetbread. ~a <I>suko</I>, -tic juice.", "0"],
["pano", "pan-o", "[UV] Bread. <I>~o blanka, bruna, freŝa, sekala, tutgrena. Buter~o</I>, b. and butter. <I>Rost(ita)~o, toasto</I>, toast. <I>~o de propono,</I> shew-b (El 25/30). <B>f</B> food, means of livelihood. <I>Viv~o</I> (~o <I>ĉiutaga</I>), daily bread. <I>Espero ~on ne donas. Karesu per pano</I> (P). <B>~ero</B> (<B>~peceto</B>), crumb, morsel. <I>Plata</I> <B>~eto</B>, scone, etc. <I>Blank~eto</I> (El 16/31.) <B>~isto</B>, baker. <B>~ujo</B>, b-bin, b-pan. <B>~tranĉ(aĵ)o</B>, slice of b. (K 82/23).", "0"],
["panoplio", "panopli-o", "(mil) panoply, suit of armour.", "0"],
["panoramo", "panoram-o", "[OA] Panoram/a. <B>f</B> continuous passing scene, unbroken view of surrounding region. <I>Vasta ~o prezentiĝis al ni</I>. <B>~a</B>, -ic.", "0"],
["pansi", "pans-i", "(<I>-n</I>), Dress (<I>vundon</I>). <B>~aĵo</B>, -ing. ~bendo, bandage. ~pakaĵo, first-aid packet. ➞ <I>desinfekt, fleg</I>.", "0"],
["pantalono", "pantalon-o", "[UV] (pair of) trousers (American pantaloons). ~o <I>ĝissura</I>, jeans. <B>~eto</B>, shorts. In<B>~o</B>, (woman’s) slacks. <B>Sub~o</B>, drawers, panties, pants. ➞ <I>kulot</I>.", "0"],
["panteismo", "pante-ismo", "[OA] <B>~isto</B>, [OA] (phil) pantheism, -ist.", "0"],
["panteono", "panteon-o", "pantheon.", "0"],
["panteroj", "panter-oj", "[UV] the large cats &gt; jaguar, leopard, lion, ounce, tiger.", "0"],
["pantoflo", "pantofl-o", "[UV] Slipper. <B>~ulo</B>, stay-at-home. ➞ <B><I>sandal, ŝu</I></B>.", "0"],
["pantografo", "pantograf-o", "pantograph (<I>aliskala</I> <B>kopiilo)</B>.", "0"],
["pantomimo", "pantomim-o", "[OA] pantomime, dumb show. ➞ <I>mimik</I>.", "0"],
["panuro", "panur-o", "bearded tit (reedling) (<I>Panurus biarmicus</I>). ➞ <I>paru</I>.", "0"],
["papago", "papag-o", "[UV] Parrot (many species) <B>f ~(um)i</B>, repeat like a parrot. <B>~eto</B>, parakeet. ➞ <I>melopsit, psitak</I>.", "0"],
["papajo", "papaj-o", "(bot) papaw, fruit of S. American tree (<I>Carica papaya</I>).", "0"],
["papavo", "papav-o", "[UV] poppy (<I>Papaver). ~o opia</I>. <B>~acoj</B>, the p. fam.. <B>~eto</B>, (<B>~o grenkampa</B>), com (field, red) p. ➞ <I>kelidoni</I>.", "0"],
["papero", "paper-o", "[UV] <B>~a</B>. Paper. <B>1</B> material: <I>meti plumon al ~o</I>. <I>~o cigareda, karbona, letera, muŝa, paka, paŭsa, skriba, ŝmirga, tapeta</I>. <B>Impres~o</B>, sensitized p. <B>Sabla</B> <B>~o</B>, sand-p. <B>Sorba ~o</B>, blotting-p. <B>Vitro~o</B>, glass-p. <B>2</B> document, certificate, deed, etc. <B>~oj</B> <I>komercaj, personaj</I>. <B>sen~ulo</B>, person without passeport, legal documents, illegal immigrant. <I>~a mono</I>, p-money, bills, drafts, notes. <B>~aĉo</B>, waste-p. <B>~eca</B>, papyraceous. <B>~ujo</B>, portfolio, etc. ➞ <I>biletuj, tek</I>. <B>~farejo</B>, p-mill. <B>~folio</B>, leaf, sheet. <B>~vendejo</B>, stationer’s shop. <B>Sur~a</B>, on p., in writing. ➞ <I>celuloz, papirus, pergamen, tapet. [Ne= gazeto, ĵurnalo]</I>.", "0"],
["papilio", "papili-o", "[UV] Butterfly. <B>Brasika ~o</B> (<I>pierido</I>), cabbage (white) b. <B>Hirund-vosta ~o</B> (<I>makaono</I>). Sulfura <B>~o</B>, brimstone b. <I>Flirtema kiel</I> ~o. <B>f</B> (<I>neserioza, malkonstanta</I>), fickle, flighty, inconstant. <B>~e</B> (<I>senatente) tralegi libron. Nokta (krepuska) ~o</I> (ordinary language <I>faleno</I>), moth. ➞ <I>lepidopter</I>.", "0"],
["papilionacoj", "", "(bot) papilionaceae, peaflower fam..", "0"],
["papilo", "papil-o", "(bot) (ent) papilla. <B>~a</B>, -ate.", "0"],
["papiruso", "papirus-o", "[OA] papyrus. <B>1</B> paper reed (<I>Papyrus</I>). <B>2</B> leaf from this.", "0"],
["papo", "pap-o", "[UV] (rc) Pop/e. <B>~a</B>, papal, pontifical. <B>~ano</B>, <B>~isto</B>, papist, <B>~eco</B>, <B>~ismo</B>, -ery, papacy. <I>~eca</I>, -ish. ➞ <I>pop</I>.", "0"],
["papriko", "paprik-o", "(col) paprica. ➞ <I>kapsik</I>.", "0"],
["PapuoNovGvineo", "Papuo-Nov-Gvine-o", "PG.", "0"],
["papuso", "papus-o", "(<I>akena tufo</I>), (bot) pappus, down, e.g., <I>leondenta ~o</I>, dandelion clock.", "0"],
["parabolo", "parabol-o", "[OA] <B>1</B> (geom) Parab/ola. ~ojdo, -oloid. <B>2</B> (rh) parab/le (Mi 2/4, Jeh 17/2, Mt 13/3), continued simile with moral; short allegory. <B>~a</B>, <B>1</B> -olic. <B>2</B> figurative. ➞ <I>alegori, komparaj, similig</I>.", "0"],
["paradi", "parad-i", "[UV] Parade. <B>1</B> (mil) (assemble for) Review. <B>2</B> march on p. <B>3</B> air, flaunt, display ostentatiously, show off. <I>~i en nova kostumo. ~i sian eruditecon</I>. <B>~o</B>, <B>1</B> r., inspection, muster, tattoo. <B>2</B> pageant, pompous procession. <I>Festa ~o</I>. <B>3</B> display, ostentation, show. <B>~a</B>, p., show, state. <I>Kuŝi sur ~a lito</I>, lie in state. <I>~a marŝo,</I> march past. <I>~a uniformo</I>, full dress. <B>~e</B>, showily. <I>Ŝi estis en sia plej bona ~aĵo,</I> dressed in her best (4 FA 28/6). <B>~ejo</B>, (<I>~a placo</I>), p-ground. <B>~ema</B>, ostentatious. <B>Sen~a</B>, simple, unostentatious. ➞ <I>dand, pav, strut</I>.", "0"],
["paradigmo", "paradigm-o", "[OA] (gram) paradigm, table of forms.", "0"],
["paradizo", "paradiz-o", "[UV] Paradise. <B>1</B> (<I>~a ĝardeno</I>), garden of Eden. <B>2</B> (<I>feliĉejo</I>), abode of the blest, heaven, <B>f</B> state of supreme bliss (delight). <B>~a</B>, of P., blissful. <B>~a birdo</B>, bird of P. (<I>paradizeo</I>). ~a fiŝo, P. fish (<I>makropodo</I>).", "0"],
["paradokso", "paradoks-o", "[F], Paradox, seeming absurdity or self-contradiction. <B>~a</B>, -ical. <I>Festina lente\\</I> Ij 22/6, Mt 16/25, 2 Ko 12/10, 1 Tm 5/6.", "0"],
["parafino", "parafin-o", "[OA] Paraffin. <B>1</B> (a. <I>alkano</I>), (chem) general name for hydrocarbons of series C<SUB>n</SUB>H<SUB>2n+2</SUB>, and especially. <B>2</B> (<I>parafina vakso</I>), solid p., candle-grease. <B>~a kandelo</B>, wax candle, (med) <I>likva ~o,</I> liquid p. ➞ <I>kerosen, lampole, petrol</I>.", "0"],
["parafo", "paraf-o", "[OA] paraph, flourish after signature. <I>~i sian subskribon</I>.", "0"],
["parafrazo", "parafraz-o", "[OA] paraphra/se, free rendering (amplification) of passage. <B>~a</B>, -stic, diffuse. <B>~i</B>, p., express meaning more fully in other words.", "0"],
["paragrafo", "paragraf-o", "[OA] <B>1</B> Paragraph, distinct section (of page, marked by indentation of first line). <B>2</B> (<I>~a signo</I>), (typ) section mark (IT). ➞ <I>aline</I>.", "0"],
["Paragvajo", "Paragvaj-o", "[OA-8] PY.", "0"],
["parakleto", "paraklet-o", "(rel) paraclete, advocate (Joh 14/16, 26).", "0"],
["paralakso", "paralaks-o", "(astr) parallax, apparent displacement by change of view-point.", "0"],
["paralela", "paralel-a", "Parallel. <B>1</B> continuously equidistant. <I>~aj linioj, stratoj, surfacoj</I>. <B>2</B> precisely analogous (collateral, corresponding): <I>~aj kolumnoj (tekstoj</I>). <B>3</B> (<I>samtempa): ~a propagando</I>. <B>4</B> (mus) (<I>samdirekta). ~a movo</I>, p. motion. <I>Uzadi Esp-on</I> <B>~e</B> <I>kun la gepatra lingvo. Uzi formon novan ~e kun formo malnova</I>. <B>~o</B>, p. (<I>~o de latitudo</I>), analogue, counterpart, correlative. ~oj (sp) (<I>paralelaj baroj</I>). (typ) reference mark (II). <B>~aĵo</B>, p. passage. ➞ <I>analog, egal, simil</I>.", "0"],
["paralelismo", "paralelism-o", "parallelism.", "0"],
["paralelogramo", "paralelogram-o", "[OA] parallelogram.", "0"],
["paralelopipedo", "paralelopiped-o", "(geom) parallelopiped.", "0"],
["paralizi", "paraliz-i", "(<I>-n</I>), Paral/yse, benumb, deaden, <B>f</B> cripple, render powerless. <I>La skismo ~is la movadon. Timo ~is liajn fortojn</I>. <B>~(itec)o</B>, -ysis, palsy, utter powerlessness. <B>Infana ~o</B> (<I>poliomjelito</I>). <B>~o tremiga</B>, Parkinson’s disease. <B>~a</B>, -itic, -ysing. <B>~ita</B>, -ysed, impotent, palsied. <I>~ita brako</I>. <B>~ito</B>, <B>~ulo</B>, -itic, person sick of the palsy.", "0"],
["paranojo", "paranoj-o", "Parano/ia, mental illness characterized by systematic delusions. <B>~a</B>, <B>~ulo</B>, -ic.", "0"],
["parapeto", "parapet-o", "(<I>randmureto</I>), parapet. <B>1</B> breast-wall, balustrade, railing, at edge of a height, or side of bridge. <B>2</B> (mil) breastwork, battlement.", "0"],
["paraplegio", "paraplegi-o", "paraplegia, paralysis of lower limbs. <B>~ulo</B>.", "0"],
["paraŝuto", "paraŝut-o", "(<I>falŝirmilo</I>), Parachute. <B>~i</B>, p. <B>~isto</B>, -ist.", "0"],
["parazito", "parazit-o", "[UV] Parasit/e, plant or animal living in or on another, e.g. <I>visko, pulo</I>. <B>f</B> hanger-on, sponger, toady. <B>~a</B>, -ic. <B>~i</B>, sponge, live on others. <B>~icido</B>, <B>~ismo</B>, -ism. <B>~ologio</B>.", "0"],
["parcelo", "parcel-o", "allotment (holding, lot, parcel, patch, plot, small portion) of land (Ru 2/3, Jos 17/5, Jes 5/10). <I>[Ne= pakaĵo]</I>. <B>~i</B>, allot, apportion, divide into lots, parcel (portion) out (land).", "0"],
["pardalo", "pardal-o", "(<I>panterkato</I>), ocelot (<I>Felis pardalis</I>).", "0"],
["pardoni", "pardon-i", "(<I>-n; al, ke</I>) [UV], Forgive, Pardon (person, fault, offence); make allowance for, excuse, overlook, pass over, (jur) absolve, let off, remit. <I>ion al iu (iun pri io). ~u al ni niajn pekojn, ŝuldojn. ~u, ke mi venis malfrue</I>. <B>~o</B><I>,</I> p., forgiveness, remission. <I>Peti ~on (de</I>), apologise to, ask p. of, beg pardon. <I>~u (min)!</I> Excuse me! (apology for action, dissent, inattention). <B>~ebla</B>, <B>~inda</B>, pardonable, excusable, venial. <B>~ema</B>, f-ing, clement, indulgent, merciful. <B>~(em)igi</B>, appease, placate, propitiate. <I>~igu min ĉe</I>, make my excuses to. <B>~peto</B>, apology. <B>Ne~ebla</B> (<I>krimo</I>), unforgivable. <B>Ne~ema</B>, implacable, rancorous, relentless. <B>Ĉio~a</B>, all f-ing.", "0"],
["parenco", "parenc-o", "[UV] (<I>samfamiliano</I>), Relat/ion, -ive; kinsman. <I>~o per Adamo. Plej proksima ~o</I>, next of kin. <I>Korpo~o</I> (Le 18/6). <B>~a</B>, -ed. germane. <I>~a lingvo, Movado, organizo</I>. (mus) <I>C maj. kaj A min. estas tonaloj ~aj</I> (relative maj. and min.). <B>~aro</B>, relatives, family, kindred, kith and kin. <B>~eco</B>, affinity, kinship, relatioship. <B>~ino</B>, kinswoman. <B>~iĝi</B>, ally one’s by marriage. <B>Bo~iĝi</B> <I>kun</I>, marry into the fam. of. <B>Sen~a</B>, without kith or kin. ➞ <I>afin, famili, gepatr, rilat</I>.", "0"],
["parentezo", "parentez-o", "[UV] Parenthe/sis. <B>1</B> word (clause, sentence) inserted into another passage. <B>2</B> <I>~oj</I>, round brackets ( ). <B>~i</B>, insert as p. <B>~a</B>, -tic. <B>~e</B>, in p., by the way. ➞ <I>kramp</I>.", "0"],
["parfumo", "parfum-o", "[UV] Perfum/e. <B>1</B> Sweet Smell, fragrance. <B>2</B> s-sing substance, fluid containg essence of flowers. <B>~i</B> (<I>-n</I>), impregnate with p. <I>~i poŝtukon. Haroj ~itaj</I> (M 89/19). <B>~aro</B>, -ery. <B>~ejo</B>, -ery shop, <B>~isto</B>, er. <B>~ujo (~boteleto)</B>, scent-bottle.", "0"],
["pargeto", "parget-o", "[UV] Parquet, inlaid wooden floor(ing). <B>~aĵo</B>, -ry, inlaid flooring. <I>Vaksita ~o</I> (M 127/25). <B>~ero</B>, piece, slab. <B>~isto</B>, -ry worker. ➞ <I>marketr</I>.", "0"],
["parietario", "parietari-o", "(bot) pellitory of the wall (<I>Parietaria</I>).", "0"],
["pario", "pari-o", "<B>1</B> (mec) inner side (wall) of surface. <I>~o de cilindro, kavaĵo, tendo, tunelo, tubo, vazo</I>. <B>2</B> (anat) wall,e.g.,<I>de stomako</I>. <B>~a</B>, parietal. <B>3</B> (a. <I>pariao</I>), pariah, low-caste, <B>f</B> social outcast. ➞ <I>vand</I>.", "0"],
["parizeto", "parizet-o", "(bot) herb Paris (<I>Paris</I>).", "0"],
["parkere", "parker-e", "[OA] (memore), By Heart (memory, rote). <B>~e</B> <I>reciti, scii</I>. <B>~i</B> (<I>-n</I>) (<I>lerni ~e</I>), learn b.h., commit to memory, memorize. <B>~ita</B> respondo. <B>~ado</B>, -ing.", "0"],
["parko", "park-o", "[UV] Park. <B>1</B> pleasure ground. <B>2</B> similar enclosure. <B>3</B> (mot) (a. <I>~ejo</I>), -ing ground. <B>~i</B> <I>aŭton</I>, p. a car.", "0"],
["parlamento", "parlament-o", "[OA] Parliament, legislative assembly. <B>~a</B>, -ary. -ano, M.P. <B>~ejo</B>, House of P. <B>~ismo</B>, -arianism.", "0"],
["parnasio", "parnasi-o", "(bot) grass of Parnassus (<I>Parnassia</I>).", "0"],
["paro", "par-o", "[UV] (<I>duopo</I>), Pair, brace, couple, set of two. <B>1</B> (used together): <I>~o da botoj, gantoj, okuloj</I>. <B>2</B> (of same species): ~o <I>da bovoj, ĉevaloj</I>. <B>3</B> (mated): <I>~o geedza. Bela ~o por altaro</I> (P). <B>~a</B>, even, fellow, matching, of a p. <I>~aj kolonoj (nombroj</I>). <B>~e</B> (<I>duope</I>), in pp (couples), <B>~eco</B>, parity, equivalence, correspondance. <B>~igi</B>, p., arrange in couples, match, mate, unite. <I>~igisto (svatisto</I>), go-between. <B>~iĝi</B>, p. off. (sp) <B>~ulo</B>, partner. <B>Ne~a</B>, not a pair, odd, uneven.", "0"],
["parodio", "parodi-o", "[OA] parody, humorous imitation, \"take-off\", travesty. ➞ <I>burlesk, travesti</I>.", "0"],
["paroĥo", "paroĥ-o", "[UV] Parish (eccl. district). <B>~a</B>, parochial, <B>f</B> petty, narrow, provincial. <I>~a preĝejo</I>, p-church. <B>~ano</B>, -ioner. <B>~estro</B>, incumbent, rector, vicar. <I>~estrejo</I>, manse, parsonage, rectory, vicarage. <I>Sub~estro (vikario</I>). <B>~ismo</B>, -ialism.", "0"],
["paroksismo", "paroksism-o", "[OA] Paroxysm, fit, seizure, sudden attack, throe (of disease, pain); outburst (of laughter, rage). <I>~o de histerio</I>. <B>~a</B>, -al. ➞ <I>konvulsi, kulmin, spasm</I>.", "0"],
["paroli", "parol-i", "(-n, <I>al, kun, pri</I>) [UV], Speak, Talk. <I>~i la veron. ~u al mi. Pensu, antaŭ ol ~i. ~i Angle, flue, laŭte</I>. <B>f</B> <I>Siaj okuloj ~is pri amo. La faktoj ~as por si mem</I>. <B>~o</B>, 1 (act) speech, utterance, words spoken: <I>De ~o ĝis faro estas malproksime. Ĉu pri tio estis la ~o?</I> Is that what they were t<B> ing</B> about? <I>Sen ~o pri la hundo</I>, to say nothing of the dog. <I>~oj glataj</I>, fair wrds. <I>Intermiksitaj ~oj</I>, confused t. <B>f</B> <I>Mi donas al</I> vi <I>la ~(permes)on. Al ŝi mankis la ~(pov)o</I>. <B>2</B> parole, word of honour: <I>Doni sian ~on</I>. <B>~a</B>, oral, verbal. <B>~e</B>, by word of mouth. ~aĉi (Ps 59/7) <B>~ado</B>, <B>1</B> s-(t-)ing. <I>Tro multa ~ado min lacigas</I>. <B>2</B> <I>~(ad)o,</I> discourse, harangue, speech. <I>Fari ~(ad)on pri la temo. ~adi</I>, hold forth, <B>~anto</B>, s-er. <B>~ejo</B>, parlour, etc. <B>~ema</B>, loquacious, t-ative. <B>~egi</B>, pour out a torrent of words. <I>Laŭt~</I><B>ilo</B>, loud-speaker.", "0"],
["paronimoj", "paronim-oj", "(rh) paronyma (<I>vortoj distingendaj = aspekte similaj, sence malsamaj</I>) (e.g., <I>desert-dezert, pes-pez, organ-orgen, ros-roz</I>). ➞ <I>homonim</I>.", "0"],
["paronomazio", "paronomazi-o", "jingle, play on words of similar sound (e.g., <I>near and dear</I>) (Ho 2/5; Pr 2/17). ➞ <I>paronim, vortlud</I>.", "0"],
["parotido", "parotid-o", "parotid gland. <B>~ito</B> (a. mumpso), mumps.", "0"],
["partenogenezo", "partenogenez-o", "(bio) parthenogenesis.", "0"],
["partero", "parter-o", "[UV] <B>1</B> (th) parterre, pit. <B>2</B> (hort) (<I>florbedejo</I>).", "0"],
["participo", "particip-o", "[UV] Particip/le. <B>~a</B>, -ial. partikul-o, particle, (gram) short indeclinable wd. (ph) atom. ➞ <I>eret</I>.", "0"],
["partio", "parti-o", "[UV] Part/y, Side. <B>1</B> (pol) camp, faction: <I>La Liberala ~o. Reganta ~o</I>, p. in power. <B>2</B> p. in the case (contract, dispute, sport): <I>Plenda ~o</I>, plaintiff. <B>~a</B>, [UV] p. <I>~a gazeto</I>. <B>f</B> -isan, biassed, ones-ed, prejudiced, prepossessed. <B>~ano</B>, -isan, advocate, follower, p-member, upholder. <I>~ano de ideo, persono, sistemo; de la reĝo</I> (on the king’s s). <I>~aniĝi</I>, s. with. <I>Mi estas ~ano de</I> (am all for). <B>~estro</B>, leader. <B>Ekster~a</B>, independent. <B>Sen~a</B>, non-p., fair, free from bias, impartial, (pol) Du~a, tri~a, bi-(tri-)partite. <B>Sam~ano</B>. ➞ <I>antaŭjuĝ, koteri, lud, partizan, tendar, tendene</I>.", "0"],
["partituro", "partitur-o", "[OA] (mus) Score. <I>~o kunpremita (piana</I>), short s. <I>~o orkestra (plena</I>), full s. <I>~o voĉa</I>, vocal s.", "0"],
["partizano", "partizan-o", "= gerilo. ➞ <I>partian</I>.", "0"],
["parto", "part-o", "[UV] Part. <B>1</B> division, piece, portion, section: <I>~o de la korpo, mondo</I>. <B>2</B> (<I>elemento</I>), component part: <I>~o de parolo</I>. <B>3</B> (<I>rolo</I>), function, portion allotted (assigned), share: (th) character, role. <B>4</B> (mus) melody for voice or instrumt: <I>~kanto</I>, part-song. <B>5</B> side in dispute. <B>~a</B>, part(ial), incomplete. <I>~a eklipso</I>. <B>~e</B>, partly, in part. <B>~eto</B>, -icle. <B>~igi</B>, <B>~iĝi</B>, part, divide into parts, separate. <I>~igi la harojn</I>. <B>~umo</B> = frakcio. ➞ <I>divid, fend</I>. <B>Ali~e</B>, on the other hand. <B>Antaŭ~o</B> (<I>~kastelo</I>), (mar) forecastle, (mus) <B>Du~a</B> <I>formo,</I> two-part form. <B>Mia~e</B>, as far as I am concerned. <B>Pago~o</B>, quota, share. <B>Pied~o</B> <I>de kuŝejo</I> (Rut 3/4). <B>Plej~e</B>, for the most part, mainly, mostly. <B>Po~e</B>, by instalnts. ➞ -er, <I>fragment, kajer, parti, porci</I>. Opp <I>tut</I>.", "0"],
["paruo", "paru-o", "[UV] (orn) (tom) Tit, titmouse (<I>Parus</I>). <B>Blua ~o</B>, blue-t. <B>Granda</B> <B>~o</B>, great t. <B>Nigra</B> <B>~o</B>, coal t. <B>Longvosta</B> <B>~o</B>, long-tailed t. <B>Salika</B> <B>~o</B>, willow t. <B>Tufa</B> <B>~o</B>, crested t.", "0"],
["parvenuo", "parvenu-o", "(<I>elsaltulo</I>), parvenu, upstart.", "0"],
["pasaĝero", "pasaĝer-o", "[OA] passenger (by public conveyance). <I>~a ŝipo</I>. ➞ <I>vetur, vojaĝ</I>.", "0"],
["pasakaglio", "pasakagli-o", "(mus) passacaglia.", "0"],
["pasamento", "pasament-o", "[UV] trimming of gold and silver lace, beads, thread (for clothes); braid, gimp (for furniture). ~i (<I>seĝori</I>), braid (edge of chair). <B>~aĵo</B>, braid (ing), lace trimming(s). <B>~isto</B>, [UV] dealer in (or, maker of) this. ➞ <I>galon, punt</I>. pase-o (<I>istempo, malfuturo, pasinteco</I>), (gram) the past.", "0"],
["pasero", "paser-o", "[UV] Sparrow (Mt 10/29). Doma <B>~o</B>, house s. Monta <B>~o</B>, tree s. Rok~o (<I>petronio</I>), rock s. <I>Gi estas kvazaŭ ~o en la aero (projekto efemera</I>). ➞ <I>niz, pronel</I>.", "0"],
["pasi", "pas-i", "[UV] Pass. <B>1</B> (nt) (<I>= forpasi</I>): pass away, be spent, disappear, elapse, vanish. <I>Jam ~is du jaroj. Kio ~is, ne revenos. La okazo jam ~is. La tempo ~is tro rapide. La pluvo ~is kaj malaperis</I> (Alt 2/11). <B>2</B> (<I>transiri): ~i de ruĝo al verdo. ~i al alia afero. ~i de morto en vivon</I> (Jn 5/24). <B>3</B> (<I>preteriri</I>): pass by; go past, leave behind or on one side, move onward to another place. <I>~i la pordon (= preter la pordo). Lasu min ~i</I>, let me pass. <I>~as super ĝi vento</I> (Ps 103/16). <I>~i renkonte</I>, encounter, meet and p. on. <B>~e</B>, <B>~ante</B>, in passing. <B>f</B> by the way, incidentally. <B>~(ad)o</B>, -age, -ing, course, expiration, lapse (<I>de tempo). Post ~o de jaro</I>. <B>~aĵo</B>, event, occurrence, situation (Rz 77/5): (lit mus) passage (M 30/20). <B>~anta</B> <I>nubo</I>, -ing cloud. <B>~anto</B>, -er-by. <I>~antaĵo</I>, temporary affair. <B>~ejo</B>, pass(age), gangway. <B>~ema</B>, ephemeral, evanescent, fleeting, transient. <I>~ema ĝojo,</I> <B>~igi</B> (<I>-n</I>), p., spend, use. <I>~igi la ferion, nokton, tempon. Tempo~igilo</I>, distraction, pastime. <B>~inta</B>, bygone, past. <I>~inta doloro,</I> for el memoro. <I>~interjectionaraj neĝoj,</I> snows of yesteryear. <B>~intaĵo</B> (<B>~inteco</B>), the past. <B>For~i</B>, pass away (Mat 5/18). <B>Preter~i</B> (Rut 4/1), pass by (over); bypass, disregard, overtake. <B>Tra~i</B>, p. along (through); traverse. <I>~~i krizon, pordon, fajron, kaj akvon. ~~ejo</I>, ford. <B>Trans~i</B>, p. across (over), cross. <I>~~i limon (rubikonon</I>). <B>f</B> (<I>superi</I>): exceed, go beyond, outstrip, overstep, surpass. <I>~~i komprenon. ~~i de averto al ago. ~~ejo</I>, p., -age through, defile, thoroughfare. <B>Flank~i</B>, outflank. <B>Frot~i</B>, <B>Puŝ~i</B> brush (push) p. <B>~bileto</B>, <B>~permeso</B>, p., permit, safe-conduct. <B>~movo</B> (football), p. ➞ <I>flu, glit, kur, paŝ; sukcesi (ĉe ekzameno</I>).", "0"],
["pasio", "pasi-o", "[UV] Passion. <B>1</B> vehement emotion, fit, outburst, transport, e.g., <I>de kolero</I>. 2 strong attachment (affection, devotion): <I>kaŝi sian ~on por iu</I>. <B>3</B> strong desire (enthusiasm, zeal): <I>~o fumi, al muziko, por la vero</I>. <B>~a</B>, -ate, ardent, glowg, im-ed, vehement. <B>~e</B>, -ately, with ardour. <B>~igi</B>, excite (stir) the pp. <I>~iga,</I> exciting, sensuous. ~iĝi (<I>al, pri</I>), become enamoured of, have strong desire. <I>~iĝa</I> (rutting) <I>sezono</I>. Sen<B>~a</B>, -less, dis-ate, apathetic, cold-blooded, collected, cool, impassive, phlegmatic. ➞ <I>dezireg, koler, pasion, patos, volupt</I>.", "0"],
["pasiono", "pasion-o", "<B>1</B> passion, sufferings of Christ. <B>2</B> oratorio narrating these.", "0"],
["pasiva", "pasiv-a", "[OA] Passiv/e. Opp <I>aktiv</I>. <B>1</B> (gram) <I>~a participo</I>. <B>2</B> (<I>neagema</I>) inactive, inert. <B>3</B> (<I>senkontraŭago</I>) submissive, unresisting. <I>~a obeo, rezisto</I>. <B>~e</B>, -ly. <I>Rigardi, suferi ~e</I>. <B>~eco</B>, -ity. ➞ <I>inert</I>. <B>~o</B>, (gram) p-voice. <B>4</B> (fin) (<I>ŝuldaro</I>), debts, liabilities.", "0"],
["pasko", "pask-o", "<B>1</B> Passover (El 12/11). <B>2</B> Easter. <I>~a festo, tempo</I>, E-tide. <B>~a</B> <I>ŝafido</I>, Paschal lamb, <B>f</B> Kristo (1 Ko 5/7), <I>~a floro</I>. Vd <I>anemon</I>.", "0"],
["paskvilo", "paskvil-o", "[OA] Lampoon; pasquinade, virulent (abusive, scurrilous) piece of satire. <B>~eto</B>, skit, squib. <B>~i</B> (<I>kontraŭ), 1</I>. <B>~isto</B>, -er. ➞ <I>pamflet</I>.", "0"],
["pasporto", "pasport-o", "Passport. <I>~a foto</I>. <B>~ejo</B>, p-office.", "0"],
["pasteĉo", "pasteĉ-o", "[UV] meat or fish pie (baked in pastry, without dish). <B>~eto</B>, pasty, patty. ➞ <I>kuk, tort</I>.", "0"],
["pastelo", "pastel-o", "[UV] (cul, pharm), lentil-shaped jujube, lozenge, pastille. <I>ĉokolad~o, ment~o, tus~o</I>, chocolate drop, peppermint tablet, cough lozenge. ➞ <I>lozanĝ</I>.", "0"],
["pastemako", "pastemak-o", "[UV] parsnip (<I>Pastinaca sativa</I>).", "0"],
["pasteŭrizi", "pasteŭriz-i", "(<I>parte steriligi</I>), Pasteurize, pastiĉ-o, (lit) pastiche, imitation of style of famous writer, (mus) pasticcio, medley from various sources. ➞ <I>parodi</I>.", "0"],
["pasto", "past-o", "Past/e. 1 (<I>pano</I>), Dough. <B>2</B> similar substance. <I>Ĉifona, papera, ligna</I> <B>~o</B>, rag (paper, wood) pulp. <B>Folia</B> <B>~o</B>, <B>Puf~o</B>, puff p-ry. <B>~eca</B>, d-ey, p-ey. <B>~aĵo</B>, p-ry, d-nut, etc. <B>~ujo</B>, kneading-trough (El 12/34, Re 28/5). <B>~platigilo</B>, <B>~rulilo</B>, rolling-pin. ➞ <I>farun, glu, gum</I>.", "0"],
["pastoralo", "pastoral-o", "pastoral, play (poem) of a bucolic idyllic nature. ➞ <I>paŝtist</I>.", "0"],
["pastoro", "pastor-o", "pastor, (us. protestant) minister.", "0"],
["pastro", "pastr-o", "[UV] Clergy/man, Minister, Pastor; clerk in holy orders, parson, priest. <I>Armea ~o</I>, army chaplain, padre. <I>Dom~o</I>, private chaplain. <I>Idol~o</I> (Ce 1/4). <B>~i</B>, m., serve as p., give spiritual guidance. <B>~a</B>, m-ial, p-al, clerical. <I>~a lando</I>, glebe land. <I>~a politikaĉo</I>, priestcraft. <B>~aĉo</B> (Ho 10/5). <B>~aro</B>, clering -(ministr-)y. <B>~eco</B>, p-ate, charge, cure, incumbency, ministry, priest-hood. <I>~eca</I> (parsonic) <I>voĉo</I>. <B>~ejo</B> (<I>~a domo</I>), c-house, manse, rectory, vicarage. <B>~igi</B> (<I>ordini</I>), ordain. <B>~iĝi</B>, take holy orders, <B>~ino</B>, female m., priestess. <B>Ĉef~o</B>, chief (high) priest. <B>Eks~igi</B>, unfrock. ➞ <I>klerik, paroĥestr, pastor, raben, sacerdot</I>.", "0"],
["paŝao", "paŝa-o", "pasha, Turkish or Egyptian officer.", "0"],
["paŝi", "paŝ-i", "(nt), [UV] <B>~o</B>, Step, pace, tread. <I>~i rapide, sencele; antaŭen. flanken. Fari unuan ~on. ~o(n) post ~o</I>, s. by s. (mus) <B>~a</B> <I>movo</I>, s-wise motion. <B>~ado</B>, gait, walk. <B>~egi</B>, stalk, stride. <B>~eti</B>, toddle, trip. <I>~etuleto</I>, little toddler. <B>Al~i</B>, s. up to, approach, enter upon. <B>Antaŭ~o</B>, s. in advance. <B>Ek~i</B>, take the first s. <B>El~i</B>, s. out, come forward. <B>Mis~o</B>, false s. <B>Preter~i</B>, over-s. <B>Retro~i</B>, s. back. <B>Super~i</B>, over-s. <B>Trans~i</B>, s. across, trangress. <B>Du~o</B>, (dance) two-s. <B>Ĉiu~e <I>mi renkontis malfacilaĵon</I></B>. ➞ <B><I>ambl, marŝ, piedir, tret, stamf</I></B>.", "0"],
["paŝtelo", "paŝtel-o", "[OA] Pastel, crayon. <B>~e</B>, in p. <B>~(aĵ)o</B>, p-drawing. ➞ <I>kret</I>.", "0"],
["paŝti", "paŝt-i", "(<I>-n</I>), [UV] Pastur/e, feed, graze, tend (cattle, etc.). <I>Kie vi ~as?</I> (Alt 1/7). <I>Viaj fratoj ~as en Sehem</I> (Ge 37/13). <B>~ataro</B> (<I>grego</I>), flock. <B>~aĵo</B>, p., fodder. <B>~ejo</B>, grass-(p-)land. <B>~iĝi</B>, browse, feed, graze. <B>~isto</B>, herdsman, shepherd, <I>Pork~isto</I>, swineherd. <I>~ista</I>, bucolic. ➞ <I>fleg, furaĝ, nutr</I>.", "0"],
["patelo", "patel-o", "<B>1</B> (<I>genuosto</I>), patella, kneecap. <B>2</B> (zoo) limpet (<I>Patella</I>).", "0"],
["pateno", "paten-o", "<B>1</B> (ecc) paten. <B>2</B> thin circular plate of metal.", "0"],
["patento", "patent-o", "[F], Patent, exclusv right to exploit (make, sell) new invention. <B>~i</B> (<I>-n</I>), p. <B>~aĵo</B>, -ed invention (process). ~<B>ejo</B>, p-office. <B>~into</B>, <B>~ulo</B>, -ee. <B>~ita</B>, -ed.", "0"],
["patino", "patin-o", "<B>1</B> patina, incrustation (us. green) on surface of old bronze. <B>2</B> = sketilo.", "0"],
["pato", "pat-o", "[UV] <B>1</B> (<I>fritilo</I>), (frying) Pan (2 Sa 13/9). <I>Potoj kaj ~oj</I>, pots and pans. <B>Tort~o</B>, patty-pan. <B>2</B> (chs) <B>~o</B>, stalemate. <B>~i</B>, be stalemate.", "0"],
["patologio", "patolog-io", "[OA] Patholog/y, study of disease. <B>~o</B>, [OA] -ist.", "0"],
["patoso", "patos-o", "[OA] (rh) exalted (fervid, passionate) expression of feeling, bombast, rant. <B>~a</B>, emotional, fervid, impassioned, moving (H/65, 80). <I>[Ne= </I> pathetic], ➞ <I>emoci, pasi</I>.", "0"],
["patriarko", "patriark-o", "Patriarch. <B>1</B> father and ruler of family or tribe. <B>2</B> venerable old man, oldest living representative. <B>3</B> title of certain (arch)bishops. <B>~a</B>, -al. <B>~eco</B>, -ate.", "0"],
["patricio", "patrici-o", "[OA] (hist) patrician. <B>~a</B>, p., aristocrat, noble. ➞ <I>note I</I>.", "0"],
["patrico", "patric-o", "Die (engraved stamp for moulding design). <B>~i</B>, emboss, punch, hall-mark, stamp (coin, medal). <B>~isto</B>, d-sinker. ➞ <I>matric</I>.", "0"],
["patrioto", "patriot-o", "[OA] (<I>patrujamanto</I>), Patriot. <B>~a</B>, -ic. <B>~eco</B>, <B>~ismo</B>. ➞ <I>ŝovinism, ŝovinist</I>.", "0"],
["patro", "patr-o", "[UV] Father. <B>Bapto~o</B>, god-f. <B>Stifa</B> <B>~o</B>, <B>Stif~o</B>, step-f. f (<I>genta) ~o</I>, founder of family, etc. <I>La ~oj de la eklezio</I>. 2 (rc) title of priest. <B>~a</B>, of a f., f-ly, paternal. <I>~a bieno, heredaĵo</I>, patrimony. <B>~i</B>, be a f. to. <B>~eco</B>, f-hood, paternity, <B>f</B> authorship. <B>~ino</B>, [UV] mother. <I>Neceso estas la ~ino de invento. ~ina amo, lingv)o</I>, m-love (-tongue). <I>~ineco</I>, m-hood, maternity. <I>~ineto (panjo</I>), ma(mma), mum(my). <B>~eto</B> (<I>paĉjo</I>), dad(dy), pa(pa). <B>~ujo</B>, [UV] f-land. <I>El~ujigi</I>, exile (Jeĥ 1/1; Am 5/27). <I>Sam~ujano</I>, compatriot. <B>~omortigo</B> (<I>~icido</I>), patricide. <B>~onia</B>, paternoster, the Lord’s prayer. <B>bo~o</B>, [UV] <B>~ino</B>, f-(mother-) in -law. <B>duon~o</B> [UV] (better stifa patro), stepfather. <B>ge~oj</B>, [UV] parents. <B>Pra~o</B>, fore-f, ancestor. Sampatr (in)a, sibling. Sam<B>~a</B>, of the same f. <I>Sam~ina</I>, uterine. Sen<B>~a</B>, f-less.", "0"],
["patrolo", "patrol-o", "[UV] (mil, sctg), Patrol. <B>~i</B>, p., go the rounds, perambulate, reconnoitre. <B>~ano</B>, p-man. <B>~boato</B>, p-boat. <B>~estro</B>, p-leader.", "0"],
["patrono", "patron-o", "[OA] Patron. <B>1</B> protector, supporter. <B>2</B> regular customer. <B>~a</B>, p. ~a <I>komitato</I>, committee of -age. <I>~a rajto</I>, -age, advowson. <I>~a sanktulo,</I> p-saint. <B>~ado</B>, custom. <B>~eco</B>, -age. <B>~i</B>, -ize, support. <B>~ino</B>, -ess. (If/7).", "0"],
["paŭpero", "paŭper-o", "(<I>senhavulo</I>), pauper, beggar. <B>~eco</B>, <B>~ino</B>, <B>~ismo</B>.", "0"],
["paŭsi", "paŭs-i", "(<I>trakopii</I>), (des) Trac/e. <I>~papero,</I> -ing paper, <B>f</B> slavishly reproduce. <B>Frot~aĵo</B>, rubbing.", "0"],
["paŭti", "paŭt-i", "pout, protrude the lips in displeasure. ➞ <I>bud</I>.", "0"],
["paŭzo", "paŭz-o", "[UV] pause, break, halt, interval of inaction. (pros) caesura, (mus) (a) (<I>silento</I>), rest, (b) (<I>daŭrigo</I>), hold (^). <B>~i</B> (<I>fari ~on</I>), <B>1</B> break off, cease, stop. <B>2</B> delay, stay, tarry. <B>3</B> demur, hesitate, hold back. <I>Labori</I> <B>Sen~e</B>, without interrupts ➞ <I>ĉes, halt, ripoz</I>.", "0"],
["pavano", "pavan-o", "(mus) pavane, stately dee. ➞ <I>vanes</I>.", "0"],
["pavezo", "pavez-o", "(mar) bulwarks, top-sides.", "0"],
["paviano", "pavian-o", "[OA] baboon (<I>Papio</I>). ➞ <I>mandril</I>.", "0"],
["pavilono", "pavilon-o", "pavilion, large tent, light detached building, especially for sport. <I>Kriketa ~o. Ĝardena ~o</I>, summer-house.", "0"],
["pavimi", "pavim-i", "[UV] Pav/e. <I>~i straton</I>. <B>f</B> <I>Per promesoj estas ~ita la infero</I>. <B>f</B> ~i <I>la vojon</I>, p. (prepare, smooth) the way. <B>~(aĵ)o</B>, -ing, -ment. <I>~o asfalta, brika, ligna, ŝtona</I>. ~ero (<I>~a ŝtono</I>), -ing stone, flag, sett, slab. <B>~ilo</B>, -ing beetle, rammer. <B>~isto</B>, -er, -ior. ➞ <I>trotuar</I>. pazigrafi-o, pasigraphy, system of universal writing.", "0"],
["pavo", "pav-o", "[UV] Pea-cock (-fowl) (<I>Pavo cristatus</I>). f (<I>parademulo</I>), vain fellow. <B>~i</B>, spread one’s, strut, swagger. <B>~ido</B>, p-chick. <B>~ino</B>, p-hen. <B>~bluo</B>, <B>~okulo</B>, p-c blue (-eye).", "0"],
["Pa!", "", "(interj) denotes unconcern. <I>~, ĉio</I> <B><I>aranĝiĝos kun la tempo</I></B>.", "0"],
["peano", "pean-o", "paean, song of praise or thanks- giving, shout of exultation.", "0"],
["peco", "pec-o", "[UV] Piece (wide sense). <B>1</B> bit, fragment, lump, morsel, portion, scrap, strip: <I>~o de paper-(sap-ŝnur-)o</I>. <B>2</B> cut, slice: <I>~o da kuk-(pan-ŝtof-)o</I>. <B>3</B> (distinct pt): <I>~o de kostumo, maŝino, mozaiko, muziko, poezio</I>. (chs, drs): p. <B>Ark~o</B>, shank (<I>Sua</I>). <B>Brik~o</B>, brick-bat. (m.i.) <B>Buŝ~o</B>, mouth-p. <B>Okul~o</B>, eye-p. <B>Pint~o</B>, toe-cap (<I>sua</I>). <B>Pot~o</B>, potsherd. <B>Ter~o</B>, plot. <B>Tuk~o</B>, patch, rag. <B>Vic~o</B>, spare part. <B>~ego</B>, chunk, hunk. <B>~eto</B>, atom, crumb, grain, iota, shred, whit. <I>~etigi</I>, crumble. <I>~etiĝi</I>, crumble, disintegrate. <I>~etiĝema,</I> crumbly, friable. <B>(Dis)~igi</B>, cut up, dismember, take to pp, tear to shreds. <B>Divers~a</B>, composite. <B>Po~a</B> <I>laboro</I>, p- work. <B>Po~e</B>, p-meal, bit by bit. <B>Unu~a</B>, in one p. ➞ <I>er, fragment, part, porci</I>.", "0"],
["peĉo", "peĉ-o", "[UV] Pitch, bituminous substance (El 2/3). ~(iz)i, cover (coat) with p. <I>~i ferdekon</I>. Ter~o (<I>asfalto</I>), asphalt. Urania ~o (<I>peĉereo</I>), p-blende.", "0"],
["pedagogio", "pedagog-io", "[OA] (<I>instruarto</I>), Pedagog/y. <B>~o</B>, [OA] p-ue, schoolmaster, teacher.", "0"],
["pedalo", "pedal-o", "[OA] Pedal. <B>1</B> foot-lever, key moved by foot, treadle. <I>~o de bieikl -(harp-kudromaŝin-)o</I>. Brems<B>~o</B>, brake-p. Gas<B>~o</B>, accelerator. Kluĉ<B>~o</B>, clutch, (org) Kombin<B>~o</B>, combination (or composition) p. Ŝvel<B>~o</B>, swell-p. (piano) Dekstra (subtena) <I>~o</I>, loud p. Maldekstra (<I>unukorda) ~o</I>, soft p. <B>~i</B>, (use) p. <B>~ado</B>, -ling. ~aro (org) (<I>~a klavaro, pieda klavaro</I>), p-board. ~orgeno, p- organ. Retro<B>~i</B>, back-p. <B>2</B> (mus) ~(not)o, (<I>persista noto</I>), p. <I>~o burd-(duop-intern -invertit-tonik-)a</I>.", "0"],
["pedanto", "pedant-o", "[OA] Pedant, doctrinaire, person possessed by formal rules (theory), precisian. <B>~a</B>, -ic, meticulous, priggish, stilted. <I>Homo teda kaj ~a. Libro instrua estu</I> ~e <I>konservativa</I>. <B>~aĵo</B>, piece of -ry. <B>~eco</B>, -ry. ~ino, blue-stocking.", "0"],
["pedelo", "pedel-o", "[OA] apparitor (guild, university); beadle (parish); usher (court); verger (church).", "0"],
["pediko", "pedik-o", "[UV] (<I>sangosuĉa laŭso</I>), Louse (<I>Pediculus</I>). <B>~(ohav)a</B>, -y, verminous. <B>~ovo</B>, nit. <B>~ozo</B>, pediculosis. <B>~ulo</B>, verminous person. <B>Sen~igi</B>, de-1. ➞ <I>laŭs</I>.", "0"],
["pedikulariso", "pedikularis-o", "(bot) lousewort, red rattle (<I>Pedicularis</I>).", "0"],
["pedunklo", "pedunkl-o", "(bot) peduncle, stalk (of flower, fruit, or cluster). ➞ <I>tig</I>.", "0"],
["pego", "peg-o", "[UV] (orn) Woodpecker (<I>Picus</I>, k.a.). Blankdorsa <B>~o</B>, whiteheaded w. <B>Eburo-beka</B> <B>~o</B>, ivorybilled w. <B>Granda</B> <B>~o</B>, pied (great spotted) w. <B>Griza</B> <B>~o</B>, greyheaded w. <B>Malgranda</B> <B>~o</B>, barred (lesser spotted) w. <B>Trifingra</B> <B>~o</B>, threetoed w.", "0"],
["pejzaĝo", "pejzaĝ-o", "[UV] Landscape, scenery. <B>2</B> painting of this. ~a <I>bildo,</I> <B>~(pentr)isto</B><I>,</I> 1-painter. ➞ <I>panoram, vidaĵ</I>.", "0"],
["pekano", "pekan-o", "(bot) pecan (Carya illinoensis). ➞ <I>hikori</I>.", "0"],
["pekario", "pekari-o", "peccary, small gregarious American pig (<I>Tayassu</I>).", "0"],
["peki", "pek-i", "[UV] <B>1</B> (commit) Sin; Transgress; do wrong, err. <B>2</B> offend against divine law, or moral standards or principles: <I>~i kontraŭ gramatiko, logiko</I>. <B>~o</B>, <B>1</B> sin, transgression, trespass, iniquity, wickedness. <I>Konfesi, pardoni ~on. De ~o kaj mizero estas plena la tero</I>. <B>2</B> offence (as above): delinquency, misdeed. <B>~(oplen)a</B>, of s., s-ful, wicked, wrong. <B>~eto</B>, fault, pecadillo. <B>~eco</B>, s-fulness, depravity, iniquity. <B>~ema</B>, frail. <I>Ne~ema</I>, inpeccable. <B>~igi</B>, corrupt, lead astray, seduce. <B>~inta</B>, fallen. <I>~into, ~ulo</I>, s-ner, t-or. <I>Kontraŭ ~o prediku, ~inton pardonu</I>. <B>ĉef~o</B>, deadly s. <B>Pra~o</B>, original s. <B>Pro~a</B> <I>kapro, ofero</I>, scape-goat, s-offering. <B>Sen~a</B>, s-less, without s., innocent. <B>Sen~igi</B> (<I>~liberigi</I>), absolve, redeem, shrive. ➞ <I>delikt, erar, krim, kulp, malbon, maljust, malvirt</I>.", "0"],
["pekli", "pekl-i", "(<I>-n</I>), [UV] Pickle (in brine), corn, preserve with salt. <B>~aĵo</B>, <I>~ita viando,</I> corned beef, etc. <B>~akvo</B>, -ing brine. ➞ <I>konserv, marin, prezerv, sal</I>.", "0"],
["pekteno", "pekten-o", "(zoo) clam, scallop (<I>Pecten</I>).", "0"],
["pektino", "pektin-o", "(chem) pectin (of fruit).", "0"],
["pelagro", "pelagr-o", "(med) pellagra, pelargoni-o, (bot) pelargonium (ordinary language \"geranium\"). ➞ <I>gerani</I>.", "0"],
["pelerino", "pelerin-o", "[OA] pelerine, cape, tippet.", "0"],
["peli", "pel-i", "(<I>-n</I>), [UV] <B>1</B> Driv/e, press(urge) forward (on), impel, propel: <I>La sorto min ~is. Kiu tro ~as, nur malakcelas. Ondoj ~as ŝipon, vento la nubojn</I>. <B>2</B> chase, charge, pursue: <I>~i nubojn, malamikon</I> (Le 26/7). <B>f</B> d. to a point (extremity), constrain, force: <I>~i iun en malesperon. ~ata de malsato, teruro timo</I>. <B>~o</B>, impulse, urge. <B>~ado</B>, -ing, coercion. <I>Turn~aĵo</I>, eddy. <B>~iĝi</B>, be -en, forced, hustled, jostled along. <I>Muŝ~\\\\o</I>, fly-swopper. <B>~isto</B>, -er (cattle), (sp) beater. <B>Antaŭen~i</B>, drive forward. <I>~~ilo</I>, propeller. <B>Dis~i</B>, dispel, disperse, scatter, <B>El~i</B>, d. (cast, turn) out, banish, expel, oust, reject. <I>~~i el la hejmo, lando. ~~ito</I>, exile, outcast. <B>For~i</B>, d. away (off), repel, spurn. <I>La suno ~~is la nubojn. Prunto amikon ~~as</I>. <B>Trud~i</B>, compel, force, put pressure on. ➞ <I>ĉas, devig, driv, persekut, veturig</I>.", "0"],
["pelikano", "pelikan-o", "[UV] pelican (<I>Pelecanus). ~o en la dezerto</I> (Ps 102/6).", "0"],
["peltigero", "peltiger-o", "dog lichen (<I>Peltigera</I>).", "0"],
["pelto", "pelt-o", "[UV] Fur (coat). <I>Kruda ~o</I>, pelt, raw hide. <B>~e</B> <I>subŝtofita</I>, f-lined. <B>~aĵo</B>, furs. <B>~isto</B>, -rier. <B>~komerco</B>, f-trade. ➞ <I>fel</I>.", "0"],
["pelvo", "pelv-o", "[UV] Basin, bowl, Pan. <I>Lav~o,</I> wash-b (Ps 60/8). <I>Lit~o</I>, bed-p. <I>~o monkolekta, pesila</I>. (anat) (<I>~osto</I>), pelvis. <B>~eto</B>, small b. ➞ <I>basen, bovl</I>.", "0"],
["pemikano", "pemikan-o", "pemmican. N-American Indian dish of dried meat.", "0"],
["penatoj", "", "(hist) penates, household gods, <B>f</B> = <I>hejmo</I>.", "0"],
["penco", "penc-o", "[OA] Penny. <B>~oj</B>, pence. <B>Duon~o</B>, half-p. <B>Ses~a</B> <I>monero</I>, six-p piece.", "0"],
["pendi", "pend-i", "(nt), [UV] Hang, be Suspen/ded, dangle, droop. <I>Lampo ~as de plafono, pomo de arbo</I>. <B>f</B> <I>Glavo ~as super nia kapo. Ni kvazaŭ ~is de liaj vortoj. ~i en la aero (esti necerta</I>). <B>~(ant)a</B>, <B> ing</B>, pendant, pending. <B>~aĵo</B>, drop, pendant, tassel, etc. <B>Al~aĵo</B>, <B>sur~aĵo</B>, appendage. <B>Ĉirkaŭ~aĵo</B>, -ings, valance. <B>Orel~aĵo</B>, ear-drop(-ring). <B>~igi</B>, h. up. <I>~igi bildon sur muro, ĉapon sur hoko. Boat~igilo (davito</I>), davit. <I>~igo</I> (coach building) s-sion. <B>~iĝi</B>, catch, get caught. <B>~umi</B> (<I>~mortigi</I>), hang (person) on gibbet. <I>Sin ~umi</I>, hang one’s. <I>~umilo</I>, gallows, gibbet, tree. <I>~umindulo</I>, gallows-bird. <B>de~i</B>, [UV] Vd. <I>depend</I>. <B>El~i</B>, h. out. <I>Lango ~~anta</I>. <B>~aĵo</B>, [UV] sign-board, etc. <B>Mal~igi</B>, take down (picture, etc.). <B>(Super)~i</B>, over-h., beetle, lower, menace. <B>Flug~i</B> (<I>ŝvebi</I>), hover. ➞ <I>brelok, ŝveb</I>.", "0"],
["pendolo", "pendol-o", "[UV] <B>1</B> Pendulum. <I>~a horloĝo</I>. <B>~a</B> <I>svingiĝo</I>, swing of p. ~i (nt) swing to and fro. <B>2</B> (<I>svingilo</I>), (gm) swing.", "0"],
["penetri", "penetr-i", "(<I>-n</I>), Penetrat/e. <B>1</B> Enter, find access (get) into or through, forge (make) a way into, invade, permeate, pierce. <I>~i en arbaron, ĝis la koro. Akvo ~is la ŝuon; kuglo la oston; radiko la teron; vorto la koron</I>. <B>2</B> fill, imbue with. <I>Animo ~ita de ideo, ĝojo, melankolio</I>. <B>3</B> discern, fathom, see into, uncover. <I>~i futuron, misteron</I>. <B>~o</B>, -ion, insight. <B>~(em)a</B>, -ing, acute, discerning, piercing, searching, sharp. <I>~a odoro, rigardo, voĉo</I>. <B>~e</B> <I>rigardi</I>. <B>~ebla</B>, -able, permeable. ~emo, acumen, perspicacity, sagacity. <B>~igi</B>, cause to p., instil, put. <I>~igi ideon en kapon. ~i iun per ideo</I>. <B>~iĝi</B>, be imbued, pervaded, possessed with. <B>Kor~a</B>, heart-rending. <B>Ne~ebla</B>, imable, impervious, inaccessible. <B>Tra~i</B>, p. deeply, permeate. <I>~~ita</I> (soaked) <I>de pluvo</I>. ➞ <I>enir, enprofundiĝ, enradikiĝ, invad</I>.", "0"],
["peni", "pen-i", "[UV] (nt) make an Effort, Labour, take Pains (Trouble); apply (exert, set) one’s to, endeavour, do one’s best, put one’s back into, strive, try hard. ~i <I>konvinki, plaĉi iun, levi, porti ion. ~u esti virta</I> (H/108). <I>Liaj filoj ~is konsoli lin</I> (Ge 37/35). <B>~(ad)o</B>, e„ 1., p., t., exertion. <I>Domaĝi nenian ~on</I>, spare no e. <I>Bona verkisto ~as evitigi ~on al la leganto. Ne valoras la ~on tion fari</I>. ~(ig)a, hard (<I>laboro</I>), heavy (<I>spirado</I>), irksm, laborious, toilsm. <B>~(em)a</B>, assiduous, careful, p-taking. <B>~e</B> (<I>kun ~o</I>), with e., p., (difficulty). ➞ <I>apenaŭ. Multe</I> <B>~adi</B>, be at great pains to, work hard at. <I>~ado perdita</I>. <B>~ego</B>, great e., toil. <B>~igi</B>, give a person (put to) the t. <B>~inda</B>, worth while (the t.). <I>~indas provi</I>, it is worth while trying (➞ 1 FA 82/32). <I>Estus ~inde</I> (3 FA 106/24). <I>Kion vi</I> pri~as (take t. over), <I>tio al vi venas</I>. <B>Sen~a</B> (<I>facila</I>), without e. (t.). ➞ <I>klopod, prov, streb, streĉ, ŝvit</I>.", "0"],
["penicilino", "penicilin-o", "penicillin (substance from this).", "0"],
["penicilio", "penicili-o", "(<I>penika ŝimo</I>), Penicillium.", "0"],
["peniko", "penik-o", "[UV] <B>1</B> Brush, hair-pencil (for paint, gum, etc.). <B>~i</B> (<I>uzi ~on</I>). <B>Barb~o</B>, <B>raz~o</B>, shaving b. <B>Plafon~o</B>, distemper b. <B>Plata ~o</B>, decorating brush. <B>ŝmir~o</B>, paint-b. <B>2</B> (<I>kvasto</I>), tassel. [3 (Bb) (<I>= grapolo</I>), bunch (No 13/23)].", "0"],
["peniso", "penis-o", "(anat) penis. <B>~ingo</B> (<I>kondomo</I>).", "0"],
["penseo", "pense-o", "(trikoloreto), pansy, heart’s ease (<I>Viola tricolor</I>).", "0"],
["pensi", "pens-i", "[UV] Think. <B>1</B> cogitate, consider, ponder, reflect, ruminate: <I>Mi ~as, do mi ekzistas. Mi ~u!</I> Let me t. <I>~u pri mi,</I> t. of me. <I>Tiu, pri kiu mi ~as</I>, (have in mind). <I>Mi ne ~is pri tio</I>, I forgot (didn’t t. of) that. <I>Mi ~as (demandas al mi): Ĉu li havas</I> (4 FA 148/27). <B>2</B> (<I>kredi, imagi, opinii, supozi</I>) be under the impression, believe, fancy, imagine, suppose, take it: <I>Mi ~as, ke jes (ne</I>), I think so (not). <B>~o</B>, Thought, concept, idea. <I>Sen ~o pri</I>, regardless of. <I>Noblaj ~oj. Diri sian ~on</I>, speak one’s mind. <B>~ado</B>, consideration, deliberation, reflection. <B>~a</B>, of t. <B>~ema</B>, <B>~oplena</B>, t-ful, contemplative, pensive. <B>~igi</B>, put in the mind, suggest. <I>~iga</I>, t-provoking. <B>~isto</B>, <B>~(em)ulo</B>, -er. <B>~legado</B>, t-reading (➞ <I>telepati</I>). <B>Antaŭ~i</B>, premeditate. <B>Ek~i</B>, have an idea. <I>Mi ĵus ek~is</I>, it has just occurred to me (come into my mind). <B>Ek~o</B>, sudden t. <B>el~i</B>, [UV] t. out, devise, invent. <I>~~i klarigon, rimedon. ~~aĵo</I>. ➞ <I>eltrov, invent, malkovr</I>. <B>~~ema</B>, ingenious, inventive. <B>En~igi</B>, be absorbed (lost in t.), muse. ➞ <I>medit. En~iĝo</I>, abstraction, brown study. <B>Ne~ebla</B>, un-able. <B>pri~i</B> [UV] (<I>konsideri</I>), think. about (of, over), consider, reflect upon. <I>Tio postulas ~~on. ~~ita,</I> deliberate. <I>Ne~~inte</I>, without forethought. <I>Ne~~ita</I>, unpremeditated. <B>Sen~a</B>, harebrained, rash, unreflecting. <B>Liber~ulo</B>, free-er. <B>Rapid~a</B>, alert, quick-witted, smart, wide-awake. <B>Trud~o</B>, possession. <B>Vag~a</B>, absent-minded. ➞ <I>konsider</I>.", "0"],
["pensio", "pensi-o", "[UV] Pension, annuity, periodical allowance. ~i (<I>iun</I>), p. <B>~ito</B>, <B>~ulo</B>, -er. ~a <I>kotizo</I>, retirement deposit. <B>~ebla</B>, -able. <B>For~i</B>, p. off. ➞ <I>emerit</I>.", "0"],
["pensiono", "pension-o", "[OA] Boarding-house, b. and lodging. ~a <I>lernejo</I>, -ing school. <B>~ito</B>, <B>~ulo</B>, b-er, lodger. <B>~estro</B>, b-h keeper. ➞ <I>gast</I>.", "0"],
["penstemono", "penstemon-o", "(bot) penstemon, beard- tongue.", "0"],
["penta", "penta-", "(Gk pfx = kvin-), penta- (chem) (<I>kvinatoma</I>). ~gono, -gon. ~gramo, -gram. ~hedro, -hedron. ~lito (<I>kvin ŝtonoj</I>), (gm) five stones. -METRO, (pros) -meter, -teŭko, -teuch. ~tona <I>skalo</I>, -tonic scale (d r m s 1).", "0"],
["pentatomo", "pentatom-o", "forest (shield, wood) bug. (<I>Pentatom</I>).", "0"],
["pentekosto", "pentekost-o", "[UV] Pentecost, Whit/ sun(tide). <B>~a</B>, -al. <I>~a ferio. ~a dimanĉo (lundo</I>), Whit-Sunday, Whit-Monday.", "0"],
["penti", "pent-i", "(<I>-n, pri, pro; ke</I>), [UV] Repent, be Peniten/t, contrite (sorry) feel remorse, regret, rue. <I>Pekinto ~as, kolero silentas</I>. <B>~o</B>, p-ce, r-ance, contrition, regret, remorse. <B>~(em)a</B>, p-tial, r-ant, contrite, sorry. ~anto, <B>~ulo</B>, p-t. <B>~igi</B>, make sorry. <B>~ofari</B>, do penance. ➞ <I>bedaŭr</I>.", "0"],
["pentri", "pentr-i", "(<I>-n</I>), [UV] Paint. <B>1</B> depict (portray) in colour: <I>~i pejzaĝon, portreton</I>. <B>2</B> (<I>bildigi</I>) describe, represent sketch in words: <I>~i tion nigre; la nunan situacion; la aferon, kiel ĝi efektive estas</I>. <B>~aĵo</B> (f<B>uŝ~o</B>), daub. <B>~ado</B>, <B>~arto</B>, -ing, pictorial art. <B>~aĵo</B>, -ing, picture. <I>Akva ~aĵo (akvarelo</I>), water-colour. <I>Mor~aĵo</I>, genre picture. <I>Olea ~aĵo</I>, oil -ing. <I>~aĵejo</I>, picture gallery. <B>~ejo</B>, studio. <B>~inda</B>, picturesque, <B>~isto</B>, -er. ➞ <I>bild, desegn, farb, ĝenr, ilustr, kolorig</I>.", "0"],
["peonio", "peoni-o", "[OA] peony (<I>Paeonia). Ruĝiĝi kiel</I> ~o (M 170/19).", "0"],
["peono", "peon-o", "<B>1</B> (S. American) peon. <B>2</B> (chs) (<I>soldato</I>), pawn.", "0"],
["pepi", "pep-i", "(nt), [UV] Chatter. <B>1</B> (birds) cheep, chirp, chirrup, peep, twitter, warble. <I>Kokidoj, paseroj ~as</I>. <B>2</B> babble (brook), <B>f</B> (children): c., prattle. <I>La ~aj voĉoj de virinoj</I>. <B>~ado</B>, -ing. <B>~ema</B>, prattling. <I>~emulo</I>, c-box. <B>Plor~i</B>, pule, moan, whimper, whine (Jes 38/14).", "0"],
["pepliso", "peplis-o", "water purslane (<I>Peplis</I>).", "0"],
["pepsino", "pepsin-o", "[OA] pepsin.", "0"],
["peptono", "pepton-o", "Pepton/e. <B>~izi</B>, -ize.", "0"],
["per", "", "[UV] (prep), (stronger forms: <I>pere de, per helpo de</I>): by means (the good offices) of, per, th rough, with (in this sense). <B>1</B> (implement, object): <I>fosi ~ fosilo, kovri ~ tuko, manĝi - forko</I>. <B>2</B> (organ, member): /(an <I>~ nazo, gvidi ~ mano, minaci ~ pugno</I>. <B>3</B> (person): <I>kompreni ~ interpretisto, respondu ~ la portanto</I> (per bearer). <B>4</B> (means, manner): <I>aĉeti ~ oro, komenci ~ gratulo, veni ~ aŭto</I> (➞ <I>kun, lau</I>). <B>~a</B>, [UV] indirect, mediate. <I>La ~a metodo de lingva instruo (~ uzo de nacia lingvo</I>). <B>~i</B>, [UV] act as intermediary. <I>~i al iu novaĵon</I>. <B>~ado</B>, mediation, intervention. <B>Pac~ado</B>. <B>~ilo</B>, means, medium. <B>~anto</B>, <B>~isto</B>, <B>~ulo</B>, agent, go-between, intermediary, middleman. <B>Ofic~isto</B>, employment agent. <B>Vet~isto</B>, book-maker. <B>Sen~a</B>, direct. <I>La sen~a metodo, Preĝi al Dio sen~e</I>. PFX: <B>~flati</B>, wheedle (<I>atingi ~ flato</I>). <B>~labori</B>, earn (<I>gajni ~ laboro</I>). <B>~ludi</B>, win (<I>enspezi ~ ludo</I>).", "0"],
["per.", "per-.", "(chem) <B>~klorata acido. ~manganato de kalio. ~oksido</B>.", "0"],
["peramelo", "peramel-o", "(zoo) bandicoot, Australian marsupial (<I>Perameles</I>).", "0"],
["percepti", "percept-i", "[OA] (phi) Perce/ive, apprehend, discern, sense (3 FA 102/2). <B>~o</B>, -ption, intuitive recognition. <B>~ebla</B>, -ptible (by sense or intellect), noticeable &gt; audible (M 129/25). <I>Apenaŭ ~ebla kliniĝo</I>.", "0"],
["perĉo", "perĉ-o", "[UV] (ich) pope, ruff (<I>Acerina</I>). ➞ <I>perk</I>.", "0"],
["perdi", "perd-i", "(<I>-n</I>) [UV]. Lose (wide sense). <B>1</B> cease to have (possess), fail to retain: <I>~i apetiton, fidon, forton, intereson, konscion, paciencon, pezon, voĉon</I>. <B>f</B> (by death): <I>~i amikon, patron, la vivon, ~i la koron al iu</I>. <B>2</B> be worse off, miss, suffer loss: <I>Vi ne ~os per tio</I>. <B>3</B> Spend (use) to no purpose (in vain), waste: <I>motion (tempon</I>). <B>4</B> 1. sight of, fail to keep in sight: <I>~i iun en la homamaso, ~i la vojon</I>. <B>5</B> fail to catch (hear, see): <I>fiŝon (vorton</I>). <B>6</B> be defeated: <I>~i batalon, ludon, proceson</I>. <B>~(itaĵ)o</B>, loss, forfeit, privation, waste, etc. <B>~igi</B>, cause to lose. <B>~iĝi</B>, get lost, go astray. <I>Mil semoj ~iĝas. ~iĝinta ŝafo. ~iĝo</I>, perdition. <B>~into</B>, loser. <B>~ita</B>, done for, lost, missing, ruined, wasted, etc. <I>Bone farita ne estas ~ita</I>. <B>Dis~i</B>, dissipate, squander, waste. <B>Pun~i</B>, forfeit. <B>Kolor~ema</B>, liable to fade, lose colour. ➞ <I>malgajn</I>.", "0"],
["perdriko", "perdrik-o", "[UV] partridge (<I>Perdrix</I>). Ruĝa <B>~o</B>, Guernsey (red-legged) p. <B>~ido</B>, p- poult.", "0"],
["perei", "pere-i", "(nt), [UV] Perish. <B>1</B> be destroyed (lost), come to an end (nought), pass away: <I>Lia nomo neniam ~os</I>. <B>2</B> cease to exist, die, lose life: <I>~i en batalo</I>. <B>~o</B>, fall, perdition, ruin. <B>~ema</B>, <B>~iva</B>, -able, frail. <B>~igi</B>, [UV] destroy, ruin, wreck. <I>~iga,</I> destructive, fatal, pernicious. <B>For~i</B>, be blotted out, disappear, fade out of sight, vanish. ➞ <I>detru, mort, ruin</I>.", "0"],
["perfekta", "perfekt-a", "[UV] Perfect. <B>1</B> complete, entire, whole. <B>2</B> excellent, capital, faultless, flawless, sound, (gram) complete. <I>~a tempo</I> (<I>~o</I>), p. tense. <I>~a futuro,</I> future p. <I>~o preterita</I>, plu-p. (mus) <I>~a intervalo (kvarto, kvinto, okto). ~a kadenco</I> (V-I). <B>~e</B>, -ly, to -ion. <I>Ludi ~e</I>. <B>~eco</B>, -ion. <B>~igi</B>, (make) p., bring to -ion. <I>~iga lernejo</I>, finishing school. <B>Ne~a</B>, im-p. <I>~~aĵo</I>, im-ion. ➞ <I>model, sendifekt, senerar, senmank, senpek</I>.", "0"],
["perfidi", "perfid-i", "(<I>-n</I>), [UV] <B>1</B> Betray, be disloyal (false, unfaithful) to, break faith with. <I>~i amikon, edzinon, partion</I>. <B>2</B> disclose, reveal involuntarily or treacherously. <I>Lia vizaĝo ~is lian penson</I>. <B>~(ec)o</B>, -al, breach of faith, perfidy, treachery. <B>~a</B>, [UV] perfidious. <B>~aĵo</B>, act of perfidy, foul play. <B>~into</B>, <B>~ulo</B>, traitor. <B>Sen~a</B>, guileless, trustworthy. ➞ <I>malfidel</I>.", "0"],
["perfori", "perfor-i", "(<I>truigi</I>), (especially phlt), Perforat/e, pierce, make hole(s) or rows of holes through, puncture, trepan. <B>~(ad)o</B>, <B>~(aĵ)o</B>, -ation, hole. <B>~a</B> <I>linio</I>, -ing line. <B>~ilo</B> , -ator.", "0"],
["pergameno", "pergamen-o", "[UV] parchment, sheepskin prepared for writing. ➞ <I>velen</I>.", "0"],
["pergolo", "pergol-o", "(hort) pergola (arbour, covered walk, with plants trained over trellis- work).", "0"],
["peri", "peri-", "(Gk pfx denotes round, about) peri-.", "0"],
["perianto", "periant-o", "perianth.", "0"],
["periferio", "periferi-o", "(<I>ĉirkaŭo</I>), periphery, outer boundary, outskirts. <B>~a</B> <I>aŭto</I><B><I>ŝ</I></B><I>oseo</I>.", "0"],
["perifrazo", "", "(<I>ĉirkaŭfrazo</I>), periphrasis, circumlocution, roundabout way of speaking; <B>~a</B>, -stic.", "0"],
["perigeo", "perige-o", "(perihelio), perigee, (perihelion), point in orbit nearest earth (sun). ➞ <I>afeli, apoge</I>.", "0"],
["perikardo", "perikard-o", "pericardium.", "0"],
["perikarpo", "perikarp-o", "(<I>semujo</I>), pericarp, seed-vessel.", "0"],
["perimetro", "perimetr-o", "[OA] perimeter, <B>f</B> area, sphere.", "0"],
["perineo", "perine-o", "perineum.", "0"],
["periodo", "period-o", "[OA] Period. <B>1</B> time taken for recurring phenomenon, cycle, round, term, season, spell. <I>~o de malsano</I>. (astr) p. of revolution. <B>2</B> indefinite portion of history. <I>Kostumo de la ~o</I>. <B>~a</B>, -ic, intermittent, recurring at regular intervals. <I>~a febro (fenomeno</I>). <B>~e</B>, -ically. <B>~aĵo</B>, -ical. <B>~eco</B>, -icity. ➞ <I>epok, intermit</I>.", "0"],
["periskopo", "", "periscope. <B>peristalta</B>, peristaltic.", "0"],
["peristilo", "peristil-o", "[OA] peristyle, row of columns surrounding building or space: space so surrounded.", "0"],
["peritoneo", "peritone-o", "[UV] (anat) periton/eum. <B>~ito</B>, -itis.", "0"],
["perkalo", "perkal-o", "(tex) percale, cotton cambric, cambric muslin (plain woven cotton fabric, finer and wider than calico). ➞ <I>kalikot, muslin</I>.", "0"],
["perknoptero", "perknopter-o", "Egyptian vulture, Pharaoh’s chicken (<I>Neophron percnop- terus</I>) (Le 11/18).", "0"],
["perko", "perk-o", "[UV] (ich) perch (<I>Percd</I>). ➞ <I>pert</I>.", "0"],
["perkolati", "perkolat-i", "(<I>-n</I>), Percolat/e, drain, filter, lixiviate, strain. <B>~o</B>, -ion. <B>~iĝi</B>, p., ooze through. ~ilo, -or.", "0"],
["perkuti", "perkut-i", "Percuss, tap (strike lightly and sharply). <I>2</I> (med) p., sound (<I>pacienton</I>). <B>~(ad)o</B>, -ion, impact. <B>~ilo</B>, hammer, plunger, striker. <B>~instrumento</B>, (mus) -ion instrument. ➞ <I>dab, frapet</I>.", "0"],
["perlamoto", "perlamot-o", "[UV] mother of pearl, nacre (2 FA 1/10).", "0"],
["perlo", "perl-o", "[UV] Pearl. <B>1</B> from mollusc. <B>2</B> similar obj, e.g., larmo, rosguto. <B>3</B> (bido), bead, bugle, <B>f</B> finest example of its kind, precious thing: <I>La ~o de la kolekto. Ĵeti ~ojn antaŭ porkojn</I>. <B>~kolora</B>, <B>-y</B>. ~aj dentoj. <B>~a</B> <I>roso</I>. form pearls, bead, glisten. <I>Larmoj ~is el ŝiaj okuloj; ŝvito ~is sur lia frunto</I>. <B>~grizaj</B> gantoj. ➞ <I>gem</I>.", "0"],
["permesi", "permes-i", "(<I>-n, al, ke</I>) [UV], Allow, Let, Permit. <B>1</B> consent, give (grant) leave, suffer: <I>al mi diri (ke mi diru</I>), let me say. <I>~u</I>! Excuse me! <I>~i nenian escepton,</I> admit of (brook) no exception. <I>Se Dio ~os</I>, God willing. <B>2</B> authorize, empower, warrant. <B>~o</B>, permission, leave, liberty, licence (to do), <I>Peti, ricevi ~on</I>. <B>Ĉas~o</B>, game licence. <B>Enir~o</B>, (mar) clearance inwards. <B>Pas~o</B>, pass(port), safe conduct. <B>Vetur~o</B>, p. <B>~a</B>, permissive. <I>Ĉu estas</I> <B>~ate</B> <I>fumi? (Ĉu licas fumi?</I>) May one (Is one a-ed to) smoke? <B>~ebla</B>, permissible. <B>for~i</B> (<I>iun</I>) [UV], a. to go, dismiss, grant leave of absence, 1. off (duties). ~<B>~o</B>, leave of absence, discharge, furlough, <I>Peti ~~on ĉeesti funebron</I>. (mar) clearance. <B>Mal~i</B>, forbid, interdict, prohibit. <I>Mi ~~as al vi kanti (~~mi ~~as, ke vi kantu;</I> but some say that <I>ke ~u</I> shows desire, not prohibition). ~<B>~o</B>, prohibition, veto. <I>Frukto ~~ita estas plej bongusta</I>. ➞ <I>konsent, las</I>.", "0"],
["permio", "permi-o", "(geol) permian (period),", "0"],
["permuti", "permut-i", "Permut/e, vary order or sequence of letters, numbers, etc. <B>~(ad)o</B>, <B>~(aĵ)o</B>, -ation. <B>~ebla</B>, interchangeable.", "0"],
["pernio", "perni-o", "(<I>frostabsceso</I>), chilblain.", "0"],
["perniso", "pernis-o", "(<I>abelbuteo</I>), (orn) honey-buzzard (<I>Pernis apivorous</I>).", "0"],
["perodikto", "perodikt-o", "(zoo) potto (<I>Perodietus potto</I>). ➞ lor is.", "0"],
["perono", "peron-o", "[UV] <B>1</B> (flight of) steps (before building), front steps. <I>Domo kun ~o</I>. <B>2</B> (ry) loading platform. ➞ <I>kaj, platform</I>.", "0"],
["perpendikla", "perpendikl-a", "perpendicular, at root angles to plane of horizon, or to given line or base; erect, upright. ➞ <I>vertikal</I>.", "0"],
["perpleksi", "perpleks-i", "Perplex, bewilder, confuse, mystify, non-plus, puzzle. <B>~o</B>, -ity, bewilderment, dilemma, entanglement, quandry. <B>~ita</B>, -ed, hesitating between opposing decisns. <B>~a</B>, complicated, intricate. ➞ <I>dubig, embaras, konfuz</I>.", "0"],
["persekuti", "persekut-i", "[UV] <B>1</B> Persecut/e, pursue with enmity and injury, torment: <I>~i la Kristanojn</I>. <B>~o</B>, -ion. <B>2</B> chase, follow after, hunt, pursue: <I>Ĉasisto ~as leporon, vulpon. Malvirtulo kuras, kiam neniu ~as</I> (Se 28/1). <I>~i malamikon</I> (Ge 14/14); <I>pajleron</I> (Ij 13/25). <B>3</B> (<I>ĝeni</I>) harass, harry, pester: <I>Rememoroj (timoj, sonĝoj) min ~as</I>. <B>4</B> (jur) <I>leĝe ~i (procesi kontraŭ</I>): proceed against, prosecute, take action, sue. <I>Juĝa ~isto</I>, public prosecutor. ➞ <I>ĉas, pel, postsekv</I>.", "0"],
["persieno", "persien-o", "persienne, (outside window- blind with light slanting slats). ➞ <I>jaluzi</I>.", "0"],
["persikario", "persikari-o", "spotted persicaria, peach-wort, red shanks (<I>Polygonum persicaria) &lt; poligon</I>.", "0"],
["persiko", "persik-o", "[UV] Peach, fruit of ~arbo, p-tree (<I>Persica</I>). ➞ <I>nektarin</I>.", "0"],
["persimono", "persimon-o", "persimmon, Virginian date plum (<I>Diospyros virginiana</I>). ~arbo.", "0"],
["persisti", "persist-i", "[UV] persist, (<I>iu</I>): be steadfast, continue firmly or obstinately in course, keep on -ing, peg away (especially in spite of remonstrance). <I>~i ĉe opinio; en eraro; kanti. (io</I>): continue in existence, endure, remain. <I>La moro, odoro ankoraŭ ~as</I>. <B>~(ad)o</B>, <B>~(ec)o</B>, -ence, tenacity. <B>~(em)a</B>, -ent, constant, dogged, pertinacious, tenacious, persevering, steadfast. <I>~a parfumo</I>, lasting perfume. <I>~a pluvo,</I> steady rain, (chem) stable, (mus) <I>~a noto (pedalo</I>), pedal note. <I>~a ritmo</I>. <B>~aĉa</B>, contumacious, obdurate, obstinate, perverse. <B>Mal~a</B>, by fits and starts. <B>Ne~ema</B>, irresolute, vacillating. <I>~~ulo,</I> trifler. Ĉp <I>daŭr, insist, obstin, senĉes</I>.", "0"],
["persono", "person-o", "[UV] Person. <B>1</B> individual, human being, one: <I>~oj, kiuj ne komprenas. Tria ~o (krom~o</I>), third party. <B>2</B> (jur) legal entity. <B>3</B> (gram) <I>unu, dua, tria ~o</I>. <B>4</B> (th) character. <B>5</B> (<I>memo</I>), own self: <I>Via kara ~o</I>, your own dear self. <B>6</B> (thl) mode of divine being: <I>Unu Dio en tri ~oj</I>. <B>~a</B>, [UV] -al, individual, private. <I>~a aludo, intervjuo, opinio, pronomo, propraĵo. ~a kolumno en gazeto. (Propra</I>)<B>~e</B>, -ally, in p. <I>Mi konas lin ~e (mi mem konas lin</I>). <B>~aĵo</B>, <B>~eco</B>, -ality; -al affair (character, trait), <B>~aro</B>, -nel, staff, (th) (<I>~oj</I>), characters in the play. <B>~ego</B>, -age, \"V.I.P.\" <B>~etoj</B>, small fry. <B>~igi</B>, <B>~iĝi</B>, -ify, act the part of, im-ate, simulate. <B>~favora</B>, partial. <B>Ne~a</B>, <B>Sen~a</B>, im-al. ➞ <I>hom, individu, iu, propr</I>.", "0"],
["perspektivo", "perspektiv-o", "[OA] Perspective. <B>1</B> (des) <I>la reguloj de ~o</I>. <B>2</B> mental point of view, proportion, sense of values: <I>Vidi laŭ ĝusta (vera) ~o</I>. <B>3</B> prospect, view, vista: <I>De tie oni ĝuas belan ~on. Bird~o</I>, bird’s eye view. ➞ <I>horizont, panoram, pejzaĝ, vidaĵ</I>. <B>f</B> (future prospect): <I>neatenditaj ~oj</I> (M 145/24). <I>~o konsola, nova</I>. <B>~a</B>, <B>~e</B>, in p., in view. <I>Entrepreno</I> <B>sen~a</B>, dead end, without hope.", "0"],
["persvadi", "persvad-i", "(-n, <I>al, ke, -i</I>), Persua/de, bring (win) over. <B>1</B> convince (satisfy) (of fact, that the thing is so). <B>2</B> induce (prevail on) (to do): <I>~i iun al ago. ~i al iu, ke li edziĝu. ~i lin edziĝi. ~o,</I> persuasion. <B>~a</B>, -sive, cogent, convincing, wiring. <I>~a elokvento, rideto</I>. <B>Mal~i</B>, argue out of, p. not to do. ➞ <I>konvink</I>.", "0"],
["perturbi", "perturb-i", "Perturb. <B>1</B> agitate, discompose, disturb, distress, trouble. <B>2</B> confuse, disorder. <B>~o</B>, -ation, commotion, confusion, disquiet. <I>Atmosfera ~o</I>, atmospheric disturbance. Radia <B>~o</B>, atmospheric. (astr) Orbita <B>~o</B>, -ation. <B>~iĝi</B> (<I>havi ~on</I>).", "0"],
["peruko", "peruk-o", "[OA] (peri)Wig. <B>~isto</B>, w-maker. <B>~hava</B>, be-ged.", "0"],
["Peruo", "Peru-o", "[OA-8] PE.", "0"],
["perversa", "pervers-a", "(<I>kontraŭema</I>), Pervers/e, persistent in error, or against what is reasonable or weight of evidence; peevish, wayward. <B>~eco</B>, -ity. <I>Koro</I> ~a (Ps 101/4). <B>~ulo</B> (Se 3/32, 12/8).", "0"],
["perverti", "pervert-i", "Pervert, turn aside from its proper use, misapply, misconstrue; lead away from right opinion or conduct. <B>~ita</B>, distorted. <B>~igi</B>, corrupt, warp. <B>~(ul)o</B>, pervert, &gt; apostate, homosexual.", "0"],
["pesaro", "pesar-o", "(med) pessary.", "0"],
["pesi", "pes-i", "(<I>-n</I>), [UV] Weigh, find the Weight of. <I>~i bebon, leteron, pakaĵon. ~i mane,</I> feel the weigh of, poise in the hand, <B>f</B> consider (estimate) the value or importance of. <I>~i ĉiun vorton, la ŝancojn</I>. <B>~(ad)o</B>, -ing. <B>~ejo</B>, -ing house. <B>~ilo</B> [UV] (<I>~maŝino</I>), Balance, Scales, -ing machine. <B>Leter~ilo</B>. Malvera ~ilo (Se 20/23). <B>Prov~il(et)o</B>, essay scales. <B>Risorta ~ilo</B>, spring s. <B>~ilo vekta</B>. <I>~ila pelvo, taso, telero</I>, pan (of scales). <B>Ne~ebla</B>, imponderable. ➞ <I>pez</I>.", "0"],
["pesimismo", "pesim/ismo", "[OA] pess/imism. <B>~isto</B>, [OA] -ist, croaker.", "0"],
["peso", "", "<B>peseto</B>, peso, peseta (coins).", "0"],
["pesto", "pest-o", "[UV] Pest. Plague. <I>Bruta ~o,</I> cattle pi, murrain. <I>Nigra ~o</I>, bubonic p. <B>2</B> s-o (something) troublesome, bane, curse, infliction, nuisance, <I>Li estas vera ~o</I>. ~(odon)a, -iferous, -ilent, infected, malignant, pi-stricken. ~ejo, p-house. ~ulo,pl-stricken person. (col)-on! Plague on it! ➞ <I>epidemi, holer, infekt, plag</I>.", "0"],
["petalo", "petal-o", "(<I>florfolio</I>), Petal. <B>Unu~a</B>, monopetalous.", "0"],
["petardo", "petard-o", "[OA] petard, demolition charge, detonating cartridge, (ry) detonator, fog signal. <B>~eto</B>, banger, cracker, squib. <B>~i</B>, blast, blow up.", "0"],
["petazito", "petazit-o", "butterbur (<I>Petasites</I>). Odora <B>~o</B>, winter heliotrope, petiol-o, petiole, leaf-stalk, petit-literoj, (typ) 8-pt, brevier.", "0"],
["peti", "pet-i", "(<I>-n, por, pri, ke</I>) [UV]<I>:</I> Ask (as a favour). ➞ <I>PETition</I>. <B>1</B> (<I>ion</I>): Ask for: <I>~i helpon, informon, konsilon, permeson. ~i pardonon</I>, apologise. <I>Kiu ne</I> ~as, <I>tiu ne ricevas</I>. <B>2</B> (<I>iun</I>): ask someone to do something: <I>Sidiĝu, mi ~as</I>, please (pray) sit down. <I>Li ~is min iri (ke mi iru). ~u lin (veni) al mi</I> (E/26). <B>~o</B>, request, etc. <I>Edziĝa ~o. Insista ~o</I>. <B>~adi</B>, badger, importune, pester. <B>~anto</B>, applicant, petitioner. <B>~egi</B>, [UV] appeal, beseech, entreat, plead. <I>~eganto,</I> suppliant. <B>El~i</B>, get by entreaty. <B>Almoz~ado</B>, begging, mendacity. <B>Inform~i</B>, request for information. <B>Plor~i</B>, implore (beseech with tears). <B>Pro~i</B>, intercede. <I>~~anto</I>, advocate, intercessor. <B>Tro~ema</B>, bothersome, exacting, harassing. ➞ <I>demand, postul, preĝ</I>.", "0"],
["petoli", "petol-i", "[UV] frisk, frolic, gambol, play pranks, ramp, sport. <I>La hundo ~is ĉe niaj piedoj. Juneco ~is, maljuneco malsatos. Ne ~u!</I> Be sensible! <B>~a</B>, frisky, frolicsm. in high spirits, mischievous, playful, roguish, wanton. <I>~a konduto, mieno</I>. ~aĉi, play the fool (giddy goat). <B>~aĵo</B>, escapade, game, lark, prank, spree, trick. <B>~eco</B>, mischief. ~ema, impish, haughty, playful, rollicking. f <I>~emaj haroj</I>. <B>~ulo</B>, joker, etc. <I>~uleto</I>, little rascal. <I>~ulino</I>, romp, tomboy.", "0"],
["petrelo", "petrel-o", "(<I>ŝtormbirdo</I>), petrel, especially. <B>1</B> mother Cary’s chicken (<I>Hydrobates</I>). 2 (ordinary language) name for many similar birds. ➞ <I>fulmar, fraterkol, procelari</I>.", "0"],
["petrolo", "petrol-o", "[UV] Petroleum (wide sense). <B>1</B> (<I>kruda ~o</I>), crude mineral oil (<I>nafto</I>). <B>2</B> (<I>lampa ~o, lampoleo, keroseno</I>): paraffin (lamp) oil, kerosene. Rafinita ~o (<I>benzino</I>), motor spirit, petrol (for car) (Am: gasoline). ~a <I>ĝelo</I>, p. jelly (<I>vazelino). ~a fornelo (kuirilo</I>), oil cooker stove. <I>~a lampo</I>, paraffin lamp. ➞ <I>benzin, kerosen, parafin</I>.", "0"],
["petrologio", "petrolog-io", "<B>~o</B>, petrolog-y, -ist.", "0"],
["petromizo", "petromiz-o", "[UV] (ich) (sea) lamprey (<I>Petromyzori</I>). Rivera ~o ( = <I>lampetro</I>).", "0"],
["petroselo", "petrosel-o", "[UV] parsley (<I>Petroselinum</I>).<B>~a <I>saŭco</I></B>. ➞ <B><I>api</I></B>.", "0"],
["petunio", "petuni-o", "(bot) Petunia (<I>Petunia</I>).", "0"],
["pezi", "pez-i", "(nt), [UV] Weigh, have Weight, be Heav/y. 67 <I>~as du funtojn. Kiom vi ~as nuntempe?</I> <B>f</B> be burdensome, w. down, lie h-ily. <I>Tio ~as sur mia koro. Malgaja sorto ~is sur li</I>. <B>~o</B>, weight, burden, load. <I>Fali sub ~o. Malgranda ~o, sed granda prezo</I>. <B>Atoma ~o</B>, atomic wt. ~o kuntara (<I>malneta</I>), gross wt. ~o sentara (<I>neta</I>), nett wt. Specifa <B>~o</B>, specific gravity. <B>Sxip~o</B>, displacement, tonnage. <B>Tro~o</B>, excess wt. (sp) <B>Muŝ~o</B>, fly-wt. <B>f</B> emphasis, influence. <I>La ~o de laboro, de jaroj</I>. <B>~a</B>, h., weighty, momentous, important, influential, of conseqce. <I>~a kiel plumbo. Pli ~a ol fero. t ~a koro, paŝo, vetero. (grava, teda): ~a sorto (stilo</I>). (chem) <I>~a hidrogeno. Fali</I> <B>~e</B> <I>al la tero. Kuŝi ~e sur la menso</I>. <B>~aĉa</B>, lubberly, lumpish, unwieldy. <B>~aĵo</B>, something h. <I>~aĵe</I>, flop! plump! <B>~ega</B>, ponderous. <B>~igi</B>, w. down. <I>La pluvo ~igis la velojn</I>. <B>~ilo</B>, [UV] wt (for clock, scales, etc.). <I>~ilo dufunta. Neegalaj ~iloj</I> (Se 20/23). <I>Jxet~ilo</I>, casting lead, plummet. <B>Kontraŭ~(il)o</B>, counterpoise. <B>Mal~a</B>, light. <I>~~a paŝo (ŝarĝo). ~~a kiel aero. ~~igi</I> (ease, lighten) <I>la koron</I>. ➞ <I>delikat, facil</I>. <B>Pli~o</B>, <B>super~o</B>, <B>tro~o</B>, excess-wt, over-wt. <B>Sen~a</B>, light, wt-less. <B>Super~o</B>, predominance. <I>~~i,</I> overwhelm. <B>Sur~i</B>, w. upon, burden, encumber. <B>Egal~o</B>, balance, equilibrium, equipoise. <I>~~i</I>, counter-balance. ➞ <I>pes</I>.", "0"],
["pfenigo", "pfenig-o", "[F], (num) pfennig.", "0"],
["pia", "pi-a", "[UV] Pious, Righteous: devout, God- fearg, godly, religious, upright. <I>~a koro</I> (Ps 7/10). <I>Pura kaj ~a</I> (Ij 8/6). <I>Vivi</I> <B>~e</B> (Se 2/7). <B>~o</B> (Se 2/9). <B>~aĉa</B> (<B>~afekta</B>), canting, hypocritical, sanctimonious. <B>~eco</B> (Ho 6/4), piety. <I>Peli ~econ ĝis bigoteco. Se ezoko</I> <B>~iĝis</B>, <I>gobio ne dormu</I>. <B>~ulo</B>, righteous person (Pr 3/17). <I>Inter ~uloj ne mankas pekuloj</I>. <B>Mal~a</B>, im-p, un-r., godless, irreligious, profane. <I>~~ulo</I>, wicked person. ➞ <I>religi</I>.", "0"],
["piano", "pian-o", "[OA] (abbreviation of <I>fortepiano</I>), Piano (forte). ~o horizontala (grand), vertikala (upright, cottage). <B>Strat~o</B>, barrel organ. <B>~ist(in)o</B>, -ist.", "0"],
["pianolo", "pianol-o", "(<I>aŭto~o</I>), pianola, p-player. ➞ <I>gurd</I>.", "0"],
["piastro", "piastr-o", "[OA] (num) piastre,", "0"],
["pibroĥo", "pibroĥ-o", "pibroch, lament, or variations, for bagpipes.", "0"],
["piceo", "pice-o", "[UV] Spruce flr (<I>Picea</I>). <B>Glaŭka ~o</B>, white s. <B>Norvega ~o</B> (<I>P. abies</I>), Norway s., Christmas tree. <B>Ruĝa ~o</B>, red s. <B>Sitka ~o</B>, Sitka s. (<I>P. sitchensis</I>). ➞ <I>abi, pin</I>.", "0"],
["piĉo", "piĉ-o", "(<I>absoluta sonalto</I>), (ac) Pitch. <I>Konservi, levi, teni, perdi la ~on</I>. ~iloj: (a) <B>~forko</B> (<I>tonforko</I>), tuning-fork, (b) <B>~tubo</B>, p-pipe. <B>~normo</B>, standard p. (A = 440 <I>vibroj sekunde</I>). <B>Rim</B>.: In this book vibration numbers are calculated by \"equal temperament\" from A = 440. <B>Ali~igi</B>, (<I>mal)levi la ~on</I>. <B>Alt~a</B> <I>piano. Klarnetoj estas divers~aj. Kanti</I> <B>sub~e</B>, <B>super~e</B>, sing flat (sharp). ➞ <I>aligamig, transpon</I>.", "0"],
["piedestalo", "piedestal-o", "[UV] pedestal, base of column (bust, etc.). ➞ <I>baz, sokl</I>.", "0"],
["piedo", "pied-o", "[UV] <B>1</B> Foot, hoof; <I>De kapo ĝis ~oj</I>, from head to f. f <I>~oj el argilo</I> (Da 2/33). <I>Sin ĵeti al ies ~oj. Havi ~on en la tombo</I>. <B>2</B> base on which something stands: peg (of cello); leg (of chair, table, piano); stem (of glass). <B>3</B> bottom part: <I>~o de paĝo, kolono, lito</I>. <B>4</B> (pros) foot of verse. <B>~a</B> <I>promeno</I>, ramble, tramp, walk. <B>~e</B>, afoot, on foot. <I>Malfeliĉo venas rapide, foriras ~e. ~e de</I> (at the foot of) <I>monto (Sxtuparo</I>). <B>~ego</B>, huge paw. <B>~eto</B>. <B>~ingo</B>, [UV] stirrup (horse), (cy) toe-clip. <B>~bati</B>, <B>~frapi</B> (a. <I>kiki</I>), kick. <B>~iranto</B>, f-passenger, pedestrian. <B>Sur~igi</B>, put on (shoe). <B>Du~ulo</B>, <B>kvar~ulo</B>, biped, quadruped. <B>Mil~ulo</B>, (zoo) millipede. <B>Nud~a</B>, bare footed. <B>Plat~a</B>, flat-ed. <B>Rapid~a</B> (Ij 9/25). <B>Tri~o</B>, tripod. ➞ <I>fut, instep, sub</I>.", "0"],
["pierido", "pierid-o", "(<I>brasika papilio</I>), white (cabbage) butterfly (<I>Pieris</I>).", "0"],
["piero", "pier-o", "(marponto, promena ĝeto), pier. ➞ <I>pilier</I>.", "0"],
["pieroto", "pierot-o", "(pantomine) pierrot.", "0"],
["pieto", "piet-o", "affectionate devotion, reverence, or veneration (to parents, country, etc.). <B>~ismo</B>, <B>~isto</B>, pietism, pietist.", "0"],
["pigmento", "pigment-o", "<B>1</B> (bio) pigment, cirg-matter. <B>2</B> colour powder, e.g., <I>okro</I>.", "0"],
["pigmeo", "pigme-o", "[OA] pygmy, dwarf. ➞ <I>nan</I>.", "0"],
["pigo", "pig-o", "[UV] magpie (<I>Pica</I>).", "0"],
["pigra", "pigr-a", "= maldiligenta, mallaborema.", "0"],
["piĝino", "piĝin-o", "pidgin. <B>1</B> p-English, p-French, etc. <B>2</B> crude simplified jargon for foreigners, e.g., Basic English.", "0"],
["piĵamo", "piĵam-o", "(cl) pyjamas.", "0"],
["pikedo", "piked-o", "[UV] <B>1</B> picket, camp guard, outpost, sentry, etc. <B>2</B> (cgm) piquet.", "0"],
["piki", "pik-i", "(<I>-n</I>), [UV] Prick. <B>1</B> pierce slightly, puncture: <I>~i bobelon, fingron</I>. <B>2</B> goad, spur: <I>~i ĉevalon per sprono</I>. <B>3</B> bite, sting: <I>Insekto ~as</I>. <B>4</B> make smart, tickle: <I>Frosto ~as vizaĝon, mustardo palaton, vento okulojn</I>. <B>5</B> gird at, nettle, touch on the raw, pique: <I>Reciproke sin ~i. Min ~as dubo</I>. ➞ <I>inciteti, ofendeti, vundeti</I>. <B>~(em)a</B>, -ly, pointed, sharp; bantering, biting, cutting, scoffing, stinging, caustic, piquant, pungent, <I>~a ironio, rimarko</I>. <B>~o</B>, <B>1</B> prick(ing), sting, <I>~o de konscienco</I>. <B>f</B> <I>senti ~on</I>, feel pique. <I>Per vorta ~o ofte perdiĝas amiko</I>. <B>2</B> (cgm) pip, spade, (mus) dash, denotes staccatissimo. <B>~(et)ado</B> (<I>sento</I>), pins and needles, tingling. <B>~e</B> <I>kaj tranĉe</I>, with cut and thrust. <B>~aĵo</B>, barb, prong, spike, thorn, <I>~aĵa</I>, barbed. <B>~eco</B>, pointedness. <B>~eti</B>, irritate, peck, etc. <B>~ego</B>, stab. <B>~ilo</B>, [UV] -er, awl, goad, (hedgehog) quill, <I>~o ŝraŭbepinta</I>, gimlet. <I>Dent~ilo</I>, tooth-pick. <I>Sag~ilo</I>, dart. <I>~ileto</I>, prickle, sting, <I>~ilego</I>, pike. ➞ <I>halebard, lane. La korvo</I> <B>el~is</B> <I>lian okulon</I>. <B>En~i</B>, jab, prod. <I>En~ita (tatuita) desegno</I>. <B>Sen~ila</B>, stingless. <B>Tra~i</B>, pierce, puncture, run through, transfix. <I>~~a</I>, penetrating, piercing. <I>~~iĝi</I>, have a puncture, <I>~~ilo (~bastono</I>), skewer, spit. <B>Glav~o</B> (~puŝo), sword thrust. <B>Korno~i</B>, gore. <B>Mort~i</B>, stab to death. ➞ <I>dorn, penetr, pine</I>.", "0"],
["pikniko", "piknik-o", "picnic.", "0"],
["pikra", "pikr-a", "<I>acido</I>, Picr/ic acid. <B>~ato</B>, -ate.", "0"],
["pikriso", "pikris-o", "(bot) bristly ox-tongue (<I>Picris</I>).", "0"],
["pilafo", "pilaf-o", "(cul) pilaff, pilaw (dish of rice with meat, spice, etc.).", "0"],
["pilastro", "pilastr-o", "[OA] (arch) pilaster. <B>Apog~o</B>, abutment, buttress. <B>Pordaj ~oj</B>, gateway piers. <B>Ŝtupara ~o</B>, newel.", "0"],
["pilĉardo", "pilĉard-o", "(ich) pilchard, sardine (<I>Pilchardus</I>). ➞ <I>anĉov, sardel, sardin</I>.", "0"],
["pilgrimi", "pilgrim-i", "[OA] go on (make) a Pilgrim/age. <B>~(ad)o</B>, -age. <B>~anto</B>, <B>p</B>.", "0"],
["piliero", "pilier-o", "pillar (column) of masonry, pier, support or spans of bridge or arch.", "0"],
["pilko", "pilk-o", "[UV] <B>1</B> (playing) Ball, solid or rubber, e.g., for golf, tennis, football. <B>2</B> name of game using this. <B>Akvo~o</B>, water-polo. <B>Baz~o</B>, base-b. <B>Hejm~o</B> (<I>rondkuro</I>), rounders. <B>Korbo~o</B>, basket-ball. <B>Pied~o</B> (<I>futbalo</I>), foot-b. <B>Ret~o</B>, volley-b. <B>~frapilo</B> (<I>rakedo</I>). <B>~ludo</B>, b-game. ➞ <I>netbal, volan</I>. <B>2</B> bulb (of inhaler, etc.) <B>~o</B> <I>klistera</I>.", "0"],
["pilo", "pil-o", "[OA] (el) Pile, Battery cell. <B>Atoma ~o</B>, atomic pile. <B>Seka ~o</B>, dry b. <B>~aro</B>, multicell b. <I>[Ne= amaso]</I>.", "0"],
["pilolo", "pilol-o", "[UV] Pill. <B>~ego</B>, bolus. <B>~eto</B>, -ule. <B>~skatolo</B>, p-box. ➞ <I>draĝeo</I>.", "0"],
["pilono", "pilon-o", "pylon. <B>1</B> of Egyptian temple. <B>2</B> mast, tower, for boundary, or cable support. ➞ <I>mast, tur</I>.", "0"],
["pilorio", "pilori-o", "Pillory. <I>Pied~o</I>, stock. <B>~i</B>, p. <B>f</B> expose to ridicule. <I>~ata de la publiko</I>.", "0"],
["piloto", "pilot-o", "[UV] <B>~i</B>, Pilot, <B>~ado</B>, -ing. <B>~fiŝo</B> (<I>naŭkrato</I>), p-fish. <B>~pago</B>, -age. <B>~ŝipo</B>, p-boat.", "0"],
["pilulario", "pilulari-o", "(bot) pill wort (<I>Pilularia</I>). piment-o, (cul) all-spice, the powdered fruit of <B>~arbo</B>, the a-s tree (<I>Pimenta officinalis</I>). ➞ <I>kapsiko</I> (sometimes misnamed <I>pimento</I>).", "0"],
["pimpa", "pimp-a", "chic, dainty, smart, spruce, spick and span, trim.", "0"],
["pimpinelo", "pimpinel-o", "(bot) burnet saxifrage (<I>Pimpinella saxifraga</I>).", "0"],
["pinaklo", "pinakl-o", "(<I>pinta kronaĵo</I>), (arch) pinnacle, <B>f</B> peak, culmination.", "0"],
["pinakoteko", "pinakotek-o", "art museum, picture gallery.", "0"],
["pinao", "pina-o", "(zoo) fan mussel (<I>Pinna</I>).", "0"],
["pinaso", "pinas-o", "(mar) pinnace,", "0"],
["pinastro", "pinastr-o", "(<I>ĉemara pino</I>), cluster (maritime) pine (<I>Pinus pinaster</I>).", "0"],
["pinĉi", "pinĉ-i", "[UV] Pinch, squeeze. <I>La papago ~is mian fingron. Jen kie la ŝuo ~as</I>. <B>f</B> <I>la maharmo ~as</I>, there is a nip in the air. <B>~(aĵ)o</B>, <B>~(pren)o</B>, p. (of salt, etc.). <B>~eti</B>, nip. <B>~ilo</B>, pliers; (crab) claw, nipper; cycle-(paper-tie-)clip; (sugar) tongs. <B>Pri~i</B> <I>ŝtrumpon</I> (peck) (4 FA 30/5). <B>Drat~ilo</B>, wirecutter. <B>Naz~ilo</B>, pince-nez. <B>Tol~ilo</B>, clothes peg. <I>~ileto, ~tenilo,</I> <B>nippers, tweezers. ➞ <I>pluk, tenajl</I></B>.", "0"],
["pingikolo", "pingikol-o", "(<I>grasherbo</I>), (bot) butterwort (<I>Pinguicula</I>).", "0"],
["pinglo", "pingl-o", "[UV] Pin. <I>Eĉ ~o povas koron trapiki</I>. <B>f</B> <I>Sidi kvazaŭ sur ~oj</I> (K 131/9). <B>Ĉapela ~o</B>, hat-p. <B>Friz~o</B>, haircurler. <B>Halt~o</B>, stop-p. <B>Har~o</B>, hair-p. <B>Kravata ~o</B>, tie-p. <B>Perkuta ~o</B>, firing-p. <B>Pin~o</B>, pine needle. <B>Puŝ~o</B>, drawing p. <B>Sendanĝera ~o</B> (<I>fibolo</I>), safety-p. ~a <I>kapo, kuseno, truo</I>. <B>~i</B> (<I>~ofiksi</I>), p. <B>~ego</B>, (mar) belaying-p. <B>~ujo</B>, pincase, pintray. <B>~oludo</B>, (gm). <B>Al~i</B>, p. up (Rz 20/5). <B>Mal~i</B>, unpin.", "0"],
["pingveno", "pingven-o", "Penguin (many species) <B>Adelia ~o</B>, Adelia p. <B>Granda (imperiestra) ~o</B>, Emperor p. <B>Reĝa</B> <B>~o</B>, king p. <B>~eto</B>, little (or blue) p.", "0"],
["pinikolo", "pinikol-o", "(<I>pina dikbekulo</I>), (orn) pine grosbeak (Pinicola). ➞ <I>pirol</I>.", "0"],
["pinio", "pini-o", "[UV] (<I>nuksa pino</I>), umbrella pine (<I>Pinus pined</I>). Its seeds are our \"pine kernels\" (<I>pinsemoj</I>). ➞ <I>cembr</I>.", "0"],
["pinjono", "pinjon-o", "gable. ➞ <I>gabl</I>.", "0"],
["pino", "pin-o", "[UV] Pine (tree) (<I>Pinus</I>). Alepa <B>~o</B>, Aleppa p. Blankŝela <B>~o</B>, Bosnian p. (<I>P. leucodermis</I>). Monta ~o (a. <I>mugo</I>), mountain or Mugho p. (<I>P. montana</I> or <I>P. mugo</I>). Nigra <B>~o</B>, Black or Austrian p. (<I>P. nigra</I>). Silvestra ~o (<I>silvestro</I>), Scots p., \"Scots fir\" (<I>P. sylvestris</I>). ~a <I><SUP>f</SUP>rukto (strobilo</I>), p-cone. ~acoj, p-fam.. <B>~aro</B>, <B>~ejo</B>, p-forest, pinetum. <B>~ligno</B> (<I>abia ligno</I>), deal. ➞ <I>cembr, duglasi, palustr, pinastr, pini, strob</I>.", "0"],
["pinto", "pint-o", "[UV] Point, extremity, sharp end. <I>~o de cirkelo, glavo, pinglo, plumo;</I> apex, peak, summit (<I>de monto). Vidi nur ĝis la ~o</I> (tip) <I>de sia nazo</I>. <B>Mam~o</B>, dug, nipple, pap, teat. <B>Ter~o</B>, promontory. <B>Tur~o</B>, spire. <B>~a</B>, peaked, sharp. <I>~a ŝtono, mentono</I>. <B>~ego</B>, spike. <B>~igi</B>, sharpen, taper off. <I>~igi krajonon;</I> cock, prick up (<I>orelojn</I>), purse (<I>lipojn</I>). <B>~ingo</B>, ferrule, tip (<I>ombrelo</I>); p-protector, sheath. <B>Sen~a</B>, blunt, pug, snub. <I>~~igi,</I> blunt, break the p. of. <B>Du~a</B> (<I>dento</I>), bicuspid. <B>Pied~e</B>, on tiptoe. ➞ <I>ekstremaĵ, kulmin, supr, pik, poent, punkt</I>.", "0"],
["pioĉo", "pioĉ-o", "[OA] (<I>pikfosilo</I>), Pick(axe) (Jes 7/25). <B>~o larĝa</B>, platlamena, mattock. <B>~i</B>, dig with p. ~eto (<I>sark~o</I>) (Vd Bulgara Esp-isto, Aprilo 1960).", "0"],
["pioniro", "pionir-o", "[UV] Pioneer, explorer, <B>f</B> person paving way for new idea. <I>~oj de nia movado</I>. ~a <I>laboro</I>. <B>~i</B>, (act as) p., open up road. ➞ <I>veteran</I>.", "0"],
["pioreo", "piore-o", "(med) pyorrhea.", "0"],
["pipeto", "pipet-o", "(pharm) pipette. ➞ <I>ampol</I>.", "0"],
["pipio", "pipi-o", "(a. <I>antuso</I>), (orn) Pipit (<I>Anthus</I>). <B>Akvo~o</B>, water p. <B>Arba ~o</B>, tree p. <B>Herbeja ~o</B>, meadow p. <B>Kampa ~o</B>, tawny p. <B>Ruĝgorĝa ~o</B>, red-throated p.", "0"],
["pipistrelo", "pipistrel-o", "pipistrelle bat (<I>Pipistrellus</I>).", "0"],
["pipo", "pip-o", "[UV] Pipe (for smoking). ~o <I>argila, rozligna. ~tubo</I>, p-stem. <B>Pac~o</B> (<I>kalumeto</I>), p. of peace. Plen~o <I>da,</I> p-ful. ➞ <I>tub</I>.", "0"],
["pipro", "pipr-o", "[UV] <B>1</B> Pepper, the powdered fruit of <B>~oplanto</B> (<I>Piper</I>). <B>~o blanka</B> (<B>nigra</B>). <B>~o kubeba</B>, cubeb. <B>~a</B> <I>grajno</I>, p-corn. <B>~eca</B>, peppery. <B>~ujo</B>, pepper-box, pepper-caster. <B>~i</B> (<I>-n</I>), p. ➞ <I>ment, paprik, piment</I>. <B>2 Ruĝa ~o</B>. ➞ <I>kapsik</I>.", "0"],
["pipso", "pips-o", "[UV] Pip, roup (disease of birds). <I>Suferi de ~o</I>, have the p. <B>f</B> be sulkily silent, have fit of bad temper (depressn).", "0"],
["piralido", "piralid-o", "knot-horn moth (<I>Pyralis</I>).", "0"],
["piramido", "piramid-o", "[OA] pyramid. <B>1</B> of Egypt. <B>2</B> solid of similar form.", "0"],
["pirato", "pirat-o", "[OA] (<I>mara rabisto</I>), Pira/te, bucaneer, marauder. <B>~i</B>, play the p., infringe another’s rights, encroach on recognised route. <B>~ado</B>, <B>~eco</B>, -cy. ~ita <I>eldono</I>, -ted edition. ➞ <I>kaper, korsar</I>.", "0"],
["piretro", "piretr-o", "(bot) pyrethrum (<I>Pyrethrum). ~a pulvoro</I>, insect powder from this, or from other plants.", "0"],
["pirito", "pirit-o", "[UV] pyrites (Fe S<SUB>2</SUB>). ➞ <I>gruz</I>.", "0"],
["piro", "pir-o", "[UV] Pear, fruit of ~arbo, p-tree (<I>Pyrus</I>). Ter~o (<I>helianto tubera</I>). Jerusalem artichoke. ~forma, p-shaped. ~ligno, p-wood. ~vino, perry.", "0"],
["pirogajla", "", "acido, (phot) pyrogallic acid (pyro).", "0"],
["pirogo", "pirog-o", "pirogue, canoe from hollowed tree-trunk.", "0"],
["pirokorako", "pirokorak-o", "(<I>monta korvo</I>), Chough (<I>Pyrrhocorax</I>). ~o flavbeka, Alpine (yellow-billed) c.", "0"],
["pirolo", "pirol-o", "[UV] <B>1</B> (orn) bullfinch (<I>Pyrrhula</I>). Karmina <B>~o</B>, rose finch, scarlet grosbeak (<I>Carpodacus erythrinus</I>). ➞ <I>pinikol</I>. 2 (bot) wintergreen (<I>Pyrola</I>). ➞ <I>gaŭlteri</I>.", "0"],
["pirometro", "pirometr-o", "pyrometer.", "0"],
["pirotekniko", "piroteknik-o", "Pyrotechnic/s. <B>~a</B>, -ic. <B>~aĵo</B>, firework. <B>~isto</B>, -ian.", "0"],
["pirozo", "piroz-o", "[UV] pyrosis, heart-burn, stomach acidity.", "0"],
["pirueti", "piruet-i", "-o, pirouette, spin round on one ft., or on point of toe.", "0"],
["pisi", "pis-i", "(<I>urini</I>), (col) piss, make water. <B>~ejo</B>. <B>~poto</B>.", "0"],
["pistako", "pistak-o", "[UV] pistachio, nut of <B>~arbo</B>, p-tree (<I>Pistacia</I>) (Ge 43/11).", "0"],
["pisti", "pist-i", "(<I>-n</I>), [UV] Pound; beat small, bray, bruise, crush, grind, pulvorize. <I>~i grajnojn de pipro, salo</I>. <B>~ilo</B>, pestle. <B>Sxton~isto</B>, stone breaker. <B>~ujo</B>, mortar. <I>~i malsaĝulon en ~ujo</I> (Se 27/22). <B>~maŝino</B>, crusher, grinder, stamping mill. <B>~miksi</B>, triturate. ➞ <I>disbat, frakas, muel, pulvorig</I>.", "0"],
["pistilo", "pistil-o", "[OA] (bot) pistil.", "0"],
["pistolo", "pistol-o", "[UV] Pistol. <B>Lubrika ~o</B>, grease- gun. <B>Lud~o</B>, <B>~eto</B>, toy-p. <B>~ujo</B>, p-case, holster. ➞ <I>farb, revolver</I>.", "0"],
["piŝto", "piŝt-o", "[UV] Piston, plunger (of force- pump). (mus) <I>~o de korneto</I>. (org) Kombin~o, pied~o, man~o, combination pistons. <I>Mergo~o</I>, plunger.", "0"],
["pitecio", "piteci-o", "saki monkey (<I>Pitecia</I>).", "0"],
["pitiriaso", "pitirias-o", "pityriasis, dandruff, scurf,", "0"],
["pitono", "piton-o", "python (<I>Python). ~o Malaja</I>.", "0"],
["pitoreska", "pitoresk-a", "(<I>pentrinda</I>), picturesque, striking, (of language) graphic, vivid. <I>~a sceno</I>.", "0"],
["pituitaria", "pituitari-a", "(med) pituitary. <I>~a glando</I>. ➞ <I>muk</I>.", "0"],
["pivoto", "pivot-o", "[OA] Pivot (El 26/17), axis, fulcrum (of lever), short pin or shaft on which something turns, spindle, (th) central figure. <I>Kruc~o</I>, gudgeon, socket. <B>~a</B>, pivotal, -ed. <I>~a argano</I>, revolving crane. <I>~a kanono</I>, swivel gun. (mus) <I>~a noto</I>. p-note. <B>f</B> <I>~a punkto</I>, turning-point (in history). <B>~i</B>, pivot, depend (hinge, turn) on. (mil) wheel. <B>~aĵo</B>, (org) backfall. <B>~ego</B>, crank-(link-pivot-swivel-)pin. <B>~ingo</B>, (<I>~a truo</I>).", "0"],
["pizo", "piz-o", "[UV] Pea (<I>Pisum</I>). <B>Granda ~o</B>, marrowfat. <B>Splitita ~o</B>, split pea. <B>Suker~o</B>, sugar p. <B>Verd~o</B>, green p. <B>Krak~o</B>, fulminating p. <B>~ejo</B>, p-field. <B>~ujo</B> (<I>= guŝo</I>) pea-pod. ➞ <I>kaĉ, kiker, latir, soj</I>.", "0"],
["Pizo", "Piz-o", "Pisa: <I>la oblikva turo de P~o</I>.", "0"],
["placento", "placent-o", "placenta, afterbirth (Rd 28/57). <B>~a</B>, -al.", "0"],
["placo", "plac-o", "[UV] <B>1</B> (public) Square. <B>2</B> open space, clearg, glade (2 FA 80/31). <I>~o Zamenhofa</I>. <B>Flug~o</B>, aerodrome. <B>Foira ~o</B>, market-place. <B>Kolona ~o</B>, piazza. <B>Parada ~o</B>, parade (ground). <B>Ŝtupara ~o</B>, landing. <B>~eto</B>, patch (3 FA 28/18). ➞ <I>kvadrat, lok</I>.", "0"],
["plaĉi", "plaĉ-i", "(<I>-n, al</I>) [UV], Pleas/e, be agreeable to, give pleasure, gratify, take the fancy of. <I>Tio min ~as (~as al mi</I>), I like it, it gives me -ure (Se 11/1, 20; 16/13). <I>Vi lin multe ~as</I>, he is greatly taken with you. <I>Tio ne ~as al mi</I>, it does not appeal to me, is little to my taste, I don’t care for it, It displeases me (Se 24/18). <I>Min ~as (Mi amas) iri</I>, J like going. <I>Se ~os al vi</I>, if you p. <I>Ĉu vin ~us (Ĉu vi volus) iri</I>, Would you care (like) to go? <I>Ĉesi ~i</I>, cease to p., pall upon. <B>~o</B>, pleasure, liking, satisfaction. <I>Akiri, trovi ~on</I>, find grace (favour) <I>en ies okuloj</I>. <B>~a</B>, agreeable, pleasant, pleasing, pleasurable, nice. <I>~a vizaĝo</I>. <B>~e</B> <I>bela (~aspekta</I>), comely, engaging, prepossessing. <B>~eco</B>, charm. <B>Laŭ~e</B> (<I>laŭ via ~o</I>), as you p., at p-ure. <B>Mal~i</B>, be disp ing (repugnant). <I>Ĉu ~~us al vi, se… ?</I> Would you mind (object)? <B>~~o</B>, displeasure. <B>~~a</B>, ill-favoured. <I>Palato</I> <B>~a</B>, palatable. ➞ <I>agrabl, ĉarm, favor, gust, kontent, plezur, ŝat</I>. Vd B.E. 1932, p. 198.", "0"],
["plado", "plad-o", "[UV] Dish, platter (container or contents), course (at a meal). <I>~o da terpomoj</I>. <B>~eto</B>, little dish, saucer. <B>~ego</B>, charger. <B>~levilo</B>, plate-hoist. <B>~varmigilo</B>, chafing dish. ➞ <I>plet, teler</I>.", "0"],
["plafono", "plafon-o", "[UV] ceiling, <B>f</B> maximum altitude, upper limit.", "0"],
["plagala", "plagal-a", "(mus) Plagal. ~a (amend) kadenco (IV-I). ~a modalo (submodalo), p. mode.", "0"],
["plagiati", "plagiat-i", "[OA] Plagiar/ize, crib, \"lift\", take (use) another’s thoughts (writgs) as one’s own. <B>~o</B>, -ism, literary theft, stolen expression. <B>~isto</B>, -ist, -y.", "0"],
["plago", "plag-o", "[OA] Plague, affliction, bane, calamity, curse, pest, scourge (Rd 28/59, 29/22). <I>La Egiptaj ~oj. ~on al ĝi!</I> p. on it! ~i (1 Kr 21 /17), harass, pester, ravage. <B>~a</B>, vexatious, <B>~ejo</B>, p-spot. <B>~ema</B>, <B>~oplena</B>, torment. <B>~eti</B>, be a nuisance, troublesome. <B>~iĝi</B>, be afflicted (stricken) with. <B>~ita</B>, (Jes 53/4). ➞ <I>aflikt, ĝen, pest, sufer, turment</I>.", "0"],
["plaĝo", "plaĝ-o", "bathing beach. ➞ <I>strand</I>.", "0"],
["plaki", "plak-i", "(<I>-n</I>), coat (cover) with, lay on (plaster); lay down (turf), overlay, plate, veneer. <I>~i oron per kupro, kupron per oro</I>. <B>~o</B>, plating, veneering, sheet (metal), slab (marble). <B>~(aĵ)o</B>, surface overlaid, (rad) <I>agorda (stacia) ~o</I>, tuning dial. <I>Fotografa ~o</I>, plate. Kruc<B>~i</B>, laminate. <I>~~aĵo</I>, plywood.", "0"],
["plando", "pland-o", "[UV] Sole <B>1</B> (of foot): <I>De la ~o de lia piedo ĝis lia verto</I> (2 Sa 14/25). <B>2</B> (a. ~umo) (of shoe): (H/57, K 117/9). <B>~ulo</B>, (zoo) plantigrade. Al<B>~o</B>, Sub<B>~o</B>, (cork sock to put in a shoe). Duon<B>~o</B>, half-s., clump. Re~i <I>ŝuon</I>.", "0"],
["planedo", "planed-o", "[UV] planet. <B>~eto</B>, asteroid.", "0"],
["planeo", "plane-o", "(av) aerofoil, wing, etc. <I>~o stabiliga</I>.", "0"],
["planetario", "planetari-o", "planetarium,", "0"],
["planimetrio", "planimetri-o", "planimetry.", "0"],
["planisfero", "planisfer-o", "planisphere.", "0"],
["planko", "plank-o", "[UV] Floor(ing), bottom, foot- plate(-way), ground. <I>~o cementa, kahela, ligna, mozaika, ŝtona, de ĉambro</I>. ➞ <I>parget, tabul</I>.", "0"],
["planktono", "plankton-o", "plankton.", "0"],
["plano", "plan-o", "[UV] Plan. <B>1</B> design, lay-out, map. <I>Urba ~o</I>. <B>2</B> arrangement, contrivance, device, method, scheme. <I>~o de agado, laboro, romano</I>. <B>3</B> (perspectv), plane. ➞ <I>eben, fon, perspektiv</I>. <B>~i</B> (<I>-n</I>), make a p., design, map out, plot, project, scheme. <B>~ado</B>, -ning. <B>Antaŭ~o</B>, draft, preliminary p. <I>Labori</I> <B>laŭ~e</B>, <B>sen~e</B>. <B>Instru~o</B>, <B>lerno~o</B>, curriculum, syllabus, (thl) <I>Argumento el</I> -iteco, argument from design. ➞ <I>metod, program, projekt</I>.", "0"],
["plantago", "plantag-o", "[OA] plantain (<I>Plantago</I>). Granda <B>~o</B>, greater (ratstail) p. Meza <B>~o</B>, hoary (lamb’s tongue) p. <B>Lancfoli~o</B>, ribwort p. <B>Mara ~o</B>, sea p. ➞ <I>pizang</I>.", "0"],
["planti", "plant-i", "(<I>-n</I>) [UV], Plant (in ground) set, sow, <I>~i arbojn (cepojn</I>). <B>f</B> <I>ideojn, pensojn, principojn en kapon; kison sur vangon</I>. <B>~ado</B>, -ing. <B>~(it)aĵo</B>, something planted, sapling, etc. <B>~ejo</B>, plantation. <B>~ilo</B>, dibble, <B>~isto</B>, -er. <B>En~i</B>, im-p. <B>Mal~i</B>, dig up, lift. <B>Pri~i</B> (<I>ĝardenon</I>), lay out. <B>Trans~i</B>, plant out, transplant. <B>f</B> <I>~~i vorton el alia lingvo</I>. <B>Te~ejo</B> (<B>~isto</B>), tea-plantation, -er. <B>plant-o</B>, Plant. <I>Akva ~o</I>, water-plant. <I>Rok ~oj</I>. ~a (<I>vegetala) regno</I>, vegetable kingdom. <B>~aro</B> (<I>flaŭro</I>), flora.", "0"],
["plasmo", "plasm-o", "Plasma. ~odio, (bio) -odium,", "0"],
["plasticino", "plasticin-o", "plasticine.", "0"],
["plastika", "plastik-a", "[OA] Plastic. <B>1</B> easily moulded, pliant, supple, soft. <B>2</B> (<I>reliefa): ~a arto,</I> p. art. <I>Cxio atendas klare kaj</I> <B>~e</B> <I>atitaŭ mia animo</I> (1 FA 88/12). <B>~eco</B>, -ity. ➞ <I>knedebla, muldebla</I>.", "0"],
["plasto", "plast-o", "Plast/ic (material). <B>~oj</B>, group of synthetic pp. <B>~a</B>, made from p. <B>~aĵo</B>, object. made of p.", "0"],
["plastro", "plastr-o", "[UV] (med) Plaster. <I>Adhera ~o,</I> sticking p. <I>~o sur la riazo</I> (Rz 42/17). <I>Kal~o</I>, corn-p. (cy) (tyre) patch. <B>~i</B> (apply a) p. ➞ <I>gips, kataplasm, stuk</I>.", "0"],
["plata", "plat-a", "[UV] Flat. <B>1</B> even, horizontal, level, spread out, unbroken, dead(calm), smooth (sea), <I>~a pejzaĝo</I>. <B>1</B> (<I>senreliefa</I>), without projections. <I>~a brusto (vizaĝo</I>). <B>f</B> bald, dull, insipid, lifeless, spiritless, monotonous, <I>~a stilo, versaĵo</I>. <B>~o</B>, flat object., board, pl<SPAN STYLE=\"text-decoration: none\">ate, sheet. <I>~o fotografa, ŝtala, vitra</I>. <B>cifer~o</B>, [UV] (clock) face, dial. <B>Fermo~o</B>, (door) wing. <B>Fibro~o</B>, (wall) board. <B>Fingro~o</B>, <B>fret~o</B>, (mus) fingerboard. <B>Forn~o</B>, hob. <B>Kolon~o</B>, plinth. <B>Krad~o</B>, (el) grid. <B>Lad~o</B> (tin- plate). <B>man~o</B>, [UV] palm. <B>Nom~o</B>, name plate. <B>Pied~o</B> (<I>plando</I>), sole. <B>Ŝton~o</B>, ledger, slab. <B>Turn~o</B>, (ry) turntable. <B>Vitra ~o</B>, glass sheet. <B>~aĵo</B>, <B>~ejo</B>, (f. pt), level stretch (land, stairs), (geol) shelf. <I>Mont~aĵo</I>, plateau, tableland. <B>~igi</B>, <B>~iĝi</B>, -ten. <I>~igi la nazon kontraŭ fenestro. Prem~igi</I>, squash. <B>~germana</B> <I>lingvo</I>, Low German. <B>~lando</B>, lowland. ➞ <I>eben, glat, kliŝ, lamen, plank, platform</I>.", "0"],
["plataleo", "platale-o", "(<I>kulera cikonio</I>), (orn) spoonbill (<I>Platalea</I>).", "0"],
["platano", "platan-o", "[OA] Plane tree, button-wood (<I>Platanus</I>) (Jeĥ 31/8). <B>~o okcidenta</B>, (<B>orienta</B>). <B>~arbo</B> (Ge 30/37). ➞ <I>acer, sikomor</I>.", "0"],
["plateno", "platen-o", "[UV] (chem) Platin/um (Pt). <B>~i</B>, -ize, plate with p.", "0"],
["plateso", "plates-o", "(ich) plaice (<I>Pleŭronectes platessa). ➞ limand, romb, sole</I>.", "0"],
["platformo", "platform-o", "Platform (wide sense). <B>1</B> (platejo) (Petrolo <I>II 101/32) raised level surface. <B>2</B> in hall or open air, for speaker</I> (<I>estrado, podio, tribuno</I>). <I>3 (pol) declaration of policy</I>.", "1"],
["platona", "", "platonic. <B>1</B> of Plato. <B>2</B> purely ideal. ➞ <I>amikec</I>.", "0"],
["plaŭdi", "plaŭd-i", "(nt), [UV] Splash. <B>1</B> beat, plash. <I>La akvo, ondo ~is kontraŭ roko, sub la boato</I>. <B>1</B> (make a s.) dabble, flop, spatter. <I>La remiloj ~is en la rivero</I>. <B>3</B> make a similar noise, flap. <I>La fenestro (flago) ~is en la vento. ~i per la manoj</I> (clap hands) (Ps 47/1). <B>~aĉi</B>, go squish-squash, e.g., <I>veturilo tra koto</I>. <B>~(ad)o</B>, splashing. <I>La ~ado de ondoj, remiloj, de la pluvo</I>. <B>~eti</B>, lap, plash, purl, ripple. ➞ <I>klak, ŝmac</I>.", "0"],
["plaŭ!", "", "(a. plaŝ!), Splash! <I>ŝi ensaltis en la akvon</I> (Z).", "0"],
["plebiscito", "plebiscit-o", "(pol) plebiscite, referendum.", "0"],
["plebo", "pleb-o", "[OA] Pleb/s, common people, lower orders. <B>~a</B>, -ish, coarse, common, (of) low (birth), vulgar. <B>~ano</B>, -ian, commoner.", "0"],
["pledi", "pled-i", "[OA] (nt) Plead (cause, in court), allege (argue, maintain, offer) in defence (excuse, justification). <I>~i nescion. ~u</I> (intercede) <I>por mi</I>. <B>f</B> <I>Multaj faktoj ~as por Esp</I>. <B>~(ad)o</B>, plea(ding), address by counsel. <B>~isto</B>, counsel. <B>Kontraŭ~o</B>, counter-p.", "0"],
["pleistoceno", "pleistocen-o", "(geol) pleistocene.", "0"],
["plej", "", "[UV] (adv) most, -est (superlatv). <I>~ saga</I>, wisest. <I>~ bela</I>, most beautiful. <I>La ~ bona</I> (best) <I>el ĉiuj. Kiel eble ~ baldaŭ</I>, as soon as possible. <I>Unu el la</I> ~ …, one of the most … ~a (greatest) <I>denso</I>. ~e (<I>maksimume, ~ ofte</I>), mostly, mainly. <I>La</I> mal<I>~ ... el</I>, the least … of.", "0"],
["plejdo", "plejd-o", "plaid. <B>1</B> (tex) Scottish tartan (cloth). <B>2</B> (cl) garment of this.", "0"],
["plejnkanto", "plejnkant-o", "(<I>Gregoria ĉantado</I>), (mus) plain-chant(-song).", "0"],
["plekoto", "plekot-o", "(<I>longorela vesperto</I>), long-eared bat (<I>Plecotus</I>).", "0"],
["plekti", "plekt-i", "(<I>-n</I>) [UV], Plait, Braid, twist, weave, wreathe, <I>~i harojn, pajlerojn, ŝnurojn, veringojn</I>. <B>~aĵo</B>, braid, plait, basket-work, wicker-work, matting, netting, webbing, tracery, tress (of hair). <I>Drata (pajla) ~aĵo de kaĝo, seĝo</I>. <B>f</B> <I>~aĵo</I> (tissue) <I>de intrigoj, mensogoj</I>. <B>Ĉirkaŭ~i</B>, <B>inter~i</B>, entwine, interlace (weave). <I>Inter~aĵo (implikaĵo</I>), interlacing, tangle. <I>Inter~itaj</I> (clasped) <I>manoj</I>. <B>Kun~i</B>, weave together. <I>Kun~i ligilon de amikeco</I>. <B>Mal~i</B> (separate the strands of, unpick, unravel) <I>intrigon, trikaĵon</I>. <B>Tra~i</B>, blend, intermingle, interlard, intersperse), e.g., <I>per flavaj fadenoj</I>. ➞ <I>implik, krad, teks</I>.", "0"],
["plektro", "plektr-o", "(<I>plukilo</I>), (mus) plectrum (for mandoline, zither, etc.).", "0"],
["plena", "plen-a", "(<I>de, je</I>) [UV], Full. <B>1</B> f. of, f-up (to the brim), flush, replete: <I>~a buŝo. Taso ~a de teo; vivo ~a de ĝojo. Koro tro ~a, buŝo parolas</I>. <B>2</B> Complete, absolute, entire, plenary, with nothing lacking: <I>~a kunsido, longo, pago, portreto, sensencaĵo, tago, vortaro. ~a mallumo,</I> complete darkness. <I>~a mizerego</I>, utter misery. <B>3</B> with a large number of, abounding in, crowded (stocked, well provided) with: <I>butiko ~a de varoj, domo ~a de mebloj, kapo ~a de ideoj, teksto ~a de eraroj</I>. <B>4</B> (mus) <I>~a noto (~o</I>): Semi-breve. <I>~nota silento</I>, s-rest. <B>~e</B>, fully, amply, completely, entirely, quite, to the full. <B>~eco</B>, fullness, abundance, plenitude, repletion. <B>~ega</B> (<I>Plen~a</I>), heaped, packed, plenteous, plentiful. <I>~egeco</I>, repletion. <B>~igi</B>, fill. <I>~igi sakon. ~igi (ŝtopi) breĉon, mankon</I>. <B>~iĝi</B>, fill up. <I>La domo ~iĝis de gastoj</I>. <B>~umi</B>, [UV] accomplish, excute, fulfil, perform. <I>~umi devon, mendon, ordonon, postulon, promeson, taskon;</I> keep, obey, <I>~umi instruon, leĝon</I>. <B>~um(ad)o</B>, <B>~(iĝ)o</B>, fulfilment. <B>Ne~umi</B>, break (promise), fail to do, leave undone. <B>~umebla</B>, practicable. <B>Super~umi</B>, exceed target. <B>Mal~a</B>, empty, vacant. <I>~a ĉambro, stomako</I>. <B><I>~~aĵo</I></B>, vacancy, void, (mus) <B>Ne~a</B> (<I>sentrita) kvinto</I>, bare fifth. <B>Re~igi</B>, replenish. <B>Super~igi</B>, <B>Tro~igi</B>, fill to over-flowing. <B>Doloro~a</B>, painful. <B>Esprimo~a</B>, expressive. <B>Fido~a</B>, confident. <B>Forto~a</B>, vigorous. <B>Hom~a</B>, crowded, busy (<I>strato</I>). <B>Mov~a</B>, animated. <B>Plen~a</B>, crammed. <B>Ŝton~a</B>, stony. <I>PPX:</I> <B>1</B> ( = -ful): <B>~buŝo</B>, mouthful, etc. <B>2</B> (<I>= tuta</I>): <B>~luno</B>. ➞ <I>abund, efektivig, komplet, sat, satur, tut</I>.", "0"],
["plendi", "plend-i", "[UV] Complain, croak, express dissatisfaction, find fault, grouse, grumble, moan. <I>~i al la patro; ĉe la tribunalo; ke neniu venis; kontraŭ la sorto; pri doloro</I>. <B>~(ad)o</B>, -t, accusation, charge, grievance, indictment, plaint.<B> <I>Fari ~on kontraŭ</I></B>, lay a complaint against. <B>~a</B>, -ing.<B> <I>~a krio (voĉo</I>)</B>. <B>~anto</B>, -ant, -er, accuser, plaintiff. <B>~ema</B>, fretful, grumbling, peevish, querulous. <B>~ilo</B> (Ij 30/31). <B>~(eg)inda</B>, deplorable, lamentable, pitiable, woeful. <B>Pri-i</B>, find fault with.<B> <I>Suferi</I></B> <B>sen~e</B>. ➞ <B><I>tikan, grumbl, ĝem, lament, protest</I></B>.", "0"],
["pleonasmo", "pleonasm-o", "[OA] (rh) pleonas/m, V redundancy of expression, e.g., <I>fali malsupren</I>. <B>~a</B>, -astic.", "0"],
["plesiosaŭro", "plesiosaŭr-o", "(pal) plesiosaurus.", "0"],
["pleto", "plet-o", "[UV] tray, dish, salver. <I>Pez~o,</I> balance [<I>Ne = arĝenta faro</I>]. ➞ <I>kliŝ, lamen, plad, plak, plat, teler</I>.", "0"],
["pletoro", "pletor-o", "(<I>troo</I>), plethor/a, unhealthy repletion, overabundance. <B>~a</B>, -ic.", "0"],
["pleŭro", "pleŭr-o", "Pleur/a. <B>~ito</B>, -isy. <B>Seka ~ito</B>, dry -isy. <B>~ita</B>, -itic.", "0"],
["pleŭronekto", "pleŭronekt-o", "[UV] member of flat-fish fam. (<I>Pleuroneetes) &gt; fles, hipoglos, limand, plates, romb, sole</I>.", "0"],
["pleŭroto", "pleŭrot-o", "oyster fungus (<I>Pleurotus</I>).", "0"],
["plezuro", "plezur-o", "[UV] Pleas/ure, delectation, enjoyment, gratification, satisfaction. <I>Doni, ricevi, senti ~on el (en, per) io. Tio farus al mi plej grandan ~on</I>, I should like that above all things. <I>Vivo de ~o,</I> gay life. <I>Estas ~o</I> (a treat) <I>vin vidi. Kun ~o!</I> Delighted! <B>~a</B>, agreeable, pleasant. <B>~e</B>, with p. <B>~ego</B>, delight. <B>~igi</B> (<I>plati</I>), p., gratify, indulge. <I>~iga</I>, enjoyable. <B>~iĝi</B> <I>ĉe</I>, take p. in, rejoice over. <I>Ĉe la malfeliĉo de via malamiko via koro ne ~iĝu</I>. <B>~boato</B>, p-boat. <B>Mal~o</B>, dis-p, annoyance. <B>~~e</B>, against the grain, reluctantly. ➞ <I>ĝoj, ĝu, kontent, plat</I>.", "0"],
["pli", "", "[UV] (adv) <I>More</I>, -er (comparison, as regards degree or quality). ~ .. . ol, m… . than. <I>~ bela</I>, m. beautiful. <I>~ akra,</I> sharper. <I>~ bona (sana</I>), better in quality (health). <I>~ kaj</I> m. and m. <I>Pli-malpli,</I> more or less, about, approximately. <I>Des (Tiom</I>) <B><I>~</I></B> <I>bone</I>, all the better. <B>~</B> (<I>multe) da pano</I>, m. bread. <I>Mi ~ (multe) volus,</I> I should prefer… . <B>~o</B>, excess. <B>~a</B> (<I>aldona, ekstra, kroma</I>), further, supplementary. <I>Unu ~a vorto</I>, one word m. (mus) (<I>Mal)~igita intervalo</I>, augmented (diminished) interval. <B>~e</B>, <B>1</B> to a greater degree. <B>2</B> (<I>krom tio</I>), besides (in addition to) that, moreover. <I>Li donis al ŝi ringon, kaj ~e monon</I>. <B>~multo</B>, majority. <I>La absoluta ~multo decidos</I>. <B>~vole</B> <I>ol,</I> rather than. <B>Mal~</B>, less. ~<B>~e</B>, to a smaller degree. <I>~~multo</I>, minority. <I>~~igi,</I> lessen. ➞ <I>ankoraŭ, plu. PFX:</I> <B>~bonigi</B>, <B>~boniĝi</B>, improve, etc.", "0"],
["pliko", "plik-o", "[UV] (med) plica, Polish plait (platted condition of hair).", "0"],
["plinto", "plint-o", "plinth, projecting base of column or wall.", "0"],
["plioceno", "pliocen-o", "(geol) pliocene.", "0"],
["plisi", "plis-i", "(<I>-n</I>), Pleat, crease, fold, pucker. <I>~i jupon</I>. <B>~ado</B>, pleating, kilting, tucks. <B>~aĵo</B>, pleated, kilted (shirt, etc.). ➞ <I>ĉifon, fald,</I> <B><I>krisp</I></B>.", "0"],
["plombi", "plomb-i", "(dentistry) fill, stop. <I>~ita dento</I>. <B>~(aĵ)o</B>, cement, plugging, stopping. ➞ <I>plumb, stop</I>.", "0"],
["plonĝi", "plonĝ-i", "(nt) Dive, Plunge, descend suddenly, pitch, swoop, take a header, (av) <B>~atako</B>, d-attack. <B>Flug~o</B>, power-dive. <B>~igi</B> (<I>-n</I>), plunge, dip, immerse, souse, submerge. <B>~igi</B> <I>manon en poŝon, ponardon en koron</I>.", "0"],
["plori", "plor-i", "(nt), [UV] Weep, cry, shed tears. <I>~i pri (pro) doloro. Ofte kantas la buŝo, kiam ~as la koro. ~i larmojn</I> (4 FA 55/37). <B>~(ad)o</B>, -ing, wailing. <I>Ne sufiĉas ~o al kreditoro</I>. <B>~egi</B>, weep bitterly, shed passion of tears, sob one’s heart out. <B>~ema</B>, lachrymose, tearful. <B>~eti</B>, pule, whimper. <I>~etaĉi</I>, grizzle, snivel, whine. <B>~igi</B>, move to tears, <B>~inda</B>, deplorable, lamentable, sad. ➞ <I>malĝoja, trista</I>. <B>~kanto</B> (Bb), Lamentations. <B>Ek~i</B>, begin to weep, burst into tears. <B>Pri~i</B>, bemoan, bewail, deplore, lament over, mourn for. <I>~~i ies morton</I>. ➞ <I>ĝem, kri, lament, larm, plend</I>.", "0"],
["ploto", "plot-o", "[UV] [from G, Pol., R.], (ich) roach (<I>Rutilus). ~o ruĝokula</I>, rudd (<I>Scardinius</I>).", "0"],
["plotono", "ploton-o", "(mil) platoon, troop.", "0"],
["plozivo", "ploziv-o", "(phon) plosive.", "0"],
["plu", "", "[UV] (adv) Further, More (denotes Continu/ation, duration, in time or space). <I>Unu paŝo</I> one step m. <I>Kaj tiel</I> ~ (k.t.p., ktp), and so on. With a negative word denotes cessation, disc-ance. <I>Ne</I> no longer, not again (Ps 41/8). <I>Neniam</I> never-m. <I>Ne - skribu</I>, write no m. <I>Ĝis tie, kaj ne</I> so far, and no further. <I>Formorti, dormi, kaj nenio</I> <B>~</B>. <B>Rim</B>.: ➞ pli (comparison). <I>Mi ne trinkis pli (multe) ol vi: Mi ne ~ trinkis (= Mi ĉesis trinki</I>). <B>~e</B>, (pleon) f-(more), in c-ance. <I>Mi ~e silentos</I>, I shall c-e to keep silence. <B>~e(n)!</B> Onwards! Proceed! <I>Abram iris ~en, tiam -en</I> (Ge 12/9). <B>Rim</B>.: ➞ plie = in addition, to a greater degree (than). The diffce is slight, and often either is usable, <B>~a</B>, further. <I>Sen ~a parolo. Mi restos du ~ajn tag ojn</I>, two days more. <B>~i</B> (<I>daŭri</I>), go on, c-e to exist. <B>~aĵo</B>, c-ation. <B>~igi</B> (extend) <I>krediton</I>. ➞ <I>ankoraŭ, daŭr, jam</I>.", "0"],
["plugi", "plug-i", "(<I>-n</I>), [UV] Plough, till. <I>~i kampon. Kiu ne -is, tiu ne rikoltos</I>. <B>~ado</B>, -ing, tillage, <B>~ebla</B>, arable, <B>~ejo</B>, p-land. <B>~ilo</B>, p. <I>Neĝ~ilo. ~ila beko, fero, trabo</I>, p- share (coulter, beam), <B>~isto</B>, p-man. <B>Dis~i</B>, break up. <B>El~i</B>, extirpate, uproot. <B>Pri~i</B> <I>kampon</I> (1 FA 8/3). <B>Tra~i</B>, cleave (<I>ondojn</I>).", "0"],
["pluki", "pluk-i", "(<I>-n</I>), Pluck, twitch. <B>1</B> (mus) twang, <I>~i la kordojn de instrumento per fingro, plektro, ungo</I>. <B>2</B> Pick, cull, gather. <I>~i florojn</I>. <B>3</B> (<I>for~i</I>), Pick off, pull at, snatch at. <I>~i fadenojn de maniko, harojn, plumojn</I>. <B>~e</B>, pizzicato. <B>~ilo</B> (<I>plektro</I>), plectrum. <B>Pri~i</B>, <B>f</B> cheat, defraud, swindle, trick (<I>iun</I>).", "0"],
["plumbo", "plumb-o", "[UV]. <B>1</B> (chem) Lead (Pb). <B>2</B> lead-weight. <I>Sond~o</I>, plummet. <I>Jxeti la ~on</I>, heave the l. <B>~a</B>, lead(en). <I>~a drato, folio, tubo, sigelo</I>. <B>f</B> <I>~a</I> (grey) <I>ĉielo</I>. <B>~i</B>, <B>1</B> plumb. <B>2</B> load (a stick, etc.). <B>~isto</B>, lead-worker, plumber, <B>~oza</B> <I>acetato</I>, sugar of lead. <B>~oblanko</B> (<I>ceruzo</I>), white-l. <B>~industrio</B>, plumbing. ➞ <I>grafit, plomb, mini</I>.", "0"],
["plumo", "plum-o", "[UV] <B>1</B> Feather, plume. <I>~o de pavo, sur ĉapelo</I>. <B>Flugila ~o</B>, quill, wing-f. <B>Vost~o</B>, tail-feather. <B>f</B> <I>Porti fremdajn ~ojn</I>. <B>2</B> (<I>skrib~o</I>), Pen, quill. <I>Font~o,</I> fountain-p. <B>f</B> <I>Preni ~on en la manon. Havi facilan ~on</I>, be a ready writer. <B>~eca</B>, <B>~forma</B>, penn-ate, -iform. <B>~eto</B>, plum-elet, -ule. <B>~ingo</B>, [UV] p-holder. <B>~isto</B>, f-dealer. <B>~izi</B> <I>sagon</I>. <B>~ujo</B>, p-box (-tray). <B>~hava</B>, <B>~kovrita</B>, f-ed. <B>~industrio</B>, f-trade. <B>~pezo</B>, (sp) f-weight. <B>Sen~a</B>, featherless, callow, unfledged. <I>~~igi (pluki) birdon</I>, pluck. <I>~~iĝi</I>, moult, shed feathers.", "0"],
["pluraj", "plur-aj", "[OA] more than one. <I>~aj edzinoj,</I> more wives than one. <B>~eco</B>, ~ismo (<I>pluralismo</I>), plural-ity, -ism.", "0"],
["pluralo", "plural-o", "[OA] (<I>multenombro</I>). (gram) Plural number (opposite singular). <I>La litero \"j\" montras la ~on</I>. <B>~igi</B>, put into the p. plus, (prep) Plus, with the addition of. <I>Ses ~ du estas ok. ĉi kostas du ŝilingojn ~ afranko. La saĝo de sep saĝuloj. ~ via propra (Quo Vadis</I> I 123/1). <B>2</B> (alg) The sign (+). <B>~o</B>, (typ) overs, surplus. <B>~valoro</B>, appreciation, increment value, increase.", "0"],
["pluskvamperfekto", "pluskvamperfekt-o", "(gram) pluperfect (tense).", "0"],
["pluŝo", "pluŝ-o", "[UV] (tex) plush (similar to velvet, but with longer, softer, pile). <B>~urso</B>.", "0"],
["plutokrato", "plutokrat-o", "[OA] Plutocra/t. <B>~a</B>, -ic. <B>~aro</B>, <B>~io</B>, [OA] -cy. ➞ <I>nobel</I>.", "0"],
["pluvo", "pluv-o", "[UV] Rain, Shower. ~o <I>densa, torenta</I>, cloud-burst. <I>Instigita ~o,</I> artificial rain. <B>Nebula ~o</B> (<I>drizelo</I>), drizzle. <B>Neĝ~o</B>, sleet. <B>Stel~o</B>, shower of shooting stars, <B>f</B> <I>~o da gratuloj (kisoj</I>). <B>~i</B>, rain. ~as, It is raining. <B>f</B> ~i <I>sitele</I>. <B>~ado</B> (<I>~kvanto</I>), r-fall, precipitation. <B>~ego</B>, downpour, heavy rain. <I>~egi</I>, r. \"cats and dogs\". <B>~ero</B> (<I>~guto</I>), raindrop. <B>~eto</B>, light shower. <B>~igi</B>, cause to r. <I>~igi manaon</I> (Ps 78/24), <I>batojn (larmojn</I>). <B>~ujo</B>, r-(water-)butt. <I>~oj kaj</I> <B>mal~oj</B>. <B>Pri~ata</B> (Am 4/7). <B>Sen~a</B>, r-less, arid, dry, thirsty. <I>~~eto</I>, drought.", "0"],
["pluvometro", "pluvometr-o", ".", "0"],
["pneŭmatiko", "pneŭmatik-o", "[OA] <B>1</B> pneumatics/s. <B>2</B> (abbreviation pneŭmo), p. tyre (with inner air-tube). <B>~a</B>, p. using air-pressure). <I>~a bremso, depeŝo, drililo, kuseno, pumpilo</I>. (org) <I>~a meĥanismo</I>, p-action.", "0"],
["pneŭmokoko", "pneŭmokok-o", "pneumococcus.", "0"],
["pneŭmonio", "pneŭmoni-o", "(<I>pulminflamo</I>), pneumonia.", "0"],
["Po", "P-o", "[F], letter P.", "0"],
["po", "", "[UV] (prep) = @, apiece, at (the rate of). <I>Mi donis al ili ~ ses pencoj</I>, 6d. apiece. <I>Mi aĉetis pomojn - du pencoj</I> (at 2d. each). (➞ <I>por du pencoj</I>, for 2p). <I>Li veturis ~ dek mejloj (du) hore = dek mejlojn en du horo</I>, 10 miles an hour. <B>Rim</B>.: Do not say \"<I>Li iris dek mejlojn pohore\" =</I> at the rate of an hour a mile! This is a common misuse of po, and a bad one. <I>Vendi</I> ~ funto (~funte), by the pound, a pound at a time. <I>Pagi</I> ~pece, by the piece. <I>Aĉeti</I> ~malgrande (~detale), retail. <B>Rim</B>.: Never use the accus. after po. <I>Elektu ~ tri homoj el du tribo</I>. <B>Rim</B>.: ➞: duope ( = two abreast) <I>ili supreniris la ŝtupojn</I> po du (<I>ŝtupoj dupaŝe</I>): (=two stairs at a time).", "0"],
["podagro", "podagr-o", "[OA] gout. ~ulo. ➞ <I>artrit</I>.", "0"],
["podicipo", "podicip-o", "= grebo.", "0"],
["podio", "podi-o", "[OA] (arch) Podium. <B>1</B> raised platform, stage (Es 1/6). <B>2</B> (<I>benksimila apogaĵo</I>), continuous projecting base (bench, pedestal), round arena or room. ➞ <I>estrad, platform, tribun</I>.", "0"],
["poefago", "poefag-o", "(<I>Tibeta bovo</I>), (zoo) yak (<I>Poephagus</I>).", "0"],
["poemo", "poem-o", "[OA] Poem. <B>Proz~o</B>, p. in prose. <B>Son~o</B>, tone-poem. ➞ <I>poet, versaĵ</I>.", "0"],
["poento", "poent-o", "[UV] Mark, Point, unit of merit (in competition, exam, game, sport). <I>Gajni ~on</I>, gain a mark, score a point. <B>~aro</B>, score, total. (<I>Bilarda</I>) <B>~isto</B>, m-er. <I>Li</I> <B>el~is</B> <I>de mi cent rublojn</I>, he did me out of (won from me) 100 roubles.", "0"],
["poeto", "poet-o", "[OA] Poet, bard. <B>~a</B>, -ic. <B>~aĉo</B>, poetaster, inferior p. <B>~ino</B>, -ess. <B>~iko</B>, -ies, -ic art.", "0"],
["poezio", "poezi-o", "[OA] Poet/ry, verse, <B>f</B> -ic beauty (feeling, style). <I>Senti ~on en do</I>. <B>~a</B>, -ic. <I>-a libereco</I>, -ic licence. <B>~aĵo</B>, piece of verse. <B>~(ec)a</B>, <B>~(em)a</B>, -ical, imaginative. <I>~a koncepto</I>. <B>Sen~a</B>, commonplace, dull, prosaic.", "0"],
["pogromo", "pogrom-o", "(<I>amasbuĉo</I>), pogrom, organized massacre.", "0"],
["pojno", "pojn-o", "(<I>manradiko</I>), Wrist, <B>f</B> (a. <I>~umo</I>), w-band (of shirt).", "0"],
["pokalo", "pokal-o", "[UV] beaker, large drinking-cup, tankard (Ps 23/5), usually of metal and bowl-shaped, funnel-shaped. <I>Inter ~o kaj lipoj povas multe okazi</I>. (sp) cup (trophy). <B>~eto</B>, goblet. ➞ <I>bokal, kalik</I>.", "0"],
["pokero", "poker-o", "(cgm) Poker. <B>~vizaĝo</B>, p-face (impassive, showing nothing).", "0"],
["polako", "polak-o", "(ich) Pollack (<I>Gadus pollachius</I>).", "0"],
["polarimetro", "polarimetr-o", "polarimeter.", "0"],
["polariskopo", "polariskop-o", "polariscope.", "0"],
["polarizi", "polariz-i", "(opt) Polariz/e. <B>~o</B>, -ation. <B>~ebla</B>, <B>~ilo</B>. <B>Mal~i</B>, de-p.", "0"],
["polaro", "polar-o", "(ph) Polar, <B>~eco</B>, -ity. ➞ <I>polus</I>.", "0"],
["poldero", "polder-o", "polder, Dutch low-lying land reclaimed from sea.", "0"],
["polekso", "poleks-o", "(<I>dikfingro</I>), thumb. ➞ <I>fingr</I>.", "0"],
["polemiko", "polemik-o", "[OA] Controversy, Polemic(s); disputation, public discussion. <B>~a</B>, c-ial, p-al. <I>~a verko</I>. ~i carry on c. ~anto, <B>~isto</B>, c-ialist, disputant. <B>~aĵo</B>, c-ial treatise. ~ema, disputatious.", "0"],
["polemonio", "polemoni-o", "(bot) Jacob’s ladder (<I>Polemonium). Blua ~o</I>, Gk valerian.", "0"],
["poleno", "polen-o", "Pollen. <B>~i</B>, pollinate. ~ero, p-grain.", "0"],
["polento", "polent-o", "(cul) polenta.", "0"],
["poli", "poli-", "(Gk pfx <I>= mult, plur</I>), Poly-. ~andrio (<I>pluredzeco</I>), -andry. ~fonio, -phony &gt; <I>kontrapunkto</I>. ~gamio (<I>pluredzineco</I>), -gam/y. <I>~~ulo</I>, -ist.", "0"],
["polianto", "poliant-o", "(bot) Polyanthus.", "0"],
["polico", "polic-o", "[UV] <B>~a</B>, Police. <I>~a ordono,</I> p-reguln. ~i (control by, furnish with) p. <B>~ano</B>, p-man, constable. ~anaro, constabulary. ~ejo, p-station. ~estro, chief of p. <B>~isto</B>, p-officer.", "0"],
["poligalo", "poligal-o", "(bot) milkwort (<I>Polygala). &gt;</I> seneca snakewort (<I>P. senega</I>).", "0"],
["poligloto", "", "[OA] (<I>multlingvulo</I>), polyglot.", "0"],
["poligonato", "poligonat-o", "(bot) (<I>sigelo Salomona</I>), Solomon’s seal (<I>Polygonatum</I>). ➞ <I>fagopir</I>.", "0"],
["poligono", "poligon-o", "[UV] <B>1</B> (bot) knotgrass (<I>Poligonum</I>). Akvopipra <B>~o</B>, water-pepper. Amfibia <B>~o</B>, amphibious bistort. Bistorta ~o (<I>bistorto</I>), bistort, snakeweed. Konvolvula <B>~o</B>, black bindweed. Makula (Noda) <B>~o</B>, knotted (spotted) persicaria. Marborda <B>~o</B>, sea knotgrass. Persikaria ~o (<I>persikario</I>), common persicaria, redleg. ➞ <I>fagopir</I>. <B>2</B> (geom) (<I>multangulo, poligono</I>), poligon.", "0"],
["poliketo (a. poliĥeto)", "", "polychaete bristle-worm. polikromio, polychrome. polimero, (chem) polymere. polinomia, (alg) polynomial.", "0"],
["poliomato", "poliomat-o", "common blue (butterfly).", "0"],
["poliomjelito", "", "(med) polio(myelitis).", "0"],
["poliplektro", "poliplektr-o", "peacock pheasant (<I>Polyplectron</I>).", "0"],
["polipo", "polip-o", "<B>1</B> (med) polypus. <B>2 polip-o</B> [OA] = polpo.", "0"],
["polipodio", "polipodi-o", "polypody (fern) (<I>Polypodium</I>).", "0"],
["polipogono", "polipogon-o", "beard-grass (<I>Polypogon</I>).", "0"],
["poliporo", "polipor-o", "polipore fungus (<I>Polyporus</I>) &gt; Dryad’s saddle.", "0"],
["poliso", "polis-o", "[OA] Policy, contract of assurance, insurance. <I>Fajrasekura, vivasekura ~o</I>. <B>~ulo</B>, p-holder.", "0"],
["polistiko", "polistik-o", "(<I>ŝildfiliko</I>), shield-fern (<I>Polystichum</I>).", "0"],
["politeismo [OA], politeisto", "", "polytheism, polytheist.", "0"],
["politekniko", "", "(<I>~teknika lernejo</I>), polytechnic.", "0"],
["politiko", "politik-o", "[OA] Politic/s, statecraft, <B>f</B> policy, prudent conduct. <I>~o loka, partia, persona, praktika. Honesto estas la plej bona ~o</I>. <B>~a</B>, -al. <I>~a geografio</I>. <B>~i</B>, engage in politics. <B>~isto</B>, -ian, statesman. ➞ <I>diplomati, prudent, sagac</I>.", "0"],
["polko", "polk-o", "[OA] (dance) Polka. <B>~i</B>, dance the p.", "0"],
["Pollando", "Pol-lando", "PL.", "0"],
["polmo", "polm-o", "(<I>manplato</I>), <B>1</B> palm of hand. <B>2</B> \"hand\" (measure of horse).", "0"],
["polonezo", "polonez-o", "(dance) polonaise.", "0"],
["polonio", "poloni-o", "(chem) polonium (Po).", "0"],
["poloo", "polo-o", "(gm) Polo. <B>~isto</B>, p-player.", "0"],
["polpo", "polp-o", "(zoo) polyp. ➞ <I>oktopod</I>.", "0"],
["poltrono", "poltron-o", "(<I>malkuraĝulo</I>), poltroon, spiritless coward. <B>~a</B>, chicken-hearted.", "0"],
["poluri", "polur-i", "(<I>-n</I>), [UV] Polish, burnish, glaze, make bright (glossy, smooth) by friction, (put a) shine (on). <I>~i lign-(metal-vitr-)on</I>. f make elegant, refine, smarten up. <I>~i stil-(verk-)on</I>. <B>~o</B>, p., gloss, lustre, shine; elegance, grace. <B>~isto</B>, -er. ~ita, -ed, bright, glossy, sleek, smart. <B>Mal~i</B>, dull, take the shine off. Ne~ita (<I>senkultura</I>), crude, rough, rude.", "0"],
["poluso", "polus-o", "[UV] (geom) Pol/e. <I>~o magnet -(negativ-nord-pozitiv-sud-)a. ~oj ĉielaj,</I> celestial pp. <B>~a</B>, -ar. <I>~a stelo</I>, p-star. <B>~eco</B>, -arity. ➞ <I>polar(iz</I>).", "0"],
["polvo", "polv-o", "[UV] Dust. <I>Forviŝi ~on</I>. f <I>Jeti ~on en la okulojn (blind-iluzi-igi). Vi estas ~o, kaj refariĝos ~o</I> (Ge 3/19). <I>Flor~o,</I> pollen. <I>Kosma ~o, ~a nubo</I>, d-cloud. <I>Seg~o</I>, saw-d. ~(ec)(plen)a, -y; <I>~a strat-(vest-)o</I>. ~ad(okovr)i, cover (smother) with d. <B>~aro</B>, cloud of d. ~ero, speck of d. ~(kolekt)isto, d-man. ~ujo, d-(refuse-)bin. ~kolora, ash-grey. Sen ~igi (clear of, free from) d., beat (<I>tapiŝon</I>). ➞ <I>likoperd, pudr, pulv, pulvor, sue, viŝil</I>.", "0"],
["pomado", "pomad-o", "[OA] Pomade, pomatum, scented ointment. <B>~i</B>, smear with p. <I>~itaj haroj</I> (M 89/19).", "0"],
["pomelo", "pomel-o", "(a. <I>grapfrukto</I>), grapefruit, pomelo (<I>Citrus paradisi Macf.</I>). ➞ <I>pampelm(us</I>).", "0"],
["pomo", "pom-o", "[UV] Apple, fruit of <B>~ujo</B>, [UV] ~arbo (<I>Pyrus malus</I>). <B>Sovaĝa</B> <B>~o</B>, crab-a. <B>Gorĝa</B> <B>~o</B>, Adam’s a. <B>Okul~o</B>, a. of the eye. <B>ter~o</B>, [UV] potato. <B>~ologio</B>, pomology, fruit-growing.", "0"],
["pompo", "pomp-o", "[OA] Pomp, display, splendour. <I>~o de kortego</I>. <B>~a</B>, -ous, imposing, magnificent, showy, splendid. <I>~a ceremonio, parolmaniero, procesio</I>. <B>~i</B>, be resplendent, blaze, glow. ~aĉa, flaunting, inflated, ostentatious. ➞ <I>grandioz, parad, solen</I>.", "0"],
["ponardo", "ponard-o", "[UV] poniard, dagger, dirk, stiletto. <B>Ĵet~o</B>, assegai, dart, javelin. <B>~i</B>, stab. <B>~ego</B>, [UV] pike, spear. ➞ <I>halebard, harpun, lane, pikstang</I>.", "0"],
["poneo", "pone-o", "pony, small horse.", "0"],
["pontifiko", "pontifik-o", "Pontif/f. <B>~a</B>, -ical, solemnly dogmatic. <B>~eco</B>, -icate.", "0"],
["ponto", "pont-o", "[UV] Bridge. <I>~o fervoja (improvizita, provizora</I>), railway, emergency, temporary b. <I>~o betona, gisfera, ŝtona</I>. Ark<B>~o</B>, arched b. <B>Baskula</B> <B>~o</B>, bascule-b. <B>Boata</B> (<B>flotanta</B>) <B>~o</B>, pontoon b. <B>Kantilevra</B> <B>~o</B>, cantilever-b. <B>Lev~o</B>, <B>movebla ~o</B>, draw-b. <B>Pendanta</B> <B>~o</B>, suspension b. <B>Pied~o</B>, foot-b. <B>Pivot~o</B>, <B>turn~o</B>, swing-(swivel-)b. <B>Stablo~o</B>, trestle-b. Tur<B>~o</B>, tower-b. (mar) b. of ship, (mus) b-passage. (vn) b. of violin (<I>Ludi ĉe la ~o</I>). <B>f</B> means of communication. <I>~o trans lingvaj baroj</I>. <B>f</B> (geom) <I>Azena ~o</I>, pons asinorum. <B>~eto</B>, gangway, plank. <B>~imposto</B>, <B>~pago</B>, b-toll. <B>Super~i</B>, <B>Trans~i</B>, b. over, span, surmount. <I>~~i abismon, kanalon, malfacilaĵon</I>.", "0"],
["pontono", "ponton-o", "[OA] = pon/6oa/(ar)o, pontoon.", "0"],
["poo", "po-o", "meadow-grass (<I>Poa</I>). poci-o, (pharm) potion, dose, draught, poĉ-i (<I>ovon</I>), (cul) poach. ➞ <I>poŝ</I>.", "0"],
["poplino", "poplin-o", "(tex) poplin, poplit-o (<I>subgenuo</I>), Ham, hough. <I>~a kavo. ~a tendeno</I>, h-string.", "0"],
["poplo", "popl-o", "[UV] Poplar (<I>Populus</I>) (Ge 30/37, Ho 4/13). <I>~o balzam-(blank-Ital-nigr-)a,</I> balsam (white or abele, Lombardy, black) p. ➞ <I>tremol</I>.", "0"],
["popo", "pop-o", "pope, parish priest of Gk church. ➞ <I>pap</I>.", "0"],
["popolo", "popol-o", "[UV] People. <B>1</B> (<I>loĝantaro</I>) inhabitants, population (of country as a whole): <I>La ~oj de la mondo. fFormikoj, ~o ne forta</I> (Se 30/25). <B>2</B> (<I>homamaso</I>) the general public, masses, ordinary folk. <I>Ili timis la ~on</I> (Lk 20/19). <I>Voĉo de ~o, voco de Dio</I>. <B>~a</B>, of the p., public. <I>~a kanto, kunveno, opinio, tumulto. Venas proverbo el ~a cerbo. ~a konsiliĝo</I>, national assembly. <I>~a moro</I>, popular usage, national custom. ~aĉo, populace, mob, rabble, riff-raff. <B>~amaso</B>, [UV] crowd, multitude. <B>~plenigi</B>, p., populate, settle (land). <B>Mult~a</B>, many p-ed. <B>Sen~igi</B>, depopulate. ➞ <I>horn, gent, naci, oni, pleb, popular</I>.", "0"],
["populara", "popular-a", "[OA] Popular, familiar to, known (liked, shared, understood) by the public. <I>~a aŭtoro, kanto, libro, oratoro</I>. <B>~eco</B>, -ity, favour, vogue. <B>~igi</B>, -ize. <I>~igi kanton</I>. <B>Ne~a</B>, un-p., little known, out of favour. ➞ <I>familiar, ĝeneral, popol, vulgar</I>.", "0"],
["por", "", "(<I>-o, -i, ke</I>) [UV] (prep), For. <B>1</B> (aim) for the benefit (purpose) of, (in order) to: <I>~ kio?</I> What for? <I>Mi venis ~ lielpo</I> (for help), <I>~ helpi</I> (to help). <I>Havi ion ~ fari</I> (to do) (4 FA 54/31, 80/6). <B>Rim</B>.: Z. sometimes omits por: <I>Iru dormi</I>. <B>2</B> (adaptation, destination): <I>glaso ~ vino, vesto ~ infano. Jen io ~ vi. Akvo ~ trinki</I>, water to drink. <B>3</B> (in exchange for): <I>Pag-(rekompenc-)o ~ laboro. Vendi ion ~ du pencoj</I>. 4 (<I>kiel, kvazau): Mi donos al vi la landon ~ posedafo</I> (Ge 17/8). <B>5</B> (in favour, support, of): <I>La ~ kaj la kontraŭ. Ĉiuj ~ si, ~ ĉiuj Di’! Voĉdoni ~ iu</I>. 6 (as regards, in relation to): <I>Triumfo ~ Esperanto. Tio estas bona ~ vi. Komprertebla ~ mi</I>, comprehensible to (understood by) me (Se 30/18). <I>Sentema ~ lumo</I>. 7 (<I>dum</I>): for the duration (to the extent) of: <I>~ ĉiam</I>, for ever. <I>~ tut a jaro. Provizo ~ la vintro. Sidiĝi ~ iomete da tempo</I> (Rut 2/7). ~ ke, in order (with a view), to, so (to the end) that, <I>Parolu klare, ~ ke oni vin kom- prenu</I>, in order to be understood, so that people may understand you. <I>~ ke vi ne falu</I>, lest you fall. 1T Por ke implies a desire, so is followed by -u. 1T Por looks forward to the future; pro backward, to the past.", "0"],
["porcelano", "porcelan-o", "[UV] <B>~a</B>, porcelain, fine china. <I>~a statuet-(tas-)o</I>. <B>~aĵo</B>, china ware. ➞ <I>fajenc</I>.", "0"],
["porcio", "porci-o", "[UV] Portion. <B>1</B> part, piece, some (of). <B>2</B> allowance, helpg, measure, quota, ration, share. <I>Taga ~o. La ~o de Benjamen</I> (Ge 43/34). <I>Duobla ~o,</I> double p., twice as much (El 16/5). <B>~igi</B>, p. out, apportion, divide into pp. ~umi, ration. <I>~umi sukeron</I>. ➞ <I>part, pec</I>.", "0"],
["pordo", "pord-o", "[UV] Door, gateway. <I>~o de domo, aŭto, urbo. (Mal)fermi, (mal)ŝlosi la ~on. Frapi, eniri ĉe la ~o</I>. ~o <I>duklapa, fermita, flanka, latisa, svinga</I>. (mar) hatchway. <B>Fal~o</B>, trap-d. <B>Fenestra ~o</B>, French window. <B>Glit~o</B>, sliding-d. <B>Klap~o</B>, trap- d., etc. <B>Krad~o</B>, wrought-iron gate, <B>f</B> entrance (means of approach). <I>Fermi la ~on al. La ~oj de la morto. Esperanto, la ~o al amikeco</I>. <B>2</B> (<I>fermklapo</I>), d. of object. <I>~o de forno, ŝranko</I>. <B>~eto</B>, ticket barrier, wicket gate, etc. ➞ <I>gijet</I>. <B>~ego</B>, [UV] <B>ĉef~o</B>, carriage (main) entrance. <B>~ejo</B>, gateway. <B>~isto</B>, d-keeper, caretaker. <B>Antaŭ~o</B>, porch. <B>Sving~o</B>, swing-d. ➞ <I>portal, portik</I>.", "0"],
["poreo", "pore-o", "[OA] leek (<I>Allium porrum</I>) (No H/5).", "0"],
["porfiro", "porfir-o", "[UV] porphyry, volcanic purplish-red rock.", "0"],
["porko", "pork-o", "[UV] Pig, hog (<I>Sus domesticus). Ĵeti perlojn antaŭ ~ojn</I> (swine). <B>Amerika</B> <B>~o</B>, peccary. <B>Mar~o</B> (<I>foceno</I>), porpoise. <B>Sovaĝa ~o</B> (<I>apro</I>), wild boar. <B>~a</B> <I>ledo,</I> p-skin. <B>~aĉa</B>, filthy, swinish, <B>~aĵo</B>, pork. <B>~aro</B>, herd of swine. <B>~ejo</B> (<I>~stalo</I>), p-sty. <B>~ido</B>, p-let. <I>~idaro</I>, farrow, litter. <I>Lakta, suĉa ~ideto</I>, sucking-p. <B>~ino</B>, sow. <B>Vir~o</B>, boar. ➞ <I>gras, grunt, lard, sink</I>.", "0"],
["pornografio", "pornograf-io", "pornograph/y. <B>~(iist)o</B>, -er.", "0"],
["poro", "por-o", "(<I>trueto</I>), Por/e, minute opening. <I>~o de haŭt-(spong-)o</I>. ~(oz)a, -ous. <B>~eco</B>, -osity. ➞ <I>interstic</I>.", "0"],
["portalo", "portal-o", "[OA] Portal, elaborate entrance, doorway, gateway. <I>Ili ŝlosis la ~on kaj la pordon</I> (4 FA 69/19).", "0"],
["portero", "porter-o", "[UV] Porter, dark-brown bitter beer from charred malt. <I>~o forta</I>, stout.", "0"],
["porti", "port-i", "[UV] Bear, Carr/y. <B>1</B> convey, fetch, take: <I>~i monon, ombrelon, sakon, valizon, karbojn al Newcastle</I>. <B>2</B> (alporti): c., ~i <I>helpon, leteron, mesaĝon, novaĵon</I>. <B>3</B> (surhavi, surporti): Wear, be dressed in, have on. <B>~i</B> <I>ĉapelon, lipharojn, okulvitrojn, verdan stelon</I>. <B>4</B> (subteni): b., support, sustain. ~i <I>koston, kulpon, respondecon, la sekvojn de malobeo; la zorgojn de la vivo</I>. <B>5</B> (havi), have, possess: <I>~i devizon, daton,</I> nomon; amon en la koro. <B>6</B> (kaŭzi, liveri, naski, produkti): b. bring forth, produce, yield. ~i <I>frukton, profiton, morton, sekvon, utilon</I>. <B>~(ad)o</B>, c-iage, conveyance, porterage, wearg, etc. <B>~aĵo</B>, burden, cargo, load. <B>~anto</B>, b-er. <B>~ebla</B>, portable, <B>~ilo</B>, means of conveyance, clothes-horse, stand, support, etc. <B>Hom~ilo</B>, stretcher. <B>Muzik~ilo</B>, music-stand. <B>Paper~ilo</B>, e.g., <I>neceseja</I>. <I>~isto, c-ier, porter</I>. <B>Leter~isto</B>, <I>postman</I>. <B>al~i</B>, [UV] bring, yield. <B>Dis~i</B>, c. in all directions, distribute. Infekton, novaĵon. <B>el~i</B>, [UV] <B>1</B> c. (bring) out. <B>2</B> (<I>elteni</I>), b., endure to the end, stand: <I>~i doloron, suferon</I>. Doloro <B>ne~~ebla</B>, insupportable, unbearable, unendurable. <B>3</B> afford, pay: <I>la koston</I>. <B>En~i</B> (Ge 47/14), bring in. <B>For~i</B>, c. off, take away, remove. ~~i <I>pakaĵon (trezoron</I>). <B>Kun~i</B>, bring together, collect, gather. <B>Re~i</B>, bring back or again. <B>Sub~i</B>, support. ~~i <I>pezon (familion</I>). <B>~~ilo</B>, prop. <B>Trans~i</B>, transport. <I>~~a pago</I>, cost of t., freight. <I>~~a ŝipo</I>. <B>~~ota</B>, <B>~~ita</B>, carried (brought forward). <B>Frukto~a</B>, fruitful, productive. <B>Semo~a</B>, seed-bearing.", "0"],
["portiko", "portik-o", "[OA] portico (2 Kr 15/8, Jeĥ 8/16), roof supported by columns, as porch to building. ➞ <I>vestibl</I>.", "0"],
["portreto", "portret-o", "[UV] Portrait, likeness, picture (representation of person or animal). <I>~o krajona, paŝtela, vorta</I>. Mem~o. <B>f</B> <I>Esti la ~o</I> (exact image) <I>de sia patro</I>. <B>~i</B>, portray, depict, describe graphically, make likeness of. <B>~ado</B>, -ure. <B>~isto</B>, -ist.", "0"],
["Portugalujo, Portugalio", "Portugal-ujo, Portugalio", "PT.", "0"],
["portulako", "portulak-o", "(bot) purslane (<I>Portulaca) &gt;</I> rose moss, sunplant.", "0"],
["porzano", "porzan-o", "(<I>akvokoketo</I>), Crake (<I>Porsana</I>). <B>~o makula (punktita)</B>, spotted c. <B>Malgranda</B> <B>~o</B>, little c. ➞ <I>kreks, ral</I>.", "0"],
["posedi", "posed-i", "[UV] (<I>havi</I>), Possess, have, hold, own. <B>1</B> (as property): <I>~i domon, edzon, sekreton</I>. <B>f</B> <I>Ĉiu medalo ~as du flankojn. ~i milionon</I>, be worth a million. <B>2</B> (as faculty, quality): <I>~i prudenton, sperton, valoron</I>. Be proficient in, master of, have at one’s finger-tips: <I>~i lingvon</I>. <B>~o</B>, p-ion, ownership. <B>~a</B>, p-ive. <I>~a adjektivo, pronomo (= posesivo</I>). <B>~aĵo</B> (<I>propraĵo</I>), p-ion, property, wealth, <B>~eco</B>, proprietorship. <B>~ema</B>, acquisitive. <B>Ek~i</B>, assume <B>(<I>authority</I>), take over (p-ion of). <I>urbon. Tiu ideo lin ~~is</I>, the idea took hold of him (he was infatuated by it). Kun~o</B>, <B>joint p-ion</B>. <B>Sen~igi</B>, <B>deprive of p-ion, dis-p. ➞ <I>disport, obsed, propr, ten</I>.</B>", "0"],
["post", "", "[UV] (prep), <B>1</B> (time) After, followg, later than: <I>~ tio</I>, a. that. <I>~ sufero venis prospero. Mustardo ~ la manĝo. ~ du tagoj</I>, two days hence. <I>~ semajno</I>, in a week. <I>Ne ~ mardo</I>, by Tuesday at latest. <I>~ ne longe (kelka tempo</I>), in a short time, soon a-wards. <I>~ kiam</I> (a. <I>~ ol) li venis (post lia vend</I>), a. he had come (Ge 6/4). <B>2</B> (place) (a. <I>malantau</I>), behind, hidden by, in (to) the rear of, on the further side (of): <I>~ la kulisoj. Sin kaŝi ~ kolono. Rigardi ~ si (posten</I>), look behind. <B>3</B> order, rank: <I>Li estas la unua ~ la reĝo</I>. <B>~a</B>, 1 ensuing, following later, next, subsequent, succeeding. <I>Mi ne aŭdis la ~an kanton</I>. <B>2</B> back, hind(er), rear, reverse: <I>La ~a parto de la ŝipo</I>. ~e (<I>~ tio</I>), <B>1</B> -wards, subsequently, then, thereafter: <I>Antaŭe kion vi devas, ~e kion vi volas. Pli</I> <B><I>~e</I></B>, later. <I>Multe pli</I> <B><I>~e</I></B>, much later. <B>2</B> behind: <I>Unue iris la muzikistoj, ~e la soldatoj</I>. ~en! Astern! Back! <I>Sin klini ~en</I>, backwards. <B>~o</B>, aft, back, reverse, <B>~aĵo</B> (<I>~a parto</I>), a-part, back part, breech (cannon), stern (ship), (<I>sidvangoj</I>) behind, bottom. <I>Piedbato sur la ~aĵo</I>. <B>~iĝi</B>, fall (get, lag) behind, loiter. <I>~iĝinto</I>, straggler. <B>~eulo</B>, descendant, successor. <I>~eularo</I>, posterity.", "0"],
["posteno", "posten-o", "[OA] Post, place of duty situation, station. <I>Okupi eminentan (gravan) ~on. Dormi (morti) ĉe sia ~o. La ~o de prezidento</I>. be at one’s p., mount guard, stand (Ps 34/7). <B>~igi</B>, p., place (station) in a p. <I>La observantoj ~iĝis ĉirkaŭe</I> <B>Antaŭ~o</B>, outpost.", "0"],
["postiljono", "postiljon-o", "postillion.", "0"],
["postulato", "postulat-o", "(phi, log, mat), postulate, assumption, assumed truth, fundamental condition. <I>~o de Eŭklido</I>. <B>~i</B>, claim, take for granted.", "0"],
["postuli", "postul-i", "(<I>-n</I>), [UV] Demand, Require. <B>1</B> ask, charge, claim, exact, insist on, request. <I>~i atenton, obeon, pagon, rajton</I>. <B>2</B> need, necessitate, postulate. <I>~i oferon, paciencon, pripenson, tempon</I>. <B>~o</B>, d., r- ment, charge, claim. <I>~o netolerebla, racia, troa. Oferto kaj ~o</I>, supply and d. <B>~aro</B>, list of r-ments. <B>~ata</B>, r-ed. <I>~ateco,</I> d. <B>~ebla</B>, due, payable. <B>~ema</B>, exacting, importunate<B>. Ne~ema</B>, easy, indulgent, lenient. <I>Tro~ema</I>, insatiable, extortionate. <B>De~i</B>, lay claim to. <B>Kontraŭ~i</B>, counterclaim. <B>Re~i</B>, d. back. ➞ <I>demand, eldevig, neces, pet, pretend</I>.", "0"],
["poŝo", "poŝ-o", "[UV] Pocket, pouch (de kanguruo). ~o <I>bileta, horloĝa, pantalona, veŝta</I>. <B>Mon~o</B>, fob. (av) <B>aero~o</B>, air-p. <B>f</B> purse. Multo en kapo, sed nenion en ~o. El fremda ~o oni pagas facile. <B>~a</B> (por la ~o): ~a horloĝ-(tranĉil-volum-vortar-)o. <B>El~igi</B>, disburse, pay out. <B>En~igi</B>, p., pouch, appropriate. <B>Plen~o</B> (da), p-ful. ➞ kas, sak.", "0"],
["poŝto", "poŝt-o", "[UV] Post(al service), Mail. <I>Aera</I> ~o. <I>Ekspresa ~o</I>, special delivery. <I>Pakaja ~o</I>, parcel p. <I>Reven(ant)a ~o,</I> return p. <I>Signo de ~o</I> (early writings) = <I>poŝtmarko</I>. <B>~a</B>, -al. <I>~a konvenci-(uni-)o. ~a monbileto,</I> -al order. <B>~e</B>, by p. ~estro, p-master. <B>~isto</B>, p-man. <B>~oficejo</B>, P.O. <B>~oficisto</B><I>,</I> -al official. <B>~pago</B>, -age. <B>~restante</B>, to be called for. ~ŝipo, m-boat. ~veturilo, m-coach. En~igi (<I>enkestigi) leteron</I>, p.", "0"],
["potaso", "potas-o", "[UV] Potash (K<SUB>2</SUB>CO<SUB>3</SUB>). <I>~o kaustika</I> (KOH), caustic p.", "0"],
["potencialo", "potencial-o", "<B>~a</B>, (el, mec) potential. <I>~a energio; funkcio</I>. ~o elektro-statika, -magnet-a.", "0"],
["potenco", "potenc-o", "[UV] Might, Power. <B>1</B> capability, efficacy: <I>~o de lens-(maŝin-teleskop -)o</I>. <B>f</B> ~o <I>de larmoj (ridetoj</I>). <B>2</B> authority: <I>~o leĝdon-(milit-publik-)a. La regno, la ~o, kaj la gloro</I>. <B>3</B> Kingdom, state: <I>Ambasadoro de fremda ~o. 4</I> (mat) 100 <I>estas la dua ~o de</I> 10. <B>~a</B>, m-y, p-ful, potent, strong. <I>~a argument - (arme - drog - influ- kverk - maŝin - regn -)o. Barbo ~a, sed kapo sensenca</I>. -i, exercise (have) p. over, dominate. <B>~ulo</B>, m-y (p-ful) person, potentate, ruler. <I>La</I> Plej-a, the Almighty, Most High. <B>Sen~a</B>, feeble, impotent, p-less, weak. ➞ <I>fort, pov</I>.", "0"],
["potentelo", "potentel-o", "cinquefoil (<I>Potentilla</I>), especially ~o rampa (<I>P. reptans</I>) &gt; silverweed (<I>P. anserina</I>); tormentil (<I>tormentelo) (P. erecta</I>).", "0"],
["poterio", "poteri-o", "(bot) salad burnet (<I>Poterium</I>). ➞ <I>sangisorb</I>.", "0"],
["poto", "pot-o", "[UV] Pot, rounded holder for liquids or solids. <I>~o argil-(kupr-)a</I>. Bol~(flor~glu~kmr~)o. Akvo-o, ewer, pitcher. Ĉambra ~o. Lakto<B>~o</B>, milk-can. <I>~oj kaj patoj</I>, pp and pans. <I>Kia la ~o, tia la kovrilo</I>. ~aj(ar)o, ~farejo, -tery. <B>~isto</B>, -ter. ~peco, p-sherd. En~(igit)a, -ted. ➞ <I>kaldron, kaserol, kruc, vaz</I>. potamoget-o, pondweed (<I>Potamogeton</I>).", "0"],
["poŭpo", "poŭp-o", "(<I>ŝipvosto</I>), (mar) poop, stern. Opp <I>pru</I>.", "0"],
["povi", "pov-i", "(<I>-n</I>), [UV] have the Power.’ ‘can\". <B>1</B> (ability): be able. <I>Mi ~as naĝi</I>, I can (am able~~have the p.~~to) swim (it is in my p. to swim). <I>Kiu devas, tiu ~as. Mi tute ne ~as iri</I>, I cannot possibly go. <I>Mi ne ~is ne ridi</I>, I could not but laugh, couldn’t help laughing. <I>Ne ~i plu,</I> be done up, dead beat, fagged, tired, worn out. <B>2</B> (authority, right): <I>Li ~as vin puni, se vi malobeas</I>. <B>3</B> (permission) be allowed, may: <I>Oni ~as diri aŭ jes, aŭ ne. Tre ~as esti, ke</I>, It may very well be (is quite on the cards) that. <B>~o</B>, Power. <B>1</B> (ability, faculty): <I>Ne estas en mia ~o</I> (it is not in my p.) <I>vin helpi. Atingo~o</I>, range, reach (e.g., <I>de pafo, sono</I>). <B>2</B> (ch, ph): <I>~oa bsorba, lumiga Akvo~o, ĉeval~o</I>, water-(horse-)p. <B>2</B> authority, command, influence, sway: <I>Havi ~on super. Esti en ies ~o. ~o politika, jura</I>. <B>~(ant)a</B>, p-ful, able to, capable, that can. <B>~umo</B>, (el) power. <B>Far~a</B>, able to do things (4 FA 143/3). <B>Flug~a</B> (<I>flugiva</I>), able to fly, fledged. <B>Plen~a</B>, plenipotentiary. <B>Viv~a</B>, viable. <B>Ne~ado</B>, inability (4 FA 95/6). <B>Sen~eco</B>, p-lessness. <B>Ĉio~a</B>, all p-ful, almighty, omnipotent. ➞ <I>ebl, kapabl, lie, potenc</I>. IT ➞ <I>Mi ~is iri</I>, I could go (yesterday): <I>Mi ~us iri</I>, I could go (now) (<I>se mi volus</I>). ➞ -&lt;V.", "0"],
["povra", "povr-a", "= kompatinda.", "0"],
["pozi", "poz-i", "(nt) [OA], Pose. <B>1</B> act as model, assume (strike) an attitude, sit as (Rz 73/28). <B>2</B> (<I>afekti, sin teni kiel</I>), claim (give one’s out, set up) to be (as). <I>kiel Nelson</I>, <B>~o</B>, p., attitude, posture (taken up). <I>~o kuŝa, rekta, soldata, teatra</I>. <B>~ema</B>, affected, assuming airs, putting on side. <B>~igi</B> (<I>modelon</I>), p. a model. <B>~ist(in)o</B>, model. <B>Sen~a</B>, unaffected.", "0"],
["pozicio", "pozici-o", "[OA] Position. <B>1</B> place, locality, situation, site, spot, station: <I>~o de planedo (ŝipo). Domo en agrabla ~o</I>. (mil) <I>~o de armeo</I>. <B>2</B> attitude, posture, stance: <I>~o senmova (sida</I>). <B>f</B> way of looking at things. <B>3</B> line, post, occupation, rank, status: <I>Grava ~o en la vivo</I>. <B>4</B> condition, circumstances: <I>Mi ne estas en ~o vin helpi</I>. <B>3</B> (mus) p., shift, (vn) of hand, (trombone) of slide. ➞ <I>lok, poz, sinten, situaci</I>.", "0"],
["pozitiva", "pozitiv-a", "[OA] Positiv/e (wide sense). opposite <I>negativ</I>. <B>1</B> (<I>io</I>) definite, explicit: <I>~a asert-(pruv-)o</I>. <B>2</B> (<I>iu</I>) certain, confident, convinced. <B>3</B> factual, practical: <I>~a filozofio (scienco</I>). <B>4</B> (phot) showing light and shade as in nature: <I>~a bildo</I>. <B>5</B> (mat) greater than zero: <I>~a kvanto</I> Opp <I>minusa</I>. <B>6</B> (gram) absolute degree: <I>~a adjektivo</I>. <B>7</B> (el) <I>~a elektro</I>. <B>~e</B>, -ly, absolutely, definitely, with conviction. <B>~o</B>, (phot) p., as seen in nature. <B>~ismo</B>, <B>~isto</B>, -ism, -ist. ➞ <I>nepre, plus</I>.", "0"],
["pozitrono", "pozitron-o", "(el) positron.", "0"],
["pra", "pra-", "[UV] (pfx) denotes Remoteness. <B>1</B> (of relationship, backwards or forwards): grand-, great-. ~avo, g-grandfather. ~~avo, great-great-grandfather. ~nepoj, children’s children (Ps 103/17). ~nevino, grand-niece. ~~nepino, great-great-grand- daughter. ~onklino, great-aunt. 11 ~patroj, ~uloj, = ancestors, forbears, forefathers (not merely <I>avoj</I>). ~flloj, ~infanoj, = posterity, future generates (not merely <I>nepoj</I>). <B>2</B> (of distance) in time, of long ago, primitive. ~arbaro, primitive forest; ~formo, original form; ~historio, history of the distant past; ~tempo, days of yore; -vorto, primitive word. <B>~a</B>, primeval, primitive. <I>Kiel ~e!</I> How out of date! ➞ <I>primitiv, malproksim</I>.", "0"],
["pragmata", "pragmat-a", "Pragmat/ic. ~iko, -ies. ~ismo, <B>~isto</B>, -ism, -ist.", "0"],
["prajmo", "prajm-o", "priming, fuse, detonator, percus sion cap. <B>~i</B>, prime. ~a truo, vent (of cannon).", "0"],
["praktiko", "praktik-o", "[UV] Practic/e (opp <I>teorio</I>).<B>1</B> Application (following, pursuit, use) of <B>principles or theory. <I>La kutima ~o</I></B>, usual p. <B><I>~o jura, medicina. ~o de navigado. Plej efika prediko estas ~o</I>. 2</B> actual (p-al) experience:<B> <I>La ~o min konvinkis, ke. Perdi la ~on</I></B>, get out of p., lose the knack of. <I>Havi vastan ~on</I>. <B>3</B> usage: <I>Religiaj ~oj</I>, religious observances. <I>Sekreta ~o</I>, underhand dealings. <B>4</B> (business, custom): <I>~o de kuracisto, juristo</I>. <B>~a</B>, -al. <B>1</B> (<I>laŭ ~o, laŭcela</I>): matter of fact, useful. <I>~a laboro, metodo, scio, sperto</I>. <B>2</B> of experiences, qualities: <I>~a homo</I>. <B>~i</B>, (put into) p., apply, follow: <I>~i sian religion, la virtojn;</I> carry on (profession, trade): <I>~i kiel kuracisto, ~i arton, juron</I>. Employ (<I>metodon</I>). <B>~e</B> (<I>en la ~o</I>), p-ally, in practice, in a practical way, in fact. <B>~anta</B> (<I>juristo</I>), practising. <B>~anto</B>, <B>~isto</B>, practitioner. <B>~ulo</B>, p-al person. <B>Ek~i</B>, take up. <B>Rim</B>.: To practice (learning) = <I>sin ekzerci (ekzerciĝi) pri</I>. <B>Ne~a</B>, un-al. ➞ <I>ekzerc, kutim, mor, oportun</I>.", "0"],
["pralino", "pralin-o", "praline, sweetmeat from burnt nuts.", "0"],
["pramo", "pram-o", "[UV] (<I>transportboato</I>), Ferry(boat), flat-bottomed, square-sided, whether propelled by oar, pole, or tow-rope (2 Sa 19/18). <I>~o karga, transira</I>. <B>~ejo</B>, f. <B>~eto</B>, small f., punt, wherry. <B>~isto</B>, f-man. ➞ <I>barĝ</I>.", "0"],
["pranci", "pranc-i", "(of mettlesome horse), Prance, walk with a bound (hind legs rising almost together). <B>f</B> walk in arrogant manner, swagger. ➞ <I>baŭm</I>.", "0"],
["prava", "prav-a", "[UV] <B>1</B> (pri iu): (in the) Right. Vi estas <B>~a</B>, you are r. Ne ĉiu, kiu laŭte krias, estas ~a. <B>2</B> (pri io): Correct, justified, reasonable, sound, well- founded. ~a ag-(dir-kondut-motiv-opini -rezonad-)o. <B>~e</B>, r-ly, justly. ~e punite, laŭmerite. <B>~(ec)o</B>, r-ness. Ju pli da havo, des pli da ~o. Kolero ~econ ne donas. <B>~i</B>, be (in the) r. Kiu jam havas, tiu ~as. <B>~igi</B> (<I>-n</I>), justify vindicate. ~~i sin (agon, riproĉori). Neseio de leĝo neniun ~igas (is no excuse). ~igebla, defensible. <B>Ne~igebla</B>, unwarranted. <B>Mal~a</B>, (in the) Wrong, incorrect, mistaken, unsound. La forestanto ĉiam estas ~~a. ~<B>~i</B>, be (in the) w. Kiu forton ne havas, ĉiam ~~as, (is in the w.). ➞ ĝust, just, rajt, ver; erar.", "0"],
["prebendo", "prebend-o", "Prebend, benefice from canonry. <B>~ulo</B>, -ary.", "0"],
["precedento", "preceden/to", "(a. <I>~co</I>), Precedent, example; previous case taken as guide to present one. <I>Krei ~on</I>, create a p. <I>Ne rigardu tion kiel ~on</I>. <B>Laŭ~e</B>, according to p. <B>Sen~a</B>, without p., unheard-of, un-ed. ➞ <I>antaŭee</I>.", "0"],
["precesio", "precesi-o", "(astr) precession.", "0"],
["precipe", "precip-e", "[UV] = <I>antaŭ (pli ol) tio alia,</I> above all, chiefly, especially, mainly, particularly, principally. <I>Min ĝenis ~e la moskitoj</I>. ~a (<I>plej grava</I>), chief, essential, first, main, leading, predominant, prime. <I>~a motivo, rolo</I>. ➞ <I>apart, ĉef, special</I>.", "0"],
["precipiti", "precipit-i", "(<I>-n</I>) (chem) Precipit/ate, cause to be deposited. <B>~(aĵ)o</B>, -ate, -ation. ➞ <I>surfundaj</I>.", "0"],
["preciza", "preciz-a", "[UV] Precis/e, accurately expressed, clearly defined, exact. <I>~a desegno, difino, esprimo, horo, informo, kalkulo, mezuro, momento, respondo. ~a</I> (punctilious, scrupulous) <I>observo</I>. <B>f</B> <I>~a horloĝo (instrumento</I>). <B>~e</B>, -ly, with -ion, accurately, exactly, strictly, quite so. <B>~eco</B>, -ion, exactitude, etc. <B>~ega</B>, with high -ion. <B>~igi</B>, define, determine, specify. <I>~igi la daton, la signifon de vorto</I>. <B>~ulo</B>, -ian. <B>Mal~a</B>, <B>Ne~a</B>, indistinct, of uncertain meaning, not clear, vague. <I>Audi ~~an onidiron</I>. <B>Tro~a</B>, fussy, meticulous, overnice, pedantic. ➞ <I>akurat, difinit, ekzakt, ĝust</I>.", "0"],
["predikato", "predikat-o", "[UV] (gram) (log), Predicat/e, what is said of the subject <B>~a</B>, -ive.", "0"],
["prediki", "predik-i", "(<I>-n, ke</I>) [UV], Preach. <B>1</B> give a religious address or sermon. <I>~i pri teksto, temo; la evangelion, Kriston</I>. <B>2</B> advocate, inculcate. <I>~i amon, penton</I>. <B>f</B> <I>al surduloj</I>. <B>~o</B>, exhortation, homily. <B>~a</B>, hortatory. ~e <I>admoni (moral~i</I>), admonish, exhort, moralize, give a lecture. <B>~aĉi</B>, p-ify, sermonize. <B>~anto</B>, -er, minister, (Bb) Ecclesiastes. <B>~aro</B>, collection of sermons. <B>~ego</B>, long-winded discourse, harangue. <B>~ema</B>, -y, moralizing. <B>~ejo</B>, pulpit. ➞ <I>admon, preleg</I>.", "0"],
["predo", "pred-o", "Prey, spoil, victim. <B>~i</B> (nt), p. upon, pillage, plunder, loot.", "0"],
["prefekto", "prefekt-o", "[OA] (<I>distrikta administranto</I>), Prefect (wide sense) (Rn 6/10). <B>1</B> Title of various office-holders. Polica ~o. <B>2</B> (in some schools) senior pupil authorized to maintain discipline, <B>~eco</B>, <B>~ejo</B>, -ure.", "0"],
["preferi", "prefer-i", "(<I>-n, -i</I>) [UV] (<I>Pli ami, pli voli</I>): Prefer (give -ence to), choose rather, count more desirable, like better. <I>~i morti, ol perfidi. ~i akvon ol vinon. El du malbonoj ~i la malpli grandan</I>. <B>~o</B>, -ence, predilection.<B> <I>Havi (senti) ~on por</I>. ~a</B>, -ential. <I>~a tarifo</I>. <B>~e</B> (<I>plivole</I>). <B>~ece</B> (Ge 48/22), -ably, by choice. <I>~e ne iru</I>, better not go. <B>~e</B> <I>ol</I>, in -ence to, rather than. <I>Trinku lakton ~e ol bieron</I>. <B>~aĵo</B>, object. of choice. <B>~ata</B>, favourite, pet. <B>~inda</B>, -able, better, more desirable, worthier of choice. <B>~indaĵo</B>, <B>~eco</B>, advantage, superiority.", "0"],
["prefikso", "prefiks-o", "[F], <B>~i</B>, prefix.", "0"],
["preĝi", "preĝ-i", "(<I>al, por, pri, ke</I>) [UV], Pray. <B>1</B> adore, make devout supplication (to God). <I>~u kore kaj laboru fervore</I>. <B>2</B> beg, beseech, earnestly entreat. <B>~o</B>, -er, invocation, orison. <I>Aŭskulti, fari ~on. ~o familia, vespera. La ~o de la Sinjoro. La Libro de Komuna ~o</I>. <B>~ado</B>, -er, devotions. <B>~ejo</B>, [UV] church, chapel. ➞ <I>moske, sinagog, tempi. ~eja servisto,</I> verger. <I>Filia</I> <B>~ejo</B>, chapel of ease. <B>~ejanaro</B> (<I>kongregacio</I>), congregation. <I>~ejeto</I>, chapel, oratory. <B>~eto</B> <I>antaŭmanĝa,</I> grace before meat. <B>Ĉef~ejo</B> (<I>katedra ~ejo</I>), cathedral. ➞ <I>pet</I>.", "0"],
["prelato", "prelat-o", "[OA] (ecc) Prelate, high dignitary. <B>~aro</B>, <B>~eco</B>, -cy. <B>Ĉef~o</B>, primate.", "0"],
["prelegi", "preleg-i", "Lectur/e. <B>~o</B>, 1., public discourse. <B>~anto</B>, <B>~isto</B>, -er. <B>~aro</B>, course of <B>~ejo</B>, l-room. ➞ lekci, lektor, parol, predik.", "0"],
["preludo", "prelud-o", "[OA] (<I>antaŭludo</I>), (mus, also figuratively), Prelude. <B>1</B> introduction, overture, opening voluntary. <B>2</B> introduction to fugue. <B>~i</B> (play or serve as) p., lead up to, introduce.", "0"],
["premi", "prem-i", "(<I>-n</I>), [UV] Press, squeeze. <B>1</B> exert steady force against, compress, crowd, flatten: <I>~i al la muro. ~u la butonon. ~i argilon, buteron en poton. Esti</I> <B>~ata</B> <I>de la amaso</I>. <B>~itaj</B> <I>kiel sardeloj. ~ita bovaĵo</I>. <B>2</B> compel, constrain, force, urge: ~ita <I>de cirkonstancoj</I>. <B>3</B> weigh down, depress (of feelings, mind, spirits): ~ata <I>de laboro, timo, varmo, zorgo</I>. <I>Krizo ~as la nacion</I>. <B>4</B> Opp (as tyrant). ~i <I>malriĉulon, la popolon</I>. <I>Vidvinon kaj orfon ne ~u</I>. <B>~(ad)o</B>, pressure, compression, constraint, exigency, stress. <B>~o</B> <I>aera, financa, sanga, vapora, venta. Labori sub la ~o de cirkonstancoj. Cedi al insista ~o de amikoj</I>. (vn) <B>~o dukorda</B>, double stopping. <B>~a</B>, <B>1</B> pressing, constraing, depressing, oppressive: <I>~a atmosfero, bezono, situacio, vetero</I>. <B>2</B> (<I>strikta</I>): close-fitting, tight. <B>~e</B>, compactly, tightly</I>. <I>Estas ~e!</I> (close, stuffy). <B>~anto</B>, oppressor. <B>~aĵo</B>, tablet, etc. <B>~ata</B>, crowded, oppressed. <B>~atoj</B>, the down-trodden, op-ed. <B>~(at)eco de animo</B>. <B>~egi</B>, squeeze hard, compress, cram, crush, overwhelm. <B>~ega penso</B>, overwhelming obsession. <I>Mia koro ~iĝis</I>. <B>~ilo</B>, <B>~maŝino</B>, press, e.g., <I>por vestoj, vinberoj</I>. <B>Akvo~ilo</B>, hydraulic p. <B>Oranĝ~ilo</B>, orange-squeezer. <B>Ŝraŭb~ilo</B>, screw p. (mus) <I>kordo</I> <B>(ne)~ita</B>, stopped (open) string. <B>Al~i</B>, clasp. <I>~~i infanon al la koro</I>. <B>Sin ~i al</B>, cling to. <B>cirkaŭ~i</B>, [UV] embrace, hug. <B>Dis~i</B>, crush to pieces, squash. <I>Dio ~~os iliajn ~antojn.</I> <B>Ek~eti</B>, dab. <B>El~i</B>, squeeze out, express, extort, extract. <I>~~i sukon el oranĝo</I>. <B>Inter~i</B>, crowd, crush. <B>Kun~i</B>, compress. (<I>dentojn, lipojn</I>); clench (<I>pugnojn</I>). <B>~~iĝi</B>, huddle up. <B>Sub~i</B> (<I>cedigi, subigi, submeti</I>), keep under, stifle, suppress. <I>~~i emocion, ribelon, ridon</I>. <B>Fingro~aĵo</B>, finger-print. <B>Kor~ata</B>, de-ed. <B>Man~o</B>, grasp. <B>Man~i</B>, clasp (shake) hands. <B>Pied~i</B> (<I>treti</I>), tread (trample) on, crush under foot. <B>Rul~i</B> (<I>paston, razenon</I>), roll, (smooth) out. <B>~~ilo</B>, rolling pin. ➞ <I>dab, deprim, glad, pez, pres, sufok</I>.", "0"],
["premio", "premi-o", "[UV] Prize, reward, for superiority (victory). <I>Disdono de ~oj</I>. prize-distribution. (fin) Premium, option; bonus. <B>~i</B>, award a prize to. <I>~ita poemo</I>, p-poem. <B>~ito</B>, p-winner. ➞ <I>rekompenc</I>.", "0"],
["premiso", "premis-o", "[OA] (log) Premise, premiss. ~o majora, minora (<I>de silogismo</I>). <B>~i</B> (<I>antaŭkondiĉi</I>), condition, p., take for granted.", "0"],
["preni", "pren-i", "(<I>-n</I>), [UV] Take. <B>1</B> take up: <I>~i plumon, monon. Vi povas gin ~i aŭ lasi. ~i en (sub, sur) la brakon, sur la dorson, ŝultron</I>. <B>f</B> <I>el la Biblio</I>. <B>2</B> carry, convey, fetch: <I>~i al la poŝto, el tirkesto, de sub tablo</I>. <B>3</B> conduct, lead: <I>~i ĉevalon per brido, infanon al lernejo, min kun vi</I>. <B>4</B> capture, gain, seize: <I>~i landon, urbon</I>. (chs) <I>pecon</I>. <B>5</B> acquire, get, obtain, procure: <I>~i bileton, ĉambron, edzon, loĝejon</I>. <B>6</B> accept, receive: <I>~i instruon, lecionon, subaĉeton</I> (Se 8/10). <I>Oni ~as avide, oni redonas malrapide</I>. <B>7</B> (a. <I>alpreni</I>): accept, adopt, assume, take up. ~i sur sin <I>iniciaton, komandon, mienon, respondecon, riskon, rolon</I>. <B>8</B> rigardi (take to be): <I>~i kiel atestanton, serviston</I>; <I>lin por iu grava. ~ parolon serioze</I>. <B>9</B> use: <I>~i banon, liberecon, seĝon, veturilon, vojon</I>. <B>10</B> Consume: <I>~i kafon, manĝon, medikamenton</I>. <B>~o</B>, capture, etc. *(cgm) trick. <I>La ~o de la urbo</I>. <B>~enda</B>, to be taken (<I>medikamento</I>). <B>~eto</B> (<B>pinĉ~o</B>), pinch (<I>da salo, flartabako</I>). <B>~ilo</B>, [UV] implement for taking hold of things (➞ <I>tenajl</I>). <B>kontakt~ilo</B> (<B>son~ilo</B>), pick-up (<I>gramofono</I>). <B>suker~ilo</B>, sugar-tongs. <B>~iva</B>, <B>~pova</B>, prehensile. <B>al~i</B>, adopt. <B>ĉirkaŭ-i</B>, [UV] embrace. <B>De~i</B>, take down (off), deduct, deprive of, remove, subtract. <I>~~i kovrilon, ŝilingon, tukon, veston</I>. <I>~~i</I> (doff) <I>ĉapelon</I>. <B>Ek~i</B>, grasp, seize. ~~</I>i <I>ion per tenajlo, iun per la mano ĉe (je) la haroj</I>. <B>El~i</B>, t. out, extract, withdraw. <I>~~i denton</I>. <B>For~i</B>, take away. <I>Dio donis, Dio for~is</I>. <B>Kun~i</B>, bring. ~~u <I>la monon</I>. <B>Re~i</B>, take again (back); cancel, retract (<I>promeson</I>), <I>Doninte, ne re~u</I>. <B>f</B> <I>~~i vorton</I>. <B>Mal~i</B>, drop, let go, unclasp. <B>parto~i</B> (-n, en), [UV] take part (share) in, partake, participate, <I>~~i ĝojon, laboron, profiton</I>. ➞ <I>akcept, entrepren, kapt, port, ten</I>.", "0"],
["prepari", "prepar-i", "(<I>-n, -i</I>), [UV] Prepare. <B>1</B> arrange, get (make) ready, set. <I>~i lecionon, manĝon, pacon, prelegon, teon, samovaron</I> (M 13/22). <B>2</B> coach, e.g., <I>kandidaton por ekzameno</I>. <B>3</B> (mus) <I>~i disonancon</I>. <B>Sin~i</B> (<B>~iĝi</B>) (p., get ready) <I>por batalo, vojaĝo</I>. <B>~(ad)o</B>, preparation, preliminary work. <B>~a</B>, preparative, initiatory, preliminary. <I>~a ekzerco, kurso, studo</I>. <B>~aĵo</B>, (pharm) -ation. <B>Sen~a</B> (<B>ne~ita</B>), un-ed, extempore, impromptu, improvized. <I>~~a traduko</I>. <B>Paĝ~i</B>, (typ) make up, page. ➞ <I>aranĝ, klopod, pretig</I>.", "0"],
["preposto", "prepost-o", "(<I>provosto</I>), provost (wide sense) (jur, mil, municipal, university).", "0"],
["prepozicio", "prepozici-o", "[UV] (gram) preposition.", "0"],
["prepozitivo", "prepozitiv-o", "(gram) indirect object., oblique case, = preposition plus noun or pron. <I>Helpu</I> al mi, <I>dubi</I> pri tio, <I>serĉi</I> por trezoro, <I>atendi</I> dum momento. <B>Rim</B>.: ➞ direct object.: <I>helpu</I> min, <I>dubi</I> tion, <I>serĉi</I> trezoron, <I>atendi</I> momenton.", "0"],
["prepucio", "prepuci-o", "(anat) foreskin, prepuce (Ge 17/11).", "0"],
["prerogativo", "prerogativ-o", "[OA] prerogative, peculiar privilege or right.", "0"],
["presbitero", "presbiter-o", "(ecc) Presbyter, elder. <B>~aro</B>, <B>~ejo</B>, -y. II <B>~iano</B>, -ian. <B>~ianismo</B>, -ianism.", "0"],
["presi", "pres-i", "(<I>-n</I>), [UV] Print. <I>~i artikolon, desegnon, libron</I>. <B>~arto</B>, -ing, typography. <I>En ~ado</I>, in the press. <I>Duobla</I> <B>~o</B>, (phlt) double impression. <B>~aĵo</B>, -ed matter, pull. <B>~ejo</B>, -ing house (office, works). <B>~endaĵo</B>, copy. <B>~igi</B>, have -ed. <B>~ilo</B>, <B>~maŝino</B>, -ing press (plant). <B>~isto</B>, -er. <B>En~i</B>, insert. <B>Mis~i</B>, mis-p. <B>Re~(aĵ)o</B>, re-p. <B>Sur~i</B>, (phlt) over-p, surcharge. <B>~ĉambro</B>, -ers’ chapel. ➞ <I>kompost, prem, tipografi</I>.", "0"],
["preskaŭ", "", "[UV] (<I>apenaŭ ne</I>) (adv), Almost, all but, nearly, not much less than, well-nigh. <I>Mi ~ falis. ~ ĉio</I>, a. all. <I>~ freneza</I>, little short of mad. <I>~ neniam</I>, hardly (scarcely) ever, a. never. <I>~ nenie</I>, hardly anywhere. <I>~ tie</I>, nearly there. ~a, approximate, rough.", "0"],
["preskribi", "preskrib-i", "<B>1</B> (med) Prescri/be, order. <I>-/ al paciento medikamenton, ripozon, rimedon</I>. <B>2</B> order formally, lay down, stipulate (Es 3/9). <I>Per ~itaj vortoj</I>, in a set form of words. <B>~o</B>, -ption, directions. <I>Konforme al la ~o de sia patro</I> (2 Kr 8/14; Ez 9/27; Mai 4/4). <B>~ita</B>, -ed, required, specifed. <B>~folio</B>, -ption form. ➞ <I>recept, regul</I>.", "0"],
["preskripto", "preskript-o", "(jur) prescription, period of posses sion (right, or use). <B>~iĝi</B>, be barred (become invalid, void) by p.", "0"],
["prestiĝo", "prestiĝ-o", "prestige, credit, influence, reputation. <I>Perdi ~on</I>, go down in public estimation, lose face.", "0"],
["preta", "pret-a", "[UV] Ready. <B>1</B> (subj), unreluctant, willg: <I>Esti ~a respondi; riski la aferon; por la eksperimento. ~a por</I>, game for. <I>Estu ~a</I>. <B>2</B> (obj) for immediate use, provided beforehand, with preparations complete: <I>Tute ~a</I>, all (quite) r. <I>~a manĝo, respondo</I>. <B>~e</B>, beforehand. <I>~e konstruita</I>, prefabricated. <I>~e kudrita</I>, r. for wear. <B>~eco</B>, r-ness. <B>1</B> willingness. <I>~eco helpi</I>. <B>2</B> availability, <B>~igi</B> (<I>uzebligi</I>), make r. <I>~igi liton</I>, make a bed. <B>~iĝu!</B> Stand by! <B>Servo~a</B>, compliant, obliging, ready to serve. ➞ <B>Manĝo~a</B> (of food).", "0"],
["preteksto", "pretekst-o", "[UV] pretext, assumed motive, excuse, ostensible reason, subterfuge, <I>Por ŝafon formanĝi, lupo trovos ~on. Sub ~o, ke</I>, on the ground that. <B>~i</B>, allege as defence (excuse), shelter one’s behind. <I>Li ~is</I> (pleaded) <I>mankon de tempo. Li rifuzis, ~(ant)e, ke</I>, alleging the plea (with the excuse) that. ➞ <I>pretend, senkulpig</I>.", "0"],
["pretendi", "pretend-i", "(<I>-n, ke</I>) [UV], Claim; advance pretensions, assert (maintain) as a right, lay c. (to). ~i <I>indulgon, parencecon,</I> c. indulgence, kinship. <B>~o</B>, c., pretension. <B>~anto</B>, -ant, pretender. <I>~anto al la trono</I>. <B>~ema</B>, <B>~oplena</B>, pretentious, assuming, presumptuous. <B>Sen~a</B>, unassuming, modest. ➞ <I>postul, pretekst [Ne= ŝajnig]</I>.", "0"],
["preter", "", "[UV] (prep), Beyond, Past, on the other side of. <B>(a)</B> (with nominatv): = at a place (position) beyond, past. <I>Loĝi ~ la preĝejo. Li pasis ~ mi. ~ tiuj arboj vi trovos</I> Vd Se 7/8. <B>(b)</B> (with accusative): = up to and beyond. <I>Mi pasis ~ la fenestron</I>, I went past the window (to a place b. it). <I>Ĝi iris al li ~ la buŝon</I> (P). <I>Pafi ~ la arbon</I> (K 71/24). Vd Ge 33/3. This distinction is not always clear or observed. Vd Ge 18/3, 5. <B>~e</B> (beyond there, on the other side) <I>oni vidas monton. La reĝo iris ~e</I> (passed by) (1 Rĝ 20/39). <B>~aĵo</B>, excess, overplus, surplus. <B>Rim</B>.: Preter = beyond (past) a position or limit. Trans = across, on the other side of a space. ➞ <I>preternatural, transatlantic</I>.", "0"],
["preterito", "preterit-o", "[OA] (<I>is-tempo</I>), (gram) past tense.", "0"],
["preventi", "prevent-i", "(med) (<I>antaŭforigi, malebligi</I>), Prevent. ~i <I>akcidenton, gravediĝon, malsanon</I>. <B>~a</B>, <B>~ilo</B>, -ive, prophylactic. ➞ <I>malhelp</I>.", "0"],
["prezenco", "prezenc-o", "(<I>as-tempo</I>), present tense.", "0"],
["prezenti", "prezent-i", "[UV] Present [N <I>= donaci</I>]. <B>1</B> (<I>doni, proponi</I>) Offer, proffer, propose, tender: <I>~i al iu la brakon, manon, kukon, peton, varon</I>. Bring forward (<I>argumenton</I>); point (<I>revolveron</I>). <B>2</B> Introduce: <I>~u min al ŝi</I>. <B>3</B> (<I>imagi</I>) imagine, set up in one’s mind: <I>~u al vi mian embarason. Ni malsame vin ~as</I> (\"Preĝo\"). <I>Mi ~as la aferon al mi jene</I>, I look at it this way (like this). <B>4</B> Depict, portray, represent: <I>La bildo ~as hundon, la foto ~as edziĝon,</I> (th) <I>~i</I> perform, render (<I>dramon</I>). <B>5</B> (<I>liveri</I>): give, have, offer: <I>la kongreso ~as imponan vidaĵon; la metodo ~as avantaĝojn; la propono ~as eblon</I> (affords an opportunity). <B>6</B> (<I>esti</I>) form, constitute, set up: <I>Religio ne ~u muron inter la homoj</I>. <B>7</B> <B>Sin</B> <B>~i</B>, present one’s, appear, go in, sit (<I>por ekzameno</I>). <B>~a</B> <I>letero</I>, letter of introduction. <B>~ado</B>, <B>~iĝo</B>, introduction, offer, get-up, style of production. <I>~o de dramo, de volumo</I>. <B>~anto</B>, sponsor. <B>~ebla</B>, <B>~inda</B>, presentable. <B>~iĝi</B>, p. itself, appear, crop up, occur, rise, turn up. <I>Neniu okazo ~iĝis. ~iĝas malfacilaĵo. Vasta panoramo ~iĝis al ili</I>. (obst) <I>~iĝo de feto</I>. <B>Mis~i</B>, misrepresent. <B>re~i</B>, [UV] p. a second time. ➞ <I>reprezent</I>.", "0"],
["prezervi", "prezerv-i", "(<I>kontraŭ putriĝo</I>), Preserv/e (from decomposition), keep fresh, f <I>bone ~ita maljunulo</I>. <B>~aĵoj</B>, tinned food. <B>~iĝi</B>, remain fresh. <B>~ilo</B>, -ative. ➞ <I>enladig, konserv</I>.", "0"],
["prezidento", "prezident-o", "(a. <I>~anto</I>), president, official head (of bank, college, republic, society, etc.). <I>La ~ento forestas, do vi devos ~i</I>, The -ent is away, so you must take the chair. <B>~eco</B>, -ency.", "0"],
["prezidi", "prezid-i", "(<I>-n</I>), [UV] Presid/e (over), be in (occupy, take) the chair, sit at head of table. <I>~i kunvenon, kongreson</I>. <B>~anto</B>, chairman, person presiding.", "0"],
["prezo", "prez-o", "[UV] Price, what must be done (given, sacrificed) to obtain something. <I>~o de bileto, instruo. ~o favora, fiksita, reduktita. Malgranda pezo, sed granda ~o</I>. <B>Enir~o</B>, charge for admission. <B>Lu~o</B>, rent. <B>Sam~o</B>, par(ity). <B>~aro</B>, <B>~listo</B>, p-list, scale of charges, tariff. <B>~inda</B>, worth the p., good value. <B>~indaĵo</B><I>,</I> bargain. <B>Alt~a</B>, <B>grand~a</B>, costly, precious. <B>Ĉiu~e</B>, at any price. <B>Mis~i</B>, mis-p. <B>Vetur~o</B>, fare. <B>~altiĝo</B>, <B>~falo</B>, rise (fall) in price. ➞ <I>kost, tarif</I>.", "0"],
["pri", "", "[UV] (prep), About. <I>Li parolis</I> <B><I>~</I></B> <I>Esp-o,</I> he spoke about (anent, as regards, concerning, of, in relation to, on the subject of, <I>re</I>, with regard (reference) to) Esperanto. <I>Mi dubas tion (~ tio</I>), I doubt (am doubtful about) that. <B>~a</B>, relative. <B>~e</B>, on the matter. <B>~aĵo</B>, subject, theme. <I>PFX:</I> <B>Pri-</B> is sometimes used to narrow the meaning of a verb. Plori, weep; priplori (bewail) <I>mortinton</I>. Semi <I>grenon;</I> prisemi (sow) <I>teron</I>. Serĉi (look for) <I>ion;</I> priserĉi <I>homon</I> (search as customs officer). Ŝteli <I>frukton</I>, priŝteli <I>budon</I>. Tondi <B><I>harojn</I></B>, pritondi<B> <I>kapon</I></B>. Verŝi<B> <I>akvon</I></B>, priverŝi (<B><I>liton) per larmoj</I></B>. ➞ <B><I>koncern, rilat</I>.</B>", "0"],
["prikli", "prikl-i", "(hort) Prick (plant, thin) out (seedlings). <B>~ado</B>, -ing out.", "0"],
["primadono", "primadon-o", "(mus) prima donna,", "0"],
["primara", "primar-a", "(<I>unuagrada, unuaranga</I>), primary (wide sense). <I>~a edukado, koloro, lernejo, roko</I>.", "0"],
["primatoj", "primat-oj", "(zoo) primates, e.g., lemurs, apes, man.", "0"],
["primitiva", "primitiv-a", "[OA] primitive. <B>1</B> (<I>unuatempa</I>), early, first, original, primary: <I>~a eklezi -(hom-lingv-)o</I>. <B>2</B> antiquated, old-fashioned: <I>~a metodo</I>. ➞ <I>pra</I>.", "0"],
["primo", "prim-o", "(mat) prime number,", "0"],
["primolo", "primol-o", "[UV] primrose (<I>Primula vulgaris</I>). <B>~acoj</B>, primula fam.. ➞ <I>veris</I>.", "0"],
["primuso", "primus-o", "\"primus\", trade name of stove burning vaporized paraffin oil.", "0"],
["principo", "princip-o", "[F], Principle, Fundamental. <B>1</B> primary element: <I>~o de vivo</I>. <B>2</B> f. truth, basis of (guide to) reasoning or judgment, gen. law(rule): <I>~oj de arto. Konsenti pri ~oj</I>, agree on pp. <B>3</B> rule of conduct: <I>~o morala, religia. Mia ~o estas</I> (Gm 51/12). <I>Agi laŭ la ~o, ke</I>. <B>f</B> honour, integrity, probity, rectitude. <B>~a</B>, f., of p. <I>Demando ~a</I>. <B>~e</B>, on p., as a rule. <I>~e mi konsentas, praktike mi hezitas</I>. <B>~aro</B>, creed, tenets. <B>Sen~a</B>, un-ed. ➞ <I>precip</I>.", "0"],
["princo", "princ-o", "[UV] Princ/e. <B>1</B> ruler of small state. <B>2</B> (<I>reĝido</I>), member of royal fam.. <B>~(ec)a</B>, -ely. <B>~ino</B>, -ess. <B>~lando</B>, -ipality. <B>Kron~o</B>, crown-p., heir to the throne, <B>f</B> <I>~o de mallumo</I> (the devil), <I>~o de Paco</I> (Christ).", "0"],
["printempo", "printemp-o", "[UV] Spring. <I>Unu kukolo ne faras ~on. ~o semas, aŭtuno rikoltas</I>. <B>f</B> <I>La ~o</I> (s-time, heyday) <I>de la vivo</I>. <B>~a</B>, (of) s., vernal. <B>~e</B>, in the s.", "0"],
["printi", "print-i", "(phot) print (off, out) on sensitized paper. <I>~i dek ekzemplerojn. ~a papero</I>.", "0"],
["prioro", "prior-o", "[OA] (ecc) Prior. <B>~ejo</B>, -y. <B>~ino</B>, -ess.", "0"],
["prismo", "prism-o", "[OA] Prism. <I>Glacia ~o</I>, ice needle. <B>~(ec)a</B>, -atic. <B>Tra~igi</B> (decompose) <I>lumon</I>.", "0"],
["pristo", "prist-o", "(<I>segfiŝo</I>), saw-fish (<I>Pristis</I>).", "0"],
["privata", "privat-a", "[UV] Private, (opposite <I>publika</I>). <B>1</B> without official position or public office: <I> ~a homo (~ulo</I>). <B>2</B> not for public use: <I>~a hotelo (pordo</I>). <B>3</B> confidential, intimate, one’s own, personal: <I> ~a afero, domo, orelo, propraĵo, vivo</I>. <B>4</B> retired, secluded, sequestered: <I> ~a loko</I>. <B>~eco</B>, privacy, retreat, seclusion. <B>~ulo</B>, p. person. <B></B> ➞ <I>konfidene, sekret</I>.", "0"],
["privilegio", "privilegi-o", "[UV] Privilege; special advantage (concession, favour, immunity, licence, right). <I>~o de maljuneco. Parlamenta ~o</I>. <B>~i</B> (<I>-n</I>), allow (to do), confer (grant, invest with) p., exempt from burden, show partiality. <I>~i personojn</I> (Ps 82/2). <B>~aj</B> <I>klasoj</I>, -ed classes. <B>~ulo</B>, -ed person. ➞ <I>monopol, prerogativ</I>.", "0"],
["prizono", "prizon-o", "= malliberejo.", "0"],
["pro", "", "[UV] (prep), because (by reason, for the sake, on account or behalf) of, for, from, owing to, through. <B>1</B> (motive, reason): <I>Post tio, sed ne ~ tio. Rapidi ~ manko de tempo. Morti ~ nesingardo. ~ ĉielo!</I> for heaven’s sake! <I>~ kio (= Kial) vi venis?</I> Why did you (What made you) come? ➞ <I>Por kio vi venis?</I> What did you come for? <I>~ tio (= tial), ke … </I> for the reason that (stronger than <I>ear</I>). <B>2</B> (<I>kontraŭ</I>): in exchange for (➞ <I>quid pro quo). Okulon ~ okulo</I>, an eye for an eye. <I>Danki</I> ~ (better than <I>por) donaco, helpo, letero</I>. <B>~batalanto</B>, champion, defender, protagonist. <B>~labora</B> <I>pago,</I> <B>~memora</B> <I>noto</I>, <B>~peka</B> <I>kapro</I> (scapegoat). ➞ <I>dank’, de, kaŭz, motiv, pri</I>.", "0"],
["probabla", "probabl-a", "[OA] Likely, Probable, on the cards, that may be expected to happen (or prove true), to be expected. <I>~a eraro. Pli ol ~a. Tute ne ~a</I>, most un-1. <B>~e</B>, p-ly, in all -ility, most 1. <B>~eco</B>, p-ility. ➞ <I>verŝajn</I>.", "0"],
["problemo", "problem-o", "[OA] Problem (to be solved), doubtful (difficult) point, question at issue. <I>~o algebra, socia, ŝaka. Proponi, solvi ~on</I>. (mat) rider, sum. <B>~a</B>, -atic(al), doubtful, moot, questionable. ➞ <I>enigm</I>.", "0"],
["procedi", "proced-i", "(nt) [OA], Proceed, adopt course of action, go about (on) with, make one’s way. <I>~i energie, metode</I>. <B>~o</B>, -ing, conduct, method, process, way. <I>Nova ~o de fabrikado</I>. ➞ <I>ag, far, klopod, metod, proeedur</I>.", "0"],
["proceduro", "procedur-o", "[OA] (jur), procedure, mode (order, rule) of conduct (business). <I>~o jura, parlamenta</I>.", "0"],
["procelario", "procelari-o", "(orn) Shearwater (<I>Procellaria</I>). ~o granda, Gt s. <B>~o griza</B>, <B>fulga</B>, sooty s. ➞ <I>fraterkol, fulmar, petrel</I>.", "0"],
["procento", "procent-o", "[UV] (fin) per cent, rate: <I>Diskonta ~o</I>, bank rate. <B>1</B> year’s interest (proceeds, profit) on fOO units. <I>En la</I> 3 <I>~oj</I>, in the 3 per cents (3% stock). <B>2</B> (<I>centono, elcento</I>): percentage, proportion, value (relative to 100). <I>Necesas ŝanĝi nur</I> 10 <I>~ojn (centonojn). Kalkuli la ~on de blinduloj. Doni</I> <B>~e</B>, <B>~aĵo</B>, commission, percentage. <I>Ricevi ~on de ĉiuj eldonoj</I>. <B>~ego</B> [OA] (<I>uzuro</I>), extortionate interest, usury. <I>Doni</I> <B>~ege</B> (Ps 15/5), <I>~egisto</I>, usurer. <I>Kvin~a dividend, solvaĵo</I>. ➞ <I>interez, rentum</I>.", "0"],
["procesi", "proces-i", "(<I>kontraŭ, pri</I>) [UV], bring (enter) an action, go to law with, prosecute, take legal proceedngs against (Ij 13/19). <B>~o</B>, (jur) law-suit, action, case, proceedngs at law, trial (Jes 3/14). <I>Gajn-(perd-)i ~on. Komenciĝas ~o, mono fluas sen ĉeso</I>. <B>~ado</B>, litigation. ~anto, <B>~ulo</B>, party (to a suit), litigant. <B>~ebla</B>, actionable. <B>~ema</B>, litigious. ➞ <I>proced, proces</I>.", "0"],
["procesio", "procesi-o", "[OA] procession. <I>~o festa, funebra, religia, torĉa</I>. <B>~a</B>, -al. <I>~a himno</I>. <B>~i</B> (iri <B>~e</B>), go in p.", "0"],
["procezo", "procez-o", "process, course (succession) of phenomena, series of changes. <I>~o</I> <B><I>historia, evolua, tempa</I></B>.", "0"],
["prociono", "procion-o", "(zoo) raccoon, coon (<I>Procyon</I>).", "0"],
["produkti", "produkt-i", "(<I>-n</I>), [UV] Produ/ce. <B>1</B> bear, bring forth, create, grow, yield: <I>Usono ~as grenon, arbo fruktojn. ~i varmon, vaporon</I>. <B>2</B> bring about, cause, effect, furnish, give rise to, occasion: <I>~i ateston, impreson, sensacion</I>. <B>3</B> make, manufacture: <I>Batado de lakto ~as buteron. La firmo ~as plastojn</I>. <B>~ado</B>, <B>~aĵo</B>, p., product(ion), output, yield. <I>Stimuli ~on. ~(aĵ)oj de la tero</I>. <B>~ema</B>, <B>~iva</B>, productive. <B>~ilo</B>, generator. <B>~isto</B>, producer. <B>Re~i</B>, re-p. <B>1</B> <I>~~i per semo</I>. <B>2</B> make a similar obj, <I>~~</I>i <I>pentraĵon</I>. <B>Flank~o</B>, by-product, secondary product. <B>Super~o</B>, <B>Tro~o</B>, overproduction.", "0"],
["produto", "produt-o", "(mat) product (of multiplication).", "0"],
["profana", "profan-a", "[OA] Profan/e. <B>1</B> lay, uninitiated. <B>2</B> secular (opp <I>religia): ~a historio, literaturo</I>. <B>3</B> impious, irreverent: <I>~a trakto de sanktaĵo</I>. <B>~(ul)o</B>, <B>1</B> layman, Philistine, person uninitiated, outside the fold. <I>Pri arto mi estas ~ulo</I> (a rank outsider) (K 181/32). <B>2</B> irreverent person. <B>~i</B>, 1 defile, desecrate, treat with disrespect, violate: <I>~i feston, promeson, preĝejon, senton, tombon</I>. <B>2</B> degrade, misuse: <I>~i talenton</I>. <B>~ado</B>, -ation. ➞ <I>malrespekt, sakrilegi</I>.", "0"],
["profesio", "profesi-o", "[UV] Profession, (a)vocation, business, calling, occupation. <B>~a</B>, -al. <I>~a etiketo, kriketo, oratoro, sekreto</I>. <B>~ismo</B>, -alism. <B>~ulo</B>, -al, vocational. <I>~ulismo</I> (2 Petrolo 165/13). <B>Ne~a</B> (<I>amatora</I>). <B>Sam~ano</B>, -al colleague. ➞ <I>meti, okup, sin nomi, vivrimed</I>.", "0"],
["profesoro", "profesor-o", "[OA] Professor (various meanings in various lands). <B>1</B> University p. (opposite <I>studento</I>). <B>2</B> Master (teacher) at high school or of high rank (opposite <I>lernanto</I>): <I>~o licea</I>. <B>~a</B>, -ial. <B>~aro</B>, -ial staff. <B>~eco</B>, -ship, chair, <B>~ino</B>, lady p. ➞ <I>lektor</I>.", "0"],
["profeto", "profet-o", "[UV] Prophe/t, inspired interpreter, revealer, teacher of God’s will, seer. (Bb) <I>La (mal)grandaj ~oj</I>. <B>f</B> <I>Veter~o (evit. prefere: veterprognozisto</I>), <B>~a</B>, -tic. <B>~i</B>, -sy. <B>1</B> be a p. <B>2</B> (<I>antaŭdiri</I>). <B>~aĵo</B>, -cy. <B>~ino</B>, -tess. ➞ <I>orakol</I>.", "0"],
["profilakso", "profilaks-o", "(med) Prophyla/xis. <B>~a</B>, -ctic. ➞ <I>antaŭgard, prevent</I>.", "0"],
["profilo", "profil-o", "[OA] Profile, Outline. <B>1</B> half-face, side-face, side-view, silhouette. <B>2</B> sectional drawing. <I>~o orta</I>, cross-section at 90°. <B>~i</B>, draw in profile (outline, contour). <B>~e</B>, in profile, sideways. <I>Duon~e,</I> in three-quarter face. <B>~iĝi</B>, stand out in p., be o-d (silhouetted) against.", "0"],
["profiti", "profit-i", "(<I>-n, de, el</I>) [UV]. <B>1</B> get Advantag/e (gain) (from), Benefi/t (Profit) (by): <I>Du militas, tria ~as</I>. <B>2</B> make use (take advantage) of: <I>~i la okazon, ŝancon</I>. <B>~o</B>, a., b., p., excess of income over outlay, gain, returns, utility. <I>Celi, ricevi, trovi ~on. Serĉi ~on,</I> seek after gain. <I>~o kaj perdo</I>. <B>~(ig)a</B>, <B>~odona</B>, beneficial, profitable, favourable, lucrative, paying, remunerative, useful. <I>Peke akirita ne estas ~a. Vendi</I> <B>~e</B>, at a profit. <B>~ama</B>, <B>~avida</B>, <B>~ema</B> (Jer 6/13), avaricious, greedy of gain, mercenary. <I>~egisto,</I> profiteer. <B>~emo</B>, cupidity. <B>~igi</B>, make a-ious (p-able), bring p. <B>Mal~o</B>, loss. <B>Ne~a</B>, <B>Sen~a</B>, p-less, unp-able, bootless. <I>Labori sen~e</I>. <B>Ne~ema</B> (<I>malegoista, sindona</I>), disinterested. <B>Super~o</B>, excess profit. <B>Tro~i</B> (<I>ekspluati</I>), abuse. ➞ <I>enspez, gajn, utilig</I>.", "0"],
["profunda", "profund-a", "[UV] Deep, Profound. <B>1</B> ~a <I>akvo, lago, puto, riverenco, voĉo, vundo</I>. <B>2</B> deep intellectually, erudite: <I>~a doktrino, studo, scio, senco</I>. <B>3</B> deeply seated, heartfelt: <I>~a doloro, konvinko, medito, malespero</I>. <B>4</B> intense, great: <I>~a dormo</I> (sound sleep). <I>~a ago</I> (Ge 18/11; 24/1). <I>~a diferenco, intereso, mallumo</I>. <B>~o</B>, depth, background, bottom, innermost part. <I>~o de la ĉambro, koro, nokto, tero</I> (Ps 69/2, 15); a. <B>~eco</B> (Ps 64/6). (mar) draught. <B>~e</B>, deeply, profoundly. <I>Kliniĝi ~e</I> (Ge 23/7). <I>Tranĉi ~e. Fiŝo granda naĝas ~e. Iri pli</I> <B>~en</B> (further) <I>en la aferon</I>. <B>~(eg)aĵo</B> (<I>abismo</I>), abyss, depth. <B>(en)~iĝi</B>, absorb (bury) one’s in, become absorbed in, penetrate into. <I>~iĝintaj</I> (d-sunk) <I>okuloj</I>. <B>f</B> <I>~iĝi en detaloj (legado, pensoj</I>). <B>~aĝa</B>, stricken in years. <I>~aĝulo</I> (Jer 6/11). <B>Mal~a</B>, shallow, superficial: <I>~~a cerbo, telero</I>. ➞ <I>supraĵ, trivial. ~~aĵo</I>, (mar) shallow, shoal. <B>Plej~a</B>, bottommost, nethermost. <B>Pli~igi</B>, <B>~iĝi</B>, deepen. ➞ <I>abism, absorb, fon</I>.", "0"],
["prognozo", "prognoz-o", "[OA] Prognos/is, Forecast, prediction, preindication (of course of illness, etc.). <B>Veter~o</B>, weather forecast. <B>Longperioda</B> <B>~o</B>, long-range f. <B>~i</B>, betoken, forecast, prognosticate. <B>~a</B>, predictive. ➞ <I>profet</I>.", "0"],
["programo", "program-o", "[OA] programme, list of arrangements, plan, syllabus. <I>~o de ceremonio, koncerto</I>. (th) playbill. <B>~a</B> <I>muziko</I>. <B>~ero</B>, item, number, piece. ➞ <I>aranĝ, plan, tagord</I>.", "0"],
["progresi", "progres-i", "[OA] (nt) (make) Progress, advance, develop, forge ahead, get on, go onward (forward) (Jes 58/8). <I>Ĉio ~as kontentige. ~i en studado</I>. <B>~o</B>, p., advance, forward (onward) movement, headway. <I>La ~o de armeo, lernanto, scienco</I>. <B>~ado</B>, -ion. <B>~ema</B>, -ive, advanced in opinions, forward-moving. <I>~ema partio</I>. <B>~emulo</B>, <I> ive</I>. <B>~igi</B>, help forward, promote, <B>~inta</B>, advanced, proficient. <B>Mal~i</B> (<I>regresi</I>), decline, fall back, retrogress. <I>~~ema,</I> reactionary, retrograde. <B>Ne~ema</B>, backward. ➞ <I>retropaŝ</I>.", "0"],
["progresio", "progresi-o", "(mat) Progression. ~o <I>aritmetika, geometria, harmona</I>. (mus) p. from one chord to another.", "0"],
["progresiva", "progresiv-a", "progressive, regularly advancing, increasing. <I>~a imposto</I>. ➞ <I>akcel, antaŭen, disvolv, grad</I>.", "0"],
["prohibi", "prohib-i", "(<I>leĝe malpermesi</I>), Prohibit, debar, forbid (action, person from doing something, especially sale of intoxicants). <B>~a</B>, -ive. <B>~o</B>, <B>~ismo</B>, -ion. <B>~isto</B>, -ionist, <B>~ita</B>, -ed.", "0"],
["projekcio", "projekci-o", "[OA] <B>~aĵo</B>, (cinema, des, phot) Project/ion, representation on plane surface or screen. ~o <I>izometra, merkatora, vertikala</I>. <B>~i</B> (<I> n</I>), cast (make, throw) a projection. <I>~i bildon, lumradion, ombron</I>. <B>~ilo</B>, -or.", "0"],
["projekto", "projekt-o", "[F], Project, preliminary draft, plan, scheme, <B>(a)</B> idea to be realized; <B>(b)</B> plan to realize it. <I>Fari, plenumi ~on. ~o de fervojo, konstruo, reorganizo. ~o de leĝo</I>, draft bill. <I>Bela ~o, morgaŭ forgesota. ~o provizora. Lingvaj ~oj</I>. contrive, devise, plan (course of action). <B>~i</B> <I>vojaĝon</I>. <B>~ema</B> ingenious, scheming. <B>Kontraŭ~o</B>, counter-project. ➞ <I>plan, program, skem</I>.", "0"],
["prokavio", "prokavi-o", "(a. <I>hirako</I>), (zoo) cony, daman, dassie, hyrax (<I>Proeavia</I>). (➞ Se 30/26).", "0"],
["proklami", "proklam-i", "(<I>-n</I>) [UV], Procla/im, publicly announce (declare). <I>~i sin reĝo. ~i respublikon</I>. <B>~(ad)o</B>, -mation. <B>Edziĝo~o</B>, banns. <B>Milit~o</B>, declaration of war.", "0"],
["prokrasti", "prokrast-i", "(<I>-n</I>) [UV], Delay, Procrastin/ate, defer, (suspend) action, put (stave) off. <I>Ne ~u ĝis morgaŭ, kion vi povas fari hodiaŭ</I>. <B>~(ad)o</B>, d., p-ation, remand, etc. (com) demurrage. <B>~ebla</B>, that can wait. <B>~ema</B>, dilatory. <B>Ne~ebla</B>, that cannot be put off, urgent. <B>Sen~e</B>, at once, forthwith, without d.", "0"],
["proksima", "proksim-a", "[UV] Near, in Proxim/ity, adjoing, close, nigh. <B>1</B> (space): neighbouring. <I>~a lando (urbo). Plej~a</I>, closest, nearest, <B>f</B> <I>~a helpo (parenco</I>). <B>2</B> (time): approaching. following, next. <I>~a jaro, tago</I>. <B>~e</B> de, at (to) hand, near (close) to. <I>Li loĝas ~e de mi. Tute ~e</I>, at close quarters. <I>Rigardi de ~e</I>, close up. <B>~eco</B>, affinity, proximity, vicinity. <I>En la ~eco de,</I> at the distance of. <I>Sanga ~eco</I>, near relationship. <B>(al)~igi</B>, approximate, bring near. <B>(al)~iĝi</B>, come (draw) near. (up to). <I>La tasko ~iĝas al la fino</I>. <B>~ulo</B> (<I>najbaro</I>), neighbour. <B>~uma</B> (<B>~ume</B>), about, ap-ately, more or less. ➞ <I>ĉirkaŭ. La biblioteko havas ~e mil volumojn</I>. <B>Mal~a</B>, Distan/t, far away (olf). <I>~~e de</I>, aloof (at a distance) from. <I>De</I> <B><I>~~e</I></B>, from afar. <B>~~en</B>, to a d-ce. <I>Pli ~~en</I>, further on. <B><I>~~</I>igi (-iĝi)</B>, move to a d-ce, recede. ➞ <I>apud, distanc, for, nekst</I>.", "0"],
["prokuro", "prokur-o", "Proxy, procuration. <I>Doni ~on al. Voĉdoni</I> <B>~e</B>, by proxy. <B>~isto</B>, agent, assignee, attorney, trustee. <I>~a letero</I>, p. (document).", "0"],
["prokuroro", "prokuror-o", "Attorney General, Procurator Fiscal (Scotland). ➞ <I>anstataŭ</I>.", "0"],
["prolapso", "prolaps-o", "(med) prolapse, slipping out of place.", "0"],
["prolepso", "proleps-o", "(rh) prolepsis, (anticipatory use of a word).", "0"],
["proleto", "prolet-o", "(a. <B>proletario</B> [OA]), proletariat, worker. <B>~aro</B>, -t, lower classes.", "0"],
["proliferi", "prolifer-i", "Prolifer/ate (<I>sin reprodukti</I>). <B>~a</B>, -ous. <B>~ado</B>, -ation.", "0"],
["prologo", "prolog-o", "[OA] prologue, preliminary (introductory) discourse, preamble. ➞ <I>antaŭparol</I>.", "0"],
["promeni", "promen-i", "[UV] Promenade, Walk, (nt), take an airing, make a short excursion, for exercise or pleasure (on foot or otherwise), drive, sail, stroll. <I>~i bicikle,</I> go for a spin. <I>~i piede (surĉevale</I>), take a walk (ride), <B>f</B> <I>Lia cerbo iris ~i. Liaj okuloj ~is</I> (wandered) <I>ĉirkaŭ la ĉambro</I>. <B>~(ad)o</B>, p., w., airing, jaunt, outing, trip. <B>Mar~o</B>, sea trip. <I>Postmanĝa ~o</I>, constitutional. <B>~a</B> <I>ŝipo</I>, excursion (pleasure) boat. <B>~adi</B>, p. <B>~ejo</B>, p., walk, esplanade, parade. <I>Surmara ~ejo</I>, pier. <B>~igi</B> (<I>-n</I>), take for a w., exercise (<I>hundon). ~igi la pensojn</I>, allow one’s thoughts to run. <I>~igi la fingrojn sur</I> (run the fingers over) <I>la klavoj</I>. <B>~anto</B>, walker, saunterer. ➞ <I>marŝ, piedir, vag, vojaĝ</I>.", "0"],
["promesi", "promes-i", "[UV] (fori -on) (<I>-n, -i, al</I>), (make a) Promis/e. <B>1</B> give one’s word. ~i <I>edziĝon, helpon, pagon</I>. <I>Ofte mano forgesas, kion buŝo ~is</I>. <B>f</B> ~i <I>orajn montojn</I>. <B>2</B> afford expectations (seem likely to). <I>La vetero ~as esti bela</I>. <B>~o</B>, p., assurance, engagement, parole, pledge, word. <B>Jur~o</B> (<I>~o sankta, solena</I>), vow. <B>Fianĉ~o</B>, troth. <B>Pag~o</B>, <B>I.O.U</B>. <I>Fari, forgesi, plenumi, repreni ~on. Per ~oj estas pavimita la infero. La ~ita Lando</I>. <B>~itaĵo</B>, <I>p. <B>~(oplen)a</B>, <B>multe~a</B> (infano, juneco</I>), <I> ing, likely to turn out well, (com) promissory,</I>", "0"],
["promocii", "promoci-i", "(-n), (4 FA 132/2), Promot/e, advance, raise to higher grade (office, rank), (chs, drs) (damigi), <B>~i</B> <I>pecon</I>. <B>~o</B>, -ion<I>, advancement, preferment</I>.", "1"],
["promontoro", "promontor-o", "[UV] (geog) promontory, high cape, headland &lt; <I>kab, terkap</I>.", "0"],
["pronelo", "pronel-o", "dunnock (<I>Prunella</I>) (misleadingly called hedge-sparrow). ➞ <I>prunel</I>.", "0"],
["pronomo", "pronom-o", "[UV] pronoun. <I>~o demanda, montra, nedifina, persona, poseda, rilata, refleksiva, sumiga</I>.", "0"],
["prononci", "prononc-i", "(<I>-n</I>) [OA], Pronounc/e. <B>~o</B>, pronunciation. <I>~o fremda, loka, misa</I>. <B>~a</B> <I>vortaro</I>, -ing dictionary. <B>~aĉi</B>, mangle (murder) the words. La vorto \"<I>budĝeto\"</I> estas malfacile <B>~ebla</B> (hard to p.). <B>Mis~i</B>, mis-p. <I>Litero</I> <B>ne~ata</B>, silent letter. ➞ <I>elparoli</I> (enounce, speak out clearly).", "0"],
["propagando", "propagand-o", "[OA] Propagand/a, publicity, organized scheme to spread belief or practice. <I>~o por Esperanto. ~o milita</I>, war- mongering. ~a <I>parolo, verko</I>. ~i (<I>fari -on</I>), carry on p., advertise, publicize, spread. ~ilo, means of p. <B>~isto</B>, -ist. ➞ <I>apostol, disvastig, reklam, rekrut, varb</I>.", "0"],
["propagi", "propag-i", "(<I>-n</I>), (ph) propagate, transmit in waves, ~i <I>lumon, tertremon, vibradon</I>. Lumo <B>~iĝas</B> po 186,300 mejloj sekunde.", "0"],
["proponi", "propon-i", "(<I>-n, -i, ke</I>) [UV], Propos/e. <B>1</B> submit for consideration, examination, judgment); bring forward, propound, put forward: <I>~i problemon, reformon, teorion. Mi ~as, ke vi pagu. Homo ~as, Dio disponas</I>. (at a meeting): <I>~i (fari ~on</I>), move, put a motion. <B>2</B> (offer for acceptance): <I>~i edziĝon, helpon, kandidaton, monon. Sin ~i</I> (stand, volunteer) <I>por elekto. Sin ~i kiel serviston</I>. <B>~o</B>, -al, -ition, suggestion, tender. <I>Akcepti, diskuti, rifuzi ~on</I>. <B>Aĉet~o</B>, bid. <B>Vend~o</B>, offer. <I>Pano de ~o</I> (El 25/30), shewbread. <B>~anto</B>, mover, proposer. <B>Kontraŭ~o</B>, counter-al. <B>Pli~i</B>, <B>super~i</B>, bid higher, outbid. ➞ <I>ofer, prezent</I>.", "0"],
["proporcio", "proporci-o", "<I>[OA]</I> (1 FA 85/2) Proportion, percentage, ratio. ~o <I>inversa, konstanta, rekta</I>. ~o <I>de alkoholo en vino</I>; <I>de la profitoj</I>. La ~oj de tambro. Regulo de ~o (arit), rule of three. <B>~a</B>, -al, -ate; <I>corresponding, pro rata, relative</I>. ~a al (<I>Le 27/16). (pol</I>) ~a reprezento.<I> <B>~e</B>, -ately, ad valorem, pro rata. <B>~igi</B> (fit) la punon al la krimo</I>.<I> <B>Mis~o</B>, dis-p. <B>Sen~a</B>, out of p</I>.", "0"],
["propozicio", "propozici-o", "[OA] (gram) proposition, assertion, formal statement (affirmative or negative), especially (log) in the form subject -f copula + predicate. ➞ <I>fraz, klaŭz</I>.", "0"],
["propra", "propr-a", "[UV] <B>1</B> (one’s) Own, belonging to one: <I>Mia ~a</I> (my o.) <I>lito, mano, nomo, volo. Estu saĝulo en via ~a domo. ~an</I> (his o.) <I>ĝibon neniu vidas. Liaj ~aj vortoj</I>, his very words. <I>Timi sian ~an</I> (one’s own) <I>ombron, fali en la ~an kaptilon</I>. <B>2</B> Peculiar to, characteristic, individual, personal: <I>Moro ~a al la Britoj</I>. (ac) <I>~a (natural) resonanco</I>. <B>~e</B>, properly, strictly speaking. ~aĵo (<I>posedaĵo</I>), belonging(s), property. <I>Nenies -aĵo</I>. <B>~eco</B>, characteristic feature, attribute, nature. <I>La ~ecoj de metaloj</I>. <B>(Al)~igi</B> <I>al si</I>, appropriate, make one’s own. ➞ <I>plagiat, ŝtel</I>. <B>Ali~igi</B>, <B>mal~igi</B>, <B>sen~igi</B>, expropriate. <B>Mal~a</B> (<I>fremda, alies</I>), another’s, foreign, no business (concern) of mine, not one’s own, of others, someone else’s. <I>Aferoj ne~aj</I>, other people’s business. [Ne= proper (<I>deca, ĝusta, konvena, taŭga</I>)].", "0"],
["proprieto", "propriet-o", "(jur) proprietorship, the right (especially the exclusive right) to the possession or disposal of something. <B>Eks~igo</B>, expropriation.", "0"],
["proscenio", "prosceni-o", "(arch, th) proscenium,", "0"],
["proskribi", "proskrib-i", "(jur) Proscri/be, put out of legal protection. <B>1</B> outlaw, banish. <B>2</B> interdict, reject. <B>~o</B>, -ption.", "0"],
["prospekto", "prospekt-o", "[OA] prospectus, descriptive circular. ➞ <I>anonc, reklam, perspektiv</I>.", "0"],
["prosperi", "prosper-i", "[UV] Prosper. <B>1</B> be -ous, do (turn out) well, flourish, get on, thrive. <I>Kiu koleras, tiu ne ~as. La komerco ~as</I>. <B>2</B> (abs) <I>~is al mi iri</I>, I managed (had the good fortune) to go, succeeded in going. <I>Ne ~is al li edziĝi</I>. <B>~a</B>, -ous, flourishing, thriving, well off (to do). <B>~(ad)o</B>, -ity, good fortune, -success, weal. <I>Porti ~on al la lando</I>. <B>~igi</B>, advance, favour. <B>Mal~i</B>, be in a bad way (danger, jeopardy), fail, miscarry, prove unsatisfactory, turn out badly. <I>~~o</I>, ill success. <I>~~a</I> (ill-starred) <I>provo. ~~igi,</I> wreck (<I>planori</I>). ➞ <I>sukces</I>.", "0"],
["prostato", "prostat-o", "prostat/e (gland). <B>~a</B>, -ic. <B>~ito</B> (~inflamo), -itis.", "0"],
["prostitui", "prostitu-i", "(<I>-n</I>) [OA], Prostitut/e (Le 19/29). <B>f</B> put to infamous use, misuse, pervert. <I>~i sin, sian talenton</I>. <B>~(ad)o</B>, -ion. <B>~isto</B>, pimp. <B>~itino</B>, p., harlot. ➞ <I>bordel, fi, malĉast, publik</I>.", "0"],
["protagonisto", "protagonist-o", "[OA] Protagonist, chief person (in drama, story), champion (of cause).", "0"],
["proteino", "protein-o", "(chem) protein.", "0"],
["protekti", "protekt-i", "(<I>-n, al, kontraŭ</I>) [OA], Protect (against, from): cover, defend, guard, keep safe, preserve, shield. <I>~i ion kontraŭ damaĝo, fajro, perdo, rusto</I>. <B>f</B> befriend, favour, help, stand by, support. <I>Kiun reĝo ~as, tiun ministro elektas</I>. <B>~(ad)o</B>, -ion, patronage. <B>~(em)a</B>, -ive. <I>~a tarifo</I>. <B>~anto</B>, -or, defender, guardian, patron. <B>~ato</B>, protege. <B>~ilo</B>, -or, -ive device. <B>~ismo</B>, <B>~isto</B>, -ion, -ist. ➞ <I>defend, gard, patron, ŝild, ŝirm</I>.", "0"],
["protektorato", "protektorat-o", "[OA] (pol) -orate, ➞ <I>koloni</I>.", "0"],
["protelo", "protel-o", "aard-wolf (<I>Proteles</I>).", "0"],
["protesti", "protest-i", "(<I>kontraŭ</I>) [OA], Protest, Remonstr/ate. <I>~i kontraŭ decido, diro, propono</I>. (com) p. (a bill), <B>f</B> <I>Kontraŭ tio ~as mia sento</I>. <B>~o</B>, protest, objection, statement of disapproval, dissent. <I>Aŭdiĝis indignaĵ~oj,</I> <B>~ado</B>, r-ance. <B>~anto</B>, (rel) -ant. <B>protestantismo</B>. <B>~ebla</B>, questionable. <B>~enda</B>, reprehensible. <B>Sen~e</B>, without p., submissively. ➞ <I>kontest</I>.", "0"],
["proto", "proto-", "(Gk pfx = first), proto-.", "0"],
["protokolo", "protokol-o", "[OA] Minutes, Record, formal statement, short official report (of meeting or transaction). <I>La ~o de la antaŭa kunveno</I>. (pol) protocol. <B>~i</B> (<I>fari ~on</I>), draw up (write) the minutes, make a record of the proceedings. <B>~aro</B>, m-book, records. <B>~ero</B>, item of the minutes. <B>~isto</B>, r-clerk.", "0"],
["protono", "proton-o", "(ph) proton,", "0"],
["protoplasmo", "protoplasm-o", "protoplasm.", "0"],
["prototipo", "prototip-o", "[OA] prototype, original.", "0"],
["protozoo", "protozo-o", "protozoon.", "0"],
["protuberanco", "protuberanc-o", "(anat, as), Protuberance, bulge, bump, swellg. <B>~a</B>, -t.", "0"],
["proverbo", "proverb-o", "[UV] Proverb, adage, saw. <I>Venas ~o el popola cerbo</I>. (gm) <B>~oj</B>, proverbs. <B>~a</B>, -ial. <I>~a fideleco de hundo</I>. <B>~aĵo</B>, byword. <B>~aro</B>, collection of pp. ➞ <I>sentenc</I>.", "0"],
["provi", "prov-i", "(<I>-n</I>) [UV], (put to the) Test (in order to see whether), try (in this sense). <B>1</B> check experimentally: <I>~i medikamenton, rimedon, vinon</I>. <B>2</B> t., assay, make trial of. <I>Fajro ~as oron, mizero la homon. Dio ~is Abrahamon</I> (Ge 22/1). <I>La afero ~os vian forton, kuraĝon</I>. <B>3</B> attempt, have a shot at, try (to). <I>~i naĝi. ~i la neeblon. ~u denove</I>, try again. <B>~o</B>, test, attempt, trial. <I>Elmeti al ~o. Elteni ~on. Ne fidu sen ~o</I>. (mus, th), rehearsal, try-over. <B>~a</B>, experimental, tentative, trial. <B>~ado</B>, endeavour, probata, test. <B>~aĵo</B>, assay, sample specimen, trial, (type) <I>Pres~aĵo</I>, proof. <B>~ato</B>, probationer. <B>~eti</B>, feel one’s way. <B>~ilo</B>, t., criterion, touch-stone. <B>~inda</B>, worth tryg. <B>~isto</B>, assayist. <I>~iteco</I> (Ro 5/4). <B>Ek~i</B>, try one’s hand at. <B>El~ita</B>, tried out, well tested. <B>Kontraŭ~o</B>, counter-verification. <B>Ne~ita</B>, untried. <B>Sur~i</B>, try on (<I>ĉapelon, veston</I>). ➞ <I>pen</I>.", "0"],
["provianto", "proviant-o", "(<I>provizumo</I>), provisions, victuals (especially of army) (1 FA 145/23), <B>~i</B>, take in supplies (lay in stock) for, victual. <I>~i armeon</I>. <B>~isto</B>. <B>~ŝipo</B>, supply ship.", "0"],
["providenco", "providenc-o", "[OA] Providen/ce, wisdom and care of God. <I>En la manoj de ~o</I>. <B>~a</B>, -tial.", "0"],
["provinco", "provinc-o", "[UV] Provinc/e, administrative division of country, county (<I>konteo</I>), shire. <I>En la ~oj</I>, out of town. <B>~a</B> (opp <I>urba</I>), -ial, bucolic, countr/-ified, -y, local, rural. <I>~a gazeto, modo, urbo</I>. <B>~ano</B>, -ial, countryman. <B>~anaĵo</B>, <B>~anismo</B>, -ialism. ➞ <I>departement, distrikt, guberni, kampar, kanton</I>.", "0"],
["provizi", "proviz-i", "(<I>ion por iu, iun per io</I>) [UV]<I>,</I> Provi/de. <B>1</B> deliver, equip (furnish, stock, supply) with, get, obtain, procure, secure (what is needed): <I>~i Hon necesan. ~i edukon al infano; fenestron per vitroj</I>. <B>2</B> make due preparation (for comfort, maintenance): <I>~i por la familio; kontraŭ atako, bezono, la vintro</I>. <B>~(aĵ)o</B>, provision(s), stock, store, supplies, victuals. <I>Fari ~on,</I> lay in a supply. <I>~oj por la vojo</I> (Ge 45/21). <B>~ejo</B>, larder, stock-room, storehouse. <B>~isto</B>, caterer, provider, purveyor, <B>~umo</B>, (<I>provianto</I>). <B>Sen~a</B>, depleted, un-ded. <B>Vort~o</B>, vocabulary.", "0"],
["provizora", "provizor-a", "[OA] provisional, for the moment (time being), interim, makeshift, temporary, tentative, subject to revision. <I>~a aranĝo, (komitato, lumigo, ponto</I>. <B>~e</B>, pro tem. ➞ <I>kalkatemp</I>.", "0"],
["provoki", "provok-i", "(<I>-n</I>) [OA], Provo/ke, bring on, call forth, cause, egg on, give rise to, incite, inflame, instigate, kindle, rouse, stir up. <I>~i fermenton, indignon, koleron, militon, ribelon. ~i sanktulon</I> (Ps 78/41), <I>malpacon</I> (Se 26/21). <B>~o</B>, -cation. <B>~a</B>, -cative, <I>Agento ~a</I>, agent, -cateur. ➞ <I>defi, spit</I>.", "0"],
["prozelito", "prozelit-o", "[OA] Proselyt/e, convert (from another party). <B>~i</B>, -ize, <B>~ismo</B>. ➞ <I>konvert, varb</I>.", "0"],
["prozo", "proz-o", "[OA] Prose, ordinary non-metrical language. <B>~a</B> <I>poemo</I>, prose poem. <B>~(ad)a</B>, -aic, -y, drab. <I>Nia ~a tempo</I> (K 167/28). <I>Kia ~a vorto!</I> (M 67/29). <B>~(aĉ)adi</B>, p. along, talk tediously. <B>~aĵo</B>, piece of p. <B>~(verk)isto</B>, p-writer. ➞ <I>banal, plat</I>.", "0"],
["prozodio", "prozodi-o", "[OA] prosody, versification. ➞ <I>metrik</I>.", "0"],
["pruda", "prud-a", "Prud/ish, prim, of extreme (especially affected) propriety, straight-laced. <B>~ul(in)o</B>, prude. <B>~eco</B>, <B>~emo</B>, -ery, -ishess. <B>Mal~a</B>, lewd, ribald, shameless, spicy.", "0"],
["prudenta", "prudent-a", "[UV] Pruden/t, Sens/ible, discreet, far-seeing, judicious, sagacious, sane, wordly wise. <I>~a elspezo, konduto, konsilo, ŝparo. Estus</I> <B>~e</B>, it word be advisable (well) <I>konsenti</I>. <B>~o</B>, discretion, judgment, p-ce, (good) s-e. <I>Perdi la ~ojn</I>, lose one’s reason (s-es,wits). <I>Sana ~o,</I> sound common s-e. <I>Venis al li ~o post la ĝusta momento</I>. <B>~igi</B>, put some s-e into. <B>~ulo</B>, s-ible person, man of understanding. <B>Mal~a</B>, im-p., absurd, foolish, irrational, preposterous, short-sighted, stupid, unreasonable, void of reason. <B>Sen~a</B>, s-eless, void of reason. ➞ <I>antaŭzorg, diskret, konsilind, sagac, singard</I>.", "0"],
["prujno", "prujn-o", "[UV] (hoar) (white) frost, rime (Ij 38/29). <I>Li ŝutas ~on kiel cindron</I> (Ps 147/16). <I>Blanketa ~o de grizhareco</I> (M 186/31). <B>~a</B>, -ed, covered with f., hoary.", "0"],
["prunelo", "prunel-o", "[UV] blackthorn, sloe, fruit of <B>~arbusto</B> (<I>Prunus spinosa</I>) (2 Rĝ 14/9). ➞ <I>brunel</I>.", "0"],
["pruno", "prun-o", "[UV] Plum, fruit of -arbo (<I>Prunus</I>). <B>~o ĉerizflora</B>, cherry plum. <B>Damaska ~o</B> (<I>idamaso</I>), damson. <B>Sek~o</B>, prune. <B>Sovaĝa</B> <B>~o</B>, bullace, wild p. (P. <I>domestica</I>). ➞ <I>abrikot, ĉeriz, damas, nektarin, prunel, renklod</I>.", "0"],
["prunti", "prunt-i", "(<I>-n; al, de</I>) [UV]. <B>1</B> <I>~i al (al~i, ~edoni</I>), Lend (out), give on loan: <I>~i al iu ĉambr-(libr-mon-)on</I>. <B>2</B> <I>~i de (de~i, ~epreni</I>), Borrow, get on loan. <B>~e</B>, on credit (loan). <I>Ne prenu ~e kaj ne ~e donu</I>, neither a b-er nor a 1-er be. <B>~(aĵ)o</B> (<I>al~o, de~o</I>), loan. <I>~o amikon forpelas. Mon~aĵo</I>. <B>~ejo</B>, loan office. <B>(Mon)~isto</B>, moneyl-er. ➞ <I>lombard</I>.", "0"],
["pruo", "pru-o", "(mar) prow, bows, forepart. Opp <B>poŭp</B>.", "0"],
["pruvi", "pruv-i", "(-n; <I>ke</I>) [UV], Prove (Demonstrat/e) by argument or evidence, establish as true. <I>~i fakton, -(kulp-teori-)on. Nigro sur blanko ~as sen manko</I>. <B>~o</B>, d-ion, proof. <I>Suspekto ~on ne egalas. ~o cirkonstanca, rekta</I>. <B>~aĵo</B>, evidence, exhibit, token. <B>~ebla</B>, d-able. <B>~iĝi</B>, be p-ed, become clear (evident). <B>Mal~i</B>, cast doubt on, dis-p, make uncertain, show fallacy of. <B>Sen~a</B>, without proof. ➞ <I>konstat, montr, prov</I>.", "0"],
["psalmo", "psalm-o", "[OA] Psalm. ~i (<I>kanti ~ojn</I>). ~(kant)ado, -ody. <B>~aro</B>, psalter, (Bb) The Psalms. <B>~isto</B>, -ist, David,", "0"],
["psaltero", "psalter-o", "psaltery, Hebrew stringed instrument (Ps 150/3, Da 3/5).", "0"],
["pseŭdo", "pseŭdo-", "pseudo-, false(ly), professed(ly), seeming(ly), but not real(ly), not authentic, sham. <I>~afikso, ~Esperantisto, ~gravedo, ~laboro</I> (M 155/2) <I>-patriotism –scienco, sufikso</I>.", "0"],
["pseŭdonimo", "pseŭdonim-o", "[OA] = <I>kaŝnomo, plumnomo</I>, pseudonym, fictitious name, pen name e.g., Kabe = K. Bein. ➞ <I>cug</I>.", "0"],
["psiko", "psik-o", "Psych/e, spirit. <B>~a</B>, -ic(al). <I>~a fenomeno</I>. ~ozo, -osis. <I>PFX</I> ~iatr-o, -io, -istr-ist-y. -analiz-o. -olog-o [OA], -io [OA]. ~opatio. ~neŭrozo. -oterapio.", "0"],
["psilo", "psil-o", "jumping plant-louse.", "0"],
["psitako", "psitak-o", "(griza papago), grey parrot (<I>Psittacus</I>).", "0"],
["psoko", "psok-o", "book louse. ➞ <I>laŭs</I>.", "0"],
["ptarmiko", "ptarmik-o", "(ternherbo), sneezewort (Achillea ptarmica). ➞ akile.", "0"],
["pterido", "pterid-o", "bracken fern (<I>Pteridium</I>). ptero- (Gk <I>pteron</I>, wing). <B>~daktilo</B>, pterodactyl. <B>~klo</B>, sand grouse. (<I>Pterocles</I>). <B>~po</B>, fruit bat, flying fox (<I>Pteropus</I>).", "0"],
["ptomaino", "ptomain-o", "(chem) ptomaine.", "0"],
["publici", "public-i", "Publicize, write for the press (on current topics). <B>~isto</B>, -icity agent.", "0"],
["publiko", "publik-o", "[UV] the Public, people (opposite <I>privat</I>). <B>1</B> the community in gen: <I>enirejo por la ~o</I>. <B>2</B> (<I>ĉeestantaro</I>), audience, all present: <I>Paroli antaŭ granda ~o</I>. <B>~a</B>, [UV] (by, for, of, the) p., common. <I>~a banejo, (feri-serv-viv-)o. ~a kunveno</I>, open meeting. <I>~aj aferoj</I>. <B>~e</B>, in p., openly. <B>~igi</B>, publish. <B>1</B> announce formally, make known. <B>2</B> issue copies. <I>~igi verkon</I>. <B>~ulino</B>, harlot, prostitute, street walker. <B>Mal~e</B>, in camera, with closed doors. ➞ <I>ĝeneral, komun, naci, ŝtat</I>.", "0"],
["pubo", "pub-o", "(anat) Pub/es, -ic region. <B>~hara</B>, -escent. <B>~laŭso</B> (<I>ftiro</I>). <B>~osto</B>.", "0"],
["pudelo", "pudel-o", "[UV] poodle (dog). ➞ <I>spaniel</I>.", "0"],
["pudingo", "puding-o", "<I>[OA]</I>, (wide sense) Pudding. ~o Kristnaska, riza. ~o el pomoj (M 60/5).", "0"],
["pudli", "pudl-i", "(met) Puddl/e, stir (molten iron). <B>~ado</B>, -ing. <B>~isto</B>, -er. ➞ <I>flak</I>.", "0"],
["pudoro", "pudor-o", "(<I>sekshontemo</I>), modesty, sense of decency. <I>Atenci ies ~on</I>. <B>~e</B>, with delicacy. <B>~afekta</B>, prudish. <B>Sen~a</B>, shameless, unblushing.", "0"],
["pudro", "pudr-o", "[UV] (face-, toilet-) Powder. <I>Talk~o, riz~o</I>. <B>f</B> <I>neĝe ~ita kampo</I>. <B>~ilo</B>, p-puff. <B>~ujo</B>, p-box, compact. ➞ <I>polv, prujn, pulvor</I>).", "0"],
["puduo", "pudu-o", "(zoo) pudu deer (<I>Pudu puda</I>).", "0"],
["pufo", "puf-o", "[OA] Puff, pad, wad, etc. <B>~a</B>, -ed out, baggy, bulgy, bloated, full, inflated, swollen. <I>~a kamizolo, maniko</I> (Rn 22/1). <I>~aj pakaĵoj, virinaj vestoj</I> (M 106/9). <I>~ita robo</I> (Rn 36/18) <B>~aĵo</B> (<I>~pasto</I>), p-pastry. <B>~igi</B>, blow out(up), distend, inflate. <B>~iĝi</B>, p. out, swell. <B>~seĝo</B>, pouffe tuffet. ➞ <I>enblov, rembur, ŝvel</I>.", "0"],
["pugno", "pugn-o", "[UV] fist, clenched hand. <B>~i</B> (<I>~obati</I>), punch, pommel, thump. <I>~u lin rekte en la kolon</I> (Rz 54/25). <B>~ado</B>, fisticuffs. <B>~ema</B>, pugnacious. <B>~igi</B>, (clench) la manon. <B>~obatali</B> (<I>boksi</I>). ➞ <I>duelbird</I>.", "0"],
["pugo", "pug-o", "hindquarters, rump, (horse) crupper. <B>Ĉe~e</B>, pillion. <B>~mezuro</B>, measurement round the hips. <B>~vergi</B>, spank. <B>Bel~a</B> <I>virino</I>.", "0"],
["pulĉinelo", "pulĉinel-o", "[OA] Punchinello. <I>~a ludo,</I> Punch-and Judy (puppet) show.", "0"],
["pulikario", "pulikari-o", "(bot) fleabane (<I>Pulicaria</I>). ➞ <I>erigon</I>.", "0"],
["pulio", "puli-o", "(<I>rulbloko</I>), Pulley (drum turned by belt); grooved wheel for cord. <B>Cilindra</B> <B>~o</B>, flatface p. <B>Diferentiala</B> <B>~o</B>, differential p. <B>Fiksita</B> <B>~o</B>, fixed p. <B>Gvid~o</B>, guide p. <B>Konusa</B> <B>~o</B>, cone p. <B>Libera</B> <B>~o</B>, loose p. <B>Moviĝanta</B> <B>~o</B>, driving p. <B>Rektbraka</B> <B>~o</B>, straight-armed p. <B>Streĉa</B> <B>~o</B>, tension p. <B>~aro</B> (<I>takelo</I>), tackle.", "0"],
["pulmano", "pulman-o", "(ry) (<I>luksvagono</I>), pullman car.", "0"],
["pulmo", "pulm-o", "[UV] Lung. ~oj, lights. <B>~a</B>, pulmonary. <I>~a kongesto, malsano</I>. <B>~ito</B> (<I>~inflamo) (pneŭmonio). Krii (spirt</I>) <B>plen~e</B>, shout at the top of one’s voice, (draw a deep breath). <B>~ofiŝo</B>, 1-fish.", "0"],
["pulmonario", "pulmonari-o", "(bot) 1-wort (<I>Pulmonaria</I>).", "0"],
["pulo", "pul-o", "[UV] Flea (<I>Pulex</I>). (ordinary language) ~o akva, water-f; ~o folia, leaf-hopper; ~o <I>mara, sabla</I>, sandhopper. <B>~kolora</B>, puce, <B>~ludo</B>, tiddlywinks.", "0"],
["pulovro", "pulovr-o", "(cl) pullover.", "0"],
["pulpo", "pulp-o", "pulp, fleshy (soft) part, formless mass, (anat) pad of finger or toe. <I>Denta, frukta, papera ~o</I>. <B>~a</B>, -y. <B>~igi</B>, reduce to p.", "0"],
["pulsatilo", "pulsatil-o", "(bot) Pasque flower (<I>Anemone Pulsatilla</I>). ➞ <I>anemon</I>.", "0"],
["pulso", "puls-o", "[OA] Puls/e, beat, throb (of artery, heart). <I>Mia ~o en takto batas. Po kiom de ~(bat)oj minute?</I> (mus) pulse, beat. <I>Tri~a mezuro</I>, 3-p. measure, 3 beats in a bar. <I>Komencu ĉe la tria ~o</I>, on the third beat. <B>Ĉef~o</B>, strong p., down beat, <B>f</B> thrill, throb. pulsate, throb, <B>f</B> <I>vivo ~as en li; en la urbo</I>. <B>~ado</B>, pulsation, beating, throbbing. <B>Sen~a</B>, p-less. <B>~ometro</B>, -ometer.", "0"],
["pulvo", "pulv-o", "[UV] (gun) Powder. <B>~a</B> <I>farejo, tenejo,</I> p-mill (magazine). <B>~okorno</B>, p-flask (horn). ➞ <I>polv, pudr, pulvor</I>.", "0"],
["pulvoro", "pulvor-o", "[UV] Powder (pulvorized matter). <I>Bak~o, kaf~o, riz~o, sap~o, smirg~o</I>. Blankiga <B>~o</B>, whiting. <B>Dent~o</B>, tooth-p. <B>Fulgo~o</B>, flash-p. <B>Lav~o</B>, detergent. <B>~igi</B>, grind (reduce) to p., pulvorize. <B>f</B> <I>~igi argumenton</I> (crush, demolish). <B>~igi</B>, crumble to dust. <B>~igema</B>, friable. <B>~umi</B>, powder, dredge (dust, sprinkle) with powder.", "0"],
["pumiko", "pumik-o", "[UV] Pumice (stone). <B>~i</B>, (clean, rub, with) pumice.", "0"],
["pumo", "pum-o", "puma, cougar, (Am) mountain lion (<I>Felis concolor</I>).", "0"],
["pumpi", "pump-i", "(<I>-n</I>), [UV] (work a) Pump. <I>~i akvon</I>. <B>~ilo</B>, pump. <B>Aer~ilo</B>, air-p. <B>Benzin~ilo</B>, petrol-p. <B>Bicikla ~ilo</B>, cycle p. <B>Gras~ilo</B>, grease-gun. <B>Stomak~ilo</B>, stomach-p. <B>~isto</B>, pumper, (mot) p-assistant. <B>El~i</B>, <B>f</B> pump, draw information out of. <B>For~i</B>, p. away (out).", "0"],
["punca", "punc-a", "[UV] (corn-)poppy red, flaming red (M 4/2, 14/21, 46/10, 174/13). ➞ <I>karmezin, skarlat</I>.", "0"],
["punĉo", "punĉ-o", "[UV] (bev) Punch. <I>Brand~o, lakt~o, rumpunĉo</I>. <B>~ujo</B>, punch-bowl.", "0"],
["pundo", "pund-o", "Pound (£). ➞ <I>funt</I>.", "0"],
["puni", "pun-i", "(<I>pro</I>) [UV], Punish (<I>iun</I>): castigate, chasten, chastise, correct. <I>~i krimulon. Kiun Dio amas, tiun li ~as. (ion</I>): avenge (offence). <B>~o</B>, penalty. <I>Pagi, porti, ricevi ~on (pro</I>). <B>Mon~o</B>, fine. <B>Mort~o</B>, capital punishment, death penalty. <B>~a</B>, penal, punitive. <B>~ebla</B>, <B>~inda</B>, -able. <I>Mort~inda</I>, worthy of death. <B>~skribo</B>, (school) imposition. <B>~libro</B>, defaulter’s book. <B>Sen~e</B>, scot-free. ➞ <I>bagn</I>.", "0"],
["punkto", "punkt-o", "[UV] Point. <B>1</B> dot, spot, tick, <B>f</B> <I>~o</I> (a mere speck) <I>sur la horizonto. ~oj kaj streketoj</I> (morse). <I>Vokala ~o</I> (Hebrew), (typ) full-stop. <B>du~o</B>, [UV] colon. <B>2</B> stop, halt: <I>Meti ~on al la diskuto</I>. <B>f</B> <I>Punkto!</I> and that’s that. <B>3</B> (mat) p. without space. <B>4</B> precise place (p., spot): <I>Neŭtrala ~o,</I> neutral p. <I>~o de alveno, apogo. ~o de kruciĝo</I> (intersection). <I>~oj de la kompaso. ~o centra, danĝera, kontakta</I>. <B>Bol~o</B>. <B>Cel~o</B>, bull’s eye. <B>Dolor~o</B>, tender spot. <B>Fin~o</B>, extremity. <B>Frid~o</B>, freezing-p. <B>Nul~o</B>, zero-p. <B>Turn~o</B>, turning-p. <B>Vid~o</B>, p. of view, stand-p, way of looking at things. <B>f</B> <I>~o tikla, vunda</I>, sore point (etc.). <B>5</B> particular, matter under discussion: <I>~o en via letero; sur la tagordo. ~o de honoro. Eviti la ~on</I>, evade the question. <I>Tiri atenton al unu ~o. Prava</I> <B>ĉiu~e</B>, in all respects. <B>6</B> degree: <I>Bola, frosta, fandiĝa ~o</I>. <B>7</B> (mus) dot. (a) staccato sign, (b) adding half-length. <I>Noto (du)~ita</I>, (double) dotted note. <B>8</B> (typ) 3<I>~a plenlinio</I>, 3-p. face. <B>~(ad)i</B>, p., punctuate, stipple. <I>~i gravuraĵon. Herbejo ~ita de floroj</I>. (mus) <I>~i</I> (p.) <I>psalmon por ĉantado</I>. <B>~ado</B>, <I>interpunkcio</I>, -ing, punctuation. <B>~aĵo</B>, stippling. <B>~aro</B>, (typ) (…). ➞ <I>pint</I>.", "0"],
["punto", "punt-o", "[UV] Lace. <B>Boben~o</B>, bobbin lace. <B>Brusela ~o</B>, Brussels lace. <B>Kudrila ~o</B>, point lace. <B>Man~o</B>, handmade lace. <B>Trikot~o</B>, knitted lace. ~a <I>kolumo</I>, lace-collar. <B>~aĵo</B>, l-work. <B>~istino</B>, l-worker.", "0"],
["pupelo", "pupel-o", "[UV] pupil (of the eye). ➞ <I>lernant</I>.", "0"],
["pupitro", "pupitr-o", "[OA] (somewhat slanting) desk, stand. <I>~o lega, muzika, skriba</I>. (rel) <B>Ĥor~o</B>, choir-stall. <B>Leg~o</B>, lectern.", "0"],
["pupo", "pup-o", "[UV] doll. <I>~o artika, ĉifona, remburita, vaksa</I>. <B>Gant~o</B>, glove puppet. <B>Prov~o</B>, dressmaker’s dummy, <B>f</B> <I>Li estas nur ~o</I>. <B>~a</B> <B>teatro</B>, puppet-theatre. ➞ <I>marionet</I>.", "0"],
["pupo", "pup-o", "(ent) pupa. ➞ <I>krizalido</I> (= <I>pupo papilia</I>).", "0"],
["pura", "pur-a", "[UV] Pur/e, Clean. <B>1</B> unadulterated, unmixed, without addition or foreign matter: absolute (<I>muziko</I>); clear, colourless (<I>ĉielo</I>); nett (<I>profito</I>), sheer (<I>malico). ~a matematiko</I> (opposite applied). <B>2</B> without defect (taint): <I>~a ĝojo, koro</I>. Unalloyed, unsullied, untarnished, <I>~a vero</I>. <B>3</B> without dirt. <I>~a aero, mano, taso, tuko. Akvo kura, akvo</I> <B>~a. ~e</B>, purely. <I>Demando ~e teoria</I>. <B>~eco</B>, <B>~emo</B>, purity, cleanliness. <I>Seksa ~eco</I>, chastity. <B>~igi</B>, [UV] clean, cleanse, purify. <I>~igi la nazon</I>, blow the nose, <B>~ismo</B>, <B>~isto</B>, p-ism, p-ist. <B>El~igi</B>, expurgate, purge, refine. <B>Mal~a</B>, impure, unclean, foul, dirty, squalid, sordid. <I>Tolaĵon ~~an lavu en la domo. ŝuoj ~~aj de koto. Atmosfera ~~o. ~~aĵo</I>, dirt, filth, grime. <I>~~ega</I>, filthy, foul, obscene. <I>~~igi</I>, begrime, besmirch, defile, foul, pollute, soil. <B><I>~~</I>ulino</B>, slattern, sloven, slut. <B>Bat~igi</B> (<I>tapiŝon</I>). <B>Frot~igi</B>, scrub. <B>Sek~igado</B>, dry cleaning. <B>Strat~igisto</B>, dustman, scavenger. ➞ <I>ĉast, sendifekt, senmakul senpek, virg, fek, kot</I>.", "0"],
["purgatorio", "purgatori-o", "[OA] (rc) purgatory.", "0"],
["puritano", "puritan-o", "[OA] Puritan. <B>1</B> (rel, hist). <B>2</B> person of extreme strictness in morals. <B>~a</B>, -ic(al). <B>~ismo</B>.", "0"],
["purpura", "purpur-a", "[UV] Purple. <B>1</B> (colour) <I>~a robo de kardinalo</I>. <B>2</B> (p. material) (Se 31/22). ➞ <I>apatur</I>.", "0"],
["puso", "pus-o", "[UV] pus, matter. <B>~i</B>, discharge, fester, run, suppurate (Ps 38/5). <B>~(oplen)a</B>, <B>~(simil)a</B>, purulent, <B>~ado</B>, suppuration.", "0"],
["pustulo", "pustul-o", "[OA] (<I>pusa akno</I>), Pustul/e, pimple, <B>~a</B>, -ous. ➞ <I>akn, vezik</I>.", "0"],
["puŝi", "puŝ-i", "(<I>-n</I>), [UV] Push, Thrust, shove. <I>Ne ~u! ~i la pordon. Sin ~i antaŭen</I>, elbow (make) one’s way to the front. <I>Li ~is min eksteren</I>. <B>f</B> actuate, drive, egg on, impel, urge. <I>~ata de entuziasmo, ĵaluzo, scivolo. ~i</I> (ginger up) <I>la vendadon</I>. <B>~o</B>, push, thrust, pressure. <I>Per unu ~o de ponardo. Furioza ~o de pasio</I>. (vn) up-bow. <I>Vent~o</I>, wind pressure, <B>~a</B>, propulsive. <B>~ado</B>, propulsion. <B>~ego</B>, butt, ram. <B>~eti</B> (<I>genue, kubute</I>), nudge. <B>~iĝado</B>, melee, press, scrimmage. <B>(Inter)~iĝi</B>, p. o-a, barge into, bump against, crowd, hustle, jostle, scuffle. <B>Antaŭen~i</B>, promote. <B>De~i</B>, push away, t. aside, repulse (Am 9/2). <B>Dis~i</B>, put to flight, rout. <B>Ek~i</B>, jerk, jolt, jog. <B>For~i</B>, cast off, spurn. <I>~~i admonon, almozulon</I>. <B>En~i</B>, p. (ram, t.,) in. <I>Najla ~~ilo</I>, nail punch. <B>Kun~iĝi</B> (<I>kolizii) kun</I>, collide with. <B>Re~i</B>, p. back, rebuff, repel. repulse, snub. <I>~~i atakon, malamikon</I>. <B>Tra~i</B> <I>sian vojon</I> (p. through). <B>Fal~iĝi</B> (<I>stumbli</I>) (Ps 121/3). ➞ <I>instig, pel, prem, ram, ŝov</I>. <B>Rim</B>.: Puŝi = force by pressure: Ŝovi = make glide on plane surface.", "0"],
["puto", "put-o", "[UV] Well. <I>Ne kraĉu en ~on, ĉar vi trinki bezonos</I>. <B>~o arteza</B>, artesian well. <B>Alfundiĝa ~o</B>, man-hole. <B>Ŝlim~o</B>, draining-well. <B>~isto</B>, well-sinker. ➞ <I>bone, nu</I>.", "0"],
["putoro", "putor-o", "[OA] pole-cat (<I>Mustela putorius</I>). from which <I>furo</I>, domestic ferret. ➞ <I>mustel</I>.", "0"],
["putri", "putr-i", "[UV] (nt) (<I>malkomponiĝi</I>), Putr/ify, decay, decompose, go bad, rot. <B>f</B> <I>~i en malliberejo</I>. <B>f</B> be morally corrupt. <I>Io ~as en la ŝtato</I>. <B>~(ant)a</B>, putrescent, putrid, addled, corrupt, dank, decaying, high, rotten, rotting. <B>~(ad)o</B>, putrefaction, corruption. <I>~o seka</I>, dry rot. <B>~aĵo</B>, carrion, decayed matter, filth, <B>~eco</B>, rottenness. <B>~ema</B>, perishable. <B>~igi</B>, addle, corrupt, cause to rot. <B>~iga</B>, septic. <B>~iĝi</B>, go bad (off). <B>~iva</B>, putrescible. <B>For~i</B>, die out, rot away. <I>Ilia nomo ~os (ekstermiĝos</I>). <B>Kontraŭ~a</B>. ➞ <I>degener, dekadenc, korupt, mucid, ŝim</I>.", "0"],
["puzlo", "puzl-o", "puzzle, (any) game of patience.", "0"],
["rabarbo", "rabarb-o", "[OA] rhubard (<I>Rheum</I>).", "0"],
["rabato", "rabat-o", "[UV] (com) Rebate, allowances, deduction, reduction, discount, <I>Konsenti, ricevi ~on</I>. 10% <I>da ~o</I>, 10% discount, <B>f</B> <I>kun deca ~o</I>, with a grain of salt. <B>~i</B> (<I>-n</I>), allow a rebate, deduct, make a reduction, take off. <I>Mi povas ~i nur unu ŝilingon. Aĉeti, vendi</I> <B>~e</B>, at reduced prices. <B>Sen~e</B>, net. ➞ <I>diskont</I>.", "0"],
["rabdo", "rabd-o", "(<I>divena vergo</I>), divining (dowsing) rod. <B>~ado. ~isto</B>.", "0"],
["rabeno", "raben-o", "[UV] Rabbi. <B>~a</B>, -nical. <B>Ĉef~o</B>, grand rabbi.", "0"],
["rabeti", "rabet-i", "<B>~o</B>, (carp) Rabbet. <B>~a</B> <I>junto</I>, r ing joint.", "0"],
["rabi", "rab-i", "(<I>-n, al, de</I>), [UV] Rob, deprive of (steal) by violence, take by force. <I>La morto ~is al (de) li infanon</I>. <B>f</B> <I>Vi ~is de mi ĉian esperon</I>. <B>~(ad)o</B>, -bery, depredation, pillage, plunder, rapine. <B>~a</B>, predatory, of prey. <I>~a besto, birdo</I>. <B>~aĵo</B>, booty, loot, plunder, spoil. <B>~ema</B>, rapacious, ravening, <B>~isto</B>, brigand, robber, freebooter, marauder. <I>Malriĉulo ~iston ne timas. Dom~isto, nokt~isto. Voj~isto</I>, highwayman. <B>~irado</B>, foray, raid. <B>Dis~i</B>, loot, sack. <I>La soldatoj ~~is die</I>. <B>For~i</B> (<I>de</I>), abduct, carry off, kidnap. <B>Pri~i</B> (Ps 44/10, Na 2/10), (<I>iun, ion</I>), cheat, defraud, prey on, swindle; despoil, pillage, plunder, ransack, rifle. <I>Li ~~is min. ~~i preĝejon, landon, vojaĝanton</I>.", "0"],
["rabio", "rabi-o", "[OA] rabies, canine madness, <B>f</B> frenzy, fury, passion. <B>~a</B>, rabid, demented, mad, raging. <I>Por hundon dronigi, oni nomas ĝin ~a. Kuri</I> ~e, run like mad. <I>Ami ~e,</I> love to distraction. <B>~ulo</B>, person in a rage. ➞ <I>frenez</I>.", "0"],
["raboti", "rabot-i", "(<I>-n</I>), [UV] Plane, <B>~aĵo</B>, (wood or metal) shavings. <B>~ilo</B>, p. (Jes 44/13). <B>~ilo dufera</B>, double p. <B>~ilo folda</B>, groove p. <B>~ilo glatiga</B>, smoothing p. <B>~ilo kaŭĉuka</B>, sqeegee. <B>~ilo profila</B>, moulding p. <B>~o rabeta</B>, rabbeting p. <B>~ilo stabla</B>, jack p. <B>~fero</B>, p-iron. <B>~feringo</B>, p-stock. <B>~maŝino</B>, <B> ing machine.</B>", "0"],
["racemo", "racem-o", "(bot) raceme.", "0"],
["racio", "raci-o", "[OA] Reason, judgment, logical (intellectual) faculty, sense. <B>~a</B>, rational. <B>1</B> endowed with r. <I>La homo estas ~a animalo</I>. <B>2</B> -able, in conformity with (based on) reason, sensible, sound. <I>~a decido, klarigo</I>. <B>~eco</B>, reasonableness, rationality. <B>~igi</B>, rationalize.", "0"],
["racionala", "racional-a", "(mat) Rational. <I>Nombro ~a (ne~a</I>). (phi)", "0"],
["racionalismo", "", "[OA] (<I>raciismo</I>), <B>-isto</B>, [OA] -ism, -ist.", "0"],
["radaro", "radar-o", "[UV] (<I>radio-birado, radio-detekto, radio-eĥado</I>), (ph) radar. <B>~i</B>, guide by radar.", "0"],
["radiano", "radian-o", "(geom) radian.", "0"],
["radikala", "radikal-a", "[OA] Radical. <B>1</B> (pol) <I>~a partio</I>. <B>2</B> (<I>funda, plena</I>): basic, complete, fundamental, thorough-going. <I>~a reform, ŝanĝo</I> (H 56/29). <B>3</B> (mat) <I>~a signo,</I> r-sign (V). <B>~e</B>, completely, fundamentally. <B>~o</B>, (chem) r. <B>~ismo</B>, (phi) -ism. <B>~ulo</B>, r.", "0"],
["radiko", "radik-o", "[UV] Root. <B>1</B> of plant. <B>2</B> of object. <I>~o de dento, haro, ungo. Man~o, (pojno</I>), wrist. <B>3</B> (gram) of word: stem. <B>4</B> (mus) of chord. <B>5</B> (mat) of number. <I>Kuba, kvadrata</I> ~o. <B>6</B> base, essential foundation. <I>Detrui la ~ojn de milito</I>. <B>~a</B>, (of the) r., base. <I>~a vorto</I>. <B>~i</B>, have rr. in, stand -ed. <B>~eto</B>, -let, radicle. <B>Ek~i</B>, <B>en~iĝi</B>, take r. <B>El~(ig)i</B> (<I>detrui, ekstermi</I>), r. out (up), eradicate, extirpate. <I>El~i malbonon</I>. ➞ <I>likvid</I>. <B>En~(ig)i</B>, implant, inculcate. <I>~~i principon</I>. <B>~(ig)ita</B>, <B>~iĝinta</B>, -ed, confirmed, inveterate. <B>Sen~a</B>, without roots. ➞ <I>nefirm, nefortik, nevivipov</I>.", "0"],
["radio", "radi-o", "[UV] Radi/ation, <B>1</B> ray: <I>~o de lumo, varmo. ~o elektra, subruĝa, transviola. Lun~o, sun~o</I>, moon-beam, sun-beam. <I>~oj aktinaj, kosmaj. Alfa~oj, beta~oj, gama~oj, iks~oj</I>. <B>2</B> something radiating (branching) out, diverging from a point, e.g., <I>Drat~o, Rad~o</I>, spoke. <I>Rad~a formilo</I>, spoke- shave. <B>3</B> Radio, wireless: <I>~a stacio</I>. <B>~(ant)a</B>, <B>~luma</B>, radiant, beaming. <B>~(ad)i</B>, -ate, beam, send out rays, shine. <I>La suno ~as forte</I>, <B>f</B> be -ant, beam. <I>Ŝia vizaĝo ~is feliĉon (de feliĉo</I>). <B>f</B> <I>El tiu placo ~as ok stratoj</I>. <B>~ado</B>, <B>~aĵo</B>, <B>~aro</B>, radiation. <I>~ado atmosfera</I>. <B>~ilo</B>, radiator. <B>~isto</B>, radio operator. <B>~uloj</B>, (zoo) -ata. <B>Dis~i</B>, radiate, spread (send out) light. <B>Pri~i</B>, illuminate, light up. ➞ <I>radius</I>. PFX: <B>RADIO-</B>, radio-. -aktiva, ~amatoro, ~aparato, ~fonio, ~fotografio, ~telegrafio, ~gramo, ~logio, ~metro, ~skopio, ~terapio.", "0"],
["radiumo", "radium-o", "(chem) radium (Ra). <I>~a terapio</I>.", "0"],
["radiuso", "radius-o", "(<I>duondiametro</I>), radius. <B>1</B> (of circle), <B>f</B> (of activity). <I>Nenie en trimejla ~o</I>, nowhere within three miles, (av) <B>Flug~o</B>, flight radius. <B>2</B> radius bone in forearm.", "0"],
["rado", "rad-o", "[UV] Wheel. <I>~o de horloĝo, muelilo, veturilo</I>. <B>Antaŭ~o</B>, front w. <B>Ĉen~o</B>, chain w. <B>Klik~o</B>, rachet w. <B>Libera</B> <B>~o</B>, free-w. <B>Post~o</B>, back w. <B>Reg~o</B>, fly-wheel. <B>Ŝild~o</B>, shield-w. <B>Transmisia</B> <B>~o</B>, transmission w. <B>Vic~o</B>, spare w. <B>Dent~o</B>, cog-w., ratchet. <B>~~eto</B>, pinion. <B>Fajro~o</B>, (pyr) Catherine w. <B>Padel~o</B>, paddle w. <B>Ŝmirg~o</B>, emery w. <B>Stir~o</B>, steering w. <B>Tret~o</B>, tread-mill. <B>Du~a</B>, two-ed. <B>f</B> <I>La ~o de la sorto</I>, w. of fate. <I>Ĵeti bastonon en la ~on (= malhelpi</I>). <B>~oj</B>, <B>~aro</B>, wheels, clock-work, mechanism, works. <B>~centro</B> (<I>nabo</I>), hub. <B>~mortigi</B> (<B>~umi</B>), break on the w. <B>~radio</B>, spoke. <B>~rando</B>, rim. <B>~ringo</B> (<I>bendo</I>), tyre. <B>Strek~o</B>, milled (serrated) wheel.", "0"],
["radono", "radon-o", "(chem) radon (Rn).", "0"],
["rafano", "rafan-o", "[UV] (black Spanish) Radish (<I>Raphanus sativus var. major</I>). <B>~eto</B>, garden r. (pink or white) (1 FA 48/36). <B>~o sovaĝa</B> (<I>rafanistro</I>), wild r. ➞ <I>kren</I>.", "0"],
["rafini", "rafin-i", "(<I>-n</I>), [UV] Refin/e, clarify, free from dross or defects, (chem) purify. <I>~i metalon, oleon, petrolon</I>. <B>f</B> polish, improve. <I>~i poemon</I>. <B>~ado</B>, -ing. <B>~ejo</B>, refinery. <I>Suker~ejo</I>. <B>~ita</B>, -ed; chaste, delicate, polished, subtle. <I>~ita gusto, penso, stilo. ~itaj manieroj</I>, exquisite manners. ➞ <I>polur</I>. Opp <I>krud</I>.", "0"],
["rafio", "rafi-o", "Raffia, bast, fibre from r. palm (<I>Raphia</I>).", "0"],
["raguo", "ragu-o", "(cul) ragout, spiced meat stew.", "0"],
["raĝo", "raĝ-o", "rajah, Indian king or prince. <B>~ino</B>, ranee.", "0"],
["rajdi", "rajd-i", "(<I>-n, sur</I>) [UV], Rid/e (animal, cycle, etc.), go on horseback, etc. <I>~i sur ĉevalo, leono. ~i biciklon, ĉevalon, Sorĉistino ~as sur balailo</I>. <B>~a</B>, equestrian. <B>~o</B>, r. <B>~e</B>, on horseback, etc. <I>Malfeliĉo venas ~e (rapide), foriras piede</I>. <B>~anto</B>, -er, equestrian. <I>Antaŭ~anto</I>, postillion. <I>~antaro</I>, cavalcade. <B>~ato</B>, mount, <B>~ebla</B> (<I>ĉevalo, distanco</I>), that can be -den. <B>~ejo</B>, -ing ground. <B>~igi</B> (<I>infanon surdorse, surgenue</I>). <B>~ilo</B>, hobby-horse. <B>~isto</B>, equerry, jockey. <B>~arto</B>, equitation, horse riding. <B>~vesto</B>, -ing habit. <B>~vojo</B>, ride, bridlepath. ➞ <I>ĉeval, ĵoke, vetur</I>.", "0"],
["rajo", "raj-o", "[OA] (ich) ray (<I>Raja) &gt;</I> skate (<I>R. batis</I>).", "0"],
["rajono", "rajon-o", "(<I>artefarita silko</I>), (tex) rayon.", "0"],
["rajpi", "rajp-i", "(nt) seize up, become stuck, bind, run hot (bearings, etc.) from lack of lubrication. <B>~ado</B> (jamming) <I>de bremso</I>.", "0"],
["rajto", "rajt-o", "[UV] Right (to something), just claim, prerogative, what one is entitled to. <I>Hereda ~o. Hom~oj. ~oj de virinoj. Defendi, perdi siajn ~ojn. Havi ~on protesti, de sindefendo. Nobelino laŭ propra ~o</I>, in her own right. <B>Kopi~o</B> (<I>aŭtora, eldoneja</I>), copy-r. <B>Traduk~o</B>. <B>Voj~o</B>, r. of way. <B>~(hav)a</B>, r-ful, just, legitimate. <B>(Laŭ~)e</B>, r-fully, by r(r). <I>~e plendi, posedi</I>. <B>~i</B>, (nt) (<I>havi ~on</I>), have the r. (be entitled) to. <I>Vi ~as (ricevi) kom- penson. Kion ~as leono, ne ~as azeno</I>. <B>~igi</B>, [UV] give r. to, authorize, empower, entitle, warrant. <I>Mi ~igas vin mianome</I>. <B>~igaĵo</B>, <B>~igilo</B>, <B>~iga</B> dokumento, authority, credentials, warrant. <I>~igito</I>, accredited agent, attorney, proxy. <B>Mal~o</B>, <B>Sen~eco</B>, tort. <B>Ne~a</B>, <B>Sen~a</B>, without r., unjustified, unwarranted, wrongful. <I>Plendi sen~e</I>. \"\"igi, invalidate. <B>Egal~eco</B>, <B>sam~eco</B>, equality (parity) of rr. <B>Egal~e</B>, on equal terms. <B>Ligno~o</B>, fuel r. by estovers. <B>Plen~a</B>, plenipotentiary. <B>Voj~o</B>, r. of way. ➞ <I>jur, pov, privilegi</I>.", "0"],
["rakedo", "raked-o", "(sp) Racquet (<I>tenisa</I>), battledore (<I>volana</I>), etc. <B>~ludo</B>, (gm) rr. <I>~a korto,</I> r-court. <B>~streĉilo</B>, r-press. ➞ <I>skvaŝ</I>.", "0"],
["raketo", "raket-o", "[OA] (pyr) Rocket. <B>Lum~o</B>, fiare-r. <B>Sav~o</B>, life-r. ➞ <I>fuze</I>.", "0"],
["rakito", "rakit-o", "rachitis, rickets. <B>~a</B>, rachitic.", "0"],
["rako", "rak-o", "Rack, framework for keeping articles in (or on). <I>~o bicikla, bomba, botela, ĉapela, drena, fojna, gazeta, muzika, pakaĵa, pipa, ila, ŝlosila, telera</I>. <B>Veturila</B> <B>~o</B>, rack (rail) of cart.", "0"],
["rakonti", "rakont-i", "(<I>-n) (pri, ke</I>) [UV], Narrat/e, describe, give an account of, recount, relate, tell about. <I>~i aventur-(histori-)on, siajn impresojn. Oni ~as, ke</I>, It is rumoured that. <I>~i parkere</I>, recite. <B>~u!</B> Fire away! Go ahead! <I>Jen kion oni ~as</I>, what people say, the tale afloat. <B>~o</B>, -ive, -ion, account, recital, tale. Mir<B>~o</B>, fairy tale. <B>Popol~o</B>, folk-tale, legend. <B>~a</B>, -ive. <B>~aĉo</B>, tedious long-winded tale. <B>~ema</B>, garrulous. <B>~isto</B>, -or, reconteur, storyteller. <B>~inda</B>, worth tellg. <B>Fi~o</B>, dirty tale, low smutty story. <B>Ne~ebla</B>, untellable, indescribable. ➞ <I>fabel, histori, priskrib, raport</I>.", "0"],
["raliko", "ralik-o", "(mar) bolt-rope, roping (of sail). <I>~a ringo</I>, cringle.", "0"],
["ralio", "rali-o", "(sport, etc.) rally.", "0"],
["ralo", "ral-o", "(orn) Rail (<I>Rallus</I>). <B>Akva</B> <B>~o</B>, water rail.", "0"],
["ramekso", "", "<B>Dock (Rumex</B>). <B>~o akva</B>, water d. <B>~o konglomerata</B>, clustered or sharp <B>d</B>. <B>~o krispa</B>, <B>curled d</B>. <B>~o larĝfolia</B>, broad-leaved d. <B>~etoj</B>, (<I>~j acidfoliaj</I>), sorrels (<I>R. acetosa, acetosella</I>). ➞ <I>oksalid</I>.", "0"],
["ramfasto", "ramfast-o", "(orn) toucan (<I>Ramphastos</I>).", "0"],
["rami", "ram-i", "(mech, mil) Ram. <B>~ilo</B>, -mer, plunger (of force-pump), tamper. <B>~ilego</B>, <B>~maŝino</B>, battering-r., pile-driver, drop-hammer. ➞ <I>puŝ</I>.", "0"],
["ramio", "rami-o", "China grass, ramie (<I>Boehmeria nivea</I>). ➞ <I>bemeri</I>.", "0"],
["ramno", "ramn-o", "buckthorn (<I>Rhamnus purshiana</I>). f. w. <I>kaskaro</I>. ➞ <I>frangol</I>.", "0"],
["rampi", "ramp-i", "[UV] (nt) <B>1</B> Creep, crawl: <I>Bebo, limako, raŭpo, serpento ~as. ~i sur manoj kaj genuoj; tra truo</I>. <B>f</B> (<I>~iri</I>), progress slowly, drag, shamble. <B>2</B> (plant), climb, spread out, trail: <I>Hedero ~as sur muro</I>. <B>~(aĉ)i</B>, cringe, toady, truckle (to); fawn (on); grovel (before). <I>~i antaŭ potenculo</I>. <B>~(ej)o</B>, incline, ramp, rise, slope. <B>~(em)a</B>, c-ing, crawling, servile. <B>~anta</B>, rampant. <B>~aĵo</B> [UV] (<I>~a planto</I>), creeper. <B>~ulo</B> (<I>reptilio</I>), reptile. <B>El~i</B>, (<B>En~i</B>), c. out (in). <B>Supren~i</B> (<I>grimpi</I>), c. up. <B>Sur~i</B>, c. over.", "0"],
["ranatro", "ranatr-o", "(ent) narrow water scorpion (<I>Ranatra</I>). ➞ <I>nepa</I>.", "0"],
["ranca", "ranc-a", "[UV] Rancid (of fats), bad, musty, rank, stale. <I>~a butero, oleo</I>.", "0"],
["rando", "rand-o", "[UV] Border, Edge (boundary, extremity, of surface). <I>~o de arbaro, kampo, paĝo, telero, tuko</I> bank, side (of river); brim (of hat); brink, verge (of abysm); eaves (of roof); limb (of moon); lip (of wound), rim (of wheel). <I>La ~oj de la tero</I>, the ends of the earth. <I>Ĉe (sur) la ~o</I>, at (on) the edge. <I>Boata ~o</I>, gunwale, gunnel. <B>~a</B>, marginal. <B>~hava</B>, -ed, rimmed. <I>Ruĝ~aj palpebroj</I>. <B>~aĵo</B>, border, e-ing, list, selvedge (<I>tuko</I>). <B>Ĝis~e</B>, alongside, e. to e. <B>Klin~o</B> (<I>bevelo</I>). <B>Larĝ~a</B>, broad-brimmed. <B>Tranĉ~o</B>, e. (<I>klinga</I>). <B>~dentoj</B>, perforation, serration, indentation. <B>~egaligi</B>, e. off, clip, trim, snuff (<I>mecon</I>). <B>~rompi</B>, eat into, indent 0<I>noĉi</I>). <B>~tranĉi</B>, cut out. ➞ <I>bord, eĝ, flanĝ, marĝen, orl</I>.", "0"],
["rango", "rang-o", "[UV] Rank (of degree, dignity, importance, quality), class, grade, place, standg, status. <I>~o administra, socia. ~o kolonela. Teni sian ~on</I>, keep up one’s position. <B>~i</B> <I>kiel (havi ~on de</I>). <B>~ulo</B>, dignitary (Ij 29/10). <I>Sam~ulo</I>, equal, fellow, peer. <B>Alt~a</B>, of high rank. <B>Dua~a</B>, of second-rate importance. <B>Laŭ~e</B>, by r. <B>Pli~iĝo</B> (<I>~altiĝo</I>), advancement, promotion. <B>Sen~a</B>, simple. <B>Unua~a</B>, first-class. ➞ <I>vic</I>. [Ne= range (<I>amplekso</I>)].", "0"],
["rankoro", "rankor-o", "rancour, inveterate bitterness, malignant hate, spitefulness. <B>~a</B>, -ous.", "0"],
["rano", "ran-o", "[UV] Frog (<I>Rana</I>). <B>Arb~o</B> (<I>hilo</I>), tree (green) f. <B>Bov~o</B>, bull (flying) f. <B>Manĝebla ~o</B>, edible f. <B>Venena ~o</B> (<I>dendrobato</I>), poison f. ➞ <I>kvak</I>.", "0"],
["ranunkolo", "ranunkol-o", "[UV] Ranuncul/us &gt; Buttercup, crowfoot, spear-wort. <B>~acoj</B>, -aceae, b. fam.. <B>Duobla ~o</B>, bachelor’s buttons. ➞ <I>fikari</I>.", "0"],
["rapida", "rapid-a", "[UV] Fast, Rapid; fleet, prompt, speedy, swift. <I>~a flugo, kuro, progreso, ŝanĝo, vento. ~a kiel fulmo, penso</I>. (mus) <I>laŭ la unua ~o</I>, tempo primo. <B>~e</B>, fast, apace, expeditiously, quickly. <I>Kreski</I> <B><I>~e</I></B>, <I>kiel fungo</I>. <B>~i</B>, be in a hurry (quick), haste. <I>~i hejmen; al la stacidomo; por fini. Ne ~u koleri. ~u mal~e!</I> <B>~(ec)o</B>, speed, velocity. <I>~o subsona, supersona. ~o de lumo</I>. <B>~aĵo</B> (<I>de rivero</I>), rapids, race. (<I>Vibro</I>) <B>~eco</B>, (el) freqcy. <B>~ega</B>, hurried, impetuous, lightning, precipitate. <I>Li for~egis</I>, sped away. <B>~ema</B>, hasty, hurried, precipitous. <I>~ema momento,</I> fleeting moment. <B>(pli)~igi</B> (<I>akceli</I>), accelerate, expedite, hasten, hurry up. <B>~umo</B>, speed gear. <I>~~ilo, (~ŝanĝilo</I>), gear lever. <I>Tri~umo</I>, three-s-g. <I>Ŝanĝi de la unua ~umo ĝis la tria</I>. <B>~aga</B>, expeditious. <I>~ira vagonaro (ekspreso</I>), fast train. <B>Mal~a</B>, slow, deliberate, tardy. <I>~~i</I>, dawdle, lag, linger, loiter, (clock) be slow. <I>~~igi,</I> retard. <B>Plen~e</B>, at full speed. <B>Poŝt~e</B>, post haste. <B>Tro~i</B> (clock) be fast. <B>Rim</B>.: Rap! rap! <I>rapidu! kriis la anasino</I> (2 FA/34, 30). ➞ <I>galop, hast, kur, urĝ</I>.", "0"],
["rapiro", "rapir-o", "[UV] rapier, foil, small-sword (fencing). ➞ <I>glav, skerm, spad</I>.", "0"],
["rapo", "rap-o", "[UV] turnip (<I>Brassica rapa</I>). <B>Kaŭlo~o</B>, kohlrabi. ➞ <I>brasik, nap</I>.", "0"],
["raporti", "raport-i", "(<I>-n, al, pri; ke</I>) [UV], <B>1</B> (make a) Report (on), describe, detail, give an accnt of, relate. <I>~i eventon, fakton, novaĵon. ~i pri decido, progreso</I>. <B>2</B> take down in shorthand, record. ~i <I>diskuton, parolon, kongreson</I>. <B>3</B> (<I>fi~i</I>), inform, peach, sneak, tell tales. <B>~o</B>, report, description, statement, record. <I>Ne ĉiu ~o estas vera vorto. ~o favora, fidela</I>. (sten) ~a (<I>parolrapida) stilo</I>. <B>~isto</B>, -er, recorder. <B>Mis~i</B>, mis-r., distort the facts. <B>Kalkul~o</B>, statement of accounts. ➞ <I>komunik, protokol, rakont, sciig</I>.", "0"],
["rapsodio", "rapsodi-o", "(lit) rhapsod/y, <B>1</B> great epic poem. <B>2</B> ecstatic rambling effusion, (mus) similar composition. <B>~(iist)o</B>, -ist.", "0"],
["rapunkolo", "rapunkol-o", "(bot) rampion bell-flower, ramps (<I>Campanula rapuneulus</I>).", "0"],
["rara", "rar-a", "= <I>malofta</I>. <B>~aĵo</B>, rarity.", "0"],
["raso", "ras-o", "[OA] Rac/e. <B>1</B> (<I>idaro</I>), breed, descendants, family, stock: <I>La ~o Abrahama</I>. <B>2</B> folk (people) with special characteristics: <I>~o blanka, flava, nigra</I>. (bot) strain, variety. <I>Bona ~o de bovoj, rozoj</I>. <B>~a</B>, -ial. <B>~ismo</B>, -(ial)ism. <B>Bon~a</B>, <B>Pur~a</B>. <B>Miks~a</B>, mongrel, of mixed r. ➞ <I>gent, hered, sang, sem</I>.", "0"],
["raspi", "rasp-i", "(<I>-n</I>) [UV], Grate, Rasp, scrape. <I>~i fromaĝon, karoton</I>. <B>f</B> g. on one, irritate. <B>~ilo</B>, grater. <I>Muskat~ilo</I>, nutmeg grater. <B>~(ec)a</B>, grating, rasping, harsh, rough. <B>~a</B> <I>bruo, sono</I>. <B>f</B> (<I>malglata, raŭka), ~a voĉo</I>. ➞ <I>fajl, grat, muel, skrap</I>.", "0"],
["rasti", "rast-i", "[UV] Rak/e, collect (draw, scrape) together. <B>1</B> (<I>kun~i), ~i fojnon, pajlon, foliojn</I>. <B>2</B> (<I>sir~i, skrapi</I>), scratch. <I>~i la teron</I>. <B>~ilo</B>, r. <B>~aĵo</B>, -ings.", "0"],
["rastralo", "rastral-o", "five-nibbed pen for making music staves.", "0"],
["ratafio", "ratafi-o", "(cul) ratafia.", "0"],
["ratelo", "ratel-o", "(zoo) ratel, honey-badger (<I>Mellivora capensis</I>).", "0"],
["ratifi", "ratif-i", "(jur, pol) ratify, confirm, endorse, make valid by formal sanction. <I>~i decidon,</I> <B><I>interkonsenton, traktaton</I></B>.", "0"],
["ratio", "rati-o", "( = <I>rilatumo</I>), (mat) ratio, quantitative relation. ➞ <I>proporei</I>.", "0"],
["ratli", "ratl-i", "(nt), Rattle, <B>~ilo</B> (toy, mus), r. ➞ <I>krotal</I>.", "0"],
["rato", "rat-o", "[UV] Rat (<B>Rattus</B>). ~o bruna, nigra.", "0"],
["raŭfo", "raŭf-o", "(<I>fojn-rako, pakaĵa rako</I>), stable-rack luggage-rack.", "0"],
["raŭka", "raŭk-a", "[UV] Hoarse, husky, raucous, raw, rough. <I>~a krio, voĉo</I>. <B>~eco</B>, h-ness. <B>~igi</B>, make h. <B>~iĝi</B> <I>de troa kriado</I>. ➞ <I>malklar, obtuz, rasp, skrap</I>.", "0"],
["raŭpo", "raŭp-o", "[UV] <B>1</B> (<I>lepidoptera larvo</I>), Caterpillar. <B>Lana ~o</B>, woolly bear (➞ <I>arkti</I>). <B>Migra ~o</B>, processionary c. <B>Silk~o</B>, silkworm. <B>Sen~igi</B>, clear of cc. ➞ <I>larv, pup, verm</I>. <B>2</B> (mec) c-band. <B>~ero</B>, unit of this.", "0"],
["ravi", "rav-i", "(<I>-n</I>) [UV], (fill with) Delight, Ravish, captivate, enchant, enrapture, entrance, hold spellbound, overjoy, transport. <I>Nin ĉiam ~as, kion ni ne havas</I>. <B>~o</B>, d., ecstacy, rapture. <B>~a</B>, ravishing, d-ful, bewitching, captivating, charming, entrancing, lovely. <I>~a fraŭlino, muziko, pejzaĝo</I>. <B>~e</B> (d-fully) <I>danci, ludi</I>. <B>~iĝi</B> <I>de</I>, d. in. <B>~ita</B>, d-ed, overjoyed. <I>~ita de novaĵo, sperto</I>. ➞ <I>ĉarm, ekstaz, ensorĉ</I>. [Ne= rave (<I>furioz, frenez</I>)].", "0"],
["ravino", "ravin-o", "ravine, deep narrow gorge, mountain cleft. <B>~i</B>, gully, hollow out. <I>La torentoj ~is la teron</I>.", "0"],
["razeno", "razen-o", "(a. <I>gazono) (grestapiŝo</I>), Lawn, fine short grass, green, sward. <I>Tondi la ~on</I>. <B>~tondilo</B>, lawn-mower.", "0"],
["razi", "raz-i", "(<I>-n</I>), [UV] Shave. <B>1</B> <I>~i la kapon, vangon, verton; sin</I>. <B>2</B> (<I>for~i), ~i la barbon, lipharojn. Plene ~ita</I>, clean-en. <B>f</B> brush, graze, skim over. <I>La hirundo ~is la teron</I>. <B>f</B> La <I>ventego for~is la domojn</I>. <B>~iĝi</B>, (have a) shave. <B>~ilo</B>, razor (Ps 52/2). <I>~ilo sendanĝera</I>, safety razor. <B>~isto</B>, barber, hair-dresser. ➞ <I>barbir, falĉ, tond, tonsur</I>.", "0"],
["re", "re-", "[UV] (pfx) re-, <B>1</B> Again, anew, a second time, once more. ~kanti, sing again. <I>Gis la</I> ~vido. ~adresi, ~komenci, ~legi. <B>2</B> Back (return to point of departure or original state). ~doni, restore, return. ~junigi, -juvenate. ~salti, re-bound, re-coil. ~pagi, ~meti, ~sendi. <B>Rim</B>.: Both meanings den, repetition of the action: the context usually shows which. <B>1</B> <I>La suno</I> ~brilas (shines again) <I>post longa nokto</I>. <B>2</B> <I>La suno</I> ~brilas (shines back) <I>de la akvo</I>. For greater precision use <B>1</B> <I>denove, duan fojon</I>; <B>2</B> <I>returne, reen</I>. ➞ <I>retro</I>.", "0"],
["reakcio", "reakci-o", "[OA] (ch) (ph) Reaction, responsive or reciprocal action. <I>Ĉen~o. ~o de la spirito</I> (M 69/12). (pol) retrograde movement. <B>~i</B>, react upon. <I>~i reciproke,</I> interact. <B>~(em)a</B>, reactive. <B>~ulo</B>, -ary. ➞ <I>reag, reefik</I>.", "0"],
["reaktanco", "reaktanc-o", "(el) reactance.", "0"],
["reaktoro", "reaktor-o", "reactor.", "0"],
["reala", "real-a", "[OA] Real: actually existing, factual, material, objective, veritable. <I>~a estro, sento. ~a mondo</I>. real life. <B>~e</B>, in a -istic way. <B>~aĵo</B>, <B>~eco</B>, -ity, actuality, <B>~igi</B>, -ize, bring into being, carry out, convert into fact; \"bring home\". <I>~igi idealon</I>. <B>~iĝi</B>, be -ized, come true. <I>Mia revo nun ~iĝis</I>. <B>~ismo</B>, -ism. <I>~isma</I>, -istic. <B>~isto</B>, -ist. <B>Mal~a</B>, <B>Ne~a</B>, unreal, illusory. ➞ <I>iluzi, rev, sonĝ, utopi</I>. ➞ <I>aktual, efektiv, fakt, praktik, ver</I>.", "0"],
["realgaro", "realgar-o", "(chem) realgar, red arsenic, disulphide of arsenic.", "0"],
["realo", "real-o", "(num) real, Spanish coin.", "0"],
["rebuso", "rebus-o", "[OA] (<I>bildenigmo</I>), rebus, picture puzzle.", "0"],
["recenzi", "recenz-i", "[OA] (write a) Review (of), write a critical report on. <I>~i libr-(verk-)on. ~i akr-(malfavor-)e</I>, cut up., r. adversely. <B>~o</B>, r., critique, critical notice in a publication. <B>~ado</B>, -ing. ~into, <B>~isto</B>, -er. ➞ <I>kritik</I>.", "0"],
["recepi", "recep-i", "(hort) cut back (down).", "0"],
["recepto", "recept-o", "[OA] (cul, tech), Receipt, formula, recipe (written instruction for preparation of something). <I>~o kuir-(kuracist-)a</I>. <B>~i</B>, give a r. <B>~aro</B>, book of rr. ➞ <I>kvitanc, preskrib, ricevatest</I>.", "0"],
["reciproka", "reciprok-a", "[UV] Reciproc/al, Mutual, in return. <I>~a am-(konfid-profit-protekt-)o</I>. <B>~e</B>, r-(m-)ally, vice versa, one another. (<I>sin) ~e malami</I>, hate each other. <I>Vi devus vin helpi</I> <B><I>~e</I></B>, help one another. <I>~e premi la manojn</I>. <B>~i</B>, -ate, give and receive m-ally, exchange, interchange. <I>~i bondezir-(salut-)ojn</I>. <B>~eco</B>, r-ity. ➞ <I>komun</I>.", "0"],
["recitalo", "recital-o", "recital, public performance by one person.", "0"],
["recitativo", "recitativ-o", "[OA] (mus) recitative.", "0"],
["reciti", "recit-i", "Recit/e, repeat by heart, (mus) ~a <I>no to</I>, <B> ing</B> note. <B>~aĵo</B>, -ation, declamation.", "0"],
["redakcio", "redakci-o", "[UV] vague word = 1 <I>redaktistaro</I> (M 72/2), 2 <I>redaktejo</I> (M 66/1). <B>~ano</B>, member of the editorial staff.", "0"],
["redakti", "redakt-i", "(<I>-n</I>) [OA], Edit. <B>1</B> draw up, put into suitable form, revise and correct: <I>~i artikol-(raport-)on</I>. <B>2</B> conduct a magazine or other publication: <I>~i gazet -(turnal-)on</I>. ~ejo, -orial office or department. <B>~isto</B>, <B>~oro</B>, [UV] -or. <B>Ĉef~isto</B>, -or in chief. <B>~istaro</B>, -orial staff.", "0"],
["redempti", "redempt-i", "(<I>elaĉeti</I>), (thl) redeem, deliver from power of sin. <B>~o</B>, redemption. ~into, -er.", "0"],
["redingoto", "redingot-o", "<B>1</B> frock-coat. <B>2</B> Woman’s long double-breasted overcoat.", "0"],
["redukti", "redukt-i", "[OA] Reduc/e. <B>1</B> diminish (in number, power, size): abate (<I>pretendon</I>); abridge, cut (down) <I>elspezon, programon;</I> bring down (lower) <I>pezon, prezon, rapidon, temperaturon</I>, relieve (<I>premon</I>); restrict (<I>liberon</I>). <B>2</B> bring (convert) to another form: <I>~i ercon al metalo; iun al malespero; la faktojn al tri klasoj</I>. ~(ad)o, -tion, abatement, cut, decrease. <I>~o de hernio, postulo, tarifo. ~o al absurdo</I>. <B>~ebla</B>, -ible, convertible. ~ilo, (phot) -er, <B> ing</B> agent. ~iĝi <I>al</I>, boil down to. <I>La tuta afero ~iĝas al unu demando</I>. ➞ <I>limig</I>.", "0"],
["reduto", "redut-o", "(mil) redoubt.", "0"],
["referato", "referat-o", "scientific or technical dis- sertation, treatise.", "0"],
["referenco", "referenc-o", "[OA] Reference. <B>1</B> r. to authority (original, another text, etc.), drction to book, etc., where information may be found. <I>Verko de ~o</I>, work of r. ~a <I>Biblio, biblioteko</I>, r. Bible (library). <B>2</B> recommendation, testimonial, as to character, etc. ~ilo (<I>~a signo</I>), r-mark (* t J etc.). <B>~ulo</B>, r. ➞ <I>alud, rilat</I>.", "0"],
["referend(um)o", "referend(um)-o", "(jur, pol, soc) referendum.", "0"],
["refleksiva", "refleksiv-a", "(<I>resenda</I>), reflexive, (gram) referring to subject <I>~a pronomo</I>.", "0"],
["reflekso", "refleks-o", "(bi, ps) Reflex. <I>~a ag-(mov-)o</I>.", "0"],
["reflekti", "reflekt-i", "(<I>-n</I>), Reflect (rays), mirror, throw back. <I>~i koloron, lumon, sonon, radion, varmon</I>. <B>~(ad)o</B>, -ed image. <B>~o</B> (gleam, shimmer) <I>de la luno sur lago</I>. <B>f</B> <I>Literaturo estas ~o de moroj</I>. <B>~a</B> <I>angulo, ebeno, surfaco, angle (plane, surface) of -ion</I>. <B>~igi</B>, <I>be -ed. (of sound), reverberate. <B>~ilo</B>, reflector. <B>~oro</B>, reflecting mirror (of telescope, or car head-lamp</I>) (<I>kaplumo). ➞ rebril, reĵet, resend, spegul</I>.", "0"],
["refo", "ref-o", "[OA] reef (strip of sail). <B>~i</B>, (nt) r., reduce surface, take in (sail). ~ilo, r-point. Mal<B>~i</B>, loose sail, shake out a r. ➞ <I>fald</I>.", "0"],
["reformi", "reform-i", "Reform, amend, improve. <I>~i juron, kalendaron, regularon, la mondon. ~ita eklezio</I>, -ed church. <B>~o</B>, reformation, removal of abuses, etc. <I>~oj en Esperanto</I>. <B>~ejo</B>, -atory. <B>~iĝi</B>, r., mend one’s ways. <B>~emulo</B>, <B>~isto</B>, -er. ➞ <I>re-form</I>.", "0"],
["reform(aci)o", "", "[OA] (rel) the Reformation.", "0"],
["refrakti", "refrakt-i", "(<I>-n</I>), Refract, bend, deflect from a straight course. ~i radion. <B>~o</B>, -ion. ~o <I>akva, atmosfera</I>. <B>~a</B> angul-(indic-tele- skop-)o. ➞ difrakt.", "0"],
["refreno", "refren-o", "(<I>rekantaĵo</I>), (lit, mus), refrain, chorus, f <I>Jen lia ĉiama ~o\\</I> (constant theme, harping on the same string).", "0"],
["refuti", "refut-i", "(<I>-n</I>) [OA], Refut/e, confute, disprove, overthrow by argument, rebut. <I>~i aserton, eraron, opinion, tezon</I> (Ij 34/6). -ation. <B>~ebla</B>, -able, <I>Ne~ebla</I> (irrefutable) <I>fakto</I>.", "0"],
["regali", "regal-i", "(<I>-n</I>) [UV], Entertain, Treat, regale. <B>1</B> e., t. (well or ill), divert. <I>~i amikon per frukto (kanto). Oni bone nin ~is</I>, they treated us well, (col) we did ourselves well, had a good tuck-in. <I>Kia</I> ~ato, <I>tia</I> ~ado. (iron) <I>La polico ~is min per vergoj</I> (Rz 73/6). ~(ad)o, e-ment, t., feast. ~anto, host. <I>Mi ~os</I>, \"It’s on me\", I’m standing t. <B>~ema</B>, generous, open-handed. For<B>~i</B>, discharge, send abt one’s business, settle the account of. ~<B>~o</B>, leave of absence. regatt-o= <I>boata festo, ŝipkurado</I>.", "0"],
["regento", "regent-o", "[OA] Regen/t, provisional ruler. <B>~eco</B>, -cy.", "0"],
["regi", "reg-i", "(<I>-n</I>) [UV], Rul/e, Domin/ate, sway, have decisive influence over. <B>1</B> (pol) be ruler over, command, govern: <I>Mono mondon ~as</I>, <B>2</B> administer, conduct, control, direct, manage, regulate, run: <I>~i aferojn, entreprenon, sian hejmon, la industrion de la lando</I>. <B>3</B> keep in check (under control), master: <I>sin, ĉevalon, la situacion, sian emocion, langon</I>. <B>4</B> dominate, take possession of: <I>Ambicio, homamo, venĝemo ~is lian animon, koron, vivon</I>, <B>f</B> <I>~is gaja humoro (erara opinio, paco, silento</I>). <B>~(ad)o</B>, d-ion, rule, conduct of affairs, government. <I>~ado Brita, demokrata</I>. <B>~anto</B>, ruler. <B>~anta</B>, d-ant, prevailing. <B>~ato</B>, [UV] subject. <B>~ema</B>, d-eering. <B>~istaro</B>, government. <B>Inter~o</B>, interregnum. <B>Mis~i</B>, misrule. <B>Ne~ebla</B>, uncontrolable, ungovernable, unmanageable, irrestrainable. <B>Sin~o</B>, autonomy, self-control, self-mastery, self-restraint. <I>Nesin~ema (impulsiva</I>), impulsive. <B>Super~i</B>, <B>1</B> d-ate, prevail over. <B>2</B> be supreme, predominant, have the upper hand. <I>Tiu principo ~~as ĉiun alian. ~~a</I> (all-important) <I>fakto. ~~ema</I>, overbearing. ➞ <I>direkt, domin, guvern, kontrol, regulig, reg</I>.", "0"],
["regimento", "regiment-o", "[UV] Regiment. <B>~a</B>, -al. <B>~aĵoj</B>, -als. ~estro, colonel.", "0"],
["regiono", "region-o", "[UV] Region. <B>1</B> (of land), pt with special characteristics, area, district, locality, territory, tract. <I>~o apudmara, dezerta, monta, tropika. Maiza ~o</I>, maize belt. <B>2</B> (of body): area, part. <I>~o abdomena, lumba</I>. <B>f</B> field, sphere. <I>~o de filozofio, laboro, de revoj</I>. <B>~a</B>, -al, local, sectional. <I>~a dialekto, federacio, gazeto</I>. <B>~estro</B>, governor. ➞ <I>distrikt, kamp, lok, sfer</I>.", "0"],
["registri", "registr-i", "[UV] Regist/er. <B>1</B> record, set down methodically, book, enter: <I>~i abonantojn, dokumentojn, variojn de temperaturo</I>. <B>2</B> (post): <I>~ita letero</I>. <B>~(olibr)o</B>, register, list, record, roll, (surv) field-book. <I>~o de nomoj</I> (No 3/40), <I>de naskiĝoj, mortoj</I>. <B>3</B> (mus) (of voice): <I>~o brusta, kapa, meza</I>. (of organ): pitch: <I>~o %-futa</I>, 16<I>-futa</I>. ➞ <I>piĉ</I>. <B>~ado</B>, -ration. <B>~ejo</B>, -ry, record office. <B>~iĝi</B>, enter one’s name. <B>~isto</B>, -rar, recorder. <B>En~i</B>, r., enrol. <I>Orgeno</I> <B>trans~a</B>, unit (cinema) organ. ➞ <I>kronik, list, not</I>.", "0"],
["reglamenti", "reglament-i", "Regulat/e, bring under -ions, make rules for, organize. <B>~o</B>, -ion, by-law, etc. <I>Trafika ~o</I>, highway code. <B>~a</B>, -ion, prescribed, statutory.", "0"],
["regno", "regn-o", "[UV] Kingdom, State. <B>1</B> (pol) entity, sovereign power. <B>f</B> <I>La ~o de la tielo</I>. <B>2</B> (sc) k. <I>~o animala, minerala, planta</I>. <B>~a</B>, state, national. <I>~a kaso</I> (K 187/9), s-treasury. <I>~a konsilantaro,</I> council of state. <B>~ano</B> [UV] (<I>civitano</I>), citizen, subject. <B>Sam~ano</B>, fellow-citizen. <I>~anigi,</I> naturalize. <B>~estro</B>, head of state. <B>Inter~a</B>, inter-s. <B>Vic~estro</B>, deputy president, regent, viceroy. ➞ <I>imperi, land, naci, potenc, ŝtat</I>.", "0"],
["regolo", "regol-o", "[UV] (orn) (<I>Regulus) &gt;</I> firecrest, goldcrest.", "0"],
["regresi", "regres-i", "draw (fall), go (move, step) back. <B>~o</B>, declension, recession, retrogression, set-back. <B>~a</B>, regressive, retrograde. <B>~e</B>, backwards. ➞ <I>malprogres, malprosper, retro</I>.", "0"],
["regulo", "regul-o", "[UV] Regul/ation, rule; canon, guide, principle, standard. <I>~o de aritmetiko, gramatiko, konduto. Ne ekzistas ~o sen escepto</I>. (ecc) rule of religious order. <B>~a</B>, Regular. <B>1</B> normal, orderly, symmetrical. <B>2</B> constant, habitual, uniform, repeated periodically, without variation. <I>~a laboro, salajro, vivo</I>. <B>~e</B>, -ly <I>respondi, ricevi gazeton, viziti lernejon</I>. <B>~oj</B>, <B>~aro</B>, (set of) rr., rules. <I>~oj de ludo</I>. <B>~eco</B>, -ity. <B>~igi</B>, -ate, -arize, adjust, set in order (right). <I>horloĝon, kontojn</I>. <B>~(ig)ilo</B>, -ator. <I>~igilo aertira,</I> draught -ator. Dec~oj, usages of good society, etiquette. <B>Ekster~a</B>, abnormal. <B>Kontraŭ~a</B>. <B>Ne~a</B>, anomalous, ir-r, out of order. <B>Laŭ-e</B>, by rule, in order. <B>Sub~o</B>, bye-law. ➞ <I>jur, leĝ, princip, reglament, statut</I>.", "0"],
["reĝimo", "reĝim-o", "[OA] regime, (mec) normal running, working conditions. (med) regimen, prescribed diet or way of life, (pol) method of government, order of things, rule(s).", "0"],
["reĝisoro", "reĝisor-o", "(th) stage manager.", "0"],
["reĝo", "reĝ-o", "[UV] King, (chs, drs), k. <I>Festo de la tri ~oj</I>, 12th night. ~oj, (Bb) Kings, <B>f</B> <I>Leono, la ~o de la bestoj</I>. <B>~(ec)a</B>, royal, regal, kingly. (chs) <I>~a turo</I>, k’s castle. <B>~i</B>, reign (1 Sa 8/9, Ps 22/28). <I>Inter blinduloj ~as strabuloj</I>. <B>~ado</B>, reign, <B>~eco</B>, kingship, royalty. <B>~ido</B>, prince of the royal blood, <B>~ino</B>, queen. ➞ <I>dam</I>. <B>~edzino</B>, queen consort. <B>~lando</B>, kingdom. <B>Eks~iĝi</B>, abdicate, lose the crown. <B>Vic~o</B>, viceroy. ➞ <I>abdik, reg</I>.", "0"],
["rejso", "rejs-o", "(num) reis.", "0"],
["reklami", "reklam-i", "(<I>-n, per, por</I>) [OA], Advertis/e, boost, puff, <B>~o</B>, -ement, -ing. <I>~o eklipsa, luma</I>, flashing (illuminated) sign. <B>~a</B>, publicity. <B>~ilo</B>, means of -ing. <B>~isto</B>, -ing agent. ➞ <I>afiŝ, abon, aviz, public</I>.", "0"],
["reko", "rek-o", "(sp) horizontal bar.", "0"],
["rekomendi", "rekomend-i", "(<I>-n, al, ke</I>) [UV], Recommend. <B>1</B> advocate, commend, praise as suitable. <I>~i hotelon, (libron, metodon, sekretarion. Sen mensoga ~o ne iras la vendo</I>. <B>2</B> advise, counsel, enjoin, prescribe. <I>~i paciencon. esti singarda. (al iu) la uzon de Esperanto (registri), ~i leteron</I>. <B>~o</B>, -ation. <B>~a</B> <I>letero</I>, letter of -ation. <B>~inda</B>, commendable. <B>Mal~i</B>, advise against, denigrate, disparage, speak ill of.", "0"],
["rekompenci", "rekompenc-i", "(<I>-n</I>), [UV] Recompense, make amends, repay, requite, reward (or punish) (for), <B>~o</B>, r., award, meed, payment, remuneration. <I>~o por laboroj</I> (Pr 2/10). <B>~e</B>, in return. <B>~inda</B>, worthy of r. ➞ <I>kompens, laŭr, premi</I>.", "0"],
["rekoni", "rekon-i", "(a. <I>agnoski) (konfesi, oficiale akcepti</I>), Recogn/ize, acknowledge character (claim, genuineness, validity) of, admit (treat) as. <I>~i kiel regon. ~i la justecon de pretendo</I>. <B>~o</B>, -ition. <I>Oficiala ~o</I>. <B>Rim</B>.: Better regarded as a root, than as <I>re-kon</I>.", "0"],
["rekordo", "rekord-o", "[OA] (sp) Record, best (most remarkable) performance. <I>Superi ~on. Mond~o</I>, world r. <B>~ulo</B>, r-break-(hold-)er. ➞ <I>campion, registr. [Ne= disk, registr]</I>.", "0"],
["rekremento", "rekrement-o", "[OA] (<I>restaĵo post ekstrakto</I>), dregs, dross, grounds, lees, residue, superfluous (waste) matter; draff (brewers’), husks (of grain). <I>~o biera, vinbera</I>. ➞ <I>feĉ, skori</I>.", "0"],
["rekruto", "rekrut-o", "[UV] (<I>nova varbito</I>), Recruit, conscript, new soldier, f <I>Nia movado bezonas ~ojn</I>. -i, r. <B>~iĝi</B>, be enlisted. <B>~isto</B>, -ing officer. ➞ <I>varb</I>.", "0"],
["rekta", "rekt-a", "[UV] Straight, Direct. <B>1</B> not curved or crooked, bee-line: <I>~a lini-(voi-)o</I>. <B>2</B> erect, upright, vertical: <I>~a kiel poplo</I>. <B>3</B> without deviation, to the point: ~a <I>demando, respondo</I>. <B>4</B> upright, honest: <I>~a konduto</I>. <B>5</B> (gram) (<I>senprepozicia): ~a komplemento</I>, d. object. <B>6</B> (<I>senpera); ~a metodo</I>. <B>~e</B>, point-blank. <I>~e antaŭen</I>, s. on. <I>~e al la celo. Stari</I> <B><I>~e</I></B>, upright. <B>~o</B>, s. line. <B>~eco</B>, rectitude, soundness, rightness. <B>~igi</B>, s-en, rectify. <B>~iĝi</B>, draw one’s up. <B>~iĝu!</B> At attention! <B>~ilo</B> (<I>liniilo</I>), ruler. <I>~ilo faldebla</I>. <B>Mezur~ilo. T~ilo</B>, T-square. <B>mal~a</B>, [UV] indirect, crooked, circuituous, devious, roundabout, tortuous, underhand, winding. <I>~~iĝi</I>, bend, curve. <B>~animeco</B>, rectitude. <B>Ne~a</B> <I>parolo</I>, indirect quotation, oblique narration. <I>~~a, ~~e,</I> askew, aslant, awry, the wrong way. <B>Re~iĝo</B>, rectification. ➞ <I>dekstr, devi, direkt, gust, ort</I>.", "0"],
["rektifi", "rektif-i", "rectif/y. (chem) refine by distillation. ~i <I>alkoholon</I>. (geom) <I>~i kurbon</I>, find a straight line equal to a curve, (el) transform A/C to D/C. <I>~ita kurento</I>. <B>~(ad)o</B>, -ication. <B>~ilo</B>, -ier. ➞ <I>distil, ĝustig, korekt</I>.", "0"],
["rektoro", "rektor-o", "[OA] (wide sense) chancellor (university), rector (college) <I>[Ne= paroĥestr]</I>.", "0"],
["rektumo", "rektum-o", "rectum. <B>~a</B>, rectal,", "0"],
["rekviemo", "rekviem-o", "(mus), requiem.", "0"],
["rekviz(ici)i", "", "(mil) Requisition, comandeer, exact, levy (service, supplies). <B>~o</B>, r.", "0"],
["relajsi", "relajs-i", "<B>~o</B>, (el) Relay. ~a <I>stacio</I>.", "0"],
["relativa", "relativ-a", "[OA] Comparative, relative, conditional, proportional, not absolute. <I>~a sukceso, valoro, vero</I>. (gram) r., referring to an antecedent. <I>~a prortomo</I>. <B>~e</B>, c-(r-)ly. <B>~eco</B>, r-ity. <I>~eca teorio</I>. <B>~ismo</B> (phi), -ism. ➞ <I>rilat</I>.", "0"],
["reliefo", "relief-o", "[OA] Relief, outstanding representation (in fact or appearance), <B>f</B> distinctness, vividness. <B>~a</B>, <B>~e</B>, in r., embossed. <I>~a mapo</I>, r-map. (typ) <I>~a preso</I>, embossing. <B>f</B> <I>prezenti la situacion ~e</I>. <B>~aĵo</B>, r-(raised) work. <B>~igi</B>, work in r., emboss, <B>f</B> give contrast to, set off, throw into relief. ➞ <I>akcent, bos, rimarkig</I>. <B>Alt~o</B>, high-r. <B>Duon~o</B>, half-r. <B>Sen~a</B> (<I>ebena, plata</I>);. flat, even, (<I>banala, pala, proza</I>): flat, tasteless. ➞ <I>cizel</I> [N<I>e = help, kvietig</I>].", "0"],
["religio", "religi-o", "[UV] Religi/on, creed, belief in superhuman controlling power. <I>~o Islama, Kristana</I>. <B>~a</B>, -ous, of r., devout, pious. <I>~a dogmo, kredo, vivo</I>. <B>~e</B>, reverently. <B>~ano</B>, <B>~ulo</B>, religious person, believer. <B>~eco</B>, <B>~emo</B>, -osity. <B>Ali~ano</B>, adherent of another r. <B>Ne~a</B>, lay, secular. <B>Sen~a</B>, without r. ➞ <I>eklezi, kred, kult, profan, rit, sekt</I>.", "0"],
["relikvo", "relikv-o", "relic. <B>1</B> (<I>sanktrestaĵo</I>), remains of saint, etc. <B>2</B> keepsake, surviving memorial. <B>~ujo</B>, reliquary, casket, shrine.", "0"],
["relo", "rel-o", "[UV] Rail (ry, etc.). <B>Apog~o</B>, <B>gard~o</B>, <B>man~o</B>, hand-rail, guard-rail. <B>Glit~o</B>, runner. <B>Pint~oj</B>, points, <B>f</B> <I>Kuri sur ~oj (glate</I>). <B>~eto</B> (<I>kanelo</I>), ridge, thread, worm (of screw. <I>Ŝraŭb~eto</I>, screw-thread. <B>~ingo</B>, chair. <B>~forko</B>, fork. <B>~kruco</B>, junction. <B>~paro</B> (<I>trako</I>). <B>~ŝanĝilo</B> (<I>komutilo</I>). <B>~trabo</B> (<I>ŝpalo</I>), sleeper. <B>Sur~aĵoj</B>, rolling-stock. <B>De~iĝi</B>, jump the metals,", "0"],
["reluktanco", "reluktanc-o", "(el) reluctance. ➞ <I>nevolont</I>.", "0"],
["remburi", "rembur-i", "[UV] pad, stuff, upholster; pack in straw; stuff (an animal). <I>~i felon, kusenon, seĝon</I>. <B>~aĵo</B>, filling, packing, padding, stuffing, flock. <I>~aĵo hara, lana, kapoka</I>. <B>~isto</B>, upholsterer. ➞ <I>pufig, stop, vat</I>.", "0"],
["remi", "rem-i", "[UV] (nt) Row, propel with oars. <I>~i sur la lago</I>. <B>~ado</B>, -ing. <B>~anto</B>, -er, oarsman. <B>~estro</B>, stroke. <B>~ilo</B>, oar. <I>~ilingo</I>, crutch, r-lock. <I>Post~il(et)o,</I> stern oar. <B>~apogilo</B>, thole-pin. <B>Ek~u!</B> Give way!", "0"],
["remizo", "remiz-o", "(<I>veturilejo</I>), coach-house, carriage lock-up. <I>~o lokomotiva</I>, engine-shed. <B>~i</B>, put in the c-h. ➞ <I>garaĝ, hangar</I>.", "0"],
["remonto", "remont-o", "(mil) remount, supply of horses for cavalry.", "0"],
["remoro", "remor-o", "sharksucker, sucking fish (<I>Remora</I>).", "0"],
["remparo", "rempar-o", "[UV] rampart, battlement, bulwark, defence wall, <B>f</B> (<I>defendilo, ŝirmilo</I>) defence, fastness, stronghold. <I>~o de libereco. ~o estas nia Dio</I>. ➞ <I>baril, bastion, dig, mar</I>.", "0"],
["renĉi", "renĉ-i", "Wrench (Rosher). <B>~ilo</B> (<I>surŝraŭbilo</I>), w., spanner. <I>~ilo alĝustigebla,</I> monkey w.", "0"],
["rendevuo", "rendevu-o", "[OA] rendezvous, appointment, tryst. <I>Aranĝi ~on</I>. <B>~ejo</B>, meeting place agreed on.", "0"],
["rendimento", "rendiment-o", "(mec) output, returns, yield; (soc) efficiency.", "0"],
["renegato", "renegat-o", "(pol) (rel) renegade, apostate, deserter from party, turncoat.", "0"],
["renesanco", "renesanc-o", "[OA] (art, lit) (the) Renaissance.", "0"],
["renio", "reni-o", "(chem) Rhenium (Re).", "0"],
["renklodo", "renklod-o", "greengage (<I>verda pruno</I>). Fr. reine-Claude.", "0"],
["renkonti", "renkont-i", "(<I>-n</I>) [UV], Meet. <B>1</B> chance (come light) upon, encounter, fall in with. <I>~i amikon. ~i hazarde</I>, stumble on. <I>~i okaze</I>, run across. <B>2</B> experience, receive. <I>~i aprobon. komprenon, mokon, simpation</I>. <B>3</B> confront, face. <I>~i malamikon, ideon, taskon</I>. <B>~o</B>, -ing. <B>1</B> encounter, <B>2</B> bout, brush, skirmish. <I>Iri al iu</I> <B>~e</B>, go to m. someone. <B>~ejo</B>, -ing-place, rendevous. <B>~iĝi</B>, m., come together. <I>Stranga ~iĝo de cirkonstancoj. Ekstremoj ~iĝas</I>. <B>~ito</B>, person met. <B>Inter~igi</B>, bring together. ➞ <I>kruciĝ, traf</I>.", "0"],
["reno", "ren-o", "[UV] Kidney. <I>Flotanta ~o</I>, floating k. ~oj, kk., reins. <B>~a</B>, renal, nephritic, (med) <B>~inflamo</B> (<I>nefrito</I>), Bright’s disease, nephritis. <B>~ŝtonetoj</B>, gravel.", "0"],
["renomo", "renom-o", "renown, distinction, fame, name (Jeh 16/14-15, Ps 145/7). <I>Havi grandan ~on</I>. ➞ <I>fam, glor, reputaci</I>.", "0"],
["rento", "rent-o", "[UV] private Means, unearned income, revenue. <I>Vivi el siaj ~oj</I>, on one’s means. <I>Ĉiujara ~o</I>, annuity (allowance, pension). <I>Viv~o</I>, life annuity. <B>~ulo</B>, man of means. <B>~umo</B> (<I>interezo</I>), interest. ➞ <I>enspez, procent. [Ne= lupag, ĝir]</I>.", "0"],
["renversi", "renvers-i", "(<I>-n</I>) [UV], Upset, knock over, overthrow. overturn. ~i <I>meblon, muron, sistemon, sitelon, vazon</I>. Bowl over (<I>keglojn</I>), capsize (<I>boaton). ~i ĉion</I>, turn everything topsy-turvy, <B>f</B> <I>opinion, planon, registaron</I>. <B>2</B> (<I>inversigi, transturni</I>), invert, reverse, turn right over (upside down). <I>~i glason, kurenton, seĝon. ~i la ordon de listo; la randon de ĉapelo. ~i rolojn</I>, turn the tables on someone. <I>Ne ~u!</I> This side up! <B>~(ad)o</B>, u., overthrow. <B>~e</B>, head over heels. <B>~ema</B>, subversive. <B>~iĝi</B>, be u., capsize, collapse, fall, overturn, topple over, turn turtle. <I>La veturilo ~iĝis. Malvirtulo ~iĝos kaj pereos</I>. ➞ <I>invert</I>.", "0"],
["reostato", "reostat-o", "(el) rheostat, variable resistance coil.", "0"],
["reparacio", "reparaci-o", "(jur) (pol) reparation, compensation, redress; damages.", "0"],
["repertuaro", "repertuar-o", "[OA] (mus, th) repertoire, stock of pieces (plays) ready for performance. <B>~a</B> <I>peco</I>, stock piece (play).", "0"],
["repliki", "replik-i", "Answer back. <I>Havi ~on pretan,</I> be ready to a. <I>akre</I>, a. acrimoniously, tartly. <B>~o</B> (a. <I>riposto</I>), pert a., rejoinder, retort, riposte. <I>Obei</I> sen~e (without a word). <I>Ne ~u!</I> No back-chat! <B>Ne~ebla</B> (unanswerable) <I>argumento</I>. <B>~ema</B>, pert, saucy. ➞ <I>respond, ripost</I>.", "0"],
["reprezalio", "reprezali-o", "(pol) Reprisal(s), act of retaliation. <I>Ekspedicio ~a</I>, punitive expedite. <B>~e</B>, by way of r.", "0"],
["reprezenti", "reprezent-i", "[UV] (art, pol) Represent, act (deputize, stand) for, fill place of, (jur) appear (hold a brief) for. <I>~i firmon. ~i en la parlamento</I>. <B>~(ad)o</B>, -ation. <I>Proporcia ~o</I>. <B>~a</B> <I>regado</I>. <B>~anto</B>, -ative, agent, traveller. <I>Rajtigita ~anto,</I> authorized -ative. <I>~antoj de diversaj nacioj</I>. ➞ <I>prezent</I>. <B>Rim</B>.: Better regarded as a root, than as a derivative (<I>re-prezent</I>).", "0"],
["repso", "reps-o", "(tex) repp, fabric with corded (ribbed) surface.", "0"],
["reptilio", "reptili-o", "(rampulo), reptile, e.g., <I>lacert, serpent, testud</I>.", "0"],
["repudii", "repudi-i", "(jur) repudiate; disown, disavow, give up, reject, relinquish, renounce. <I>~i edzinon, kontrakton, opinion</I>. ➞ <I>abdik</I>.", "0"],
["reputacio", "reputaci-o", "[OA] Reput/ation, char, (good or bad), what is generally believed about one. <I>Bona ~o</I>, credit, good name. <I>Havi la ~on</I> (be -ed) <I>esti riĉa. Fari por si ~on,</I> make a name for one’s. <I>Koni iun laŭ ~o,</I> by -e. <I>Perdi sian ~on</I>, lose one’s char, (good name), fall into dis-e. ➞ <I>fam, renom</I>.", "0"],
["resonanco", "resonanc-o", "(<I>simpatia vibrado</I>), resonance, sympathetic vibration. <I>~a kesto</I>, sound box(chest). <B>~ilo</B>, resonator.", "0"],
["respektiva", "respektiv-a", "Respective, each’s own, pertaining to each, individual (with reference to each). <I>Metu ilin en iliajn ~ajn lokojn. La ~aj pozicioj</I> (each to each) <I>de du steloj. Niaj ~aj devoj</I>, our several obligations. <B>~e</B>, -ly. <B>Rim</B>.: <I>Respektive</I> (abbreviated to <I>resp.</I>) is often misused.", "0"],
["respekto", "respekt-o", "[UV] Respect, Deference. <I>Pro ~o al</I>, out of regard for. <B>~i</B> (<I>-n</I>), <B>1</B> (<I>havi ~on por, trakti kun ~o</I>): hold in awe, look up to, pay heed to, show d. to, treat with r. <I>Malgraŭ mia plena ~o al,</I> with all due r. to. <I>Tim~o</I>, awe. <B>2</B> (<I>atenti, konsideri</I>): abide by, comply with, give weight to. <I>~i leĝon, promeson, skrupulon, tradicion</I>. <B>~(oplen)a</B>, r-ful. <B>~e</B>, r-fully. <B>~ego</B>, reverence. <I>~eginda</I>, venerable. ~igi <I>la leĝon</I>. <B>~inda</B>, r-able, worthy of r. <I>~indeco</I>, r-ability, good name. <B>Mal~i</B>, despise, disdain, disregard, infringe, profane, scorn, (col) sniff (turn up one’s nose) at. <I>~~a (sen~a</I>), forward, impertinent, insolent, pert, rude. <B>Ne~a</B>, disr-ful. <B>Sin~o</B>, self-r. <B>Tro~a</B>, obsequious. ➞ <I>estim</I>.", "0"],
["respondi", "respond-i", "(<I>-n, al, pri, ke</I>) [UV], Answer. <B>1</B> Reply: <I>~i demandon, al demando. ~i leteron, sonorilon. ~i jese, ke jes. ~i nenion</I>, make no reply. <B>2</B> reciprocate, return: <I>~i amon</I>. <B>3</B> comply with: <I>~i peton. Ne ~i,</I> fail to a. <B>4</B> (<I>inter~i</I>), correspond (be a counterpart to), meet: <I>~i atendon, bezonon, postulon. La Rusa Jan. 1 ~as al nia Jan</I>. 11. <B>~o</B>, answer, reply, rejoinder, response. <I>Oni petas ~on</I>, R.S.V.P. <I>~o pagita</I>, r. paid. <I>Havi, trovi ~on pri ĉio</I>, have an a. for everything. (fugue) answer. <B>~a</B>, appropriate, corresponding. <B>~e</B>, for a., in reply. <I>~e al via letero</I>, in r. to your letter. <B>~eca</B>, [UV] responsible (a. <I>responsa). ~eco</I>, responsibility. <B>~enda</B>, to be a-ed. <B>Inter~i</B>, correspond (one to another). <B>Pri~i</B> (<I>responded</I>) (a. <I>responsi</I>), be responsible,", "0"],
["responsi", "respons-i", "(<I>prirespondi, responded) (al, por, pri</I>), be Responsib/le, accountable, answerable, liable. <I>Mi ~as (estas ~a) pri eraroj, la programo, tiu decido</I>. <B>~(ec)o</B>, -ility, onus. <I>Akcepti ~on. Persona ~o</I>. <B>~igi</B>, hold r., blame (for).", "0"],
["respubliko", "respublik-o", "[OA] Republic. <I>La Franca</I> ~o. <B>~(em)a</B>, -an. <B>~ano</B>, -an. <B>~estro</B>, president of r. <B>~ismo</B>, -anism. ➞ <I>demokrat</I>.", "0"],
["resti", "rest-i", "[UV] (<I>estadi</I>), (nt) Remain, continue to be. <B>1</B> (in same place): abide, stay, stop, tarry. ~i <I>hejm-(survoj-)e, en Parizo, por tagmanĝo. ~u kie vi estas</I>, stay where you are. <I>Jen mi estas, jen mi ~as</I>, Here I am, here I stay. <B>2</B> (in same state): <I>~i en bona sano, fidela, sen puno. Mi ~as via amiko. Kiel estis, tiel ~as</I>. <B>3</B> be left behind, over (when pt has gone): <I>Nur ~as al mi diri</I>... It only remains for me to say <I>. .. Ne ~is al li eĉ unu penco. Kio ~as ankoraŭ farenda?</I> <B>~o</B>, balance, remainder, what is over. <I>La ~o de la mono, de mia vivo</I>. <B>~ado</B>, stay. ~aĵo(j), remains, arrears, left-overs, relics, residue. Manĝ~aĵoj, leavings, scraps. <I>La</I> post~aĵo (gleanings) <I>de la rikolto</I>. Seb~aĵoj, greaves, tallow dregs. ~adi (➞ <I>loĝi</I>), abide, reside, stay, stop. <I>Kamp~adi,</I> rusticate. <I>Somera ~adejo</I>, residence. ~anta, residual. ~ejo, abode, stopping- place. <I>Ŝip~ejo</I>, berth. <B>~igi</B>, detain, leave behind, let r. <I>Ĉio, kion ~igis la hajlo</I> (El 10/15). Post<B>~i</B>, r (fall, lag) behind, stay in (after school). <I>Mense post~anta,</I> backward. ➞ <I>ceter, daŭr, halt, ripoz</I>.", "0"],
["restoracio", "restoraci-o", "[UV] restaurant, dining-room. <B>~aĉo</B>, low-class eating-house.", "0"],
["resumi", "resum-i", "[UV] Summar/ize, boil down, recapitulate, sum up. <B>~o</B>, -y, abstract, epitome, precis, resume, short statement. <I>Kont~o</I>, statement of a/c, (mus) ~a <I>sekcio</I>, recapitulation. <B>~e</B>, briefly, in a nutshell, in brief (short), to sum up. ➞ <I>epitom</I>.", "0"],
["resuso", "resus-o", "Rhesus monkey (<I>Macaca mulatto</I>). Vd <I>makak</I>.", "0"],
["retino", "retin-o", "[OA] Retina (of eye), <B>~a</B>, -al. ~ito, -itis.", "0"],
["reto", "ret-o", "[UV] Net, (anat) caul. <B>Drat~o</B>, wire-ting. <B>Har~o</B>, hair-n. <B>Sak~o</B>, landing n. <B>Skrap~o</B>, dredger. <B>Tren~o</B> (<I>trolo</I>), drag-n, trawl. <B>Voj~o</B>, road system. <I>Enfali en ~on. ~o de mensogoj</I>. <B>~aĵo</B>, netting, n-work. <I>~aĵo de fervojoj, vejnoj</I>. <B>~eco</B>, n-like, reticulated. <I>Pajl~a seĝo</I>, straw-bottomed chair. <B>~kapti</B> (<B>En~igi</B>), (catch in a) n., snare. <B>En~iĝi</B>, fall into a trap. ➞ <I>araneaj, maŝar</I>.", "0"],
["retoro", "retor-o", "[OA] Rhetor/ician. <B>~aĵo</B>, imposing oratory, fine language (Se 1/6). II ~IKO, -ic. <B>~ika</B>, -ical. <I>~ika demando</I>.", "0"],
["retorto", "retort-o", "[OA] (chem) retort, retrat-i (<I>-n), (fin</I>) call in, take up (bill), withdraw from circulation.", "0"],
["retreti", "retret-i", "(<I>retiriĝi</I>), (mil) Retreat, relinquish post, withdraw, (chs) move back. <B>~o</B>, r., withdrawal.", "0"],
["retro", "retro-", "(unofficial pfx), retro-, denotes movement in direction contrary to normal, (mus) ~a <I>kanono</I>, canon cancrizans. <B>~e</B>, backwards. ~aktiva, -active. ~fleksa, -flex. ~ira, -grade. ~paŝi, step backwards. ~pedali, back-pedal. ~spektiva, respective, looking backwards.", "0"],
["retuŝi", "retuŝ-i", "improve, retouch, touch up (article, photo, etc.). ➞ <I>tuŝ</I>.", "0"],
["reŭmatismo", "reŭmatism-o", "[OA] <B>rheumatism</B>. <B>~a</B>, <B>~ulo</B>, <B>rheumat</B>ic<B>. ➞ artrit</B>.", "0"],
["revelacio", "revelaci-o", "[OA] (rel) revelation, divine or supernatural communication. reveal (1 Sa 3/7, 21; 9/15). ➞ <I>apokalips</I>. <B>Rim</B>.: It is increasingly common to use rivel-i, <B>~aĵo</B>, in this sense. Vd <I>rivel</I> (2).", "0"],
["reveri", "rever-i", "(<I>respektegi</I>). Rever/e, hold in deep respect, venerate. <B>~o</B>, -ence. <B>~enda</B>, reverend, The Rev. ➞ <I>riverenc</I>.", "0"],
["reversi", "revers-i", "(<I>-n</I>), Revers/e, turn inside-out (<I>veston</I>). <B>~o</B>, r-side; back (<I>monera</I>): other side (<I>paĝa</I>); wrong side (<I>ŝtofa</I>); facing, lapel, revers (<I>vesta</I>); turn-over (<I>ŝtrumpa</I>); turn-up (<I>pantalona</I>). <B>~ebla</B>, -ible. ➞ <I>invers, invert</I>.", "0"],
["revi", "rev-i", "(<I>-n, pri</I>) [UV], (day)Dream, be in a Reverie (wool-gathering), muse. <I>~i pri edziĝo, estonta feliĉo, sukceso</I>. <B>~o</B>, d., brown study. <I>Droni en ~oj. La regno de ~oj</I>. <B>~(em)a</B>, d-y, romantic. <I>~(em)ulo,</I> dreamer, visionary. <B>El~igi</B>, <B>Sen~igi</B>, disappoint, disillusion. <B>dis~iĝo</B> [UV] (better <I>Elreviĝo, Sen~iĝo</I>), disenchantment, disillusionment, <I>~~iĝi</I>, come down to earth, sober down, wake from one’s dreams. <B>En~iĝi</B>, fall into a r. <B>For~i</B>, d. away. <I>For~i la vivon</I> (4 FA 157/15). <I>Tion mi ne atendis, eĉ ne</I> pri~is. ➞ <I>desapont, fantazi, sonĝ</I>.", "0"],
["revizi", "reviz-i", "examine, inspect, overhaul, e.g., <I>~i konton. ~i la gubernion</I> (Rz 5/23). 1T Perhaps a needless synonym of <I>inspekti, kontroli</I>.", "0"],
["revizii", "revizi-i", "[OA] Revise, emend, look over (read), making necessary improvements. <I>~i opinion, manuskripton. ~ita eldono, traduko</I>. (jur) review (<I>proceson</I>); reconsider (<I>verdikton</I>).", "0"],
["reviziismo", "reviziism-o", "revisionism.", "0"],
["revizoro", "revizor-o", "[OA] ( = ~isto), Inspector-General (Rz 5/8).", "0"],
["revolucio", "revoluci-o", "[OA] (pol) Revolution, insurrection, revolt, uprising. <B>f</B> fundamental reconstruction, sudden complete change, turning upside-down. <I>~o de ideoj, en prezoj</I>. <B>~i</B>, revolt. <B>~ano</B>, <B>~ulo</B>, -ary. <B>~ema</B>, <B>~iga</B>, -ary. <B>~igi</B>, -ize, recast, refashion, reform). ➞ <I>ribel</I>.", "0"],
["revolvero", "revolver-o", "[OA] revolver.", "0"],
["revuo", "revu-o", "[OA] Review. <B>1</B> Survey (commentary, considerate, digest, examination, synopsis) of current events. <B>2</B> (mil) display and inspection, muster, parade: <I>La reĝo ~is la tutan Izraelon</I> (2 Rĝ 3/6). <B>3</B> magazine, periodical, publication (M 65/27). <B>4</B> (th) light theatrical performance touching current alfairs. ➞ <I>recenz</I>.", "0"],
["rezedo", "rezed-o", "[OA] mignonette (<I>Reseda</I>).", "0"],
["rezervi", "rezerv-i", "(<I>-n</I>) [UV], Reserv/e, hold over, keep back, lay by (up), postpone use of, retain, save, set apart (aside). <I>~i bileton, decidon, kapitalon, sidlokon</I>. ~(ad)o, -ation, limitation, qualification. <I>Akcepti kun ~o</I> (a grain of salt). <I>Konsenti kun ~oj</I>. <B>~a</B>, r., spare, <I>~a armeo, kapitalo, lito</I>. <B>~aĵo</B>, r. <I>~aĵoj</I>, provisions, spares, stock, stores. <B>~ano</B>, -ist. <B>~ita</B>, -ed, booked. <I>~ita seĝo. Ciuj rajtoj ~itaj</I>. ~ujo, -oir. ➞ <I>spar</I>.", "0"],
["rezidento", "rezident-o", "(pol) resident (diplomatic agent).", "0"],
["rezidi", "rezid-i", "(<I>loĝi konstante</I>), (jur) Resid/e, dwell. <B>~ejo</B>, -ence.", "0"],
["reziduo", "rezidu-o", "(ch, mat) Residu/’e, -um. <B>~a</B>, -al.", "0"],
["rezignacio", "rezignaci-o", "[OA] (pious) resignation, uncomplaining endurance (forbearance, fortitude, submission). <I>~o pri la sorto</I>. accept with resignation, bear patiently, put up with, resign one’s to.", "0"],
["rezigni", "rezign-i", "(-n, <I>pri</I>) [OA], Resign, abandon, cryolf, disclaim, forego, give up, relinquish, renounce, surrender, waive, withdraw. <I>~i ambicion, entreprenon, esperon, oficon, pretendon, rajton, taskon, vivon</I>. <B>~o</B>, -ation. ➞ <I>abdik, eksiĝ, fordon, forlas, formet, rezignaci, rifuz</I>.", "0"],
["rezino", "rezin-o", "[UV] <B>1</B> resin. <B>2</B> any similar substance, natural or synthetic, e.g., copal, shellac. <I>Sigel~o = sigelvakso</I>. <B>~(ec)a</B>, resinous. <I>Flamiĝema kiel ~a ligno</I>. ➞ <I>kolofon</I>.", "0"],
["rezistanco", "rezistanc-o", "(el) resistance. <I>Izol~anco</I>, insulation -ance.", "0"],
["rezisti", "rezist-i", "(<I>-n, al, antaŭ, kontraŭ</I>) [OA] (Jos 1/5, Da 11/15, Ja 4/7). Resist, bear up (hold out, strive) against, oppose, repel, withstand. <B>~a</B> (a. <I>-imuna</I>), resistant (to disease, etc.), tough, stout. <B>Akvo~a</B>, <B>fajr~a</B>, <B>veter~a</B>, water-(fire-weather-) proof. <B>Korod~a</B>, stainless, rustless. <B>~o</B>, -ance. <B>~eco</B>, (bot) hardiness. <B>~ilo</B>, -or. <B>~ivo</B>, -ivity. <B>Mal~a</B>, <B>Sen~a</B>, susceptible. <B>Ne~ebla</B>, irresistible. ➞ <I>kontraŭstar, malced, malhard, sentem</I>.", "0"],
["rezolucio", "rezoluci-o", "resolution (at meeting), adopted motion, decision. ➞ <I>decid</I>.", "0"],
["rezoluta", "rezolut-a", "Resolute, bold, decided, determined, firm of purpose. <B>~e</B>, -ly.", "0"],
["rezoni", "rezon-i", "[OA] (nt) Reason, argue (abt), conclude, draw conclusions (inferences), use arguments. ~i <I>logike</I>. <B>~ado</B>, -ing. <I>Cirkla ~ado,</I> vicious circle, <I>~ado kaj filozofio panon ne donas</I>, <B>~ema</B>, argumentative, reasoning. <B>Mis~i</B>, reason wrongly. ➞ <I>argument, logik, raci, resonanc</I>.", "0"],
["rezultato", "rezultat-o", "[OA] = rezult(aĵ)o. International root., but unsuitable for verbal use, and giving way to <I>rezult</I>.", "0"],
["rezulti", "rezult-i", "[OA] (<I>el</I>), (nt) Result, arise as logical conclusn, follow (issue, proceed) from. <I>Nenio ~is el la diskuto</I>. <B>~o</B>, r., consequence, outcome, sequel, upshot. <I>Akiri, alporti, ricevi ~on. La ~o de la kalkulado</I> (1 Kr 21/5), <I>de juĝo</I> (Hb 1/4). <B>~(ant)a</B>, eventual. <B>~antoj</B>, (ac) -ant or combination tones = (a) <I>diferenctono</I>, (b) <I>sumtono</I>. <B>~igi</B>, lead to, cause, produce as a result. ➞ <I>kaŭz</I>. <B>Sen~a</B> (<I>senutila, vana</I>), barren, bootless, fruitless, futile, useless. <I>Sen~a klopodo</I>.", "0"],
["ribeli", "ribel-i", "(<I>kontraŭ</I>) [UV], (nt), Rebel, mutiny, revolt. <B>~(ad)o</B>, -lion, revolt, sedition, <B>~anto</B>, <B>~ulo</B>, r., insurgent, mutineer. <B>~ego</B>, insurrection. <B>~ema</B>, -lious, contumacious, insubordinate, recalcitrant, refractory. <B>~igi</B>, incite to rebellion. <B>~iga</B>, seditious. ➞ <I>revoluci</I>.", "0"],
["ribo", "rib-o", "[UV] Currant (<I>Ribes</I>). ~o blanka, flava, nigra, ruĝa. <B>~arbedo</B>, <B>~ujo</B>, c-bush. ➞ <I>rip, sekvinberet (korint</I>).", "0"],
["riceli", "ricel-i", "Receiv/e and conceal (stolen goods), <B>~anto</B>, -er.", "0"],
["ricevi", "ricev-i", "(<I>-n</I>) [UV], Recei/ve. <B>1</B> acquire, derive, gain, get, obtain: <I>atent -(bonven - donac - help - impres - leter - nom -profit-)on</I>. <B>2</B> admit, take in, welcome. <I>~i gaston, kiel filon</I>. <B>3</B> come by, experience: catch (<I>malsanon</I>); suffer (<I>prokraston</I>); take (<I>formori). ~o</I>, -pt. ~a <I>stacio</I>, -ving station. ~anto, -ver, recipient. <B>~ebla</B>, to be got (had), obtain-(procur-)able. ~ema, -ptive. <B>~igi</B>, confer, impart, procure, (el) ~ilo, -ver. <I>~ilo kristal-(radi-telefon-)a</I>. <B>~onto</B>, consignee. <B>~atesto</B>, <B>~avizo</B>, acknowledgement of -part. ➞ <I>akir, ating, gajn, havig, kolekt, obten, rikolt</I>.", "0"],
["ricino", "ricin-o", "[OA] castor-oil-plant (<I>Ricinus</I>). <B>~oleo</B>.", "0"],
["riĉa", "riĉ-a", "(<I>je</I>) [UV], Rich <B>1</B> (in money): affluent, opulent, wealthy, well-to-do. <B>2</B> (in other things): abounding in, fertile, fruitful. <I>~a tero. ~a je promesoj</I>. <B>3</B> (<I>multenhava</I>), abundant, ample: <I>~a meblaro, rikolto, sperto</I>. <B>4</B> (cul) with much fat or sugar. <B>~o</B>, wealth. <I>Feliĉo kaj ~o elvokas envion</I>. ~e <I>vestita</I>, -ly clad. <B>~aĵo(j)</B>, -es, fortune, possessions, wealth (e.g., <I>~aĵo</I>, Jes 8/4, <I>~aĵoj</I>, Jes 30/6). <B>Rim</B>.: In early writings Z. used <I>~eco</I> (e.g., K 129/9, 14). Later <I>~o</I> (e.g., Ge 31/16); afterwards <I>~aĵo(j</I>). ~eta, in comfortable circumstances. <B>~iĝi</B>, get r. <B>~igi</B>, en-r, fertilize. <B>~ulo</B>, [UV] r. man. Mal<B>~a</B>, poor, indigent, needy; barren, inferior, insufficient, meagre, paltry, slight. <I>~~eco,</I> poverty. <I>~~ega</I>, destitute. <I>~~igi</I>, impoverish. <I>~~ulo</I>, poor person. <I>~~ulo pareneojn ne havas</I>. <B>Ne~a</B>, of modest means. <B>Nov~ulo</B>, newly-r. ➞ <I>abund, hav, malmank, plen</I>.", "0"],
["riĉ! raĉ!", "", "sound of tearing (4 FA 114/31).", "0"],
["ridi", "rid-i", "(-n, <I>je, pri, pro</I>) [UV], Laugh (at). <I>Plej bone ~as, kiu laste ~as</I>. f <I>La montoj ~as pro ĝojo. La sorto ~is al ni</I> (smiled on us). <I>~anta pejzaĝo</I>. ~(ad)o, -ter. <I>~o brua,</I> guffaw, horse 1. ~(ant)e, -ingly. ~aĉi, cackle. ~egi, be convulsed (doubled up) with -ter. ~ema, gay, gleeful, merry, mirthful. ~emo, risibility. <B>~eti</B>, [UV] smile, giggle, titter. <I>~etaĉi, afekte ~eti</I>, grin, simper, smirk. <B>~iga</B>, diverting, droll, facetious. <B>~igi</B>, raise a laugh. <B>~inda</B>, -able, comical, funny, ludicrous, ridiculous. <I>~indaĵo (~objekto</I>), <B> ing</B> stock, absurdity, butt (object. of ridicule). <B>Ek~i</B>, burst into -ter. <B>For~i</B> (<I>-n</I>), dismiss with a l. <B>Sen~a</B>, grave, serious. <B>Sub~i</B>, <B>Kaŝ~i</B>, chuckle, laugh in one’s sleeve. <B>Mok~i</B>, <B>Pri~i</B>, deride, jeer (mock) at, laugh to scorn, make fun of, ridicule. ➞ <I>mok, rikan</I>.", "0"],
["rifo", "rif-o", "[UV] reef, ridge of rock, sandbank, (min) lode, <B>f</B> danger, risk of failure. <I>Atendu ~ojn survoje</I>. <B>Sub~o</B>, half-submerged rock, shoal.", "0"],
["rifuĝi", "rifuĝ-i", "(take) Refuge (in, from), nestle, shelter. <I>Al vi mi ~as</I> (Ps 143/9). <I>~i en kaverno; en alia lando</I>. <B>~o</B>, refuge, protection, safety, security, shelter. <I>Urbo de ~o</I> (Jos 20/2). <B>~ejo</B>, (place of) r., haven, sanctuary, retreat; (street) r. <I>Dio estas ~ejo</I> (Ps 46/1). <B>~into</B>, refugee. ➞ <I>azil, fuĝ, oaz, protekt, ŝirm</I>.", "0"],
["rifuzi", "rifuz-i", "(<I>-n, al</I>) [UV], Refus/e, say \"No\". <B>1</B> decline, reject, turn down, refuse to accept: <I>~i donacon, honoron, oficon, proponon</I>. <B>2</B> disclaim, r. to admit (acknowledge): <I>~i rajton, respondecon</I>. <B>3</B> deny, r. to agree (give): <I>~i krediton, peton</I>. <B>4</B> r. to do s-t: <I>~i elspezi, fari, kanti, submetiĝi. Miaj piedoj ~as min porti</I>. <B>~o</B>, refusal, denial, etc. <B>~anto</B>, <B>~ema</B>, recusant. <B>Ek~i</B>, demur. <B>For~i</B> (*~lfil <I>je</I>), abjure, forgo, give up, renounce, resign, retire from. <I>~~i profiton, rolon, la mondon</I>. ➞ <I>domaĝ, malkonsent, rezign</I>.", "0"],
["rigardi", "rigard-i", "(<I>-n, al</I>) [UV], Look. <B>1</B> 1. at, behold, view: <I>~i iun, al iu, la pejzaĝon, tra la fenestro</I>. <B>~u!</B> Look! See! Take notice! <B>1</B> face, front: <B><I>La fenestro ~as la maron</I>. 2</B> check, examine, see: <I>~u la faktojn! ~u, pro kio estas la bruo</I>. <B>3</B> Take heed: <I>~u, antaŭ ol salti</I>. <B>4</B> (<I>~i kiel</I>): account (consider, look on, think of) as: <I>~i iun kiel amikon. ~i proponon kiel utopion</I>. <B>~o</B>, look. <I>~o demanda, kolera, riproĉa, scivola. Ĵeti ~on al</I>. <B>~aĉi</B> (<I>~i stulte) kiel bow</I>. <B>~adi</B>, contemplate, gaze on, observe. <B>~anto</B>, looker on, spectator. <B>~egi</B>, look hard, glare, stare. <B>~ejo</B>, viewpoint. <B>~ema</B>, gaping. <B>~eti</B> (<B>ek~i</B>), glance. <B>~ilo</B>, eyepiece, finder, sight. <B>Al~i</B> (<I>spekti</I>), look at (on), be a spectator. <B>Ĉirkaŭ~i</B>, look around (all over), survey. <B>En~i</B>, <B>Pri~i</B>, look at (into, over), examine, inspect, investigate, scrutinize. <B>Re~i</B>, look again. <B>Retro~i</B>, look back. <B>Super~i</B>, supervise. <B>Supren~i</B> (<I>levi la ~on</I>), look up. <B>Tra~i</B>, look through, examine. <I>~~eti (libron</I>), skim through. <I>~~a truo,</I> peephole. <B>Sub~i</B>, <B>Kaŝ~i</B>, look on the sly, glance at furtively (stealthily), peep. ➞ <I>atent, observ, vid</I>.", "0"],
["rigi", "rig-i", "(<I>ŝipon</I>), Rig, provide with necessary ropes, spars, etc. <B>~ilaro</B> (-ging); <I>senmova</I> (standing), <I>mova</I> (running). <B>Plen~a</B>, full -ged.", "0"],
["rigida", "rigid-a", "[UV] Rigid, Stiff, hard: <I>~a framo, objekto</I>. Formal, hide-bound: <I>~a etiketo</I>. Inflexible, stubborn, unbending, unyielding; <I>~a karaktero, principo, sinteno, virto</I>. Set, strained, taut, tense: <I>~a muskolo, ŝnuro, vizaĝo</I>. Starchy, stilted: <I>~a stilo</I>. <B>~e</B>, rgidly, stiffly. <B>~eco</B>, r-ity. <B>~igi</B>, s-en, benumb, cramp. ~iĝi <I>de frosto</I>, be numbed, frozen s. <B>~iĝo</B>, cramp, rigor. <I>~iĝo de la morto</I>. <B>Mal~a</B> (<I>elasta, fleksebla</I>), flabby, limp. <I>~~iĝi</I>, grow limp, relax. ➞ <I>necedem, nefleksebl, obstin, paraliz, rigor, senmov</I>.", "0"],
["rigli", "rigl-i", "[UV] Bolt. <I>~i fenestron, pordon</I>. <B>~ilo</B>, [UV] b., bar (2 Kr 14/7; Ps 147/13). <B>glit~ilo</B>, sliding b. <B>Risorta ~ilo</B>, spring b. <B>serur~ilo</B>, lock-b., catch, <I>~ileto</I>, sash-b„ latch. <B>Mal~i</B>, unbolt. <B>Sub~e</B>, in safe custody. ➞ <I>bar, surur, ŝlos</I>.", "0"],
["rigora", "rigor-a", "[OA] Rigorous, harsh, severe: <I>~a agado, juĝo, klimato</I>. Hard: <I>~a sorto, vintro</I>. Strict: <I>~a justeco, neŭtraleco</I>. Close: <I>~a ekzamenado, observado, rezonado</I>. <B>~e</B>, -ly, strictly to the letter. <B>~eco</B>, rigour, austerity, severity, strict enforcement of rules. <B>Ne~a</B>, optional. ➞ <I>rigid, sever, strikt</I>. Opp <I>indulg</I>.", "0"],
["rikani", "rikan-i", "[OA] (nt) Sneer (at), express or suggest derision or disparagement, smile derisively. <B>~(ad)o</B>, sneer(ing). <I>~anta simio,</I> grinng ape (3 FA 34/10). ➞ <I>grimac, mok, ridaĉ</I>.", "0"],
["rikiŝo", "rikiŝ-o", "rickshaw. <B>~isto</B>.", "0"],
["rikolti", "rikolt-i", "[UV] Harvest, Reap; gather in. <I>~i frukton, grenon. Kion vi semas, tion vi ~os. Vin~o</I>, wine-h., vintage, <B>f</B> gain, obtain. <I>~i aplaŭdon, sukceson, la frukton de laboro</I>. <B>~(ad)o</B>, h-ing, reaping, ingathering. <B>~(aĵ)o</B>, h., crop. <I>Hajlo detruis la -on</I>. <B>f</B> <I>~o de riproĉoj</I>. <B>~a</B> <I>festo</I>, h-home, h-festival. <B>~ilo</B>, [UV] scythe. <I>~ileto</I>, reapinghook, sickle. <B>~isto</B>, h-er, reaper. Post~a <I>kampo</I>, stubble-field. (<I>spikumi</I>), glean. <B>~maŝino</B>, h ing machine. ➞ <I>akir, fait, gajn, kompajn, ricev, serp</I>.", "0"],
["rilati", "rilat-i", "(<I>-n, al</I>) [UV], Relat/e; be -ed, connected (have to do) with, concern, have a bearing on. 20 <I>~as al 5 kiel</I> 8 <I>al</I> 2. <I>~i amike al</I>, be on friendly terms with. <I>Ne ~as</I>, is irrelevant (beside the point), has no bearing on the matter. ~o. <B>1</B> -ion, connection. <I>En tiu ~o (tiu~e</I>), in that connection (respect). <I>Sen ~o al</I>, without any bearing on. (mus) <I>Fals~o</I>, false -ion. <B>2</B> (<I>sinteno</I>), attitude. <I>Mia ~o al la demando</I>. <B>~a</B>, -ive (having -ion, germane) to, pertinent, relevant, (gram) <I>~a pronomo</I>. <B>~e</B>, -ively. <I>~e (en ~o) al</I>, as regards, concerning, in (with) -ion to, in the case of, with referee (regard, respect) to. <I>~e min</I>, as for me, for my pt. <I>~e prezon kaj paperon la verko estas bona</I>. <B>~igi</B>, assign, attribute. <I>~igi al si</I>, apply (take to one’s). <B>~umo</B> (<I>ratio</I>), (mat) ratio, proportion. <B>Ek~i</B>, enter into rr. (with). <B>Inter~oj</B>, connections. <B>~~igi</B>, establish relations. with. <B>Kun~eco</B>, affinity. ➞ <I>afin, analog, koncern, najbar, parenc, proporci, relativ</I>.", "0"],
["rilo", "ril-o", "(Scottish dee), reel.", "0"],
["rimarki", "rimark-i", "(<I>-n, de</I>) [UV], <B>1</B> Notice, Observ/e, Remark, note (Ru 2/9, 3/4; Ob 7, Ho 7/9). <I>Li ~is, ke la sistemo estas tro komplikita</I>. <B>2</B> make a r., r. upon. <I>Vi ja nenion diras</I>, <B>~is</B> <I>unu el la teksistoj</I> (1 FA 69/31). <B>~o</B>, observation. <B>~ebla</B>, perceptible, sensible (<I>fenomeno</I>). <B>~ema</B>, o-ant. <B>~igi</B> <I>al,</I> call attention to, point out (<I>eraron). ~iga,</I> striking. <B>~ilo</B>, mark (<I>en libro</I>), sign. <B>~inda</B>, r-able, extraordinary, worthy of note. <I>~indaĵo</I>, thing to be n-ed, matter of interest. <I>~indaĵoj</I>, notabilia. <I>~indulo,</I> man of note, person-age, -ality. <I>~indigi,</I> distinguish, signalize. <B>Ne~ebla</B>, imperceptible, slight. <I>Li foriris ne~ite</I>, unn-ed, uno-ed. ➞ <I>akcent, atentig, dir, not, observ, reliefig</I>.", "0"],
["rimedo", "rimed-o", "[UV] Means, measure, method, opportunity, way. <I>Uzi ĉiujn ~ojn por resaniĝi. Cu la celo pravigas la ~on? Mi trovis ~on iri</I> (a way of going). <I>Miaj ~oj ne permesas tion</I>, I can’t afford it. <I>Provizora ~o</I>, expedient. <B>Antaŭ~o</B>, <B>kontrau~o</B>, precautionary (preventive) measure. <B>Mon~oj</B>, pecuniary resources. <B>Sen~a</B>, without means. <B>Viv~o</B>, means of livelihood [<I>Ne = kuracil</I>]. ➞ <I>il, metod, per, pov, voj</I>.", "0"],
["rimeno", "rimen-o", "[UV] Strap, leather band (lace, strip), thong. <I>~o de ŝuo</I> (Ge 14/23). (mec) belt. <B>Alliga ~o</B>, tether. <B>Brak~o</B>, arm-rest. <B>Gvid~oj</B>, reins. <B>Konduka ~o</B>, lead, rein. <B>Leda ~o</B>, leather belt, strap. <B>Libra ~o</B>, book-strap. <B>Pak~o</B>, s., webbing. <B>Ŝultra ~o</B>, shoulder-s. <B>Tir~o</B>, trace(s) of harness. <B>Vost~o</B>, crupper. <B>~aĵo</B>, belting. <B>~isto</B>, harness-maker.", "0"],
["rimeso", "rimes-o", "(<I>monsendo</I>), remittance. <B>~i</B>, remit (transmit) funds.", "0"],
["rimo", "rim-o", "[UV] Rhym/e, <I>~o ina, vira</I>. <B>~i</B>, (nt) r. with. <B>~aĉo</B>, <B>~ojdo</B>, imperfect r. <B>~aĉisto</B><I>,</I> -ster. <B>~aĵo</B>, piece of r. <I>Ĉu poemo, aŭ nur ~aĵo?</I> <B>~igi</B>, put into r., versify. <B>Sen~a</B>, blank (verse).", "0"],
["rimorso", "rimors-o", "(<I>konscienc-riproĉo</I>), remorse, bitter repentance, compunction. ➞ <I>bedaŭr, pent</I>.", "0"],
["rinanto", "rinant-o", "(bot) cock’s comb, yellow rattle (<I>Rhinanthus</I>).", "0"],
["ringo", "ring-o", "[UV] <B>1</B> Ring. <I>~o edziĝa, fianĉiĝa. Buŝtuk~o, orel~o, sigel~o</I>, napkin ring, ear ring, signet ring. <B>2</B> ring-shaped object. <I>~oj en akvo</I>. Band (of cigar); eyelet (<I>koŝo</I>) of rope; halo (of moon); hoop (of barrel). <B>Arb~o</B> (<B>suk~o</B>), age (annual) ring (<I>arbo</I>). <B>Elasta ~o</B>, rubber r. <B>Fum~o</B>, smoke-r. <B>Gas~o</B>, gas-r. <B>Inter~o</B>, <B>Ŝraŭb~o</B>, washer. <B>Kol~o</B> (<I>kolumo</I>), e.g., dog-collar. <B>Kolekta ~o</B>, slip-r. <B>Laĉ~o</B> (<I>okuleto</I>), eyelet. <B>Lagro~o</B>, bearing. <B>Pend~o</B>, r. (on watch). <B>Rad~o</B>, tyre. <B>Ralika ~o</B>, cringle. <B>Rul~o</B>, (gm) hoop. <B>Ŝnura ~o</B>, grummet, sling, strop. <I>Plata</I> <B>ŝtop~o</B>, gasket. <B>~(form)a</B>, annular, circular. <B>~ego</B>, [UV] hoop, etc. <B>~eto</B>, -let, ferrule. <B>~igi</B>, <B>~iĝi</B>, circle, coil, curve. <B>~izi</B>, band, hoop. <B>~ujo</B>, ring case (ring stand). ➞ <I>cirkl, maŝ, rond</I>.", "0"],
["rinkotoj", "rinkot-oj", "Rhyncota f. &gt; aphids, bugs, froth-flies, scale-insects.", "0"],
["rinocero", "rinocer-o", "[UV] (<I>nazkornulo</I>), Rhinoceros (<I>Rhinoceros). ~o nigra</I>, black r. (<I>Diceros</I>).", "0"],
["ripari", "ripar-i", "[OA] Repair, mend, set right again, overhaul (<I>aŭton</I>), renew, recruit (<I>sian forton</I>), retrieve (<I>perdon). ~i fenestron, horloĝon, maŝinon, ŝuon, veston</I>. <B>~(ad)o</B>, repairs. (<B>Ne</B>)<B>~ebla</B>, (ir)reparable. <B>~inda</B>, worth -ing. <I>Ŝip</I><B>~ejo</B> (<I>~doko</I>), dry dock.", "0"],
["ripeti", "ripet-i", "(<I>-n, ke</I>) [UV], repeat, do (make, say) again, duplicate, reiterate, (mus) ~a <I>baso</I>, ground bass, <I>basso ostinato. ~a signo. ~u post mi. Mi ~as, ke</I>. <B>~o</B>, repetition. <I>Prov~o</I>, rehearsal. <B>~aĉi</B>, <B>~adi</B>, be everlastingly harping on the same string. <B>~iĝi</B>, occur again, recur. ➞ <I>refren</I>.", "0"],
["ripo", "rip-o", "[UV] (anat, cul), Rib. <I>Mez~o</I>, mid-r. <I>~o rompita</I>. <B>f</B> rib (of column, ship); spine (of book, etc.), vein (of leaf, insect’s wing). <B>~oj</B>, (umbrella) ribs, frame. <B>~a</B>, costal; (cl) -bed, corded, corduroy. <B>~ego</B>, (mar) web-frame. <B>Inter~a</B>, <B>Sub~a</B>, intercostal, subcostal.", "0"],
["riposti", "ripost-i", "(<I>rebati</I>), <B>1</B> (boxing, fencing), riposte. <B>2</B> counter, give as good as one gets. ~i <I>atakon</I>. <B>f</B> answer back, retort. <B>~o</B>, riposte, counter(stroke), return-thrust.", "0"],
["ripozi", "ripoz-i", "[UV] (nt) (take) Rest, repose, remain inactive, renew one’s strength: <I>La lando ~is</I> (lay fallow). <B>2</B> lie motionless (quiet), sleep: <I>Lia kapo ~is sur la kuseno</I>. <B>f</B> <I>Ĉi tie ~as lia cindro</I>. <B>~(ad)o</B>, r., ease, quietude, respite from work, tranquility. <I>Laboro finita, ~o merita. En ~o</I>, at r. <I>La lasta ~o</I>, the last sleep. <B>~e</B>, -fully, at ease. (<I>En</I>)<B><I>~</I>a</B>, peaceable, peaceful, calm, quiet, undisturbed, untroubled. <B>~ejo</B>, r-ing-place. <B>~iga</B>, restful (<I>okupo</I>), refreshing (<I>dormo</I>). <B>Sen~a</B>, restless, agitated, turbulent, unquiet. <I>Labori sen~e</I>. ➞ <I>dorm, kviet, kuŝ, mallabor, paŭz, rest</I>.", "0"],
["riproĉi", "riproĉ-i", "(<I>iun pri io</I>) [UV], Reproach, Blame; censure, chide, rate, rebuke, reprimand, reprove, take to task, upbraid, (<I>ion al iu</I>): cast in one’s teeth, lay to one’s charge. <I>Ŝi ~is al li la fiaskon</I>. <B>~o</B>, blame, reproach. <I>~o</I> (qualm, twinge) <I>de konscienco</I>. <I>Ne ~u vian amikon: vi mem pli multe meritas ~on</I>. <B>~(oplen)a</B>, -ful, reproving. <B>~inda</B>, faulty, reprehensible, to b., worthy of censure. <I>~indaĵo</I>, demerit, fault. <B>Kontraŭ~i</B>, recriminate. <B>Ne~ebla</B> (<B>~inda</B>), irreproachable, faultless. <B>Sen~a</B>, blameless. <B>Sin~o</B>, self-r., compunction, remorse. ➞ <I>admon, insult, kulp, malaprob, mallaŭd</I>).", "0"],
["riski", "risk-i", "(<I>-n, ke, -i</I>) [UV]: Risk, Venture, chance, hazard. <B>1</B> expose to chance of danger (loss), endanger, jeopardize, put in peril: <I>~i sin, sian monon, vivon</I> (2 Sa 19/5). <B>2</B> attempt (to do something in spite of uncertainty or possibility of failure): <I>Kiu ne ~as, tiu ne gajnas</I>, nothing venture, nothing win. <I>Mi ~os tion fari. Vi ~us fali</I>, you might fall. <I>~ante fali</I>, at the risk of falling. <B>~o</B>, risk venture, chance, danger, hazard. <I>Militaj ~oj</I>, war rr. <B>~(em)a</B>, r-y, v-some, bold, daring, hazardous, <B>f</B> \"close to the wind\". <I>Ne~ema</I>, cautious, prudent, not taking rr. <B>Tro~ema</B>, foolhardy, headstrong, rash, reckless. <I>~emulo</I>, dare-devil. <B>Sen~a</B>, without r., safe, sure. <I>Vi povas iri ~~e</I>. <B>Ĉiu~e</B>, at any cost. <I>Poliso ~~a</I>, all-in policy. ➞ <I>danger, kuraĝ, sane</I>.", "0"],
["rismo", "rism-o", "[OA] ream (of paper). <I>Angla ~o,</I> 480 sheets. <I>Presista ~o</I>, 516 sheets.", "0"],
["risolo", "", "(<I>fritbulo</I>), rissole.", "0"],
["risorto", "risort-o", "[UV] (mec) Spring. <I>~o cilindra, fleksa, folia, plata, konusa, spirala, tavola, torda. ~o de aŭto, horloĝo, lito. Co~o</I>, C-s. <B>~a</B> <I>matraco</I>, spring mattress. <B>~aro</B>, suspension (of vehicle), <B>~eca</B>, <B>~osimila</B>, -y, elastic, rebounding, resilient. ➞ <I>elast, salt</I>.", "0"],
["ritmo", "ritm-o", "[OA] (mus, pros) Rhythm. <B>~a</B>, -ic(al), measured, <I>~a bruo, lumo</I>, <B>~e</B> <I>paŝi</I>. <B>Sen~a</B>, un-ical. <B>~onomoj</B>, (mus) time-names, e.g., <I>tafatefe</I>. ➞ <I>takt</I>.", "0"],
["rito", "rit-o", "[UV] Rit/e, ceremony, ordinance, observance. <I>~oj de la Pasko</I> (No 9/12, 14). <B>~aro</B>, ceremonial, rites, ritual, <I>~aro framasona</I>. <B>~ismo</B>, <B>~isto</B>, ritual-ism, -ist.", "0"],
["rivalo", "rival-o", "(<I>konkuranto</I>), Rival. <B>~i</B>, r. compete, vie. <B>~eco</B>, -ry. <B>Sen~a</B>, un-led, peerless, <B>Super~i</B>, cut out.", "0"],
["riveli", "rivel-i", "(<I>malkaŝi</I>), <B>1</B> Reveal, disclose, let out (<I>fakton, sekreton</I>). <B>2</B> (rel) (a. <I>revelacii</I>), r. <I>~ita vero</I>, divinely r-ed truth. <B>3</B> (phot) Develope. <B>~ilo</B>, developer. <B>~ado</B>, <B>~aĵo</B>, revelation, disclosure. <B>~iĝi</B>, be r-ed, d-ed, brought to light. ➞ <I>apokalips</I>.", "0"],
["riverenci", "riverenc-i", "[UV] Bow, Curtsey, do reverence (make obeisance), salaam, salute, <B>~o</B>, b., c. <B>~adi</B>, bow and scrape, kow-tow. ➞ <I>kapoklin, respekteg, rever</I>.", "0"],
["rivero", "river-o", "[UV] River, Stream, <B>f</B> flood, flow. <I>~o da larmoj (sango), de vivo</I> (course of life). <B>~ego</B>, mighty river. <B>~eto</B>, brook, burn, rill, rivulet, streamlet. <I>~etoj fluas al ~oj</I>. <B>~ujo</B>, r-bed. ➞ <I>kanal, torent</I>.", "0"],
["rivolui", "rivolu-i", "Revol/ve, <B>~o</B>, -ution (<I>de rado</I>). ➞ <I>rondir, rotaci</I>.", "0"],
["rizo", "riz-o", "[UV] Rice (<I>Oryza</I>). <B>~eroj</B> (<I>~ogrenoj</I>), grains of r. <B>~(plant)ejo</B>, r-plantation. <B>~kampo</B>, rice-field, paddy-field.", "0"],
["rizomo", "rizom-o", "(<I>subtera tigo</I>), (bot) rhizome, rootstock.", "0"],
["Ro", "R-o", "[F], letter R.", "0"],
["robinio", "robini-o", "false acacia, black locust (<I>Robinia pseudoakacia</I>). ➞ <I>karob</I>.", "0"],
["robo", "rob-o", "[OA] Robe, Gown, vestment, long loose outer garment worn by (a) clergy, lawyers, orientals, professors, (b) women and children: dress, frock. <B>Beba ~o</B>, long clothes. <B>Ĉambra</B>, <B>negliĝa ~o</B>, dressing-gown, wrapper. <B>Dekolta ~o</B>, low-necked dress. <B>Nokta</B>, <B>vespera</B> <B>~o</B>, evening dress. <B>~ularo</B>, legal profession. <B>Sen~igi</B>, <B>sen~iĝi</B>, disrobe. <B>Sub-o</B>, undergarment, (woman’s) slip. <I>Sub~o nilona</I>. ➞ <I>sutan, talar</I>.", "0"],
["roboto", "robot-o", "robot. <B>1</B> man-like automaton, <B>f</B> machine-like person. <B>2</B> automatic traffic- signal.", "0"],
["robro", "robr-o", "(cgm) rubber,", "0"],
["rocelo", "rocel-o", "dyer’s moss (<I>Roccella). ~a tinkturaĵo</I>, orchil. ➞ <I>lakmus</I>.", "0"],
["rodi", "rod-i", "(<I>mordeti</I>), gnaw, nibble. <I>~i oston,</I> pick a bone. <I>Ratoj ~is la lignon</I>. <B>f</B> <I>~ita de zorgoj</I>, careworn, <I>~i la koron</I>, eat one’s heart out, prey on one’s mind, <B>f</B> <I>Acido, rusto ~is la feron</I>. (mot) <B>~ata</B>, \"running-in\". <B>~ulo</B>, rodent. ➞ <I>erod, korod</I>.", "0"],
["rodio", "rodi-o", "(chem) rhodium (Rh).", "0"],
["rodo", "rod-o", "[UV] (mar) anchorage, road(stead). <B>El~iĝi</B>, be driven out to sea.", "0"],
["rododendro", "rododendr-o", "Rhododendron. Many species and hybrids: some are called <I>Azealeas</I>. The aa. are mostly deciduous, with 5 stamens: the rr. have 10 stamens.", "0"],
["rojalismo", "rojalism-o", "[OA] <B>rojalist-o</B>, [OA] royalism, royalist.", "0"],
["roko", "rok-o", "[OA] Rock, boulder, crag. <I>La ~o de Gibraltaro. Firma kiel ~o. Korbela ~o</I>, overhang. <I>Balanc(-iĝema) ~o,</I> logan(stone), r<B> ing</B> stone, <B>f</B> defence, protection, refuge, support (Ps 18/31). <I>Konstrui sur ~o (fortike</I>). <B>~(oplen)a</B>, flinty, pebbly, stony, rocky. <B>~aĵo</B>, <B>~aro</B>, <B>~ejo</B>, -ery, -garden, -work. <B>~eca</B>, rugged (style). ➞ <I>ŝtoneg</I>.", "0"],
["rokoko", "rokok-o", "[OA] (arch) rococo (highly ornamented decoration).", "0"],
["rokuo", "roku-o", "annatto. <B>~arbo</B> (a. <I>bikso) (Bixa</I>).", "0"],
["rolo", "rol-o", "[OA] Rˆle, Part. <B>1</B> (th) <I>~o grava, serioza</I>, prominent (heavy) part. <I>Asigno, distribuo de ~oj</I>, casting. <B>2</B> p., function, task. <I>Ludi ~on duagradan,</I> play second fiddle. <I>Ne estas mia ~o</I> (It is not my business) <I>tion fari. Ludi la ~on (Ludi kiel) Macbeth</I>, play (the p. of) M. <B>~ulo</B>, character, personage. <B>ĉef~ulo</B>, hero. ➞ <I>ofic, part, profesi, task</I>.", "0"],
["romanco", "romanc-o", "[OA] (mus) Romance, drawing- room ballad, sentimental song or song-like composition. <I>~o senvorta</I>, song without words. <I>Kanti ~on</I>. <B>~isto</B>, ballad writter, songwriter. ➞ <I>balad, kanzon, roman(tik</I>).", "0"],
["romano", "roman-o", "[OA] Novel, Roman/ce, lengthy tale (work of fiction). <I>~o detektiva</I>. <B>~a</B> <I>heroo</I>, hero of r. <I>Rakonto tute</I> <B>~eca</B>, -tic, quite (like) a r. <B>~(verk)isto</B>, novelist. ➞ <I>novel, romanc, romantik, sentimental</I>. II (ecc) (= r.c.) <B>~a</B>, <B>~isto</B>, Roman-(ist).", "0"],
["romantika", "romantik-a", "[OA] Romantic, dreamy, imaginative, picturesque, suggestive of fancy and romance. <B>~ismo</B>, <B>~isto</B>, -ism, -ist.", "0"],
["rombo", "romb-o", "[OA] <B>1</B> (geom) Rhomb/us. <B>~a</B>, -ic. <B>~ojdo</B>, -oid. ➞ <I>lozanĝ</I>. <B>2</B> (ich) <B>~(fiŝ)o</B> (<I>Rhombus</I>), turbot (<I>R. maximus</I>). <B>~eto</B>, brill (<I>R. laevis</I>).", "0"],
["rompi", "romp-i", "(<I>-n</I>), [UV] Break. <B>1</B> (objekton): <I>~i glacion, katenon, kolon, kruron, vazon</I>. crack (<I>nukson</I>); crush (<I>ŝtonojn</I>); fracture (<I>oston</I>); shatter (<I>vitron</I>); snap (<I>branĉeton</I>), <B>f</B> ~i <I>falon, koron, leĝon, promeson, sian vorton</I>. <B>2</B> b. off, cut short, interrupt: <I>~i atenton, cirkviton, fianciĝon, pacon, silenton, tradicion</I>. <I>Voĉo</I> <B>~ita</B> <I>de emocio. Fari ~on (~i rilatojn) kun iu</I>. <B>3</B> b. down: <I>~i indiferenton, kontraŭstaron, rekordon, reziston</I>. ~i <I>la murojn inter la popoloj</I>. <B>~(ad)o</B>, breach, disruption, fracture. <B>~(it)aĵo</B>, bit, fragment, stub, <B>Ŝton~aĵo</B>, rubble. Facile <B>~ebla</B>, brittle, fragile. <B>Ne~ebla</B>, unbreakable. <B>~iĝi</B>, break up, come apart, get broken. <I>Kie maldike, tie ~iĝas</I>, <B>~iĝo</B>, b. (in voice). <B>Glaci~iĝo</B>, b-up of ice. <B>Ŝip~iĝo</B>, wreck. <B>~ilo</B>, (el) contactbreaker, interruptor. <B>Nuks~ilo</B>, nutcrackers. <B>Ond~ilo</B>, breakwater, mole. <B>Serur~ilo</B>, picklock. <B>Ston~ilo</B>, stone-crusher. <B>~ita</B>, broken, in abeyance, suspended, (mus) <I>~itaj akordoj, oktoj, broken chords (octaves). (orn</I>) <B>Nuks~</B><I><B>ulo</B></I> (<I>nucifrago</I>), <I>nutcracker. <B>De~i</B>, b. away (from, off). <B>Dis~i</B>, b. up, smash</I>. <B>~~aĵo</B>, <I>debris, wreckage. <B>En~i</B>, b. (beat, stave) in, invade, inrupt. <B>~~</B></I><B>isto</B>, <I>burglar</I>. <B>Akrobata ~~isto</B>, <I>cat-burglar. <B>Inter~i</B>, b. into, interrupt</I>. <I>parolanton</I>.<I> <B>Sen~a</B>, continuous, uninterrupted. <B>Tra~i</B>, b. through, pierce, (mil) <B>~~o</B>, break-through. <B>Glaci~anto</B></I> (<B>~a ŝipo</B>), <I>ice-breaker. <B>Kap~a</B>, b-neck, head-splitting, insoluble, maddening. <B>Kor~a</B>, heart-breaking. <B>Strik~anto</B>, strikebreaker. ➞ detru, fend, frakas, krevig, ruinig</I>.", "0"],
["rondelo", "rondel-o", "(lit) rondeau, rondel, (mus) rondo. <I>~a</I> formo, rondo form (ABACADA).", "0"],
["rondo", "rond-o", "[UV] Round. <B>1</B> (more or less regular): Circle, ring. <B>Danc~o</B>. <B>Fe~o</B>. <B>Duon~o</B>, semi-c. (el) <B>Flu~o</B>, circuit. <B>Sorĉ~o</B>, magic c. <B>Vers~o</B>, rondeau. <B>2 ~oj</B>, (<I>~iro, ~vizitado</I>), beat, round(s): e.g., of doctor, milkman. <B>3</B> social c. (environment, sphere, surroundings): <I>~o hejma, intima, ~o de konatoj. Teatra ~o</I>, world of the theatre. <I>~oj oficialaj</I>. <B>4</B> (<I>~a peco</I>): fillet (<I>fiŝa</I>), pat (<I>butera</I>). slice (<I>pana</I>). <B>5</B> (mus) (<I>~a noto</I>), semibreve. <B>~(form)a</B>, round. <I>~a danco</I>, r. dce. <I>En ~aj ciferoj</I>, in r. figures. <I>~a kanto</I>, round(elay). <I>~a placo,</I> \"circus\". <I>~a valo</I>, \"punch-bowl\". <B>~aĵo</B>, r-ed form, e.g., <I>gluteo, mamo, vango</I>. <B>~eco</B>, rotundity. <B>~igi</B>, make r. <I>La kato sin ~igis</I> (curled up) <I>antaŭ la fajro</I>. <B>f</B> smooth, tone down. <B>~eto</B>, small c. <B>~iri</B>, go r., circulate, patrol, revolve. <I>~iro</I>, (sp) lap. <I>~iranto (~ira gazeto</I>), evercirculator. ➞ <I>cirkl, cirkul, ĉirkaŭ, ring, rondel</I>.", "0"],
["ronĝi", "ronĝ-i", "= rodi.", "0"],
["ronki", "ronk-i", "[UV] Snor/e. <I>Ne ~u!</I> <B>f</B> make a similar sound, boom (<I>organo</I>); grunt (<I>porko</I>); roar (<I>fajro</I>); snort (<I>ĉevalo</I>). <B>~(ad)o</B>, -ing. <B>~anto</B>, -er. ➞ <I>stertor</I>.", "0"],
["ronroni", "ronron-i", "purr (as cat); (mec) hum, whirr. ➞ <I>zum</I>.", "0"],
["rorkvalo", "rorkval-o", "(a. <I>balenoptero</I>), Rorqual, finback, razorback whale.", "0"],
["rosino", "rosin-o", "(<I>sekvinbero</I>), raisin. <B>~o deserta</B>, muscatel. <B>~eto</B>, sultana. ➞ <I>korint</I>.", "0"],
["rosmareno", "rosmaren-o", "[UV] Rosemary (Rosmarinus). ~o por memoro (H 130/16). <B>~a</B> <I>oleo</I>.", "0"],
["rosmaro", "rosmar-o", "[UV] walrus, sea-cow, sea-horse (<I>Odobenus rosmarus</I>) (1 FA 117/17).", "0"],
["roso", "ros-o", "[UV] Dew. <B>~</B>as (~o falas), <I>d. is falling</I>. <B>~o</B> <I>glaciiĝinta (prujno</I>), rime, <B>f</B> La ~o (<I>larmo</I>) en ŝiaj okuloj (<I>K 167/34</I>). <B>Miel~o</B>, honey-d. <B>~(kovrit)a</B>, -y. <B>~ero</B>, <B>~guto</B>, d-drop.", "0"],
["rosti", "rost-i", "(<I>-n</I>), [UV] Roast, broil, grill. <I>~i kafon, viandon. ~ita bovaĵo. ~itaj kaŝtanoj. ~ita pano (toasto</I>), toast, <B>f</B> <I>Tero ~ita</I> (baked, dried up, parched, scorched) <I>de la suno</I>. <B>~aĵo</B>, r. <B>~ejo</B>, grill-room. <B>~eti</B>, brown, scorch (toast). <B>~iĝi</B>, be -ed. <B>~ilo</B>, oven, cooker. <B>Krad~ilo</B>, (<I>~krado</I>), gridiron, grill. <B>Pan~ilo</B>, toaster, t ing fork. <B>Turn~ilo</B>, spit. <B>Sub~i</B>, brown, scorch, singe. ➞ <I>bak, frit, kalcin</I>.", "0"],
["rostro", "rostr-o", "[UV] <B>1</B> trunk, proboscis, snout (<I>~o de elefanto, porko</I>), sucker (<I>de insekto</I>). <B>2</B> (bot) stigma. <B>3</B> ram (<I>de ŝipo</I>). ➞ <I>bek</I>.", "0"],
["rotacii", "rotaci-i", "(mec) Rotat/e, revolve round axis. ~i <I>sur pivoto. Ĉiu planedo ~as</I>. <B>~o</B>, -ion. (type) <B>~a</B> (rotary) <I>presmaŝino (pumpilo</I>). <I>~a plato, (</I>gramophone<I>) turntable</I>. ➞ <I>rivolu, ruliĝ, turniĝ</I>.", "0"],
["rotango", "rotang-o", "rattan. <B>1</B> name of various palms (<I>Calamus rotang</I>). <B>2</B> <I>~a kano</I>.", "0"],
["rotario", "rotari-o", "(soc) Rotary. <I>~a klubo</I>.", "0"],
["rotiferoj", "rotifer-oj", "rotifers, wheel-animalcules (<I>Rotifera</I>).", "0"],
["roto", "rot-o", "[UV] company, detachment, gang, squad. ➞ <I>band, kompani, trup</I>.", "0"],
["rotondo", "rotond-o", "[OA] rotunda, circular hall,", "0"],
["rotoro", "rotor-o", "rotor.", "0"],
["rovero", "rover-o", "(sctg) venturer scout (16-19-<I>jara</I>). <B>~ino</B>, ranger.", "0"],
["rozario", "rozari-o", "[UV] Rosary, string of prayer- beads. <B>~ero</B>, bead of r. <I>Trapreĝi la ~on,</I> say a rosary.", "0"],
["rozeolo", "rozeol-o", "roseola, rose-rash. <I>~o epidemia (rubeolo</I>), German measles,", "0"],
["rozo", "roz-o", "[UV] Rose. <B>1</B> (bot) (<I>Rosa</I>). Many species and hybrids. <B>~o centfolia</B> (<I>centifolio</I>), cabbage or Provence r. (<I>R. centifolia</I>). <B>Hunda ~o</B>, brier, dog or hedge rose (<I>R. canina</I>). <B>~o kampa</B>, field (trailg) r. (<I>R. arvensis</I>). <B>Sovaĝa ~o</B> (<I>eglanterio</I>), wild r., sweet brier (<I>R. eglanteria</I>). <B>Vila ~o</B>, downy r. (<I>R. villosa</I>). <B>2</B> (obj): <B>Kompasa ~o</B>, compass r. <B>Ŝpruc~o</B>, r. of watering-can. <B>~(kolor)a</B>, pink, flushed, -y. <I>~a lipo, rubando, vango</I>. <B>f</B> auspicious, hopeful. <I>~a perspektivo. Vidi ĉion</I> <B>~kolore</B>. <B>~acoj</B>, r-fam.. <B>~ejo</B>, <B>~ĝardeno</B>. <B>~eto</B> (<I>kokardeto</I>), <B>-ette. ~eta (pal~a), pinkish, ~arbeto, r-bush</B>.", "0"],
["ruana", "ruan-a", "roan (horse).", "0"],
["Ruando", "Ruand-o", "RW.", "0"],
["rubando", "ruband-o", "[UV] Ribbon, Band, long narrow strip (for binding, clothing, dressing wounds, wrapping). <B>Ĉapel~o</B>, hat-b. <B>Eĝ~o</B>, braid edging, gimp, piping. <B>Flag~o</B>, penn-ant-on, streamer. <B>Ink~o</B> (<I>por tajpilo</I>). <B>Izol~o</B>, insulating tape. <B>Mezur~o</B>, tape measure. <B>Ŝtal~o</B>, steel b. <B>Ŝultra ~o</B>, shoulder-knot, shoulder-strap. <B>~a</B> (<I>laŭŝosea) domkonstruo</I>, r. development. <B>~eto</B>, tape. ➞ <I>galon, laĉ, orden, pasament, rimen, stri</I>.", "0"],
["rubekolo", "rubekol-o", "(<I>ruĝgorĝo</I>), robin (redbreast), ruddock (<I>Erithacus rubecula</I>).", "0"],
["rubeno", "ruben-o", "[UV] (min) Ruby. <B>~(ruĝ)a</B>, r-red. ➞ <B><I>grenat, korund</I></B>.", "0"],
["rubeolo", "rubeol-o", "German measles.", "0"],
["rubidio", "rubidi-o", "(chem) rubidium (Rb).", "0"],
["rubio", "rubi-o", "(bot) Madder (Rubia tinctoria). <B>~a</B> <I>flavoruĝo), m. yellow (Turkey red</I>).", "0"],
["rublo", "rubl-o", "[OA] rouble.", "0"],
["rubo", "rub-o", "[UV] <B>1</B> (<I>forĵetindaĵo, senvaloraĵo</I>), Rubbish, junk, litter, refuse, sweepings, trash, waste. <B>2</B> debris, ruins, rubbish. (Ne 4/2, 10). <B>~ejo</B>, dump( ing ground) (<I>dumpejo</I>), r-heap. <B>~ujo</B>, dust-bin, r-bin. <B>Sen~igi</B>, clear away r. <B>Fer~o</B>, old (scrap) iron. ➞ <I>dump</I>.", "0"],
["rubriko", "rubrik-o", "[UV] (ecc, typ) rubric, column, heading, section. <I>Presi en aparta ~o. La ~o \"Respondoj\"</I>. ➞ <I>fak, sekci</I>.", "0"],
["rubuso", "rubus-o", "(Rubus), &gt; blackberry (<I>R. fruticosus</I>); cloudberry (<I>R. chamaemorus</I>); dewberry (<I>R. caesius</I>). <B>~arbusto</B>, <B>~ujo</B>, bramble. ➞ <I>framb, logan</I>.", "0"],
["rudimento", "rudiment-o", "Rudiment: element, first principle, <B>f</B> imperfect begining, germ, root, seed. <B>~a</B>, -ary, -al, undeveloped. ➞ <B><I>element, komenc</I></B>.", "0"],
["rudro", "rudr-o", "(mar) Rudder. <I>~o horizonta, vertikala</I>. <B>~oĉenoj</B>, r-chains. <B>~astango</B>, helm, tiller.", "0"],
["rufa", "ruf-a", "(<I>flavruĝa, arde flava</I>), rufous, ginger, reddish brown, rusty. ➞ <I>bel</I>.", "0"],
["ruf~o", "", "(mar) deckhouse,", "0"],
["ruga", "rug-a", "(bot) (zoo) rugose, corrugated, wrinkled. <B>~i</B>, (<I>dense sulketiĝi</I>).", "0"],
["rugbeo", "rugbe-o", "(sp) Rugby (football).", "0"],
["ruĝa", "ruĝ-a", "[UV] Red. <I>~a flanko</I>, port (side), <I>~a de honto, sano, kiel peonio</I>. Brik~a, sang~a, vin~a. <B>Brul~a</B>, r-hot. <B>Fajre ~a</B>, fiery r. <B>Flav~a</B>, russet, carroty (hair). <B>Sango~a</B> (Jes 1/18). <B>Trans~a</B>, <B>ultra~a</B>, infra-r. <B>~o</B>, r. <I>~o Hinda (feroksida</I>), Indian r. <B>f</B> <I>Vidi</I> <B>~e</B>, see r. <B>~en!</B> Port! <B>~aĵo</B>, red spot. <B>~igi</B>, [UV] blush, flush. <B>~ulo</B> (<I>~haŭtulo</I>), redskin, (pol) red. <B>~hara</B>, <B>~naza</B>. <B>~gorĝ(ul)o</B> (<I>rubekolo</I>). <B>~vostulo</B> (<I>fenikuro</I>).", "0"],
["rui", "ru-i", "(tex) ret, steep (flax, etc.).", "0"],
["ruino(j)", "ruin-o(j)", "[UV] (<B>~aĵo</B>), Ruin(s). <B>1</B> remains, wreckage. <I>~oj de Pompei. Ŝip~o</I>, wreck. <B>2</B> (<I>disfalo, pereo</I>), decay, desolation, destruction, (down)fall, overthrow, undoing. <I>~o de idealo, imperio</I>. <B>~a</B>, -ed, in ruins, crumbling, delapidated, tumble-down. <I>~a kastelo</I>. <B>~ego</B>, collapse. <B>~igi</B>, [UV] ruin, bring (reduce) to r. (<I>malriĉigi): Lia malŝparo min ~igis</I>. <B>~iga</B>, ruinous, destructive, disastrous. <B>~iĝi</B>, be -ed, break down (in health), fall into decay (ruins). <I>~iĝo</I>, -ation. ➞ <I>bankrot, detru, kaduk, senhavig, subfos</I>.", "0"],
["rukti", "rukt-i", "[UV] belch, eructate, bring up wind.", "0"],
["rukuli", "rukul-i", "= kveri, coo as a pigeon.", "0"],
["rulado", "rulad-o", "(mus) run, rapid scale passage, vocal flourish.", "0"],
["ruledo", "ruled-o", "(<I>rultranĉilo</I>), roulette, revolving toothed wheel, pricking (tracing) wheel. <I>~o punkta, segildenta</I>. <B>~i</B>, ~ita. ➞ <I>perfor, truet</I>.", "0"],
["ruleto", "rulet-o", "(gm) roulette.", "0"],
["ruli", "rul-i", "(<I>-n</I>), [UV] (cause to) Roll. <B>1</B> r. along, bowl, trundle: <I>~i barelon, globon</I>. <B>2</B> (<I>platigi</I>): r. out, flatten. <I>~i oron, paston, razenon</I>. <B>3</B> (a. <I>~umi</I>), roll up, furl, turn over and over: <I>~i cigaredon, ombrelon, velon</I>. <B>4</B> rotate: <I>~i la okulojn</I>. <B>5</B> make trilling, undulating, vibrating sound: <I>~ado</I>, roll, peal. <I>~ado de tamburo, tondro</I>. <B>~o</B>, [UV] (wide sense) -er, cylinder, drum, platen. Ink~(razen~tuk~)o, ink-(garden-towel -)er. <B>Past~o</B>, <B> ing</B> pin. Ŝosea steam -er. <B>~(aĵ)o</B>, r., spool. <I>~o higiena</I>, toilet r. <I>Tabak~aĵo</I>, twist of tobacco. <I>~aĵo papera, muzika</I>. <B>~iĝi</B>, (nt), <B>1</B> roll along, advance, drive, run: <I>La aŭto, barelo, ondo, pilko,vojaĝanto ~iĝas</I>. <B>2</B> roll over and over: <I>La ĉevalo, hundo ~iĝis sur la greso. Li falis kaj ~iĝadis (~falis</I>), <B>f</B> wallow: <I>~i en lukso, mono</I>. <B>3</B> roll from side to side, reel, sway: <I>La ebriulo, ŝipo ~iĝis. ~iĝo</I>, <B> ing</B> (of ship). <I>~iĝanta ŝtono</I>, <B> ing</B> stone. <I>~iĝaĵo</I>, <B> ing</B> stock. <B>~ilo</B>, castor, trolley wheel. <B>~ujo</B>, (mec) bearing. <B>De~i</B> (Mk 16/3, 4). <B>For~i</B>, r. away. <I>La nebulo rapide for~iĝis</I>. <B>Kun~i</B>, r. (wrap) up. <I>~~i mapon, dokumentojn</I>. ➞ <I>boben, bulk, sket, turn, volv</I>.", "0"],
["Rumanujo, Rumanio", "Ruman-ujo, Rumanio", "[OA-8] RO.", "0"],
["rumbo", "rumb-o", "(dance) rumba.", "0"],
["rumo", "rum-o", "[UV] (bev) rum.", "0"],
["runo", "run-o", "Run/e, letter of ancient Scandinavian alphabet. <B>~a</B>, -ic. <I>~a ŝtono</I>.", "0"],
["rupio", "rupi-o", "(num) rupee.", "0"],
["rupio", "rupi-o", "(bot) tassel pondweed (<I>Ruppia</I>).", "0"],
["rusko", "rusk-o", "(bot) butcher’s broom (<I>Ruscus</I>).", "0"],
["rusolo", "rusol-o", "russula fungus (<I>Russula</I>). <B>~o vomiga</B>, the sickener (<I>R. emetiea</I>).", "0"],
["rustika", "rustik-a", "rustic, rural, <B>f</B> unpolished. <B>~a</B> <I>danco</I>, country dance. <B>~eco</B>, -ity.", "0"],
["rusto", "rust-o", "[UV] (<I>fera oksido</I>), Rust, red iron oxide. <I>Sxlosilo uzata ~on ne kolektas</I>. (bot) rust, (<I>plant disease</I>). <B>Gren~o</B>, corn rust. <B>~a</B>, rusty, -ed. (bot) blighted. <B>~iĝi</B>, r., be (get) -y, oxidize, <B>f</B> <I>Mia Esperanto ~iĝas</I>. <B>~kolora</B>, r-colored. <B>Sen~igi</B>, polish up, remove rust.", "0"],
["Rusujo, Rusio", "Rus-ujo, Rusio", "[F] RU.", "0"],
["ruŝo", "ruŝ-o", "ruche, frill, ruffle (of gauze, lace, etc.).", "0"],
["rutelo", "rutel-o", "(ich) roach (<I>Rutilus</I>).", "0"],
["rutenio", "ruteni-o", "(chem) ruthenium (Ru).", "0"],
["rutilo", "rutil-o", "(min) rutil.", "0"],
["rutino", "rutin-o", "[OA] Routine, customary round, groove, regular procedure, unvarying performance. <B>~a</B>, of r., groovy, stick-in-the-mud. <I>~a laboro</I>, donkey-work. <I>La ~aj ideoj de la amaso</I>. <B>~e</B>, by rule of thumb, by rote, out of sheer habit. <I>Oficeja</I> <B>~aĉo</B>, red tape. <B>~ema</B>, addicted to r., hidebound. <B>~ulo</B>, slave to r. ➞ <I>gurd, stereotip</I>.", "0"],
["ruto", "rut-o", "[OA] rue (Ruta graveolens). ➞ <I>aspleni</I>.", "0"],
["ruzo", "ruz-o", "[UV] (<I>~aĵo</I>), Cunning, Dodg/e, Trick; artifice, guile, ruse, stratagem, wile. <I>~o milita</I>. <B>~a</B>, c., tricky, artful, astute, crafty, deep, knowing, shrewd, sly, wily. <B>~i</B>, (nt) (<I>esti ~a</I>), deal subtly, dodge, shuffle, use cunning. (Mal 3/8). <B>~aĉa</B>, foxy. <B>~eco</B>, astuteness, craft, finesse, subtlety. <B>~ema</B>, c. <B>~ulo</B>, artful d-er. <B>Sen~a</B>, artless, ingenuous, simple, unsophisticated. <B>Super~i</B>, dupe, outwit, overreach. ➞ <I>artifik, subtil, tromp</I>.", "0"],
["sabadilo", "sabadil-o", "Sabadilla (<I>Meksika liliaco</I>) (<I>Schoenocaulon</I>).", "0"],
["sabato", "sabat-o", "[UV] <B>1</B> Saturday. <B>2</B> Sabbat/h, day of rest = (Jewish) Saturday, (Christian) Sunday. <I>Festi, Observi</I> (keep) <I>la ~on. Profani</I> (break) <I>la ~on</I>. <B>~a</B> <I>jaro</I>, -ical year. <B>~ismo</B>, <B>~isto</B>, sabbatarianism, -atarian.", "0"],
["sabeliko", "sabelik-o", "(<I>Savoja brasiko</I>), Savoy cabbage. ➞ <I>brasik</I>.", "0"],
["sabelo", "sabel-o", "(zoo) peacock worm (<I>Sabella</I>).", "0"],
["sabino", "sabin-o", "(bot) savin(e) (<I>Juniperus sabina</I>).", "0"],
["sablo", "sabl-o", "[UV] Sand, Grit. <I>Ludi sur la ~o. Konstrui sur ~o (malfortike</I>). f <I>Jxeti ~on en la okulojn (blindigi). Flu~o</I>, running s. <B>~a</B>, of s. <I>~a bordo</I>, the sands, sandy beach. <I>~a monteto (duno</I>), s-hill. <B>~(oŝut)i</B>, (cover with) s. <I>~ita vojo</I>. <B>~aĵo</B>, [UV] s-bank(-bar). <I>Suĉa ~aĵo (~o moviĝanta</I>), quick-s. <B>~ejo</B>, s-(gravel-)pit. <B>~ero</B>, [UV] grain of sand, bit of grit. <B>~eto</B>, fine s. <B>~oza</B>, <B>~okovrita</B>, <B>~oplena</B>, sandy, g-y. <B>~ujo</B>, s-box. <B>~obstrukci</B>, silt up. <B>~okolora</B>, s-y. <B>~oŝtormo</B>, s-storm. ➞ <I>gruz</I>.", "0"],
["saboti", "sabot-i", "(<I>-n</I>), ~(aĵ)o, sabotage.", "0"],
["sabro", "sabr-o", "[OA] Sabre, sword with curved blade. <B>~(obat)i</B>, s. <B>~ingo</B>.", "0"],
["sacerdoto", "sacerdot-o", "[OA] (rc) Priest. <B>~a</B>, -ly, sacerdotal, <B>~ado</B>, <B>~eco</B>, -hood. <B>~ismo</B>, sacerdotalism.", "0"],
["sadismo", "sad-ism-o", "<B>~isto</B>, sad-ism, -ist.", "0"],
["sadukeo", "saduke-o", "sadducee.", "0"],
["safiro", "safir-o", "[UV] Sapphir/e, blue crystalline corundum. <B>~a</B>, -ine.", "0"],
["safrano", "safran-o", "[UV] Saffron crocus (<I>Crocus sativus</I>). <B>2</B> dye from this. <B>~kolora</B>, s., orange yellow.", "0"],
["sagaca", "sagac-a", "[UV] Sagac/ious, long-headed, sharp (subtle) in spirit, shrewd; (of animal) intelligent. <B>~(ec)o</B>, -ity, acumen, discernment, perspicacity. <B>~e</B>, shrewdly. ➞ <I>inteligent, penetr, saĝ, spirit, subtil</I>.", "0"],
["sagao", "saga-o", "(lit) saga, long chronicle.", "0"],
["sagino", "sagin-o", "(bot) pearl wort (<I>Sagina</I>).", "0"],
["sagitario", "sagitari-o", "(bot) arrow-head (<I>Sagitaria</I>).", "0"],
["sago", "sag-o", "[UV] Arrow, bolt, shaft (from bow), <B>f</B> <I>~oj de satiro, sorto</I>. <B>~eto</B>, dart. <B>~ujo</B>, quiver. <B>~forma</B>, a-headed. <B>Ĵet~o</B>, (gm) darts. <B>~(paf)isto</B>, archer, (astr) Saggitarius. <B>~pinto</B>, a-head. <B>~signo</B>, (typ) a-head. ➞ <I>ark</I>.", "0"],
["saguo", "sagu-o", "[OA] Sago. <B>~arbo</B>, s-palm.", "0"],
["saĝa", "saĝ-a", "[OA] Wise. <B>1</B> knowing, learned, sage, skilled. <B>2</B> circumspect, discreet, judicious, prudent, sensible. <I>~a decido, vorto. Agi</I> ~e. <B>~(ec)o</B> (Se 8/1, 14/8), good sense, prudence. <I>Homa ~o,</I> human wisdom. <I>Perdi la ~on</I>, lose one’s wits. <I>Streĉi la ~on</I>, rack one’s brains. <I>~o abunda, sed ne profunda</I>. <B>~igi</B> <B>~(iĝi)</B>, make (become) w. <B>~ulo</B>, w. person, sage. <B>~ulaĉo</B>, w-acre. <B>~umi</B>, affect wisdom, cavil, quibble, raise captious objj., split hairs. <B>~umado</B>, casuistry, ratiocinate, sophistry (Rj 129/23). <B>Mal~a</B>, unwise, absurd, daft, foolish, imbecile, stupid. <I>~~a kiel ŝtipo</I>. <B>~~aĵo</B>, folly, nonsense, silliness, stupidity. <B>~~ulo</B>, ass, blockhead, dolt, fool, idiot, imbecile. ➞ <I>idiot, sensaĝul, stultul</I>. <B>Ne~a</B>, unwise, imprudent. <B>Sen~a</B>, silly, vacuous, witless. <B>~~ulo</B>, simpleton. <B>Duon~a</B>, half-witted. ➞ <I>inteligent, prudent, sagac</I>.", "0"],
["sajmirio", "sajmiri-o", "squirrel monkey (<I>Saimiri</I>).", "0"],
["sakarino", "sakarin-o", "saccharin.", "0"],
["sakeo", "sake-o", "sake (<I>rizbrando</I>).", "0"],
["sako", "sak-o", "[UV] (large) Bag, Sack, pouch. ~o <I>almozula. Vortoj ~on ne plenigas</I>. <B>f</B> purse, <I>Kiam ~o mizeras, amo malaperas</I>. <B>Dors~o</B> (<I>tornistro</I>), knapsack, rucksack. <B>Fel~o</B>, (Bb) bottle, wineskin (Ps 56/8, 119/83). <B>Vent~o</B>, wind-cone. Dorm~o, man~o, mon~o, poŝt~o, sablo~o, sel~o, sleeping-, hand-, money-, mail-, sand-, saddle-bag. <B>~aĵo</B>, s-ing, s-cloth (Ge 37/34). <B>~eto</B>, satchel, wallet. <I>Ret~eto,</I> reticule. <B>~forma</B>, baggy, loose. <B>En~igi</B> (<I>-n</I>), b. <B>Plen~o</B> (<I>da</I>), sackful. ➞ <I>kas, poŝ, ŝalm</I>.", "0"],
["sakramento", "sakrament-o", "[OA] sacrament. <B>~a</B>, -al.", "0"],
["sakri", "sakr-i", "(<I>blasfemeti</I>), use bad language (mild expletives).", "0"],
["sakrilegio", "sakrilegi-o", "sacrileg/e. <B>~a</B>, -ous. <B>~i</B>, (nt) (<I>fari ~on</I>). ➞ <I>pro fan</I>.", "0"],
["sakristio", "sakristi-o", "[OA] (arch, ecc) Sacrist/y, vestry. <B>~ano</B>, -an, sexton (1 FA 8/37).", "0"],
["sakro", "sakr-o", "[UV] Sacr/um (bone) (Le 3/9). <B>~a</B>, -al.", "0"],
["saksifrago", "saksifrag-o", "saxifrage, rockfoil (<I>Saxi- fraga) &gt;</I> London pride.", "0"],
["saksikolo", "saksikol-o", "(orn) Chat (<I>Saxicola</I>). <B>~o brungorĝa</B>, whin-c. <B>~o nigragorĝa</B>, stone-c. ➞ <I>motacel, silvi</I>.", "0"],
["saksofono", "saksofon-o", "(m.i.) saxophone.", "0"],
["salajro", "salajr-o", "[UV] Salar/y, allowance, emolu- ments, fee, pay, remuneration, stipend, wages. <I>~i iun. ~ata</I> (paid) <I>sekretario</I>. <B>~aĉo</B>, <B>~eto</B>, mere pittance. <B>~ulo</B>, -ied person. <B>Krom~o</B>, bonus. ➞ <I>honorari, pag, rekompenc</I>.", "0"],
["salamandro", "salamandr-o", "[UV] Salamander. <B>1</B> (zoo) (<I>Salamandra</I>). <B>2</B> elemental spirit of fire.", "0"],
["salamoniako", "salamoniak-o", "[UV] salammoniac (<I>amonia klorido</I>).", "0"],
["salangano", "salangan-o", "(orn) salangane. (cul) <B>~a</B> (<I>birdnesta</I>), bird’s-nest (<I>supo</I>).", "0"],
["salato", "salat-o", "[UV] Salad. <I>~o frukta, kamparana, Mediteranea, verda</I>. <B>f</B> mixture. <B>~ujo</B>, s-bowl.", "0"],
["saldo", "sald-o", "[OA] Balance (diffce between debit and credit). <I>~o debita, kredita</I>. <B>~i</B>, b., settle, square. <I>~i la konton</I>. ➞ <I>bilanc, rest</I>.", "0"],
["salicilato", "salicil/ato", "Salicyl/ate. <B>~acido</B>, -ic acid.", "0"],
["salikario", "salikari-o", "purple loose-strife, willow-strife (<I>Lythrum salicaria</I>).", "0"],
["saliko", "salik-o", "[UV] Willow, osier, sallow (<I>Salix). Sur la ~oj ni pendigis niajn harpojn</I> (Ps 137/2). <B>~o Babilona</B> (<I>Plor~o</I>), weeping willow <B>~o kampa</B>, goat (or pussy) w. <B>~o rampa</B>, creeping w. <B>~a</B> <I>korbo</I>, wicker basket. <B>~acoj</B>, w. fam.. <B>~aĵo</B>, wickerwork. <B>~ejo</B>, w-plantation.", "0"],
["salikoko", "salikok-o", "(ordinary language) prawn (<I>Leander</I>). <B>~eto</B>, shrimp (<I>Crangon</I>).", "0"],
["salikornio", "salikorni-o", "glass-wort, marsh samphire (<I>Salikornia</I>).", "0"],
["salivo", "saliv-o", "[OA] Saliv/a, spittle (Ij 7/19). <B>~i</B>, (nt) -ate, water at the mouth. <B>~iga</B>, sialagogic. <B>~umi</B> (<I>bavi</I>). <B>~otuko</B>, bib.", "0"],
["salmo", "salm-o", "[UV] Salmon. <B>~o iriza</B>, rainbow trout. <B>~ido</B>, samlet. <I>~idaro</I>, s-fry. <B>~okolora</B>, s-colored, orange-pink. ➞ <I>trut</I>.", "0"],
["salo", "sal-o", "[UV] Salt. <B>1</B> sodium chloride. <I>Mar~o, Min~o, rok~o</I>. <B>f</B> <I>Preni kun grano da ~o. Manĝi~on kun iu. ~o de la tero</I> (Mt 5/13). <B>2</B> (chem) class of compounds. <B>~(gust)a</B>, <B>~(hav)a</B>, salt, briny, saline. <B>~i</B> (<I>-n</I>), s. <I>~i supon. Pli bone ne ~i, ol tro ~i</I>. <B>~ita</B> (corned) <I>bovaĵo</I>. <B>~eco</B>, salinity. <B>~ejo</B>, s-works. <B>~(vend)isto</B>, -er. <B>~ujo</B>, s-cellar. <B>Sen~a</B>, s-less, insipid. <I>~~a butero</I>, fresh butter. ~imposto, ~lekejo, ~marĉo, ~minejo.", "0"],
["Salomonoj", "Salomon-oj", "SB.", "0"],
["salono", "salon-o", "[UV] drawing-room, reception-Room, \"salon\", (art) studio. <I>~o dentista, frizista, florista</I>. <B>Koncerta ~o</B>, concert-r. <B>Manĝ~o</B>, dining-hall. <B>Te~o</B>, tea-r. <B>~a</B> <I>muziko,</I> light music. <I>~aj ludoj</I>, parlour games. <B>~eto</B>, morning-, living-, sitting-room. <B>~ego</B>, hall. ➞ <I>ĉambr, kajut</I>.", "0"],
["salpetro", "salpetr-o", "[UV] (<I>kalia nitrato</I>), salpetre, nitre.", "0"],
["salpingo", "salping-o", "(anat) Fallopian tube, upper part of oviduct.", "0"],
["salsolo", "salsol-o", "(bot) prickly saltwort, glass-wort (<I>Salsola</I>).", "0"],
["saltarelo", "saltarel-o", "(dance) saltarelle.", "0"],
["salti", "salt-i", "(nt), [UV] <B>1</B> Jump, Leap, bound, spring up: <I>~i pro ĝojo, en la maron, post en</I>. <B>f</B> <I>La montoj ~is kiel ŝafoj</I>. <B>2</B> (move quickly): <I>Fajreroj ~is ĉirkaŭen. Ondoj ~is (sin ĵetis) sur la rokon</I>. (pass quickly): <I>~i de rido al larmoj</I>. (rise): <I>lia temperaturo ~is ĝis</I> 103°. <B>~o</B>, jump, leap, spring: <I>~o alta, longa, transkapiĝa</I>. <B>Ran~o</B>, (gm) leap-frog. <B>Reĝ~o</B> (<I>aroko</I>), (chs) castling. <B>~e</B> <I>leviĝi</I>, jump up, give a j. <B>~ado</B>, j-ing. <I>~adi de branĉo al branĉo</I>. <B>~eti</B>, hop (as a sparrow), go hoppity-hop. <I>Iri ~ete</I>, trip along. <I>~etadi,</I> make capers, frisk abt. <I>Ŝnur~i (skipi</I>), (gm) skip. <B>~igi</B>, make jump (pop) <I>korkon el botelo;</I> (toss up) <I>infanon en la aeron</I>. <B>Al~i</B>, pounce on, spring at. <B>Ĉirkaŭ~i</B>, j. round. <B>De~i</B>, j. down (off), dismount. <B>Dis~i</B>, fly asunder. <I>~~os la baroj</I>. <B>Ek~i</B> (start) <I>de surprizo</I>. <B>El~i</B>, j. out (<I>el la lito), ~~i el la propra haŭto. ~~ulo (novriĉulo</I>), parvenu, upstart. <B>En~i</B>, j. in. <B>For~i</B>, bound off, j. away. <B>Preter~i</B>, j. past. <B>Re~i</B>, rebound, recoil, ricochet. <B>Super~i</B>, leap over. <B>Supren~i</B>, j. up. <B>Sur~i</B> (Vault on to) <I>ĉevalon</I>. <B>Trans~i</B> (j. across, over) <I>barojn, detalojn, paĝojn</I>. ➞ <I>kapric</I>.", "0"],
["saltiero", "saltier-o", "St Andrew’s cross (X), (her) saltire. <B>~e</B>, crosswise.", "0"],
["salubra", "salubr-a", "(<I>sandona</I>), healthy, salubrious. <I>~a aer-(kilmat-)o</I>. <B>~igi</B>, cleanse, purify, sweeten. Ne<B>~a</B>, insanitary, unhealthy.", "0"],
["saluti", "salut-i", "(<I>-n</I>), [UV] Salut/e, <B>1</B> Greet, hail, welcome. <I>Interŝanĝi ~ojn. ~u</I> (give kind regards to) <I>lin de mi. ~i la sunon</I>. <B>2</B> by gesture express respect. <B>~o</B>, greeting, s., -ation. Kap<B>~o</B>, bow. Man<B>~o</B>, wave of the hand. <I>~o funebra</I>. ~on! Salut’ al vi! (H/2). ~a <I>paf-(salv-)o. ~a letero</I>, letter of g-ing. <I>Sin</I> for<B>~i</B>, bow one’s out. Capel<B>~i</B>, raise one’s hat. ➞ <I>aklam, riverenc, salv. •</I>", "0"],
["Salvadoro", "Salvador-o", "SV", "0"],
["salvarsano", "salvarsan-o", "salvarsan.", "0"],
["salveleno", "salvelen-o", "(ich) char (<I>Salvelinus</I>).", "0"],
["salvio", "salvi-o", "[UV] (bot) sage, clary (<I>Salvia</I>).", "0"],
["salvo", "salv-o", "[OA] salvo, salute, volley, simultaneous discharge of firearms, <B>f</B> round (burst) of applause, etc. <I>~a pafado,</I> volley-firing. ➞ <I>ungvent</I>.", "0"],
["sama", "sam-a", "[UV] the Same, not another, without difference; identical, indistinguishable. <I>De ~a koloro, ~a valoro. Paroli ~an lingvon, havi ~an senton. En tiu ~a tago</I>, on that very day. <I>Tio ~a</I> (just the s. thing) <I>okazis al mi</I>. ~(manier)e, in the s. way. <I>Iru kaj fari</I> <B><I>~e</I></B>, go and do likewise. <I>Estus ~e racie diri</I>, it word be just (quite) as rational to say. <I>Ĉu Judoj kaj Kristanoj estas la</I> ~o? (Quo Vadis 1/129). <B>~eco</B>, identity. ~landanoj, ~urbanoj, fellow-country-men, -towns-men. <B>~tempe</B>, simultaneously. Mal~a (<I>diferenea</I>), different, other, unlike. <I>~~eco</I>, diversity. ➞ <I>ali, divers, egal, ident</I>.", "0"],
["samario", "samari-o", "(chem) samarium (Sa).", "0"],
["sambuko", "sambuk-o", "[UV] elder (tree) (<I>Sambucus</I>). <B>~a</B> <I>bero, vino</I>. ➞ <I>ebol</I>.", "0"],
["samolo", "samol-o", "brookweed, water pimpernel (<I>Samolus</I>).", "0"],
["Samoo", "Samo-o", "WS.", "0"],
["samovaro", "samovar-o", "[OA] (<I>temaŝino</I>), samovar, Russian tea-urn.", "0"],
["sana", "san-a", "[UV] Health/y, able-bodied, hale, in good h., sound, well. <I>~a menso en ~a korpo. Cerbe ~a</I>, sane. <B>~e</B> <I>vivi</I>. <B>~o</B> (good) health. <I>Fera ~o</I>, iron constitution. <I>Je via ~o!</I> Here’s to you! Good health! <B>~ega</B>, lusty, sturdy. <B>~iga</B>, h-giving, curative, healing, restorative, salubrious, wholesome. <I>~iga por la nervoj. ~igi</I>, make well, heal. <I>~igejo (sanatorio</I>), nursing-home, sanatorium. <I>~igilo</I>, means of h., cure, remedy. <B>Re~igi</B>, cure, make well again. <I>~~igebla,</I> curable. <I>~~iĝanto</I>, convalescent.", "0"],
["sanatorio", "sanatori-o", "sanatorium, convalescent home.", "0"],
["sandalo", "sandal-o", "[OA] Sandal. <I>~e vest ita</I>, s-ed.", "0"],
["sandarako", "sandarak-o", "(gum) Sandarach. <B>~arbo</B>, s-tree (<I>Callitis articulata</I>).", "0"],
["sanderlingo", "", "= sabla kalidro.", "0"],
["sandro", "sandr-o", "pike-perch (<I>Lusioperca sandra</I>).", "0"],
["sandviĉo", "sandviĉ-o", "(cul) Sandwich, ~(vend)isto. <B>f ~ulo</B> (surstrata reklamisto kun varbafiŝo super ventro kaj dorso), s-man.", "0"],
["sangisorbo", "sangisorb-o", "(bot) great burnet (<I>Sanguisorba</I>). ➞ <I>poteri</I>.", "0"],
["sango", "sang-o", "[UV] Blood, gore. <I>Verŝi ~on</I>, shed b. <B>f</B> lineage, race. <I>La ~o de David</I>, the house of D. <B>~(ad)i</B>, bleed, lose blood. <I>Li ~as el la nazo</I>, his nose bleeds, <B>f</B> suffer, as though wounded. <I>~as mia koro</I>. <B>~a</B>, -y, of blood, bleeding. <B>~ema</B>, bleeding readily. <B>~ero</B>, drop of blood. <B>~alfluo</B> (<I>kongesto</I>). <B>~ama</B>, <B>~avida</B>, b-thirsty, sanguinary. <B>~elfluo</B> (<I>hemoragio</I>). <B>~eltiri</B>, bleed. <B>~makulita</B>, gory, <B>~ogrupo</B>, b-group. <B>~okolora</B>, <B>~oruĝa</B>, b-red. <B>~oplena</B>, <B>~oriĉa</B>, plethoric. <B>Pur~a</B>, fullbred, thoroughbred. <B>Sam~a</B>, consanguine. <I>Sam~ulo</I>, blood-relation. <B>Sen~a</B> (b-less) <I>venko. ~~igi</I>, drain off b. <B>Varm~a</B>, warm blooded. <I>Malvarm</I><B><I>~e</I></B>, in cold b. ➞ <I>anemi, flegm, incest, ras, senemoci</I>.", "0"],
["sangvina", "sangvin-a", "sanguine, confident, hopeful. ➞ <I>esperem, optimism</I>.", "0"],
["saniklo", "sanikl-o", "(bot) sanicle, self-heal (<I>Sanicula</I>).", "0"],
["sanitara", "sanitar-a", "sanitary, concerning health. <I>~a tuko. ~a vagonaro</I>, hospital train.", "0"],
["sankcio", "sankci-o", "[F], Sanction. <B>1</B> official approval, confirmation, encouragement, permission, ratification. <I>Doni ~on</I>. <B>2</B> (jur) penalty (reward) for (dis)obedience. means to enforce obedience. <B>~i</B> (<I>-n</I>), sanction, authorize, countenance, permit, ratify. <I>~ita,</I> authorized. ➞ <I>aprob, konfirm</I>.", "0"],
["sankta", "sankt-a", "[UV] Hol/y, consecrated, sacred. <I>~a akvo, Ĵaŭdo, oleo. La S~a Familio. La S~a Skribo</I>, the H. Scriptures. <I>~a promeso,</I> vow, <I>~a vespero</I>, Christmas eve. <B>f</B> <I>~a estu por ni la hodiaŭa tago</I>. <B>2</B> (geog) <I>S~a Marko</I> (sometimes San-). <B>S~a Kristoforo kaj Neviso</B> KN. <B>S~a Lucio</B> LC. <B>S~a Vincento kaj Grenadinoj</B> VC. <B>Sanmarino</B> SM. <B>Santomeo kaj Principeo</B> ST. <B>~aĵo</B>, holy thing. <B>~eco</B>, -iness, sanctity. <B>~ejo</B>, [UV] holy place, fane, sanctuary, shrine. <I>Plej~ejo</I>, holy of holies = innermost shrine. <B>~igi</B>, consecrate, hallow, sanctify. <B>~ulo</B>, saint. <I>Festo de ĉiuj ~uloj</I>, All Saints’ Day. <B>Mal~igi</B>, defile, desecrate, pollute, profane.", "0"],
["sanskrito", "sanskrit-o", "<B>~a</B>, Sanscrit.", "0"],
["santalo", "santal-o", "[OA] sandalwood tree (<I>Santalum alburn</I>). <B>Ruĝa ~o</B>, red s., African rosewood. <I>~a ligno</I> (1 Rĝ 10/11).", "0"],
["santolino", "santolin-o", "(bot) Santolina shrub, lavender cotton.", "0"],
["santoniko", "santonik-o", "(bot) Santonica, f. w. (pharm) <B>santonino</B>, Levant wormseed.", "0"],
["sapei", "sape-i", "Sap, undermine. <I>~i muron</I>. <B>~isto</B>, sapper. <B>f ~i <I>decidon, kredon</I></B>.", "0"],
["sapindo", "sapind-o", "(<I>saparbo</I>), soap-berry(-tree) <B>(<I>Sapindus saponaria</I>)</B>.", "0"],
["sapo", "sap-o", "[UV] Soap. <B>Barba ~o</B>, shaving-s. <B>~o potasa</B>, soft s. <B>~o pumika</B>, pumice s. <B>~o sinteza</B> (<I>sapsuragato</I>), detergent. <B>Soda ~o</B>, hard (dry) s. <B>Tualeta ~o</B>, toilet s. <B>~i</B> <I>tolon (vizaĝon</I>). <B>~a</B> <I>briko (bulo</I>), cake of soap. <I>~a bobelo, veziko</I>, s-bubble. <B>~eca</B>, <B>~oza</B>, -y, saponaceous. <B>~igi</B>, saponify. <B>~ujo</B>, s-dish. <B>~umi</B>, soap, lather. <B>~fabrikisto</B>, s-maker. <B>~farado</B>, s-making. <B>~ŝaŭmo</B>, lather, s-suds. ➞ <I>sapind, saponari, steatit</I>.", "0"],
["saponario", "saponari-o", "soap-wort, fuller’s herb <B>(<I>Saponaria</I>)</B>.", "0"],
["sapoto", "sapot-o", "(bot) sapodilla (<I>Achras sapota</I>). <B>~frukto</B>, s-fruit, plum.", "0"],
["saprofito", "saprofit-o", "(bot) saprophyte.", "0"],
["sarabando", "saraband-o", "(dance) saraband.", "0"],
["sardelo", "sardel-o", "[UV] (com) pickled anchovy or similar clupeid in tins or barrels.", "0"],
["sardino", "sardin-o", "sardine, young pilchard or similar fish, tinned and preserved in oil or tomato sauce. ➞ <I>anĉov, pilĉard</I>.", "0"],
["sardona", "sardon-a", "sardonic, bitter, cynical, scornful. <I>~a rido</I>.", "0"],
["sardonikso", "sardoniks-o", "(min) sardonyx, a form of onyx with brown and white bands.", "0"],
["sargaso", "sargas-o", "(bot) sargasso, gulf-weed. <I>~a maro</I>.", "0"],
["sario", "sari-o", "(cl) sari.", "0"],
["sarkasmo", "sarkasm-o", "[OA] Sarcas/m, cutting, mocking, wounding irony. <B>~a</B>, -tic. <I>~a rideto</I>. <B>~i</B>, speak sarcastically. ➞ <I>ironi</I>.", "0"],
["sarki", "sark-i", "(<I>-n</I>) [UV], Hoe, Weed. <I>~i florbedon, kampon</I>. <B>~ado</B>, hoeing. <B>~aĵo</B>, garden refuse, sweepings, weedings. <B>~ilo</B>, hoe. <B>Puŝ~ilo</B>, Dutch (thrust) hoe. <B>Tir~ilo</B>, weeding hook. <B>For~i</B>, weed out, exterminate, grub up. <B>f</B> <I>~i antaŭjuĝojn</I>.", "0"],
["sarkofago", "sarkofag-o", "[OA] sarcophagus, stone coffin. <B>2</B> similar monument.", "0"],
["sarkofilo", "sarkofil-o", "(<I>Tasmania diablo</I>), Tasmanian devil (<I>Sarcophilus</I>).", "0"],
["sarkomo", "sarkom-o", "(med) sarcoma, malignant tumour of tissue.", "0"],
["sarkopto", "sarkopt-o", "sarcoptes &gt; itch mite (<I>S. scabei</I>).", "0"],
["sarmento", "sarment-o", "bine, climbing stem e.g., of hop or vine.", "0"],
["sarongo", "sarong-o", "(cl) sarong.", "0"],
["sarotamno", "sarotamn-o", "(bot) broom (<I>Sarothamnus</I>).", "0"],
["sarsaparilo", "sarsaparil-o", "(<I>smilakradiko</I>), sarsaparilla.", "0"],
["sarseneto", "sarsenet-o", "(tex) sarsenet, fine soft silk lining material.", "0"],
["sasafraso", "sasafras-o", "sassafras, N. American laurel (<I>Sassafras</I>).", "0"],
["sata", "sat-a", "[UV] Satiated (satisfied), full, replete, having had enough, no longer hungry, with hunger appeased (no desire for more), f <I>~a de (je, pri) plezuroj (vivo). Havi</I> ~e (<I>sufiĉe) da pano</I> (Se 28/19). ~i (<I>esti ~a</I>), be -ated. <B>~ego</B>, surfeit. <B>~igi</B>, appease (hunger), quench (thirst). <I>~igi la animon. Ne~igebla</I>, in-able. <I>Ne~igita,</I> unappeased, unsatisfied. <I>Super~igi, tro~igi,</I> clog, cram, glut, overfeed, saturate, stuff, surfeit. ~iĝi (Se 27/20), be -sfied, take one’s fill of. <I>Tro~iĝi</I>, have more than enough, too much. <I>Manĝi</I> <B>ĝis~e</B>, till -sfied, to repletion, gorge. <I>Trinki ĝis~e,</I> drink one’s fill. <B>Mal~a</B>, Hungry, empty. <B>~~a</B> <I>kiel lupo. Sata ~~an ne povas kompreni</I>. <B>~~o</B>, hunger, famine, want. <I>Morti de ~~o</I>. <B>~i</B>, be hungry, crave (hanker) after, long for. <B>~~ega</B>, famishing, starving, ravenous. <B>~~ego</B>, famine, starvation. <B>~~igi</B>, starve. ➞ <I>kontentig, plen, satur, sufiĉ</I>.", "0"],
["satano", "satan-o", "[OA] Satan.", "0"],
["satelito", "satelit-o", "(astr) satellite, <B>f</B> follower, underling. <I>~a nacio, urbo</I>.", "0"],
["satiro", "satir-o", "[OA] Satir/e. <B>~a</B>, -ic<B>al</B>, mocking. <B>~i</B>, -ize. <B>~isto</B>, -ist. ➞ <I>mok, vip</I>.", "0"],
["satiruso", "satirus-o", "(myth) satyr, woodland deity.", "0"],
["satrapo", "satrap-o", "[OA] (hist) satrap, Persian governor (Da 3/2, Ez 8/36, Es 3/12).", "0"],
["satureo", "sature-o", "(bot) savory (herb of mint fam.) (<I>Satureia</I>).", "0"],
["saturi", "satur-i", "(<I>-n</I>), [UV] Saturat/e, impregnate, penetrate, permeate. <B>~ita</B>, -ed. <I>~ita de lumo, nebulo, odoro, sango</I>. Drenched, soaked (<I>de pluvo). Ostoj ~itaj de medolo</I> (Ij 21/24). <B>f</B> crammed, imbued, steeped, <I>de ideoj, principoj, sentoj</I>. (chem) <I>~ita solvaĵo</I>. <B>~a</B> <I>punkto</I>. <B>~ado</B>, <B>~eco</B>, saturation. <B>Super~i</B>. ➞ <I>impregn, penetr, sorb</I>.", "0"],
["saturnio", "saturni-o", "emperor moth (<I>Saturnia</I>).", "0"],
["Sauda Arabujo, Sauda Arabio", "Saud-a Arab-ujo, Sauda Arabio", "[OA-8] SA.", "0"],
["saŭco", "saŭc-o", "[UV] (cul) Sauce. <I>~o Holanda, kapora, pana, poma, tomata. Blanka ~o</I>, melted butter. <B>~ujo</B>, s-boat, -bottle. ➞ <I>frikas</I>.", "0"],
["saŭdado", "saŭdad-o", "saudade (Portuguese word), haunting sense of sadness and regret for days gone by, or for what might have been. ➞ <I>nostalgi</I>.", "0"],
["saŭno", "saŭn-o", "sauna, Finnish bath. ➞ <I>ŝvitbanej</I>.", "0"],
["savano", "savan-o", "savanna, tropical grassy treeless plain (1 FA 118/22).", "0"],
["savi", "sav-i", "[UV] Sav/e. <B>1</B> Deliver (free, rescue) from, salve (<I>Upon): ~i de morto; el brulanta domo; kontraŭ doloro. Li ~is mian vivon. Sin ~i</I>, escape. <I>~u vin (forkuru) sur la monton</I>. <B>f</B> ~i <I>la situacion. Ĉu mi ne ~u la esperon</I> (cherish the hope)? (If 84/20). <B>2</B> (<I>domaĝi, evitigi</I>), spare: <I>~i energion, ĝenon</I>. <B>Sav-</B> (Safety<I>-) (danĝerevita, sendanĝeriga): Sav-kurteno, ~lampo, ~razilo, ~valvo. ~zono</I>, s-belt. <B>~o</B>, salvation. <B>~anto</B>, -iour, rescuer. <I>Ne plu</I> <B>~ebla</B>, past praying for. <B>~iĝo</B>, deliverance, rescue, salvation. <I>Apenaŭa ~iĝo</I>, hair-breadth escape. <B>~ito</B>, rescued person, survivor. <I>Dronanto domon proponas</I>, <B>~ito</B> <I>eĉ brikon ne donas</I>. <B>~rimedo</B>, means of deliverance. <B>Antaŭ~i</B>, preserve (from), <B>For~iginto</B>, refugee (Ge 14/13). <B>Sen~a</B>, helpless <I>[Ne= ŝpar]</I>.", "0"],
["scen", "", "<B>-o</B> [F], Scen/e. <B>1</B> locality of action or event: <I>La ~o de la batalo, akcidento</I>. <B>2</B> event, incident: <I>~oj el Pariza vivo: el mia juneco. Detaloj de la ~o</I> (M 23/29). <I>~o neforgesebla</I>. <B>f</B> <I>Ne faru ~on (trankviliĝu)!</I> <B>3</B> subdivision of a play: Akto 2, ~o 4. <B>~(ej)o</B>, (th) stage, boards. <I>Sur la ~o</I> (H 65/31). <I>Post la ~o (en la kuliso</I>) (H 173/25). <B>~a</B>, scenic. <B>~aro</B>, -ario. <B>Antaŭ~ejo</B>, proscenium. ➞ <I>pejzaĝ, vidaĵ</I>.", "0"],
["sceptr", "", "<B>-o</B> [UV] (<I>reĝbastono</I>), Sceptre, emblem of royal power. <I>For lia ~o kaj trono!</I> (K 326/20).", "0"],
["scienco", "scienc-o", "[UV] Scienc/e, <I>Naturaj ~oj</I>. <B>~a</B>, -tific. <B>~isto</B>, <B>~ulo</B>, -tist, savant.", "0"],
["scii", "sci-i", "(<I>-n, ke, kie, etc.</I>), [UV] Know. <B>1</B> (facts): <I>~i lecionon parkere. ~i lingvon, la vojon. Nenion li volis ~i</I>, He wouldn’t listen to anyone. <B>2</B> be aware of, know certainly, precisely, understand: <I>Oni neniam ~as! Ĉu vi ~as, ke? Mi ~as, kion mi ~as. Mi ~as ĝiajn suferojn</I> (El 3/7). <I>Neniu ~as lian tombon</I> (Re 34/6). <I>Mi ne ~as</I> (don’t k., can’t tell) <I>kie lin trovi, kion diri, fari, pensi, respondi. Kiom mi ~as</I>, as far as I k., for aught I know. <B>3</B> know how to (a. <I>povoscii</I>), be skilled in: <I>~i muzikon. ~i (kiel) ludi harpon. Mi ne ~as instrui</I> (k. how to teach). <B>~o</B>, knowledge, learning, understanding. <I>Laŭ mia ~o</I>, as far as I am aware, <I>Sen mia ~o</I>, behind my back, unknown to me, without my -ledge. <B>~ama</B>, <B>~avida</B>, <B>~ema</B>, <B>~vola</B>, dezirous of -ing, curious, inquisitive. <I>~emo</I>, thirst for -ledge. <B>~eti</B> (<I>suspekti). ~eto</I>, inkling. <B>~igi</B> [UV]. (a) (<I>iun pri io</I>): inform, let know, notify, tell, (b) (<I>ion al iu</I>): make known, announce, give notice. <I>~igoj</I>, details, particulars, tidings. <B>~iĝi</B>, [UV] (a) become known. (b) get to k., learn, be told (informed). <B>~inda</B>, worth knowing. <B>~voli</B>, be curious. <B>Antaŭ~o</B>, fore-ledge. <I>~~igi</I>, forewarn. <B>Ek~o</B>, sudden insight, <B>Ne~o</B>, ignorance. <B>Sen~e</B>, unconsciously, unwittingly. <I>Sen~ulo</I>, dunce, ignoramus, simpleton. <B>Ĉio~a</B>, omniscient. <B>Duon~o</B>, half-ledge. <B>Multe~a</B>, accomplished. ➞ <I>kon, scienc</I>.", "0"],
["scintili", "scintil-i", "(<I>trembrili</I>), scintillate, sparkle, twinkle.", "0"],
["scirpo", "scirp-o", "bulrush, club-rush (<I>Scirpo</I>).", "0"],
["sciuro", "sciur-o", "[UV] Squirrel (<I>Sciurus</I>). <B>~o griza</B> (<B>ruĝa</B>), grey (red) squirrel.", "0"],
["sciuroptero", "sciuropter-o", "flying squirrel (<I>Sciuropterus</I>).", "0"],
["se", "", "[UV] (conj) If (= supposing, on condition, that). ~ jes, if so, if you do, if it is, etc. (according to context). ~ ne, if not, unless. <I>~ nur unu</I>, if only one. <I>El</I> even if. <I>Nur</I> Only if. <I>~ li venos</I>, if he comes. <I>~ li venus</I>, if he came. <I>Ho, ~ mi povus (ke mi povu)!</I> If I could only, (log) ~a (<I>hipoteza, supoza) propozicio</I>. <B>Rim</B>.: \"Se absoluta\". ~ (<I>oni volus) lin kompari kun</I>, in comparison with. <I>~ konsideri, ke</I>, considering that. <I>~ paroli sincere</I>, to speak sincerely. <I>~ ne paroli pri</I>, to say nothing of. <I>~ tiel diri,</I> so to speak. <B>Rim</B>.: ➞ ĉu = if (whether),", "0"],
["seahorse (", "", "Syngnathus).", "0"],
["seanco", "seanc-o", "(spiritualistic) seance.", "0"],
["sebo", "seb-o", "[UV] (<I>bestograso</I>), tallow fat, suet, secretion from sebaceous glands (Ps 119/70). <I>Porka ~o</I> (K 63/33). <I>~o minerala, planta</I>. <B>~a</B> <I>kandelo</I>, t-candle. <I>~a kisto</I>, (med) blackhead. <B>~i</B>, grease. <B>~eca</B>, sebaceous. <B>~restaĵoj</B>, (cul) cracklings. ➞ <I>gras</I>.", "0"],
["sebumo", "sebum-o", "(anat) sebum,", "0"],
["secesio", "secesi-o", "(jur) secession. <B>~i</B>, secede. <B>~a</B> <I>milito</I>.", "0"],
["sed", "", "[UV] (conj) (denotes contrast, demurring, diffidce, surprise, etc.) but, however, moreover, nevertheless, on the contrary (other hand), yet. <I>Ŝtalo estas fleksebla, ~ fero ne. Venis ne li, ~ lia edzino. Dion fidu, ~ senfare ne sidu. Bone, ~ ne tre! Mi volus veni, ~ ... Li ĉiam elpaŝas kun ia (kontraŭdiro</I>). ➞ <I>aliflanke, cetere, krom, nur, tamen</I>.", "0"],
["sedativo", "sedativ-o", "(<I>trankviligilo</I>), Sedative. <B>~a</B>, s.", "0"],
["sedimento", "sediment-o", "(geol) Sedimentary rock, deposit. <I>~o de kaldrono</I> (Jeĥ 24/6). <B>~a</B>, -ary. <B>~iĝo</B>, -ation. ➞ <I>fee, precipitaĵ</I>.", "0"],
["sedo", "sed-o", "stonecrop (<I>Sedum</I>) &gt; orpine, wall pennywort, wall pepper.", "0"],
["segi", "seg-i", "[UV] Saw. <B>~ado</B> (<B>~aĵo</B>) <I>a/ura</I>, fretwork. <B>~ejo</B>, saw-mill, saw-yard. <B>~ilo</B>, s. <I>~ilo frama, ligna, mana</I>. <B>Arĉ~ilo</B>, bow-s. <B>Benda (senfina) ~ilo</B>, band (belt, endless, ribbon) s. <B>Laŭlonga ~ilo</B>, rip s. <B>Rond~ilo</B>, circular s. <B>Trapeza (vosta) ~ilo</B>, compass s. <B>Tru~ilo</B>, jig-saw, keyhole-saw. (mus) <B>Muzika ~ilo</B>, musical s. <I>Akrigi, klinigi, reguligi ~ilon,</I> sharpen (set, regulate) a saw. <B>~isto</B>, sawyer. <B>De~i</B>, s. off. <B>Dis~i</B>, s. up. <B>Tra~i</B>, s. through. ➞ <I>prist</I>.", "0"],
["segmento", "segment-o", "[OA] <B>~i</B>, Segment. <I>~o de insekto, linio, sfero</I>. <B>~ado</B>, -ation.", "0"],
["segregi", "segreg-i", "(<I>apartigi</I>) (<I>-n</I>), Segregat/e. <I>~i leprulojn</I>. <B>~ado</B>, -ion. <B>~ismo</B>, -ism, apartheit. <B>~ita</B>, -ated.", "0"],
["seĝo", "seĝ-o", "[UV] Chair, Seat (coachman’s) box. f <I>~o parlamenta, juĝista</I> (bench). <I>La Sankta ~o</I>, the Holy See. <I>Okupi ~on</I>. Apog~o, brak~o (<I>fotelo</I>), arm-chair, easy-chair. <B>Fald~o</B>, deck-c. <B>Glit~o</B>, <B>Sxov~o</B>, sliding-seat. <B>Kan~o</B>, cane c. <B>Kuŝ~o</B>, lounge-c. Ltd~o (<I>balanca ~o</I>), rocking-c. <B>Port~o</B>, sedan-c. <B>Puf~o</B>, cushioned, padded c. <B>Rad~o</B>, <B>Rul~o</B>, bath-(wheel-)c. <B>Tru~o</B>, close-stool, commode. <B>~eto</B>, baby-c. <B>~(far)isto</B>, c-maker. ~(montr)ist(in)o, c-attendant, usherette. ➞ <I>benk, sid(ej)(lok), taburet</I>.", "0"],
["seismo", "seism-o", "<I>a</I>. <B>sism-o</B> (<I>tertremo</I>), earthquake. <B>~a</B>, seismic. <B>~ografo</B>, <B>~ologio</B>, <B>~ometro</B>.", "0"],
["Sejŝeloj", "Sejŝel-oj", "SC.", "0"],
["seka", "sek-a", "[UV] Dry. <B>1</B> without moisture: <I>~a gorĝo, vetero. ~aj folioj, okuloj</I>. <B>2</B> dried up, parched, thirsty: <I>~a puto, tero</I>. <B>3</B> without additional or fancy details, bald, hard, meagre, plain: <I>~a humoro, rido, stilo, voĉo. ~aj faktoj. ~a pano (senbutera), ~a manĝo (sensaŭca</I>). <B>4</B> senalkohola. <B>~aĵoj</B>, [UV] d-goods. <B>~ega</B>, arid. <B>~igi</B>, dry. <I>~igi tolaĵon, larmojn</I>, (wipe) <I>tasojn</I>. <B>~iga</B> <I>paliso</I>, clothes-prop. <I>~iga ŝnuro</I>, clothesline. <B>~igita</B> (dried, dessicated) <I>frukto, kokoso, pizo</I>. <B>~igilo</B>, dryer. <B>~iĝi</B>, dry up, wilt. <B>El~igi</B>, drain, empty. <B>Mal~a</B>, watery, wet. <B>~~iĝema</B>, deliquescent. <I>~~aj okuloj</I>. <B>~~ec(et)a</B>, damp, humid, moist. <B>Tra~~igi</B>, drench, soak. <B>~~iĝi</B>, be soaked (Pr 10/18). ➞ <I>pluv, proz, senakv, senmetafor</I>.", "0"],
["sekalo", "sekal-o", "[UV] Rye (Secale). <B>~a</B> <I>pano</I>.", "0"],
["sekanto", "sekant-o", "(trig) secant.", "0"],
["sekci", "sekc-i", "(<I>-n</I>) [UV], cut up (cake, etc.) into pieces, (geom) divide into sectns, (med) dismember. <B>~o</B>, cut. <I>~o laŭlonga, transa,</I> (longitudinal, transversal). <B>~aĵo</B>, section (for microscope). <B>~ilo</B>, scalpel. <B>De~i</B>, resect, pare down. <B>Dis~i</B>, dissect. <B>Du~i</B>, bisect.", "0"],
["sekcio", "sekci-o", "[OA] Section, distinct part. <I>~o de ĉapitro, konstruo, vojaĝo</I>, (com) branch, department (<I>de magazeno</I>). (geom) <B>konusa ~o</B>, (mus) <B>~o de fugo</B>. (org) = \"organ\": <I>ĥora, ĉefa, ŝvela, soloa, eĥa</I>. ➞ <I>fak</I>.", "0"],
["sekojo", "sekoj-o", "sequoia, mammoth tree, Welfingtonia (<I>Sequoia gigantea) &gt;</I> redwood (<I>S. sempervivens</I>).", "0"],
["sekrecio", "sekreci-o", "[OA] Secret/ion (from glands). <B>~i</B> (<I>-n</I>), secrete.", "0"],
["sekretario", "sekretari-o", "[UV] Secretary, amanuensis. <I>~o ŝtata. Ĝenerala S~o (de UN</I>) <B>~a</B>, -ial. <B>~aro</B>, <B>~ejo</B>, -iat. <B>~ino</B>.", "0"],
["sekreto", "sekret-o", "[UV] Secre/t, mystery. <I>Publika</I> (known by all). <I>Babili, gardi ~on. Eltiri</I> (worm out) <I>~on. Perfidi ~on</I>, let the cat out of the bag. <I>~o familia,</I> skeleton in the cupboard. <B>~a</B>, s., clandestine, hidden, hush-hush, private. <I>~a amo, influo, societo. ~a inko</I>, invisible ink. <I>Tenu ĝin ~a</I>, keep it dark. <B>~e</B>, in s., secretly, privately. <B>~i</B> (<I>-n, al</I>), tell in s., confide. <I>Vi ~os al edzino, ŝi al fratino ..</I>. <B>~eco</B>, -cy. <B>~ema</B>, discreet, -tive. <B>~igi</B>, keep s., -te. <I>En~igi</I>, initiate. <B>Mal~igi</B> (<I>-n</I>) (<I>malkasi</I>), blab, blurt out, disclose, divulge, noise abroad.", "0"],
["seksagesimo", "seksagesim-o", "(rel) sexagesima.", "0"],
["sekso", "seks-o", "[UV] Sex. <I>~o ina, vira. La bela ~o,</I> the fair sex. (gram) (<I>genro</I>), gender. <B>~allogo</B>, s-appeal. <B>~kuniĝi</B>, copulate. <B>~matura</B>, adult (<I>adolta). ~~eco</I>, puberty. <B>Ambaŭ~a</B>, <B>du~a</B> (<I>hermafrodita</I>), bisexual, hermaphrodite. <B>Sam~ama</B> (<I>geja</I>), homosexual, gay. <B>Unu~a</B>, unisexual. <B>Vir~a</B>, ~~ulo (<I>maskl-a, -o</I>), male. ➞ <I>in, gej, vener, vir</I>.", "0"],
["sekstanto", "sekstant-o", "sextant.", "0"],
["seksteto", "sekstet-o", "=sesteto.", "0"],
["seksto", "sekst-o", "= sesto.", "0"],
["sekto", "sekt-o", "[OA] Sect, group with separate views. <B>~a</B>, -arian. <B>~ano</B>, member of a s. <B>~ismo</B>, -arianism. <I>~ismano</I>, -arian. <B>Sen~a</B>, unsectarian. ➞ <I>koteri, tendar</I>.", "0"],
["sektoro", "sektor-o", "[OA] Sector. <B>1</B> (geom) arc, quadrant. <B>2</B> (district area): <B>~a</B> <I>limo</I>. <B>3</B> beat. <I>~o okupacia, policista, poŝta</I>.", "0"],
["sekulara", "sekular-a", "(<I>neklerikala</I>), lay, secular. <B>~igi</B>, -ize.", "0"],
["sekundara", "sekundar-a", "(geol) (el) (tech) secondary. ➞ <I>primar</I>.", "0"],
["sekundi", "sekund-i", "second, abet, further, promote (<I>Cikonikalifo</I> 41/5). <B>~anto</B>, [OA] second in a duel.", "0"],
["sekundo", "sekund-o", "[UV] Second, sixtieth of a minute (time or degree). <B>~a</B> <I>montrilo,</I> s-hand.", "0"],
["sekura", "sekur-a", "[OA] Secur/e (from danger), safe. <I>~a loko</I>. <B>~eco</B>, -ity. <I>Socia ~eco,</I> public welfare. <I>Kolektiva ~eco</I>. <B>~igi</B>, make s. <I>~iga</I> (safety) <I>butono, bremso, drato, valvo</I>.", "0"],
["sekvenco", "sekvenc-o", "Sequence. (mus) ~o (<I>mal)suprena, harmonia, melodia, tonala, vera</I>.", "0"],
["sekvestri", "sekvestr-i", "(<I>-n</I>), (jur) Sequestrat/e, transfer temporary possession of disputed property to a third party. <B>~o</B>, -ation.", "0"],
["sekvi", "sekv-i", "_(-n, abs), [UV] Follow. <B>1</B> go after, behind: <I>Safo ŝafon ~as. Vi iru: mi ~os</I>. <B>2</B> come after, succeed: <I>Printempo ~as vintron, puno krimon. Tago ~as tagon</I>. <B>3</B> pay attention to, observe: <I>~i argumenton (kantiston). ~i spuron. ~i per la imago, okulo</I>. <B>4</B> (<I>laŭiri</I>), act in conformity (comply) with: <I>~i ekzemplon, konsilon, metodon, principon, vojon. ~u miajn leĝojn</I>. <B>5</B> be caused by, result from: <I>El tio ~as, ke</I>, it follows from that (the conseqce is), that. <B>~o</B>, conseqce, effect, outcome, result, sequel. <I>~o natur-(neevitebl-)a</I>. <B>~a</B>, consequent. <B>~anta</B>, next, subsequent, succeeding. <I>La ~anta tago</I>. <B>~anto</B>, follower, disciple, successor. <I>~antaro</I>, band of -ers, retinue, train. <B>~onta</B>, future. <B>~e</B>, accordingly, consequently, therefore. <I>~e mi ne venos. ~e de,</I> owing to, as a consequence of. <B>~igi</B>, <B>1</B> have f-ed: <I>~igi suspektaton</I>. <B>2</B> bring about, cause, entail, involve, lead to, run one into: <I>~igi elspezon, prokraston. Unu ŝanĝo ~igas duan. Tio ne ~igas (Ne ~as el tio</I>), it does not follow (it is not to be inferred) (that). <B>Sen~a</B> <I>okupo</I>, blind alley. <B>(Sin)</B><B>~o</B>, consecutive, successive. <B>~~o</B>, series, succession. <I>Sin~e,</I> in file, (mus) <I>Sin~aj</I> (consecutive) <I>kvartoj, kvintoj, oktoj</I>. <B>Gvat</B><B>~i</B> (<I>spur~i</I>), follow stealthily, shadow, tail, track. <B>Prem</B><B>~i</B>, f. closely, press hard after. <B>~oriĉa</B>, big (heavy) with conseqces. ➞ <I>kuntren, konsekvenc, post, rezult, sekvenc</I>.", "0"],
["selaginelo", "selaginel-o", "(bot) prickly or lesser club- moss (<I>Selaginella</I>).", "0"],
["selakto", "selakt-o", "[OA] whey.", "0"],
["selekti", "selekt-i", "(<I>-n</I>), Select, choose, pick by discrimination, elimination, sort out. (rad) <I>~i ondlongon</I>. <B>~(aĵ)o</B>, -ion, choice, pick, (bio) <I>Natura ~o</I>. <B>~(it)a</B>, choice, picked. <B>~ema</B>, cautious, choosy, exclusive, fastidious. <B>~ilo</B>, -or. <B>~iva</B>, -ive. <I>~iveco,</I> -ivity. ➞ <I>elekt</I>.", "0"],
["seleno", "selen-o", "(chem) selenium (Se).", "0"],
["selo", "sel-o", "[UV] Saddle (horse, cycle, etc.). (vn) nut. <B>~i</B>, s. <I>~i ĉevalon</I>. <B>f</B> burden. <B>~(far)isto</B>, s-er. <B>~ejo</B>, harness room. <B>~arko</B>, s.bow. <B>~rimeno</B>, <B>~zono</B>, girth. <B>De~iĝi</B>, dismount. <B>El~igi</B>, unhorse, unseat. <B>Pak~o</B>, <B>ŝarĝ~o</B>. pack-s. <B>Sen~igi</B>, unsaddle. <B>Sur~iĝi</B>, mount.", "0"],
["semaforo", "semafor-o", "[OA] semaphore.", "0"],
["semajno", "semajn-o", "[UV] Week. <I>Sankta ~o</I>, Holy W. ~a (<I>simpla) tago</I>, w-day. <B>(ĉiu)~a</B> <B>~e</B>, w-ly, hebdominal. <B>(Ĉiu)du~a</B>, fortnightly. <B>Duon~e</B>, twice w-ly. <I>Lundo post~a</I>, Monday w.", "0"],
["semantiko", "semantik-o", "semantics, study of the meaning of words.", "0"],
["semestro", "semestr-o", "(<B>duonjaro</B>), half-year. <B>➞ trimestr</B>.", "0"],
["semido", "semid-o", "Semit/e. <B>~a</B>, <B> ic</B>. <B>~ismo</B>, <B>-ism.</B> <B>Kontraŭ~ismo</B>. ➞ <I>antisemit, antisemitism</I>.", "0"],
["seminario", "seminari-o", "[OA] seminary, training college (for clergy, teachers, etc.).", "0"],
["semo", "sem-o", "[UV] (a. <I>semero</I>), Seed, f <I>cent ~oj perdiĝas</I>. <B>2</B> semen (<I>spermo</I>). <B>3</B> (<I>idaro</I>) (1 Rĝ 11/39): s., descendants, offspring, posterity. <I>La ~o de David. Ilia ~o estos ekstermita</I>. <B>~i</B>, [UV] <B>1</B> Sow (seed): f <I>Lago ~ita de insuloj. Stel~ita</I> (star-spangled) <I>ĉielo</I>. <B>2</B> broadcast, spread abroad: <I>La epidemio ~is morton</I>. <B>~a</B>, seminal. <I>~a sezono</I>, s-time. <B>~ado</B>, sowing. <I>~ado laŭlinia</I> (drilling). <B>~aĵo</B>, seed(s). <I>Bird~aĵo,</I> bird-(canary-)s. <B>~(vend)isto</B>, -sman. <B>~anto</B>, <B>~isto</B>, sower. <B>~ilo</B>, <B>~maŝino</B>, sowing-machine, drill, <B>~itaro</B>, -lings, <B>~ujo</B>, s-vessel, pericarp, pod. <B>dis~i</B>, [UV] disseminate, broadcast, scatter, sprinkle, strew. <B>En~i</B>, enculcate <B>f</B> <I>~~i malamon en animon</I>. <B>Pri~i</B> (<I>kampon</I>), sow (Ge 47/23, 24; Ps 107/37). ➞ ~i <I>tritikon</I>, sow wheat. <I>Ne~~ita</I>, fallow. <B>Sen~a</B>, s-less. <B>~bedo</B>, s-plot. <B>~taŭga</B>, arable, <B>~vendisto</B>, corn-chandler.", "0"],
["semolino", "semolin-o", "(cul) semolina.", "0"],
["sempervivo", "semperviv-o", "(bot) Houseleek (<I>Semper- vivum). ~o araneeca</I>, cobweb plant.", "0"],
["sen", "", "[UV] (prep) (denotes absence, lack), without; free from, minus, with no. <I>Rozo ~ dornoj. Teo ~ sukero. ~ li, mi jam falus,</I> but for (were it not for) him, I should have fallen. ~ (<I>tio) ke</I>, but that... <I>~ kio, ~ tio</I>, otherwise, else, had it not been for that. <B>~eco</B>, absence, dearth, lack, want. ~igi (<I>je</I>), bereave, de-nude(-prive) of, free from, strip. ~iĝi (<I>je</I>), be deprived of, get rid of, lose, run out of. Sen- (pfx with noun-root) = -less. Senamika = sen amiko, friendless, without a friend. Sim: <I>sen-ĉapel(-frukt-patr)a</I>, hat-fruit-father -)less. Senmensoge, to tell the truth. ➞ <I>mal, mank, minus, ne</I>. If Sen manĝi, without eating. Z. advised against this form (LR/128). Better avoided, but often met, and fairly international. Alternatvs: <I>senmanĝe, sen manĝo, ne manĝante</I>. ... to say nothing of the dog, <I>sen parolo (se nenion diri) pri la hundo</I>.", "0"],
["senao", "sena-o", "Senna (<I>Cassia senna</I>). <B>~folio</B>, s-leaf. ➞ <I>kasi</I>.", "0"],
["senato", "senat-o", "[OA] <B>1</B> Senat/e. <B>2</B> Upper House (of parliament). <B>~ano</B>, -or. <I>~ana</I>, -orial. <B>~ejo</B>, s-house, upper chamber.", "0"],
["senco", "senc-o", "[UV] Sense; meaning; idea, import, purport (of word, phrase). <I>~o duba, klara, figura, ordinara, propra. La ~o de ambaŭ vortoj estas sama. Tio havas nenian ~on por mi</I>, means (conveys) nothing to me. <B>Ali~igi</B>, alter the meaning. <B>Du~a</B>, <B>dube~a</B>, <B>plur~a</B>, ambiguous, equivocal. <I>Paroli</I> <B><I>du~e</I></B>, prevaricate. <B>Kontraŭ~e</B> (<I>mise</I>), with the wrong meaning. <B>Propra-e</B>, properly. <B>Sam~a</B> (<I>kun</I>), equivalent (to). <B>Sen~a</B>, -less, absurd, foolish, meaning-less. <B>~~aĵo</B><I>,</I> absurdity, nonsense. <I>~~ulo</I>, fool, idiot. <B>Unu~a</B>, univocal. <B>~oriĉa</B>, expressive. <B>Rim</B>.: <I>Signifo</I> is a near synonym, adding the idea of importance. ➞ sensenca, nonsensical; sensignifa, unimportant.", "0"],
["sendi", "send-i", "[UV] Send. <B>1</B> (<I>iun): ~i servanton. ~i por helpo. ~i venigi (voki) iun</I>, send for someone. <B>2</B> (<I>ion</I>), s. off, despatch, forward: <I>~i donacon, leteron, telegramon;</I> remit (<I>monon</I>), throw (<I>ŝtonon</I>). <B>f</B> <I>~i amon, kisojn. Mi ~os (venigos) miajn plagojn sur ilin</I>. <B>~(ad)o</B>, despatch, transmission. <B>~aĵo</B>, consignment, missive, packet, parcel. <B>~anto</B>, -er. <B>~igi</B>, have sent, <B>~ilo</B>, means of conveyance. <B>~ito</B>, bearer, envoy, messenger, representative, <I>~itaro</I>, delegate, etc. ➞ <I>agent, delegit</I>. <B>Dis~i</B>, broadcast, circulate (➞ <I>brodkast</I>). <B>El~i</B>, send forth (out), emit (<I>vaporon</I>). <B>For~i</B>, s. away (off), despatch, dismiss. <B>Re~i</B>, s. back, return (➞ <I>reflekt</I>). <B>f</B> (<I>atentigi</I>). <I>~~i</I> (refer) <I>al la aŭtoro. Re~a</I> (reflexive) <I>pronomo</I>. <B>Trans~i</B>, send on, forward, transmit. ➞ <I>adres, direkt, eksped</I>.", "0"],
["senecio", "seneci-o", "groundsel (<I>Senecio</I>). ~o Jakoba, ragwort, St James’ wort.", "0"],
["Senegalo", "", "SN.", "0"],
["senila", "senil-a", "(med) Senile. <B>~eco</B>, -ity.", "0"],
["sensacio", "sensaci-o", "[OA] Sensation, intense commotion, emotion, or interest; strong impression on the public. <B>~i</B> <I>= fari, kaŭzi ~on,</I> make a s. <B>~a</B>, -al. <I>~a evento, romano. ~a proceso</I>, famous trial. ➞ <I>ekscit, sent</I>.", "0"],
["sensitivo", "sensitiv-o", "sensitive plant (<I>Mimosa pudica</I>).", "0"],
["senso", "sens-o", "(<I>sentumo</I>), Sens/e, (one of the) <I>kvin ~oj</I>. <B>~a</B>, of sense, -ory, -ous. <I>~a plezuro</I>. ~i (a. <I>senti</I>), perceive by the senses. <B>~aĵo</B>, (phys) -ation, impression received from one of the senses. <B>~ebla</B>, appreciable, perceptinle, sensible. <B>~iva</B>, sensitive (to heat, etc.). <B>Ne~ebla</B>, imperceptible. <B>~ama</B>, sensual. <B>~alloga</B>, emotive, provocative. ➞ <I>prudent</I>.", "0"],
["sensuala", "sensual-a", "(<I>sens-ama</I>), Sensual, carnal, voluptuous. <B>~ismo</B>, <B>~isto</B>.", "0"],
["sentenco", "sentenc-o", "[UV] short pithy wise saying. (Bb) <I>La ~oj</I> (Proverbs) <I>de Salomono</I>. <B>~a</B>, sententious. ➞ <I>aforism, fraz, maksim, proverb [Ne= juĝodecid, verdikt]</I>.", "0"],
["senti", "sent-i", "[UV] Feel, be conscious (sensible) of, experience. <B>1</B> (physically) (<I>sensi): ~i dolor-(sufer-varm-)on, bloveton, odoron</I>. 2 (mentally): <I>~i bezonon, feliĉon, ĝenon, plezuron. ~i lian foreston</I>, miss him. <B>3</B> f. (to be): <I>Ni ~is nin amikoj. Li sentis sin laea, (kiel) hejme</I>, at home. <B>~o</B>, -ing, perception, sense, sentiment. <I>~o de admiro, amo, timo</I>. <B>Spur~o</B>, flair. <I>Miaj ~oj estas … Esprimo de ~oj</I>. <B>~a</B>, of -ing. <B>~ebla</B>, that can be felt. <B>~emo</B>, sensibility. <I>Afekta ~emo,</I> cheap display of emotion, false sentiment, mawkishness. <I>~ema</I>, -ing, impressionabl, sensitive, susceptible, tender, thin-skinned. <I>Ofend~ema</I>, apt to take offence, sore, touchy. <I>Tro~ema</I>, hypersensitive. <I>Tiklo~ ~ema</I>, ticklish. <B>~eti</B>, be vaguely aware of. <B>~igi</B>, cause (make) to feel (be felt). <I>~igi sian aŭtoritaton</I>. <B>~iva</B>, sentient. <B>~umo</B>, (<I> ~~ senso</I>). <B>Antaŭ~o</B>, presentiment, <I>~~igi,</I> cast a shadow before, fore-bode (-shadow), portend. <B>Ek~i</B>, perceive. <B>Kun~o</B>, fellow-feeling, sympathy. <I>Esprimi ~~on kun suferanto</I>. ➞ <I>konsent, simpati</I>. <B>Ne~ema</B>, apathetic, cold, dull, hard. <B>Sen~a</B>, devoid of -ing, unfeeling, insensible. <I>~~igi</I>, render insensible, harden, stun. <I>~~igilo</I>, anaesthetic. <I>~~iĝi</I>, lose the power of feeling. <B>Tro~ema</B>, oversensitive. <B>~ofenda</B>, offensive. ➞ <I>konsci, kortuŝ, palp, percept, sentimental</I>.", "0"],
["sentimentala", "sentimental-a", "[OA] (<I>sentoplena</I>), Sentimental, soulful, swayed by feelings, mawkishly tender. <B>~i</B>, -ize. <B>~eco</B>, -ity. <B>~isto</B>, -ist. <I>~a kanto, junulino, melodio</I>.", "0"],
["sentinelo", "sentinel-o", "(<I>gardostaranto</I>), sentinel.", "0"],
["sep", "", "[UV] Seven. <B>~a</B>, 7th in order. <B>~obla</B>, 7-fold. <B>~ono</B>, 7th (fraction). <B>~opo</B>, heptad. <B>~dekjarulo</B>, septuagenarian. <B>Ĉiu~jara</B>, septennial. Sep- = hepta-.", "0"],
["sepalo", "sepal-o", "(<I>kalikfolio</I>), sepal.", "0"],
["sepio", "sepi-o", "[UV] <B>1</B> (zoo) cuttlefish (<I>Sepia</I>). <B>2</B> <I>~(kolor)o</I>, sepia, colouring from this.", "0"],
["sepsa", "seps-a", "(<I>infektohava</I>), Septic. <B>Kontraŭ</B><B>~a</B>, <I>anti-s. <B>Sen~a</B>, aseptic</I>.", "0"],
["Septembro", "Septembr-o", "[UV] September.", "0"],
["septeto", "septet-o", "[OA] septet (composition or performers).", "0"],
["septo", "sept-o", "(a. <I>septimo</I>), (intvl) seventh. <I>~o</I> <B>dominanta, minimuma. ~akordoj</B>, chords of the 7th.", "0"],
["septuaginto", "septuagint-o", "(Bb) (sepdekopa traduko), Septuagint.", "0"],
["sepulti", "sepult-i", "dispose of the dead &gt; <I>enterig, kremat</I>. ➞ <I>funeral</I>.", "0"],
["serafo", "seraf-o", "[OA] (rel) Seraph. <B>~a</B>, -ic. <B>~oj</B>, -im.", "0"],
["serajlo", "serajl-o", "[OA] seraglio, Sultan’s harem, walled palace.", "0"],
["serako", "serak-o", "serac (of glacier), ice pinnacle.", "0"],
["seratolo", "seratol-o", "saw-wort (<I>Serratula</I>).", "0"],
["serĉi", "serĉ-i", "[UV] Search. <B>1</B> be in quest of, look (hunt) for, seek, try to find (obtain): <I>Kion (Kiuri) vi ~as? ~i amikon, laboron, plezuron, subtenon, vojon, vorton. ~i en siaj poŝoj</I>, go through one’s pockets. <B>2</B> investigate, inquire into, do research work: <B>~(ad)o</B>, s., re-s, quest. <I>~o historia, scienca</I>. <B><I>~</I>anto</B> <I>al la lumo</I>, seeker after light. <B>~ata</B>, wanted. <B>~ateco</B> (<I>populareco</I>), demand, popularity. <B>~ilo</B>, (astr) finder (of telescope), (phot) view-finder. <B>~isto</B>, research-worker, detective, etc. <B>El~i</B>, ferret (seek) out, hunt, investigate. <B>Pri~i</B> (<I>iun</I>), search (for contraband, etc.). <I>La doganisto min ~~is</I>. <B>Tra~i</B>, s. all over, ransack, rummage. <I>La polico ~~is la domon</I>. <B>~lumilo</B>, s-light. <B>~mandato</B>, s-warrant.", "0"],
["serena", "seren-a", "[OA] Seren/e; calm, placid, unperturbed, unruffled, untroubled. <I>~a animo, frunto, konscienco, rideto, voĉo. ~a ĉielo</I>, cloudless sky. ~a <I>tago</I>, fine day. <B>~e</B>, calmly, with composure. <I>~a vetero</I>, bright (clear) weather. <B>~(ec)o</B>, -ity, absence of passion, calm of soul, peace (quiet) from within. <B>~igi</B>, calm, soothe. <B>~iĝi</B>, bem clear. <I>Lia frunto ~iĝis</I>. <B>Mal~a</B>, agitated, anxious, disturbed, lowering, stormy, troubled. ~<B>~igi</B>, agitate, cast a gloom over, disturb, ruffle, trouble. ➞ <I>hel, kalm, klar, mild, sennub, senvent, senzorg, trankvil</I>.", "0"],
["serenado", "serenad-o", "<B>~i</B>, serenade,", "0"],
["serĝento", "serĝent-o", "[UV] Sergeant. <B>Ĉef~o</B>, staff-s, flight-s.", "0"],
["serĝo", "serĝ-o", "(tex) serge, twilled worsted cloth. <I>Maldelikata lan~o (bajeto</I>), baize.", "0"],
["serifo", "serif-o", "(typ) serif. <B>Sen~a</B> <I>skribo</I>, sanserif.", "0"],
["serio", "seri-o", "[UV] Seri/es, sequence of similar things. <I>~o de eksperimentoj, eventoj, numeroj;</I> line, range (<I>de koloroj, varoj</I>); round (<I>de vizitoj</I>); set (<I>de verkoj</I>); spell (<I>de belaj tagoj</I>); (gm) break, run, set. <B>~a</B>, serial, -ated. <I>~a fabrikado</I>, mass-production. <B>~e</B>, -ally. <B>~igi</B>, arrange in s., standardize.", "0"],
["serioza", "serioz-a", "[UV] Serious. <B>1</B> s-minded, sober: <I>~a kiel juĝisto. ~a kostumo</I>, quiet dress. <I>~a matrono</I>, staid matron. <B>2</B> earnest, genuine: <I>Ĉu vi estas</I> ~a? Are you in earnest, Do you mean it? <I>~a homo,</I> reliable (responsible, steady) person. <I>~a propono</I>, bona-fide offer. <B>3</B> grave, important, weighty: <I>~a afero, demando, malsano, situacio. Preni</I> <B>~e</B>, take -ly. <B>~eco</B>, gravity. <I>Konservi sian ~econ</I>, keep a straight face. <I>Manko de ~eco</I>, levity. <B>Mal~a</B>, <B>Ne~a</B>, fickle, irresponsible, light, volatile. <I>~~aĵo</I>, piece of trifling. <I>~~ulo,</I> trifler. ➞ <I>bagatel, grav, senŝerc, sever</I>.", "0"],
["sero", "ser-o", "serum (of blood), <B>~odiagnozo</B>, <B>~oterapio</B>. ➞ <I>serum</I>.", "0"],
["serpentario", "serpentari-o", "(pharm) snake-root (<I>Aristolochia serpentaria</I>).", "0"],
["serpento", "serpent-o", "[UV] Serpent. <B>1</B> snake. <I>Akva (mara) ~o</I>. <B>son~o</B> [UV] (<I>krotalo</I>), rattlesnake. f <I>Dorloti ~on sur sia brusto</I>. <B>~osimila</B>, ophidian, sinuous, snaky, tortuous, wavy. <B>~ino</B>, fem. s. II (min) serpentine. <B>~i</B> (<B>~iri</B>, <B>~umi</B>), curve, meander, turn and twist, wind. <I>La rivero ~umas</I>. <B>2</B> (as, m.i.) Serpent. ➞ <I>angvis, boa, dres, kobr, kolubr, krotal, natrik, oftoglos, vipur</I>.", "0"],
["serpilo", "serpil-o", "(<I>timiano sovaĝa</I>), wild thyme (<I>Thymus serpyllum</I>).", "0"],
["serpo", "serp-o", "bill-hook, reaping-hook. <B>~eto</B>, pruning knife.", "0"],
["serpolo", "serpol-o", "(zoo) <I>Serpula</I> annelid,", "0"],
["serumo", "serum-o", "(med) serum (for injections). ➞ <I>ser</I>.", "0"],
["seruro", "serur-o", "[UV] Lock. <B>Pend~o</B>, padlock. <B>Risorta ~o</B>, spring lock. <I>Meti ~on sur pordon</I>. ~a <I>lango</I>, latch. <I>~a truo</I>, key-hole. <B>~isto</B>, 1-smith.", "0"],
["servalo", "serval-o", "(zoo) serval (<I>Felis serval</I>).", "0"],
["servi", "serv-i", "(<I>-n</I>), [UV] Serv/e. <B>1</B> be employed by (a servant of): <I>~i ĉe bakisto. ~i du mastrojn</I>. <B>2</B> (<I>helpi, utili</I>), be helpful, useful, of service: <I>Akvo kaj pano ~as al sano. ~i la movadon. Kiel (Per kio) mi povas vin ~i?</I> What can I do for you? <I>Tio povas ~i,</I> that may be of use. <B>3</B> (<I>taŭgi</I>), be suitable as (for), s. as: <I>Tio ~os kiel tablo. La branĉoj ~os por la fajro. Tio ~u kiel preteksto</I>. <B>4</B> dish up, distribute, supply with, wait on: <I>~i la tagmanĝon, ~i ĉe la tablo. Li ~is al si</I> (helped himself). <I>~i buteron al kliento, klienton per butero. ~i urbon per gaso</I>. (tennis) <I>~i pilkon</I>. <B>~o</B>, -ice, attendance, employment, function, help, ministry. <I>Je via ~o</I>, at your -ice. <I>Vi farus al mi grandan ~on</I> (word help me much), (mil) <I>~o aktiva, milita</I>. (transport) <I>~o fervoja, informa, omnibusa</I>. <B>~anto</B>, <B>~isto</B>, -ant, -itor, employee, valet, etc. <I>~antaro</I>, staff. <B>~ema</B>, attentive, obliging, kind, willing. <B>Tro~ema</B>, officious, obsequious, servile. <B>~igi</B>, employ, utilize. <B>Di~o</B>, Divine -ice. <I>Ĉeesti ~~on</I>. <B>Dom~istino</B>, domestic -ant. <B>Krom~isto</B>, extra, jobber. <I>~~istino</I>, charwoman, home help. <B>Kun~anto</B>, fellow-ant. <B>Lerno~i</B> <I>ĉe</I>, be apprenticed to. <B>Preter~o</B>, overtime. <B>Pri~i</B>, dedicate (devote) one’s to. <B>~daŭro</B>, <B>~tempo</B>, seniority of -ice. ➞ <I>deĵor, help, servic</I>.", "0"],
["servico", "servic-o", "[UV] (table-)service, set of dishes, plates, etc. <I>Arĝenta ~o</I>, plate. <I>~o deserta, kafa, tagmanĝa, tea</I>. ➞ <I>ser v</I>.", "0"],
["servuto", "servut-o", "[UV] Servitude, forced labour; bondage, serfdom, thraldom. <B>~i</B>, labour as a vassal, <B>f</B> drudge, fag, toil and moil, sweat at. <B>~eco</B>, bondage, drudgery. <B>~ulo</B>, bondservant, drudge, forced labourer, serf. <B>~odeva</B>, liable to forced labour (fatigue duty).", "0"],
["ses", "", "[UV] Six. <B>~a</B>, 6th in order. <B>~o</B> (<I>da</I>), half-a-dozen, (sctg) six (6 scouts). <B>~obla</B>, 6-tms (multiplication), sextuple, 6-fold. <B>~olo</B>, (mus) sextuplet. <B>~ono</B>, 6th (fraction). <B>~opo</B>, hexad. <B>~ope</B>, 6 at a time. <B>~dek</B>, 60. <I>~~jarulo</I>, sexagenarian. ses- = hexa-.", "0"],
["sesio", "sesi-o", "(pol) Session, sitting (<I>kunsida periodo</I>).", "0"],
["seskvi", "seskvi-", "(ch pfx) sesqui- (3 : 2). sest-o (a. <I>seksto</I>), (mus intvl) Sixth. <I>~o</I> major - (maksimum - minimum - minor - )a, Major (augmented, diminished, minor) 6th. ~akordoj, chords of the 6th. ~~o <I>aldonita (Franca, Germana, Itala, Napola).</I> . .", "0"],
["sesteto", "sestet-o", "(a. <I>seksteto</I>), sextet(te): (a) six performers, (b) music for these.", "0"],
["setario", "setari-o", "bristle-grass (<I>Setaria). ~o Itala,</I> foxtail millet.", "0"],
["severa", "sever-a", "[UV] Sever /e, hard, harsh, rigorous, stern. <I>~a rigardo, vetero, vintro</I>. <B>f</B> rigid, strict. <I>~a disciplino, fasto. ~a, sed justa</I>. <B>~e</B>, -ly. <B>~(ec)o</B> (Rd 29/20), -ity, austerity, rigour, strictness. <I>Trakti kun ~eco (esti ~a por, juĝi ~e pri</I>), be hard on. <B>Mal~a</B>, forbearing, indulgent, lenient, mild. <B>~igi</B>, augment (penalty, etc.). ➞ <I>akut, kruel, rigid, rigor, senced, senescept, senindulg</I>.", "0"],
["sevrugo", "sevrug-o", "[OA] stellated sturgeon (<I>Accipenser stellatus</I>). ➞ <I>huz, sturg</I>.", "0"],
["sezamo", "sezam-o", "Sesame. <B>1</B> (bot) (<I>Sesamus). ~a oleo</I>. <B>2</B> (of Arabian Nights).", "0"],
["sezono", "sezon-o", "[UV] Season. <B>1</B> <I>La kvar ~oj</I>. <B>2</B> Time (of the year): <I>Ban~o, ĉas~o, pluv~o, sem~o</I>. <B>3</B> (<I>ĝusta tempo). Por ĉio estas ~o</I> (Pr 3/1). <B>~a</B>, -al. Ekster~a (<I>ŝerco, vetero</I>), out of s., unseasonable, illtimed, inopportune. <B>Laŭ~a</B>, -able, in s. <B>Fru~a</B> <I>floro</I>.", "0"],
["sfagno", "sfagn-o", "(<I>marĉa musko</I>) bog-(peat-)moss, packing-moss (<I>Sphagnus</I>).", "0"],
["sfenodonto", "sfenodont-o", "tuetera (N.Z. reptile) (<I>Sphenodon</I>).", "0"],
["sfero", "sfer-o", "[OA] Spher/e. <B>1</B> globe, ball, orb. <B>f</B> <I>La ĉiela ~o</I>, celestial s. 2 (<I>medio</I>), field of action (existence), place in society. <I>~o de influo, laboro. ~o pedagogia</I>. <B>~a</B> (<B>~eca</B>, <B>~forma</B>), -ical. <I>~a geometrio</I>. <B>~ojdo</B>, -oid. <B>Duon~o</B> (<I>hemisfero</I>), hemi-s. ➞ <I>glob, kamp, region, rond, teren</I>.", "0"],
["sfingo", "sfing-o", "Hawk-moth (<I>Sphinx). Kolibra ~o</I>, humming-bird h-m. Ligustra <B>~o</B>, privet h-m. <B>~edoj</B>, sphingidae, h-m fam.. ➞ <I>atropos</I>.", "0"],
["sfinkso", "sfinks-o", "[OA] Sphinx (ant) (myth), various fabulous animals, <B>f</B> enigmatic person. <B>~a</B>, enigmatic. ➞ <I>enigm, mister, problem</I>.", "0"],
["sfinktero", "sfinkter-o", "[OA] (<I>ringa muskolo</I>), sphincter muscle.", "0"],
["sforcande", "sforcand-e", "(mus) sforzando, with sudden emphasis.", "0"],
["si", "", "[UV] (reflexive pron). Refers to the subject of the sentence (expressed or understood), but only if this is in the 3rd person. Si, sin, = him-(her-it-one-)self, themselves. <B>sia</B> [UV] = his-(her-its-their-one’s) own. <I>Li amas</I> sin <I>kaj</I> /in = himself and him (the other person). <B>Rim</B>.: Si cannot be the subject <I>P. kantas kun</I> sia (his own) <I>edzino</I>. But <I>Lia</I> (not: <I>sia) edzino kantas kun li</I>. <B>Rim</B>.: An infinity or participle, being a verb, forms a new subject understood. <I>P. petis M viziti (=ke M vizitu) lin. Mi aŭdis viron kantantan (=kiu kantas</I>) (a) <I>al</I> si (himself), (b) <I>al li</I> (= to him, the other man). (PFX) <B>Sin-</B> = self- (reflexive). <B>~defendo</B> (<I>oni defendas sin</I>). <B>~rego</B>, <B>~trompo</B>. <B>~gardo</B>, caution. <B>~mortigo</B>, suicide. <B>~teno</B>, attitude. ➞ <I>mem-</I>. <B>Rim</B>.: In the following cases <I>si</I> is not reflexive, so the above rules do not apply, (a) \"Si\" (noun) <I>estas utila vorto</I>. (b) <I>Sia (=propra</I>, one’s own). <I>Ĉio sia estas plej ĉarma. Metu ĉion en sian lokon</I> ( = its own, the right place). <B>Rim</B>.: See <I>siatempe</I> at TEMP, (c) With the stereotyped phrases inter si, per si. <I>Ili parolis inter si (= reciproke). Tion li faris per si mem (= propramove</I>), off his own bat. (d) With a <I>si</I>-compound. <I>Lia</I> sinteno <I>estis heroa</I>. <B>Siaĵo</B>, something of one’s own. ➞ <I>mem</I>.", "0"],
["sialo", "sial-o", "(ent) alderfly (<I>Sialis</I>).", "0"],
["sibarito", "sibarit-o", "<B>~a</B>, sybarit/e, -ic (luxurious and effeminate). ~ismo.", "0"],
["Siberio", "Siberi-o", ".", "0"],
["sibilo", "sibil-o", "sibylline, oracular.", "0"],
["sibli", "sibl-i", "[UV] Hiss (nt), sizzle (<I>arklampo, fritaĵo</I>); sough, whistle (<I>vento</I>); swish (<I>vipo</I>); wheeze (<I>astmulo</I>); whizz (<I>sago</I>). ~o (<I>s-sono</I>), hiss(ing), etc. <I>~o de ansero, gaso, serpento, vaporo</I>. <B>~a</B>, sibilant. <I>~a spirado</I>. (phon) <B>~aĵo</B>, <B>~a litero</B>, sibilant (s, Ŝ). (th) <B>(Pri)~i</B> (<I>-n</I>), hiss, (to express disapproval or derision), boo, hoot, give the bird to. ➞ <I>muĝ, suspir, susur, zum</I>.", "0"],
["sidera", "sider-a", "(astr) sidereal. ~a <I>horloĝo, jaro, tago</I>.", "0"],
["siderito", "siderit-o", "siderite. <B>1</B> mineral. <B>2</B> nickel-iron meteorite.", "0"],
["sidi", "sid-i", "[UV] (nt) Sit. <B>1</B> Be sitting, perched, seated: ĉe <I>la tablo, sur branĉo, trono. Forte ~as, kiu Dion fidas</I>. <B>2</B> Be in session: <I>La parlamento nun ~as</I>. <B>3</B> Remain inactive, motionless: <I>~i kiel muŝo sub balailo. Dion fidu, sed senfare ne ~u</I>. <B>4</B> (<I>troviĝi</I>), be situated:<B> <I>Malico ~as en lia koro. Kiel solece ~as la urbo! Verda stelo ~is sur lia brusto</I></B>. <B>5</B> (cl) fit, set: <B><I>La vesto ~as bone sur li</I>. ~a</B>, sedentary. <B><I>~a laboro</I>. ~(ant)a</B>, sitting, seated, (bot) sessile. <B>~aĉi</B>, lounge, sprawl. <B>~adi</B> (pore) <I>super libro</I>. <B>~ejo</B>, <B>~loko</B> (Ob/3), seat, perch, pew, setting, site. <I>~ejo de administro, de la emocioj. Ĉef~ejo</I>, headquarters. <B>~igi</B>, seat (<I>iun</I>). <B>~iĝi</B>, [UV] s. down., settle, take a seat. <I>~iĝu!</I> s. down! <I>Fale ~iĝi</I>, drop (flop) into a seat, plump down. <B>Ek~i</B>, alight, perch, s. down (momentarily). <B>kun~i</B> [UV] (<I>kunveni</I>), hold a meeting. <B>~~o</B>, session, sitting. <B>Re~iĝi</B>, s. down again, resume one’s seat. <B>Tra~i</B>, s. out (through). <B>Du~a</B>, two-seated. <B>Duon~a</B> (reclining) <I>pozicio</I>. <B>Fork~i</B>, bestride, straddle. <B>Hejm~i</B>, stay-at-home. <B>Star~i</B>, squat. ➞ <I>kov, kuŝ, seĝ, seanc, sesi</I>.", "0"],
["sieĝi", "sieĝ-i", "(<I>-n</I>), [UV] Besiege; beleaguer. <I>urbon</I>. <B>f</B> <I>~i</I> (beset, crowd or throng around ) <I>ies pordon. Danĝero ~as</I> (menaces, threatens), <I>al Dio ni preĝas</I>. <B>~(ad)o</B>, siege. <I>Ĉesigi</I> (raise) <I>~on. Stato de ~o,</I> martial law. <B>~anta</B>, besetting. <B>~ata</B>, -ed. <B>Ĉirkaŭ~i</B>, hem in. <B>Ek~i</B>, lay siege to.", "0"],
["sieno", "sien-o", "<B>Sienna</B>, <B>~o brunflava</B> (kruda), <B>raw s</B>. <B>~o ruĝbruna</B> (rostita), <B>burnt s.</B>", "0"],
["Sieraleono", "Sieraleon-o", "SL.", "0"],
["siesto", "siest-o", "<B>Siesta, midday nap</B>. <B>~i</B>, <B>take a s</B>.", "0"],
["sifiliso", "sifilis-o", "[OA] <B>(med) syphili/s</B>. <B>~a</B>, <B>~ulo</B>, <B>-tic.</B> <B>Kontraŭ~a</B>.", "0"],
["sifono", "sifon-o", "[OA] syphon. <B>1</B> (chem) apparatus with U-tube. <B>2</B> (<I>~botelo</I>), for aerated water. <B>~i</B>, s.", "0"],
["sigelo", "sigel-o", "[UV] Seal. <B>1</B> (a. <B>~aĵo</B>), s., impression or wafer: <I>Surmeti ~on</I>. <B>2</B> (<I>certigilo, indikilo</I>): <I>Tio metis la ~on al lia elekto</I>. <B>3</B> (<I>fermilo</I>): <I>Meti ~on sur la lipojn. Sub la ~o de silento</I>. <B>4</B> (<I>distingilo</I>): <I>tio portas la ~on de vero</I>. (bot) <B>~o Salomona</B> (<I>poligonato</I>). <B>~a</B> <I>ringo</I>, signet ring, <B>~i</B>, seal. <B>1</B> Affix a seal: <I>~i dokumenton</I>. <B>2</B> Close, seal up: <I>~i leteron, pordon</I>. <I>Mia buŝo estas</I> <B>~ita</B> <I>per promeso</I>. <B>3</B> confirm, prove: <I>~i amikecon, reputacion</I>. <B>~a</B>, sigillary. <B>~ado</B>, sealing, ratification. <B>~ilo</B>, seal, signet. <B>Ŝtata ~ilo</B>, privy seal. <B>Mal~i</B> (<B>Sen~igi</B>), open, unseal.", "0"],
["siglo", "sigl-o", "(<I>vortsigneto</I>), (sten) grammalogue, word-sign.", "0"],
["signalo", "signal-o", "[UV] Signal, preconcerted sign of communication, information, warning. <B>1</B> (eca): rond-(sag-triangul-)a; ~o tyialtiga, limiga (pri alto, larĝo, pezo, rapido). <B>2</B> (<I>pera</I>): ~o aŭda, diska, fajf-fajr-flag-man -vid-)a</B>. <B>3 (<I>pria</I>): ~o <I>danĝera, fervoja, ĝiba, hospitala, kruciĝa, lerneja, obstakla, trafika, transtraka, ŝtorma</I>. Krak~o, petard~o</B>, detonator, fog signal. <B>Vek~o</B>, reveille, <B>-i (<I>-n</I>)</B>, s. (a train, etc.). <B>~a lanterno</B>, s-lamp. <B>~aro</B>, code of signals. <B>~ejo</B>, s-box. <B>~isto</B>, s-man. <B>~izi</B> (route), mark out by ss. <B>Voj~oj</B>, road signs, <B>~diro, ~vorto</B>, password, watchword, slogan. ➞ <B><I>sign</I>.</B>", "0"],
["signifi", "signif-i", "(<I>-n</I>), [UV] Mean, Signif/y, betoken, denote, represent. <I>Tiu diro ~as nenion. Kion ~as tiu bruo?</I> <B>~o</B>, <B>1</B> m-ing, s-icance, s-ication: <I>La ~o de signo, vorto</I>. <B>2</B> Importance, weight, value: <I>Tiu deklaro havas grandan ~on. Kian praktikan ~on havas tio? <B>~o(plen)a</B>, <B>Multe~a</B>, s-icant, eloquent, telling, that speaks volumes</I>. <B>~a</B> <I>demando, rideto, Li levis la fingron <B>~e</B>. <B>Sen~a</B>, insignificant, of no significance, meaningless. <B>~~</B></I><B>ulo</B>, <I>person of no account, nonentity. ➞ senc, q.v</I>.", "0"],
["signo", "sign-o", "[UV] Sign, Mark. <B>1</B> indication, token, portent: <I>Bona ~o</I>, good s. <I>~o de ĝojo. Malbon~a</I>, ominous. <I>~o de malsano (simptomo</I>), sign of disease; <I>de respekto</I>, mark of respect; <I>de vero</I>, stamp of truth. <B>Lego~o</B>, <B>paĝ~o</B>, book-mark, page-marker. <B>Lim~o</B>, land-m. <B>Memor~o</B>, memento. <B>Paŝ~o</B>, <B>pied~o</B>, footprint. <B>post~o</B>, [UV] evidence, trace, vestige. <I>~~aro (spuro</I>), spoor, track, trail. <B>Prem~o</B>, impression. <B>Pruv~o</B>, sign (Ps 105/27; Jes 38/7). <B>2</B> symbol: <I>~o de amikeco</I>, token of friendship. <B>3</B> gesture, motion: <B>Kap~o</B>, nod. <B>Man~o</B>, wave of the hand, (mus) hand-s. <B>Okul~o</B>, wink. <B>Vok~o</B>, call sign(al). <B>5</B> (typ) <I>~oj matematikaj, tipografiaj. Demanda ~o (?); Ekkria ~o, Mir~o, (!); Kaj~o</I> (&amp;). <B>6</B> (mus) <B>Gam~o</B>, key signature. <B>Krom~o</B>, accidental. <B>Spir~o</B>, breath-m. <B>Takto~o</B>, time signature. <B>7</B> (<I>supersigno</I>). accent-m; <I>akuta (´); cirkumfleksa (ô); malakuta (`); onda (tildo) (˜); libera</I>, floating accent, <B>~i</B> (<I>-n</I>), <B>1</B> indicate, show: <I>~i ideon, progreson, vojon</I>. <B>2</B> (= <I>doni, fari, ~on</I>), make a s., ~i <I>al fiakristo, taksiisto</I>. <B>~ado</B>, marking. <B>~aĵo</B>, indication, token. <B>~aro</B>, system of signs, code. <I>Krajona</I> <B>~eto</B>, pencil-mark, tick. <I>Vort~eto (siglo</I>). <B>~ilo</B>, (gm) m-er, peg, etc. <B>Antaŭ~i</B>, portend. <B>Kruco~i</B>, sign with a cross. <I>Sin</I> ~~i cross one’s. <B>Lim~i</B>, delimit. <B>~olingvo</B> (<I>mimiko</I>). ➞ <I>akcent, indik, insign, mark, montr, signal</I>.", "0"],
["siklo", "sikl-o", "(Bb) shekel (coin and weight).", "1"],
["sikomoro", "sikomor-o", "sycomore-fig, fig-mulberry (of Egypt) (<I>Ficus sycomorus</I>). ➞ <I>acer, platan</I>.", "0"],
["silabo", "silab-o", "[UV] Syllab/le. <I>Ĉiu vokalo prezentas unu silabon</I>. <B>~a</B>, -ic. <B>~i</B>, -ify (➞ <I>literi =</I> spell). <I>Vorto</I> <B>du~a</B>, <B>plur~a</B>, <B>unu~a</B>.", "0"],
["sileno", "silen-o", "(bot) catch-fly (<I>Silene</I>). <B>Mar~o</B>, sea campion. <B>Puf~o</B>, bladder campion. ➞ <I>liknid</I>.", "0"],
["silenta", "silent-a", "[UV] Silen/t, tacit. <I>~a interkonsento</I>. Noiseless (<I>tajpilo, paŝo</I>); quiet (<I>vespero</I>). <B>~o</B>, -ce. <I>~o absoluta</I>, dead -ce. <I>Subita ~o</I>, sudden hush. <I>~o estas konsento. Gardi, rompi la ~on. La ~o de la morto, nokto, tombo</I>. (mus) rest. <I>Plen(not)a ~o</I>, semibreve rest. <I>Foriri, suferi</I> <B>~e</B>. <B>~i</B>, (nt) be s. <B>1</B> hold one’s tongue. <I>Saĝulo ~as</I>. <B>2</B> make no sound. <I>Se ~as draŝejo, malpacas loĝejo</I>. <B>f</B> <I>~as nun ĉiu disputo</I>. <B>~on!</B> <B>~u!</B> silence! Be quiet! Hush! <B>~adi</B>, hold one’s peace. <B>~eco</B>, hush, peace, stillness. <B>~ema</B>, discreet, quiet, reticent, taciturn. <B>~igi</B>, reduce to -ce. <I>~igi kalumnion. ~iga mono</I>, hush-money. <I>~igilo</I>, (mec) -cer. <B>~iĝi</B>, become s., <I>La muziko ~iĝis</I> (ceased). <B>Ek~i</B>, pause, stop speaking. <B>Pri~i</B> (<I>-n</I>), pass over in -ce. ➞ <I>damp, mut, senbru, senparol, senson</I>.", "0"],
["silepso", "sileps-o", "(rh) syllepsis (2 Kr 31/8).", "0"],
["silfo", "silf-o", "Sylph, spirit of the air. <B>~(osimil)a</B>, s-like.", "0"],
["silicio", "silici-o", "silicon (Si).", "0"],
["silico", "silic-o", "silica (Si 0<SUB>2</SUB>). <B>~a</B>, siliceous.", "0"],
["siliko", "silik-o", "[UV] (min) Flint. <I>Malmola kiel ~o,</I> hard as f. <B>~eca</B>, f-y. <B>~ato</B>, silicate. <I>Alkalia ~ato</I>, water glass. <B>~ero</B>, speck of f. <B>~ozo</B>, (med) -osis.", "0"],
["silikv", "", "<B>-o</B>, siliqua, pod of cruciferae, e.g., mustard, wallflower. ➞ <I>semuj, ŝel</I>. ➞ guŝo, pod of <I>fabacoj</I>, e.g., pea, bean. IT 3 FA 67/27 however says \"<I>kvin pizoj en unu silikvo\"</I>.", "0"],
["silko", "silk-o", "[UV] <B>1</B> Silk. <I>2</I> material from s. <B>f</B> <I>Vivi en ~o kaj veluro (lukse). Kruda ~o</I>, raw s. <B>~(ec)a</B>, -en, -y, like s. <B>~aĵoj</B>, silks, -en goods. <B>~aĵisto</B>, s-merchant. <B>~raŭpo</B>, -worm. ➞ <I>atlas, bombicel, kokon</I>.", "0"],
["silo", "sil-o", "(agr) Silo, fodder pit. <B>En~igi</B>, s. <B>~~o</B>, ensilage.", "0"],
["silogismo", "silogism-o", "[OA] (log) Syllog/ism. <B>~a</B>, -istic. <I>Rezoni</I> <B>~e</B>, -ize.", "0"],
["silueto", "siluet-o", "[OA] silhouette, outline-(shadow portrait, picture by contour, profile, or shadow, <B>f</B> form, outline, profile. ~o <I>de la urbo</I>. <B>~i</B>, outline. <B>~iĝi</B> (<I>sur</I>), show in outline, show up against (horizon, etc.), stand out. <I>La turoj ~iĝis kontraŭ la ruĝa ĉielo</I>.", "0"],
["siluro", "silur-o", "[UV] cat (sheat-)fish, etc. (<I>Silurus</I>). siluri-o, (geol) Silurian. <I>~a periodo</I>.", "0"],
["silvio", "silvi-o", "[UV] Warbler (<I>Sylvia</I>). <B>~o blank- gorĝa</B>, white-throat. <B>~o ĝardena</B>, garden w. <B>~o nigroĉapa</B>, black-cap. <B>~o Orfea</B>, orphean w. <B>~o rulĉirpa</B>, lesser white-throat. <B>~edoj</B>, warblers in gen; ➞ <I>akrocefal, ĉifĉaf, filoskop, fitis, hipola, lokustel</I>.", "0"],
["simbiozo", "simbioz-o", "(bio) Symbio/sis. <B>~a</B>, -tic.", "0"],
["simbolo", "simbol-o", "[OA] Symbol, object. conventionally standing for (representing) an idea, e.g., <I>pesilo = ~o de justeco</I>. <B>~a</B>, -ic. <I>~a signo (skribado</I>). <B>~i</B>, be a s. of. <I>Ruĝa rozo ~as amon</I>. <B>~ismo</B>, -ism. <B>~igi</B> (<I>prezenti</I>), -ize. <I>~igi amon per ruĝa rozo</I>. ➞ <I>emblem, figur</I>.", "0"],
["simbrankoj", "simbrank-oj", "order of eel-like fishes (<I>Symbranchia</I>).", "0"],
["simetrio", "simetri-o", "[OA] <B>~eco</B>, Symmetr/y. <B>~a</B>, -ical (Jeĥ 41/21). <I>~a aspekto (konstruo). Aranĝi</I> <B>~e</B>. <B>Ne~a</B>, a-ical, lop-sided.", "0"],
["simfito", "simfit-o", "(bot) comfrey (<I>Symphytum</I>).", "0"],
["simfonio", "simfoni-o", "[OA] (<I>orkestra sonatego</I>), Sym- phon/y. <B>~a</B>, -ic.", "0"],
["simforikarpo", "simforikarp-o", "snowberry (<I>Symphoricarpos</I>).", "0"],
["simila", "simil-a", "(<I>al, je</I>) [UV], Simil/ar (to), (a)like, with same qlties. (geom) <I>~aj trianguloj</I>. <B>~e</B>, -arly, likewise, the same. <B>~i</B> (<I>esti ~a</I>), be like (s. to), match, resemble. <I>Ili ~as unu la alian kiel du rosgutoj</I>. <B>~aĵo</B>, something similar <B>~eco</B>, -arity, -itude, likeness. <B>~igo</B>, (rh) simile. <B>~igi</B>, iĝi, asate, make (get) like. <B>~ulo</B>, double. <B>Mal~a</B> (<I>diferenca</I>), dis-s, unlike. <I>~~eco</I>, contrast, diffce. <B>Sen~a</B>, unique, without a fellow. <B>Fulmo~a</B>, like lighting. <B>Sonĝo~a</B>, dreamlike. <B>Ver~eco</B>, veri-itude. ➞ <I>analog, parenc, proksim, sam</I>.", "0"],
["simio", "simi-o", "[UV] Ape, Monkey. <B>~(ec)a</B>, a-like, simian. <B>~i</B> (<I>agi</I> <B>~e</B>), ape, imitate like a monkey. ~i <I>nobelan sintenon</I>. ➞ <I>aluat, atel, ceb, cerkopitek, ĉimpanz, gibon, goril, kolob, lagotrik, makak, mandril, orangutang, pavian</I>.", "0"],
["simonio", "simoni-o", "(ecc) simony.", "0"],
["simpatio", "simpati-o", "[OA] Lik/e, -ing; Congenial/ity, Sympath/y (in this sence only), affinity, fellow-feeling, instinctive attraction <I>[Ne= kunsento]. Havi ~on por</I>, like, feel drawn (cotton, take, warm) to (Es 2/17; 8/5). <I>~oj kaj antipatioj</I>, likes and dislikes. <I>Plena de kunsento kaj ~o</I>, with similar feelings and tastes. <I>La du ideoj (virinoj) ne estas en ~o</I>, don’t go together, have nothing in common. <B>~a</B> (<I>al, por</I>), likeable, with tastes in common, in s. with, kindred-souled, to one’s liking. <I>~a homo, junulo</I> (Da 10/19). <I>~a medio</I>, c. surroundings. <I>~a vizaĝo,</I> attractive face. <I>Por mi la tasko estas tre ~a</I> (c.). <I>Por mi ŝi ne estas ~a</I>, I don’t like. (care for, feel drawn to, take to) her, am not at ease (don’t feel at home, have little in common) with her. (anat) <I>~a nervo</I>, s-etic nerve, (ac) <I>~a vibrado,</I> s-etic vibrato. <B>~i</B>, be in accord with, feel a liking (have a fellow-feeling) for. <I>Ni ne ~as</I>, don’t see eye to eye. <I>Li ~as nian movadon (al nia movado</I>). <B>~e</B>, c-ly. <B>Mal~a</B> (<I>antipatia</I>), repugnant. <B>~~o</B>, antipathy, aversion, repugnance. <B>Ne~a</B>, unattractive. ➞ <I>kompat, kondol, konsent</I>.", "0"],
["simpla", "simpl-a", "[OA] Simpl/e. <B>1</B> not compound: <I>~a vorto</I>, (gram) <I>~a tempo</I>, simple tense. <B>2</B> plain, uncomplicated: <I>~a prudento</I>, elementary commonsense. <I>~a maŝino. ~aj faktoj,</I> broad (plain) facts. <B>3</B> easy to understand: <I>~a metodo, problemo, procedo, rimedo, tasko</I>. <B>4</B> unembroidered, without affectation or ornament: <I>~a stilo, vesto. ~a manĝo,</I> homely meal. <I>La vero pura kaj ~a</I>. <B>5</B> (<I>nura</I>), common, ordinary, mere: <I>~a homo</I>, plain man, man in the street. <I>~a soldato</I>, private. <I>~a tago</I>, week-day. <B>6</B> Artless, naive: <I>~a kiel kolombo</I>. <B>~e</B>, <B>1</B> –y &gt; just, merely, only: <I>Mi ~e diris</I>, I merely observed. <I>La decido restas ~e malviva litero</I>. <B>2</B> Plainly: <I>Vivi (sin vesti) ~e</I>. <B>~eco</B>, -icity. <B>~igi</B>, -ify. <I>Tro~igi</I>, over s-ify. <B>~ulo</B>, s-minded person. <B>Mal~a</B>, complex, complicated, compound. ➞ <I>facil, naiv</I>.", "0"],
["simpozio", "simpozi-o", "symposium, discussion of a subject by various authors.", "0"],
["simptomo", "simptom-o", "[OA] Symptom, indication, sign, token. <B>~a</B> <I>pri</I>, -atic of. ➞ <I>antaŭsign, indik</I>.", "0"],
["simuli", "simul-i", "Simul/ate, counterfeit, feign, sham. <B>~i</B> <I>malsanon</I>, malinger. <B>~ado</B>, -ation. <B>~ita</B>, bogus. ➞ <I>ŝajnig</I>.", "0"],
["simulio", "simuli-o", "(ent) sand-fly (<I>Simulium</I>).", "0"],
["simultana", "simultan-a", "simultaneous (<I>funkcianta, okazanta, samtempe</I>). <B>~a</B> <I>tradukado</I>. <B>~aj</B> <I>ekvacioj</I>.", "0"],
["simuno", "simun-o", "(met) simoon (Araba polvovento).", "0"],
["sinagogo", "sinagog-o", "[OA] synagogue.", "0"],
["sinapo", "sinap-o", "[OA] Mustard-plant (<I>Sinapis</I>). <B>~o blanka</B>, white m. <B>~o nigra</B>, black m. <B>~o sovaĝa</B>, charlock. <B>~a</B> <I>faruno</I>, m-powder. <I>~a semeto, semero de ~o</I>, grain of m-seed (Mt 13/31; 17/20). ➞ <I>iperit, kataplasm, mustard</I>. <B>Rim</B>.: <I>Blanka ~o</I> is the m. of \"mustard and cress\".", "0"],
["sincera", "sincer-a", "[UV] Sincer/e. <B>1</B> (<I>iu</I>): candid, frank, honest, without hypocrisy. <I>~a homo</I>. <B>2</B> (<I>io</I>): genuine, truthful, unfeigned. <I>~a amo, bedaŭro, deziro, konvinko, opinio, respondo</I>. <B>~eco</B>, -ity, candour, good faith. <B>Mal~a</B>, deceitful, double-deahng, false, two-faced. <B>~~aĵo</B>, in-ity, piece of hypocrisy. ➞ <I>diafan, pur, verem</I>.", "0"],
["sindikato", "sindikat-o", "<I>[OA]</I>, syndicate. <B>1</B> = sindikaro. <B>2</B> Union to defend corporate interests. <B>Financa ~o</B>. <B>Industria ~o</B>, pool. <B>Profesia (laborista</B>, <B>metiista) ~o</B>, Trade Union. <B>~o de fabrikistoj</B>, union of manufacturers. <B>~ano</B>, trade-unionist. <B>~aneco</B> deviga, closed shop. <B>~iĝi</B>, combine into a u. <B>~ismo</B>, <B>~isto</B>. <B>Ekster</B><B>~a</B>, non-u. ➞ <I>kolektivism, komunism, socialism</I> [Ne= kartel, trust].", "0"],
["sindiko", "sindik-o", "syndic (wide sense), especially authorized representative of corporate body, (jur) trustee, receiver in bankruptcy.", "0"],
["sinedrio", "sinedri-o", "[OA] (hist) Sanhedrim, Jewish tribunal.", "0"],
["sinekdokeo", "sinekdoke-o", "(<I>ideoŝanĝo</I>), (rh) synechdoche = (a) the whole used for a part, or the genus for the species; (b) the part used for the whole, or the genus for the species (Vd <I>Klasifo de Esperanto. Temoj,</I> pp. 99-100).", "0"],
["sinekuro", "sinekur-o", "sinecure, office with salary but no duties.", "0"],
["Singapuro", "Singapur-o", "SG.", "0"],
["singnato", "singnat-o", "(<I>mar-aleno</I>), (ich) pipe-fish,", "0"],
["singulara", "singular-a", "(<I>ununombra</I>), (gram) singular (number).", "0"],
["singulti", "singult-i", "[UV] hiccough, have hh. <B>Plor~i</B>, sob convulsively.", "0"],
["sinjoro", "sinjor-o", "[UV] <B>1</B> gentleman. <B>2</B> (title) Esq., Mr. <I>S-ro B</I>. <B>3</B> master. <I>Li estas sia propra ~o. 4</I> (rel) <I>La S~o</I>, The Lord (Ge 18/27, El 15/17, Jes 30/15). <B>Rim</B>.: In early writings Z. avoided this form (OV/52). <B>~(ec)a</B>, lordly. <I>La ~a preĝo. Lia ~a moŝto</I>, his lordship. <B>~aro</B>, gentry. <B>~eto</B>, <B>~ido</B>, (young) master. <B>~ino</B>, lady, madam, mistress. <I>~inoj kaj ~oj!</I> <B>S~ino</B>, Mrs. <I>Ŝia ~ina moŝto</I>, my lady. <B>Ge~oj</B> (Ges.), Mr. and Mrs. <B>Grand~o</B>, lord (of manor), seigneur. ➞ <I>kavalir, lord</I>.", "0"],
["sinki", "sink-i", "Sink, fall slowly. <B>1</B> descend to below horizon or surface of fluid, go down., set (<I>la suno, ŝipo, ~is</I>). <B>2</B> settle, subside (<I>rivero, tero</I>). <B>f</B> decline, become weaker (<I>koro, malsanulo, vivo</I>). <B>~igi</B>, (cause to) sink, scuttle (<I>ŝipon</I>). ➞ <I>malflot, penetr, sorb, subsid, vrak</I>.", "0"],
["sinkopo", "sinkop-o", "[OA] <B>1</B> Syncop/e, fainting, loss of consciousness from fall of blood-pressure. <B>2</B> (mus) <B>~i</B>, -ate. <B>~ado</B>, -ation, intentional misaccent. <B>3</B> (phon) = <I>haplologio</I>.", "0"],
["sinkrona", "sinkron-a", "(<I>sammomenta, samtempa</I>), Synchronous, occurring at the same time, simultaneous. <B>~igi</B> (<I>samtempigi</I>), -ize. <B>~igo</B>, -ization.", "0"],
["sino", "sin-o", "<B>1</B> Bosom, breast (Se 6/27; 21/14; Ps 79/12). <I>Si premis la infanon al sia ~o. Sur la ~o de Abraham</I> (Lk 16/22). <B>2</B> clothing covering this (El 4/6). <B>f</B> (<I>internaĵo). Mi estis ankoraŭ en la ~o de mia patrino. La ~o de la estonteco, familio, tero</I>. ➞ <I>brust, genu, mam, ventr</I>.", "0"],
["sinodo", "sinod-o", "[OA] (ecc) synod, council.", "0"],
["sinonimo", "sinonim-o", "[OA] synonym, word with same meaning. <B>~a</B>, -ous. <I>Preskaŭ ~a</I>.", "0"],
["sinoptika", "sinoptik-a", "[OA] synoptic, giving a comprehensive mental view. ~a <I>tabelo</I>. ~aj <I>evangelioj</I> (Mt, Mk, Lk).", "0"],
["sinovio", "sinovi-o", "(anat) synov/ia. <B>~a</B>, -ial. <B>~ito</B>, -itis.", "0"],
["sintakso", "sintaks-o", "[OA] (gram) Synta/x, sentance constructs. <B>~a</B>, -ctic.", "0"],
["sintezo", "sintez-o", "[OA] Synthe|sis. (chem) artificial production of compound. <I>Foto~o</I>. (gram) con- struction of compound word. <B>~a</B>, -tic. <I>~a rezonado (de kaŭzo al efiko</I>). <B>~i</B>, -size. ➞ <I>kunmet</I>. Opp <I>analiz</I>.", "0"],
["sinuso", "sinus-o", "[OA] <B>1</B> (trig) sine (sin). <B>2</B> (anat) sin/us. <B>~ito</B>, -itis.", "0"],
["sirenio", "sireni-o", "(<I>marbovo</I>), sea-cow (<I>Sirenia) &gt; dugong, manat</I>.", "0"],
["sireno", "siren-o", "[OA] Siren, <B>1</B> (myth). <B>2</B> dangerously fascinating woman. <B>3</B> (ac) (mar) hooter, e.g., <I>ĉe aeratako, fabrikejo</I>.", "0"],
["siriko", "sirik-o", "(ent) horntail, wood-wasp (<I>Sirex</I>).", "0"],
["siringo", "siring-o", "[UV] lilac (<I>Syringa). ~obruna,</I> puce. <B>~(viol)a</B>, lilac. ➞ <I>filadelf, lil</I>. <B>Rim</B>.: On various pp of 4 FA <I>~o</I> should be <I>sambuko</I>.", "0"],
["Sirio", "Siri-o", "[OA-8] SY, Syria.", "0"],
["siroko", "sirok-o", "(met) sirocco, hot Sahara wind (Jes 49/10).", "0"],
["siropo", "sirop-o", "[UV] syrup, solution of sugar. <B>~(ec)a</B>, -y. <B>Rafinita ~o</B> (<I>melaso</I>), golden syrup.", "0"],
["sisalo", "sisal-o", "Sisal-grass (<I>Agave sisalina</I>). <B>~a</B> <I>fibro, s-hemp</I>.", "0"],
["sismo", "sism-o", "= seismo.", "0"],
["sistemo", "sistem-o", "[F], System. <B>1</B> complex whole, harmonious combination, group. <I>~o digesta, fervoja, lumiga, serva, suna</I>. <B>2</B> orderly arrangement, plan, scheme: <I>Metra ~o. ~o de klasifo, regado</I>. <B>~a</B>, -atic. <B>~e</B>, -atically. <I>~e venki ĉiun baron</I>. <B>~eco</B>, -atization. <B>~igi</B>, -atize.", "0"],
["sistolo", "sistol-o", "Systol/e, contraction of heart. ➞ <B><I>distol</I></B>.", "0"],
["sistro", "sistr-o", "(ant) sistrum, Egyptian jinglg m.i. (2 Sa 6/5).", "0"],
["sitelo", "sitel-o", "[UV] Bucket, Pail. <I>Lakto~o</I>, milk- p. (<I>Plen)~o (da</I>), b-(p-)ful. f <I>Pluvi</I> <B>~e</B>, <B>~portilo</B> (<I>vekto</I>), yoke.", "0"],
["sito", "sit-o", "(orn) nuthatch (<I>Sitta</I>).", "0"],
["situacio", "situaci-o", "[UV]<B>, 1</B> Circumstances, state of affairs. <B>~o danĝera, komika, nova, plorinda, politika. ~o financa</B>, financial standing. <B>~o malfacila</B>, predicament. <B>~o socia</B>, social status, station in life. <B>Esti en ~o</B> (<I>position) ion fari. Mastri, plibonigi, savi la ~on. Klarigi la ~on</I>, explain the circumstances, put the case. <B>2</B> (<I>= situo), position</I>. ➞ <I>lok, ofic, posten, pozici, stat</I>.", "0"],
["situo", "situ-o", "Situat/ion, position, site. <B>~i</B>, (nt) be -ed. <I>Urbo bele ~anta, Nia tendaro ~is en valo</I>. <B>~igi</B>, locate, place.", "0"],
["siumo", "sium-o", "water parsnip (<I>Sium</I>).", "0"],
["sizigio", "sizigi-o", "(mat) syzygy. (astr) conjunction or opposition.", "0"],
["sizimbrio", "sizimbri-o", "(bot) hedge-mustard (<I>Sisymbrium</I>). ➞ <I>aliari, erizim</I>.", "0"],
["skabelo", "skabel-o", "(<I>piedbenketo</I>), footstool.", "0"],
["skabeno", "skaben-o", "(hist) municipal magistrate, sheriff.", "0"],
["skabio", "skabi-o", "[UV] (bt, med) scabies, itch, infection caused by mite (<I>akaro, sarkopto</I>) (Rd 28/27); (vet) mange. <B>~a</B>, mangy. ➞ <I>fav</I>.", "0"],
["skabiozo", "skabioz-o", "(bot) Scabious, pincushion ffwr (<I>Scabioza</I>). ~o kampa, field (meadow) s. ~o kolomba (<I>knaŭtio</I>), small s. ~o mordita (<I>sukcizo</I>), devil’s bit, premorse s. (<I>succisa</I>).", "0"],
["skabo", "skab-o", "(bot) symptom of plant disease caused by bacteria or fungus. ➞ <I>skabi</I>.", "0"],
["skadr(on)o", "", "[UV] squadron (of cavalry). <I>[Ne= eskadro]</I>.", "0"],
["skafaldo", "skafald-o", "(<I>provizora framo, trabaro</I>), Scaffolding. <B>~i</B>, erect s.", "0"],
["skafandro", "skafandr-o", "diving-suit. <I>~o sendependa,</I> aqualung. <B>~isto</B>, diver.", "0"],
["skalena", "skalen-a", "(<I>triangulo</I>), scalene (<I>kun lateroj neegalaj</I>).", "0"],
["skalo", "skal-o", "[UV] Scale (wide sense). <B>1</B> graded series, ladder: <I>~o intelekta, socia. Supre de la ~o</I>. <B>2</B> relative dimensions, ratio of reduction or enlargement: <I>~o de mapo, prezoj, filantropio. Grand</I><B><I>~e</I></B>, on a large s. <I>~o reduktita, Varia ~o</I>, sliding s. <I>Laŭ ~o</I> 1/1000. <B>3</B> graduated degree-marks: <I>~o de barometro, termometro. Tajd~o</I>, tide gauge. <B>4</B> (mus) s., succession of tones and semitones from a sound to its octave: <I>~o mafora, minora; diatona, kromata; cigana, plenduta. ~o kvinnota</I>, penttonic s. (d r m s 1). <B>5</B> system of numeration: <I>~o decimala (dekuma</I>). <B>Laŭ~e</B>, to s. <B>~papero</B>, squared (plotting) paper. ➞ <I>ampleks, gam, mezur</I>.", "0"],
["skalpelo", "skalpel-o", "(<I>sekcilo</I>), (surg) scalpel &lt; <I>bisturi</I>.", "0"],
["skalpo", "skalp-o", "[OA] <B>~i</B>, Scalp. <B>~ilo</B>, -ing knife.", "0"],
["skandalo", "skandal-o", "[OA] Scandal, Disgrace, evil example. <I>Estas ~o! ~e!</I> (It is) d-ful! <I>Fari (Kaŭzi) ~on</I>, create a scene. <I>Eviti ~on,</I> avoid public exposure. <I>Por dies ~o</I>, to everyone’s horror. <B>~a</B>, s-ous, d-ful, discreditable, shameful, shocking. <I>~a afero, konduto</I>. <B>~i</B> (<I>-n</I>), scandalize, cause (give) grave offence, shock. <B>~iĝi</B>, be shocked. <B>~ulo</B>, s-monger.", "0"],
["skandi", "skand-i", "(<I>-n</I>), (pros) Scan, divide (a line of verse). <B>~o</B>, -sion.", "0"],
["skandiko", "skandik-o", "(<I>Venuskombilo</I>), Shepherd’s needle, Venus’ comb (<I>Scandix</I>).", "0"],
["skandio", "skandi-o", "(chem) scandium (Sc).", "0"],
["skapolo", "skapol-o", "[UV] shoulder-blade. <B>~a</B>, scapular.", "0"],
["skarabo", "skarab-o", "[UV] Beetle, scarab. <B>~edoj</B>, dung-bb and chafers. ~o Kolorada <B>(terpoma)</B>, Colorado b. <B>Or~o</B> (<B><I>krizomelo</I>)</B>, golden b. <B>Salt~eto</B>, flea-b. <B>Sterko~o</B>, dung-b &gt; <B>geotrupo</B>. ➞ <B><I>ditisk, karab, kokcinel, kurkuli, lampir, lukan, melolont, nekrofor</I></B>.", "0"],
["skardinio", "skardini-o", "(ich) rudd, red-eye (<I>Seardinius</I>).", "0"],
["skarifi", "skarif-i", "Scarif/y, cut through skin. ~a <I>kupo</I>. <B>~ado</B>, -ication. <B>~ilo</B>, -ier.", "0"],
["skarlata", "skarlat-a", "[UV] Scarlet.", "0"],
["skarletino", "skarletin-o", "[OA] (med) s-fever, scarlatina.", "0"],
["skarpo", "skarp-o", "[UV] <B>1</B> Scarf. <I>Silka ~o</I>. <B>2</B> chain of office, municipal s. <B>3</B> (surg) arm-sling.", "0"],
["skatolo", "skatol-o", "[UV] Box, tin (various shapes and materials). <B>Kartona ~o</B>, carton, card-board box. <B>Lad~o</B>, tin. <B>Mon~o</B>, money-box. (mus) <B>Muzika ~o</B> (<I>pinglogurdeto</I>), musical box. <B>~eto</B>, casket, jewel-case. <I>~eto alumeta, pilola</I>. <B>En~igi</B>, pack.", "0"],
["skeĉo", "skeĉ-o", "(th) sketch.", "0"],
["skeleto", "skelet-o", "[OA] skeleton, (anat) <I>ostaro</I>. <B>f</B> a very thin man. <B>2</B> (<I>framo</I>), frame(work) (of building, ship, umbrella, etc.). <B>3</B> (<I>skiza piano</I>), outline. <B>~a</B>, bony, fleshless, thin, sketchy. <I>~a kesto</I>, crate. ➞ <I>armatur, skiz, resum</I>.", "0"],
["skemo", "skem-o", "[OA] Schem/e, systematic arrangement, lay-out, plan of action, programme, table, (typ) <I>Paĝa ~o</I>, make-up. <B>~i</B>, make plans. ➞ <I>diagram, grafikaf, plan, projekt, skelet, skiz</I>.", "0"],
["skeptika", "skeptik-a", "[OA] Sceptic/al, incredulous, <B>~eco</B>, <B>~ismo</B>, <B>~ulo</B> (Ps 119/113). ➞ <B><I>dubema, senkredema, malfacile konvinkebla</I></B>.", "0"],
["skerco", "skerc-o", "[OA] (mus) scherzo, light playful composition.", "0"],
["skermi", "skerm-i", "[UV] (sp) Fenc/e, fight with swords. <B>~ado</B>, <B>~arto</B>, -ing, swordplay. <B>~anto</B>, -er, swordsman. <B>~ejo</B>, -ing ground. <B>~isto</B>. -ing-master.", "0"],
["sketi", "sket-i", "(a. <I>patini</I>), Skat/e. <B>~ado</B>, -ing. <B>~anto</B>, -er. <B>~ilo</B> (<B>~ŝuo</B>), s. <B>~vojo</B>, s-ing track. <B>Rul~i</B>, roller-s. <B>~~ilo</B> (<I>rulŝuo</I>), <B>~~ejo</B>, s-ing rink.", "0"],
["skieno", "skien-o", "(<I>aglofiŝo</I>), meagre (<I>Sciaena</I>).", "0"],
["skilio", "skili-o", "(ich) spotted dogfish (<I>Scyllium</I>).", "0"],
["skilo", "skil-o", "(bot) Squill (<I>Scilla). ~o aŭtuna,</I> autumn s. <I>~o printempa</I>, spring s. ➞ <I>hiacint</I>.", "0"],
["skinko", "skink-o", "skink (<I>Scincus</I>) (Le 11/30).", "0"],
["skio", "ski-o", "Ski. <B>~(kur)i</B>, s. <B>~ado</B>, -ing. <B>~anto</B>, <B>~isto</B>, -er. <B>~bastono</B>, s-stick.", "0"],
["skipi", "skip-i", "(<I>ŝnursalti</I>), (gm) Skip. <B>~ilo</B>, -ping rope.", "0"],
["skismo", "skism-o", "[OA] Schism, break-up, division, separate by diffce of opinion. <B>~(em)a</B>, <B>~ilo</B>, -atic. <B>~i</B>, <I>fari ~on</I>. ➞ <I>fend, romp</I>.", "0"],
["skisto", "skist-o", "(geol) schist. <B>~(ec)a</B>, schistaceous, flaky. ➞ <I>ardez</I>.", "0"],
["skizo", "skiz-o", "[UV] Draft, Outline, Sketch. <B>1</B> quick drawing in a few characteristic lines. <B>2</B> d., o. <I>Literatura ~o</I>. <B>3</B> draft (summary) of plan. <I>~o teoria. Jen ~o de miaj ideoj. Unua ~o</I>, rough d. <B>~(ec)a</B>, s-y. <B>~i</B> (<I>fari ~on pri</I>), d., o., s., rough out. <I>~i biografion, planon, konturon. ~i grandtrajte</I>, give the main outlines of. <B>~eco</B>, rudimentary character ➞ <I>kontur, krokiz, malnet, skelet, skem</I>.", "0"],
["skizofrenio", "skizofreni-o", "(med) schizophrenia. <B>~ulo</B>.", "0"],
["sklavo", "sklav-o", "[UV] Slav/e. <B>1</B> (bond-man-servant). <B>2</B> subject of despotic regime. <B>3</B> person unconditionally obedient to the will of another. <B>f</B> <I>~o al kutimo (pasio), alkoholo (tabako), la modo</I>. <B>~a</B>, -ish, servile. <B>~e</B>, -ishly. ~i (<I>esti ~o, labori ~e</I>), s., drudge. <B>~eco</B>, slavery, bondage, servitude. <B>~emo</B>, servility. <I>~ema</I>, cringing, fawning, mean, servile. <I>~emulo</I>, toady. <B>~igi</B>, en-s. <B>~ino</B>, bondwoman. <B>~isto</B>, -er, -driver, -trader. <B>Eks~o</B>, freed slave. ➞ <I>servut</I>.", "0"],
["sklera", "skler-a", "Scler/ous, bony, hard. <B>~oza</B>, -otic, with hardened blood-vessel. <B>~ozo</B>, morbid hardening. <I>Arteria ~ozo</I>.", "0"],
["skleranto", "sklerant-o", "(bot) knawel (<I>Scleranthus</I>).", "0"],
["skleroto", "sklerot-o", "(anat) scler/a, membrane over eye-ball. <B>~ito</B>, -itis.", "0"],
["skolastiko", "skolastik-o", "[OA] Scholastic/ism. <B>~a</B>, -ic. <I>~a teologio</I>. <B>~ulo</B>, schoolman.", "0"],
["skoldi", "skold-i", "scold, call over the coals, chide, find fault noisily with, give a wigging to, reprimand, rate. ➞ <I>insult</I>.", "0"],
["skolito", "skolit-o", "(ent) wood-boring beetle (<I>Seolytus</I>).", "0"],
["skolo", "skol-o", "[OA] School (of art, philosophy, thought). <I>La ~o Itala, Sokrata</I>. <B>~ano</B>, disciple, follower <I>[Ne= lernejo]</I>, ➞ <I>adeptaro</I>.", "0"],
["skolopendro", "skolopendr-o", "centipede (<I>Seolopendra</I>).", "0"],
["skolopo", "skolop-o", "[UV] woodcock (<I>Scolopax</I>). ➞ <I>galinag</I>.", "0"],
["skolto", "skolt-o", "(mil) Scout. <B>~i</B>, s., reconnoitre. ~a <I>aviadilo</I>. (sctg) scout, (11-15 yrs). <B>~ado</B>, <B>~ismo</B>, <I>~a movado</I>, s-ing. <B>~estro</B>, s-er (adult leader). <B>~ino</B>, guide. <I>~inestro,</I> guider. ➞ <I>esplorrigard, spion</I>.", "0"],
["skombro", "skombr-o", "mackerel (<I>Scomber</I>).", "0"],
["skono", "skon-o", "(cul) scone.", "0"],
["skopo", "skop-o", "(orn) hammer-head(ed stork) (<I>Scopus</I>).", "0"],
["skorbuto", "skorbut-o", "[UV] (med) scurvy. <B>~a</B>, <B>~ulo</B>, scorbutic.", "0"],
["skorio", "skori-o", "(<I>erc-rekremento</I>), scoria, cinders, clinker, dross, slag (from furnace), <B>f</B> (<I>= forĵetindaĵo, senvaloraĵo): Via arĝento fariĝis ~o</I> (Ps 119/119; Jes 1/22, 25). <B>~ejo</B>, ash-heap. ➞ <I>rekrement</I>.", "0"],
["skorpeno", "skorpen-o", "scorpion fish (<I>Scorpaena</I>).", "0"],
["skorpio", "skorpi-o", "[UV] (as, zool) Scorpion (<I>Scorpio</I>). ~o imperia, Imperial s. ➞ <I>skorpen</I>.", "0"],
["skorzonero", "skorzoner-o", "viper’s grass (<I>Scor- zonera</I>).", "0"],
["Skotlando", "Skot-lando", ".", "0"],
["skovelo", "skovel-o", "bottle-(flue-oven-)brush, bristle-brush, cleaning-brush. <B>~i</B>, clean (brush) out cylindrical objs, sweep (<I>kamentubori). ~i botelon, fornon</I>. ➞ <I>ŝvabr</I>.", "0"],
["skrapi", "skrap-i", "(<I>-n</I>), [UV] <B>1</B> Scrape (<I>terpomon</I>); graze (<I>haŭtori</I>); scale (<I>dentori</I>). <B>2</B> make a disagreeable noise. <I>~i al ni la orelojn, ~i violonon</I>, s. (saw) on the fiddle. <B>~aĵo</B>, scrapings, shavings. <B>~egi</B>, drag, dredge. ➞ <I>drag</I>. <B>~ilo</B>, -er, eraser, (surg) curette. <I>Kot~ilo,</I> <B><I>ŝ</I></B><I>u~ilo</I>, -er. <B>~reta</B> <I>ŝipo</I>, trawler. <B>~vundo</B>, abrasion. <I>Ĉiel~(Nub~)\\Ao</I>, sky-er very high building. <B>De~i</B>, <B>for</B>~i (<I>koton</I>), s. off. <B>Pri~i</B> (<I>domon</I>) (Le 14/41). ➞ <I>frot, grat, rasp</I>.", "0"],
["skribi", "skrib-i", "[UV] Writ/e. <B>1</B> (nt) <I>Li scias nek legi, nek ~i ink-(legebl-)e, laŭ dikto</I>. <B>2</B> (<I>-n</I>) (verki), jot down, note. <I>~i anekdoton, leteron, karton. Mi tion ~os al li</I>. <B>3</B> record. <I>Kion mi ~is, tion mi ~is</I>. <B>~(ad)o</B>, -ing. <I>~o oblikva</I>, cursive hand. <I>Diron oni neas, ~o</I> (record in black and white) <I>ne pereas. La Sankta ~o</I>, Holy Writ. <B>~(it)a</B>, <B>per~a</B>, -ten, script. <I>~a komuniko</I>. (typ) <I>~aj literoj</I>, script type. <B>~aĉi</B>, <B>~aĉo</B>, scrawl, scribble. <B>~anto</B>, <B>~isto</B>, -er, clerk, scribe. <I>~istaĉo</I>, hack. <B>~ejo</B>, -ing-room. <B>~enda</B>, that must be -ten. <B>~ilo</B>, -ing implement, pen, etc. <I>~ilaro</I>, <B> ing</B> materials. <I>~ilujo</I>, pen box. <B>~eraro</B>, slip of the pen. <B>~karaktero</B>, <B>~maniero</B>, hand. <B>~maŝino</B> (<I>tajpilo</I>). <B>~tablo</B>, -ing desk. <B>Al~i</B>, assign, attribute, charge, put down to. <B>ĉirkaŭ~i</B>, [UV] circumscribe. <B>En~i</B>, book, enter, inscribe, post up, record, register. <I>Mi en~os la sumon en vian krediton. En~iĝi</I>, enter, enrol one’s. <B>Mis~i</B>, miswrite. <B>Post~o</B>, postscript. <B>Pri~i</B>, describe (by speech or -ing). <I>~~a muziko</I>, programme music. <B>Re~i</B>, re-w., copy. <B>Sub~i</B>, sign (one’s name) [<I>Ne~~abon, kotiz]. Apude ~~i,</I> countersign. <B>Super~i</B>, w. over other words. <B>Sur~i</B>, engrave, inscribe etc. <B>Trans~i</B>, copy out, transcribe. <B>Man~o</B>, hand-ing. <B>Maŝin~i</B> (<I>tajpi</I>), type. <B>Pet~o</B>, petition. <B>Pun~o</B>, imposition, lines. ➞ <I>kaligrafi, pupitr, verk</I>.", "0"],
["skrofolo", "skrofol-o", "[UV] (med) scrofula, king’s evil. <B>~a</B>, -ous. <B>~ulo</B>.", "0"],
["skrofulario", "skrofulari-o", "figwort (<I>Scrophularia</I>). Akva <B>~o</B>, water f. skrot-o, (anat) scrotum.", "0"],
["skrupulo", "skrupul-o", "[OA] Scrup/le, Conscien/tious objection, doubt, or hesitation. <I>Havi ~ojn pri</I>, have scruples about, be troubled by qualms of conscience, boggle (demur) at. <B>~i</B>, be meticulous, nice, make a point of. <B>~(em)a</B>, c., s-ulous, punctilious. <I>~a atento, esploro, persono, pureco</I>. <B>~e</B>, s-ulously. <I>~e ĝusta</I>. <B>Sen~a</B>, uns-ulous. <I>Agi</I> <B>sen~e</B>, stick at nothing. ➞ <I>honest, pedant, preciz, zoring</I>.", "0"],
["skualo", "skual-o", "(met) squall, sudden gust of wind.", "0"],
["skui", "sku-i", "(<I>-n</I>), [UV] Shak/e. ~i <I>arbon, skatolon, veston. ~i la kapon (nee</I>, from side to side); wag (<I>voston</I>); wave (<I>flagon</I>), <B>f</B> (<I>ŝanceli</I>): unsettle, upset, weaken. <I>~ita</I> (buffeted) <I>de la vento, de malsano. ~i iun elrevige. La Eternulo ~as la mondon. ~u vin!</I> S. yourself together, get a move on! <B>~(ad)o</B>, -ing, shock. <I>~o cerba</I>, shell-shock, etc. <B>~iĝi</B>, be -en. <I>~iĝi</I> (toss) <I>sur la lito. Eĉ folio ne ~iĝis</I>, not a leaf stirred. <I>~iĝi</I> (quiver, shiver, thrill) <I>de emocio</I>. <B>~ilo</B> (<I>~botelo, ~maŝino</I>), s-er. <B>~lavi</B>, rinse. <B>De~i</B> <I>polvon de vesto, pomon de arbo</I>. <B>Ek~i</B>, jar, jerk, jolt. <I>Ek~o</I>, shudder (<I>timo</I>), start (<I>surprizo</I>), thrill (<I>ĝojo</I>), wince (<I>doloro</I>). <B>El~i</B> <I>cindron el pipo</I>. <B>For~i</B>, s. off (<I>ĉagrenon, impreson, jugon</I>. <B>Ne~ebla</B> (<I>firma</I>), un-able, firm, immovable, resolute. <B>Sen~a</B>, gently, softly, without shock. ➞ <I>agit, balanc, ŝancel</I>.", "0"],
["skulpti", "skulpt-i", "(<I>-n</I>) [UV], Carve, Sculpt. ~i <I>lignon, marmoron. ~i statuon</I>. <B>~ado</B>, s-ure, statuary. <B>~aĵo</B>, piece of c-ing, s-ure. <I>Ligna ~aĵo</I>, woodc-ing. <B>~ilo</B>, [UV] chisel, etc. <B>~isto</B>, c-er, s-or. <B>~arto</B>, s-ure. ➞ <I>ĉiz, modi</I>.", "0"],
["skunko", "skunk-o", "skunk fur. ➞ <I>mefit</I>.", "0"],
["skuno", "skun-o", "(a. <I>goeleto</I>), schooner, fore-and-aft sailing-ship with two or more masts.", "0"],
["skurĉo", "skurĉ-o", "[UV] scourge, birch, cat and nine tails, lash. <B>~i</B>, s., flog, thrash unmercifully. ➞ <I>knut, verg, vip</I>. (Vd. Albault, <I>Fundamento</I>, p. 337).", "0"],
["skutelario", "skutelari-o", "(bot) scullcap (<I>Scutellaria</I>).", "0"],
["skutero", "skuter-o", "scooter, light motor-cycle. ➞ <I>moped</I>.", "0"],
["skuti", "skut-i", "(sp) Scoot, use a (child’s) scooter. <B>~ilo</B>, -er.", "0"],
["skvalo", "skval-o", "spur-dog shark, spiny dog-fish (<I>Squalus</I>) (K 377/21).", "0"],
["skvamo", "skvam-o", "[UV] Seal/e, flake. <I>~o de fiŝo, haŭto, serpento. f Se la ~oj defalus de viaj okuloj</I> (Rj 11/12). <B>~(ec)a</B>, <B>~hava</B>, <B>~e kovrita</B>, s-y. <B>For~iĝi</B>, flake off. <B>Sen~igi</B>, clear of seals, desquamate. ➞ <I>imbrik</I>.", "0"],
["skvaŝo", "skvaŝ-o", "(game) Squash (rackets), (sport) <I>de rakedludo</I>.", "0"],
["skvateno", "skvaten-o", "angel shark, monk-fish (<I>Squatina</I>).", "0"],
["slabo", "slab-o", "slab, flag-stone, paving-stone, flooring tile. <I>~o betona, marmora</I>.", "0"],
["slango", "slang-o", "slang, argot. <I>~o Londona, almozula</I>.", "0"],
["slano", "slan-o", "Vd <I>lign</I>.", "0"],
["sledo", "sled-o", "(<I>glitveturilo</I>), sled, sledge, sleigh. <I>Sport ~o</I>, bob-sleigh.", "0"],
["slipo", "slip-o", "[OA] slip (of paper), index card (for notes or record). <B>~aro</B>, <B>~ujo</B>, (<I>kartoteko</I>), card index. <B>Sur~igi</B>, card-index,", "0"],
["slogano", "slogan-o", "(<I>frapfrazo</I>), slogan, short catchy phrase, party cry.", "0"],
["slojdo", "slojd-o", "sloyd, Swedish manual-training through woodwork.", "0"],
["Slovakujo, Slovakio", "Slovak-ujo, Slovakio", "SK.", "0"],
["Slovenujo, Slovenio", "Sloven-ujo, Slovenio", "SI.", "0"],
["slupo", "slup-o", "(mar) sloop, one-masted ship with fore and aft sails,", "0"],
["smalto", "smalt-o", "smalt. <B>1</B> (<I>kobaltvitro</I>). <B>2</B> pigment from this.", "0"],
["smeraldo", "smerald-o", "[UV] Emerald. <B>~(everd)a</B>, e-green. <B>Marblua ~o</B>, aquamarine.", "0"],
["smilako", "smilak-o", "Smilax (<I>Smilax</I>). <B>Ĉina ~o</B>, China root. <I>~a radiko (sarsaparilo</I>).", "0"],
["smirgo", "smirg-o", "Emery. ~a <I>papero, pulvoro</I>. <B>~i</B>, grind, polish, rub, with e.", "0"],
["smuto", "smut-o", "(agr) smut (plant disease). <I>~o nuda (kovrita</I>), loose (covered),", "0"],
["snobo", "snob-o", "Snob, person with exaggerated respect for social position or wealth, and disposition to be ashamed of socially inferior connections. <B>~eco</B>, <B>~ismo</B>, -bery, -bishness. <B>~ino</B>, vulgar follower of fashion.", "0"],
["snufi", "snuf-i", "sniff (up), snivel, snort, snuffle, <B>f</B> (<I>je io</I>), turn up one’s nose at. <I>En~i tabakon</I>, snuff up tobacco. ➞ <I>flar</I>.", "0"],
["So", "S-o", "[F], letter S. <B>S-hoko</B>, S-hook.", "0"],
["sobra", "sobr-a", "[UV] Sober, Moderat/e, Temperate. <B>1</B> (<I>abstinema</I>): abstemious, frugal. <B>2</B> cautious, impartial, passionless, restrained, sedate, well-balanced. <I>~a laŭdo, sinteno, takso</I>. <B>~e</B>, s-ly. <I>~e</I> (quietly, unostentatiously) <I>vestita. ~e paroli</I>, be sparing of words. <B>~eco</B>, discretion, gravity, m-ion, sobriety, restraint. <B>~igi</B>, s., calm. <B>~ulo</B>, t. person. <B>mal~a</B>, [UV] im-m., in-t., passionate <I>[Ne= ebria]. ~~igita de amo, ĉampano, kaj dancmuziko</I> (K 163/5). <B>Re~iĝi</B>, recover one’s balance. ➞ <I>diskret, moder, seren</I>.", "0"],
["socialismo", "social-ismo", "[OA] <B>~isto</B>, [OA] social-ism, -ist.", "0"],
["societo", "societ-o", "[UV] Society. <B>1</B> community: <I>Religia ~o</I>.<B>< 2</B> association, club, group. <B>3</B> company, firm: <I>~o akcia</I>, joint stock c. <I>~o kun limigita respondeco</I>, limited liability c. <B>4</B> companionship, set, social circle: fashionable world (<I>mondumo). Vivi en bona ~o</I>, move in good s. <B>~a</B>, (of a) s., social. <I>~a gazeto, kunveno</I>, s. journal (meeting). <I>~a babilado</I>, social gossip. <B>(Ne)~ema</B>, (un)-sociable, (un-)social. <B>~ulo</B>, man about town. ➞ <I>kompani, mondum, soci</I>.", "0"],
["socio", "soci-o", "[OA] Soci/ety, body, community, the public, social system. <I>de abeloj</I> <B>(formikoj)</B>. <B>~a</B>, -ial, communal. <B>~a <I>asekuro, demando, scienco, sfero, vivo</I>. ~aj <I>aranĝoj, klasoj, rilatoj</I></B>. <B>~e</B>, -ally. <B>~ano</B>, citizen, member of community. <B>~igi</B>, -alize. <B>Kontraŭ~a</B>, anti-ial.", "0"],
["sociologio", "sociolog-io", "[OA] <B>-o</B>, [OA] -ology, -ist. ➞ <B><I>amik, civil, komunum, societ</I></B>.", "0"],
["sodo", "sod-o", "[OA] (<I>natria karbonato</I>), (washing) Soda. <B>Kaustika ~o</B> (<I>natro</I>), caustic s. (<I>natria hidroksido</I>). <B>Kristala ~o</B>, s. crystals. ➞ <I>akv, natri</I>.", "0"],
["sofismo", "", "[F], Soph-ism, -istry, fallacy, false reasoning. <B>~a</B>, specious.", "0"],
["sofisto", "sofist-o", "[OA] Sophist.", "0"],
["sofito", "sofit-o", "(arch) soffit, lower surface of arch, etc.", "0"],
["sofo", "sof-o", "[UV] Sofa, couch with raised ends and back, on which several persons can sit, or one lie. <B>~eto</B>, lounge, settee. <B>~a</B> <I>lito,</I> s-bed. ➞ <I>divan, kanap</I>.", "0"],
["soforo", "sofor-o", "ornamental shrub (<I>Sophora</I>), coral beam, Japanese pagoda tree.", "0"],
["softa", "soft-a", "= mallaŭta.", "0"],
["soifi", "soif-i", "(<I>-n, al</I>) [UV], Thirst (for), be -y (dry). <I>Mi ~as. ~i venĝon (al venĝo</I>), be eager for revenge. <I>Mia animo ~as Dion</I> (Ps 42/2). <B>~o</B>, t. <I>Suferi de ~o. ~o al</I> (hankering after, hunger for). <B>~(ant)a</B>, t-ly, longing for. <B>~igi</B>, parch. <B>Sen~igi</B>, quench (slake) t. <B>Sen~iĝi</B>, refresh one’s. <B>Sango~a</B>, bloodt-y. ➞ <I>avid, sopir</I>.", "0"],
["sojlo", "sojl-o", "[UV] (Ce 2/14), threshold, doorstep; sill. Fenestra <B>~o</B>, window-sill. <B>Supra ~o</B> (<I>lintelo</I>), lintel (El 12/7), entrance, outset. <I>Ĉe la ~o de dezerto, diskuto, kariero, jarcento, vintro, vivo. Halti ĉe la ~o de</I>, stop short of.", "0"],
["sojo", "soj-o", "(a. glicineo), Soya (Glycine soja). <B>~a</B> <I>fabo, faruno, lakto, oleo, saŭco</I>. ➞ <I>apios</I>.", "0"],
["soklo", "sokl-o", "[OA] socle, base, bottom, pedestal, Support (<I>flaga, masta</I>); footing (of wall); plinth (of pillar, statue, vase); stand for object). <I>Izola</I> <B>~o</B>, insulating base. ➞ <I>piedestal</I>.", "0"],
["soko", "sok-o", "(<I>plugila beko</I>), ploughshare.", "0"],
["sola", "sol-a", "[UV] Alone, Lone. <B>1</B> by one’s, solitary: <I>Labori, promeni, veni ~a. Nur mi ~a</I>. <B>1</B> alone (1 Rĝ 19/10, <B>4</B> FA 64/16). <B>2</B> without aid: <I>Mia forto ~a ne sufiĉas</I>. <B>3</B> (<I>unu ~a</I>) (one and) only, single, unique: <I>mia ~a filo. Ĝxia ~a postesigno</I>, the only trace of it. <I>La ~a Dio</I>, the One God. <B>~e</B>, <B>1</B> <I>Promeni ~e</I> (better <I>~a</I>). <B>2</B> (<I>nur</I>), only, excluding others, no more than, nothing but: <I>La decido dependas ~e de vi</I> (on you a.). <I>Li manĝis ~e panon. Tiu besto vivas ~e en Afriko. Ne ~e … sed ankaŭ;</I> not only ... but also; both ... and ... (pleon) <I>Sole nur</I> (for emphasis). <I>Ni devas obei s.n. la logikon. La domon de David sekvis s.n. la tribo de Jehuda</I>. <B>~eco</B>, isolation, 1-liness, privacy, seclusn, solitude. <B>~eca</B> (<I>~e staranta</I>), l-ly(-some), solitary. <I>~eca ĉambro, domo, nokto. Esti ~eca kaj malgaja. Stari ~ece sur la monto</I>. <B>~igi</B>, isolate. <B>~iĝi</B>, become isolated. <B>~ulo</B> (Ps 102/7). <I>~ula vivo,</I> solitary life. <B>~infano</B>, o. child. ➞ <I>apart, izol, nur, solo</I>.", "0"],
["solano", "solan-o", "(<I>Solanum</I>). Nigra <B>~o</B>, black nightshade. ~acoj, nightshade fam. &gt; <I>alkekeng, beladon, datur, dolĉamar, hiskiam, mandragor, terpom, tomat</I>.", "0"],
["soldanelo", "soldanel-o", "soldanella, Alpine perennial.", "0"],
["soldato", "soldat-o", "[UV] Soldier, trooper. <I>La Nekonata ~o</I>, the Unknown S. <B>Mar~o</B>, marine. <B>Pied~o</B>, foot-s., infantryman. <B>Pik~o</B>, pikebearer. <B>Plumb~o</B>, <B>stan~o</B>, tinsoldier. Serv<B>~o</B>, orderly. Simpla <B>~o</B>, private. ~(ec)a, -ly. <B>~i</B>, serve as s. <B>~aro</B>, s-y, army, troops. <I>Mar~aro</I>. <B>~ejo</B> (<I>kazerno</I>), barracks, quarters. <B>~iĝi</B>, enlist. II (chs) pawn. ➞ <I>stratiot</I>.", "0"],
["soldo", "sold-o", "[OA] <B>1</B> sou. <I>Sen~a</I>, beggared, destitute, penniless. <B>2</B> (mil) pay. <B>~ulo</B>, mercenary.", "0"],
["solecismo", "solecism-o", "[OA] solecism, blunder, offence against standard. <I>~o gramatika, (konduta</I>).", "0"],
["solena", "solen-a", "[UV] Solemn, ceremonious, formal, impressive, serious. <I>~a aŭdienco, deklaro, promeso, silento. ~a akcepto,</I> official reception. <B>~o</B>, ceremony. <B>Edziĝa ~o</B>, solemnization of marriage. <B>Memor~o</B>, commemoration festival. <B>~i</B> (<B>~e</B> <I>festi, plenumi</I>), celebrate, solemnize. <B>~eco</B>, -ity. <I>Afekti ~econ</I>, be pompous. ➞ <I>celebr, ceremoni, impon, majest, parad, serioz</I>. Opp <I>frivol</I>.", "0"],
["soleno", "solen-o", "(zoo) razor-shell (<I>Solena</I>).", "0"],
["solenojdo", "solenojd-o", "(el) solenoid.", "0"],
["soleo", "sole-o", "[OA] (ich) sole (<I>Solea</I>).", "0"],
["solfao", "solfa-o", "(<I>litera muzikskribo, \"tonika do\"</I>), (Tonic) Sol-fa (movable doh). <I>Skribi ~e</I>. <B>~isto</B>, -ist. <B>~i</B>, s., sing to s-names.", "0"],
["solfeĝo", "solfeĝ-o", "solfeggio, vocal exercise using \"fixed-doh\" syllables. ➞ <I>solfa</I>.", "0"],
["solicitoro", "solicitor-o", "solicitor (<I>Brita juro</I>).", "0"],
["solidago", "solidag-o", "(<I>ora vergo</I>), (bot) golden-rod (<I>Solidago</I>).", "0"],
["solidara", "solidar-a", "[OA] jointly and severally liable and responsible, interdependent. <I>Liaj interesoj estas ~aj</I> (bound up) <I>kun niaj</I>. (tech) <I>rado ~a kun alia</I>, in one piece, interlocked. <B>~eco</B>, solidarity, joint responsibility, community of interests or actions, mutual dependence. <I>Striko de ~eco</I>, sympathetic strike. <B>~igi</B>, consolidate (interests).", "0"],
["solido", "solid-o", "[OA] Solid. <B>1</B> Not fluid or liquid. <B>2</B> alike all through, sustained, un -broken(-interrupted): <I>~a arĝento, hufo, koloro, progreso</I>. <B>3</B> firm, reliable, steady: <I>~a amikeco, fundamento, garantio, homo, ligilo. ~aj botoj</I>, stout boots.<B>< 4</B> serious, sound: <I>~a argumento. ~aj kvalitoj,</I> sterling qlties. <B>5</B> (com) safe, solvent, steady, well-established: <I>~a firmo (reputacio</I>). <B>~e</B>, solidly, stoutly. <B>~eco</B>, stability. <B>~igi</B>, -ify, consolidate, establish. <B>Mal~a</B>, <B>Ne~a</B>, flimsy, shaky, weak. <B>~~eco</B>, unsettled state. ➞ <I>firm, fortik</I>. Opp <I>fluid, likv</I>.", "0"],
["solitero", "soliter-o", "<B>1</B> (gm) solitaire. <B>2</B> (cgm) patience. <B>3</B> ring, etc., with one gem. ➞ <I>teni</I>.", "0"],
["solivo", "soliv-o", "(carp, mar) beam, cross-timber, joist.", "0"],
["soloo", "solo-o", "<I>= sol-aj(-kant-lud)o</I>, Solo. ~isto -ist. ~orgeno, s-organ.", "0"],
["solstico", "solstic-o", "(astr) Solstic/e, time of sun’s greatest distance from equator. <I>~o somera, vintra</I>. <B>~a</B>, -tial.", "0"],
["solventa", "solvent-a", "[OA] (<I>pagokapabla</I>), Solven/t. <B>~eco</B>, -cy. <B>Ne~a</B>, in-s.", "0"],
["solvi", "solv-i", "(<I>-n</I>), [UV] <B>1</B> Dissolve, make a solution of: <I>~i salon en akvo</I>, <B>2</B> Resol/ve, Solve, clear up, find a way out of, settle, unravel, untangle: <I>~i demandon, disputon, dubon, ekvacion, enigmon, malfacilon, problemon</I>. (mus) <I>disonancon</I>, r. a discord (<I>supren, malsupren</I>). <B>~o</B>, solution, answer, (mus) r-ution. <B>~a</B>, solvent. <B>~aĵo</B>, solution. <B>~ebla</B>, soluble, solvable. <I>Problemo</I> ~inda, to be s-ed. <B>~iĝi</B>, d. ~ilo, solvent, <B>f</B> expedient. Ne<B>~ebla</B>, insoluble. <I>Diskuti</I> <B>sen~e</B>. ➞ <I>divert, malkombin</I>.", "0"],
["Somalujo, Somalio", "Somal-ujo, Somalio", "SO.", "0"],
["somaterio", "somateri-o", "eider duck (<I>Somateria</I>). Vd <I>anas</I>.", "0"],
["sombra", "sombr-a", "(<I>preme malhela, malluma</I>), Sombre, gloomy, dark (<I>koloro</I>); dim (<I>lumo</I>); dismal (<I>vizaĝo</I>); dull (<I>vetero</I>); overcast (<I>ĉielo). Estas ~e!</I> It is dark! ➞ <I>morn</I>.", "0"],
["somero", "somer-o", "[UV] Summer. <B>~eca</B>, <B>~simila</B>, -y. <B>~e</B>, in the s. <B>Tra~i</B>, pass the s.", "0"],
["somiero", "somier-o", "box-mattress, spring-mattress; plate supporting machine-parts. <I>Drata ~o</I>, (org) wind chest.", "0"],
["somnambulo", "somnambul-o", "[OA] somnambul/ist. <B>~i</B>, walk in one’s sleep. <B>~ismo</B>, -ism.", "0"],
["sonato", "sonat-o", "[OA] (mus) Sonat/a. <B>~a</B> <I>formo</I>. s-form. <B>~eto</B>, -ina. ➞ <I>moviment, simfoni</I>.", "0"],
["sondi", "sond-i", "(<I>-n</I>) [OA], Sound, take -ings, explore the bottom, fathom, measure the depth of. <I>Plumbo~i</I>, s (with a plummet), (surg) probe (<I>vundon</I>), sound (<I>pacienton</I>). <B>f</B> feel one’s way, see how the land lies, test experimentally, try to find out the opinions of, explore (<I>arbaron</I>); scan (<I>horizonton). ~i misteron</I>. <B>~(ad)o</B>, s-ing, casting the lead. <I>~ado akustika, radia</I>. <B>~ilo</B>, depth-finder, lead, plummet. <B>Eĥo~ilo</B>, echo-sounder. <B>~isto</B>, leadsman. <B>Ne~ebla</B>, fathomless, inscrutable, unfathomable.", "0"],
["soneto", "sonet-o", "[OA] sonnet.", "0"],
["sonĝi", "sonĝ-i", "[UV] <B>~o</B>, Dream (in sleep). <I>~o bela, stranga, ~o teruras, ~o forkuras</I>. <B>~e</B>, in a d. ~aĉo (<I>koŝmaro, prem~o</I>), nightmare. <B>~ado</B>, dreaming. <B>~osimila</B>, d-like. <B>Sen~a</B>, d-less. <B>Tra~i</B> <I>la vivon</I>, d. one’s life away. ➞ <I>rev</I>.", "0"],
["soni", "son-i", "[UV] (nt) (make, emit, give out) Sound, be heard, resound. <I>Lia voĉo ~is agrable, Barelo malplena ~as plej laŭte. ~i false</I>, ring false. <I>~is la deka</I>, it struck ten o’clock, f (<I>aŭdiĝi</I>): be expressed audibly. <I>En lia voĉo ~is ĝojo</I>. <B>~o</B>, s. beat (<I>tambura</I>); blare (<I>trumpeta</I>); blast (<I>sirena</I>); chink (<I>ora</I>); clang, ring, tinkle (<I>sonorila). Lip~o</I>, (phon) labial. <B>~a</B>, of s., acoustic, phonetic. <B>~egi</B>, blare, roar. <B>~ero</B> (<I>sonparto), &gt;</I> harmonic, overtone, partial. Vd <I>harmon, kromton, superton</I>. <B>~igi</B> (<I>-n</I>), (cause to) sound, make heard, utter. <I>La birdoj ~igis sian voĉon. ~igi,</I> clink, rattle (<I>monon</I>); jingle (<I>ŝlosilojn). La horloĝo ~igis</I> (struck) <I>la horojn. ~igi la</I> \"r\", roll one’s \"r’s\". <B>~konduki</B>, <B>~porti</B>, conduct sound. <B>Ek~i</B>, strike up, be heard. <I>Ek~is paŝoj</I>. <B>For~i</B>, die away. <B>Re~i</B>, resound, send back the s., (re)echo, reverberate. <I>Re~o</I>, echo, resonance. <I>Ŝiaj vortoj trovis re~on en mia koro. ~~ilo</I>, resonator. <B>Sen~a</B>, s-less. <B>Sub~a</B>, subsonic. <B>Super~a</B>, supersonic. <B>Akre~a</B>, strident. <B>Bel~a</B>, <B>bon~a</B>, euphonious, <B>Malbel~a</B>, disagreeable, harsh. <B>Plen~a</B>, resonant, ringing, sonorous. ➞ <I>bru, eĥ, sonor, ton</I>.", "0"],
["sonko", "sonk-o", "sowthistle (<I>Sonehus</I>).", "0"],
["sonori", "sonor-i", "[UV] (nt) Ring, be Sonor/ous, give out a prolonged ringing or musical sound. <B>~a</B>, ringing, sonorous, cleartoned, deeptoned, musical, resonant, resounding. <I>~a voĉo. ~aj vortoj</I>, high-sounding words. <B>~ado</B>, ringing, pealing, reverberation. <I>Funebre ~adi</I>, toll. <B>Mort~ado</B>, knell. <B>~eco</B>, s-ity. <B>~ego</B>, boom, clang, clash. <B>~eti</B>, clink, tinkle. <I>~etigi la glasojn</I>. <B>~igi</B> (<I>-n</I>), ring, <I>~igi por akvo (la kelnero). ~igisto</I>, bell-ringer. <B>~ilo</B>, bell. <I>La ~ilo ~is ĝoje</I>. <B>Man~ilo</B>, hand-bell. <B>Mort~ilo</B>, <B>Signal~ilo</B>, alarm-bell, etc. <B>Sled~ilo</B>, sleigh-b. <B>Tub~ilo</B>, tubular bell. <B>Tumult~ilo</B>, tocsin. <I>~iladi,</I> chime, ring a peal. <I>~ilaro (karilono</I>), peal of bells. <I>~ilejo (~ila turo, belfrido</I>), belfry. <I>~ilisto</I>, b-ringer. <I>~ilmuldisto,</I> b-caster. Mal<B>~a</B>, dull, muffled. ➞ <I>gong, kloŝ, son, tint, vibr</I>. <B>Rim</B>.: Though <I>sonori</I> is nt, we meet <I>~i ĝojon (la komencon, liberecon</I>) (4 FA 212/30; 3 FA 31/30; Rj 110/6).", "0"],
["sopiri", "sopir-i", "(<I>-n al, je, por, pri, -i</I>) [UV], Long, Sigh (from nostalgia or desire), pine, (thirst, yearn) for, fain word have, hanker after: <I>~i feliĉon (al feliĉo). Cervo ~as al fluanta akvo</I> (Ps 42/1) (J1 1/20). <I>~i al la patrujo, al Dio, ripozo, trankvilo. ~i revidi iun</I>). <B>~(ad)o</B>, longing, ardent desire, yearning, etc. <B>~(ant)a</B>, <B>~(em)a</B>, longing, anxious, ardent, fond, wistful. Hejm~o (<I>nostalgio</I>), home-sickness. <B>~e</B>, l-ingly. <B>~anto</B>, lovesick swain, etc. <B>~ega</B>, passionately desirous. ➞ <I>aspir, avid, dezir, soif, suspir</I> (= sigh audibly).", "0"],
["soprano", "sopran-o", "[UV] Soprano, treble (high voice of woman or child). <B>~ul(in)o</B>, s. singer (Ps 46 caption). <B>Mezo~o</B>, mezzo-s.", "0"],
["sorbi", "sorb-i", "(<I>-n</I>), [UV] Absorb (liquid), soak (suck) up. <I>inkon, sukon</I>. <B>f</B> (<I>En~i</I>), drink (suck) in, imbibe, take on. ~~i <I>ideojn, instruon</I>. <B>~(em)a</B>, -ent. <I>~a papero,</I> blotting-paper. <I>Ne ~ema</I>, non-ent, impermeable. <B>~iĝi</B> (<I>esti ~ita</I>), be -ed, sucked up (by). <B>~igi</B>, drench (penetrate, saturate, soak) with. <I>~igita de</I> (bathed in) <I>sango</I>. <B>~ilo</B>, -ent. <I>Ink~ilo</I>, blotter. <B>Tra~iĝi</B>, leak (sweat) out, percolate, soak through. ➞ <I>absorb, filtriĝ, lik, ŝvit</I>.", "0"],
["sorĉi", "sorĉ-i", "(<I>-n</I>) [UV], Enchant, bewitch, practise sorcery (witchcraft), throw a spell on, use magical powers. <B>f</B> (<I>ĉarmi</I>), fascinate. <I>~i iun per sia beleco, elokvento. La propono min ~as</I>. <B>~a</B>, -ing, bewitching, captivating, fetching, magic, seductive, wondrous. <I>~a voĉo</I>. <B>~(ad)o</B>, <B>~(art)o</B>, -ment, glamour, necromancy, sorcery, witchcraft. <B>~aĵo</B>, charm, spell. <B>~isto</B>, -er, magician, sorcerer, wizard. <B>~istino</B><I>,</I> e-ress, witch, <B>~ita</B>, bewitched. <B>De~i</B>, exorcize. <B>Fi~i</B>, cast an evil eye on. <B>Trans~i</B>, change (transform) by magic. ➞ <I>ĉarm, ĵongl, log, magi, rav</I>.", "0"],
["sordida", "sordid-a", "sordid; base, ignoble, mean, mercenary; dirty, squalid.", "0"],
["sordino", "sordin-o", "= dampilo.", "0"],
["sorgo", "sorg-o", "sorghum &gt; great millet (<I>S. vulgare). (S</I>. v. <I>var durra = duTm</I>, Indian millet).", "0"],
["sori", "sor-i", "(<I>suprenglisi</I>), (av) soar (mount on a rising current). ➞ <I>ŝveb</I>.", "0"],
["soriko", "sorik-o", "[UV] Shrew(mouse) (<I>Sorex</I>). <B>Arba (pigmea) ~o</B>, tree (pigmy) s.", "0"],
["sorito", "sorit-o", "(<I>silogisma ĉeno</I>), sorites.", "0"],
["sorpo", "sorp-o", "[UV] service tree (<I>Sorbus domestica</I> and <I>torminalis</I>) (3 FA 47/19). <B>~a</B> <I>frukto,</I> sorb (apple). ➞ <I>aliz, aŭkupari</I>.", "0"],
["sortimento", "sortiment-o", "[OA] (<I>specimenaro</I>), assortment, collection of wares (goods) of similar kind, selection. <B>~i</B>, stock a wide selection (range).", "0"],
["sorto", "sort-o", "[UV] Fate, condition in life, destiny, lot, luck (present or future). <I>Antaŭdiri, eviti, gvidi, plibonigi la ~on, Provi sian ~on</I>, try one’s luck. <I>Forlasi iun al la ~o, Esti kontenta pri (submetiĝi al) la ~o. La ironio de la ~o</I>, irony of fate. <I>Mia ~o estas decidita</I>, my f. is sealed. <I>La ~o estas blinda</I>, Fortune is blind. <B>Sam~ano</B>, <B>~ulo</B>, one in the same boat, fellow-sufferer. <B>~obato</B>, blow of fate. <B>~oŝanĝoj</B>, vicissitudes. ➞ <I>destin, fat(al), fortun, lot [Ne= klas, spec]</I>.", "0"],
["sovaĝa", "sovaĝ-a", "[UV] Savage, Wild. <B>1</B> rude, uncivil, uncouth: <I>~a aspekto, popolo, vivo</I>. 2 untamed: <I>~a besto, ĉevalo, kato</I>. <B>3</B> uncultivated: <I>~a floro, loko, tero. ~a arbaro</I>, trackless forest. <B>4</B> barbarous, brutal, unbridled, unrestrained, violent: <I>~a gesto, pluvo, naturo</I>. <B>~i</B>, rage. <B>~eco</B>, ferocity, savagery, wildness, natural state. <B>~ejo</B>, uncultivated land, bush, scrub, tangle, wilderness. <B>~ulo</B>, s. (wild) person. <B>Mal~a</B>, disciplined, tame. <B>~~igi</B>, tame. ➞ <I>barbar, furioz, impet, senbrid</I>.", "0"],
["soveto", "sovet-o", "(a. <I>sovjeto (ark.)</I>), soviet. <B>Sovet-io</B>, <B>Sovet-Uni-o</B>.", "0"],
["sovreno", "sovren-o", "(num) sovereign.", "0"],
["spaco", "spac-o", "[UV] Spac/e. <B>1</B> area, extent, room: <I>Okupi grandan ~on. La ~o mankas</I>. <B>2</B> (<I>senlimaĵo, vastego</I>), limitless space: <I>~a ŝipo. Rigardi en la ~on</I>, stare into vacancy. <B>3</B> (mus) s. between lines. <B>~(oplen)a</B>, spacious, spatial, capacious, roomy. <B>En~i</B> (<I>ampleksi</I>), comprise. <B>Inter~o</B>, distance (interval) between. <I>De la buŝo ĝis la manoj estas granda ~~o</I>. <B><I>~~</I>i</B>, thin out (seedlings), (typ) s. out (lines of type), <B>~igo</B>, spacing, clearance. <B>Ter~o</B>, area, superficies. <B>~vojaĝisto</B> (<I>astronaŭto, kosmonaŭto</I>), space- traveller. ➞ <I>are, lok, teren</I>.", "0"],
["spadiko", "spadik-o", "(by) spadix; thick fleshy spike, e.g., of dates, bananas.", "0"],
["spado", "spad-o", "[OA] straight sword, narrow short pointed blade with hilt (us. ceremonial, dress, state). ➞ <I>glav, rapir, sabr [Ne= fosilo]</I>.", "0"],
["spaliro", "spalir-o", "[UV] espalier. <B>1</B> trellis for wall-fruit. <B>2</B> row of trees so trained. <B>~a</B> <I>arbo</I>, wall-tree. <B>~i</B>, train (trailing plants). <B>~aĵo</B>, trellis work.", "0"],
["spanielo", "spaniel-o", "spaniel (dog). ➞ <I>pudel</I>.", "0"],
["spano", "span-o", "Span. <B>1</B> bay, width (of arch, bridge, roof, etc.), distance between two upright supports. <I>~o neta</I>, clear s. <B>~aĵo</B>, girder-work. <B>2</B> (<I>manstreĉo</I>).", "0"],
["sparganio", "spargani-o", "bur-reed (<I>Sparganium</I>).", "0"],
["sparko", "spark-o", "<B>~i</B>, (el) Spark discharge. <I>Fruigi</I> (advance) <I>la ~on</I>. <B>~ado</B>, -ing, ignition- <B>~ilo</B>, sparking plug. <B>~aperturo</B>, s-gap. <B>~bobeno</B>, ignition coil. <B>~regulado</B>, s-control. <B>~ŝaltilo</B>, s-switch.", "0"],
["sparo", "spar-o", "<B>1</B> (av) Spar of wings, (ry) ridgebar, side-sill. <B>2</B> (bid) round s.; ➞ <I>ĉevr, lign</I>. <B>3</B> (ich) = pagelo.", "0"],
["sparteno", "sparten-o", "cord-grass, rice-grass (<I>Sparlino</I>).", "0"],
["spartio", "sparti-o", "Spanish (or rush) broom (<I>Spartium</I>). ➞ <I>sarotamn</I>.", "0"],
["spasmo", "spasm-o", "[OA] Spasm. <I>~o kora</I>. <B>~a</B>, -odic, convulsive, spastic, <B>f</B> <I>Labori</I> <B>~e</B>, by fits and starts. <B>Kontraŭ~a</B>, antispasmodic. ➞ <I>konvulsi, kramf, rigidiĝ, tetan</I>.", "0"],
["spatelo", "spatel-o", "(<I>trideto</I>), (phar, tech) Spatul/a, flat knife for mixing or spreading, palette-knife, etc. <I>Butera ~o</I>, butter-pat. <B>~(ec)a</B>, -ate.", "0"],
["spato", "spat-o", "[UV] (min) Spar. <B>Fluor~o</B>, fluorspar <I>[Ne= spaveri\\</I>.", "0"],
["spatolo", "spatol-o", "(orn) shoveller (<I>Spatula clypeata</I>).", "0"],
["spaveno", "spaven-o", "(vet) spavin, disease of horse’s hock-joint.", "0"],
["speciala", "special-a", "[F], Special, Particular, especial, for a definite purpose. <I>~a afero</I>, p. business. <I>~a maŝino (vagonaro</I>). <B>~e</B>, (e)s-ly, p-ly, in a s. way. <I>Mi venis ~e por la festo</I>. <B>~(aĵ)o</B>, s-ity, s. feature (class of goods, function, line of service, etc.). <B>S~igi</B>, S-ize. <B>s~isto</B>, s-ist. ➞ <I>apart, fak, precip</I>. Opp <I>general, komun</I>. <B>Rim</B>.: <I>Aparta</I> denotes diffce, outstandingness, separation: <I>Precipe</I> denotes importance by comparison: <I>Speciala</I> implies definite aim.", "0"],
["specifi", "specif-i", "Specif/y; define in detail, mention definitely, name expressly. <I>la devojn</I>, lay down the duties. <B>~o</B>, -ication- <B>~a</B>, -ic. <I>~a pezo, varmo. ~a diferenco, kuracilo, reakcio. ~a konto</I>, detailed (itemized) a/c. ➞ <I>precizig, spec</I>.", "0"],
["specimeno", "specimen-o", "[OA] Specimen, Pattern, sample. <I>Preni ~on el</I>, s. <B>~aro</B>, collection (set) of specimens, p-book, range of patterns. ➞ <I>ekzempl, provaĵ, sortiment</I>.", "0"],
["specio", "speci-o", "(bio) Species &lt; <I>genro</I>. ~a <I>nomo,</I> specific name. <B>Sub~o</B>, sub-s.", "0"],
["speco", "spec-o", "[UV] Kind, Sort; brand, variety. <I>Nova ~o de sapo</I>. <B>~aro</B>, (<I>sortimento</I>) assortment. <B>~igi</B>, (as)sort. <I>Poŝtaĵoj ~~itaj</I> (K 220/3). <I>~igisto</I>, s-er. <B>Dis~igi</B>, s. out (type, etc.), distribute. <B>Ali~a</B>, of another k. <B>Ĉiu~a</B>, all kinds of. <B>Divers~a</B>, varied. ~~a <I>literaturo</I>. <B>Du~a</B>, of two kinds. <B>MaIbon~a</B>, inferior, bad. <B>Plur~a</B>, <B>sam~a</B>, heterogeneous, homogeneous. <B>Unu~a</B>, alike, of one kind. ➞ <I>genr, ĝenr, kvalit, ras, speci, specif</I>.", "0"],
["spegulo", "spegul-o", "[UV] Mirror, looking-glass, reflector. <I>Poŝa ~o. Rigardi sin en ~o</I>. <B>f</B> <I>De l’ koro ~o estas la okulo</I>. <B>~i</B>, image, m., reflect, <B>f</B> show, be the sign of. <I>Rideto ~as feliĉon</I>. <B>~a</B>, specular. <B>~ego</B>, mantel (wall) m. <B>~iĝi</B>, be reflected, m-ed. <I>La animo ~iĝas en la vizaĝo; la luno en la lago</I>. <B>~umo</B>, (surg) speculum. <B>Re~aĵo</B>, reflection. <B>Retro~o</B>, rear view m. ➞ <I>imit, kopi, rebril</I>.", "0"],
["spektaklo", "spektakl-o", "[OA] (<I>spektaĵo</I>), (public) Spectac/le, entertainment, pageant, show, <B>f</B> (<I>vidaĵo</I>), sight. <B>~a</B>, -ular, showy. ➞ <I>seen</I>.", "0"],
["spekti", "spekt-i", "be a spectator. <B>~aĵo</B>, (a. <I>spektaklo</I>). <B>~anto</B>, spectator, looker-on. <I>~antaro</I>. <B>~ejo</B>, place of entertainment, grandstand. <B>~ema</B>, gaping, window-gazing.", "0"],
["spektro", "spektr-o", "[OA] <B>1</B> (opt) Spectr/um. <I>~o absorba, difrakta, prisma, suna</I>. <B>2</B> (<I>fantomo</I>): Spectre, apparition, ghost. <I>Elvoki ~ojn</I>, raise ghosts, <B>f</B> thin lean person. <B>~a</B>, 1 <I>~a analizo</I>, -um analysis. <B>2</B> ghost-like, spectral, etc. <B>~ografo</B>, <B>~oskop-o</B>, <B>-io</B>.", "0"],
["spekulario", "spekulari-o", "Venus’ looking-glass, corn violet (<I>Specularia</I>).", "0"],
["spekulativa", "spekulativ-a", "[OA] (phi) speculat/ive, conjectural, hypothetical. <I>Tio havas nur ~an</I> (purely theoretical) <I>intereson</I>. <B>~o</B>, theoretical study. ~i, (<I>~e koncepti</I>), theorize. <I>Pri tio la filozofoj ~as</I>.", "0"],
["spekul[aci]i", "spekul[aci]-i", "[OA] Specul/ate. ~i <I>je kaŭĉuko</I>, s. in rubber. <B>~a</B>, <B>~e</B>, -ative(ly). <B>~ado</B>, <B>~aĵo</B>, -ation. <I>Pura ~ado</I>, pure gamble. <B>~anto</B>, <B>~isto</B>, -ator.", "0"],
["spelto", "spelt-o", "spelt, German wheat (<I>Triticum spelta</I>) (El 9/32).", "0"],
["spergolo", "spergol-o", "corn spurrey (<I>Spergula</I>).", "0"],
["spergulario", "", "sand (sea) spurrey (<I>Spergularia</I>).", "0"],
["spermaceto", "spermacet-o", "spermaceti. <I>~a baleno (kaĉaloto</I>), sperm whale.", "0"],
["spermatofilo", "spermatofil-o", ".", "0"],
["spermatozoo", "spermatozo-o", "", "0"],
["spermo", "sperm-o", "[OA] (bio) sperm, seed, semen. <B>~a</B>, seminal.", "0"],
["sperta", "spert-a", "[UV] Experience/d, adept, (cap)-able, competent, conversant (with), expert, skilled. <I>~a gvido. Homo ~a kaj lerta</I>. <B>~o</B>, e. (quality). <B>~i</B>, (know by) e., enjoy, feel, pass through, suffer, undergo. <I>~i atakon, embarason, krii-, sorton</I>. <B>(Laŭ)~e</B>, by e. <B>~(aĵ)o</B> (<I>travivaĵo</I>), e. <I>Hieraŭ mi havis interesan ~on</I>. <B>~igi</B>, coach, train. <B>~iĝi</B>, gain e., become expert. <B>~ulo</B>, man of e., adept, expert, old hand, past master. <I>~ula uzo</I>, expert use. <B>~oplena</B>, full of e., well versed (in). <B>Ne~a</B>, sen<B>~a</B>, in-ed, callow, simple, unskilled. <B>~~ulo</B>, greenhorn, novice. ➞ <I>ekspert, empiri, lert, majstr, super</I>.", "0"],
["speso", "spes-o", "speso, fictitious money unit introduced by R. de Saussure (1907). <B>~deko</B>, = id. <B>~milo</B> = 2/- (approx). <I>Kiu ~on ne tenas, al ~milo ne venas. ~milo superflua la poŝon ne ŝiras. Kvin ~oj</I> (4 FA 86/26). ➞ <I>spez, stel, ekspert</I>.", "0"],
["spezo", "spez-o", "[UV] monetary transaction, transfer, turnover. <B>~i</B>, circulate (transfer, turn over) money, <B>~ejo</B>, cash-desk, clearing house. <B>Antaŭ~o</B>, advance. <B>el~i</B>, [UV] expend, disburse, pay(lay)out, spend. <B>~~o</B>, expence, expenditure, outgoings. <I>Vana ~~o de tempo kaj mono</I>. <B>~~libro</B>, cash- book. <B>Etaj ~~oj</B>, petty expenses. <B>~~ema</B>, extravagant, fond of spending. <B>~~ejo</B>, pay desk. <B>~~iga</B>, costly, expensive. <B>Send~~o</B>, cost of carriage. <B>en~i</B>,receive, (get, take) money. <B>~~o</B> (No 18/30), income, receipts, takings. <B>~~e laboranta</B>, gainfully employed. <B>Nacia ~~aro</B>, national revenue. <B>~~iga</B>, lucrative, remunerative. <I>Riĉigas ne en~o, sed prudenta el~o</I>.", "0"],
["spico", "spic-o", "[UV] (<I>bongustigaĵo</I>), (cul) Spic/e, aromatic substance. <B>f</B> dash, smack. <B>~i</B>, s., flavour, season. <I>~i kukon</I>. <B>f</B> <I>horoj ~itaj de bonhumoro</I>. <B>~(oriĉ)a</B>, spicy, fragrant, piquant, pungent, racy, <B>f</B> <I>~a romano, -y</I> novel. <B>~aĵo</B>, condiment, seasoning. <B>~aro</B>, -ery, spices. <B>~ejo</B>, grocer’s shop, <B>~isto</B>, grocer. <B>~ujo</B>, s-box. ➞ <I>aromaĵ</I>.", "0"],
["spiko", "spik-o", "[UV] Ear, head, spike (of corn, etc.) (Ps 72/16, Ge 41/5). <I>~o de tritiko. ~o malplena plej alte sin tenas</I>. <B>~(ohav)a</B>, -ed. <B>~iĝi</B>, e. <B>~eto</B>, spicule, spikelet. <B>~iĝo</B> (Jes 37/27). <B>~umi</B> (<I>postrikolti</I>), glean. <B>~oplena</B>, <B>grand~a</B>, full of ears, full-eared. ➞ <I>najleg</I>.", "0"],
["spili", "spil-i", "(<I>trui</I>), spile, broach. <I>~i barelon</I>. <B>~ilo</B>, augur, gimlet.", "0"],
["spinaco", "spinac-o", "[UV] Spinach (<I>Spinacia</I>).", "0"],
["spinako", "spinak-o", "(mar) spinnaker.", "0"],
["spindelo", "spindel-o", "spindle, bobbin; pin (small bar) for twisting and winding thread, revolving axis, shaft, stem. <I>~o de borilo, ŝraŭbtenilo, turbo</I>. <B>~rado</B>, fusee (of clock, watch). ➞ <I>aks, boben, ŝpinil</I>.", "0"],
["spinelo", "spinel-o", "(min) spinel.", "0"],
["spineto", "spinet-o", "(m.i.), spinet, small clavichord.", "0"],
["spino", "spin-o", "[UV] Spin/e, backbone, vertebral column. <B>2</B> crest, ridge (of mountain); shaft (of arrow); spine (of book). <B>~a</B> <I>malsano</I>, spinal disease, rachitis. <I>~a paralizo</I>. <B>~e</B> <I>malsana</I>, rickety. <B>Sen~a</B>, spineless, invertebrate. <B>f</B> limp, weak. ➞ <I>dorn, kontur, vertebr</I>.", "0"],
["spino", "spin-o", "(ph, sp) spin (secondary revolving motion), twist, whirl.", "0"],
["spiono", "spion-o", "[UV] Spy, secret agent (observer). <B>~i</B>, spy on (out), inspect (watch) secretly. <B>~aĉi</B>, pry. <B>~ado</B>, espionage. <B>Kontraŭ~ado</B>, counter-e. ➞ <I>esplor-rigard, skolt</I>.", "0"],
["spiralo", "spiral-o", "[OA] Spiral, coil. <I>Arkimeda ~o,</I> (ry) loop. <B>~a</B>, s. coiled. <I>~a konko, vojo</I>. (hor) coil-spring, hair-spring. <I>~a ŝtuparo,</I> winding stairs. <B>~i</B>, s. <I>La fumo ~is supren,</I> curled up, rose in spirals. <B>~aĵo</B> (<I>voluto</I>), scroll (of vn), worm (of screw). <B>~ero</B>, turn of spiral. whorl, (av) <B>~fali</B>, tailspin. <B>~plonĝi</B>, descend in a spiral.", "0"],
["spiranto", "spirant-o", "lady’s tresses (orchid) (<I>Spirant hes</I>).", "0"],
["spireo", "spire-o", "(Spiraea), denotes various plants &gt; bridewort (<I>S. salikfolia</I>), filipendol, ulmari.", "0"],
["spiri", "spir-i", "[UV] (nt) take Breath, Breathe, Respir/e. <I>Dum ni spiras, ni esperas</I>. <B>f</B> (<I>el~i), ~i minacon</I>. <B>~o</B>, b. <I>Perdi la ~on,</I> get out of breath. <B>f</B> <I>Lia lasta ~o</I>. <B>~(ad)o</B>, b-ing, r-ation. <B>~aĵo</B>, b., blur (of b. on window), vapour. <B>~ebla</B>, r-able. <B>~egi</B>, b. deeply, gasp, pant (➞ <I>anhel). Naz~egi,</I> snort, <B>~eto</B>, b. lightly, utter softly, whisper. <B>El~i</B>, <B>1</B> b. out, exhale, expire, <B>f</B> give out. <I>~~i odoron (varmon</I>). <B>2</B> express, show. <I>La libro ~~as malamon. Atestanto falsama ~~as mensogojn. ~~aĵo</I>, exhalation, whiff, (mus) <B>~loko</B>, b-ing place. <B>~manko</B>, shortness of b. <B>~truo</B>, air-hole, blow-hole. (zoo) spiracle. <B>En~i</B>, inhale, b. in. <I>~~i aeron (parfumon</I>). <B>Naz~i</B> (<I>snufi</I>), sniff. <B>Re~i</B>, b. again, get a second wind.", "0"],
["spirito", "spirit-o", "[UV] Spirit (wide sense). <B>1</B> (<I>animo</I>), immaterial part of man, soul: (Ag 7/59; Pr 3/21). <I>Pacon al lia ~o!</I> <B>2</B> Incorporeal being: <I>Dio estas ~o</I> (Jn 4/24). <I>La Sankta ~o</I> (Ps 51/11, Ef 4/30). (angel, demon): (He 1/14, Ef 6/12, Mk 5/13). (ghost): <I>Vidi ~on</I> (Lu 24/37, 39). (H 21/16, 29/5). (elf): <I>~oj de fajro kaj akvo</I>, <B>3</B> mental attitude, mode of thought, mind: <I>Mi estos kun vi laŭ ~o</I> (Kol 2/5). <I>Konfuziĝis lia ~o</I> (Da 2/1). <I>Adori laŭ ~o</I> (Jn 4/24). <I>Malriĉa en ~o</I> (Mt 5/3). <I>Havi trankvilan ~on</I>, be easy in mind. <I>Pli valoras kontenta ~o, ol granda profito. Grandaj ~oj</I>, great minds. <B>4</B> deep sense, essence, meaning, animating tendency: <I>La ~o</I> (genius) <I>de E. ~o de saĝo</I>, soul of wit. (H). <I>La ~o de la leĝo</I>. <B>~a</B>, immaterial, intellectual, mental, spiritual. <B>~eco</B>, -uality. <B>~ismo</B>, spiritualism, communication with departed spirits. <B>~isto</B> [OA]. <B>Sen~a</B>, characterless. <B>~ĉeesto</B>, (<B>~foresto</B>), presence (absence) of mind. Opp <I>korp, material</I>. ➞ <I>alkohol</I>.", "0"],
["spiritualismo", "spiritual-ismo", "[OA] <B>-isto</B>, [OA] (phi) spiritual-ism, -ist. ➞ <I>spiritism</I>.", "0"],
["spirozoo", "spirozo-o", "(bio) spirozoon.", "0"],
["spiti", "spit-i", "[UV] act in Defi/ance of, brave, defy, flout, fly in the face of, jib at, spite. <I>Pli facile estas eviti, ol ~i. Abelujon ne incitu, amason ne ~u</I>. <B>~(ad)o</B>, d., bravado. <B>~(em)a</B>, defiant, insolent, recalcitrant (Ps 37/35). <B>~e</B> <I>lin (al li</I>) (Ps 27/11; 69/18), in d. (scorn) of him. <I>~e (tion), ke</I>, in d. of the fact that, <B>~ulo</B>, refractory person. <B>For~i</B> <I>malamikojn</I> (Ps 10/5). Spit! Rats! ➞ <I>defi</I>. <B>Rim</B>.: ➞ malgraŭ (weaker). <I>Se vi malgraŭ tio ~os min</I>, if in spite of (= notwithstanding) that you defy me (Le 26/21, 40).", "0"],
["spleno", "splen-o", "[OA] Spleen, blues, deep depression, dumps, melancholy, low spirits, vapours, <B>~a</B>, hipped, peevish, splenetic. <B>~ema</B>, subject to depression. <B>~ulo</B>, hypochondriac. ➞ <I>gal, melankoli</I> [N<I>e = lien, malic, sarkasm</I>].", "0"],
["splinto", "splint-o", "(surg) splint, (med) similar object.", "0"],
["splisi", "splis-i", "Splice (rope). <B>~o</B> <I>okula (maŝa</I>), eye-s. <I>~o (mal)longa, retroa</I>. <B>~ilo</B>, marlinspike.", "0"],
["splito", "split-o", "[OA] Splinter, chip, flake, shaving, shiver. <I>~o de ligno, fero, osto, virto</I>. <B>~i</B>, Split, break up, divide. <I>~i atomojn, la movadon, siajn fortojn</I>. <B>f</B> <I>~i harojn</I>. <B>Har~aĵo</B>, subtlety. <B>Vitro ne~ebla</B>, safety glass. <B>~iĝi</B>, s. up. <I>La lingvo ~iĝis en dialektojn; la societo en du partiojn</I>. <B>~igo</B>, fission, s. <B>~ita</B> (<I>fendita) ligno,</I> fire-wood. <I>~itaj pizoj</I>, s. peas. <B>Dis~i</B>, reduce to fragments, shatter. <B>Dis~iĝi</B><I>,</I> burst into pieces, fly into splinters. ➞ <I>fend, frakas, krev, romp, skism</I>.", "0"],
["spondeo", "sponde-o", "[OA] (pros) Spond/ee (-). <B>~a</B>, -aic.", "0"],
["spongo", "spong-o", "[UV] Spong/e. <B>1</B> (zoo). <B>2</B> (toilet) <I>~o kaŭĉuka, metala</I>. <B>~(ec)a</B>, -y. <B>~(frot)i</B>, s. <I>~i la tablon, ~i la okulojn, la vizaĝon</I>. <B>For~i</B> <I>makulon</I>, s. off, remove.", "0"],
["sponta", "spont-a", "<B>spontan-a</B>, <I>see</I> spontanea.", "0"],
["spontanea", "spontane-a", "[OA] Spontane/ous. <I>~a ekbrulo, propono, movo</I>. <B>~e</B>, of one’s own accord, <B>~eco</B>, -ity. <B>Mal~a</B> (forced) <I>rido</I>. ➞ <I>memvol, propramov</I>. <B>Rim</B>.: Shorter forms (<B>spont</B>, <B>spontan</B>) are increasingly used. ➞ Lat <I>spons, spont-is</I>.", "0"],
["sporada", "sporad-a", "sporadic, occurring only here and there, scattered. <I>~a sunbrilo</I>, sunny intervals. <I>~aj strikoj. Labori</I> <B>~e</B>. <B>~eco</B>, -icity. ➞ <I>epidemi, izol</I>.", "0"],
["sporo", "spor-o", "(bot) Spor/e, ~ujo, -angium.", "0"],
["sporto", "sport-o", "[OA] Sport, out-of-door recreation. <B>~(am)a</B>, <B>~(em)a</B>, fond of sport. <B>~isto</B>, -sman. <B>~ejo</B> (<I>stadiono</I>), stadium. <B>~emo</B>, -ing spirit. ➞ <I>lud, petol</I>.", "0"],
["sprinti", "sprint-i", "<B>~o</B>, (sp) sprint.", "0"],
["sprita", "sprit-a", "[UV] Wit/ty, bright, clever, quick, sprightly. <B>~(ec)o</B>, w., sense of humour, sprightliness. <I>Malsato donas ~on</I>. <B>~(ad)i</B>, have a ready wit., be facetious. <B>~aĵo</B>, -ticism, bon mot, joke, quip, repartee, sally, <B>~ego</B>, brilliant (sparkling) wit. <B>~ulo</B>, wit, wag. <I>Kortega ~ulo</I>, court jester. <I>~ulaĉo</I>, practical joker. <B>Mal~a</B>, inane, stupid. <I>~~eco</I>, folly. <I>~~ulo</I>, blockhead, fool, stupid fellow. <I>~~igi</I>, besot, dull. <B>Sen~a</B>, witless, dull, flat, insipid, tame. <I>Sen~aĵo</I>, bosh, twaddle. ➞ <I>lert, sere, vortlud</I>.", "0"],
["sprono", "spron-o", "[UV] Spur. <B>1</B> for horse. <B>2</B> of cock, flower, mountain, <B>f</B> goad, incentive, stimulus, <B>~i</B>, spur, <B>f</B> encourage, give fresh impulse to, stimulate, urge on. <I>Premioj ~as la lernantojn</I>, <B>~ita</B>, <B>~hava</B>, <B>kun ~oj</B>, s-red. <B>Sen~a</B>, spurless. ➞ <I>incit, instig, stimul</I>.", "0"],
["sproto", "sprot-o", "sprat (<I>Clupea sprattus</I>).", "0"],
["spuro", "spur-o", "spoor, footprint, mark, scent, track, trace, trail. <I>Freŝa ~o. Sekvi ~on. Kovri la ~ojn</I>, cover up tracks, put off the scent. <B>Sen~e</B>, without a trace.", "0"],
["sputi", "sput-i", "(<I>-n</I>), [UV] spit (spew) out, cough up, eject, expectorate, vomit. <I>~i mukon, sangon</I>. <B>f</B> <I>~i lafon (vulkano): morton (kanono</I>). <B>~aĵo</B>, sputum. <B>~eti</B>, sputter. <I>Akvo</I><B><I>~</I>ilo</B> (<I>gargojlo</I>). <B>El~o</B> (<I>erupto</I>), eruption. ➞ <I>kraĉ, ŝprucig, vom</I>.", "0"],
["sputniko", "sputnik-o", "(av) sputnik.", "0"],
["Srilanko", "Srilank-o", "LK.", "0"],
["Sss!", "", "sound of sizzling roast (4 FA 232/26).", "0"],
["stabila", "stabil-a", "Stab/le. <B>1</B> balanced, resting firm, steady. <B>2</B> durable, permanent. <I>~a paco,</I> lasting peace. <B>~eco</B>, -ility. <B>~igi</B>, -ilize. <B>~igilo</B>, -ilizer. <B>Mal~a</B>, <B>Ne~a</B>, untrustworthy, un-s. ➞ <I>daŭr, firm, stabl</I>.", "0"],
["stablo", "stabl-o", "[UV] object. holding firm that on which one is working. <B>1</B> work-bench. <I>Labori sur la ~o</I> (Jer 18/3). <I>~o de potisto, teksisto</I>. <B>Torno~o</B>, lathe (2 FA 32/27). <B>Seg~o</B>, saw-bench. <B>2</B> support, easel, frame, rest, stand, trestle: <B>ĉapela ~o</B>, hall-stand. <B>Sekiga ~o</B>, clothes-horse. <B>~eto</B>, (knife-)rest, (photo-)stand. (vn) bridge. <B>Kamen~eto</B>, andiron, fire-dog [Ne= <I>stabil, stal</I>].", "0"],
["stabo", "stab-o", "[UV] Staff. <B>1</B> (mil) <I>Ĉefa ~o</I>, general s. <I>~a oficiro</I>, s-officer. <I>~estro</I>, chief of s. <B>2</B> directing staff, officers, <I>~o da instruistoj</I>. ➞ <I>dungitar, personar</I>.", "0"],
["stacio", "staci-o", "[UV] Station. <B>1</B> (<I>haltejo</I>), s., break of journey, halt, stage, stop: <I>~o dogana, fervoja, landlima, omnibusa, pasaĝera, subtera</I>. <B>Ĉef~o</B>, <B>sub~o</B>. <B>Fin~o</B>, terminus. <B>Ŝip~o</B>, landing-place. <B>2</B> (<I>restejo</I>): <B>Fiakra ~o</B>, cab rank (stand). <B>3</B> (<I>establaĵo</I>): <B>Ban~o</B>, seaside resort, watering-place. <B>Radia ~o</B>, <B>Send~o</B>, transmitting s. (mot) <B>Benzin~o</B> (a. <I>benzinejo</I>), <B>serv~o</B>, filling-station, service-s. <B>~domo</B>, [UV] s-(building). <B>~estro</B>, s-master. ➞ <I>halt, stadi</I>.", "0"],
["stadio", "stadi-o", "[OA] <B>1</B> Stage, period, phase (of development, disease, progress, etc.). <I>~o eksperimenta, fina, komenca. Ĝi trairis diversajn ~ojn</I>, passed through various stages. <I>En la ~o de malkresko</I>, on the wane (2 FA 119/14). <I>~o sur la vojo de progreso</I>. <B>2</B> Stadium (Gk measure). ➞ <I>etap, faz, period, staci</I>.", "0"],
["stadiono", "stadion-o", "(<I>sportejo</I>), stadium, sports ground.", "0"],
["stafeto", "stafet-o", "despatch-rider (➞ <I>kurier</I>). <B>~kurado</B>, (sp) relay-race.", "0"],
["stafileo", "stafile-o", "bladder-nut (<I>Staphylea</I>).", "0"],
["stafilokoko", "stafilokok-o", "(med) staphylococcus.", "0"],
["stagni", "stagn-i", "(nt) Stagn/ate, be -ant (at a standstill), without flow; drag, flag, (mot) stall. <B>~(ant)a</B> <I>akvo</I>, standing water, <B>f</B> remain inactive, without movement. <I>La komerco (konversacio) ~is</I>. <B>~o</B>, -ion. <I>~o kaj apatio</I>. ➞ <I>marasm</I>.", "0"],
["stajo", "staj-o", "(<I>firmtenilo</I>), Stay, (tech) batten, cross-bar, strut, tie-beam(-bolt-rod), trace, (mar) brace, guy, supporting rope. <I>Posta ~o</I>, back-s. <B>~aro</B>, bracing, shroud.", "0"],
["stakato", "stakat-o", "(mus) staccato.", "0"],
["stakiso", "stakis-o", "woundwort (<I>Stachys</I>). <B>~o heĝa</B>, hedge w; <B>~o kampa</B>, field w; <B>~o marĉa</B>, marsh w. ➞ <I>betonik</I>.", "0"],
["stako", "stak-o", "Stack, rick (of corn, hay); heap, pile (of books, branches, coal, wood). <B>~i</B>, stack, pile up. <B>~eto</B>, cock, shock, stook. <B>~e <I>ordigi florojn</I></B>.", "0"],
["stalagmito", "stalagmit-o", "[OA] stalagmite.", "0"],
["stalaktito", "stalaktit-o", "[OA] stalactite.", "0"],
["stalo", "stal-o", "[UV] (<I>brutloĝejo</I>), Stable, mews (horses), shed, sty (cattle, etc.). <I>~o</I> <B><I>bova, porka, ŝafa. ~o por kameloj</I></B> (Jeĥ 25/5). <I>Bovina ~o</I>, byre, cowshed. <I>Ŝaf~o</I>, sheep-cot. <I>~a fako</I>, horse-box. <B>~isto</B>, s-man. <B>En~igi</B>, s., stall.", "0"],
["stameno", "stamen-o", "[OA] (bot) stamen.", "0"],
["stamfi", "stamf-i", "(<I>piedfrapi</I>), Stamp, (horse) paw the ground. <B>For~i</B> (s. out) <I>fajron</I>. ➞ <B><I>tret</I></B>.", "0"],
["stamino", "stamin-o", "(tex) butter (coarse) muslin, cheese cloth.", "0"],
["stampedo", "stamped-o", "Stampede: sudden rush and flight (horses, cattle; mob). <B>~i</B>, <B>~igi</B>.", "0"],
["stampi", "stamp-i", "(<I>-n</I>), [UV] Stamp (impress with a blow), punch. <I>~i buteron, ledon, paperon</I>. cancel (<I>poŝtmarkon</I>); coin, mint (<I>medalon, moneron</I>). <B>f</B> produce a lasting impression. <I>~i ion en la memoron</I>. <B>~(aĵ)o</B>, brand, hall-mark, impress, seal. <I>~o de genio, honesto</I>. <B>~ado</B>, -ing. <B>~ilo</B>, s., die, punch. <I>Data, kaŭĉuka ~ilo</I>, date (rubber) stamp. <B>~maŝino</B>, embossing press. <B>Antau~ita</B>, (phlt) precancelled. <B>En~i</B>, work in repousse, chase, emboss (<I>cizeli</I>). <B>Brul~i</B>, brand. <I>~~ilo</I>, branding-iron. ➞ <I>gravur, mark, pres, sigel</I>.", "0"],
["stanco", "stanc-o", "(pros) stanza. ➞ <I>strof</I>.", "0"],
["standardo", "standard-o", "[UV] Standard, official flag, banner, colours, ensign. <I>La verda ~o. La ~o de libereco</I>. <B>~isto</B>, s-bearer, colour- sergeant, ensign. ➞ <I>flag [Ne= norm]</I>.", "0"],
["stando", "stand-o", "stand, stall (com. exhibition, etc.). ➞ <I>podi, stabil, stabl</I>.", "0"],
["stango", "stang-o", "[UV] (No 21/8, Jes 33/20). Bar, Pole, Rod, staff, stake, stave; long thin piece of wood or metal, (vn) (bow)stick. <B>Apog~o</B>, prop. <B>Barĝ~o</B>, barge-p. <B>Bird~o</B>, <B>Sid~o</B>, perch. <B>Boben~o</B>, distaff. <B>Bremsa ~o</B>, brake-r. <B>Dent~o</B>, rack. <B>Fajr~o</B>, poker. <B>Flag~o</B>, flag-s. <B>Glit~o</B>, slide-b. <B>Hok~o</B>, boat-hook, gaffe. <B>Ĵib~o</B>, jib boom. <B>Konekta (kupla) ~o</B>, connecting rod. <B>Kornica ~o</B>, curtain-r. <B>Lev~o</B>, crow-b, handspike, lever. <B>Lupol~o</B>, hop-p. <B>Pik~o</B>, pike, (org) <B>Puŝ~o</B>, tappet, tracker. <B>Reg~o</B>, control-rod. <B>Rost~o</B>, turnspit. <B>Salt~o</B>, jumping-pole. <B>Start~o</B>, starting lever. <B>Stir~o</B>, steering-shaft, tiller. <B>Telegrafa ~o</B>, telegraph-pole. (mar) <B>Trans~o</B>, cross-tree. <B>Vel~o</B>, spar, (sail)-yard. <B>~eto</B>, stick, shank (of key), pilaster (of railing). <B>Sigel~eto</B>, stick of sealing-wax. <B>Son~eto</B> (vn) sound-post, (ry) <B>(Cel)~i</B>, peg (stake) out a line. ➞ <I>baston, fost, mast, palis, stilz, vering</I>.", "0"],
["staniolo", "staniol-o", "= stanfolio.", "0"],
["stano", "stan-o", "[UV] (chem) Tin (Sn). <B>~a</B>, (of) t. <I>~a kulero, soldato</I>. <B>~i</B>, [UV] <B>~izi</B>, (cover with) t. <B>~atacido</B>, stannic acid. <B>~ato</B>, stannate. <B>~ika</B>, stannous, <B>~isto</B>, tinker, <B>~ferlado</B>, t-plate. <B>~folio</B> (staniolo), tin-foil, silver-paper, silvering (for mirror).", "0"],
["stapelio", "stapeli-o", "carrion-flower (<I>Stapelia</I>).", "0"],
["staplo", "stapl-o", "warehouse, repository. <B>~i</B>, (put goods in) bond.", "0"],
["stari", "star-i", "[UV] (nt) Stand. <B>1</B> be erect, in an upright position: <I>~i apud la fenestro, garde, sur seĝo. La arbo, domo, tablo ~as</I>. <B>2</B> (<I>resti</I>) maintain position, remain unshaken: <I>~i forte kontraŭ malamiko. Mia decido ~as</I>. <B>3</B> (<I>troviĝi</I>) be situated: <I>Sur la tablo ~as diversaj objektoj. Tiel ~as la afero, demando. Malfacila problemo ~as antaŭ ni</I>. <B>~o</B>, s. <B>~(ant)a</B>, -ing, erect, stationary, stagnant (<I>akvo</I>); uncut (<I>greno). Li restis</I> <B>~e</B>, in a -ing position. <B>~ejo</B>, s., footing, holding, ground, position, post. <B>~ema</B> (<I>stabila</I>), fast, steady, stable. <B>~igi</B>, erect, establish, found, raise, set up. <I>~igi komitaton, mejlŝtonon, metodon:</I> pose (present) (<I>problemon</I>). ➞ <I>establ, fond, kre. Libro~igiloj</I>, book-ends, <B>~igi</B>, (a) s. up, rise to one’s feet. <I>~iĝu!</I> (b) Stick up, s, on end. <I>Miaj haroj ~iĝis. ~iĝis (aperis) malfacilaĵo</I>. <B>~maniero</B>, stance. <B>De~i</B>, s. aside (off). <B>Dis~igi</B> (straddle) <I>la krurojn. Liaj haroj dis~iĝis</I> (bristled). <B>Ek~i</B>, start up, jump to one’s feet. <B>El~i</B>, s. (jut, stick) out. <B>El~a</B>, out-ing, projecting, salient. <B>Super~o</B>, <B>~~i</B>, over-hang. <I>El~aĵo,</I> projection, prominence. <B>Kontraŭ~i</B>, oppose, militate against, resist, with-s. ➞ <I>opon, rezist</I>. <B>mem~a</B>, [UV] autonomous, independent. <B>Mal~igi</B>, demolish, pull down, lay low, strike (tent). <B>Re~igi</B>, re-establish, restore, set up again. <B>Super~i</B>, (over) top, excel, transcend. <I>La monto ~~is</I> (towered above) <I>la urbon</I>. <B>Har~iga</B>, hair-raising.", "0"],
["starti", "start-i", "(nt) <I>= ekiri, ekkuri, ekfunkcii</I>, Start off, depart, drive off, leave, (mot) s. up. -o, s., departure. <I>Kara ~o</I>, running s. <B>~ejo</B>, <B>~fosto</B>, <B>-ing</B> post, <B>~igi</B> <I>kuron per pafo, maŝinon</I>. <B>~igilo</B> (-er), <B>~igisto</B>, -er [Ne= <I>komenc</I>].", "0"],
["statiko", "statik-o", "(mech) stat/ics. <B>~a</B>, -ic. <I>~a akvo, elektro, premo</I>.", "0"],
["statistiko", "statistik-o", "[OA] Statistic/s, numerical facts systematically presented, <B>~a</B>, -al. <B>~isto</B>, -ian. <I>Asekura ~isto</I>, actuary,", "0"],
["stativo", "stativ-o", "stand, support, tripod (of camera, etc.). <I>~o kunmetebla</I>.", "0"],
["stato", "stat-o", "[UV] Condition, State; plight, situation, station (in life), status. <I>Anima ~o,</I> s. (frame) of mind. <I>Spirita ~o</I>, mentality. <I>~o civila, likva. La nuna ~o de la afero. En antaŭa ~o, in statu quo</I>. <B>~i</B>, be in a state. <B>Bon~a</B>, in good condition (circumstances), sound, well off. <B>Sam~ano</B>, one in same position. <B>~montrilo</B>, indication, indicator, symptom. ➞ <I>fart, kondit, pozici, rang</I>.", "0"],
["statuo", "statu-o", "[OA] Statue. <B>~(ec)a</B>, <B>~simila</B>, -esque. <B>~aro</B>, -ary. <B>~eto</B>, -ette.", "0"],
["staturo", "statur-o", "[OA] (<I>homalto</I>), stature, height. <I>Bel~a junulino</I> (Es 2/7). <I>~mezurilo</I>.", "0"],
["statuto", "statut-o", "Statut/e, rules of legislative body, articles of association. <B>~a</B>, -ory.", "0"],
["staŭdo", "staŭd-o", "(bot) perennial.", "0"],
["staŭli", "staŭl-i", "(mot) Stall, lose speed, stop. <B>~angulo</B>, -ing angle.", "0"],
["stearino", "stearin-o", "[OA] Stear/in. <B>~a</B>, -ic.", "0"],
["steatito", "steatit-o", "(<I>sapŝtono</I>), steatite, soapstone.", "0"],
["stebi", "steb-i", "[UV] (<I>maŝinkudri</I>), Quilt. <B>Ĉen~o</B>, chain-stitch. ~ita <I>litkovrilo</I>, q., counterpane. <B>~(ad)o</B>, -ing. <B>~ero</B>, (<I>interplektita ~aro</I>), lock-stitch. <B>~maŝino</B>, sewing-machine. ➞ <I>kudr</I>.", "0"],
["steko", "stek-o", "(cul) steak.", "0"],
["stelario", "stelari-o", "(<I>birdherbo</I>), chickweed, stitch-wort (<I>Stellarid</I>).", "0"],
["steleo", "stele-o", "(arch) stele,", "0"],
["stelo", "stel-o", "[UV] <B>1</B> Star. <B>Fal~o</B> (<I>meteoro</I>) (4 FA 105/5), shooting-s (➞ <I>aerolit</I>). <B>Helŝanĝa ~o</B>, variable star. <B>Mar~o</B> (<I>asterio</I>), s-fish. (astr) Nov~o (<I>novao). ~o Betlehema, duobla, matena, vespera</I>. <B>f</B> <I>Naskiĝi sub bona ~o</I> (lucky s.). <B>~a</B>, -ry, stellar, (th) <B>~ul(in)o</B>, \"star\". (typ) <B>~eto</B> (<I>asterisko</I>). <B>~umi</B>, scintillate. <B>~amaso</B>, s-cluster. <B>~forma</B>, s-shaped. <B>~lumo</B>, s-light. <B>~semita</B>, s-spangled. <B>Sen~a</B>, s-less. <B>2</B> a monetary unit proposed by Cseh, = 6d. ➞ <I>asteri, astr, gage, ilici, madrepor, stelari</I>.", "0"],
["stencilo", "stencil-o", "<B>~i</B>, stencil. ➞ <I>mimeograf</I>.", "0"],
["stenografi", "stenograf-i", "[OA] write Shorthand. <B>~io</B>, [OA] ~arto, s. <B>~aĵo</B>, s-script. If These long forms are usually abbreviated to <B>sten-o</B>, shorthand, stenography; <B>~i</B>, write s., <B>~e</B>, in s., <B>~ist(in)o</B>, s-writer.", "0"],
["stenotipo", "stenotip-o", "(<I>stenomaŝino</I>), shorthand-typing machine. <B>~i</B>, stenotype. <B>~isto</B>, stenotypist. ➞ <I>stenotajpisto</I>, shorthand- typist.", "0"],
["stepo", "step-o", "[UV] Steppe, sandy plain,„ waste land (Jes 40/3). <I>La ~o de Jeriĥo</I> (Jos 4/13). <I>La ~oj de Moab</I> (No 33/48). ➞ <I>erikej, savan, ŝtup. [Ne= paŝ]</I>.", "0"],
["stereofonio", "stereo-fonio", "<B>~grafio</B>, <B>~metrio</B>, <B>~skopo</B>, Stereo-phony, -graphy, -metry, -scope. ~tipi (<I>kliŝigi</I>), -type, <B>f</B> <I>~tipa (banala, rutina</I>), -typed. <I>~tipa demando, frazo, rakonto</I>.", "0"],
["sterila", "steril-a", "Steril/e. <B>1</B> barren, unfruitful; fruitless (<I>klopodo</I>); unproductive (<I>tero</I>); unprofitable (<I>laboro</I>).<B> <I>2</I></B> (<I>senbakteria</I>). <B>~eco</B>, -ity. <B>~igi</B>, -ize. --ilo, -izer.", "0"],
["sterko", "sterk-o", "[UV] <B>1</B> animal Dung, droppings. <B>2</B> Manure. <I>~o likva (~akvo</I>), liquid m. <I>~o minerala</I>, mineral fertilizer. ~i <I>teron</I>. ~amaso, d-hill. -oskarabo, d-beetle (<I>&gt; geotrupo</I>). -otruo, cess-pit.", "0"],
["sterkorario", "sterkorari-o", "(<I>rabmevo</I>), skua (<I>Stercorarius</I>).", "0"],
["sterkulio", "sterkuli-o", "sterculia (tree).", "0"],
["sterledo", "sterled-o", "[UV] (ich) sterlet (<I>Accipenser ruthenus</I>). ➞ <I>huz, sturing</I>.", "0"],
["sterni", "stern-i", "[UV] <B>1</B> Lay, Spread out (at full length and breadth): <I>littukon, tablotukon, reton, tapiŝon. Kiel oni ~as, tiel oni dormas</I>. <B>2</B> open out, unfold: <I>Vi ~as la ĉielon kiel tapiŝon</I> (Ps 104/2). <I>Li ~is antaŭ ni sian tutan vivon</I>. <B>3</B> s. over, scatter, strew: <I>~i sterkon sur la teron. La suno ~is siajn radiojn</I>. <B>4</B> lay low: <I>La pafado ~is centojn da soldatoj. La vento ~is la grenon. Sin</I> ~aĉi, loll, sprawl. <B>~aĵo</B>, 1-er, stratum. <I>Neĝa ~aĵo. ~aĵo el folioj</I>, bed of leaves. ~iĝi (<I>sin ~i</I>), lie down at full length, stretch one’s out. <I>Sin ~i sur la razeno</I>. f <I>~iĝis antaŭ ni longa valo</I>. ~ita, extended, laid out, prone. Sub<B>~o</B>, substratum. <I>~~ita</I>, underlying, latent. ➞ <I>etend, kuŝ, malvolv, tavol</I>. <B>Rim</B>.: <I>sterni</I> relates to horizontal position; <I>etendi</I> to space occupied.", "0"],
["sternumo", "sternum-o", "breast-bone, sternum.", "0"],
["stertoro", "stertor-o", "[UV] Rattle (in the throat). <I>Mort~o</I>, death r. <B>~i</B>, rattle, be at one’s last gasp, in the throes of death, <B>~a</B>, stertorous. ➞ <I>agoni</I>.", "0"],
["stetoskopo", "stetoskop-o", "Stethoscop/e. <B>~i</B>, test with s. <B>~io</B>, -y.", "0"],
["stevardo", "stevard-o", "(av, mar) Steward, passengers’ attendant or waiter, ~ino, -ess, air hostess.", "0"],
["steveno", "steven-o", "(mar) stem (of boat). <I>~o posta,</I> sternpost.", "0"],
["stifa", "stif-a", "(a. sti-), step-(G. <I>Stief</I>) = relation through the second marriage of a parent, but not by blood. ~a patr(in)o, step-father(-mother) = second husband of a mother, second wife of a father, -infano, ~a fil(in)o, step-child(-son -daughter) = child by a former marriage of the husband or the wife, -a frat(in)o, step-brother(-sister). ➞ <I>bo</I>.", "0"],
["stifto", "stift-o", "bolt, key, peg, pin, spindle, headless nail. <B>Aks~o</B>, <B>ĉef~o</B>, king (main) bolt, king-(linch-)pin. <B>Fendita ~o</B>, cotter, split pin. <B>Fiksa</B> <B>~o</B>, stud bolt. <B>Haltiga ~o</B>. <B>Kuplo~o</B>, coupling-pin, stop-bolt. ➞ <I>bolt, kejl</I>.", "0"],
["stigmato", "stigmat-o", "Stigm/a, brand, stain of infamy, (rc) -ata. <B>~izi</B>, -atize.", "0"],
["stigmo", "stigm-o", "(bot) (<I>pistila supro</I>), stigma.", "0"],
["stiki", "stik-i", "(hort) plant (set) cuttings.", "0"],
["stileto", "stilet-o", "stiletto, small dagger. <B>2</B> similar object., e.g., probe. <B>~a</B> <I>kalkanumo (de virina ŝuo</I>). ➞ <I>ponard, kalkan</I>.", "0"],
["stilo", "stil-o", "[UV] Style. <B>1</B> Manner (of expression, action): <I>~o Biblia, bruska, flua, klara, peza, telegrama. ~o baroka, gotika</I>. <B>2</B> make, pattern, shape: <I>laŭ la lastmoda ~o</I>, <B>~igi</B>, -ize, conventionalize. <B>~isto</B>, -ist. <B>Bon~a</B>, -ist. <B>Sen~a</B>, banal. ➞ <I>manier, metod, mod</I>.", "0"],
["stilobato", "stilobat-o", "(arc) stylobate.", "0"],
["stiluso", "stilus-o", "stylus, writing-implement. (bot) style. ➞ <I>grifel</I>.", "0"],
["stilzo", "stilz-o", "(<I>stang-irilo</I>), stilt. <B>~iri</B>. <B>f</B> <I>~aj kruroj</I>. <B>~birdo</B>, wader.", "0"],
["stimuli", "stimul-i", "(<I>-n</I>) [OA], Stimul/ate, excite to action, give a fillip to, incite, prod, spur (urge) on. <I>~i la cerbon, digeston; iun al laboro;</I> foster (<I>amikecon</I>); whet (<I>apetiton</I>). <B>~o</B>, -ation. <B>~a</B>, -ant, -ating, -ative. <B>~aĵo</B>, <B>~ilo</B>, -ant, -us, goad, incentive, spur. ➞ <I>ekscit, fervorig, instig, spron</I>.", "0"],
["stipendio", "stipendi-o", "[OA] Grant, bursary, scholarship, study-allowance, <B>~ulo</B>, exhibitioner, scholar.", "0"],
["stipito", "stipit-o", "(bot) stipe; (zoo) stipes.", "0"],
["stipo", "stip-o", "[UV] stipa grass (<I>Stipa</I>). <B>Plum~o</B>, feather-grass (<I>S. pennata</I>). ➞ <I>espart, genist</I>.", "0"],
["stipulo", "stipul-o", "(bot) stipule.", "0"],
["stiri", "stir-i", "(<I>-n</I>), Steer, (mot) Driv/e, guide (by helm, rudder, wheel, etc.). <B>f</B> direct the course of, pilot. <B>~ilo</B>, handle-bar, helm, s-ing bar, tiller (➞ <I>rudr</I>). <B>~ilaro</B>, s-ing gear, <B>~isto</B>, d-er, helmsman, coxwain. <B>~kolono</B>, -ing pillar, (mot) <B>~lernejo</B>, motor-school, (av) ~stango, joy-stick, <B>~rado</B>, -ing wheel, <B>~ŝnuro</B>, rudder rope. <B>Ne~ebla</B> (<I>ŝipo</I>), disabled. ➞ <I>direkt</I>.", "0"],
["stivi", "stiv-i", "(<I>-n</I>), Stow away (cargo), trim (hold), pack goods away without waste of room, <B>~ado</B>, -age. <B>~isto</B>, stevedore, <B>~ligno</B>, dunnage.", "0"],
["stofo", "stof-o", "[OA] stof, Russian measure &gt; quart.", "0"],
["stoiko", "stoik-o", "Stoic. <B>~a</B>, stoic(al), of great self-control, <B>~eco</B>, <B>~ismo</B>, -ism, indiffce.", "0"],
["stoko", "stok-o", "(com) Stock, goods for sale, quantity in hand, reserve store. <B>~i</B> <I>varojn</I>, s. goods, <B>~ata</B>, in s. <B>~isto</B>.", "0"],
["stolo", "stol-o", "(cl) stole.", "0"],
["stolono", "stolon-o", "(bot) stolon; creeping stem, runner (e.g<I>.fraga) &lt; ŝos</I>.", "0"],
["stomako", "stomak-o", "[UV] Stomach, gizzard, maw. <I>Malsata ~o orelon ne havas</I>. <B>~a</B>, gastric. <B>~ito</B>, gastritis. ➞ <I>ventr</I>.", "0"],
["stomo", "stom-o", "(bot) (zoo) Stoma, minute opening, ~a, -atic.", "0"],
["stompi", "stomp-i", "(des) Stump, shade (soften) off with stump, <B>f</B> <I>~i</I> (tone down) <I>krudajn detalojn</I>. <B>~aĵo</B>, s. drawing. <B>~ilo</B>, s. <B>~ita</B>, blurred, indistinct. <I>Memoroj ~itaj</I>, dim memories.", "0"],
["stoplo(j)", "", "[OA] Stubbl/e. <I>La nudaj ~oj elstaris</I> (1 FA 27/31). <B>~(ec)a</B>, stubbly, scrubby. <I>~a barbo</I>. <B>~ejo</B>, <B>~kampo</B>, s-field. <B>Sen~igi</B> (<I>kampon</I>), clear of s. ➞ <I>kv.ltion</I>.", "0"],
["stop!", "", "(injt) Stop! e.g., in dictation, or to a driver, <B>~signalo</B>. ➞ <I>haltig, punkt</I>.", "0"],
["storako", "storak-o", "storax, balsam from <I>Liquidambar orientate</I>. ➞ <I>benzo</I>.", "0"],
["stovo", "stov-o", "(<I>hejtforno, hejtilo</I>), Stove (for warming rooms). <I>~o longbrula</I>, slow- combustion stove. <B>~tubo</B>, s-pipe. ➞ <I>forn</I>.", "0"],
["strabi", "strab-i", "[UV] (nt) Squint, look obliquely (crosswise), have a cast in one eye. <B>~(ad)o</B>, s., strabismus, <B>f</B> sidelong or stealthy glance, -c <I>rigardi al</I>, squint at. <B>~a</B>, -ing, looking difft ways, <B>~ulo</B>, cross-eyed person. <I>Inter blinduloj regas ~uloj</I>.", "0"],
["stramonio", "stramoni-o", "(<I>dornpomo</I>), jimson-weed, thorn-apple (<I>Datura stramonium</I>). ➞ <I>datur</I>.", "0"],
["strando", "strand-o", "(<I>marbordo</I>), strand, beach, margin (of sea, lake, river), seashore. <I>~o intertajda</I>, foreshore. ➞ <I>plaĝ</I>.", "0"],
["stranga", "strang-a", "[UV] (<I>neordinara</I>), strange, bizarre, curious, droll, odd, peculiar, queer, singular. <I>~a ideo, vesto, vidaĵo</I>. <B>~e</B> <I>vestita</I>. <B>~aĵo</B>, oddity, peculiarity, singularity. <B>~ega</B>, extraordinary. <B>~ulo</B>, crank, eccentric, original. ➞ <I>eksterordinar, fremd, grotesk, kurioz, ne normal</I>.", "0"],
["strangoli", "strangol-i", "(<I>-n</I>), Strang/le, -ulate, throttle, (med) constrict, <B>f</B> suppress. <I>~ita hernio, voĉo</I>. <B>~o</B>, -ulation.", "0"],
["straso", "stras-o", "(<I>falsbrilaĵo</I>), paste (jewellery), brummagem goods, trash. <B>~a</B>, faked, imitation, sham.", "0"],
["strategio", "strateg-io", "[OA] Strateg/y, generalship. ~ia, -ic. <B>~(iist)o</B>, -ist. ➞ <I>taktik</I>.", "0"],
["stratioto", "stratiot-o", "(<I>akvosoldato</I>), (bot) water-soldier, crab’s claw (<I>Stratiotes</I>).", "0"],
["strato", "strat-o", "[UV] Street, thoroughfare, road between buildings. <I>Loĝi en strato X. Promeni laŭ (sur) la ~o</I>. <B>Flanka ~o</B>, side (back) s. Sak~o (<I>~o senelira</I>), blind alley, cul de sac. Unudirekta <B>~o</B>, one-way road. ~a <I>pordo</I>, front door. <B>~ego</B> (<I>avenuo, bulvardo</I>). <B>~eto</B>, alley, _ lane, row. <B>~ulaĉo</B>, hooligan, loafer. <I>Ĉambro</I> <B>ĉe~a</B>, facing the s. <B>Ĉef~o</B>, high (main) s., main avenue. ➞ <I>voj</I>.", "0"],
["stratosfero", "stratosfer-o", "(met) stratosphere.", "0"],
["stratumo", "stratum-o", "(geol) (min), stratum, bed, deposit, layer, measure. <B>~iĝo</B>, stratification. ➞ <I>tavol</I>.", "0"],
["stratuso", "stratus-o", "(met) stratus, sheet of cloud. Alto-(ciro-nimbo-)stratuso.", "0"],
["strebi", "streb-i", "[OA] (nt) strive; do one’s utmost, make great efforts, seek earnestly, try wholeheartedly (to attain or reach). <I>~i al celo</I> (2 FA 111<I>12); al la Eternulo (2</I> Kr 22/9); <I>al malpieco</I> (Ho 4/8); <I>al nokto</I> (Ij 36/20); <I>antaŭen</I> (3 FA 60/36; 4 FA 14/14); <I>eniri</I> (Lk 13/24). <B>~o</B>, great effort, struggle. ➞ <I>cel, klopod, peneg</I>.", "0"],
["streĉi", "streĉ-i", "(<I>-n</I>), [UV] Stretch, brace, make taut (tense), screw up, stiffen, strain, tighten: <I>~i la atenton, okulojn, orelojn. ~i la cerbon</I>, exert one’s wits, rack one’s brains. <I>Sin ~i</I>, s. <B>~o</B>, stretch, strain, tension. <I>~o kaj premo (streso</I>), strain and stress <B>~a</B> <I>muskolo</I>, tensor. <B>~e</B>, fixedly, intensely, narrowly. <I>~e laĉita</I>, tight-laced. <B>~ado</B>, (shoe) treeing. <B>~ilo</B>, extender rack, tightener, (hor) key; (mar) guy-rope; (<I>ombrelo</I>) stretcher. <I>Drat~ilo</I>, brace-rod. <B>~ita</B>, s-ed close, intense, strained, taut, tense, tightened, unflagging. <B>Dis~o</B>, distension. <B>El~i</B> (<I>la brakojn</I>), extend. <B>Ne~ita</B>, loose, slack. <B>Mal~i</B>, ease, loosen. ~<B>~iĝi</B>, relax, give way, unbend. <B>Fort~o</B>, effort. <B>Man~o</B>, span. <B>Tord~i</B>, wind up (clock). Tro~o <I>de la cerbo</I>, mental strain. ➞ <I>etend, rigid, strikt, tord</I>.", "0"],
["streki", "strek-i", "[UV] (make a) Line (Stroke, dash), furrow, score, streak, trace, trail. <I>~i per la fingroj tra la haroj</I>. <B>~o</B>, [OA] s., 1., furrow, streak, trace, (typ) (<I>halto~o</I>), dash. <I>Desegni per kelkaj ~oj</I>. <B><I>~</I>ado</B>. <B>~aĵo</B>, lining, tracing; rifling (of gun). <B>~eto</B> (<I>divida ~o</I>), (typ) hyphen. <B>~ozo</B>, (hort) streak (<I>virusa plantmalsano</I>). <B>El~i</B>, <B>For~i</B>, <B>Tra~i</B>, cancel, cross out, draw line across, run pen through, strike off. <B>f</B> <I>El~i el la libro de vivantoj. Fari ~on tra la lasta jaro</I> (wipe off the slate) (4 FA 183/25). <B>Sub~i</B>, underline. <B>f</B> (<I>emfazi, insisti); Mi aparte ~~as, ke</I>. <B>Tra~o</B>, (sten) intersection. <B>Har~o</B>, (cal) hair-s., fine up-s. (mus) <B>Mezur~o</B>, <B>takto~o</B>, barline. <I>Duobla ~o</I>, double bar. <B>Ombro~i</B> (<I>haĉi</I>), (des) shade. <B>Rand~i</B>, mill (edge of coin). <B>Seg~o</B>, saw-cut. <B>Son~o</B>, (film) soundtrack. <B>Vapor~o</B>, (met) condensation trail. <B>Voj~o</B>, narrow way, path, track. ➞ <I>desegn, lini, stri, vejn</I>.", "0"],
["strepero", "streper-o", "gadwall (duck) (<I>Anas strepera</I>).", "0"],
["streptokoko", "streptokok-o", "streptococcus", "0"],
["streptomicino", "streptomicin-o", "streptomycin.", "0"],
["streptopelio", "streptopeli-o", "(<I>Streptopelia) &gt;</I> collared dove (➞ <I>kolomb, turt</I>).", "0"],
["streto", "stret-o", "(<I>kuntiraĵo</I>), (fugue) stretto.", "0"],
["stridi", "strid-i", "chirr, stridulate, make jarring noise as grasshopper. <B>~a</B>, strident.", "0"],
["strigli", "strigl-i", "(<I>-n</I>) [OA], groom, rub down (horse). <B>~ilo</B>, curry-comb, flesh-brush.", "0"],
["strigo", "strig-o", "[UV] Owl (<I>Strix</I>). <B>Arbara ~o</B>, wood or tawny o. <B>Flama ~o</B>, short-eared o. <B>Longorela ~o</B>, long-eared o. <B>Neĝo~o</B> (<I>nikteo</I>), snowy o. <B>Niza ~o</B> (<I>surnio</I>), hawk-o. <B>Pasera ~o</B>, passerine or pigmy o. <B>Tur~o</B>, barn owl. ➞ <I>guf, nikte, noktu, otus, surni</I>.", "0"],
["striknino", "striknin-o", "[OA] strychnine.", "0"],
["strikno", "strikn-o", "(bot) strychnos. <I>~a ligno,</I> snake-wood. <I>~a nukso</I>, nux vomica.", "0"],
["striko", "strik-o", "[UV] Strike. <B>~i</B>, s, cease work, <B>f</B> <I>Mia memoro ~as</I>. <B>~anto</B>, <B>~ulo</B>, -er. <B>~estro</B>, s-leader. <B>~rompanto</B>, black-leg, s-breaker. <I>~o loktena</I>, stay-in s. <I>~o prokrasta</I>, go-slow s. <B>Malsato~o</B>, hungers. <B>Mastro~o</B>, lock-out <I>[Ne= frap]</I>.", "0"],
["strikta", "strikt-a", "close-fitting, tight-fitting, constricted. <I>~a kamizolo, vesto</I> (2 Sa 20/8). <B>f</B> permitting no exceptions, exact, rigid, rigorous, severe, strict. <I>~a moro, neŭtraleco, ordono, regulo, senco. ~aj limoj</I>. (mus) <I>~a tempo. ~a fugo (kontrapunkto). La kamizolo sidas sur mi</I> ~e (1 FA 151/7). <B>~igo</B>. ➞ <I>rigor, sever, loz</I>.", "0"],
["stringi", "string-i", "(<I>-n</I>), draw (bind, tie) tight, tighten (<I>knoton</I>), embrace (as bear, or boa constrictor), clutch, grip, wring (<I>la koron, manon</I>). -ita, taut, (surg) <B>~ado</B>, ~ilo, ligature.", "0"],
["strio", "stri-o", "[UV] Stripe, Band; bar, ray, score, streak, strip. <I>~o de koloro, lumo, papero, tero, tolo;</I> fork (<I>de fulmo</I>); trickle (<I>de akvo</I>); weal (<I>sur haŭto</I>). (USA) <I>Steloj kaj ~oj</I>. <B>Basa</B> <B>~o</B>, base bar (vn); <B>Funebra</B> <B>~o</B>, mourng b; <B>Post~o</B>, furrow, track, wake (of ship); <B>Zebra ~o</B> (on street). <B>~i</B>, streak, etc. <B>~(it)a</B>, s-ed, streaky, striated; corrugated (iron), fluted, grooved (pillar); grained (wood), ribbed (glass). <I>Monto ~ita de gresaj ~oj</I>. <B>~ozo</B>, (hort) stripe (<I>virusa malsano</I>). ➞ <I>bandaĝ, banderol, bend, ruband, strek</I>.", "0"],
["strobilo", "strobil-o", "cone, strobile. <I>~o abia, lupola, pin</I><B><I>a</I></B>. ➞ <B><I>konus</I></B>.", "0"],
["strobo", "strob-o", "(<I>Vejmuta pino</I>), Weymouth (Eastern white) pine (<I>Pinus strobus</I>).", "0"],
["strofanto", "strofant-o", "(bot) Strophanth/us, from which ~ino, -in.", "0"],
["strofo", "strof-o", "[OA] (pros) verse.", "0"],
["stroncio", "stronci-o", "(chem) strontium (Sr).", "0"],
["strukturo", "struktur-o", "[OA] Structur/e, build, constructs conformation, make. <I>~o de domo, frazo, maŝino, poemo</I>. <B>~a</B>, -al. <I>~a difekto</I>.", "0"],
["strumo", "strum-o", "(<I>koltumoro</I>), goitre, wen.", "0"],
["struto", "strut-o", "[UV] ostrich (Struthius<B>). f ~a</B> <I>politiko (fakt-ignoro</I>). <B>~e</B> <I>ensabligi la kapon</I>. ➞ <I>rtandu</I>.", "0"],
["stuci", "stuc-i", "(hort) dress, trim, remove unsightly pts; lop (<I>arbojn). ~i harojn, heĝon</I>. ~ilo, hedging bill, garden shears, secateur, -orela, crop-eared.", "0"],
["studento", "student-o", "[UV] (college) Student, collegian, undergraduate. <I>~o medicina, teologia. ~a vivo</I>, <B>~aro</B>, s-world. <B>~ino</B>, female s. ➞ <B><I>studant</I></B>. <I>[N</I><B><I>e = kursan, lernant]</I></B>.", "0"],
["studi", "stud-i", "(<I>-n</I>) [OA], (make a) Stud/y (of), do research work on, investigate scientifically, take pains to acquire knowledge (of). <I>~i filozofion, juron, muzikon. ~i sub profesoro</I>. <B>~(ad)o</B>, s., reading, research, <B>~aĵo</B>, work (on subj). <B>~anto</B>, person -ing. <B>~ejo</B>, s (room), <B>~ema</B>, -ious. ➞ <I>etud, lern, student</I>.", "0"],
["studio", "studi-o", "(art, cin, rad) studio, working- room.", "0"],
["stufi", "stuf-i", "(<I>-n</I>), Stew, braise, broil, cook by simmering in closed vessel. <I>~i en ĝia propra suko</I>. <B>~a</B> <I>pato</I>. <B>~ujo</B>, s-pan. <B>~iĝi</B>, (nt) s., simmer slowly. ➞ <I>plenplenig, rembur, stop</I>.", "0"],
["stuko", "stuk-o", "[UV] Plaster, Stucco, cement for coating wall-surface. <B>-i</B> (<I>-n</I>), coat with s., rough-cast, -isto, p-er. ➞ <I>gips, plastr</I>.", "0"],
["stulta", "stult-a", "[OA] Stupid; foolish, silly. <I>~a babilado</I>, foolish talk, -e, -ly. <B>~aĵo</B>, <B>~eco</B>, -ity. -eta, feeble-minded, -ego, crass -ity. <B>~igi</B>, besot, make foolish, stultify. <B>~ulo</B>, blockhead, dolt, imbecile. ➞ <I>malsprit, naiv, sensaĝ, sensenc</I>).", "0"],
["stumbli", "stumbl-i", "(<I>ekfali, faleti</I>), (nt) Stumble, stagger, totter, trip up. <I>~i en la mallumo</I>. <B>f</B> flounder. <B>~o</B>, s., false step, <B>f</B> blunder, indiscretion. (pros) poetic license. <B>Tra~i</B> <I>recitaĵon</I>.", "0"],
["stumpo", "stump-o", "[OA] Stump, remnant, butt, stub. <B>1</B> (of amputated limb): <I>~o de brak-(krur -vost-)o</I>. <B>2</B> (of other obj): <I>~o de arbo, branĉ - brasik - cigar(ed) - dent - kandel -krajon-)o</I>. -(osimil)a, -y, stocky, thickset, truncated. <I>Lia nazo ~as</I>. <B>~eto</B>, candle-(cigarette-)end. Sen~igi <I>teron,</I> clear of (grub up) ss. ➞ <I>stomp, ŝtip, trunk</I>.", "0"],
["stupo", "stup-o", "[UV] Oakum, Tow, hemp (flax, cotton) waste (Jĝ 16/9, Jes 1/31). <B>~(ec)a</B>, t-y. <I>Disŝiri ~on</I>, pick o. <B>~aĵo</B>, caulk-plugging, -stuffing. <B>~umi</B>, stuff with o. <B>~hara</B>, with tow-like (washed-out) hair.", "0"],
["stuporo", "stupor-o", "(<I>sens-obtuzo</I>), stupor, dazed state, stupefaction. <B>f</B> hopeless amazement. ➞ <I>torpor</I>.", "0"],
["sturgo", "sturg-o", "[UV] common sturgeon (<I>Acei- penser sturio</I>). ➞ <I>sterled</I>.", "0"],
["sturmi", "sturm-i", "(<I>kurataki</I>), Storm, assail, charge. <B>~o</B>, assault, attack, onset, swoop. ~a <I>trupo</I>, s-(shock-) troop. <B>~e</B>, at the charge. ~e <I>preni</I>, take by s. ➞ <I>ŝtorm</I>.", "0"],
["sturno", "sturn-o", "[UV] starling (<I>Sturnus</I>), Roza <B>~o</B>, rose-colored s.", "0"],
["sub", "", "(prep), Under(neath), beneath (touching or not). Dormi - tegmento. Kuri - la lito(ri). Porti ~ la brako. <B>f</B> - la formo de, <I>as, in the shape of. ~</I> tiu kondiĉo, <I>on that conditin. ~a, lower, nether, u-(lying</I>). ~a tavolo. <I>~e u-neath, below</I>. Li iris <I>~en, went below. Ĉi-e, u. this, -aĵo (</I>~ŝtofo), <I>-lay, lining, substratum. ~igi, overcome, sub-due(-jugate). ~ulo, -ling, inferior, subordinate. (PFX) ~ir(~kuŝ~lu)i. ~mara (~tera); ~vesto (~vojo). 1T Special use</I> ( = kas): <I>~aĉeti, bribe; ~aŭskulti, eavesdrop; ~bruli, smoulder; ~kompreni, infer; ~ridi, chuckle; ~voĉe, in an u-tone. ➞</I>. <I>malsuper</I>, malsupr. <I>subaltern-a, Subaltern, of inferior rank, (log) subordinate</I>. ~a pozicio.<I> <B>~ulo</B></I> (suboficiro), <I>s., sub-officer, subordinate, underling</I>.", "0"],
["subita", "subit-a", "[UV] Sudden, abrupt, unexpected, without warning. <I>~a mort-(mov-ŝanĝ-tim-)o</I>. <B>~e</B>, -ly, all at once, of (on) a s. <I>~e fali (veni</I>). ➞. <I>abrupt, brusk, neatendit, rapid</I>.", "0"],
["subjektiva", "subjektiv-a", "[OA] Subjectiv/e. <B>1</B> (phi) (opposite real, external). <B>2</B> rel. to personal idiosyncracy or individual point of view. <B>~e</B>, -ly. <B>~eco</B>, ~ismo, -eness, -ism, -ity. Opp <I>objektiv</I>.", "0"],
["subjekto", "subjekt-o", "[UV] Subject. <B>1</B> (gr, log). ~o <I>de frazo</I>. <B>2</B> (<I>temo): la ~o de la diskuto, eksperimento</I>, (mus) <I>~o de fugo, movimento</I>. <B>Kontraŭ~o</B>, counter-s. <B>f</B> (person) <I>Li estas ĉefurba ~o</I> (town character). (Rz 40/22). ➞ <I>komplement, predikat</I>, Opp <I>objekt</I>.", "0"],
["subjunktivo", "subjunktiv-o", "[OA] (gram) Subjunctive mood (none in Esp). ➞ <I>kondiĉ, volitiv</I>.", "0"],
["sublima", "sublim-a", "sublime, exalted, inspiring awe or lofty emotion. <I>~a genio, penso, sinofero, vidaĵo</I>. ➞ <I>majest, nobleg, superbel</I>.", "0"],
["sublimi", "sublim-i", "(chem) Sublimate, refine. <I>~i sulfuron</I>. <B>f</B> idealize. <B>~ato</B> [UV] (<I>~aĵo</I>), s., (col) <I>=koroda ~aĵo (hidrargika klorido</I>), corrosive s. (Hg CU).", "0"],
["subsidi", "subsid-i", "subside, abate (<I>ŝtormo, tumulto</I>); become less active; go down (<I>inflamo</I>); cave in (<I>grundo</I>); sink in level (<I>akvo</I>). ➞ <I>sink</I>.", "0"],
["substanco", "substanc-o", "[OA] Substan/ce. <B>1</B> (phi) (opp accident), essence, gist, pith, purport, real meaning. <I>~o de argumento, artikolo, parolo</I>. <B>2</B> reality, solidity (opp shadow). <B>3</B> matter: <I>Flava ~o</I>. <B>~a</B>, -tial (opp nominal, verbal): <I>~a progreso</I>. <B>Trans~iĝo</B>, transubstantiation. ➞ <I>materi(al), ŝtof</I>.", "0"],
["substantivo", "substantiv-o", "[UV] Substantiv/e, noun. <B>~a</B>, -al.", "0"],
["substitui", "substitu-i", "(<I>-n</I>), (chem) Substitu/te. <B>~anto</B>, -ent. <B><I>Tolueno estas facile</I></B> <B>~ebla <I>de kloro</I></B>. ➞ <B><I>anstataŭ(ig</I>), <I>surogat</I></B>.", "0"],
["substrato", "substrat-o", "substratum, underlying basis, foundation. <I>~o de vero</I>.", "0"],
["subtila", "subtil-a", "[OA] Delica/te, Subtle. <B>1</B> fine, light; <I>~a aero, parfumo, vaporo, pluvo</I> (drizzle), <I>polvo</I> (Jes 29/5). <B>2</B> hard to grasp, pervasive: <I>~a arto, ĉarmo, magio, povo</I>. <B>3</B> acute, capable of noticing, discerning, having keen perception or insight: <I>~a intelekto (senso</I>). <B>4</B> d., with fine shade of diffce: <I>~a fantazio, ironio, nuanco, teorio. ~a diferenco, distingo</I>, nice distinction. <B>~aĵo</B>, s-ty, nicety, quibble, <B>~eco</B>, d-cy. <B>~igi</B>, subtilize. Mal<B>~a</B>, coarse, subtrah-i (<I>depreni</I>), (arit) subtract. <B>~o</B>, -ion.", "0"],
["subuteo", "subute-o", "(<I>alaŭdfalko</I>), hobby (<I>Falco subbuteo</I>).", "0"],
["subvencio", "subvenci-o", "[OA] (<I>oficiala monhelpo</I>), Sub- sid/y, bounty, grant, subvention. <I>Ricevi ~on de</I>, be -ized by. <B>~i</B>, -ize, make a grant in aid. <B>f</B> defray, meet, provide for, supply. <I>~i bezon-(elspez-) ojn</I>.", "0"],
["suĉi", "suĉ-i", "(<I>-n</I>) [UV], Suck. <I>~i botelon, marnon de patrino, mielon el floroj, dikfingr-(lakt -oranĝ-pastel-vund-)on</I>. f <I>~i ies cerbon</I>. ~(ad)o, -forto, suction, <B>~aĵo</B>, dummy (for baby), sweet, etc. ~igo, lactation. <B>~ilo</B>, -er. <I>Polv~ilo</I>, vacuum cleaner. <B>~ulo</B>, ~infano (<I>bebo</I>), -ling, babe, baby-in-arms, infant, nurseling, f <I>la ~infana periodo de nia lingvo</I>. <B>El~i</B>, exhaust, drain. ~~i <I>venenon el vundo. I La malsano ~~is miajn fortojn</I>. <B>En~i</B>, s. in(up), absorb, draw in, imbibe, soak up, swallow. <I>Spongo ~~as akvon, ~~iĝi</I>, be -ed (sink) in. <B>Mam~i</B>, s., take the breast, (<I>mam) ~igi</I>, suckle, give the breast to. <I>~igistino</I>, foster-mother, wet- nurse. <B>Sang~anto</B> (<I>vampiro</I>), bloodsucker, vampire. ➞ <I>ĉerp, sorb</I>.", "0"],
["Sudano", "Sudan-o", "[OA 8] SD. <B>Sud-S~o</B>.", "0"],
["sudo", "sud-o", "[UV] South. <B>~a</B>, s., -erly, -ern, meridional. <I>~a poluso, vento</I>. <B>~e</B>, in the s. <I>~e de</I>, (to the) s. of. <I>De ~e,</I> from the s. <B>~en</B>, southwards, to the s. <B>~ano</B> (Ob /19), <B>~ulo</B>, -erner. <B>S~afriko</B>. <B>Plej~a</B>, -ernmost.", "0"],
["suferi", "sufer-i", "(<I>-n, de, je, pro</I>) [UV] Suffer. <B>1</B> Feel distress or pain. <I>Kapo pekis, piedoj ~as</I>. -7 <I>de gripo, soifo</I>. <B>2</B> be subjected to (experience) affliction, etc: <I>~i atak-(perd -mankon, mizeron. La kunveno -is pro multeco de lingvoj</I>. ~(ad)o, -ing, affliction, distress, pain, trouble. <I>Pacience elporti -ojn</I>. ~anto, -er, <I>Nur -into ŝatas feliĉon</I>. <B>~ebla</B>, bearable. <B>~ego</B>, intense -ing, agony, anguish, pangs. ~ema, peaky. <B>~igi</B>, make s., distress, hurt, pain, trouble. <I>Tertremoj -igas la landon</I>. ~oplena <I>krio,</I> cry of distress. Ne<B>~ebla</B>, intolerable. Sen<B>~e</B>, without -ing. ➞ <I>aflikt, angor, dolor, elport [Ne= lasi, permesi]</I>.", "0"],
["sufiĉa", "sufiĉ-a", "[UV] Enough, Adequa/te, Suffic/ient. <I>Apenaŭ ~a,</I> a bare (mere), only just e. <B>~e!</B> Enough! That will do! <I>~e da</I> (enough) <I>lakto, mono, tempo. ~e da tio!</I> Have done with, (no more of, a truce to) that! <B>~i</B>, be e., s., (do) for, meet the needs of, satisfy, suffice. <I>Tio ~os por mi. ~as diri, ke</I>. I will content myself by saying (Suffice it to say) that. ~os (Estos ~e), se, It will suffice if. .. <B>~eco</B> a-cy, s-iency, <B>~ega</B>, abundant, ample, copious, more than s. <B>Mem~a</B>, self s-ient, independent. <B>Ne~a</B>, in-a, in-s. <I>Ne~e meblita</I>, poorly furnished. <I>Ne ~e kuirita</I>, underdone. ➞ <I>abund, adekvat, dec, iom, sat</I>.", "0"],
["sufikso", "sufiks-o", "[F], Suffix. <B>Pseŭdo~o</B>.", "0"],
["sufleo", "sufle-o", "(cul) souffle.", "0"],
["sufloro", "suflor-o", "[OA] (th) prompter. prompt, supply wanted words. ~a kesto, prompter’s box.", "0"],
["sufoki", "sufok-i", "[UV] Suffocat/e, stifle. <B>1</B> choke, smother, strangle, throttle. <B>2</B> keep back, repress, restrain: <I>~i indignon, koleron, oscedon, ridon, larmojn;</I> bottle up (<I>sentojn</I>); stamp out (<I>epidemion</I>); suppress (<I>ribelon</I>). <B>~a</B>, close, stuffy. <B>~eco</B>, stuffiness, sultriness, want of air. <B>~(iĝ)o</B>, -tion, asphyxia. <I>~iĝi</I>, choke, <I>~igi de kolero, rido</I>. ➞ <I>brems, damp, dronig, strangol, subprem</I>.", "0"],
["sugesti", "sugest-i", "Suggest. <B>1</B> (<I>pensigi</I>), cause to be thought of, call up in the mind, give a hint (inklining) of: <I>Mi ~as</I> (put it to you), <I>ke</I>. <B>2</B> (<I>proponed</I>); propose (idea) for considerate: <I>Mi ~as, ke vi skribu. ~i alternation</I>. <B>~o</B>, -ion, hint, insinuate. <B>~a</B>, -ive, <I>Respond~a demando</I>, leading question.", "0"],
["sugestii", "sugesti-i", "[OA] Suggest (influence) by hypnotic influence, <B>~ebla</B>, -ible (open) to h.i… . Sugesti-i (used 14 times by Z.) is used with both meanings of \"suggest\", but now increasingly reserved for the hypnotic mg. Perhaps sugest- will finally survive with both meanings.", "0"],
["suito", "suit-o", "(mus) suite (<I>dancaro</I>).", "0"],
["sukceno", "sukcen-o", "[UV] (<I>fosilia rezino</I>), yellow amber. <B>~(ec)a</B>, of a. <I>~a buŝpeco de pipo. ~a bido</I>. ➞ <I>ambr</I>.", "0"],
["sukcesi", "sukces-i", "(<I>en, pri, -i</I>) [UV], (nt) Succeed, have Success, be s-ful, accomplish one’s purpose, come off, have the desired result, pass (<I>ĉe ekzameno</I>), turn out well. <I>~i iri,</I> s. in going. <I>~i pri</I>, pull off. <B>~o</B>, s., accomplishment of aim, favourable result. <I>Ĝui, havi, ricevi ~on. Trafi grandan ~on,</I> make a hit, \"take\". <B>~a</B>, s-ful. <B>~igi</B>, make s-ful. <B>Mal~i</B>, <B>Ne~i</B>, fail, break down, fall through, prove abortive. <B>~~o</B>, defeat. <I>~~igi</I>, frustrate, ruin, wreck. <B>Sen~a</B>, un-ful. <B>Sen~e</B>, without s., unavailingly, in vain. ➞ <I>prosper</I>. Opp <I>bankrot, fiask, ruinig</I>.", "0"],
["sukero", "suker-o", "[UV] Sugar. <B>Bet~o</B>, beet s. <B>Kan~o</B>, cane s. <B>Kristala ~o</B>, granulated s. <B>kruda ~o</B>, brown s. <B>Peca ~o</B>, lump s. <B>Pulvora ~o</B>, caster s. (chem) <B>Frukt~o</B>, fructose. <B>Lakt~o</B>, s. of milk (lactose), <B>~dolĉa</B>, <B>~gusta</B>, sugary, sweet, <B>f</B> honeyed. <B>~i</B> (<I>-n</I>), (sweeten with) sugar. <B>~aĵo</B>, sweet(meat), comfit, dainty. <I>~aĵoj</I>, confectionery, <I>~~isto</I>, confectioner. <B>~kanejo</B>, s-plantation. ➞ <I>bombon, dole, kand, konfit</I>.", "0"],
["suko", "suk-o", "[UV] Juic/e, organic fluid, sap. <I>~o de limono, oranĝo. Frukta ~o</I>, fruit j. <I>Stomaka -o</I>, gastric j. <I>Vianda suko</I>, gravy, <B>f</B> vim. ~abunda, ~plena, ~oriĉa. j-y, luscious, succulent. <B>~arbeto</B>, sapling. <B>~ligno</B>, alburnum, sapwood. <B>Sen~a</B>, faded, sere, stunted, withered; insipid, <I>~~iĝi</I>, dry up, wilt, wither. ➞ <I>sekiĝ, sirop, velk</I>.", "0"],
["sukuro", "sukur-o", "(<I>unua helpo</I>), first aid. <B>~ejo</B>, <B>~isto</B>.", "0"],
["sulfuro", "sulfur-o", "[UV] (chem) Sulph/ur, brimstone (S). <B>Stanga ~o</B>, roll s. <B>Pulvora</B> (<I>sublimita</I>) <B>~o</B>, flowers of s. <B>~(ec)a</B>, -uric, -urous. <B>Rim</B>.: Combining form: <I>sulf-</I>. Sulf -ato, -ido, -ito, -onato, Sulph-ate (- ide - ite - onate). <B>~atacido</B> (<I>vitriolo</I>), -uric acid, <B>~idacido</B>, -uretted hydrogen, <B>~itacido</B>, -ous acid. <B>Rim</B>.: <B>Feroza ~ato</B>, green vitriol; <B>kupr(ik)a ~ato</B>, blue vitriol; <B>zinka ~ato</B>, white vitriol.", "0"],
["sulko", "sulk-o", "[UV] Furrow, Wrinkle (<I>brova</I>); drill (agr); groove (anat); rille (<B>luna</B>); ripple-mark (geol); streak (<B>luma</B>); trough (met). <I>La plugilo (ŝipo) tranĉis ~on en la tero (maro</I>). <I>Havi ~ojn (faltojn) sur la frunto</I>. <I>Maljunulaj ~oj</I> (K 138/5). <B>Rad~o</B>, <B>Voj~o</B>, track, rut. <I>La voj~o de rutino</I>. <B>~(iĝint)o</B>, f-ed, w-ed. <I>Venteto ~etigis la maron</I>. <B>~igi</B>, f., w. <I>~igi la brovojn (frunton), knit the brows,</I> <B>~iĝi</B>, wrinkle, pucker, ruck up. <B>~umita papero</B>, corrugated (ribbed) paper. ➞ <I>ĉif, fald, falt, fold, ŝrump</I>.", "0"],
["sulo", "sul-o", "booby, gannet, solan goose (<I>Sula</I>).", "0"],
["sultano", "sultan-o", "[OA] <B>1</B> Sultan, <B>~ino</B>, <B>~a</B>, -ess. <B>2</B> (cul) sultana. ➞ <I>rosinet</I>.", "0"],
["sumako", "sumak-o", "sumach (<I>Rhus). ~o venena,</I> poison ivy.", "0"],
["sumo", "sum-o", "[UV] sum. <B>1</B> (arit) total. <B>2</B> definite amount (quantity). <I>~o da mono</I> (Ge 23/9). <I>Pagi grandan ~on</I>. <B>~e</B> (<I>entute</I>), in all, all things together. <B>~ero</B>, item. <B>~igi</B>, add (tot) up, total. <I>Popol~igo</I>, census. <I>~igilo</I>, totalizator. <B>~iĝi</B> <I>al</I>, come to. ➞ <I>adici, epitom, kompendi, resum</I>.", "0"],
["suno", "sun-o", "[UV] Sun. <B>1</B> Centre of solar system. <I>Levigi kun la ~o</I>. <B>2</B> another star regarded as a s. <B>3</B> (<I>=~lumo, ~radioj), Estas nenio nova sub la ~o. Sidi en la ~o</I>. <B>~a</B>, solar. <I>~a jaro, sistemo</I>. <B>~(hel)a</B>, <B>~plena</B>, -ny. <I>~a loko</I>. <B>~brilo</B>, <B>~lumo</B>. sunlight, sunshine. <B>~umi</B>, expose to the s. <B>~leviĝo</B>, <B>~subiro</B>, sunrise, sunset. <B>Sen~a</B>, sunless, dull, cloudy, overcast.", "0"],
["super", "", "[UV] (prep), Above, Super-, over (without touching). ➞ <I>sur</I> (touching.) <I>~ la rivero, tero. La suno leviĝis ~ la teron</I>. <B>f</B> beyond. <I>Tio estas ~ mia povo</I>, more than I can do (of work): <I>Labori ~ projekto, sidi</I> <B><I>~</I></B> <I>problemo, ŝviti</I> <B><I>~</I></B> <I>la alfabeto</I>. <B>~a</B>, s-ior, higher, upper. <I>~a inteligento, oficiro. ~a matematiko</I>, higher mathematics. <B>~i</B>, [UV] beat, exceed, excel, surpass. <I>~i ĉiujn per kuraĝo. La sukceso ~is nian atendon</I>. <B>Ne~ebla</B>, ins-able, unsurpassable. <B>~aĵo</B>, <B>~eco</B>, s-iority. <B>~ega</B>, supreme, surpassing, transcendent. <B>~emo</B>, emulation, desire to excel. <B>~ulo</B>, s-ior. <B>Mal~a</B>, inferior, below, lower. <I>PFX:</I> <B>Super-</B>, super-, (a) (<I>loka</I>): <B>~signo</B>. (b) (<I>kvalita</I>): <B>~natura</B>. (c) (<I>ekstra</I>): <B>~flua</B>.", "0"],
["superba", "superb-a", "(<I>eksterordinare bela aŭ bona</I>), <I>superb. ➞ 2 FA 18/30</I>.", "0"],
["superlativo", "superlativ-o", "[OA] (gram) Superlativ/e degree. ~o <I>absoluta, rilata</I>. <B>~e</B> (s-ly) <I>bela</I>. ➞ <I>plej</I>.", "0"],
["superstiĉo", "superstiĉ-o", "[UV] Superstit/ion. <B>~a</B>, -ous. <B>~ulo</B>, -ous person.", "0"],
["supla", "supl-a", "supple. <I>~a ganto (ledo</I>). Adaptable (<I>menso</I>); flexible (<I>branĉo, voĉo</I>); limp (<I>bindo</I>); lithe, lissom (<I>korpo</I>); pliant (<I>kano</I>). ➞ <I>fleksebl</I>.", "0"],
["suplemento", "suplement-o", "(<I>aldonaĵo</I>), Supplement. <B>~a</B>, -ary, addnl, extra, fuller, further. <I>~a kredito. ~a pago</I>, excess fare, extra charge. <I>~aj horoj</I>, overtime, (mat) <I>~a angulo</I>. (mus) <I>~aj linioj (kromlinioj</I>), leger lines. <B>2</B> (gram) (<I>kompletigo akcesora</I>), enlargement (of subj or obj).", "0"],
["supo", "sup-o", "[UV] Soup. <I>Ne por lupo estas ~o,</I> It’s too good for the likes of you, <I>Aven~o</I>, skilly. <I>Lent~o, piz~o, viand~o</I>. <B>~eca</B>. -y. <B>~ejo</B>, s-kitchen. <B>~ujo</B>, s-tureen. <B>~ĉerpilo</B>, s-ladle. ➞ <I>buljon, kat</I>.", "0"],
["supozi", "supoz-i", "[UV] Suppos/e, accept as true or possible without proof; assume, be inclined to think, imagine, presume, take for granted. <I>Mi ~as, ke jes</I>, I s. so. <I>~i vera</I> (of question under discussion), beg the question. <I>Ni ~u</I> (let us assume, take it for granted), <I>ke. Oni ~as</I> (It is thought), <I>ke. ~u vin en Romo</I>, imagine yourself in Rome. <B>~o</B>, supposition, assumption, conjecture, hypothesis. <I>Tio konfirmas miajn ~ojn</I>. <B>~e</B>, ke, on the -ition that. <B>~(at)a</B>, -ed, alleged, hypothetical, reputed, putative. <B>~eble</B>, as can be -ed, presumably. <I>Eĉ ne</I> <B>~eti</B>, not have the ghost of an idea. <B>~igi</B>, cause to s., suggest. <I>Tio ~igas, ke li mortis</I>. <B>Antaŭ~i</B>, expect, pre-s. <B>Ek~i</B>, surmise, suspect. ➞ <I>diven, hipotez, konjekt</I>.", "0"],
["supro", "supr-o", "[UV] Top, summit. <I>La ~o de la monto, turo</I>. <B>f</B> highest grade. <I>La en- tuziasmo atingis la ~on</I>. <B>~a</B>, [UV] upper. <I>Plej ~a</I>, highest. <I>~a etaĝo, parto</I>. <B>~e</B>, above, at the top, aloft, on high, up(stairs). <I>Vidu ~e! De</I> <B><I>~e</I></B>, from a. ~e de, on the t. of. <I>~e eitita</I>, a-mentioned. ~en, up(wards). <I>La vojo iras ~en. La ~ena vojo</I>, upward path. <I>~eniri</I>, ascend, climb (go) up(stairs), mount, rise. <I>~enejo</I>, way up. <B>~aĵo</B>, [UV] (<I>surfaco</I>), face, surface. <I>~aĵa</I>, superficial, outer. <I>~aĵa inspekto, lego, rigardo. Juĝi ~aĵe. ~aĵema</I>, shallow. <I>~aĵulo</I>, smatterer.", "0"],
["sur", "", "[UV] (prep), <B>1</B> (malsub), on, upon, (touchg): <I>Sidi ~ la planko, seĝo, tero. Mizero ~</I> (added to) <I>mizero</I>. (direction): <I>Fali ~ la teron</I>. <B>2</B> (covering): Bildo ~ la muro, rideto ~ la vizaĝo. <B>3</B> (position): havi la kapon ~ la ĝusta loko. Frapi iun ~ la kapo. <B>4</B> (= en):Se mi estus ~ via loko. ~ la ĉielo, kampo, strato. <B>5</B> ( ~~ al): Rigardi ~ la kampon, ~ maron. Beno estu ~ via kapo. ~ la Danan tronon mi havas rajtojn. Efiki ~ la ovoj (4 FA 20/37) <B>~akva</B> promeno, water trip. <B>~meti</B> veston. <B>~verŝi</B> oleon.", "0"],
["surda", "surd-a", "[UV] Deaf, hard of hearing. <I>~a ĉe unu orelo. ~a kiel fosto</I>. <B>f</B> not wishing to hear. <I>Resti ~a (por), turni ~an orelon,</I> turn a d. ear, be unresponsive. ~eta, duon<B>~a</B>, iom <B>~a</B>, a little d. ~igi. -en. <B>~iĝi</B>, become d., lose one’s hearing. <B>~ulo</B>, d. person. <I>Prediki al ~uloj</I>, ➞ <I>damp, mut. obtuz</I>.", "0"],
["surfaco", "surfac-o", "(<I>supraĵo</I>), Surface<B></B>, <I>~o glata, granda. Floti sur (leviĝi al) la ~o de la akvo. Penetri sub la ~on</I>. <B>~a</B>, on the s., shallow, superficial. <I>~a amikeco (ĝentileco</I>). (mot) <B>Rul~o</B>, tread (of tyre).", "0"],
["surfo", "surf-o", "(<I>ondrosalto</I>), surf, foam and commotion of sea breaking on rock or shore. <B>~rajdado</B>. <B>~tabulo</B>.", "0"],
["Surinamo", "Surinam-o", "SR.", "0"],
["surnio", "surni-o", "(<I>niza strigo</I>), hawk owl. (<I>Surnia ulula</I>).", "0"],
["suro", "sur-o", "(<I>tibikarno</I>), calf (of leg).", "0"],
["surogato", "surogat-o", "(<I>anstataŭaĵo</I>), substitute, imitation, make-shift. <B>Sap~o</B>, detergent,", "0"],
["surpliso", "surplis-o", "(ecc. cl), surplice. <I>Blankaj ~oj</I> (Rn 24/7).", "0"],
["surprizi", "surpriz-i", "(<I>-n</I>) [UV], Surpris/e, astound by unexpectedness; catch (come upon) one unawared, unprepared (off one’s guard). <I>~i la malamikon. La nokto nin ~is</I> (overtook). <B>~o</B>, s. <I>Je mia granda ~o</I>, to my great s., much to my s., to my utter astonishment. ~as <I>min, ke</I>, What -es me is that. <I>Tio ne ~as min</I>, I don’t wonder at it, I am not -ed, it is not to be wondered at. <B>~e</B>, -ingly. <B>~iĝi</B>, be -ed, taken unawares. <B>~ita</B>, -ed, startled.", "0"],
["surtuto", "surtut-o", "[UV] loose-fitting over-garment or covering = io sur la tuto, vesto super la aliaj. <B>Tabla ~o</B>, centrepiece<B></B>. ➞ <I>mantel, palt, redingot</I>.", "0"],
["suspekti", "suspekt-i", "(<I>-n, ke</I>) [UV], have Suspic/ion, suspect. <B>1</B> be inclined to think, half believe, have impression without certain proof: <I>~i, ke li estas prava; ke li eraras</I>. <B>2</B> distrust, doubt the innocence of, be -ious of: <B>~i <I>danĝer</I></B><I>on,</I> <B><I>komploton. ~i iun pri ŝtelo. Kiu ~us, ke li estas spiono?</I> 2</B> doubt the genuineness or truth of: <I>~i la aŭtentecon (verecon) de; ~i ies lojalecon</I>. <B>~o</B>, -ion, doubt, question, mistrust. <I>Veki ~on. ~o ne egalas pruvon. Rigardi</I> <B>~e</B>, look askance at. <B>~ato</B>, s. <B>~ema</B>, -icious by nature, mistrustful. <B>~igi</B>, throw s. on. <B>~inda</B>, -ious, shady, worthy of s. doubtful, questionable. <B>Ne~ebla</B>, above -ion. <B>Sen~e</B>, un-ing-ly, without mistrust.", "0"],
["suspendi", "suspend-i", "(<I>-n</I>), (mus) Suspen/d (= prokrasti). ~i <I>solvon de disonanco</I>. <B>~o</B>, -sion.", "0"],
["suspensi", "suspens-i", "(nt), (chem) be in Suspension. <B>~aĵo</B>, matter in s.", "0"],
["suspiri", "suspir-i", "(<I>sopire ĝemi</I>), sigh audibly. <I>Li laŭte ~is</I>. <B>f</B> <I>Nur la</I> <B>~ado</B> <I>de la vento respondis</I>. ➞ ĝem, ve.", "0"],
["susuri", "susur-i", "(nt) [OA] (2 FA 59/1). Rustle (<I>papero, folio</I>): buzz (<I>insekto</I>); murmur (<I>maro</I>); swish (<I>silko</I>); sough (<I>vento</I>). <B>~(ad)o</B>, <B>~(ant)a</B>, rustling, etc.", "0"],
["sutano", "sutan-o", "[OA] cassock. ➞ <I>rob, talar, tog</I>.", "0"],
["suturi", "sutur-i", "(surg), Stitch (unite edges of) wound. <B>~o</B>, suture, s-ing.", "0"],
["suvereno", "suveren-o", "Sovereign, supreme ruler. <B>~a</B>, s., supreme. <I>~a potenco, princo, rimedo</I>. <B>~eco</B>, -ty. ➞ <I>sovren</I>.", "0"],
["svarmo", "svarm-o", "[OA] (4 FA 44/34). Swarm, crowd, large number, great numbers, mass, mob, press, throng, host (of ideas). <B>1</B> s., be crowded together, cluster, congregate: <I>~as homoj sur la strato; kuloj super la arbo; ŝipoj en la haveno</I>. IT <B>2</B> be alive (over-run) with, be full of. Perhaps the only example of this exceptional use is <I>La rivero ek~is per ranoj</I> (El 8/3). <I>Elrampi</I> <B>~e</B>. <B>~adi</B> (4 FA 44/33). <B>~ado</B>, s-ing. <B>~ejo</B> <I>por fantomoj</I> (If 31/9). <B>Ek~i</B> (<I>paseroj</I>) (3 FA 28/19). <B>~amaso</B> <I>da abeloj</I> (Jĝ 14/8). ➞ <I>amas, ar</I>.", "0"],
["svastiko", "svastik-o", "(<I>hokkruco</I>), swastika.", "0"],
["svati", "svat-i", "[UV] (<I>peri edziĝon) al</I>, act as Marriage-agent (go-between, intermediary), negotiate a match for someone else. <B>~ist(in)o</B>, matchmaker, matrimonial agent. <B>~ejo</B>, m-bureau. <B>~iĝi</B> (sin ~i) (<I>Je, al</I>), court, make suit to, pay one’s addresses to, seek the hand of. <I>Multaj ~iĝas, feliĉulo edziĝas</I> (P). <I>~iĝanto</I>, suitor, wooer. ➞ <I>amindum, aspir</I>. svelta = gracila.", "0"],
["Svazilando", "Svaziland-o", "SZ.", "0"],
["Svedujo, Svedio", "Sved-ujo, Svedio", "[OA 8] SE.", "0"],
["sveni", "sven-i", "(nt), [UV] Faint, Swoon, have f-ing fit, lose consciousness. <B>~eto</B>, dizziness, half-s. <B>~o</B>, s., f-ing fit. <I>Fali</I> <B>~e</B>. <B>~igita</B> <I>de la bato</I>. <B>f</B> <B>(For)~i</B>, die (fade languishingly) away. <I>La odoro, tago ~~is</I>. <B>~eta</B> sento, sinking feeling. <I>La vortoj</I> <B>duon~e</B> <I>forsonis preter liaj oreloj</I>.", "0"],
["svingi", "sving-i", "(<I>-n</I>), [UV] Swing. <B>1</B> to and fro, backwards and forwards, in all directions: <I>~i la brakojn, krurojn;</I> Brandish (<I>glavon</I>); beat, flap (<I>flugilojn</I>), twirl (<I>bastonon</I>); wag (<I>voston</I>); wave (<I>ĉapelon, manon, tukori). Ili dancis, ~ante sin tien kaj reen</I>. <B>2</B> swing (throw) forward, push on, se going start off: <I>~i martelon, piedon, pilkon</I>. <I>Kiu tro forte ~as, nenion atingas</I>. <B>~o</B>, <B>1</B> swing wave, etc. <I>~o de mano (pendolo</I>). <B>2</B> (mus) (dance) swing. <B>~iĝi</B>, swing, dangle, hang loose, rock, sway, spin (compass), ride at anchor (ship). <B>~ilo</B>, clapper, tongue (<I>sonorila</I>); handle (<I>pumpila</I>); pendulum (<I>horloĝa</I>); starting-handle (<I>aŭta</I>); (gm) (a. <I>pendolo</I>),children’s s. <B>~boato</B>, s-boat (at fair). ➞ <I>balanc, kirl</I>.", "0"],
["Svislando", "Svis-lando", "CH.", "0"],
["ŝablono", "ŝablon-o", "Pattern, form, model, mould, stencil plate, transfer, e.g., for lace. <I>Desegni per ~o</I>. <B>f</B> cliche, stereotyped form. <B>~a</B>, formal, stereotyped, routine. <I>Labori</I> ~e (like a machine). <I>Tajli</I> <B>~e</B>, cut out to p. <I>Homo ~e edukila</I>. <B>~iĝo</B> <I>de la homaro</I>. ➞ <I>gurd, stencil, stereotip</I>.", "0"],
["ŝafo", "ŝaf-o", "[UV] sheep, (astr) ram (<I>Aries</I>), <B>f</B> (a) person blindly imitative. <I>Sekvi</I> <B>~e</B>. (b) <I>~o meze de lupoj</I>. <B>~aĵo</B>, mutton. <B>~aro</B>, flock. <B>~id(et)o</B>, lamb(kin). (rel.) <I>La Di~ido</I>, the Lamb of God. <B>~ino</B>, ewe. <B>~isto</B>, shepherd, <B>~simila</B>, -ish. <B>~bleki</B> (<I>bei</I>), baa, bleat. <B>Vir~o</B>, ram. ➞ <I>muflon</I>.", "0"],
["ŝafto", "ŝaft-o", "(mec) Shaft, axle, revolving bar (transmitting rotary motion). <B>Ĉef~o</B>, main s. <B>Kam~o</B>, cam s. <B>Kardana ~o</B>, propeller s. Krank~o, crank s. <B>~ingo</B>, hub. ➞ <I>aks, ŝakt</I>.", "0"],
["ŝagrino", "ŝagrin-o", "shagreen, untanned skin with granulated surface. <I>Papero ~ita</I>, granulated (pebbled) paper.", "0"],
["ŝaho", "ŝah-o", "[OA] shah.", "0"],
["ŝajni", "ŝajn-i", "[UV] Seem. ~i (esti), s. (to be), appear (look) like. <I>Li ~as (esti) prudenta, la vetero ~as favora</I>. <I>~as, ke</I>, It seems that. <I>Jen, ~as, (~e), la loko</I>. This seems to be the place. <B>~o</B>, appearance, exterior, look. <B>~a</B>, apparent, illusory, ostensible. <I>~a aŭtoritato, malŝato, potenco, valoro</I>. <B>~e</B>, apparently, judging by appearances. It looks as if, it seems (would seem) that. <I>~e sana, sukcesa. ~e li konas la vojon. Ili disiĝis, ~e por tiam</I>. <B>~igi</B>, make believe, pretend (2 Sa 14/2). <I>sin freneza</I>, pretend to be mad, feign madness. <I>~~u, ke vi ne aŭdas</I>, p. not to hear. <I>Ne ~~u vin</I> (make yourself out to be) <I>idioto. ~igo,</I> pretence. <I>~iga</I>, simulated. <B>Ver~a</B>, likely, plausible. <B>Ver~e</B>, presumably, probably. ➞ <I>afabl, afekt, aspekt, ekster, hipokrit, kvazaŭ, mask, supraĵ</I>.", "0"],
["ŝakalo", "ŝakal-o", "[UV] jackal (&gt; <I>Canis aureus</I>) (Mai 1/3)\" <I>Frat’ fraton atakas</I> ~e.", "0"],
["ŝako", "ŝak-o", "[UV] chess. Ŝak! <B>~igi</B>, check. ~ludo, ~mato, ~peco, ~tabulo. ➞ <I>arok, ĉel, ĉeval, dam, kurier, mat, peon, reĝ, tur</I>.", "0"],
["ŝakri", "ŝakr-i", "huckster, carry on petty trade, deal at secondhand, cheaply, on the pavement. <B>~isto</B>, petty dealer, old-clothes man, etc.", "0"],
["ŝakto", "ŝakt-o", "Shaft, upward vent, vertical or inclined excavation. <I>~o aera (ventola). ~o de lifto</I>. ➞ <I>galeri, put, ŝaft</I>.", "0"],
["ŝalmo", "ŝalm-o", "[UV] <B>1</B> (reed) Pipe, straw (for drinkg). <B>2</B> (m.i.) (shepherd’s) p. <B>Pajn~o</B>, Pan-pp. <B>Sak~o</B>, bag-pp. <B>3 Blov~o</B>, blow-pipe. ➞ <I>kan, kulm</I>.", "0"],
["ŝalo", "ŝal-o", "[UV] shawl. ~eto (<I>~a kolumo</I>), fichu.", "0"],
["ŝaloto", "ŝalot-o", ". (a. <I>askaloniko</I>), shallot,", "0"],
["ŝalti", "ŝalt-i", "= (<I>mal)kontaktigi</I>, Switch (turn) on or off. <B>Al~i</B> (<B>En~i</B>) s. on; <B>For~i</B> (<B>Mal~i</B>), s. off; <I>la gason, elektron, radion, telefonon</I>. <B>~ilo</B>, s. (to make or break contact, start or stop the flow), cut-out. <I>Duvoja ~ilo</I>. ➞ <I>komut, kran</I>.", "0"],
["ŝalupo", "ŝalup-o", "[UV] Launch, long boat. <I>~o kanona</I>, gun-boat, ~o <I>vapora</I>, steam-1.", "0"],
["ŝamo", "ŝam-o", "[UV] <B>1</B> chamois leather, shammy. <B>2</B> sheepskin substitute for this, wash-leather. ➞ <I>cam</I>.", "0"],
["ŝampinjono", "ŝampinjon-o", "any edible fungus, especially mushroom (Vd <I>agarik</I>). ➞ <I>fung</I>. ŝampu-o, (<I>harlavo</I>), shampoo.", "0"],
["ŝanceli", "ŝancel-i", "(<I>-n</I>), [UV] <B>1</B> Shake, rock, <I>Tertremo ~is la domon. Simŝon ~is la kolonojn</I>. <B>2</B> weaken. <I>Tio ~is mian aŭtoritaton, decidon, fidon, kuraĝon</I>. -iĝi, <B>1</B> be unsteady, quake,_ quiver, reel, stagger, totter, wobble. <I>Siaj paŝoj ~iĝis</I>. <B>2</B> be loosened, weakened. <I>Lia decido, sano, trono ~iĝis</I>. <B>3</B> (now usually <I>heziti</I>), Hesitate, dither. <I>Ne ~iĝu!</I> <B>~iĝema</B>, irresolute, fluctuating, vacillating, wobbly. <B>Ne~ebla</B>, firm, resolute, unshakeable. <B>Sen~iĝa</B>, unflinching, unserving. <I>Sen~iĝe</I>, without hesitation. ➞ <I>hezit, sku, tremig</I>.", "0"],
["ŝanco", "ŝanc-o", "[OA] Chance, undesigned occurrence, way things turn out. <B>1</B> opening, possibility of success: <I>Havi ~on gajni</I>, have a c. to gain. <I>Profiti, riski la ~on. Tio havas ~on,</I> it is just possible. <I>Kandidato kun ~o</I>, in the running. <I>La ~oj</I> (odds) estas. ... <B>2</B> Fortun/e, Luck: <I>Bon~on!</I> Good luck! <I>Kia</I> ~o! What (a bit of) luck! What a blessing! <I>Malbona ~o</I>, bad luck, hard lines. <I>Porti ~on,</I> bring luck. <I>La ~o turniĝis</I>, <B>~a</B>, c., casual, fluky. <B>~e</B>, by c., as it fell out, fortuitously. <B>Bon~a</B>, f-nate, l-y. <B>Dube~a</B>, dubious, uncertion. ➞ <I>hazard, sort</I>.", "0"],
["ŝanelo", "ŝanel-o", "Channel, pass. <I>Enira ~o,</I> narrows. <I>~o navigebla</I>, fair-way. <B>~meze</B>, in mid-c. ➞ <I>markol</I>.", "0"],
["ŝanĝi", "ŝanĝ-i", "(<I>-n</I>), [UV] Alter, Change, vary; <B>1</B> make a diffce, modify, replace A by B. ~i <I>leĝon, loĝejon, monon, opinion, sidlokon, tolaĵon, vagonaron, veston</I>. <B>2</B> (transform): <I>~i akvon en sangon; dezerton en lagon</I>. <B>~o</B><I>,</I> alteration, c., variation. <I>~o de aero, okupo, vento</I>. (mus) <I>~o de modalo, tonalo,</I> c. of mode (key), (voice); <I>La granda ~o,</I> \"great break\". <B>~ama</B>, fond of c. <B>~ema</B>, <B>~anima</B>, given to a-ing things. <B>~iĝi</B> (nt), a., c., pass from one state to another. <I>La kolor -(veter-)o ~iĝas. Mi ne ~iĝas</I> (Mal 3/6). <B>~iĝo</B>, c., a-ation. <I>~iĝoj de la lumo, sorto</I>. <B>~iĝema</B>, c-able, fickle, inconstant, unstable, variable. <B>~ilo</B>, (el) (<I>ŝaltilo</I>), commutator, switch, (ry) (<I>rel)~ilo (komutilo</I>), points, <I>~~isto</I>, pointsman. <I>Venos mia</I> for -o (Ij 14/14). <B>Inter~i</B>, ex-(inter-)c., barter, swap. <I>~~i ideojn, varojn, vortojn</I>. (mus) <I>~~o de voĉoj (unu voĉo prenas la noton de alia</I>). <B>Ne~ebla</B>, immutable, unalterable. <B>Sen~a</B>, c-less, fixed, unaltering, varying. <I>La Fundamento devas resti absolute ~~a</I>. <B>Kolor~a</B>, irridescent. <B>Mon~o</B>, c. <I>~~isto,</I> moneyc-er. <B>Trans~i</B>, transmute. ➞ <I>aliig, komut, metamorfoz, renvers, transform, vari</I>. Opp <I>firm, senmov</I>.", "0"],
["ŝankro", "ŝankr-o", "[OA] (med), canker, chancre, venereal ulcer.", "0"],
["ŝaperono", "ŝaperon-o", "chaperon, \"gooseberry\".", "0"],
["ŝarado", "ŝarad-o", "[OA] (gm) charade. <I>Ludi ~on</I>.", "0"],
["ŝargi", "ŝarg-i", "(<I>-n</I>) [UV], Charge, Fill. <I>~i akumulil -(kamer-)on. ~ita pafilo</I>, loaded gun. <B>~o</B>, c. (el) <I>~o negativa, pozitiva</I>. <B>~aĵo</B>, re-f. (of pencil, pocket, lamp, etc.). ~ujo, chamber (of gun). Mal~i (el) dis-c. <I>~~ilo</I>, wad, extractor, etc. Re<B>~i</B>, re-c., re-f. Ses~a <I>revolvero</I>, six-shooter. Tro<B>~i</B>, overload.", "0"],
["ŝarĝi", "ŝarĝ-i", "[UV] Burden, Charge, Load. <B>1</B> (<I>ion): ~i breton per libroj; ŝiponper kargo; tablon per manĝoj; memoron per faktoj</I>.<B> <I>2</I></B> (<I>iun</I>): entrust, saddle: <I>~i iun per dev-(pet-respondec-)o</I>. <B>~ita</B> b-(c-l-)ed, laden, weighed down, encumbered (<I>de Suldoj</I>); prostrated (<I>de febro)-</I>, stricken (<I>de jaroj)-</I>, worn out (<I>de laceco). ~ita per impostoj. Konscienco ~ita de krimo</I>. ~(aĵ)o, b., 1., freight, lading, weight. <I>Ciu homo havas sian ~on</I>. <B>~(eg)a</B> (<I>peza</I>), b-some, grievous, oppressive. -ego, heavy 1. -besto, beast of b. <B>~(port)isto</B>, porter, dock hand. <B>Mal~i</B>, relieve of b., unload. Sen-iĝi, be relieved. Super-o, (el) overload. <B>Trans~i</B>, transfer. transship. <B>Tro~i</B>, overburden, overfill, overload, overwork.", "0"],
["ŝarko", "ŝark-o", "[UV] Shark. <B>Glaŭka ~o</B>, blue s. <B>Malea</B> (<I>martela</I>) <B>~o</B>, hammerhead s. <B>Rab~o</B>, great. white (maneater) s. ➞ <I>alopias, gale, lamn, ork, skval, skvaten</I>.", "0"],
["ŝati", "ŝat-i", "[UV] (<I>alte taksi pri graveco aŭ valoro</I>): appreciate, enjoy, have a high opinion of, prize, relish, think highly of, treasure, value; like (in this sense only). <I>honoron pli ol motion</I>. <I>~i kuraĝon, ordon, prudenton, scion</I> (Se 4/8, 8/10); <I>sian vivon</I> (Jĝ 9/17); <I>la vorton de virino pli ol glavon</I> (If 93/14). <I>Ŝteletiston oni batas, ŝtelegiston oni ~as</I> (P). <I>~i ricin-oleon kiel medikamenton</I>. <B>~o</B>, appreciation, high opinion of. <B>~a</B>, appreciative. <B>~ata</B>, esteemed, valued, worthy, etc. <I>Via ~ata letero. ~ata edzino</I> (GD 25/24). <I>~ateco</I>, appreciation, esteem, good opinion. [Common misuse to be avoided: <I>Mi ~us sugesti</I> (= I should appreciate hinting!) instead of: <I>Mi proponas (volus proponi)</I>]. As an empirical rule, avoid using <I>ŝati</I> before an infinitive: this will obviate the worst misuses of the word. <B>Rim</B>.: For the meanings of <I>ami, ŝati</I>, see aimer, schätzen, in French and German dictionaries. For translations of \"like\" see <I>agrabl, am, amet, amik, antipati, aprob, dezir, estim, frand, gust, inklin, kontent, kunsent, plaĉ, prefer, pren, simil, simpati, taks, tre, trov, us, vol, volont</I>, in this volume. Also (LR/42); BE 1932/198, 1940/217.", "0"],
["ŝaŭmo", "ŝaŭm-o", "[UV] Froth, Scum, foam, spume; head (<I>de biero</I>); lather (<I>de sapo</I>); spray (<I>de maro</I>). <B>f</B> s., dregs. <I>~o de la socio</I>. <B>~a</B>, f-y, bubbly, foaming; aerated, fizzy (<I>trinkaĵo</I>). (nt), f., effervesce, foam, seethe, f <I>Ĉie la vivo ~is</I>. <B>~ero</B>, bubble. <B>~eti</B>, effervesce, sparkle, <B>~igi</B>, make froth. <I>Miaj klopodoj dis~iĝis, for~iĝis</I>, vanished into the air. <B>Ne~a</B>, <B>Sen~a</B>, flat, without head, still (<I>biero, vino). Sen~igi</I>, remove s., skim. <I>Sen~igilo</I>, skimmer. ➞ <I>fee, skori</I>.", "0"],
["ŝedo", "ŝed-o", "shed, outhouse; slight structure for shelter, storage, etc. Sometimes lean-to, sometimes with open front or sides.", "0"],
["ŝejko", "ŝejk-o", "sheik, Arab chieftain.", "0"],
["ŝeklo", "ŝekl-o", "shackle, bow of padlock, coupling link closed by bolt.", "0"],
["ŝelako", "ŝelak-o", "Shellac. <B>~i</B> (varnish with) s. <B>~a</B> (<I>muzik)disko</I>. ➞ <I>lak, verniz</I>.", "0"],
["ŝelko", "ŝelk-o", "[UV] brace(s), sling. <I>Ŝtrumpeta ~o (ĵartelo</I>), stocking (sock) suspender. <B>~ego</B>, strap. <B>~eto</B>, shoulder strap, etc. <B>Sen~a</B> <I>mamzono</I>, strapless brassiere,", "0"],
["ŝelo", "ŝel-o", "[UV] Shell (ova, <I>helika, testuda</I>), bark (<I>arba</I>); husk (<I>grena</I>), peel, „rind, skin (<I>frukta</I>); pod (<I>faba, piza). Ŝip~o,</I> sheathing. <B>~aĵo</B>, casing, facing. <B>~eto</B>, film, pellicule, scale. <B>sen~igi</B>, [UV] s., husk, peel, decorticate. <B>El~iĝi</B>, hatch out. <B>Sen~a</B>, shell-peeled, shell-skinned. ➞ <I>bast, guŝ, silikv</I>.", "0"],
["ŝenoprazo", "ŝenopraz-o", "chives (<I>Allium schoenoprasum</I>).", "0"],
["Ŝeolo", "Ŝeol-o", "Sheol, Hades, place of the dead; the grave.", "0"],
["ŝerci", "ŝerc-i", "[UV] Jok/e, banter, chaff, jest, make fun. <I>Vi~as!</I> You’re -ing, you don’t mean it! <B>~(ad)o</B>, j., fun. <B>~a</B>, jocular. <I>~a vorto, word</I> spoken in jest. <B>~e</B>, for fun, in jest. <I>~e dirite, cele pensite!</I> <B>~aĵo</B>, piece of fun, bunkum, humbug. <B>~ema</B>, facetious, full of fun, jovial, jocular, waggish. <I>~emulo, -er</I>, wag. <B>Mal~a</B>, <B>Ne~ema</B>, serious. <B>Sen~e</B>, -ing apart, seriously speaking. ➞ <I>humoraĵ, mok, petol, sprit</I>.", "0"],
["ŝereo", "ŝere-o", "(bev) sherry,", "0"],
["ŝerifo", "ŝerif-o", "(wide sense) sheriff (English Am),", "0"],
["ŝevioto", "ŝeviot-o", "(tex) cheviot (cloth, wool). Skota <B>~o</B>, tweed.", "0"],
["ŝi", "", "[UV] (pron) She. <I>Voku</I> ~n (al ŝi), call her. <B>~a</B> [UV] <I>libro</I>, her book, <I>ĉi estas ~a</I>, It is hers. <I>Amiko ~a</I>, a friend of hers,", "0"],
["ŝiboleto", "ŝibolet-o", "shibboleth, pass-word, test-word. (Jĝ 12/6).", "0"],
["ŝika", "ŝik-a", "chic, stylish, in the fashion. <I>~a ĉapelo</I>.", "0"],
["ŝildo", "ŝild-o", "[UV] Shield. <B>1</B> buckler, <B>f</B> (Ps 3/3). <B>2</B> (<I>elpendaĵo</I>), s-shaped board, signboard, etc. (her) <B>blazon~o</B>, coat of arms, escutcheon. <B>~i</B>, s., protect, screen. <B>~eto</B>, targe, <B>~isto</B>, squire, <B>~fako</B>, quartering. ➞ <I>aspidi, egid, ŝirm</I>.", "0"],
["ŝilingo", "ŝiling-o", "shilling.", "0"],
["ŝimo", "ŝim-o", "[UV] Mould, blight. <B>Griza ~o</B>, grey m. (<I>Botrytis</I>). <B>Folia ~o</B>, mildew. <B>~a</B>, -y, fusty, musty, mildewy (taste or smell), blue-moulded (<B><I>fromaĝo</I></B><I>); foxed</I> <B>(<I>papero, gravuraĵo</I>)</B>. <B>~i</B>, be -y. <B><I>La libroj ~as sur la bretoj</I></B>. <B>f <I>Li ~as</I></B> (vegetates) <B><I>en emeriteco</I></B>. <B>~iĝi</B> (Jos 9/5). ➞ <B><I>meldu, mucid, putr</I></B>.", "0"],
["ŝindo", "ŝind-o", "[UV] Shingle, wooden tile. <B>~a</B> <I>tegmento</I>, s-roof. <B>~i</B>, roof with ss.", "0"],
["ŝinko", "ŝink-o", "[UV] Ham, gammon. <B>~eto</B>, knuckle of h. ➞ English <I>shank</I>.", "0"],
["ŝintoismo", "ŝinto-ismo", "<B>~isto</B>, (rel) shinto-ism, -ist.", "0"],
["ŝipo", "ŝip-o", "[UV] Ship, Boat; any sea-going vessel, especially driven by machine or motor. <I>Aera, balen(kapt)a, batala, esplora, glaciromp(ant)a, karinga, komerca, milita, posta, sklava, submara, transporta, tureta, turisma, vapora, veterobserva ~o</I>. <B>Helica ~o</B>, screw-steamer. <B>Lum~o</B>, light-s. <B>Pun~o</B>, hulk. <B>Pram~o</B> (4 FA 129/12). <B>Rem~o</B>, galley. <B>Trejn~o</B>, training-s. <B>Tren~o</B>, tug-b. <B>Vel~o</B>, sailing-b. <B>f</B> <I>~o de la dezerto (= kamelo</I>). <B>~a</B>, naval. <B>~e</B>, by water. <B>~(ir)i</B>, sail (K 48/6). <B>~i</B> (<I>-n</I>), transport by s. <I>~i karbon</I>. <B>~ano</B>, mariner, sailor. <I>Sam~ano</I>, s-mate. <I>~anaro</I>, crew. <B>~aro</B>, fleet, marine. <I>~aro komerca</I>, merchant navy. <I>~aro milita (,regna</I>), navy. <I>~areto</I>, flotilla. <B>~estro</B>, [UV] captain, skipper. <B>~eto</B>, small s. <B>~farejo</B>, s-yard. <B>~irado</B>, passage, crossing. <I>~irebla,</I> navigable. <B>~riparejo</B>, dockyard. <B>El~igi</B>, discharge, unload. <I>El~iĝi</I>, disembark, go ashore, land. <I>~~~ejo (kajo</I>), landing-stage, wharf. <B>En~igi</B>, <B>Sur~igi</B>, take aboard, load. <I>~~iĝi</I>, embark, go on board. <B>Sur~e</B>, on board. ➞ <I>bark, boat, jaĥt, skun, ŝalup</I>.", "0"],
["ŝiri", "ŝir-i", "[UV] Tear; pull apart, rent, rip. <I>~i paperon, katunon</I>. <B>f</B> <I>~u vin en du partojn, la mondo trian postulos</I>. <B>~o</B>, tear, rent, split, <B>~aĵo</B>, <B>~peco</B>, rag, shred, tatter. <B>~iĝi</B> (nt), get torn. <I>Muslim facile ~iĝas</I>. <B>~vundo</B>, laceration (e.g., by claw or nail). <B>De~i</B>, t. off. <B>dis~i</B>, [UV] t. up, shred to pieces. <B>El~i</B>, t. out. <I>~~i herbaĉon, paĝon, harojn, okulojn</I>. <B>f</B> <I>Mi el~os ilin el ilia lando</I>. <B>For~i</B>, t. (snatch) away. <I>Sin ~~i de</I>, t. one’s away from. <B>Tra~o</B>, hole, slit, split. <B>Kor~a</B>, heart- rending. <I>~~a krio</I>. ➞ <I>grat, pluk</I>.", "0"],
["ŝirmi", "ŝirm-i", "(<I>-n, de, kontraŭ</I>) [UV], Guard, Protect, Shelter; cover, defend, save, screen, shade, shield. <I>Sin ~i</I> (take cover) <I>kontraŭ la pluvo. ~i infanon kontrau akcidento, la okulojn per la mano</I>. <B>~(ad)o</B>, s., protection, safe-guard, screening. <B>~(ant)a</B>, p-ive. <I>~aj okulvitroj</I>, colored spectacles. <B>~ata</B> <I>kontraŭ atako, vento</I>, p-(s-)ed against, safe (under cover) from. <B>~ejo</B>, s., cover, nook, retreat. <B>~ilo</B>, g., p-or, screen, shield. <B>1</B> (~o <I>por</I>), p-ion (shield) for: <B>Ĉen~ilo</B>, chain-g. <B>Jup~ilo</B>, dress-g. <B>Kandel~ilo</B>, <B>lamp~ilo</B> (a <I>abaĵuro</I>), candle-shade, lamp-shade. <B>Krur~ilo</B>, leg-g. <B>Manik~ilo</B>, cuff-p-or, oversleeve. <B>2</B> (<I>~o kontraŭ</I>): p-ion, shield, against (from): <B>Cindro~ilo</B>, fender. <B>Fajr~ilo</B>, firescreen. <B>Gut~ilo</B>, splash-board. <B>Kot~ilo</B>, mud-g. <B>Man~ilo</B> g. (of rapier). <B>Polv~ilo</B>, dust-g. <B>Son~ilo</B>, baffle. <B>Sun~ilo</B> (<I>tolmarkezo</I>), sun-blind, awng. <B>Vent~ilo</B>, wind-screen. <B>Rim</B>.: Example of this double use: Okul~o or Lum~ilo, eye-shade. <B>Antaŭ~o</B>, prophylaxis. <B>Mal~i</B>, expose, uncover. <B>Sen~a</B>, <B>Ne~ata</B>, defenceless, exposed. ➞ <I>baston, gard, garanti, protekt, rifuĝ, sav, ŝild</I>.", "0"],
["ŝkoto", "ŝkot-o", "(mar) sheet (of sail), rope for trimmg a sail.", "0"],
["ŝlifi", "ŝlif-i", "abrade, grind, polish smooth. <I>Sxtonoj ~itaj kaj glatigitaj de la maro</I> (4 FA 165/34). ➞ <I>abrad,polur</I>.", "0"],
["ŝlimo", "ŝlim-o", "[UV] Slim/e. <B>1</B> alluvium, mire, mud, ooze, silt, sludge, slush. <I>~o funde de lago, rivero</I>. <B>2</B> <I>~o de fiŝo, limako</I>. <B>~a</B>, s-(mir-ooz-slush-)y. deposit s. <B>~ejo</B>, bog, quagmire, morass, slough. ➞ <I>kot, mart</I>.", "0"],
["ŝlosi", "ŝlos-i", "[UV] Lock. <B>1</B> close (fasten) with a lock: <I>la pordon</I>. <B>2</B> Lock (shut) up. <I>Pensoj ~itaj en la brusto</I>. <B>~ilo</B>, [UV] (a. <I>mal~iloj</I>), lock Key: <B>Ĉef~ilo</B>, master-key, pass-key. <B>Dom~ilo</B>, <B>Klink~ilo</B>, latch-k. <B>Kontakt~ilo</B>, ignition k. ŜteMlo, pick-lock, skeleton-k. <I>~ilaro,</I> bunch of kk. <I>~iltruo</I>, k-hole. f <I>~ilo de dilemo, enigmo, problemo</I>. <B>2</B> (elementary manual). <I>~ilo Ĉefeĉa</I>, E-\"key\". <I>~ila industrio, pozicio, ŝtono</I>. <B>En~i</B> (Jeĥ 3/24), lock in (up). <I>~~iteco</I>, confinement, detention. <B>Mal~i</B>, unlock, elucidate, open. ~<B>~o</B>, discharge, release. ➞ <I>klavikl, renĉ</I>.", "0"],
["ŝmaci", "ŝmac-i", "[UV] (nt) <B>1</B> Smack the lips, e.g., in kissing or eating. <I>~i per la lipoj (lango</I>). s. one’s lips (tongue). <B>2</B> squelch, make a sucking sound, as in clay or mud. <I>La koto ~is sub liaj piedoj</I>. <B>~o</B>, 1 loud kiss, s. <B>1 noise of jaws. La ~ado de kvin buŝoj =</B> <I>manĝantaj kun granda apetito</I>.", "0"],
["ŝminki", "ŝmink-i", "(colour the face with) paint, rouge. <I>~i blanke, nigre, ruĝe</I>. <B>f</B> disguise, fake. <B>~o</B>, rouge, make-up. <B>~bazo</B>, <B>Fon~o</B>, foundation.", "0"],
["ŝmiri", "ŝmir-i", "(<I>-n</I>) [UV], Smear. <B>1</B> anoint, bedaub, besmear, coat, overlay, rub in, spread over: <I>~i panon per butero, harojn per graso, muron per mortero</I>. <B>2</B> (<I>lubriki</I>), grease, lubricate. <I>~i la radojn</I>. <B>f</B> <I>~i la manojn al iu</I> (➞ \"palm-oil\"). <I>Kiu bone ~as, bone veturas</I>, <B>f</B> deface, sully. <I>~ ies karakteron</I>. <B>~o</B>, smear, smudge. <B>~a</B>, s-y, greasy, unctuous. <B>~aĵo</B>, grease, lubricant, ointment, unguent. <B>Bot~o</B>, <B>ŝu~aĵo</B> (<I>ciro</I>), boot polish, shoe cream. <B>ĉirkaŭ~i</B>, bedaub, cover over with. ➞ <I>gras, ole</I>.", "0"],
["ŝnuro", "ŝnur-o", "[UV] Cord, Line, Rope. <I>Kanaba ~o</I>, hemp r. <B>Arka ~o</B>, bow-string. <B>Bu~o</B>, buoy-r. <B>Ĵet~o</B>, heaving-line. <B>Kapto~o</B> (<I>lazo</I>), lasso. <B>Konduka ~o</B>, guide-r. <B>Lig~o</B>, gasket, lanyard, painter, mooring-rope. etc. <B>Pak~o</B>, pack-thread. <B>Plumb~o</B>, plumb-line. <B>Salt~o</B> (<I>skipilo</I>), <B>Sav~o</B>, life-line. <B>Sonorila ~o</B>, bell-pull. <B>Streĉa ~o</B>, guy-1. <B>Ŝtala ~o</B>, wire rope. <B>Tir~o</B>, <B>tren~o</B>, hawser, tow-rope; breast harness (horses). <B>Umbelika ~o</B>, umbilical cord. <B>f</B> <I>Tordi ~ojn el sablo. Trostreĉi la ~ojn</I>, overdo things. <B>(Kun)~i</B>, bind, cord, lace, tie. <B>~aro</B>, c-age. (mar) shrouds, stays. <B>~ego</B>, thick rope, hawser. <I>~egaro (rigilaro</I>), rigging, tackle. <B>~ero</B>, <B>~fadeno</B>, strand, yarn. <B>~eto</B>, string, thread, twine. <B>~(far)isto</B>, rope-maker. <B>Mal~i</B>, <B>Sen~igi</B>, uncord, untie. (mar) dismantle (<I>ŝipon</I>). ➞ <I>kabl, kord, laĉ</I>.", "0"],
["Ŝo", "Ŝ-o", "[F], name of letter Ŝ.", "0"],
["ŝoforo", "ŝofor-o", "chauffeur, (professional) car-driver. ➞ <I>aŭtist, aŭtomobilist</I>.", "0"],
["ŝoko", "ŝok-o", "Shock. <B>1</B> blow, impact: <I>~o elektra. ~o de kolizio</I>. <B>2</B> (med) mental s: <I>Obusa ~o</I>, shell-s. <B>~i</B> (<I>-n</I>), s. <B>1</B> give a s. to. <B>2</B> give offence to, hurt the feelings of, scandalize. <I>Tiu blasfemaĵo min ~is</I>. <B>~a</B>, -ing, improper, offensive, revolting. ~e! -ing! <B>~ebla</B>, easily -ed. <B>~iĝi</B>, be -ed. ➞ <I>konstern, skandal</I>.", "0"],
["ŝorbeto", "ŝorbet-o", "sherbet.", "0"],
["ŝoseo", "ŝose-o", "[OA] High (main) road, carriageway, causeway, highway, roadway (especially metalled, macadamized). <B>Aŭto~o</B>, motor-way. <B>Betona ~o</B>, concrete road. <B>~isto</B>, road-mender. ➞ <I>strat, voj</I>.", "0"],
["ŝoso", "ŝos-o", "(hort) Shoot, sprout (<I>elkreskanta tigo aŭ branĉeto</I>). <B>Flanka ~o</B>, off-s. <B>Suk~o</B>, water-shoot.", "0"],
["ŝotiŝo", "ŝotiŝ-o", "(dance) schottische.", "0"],
["ŝoveli", "ŝovel-i", "(<I>-n</I>), [UV] Shovel, <B>~ilo</B>, s., scoop. <I>Polv~ilo</I>, dust-pan and brush. <I>~ileto,</I> garden trowel. <B>Kun~i</B> <I>foliojn en amasojn,</I> shovel up in heaps. <B>~maŝino</B>, excavator. <B>Plen~o</B> <I>da</I>, s-ful of.", "0"],
["ŝovi", "ŝov-i", "(<I>-n</I>) [UV], Push (along a surface), shove. <B>1</B> slide: <I>~i keston sur planko, teleron sur tablo. ~i</I> (shuffle) <I>la piedojn</I>. <B>2</B> put, slip, thrust: <I>~i manon en poŝon; birdon el nesto. Ne ~u la nazon en fremdan vazon. Sin ~i en</I>, butt (poke one’s nose) into. <B>~a</B> <I>fenestro, pordo, seĝo,</I> sliding window (door, chair). <I>~a knoto,</I> running-knot, slip-knot. <B>~iĝi</B>, creep (glide, slide, slip, steal) along. <I>La ~iĝado</I> (brushing, swishing) <I>de robo sur la planko. Ter~iĝo, terglito</I>, land-slide. <B>Al~i</B>, shove (thrust) towards. <I>Li ~~is la seĝon al ŝi. Al~iĝi al</I>, glide up to. <B>De~i</B>, brush (p., wave) aside. <B>Dis~i</B> <I>la fingrojn, krurojn,</I> spread, draw apart; open (<I>kurtenojn</I>). <B>El~i</B>. poke out (<I>la kapon</I>), put out (<I>la langon</I>). <B>f</B> <I>Kaŝu kiom vi volos, la vero sin el~os</I>. <B>En~i</B>, foist on, insert, interpolate, introduce, poke (slip, thrust) into. <I>En~iĝi</I>, creep (slide) into, intrude. <B>For~i</B>, displace, push aside. <I>Ne for~u antikvajn limojn</I>. <B>Kun~i</B>, close (draw) (<I>kurtenojn</I>); knit (<I>brovojn). La bildo</I> <B>preter~iĝis</B> (glided past) <I>antaŭ ŝia animo</I>. ➞ <I>glit</I>. <B>Rim</B>.: <I>Sxovi</I> denotes gentle sliding action; <I>puŝi</I>, rougher action.", "0"],
["ŝovinismo", "ŝovinism-o", "[OA] chauvinism, bellicose patriotism, jingoism.", "0"],
["ŝovinisto", "ŝovinist-o", "[OA] jingo, war-monger,", "0"],
["ŝpalo", "ŝpal-o", "(<I>reltrabo</I>), (ry) sleeper, (Am) tie. <B>~bolto</B>, s-screw.", "0"],
["ŝpari", "ŝpar-i", "(<I>-n</I>), [UV] <B>1</B> Save (up), keep for future use, lay (put) by, reserve, store up. <I>~u kiam bone, vi havos kiam bezone. ~u groŝon, vi havos plenan poŝon</I>. <B>2</B> be sparing of, economize, husband, spare (➞ <I>domag</I>). <I>Vortojn ~u, agojn faru. ~i al iu aplaŭdon</I>. <B>~(ad)o</B>, -ing, economy. <B>~aĵoj</B> (<B>~mono</B>), -ings, economies, nest-egg. <B>~egi</B>, hoard. <B>~(em)a</B>, -ing, economical, frugal, thrifty. <I>Tro~ema,</I> parsimonious. <I>~emaĉa</I>, close-fisted, mean, niggardly, shabby, stingy. <B>Mal~i</B>, waste, be prodigal (lavish) with, blue, dissipate, squander. <I>Vivi</I> <B>~~e</B>, go the pace, live in lavish style. <I>~~ema</I>, extravagant, prodigal, wasteful. <B>Ne~ema</B>, thriftless. <B>Tempo~a</B>, time-saving. ➞ <I>avar, dispoti, ekonomi, rezerv, sav</I>.", "0"],
["ŝpato", "ŝpat-o", "[OA] (<I>fosilo</I>), spade.", "0"],
["ŝpico", "ŝpic-o", "spitz, Pomeranian dog.", "0"],
["ŝpini", "ŝpin-i", "[UV] Spin. <B>1</B> (into thread): <I>~i lanon. La araneo, silkraŭp-o ~as</I>, <B>2</B> (<I>fari, kunmeti): ~i projekton, rakonton</I>. 3 purr. <I>La kato ~as (ronronas</I>) (onomat). <B>~ado</B>, ~arto, spinning. <B>~ejo</B>, -ning mill. <B>~ilo</B>, -ning wheel, spindle. <I>~ileto</I>, -neret (spider’s). <B>~ist(in)o</B>, -nner, mill-hand. <B>~maŝino</B>, jenny.", "0"],
["ŝpruci", "ŝpruc-i", "[UV] (nt), Spurt (out), gush forth, play (as fountain or fire-engine), spout (well) up. <I>Fonto ~is el la roko</I>. <B>f</B> appear suddenly. <I>Ĉie ~as nova vivo. Ĝojo (larmoj) ~is el liaj okuloj</I>. <B>~(ad)o</B> <B>~aĵo</B>, s., gush, jet, spout, <B>f</B> outburst. <B>~ego</B>, geyser. <B>~eto</B>, sputter. <B>~igi</B>, make s., splash, spray, sprinkle, squirt. <I>La fontoj ~as akvon. ~igilo</I>, spray gun, sprinkler, squirt, syringe. <I>Ĝardena ~igilo</I>, garden spray. <B>Dis~i</B>, spatter, splash. <B>Dis~igi</B>, spray all over. <B>~~igilo</B>, sprayer. <B>En~igi</B>, inject (not med), <I>Tio ~~igis novan vivon en la societon. En~igilo</I>, douche, irrigator. <B>For~igi</B>, flush. <B>Re~i</B>, splash back. <B>Sur~igi</B>, be-spatter (-sprinkle). ➞ <I>asperg, injekt, spul, plaŭd</I>.", "0"],
["ŝpuro", "ŝpur-o", "(<I>trak-larĝo</I>), (ry) gauge, wheel-span. [<I>Ne = spuro</I>].", "0"],
["ŝranko", "ŝrank-o", "[UV] Cupboard. Libra <B>~o</B>, bookcase. <B>Lit~o</B>, box-bed. <B>Montra ~o</B> (<I>vitrino</I>), show case. <B>Muzika ~o</B>, music cabinet. <B>Porcelana ~o</B>, china c. <B>Servica ~o</B>, buffet. <B>Sxtal~o</B>, safe, (org) <B>Ŝvel-o</B>, swell-box. <B>Varmiga</B>, <B>sekiga</B> <B>~o</B>, drying c. <B>Vest~o</B>, <B>tol~o</B>, press, wardrobe.", "0"],
["ŝrapnelo", "ŝrapnel-o", "[OA] (<I>kuglobuso</I>), shrapnel.", "0"],
["ŝraŭbo", "ŝraŭb-o", "[UV] Screw. <I>Streĉi ~on</I>, tighten a screw. <B>Aleta ~o</B>, wing s. <B>Haltiga ~o</B>, stop s. <B>Kap~o</B>, cap s. <B>Maldekstrena ~o</B>, left-handed screw. <B>Mergita ~o</B>, countersunk s. <B>Plurrela ~o</B>, multiple s. <B>Prem~o</B>, thumb-s. <B>Senfina ~o</B>, endless (worm) s. <B>~i</B>, <B>1</B> turn a screw. <B>2</B> fix with a screw. <B>3</B> <B>f</B> (similar movement) <I>~i sin en la ĉielon, aeron (aviadilo), akvon</I>. <B>~(turn)ilo</B>, screw-<B>driver, Alĝustigebla ~ilo, adjustable s-d.</B> <I>Randstrekita ~ilo</I>, milled s-d. <I>Sesangula ~ilo,</I> hexagon-head s-d. <I>Universala ~ilo,</I> monkey s-d. <B>~in(g)o</B>, female s., nut. <I>Kontraŭ~ingo</I>, keeper, lock-nut. <B>~forma</B>, <B>~simila</B>, spiral, <B>~kapo</B>, s-head. <B>Al~i</B>, s. down (on). <B>Mal~i</B>, unscrew. ➞ <I>helic, spiral, tord, renĉ</I>.", "0"],
["ŝrumpi", "ŝrump-i", "(nt), [UV] Shrivel (up) (with dryness or age), crumple, shrink, wilt, wrinkle up (1 FA 27/23; 84/13; 2 FA 132/33). <I>~as falinta folio, maljunula haŭto</I>. <B>f</B> <I>~inta animo</I>. ~o <I>de la merkato,</I> <B>~igi</B>, dwarf, reduce, straiten. ➞ <I>sek, sulk</I>,", "0"],
["Ŝŝ!", "", "Hist! Hush! Quiet! Sh! Silence!", "0"],
["ŝtalo", "ŝtal-o", "[UV] Steel. ~o <I>makul-imuna</I>, stainless s. <I>~o trempita</I>, hardened s. ~a <I>klingo, plumo (= malmoderna skribilo</I>). <B>~(ec)a</B>, (hard as) s. <B>f</B> (<I>necedema</I>), inflexible. <I>~a decido. ~a rigardo</I>, -y glance. <B>~izi</B>, case-harden. <B>~blua</B>, s-blue. <B>~fabrikejo</B>, s-works. <B>~kolora</B>, s-colored.", "0"],
["ŝtato", "ŝtat-o", "[UV] State (realm), form of government, nation. <I>La Grandaj ~oj</I>, the Gt. Powers. <I>Unuiĝintaj ~oj (Usono</I>), U.S.A. <B>~a</B>, state, national. <I>~a banko, eklezio. ~aj aferoj,</I> public affairs. <I>~a ŝuldo</I>, National Debt. <B>~ano</B>, citizen. <B>~estro</B>, head of s. <B>~igi</B>, nationalize. <B>~isto</B>, <B>~ismo</B>, statesman (-ship). <B>De~iĝo</B> (disestablishment) <I>de la eklezio</I>. ➞ <I>naci, regn</I>.", "0"],
["ŝteli", "ŝtel-i", "(<I>-n</I>) [UV], Steal, appropriate without right or leave, purloin from, thieve. <I>~i monon</I>. <B>f</B> <I>~i kison, koron. ~i de najbaro por doni al altaro</I>. <B>~(ad)o</B>, -ing, larceny, robbery, theft. <I>~o de kasmono</I>, embezzlement, peculation. <B>~e</B> (<I>~move</I>), furtivly, stealthily, by stealth, like a thief. <B>~aĵo</B>, ill-gotten booty, plunder, stolen objs. <B>~ema</B>, rapacious, thievish. <B>~emo</B> (<I>kleptomanio</I>). <B>~eti</B>, filch, help one’s to, pilfer, scrounge, (col) bone, pinch, prig. <I>~eto</I>, petty theft. <I>~etiston oni batas, ~egiston oni ŝatas</I>. <B>~isto</B>, burglar, robber, thief. <I>Poŝa ~isto</I>, pick-pocket. <I>Infan~isto</I>, kidnapper. <B>~</B>imuna, burglar- proof. <B>~iri</B>, creep, go-stealthily, slink. <B>Al~iĝi</B>, creep up (H 34/19). <B>El~iĝi</B>, slip away, s. off. <B>En~iĝi</B> (<I>enŝoviĝi</I>), s. (creep, worm one’s) into. <I>Perfidulo ~~iĝis en niajn vicojn</I>. <B>For~iĝi</B>, s. away, abscond, decamp. <B>Pri~i</B> (<I>senigi de io</I>), pilfer from. <I>Pri~i budon, homon</I>. <B>Ŝtel’!</B> Stop thief! ➞ <I>rab</I>.", "0"],
["ŝterno", "ŝtern-o", "(orn) Tern (<I>sterna</I>). <B>Arkta ~o</B>, arctic s. <B>Hirunda ~o</B>, common s. <B>Malgranda ~o</B>, little s. <B>Sandviĉa ~o</B>, sandwich s.", "0"],
["ŝtipo", "ŝtip-o", "[UV] Block, Log, billet (of wood) (Jes 44/19; Am 4/11). <B>Bot~o</B>, boot-tree, last. <B>Brul~o</B> (Ze 3/2). <B>Ekzekuta ~o</B>, <B>Pun~o</B>, b. <B>Hak~o</B>, (cul) chopping-block. <B>Kristnaska ~o</B>, Yule log. <B>f</B> (a. ~w/o), b-head, chump, duffer. <B>~aro</B>, pile of faggots, stake. <B>~ejo</B>, wood-shed.", "0"],
["ŝtofo", "ŝtof-o", "(<I>teksaĵo</I>), [UV] Stuff, fabric, textile, woven material. <I>Kvar metroj da ~o. ~o kotona, lana, silka</I>. <B>f</B> (materials). <I>La ~o el kiu fariĝis niaj sonĝoj</I>. ~resto, remnant. <B>Sen~a</B>, unlined. <B>Sub~o</B>, lining. line (4FA 81/25). <B>Or~o</B> (<I>brokato</I>), cloth of gold, gold brocade. ➞ <I>material, teks</I>.", "0"],
["ŝtono", "ŝton-o", "[UV] Stone. <I>Tiu unua ĵetu ~on</I> (Jn 8/7). <I>~o artefarita, kalka, mejla, muela, pumika</I>. <B>Akriga (Olea) ~o</B>, hone. <B>Bazangula~o</B>, corner-s. <B>Juvel~o</B>, precious s. <B>Lim~o</B>, boundary s. <B>Plat~o</B> (<I>slabo</I>), flag-s, s-slab. <B>Prov~o</B>, touchstone. <B>Puding~o</B> (<I>konglomeraĵo</I>), pudding s. <B>Rand~o</B>, curb-s. <B>Rul~o</B>, boulder. <B>Sablo~o</B> (<I>grejso</I>), sand-s. <B>Tomb~o</B>, tomb-s, ledger. <B>Sap~o</B>, soap-s. <B>Volb~o</B>, (tapering) arch-s. <I>Meza ~~o</I>, key-s. <I>~o de falpuŝiĝo (falilo</I>), stumbling-block. (med) s., calculus. <B>Gal~o</B>, gall-s. <B>Ren~etaro</B>, gravel. <B>~(ec)a</B>, s., -y, hard. <I>~a koro</I>. <B>~(ar)o</B>, pile of ss. <B>~ego</B> (<I>roko</I>), rock. <B>~eto</B>, pebble. <I>~etaĵo, ~etaro (gruzo</I>), gravel, grit, shingle. <B>~igi</B>, fossilize, make rigid, petrify. <B>~iĝi</B>, become fossilized, petrified. <I>~iĝi de timo. ~iĝanta lingvo, vizaĝo</I>. <B>~hava</B>, <B>~plena</B>, <B>~oza</B>, full of stones. <B>~umi</B> (<B>~mortigi</B>), s. to death. <B>~elfosejo</B>, quarry, <B>~hakisto</B>, <B>~ministo</B>, s-mason. <B>Por~a</B>, lapidary. ➞ <I>fosili, gem, rok</I>.", "0"],
["Ŝton~ulo", "", "(orn) t-stone (<I>Arenaria</I>). <B>Voj~(iĝ)o</B>, -ing (of road). ➞ <I>aplik, cel, direkt, kirl, rul, tord, torn</I>.", "0"],
["ŝtopi", "ŝtop-i", "[UV] Stop (up). <B>1</B> close (plug) up, occlude: <I>~i breĉon, truon</I>. Bung (<I>barelon</I>): cork (<I>botelon</I>); wall up (<I>fenestron</I>); (mar) caulk (<I>fendon</I>). <B>f</B> (<I>fliki</I>): darn, patch. <I>~i truon en ŝtofo, ŝtrumpo. Tekso~ado</I>, fine darning, invisible mending. <B>2</B> Block (up), clog, obstruct: <I>Neĝo ~is la elirejon. Veturiloj ~is la vojon</I>. Bottle up (<I>havenon</I>); choke up (<I>tubon</I>), hold (<I>nazon</I>); stifle (<I>voĉon</I>); stop (<I>orelojn</I>). <B>3</B> (<I>plenigi</I>): Fill up. <I>~i sin, sian stomakon</I> stuff one’s. <I>Dika volumo ~ita per faktoj. (Krop)~i, ~nutri</I>, cram (<I>anseron). (Or)~i,</I> fill (<I>denton</I>). <B>~a</B> <I>epiteto, vorto</I>. s-gap. <B>~ado</B>, obstruction. <I>Junta ~ado</I>, pointing. <I>Trafik~ado</I>, jam, road congestion. <B>~aĵo</B>, stopping, plugging, stuffing. <B>~iĝi</B>, get -ped up. <B>~ilo</B>, -per, bung, cork, plug, stopple, tampion, tampon. <B>Buŝ~ilo</B>, gag. <B>Dren~ilo</B>, drain-cock, bung, plug. <B>Kran~ilo</B>, spigot. <B>Pip~ilo</B>, pipestoper. <B>Mal~i</B>, unstop, broach, open, uncork. PajW, s. with straw. <B>Plen~i</B>, pad, ram (tight down). ➞ <I>ferm, plenig, plomb, rembur, dubi, tampon</I>.", "0"],
["ŝtormo", "ŝtorm-o", "Storm, violent atmospheric disturbance. <I>~o furiozis super la lando, ~o magneta, neĝa, sabla. Kalmigi la ~on. Vent~o (tempesto</I>), s. of wind, <B>f</B> <I>~o en tetaso. ~o de aplaŭdo</I>, s. of applause. <I>~o de batoj</I>, hail of blows. <I>~o de riproĉoj,</I> torrent of abuse. <B>~a</B> -y, boisteruous, tempestuous. <I>~a maro, vetero</I>. <B>~i</B>, be in a fury, blow a hurricane (great guns), <B>f</B> rage. <B>~avertilo</B>. <B>~centro</B> (also figuratively). <B>~nubo</B>.", "0"],
["ŝtrebo", "ŝtreb-o", "(<I>kontraŭapogilo</I>), (bid) buttress, prop, strut.", "0"],
["ŝtrumpo", "ŝtrump-o", "[UV] Stocking. <I>~o aĵura</I>, openwork s. <I>~o provarika</I>, elastic (surgical) s. ~a <I>ligilo, rubando, zono (krurzono</I>), garter. <I>Pri la ~a truo scias nur la ŝuo</I>. <B>~aĵo</B>, <B>~industrio</B>, hosiery. <I>~aĵ(-vend)isto</I>, hosier. <B>~aro</B>, ~oj, ss., hose. <B>~eto</B>, sock. <B>Duon~o</B>, half-hose. <B>Lit~o</B>, bed sock. ➞ <I>fartel</I>.", "0"],
["ŝtupo", "ŝtup-o", "[UV] Stair, step (of staircase, etc.). (mil) echelon. <I>~o transira, unua</I>. <B>f</B> level, stage. <I>~o post ~o</I>, s. by s. <B>Tret~o</B>, tread (on stair). <B>Viv~o</B>, plane of living. ~a <I>progreso</I>. <B>~e</B>, gradually, by degrees (stages). <I>Sam~e kun</I>, on a level with. <B>~aro</B>, [UV] s-case (flight of) ss. <I>~aro ekstera, interna, spirala</I>. <B>~eto</B>, rung (of ladder). <I>~etaro (eskalo</I>), (adder, steps. <I>~etaro faldebla, portebla. Ŝnura ~etaro,</I> rope ladder. <B>~igi</B>, space out. <B>Inter~aro</B>, landing. <B>Rul~aro</B>, escalator, moving stairway. ➞ <I>nivel, paŝ, peron</I>.", "0"],
["ŝuldi", "ŝuld-i", "(<I>-n</I>) [UV], be in Debt, Owe. <B>1</B> <I>~i motion. Riĉa estas tiu, kiu ~as al neniu</I>. <B>2</B> owe, be beholden (indebted, under an obligation) to, have to thank for. <I>~i dankon, prosperon, sanon, vivon al</I>. <B>3</B> owe, (<I>devi fari): Mi ~as al vi klarigon</I>. <B>~o</B>, debt, obligation. <I>Pagi ~on. Droni en ~oj. Pardonu al ni niajn ~ojn. Tio estas por mi sankta ~o</I>. <B>~(ant)a</B>, indebted, beholden, bound, obliged. <B>~anto</B>, debtor. <B>~igi</B>, put in d., make -or, lay under an obligation. <I>Vi min tre ~igos,</I> will greatly oblige me. <B>~oŝargita</B>, burdened with (head over ears in) d. <B>Sen~igi</B>, free from d. ➞ <I>dev</I>.", "0"],
["ŝultro", "ŝultr-o", "[UV] Shoulder. <I>Eklevi la ~ojn,</I> shrug the shoulders. <B>f</B> <I>Preni devon sur la ~ojn. Maljuna kapo sur junaj ~oj. Labori ~on ĉe ~o (akorde</I>). <B>~a</B>, scapular. <I>~a banto,</I> s-knot. <B>Sur~aĵo</B>, s-piece. <B>Al~igi</B>, bring to the s. <B>Sur~igi</B>, s. <B>Larĝ~a</B>, broad-ed. <B>Rond~a</B>, round-ed, stooping.", "0"],
["ŝunti", "ŝunt-i", "(el, ry), Shunt, side-track, divert current (train) in another direction. ➞ <I>komut, manovr, vojŝanĝ</I>.", "0"],
["ŝuo", "ŝu-o", "[UV] Shoe. <I>~o felta, laĉa, marŝa, neĝa, sabla</I>. <B>Bal~o</B>, <B>danc~o</B>, ball-s. <B>Ferita ~o</B>, hobnailed s. <B>Glitila (Sleda) ~o</B>, runner. <B>Haltiga ~o</B>, <B>Rad~o</B>, brake s., block, drag-s, skid-pan, shoe of brake. <B>Ligna ~o</B>, clog, sabot. <B>Salona ~o</B>, court s. <B>Senligila ~o</B>, pump shoe. <B>Ŝirm~o</B>, protective footwear. <B>Tol~o</B>, canvas s. <B>f</B> <I>Esti sub la ~o de sia edzino. Jen kie la ~o pinĉas!</I> <B>~i</B>, s. <B>~ita</B>, shod, <B>~(far)isto</B>, s-maker. <B>Sen~a</B>, barefoot (Mi 1/8). <I>Ligna</I> <B>Sub~o</B>, patten. ➞ <I>bot, galoŝ, pantofl</I>.", "0"],
["ŝuti", "ŝut-i", "(<I>-it</I>) [UV], Shoot, pour out (solids). <I>~i karbon en kelon, rubon sur la fajron</I>. <B>f</B> <I>Kiajn vortojn vi ~as!</I> <B>~e</B> <I>malplenigi,</I> dump down, tip. <B>~ejo</B>, chute. <B>~ilo</B>, bucket (of dredger), scoop, etc. <I>Suker~ilo,</I> sugar-caster. <B>Dis~i</B>, scatter, strew in all directions. <B>El~i</B>, Discharge (sand, etc.), drop out. <B>Kun~i</B> <I>ŝtonojn en amason</I>. <B>Super~i</B>, load, overwhelm, shower. <I>~~ita per bonfaroj, demandoj, laboroj, plendoj</I>. <B>Sur~i</B>, cover (<I>ĉerkon per tero; teron per floroj; straton per sablo</I>).", "0"],
["ŝutro", "ŝutr-o", "shutter (of window, etc.); (org) (of swell-box). ➞ (<I>lat)kurten, obturil, persien</I>.", "0"],
["ŝvabri", "ŝvabr-i", "Mop, Swab, <I>~i la ferdekon</I>. <B>~ilo</B>, mop, swab, <I>~ileto</I>, dish-cloth, (-mop). <I>~ileto metala</I>, metal scrubber.", "0"],
["ŝvebi", "ŝveb-i", "[OA] <I>= flugpendi, glitpendi</I> (nt), <B>1</B> Hover, be poised (suspended) float (in the air), hang, soar (over) (1 FA 42/6; 102/27), Ge 1/2). <B><I>La aglo, fumo, nubo ~is en la aero. Ruino ~as super ni</I>. 2</B> (<B><I>sentiĝi</I>): <I>La kanto (odoro, sento) ~is</I>, die. <I>Stranga famo ~is en la kunveno</I>. 3</B> be pending (in suspense, uncertain), hang in the balance; <B><I>~i inter vivo kaj morto</I>. <I>~i sur la lango</I></B>, be on the tip of one’s tongue. <B>~anta <I>demando</I></B>, unsettled question. <B><I>~anta ŝuldo</I></B>, floating debt. <B>Al~i</B>, (4 FA 60/7). <B><I>La junulino</I> preter~is (<I>glite preter-pasis</I>), (</B>passed like a dream) <B><I>antaŭ miaj okuloj</I></B>. ➞ <B><I>flirt, flot, glis, sor</I></B>.", "0"],
["ŝveli", "ŝvel-i", "(nt) [UV] (<I>pliiĝi</I>), Swell (out, up), dilate, expand, increase (in power, size, strength). <I>Lia vango ~is pro absceso. La muziko, rivero, sono, velo ~is</I>. <B>f</B> <I>~i de fiero</I>. <B>~(ad)o</B>, -ing, bulge, distension, hump, increase, inflation, tumefaction. (mus) <I>~(sign-)o</I>, s., &lt; &gt; . (mar) s... surge caused by wind. <B>~(form)a</B>, baggy (<I>pantalono</I>); full (<I>jupo</I>); puffed (<I>maniko</I>). <B>~aĉa</B>, bloated, puffy. <B>~aĵo</B>, -ling, bump, puffiness, tumour. <B>~igi</B>, cause to s., blow (puff) out, distend, inflate, pump up (tyre). <I>Ni ne tro ~igu nian vortaron</I>. <B>~inta</B>, congested, swollen, (org) <B>~orgeno</B>, s-organ. <B>~pedalo</B> (<I>kresĉenda pedalo</I>), s-pedal. <B>~parola</B> (<I>bombasta</I>), bombastic, high-falutin-flown, turgid. <B>Mal~i</B>, collapse, go down. subside. <I>Mal~a</I>, flabby, flaccid, floppy, lank, sunken. <I>~~igi</I>, bring down, deflate, reduce. ➞ <I>plenblov, puf, tuber, tumor</I>.", "0"],
["ŝviti", "ŝvit-i", "[UV] <B>1</B> Sweat, Perspir/e. <B>2</B> flow similarly: <I>~i per sango. La muro ~as. La vundita arbo ~is per rezino</I>. <B>3</B> toil, work strenuously: <I>~i super la alfabeto</I>. <B>~(ad)o</B> sweat, sweatation, drudgery, toil. <I>La ~o de via vizaĝo</I> (Ge 3/19). <B>~a</B> <I>febro</I>, s-ing sickness. <B>~anta</B>, <B>~kovrita</B>, covered with s. <B>~e</B> <I>farita laboro</I>. <B>~egi</B>, be bathed in s. <B>~eta</B>, moist with perspiration. <B>~igi</B>, cause to p. <I>~iga</I>, sudorific. <I>~iga laboro</I>, hot work. <B>~ban(ej)o</B>, Turkish bath. <B>El~o</B>, exudation. Trans~iĝo, transudation. ➞ <I>elflu, lik, saŭn</I>.", "0"],
["tabako", "tabak-o", "[UV] Tobacc/o. <B>1</B> The plant (<I>nicotiana</I>). <B>2</B> Its leaves. <I>Pipo da ~o. Fumi~on</I>. <B>Flar~o</B>, snuff. <B>Maĉ~o</B>, chewing-t. <B>~ejo</B>, t-plantation. <B>~isto</B>, -onist. <B>~ujo</B>, <B>~a saketo</B>, t-pouch. <B>~(vend)ejo</B>, t-shop. ➞ <I>nikotin</I>.", "0"],
["tabano", "taban-o", "[UV] gad-fly (<I>Tabanus</I>).", "0"],
["tabelo", "tabel-o", "[UV] Table, Tabul/ar summary (catalogue, index, list, synopsis, etc.). <I>~o de enhavo</I>, t. of contents. <I>~o alfabeta, gramatika, logaritma, multiplika</I>. <B>Kalkul~o</B>, ready reckoner. <B>Viv~o</B>, mortality t. (expectation of life). <B>~a</B>, -ar, -ated. <B>~aro</B>, book of tt. <I>Fervoja ~aro,</I> ry time-table. <B>~igi</B>, -ate. <I>~igilo</I>, -ator. <B>2</B> slab of wood, stone, etc., with inscription. <I>Stona ~o</I>, t. of stone (El 24/12; 32/15). <B>f</B> <I>Skribu ilin sur la ~o de via koro</I> (Se 7/3; 2 Ko 3/3). ➞ <I>indeks, registr, resum</I>.", "0"],
["tabernaklo", "tabernakl-o", "(Bb) tabernacle. <I>La ~o de kunveno</I> (El 29/4). ➞ <I>laŭb</I>.", "0"],
["tablo", "tabl-o", "[UV] Table. <I>Bilarda, karta, manĝa, operacia, ronda, skriba, tualeta ~o. ~o longigebla</I>, telescopic t. <I>La Sankta ~o,</I> the Lord’s T. <I>Kovri, pretigi, primeti</I> (lay) <I>la ~on. Leviĝi de (Sidiĝi ĉe) la ~o</I>. <B>Sur~igi</B> <I>manĝon, kartojn</I>. ➞ <I>seĝ</I>.", "0"],
["tablojdo", "tablojd-o", "(pharm) tabloid, tablet. ➞ <I>lozanĝ, pastel</I>.", "0"],
["tabulo", "tabul-o", "[UV] Board, Plank, (chs, drs) b. <B>Aviz~o</B>, notice-b. <B>Cel~o</B>, target. <B>Desegna ~o</B>, drawing-b. <B>Hak~o</B>, chopping-board. <B>Nigra ~o</B>, black-b. <B>Pas~o</B>, gang-p. <B>Pik~o</B>, dart-b. <B>Plonĝ~o</B>, diving-b. <B>Serv~o</B>, counter. <B>Ŝalt~o</B>, switch-b. <B>Tranĉ~o</B>, <B>cutting-b</B>. <B>~aĵo</B>, b-(p-floor-)ing. <B>~ego</B>, beam. <B>~eto</B>, cake (<I>sapo</I>); slab (<I>ĉokolado</I>), (occ) planchette. <B>f</B> tablet (<I>de memoro). Lig~eto</I>, batten. <B>~izi</B>, timber (<I>muron</I>). <B>~ita</B>, panelled (Ĥg 1 /4), <B>~kovri</B>, b. over. Vd <I>Sign</I>.", "0"],
["tabuo", "tabu-o", "Taboo, ban, interdict, prohibition. <B>~i</B>, t. <B>~a</B> <I>temo</I>, forbidden subject <B>~eco</B>, inviolability. <B>Sen~igi</B>, lift the t. from.", "0"],
["tabureto", "taburet-o", "[OA] stool (seat without arms or back). <I>Fiona (pieda) ~o</I>.", "0"],
["taĉmento", "taĉment-o", "[UV] detachment. <B>1</B> (mil) commando, contingent (troops). <B>2</B> gang, team (workmen etc.). <I>~o de anĝeloj, laboristoj, soldatoj</I> (Ps 78/49, Ge 32/7, Ij 1/17). <I>Nokta, taga ~o (en fabrikejo, hospitalo</I>), night shift, day shift, <I>Labori</I> <B>~e</B>, work in shifts, do team-work, <B>~estro</B> (Ĥb 3/14), foreman, etc. ➞ <I>rot</I>.", "0"],
["tadorno", "tadorn-o", "(orn) Sheldrake (<I>Tadorna</I>). ~ino, shelduck. <I>Rusta ~o</I>, ruddy s.", "0"],
["tafto", "taft-o", "[UV] (tex) taffeta, fine plain-woven glossy silk. Gum<B>~o</B>, court plaster.", "0"],
["tageto", "taget-o", "African Marigold (<I>Tagetes ereeta</I>). Malgranda <B>~o</B>, French m. (7~. <I>pa tula</I>). ➞ <I>kalendol</I>.", "0"],
["tago", "tag-o", "[UV] Day. <B>1</B> period of sunlight. <I>En la ~o ni vidas la sunon</I>. <B>2</B> (<I>~ nokto, diurno</I>), 24 hours. <I>~o sekvas ~on. Antaŭ du ~oj,</I> two days ago. <I>Unu ~on</I>, one day. <I>~oj antikvaj,</I> days of old (Ps 143/5). <I>~o difinita, grava, pluva</I>. <B>Labor~o</B> (<I>simpla ~o</I>), week-day. <B>naskiĝa ~o</B>, birth-d. <B>Prokrasto~o</B>, d. of grace, (respite). <B>Ripoza ~o</B>, day of rest. <I>Bonan</I> <B>~on!</B> Good day! (col) <I>Bonbon! Bon tag!</I> (2 FA 61/14). <B>~a</B>, of day(light). <I>~a laboro</I>. <B>~e</B>, by (during the) d. <B>~iĝo</B>, d- break. <I>~iĝa muziko</I>, aubade, song of dawn. <B>~deko</B>, decade. <B>Ĉiu~a</B>, daily, diurnal, for every d. <B>f</B> ordinary, prosaic. <I>La proza ĉiu~eco de la vivo</I>. <B>Laŭ~e</B>, by the day. <B>Super~o</B>, intercalculary day. <B>Plen~a</B>, <B>tut~a</B>, day-long. <B>Unu~a</B> <I>laboro</I>, one day’s work.", "0"],
["Taĝikujo, Taĝikio", "Taĝik-ujo, Taĝikio", "TJ.", "0"],
["tajdo", "tajd-o", "Tid/e, rise and fall of sea. <I>~o (mal)alta</I>, high (low) t. (water). (<I>mal)granda</I>, spring (neap) t. <I>~o reflua,</I> ebb t. f <I>La ~o</I> (course, flow) <I>de progreso</I>. <B>~a</B>, -al. <I>~a ond-(river)o</I>. -vojo, t-way. <B>Sen~a</B> (t-less) <I>maro</I>. ➞ <I>flits</I>.", "0"],
["tajgo", "tajg-o", "taiga, Siberian pine-forest.", "0"],
["Tajlando", "Tajland-o", "TH.", "0"],
["tajli", "tajl-i", "Cut (out), fashion, shape. <I>~i robon laŭ la korpo</I>. Clip, trim (<I>arb-barb -heĝ-)on;</I> c. (<I>diamanton</I>); hew (<I>ŝtonon</I>); sharpen (<I>krajonon</I>). ~o <I>de pantalono</I>, c. of trousers. <I>Bone</I> ~ita (well-c.) <I>vesto</I>. <B>Ungo~ilo</B>, nail -ter. <B>~isto</B>, -ter. ➞ <I>stuc, tond</I>.", "0"],
["tajloro", "tajlor-o", "[UV] (<I>vestotajlisto</I>), Tailor. <B>~i</B> (work as a) t. <B>~ita</B> (t-made) <I>jupo, kostumo</I>. <B>~ino</B>, -ess, dressmaker.", "0"],
["tajpi", "tajp-i", "(<I>maŝinskribi</I>), Type(write). <I>leteron</I>. <B>~aĵo</B>, t-script. <B>~ist(in)o</B>, -ist. ~ilo (<I>skribmaŝino</I>), -writer. <I>Steno~istino,</I> shorthand-ist. ➞ <I>stenotip</I>.", "0"],
["Tajvano", "Tajvan-o", "TW.", "0"],
["takelo", "takel-o", "(mar, mec), tackle, (ropes, pulley-blocks, etc.).", "0"],
["taki", "tak-i", "(<I>zigzagiri), (velado</I>) Tack, \"go about\", make progress by changing course to within about 45° of the wind on alternate sides (bringing the ship’s head to windward, then \"paying off\" to leeward). <B>~ado</B>, tacking. ➞ <I>ĝajb, lof</I>.", "0"],
["taksi", "taks-i", "[UV] Estimat/e. <B>1</B> Valu/e, appraise, assess, judge, rate, form an opinion on, reckon the value of, <I>~i homon laŭ lia merito. ~i la graveeon de io. ~ita valoro,</I> e-ed v. <B>2</B> fix, calculate. <I>~i la nombron de loĝantoj. Alte ~i (ŝati</I>), set a keen v. on, prize. <B>~o</B>, e., v-ation. <B>~aro</B>, prices, scale of fees, etc. <B>~ebla</B>, rateable. <B>Ne~ebla</B>, ine-able, inv-able, priceless. <B>~isto</B>, assessor, v-er. <I>Asekura ~isto</I>, actuary. <B>Ne~inda</B>, v-less. <B>Tro~i</B>, over-rate. <B>Sub~i</B>, under-e. ➞ <I>estim, juĝ, konjekt, valor</I> [Ne= <I>akuz, impost, trouz]</I>. ➞ <I>Sat</I>.", "0"],
["taksio", "taksi-o", "taxi (cab), -isto, ~metro.", "0"],
["taksuso", "taksus-o", "[OA] yew (tree) (<I>Taxus</I>).", "0"],
["taktiko", "taktik-o", "[OA] Tactic/s, art of deploying and manoeuvring forces. <B>~oj</B>, devices for gaining an end. <B>~a</B>, tactical. <B>~isto</B>, -ian. ➞ <I>strategi</I>.", "0"],
["takto", "takt-o", "[OA] <B>1</B> (mus) Time, Rhythm, number and value of pulses in a measure: <I>~o (mal)simpla</I>, simple (compound) t. <I>~o tripulsa</I>, triple t., three beats in a bar. <I>Observi la ~on</I>, keep t. ~o <I>de valso,</I> waltz-t. <I>Li havas nenian ideon pri ~o</I> (no idea of keeping time). <B>2</B> regular beat(ing): <I>Mia pulso batas en ~o</I>. <B>~a</B>, measured, rhythmical. <I>La ~a batado de la remiloj</I>. <B>~i</B>, beat time. <B>~ero</B>, (mus) pulse, <B>~bastono</B>, <B>~ilo</B>, baton. <B>Laŭ~e</B>, in time (step). <B>Mis~e</B>, out of time. ➞ <I>mezur, puis, ritm</I>. <B>3</B> Tact, intuitive perception of what is fitting: <I>Manko de ~o. Montri ~on</I>. <B>~(oplen)a</B>, tactful. <B>Sen~a</B>, tactless. <I>Sen~aĵo</I>, faux pas, gaffe, indiscretion.", "0"],
["talanto", "talant-o", "(coin, weight), talent (Mt 18/24). ➞ <I>talent</I>.", "0"],
["talaro", "talar-o", "official gown, robe (of judge, lawyer, professor, etc.).", "0"],
["talento", "talent-o", "[OA] Talent, aptitude, bump, faculty, gift, high capacity, knack. <I>~o por muziko. Tio postulas ~on kaj inspiron. Li havas ~on … -i</I>, he is a great hand at .... ing. <I>Li ne havas ~on por.. .</I>, he is no good at.. . <B>~(oplen)a</B>, -ed, of talent, gifted. <I>~a poeto</I>. <B>~</B>e, with t. <B>~ulo</B>, man of talent. <B>Sen~a</B>, without t. ➞ <I>geni, talant, virtuoz</I>.", "0"],
["talero", "taler-o", "[OA] (ant) thaler, G. silver coin. ➞ <I>dolar</I>.", "0"],
["taliktro", "taliktr-o", "(bot) meadow rue (<I>Thalictrum</I>).", "0"],
["talio", "tali-o", "[UV] Waist, Figure. <I>~o fleksebla, vespa</I>. <B>~a</B> <I>mezuro</I>, w-measure. <I>~a vesto</I>, bodice. <B>Bel~a</B>, well-formed, with elegant figure. ➞ <I>figur, kamizol, vest</I>.", "0"],
["talismano", "talisman-o", "[OA] talisman, lucky charm with magical properties; worn for protection or to bring good fortune. ➞ <I>amulet</I>.", "0"],
["talitro", "talitr-o", "(<I>marpulo, sablopulo) &lt;</I> sand- hopper (<I>Talitrus</I>).", "0"],
["taliumo", "talium-o", "(chem) thallium (Tl).", "0"],
["talko", "talk-o", "[OA] Talc(um). <B>~a</B> <I>pulvoro</I>, t. powder.", "0"],
["talmudo", "talmud-o", "[OA] Talmud, book of Jewish civil law: <I>ekzegezo de la ~o</I>. <B>~isto</B>. <B>~eksperto</B>.", "0"],
["talo", "tal-o", "(bot) thallus, plant-body without root, stem, or leaves.", "0"],
["talpo", "talp-o", "[UV] Mole (<I>Talpa). Blinda kiel ~o</I>. <B>~ejo</B>, molehill. <B>~ĉasisto</B>, mole-catcher. ➞ <I>gril</I>.", "0"],
["taluso", "talus-o", "talus. <B>1</B> ankle-bone. <B>2</B> bank, batter, embankment, ramp, tapering slope (of ditch, earthwork, excavation, wall), <B>~i</B>, bank (fill) up. ➞ <I>dekliv</I>.", "0"],
["talvego", "talveg-o", "(geol) thalweg, valley-line: <I>~o difinas la enriveran limon inter du landoj</I>.", "0"],
["tamanduo", "tamandu-o", "(zoo) tamandua ant-eater (<I>Tamandua</I>).", "0"],
["tamarindo", "tamarind-o", "tamarind (tree) (<I>Tamarindus</I>). <B>~a</B> <I>arbeto</I> (4 FA 58/9). <I>~a frukto</I>.", "0"],
["tamarino", "tamarin-o", "tamarin monkey (<I>Leontieebus</I>).", "0"],
["tamarisko", "tamarisk-o", "tamarisk (shrub) (Ge 21/33, <B>1</B> Sa 22/6) (<I>Tamarix</I>).", "0"],
["tamburino", "tamburin-o", "[OA] (m.i.) tambourine (Ps 150/4). <B>~istino</B> (Ps 68/25).", "0"],
["tamburo", "tambur-o", "[UV] Drum. <B>1</B> (m.i.) <I>Bas~o (~ego). ~o milita</I>, snare-drum, side-d. <B>2</B> similar object. (arch) tambour (cylindrical stone); (mar) gipsy (of capstan); (nwk) tambour, (circular frame for embroidery). Brems~o, brake d. <B>~i</B>, [UV] drum, e.g., <I>per la fingroj sur la tablo</I>. <B>~ado</B>, -ming. <B>~eto</B>, tabor. <B>~isto</B>, -er. <B>~(frap)ilo</B>, d-stick. ➞ <I>tamtam, timpan</I>.", "0"],
["tamen", "", "[UV] (adv, conj) (<I>malgraŭ tio, sed</I>), Nevertheless, all the same, but for all that, howbeit, however, still, though, yet. <I>Kvankam li estas riĉa,</I> <B><I>~</I></B> <I>li ne estas feliĉa. T~ estas bone, ke...</I>, all the same, it is a good thing that. ➞ <I>dum, kontraŭ, kvankam, malgraŭ, sed</I>.", "0"],
["tamiaso", "tamias-o", "chipmunk (<I>Tamias</I>). ➞ <I>marmot</I>.", "0"],
["tampono", "tampon-o", "tampon, plug, tamp. <B>~i</B>, bung, stop up. ➞ <I>dubl, stop, vat</I>.", "0"],
["tamtamo", "tamtam-o", "[OA] tom-tom, native African or Indian drum, <B>~i</B> (<I>distrumpeti</I>), advertise noisily. ➞ <I>gong</I>.", "0"],
["tamuso", "tamus-o", "black bryony (<I>Tamus</I>). ➞ <I>brioni</I>.", "0"],
["tanaceto", "tanacet-o", "(bot) tansy (<I>Chrysanthemum</I> or <I>Tanacetum vulgare</I>).", "0"],
["tanagro", "tanagr-o", "(orn) tanager.", "0"],
["tandemo", "tandem-o", "[OA] tandem. <B>1</B> carriage. <B>2</B> cycle. <I>Jungi</I> <B>~e</B>, one behind the other, tang-i, <B>1</B> (av, mar mot), Pitch, sway backwards and forwards. <I>La aŭto, ŝipo ~is</I>. <B>~ado</B>, -ing. (av) ~a <I>angulo</I>, angle of p. ➞ <I>ruliĝ</I>. <B>2 ~o</B>, (dance), tango.", "0"],
["tangelo", "tangel-o", "tangelo, ugli (Jamaican hybrid between tangerine and grapefruit),", "0"],
["tangento", "tangent-o", "[OA] (trig) tangent of angle. ➞ <I>tanĝ</I>.", "0"],
["tanĝi", "tanĝ-i", "(<I>-n</I>), (geom) touch at one point; meet without intersection. <B>f</B> diverge suddenly from course or subject; dodge the question, go off at a tangent, dodge, graze, skim the surface, touch lightly. <I>~i la morton</I>. <B>~anta</B>, at a tangent. ➞ <I>kontakt, tuŝet</I>.", "0"],
["tani", "tan-i", "(<I>-n</I>), [UV] Tan. ~i <I>ledon. ~i blanke,</I> taw, dress, <B>f</B> (<I>bati) ~i al iu la haŭton</I>. <B>~a</B>, -nic. <B>~ado</B>, -ning. <B>~ejo</B>, -nery. <B>~ilo</B>, bark for -ning. <B>~isto</B>, -ner. <B>~kolora</B>, t-colored, bronze, tawny.", "0"],
["tanino", "tanin-o", "[OA] tannin.", "0"],
["tankao", "tanka-o", "tanka (<I>31-silaba utao</I>), Japanese poem of 31 syllables (us. 5.7.5-7.7). ➞ <I>uta</I>.", "0"],
["tanko", "tank-o", "(mil) Tank. <B>Kontraŭ~a</B>, anti-tank: <I>~a misilo</I>. ➞ <I>cistern</I>.", "0"],
["tantalizi", "tantaliz-i", "tantalize.", "0"],
["tantalo", "tantal-o", "(chem) tantalum (Ta).", "0"],
["tantiemo", "tantiem-o", "percentage (quota, share) of profits. <I>Aŭtora ~o</I>, royalty. ➞ <I>dividend</I>.", "0"],
["Tanzanio", "Tanzani-o", "TZ.", "0"],
["taoismo", "tao-ismo", "<B>~isto</B>, (rel) tao-ism, -ist.", "0"],
["tapeto", "tapet-o", "[UV] <B>1</B> Tapestry, hanging(s), wall-covering (Alt 1/5). 2 (<I>~a papero</I>), wall-paper. <B>~i</B> (<I>-n</I>), cover (hang) with t., paper (a room). <I>~i</I> (line) <I>skatolon per papero. Muro hedere ~ita</I> (ivy-clad). <B>~isto</B>, paper-hanger. ➞ <I>tapiŝ, teg</I>.", "0"],
["tapioko", "tapiok-o", "[OA] tapioca. ➞ <I>sagu</I>.", "0"],
["tapiro", "tapir-o", "(zoo) tapir (<I>Tapirus</I>).", "0"],
["tapiŝo", "tapiŝ-o", "[UV] carpet. <I>~o kovris la plankon. Vi sternis la ĉielon kiel ~on</I> (Ps 104/2). <I>~o altlana</I> (long-pile), <I>flordesegna</I> (flowered). <B>f</B> <I>Gresa, verda ~o (razeno</I>), greensward, <B><I>La tero est is ~ita de floroj</I>. ~eto</B>, rug. <B>Preĝ~eto</B>, prayer-rug. ➞ <B><I>mat, tapet</I></B>.", "0"],
["tapsio", "tapsi-o", "(bot) thapsia &gt; deadly carrot.", "0"],
["taraksako", "taraksak-o", "(technical language) dandelion (<I>Taraxacum dens leonis</I>). Both this and <I>leontodono</I> are called (ordinary language) <I>leondento</I> from their jagged leaves.", "0"],
["tarantelo", "tarantel-o", "[OA] (dance) tarentella. ➞ <I>tarantul</I>.", "0"],
["tarantulo", "tarantul-o", "[OA] tarantula spider (<I>Tarantula</I>).", "0"],
["tarda", "tard-a", "Tard/y, slow-moving, sluggish. II ~igrado, (zoo) -igrade.", "0"],
["tarifo", "tarif-o", "[OA] tariff, list (scale) of charges. <I>Poŝta ~o</I>. ➞ <I>impost</I>.", "0"],
["taro", "tar-o", "tare, weight of packing, etc. <I>~a prezo</I>, price with packing. <B>Kun~a</B>, gross. <B>Sen~a</B>, nett.", "0"],
["taroko", "tarok-o", "[OA] (cgm) taroc, tarot. <I>-ita,</I> chequered (of card),", "0"],
["tarsio", "tarsi-o", "(zoo) tarsier (<I>Tarsius</I>).", "0"],
["tarso", "tars-o", "<B>1</B> (anat) tarsus, (ent) terminal segment of limb. <B>2</B> (orn) shank,", "0"],
["tartano", "tartan-o", "(cl. tex), tartan, Scottish plaid, woollen fabric with crossed stripes,", "0"],
["tartro", "tartr-o", "(chem) Tartar, deposit, fur, scale. <B>1</B> from fermented wine. <I>rafinita</I>, cream of tartar. <B>2</B> on teeth. <B>~acido</B>, -ic acid. <B>~ato</B>, tartrate. Vomiga ~ato, t. emetic, (mot) <B>Sen~igi</B>, scrape.", "0"],
["tasko", "task-o", "[OA] Task, job, piece of work. ~o <I>malfacila, laciga. Fini, proponi ~on. Akcepti la ~on de klasifado. Hejm~o,</I> homework. ~i (1 FA 44/1), assign task to, require from. <B>~aĉo</B>, forced labour, irksm task, piece of drudgery, thankless job. ➞ <I>dev, ofic, okup, vol</I>.", "0"],
["taso", "tas-o", "[UV] Cup, mug; pan (of scales). <I>Metala ~o</I>, tin mug. <I>Kaf~o, te~o, ov~o. ~(plen)o da teo</I>, cupful of tea. <B>~ego</B>, basin, bowl (➞ <I>bovl</I>). <B>Sub~o</B>, saucer. ➞ <I>kalik, kup</I>.", "0"],
["tatui", "tatu-i", "[OA] tattoo. <B>~(ad)o</B>, <B>~arto</B>, t-ing. <B>~aĵo</B>, <I>forigi ~~on</I>. <B>~isto</B>.", "0"],
["taŭgi", "taŭg-i", "(nt), [UV] be Fit (good, suitable) for, be of use, serve. <I>~i kiel edzo, por manĝo. Li ~as (kapablas) nek por studo, nek por ludo. Bone ~i</I>, answer the purpose, do very well, <I>Li ne ~as</I> (is no good) <I>por komerco</I>. Kio ~as por somero, ne ~as por vintro. <I><B>~a</B>, fit, good, serviceable, suitable for</I>. <I>~a por la okazo. La supervivo de la plej taŭgaj (fittest). <B>~eco</B>, fitness, qualification, suitability, utility. <B>~igi</B>, fit, qualify. <B>Ne~a</B>, no good, of no use, unfit. <B>Sen~a</B>, good for nothing, worthless</I>. <B>~~aĵo</B>, <I>lumber, rubbish</I>. <B>~~ulo</B>, <I>bad lot, good-for-naught, ne’er-do-well, scamp, scapegrace. <B>Mar~a</B>, seaworthy. <B>Sem~a</B>, arable. ➞ konven, serv, util, valor</I>.", "0"],
["taŭrotrago", "taŭrotrag-o", "(zoo) eland (Taurotragus oryx).", "1"],
["taŭtologio", "taŭtologi-o", "(rh) tautology, redunduncy, repetition of same idea in difft words. <B>~a</B>, -ic<B>al</B>.", "0"],
["taŭzi", "taŭz-i", "(<I>-n</I>), <B>1</B> (<I>malordigi</I>) pull abt, disorder, ruffle, rumple, tousle, tumble (<I>harojn, veston</I>). <B>2</B> treat roughly, hustle, jostle. <I>La policanoj ~is la krimulon</I>. <B>3</B> (<I>= kardi</I>), card, comb, tease. <I>~i drapon. Kun haroj</I> <B>dis~itaj</B>, dishevelled, ruffled, rumpled, tangled. <B>~hara</B>, shockheaded. ➞ <I>tir</I>.", "0"],
["taverno", "tavern-o", "tavern (slightly pej.).", "0"],
["tavolo", "tavol-o", "[UV] Layer, thickness of matter spread over (covering) a surface. <I>~o da butero, neĝo, nubo, oranĝoj en skatolo;</I> bed (<I>argilo</I>); coat, deposit (<I>sablo</I>); sheet (<I>akvo, glacio</I>); stratum, (met) <I>Appletona ~o</I>, Appleton layer. <B>f</B> <I>~o de antaŭjuĝoj, de la socio</I>. <B>~aro</B>, strata. <B>~eto</B>, coating, film, leaf, membrane, thin flake, skin. <B>~igi</B>, arrange in layers. <B>(de)~iĝi</B>, peel (flake) off. <B>Sub~o</B>, under-layer. ➞ <I>film, foli, lamen, stratum, stratus</I>.", "0"],
["teamo", "team-o", "(sp) team, set of players, side.", "0"],
["teatro", "teatr-o", "[F], Theatr/e, play-house. <I>~o subĉiela</I>, open-air t. <B>f</B> (drama, scene, spectators): <I>La Angla ~o. Aperi sur la ~o. La tuta ~o aplaŭdis</I>. <B>~a</B>. -ical. <I>~a gesto</I>, <B>~aĉa</B>, meretricious, <B>~aĵo</B>, drama, piece, play, <B>~amanto</B> [F], play-goer. ➞ <I>aktor, dram, lud</I>.", "0"],
["tedeumo", "tedeum-o", "(mus, rel) Te Deum.", "0"],
["tedi", "ted-i", "(<I>-n, al</I>) [UV], Bor/e, Weary, fatigue (tire) by excessive length, importunity, repetition, etc. <I>Al mi ~is lin aŭskulti</I>. <B>~ita</B>, b-ed with, tired of, <B>~o</B>, b-dom, tedium (caused by another). <I>Kontraŭ ĉiu ~o ekzistas rimedo</I>. <B>~a</B>, b-ing, irksm, tedious, wearism. <I>Du ~aj horoj</I>, two mortal (solid) hours. <B>~aĵo</B>, botheration, nuisance, rigmarole. <B>~egi</B>, b. stiff (to death). <B>~iĝi</B>, have enough (be sick) of. <B>~ulo</B>, dull fellow, ➞ <I>enu, ĝen, lac</I>.", "0"],
["tegenario", "tegenari-o", "(ent) house-spider (<I>Tegenaria</I>) ➞ <I>arane</I>.", "0"],
["tegi", "teg-i", "[UV] coat, cover, face, over-lay (-spread); drape, hang, upholster (<I>meblon</I>); lag (<I>tubon</I>); patch (<I>bendon</I>), revet (<I>muron). ~u ĝin per oro</I> (El 25/11). <B>~o</B>, [UV] coating, covering, facing, lining, surfacing, ticking. <B>f</B> cloak, pretence. <I>Ligna</I> <B>~aĵo</B>, panelling, wainscotting. <B>~ilo</B>, cover, envelope, wrapper. <I>Kusen~ilo (kuseningo</I>), pillow-case, pillow-slip). <B>Mal~i</B>, bare, denude, strip. <B>Re~i</B>, re-cover, retread (<I>bendon</I>). ➞ <I>kovr</I>.", "0"],
["tegmento", "tegment-o", "[UV] Roof, house-top. <I>~o ardeza, pajla, pinta, tegola</I>. <B>~a</B> <I>defluilo</I>, eave, gutter. <I>~a rando</I>, overhang. <I>~a supro (firsto</I>), <B>~i</B>, (cover with a) roof. <B>~aĵo</B> <I>ondlada,</I> corrugated roofing. <B>~isto</B>, -er, slater. <I>Pajl~isto</I>, thatcher. <B>Sen~a</B>, r-less. <B>sub~o</B>, [UV] attic, garret, loft. ➞ <I>first, mansard, trab</I>.", "0"],
["tegolo", "tegol-o", "<I>[OA]</I>, Til/e. <B>~o</B> <I>ardeza, argila, marmora, vitra</I>. <B>First~o</B>, ridge-t. <I>~oj falis de la tegmento</I>. <B>~i</B>, t. <B>~a</B>, tiled, <B>~ejo</B>, -ery. ➞ kahel, <I>ŝind</I>.", "0"],
["teismo", "teism-o", "[OA] <B>teisto</B>, [OA] theism, theist.", "0"],
["tekniko", "teknik-o", "[OA] Techni/que. <B>~o</B>, -cal, <I>~a detalo, edukado, termino</I>. <B>~isto</B>, -ician.", "0"],
["teknologio", "teknolog-io", "technolog/y. <B>~(iist)o</B>, -ist. <B>~ia</B>, -ical.", "0"],
["teko", "tek-o", "holder for documents, brief-case, file, portfolio, satchel.", "0"],
["teksi", "teks-i", "(<I>-n</I>), [UV] Weav/e. ~i <I>kanabon, lanon, linon, silkon; drapon, katunon, tolon</I>. <B>f</B> ~i <I>komploton</I>, w. (hatch) a plot. ~i <I>mensogojn kaj ruzojn</I>. ~i <I>detalojn en historion</I>. <B>~a</B>, textile. <I>~a industrio</I>. <B>~(ad)o</B>, <B>~arto</B>, w-ing. <B>~aĵo</B>, woven fabric, tissue, <B>f</B> ~aĵo el maheroj. <B>~ejo</B>, w-ing factory. <B>~ilo</B>, <B>~maŝino</B>, loom. <B>~isto</B>, -er. <B>~aranĝo</B>, texture. <I>La historio estas</I> <B>tra~ita</B> <I>de katastrofoj</I>. ➞ <I>hist, plekt, spin, trik, varp, veft</I>.", "0"],
["teksto", "tekst-o", "[OA] Text, wording, words (of music), legend (of picture). <B>1</B> exact words of author (document), <I>La originate ~o. Sxanĝi la ~on</I> (preface to <I>Psalmaro). Reveni al sia ~o</I>, to one’s subject <B>2</B> text of sermon, <B>~a</B>, -ual. <I>~a eraro</I>. <B>~i</B> (nt), be formulated in words, run. <I>La decido ~is jene</I>. <B>~aro</B> <B>~libro</B>, book of words; (<I>korpuso</I>), collection of texts, corpus. <B>Ĉirkau~o</B>, <B>Kun~o</B>, context. <B>Laŭ-e</B>, textually, <B>Sen~a</B>, without words.", "0"],
["tektono", "tekton-o", "Teak (<I>Tectona). ~a ligno,</I> t-wood.", "0"],
["tele", "tele-", "(international pfx), tele-, distant. -aŭto, -grafi, -aŭskulti, ~desegni, -filmi, -fotografi, -komuniki, -mekaniki, -paroli, -presi,", "0"],
["telefono", "telefon-o", "[OA] (col. abbreviate <I>fon-</I>), Telephon/e, phone. <I>~o aŭtomata</I>. ~a <I>centralo, libro, linio, numero</I>. <B>~i</B>, t. <I>~i mendon. Mi ~os al vi</I>, I’ll ring you up. <I>Paroli</I> ~e. <B>~ado</B>, <B>telefoni-o</B>, -y. <B>~aĵo</B>, -ic message. <B>~ejo</B>, <B>~budo</B>, t-box. <B>~istino</B>, t-girl.", "0"],
["telegrafi", "telegraf-i", "[F], Telegraph, wire, <B>~ado</B>, <B>telegrafi-o</B>, -y. <I>Senfadena ~io</I>, wireless, <B>~a</B>, -ic. <I>~a adreso, drato, fosto, reto</I>. <B>~aĵo</B> (<I>~a depeŝo</I>), telegram.", "0"],
["telegramo", "telegram-o", "[OA] telegram. <I>~o submara,</I> cablegram. <I>Radio~o</I>. <B>~a</B> <I>kodo, stilo</I>. <B><I>~</I>(port)isto</B>.", "0"],
["telegvido", "", "<B>telerego</B>, remote control. <B>~ilo</B>.", "0"],
["telekinezo", "telekinez-o", "(ps) telekinesis,", "0"],
["telemetro", "", "rangefinder.", "0"],
["teleobjektivo", "teleobjektiv-o", "telephoto, telegraphic lens.", "0"],
["teleologio", "teleologi-o", "(phil) teleologio, doctrine of final causes.", "0"],
["telepatio", "telepat-io", "telepath/y, thought-transferee. <B>~(iist)o</B>, -ist.", "0"],
["telerespondi", "telerespond-i", "<B>~(ad)o</B>, <B>~ilo</B>.", "0"],
["telero", "teler-o", "[UV] Plate. <I>Pan~o (ligna ~o</I>), platter, trencher. <I>Lavi la ~ojn</I>, wash up. <I>~o pesila, monkolekta</I>. <B>~a</B> <I>rako</I>, p-rack. <B>~aro</B>, table-service, crockery, plates and dishes, <B>~eto</B>, small p., bottle mat. ➞ <I>plad, plet</I>.", "0"],
["teleskopo", "teleskop-o", "[OA] telescop/e. <B>~a</B>. -ic. ➞ <I>lorn</I>.", "0"],
["televido", "televid-o", "television.", "0"],
["teliptero", "telipter-o", "(<I>Thelypteris</I>) &gt; beech (marsh mountain) ferns.", "0"],
["teluro", "telur-o", "tellurium (Te) <B>~ato</B>, ~ido, <B>~ito</B>.", "0"],
["tembro", "tembr-o", "(sonkoloro), timbre, distinctive quality of instrument or voice.", "1"],
["temo", "tem-o", "[UV] Subject, Them/e, topic. <I>La ~o de la parolo, tezo, verko. ~o aktuala</I>, topic of the day. <I>Mia ~o estas… Ŝanĝi la ~on</I>. (mus) <B>~a</B> ellaboro, thematic development. <B>~i</B>, have as a s., touch on, treat of. <I>La diskuto ~is pri… ~as pri, the s. (matter under discussion) is. <B>~aro</B>, curriculum, syllabus, (mus) <B>~ero</B></I> (<I>figuro</I>), <I>figure. <B>Ekster~a</B> (demando), digressive, extraneous, outside the s. ➞ enhav, kamp, objekt, pri, punkt, subjekt</I>.", "0"],
["temperamento", "temperament-o", "[OA] Temperament, individual character, spirit. <I>~o artista, flega, melankolia, nerva, sangvina</I>. <B>~a</B>. -al. <I>~a difekto</I>.", "0"],
["temperaturo", "temperatur-o", "[OA] temperature. <I>~o de ĉambro. (med) Havi altan ~on</I>. <B>~a</B> <I>kurbo</I>.", "0"],
["temperi", "temper-i", "<B>1</B> (mus) temper, adjust tuning. <I>~ita skalo. La piano estas agordita laŭ egala ~(ad)o</I>. <B>2</B> (bid) Distemper, size-colour. <B>3</B> (painting) <B>~o</B>, tempera.", "0"],
["tempesto", "tempest-o", "(<I>venta ŝtormo</I>), Tempest. <B>~a</B>, -uous. ➞ <I>ciklon, storm, uragan</I>.", "0"],
["tempio", "tempi-o", "[UV] (anat) temple.", "0"],
["templo", "templ-o", "[OA] <B>1</B> Temple, fane, holy place, place of worship, <B>f</B> <I>Via korpo estas ~o de la Sankta Spirito</I> (1 Ko 6/19). <I>2</I> Freemason’s lodge, etc. <B>Bon~ano</B>, Good Templar.", "0"],
["tempo", "temp-o", "[UV] Time. <B>1</B> (continued existence): <I>~o estas mono. Konsolon ~o donas al la koro</I>. <B>2</B> (date, period, times): <I>Aliaj ~oj, aliaj moroj. ~o feliĉa, nuna, pasinta. ~o de milito, rikolto. Post kelka ~o. Antaŭ longa ~o</I>, a long time ago. <I>Dum la tuta ~o,</I> all the t. <I>De ~o al ~o</I>, ever and anon, every now and then, from t. to t., off and on, occasionally, on occasion. <I>Signoj de la ~o</I>. <B>3</B> definite (right, suitable) moment: <I>Jam estas ~o iri domen. Estas ~o por plori kaj ~o por ridi</I>. <B>4</B> (t. to spare, leisure). <I>Gajni, okupi, ŝpari ~on. Mi ne havas ~on por tio</I>. <B>5</B> (gram) <I>~(form)o</I>. (a. <I>tenso</I>). tense. <B>As~o</B>, (<I>prezenco</I>); <B>is~o</B> (<I>preterito</I>); <B>os~o</B>, (<I>futuro</I>). <B>6</B> (<I>= horsistemo); ~o loka, sidera. Brita Somera T~o</I>. <B>~ero</B>, <B>~eto</B> (<I>momento</I>), moment, short time. <B>Ali~e</B>, at another time. <B>Antaŭ~a</B>, premature, untimely. <B>Ĉiu~e</B>, at all times. <I>En tiu ~o amiko amas</I> (Se 17/17). <B>De~e</B> <I>de</I>, ever since, from the t. of (Ij 31/18, Ps 71/17). <B>Ĝusta~a</B>, at the right time, timely, opportune, seasonable. <I>Veni ~~e</I>. <B>Inter~o</B> (<I>intervalo</I>), interval. <B><I>~~e</I></B>, meanwhile. <B>Labor~o</B>, working hours. <B>Lasta~e</B>, lately, of late, recently. <B>Lerno~o</B>, apprenticeship, schooldays, time of study. <B>Liber~o</B>, free (spare) t., leave, leisure. <B>~~i</B>, have a holiday. <B>Lim~o</B>, term, t-limit. <I>~~o de du tagoj,</I> two days’ grace. <B>Nun~a</B>, modern, present-day. <B>~~e</B> (<B>nia~e</B>), nowadays. <B>Por~a</B>, temporary, <B>Post~a</B>, behind t., delayed, expired, out of date, over-due, tardy. <B>Pra~a</B>, primitive. <B>Prov~o</B>, t. of testing (trial), probate. <B>Sam~a</B>, coeval, contemporary. <I>~~eco</I>, coincidence. <I>~~igi,</I> synchronize. <I>~~ulo</I>, contemporary. <B>Unua~e</B>, at first. ➞ <I>epok, foj, hor, mezur, obi, period, puis, sezon, takt</I>. <B>Rim</B>.: Sia~e, en sia ~o. These locutions are used non-reflexivety, for \"in his (its) t., in due (the right) t., duly, seasonably, <I>ĝustatempe.\"</I> The use of the appropriate pronoun can remove ambiguity. <I>Dio donas al ni pluvon en sia ~o</I> (in his time); <I>en ĝia ~o</I>, in its t. <I>Ĉion li kreis bela sia~e</I> (in his t.); <I>ĝia~e,</I> in its t. <I>Mi sia~e (mia~e) leviĝos</I>. This is not the place for exhaustive discussion. Both uses are Z, and legitimate.", "0"],
["tenaca", "tenac-a", "tenacious, holding fast, keeping firm hold, sticky; clinging (<I>planto, odoro</I>), dogged (<I>volo</I>); fast (<I>koloro</I>); retentive (<I>memoro</I>); stiff (<I>tero</I>).", "0"],
["tenajlo", "tenajl-o", "forceps, nippers, pincers, tongs. ➞ <I>prenil, tenil</I>.", "0"],
["tendenco", "tendenc-o", "[OA] Tenden/cy, bias, inclination, leang, propensity, trend, turn. <I>Gazeto kun reakcia ~o. Rakonto kun morala ~o</I>. <B>~a</B>, -tious, biassed, propaganda. <I>~a dramo, raporto, romano, verko. ~a demando</I>, leading question. ➞ <I>cel</I>.", "0"],
["tendeno", "tenden-o", "[UV] sinew, tendon. <B>~(oplen)a</B>, sinewy. ➞ <I>kartilag</I>.", "0"],
["tendo", "tend-o", "[UV] Tent. <I>Starigi -on</I> pitch t. <B>f</B> <I>Aparteni al malsamaj ~oj</I>. <B>Ferdeka ~o</B>, deck awning. <B>Fram~o</B>, frame t. ~a <I>najlo,</I> t-peg. <B>~aro</B>, (en)camp(ment). <B>~ejo</B>, camping-ground. <B>~ego</B>, marquee, etc. <B>~umi</B> (kampadi), camp. ➞ <I>markez, ŝirm</I>.", "0"],
["tenebrio", "tenebri-o", "ground beetle (<I>Tenebrio</I>). <B>~a</B> <I>larvo</I>, mealworm.", "0"],
["tenera", "tener-a", "tender, affectionate, fond, loving. <I>~a kareso, manpremo, parolo, prizorgo</I>. ~e (<I>prizorgi</I>), with loving care. ➞ <I>amen, kares, molkor</I>.", "0"],
["tenesmo", "tenesm-o", "(med) tenesmus.", "0"],
["teni", "ten-i", "[UV] Hold, Keep. <B>1</B> Hold (in hand), grasp: <I>~i bastonon, ies manon. Sin ~i</I> (cling, h. on) <I>je la ŝnuro</I>, strap-hang, etc. <B>2</B> Keep (in a place): <I>~i krimulon en karcero: monon en banko</I>. <B>3</B> k. (in a position, state): <I>~i la buŝon fermita: la kapon rekta; la langon silenta. ~i sin trankvila, sur la piedoj</I>. <B>4</B> (not let go or lose): maintain, preserve, retain. <I>~i instruon, memoron, oficon, promeson, sekreton, sian opinion</I>, (mus) <I>~i la piĉon</I>, k. the pitch. <B>~o</B>, h., custody, grasp, grip. <I>Pied~o</I>, foot-hold. <B>~ado</B>, holding, retention. <B>~aĵo</B>, h-ing, deposit, etc. <B>~anto</B>, holder, keeper. <B>~ebla</B>, tenable. <B>~ejo</B>, depository, store, warehouse. <I>Cigar~ejo, libro~ejo,</I> <B>~ema</B>, retentive, tenacious. <I>Kun~iĝemo</I>, cohesion. <B>~iĝo</B>, <B>sin~o</B>, attitude, bearing, carriage, deportment, posture. <I>~~o digna, prudenta, trankvila</I>. ➞ <I>poz</I>. <B>~ilo</B>, [UV] haft, handle, grip, hilt (➞ <I>ans). ~o de fritilo, martelo, ombrelo, pordo</I>. (nwk) <I>maŝ~ilo</I>, stitch holder. (vn) <I>Kord~ilo</I>, tailpiece. <I>Pinĉ~ilo</I>, pliers. <B>~ujo</B>, reservoir, <B>etc. Al~iĝi, adhere, be attached to. de~i</B>, [UV] check, curb, detain, hold back, keep (stop) from, e.g., <I>de alkoholo, edziĝo, movo, vojaĝo</I>. (Ps 19/13; 1 Sa 3/13; Ij 7/11; Ps 119/101). <I>Sin~~i de</I>, abstain (refrain) from. <B>El~i</B>, endure, h. out against (Jer 10/10). <I>~~i malfeliĉon, provon, suferon; batojn de sorto; forton de vento</I>. <B><I>~~ebla</I></B>, endurable, supportable. <I>Ne~~ebla doloro</I>. <B>En~i</B> (➞ <I>enhav, implic, inklud</I>), h., contain, enclose. <I>La libro ~~as bildojn</I>. <B>For~i</B>, avert, k. away (at bay), ward off. <B>Kun~iĝi</B>, cohere. <B>Re~i</B>, <B>1</B> hold in, keep back, retain, withhold (Ge 39/9; El 9/17; Se 11/26). <B>2</B> (<I>deteni</I>, restrain): <I>~~i koleron, larmojn</I>) (Ps 74/11, Jer 2/24, <B>1</B> Sa 25/26, H 30/31). <B>Rim</B>.: Sometimes deteni and reteni are equally applicable. <I>Li apenaŭ detenis, retenis rideton</I>. <B>sub~i</B>, [UV] <B>1</B> hold up, maintain, bolster (prop) up, support, underpin. <I>~~i tegmenton; muron per traboj</I>. <B>2</B> <I>~~i malriĉulojn, Esperanton, proponon</I>. <B>2</B> continue, sustain. <I>amikecon, familion, komunikon, korespondon, opinion</I>. ~<B>~o</B>, stay, support; (<I>piano) ~~</I>a <I>pedalo</I>, sustaing pedal. <I>~~anio</I>, supporter. <B>Rim</B>.: ➞ <I>teni sube</I>, keep under, suppress, e.g., in drowning a cat. <B>libro~anto</B>, [UV] bookkeeper. ➞ <I>gard, konserv. prezerv</I>.", "0"],
["tenio", "teni-o", "[OA] tape-worm (<I>Taenia</I>).", "0"],
["teniso", "tenis-o", "(lawn) Tennis. <I>Salona (Tabla) ~o,</I> table-t., ping-pong. <B>~ejo</B>, t-court (-ground).", "0"],
["tenono", "tenon-o", "(carp) Tenon. <I>~o hirundvosta,</I> dovetail. <B>~a</B> <I>junto</I>, mortise-and t. joint. <B>~ilo</B>, t-saw. ➞ <I>mortez</I>.", "0"],
["tenoro", "tenor-o", "[OA] Tenor <B>1</B> voice. 2 (<I>-ulo</I>), singer.", "0"],
["tenreko", "tenrek-o", "tenrec shrew (<I>Tenrec</I>).", "0"],
["tensio", "tensi-o", "<B>1</B> Tension (<I>tirstreĉo</I>), strain, stress, tenseness, tightness. <I>Forta ~o</I>. <B>2</B> (el) Voltage. <I>~o kontinua. (Mal)alta ~o,</I> high (low) v. ~a <I>falo</I>, v-drop. <B>Sub~o</B>, hypo-t. <B>Super~o</B>, hyper-t. (el) boosting, over-v. (med). <I>~~o arteria</I>, high blood pressure.", "0"],
["tenso", "tens-o", "(gram) tense. (= <I>tempo</I> 5).", "0"],
["tensoro", "tensor-o", "(anat) tensor.", "0"],
["tentaklo", "tentakl-o", "(zoo) tentacle.", "0"],
["tenti", "tent-i", "[UV] Tempt, try, entice (incite) (usually to evil). <I>Vane vi ~as, mi ne konsentas</I>. <B>~o</B>, -ation, enticement, seduction, trial (action). <I>Cedi</I> (succomb, yield) <I>al ~o. Rezisti ~on. Malfermita kelo ~as al Stelo</I>. <B>~a</B>, -ing, alluring. ~anto, -er. ~iĝo, -ation (experienced).", "0"],
["teo", "te-o", "[UV] Tea. 1 (<I>folioj</I>), t-leaves. <B>2</B> (bev) <I>infuzi, trinki ~on</I>, make (take) tea. <I>~o Ĉxina, Hinda</I>. <B>~ujo</B>, t-caddy (-canister). <B>~arbusto</B>, t-shrub (<I>Thea</I>). <B>~horo</B>, t-break. <B>~kunveno</B>, t-party. <B>~kruĉo</B>, [UV] t-pot. <B>~kultivejo</B>, t-plantation. <B>~horo</B>, <B>~manĝo</B>, tea (meal). <B>~maŝino</B> [UV] (<I>samovaro</I>). <B>~salono</B>, t-room. <B>~vendisto</B>, t-merchant.", "0"],
["teobromino", "teobromin-o", "(chem) theobromine.", "0"],
["teodolito", "teodolit-o", "theodolite.", "0"],
["teokratio", "teokrati-o", "[OA] theocra/cy. ~a -tic.", "0"],
["teologo", "teolog-o", "[OA] Theolog/ian, divine. ~IO, -y, divinity.", "0"],
["teoremo", "teorem-o", "[OA] theorem.", "0"],
["teorio", "teori-o", "[F], Theor/y. <I>~o de gravito, muziko. Tio estas nur ~oj</I>. <B>~a</B>, -etical, speculative. <I>~a skizo</I>. <B>~e</B> <I>ĝusta, sed praktike nerealigebla</I>. <B>~i</B>, -ize, <B>~isto</B>, -etician.", "0"],
["teozofio", "teozof-io", "Theosoph-y. ~ia, -ical. ~(iist)o, -ist.", "0"],
["terakoto", "terakot-o", "<B>~a</B>, terracotta.", "0"],
["terapeno", "terapen-o", "terrapin (<I>Terrapene</I>), various species of pond-tortoise or box-turtle (<I>~o aligatora, Eŭropa, pentrita</I>).", "0"],
["terapio", "terapi-o", "[OA] (<I>kuracarto</I>), Therap <I>ly</I>, -eutics, curative treatment. <B>~a</B>, -eutical.", "0"],
["teraso", "teras-o", "[UV] Terrace. <B>1</B> raised level space. <B>2</B> Row of houses along this. <B>~e</B>, in terraces. ➞ <I>altan, balkon</I>.", "0"],
["teratologio", "teratologi-o", "teratology, study of monstrosities.", "0"],
["terbio", "terbi-o", "(chem) terbium (Tb).", "0"],
["terceto", "tercet-o", "[OA] <B>1</B> (pros) tercet. <B>2</B> (mus) (= triteto), trio, three performers, or music for them.", "0"],
["terciara", "terciar-a", "~o (geol) Tertiary era.", "0"],
["terco", "terc-o", "( = trito), (mus) third (intvl). <I>~o</I> <B><I>majora (minora</I>)</B>.", "0"],
["terebinto", "terebint-o", "[OA] Turpentine, resin from various conifers. <B>~arbo</B>, terebinth (<I>Pistacia terebentha</I>) (Jes 1/29; Ho 4/13). <B>~oleo</B>, t-oil, turps.", "0"],
["teredo", "tered-o", "teredo, ship-borer(-worm) (<I>Teredo</I>).", "0"],
["tereno", "teren-o", "Ground, plot, terrain, tract of land, (sp) pitch. <I>Favora ~o</I>, vantage-ground. <I>Akiri, gajni, okupi, perdi ~on</I>, gain (lose) g. (territory), <B>f</B> (<I>agokampo). Koni la ~on,</I> be sure of one’s g., know the ropes. <I>~o komerca. ~o de dispute</I>. ➞ <I>are, aren, kamp, ter, teritori</I>.", "0"],
["teritorio", "teritori-o", "[OA] Territor/y, district, region, land (under jurisdiction or operate). <B>~a</B>, -ial. ➞ <I>distrikt, kanton, provinc, region, subŝtat, ŝtat, teren</I>.", "0"],
["termino", "termin-o", "[UV] (technical) Term, expression, name. <B>~aro</B>, nomenclature. <B>~ologio</B>, terminology. ➞ <I>finstaci</I>.", "0"],
["termito", "termit-o", "[OA] termite, \"white ant\" (<I>Termes</I>). <B>~ejo</B>.", "0"],
["termo", "term-o", "<B>1</B> (mat, log), term (element of formula or reasoning). <I>~o de ekvacio, silogismo</I>, <B>2</B> (ph) <B>~a</B>, thermal, thermic.", "0"],
["termo", "termo-", "(Gk pfx = <I>varm</I>), Thermo-. ~dinamiko, ~elektro, ~kemio, ~metro [OA], ~nukleo, ~stato, ~terapio. ~botelo (<I>termoso</I>), vacuum flask.", "0"],
["terni", "tern-i", "[UV] <B>~o</B>, Sneeze. <I>Ne ekzistas ~o sen nazo</I>. <B>~igi</B>, make s. <I>~iga</I>, sternutatory. <I>~iga pulvoro</I>, -ing powder.", "0"],
["tero", "ter-o", "[UV] Earth. <B>1</B> (<I>~globo</I>), (astr) the world. <I>Esti sola sur la ~o. Mondo~o</I> (Se 8/31). <B>2</B> Ground, land. ~o <I>firma, sankta. Kuŝi sur la ~o. Vojaĝi sur ~o kaj maro</I>. <B>3</B> ground, soil. <I>Fosi, kultivi la ~on. ~o argila, riĉa, sabla, seka</I>. <B>~a</B>, earthen, of the e. <I>~a poto, surfaco. Fali</I> ~en, (down. to the g.) <I>Rigardu ~en</I>, landward. <B>~en!</B> Down! <B>~aĵo</B>, e-work. <B>~ulaĉo</B>, clodhopper. <B>~amaso</B>, hillock, knoll, piece of e. <B>Al~iĝi</B>, land. <B>Vizaĝ~~e</B>, prone. <B>ekster~ulo</B>. <B>El~igi</B>, dig up, disinter, exhume. <I>~~iĝi (tra~iĝi</I>), come up. <B>en~igi</B> [UV] (Jeĥ 39/15), bury, inter. <I>~~igi mortinton, trezoron. ~~igita,</I> done with and forgotten. <I>~~iga soleno,</I> obsequies (➞ <I>funeral). ~~igejo</I>, burial-ground, cemetery, grave-yard. <I>~~igisto</I>, grave-digger. <I>~~iĝi</I>, burrow, go to e. <B>Ne~a</B>, unearthly. <B>Sub~a</B>, under-g., subterranean. <I>~~a fervojo (metroo</I>). <B>Super~a</B>, ethereal, supermundane. <B>Sur~a</B>, e-ly, on the e., terrestrial. <I>~~a vivo. Kuŝanta</I> <B>~~e</B>, prostrate. <I>~~iĝi</I>, run aground, land. <B>Trans~a</B>, from beyond, ultra-territorial. ➞ <I>grund, hum, kamp, land</I>.", "0"],
["teroro", "teror-o", "(pol) Terror/ism, reign of terror. <B>~i</B>, -ize, frighten into submission, use coercive intimidation. <B>~isto</B>, -ist. ➞ <I>terur</I>.", "0"],
["teruro", "terur-o", "[UV] Terr/or, fright, intense fear. <I>Atakis min ~o</I>. <B>~a</B>, terrible, terrifying, awful, dire, frightful, horrid, horrible. <I>~a akcidento, stato</I>. <B>f</B> (<I>ega), ~a malamo</I>. <B>~e</B> (<I>treege) malorda, malbona vetero, suferi</I>. <B>~(eg)i</B>, -ify, appal, dismay, fill with terror, horrify. <I>Vi ~as min</I> (Ij 7/14, Ps 27/1). <I>Kuri ~ite</I> (2 Sa 22/46; Ps 18/45). <I>~ata de</I>, -ified at. <B>~aĵoj</B> <I>de milito</I>, horrors of war. <B>~igi</B>, make -ible. <B>~iĝi</B>, be -ified. ➞ <I>abomen, teror, timig</I>.", "0"],
["testamento", "testament-o", "[UV] Testament. <B>1</B> (jur) will, death settlement. <B>~a</B>, -ary. <B>~i</B>, bequeath, leave (by will), <B>f</B> pass on, e.g., from one generation to another. <B>~aĵo</B>, bequest, legacy. <B>~into</B>, testator. <B>Sen~a</B>, intestate. ➞ <I>hered, postlas</I>. <B>2 (Bb)</B> (covenant, dispensation): <I>La (Mal)Nova ~o (MT, NT</I>).", "0"],
["testiko", "testik-o", "[UV] testicle. ~ujo, scrotum.", "0"],
["testo", "test-o", "test, critical examination (trial) of qlties (of person or thing). <I>~o pri inteligento</I>. <B>~i</B>, put to the test, make trial of. ➞ <I>prov</I>.", "0"],
["testudo", "testud-o", "[UV] Tortoise (<I>Testudo). Mara ~o (kelonio</I>), turtle. <B>~a</B> <I>ŝelo (karapaco</I>), t-shell. <I>Paŝi</I> <B>~e</B>. <I>Bona famo sin trenas</I> <B><I>~e</I></B>, <I>malbona kuras rapide</I>.", "0"],
["tetano", "tetan-o", "[UV] Tetan/us &gt; lockjaw. II ~io, <B>-y</B>.", "0"],
["tetra", "tetra-", "(Gk pf<I>x = kvar</I>), tetra-. ~gono, ~klorido, ~metro, ~oksido. (mus) ~kordo, -chord = each half of a major scale, e.g., C-F, G-C.", "0"],
["tetrao", "tetra-o", "[UV] hazel grouse (<I>Tetrastes</I>). <B>~ino</B>, hazel hen. ➞ <I>lagop, urogal</I>.", "0"],
["tetro", "tetr-o", "[UV] black cock (grouse) (<I>Lyrurus tetrix</I>). <B>~ino</B>, gray hen. ➞ <I>lagop, urogal. [Ne= tetra]</I>.", "0"],
["teŭgo", "teŭg-o", "(mar) forecastle, deck.", "0"],
["teŭkrio", "teŭkri-o", "(bot) wood-sage, germander (<I>Teuerium</I>).", "0"],
["tezo", "tez-o", "[UV] thesis, proposition to be maintained (esp in university exam). <I>Senpruva ~o estas nur hipotezo. Submeti</I> (uphold) <I>~on</I>.", "0"],
["tFI!", "", "(interjection), denotes 1 <I>mallaŭdon</I>. Fie! For shame! <I>~ al</I> vi’/Fie upon you! Shame on you! <B>2</B> (<I>naŭzon</I><B>)</B>: <B>Ugh!</B> <I>Kia ŝlimo!</I> <B>Fia</B> (or pfx fi-), shameful, morally bad, worthy of indignation, abominable, base, discreditable, disgusting, disreputable, foul, ignoble, infamous, immoral, nasty, questionable, scandalous, shady, unworthy. <B>A fi-ag(-aĵ-pens-parol-)o</B> is an act (thing, thought, speech) of which one should be ashamed. <B>~fama</B>, of ill repute. <B>~flati</B>, toady; <B>~gazetaro</B>, gutter press; <B>~Iibro</B>, immoral (filthy) book; <B>~rakonto</B>, dirty (smutty) story; <B>~virino</B>, ignoble woman; <B>~vorto</B>, bad word. <B>-ulo</B>. ➞ <I>aĉ</I>.", "0"],
["tia", "", "[UV] (<I>tiuspeca</I>), of that kind, that kind of a, such a, like that. <I>Ne skribu ~jn longajn leterojn. Mi ne amas ~jn homojn, Ni ne estas ~j</I> (people like that). <I>Li kreis ion ~n, kio ankoraŭ neniam ekzistis</I> (the like of which till then had never existed). <I>Kia patro, ~ filo</I>, like father, like son. <I>Venu ~a, kia vi estas</I> (as you are). <I>Tia-tia</I> (Rut 4/1). <B>~ĵoj</B>, such things. <B>~maniere</B>, ke, so that.", "0"],
["tial", "", "[UV] (<I>tiukaŭze, pro tio</I>, strong form of <I>do</I>), accordingly, for that reason, therefore, that is why. <I>Li ne volas lerni, kaj ~ mi batas lin. ~</I> ke, because, for the reason that (strong form of <I>ĉar). La bebo ploris nur ke ĝi malsatis</I>. <B>~o</B> (<I>kialo</I>). ➞ <I>sekve</I>.", "0"],
["tiam", "", "[UV] (adv) (<I>tiumomente, tiutempe</I>). <B>1</B> Then, at that time: <I>~ mi estis juna. Venu morgaŭ; ~ mi estos libera</I>. <B>De ~</B>, from that time, since then, thenceforward, thereafter. <B>2</B> (<I>tiuokaze</I>): In that case, under those circumstances. <I>La artikolo \"la\" estas uzata kiam ni parolas pri aferoj konataj. Se vi ne komprenos, ~ mi parolos pli malrapide</I>. <B>~a</B>, of that time (those days), contemporary. <I>La ~aj moroj. La ĝis~aj sistemoj</I> (K 261/32). <B>~ulo</B>, contemporary, man of that time (living then).", "0"],
["tiaro", "tiar-o", "[OA] tiara, papal crown, ornamental coronet.", "0"],
["tibio", "tibi-o", "[UV] tibia, shin-bone, drumstick. <I>~o de akrido</I> (4 FA 10/25). <B>~ingo</B>, upper of high boot. <B>~umoj</B>, leggings. <B>~karno</B> (<I>suro</I>), calf of leg.", "0"],
["tie", "", "[UV] (adv) (<I>tiuloke</I>), There, in that place, over t., yonder. <I>~ kaj aliloke</I>, here and there. <I>Kion vi faras ~? De</I> thence. <I>Ne iru</I> <B>~n</B> (to t., thither). <I>Kie dento doloras, ~n iras la lango. Paŝi ~n kaj reen</I>, hither and thither, t. and back, to and fro. <B>~a</B>, local, of that place. <B>~ulo</B>, local person. <B>Ĉi ~</B>, here, in this place, on this point. <I>Proksimume ĉi ~</I>, hereabouts. <I>For de ĉi ~!</I> Hence! <I>Ĉi ~en</I>, hither, to here.", "0"],
["tiel", "", "[UV] (adv). <B>1</B> (MANNER <B>=</B> tiumaniere): as, in such a (that) way, like that, so, thus. <I><B>~</B> ni kontentigis ĉiuj</I>. tr. ~ estu, so be it. <B>~</B> ke, so that. Por ~ diri, so to speak. <B>Kaj ~ plu</B> (k.t.p., ktp.), and so on, etc. Se <B>~</B> estas, if that is the case. <B>2</B> (COMPARISON): <B>~</B> bona, kiel vi (just) as good as you. Kiel oni sternas, ~ oni dormas. Estu ~ afabla, kiel… Be so kind as to. <B>3</B> (DEGREE): La nokto estis ~ malluma, ke ni nenion povis vidi. Li estas ~ malsana, ke li verŝajne mortos. <B>~a</B>, <B>~e</B>, emphatic pleonastic forms of tia, tiel (Jeh 17/19, 26/7).", "0"],
["ties", "", "[F], <B>1</B> (de tiu, de tio, de tiuj), Of that (those), that one’s, his, etc.: <B>~</B> opinio ne multe valoras. Kies panon oni manĝas, ~ vorton oni parolas. <B>2</B> (the latter’s): Ili promenis kun sia amiko kaj ~ (= lia) kuzo. La infano ludis kun sia pupo, kaj subite ~ (its) kapo rompiĝis.", "0"],
["tifao", "tifa-o", "reed mace, false bulrush (<I>Typha</I>).", "0"],
["tifo", "tif-o", "[OA] Typh/us. <B>~(ec)a (~ojda)</B> febro. <B>~ulo</B>, sufferer from typhus.", "0"],
["tifono", "tifon-o", "(<I>Pacifika uragano</I>), (met) typhoon,", "0"],
["tigo", "tig-o", "stem, stalk (of plant): shaft (of column); shank (of key); straw (of corn); (mus) stem (of note). ➞ <I>trunket</I>.", "0"],
["tigro", "tigr-o", "[UV] tiger (<I>Panthera tigris</I>). <B>~ino</B>, tigress.", "0"],
["tikli", "tikl-i", "(<I>-n</I>), [UV] Tickl/e. <I>Ne ~u min</I>. <B>f</B> <I>Tiu muziko simple ~as la orelon</I>. <B>~o</B>, tickle. <B>~a</B>, that -s. <B>f -ish</B>, awkward, delicate, thorny. <I>~a demando, punkto</I>, weak spot. <I>Tio ĉi estas ~aj aferoj</I> (GD 13/9). <B>~eti</B>, titillate. <B>~osentema</B>, -ish.", "0"],
["tiko", "tik-o", "<B>1</B> (med) tic, twitch(ing). <B>2</B> (tex) ticking (of mattress).", "0"],
["tikodromo", "tikodrom-o", "(<I>murbirdo</I>), wall-creeper (<I>Tichodroma</I>).", "0"],
["tiktaki", "tiktak-i", "Tick, go tick-tock (<I>horloĝo</I>); click-clack (<I>teksilo</I>); pit-a-pat (<I>koro</I>). <B>~ado</B>, -ing.", "0"],
["tildo", "tild-o", "(<I>ondosigno</I>), (typ) tilda (~).", "0"],
["tilio", "tili-o", "[UV] lime (linden) tree (<I>Tilia). Amerika ~o</I>, basswood (<I>T. Americana</I>). ~a <I>floro, teo</I>.", "0"],
["timalo", "timal-o", "(ich) grayling (<I>Thymalus</I>).", "0"],
["timi", "tim-i", "[UV] Fear, be afraid (frightened) of, anxious (apprehensive) about. dread, <I>~i doloron, mokon, morton, punon. ~i diri, konfesi, morti. Mi timas, ke jes (ne</I>). I am afraid so (not). <I>~i, ke pluvos, ke ne pluvos</I>. <B>~o</B>, fear, anxiety. <I>Perfekta amo elĵetas ~on</I> (1 Jo 4/18). <I>Paliĝi de ~o, ~o pri</I> (fear of) <I>fiasko. Pro ~o ke</I>, lest, for fear that. <I>~o antaŭ la Eternulo</I> (Se 1/7) <B>~(em)a</B>, fearful, apprehensive, nervous, tim-id-orous. <I>~a krio</I>, cry of fear. <B>~emo</B>, faint-heartedness, pusillanimity, timidity. <I>~(em)ulo</I>, coward, poltroon. <B>~ego</B>, abject f., fright, terror. <B>~igi</B>, affright, alarm, frighten, intimidate, scare. <I>~igilo</I>, bug-bear, scarecrow. <I>Ne~igebla</I>, dauntless, imperturbable. <I>Parol~igi</I>, browbeat. <B>~iĝi</B>, become afraid. <B>~inda</B>, formidable, <I>~eginda</I>, awesome, terrific. <B>Antaŭ~o</B>, apprehension, foreboding. <B>Ek~i</B>, be startled, take fright. <B>For~igi</B>, frighten away (off), repel. <I>~~iga</I>, forbidding, horrible, repellent. <B>Mal~i</B>, have courage, brave, dare, risk. <B>~~o</B>, boldness, daring, intrepidity, pluck, temerity. <B>Ne~igebla</B>, undaunted. <B>Sen~a</B>, fearless, bold, unconcerned, <I>~~eco</I>, coolness, composure, sang-froid. <I>Tro~~a</I>, rash. <B>Akvo~o</B> (<I>hidrofobio</I>). <B>Dio~a</B>, God-fearing, <B>Hom~a</B>, coy, shy, timid. <B>Tuŝo~a</B>, fragile, shivery, sore, tender. ➞ <I>aŭdac, kuraĝ, terur</I>. <B>Rim</B>.: The form <I>Mi timas, ke ne pluvu</I> (= I f. lest it rain) is a combination of <I>Mi timas, ke pluvos</I> and <I>Mi deziras, ke ne pluvu</I>. It is classical and Z., but liable to be misunderstood, so may well be avoided.", "0"],
["timiano", "timian-o", "[UV] Thyme (Thymus). <B>~o sovaĝa</B> (a. <I>serpilo</I>), wild t.", "0"],
["timolo", "timol-o", "(chem) thymol.", "0"],
["timono", "timon-o", "[UV] Shaft; beam (of plough); pole (of carriage); trail (of cannon). <I>~a paro</I>, pair of shafts.", "0"],
["Timoro", "Timor-o", "<B>Orienta T~o</B> TL.", "0"],
["timpano", "timpan-o", "<B>1</B> kettle-drum. <B>~isto</B>. <B>2</B> (anat) tympanum, ear-drum.", "0"],
["timuso", "timus-o", "thymus-gland, sweetbread.", "0"],
["tinamo", "tinam-o", "(orn) tinamou.", "0"],
["tindro", "tindr-o", "[OA] tinder, touch-wood.", "0"],
["tineo", "tine-o", "[UV] (clothes-)moth (<I>Tinea</I>) (Ps 39/11, Mt 6/19). ➞ <I>lepidopter</I>.", "0"],
["tingtang!", "ting-tang!", "(onom) ding-dong (4 FA 67/1, 70/2).", "0"],
["tinimkolo", "tinimkol-o", "(<I>turfalko</I>), kestrel (<I>Falco tinunculus</I>).", "0"],
["tinko", "tink-o", "[OA] (ich) tench (<I>Tinea</I>).", "0"],
["tinkturo", "tinktur-o", "[OA] Tinct/ure. <B>1</B> Dye, hue, stain. <B>~i</B>, d., colour, stain, tone, tint, tinge. <B>~a</B>, t-orial. <B>~ado</B>, d-ing. <B>~ejo</B>, d-works. <B>~isto</B>, d-er. <B>2</B> (pharm) = <I>tintur</I>.", "0"],
["tino", "tin-o", "Tub, tank, tun, vat (J1 3/13). <I>Lav~o</I>, wash-tub. <B>~eto</B>, firkin, wooden bucket. <I>Inka ~eto</I> (4 FA 134/18). <B>~isto</B>, cellar-man, wet cooper. <I>[Ne= lad, stan, tinus]</I>.", "0"],
["tinti", "tint-i", "[UV] (nt) Tinkl/e, chink, clink, (bells, glasses); jingle (coins, keys); rattle (windowpanes). <I>Ŝi povas iom ~i</I> (strum a little) <I>per gitaro; sur piano</I>. <B>~a</B>, tinkling, silver-toned, <B>~ado</B>, -ing, tintin-nabulation. <I>~ado de armiloj. Klak~i, krak~i,</I> clash, jingle, etc. <B>~igi</B> (<I>-n</I>), chink, jingle (<I>glasojn, ŝlosilojn</I>). <B>~ilo</B>, small bell.", "0"],
["tinturo", "tintur-o", "(a. <I>tinkturo</I>), (pharm) tincture, essence, solution in alcohol. <B>~o joda</B> (<B>kinina</B>), t. of iodine (quinine).", "0"],
["tinuso", "tinus-o", "(ich) tunny (Thynnus).", "0"],
["tio", "", "[UV] (pron) that (thing) (affair, object), it. De kie ~ venis? Where did that come from? Kion vi promesis, ~n plenumu. Cu ~ estas vi? ~ (tiu bruo) estas hundoj, kiuj bojas. Poste venis nigra hundo; ~ (ĝi) estis … ~ (tiu listo) estas la filoj de Jehuda (No. 26/22 …). <B>~</B> (kion mi ĵus diris) estas miaj pensoj. <B>Ĉi ~</B>, this thing. ➞ <I>tiu</I>.", "0"],
["tiom (da)", "", "[UV] (adv) (tiu kvanto), that amount (number, quantity), so many (much). <B>~</B> estis la jaroj de Sara (Ge 23/1). Ne estis necese fari al mi ~ da lecionoj, kaj ~ skandaliĝi (GD 15/24). Kiom da kapoj, ~ da opinioj. Ĝia longo estas kiom la largo (Ap 21/16). Li ~ drinkis, ke li ebriiĝis. ~ (des) pli bone, so much the better. <B>~</B> pli, ke (car), all (so much) the more that, especially as. <B>~</B> (so far, to that extent) mi konsentas. <B>~a</B>, of so much (great). <B>Ho</B>, <B>~e!</B> (col, pleon) Oh! ever so much! (Aline 15). <B>~aj</B> (tiel multaj), of so many, such a number of. ➞ <I>kiom, tia, tiel</I>.", "0"],
["tipo", "tip-o", "[OA] Typ/e, character, specimen, (thl) symbol (Ro 5/14). <I>~o de aglutina lingvo</I>. (col) <I>Li estas vera ~o</I> (quite a character). <B>(laŭ)~a</B>, -ical, to t. <B>~a</B> <I>Franco. Vizaĝo</I> <B><I>~e</I></B> <I>Itala</I>. (typ) (<I>preslitero</I>). <B>~aro</B>, fount. <B>~fandisto</B>, t-founder, <B>Laŭ~igi</B>, standardize. <B>Pra~o</B> (<I>prototipo</I>), proto-t. ➞ <I>emblem, figur, model, norm</I>.", "0"],
["tipofono", "tipofon-o", "(m.i.) dulcitone.", "0"],
["tipografio", "tipograf/io", "[OA] Typograph/y. <B>~(ist)o</B>, printer, <B>~ia</B>, -ical.", "0"],
["tipolo", "tipol-o", "(<I>longkrurulo</I>), daddy-long-legs, crane-fly (<I>Tipula</I>). <B>~a</B> <I>larvo</I>, leather- jacket.", "0"],
["tiraljoro", "tiraljor-o", "sharp-shooter, skirmisher.", "0"],
["tirano", "tiran-o", "[OA] Tyran/t. <B>1</B> of Gk history. <B>2</B> ruler or person. <B>~a</B>, -nical. <I>~a ordono, povo</I>. <B><I>~</I>i</B>, tyrannize, rule with a rod of iron, <B>~eto</B>, petty t., bully. <I>~eti</I>, hector, -icido, -nicide. <B>3</B> <B>~(bird)o</B>, t-bird (-flycatcher). (<I>Tyrannus</I>).", "0"],
["tiraviro", "tiravir-o", "(mar) parbuckle, rope for raising or lowering objs. <B>~i</B> <I>barelon</I>.", "0"],
["tiri", "tir-i", "[UV] Draw, Pull: <I>~i kurtenon, manikon; harojn, ŝnurojn. ~i iun el la lito. Fiŝo ne iras, sed hoko ĝin ~as</I>. (vn) ~«/ = down- bow. <B>f</B> (<I>logi): Tio min ~is al ŝi. Ili provis ~i min en la disputon</I>. <B>2</B> drag, haul, tow: <I>~i sledon. Ĉevalo ~as plugilon</I>, <B>3</B> (<I>ĉerpi</I>): get (out of), obtain. <I>~i instruon, konkludon, utilon el io; profiton (lecionon) el la sperto</I>.< <B>4</B> lengthen, eke (spin, stretch) out: <I>~i draton</I>. <B>~o</B>, pull (org) <B>~a</B> <I>mekanismo,</I> tracker action. <B>~ado</B>, draught, haulage, traction. <B>~ata</B>, drawling (<I>voĉo</I>); shambling, slouching (<I>paŝado</I>). <B>~egi</B>, heave, tug. <B>~ilo</B>, bell-pull, door-handle, etc. <B>Bot~ilo</B>, <B>Ŝu~ilo</B>, boot-jack. <B>Buton~ilo</B>, button-hook. <B>Dent~ilo</B>, forceps. <B>Kork~ilo</B>, corkscrew. <B>Najl~ilo</B>, nail-claw. <B>Al~i</B>, attract. ~~i <I>atenton. ~~a muskolo</I>, adductor. <I>~~iĝi</I>, be d-n to. <B>Ek~i</B>, jerk, (mot) pick up. <B>El~i</B>, draw (pull) out, extract. ~i <I>konfeson, promeson, sangon, sekreton; larmojn el la okuloj; oron el la tero</I>. <B>En~i</B>, d. in, furl. <B>For~i</B> (<B>De~i</B>), draw (pull) away, with-d. <I>~~i la botojn. ~~a muskolo</I>, abductor. <B>kun~i</B>, [UV] draw together, astringe, contract, tighten, knit (brows). <B>Re~i</B>, draw back, recall, with-draw. ~~i <I>manon, vorton. Sin ~~i de</I>, cry off. <I>~~iĝi,</I> retire, step back. <B>Supren~i</B>, draw (p.) up, raise. <B>Sur~i</B>, d. (p.) on. ~ <I>~ ganton, boton</I>. ➞ <I>tren</I>.", "0"],
["tirojdo", "tirojd-o", "<B>~a</B>, thyroid. <I>~a glando</I>.", "0"],
["titanio", "titan-io", "(chem) Titan/ium (Ti) (combining form <I>titan-</I>). <B>~ato</B>, <B>~ika</B>, <B>~oza</B>.", "0"],
["titano", "titan-o", "[OA]<B></B>, (myth) Titan. <B>~a</B>, -ic, colossal, superhuman, vast. <B>➞ kolos</B>.", "0"],
["titolo", "titol-o", "[UV] Title, designate, heading, name. <B>1</B> official: <I>Havi la ~on prezidento, princo. ~o sen mono, sensignifa sono</I>. <B>2</B> of article, book, etc. <B>3</B> claim to merit, ownership, etc., deed, diploma: <I>Skribu viajn ~ojn</I>. <B>~i</B>, call, designate, name, (en)title, style. <I>Ne ~u min \"Majstro</I>\". <B>~a</B>, of title, brevet, honorary, nominal, titular. <B>~uloj</B>, people of title. ➞ <I>epitet, honor, nom, rubrik</I>.", "0"],
["titro", "titr-o", "(chem) Titr/e, strength of solution (alloy). <B>~i</B> titrate, assay, standardize.", "0"],
["tiu", "", "[UV] <B>1</B> (pron), That one (thing or person), the one (he, she, it) over there. <I>Provu ~n (~jn</I>), try that (those). <I>Kiu vivos, ~ vidos. Kiu rompis, ~ pagu. Mi estas kiu parolis al vi hieraŭ</I>. <B>2</B> (adj) That (particular, individual). <I>Mi ne konas ~n homon</I> (that man); <I>~ujn homojn</I>, those men. Ĉi tiu, this (one). ~<I>~ au alia</I>, this or that. Ĉi tiuj, these,", "0"],
["tizano", "tizan-o", "decoction, infusion. <I>Kamomila ~o,</I> camomile tea.", "0"],
["tju!", "", "boo! shoo! Fortimigi lupon per forta ~.", "0"],
["tlaspo", "tlasp-o", "(<I>monherbo</I>), penny-cress (<I>Thlaspi</I>).", "0"],
["tmezo", "tmez-o", "(rh) tmesis, insertion of another word in middle of a compound word (e.g.) to us ward, what things soever.", "0"],
["To", "T-o", "[F], letter T. <B>T-anteno</B>, <B>~-fero</B>, <B>~-peco</B>, <B>~-relo</B>, T-aerial, -iron, etc. T-ortilo, T-square, (av) <B>T-montrilo</B>, landing-T.", "0"],
["toasto", "toast-o", "(<I>rostita pano</I>), toast. <I>Fromaĝita ~o</I>, Welsh rabbit. <B>~rako</B>. ➞ <I>tost</I>.", "0"],
["tobogano", "tobogan-o", "toboggan.", "0"],
["tofo", "tof-o", "tuff, tufa, tophus (stone deposit, chalky sub-soil).", "0"],
["togo", "tog-o", "[OA] toga. Roman flowing robe over whole body except right arm.", "0"],
["Togolando", "Togoland-o", "TG.", "0"],
["tokato", "tokat-o", "(mus) toccata.", "0"],
["toksa", "toks-a", "Tox/ic. <B>~i</B>, affect by poison or -in. <B>~iĝo</B>, -aemia. <B>~ologio</B>, -ology.", "0"],
["toksino", "toksin-o", "toxin.", "0"],
["toleri", "toler-i", "(<I>-n</I>), [UV] Toler/ate. <B>1</B> bear, endure, suffer (<I>varmon</I>, etc.). <I>Mi ne povas ~i</I> (I can’t bear, endure, stand) <I>tion</I>. (med) <I>~i drogon</I>. <B>2</B> allow, abide, brook, excuse, overlook, pass over, put up with, wink at. <I>~i kapricon. ~u, ke mi parolu</I>. <B>f</B> <I>Tiu regulo ne ~as escepton</I>. <B>~(ad)o</B>, -ation, patience, forbearance. <I>Longe ~a</I>, long-suffering. <B>~ebla</B>, tolerable, not so very (too) bad, venial. <B>Ne~ebla</B>, intolerable. <B>~ema</B>, tolerant, broad-minded, compliant, easy-going. <I>Ne~ema</I>, intolerant. ➞ <I>elport, las, permes, sufer</I>.", "0"],
["tolo", "tol-o", "[UV] (tex) Linen (Cloth), sheeting. <I>Pala, kiel ~o</I>, white as a sheet. <B>Ĉemiz~o</B>, shirting. <I>Delikata ~o</I> (Se 31/22). <B>Drata ~o</B>, wire gauze. <B>Flag~o</B>, bunting. <B>Gum~o</B>, buckram. <B>Katuna ~o</B> (<I>kalikoto</I>), calico. <B>Lak~o</B>, <B>vaks~o</B>, [UV] oil-cloth. <B>Pak~o</B>, pack-c. <B>Pentrista (vela) ~o</B>, canvas. <B>Sak~o</B>, sack-cloth. <B>~a</B>, (of) 1. <I>~a antaŭtuko. ~a bindo</I>, c-binding. <B>~aĵo</B>, [UV] linen-goods, washing. <B>Brust~aĵo</B>, <B>(men) shirt-front;</B> (woman) modesty-vest, front-vest. <B>Dom~aĵo</B>, house-linen, napery. <B>Lit~aĵo</B>, bedding, sheeting. <B>Tabla ~aĵo</B>, table-linen. <B>Virina ~aĵo</B>, lingerie. <I>~aĵisto,</I> draper. ➞ <I>drap, lin, linoleum, tuk</I>.", "0"],
["tolueno", "toluen-o", "toluene.", "0"],
["toluo", "tolu-o", "Tolu. <B>~arbo</B>, t-tree (<I>Myroxylon). ~a balzamo</I>.", "0"],
["tomahoko", "tomahok-o", "tomahawk. ➞ <I>hakil</I>.", "0"],
["tomato", "tomat-o", "[OA] tomato (<I>Lycopersicum</I>). <B>~a</B> <I>saŭco</I>.", "0"],
["tombako", "tombak-o", "[UV] pinchbeck, tombac. Cu and Zn alloy for <B>~aĵo</B>, cheap jewellery.", "0"],
["tombo", "tomb-o", "[UV] Grave, Tomb, vault. <I>Familia ~o. La Sankta ~o</I>. <B>f</B> <I>havi unu piedon en la ~o</I>, be on the point of death, on the edge of (have one foot in) the grave. <B>~a</B> (sepulchral) <I>paleco, voĉo. ~a kavo (kripto</I>), vault. <I>~a ŝtono</I>, t-stone. <I>~a tolaĵo</I>, g-clothes. <B>~ejo</B>, [UV] g-yard, cemetery, necropolis. <I>Preĝeja ~ejo</I>, church-yard. <B>~isto</B>, g-digger. <B>~ujo</B>, <B>~loko</B>, sepulchre (Ge 23/6). <B>El~igi</B>, exhume. <B>En~igi</B>, en-t., bury, inter, lay in the g. (<I>enterigi</I>). <B>Sen~a</B>, unburied. <B>Sur~aĵo</B>, g-mound, barrow, tumulus (<I>tumulo</I>). <B>Trans~a</B>, beyond the g. ➞ <I>ter</I>.", "0"],
["tombolo", "tombol-o", "tombola, (charity) lottery, raffle. ➞ <I>loteri</I>.", "0"],
["tonalo", "tonal-o", "(mus) Key. <I>~o maj or a (minora).; proksima</I> (related, attendant); <I>relativa</I> (e.g., C. maj. kaj A min.); <I>samtonika</I> (e.g., A maj. kaj A min.). <B>~a</B>, tonal. <I>~a fugo = fugo kun ~a respondo</I> (opposite <I>reala</I>). <B>~eco</B>, tonality. <B>~signo</B> (<I>gamsigno</I>), k-signature. <B>Ne~a</B> (<I>sentonika</I>), atonal, in no key.", "0"],
["tondi", "tond-i", "(<I>-n</I>) [UV], Clip, Shear, snip. <I>~i barbon, drapon, heĝon; harojn. ~i ĉevalon, hundon, ŝafon. Por ŝafo ~ita Dio venton moderigas</I>. <B>~aĵo</B>, clipings. ~<B>ilo</B>, [UV] scissors, clippers, s-s. <B>Heĝ~ilo</B>, hedge c-per. <B>Meĉ~ilo</B>, snuffer. <B>Razen~ilo</B>, lawn-mower. <B>Ungo~ilo</B>, nail-scissors, <B>~isto</B>, s-er. <B>~fasono</B>, cut. <B>~maŝino</B>, s-ing machine. <B>De~i</B>, cut off. <B>El~i</B>, cut out (wide sense). <B>Pri~i</B> (<I>arbon</I>), prune. <I>~~ilo</I>, secateurs. ➞ <I>stuc</I>.", "0"],
["tondro", "tondr-o", "[UV] Thunder. <I>Fulm~o</I>, t. and lightning, t-storm. <B>f</B> <I>kvazaŭ frapita de ~o,</I> t-struck. ~o <I>de aplaŭdo, ~a aplaŭdado</I>. ~as, it is t-ing. <B>~i</B>, boom, reverberate, roar (<I>kanono, tamburo</I>). <B>f</B> <I>~i kontraŭ</I>, inveigh against. <I>~is kolera voĉo</I>. <B>~eca</B>, <B>~era</B>, -y. <B>~ado</B>, rolling, ‘etc. (of t., drum). <B>Ek~o</B>, clap, peal, of t.", "0"],
["tonelo", "tonel-o", "(mar) measure of capacity, unit of registered tonnage, space of 100 cubic feet (2.83 m<SUP>3</SUP>.) <B>Frajta ~o</B>, 40 cubic feet (1,44 m<SUP>3</SUP>). <B>~aro</B>, -nage (weight). <I>~aro kruda</I> (gross), <I>neta</I> (net). ➞ <I>tun, volumen</I>.", "0"],
["Tongo", "Tong-o", "TO.", "0"],
["toniko", "tonik-o", "(<I>gamnoto</I>), Tonic, key-note. <B>~a</B>, t. <I>~a do (solfao</I>), Tonic Sol-fa. <B>Sen~a</B> (<I>netonala</I>), atonal. <B>Super~o</B>, super-t.", "0"],
["tono", "ton-o", "[UV] Tone. <B>1</B> (= <I>sono</I>), sound, \"note\" heard: <I>~o simpla (pura), malsimpla</I>. <B>2</B> intonation, modulation, of voice: <I>~o amika, aŭtoritata, kolera. Paroli kun ~o de riproĉo. ŝanĝi la ~on</I>, change one’s tune, sing another song. <I>Naza ~o</I>, nazal twang. <B>3</B> prevailing char: <I>La ~o de la dramo (diskuto) estis gaja. Doni la ~on,</I> set the tone. <I>Bon~o</I>, breeding, good form (manners), etiquette of good society. <I>~~a</I>, elegant, refined. <B>4</B> (art, phot) (<I>kolor~o</I>), gen. effect (of colour, light and shade): hue, nuance, tinge, tint. <I>Varmaj ~oj</I>. ~igi (phot) tone. <I>~iga bano</I>, toning bath. <B>5</B> (med) -icity, healthy elasticity of muscles. <I>~igi</I>, t. (brace) up, invigorate. (phot) <B>Duon~o</B>, half-t. <B>6</B> (ac) <B>Krom~o</B>, &gt; over-t, harmonic, partial. <B>Sub~o</B>, differential. <B>Sum~o</B>, summation tone. <B>Super~o</B> (<I>harmono</I>), harmonic, upper partial. <B>Sen~a</B>, toneless. <B>Unu~a</B> (<I>monotona</I>), monotonous. <I>~~a rakonto, stilo, voĉo</I>. <B>7</B> (mus intvl) Tone, major second <I>= (plen)duto</I>. Duon~o, kvaron~o, tri~o, semi-(quarter-tri-)t. <B>Rim</B>.: These terms are international. But as <I>ton</I> has many meanings, the use of <I>dut</I> (which see) seems preferable here. ➞ <I>harmon, interval, not, nuanc, piĉ, son(er), tonal, tonik</I>.", "0"],
["tonsilo", "tonsil-o", "Tonsil. <B>~ito</B>, -itis.", "0"],
["tonsuro", "tonsur-o", "[OA] -i, Tonsure. <B>~a</B>, -ed, shaven (as a priest),", "0"],
["topazo", "topaz-o", "[UV] topaz, aluminium silicate (Ij 28/19).", "0"],
["topinamburo", "topinambur-o", "= terpiro, Jerusalem artichoke. ➞ <I>pir, heliant</I>.", "0"],
["topo", "top-o", "(mar) Top. <B>~masto</B>, <B>~velo</B>, top-mast, top-sail.", "0"],
["topografo", "topograf-o", "[OA] <B>~io</B>, [OA] topograph-er, -y. <B>~ia</B>, -ical.", "0"],
["torako", "torak-o", "thorax, chest.", "0"],
["torĉo", "torĉ-o", "[UV] Torch, link. <I>~o elektra</I>. (av) ~o <I>alteriga</I>, landing-flare, <B>f</B> <I>~o de religio, scienco</I>. <B>~(lum)a</B> (t-light) <I>procesio</I>. <B>~isto</B>, t-bearer, link-boy. <B>~ujo</B>, t-holder.", "0"],
["tordi", "tord-i", "(<I>-n</I>) [UV], Twist, ~i <I>brakon, draton, piedon, vizaĝon, la lipharojn:</I> wring, <I>kolon, tukon, manojn, vestojn</I>. <B>~(it)a</B>, -ed, buckled, contorted, distorted, wry. <I>Arbo ~ita de vento</I>. <B>~o</B>, twist, sprain. <I>Kol~o</I>, crick in the neck, <B>~ado</B>, <B>~eco</B>, torsion. <B>~aĵo</B>, t., coil. <B>~eca</B>, devious, circuituous, tortuous. <B>~ilo</B>, garrot, tightener, wringer, etc. <B>~iĝi</B> (<I>sin ~i</I>), become t-ed (convulsed), squirm, wriggle, writhe. <I>~iĝema</I>, wriggly. <B>El~i</B>, extort, squeeze out. <B>For~i</B>, wrench (wring) off. <I>~~i la kolon de birdo</I>. <B>Kun~i</B> (coil) <I>la harojn</I>. <B>Mal~i</B>, un-t, disentangle, unravel. <B>Lang~ilo</B>, tongue-twister. <B>Prem~i</B> (<I>~elpremi</I>), mangle, squeeze, wring out (1 FA 149/28). <B>Streĉ~i</B>, wind up (2 FA 28/13). <B>~premilo</B>, tourniquet. ➞ <I>elprem, plekt, streĉ, volv</I>.", "0"],
["toreadoro", "toreador-o", "[OA], toreador, mounted bull-fighter.", "0"],
["torento", "torent-o", "[OA] Torrent, swift rushing stream. <I>~o da pluvo. Akvaj ~oj</I> (Ps 1/3). <B>f</B> violent flow. <I>~o da larmoj, riproĉoj, vortoj</I>. <B>~(ec)a</B>, -ial. <I>~a pluvo. Pluvi</I> <B>~e</B>, rain in torrents (buckets, sheets), cats and dogs. <B>~eco</B>, impetuousity. <B>~ego</B>, deluge, down-pour. ➞ <I>lavang, uragan</I>.", "0"],
["torfo", "torf-o", "[UV] Peat, sod, turf. <I>Fosi ~on,</I> cut p. <B>~(ec)a</B>, -y. <I>~a grundo. ~a bulo,</I> slab or block of p. <B>~ejo</B>, p-bog.", "0"],
["torilido", "torilid-o", "(bot) bur-(hedge-)parsley (<I>Torilis</I>).", "0"],
["torio", "tori-o", "(chem) thorium (Th).", "0"],
["tormentelo", "tormentel-o", "(bot) tormentil (<I>Potentilla erecta</I>).", "0"],
["tornado", "tornad-o", "(met) tornado, violent storm.", "0"],
["torni", "torn-i", "(<I>-n</I>), [UV] (carp) Turn (fashion, shape) in a lathe. <I>Argilon, eburon, lignon, metalon. ~i poton, vazon</I>. <B>f</B> ~i <I>belsonan frazon</I>. <B>~aĵo</B>, -ings, -ed work. <B>~ejo</B>, -ery. <B>~ilo</B>, lathe. <I>Sraŭb~ilo</I>, screw-cutting lathe. <B>~isto</B>, -er. ➞ <I>turn</I>.", "0"],
["tornistro", "tornistr-o", "[UV] haversack, knapsack. <B>~eto</B>, satchel, wallet.", "0"],
["torpedo", "torped-o", "[OA] <B>1</B> (mil) Torpedo. ~a <I>ŝipo,</I> t-boat. <B>2</B> (ich) (<I>elektra rajo), (sku-rajo</I>), electric ray t.", "0"],
["torpora", "torpor-a", "Torp/id, without power of motion or feeling. <B>f</B> apathetic, benumbed, dormant, inactive, sluggish. <B>~(ec)o</B>, -idity. <B>~igi</B>, benumb, -ify. ➞ <I>letargi, sensenc, stupor</I>.", "0"],
["torso", "tors-o", "[OA] (anat) torso, trunk. <I>Nur la ~o restis</I> (1 Sa 5/4).", "0"],
["torto", "tort-o", "[UV] (cul) <B>1</B> (covered, puff, raised) fruit pie, tart. <I>~o ĉeriza, poma</I>. <B>2</B> flat pastry with jam, jam tart. <B>~eto</B>, tartlet. <B>~ujo</B>, baking-tin, pie-dish. ➞ <I>pasteĉ</I>.", "0"],
["tortriko", "tortrik-o", "leaf-roller moth (<I>Tortrix</I>).", "0"],
["torturi", "tortur-i", "(<I>-n) (turmentegi</I>), Tortur/e, e.g., (to produce confession); inflict severe pain. <B>~o</B>, t. <I>~o fizika, morala</I>. <B>~ejo</B>, t-chamber. <B>~ilo</B>, e.g., rack.", "0"],
["tosti", "tost-i", "[OA] Toast, propose (drink to) the health (success) of. <B>~o</B>, t. <I>Respondi al ~o</I>. <B>Rim</B>.: In Z’s Russian and German dictionaries, and his own writings, Z. used <I>toast-i</I>. But in a reprint, by an obvious printer’s error, the \"a\" fell out. Now <I>tost-i</I> is official. ➞ <I>toast</I>.", "0"],
["totala", "total-a", "(<I>ĉioma</I>), Total. <I>~a eklipso. ~a milito</I>. <B>~ismo</B>, -itarianism. <I>~isma reĝimo</I>.", "0"],
["totano", "totan-o", "(orn) (<I>ruĝkrurulo</I>), redshank (<I>Tritiga totanus) &lt; tringo</I>.", "0"],
["totemo", "totem-o", "Totem. ~ismo, -ism.", "0"],
["tra", "", "[UV] (prep), through. <B>1</B> from one end to the other: <B>~</B> la ventego lia voĉo ne aŭdiĝis. Serĉi <B>~</B> (all over) la urbo. <B>2</B> through and past: Pelu mizeron ~ la pordo, ĝi revenos ~ la fenestro. ~ unu orelo ĝi eniras, ~ la dua ĝi eliras. <B>Rim</B>.: The accusative is sometimes used for greater precision. Brili ~ kurtenon; pasi ~ urbon; salti ~ fenestron. <B>3</B> (dum) during. Mi dormis ~ la tuta nokto. <B>~a (~e)</B>, thorough(ly). PFX: <B>~bori</B>, <B>~dormi</B>, <B>~guti</B>, <B>~legi</B>, <B>~vivi</B>, etc. ➞ <I>al, per, trans</I>.", "0"],
["trabo", "trab-o", "[UV] Beam, Girder, Joist (Mt 7/3, Alt 1/17). <I>Prenu ĉiu po unu</I> ~o (2 Rĝ 6/2). <B>Apog~o</B>, prop, shore, stay. <B>Ĉef~o</B>, main g. <B>Flanka ~o</B>, side-g. <B>Krad~o</B> (<B>Trus~o</B>), trussed g. <B>Lig~o</B> (<B>Tir~o</B>), binding-joist, tie beam. <B>Ligna ~o</B>, wooden b. (ry) <B>Rel~o</B> (<I>ŝpalo</I>), sleeper. <B>Rul~o</B> (1 Sa 17/7). <B>Sub~o</B>, bearer, bridging j. <B>Tegola ~o</B>, rafter. <B>Trans~o</B>, cross-bar, tie, transom, traverse-beam. <B>~aĵo</B>, <B>~aro</B>, frame-work, timber-work, scaffolding, etc. <B>~eto</B>, tie. <B>~izi</B> (timber) <I>minon, muron, panelon</I>. ➞ <I>ĉevron, ŝtip, tabul, trus</I>.", "0"],
["tradicio", "tradici-o", "[OA] Tradition. <B>~a</B>, -al. <I>~a festo, instruo, kutimo, melodio</I>. <B>~ismo</B>, <B>~isto</B>, -alism, -alist. <B>~aro</B>, body of t.", "0"],
["trado", "trad-o", "(met) trade (wind). ➞ <I>muson</I>.", "0"],
["traduki", "traduk-i", "(<I>-n</I>), [UV] Translat/e. <I>~i estas malfacile. ~i el unu lingvo en alian. ~i Esperanten (en Esperanton) (= Esp-igi</I>). <B>f</B> interpret, realize. ~i <I>teorion en praktikon</I>. <B>~(ad)o</B>, <B>~(art)o</B>, -ion. <B>~(aĵ)o</B>, -ion, rendering, version. <I>Esperanta ~o de Hamleto</I>. <B>~anto</B>, <B>~isto</B>, -or. <B>Mis~i</B>, mis-t. <B>Ne~ebla</B>, un-able.", "0"],
["trafi", "traf-i", "(<I>-n</I>) [UV], <B>1</B> Hit the goal (mark), attain (reach) one’s aim, strike home. <I>Homo pafas, Dio ~as. ~i du birdojn per unu ŝtono. ~i</I> (catch) <I>la poŝton, vagonaron. Se fajro ~os</I> (catch in) <I>dornojn</I> (El 22/6). <B>f</B> befall, come (fall) upon. <I>La gripo. Kuglo. morto lin ~is. La mateno ~is ilin en Ĥebron (2</I> Sa 2/32). <I>Povus min ~i</I> (overtake) <I>malfeliĉo</I> (Ge 19/19). <I>~i laŭmerite</I>, serve (one) right. <B>2</B> contact, fall foul of, hit against, meet. <I>~i meblon kaj sin vundi. ~i per la vizaĝo en koton. ~i</I> (find one’s) <I>en la manojn de la polico; ~i en sablan trombon</I> (4 FA 29/33). <B>f</B> experience, <I>~i embarason, malfeliĉon, rezulton. ~i bonan akcepton</I>, meet with a good reception. <B>~o</B>, hit, good shot, home thrust. <I>~o blinda, okaza</I>, chance hit, fluke. <B>~a</B>, apposite, pat, pertinent, shrewd, telling, to the point. <I>~a argumento, respondo, rimarko</I>. <B>~e</B> <I>priskribi la situation. ~e-maltrafe</I>, hit or miss. <I>~e!</I> hear! hear! you’ve hit it! <B>~ebla</B>, within range. <B>~eco</B>, pertinence, <B>~ema</B> <I>pafisto</I> (K 72/28) <B>~ite!</B> a hit! (H 169/28). <B>~povo</B>, range. <B>Mal~i</B> (<I>fiaski, malsukcesi</I>), Miss, fail to hit the mark, fall flat, lose. <I>~~i la okazon, vagonaron. ~~o</I>, m., wide. <B><I>Ne~~ebla</I></B>, inevitable, certain to be hit. <I>~~igi</I>, baulk, cause to m. ➞ <I>ating, fat, frap, renkont, tuŝ</I>.", "0"],
["trafiko", "trafik-o", "<I>[OA]</I>, traffic. <B>~o</B> <I>fervoja, havena, strata, turista</I>.", "0"],
["tragakanto", "tragakant-o", "(bot) tragacanth (<I>Tragacanthus). ~a gumo</I>. ➞ <I>astragal</I>.", "0"],
["tragedio", "tragedi-o", "[F], Traged/y. <B>1</B> (th) drama in prose or verse, with an unhappy ending. <B>2</B> calamity, sad event. <I>~o familia, nacia, persona</I>. <B>~a</B>, 1 of t., <B>2</B> tragic, calamitous, distressing, sad. <I>~a rolo, poeto, sceno, voĉo</I>.", "0"],
["tragelafo", "tragelaf-o", "(zoo) &gt; bushbuck, nyala, and kudu antelopes (<I>Tragelaphus</I>) (Rd 14/5).", "0"],
["tragika", "tragik-a", "[OA] (<I>= tragedia</I> 2), tragic.", "0"],
["tragikomedio", "tragikomedi-o", "[OA] tragicomedy, tragedy with happy ending.", "0"],
["tragolo", "tragol-o", "(zoo) mouse-deer, chevrotain (<I>Tragulus</I>).", "0"],
["tragopogo", "tragopog-o", "goat’s beard, Jack go to bed at noon, shepherd’s cloak. (<I>Tragopogon</I>). &gt; salsify (<I>T. porriforius</I>). ➞ <I>skorzoner</I>.", "0"],
["traĥeo", "traĥe-o", "[UV] (a. <I>keo</I>), trachea, wind-pipe.", "0"],
["trajektorio", "trajektori-o", "trajectory, path of comet, projectile, etc. (av) flight path.", "0"],
["trajno", "trajn-o", "(<I>trenaĵo</I>), Train, string, tow. <B>1</B> line, series, succession of objs one behind another: <I>~o da aviadiloj, boatoj, eventoj, kameloj, servantoj, venturiloj. ~o artileria</I>. (av) <I>~o glisila</I> glider t. <B>2</B> <I>fervoja ~o = vagonaro</I>.", "0"],
["trajto", "trajt-o", "[UV] Feature, characteristic, line, trait; liniament (<I>de vizaĝo). ~o de karaktero, situacio, de Angla vivo. La ĉefaj ~oj</I> (main out-lines) <I>de temo</I>. <B>Sever~a</B>, grave f-ed.", "0"],
["trakelio", "trakeli-o", "nettle-leaved bell-flower (<I>Campanula traehelium</I>).", "0"],
["trakeno", "traken-o", "(ich) Weever (<I>Traehinus</I>). <B>Vipura ~o</B>, lesser w., sting-fish.", "0"],
["trako", "trak-o", "(<I>relparo</I>), Track, line, permanent way, road. <I>Ĉefa ~o</I>, main line. <I>Flanka ~o,</I> siding. <I>~o libera, okupita</I>, empty (occupied) line. ~o <I>duobla, simpla</I>, double (single) track. <I>~o al-(de-)ĉefurba</I>, up (down) line. <I>~o etŝpura</I>, narrow-gauge track. <B>De~iĝi</B>, leave the rails. <I>Vojo</I> <B>du~a</B>, <B>unu~a</B>. <B>~forko</B>. <B>~krucaĵo</B>, scissor-crossg. -largo (<I>spuro</I>), gauge. -metado, plate-(t-)laying.", "0"],
["traktato", "traktat-o", "[OA] (<I>traktaĵo</I>), (pol) Treaty, agreement, compact. <I>~o inter du landoj. ~o de paco</I>, peace t. <I>Fari ~on</I>, conclude a t. ➞ <I>trakt</I>.", "0"],
["trakti", "trakt-i", "(<I>-n., pri</I>) [UV] <B>1</B> (<I>ion</I>), Treat of, deal with, describe, discuss, handle: <I>~i demandon, problemon, situacion, taskon, temon. ~i negocon</I>, negotiate, transact business, <I>~i diversmaniere, serioze, supraĵe</I>. <B>2</B> (<I>iun</I>), act (behave) towards, deal with. <I>~i malbone,</I> be unkind to, t. badly. <I>~i afable, frate, laŭmerite, perfide, kiel amiko. Li indignis, ke oni ~is lin tiel</I> (at being -ed so), (med) <I>~i malsanon, pacienton (kuraci</I>). <B>~o</B>, -ment. <B>~ado</B>, negotiates. <B>~aĵo</B>, t-ise (systematic composition). <I>~aĵo pri elektro, vegetarismo. Religia</I> <B><I>~aĵo</I></B>, tract. <B>Ek~i</B>, touch on. (mil) <I>ek~o</I>, parley. <B>Inter~o</B>, conference, discussion. <B>Pri~i</B>, deal with, set forth, unfold. <I>~~o</I>, full account, statement. ➞ <I>traktat</I>.", "0"],
["traktoro", "traktor-o", "(mec) tractor. <I>Haŭla ~o</I>.", "0"],
["tramo", "tram-o", "[OA] Tram. <B>1</B> (<I>survoja relo</I>), rail. <B>2</B> (<I>~veturilo</I>), tram(car). <I>~o kabla, trolea</I>. <B>~(vetur)i</B>, travel by t. <B>~eto</B>, (min) truck, <B>~isto</B>, t-driver. <B>~konduktor-o</B>, t-conductor. <B>~trako</B>, t-lines. <B>~vojo</B>, t-way.", "0"],
["trampli", "trampl-i", "= surtreti.", "0"],
["trampo", "tramp-o", "Tramp. <B>1</B> vagrant. t. the streets, be on the road, out of work. <B>2</B> (<I>mar</I>) t-ship, freight vessel on no regular line.", "0"],
["trampolino", "trampolin-o", "(sp) trampoline.", "0"],
["tranco", "tranc-o", "(ps) trance. <B>~i</B> (<I>esti en t.</I>). <B>Ek~i</B> (<I>entranciĝi</I>).", "0"],
["tranĉeo", "tranĉe-o", "(mil) (tech), trench, cutting, <I>~o fronta, komunika</I>.", "0"],
["tranĉi", "tranĉ-i", "(<I>-n</I>) [UV], Cut, cleave: <I>~i drapon, kukon, paperon</I>, carve (<I>viandon</I>), fell (<I>arbon</I>); pierce: <I>la krio ~is la aeron, silenton</I>. <B>~o</B>, cut(ting), c. (of coat). <B>~a</B>, -ting, piercing, piquant, trenchant. ~a <I>krio (parolo</I>); biting, bitter, nipping, sharp (<I>frosto, vento</I>). <B>~(aĵ)o</B>, rasher (<I>lardo</I>); slice (<I>pano</I>). <B>~egi</B>, slash. <B>~eti</B>, c. (s)lightly. <B>~ilo</B>, Knife. <B>Pajl~ilo</B>, chaffter. <B>Pan~ilo</B>, bread-slicer. <B>Paper~ilo</B>, <B>poŝ~ilo</B>, paper-knife, pocket-k. <B>Rul~ilo</B>, -ting wheel. <I>~ilaro,</I> c-lery. <I>~ilego</I>, carving-knife, cleaver, cut-lass. <I>~ileto</I>, pen-knife. <I>~ilakrigisto</I>, knife-grinder. <I>~ilfaristo</I>, -ler. <B>al~i</B> [UV] (<I>tajli</I>), (cl) cut out. <B>De~i</B>, curtail, deduct, reduce. <I>Dek fojojn mezuru, unu fojon ~~u</I>. <B>Dis~i</B>, c. up (in pieces). <B>El~i</B>, c. out. <B>~~o</B>, excision (med). <I>~~aĵo</I>, (paper) cutting. <B>En~o</B> (med) incision. <B>For~i</B>, amputate, cut away (off), intercept. a<I>rmeon, (gas-kap-komunik-retret-)on</I>. <B>Fuŝ~i</B>, cut about, gash, hack, mangle, mutilate. <B>Pri~i</B> (<I>pritondi</I>), prune. <I>~~i krucon</I> (1 FA 36/22), <I>flugilon</I>, (4 FA 56/27). <B>Tra~i</B>, cut through (<I>gorgon</I>), cross, intersect. <I>Lando ~~ita de kanaloj</I>. <B>Ambaŭ~a</B> (<B><I>glavo</I>)</B>, two-edged. <B>Bat~i (haketi)</B>, (cul) chop. ➞ <B><I>falĉ, gilotin, sekc, tond</I>.</B>", "0"],
["trankvila", "trankvil-a", "[UV] Tranquil, not agitated or disturbed, free from anything inimical to quietude, unruffled, untroubled. <I>~a humoro. ~a</I> (peaceful) <I>formo (morto). Estu ~a</I>, set your mind at ease (rest), <I>mi baldaŭ pagos. Konscienco ~a estas bona dormilo. Lasu lin ~a</I>, let him be. <B>2</B> free from commotion, quiet, still: <I>~a rivero,</I> placid river. <I>~a arbaro, lando, maro, surfaco, urbo, En ~a vetero ĉiu remas sendanĝere</I>. <B>~e</B>, calmly, composedly, quietly, in peace. <I>Dormi, labori, respondi</I> <B>~e</B>. <I>~e!</I> Quiet! Calm down! Steady on! <I>Ĉu ni ~e tion toleru?</I> <B>~(ec)o</B>, -ility, peacefulness, quiet. <I>Momento da ~o</I>. <B>~igi</B>, -lize, make easy, reassure, set at rest, soothe, still; quench (<I>soifon). ~~i animon, ĉagrenon, pacienton</I>. <B>~iĝi</B>, become calm, pull one’s together, quieten down. <I>Mia animo grade ~iĝis. ~iĝu pri tio</I>, make your mind easy as to that. <B>Mal~a</B>, agitated, anxious, apprehensive, disturbed, troubled, uneasy, unquiet. <I>~~a movo. Ho mia kor’! Ne batu ~~e! ~~o</I>, agitata, disquietude, trouble, worry. <I>~~iĝi</I>, get anxious (grow uneasy) about, fret (worry) over. <B>Re~iĝi</B>, recover one’s equanimity. ➞ <I>kalm, kviet, pac, silent</I>.", "0"],
["trans", "", "[UV] (prep), Over, across. <I>Stari ~ la strato</I> (=on the other side). <I>Iri ~ la straton =</I> to the other side. <I>Belaj rakontoj el ~ la montoj</I>, pretty stories from o. the hills (traveller’s tales). <B>~a</B>, on the farther (other) side. <I>~a vivo</I> (Rj 114/28). <B>~e</B>, athwart. <I>~e de Jordano</I>, beyond J. (Ge 50/10). <I>De ~e,</I> from beyond. <B>~(ej)o</B>, (<I>~a mondo</I>), the beyond, world to come, etc. <B>~igi</B>, trans-fer (-mit-port). <B>~iĝi</B>, cross -o, to the other side. <B>~uloj</B>, people from o. the way. <B>PFX</B>: <B>Trans-=</B> trans-. <B>~alpa</B>, <B>~atlanta</B>, <B>~mara; ~figuro</B>, <B>~migro</B>, <B>~planto</B>, <B>~porto</B>, <B>~skribo ~iro</B>, <B>~veturo</B>, crossing, passage, transit. <I>~ira boato (pramo</I>), ferry. <I>~irejo</I>, crossing, ford. <B>~monda</B>, ultramondane. <B>~ruĝa</B>, infra red. ~viola, ultraviolet. ➞ <I>form, post, preter, super, tra</I>.", "0"],
["transakcio", "transakci-o", "(com) business done, deal, proceedings, transacts", "0"],
["transcenda", "transcend-a", "Transcend/ent, outstanding, pre-eminent, surpassing ordinary limits. <B>~i</B>, t., exceed. <I>~i ĉian rezonadon</I>. (mat, phil) <B>~a</B> -ental.", "0"],
["transepto", "transept-o", "[OA] (arch) transept,", "0"],
["transfuzi", "transfuz-i", "Transfus/e, e.g., <I>sangon</I>. <B>~o</B>, -ion.", "0"],
["transistoro", "transistor-o", "(el) transistor.", "0"],
["transitiva", "transitiv-a", "[OA] (gram) Transitive, <B>~igi</B>, make t. <B>Ne~a</B>, in-t.", "0"],
["transito", "transit-o", "[OA] (com) Transit, passage through a country without payment of duty. <I>~a komereo</I>. t-trade. <B>~e</B>, in t. (bond). <B>~tenejo</B>, bonded warehouse. <B>~varoj</B>, t-goods. <B>~vizo</B>. ➞ <I>trans-ir-pas</I>.", "0"],
["transmisii", "transmisi-i", "(mec) Transmi/t (communicate) energy from one machine to another. <B>~o</B>, -ssion, drive. <B>Ĉen~o</B>, chain -ssion. <B>~a</B>, of -ssion. <B>~ilo</B>, -ssion gear,", "0"],
["transmuti", "transmut-i", "(<I>-n</I>), Transmut/e, change form (nature, substance). <B>~o</B>, -ation.", "0"],
["transpiri", "transpir-i", "(bot) transpire, emit moisture, ooze.", "0"],
["transponi", "transpon-i", "(mus) = <I>ali-gam(-piĉ)igi</I>, Tran- spos/e (3 FA 120/29), put into another key. <B>~o</B>, -ition.", "0"],
["transversa", "transvers-a", "Transvers/al, -e, athwart, cross-, in crosswise direction. <I>~a linio, muskolo, trako. ~a strato</I>, side street (1 FA 136/7). <I>~aj strioj</I>. <B>~e</B> de, right across. <B>~i</B> (lie across) <I>la ĉambron, riveron</I>. ➞ <I>laŭlarĝ</I>.", "0"],
["trapezo", "trapez-o", "[OA] <B>1</B> (sp) Trapez/e. -isto, -ist. ~ojdo, -oid. <B>2</B> (geom) -ium.", "0"],
["trato", "trat-o", "(com) bill, draft. <B>~i</B>, Draw (a bill on), ~anto, -er. <B>~ato</B>, -ee. ➞ <I>ĝir, kambi</I>.", "0"],
["traumo", "traum-o", "(med, ps) Trauma. <B>~a</B>, -tic.", "0"],
["travertino", "travertin-o", "(min) travertine, crystalline limestone.", "0"],
["travestio", "travesti-o", "<B>~i</B>, travesty, gross parody, ridiculous imitation, misrepresentation. ➞. <I>burlesk, parodi</I>.", "0"],
["tre", "", "[UV] (altgrade, forte) (adv) very (much) strongly. <B>~</B> bela, grava. <B>~</B> multe, a great deal. Mi <B>~</B> (multe) timas, ke … <B>~</B> povus esti, it might well be. .. . <B>~</B> volonte mi lin aŭskultus, I should very much like to hear him. <B>~ege</B>, exceedingly, extremely. ➞ <I>eg, ekstrem, mult, tro</I>.", "0"],
["tredi", "tred-i", "(mec) thread (<I>entruigi</I>). ~i <I>fadenon, elaston, ŝnuron, k.s., tra kudrilon, tubon, bidojn, ringojn, k.s</I>. <B>~ik&gt;</B>, <B>bodkin</B>. (porku- drila) <B>~ileto</B>, needle-threader. ➞ <I>kudril</I>.", "0"],
["trefo", "tref-o", "[UV] (cgm) Club. <I>~a aso (damo</I>), ace (queen) of clubs.", "0"],
["trejni", "trejn-i", "Train, coach, drill, school, perfect by instruction and practice. <B>~i</B> kandidaton, orel-<I>rekrut-servant-soldat-)on</I>. <B>~ejo</B>, -ing centre (ground). <B>~isto</B>, -er, coach. <B>~ita</B>, -ed, experienceed, practised, seasoned. <I>~ita okulo</I>. ➞ <I>dres</I>.", "0"],
["tremao", "trema-o", "(typ) diaeresis (\").", "0"],
["trematodo", "trematod-o", "trematode &gt; flatworm, fluke, tapeworm, etc. (<I>Trematoda</I>).", "0"],
["tremi", "trem-i", "[UV] (nt) Trembl/e, quake, shake, shiver, flicker (<I>lumo</I>); simmer (<I>bolanto akvo). La tero ~is. ~i de malvarmo, timo, kiel folio, per la tuta korpo</I>. <B>~(ad)o</B>, -ing, tremor, (med) fremitus. <I>Ter~o (seismo</I>), earthquake. ~a <I>paralizo,</I> Parkinson’s disease. ~e (in singing) tremolo. <B>~ego</B>, trepidation. ~ema, tremulous. ~eti, flutter, palpitate, quiv-(shiv. wav-)er, wobble. <I>La flugil-(lum-voĉ-)o ~etis. La ~etanta brilo</I> (flickering glow) <I>de la flamo</I>. <B>~igi</B>, make t. (shiver), give the shivers to. <I>~igi la fenestrojn. ~iga</I> (fearsm, terrifying) <I>sperto</I>. <B>~ilo</B>, (el) vibrator (of coil), (org) tremulant, tremolo stop. <B>Ek~i</B>, (give a) start, shudder. <B>Tra~i</B>, be thrilled. <B>Frost~i</B>, have a cold fit (the shivers), shudder. ➞ <I>sku, ŝancel</I>.", "0"],
["tremolo", "tremol-o", "[UV] aspen (<I>Populus tremula</I>) &lt; poplo. Sxia mano iremis, kiel folio de ~o (<I>M 227/30</I>).", "0"],
["trempi", "tremp-i", "[UV] 1, dip, immerse, plunge: <I>~i panon en lakton; plumon en inkon; tukon en akvon</I>. <B>2</B> Soak, steep. <I>~ita de pluvo</I>, s-ed, drenched, wet to the skin, sodden (<I>tero). ~ita de ŝvito</I>, bathed in perspiration. <B>f</B> <I>~ita en antaŭjuĝoj</I>, steeped in prejudice, <B>3</B> harden, chill, temper (<I>metalori). ~ita ŝtalo</I>. ~e <I>moligi</I>, macerate. <B>~adi</B>, s., steep, <B>f</B> imbue, impregnate, permeate. <B>~iĝi</B>, be s-ed. ➞ <I>ban, enakvig, sorb</I>.", "0"],
["treni", "tren-i", "(<I>-n) [UV]</I> (<I>pene posttiri</I>), Drag, haul, pull, tow. <I><B>~i</B></I> ankron, aŭton, sakon, ŝipon. drawl (vortojn), d. on (out) (sian vivori). Sin ~i (~i la krurojn), d. one’s (crawl, shuffle, traipse) along, walk wearily. <I>Tago post tago ~e pasis</I>. <B>~ado</B>, haulage. <B>~aĵo</B> tail (<I>kometo</I>), trail (<I>fumo, limako, nubo</I>), <I>train (robo</I>). <B>~aĵportisto</B>, <I>train-bearer. ~iĝi, d. on, flag, slacken (aferoj, konversacio</I>). <I>➞ haul, tir</I>.", "0"],
["trepako", "trepak-o", "trepak (Russian dce).", "1"],
["trepano", "trepan-o", "Trepan, surgical crown-saw. ~i, t., perforate the skull. ~ado, -ning. ➞ dril.", "1"],
["tret~i", "", "Tread (Jes 63/2, 3; <B>2</B> FA 36/5). ~i en vinpremejo (Ij 24/11). ~i vinpremilon (Ne 13/15). Atentu, ke neniu ~u sur vin. Regiono ankoraŭ ne ~ita de homoj. <B>Sur~i</B>, t. (trample) on, crush under foot. ~~i iun, ies piedon. ➞ <I>trampl</I>. <B>f</B> Sur~u vian antaŭjuĝon. <B>~detrui</B> ĝardenon. <B>~makuli</B> plankon. <B>~platigi</B> ŝuon.", "0"],
["trezoro", "trezor-o", "[UV] Treasur/e, hoard, savings. Enterigita ~o. ~o trovita, t. trove. <B>Vort~o</B>, thesaurus, <B>f</B> something prized or loved, prize. Tiu verko estas por mi vera ~o. (someone) Si estas ~ol Mia ~o (darling), <B>~ejo</B>, -y. Ŝtata ~ejo, Exchequer, <B>-isto</B>, -er, paymaster. ➞ <I>kas</I>.", "0"],
["tri", "", "[UV] three. <B>Dek</B> 13. <B>-dek</B>, 30. <I>En la ~dekaj jaroj</I>, in one’s thirties (4 FA 128/36). <B>~a</B>, 3rd. <B>~o</B>, trio. ~foje, <B>3</B> times (repetition). ~obla, triple, 3-fold. <I>~oble</I>, <B>3</B> times (multiplication). <I>~obligi</I>, treble. ~ono, 1/3. <I>~onigi</I>, trisect. ~ope, <B>3</B> by 3, in 3’s. <I>~opo,</I> group of 3. <I>~opa</I>, 3-fold, 3-ply. <I>~opa kopiado</I> (in triplicate). <I>Fadeno ~opigita</I> (Pr 4/12). Ĉiu~jara, triennial. ➞ <I>pense, tercet, trifoli, viol</I>.", "0"],
["triado", "triad-o", "(kvintakordo), (mus) triad. ~o majora, (maksimum-minimum-)a.", "0"],
["triaso", "trias-o", "(geol) trias.", "0"],
["tribo", "trib-o", "Tribe. La dek du ~oj (Ge 49/28, Ja 1/1), La ~o de Jehuda. <B>~a</B>, tribal. <B>~ano</B>, -sman. <B>~estro</B>, ➞ <I>gent, klan</I>.", "0"],
["tribordo", "tribord-o", "= dekstra(verda) Sipflanko, starboard.", "0"],
["tribrako", "tribrak-o", "(pros) tribrach (<SUP>oou</SUP>).", "0"],
["tribunalo", "tribunal-o", "[OA] (<I>juĝejo, juĝistaro</I>), tribunal, bench (of judges), court (of justice, <B>f</B> judgment seat.", "0"],
["tribuno", "tribun-o", "[UV] tribune. <B>1</B> (Roman hist), <B>f</B> popular leader, demagogue. <B>2</B> (<I>podio</I>), speaker’s platform. ➞ <I>estrad</I>.", "0"],
["tributo", "tribut-o", "[OA] Tribut/e. <B>1</B> t-money. <B>2</B> mark of dependce or homage. <I>~o de admiro, respekto</I>. <B>~i</B>, pay t. (dues). <I>~u al la Eternulo honoron</I> (Ps 96/8). ~(dev)a, -ary. <I>~a regno</I>. ~ulo. ➞ <I>impost</I>.", "0"],
["tricepso", "triceps-o", "(anat) triceps.", "0"],
["triciklo", "tricikl-o", "tricycle. <I>Motor-t</I>.", "0"],
["tridakno", "tridakn-o", "(zoo) giant clam (<I>Tridacna</I>).", "0"],
["trielo", "triel-o", "(orn) stone-curlew (<I>Burhinus oedicnemus</I>) (G. <I>Triel</I>).", "0"],
["trifolio", "trifoli-o", "[UV] trefoil, clover, shamrock (<I>Irifolium</I>). ➞ <I>format, kling, lamen, plat, tavol</I>.", "0"],
["trifolio", "trifoli-o", "[UV] (bot) clover, trefoil (<I>Trifolium</I>).", "0"],
["triforio", "trifori-o", "(arch) triforium.", "0"],
["triglo", "trigl-o", "(ich) gurnard (<I>Trigla</I>) (various species). ➞ <B><I>gurnard</I></B>.", "0"],
["trigono", "trigon-o", "sting-ray (<I>Trygon</I>).", "0"],
["trigonometrio", "trigonometri-o", "[OA] trigonometry.", "0"],
["triki", "trik-i", "(<I>-n</I>), [UV] Knit. <I>inverse</I> (purl), <I>rekte</I> (plain). <B>~aĵo</B>, -ting. <B>~ilo</B>, -ting- needle. ~istino. ~maŝo, stitch. ~maŝino, -ting machine. Kun<B>~i</B>, k. together. Mal~i, unravel. <B>Kroĉ~i</B> (<I>kroĉeti</I>), crochet.", "0"],
["trikino", "trikin-o", "parasitic worm (<I>Trichina</I>).", "0"],
["trikolomo", "trikolom-o", "(<I>Tricholoma</I>) blewit toadstool.", "0"],
["trikoto", "trikot-o", "[UV] <B>1</B> (tex) knitted fabric, stockinet. <B>2</B> (<I>trikitaĵo</I>), cardigan, jersey, singlet, woolly jacket or undervest. <I>~a bluzo</I>, jersey blouse. <I>~a veŝto</I>, knitted waistcoat.", "0"],
["triktrako", "triktrak-o", "(gm) backgammon.", "0"],
["trili", "tril-i", "[UV] <B>1</B> (mus) trill, shake. 2 warble. <B><I>La</I> ~ado <I>de alaŭdoj</I></B>. (mus). <B>Ek~o (~eto)</B>, <B>(<I>mordento</I>)</B>.", "0"],
["trilio", "trili-o", "(bot) wood lily, wake-robin <B>(<I>Trillium</I>)</B>.", "0"],
["triliono", "trilion-o", "trillion (Eng-G=10<SUP>18</SUP>; Am-Fr = 10<SUP>12</SUP>).", "0"],
["trilobito", "trilobit-o", "(pal) trilobite.", "0"],
["trilogio", "trilogi-o", "(lit) trilogy.", "0"],
["trimestro", "trimestr-o", "quarter, term. <B>~e</B>, every t., quarterly. <I>~a gazeto</I>.", "0"],
["tringo", "tring-o", "(orn) Sandpiper (<I>Tringa</I>). ~o blankventra, common s.; griza, green- shank; grizkrura, green s; malhela, spotted redshank; tereka, terek-s; verdkrura, wood-s.", "0"],
["Trinidado kaj Tobago", "Trinidad-o kaj Tobag-o", "TT.", "0"],
["trinki", "trink-i", "(<I>-n</I>) [UV], Drink, imbibe, quaff. <I>~i el glaso, kiel fiŝo, pro ies sano (tosti). Donu al mi (ion por) ~i</I>, something to d. <B>f</B> (plants) absorb, soak in, suck up (water). ~o (<I>da</I>), d., draught. ~aĉi, guzzle. <B>~aĵo</B>, beverage, d. <I>~aĵo ebriiga, varmiga. ~a]ejo</I>, refreshment-room. ~ema, dry, thirsty. ~eti, (ek~i) nip, taste, sip. <B>~igi</B>, give d. to, water (<I>bestojn</I>). <I>Mi ~igos viajn kamelojn</I> (Ge 24/14). ~ujo, d-ing trough, horse-pool. <B>El~i</B>, d. up, drain, empty (finish) the cup. <I>~~i per unu gluto</I>, drain at a draught, swig (toss) off. <B>Lang~i</B>, <B>lek~i</B>, lap up. ➞ <I>drink, sorb</I>.", "0"],
["triodo", "triod-o", "(el) (<I>trielektroda lampo</I>), triodo.", "0"],
["trioleto", "triolet-o", "(pros) triolet.", "0"],
["triolo", "triol-o", "(mus) triplet.", "0"],
["tripango", "tripang-o", "trepang, beche de mer (<I>Holothuria edulis</I>).", "0"],
["triplikata", "triplikat-a", "Triplicate. <I>~a letero</I>. <B>~e</B>, in t.", "0"],
["tripo", "trip-o", "[UV] Tripe (for food), bowels, entrails. <B>~ejo</B>, t-stall. <B>Sen~igi</B>, gut <B>(<I>fiŝojn</I>). ~istino</B>, gut-girl. ➞ <B><I>ekfal</I></B>, <B><I>ekskurs</I>.</B>", "0"],
["tripso", "trips-o", "(ent) thrips. triptik-o, (arch) triptych,", "0"],
["trista", "trist-a", "= malgaja, melankolia.", "0"],
["tritiko", "tritik-o", "[UV] wheat (<I>Triticum</I>). <B>~a</B> <I>faruno, pano</I>.", "0"],
["trito", "trit-o", "<B>1</B> (myth) triton. <B>2</B> (mus) third (intvl). <B>Dek~o</B>, 13th. triteto (a. <I>terceto</I>), (mus) <I>trio</I>.", "0"],
["tritonio", "tritoni-o", "triton (sea slug) (<I>Tritonia</I>). ➞ <I>holoturi</I>.", "0"],
["trituro", "tritur-o", "(zoo) eft, newt (<I>Triturus</I>).", "0"],
["triumfo", "triumf-o", "[OA] Triumph, victory. La kampanjo rezultis en vera ~o. <B>~a</B>, -al, -ant, exultant. ~a kanto, krio, son-)o. t., carry the day, get the better of, master, overcome, prevail over, vanquish. ~i kontraŭ (super) ĉio.", "1"],
["triviala", "trivial-a", "[UV]. <B>1</B> Vulgar, base, common, coarse, gross, low, mean, ribald. <I>Homo ~a kaj malsobra. ~a krio (spritaĵo</I>). <B>~aĵo</B>, low jest. <B>~eco</B>, v-ity. <B>2</B> paltry, petty, trifling, trivial. <B>~ulo</B>, a nobody. 11 As internationally this root has various meanings, it is safer to use 1 <I>maldelikata, vulgaraĉa;</I> 2 <I>bagatela, negrava</I>. ➞ <I>vulgar</I>.", "0"],
["tro", "", "[UV] (adv), <B>1</B> Too. <I>~ grand-(long -malfacil-)a. ~ frua</I>, premature. <I>~ rapida,</I> precipitate. <I>~ sinfida</I>, headstrong, overweening. <I>La sono estis ~ malproksima, ke oni povu ĝin audi</I>, t. far off to be heard. ~ (multe) da, t. many (much), more than needed. <I>~ da libroj (mono). ~ da tempo</I>, time to spare. <I>~ da kuiristoj kaĉon difektas</I>. <B>2</B> (with vb): over(much), t. much, unduly. - (<I>multe) ami</I>, love t. well. <I>~ labori</I>, work t. hard, <I>~ paroli</I>, be t. talkative. <B>~a</B>, excessive. <I>~a festeno estas yeneno. ~a karto</I>, a card t. many. <B>~e</B>, to (in) excess. <I>Estas ja ~e!</I> It is really t. bad (a bit thick)! ~(aĵ)o, excess, superfluity, surfeit, surplus. ➞ <I>eksces</I>. <B>~igi</B>, exaggerate, overdo. <I>~igo</I>, exaggerate, hyperbole. Mal-igi, understate. <I>~igo (litoto). PFX</I> over-. -laborig(-pez-pro- dukt)i. -uzi, abuse. ➞ <I>preter, super, trans</I>.", "0"],
["trobadoro", "trobador-o", "(hist) troubadour.", "0"],
["trofeo", "trofe-o", "[OA] trophy, captured arms, spoil, or other evidence, memorial, or token of victory.", "0"],
["troglodito", "troglodit-o", "<B>1</B> troglodite, cave-dweller. <B>2</B> (orn) (Jenny) wren. (<I>Troglodytes</I>). ➞ <I>regol, silvi</I>.", "0"],
["trogo", "trog-o", "[UV] Trough (El 2/16), Bucket (of noria or waterwheel), (bricklayer’s) hod, scoop, skip (of dredger). <B>Erc~o</B>, (min) cradle, sluice-box. <B>Gudro~o</B>, tar-b. <B>Lav~o</B>, sink. <B>Manĝ~o</B>, feeding-t, <B>Stal~o</B>, manger (Lk 2/7), <B>-eto</B>, (bird) seed-tub. (bid) <B>~ĉeno</B>, b-chain. ➞ <I>kuv, ttori</I>.", "0"],
["trogono", "trogon-o", "(orn) trogon (<I>Trogon</I>).", "0"],
["trokaro", "trokar-o", "(suring. instrument) trocar.", "0"],
["trokeo", "troke-o", "(pros) Troch/ee. (-u). <B>~a</B>, -aic.", "0"],
["troko", "trok-o", "(zoo) top-shell (<I>Trochus</I>).", "0"],
["troleo", "trole-o", "<B>~a</B>, (el) trolley <I>~a buso, drato, rado, stango, tramo</I>.", "0"],
["trolio", "troli-o", "globe flower (<I>Trollius</I>).", "0"],
["trolo", "trol-o", "<B>1</B> (myth) troll. <B>2</B> (<I>skrap-reto</I>), drag-net, trawl. <I>~ŝipo</I>, trawler.", "0"],
["trombo", "tromb-o", "waterspout. <I>Polva ~o</I>, (met) dust devil. <I>Venta ~o</I>, whirlwind, <B>f</B> <I>En-(El-)iri</I> <B>~e</B>, burst (sweep) in, dash out. ➞ <I>kirl</I>.", "0"],
["trombono", "trombon-o", "[OA] Trombone. <I>~o bas-(tenor -valv-)a</I>. <B>~i</B>, play the t. ➞ <I>bastrumpet</I>. tromboz-o, (med) thrombosis, localized bloodclotting. ➞ <I>emboli</I>.", "0"],
["tromelo", "tromel-o", "(min) trommel, revolving screen.", "0"],
["trompi", "tromp-i", "(<I>-n</I>) [UV]. Dece/ive, <B>1</B> cheat, delude, dupe, gull, impose on, take in, victimize. ~i <I>aĉetanton, la publikon. ~i per belaj promesoj. La ŝajno ~as</I>, appearances are -itful. <B>2</B> disappoint, elude, frustrate. <I>~i esperon</I>, disappoint one’s hope. <I>Mia lasta espero min ~is</I>, has failed me (let me down). <B>3</B> betray, be unfaithful. <I>~i edz(in)on</I>. <B>~(aĵ)o</B>, -it. -ption, fraud, imposture, swindle; bluff, eye-wash, hanky-panky, window-dressing. <B>-a</B>. -ptive, disappointing, false, fraudulent, illusory. -anto, <B>-isto</B>, d-iver, cheat, double-dealer, impostor, sharper, trickster. <B>-ito</B>, dupe, victim, <B>~ema</B>, <B>-oplena</B>, -ptful, tricky, <B>-iĝi</B> (<I>esti -ita</I>), be -d, disappointed, led astray, mistaken, taken in. -logi, <B>~ilo</B>, bait, decoy, lure. <B>Ne-a</B>, <B>Sen~a</B>, genuine, sincere, sound. ➞ <I>fraŭd, fripon, kokr, perfid, ruz</I>.", "0"],
["trono", "tron-o", "[UV] Throne, <B>f</B> seat of sovereign power. <I>Meti iun sur la ~on</I>. <B>~i</B> (nt) sit enthroned, in state, <B>f</B> lord it. <I>La kastelo fiere ~is sur la alta roko</I>. <B>~ejo</B>, t-room. <B>-heredonto</B>, heir-apparent. De-igi, sen~igi, de-pose, (-t.). El~iĝi, abdicate. Sur~igi, (en)t. Sur~iĝi, ascend the t.", "0"],
["tropeolo", "tropeol-o", "\"nasturtium\", Indian cress (<I>Tropaeolum</I>). ~o kanaria, canary creeper (<I>T. peregrinum</I>). ➞ <I>kres</I>.", "0"],
["tropiko", "tropik-o", "[UV] tropic, <B>~a</B>, -al. ~a <I>klimato, lando, planto, suno, varmo</I>. ~a (torrid) <I>zono</I>.", "0"],
["tropo", "trop-o", "[OA] (<I>parolfiguro</I>), (rh) trope, figure of speech.", "0"],
["tropopaŭzo", "tropopaŭz-o", "(met) tropopause.", "0"],
["troposfero", "troposfer-o", "troposphere.", "0"],
["troti", "trot-i", "(nt), [UV] Trot, jog along. <I>La ĉevalo ~is sur la strato, la infano ~is apud la patro</I>. ~i <I>altpaŝe</I>, be a high-stepper. <I>~i hundosimile</I> (Rn 21/30). <B>~adi</B>, be on the go. <B>~eti</B> (child), toddle, <B>~ulo</B>, trotter. <B>Ek~i</B>, break into a trot. <B>For~i</B>, trot off. ➞ <I>ambl, skut</I>.", "0"],
["trotuaro", "trotuar-o", "pavement, foot-path (-way), side-walk, (ry) platform, <B>~a</B> <I>artisto. ~a bordo</I>, kerb. <B>Rul~o</B>, travelator, continuous moving platform. ➞ <I>pavim, rulŝtupar</I>.", "0"],
["trovi", "trov-i", "(<I>-n</I>), [UV] Find. <B>1</B> come across (upon), discover, fall in with, hit (light) upon: <I>~i amikon, trezoron. Kie vi ~is tion?</I> <B>2</B> meet with, obtain, receive: ~i a<I>kcepton, aprobon, atenton, helpon, plezuron, reziston</I>. <B>3</B> succeed in getting, obtaining: <I>~i kuraĝon, momenton, solvon, taksion, tempon</I>. <B>4</B> consider (deem, think) to be: <I>~i iun (ion) bela, bona, fidinda, honesta</I>. <I>Ĉu vi ~as konvena, necesa = ke estas konvene, necese, tion fari? Kiel vi ~as</I> (How do you like) <I>mian ĉapelon?</I> <B>5 Sin ~i</B>, find one’s (to be): <I>Li sin ~is en Parizo. Mi ~is min feliĉa, senamika</I>. ~aĵo, f., godsend, windfall. <B>~ebla</B>, to be found, <B>~ema</B>, ingenious, inventive, resourceful. <B>~iĝi</B>, be found, (met with, situated), exist, occur. <I>Ne ~iĝas serpentoj en Irlando. Trans la rivero ~iĝis</I> (were to be seen) <I>hirundoj</I>. <B>Ne ~iĝi</B>, be missing, not to be found. <B>~iĝi</B>, like <I>kuŝi, sidi, stari</I>, helps to avoid the monotony of a repeated <I>estas</I>. <B>~it(in)o</B>, foundling. <B>~itejo</B>, foundling hospital. <B>El~i</B>, f. out, discover, novan metodon. <B>El~oj</B> de seieneo. <B>Re~i</B>, find again, recover. ~~i <I>ringon, sanon, trankvilon</I>. <I>Perditan tempon oni ne povas ~~i</I>. <B>Bon~o</B>, choice, good pleasure. <I>Agu laŭ via bon~o</I> (as you think best). <I>Bone ~ita</I> (ekzemplo, ideo), apt, felicitous. ➞ <I>akir, konstat, opini, ricev; elpens, malkovr</I>.", "0"],
["trudi", "trud-i", "(<I>-n</I>), [UV] Intru/de, Obtru/de, foist, impose, thrust (up)on. <I>~i al iu kondiĉojn, opinion, tedan taskon. Ne ~u, kion devus mi rifuzi</I> (If 71/20). <B>Sin ~i</B> (<B>al~iĝi</B>, <B>en~iĝi</B>), intrude, encroach, force (thrust) one’s on, interfere, poke one’s nose in. <I>Sin ~i en societon. La demando sin ~is al mi</I> (was borne in on me). <I>Sin ~is al mi</I> (I was assailed, beset by) <I>duboj</I>. <B>~(ad)o</B>, i-sion, constraint, pressure. <B>~a</B>, <B>~(iĝ)ema</B>, importunate, insistent, obsessing,<SUP>!</SUP> pushing, troublesome, urgent. <I>~iĝema klientino</I> (M 74/2), <I>gasto, penso</I>. <B>Ne~ema</B>, unobtrusive. <B>Al~i</B>, impose (inflict) on, force to accept, press to take. <B>En~ulo</B>, intruder. <B>Prem~i</B>, exert pressune on (to attain one’s end).", "0"],
["trufo", "truf-o", "[UV] (bot) Truffle, <B>~i</B>, t., stuff with truffels. <B>~ejo</B>, t-bed.", "0"],
["truko", "truk-o", "Trick, knack. <I>Havi la ~on</I>. <B>~i</B>, get the hang (have the knack) of … ing. <I>La ~oj de la metio</I>, the tricks (dodges) of the trade, (th) stage device (effect). <I>Ŝerĉ~o,</I> conjuring trick. <B>~i</B>, <B>f</B> cook (account); fake (antique, experiment, photo); gerrymander (election). ➞ <I>artifik</I>.", "0"],
["trulo", "trul-o", "[UV] trowel, (mason’s) smoother. <B>~eto</B>, fish-slice, etc. ➞ <I>spatel</I>.", "0"],
["trumpeto", "trumpet-o", "[UV] <B>1</B> (m.i.) Trumpet. ~o natura (senvalva). ~o valva (kromata), valve t. ~o glita, slide t. Bas~o (<I>valv- trombono</I>). 2 similar object. <I>~o de floro</I>. Orel-o, Parol~o. blow the t. <B>~ado</B>, t-blast. <B>~isto</B>, -er. <B>f</B> Dis<B>~i</B>, t. abroad. <I>Oni ~is al la mondo, ke … </I> ➞ <I>korn</I>.", "0"],
["trunko", "trunk-o", "[UV] trunk (<I>de korpo, arbo,</I> etc.), bole, shaft (of column); stick (of candle). <I>Centra ~o</I>, (bid) crown -(king-) post, (hort) Baz~o (<I>grefta bazo</I>), parent (wild) stock, wilding. <B>~eto</B>, [UV] (<I>gren~o, spik~o</I>) (Ge 41/6), corn stalk, haulm. Dik<B>~a</B>, dumpy, squat, thick-set. Sen<B>~a</B>, stemless. ➞ <I>kofr, lign, rostr, tig, tors</I>.", "0"],
["truo", "tru-o", "[UV] Hole, break, breach, gap, opening. <I>~o en heĝo, muro, ŝtrumpo. ~o de fluto, kudrilo,seruro. Bori, fliki, plenigi, ŝtopi ~on</I>. <B>f</B> <I>Fari ~on en sia kapitalo</I>. <B>Aer~o</B>, (av) air-pocket. <B>Brak~o</B>, arm-hole. <B>Buton~o</B> (button-h). <I>maŝinkudrita</I> (worked), <I>pikita</I> (stabbed). <B>Cel~o</B>, sight-hole. <B>Elflua ~o</B>, vent. <B>Forn~o</B>, draught-hole. <B>Hom~o</B>, man-hole. <B>Laĉ~o</B>, lace-h. <B>Lubrika ~o</B>, oil-hole. <B>Naz~o</B>, nostril. <B>Paf~o</B> (<I>embrazuro</I>). <B>Son~o</B>, (vn) sound-hole. Vd (4 FA 69/33). <B>Ŝlosil~o</B>, key-h. <B>Spir~o</B>, blow-h, spiracle. <B>Vid~o</B>, peep-hole. <B>Voj~o</B>, pot-h. <B>~a</B>, in (full of) holes, leaking. <I>~aj platidoj</I> (K 117/9). <B>~i</B> (<I>-n</I>), make a hole in, punch, puncture. <I>Vesto</I> ~ita <I>de tineoj. ~ita ĉe la kubutoj</I>, out at elbows, <B>f ~aĉo</B>, dirty hole, hovel, pigsty. <B>~eto</B> (<I>poro</I>). <B>~eti</B>, <B>tra~i</B>, perforate. <I>~ita linio,</I> perforated line. <B>~iĝi</B>, wear into holes. <B>~ilo</B>, punch, perforator, ➞ <I>aĵur, apertur, bor, breĉ, fend, luk, perfor</I>.", "0"],
["trupo", "trup-o", "[OA] (mil) troop, band, company, team, (sctg) troop (30 scouts). ~estro, scout leader, (th) troupe. ➞ <I>ar, band, greg</I>.", "0"],
["truso", "trus-o", "(bid) truss (supporting structure or framework).", "0"],
["trusto", "trust-o", "[OA] (com) trust, combine, organized syndicate. ➞ <I>kartel, sindikat, (Ne=esper, fid</I>).", "0"],
["truto", "trut-o", "[UV] trout (<I>Salmo trutta</I>).", "0"],
["tsetseo", "", "= glosino.", "0"],
["ts!", "", "Hist! Here! (to call attention).", "0"],
["tualeto", "tualet-o", "[UV] Toilet, attire (make-up). <I>~o ceremoni-(elegant-simpl-)a</I>. ~a <I>tablo</I>. ~i (<I>fari sian ~on</I>), make one’s t., have a wash and brush-up, tidy one’s, titivate. ~aĵoj, articles of t. <B>~ejo</B>, dressing-room. ~ujo, dressing-case. ➞ <I>necesej</I>.", "0"],
["tuberkulo", "tuberkul-o", "[OA] (<I>tubereto</I>), (med) Tuberc/le. <B>~a</B>, -ulous. <B>~ino</B>, -uline. <B>~ozo</B>, [OA] -ulosis. ➞ <I>ftiz</I>.", "0"],
["tubero", "tuber-o", "[UV] Tuber. <B>1</B> Bulge, bump, protuberance, swelling. <B>2</B> joint, knot in grass stalk, (bot) <I>~o (tubera radiko</I>), e.g., <I>terpiro, terpomo</I>. <B>f</B> <I>Estas ~o en la afero,</I> there is a difficulty, things are not running smoothly. <B>Har~o</B>, bun, chignon. <B>Lig~o</B> (a. <I>knoto, nodo</I>), knot. <B>Seb~o</B>, wen. <B>Ŝvel~o</B>, boil, tumour. <B>~aĵo</B>, -osity, nodosity (<I>artrita</I>). <B>~eca</B>, knarled, knotty. <B>~eto</B>, small t. ➞ <I>bos, ĝib</I>.", "0"],
["tuberoso", "tuberos-o", "(bot) tuberose (Polianthes tuberosa), &lt; poliant.", "0"],
["tubjo", "tubj-o", "Tuba (any bass brass m.i. other than a trombone) &gt; basa sakskorno, suzafono. <B>Bas~o</B> = bombardono. <B>Tenora ~o</B>, ~~eŭfoniumo.", "0"],
["tubo", "tub-o", "[UV] <B>1</B> Tube, Pipe; flue; barrel (of gun); leg (of boot, trousers); stem (of pipe). ~o <I>de dentkremo. ~o plumba, vitra. Akvo~o, anĉ~o, blov~o, dren~o, orgen~o, pluv~o, stov~o, suĉ~o</I>, water-pipe, reed-, blow-, rain-, organ-, rain-, stove-, suction-pipe. <B>Gum~o</B>, rubber tube. <I>Fleksebla ~~o</I>, hose (<I>hoso</I>). <B>kamen~o</B>, [OA] chimney. <B>Krom~o</B>, <B>glit~o</B> (of m.i.), crook, shank. <B>Lamp~o</B>, lamp-glass. <B>Parol~o</B>, <B>son~o</B>, <B>voĉ~o</B>, speaking-tube. <B>Prov~o</B>, test-t. <B>Ren~o</B>, ureter. <B>Serpenta ~o</B>, worm (of piping, tubing) <B>2</B> Increasingly used for (rad) \"valve\". ➞ <I>valv</I>. <B>~(ar)a</B>, tubular. <I>~a poŝto</I>, pneumatic post. <B>~aro</B>, p-(t-)ing. <I>Varm~aro,</I> radiator. <B>~eto</B>, cannula, duct. <B>~isto</B>, plumber. <I>Gas~isto</I>, gas-fitter. <B>Du~a</B> (double-barrelled) <I>pafilo</I>. ➞ <I>pip</I>.", "0"],
["tufo", "tuf-o", "[UV] Tuft, plume, tussock; wisp (<I>Jojno, pajlo, lano</I>). <B>Har~o</B>, forelock, toupee, etc. <B>Plum~o</B>, tuft, crest. ➞ <I>egret, fask, garb, kvast, spik</I>.", "0"],
["tuj", "", "[UV] (adv) <B>1</B> (of time) (<I>senatende, senprokraste</I>): Just = at once, forthwith, immediately, instantly. <I>Iru ~. Li ~ iris (Mi ~ iros</I>), He went (I shall go) at once. <I>Li ~ venos</I>, he is just coming. ~ kiam (or, <I>Ĝuste kiam</I> [<I>Ne: ĵus kiam</I>], at the precise moment when, just when, directly. <I>~ kiam li venos</I>, as soon as (directly) he comes. <I>~ forironta</I>, j. off, ready to sail. <B>2</B> (of place) (<I>tute apude</I>): j. right. ~ antaŭ <I>via nazo</I>, j. in front of your nose. ~ apud <I>la muro</I>, quite close to the wall. ~ post <I>la pordo</I>, j. behind (inside) the door. ~ sur <I>la unua ŝtupo</I>, on the very first stair. <B>~a</B> (immediate, instant) <I>respondo</I>. <B>~e</B>, in a trice,", "0"],
["tujo", "tuj-o", "thuya, arbor vitae (<I>Thuja</I>).", "0"],
["tukano", "tukan-o", "(orn) ordinary language for toucan = <I>ramfasto</I>.", "0"],
["tuko", "tuk-o", "[UV] Cloth (made or used for a purpose). <B>antau~o</B>, [UV] apron, pinafore. <B>Brust~o</B>, front, tucker. <I>~~eto</I>, bib. <B>Buŝ~o</B>, napkin, serviette. <B>Gudro~o</B>, tarpaulin. <B>Kol~o</B>, foulard, muffler, neckerchief, scarf. <B>Kovro~o</B> (No. 3/26, Alt 5/7), cover-cloth, veil. <B>Lav~o</B>, washing-up c. <B>Lit~o</B>, sheet. <B>Lumb~o</B>, loin-c. <B>Mort~o</B>, shroud, winding-sheet. <B>Poŝ~o</B> (pocket) handkerchief. <B>Sak~o</B>, sack-c. <B>Saliva ~o</B>, bib (baby’s). <B>Ŝultra ~o</B>, fichu. <B>Tablo~o</B>, table-c. <I>~~eto</I>, tray-c. <B>Teler~o</B>, dish-c. <B>Tualeta</B> (<B>Man~</B>) <B>~o</B>, towel. <B>Vind~o</B>, baby’s napkin, pilch, roller, swaddling- band. <B>Viŝ~o</B>, tea-cloth. <B>Vizaĝ~o</B>, face flannel. <B>~aĉo</B>, rag. <B>~peco</B>, piece (scrap) of c. ➞. <I>drap, tol</I>.", "0"],
["tulio", "tuli-o", "(chem) thulium (Tm).", "0"],
["tulipo", "tulip-o", "[UV] Tulip (<I>Tulipa</I>). <B>~arbo</B>, t-tree (<I>Liriodendron tulipofera</I>). ➞ <I>magnoli</I>.", "0"],
["tulo", "tul-o", "[UV] (tex) tulle, thin soft fine silk net.", "0"],
["tumoro", "tumor-o", "(med) tumour, abnormal or morbid swelling.", "0"],
["tumulo", "tumul-o", "(<I>tombomonteto</I>), Tumul/us, barrow, sepulchral mound. <B>~a</B>, -ary.", "0"],
["tumulto", "tumult-o", "[UV] Tumult; commotion, din, hullabaloo, public disturbance, uproar. <I>~o</I> (clash, outbreak) <I>de pasioj</I>. <B>~(em)a</B>, -ous, noisy, riotous, rowdy, stormy, turbulent. <I>~a aplaŭdo, kunveno</I>. <B>~i</B>, rage, riot. <I>Kial ~as popoloj?</I> (Ps 2/1). <B>~igi</B>, stir up. <B>~iĝi</B>, be agitated, etc. <B>~ulo</B>, roisterer, rowdy. ➞ <I>agitiĝ, brueg, ekscit</I>.", "0"],
["tundro", "tundr-o", "tundra, vast level treeless region with arctic climate and vegetation.", "0"],
["tunelo", "tunel-o", "[OA] tunnel, subterranean passage. (Tra)<B>~i</B>, t., e.g., through a mountain.", "0"],
["tungsteno", "tungsten-o", "= volframo.", "0"],
["tuniko", "tunik-o", "[OA] tunic, (ant) shirt-like garment worn by Romans and Greeks, (mod) Outer garment gathered at the waist, as short overskirt or blouse.", "0"],
["Tunizio", "Tunizi-o", "[OA 8] TN.", "0"],
["tuno", "tun-o", "(metr) Ton (weight) ~o <I>Angla, metra</I>. <B>~aro</B>, -nage (weight). ➞ <I>tonel</I>.", "0"],
["turbano", "turban-o", "[UV] turban.", "0"],
["turbino", "turbin-o", "[OA] turbine. <B>Vapor~o</B>, <B>~a</B>, turbo- e.g. turbine, <I>alternigilo, dynamo, generilo, kono, ventilo, kunpremilo, motoro, pumpilo</I>.", "0"],
["turbo", "turb-o", "[OA] (peg-spinning-whipping-) Top. <B>Zum~o</B>, hummg-t. <B>~i</B> (nt) spin (eddy, swirl, wheel, whirl) as a t. <B>~ludi</B>, spin a t. ➞ <I>trok</I>.", "0"],
["turbulenta", "turbulent-a", "turbulent, disturbed, in commotion. (met) <B>~o</B> (<I>flukirlo</I>), disturbance.", "0"],
["turdo", "turd-o", "[UV] Thrush, mavis. (<I>Turdus</I>). <B>Kanta ~o</B>, song-t. <B>Kolringa ~o</B>, ring-ousel. <B>Muzika (ruĝa) ~o</B>, redwing (<I>T. musicus</I>). <B>Sorpa ~o</B> (<I>litorno</I>), fieldfare (<I>T. pilarus</I>). <B>Viska ~o</B>, missel-t. ➞ <I>merl</I>.", "0"],
["turismo", "turism-o", "[UV] <B>turist-o</B>, [UV] tour-ism, -ist (globe-trotter), <I>turisma aŭto (oficejo</I>).", "0"],
["turkiso", "turkis-o", "[UV] (min) turquoise,", "0"],
["Turkmenujo, Turkmenio", "Turkmen-ujo, Turkmenio", "TM.", "0"],
["Turkujo, Turkio", "Turk-ujo, Turkio", "[F] TR.", "0"],
["turmalino", "turmalin-o", "(min) tourmaline.", "0"],
["turmenti", "turment-i", "(<I>-n</I>), [UV] Torment, cause severe suffering, <B>f</B> afflict, distress, <I>~is min duboj, moskitoj, postuloj</I>. ~ita, stricken (racked) <I>de timo</I>. <B>~ado</B>, t., etc. <I>~oj de amo rifuzita</I>. ~(oplen)a, t-ing, harassing, painful. <I>~a dubo</I>. ~anto, <B>~isto</B>, -er. ~adi, harass, harry, pester, plague, worry the life out of. <B>~ego</B>, agony, anguish. <B>~eti</B>, tease, vex, worry, <B>~ilo</B>, rack, etc. ➞ <I>aflikt, dolor, martir, suferig, tortur</I>.", "0"],
["turni", "turn-i", "(<I>-n</I>), [UV] Turn. <B>1</B> t. over (round): <I>~i fojnon, paĝon, radon, ŝlosilon, la dorson, la kapon</I> (also figuratively). <I>Sin ~i dekstren, sur la kalkano</I>. <B>2</B> turn to, direct: <I>~i la fortojn, okulojn. ~i rigardojn</I>, attract attention, be conspicuous. <I>Vin ~u</I> (apply, have recourse) <I>al</I>. <B>Sin~i</B> <I>al iu por helpo</I>. <B>f</B> <I>Kien ajn li sin ~os, li sukcesos. Kontraŭ min mem sin ~is mia ruzo</I>. <B>3</B> turn into, change, metamorphose, transform. <I>~i lignon en ŝtonon</I> (H 134/22) <I>akvon en vinon</I>. <B>~o</B>, turn, change of direction (mus). turn (<I>normala, invertita). ~o de la vojo</I>, bend, corner, turn. <B>~a</B>, gyratary, rotary. <B>~igi</B>, <B>1</B> turn, (nt) turns, round, pivot, rotate, spin: <I>La rado ~iĝis</I>. <B>2</B> change the direction: <I>~iĝadi</I> (wriggle) <I>kiel serpento</I>. <B>3</B> enter new state: <I>Lia amo ~iĝis en malamon. Demono povas ~iĝi en anĝelon</I> (H 108/34). <I>~iĝi en polvon</I>. ~iĝo, eddy, swirl. ~ilo, crank, reel, winch, etc. <I>Ŝraŭb~ilo</I>, screwdriver. Ĉirkaŭ<B>~o</B>, (knitting) t., (<I>simpla, duobla</I>). De<B>~i</B>, For~i (Se 13/19), t. aside (away from), avert, deter, divert. <I>De~o</I>, diver sion (of stream, traffic). <I>Sende</I><B><I>~e</I></B>, without flinching (turning a hair). ➞ <I>delog, devojig</I>. <B>El~iĝi</B>, extricate one’s from, evade, get (shuffle, wriggle) out of. <I>Ne vin el~u!</I> Don’t beat abt the bush! <I>El~(aĵ)o, el~(ig)o,</I> evasion, subterfuge. <B>~iĝema</B>, adroit, artful, evasive, shifty, slippery. <B>Re~e</B>. <B>1</B> (<I>reen, retro-</I>), back, in reverse direction. <I>Josuo iris ~e</I> (went back, returned) <I>hejmen. Re~u vin de malbono,</I> <B><I>~~ebla</I></B>, reversible. <B>2</B> in return. <I>Doni re~e. Re~iĝi</I>, t. right abt. <B>Trans~i</B>, t. over (page, etc.). <B>Kap~(iĝ)o</B>, dizziness, gjddiness, vertigo. <B>Parol~o</B>, t. of speech, locution.", "0"],
["turniro", "turnir-o", "[UV] Tournament, assault at arms, joist, tilt(ing), (whist) drive. <I>Ŝak~o</I>, chess-t. <B>~i</B>, contest, enter into the lists, play. <B>~ejo</B>, lists. ➞ <I>konkurs, lukt</I>.", "0"],
["turo", "tur-o", "[UV] Tower (Ge 11 /4). (chs) Castle, rook. <I>La ~o de Londono. Preĝeja ~o,</I> steeple. Akvo~o (ry) water-t. <B>Ĉef~o</B>, keep, stronghold. <B>Gard~o</B>, watch-t. <B>lum~o</B>, [UV] light-house. <B>Pint~o</B>, spire. <B>Sonorila ~o</B> (<I>belfrido</I>), belfrey. <B>~(hav)a</B>, -ed. <B>~e</B> <I>altega</I>, -ing, <B>~eto</B>, pinnacle, turret. ➞ <I>falk</I>.", "0"],
["turto", "turt-o", "[UV] (orn) turtle dove (<I>Strepto- pelia turtur</I>). ➞ <I>kolomb</I>.", "0"],
["tusi", "tus-i", "[UV] Cough. <I>Amo kaj ~o ne estas kaŝeblaj</I>. <B>~adi</B>, keep on -ing. <B>~igi</B>, make c. <B>Ek~i</B>, <B>Kraĉ~i</B>, clear the throat.", "0"],
["tusilago", "tusilag-o", "(<I>ĉevalpiedo</I>), (bot) coltsfoot (<I>Tusilago</I>).", "0"],
["tuŝi", "tuŝ-i", "(<I>-n</I>), [UV] Touch, finger, handle, taste (dish). <B>1</B> lay hand (finger) on: <I>Ne ~u!</I> Hands off! <I>Liaj lipoj apenaŭ ~is la glason. Ne ~u min!</I> <B>2</B> contact, reach to: <I>Sia jupo ~is la teron</I>. <B>3</B> alter: <I>La Fundamento estas ne~ebla</I> (inviolable, untouchable). <B>4</B> allude to, deal with, mention, grapple with, tackle: <I>~i la aferon, demandon, problemon, temon</I>. <B>5</B> affect, impress, move: <I>~i la koron. ~ita ĝis larmoj</I>, moved to tears. <B>6</B> concern, relate to: <I>Min ne ~as tio, mi staras ekstere</I>. <B>~o</B>, t., feel, (med) <I>~o de malsano</I>. (mus) (<I>piano</I>) (a) touch (of player) (b) (<I>~respondo</I>) t., response (of instrument). <B>~ebla</B>, tangible. <B>~egi</B>, barge into, bump, collide with, knock against. <B>~eti</B>, (<B>ek~i</B>, <I>~i delikate</I>), graze, run lightly over, skim, tap. <B>f</B> just mention. <B>Inter~i</B> <I>la glasojn</I> (1 FA 49/18). <B>Kun~o</B>, contact, (el) short circuit. <B>Re~i</B>, correct, re-t., t. up. <I>foton, pentraĵon</I>. <B>Kor~i</B> (<I>emociigi</I>), affect, go to one’s heart, move, stir. <I>~~a</I>, affecting, moving, touching, pathetic. <I>Paroli ~~e. ~~iĝi de. ~~iĝema</I>, emotional, softhearted, tender. <B>Afero~a</B>, relevant. ➞ <I>kontakt, palp</I>.", "0"],
["tuta", "tut-a", "[UV] (Complete, entire): the Whole, all the, intact. <I>La ~a popolo</I>, all the people, the entire nation. <I>La ~a tago</I>, all (the w. of the) day. <I>Mi jam legis la ~an libron</I>, the w. book. <I>La ~a mateno, nokto, tago, tempo, vojo. Dum la ~a</I> (all through the) <I>jaro, somero, vivo. Tra la ~a</I> (all through the w.) <I>lernejo (urbo</I>). <B>~e</B>, quite, completely, entirely, totally, utterly, wholely. <I>~e alia</I>, altogether difft. <I>~e plena</I>, quite full. <I>~e nova</I>, brand new. <I>~e nuda</I>, stark naked. <I>~e egale!</I> all the same! ~e ne (<I>neniel</I>) (= quite not), by no means, certainly not, not a bit (jot), not at all, not in the least, by no means. <I>Mi ~e ne estas sana</I>, I am not at all well. <B>Ne ~e</B> (= not altogether, not quite). <I>Mi ne estas ~e sana</I>, I am not quite well. <I>~e same, kiel</I>, just (the same) as. <B>~(aĵ)o</B>, whole, aggregate, general effect, totality, sum total. <B>~eco</B>, c-ness, entirety. <B>En~e</B>, as a (on the) whole, in general, in short. ~~e <I>mi konsilas, ke</I>. <B>2</B> in all. <I>Mi havas ~~e du pundojn</I>. <B>Ne~a</B>, in-c, partial. <B>~monda</B>, (world) <I>kongreso</I>. ➞ <I>ĉio, ĉiuj, komplet, plen, sum</I>.", "0"],
["Tuvalo", "Tuval-o", "TV.", "0"],
["tVALORo", "tVALOR-o", "Worth, Value. <B>1</B> grade of merit: <I>La ~o de argumento, laboro, verko. Sia ~o estas pli granda ol perloj</I> (Se 31/10). <I>La kompara ~o de diversaj proponoj</I>. <B>2</B> money v: <I>La ~o de diamanto</I>. have w., v., by quality or merit: <I>Tio ne multe ~as</I>, is of little w., (col) no great catch (shakes). <I>Pli ~as io, ol nenio</I>. <B>2</B> be w-y of, deserve, merit: <I>Cu ~as iri?</I> Is it w. while to go? <I>~as provi</I>, it is w. trying. <I>La profito ne ~as la penadon. Kio multe kostas, multe ~as</I>. <B>3</B> be equivalent to. <I>Unu gineo ~as 21 ŝilingojn</I>. <B>~a</B>, v-able. <I>~a libro, objekto, tempo</I>. <B>~aĵo</B>, something v-able. <B>~igi</B>, turn to accnt, exploit. <B>Laŭ~a</B>, <B>~e</B>, <I>ad valorem</I>. <B>Sen~a</B>, of no v., v-(w-)less, trifling. <B>~~aĵo</B>, rubbish, trash. <B><I>~~</I>eco</B>, insignificance. <B><I>~~</I>igi</B> (<I>argumenton</I>), invalidate. <I>~~uloj</I>, small fry, people of no conseqce. <B>Alt~a</B>, <B>Multe~a</B>, Grand~a (Ps 139/17), precious, of great v. <B>Egal~a</B>, equivalent. <B>Malpli<I>~</I>iĝo</B> (<B>Minus~o</B>), (com) depreciation, <B>Pli~iĝo</B> (<B>plus~o</B>), appreciation, increase in v. <B>Pen~i</B>, be w. the trouble. <B>Plen~e</B>, at its full v. <B>Sam~a</B>, of the same v. ➞ <I>ind, kost, merit</I>.", "0"],
["U", "", "[F], Letter U. <B>U-fero</B>, U iron. <B>U-tubo</B>, U tube, (gram) <B>U-modo</B>, imperative (volitv) mood.", "0"],
["u", "-u", "[UV] (gram) ending of volitive mood: denotes wish, desire (of any degree, expressed or not); command, order; request; necessity; advice, permission. (Ki)Venu! (You) Come! Ne venu! Don’t come! <I>Li</I> venu! Let him come, he must come. <I>Tiel</I> estu! So be it! <I>Dio vin</I> benu! <I>Mi skribis al li, ke li</I> iru, (telling) him to go. Voku, <I>por ke li</I> aŭdu (so that he may hear). <I>Ho, ke li</I> venu! Oh (Would) that he might come! <I>Ĉu mi</I> iru? Shall I go? Am I to go? <I>Kiom li</I> pagu? How much is he to pay?", "0"],
["ublieto", "ubliet-o", "(<I>forgeskelo</I>), oubliette.", "0"],
["Ugando", "Ugand-o", "UG.", "0"],
["uj", "-uj", "[UV] (sfx), denotes <B>1</B> container, holder, receptacle: <B>Abel~o</B>, hive. <B>Ĉapel~o</B>, hat-box. <B>Ink~o</B>, ink-pot. <B>Mon~o</B>, purse. <B>Sup~o</B>, soup-tureen. <B>Violon~o</B>, violin- case. <B>2</B> (with verbal root) object. in which an action is performed: <B>Ban~o</B>, bath. <B>Bol~o</B>, boiler. <B>Bapt~o</B>, font. <B>Kned~o</B>, kneading-trough. <B>3</B> Land of.: <B>Angl~o</B>, England. <B>Patr~o</B>, fatherland. <B>4</B> Fruit-bearing plant or tree; <B>Frag~o</B>, strawberry plant. <B>Pom~o</B>, apple-tree. If Better fragplanto, pomarbo, to avoid ambiguity. <B>~o</B>, container, receptacle. <I>Kiom ĝi</I> ~as (<I>enhavas)’?</I> How much (many) does it hold? ➞ <I>ing</I>. over the.", "0"],
["ukazo", "ukaz-o", "[OA] ukase, edict of Czarist government, <B>f</B> any arbitrary order.", "0"],
["Ukrainujo, Ukrainio", "Ukrain-ujo, Ukrainio", "UA, Ukraine.", "0"],
["ukulelo", "ukulel-o", "(m.i.) ukulele; Hawaiian 4-stringed guitar.", "0"],
["ul", "-ul", "[UV] (sfx), den individUaL. <B>1</B> (with adj. root): person characterized by the quality: Bel~o = <I>bela ulo (persono</I>). <B>Avar~o</B>, miser. <B>Bel~ino</B>, belle. <B>Jun~(in)o</B>, youth (maiden). <B>Kar~(in)o</B>, darling. <B>Sankt~o</B>, saint, (b) (with other roots): <B>Ali~o</B>, someone else. <B>Azen~o</B>, ass, dolt. <B>Kontraŭ~o</B>, adversary, opponent. <B>Lepr~o</B>, leper. <B>Tiam~o</B>, contemporary. <B>2</B> (animal): <B>Mam~o</B>, mammal. <B>Ramp~o</B>, reptile. <B>Vertebr~o</B>, vertebrate. <B>3</B> (inanimate obj): <B>Neĝbor~o</B> (<I>galanto</I>) (1 FA 23/26). <B>Triferdek~o</B>, threedecker (4 FA 79/11). <B>Trimast~o</B>. <B>Rim</B>.: La propono de K. Picx uzi -al anstataŭ -ul por aĵoj aŭ objektoj (<I>neĝboralo, triferdekalo, trimastalo</I>) kaj limigi la uzon de -ul al personoj ne disvastiĝis. <I>Blind</I><B><I>~</I>igi</B>, blindfold. <B>Ulo</B> (somewhat contemptuous) = bloke, creature, fellow, person, wight. ➞ <I>an, ist, person</I>.", "0"],
["ulano", "ulan-o", "[OA] uhlan (cavalryman with lance).", "0"],
["ulcero", "ulcer-o", "[UV] Ulcer, open sore. <I>~o stomaka</I>. <B>f</B> moral blemish. ~(ec)a, ~ita, -ated. <B>f</B> embittered. <B>~iĝi</B>, fester, gather.", "0"],
["ulekso", "uleks-o", "gorse, furze, whin (<I>Ulex</I>). ➞ <I>genist</I>.", "0"],
["uliginoso", "uliginos-o", "bog whortleberry (<I>Vaccinium uliginosum</I>).", "0"],
["ulmario", "ulmari-o", "(<I>herbeja reĝino</I>), meadow-sweet, queen of the meadow (<I>Filipendula ulmaria</I>). ➞ <I>filipendol, spire</I>.", "0"],
["ulmo", "ulm-o", "[UV] elm (<I>Ulmus</I>). ~o glabra, wych-e. ~ejo, e-grove. ➞ <I>jard</I>.", "0"],
["ulno", "uln-o", "[UV] <B>1</B> ell (obsolete measure), cubit. <B>2</B> arm’s length (Ge 6/15, Da 3/1, K 114/18). <I>Mezuru ĝin per la ~o de racio</I>. <B>3</B> (anat) ulna, bone of forearm. ➞ <I>jard</I>.", "0"],
["ultimato", "ultimat-o", "[OA] (pol) ultimatum.", "0"],
["ultra", "ultra-", "(sc. pfx) ultra-, in extreme degree, -mikroskop (~ruĝ~son~viol)a. ➞ <I>prefer, trans</I>.", "0"],
["ultramara", "ultramar-a", "ultramarine (blue). <I>Natura ~o</I>, lapis lazuli.", "0"],
["ululi", "ulul-i", "(<I>bleketi</I>), <B>1</B> howl, wail (as dog or wolf). <B>2</B> hoot (as owl). <B>~ado</B>, ululation, tu-whoo.", "0"],
["um", "-um", "[UV] (sfx): has no definite meaning., but forms related words whose sense is defined by usage or suggested by context. The following are in the Fundamento. Aer<B>~i</B>, aerate. Amind<B>~i</B>, woo, court, make love to. Brul<B>~o</B>, inflammation. <B>Buŝ~o</B>, muzzle. <B>Buton~i</B>, button. <B>Gust~i</B>, taste (tr). Kol<B>~o</B>, collar, Komun<B>~o</B>, community. Kruc<B>~i</B>, crucify. <B>Lakt~o</B>, soft roe. <B>Lot~i</B>, dispose of by lot. <B>Malvarm~i</B>, catch cold, take a chill. Man<B>~o</B>, cuff. Mastr<B>~i</B>, keep house, manage. <B>Naz~o</B>, pince-nez. <B>Palpebr~i</B>, blink, move eyelid. <B>Plen~i</B>, fulfil, accomplish, perform. <B>Vent~i</B>, fan, winnow. Numerous other forms have been used: some have taken root. (See <I>Step by Step</I> par. 1139). But in general, um-words had better be formed only (a) in case of real necessity, or (b) as \"nonce-words\" coined for the occasion; not as permanent additions to the dictionary: e.g., <B>~ilo</B>, gadget; <B>~dek</B> (<I>dek</I> ~), ump-teen.", "0"],
["umbelo", "umbel-o", "(bot) Umbel. <B>~a</B>, -late. ~acoj.", "0"],
["umbiliko", "umbilik-o", "[UV]. <B>1</B> Umbilic/us, navel, belly-button. ~a <I>hernio. ~a ŝnuro</I>, -al cord, n-string. <B>2</B> (bot) (<I>hilumo</I>), hilum.", "0"],
["umbro", "umbr-o", "umber.", "0"],
["uncio", "unci-o", "(zoo) ounce, mountain panther, snow leopard (<I>Panthera uneia</I>).", "0"],
["unco", "unc-o", "[UV] ounce (weight).", "0"],
["ungo", "ung-o", "[UV] nail (of finger, toe); claw (of cat); (bot) claw of petal. <I>~o enkreskanta</I> (ingrowing). <I>Krur~o</I>, spur (of cock). <I>Fajli, purigi, tajli, tondi la ~ojn. Mordi la ~ojn</I>. <B>~a</B>, ungual. <I>~a haŭteto</I>, agnail. <B>~e</B> <I>grati</I>, scratch. <B>~ego</B>, [UV] claw, talon (<I>de agio, leono</I>). <B>~ilaro</B>, manicure set. ➞ <I>najl</I>.", "0"],
["ungvento", "ungvent-o", "(phar) (<I>medicina ŝmiraĵo</I>), ointment, salve.", "0"],
["uniformo", "uniform-o", "[UV] (cl) uniform, distinctive dress of members of an organization. <I>~o lerneja</I>. (mil) <I>Parada, plena ~o</I>, full regimentals. <B>Sen~e</B>, in plain clothes (civvies, <I>mufti</I>).", "0"],
["unika", "unik-a", "[OA] unique. <B>1</B> (<I>unu sola</I>), the only one, single, sole; <I>~a filo, vojo</I>. <B>2</B> (<I>sensimila</I>), unlike anything else, unequalled, unmatched, unparalleled, unrivalled. <I>~a ĉapitro en la historio. ~a pejzaĝo, pozicio, spektaklo, sperto</I>. <B>~aĵo</B>, <B>~eco</B>.", "0"],
["unikorno", "unikorn-o", "= unukornulo.", "0"],
["unio", "uni-o", "(<I>unuiĝo</I>), union, coalition. <I>La Poŝta ~o</I>.", "0"],
["unisono", "unison-o", "[UV] unison, coincidence of sound or melody, <B>f</B> agreement, concord, <B>f</B> <I>en ~o kun</I>, in keeping (harmony) with. ➞ <I>unut</I>.", "0"],
["unitariano", "unitarian-o", "<B>~a</B>, ~ismo, unitarian (-ism).", "0"],
["universala", "universal-a", "[UV] (<I>ĉies, ĉiua, senescepta</I>), universal, world-wide, ecumenical. <B>~a</B> (<I>tutmonda) diluvo. ~a aplaŭdo, lingvo, voĉdono</I>. <B>~a kuracilo</B>, panacea. <B>~eco</B>, <B>~igi</B>, <B>~ismo</B>.", "0"],
["universitato", "universitat-o", "[UV] university, <B>~a</B> <I>profesoro, studento, urbo</I>.", "0"],
["universo", "univers-o", "[UV] Universe, all existing things, the whole creation (Ps 18/15, 19/4). <B>~a</B>, of the universe, cosmic.", "0"],
["unu", "", "[UV] One, single. <B>1</B> (numeral) One. <I>~ kaj (aŭ: plus) ~ estas du. Du homoj povas pli multe fari, ol ~. Eĉ ne ~</I>, not even one. Pli ol ~ (pluraj), several. <I>Ili kuris, ~ post la aliaj</I> (one after another). <B>2</B> (adj) One and the same: <I>Ĉiuj havas ~ celon</I>. <B>3</B> (indefinite pron = <I>iu</I>): <B>~ el la knaboj</B>. <B>~j</B> (some) <I>estis bonaj, aliaj ne</I> [FE]. <B>4</B> a certain. <I><B>~</B> tagon</I>, one day. <I><B>~</B> vidvino havis du filinojn</I> [FE]. <I>En la ĉambro de ~ poeto</I> (4 FA 133/1). <B>~o</B>, unit. <B>Mon~o</B>, monetary unit. <B>Pez~o</B>. <I>~o de longo</I>. <B>tri~o</B>, [UV] Trinity, (arit) <I>La kolumno de ~oj</I>. <B>~e</B>, in the first place, first(ly). <I>Veni ~e. ~e naskita</I>. <B>~eco</B>, unity, unanimity. <I>~eco donas forton</I>. <B>~ecigi</B>, unify. <B>~igi</B>, unite. <B>1</B> (kunigi); join: <I>~igi la fortojn</I>. <B>2</B> (<I>kunligi, kunfandi</I>): <I>Por</I> <B>re~igi</B> <I>la homaron</I>. <I>~igitaj per edziĝo</I>. <B>~igilo</B>, <I>bond, tie. <B>~iĝi</B>, (kuniĝi), coalesce, unite</I>. <B>~iĝo</B>, <I>union</I>. <I>La</I> <B>re~iĝo</B> <I>de la eklezioj</I>.<I> <B>~obla</B>, single (not complex). <B>~ope</B>, in single file, one by one <B>~forma</B>, uniform. <B>~homa</B>, <B>~mana</B>, single-handed. <B>~kolora</B>, monochrome. <B>~loka</B> (</I>lito), <I>single. <B>~taga</B>, of one day. <B>~valenta</B>, monovalent. <B>~voĉa</B>, unanimous</I>.", "0"],
["unua", "", "[OA] First (a) (order, rank): <I>La ~ en la klaso. La lastaj estos la ~j</I>. (b) (time): early, earliest. <I>La ~j Kristanoj. ~ helpo,</I> first-aid. <I>~ parolo (vojaĝo</I>), maiden. <B>~aĵo</B>, frist fruits. <B>~eco</B>, priority, <B>~ulo</B>, f. one (Am 6/1). <B>~foje</B>, for the first time. <B>~grada</B>, elementary, primary. <B>~klasa</B>, f-class, A 1. <B>~taga</B>, on the first day. <B>~vide</B>, at first sight.", "0"],
["unuto", "unut-o", "(<I>piĉa koincido</I>), (ac) absolute coincidence of pitch (by analogy with the intvls <I>kvarto, kvinto</I> …, though a <I>unuto</I> is hardly an intvl!). <I>Kanti</I> <B>~e</B> (<I>sampiĉe</I>), sing precisely the same sound. ➞ <I>Kanti</I> unisone, sing in unison. (<I>= unute, okte, aŭ plurokte</I>). <B>Dek~o</B>, eleventh (intvl). <I>Akordo dek~a</I>, chord of the eleventh.", "0"],
["upaso", "upas-o", "upas-tree (<I>Antiaris toxicaria</I>). <B>~a</B> <I>suko</I>.", "0"],
["upupo", "upup-o", "(orn) hoopoe (<I>Upupa</I>).", "0"],
["uragano", "uragan-o", "[OA] Hurricane (Se 1/27). <B>f <I>~o de pasio, rido, de aplaudoj, krioj, prooj</I></B>, <I>testoj</I>. <B>~a</B>, furious, violent. <B>~i</B>, have the fury of a h. ➞ <I>venteg</I>.", "0"],
["uranio", "urani-o", "(chem) uranium (U). <I>~a peĉ-erco</I>, pitch-blende.", "0"],
["uratacido", "urat-acido", "uric acid,", "0"],
["urbo", "urb-o", "[UV] Town. <B>~o</B> <I>havena, hejma, lima,</I> seaport (native, frontier) town. <B>Ban~o</B>, spa, watering place. <B>Ĝarden~o</B>, garden city. <B>~a</B>, <B>~eca</B>, <B>~maniera</B>, urban. <B>~ano</B>, -sman, burgher. <I>~anaro</I>, -sfolk. <I>Sam~ano,</I> fellow-sman. <B>~ego</B>, great city. <B>~estro</B>, mayor, provost. <I>~estraro</I>, municipal corporation. <B>~eto</B>, small town. <B>~domo</B>, t-hall, mansion-house. <B>~oplanado</B>, t-planning. <B>antaŭ~o</B>, [UV] outlying district, suburb. <B>Antaŭ~a</B>, <B>apud~a</B>, <B>sub~a</B>, suburban. <B>Ĉef~o</B>, capital, metropolis. <B>Ĉirkaŭ~o</B>, environs, outskirts, suburbs. <B>Ekster~a</B>, country, outlying, rural. <B>Sub~aĵoj</B> (Jos 21/11). ➞ <I>civit</I>.", "0"],
["uredo", "ured-o", "uredo fungus.", "0"],
["uremio", "uremi-o", "uremia.", "0"],
["ureo", "ure-o", "(<I>urinaĵo</I>), urea.", "0"],
["uretero", "ureter-o", "ureter, urinary duct.", "0"],
["uretro", "uretr-o", "(<I>urintubo</I>), urethra,", "0"],
["urĝi", "urĝ-i", "[OA] <B>1</B> (<I>-n</I>), Urg/e, drive, impel, press upon: <I>~i argumenton, ĉevalon. Ne ĉesu ilin ~i</I> (GD 39/23). <I>La Egiptoj ~is</I> (were urgent upon) <I>sur la popolon</I> (El 12/33). <B>2</B> (nt) be urgent (pressing), not brook delay: (<I>La afero) ne ~as</I>, There’s plenty of time. <B>~a</B> (<I>neprokrastebla</I>), urgent, calling for immediate attention, instant, pressing. <I>~a bezono, laboro, letero, peto, voko</I>. <B>~(ec)o</B>, -ency, emergency, hurry, pressure. <I>Kia ~o!</I> What a hurry! <B>~e</B> <I>bezoni ion</I>. ➞ <I>brul, hast, insist, instig, rapid</I>.", "0"],
["urino", "urin-o", "[UV] Urin/e. <B>~i</B> (col. <I>pisi</I>, fac. <I>maltrinki</I>), urinate, make water. <B>lit~ado</B>, bed-wetting. <I>Malfacila ~ado</I>, strangury, <B>~ejo</B>, convenience. <B>~iga</B>, diuretic. <B>~ujo</B>, urinal, chamber-pot.", "0"],
["urio", "uri-o", "(orn) Guillemot (<I>Uria</I>). <B>Nigra ~o</B>, black g.", "0"],
["urio", "-uri-o", "(med sfx) <I>= enurina</I>. <B>Fosfat~o</B>. <B>Glukoz~o</B>.", "0"],
["urno", "urn-o", "[UV] (ant) Urn, large vase. <I>Funebra ~o</I>, cinerary u. <I>[Ne= tekruĉo]</I>.", "0"],
["uro", "ur-o", "[UV] aurochs, extinct wild ox (<I>Bos urus</I>) (Re 14/5).", "0"],
["urogalo", "urogal-o", "[UV] (<I>tetraego</I>), capercailie (<I>Tetrao urogallus</I>).", "0"],
["urso", "urs-o", "[UV] Bear (<I>Ursus</I>). <B>~o Blanka</B>, <B>Bruna</B>, <B>Nigra</B>, <B>Polusa</B>. <B>Formik~o</B> (<I>mirmekofago) (astr</I>) (Mal)Granda ~o, Great (Little) bear (a. <I>~ino, ~eto</I>). <B>~a</B>, bearish, ursine, <B>f</B> clumsy. <I>~a kareso</I>, b-hug. <B>~ejo</B>, <B>~kavo</B>, bear-garden, bear-pit. <B>~ido</B>, b-cub. <B>~ino</B>, she-b. <B>~felo</B>. <B>~graso</B>. ➞ <I>aŭrikol, arktostafil, melurs</I>.", "0"],
["urtiko", "urtik-o", "[UV] Nettle (<I>Urtica). ~on frosto ne difektas</I>. <B>~i</B>, sting as a n. <B>~acoj</B>. ➞ <I>incit, juk, pik</I>. (med) <B>~ario</B>, <B>~ozo</B>. (<I>urtika ekzantemo</I>), n-rash.", "0"],
["Urugvajo", "Urugvaj-o", "[OA 8] UY.", "0"],
["us", "-us", "[UV] (gram. ending), denotes hypothesis, supposition. It speculates about a state of affairs doubtfully existent. It has no time value. Supposing that (in the past, present, or future) something <I>were</I> (-us) the case (which is not known), then something else <I>would be</I> (-us) the case. The supposition and its consequence form a pair (If -us, then -us). <I>Se li</I> venus, <I>li pagus</I>. Supposing he were to come, he would pay. Or, Supposing he had come, he would have paid. <I>Se vi</I> kantus <I>morgaŭ, mi ĝojus</I>. If you sang (supposing you were to sing) tomorrow (which may not occur) I shoud rejoice. <I>Morgaŭ (li) finus</I> (would have finished) <I>kvin jarojn, se ni povus lin konservi</I> (4 FA 162/6). <B>Rim</B>.: Sometimes the second -us is not expressed, though understood. <I>Mi</I> ĝojus <I>iri</I>, I should be delighted to go (if…). <I>Mi</I> volus <I>iri</I>. I should like to go (if …). <I>Eble</I> estus <I>bone iri</I>, It might be well to go. <B>~modo</B>, conditional mood.", "0"],
["usneo", "usne-o", "beard lichen (<I>Usnea</I>).", "0"],
["Usono", "Uson-o", "[OA 9] US.", "0"],
["ustilago", "ustilag-o", "(a. <I>smuto</I>). blight, loose smut (of cereals) (<I>Ustilago</I>).", "0"],
["utao", "uta-o", "uta, Japanese poem with 5- and 7-syllable lines. Various species The 31-syllable <I>uta</I> is a <I>tanka (tankao</I>).", "0"],
["utero", "uter-o", "[UV] womb, uterus. <I>Kial mi ne mortis tuj el la ~o?</I> (Ij 3/11). <B>~a</B> <I>cerviko, falo, tubo (salpingo</I>). <B>Sam~a</B> (<I>sampatrina</I>), uterine.", "0"],
["utila", "util-a", "[UV] of Use; advantageous, beneficial, profitable, useful. <I>~a arto, instruo, mento, libro</I>. <B>~aĵo</B>, <B>~eco</B>, usefulness, advantage, service, utility. <B>~i</B> (<I>esti ~a, liveri ~on</I>), be of use, avail, help, serve. <I>Ne ĉio ~as, kio brilas. Tio neniel ~us al vi</I> (word avail you nothing). <B>~igi</B>, avail one’s of, employ (for a purpose), exploit, put to use, turn to account, utilize. <I>~~i la okazon</I>. <B>Ne~ebla</B>, useless, unserviceable. <B>~ismo</B> (<I>utilitarismo</I>), utilitarianism. <B>mal~a</B>, [UV] baneful, harmful, hurtful, detrimental, disadvantageous, injurious, noxious, pernicious, prejudicial. <I>~~o</I>, detriment, etc. <I>~~i (esti</I> ~~a), harm, hurt, injure. <B>Ne~a</B>, <B>Sen~a</B>, useless, bootless, of no use, unavailing. <B>Nemal~a</B>, inoffensive. <B>Sen~aĵo</B>, lumber, refuse, rubbish, waste. <B>Sen~eco</B>, futility. ➞ <I>difekt, help, profit, serv, taŭg, uz</I>.", "0"],
["utopio", "utopi-o", "[OA] Utopia, ideally perfect place or state of things, castle in Spain. <I>Labori por ~o</I>. <B>~a</B>, -n. <I>~a projekto</I>. <B>~ismo</B>, -nism.", "0"],
["utriklo", "utrikl-o", "(bot) (zoo), utricle. <B>~a</B>, utricular.", "0"],
["utrikulario", "utrikulari-o", "(bot) bladderwort (<I>Utricularia</I>). ➞ <I>ascidi</I>.", "0"],
["uverturo", "uvertur-o", "[OA] (mus) overture. ➞ <I>antaŭlud, prelud</I>.", "0"],
["uvulo", "uvul-o", "(anat) Uvula. <B>~a</B>, uvular.", "0"],
["Uzbekujo, Uzbekio", "Uzbek-ujo, Uzbekio", "UZ.", "0"],
["uzi", "uz-i", "[UV] Use, employ (to gain end, meet need), utilize. <I>~i multe da salo, la fingrojnla okazon, ruzon. Ni ~u bone la vivon. Cesi ~i</I>, dis-u. <B>~(ad)o</B>, use, usage, wear. <I>Fari ~on el</I>, make use (avail one’s) of. Ĝ<I>ui la ~on de</I>, have access to. <I>~ado pli gravas, ol simpla teorio</I>. <B>~aĵo</B>, [UV] contrivance, device, requisite, utensil. <B>~ata</B>, <B>komun~a</B>, in everyday use, current. <I>~ata</I> (beaten, trodden) <I>vojo. Ne plu ~ata,</I> discarded, obsolete, disused, out of date. <I>~ateco</I>, currency, vogue. <I>Ne~~aĵo</I>, lumber. <I>Ne~ita</I>, unused, fresh, new. <B>~ebla</B>, unavailable, unserviceable, valid. <B>Ne~ebla</B>, unusable. <B>El~i</B> (<I>~difekti</I>), consume, spend, wear out. <I>~~i sian vivon per vana penado. ~~i pantalonon. ~~itaj okuloj. Kalkanoj stump~~itaj</I>, down at the heel. <I>Rapide ~~iĝi</I>, wear badly. <B>Fi~i</B>, maltreat. <B>For~i</B> (<B>~konsumi</B>), use up, waste. <B>Man~i</B>, handle, manipulate, wield (➞ <I>manumi</I>). <B>Mis~i</B>, misuse. <B>Re~i</B>, re-employ. <I>~~ebligi,</I> renovate, put into service again. <B>tro~i</B>, [UV] use to excess, abuse, over-use. <I>~~i kunmetitajn tempojn. Ne</I> <B>skrib~ita</B> <I>papero</I> (4 FA 148/2). ➞ <I>konsum, kutim, serv, utilig</I>.", "0"],
["uzino", "uzin-o", "(&lt; <I>fabrikejo</I>), factory dealing with raw materials; mill, works.", "0"],
["uzuro", "uzur-o", "[OA] (<I>procentego</I>), Usur/y. <B>~isto</B>, -er.", "0"],
["uzurpi", "uzurp-i", "(<I>-n</I>), [UV] Usurp, seize, wrongfully assume. <I>~i aŭtoritaton, oficon, pozicion, povon, titolon</I>. <B>~ado</B>, -ation. <B>~into</B>, -er. ➞ <I>arog</I>.", "0"],
["ŭa", "", "(interjection). <I>Ĉiam la bubeto krios ŭa! ŭa! ŭa!</I> (Rz 87/26), the little chap will keep compass direction on crying <I>Wah! wah!</I>", "0"],
["ŭato", "ŭat-o", "<B>(a. <I>vato</I>)</B> watt. <B>Kilo~</B>, <B>-metro</B>,", "0"],
["ŭesto", "ŭest-o", "(<I>okcidento</I>), west, proposed.", "0"],
["Ŭo", "Ŭ-o", "[F], letter Ŭ.", "0"],
["ŭuf!", "", "(onom), woof! bark of dog. ➞ <I>boj</I>.", "0"],
["vaĉo", "vaĉ-o", "(mar) Watch. <B>~i</B>, be on w. <B>~anaro</B>, w. <B>Duon~o</B>, dog’s w.", "0"],
["vadi", "vad-i", "[OA] Wade (4 FA 186/27), splash, squelch. <I>~i en koto, sablo, sango, la maro. Iri</I> <B>~aĉe</B>, flounder, waddle. <B>(Trans)~ejo</B>, crossing, ford (Ge 32/22). <B>~eti</B>, paddle. <B>~uloj</B>, <B>~birdoj</B>, -ers. <B>Tra~i</B>, <B>Trans~i</B>, w. through.", "0"],
["vaflo", "vafl-o", "[UV] Wafer, thin cake, waffle. <I>Maca ~o</I>. <B>~a</B> <I>fero</I>, waffle-iron. <B>~eto</B>, coneshaped w., cornet, for ice-cream.", "0"],
["vagabondo", "vagabond-o", "vagabond, beach-comber, prowler, tramp, vagrant. <B>~a</B> <I>vivo</I>. ➞ <I>nomad, vag</I>.", "0"],
["vagi", "vag-i", "(nt), [UV] wander (aimlessly), drift, ramble, roam, rove, stroll (abt.), <I><B>~i</B> en la arbaro, sur la kamparo</I>. <I>Ĉirkaŭ sanktuloj diabloj ~as</I>. <B>f</B> <I>Lasi la pensojn ~i. Nuboj ~is sur la ĉielo. Lia rigardo ~is sur la ĉirkaŭa pejzaĝo</I>. <B>~a</B> <I>vivo</I>. <B>~aĉi</B>, <B>gap~i</B>, dawdle, hang (gad, moon) about, gallivant. <I>Pense ~i</I>, be wool-gathering. <B>~adi</B> <I>en la nokto</I>. <B>~ado</B>, roaming. <I>Palpe ~adi</I>, grope abt. <B>~anto</B>, tramp <B>(</B><I>trampo</I>). <B>For~i</B> <I>de la vojo</I>, (go a-)stray, digress. <B>Miaj pensoj ~~is</B>. <B>Tra~i</B> <I>Germanujon</I> (Rj 46/16).", "0"],
["vagino", "vagin-o", "(anat) Vagin/a, sheath. <B>~a</B>, -al. <I>~a duŝo</I>. <B>~ismo</B>, -ism. <B>~ito</B>, -itis.", "0"],
["vagono", "vagon-o", "[UV] (ry) Waggon, carriage (Am) Car, van (for goods). <B>~eto</B>, Truck. <B>Brut~o</B>, cattle-t. <B>Ĉeval~o</B>, horse-box. <B>Dorm~o</B>, <B>Lit~o</B>, sleeper, sleeping-c. <B>Karb~o</B>, coal-w, tender (of locomotive). <B>Manĝ~o</B>, dining-c. <B>Pakaĵ~o</B>, <B>Ŝarĝ~o</B>, luggage–w., goods-w. <B>Plat~o</B>, t. <B>Salon~o</B>, saloon-c. <B>Ŝut~o</B>, tip-t. <B>~aro</B>, [UV] train. ~~o <I>ekspresa, koridora, pasaĝera, poŝta, speciala</I>. <B>El(~ar)iĝi</B>, <B>(En~)(ar)iĝi</B>. <B>Trans~iĝi</B>, change trains. ➞ <I>ŝarĝveturil</I>.", "0"],
["vajro", "vajr-o", "(her) vair.", "0"],
["vakcinio", "vakcini-o", "[UV] Whortleberry (Vaccinium), <I>especially red w„ cowberry</I> (V. vitis idaed). Aliaj <B>~acoj</B>: mirtel, oksikok, uliginos.", "0"],
["vakcino", "vakcin-o", "Vaccin/e, lymph. <B>~i</B> (<I>injekti serumon</I>). -ate. <B>~a</B> <I>terapio</I>. <B>~ado</B>, <B>~ilo. ~atesto. Re~i</B>.", "0"],
["vakero", "vaker-o", "cowboy. ➞ <I>gaŭĉ</I>.", "0"],
["vaki", "vak-i", "<I>[OA]</I> (nt) be Vac/ant (empty, free, tenantless, unoccupied). <I>La posteno ~as</I>. <B>~(ant)a</B>, v. <B>~a</B> <I>loko, ofico, rigardo, seĝo, spaco, tero</I>. <B>~aĵo</B>, -ancy. <B>~igi</B>, evacuate, vacate (<I>ĉambron, urbon</I>); blow (<I>ovon</I>); clear out (<I>ŝrankon</I>). ➞ <I>liber, neluit, neokupit</I>.", "0"],
["vakso", "vaks-o", "[UV] Wax. <I>Mola kiel ~o</I>. <B>1 Abel~o</B>, bees-w. <B>Modla ~o</B>. <B>Orel~o</B> (cerumeno). <B>2</B> (<I>similar substance</I>): <B>Pargeta ~o</B>, floor polish. <B>sigel~o</B>, [UV] sealing-wax. <B>~(ec)a</B>, w-en, -y. <B>~a</B> <I>alumeto, kandelo, pupo</I>. <B>~a</B> (palflava) vizaĝo. <B>~i</B> (ŝmiri per ~o), (<I>coat with) w</I>. <B>~i</B> <I>meblon, plankon</I>.", "0"],
["vakuo", "vaku-o", "Vacuum. <B>~a</B> <I>purigado</I>. <B>~eco</B>, vacuity. <B>~igi</B> make a v. in. <B>~botelo</B>, v-flask (<I>termoso</I>).", "0"],
["valabio", "valabi-o", "wallaby, popular name for various species of <I>Macropus (kanguruo</I>).", "0"],
["valento", "valent-o", "(chem) valency. <B>Du~a</B>, bivalent. <I>Karbono estas 4~a</I>.", "0"],
["valerianelo", "valerianel-o", "(bot) corn-salad, lamb’s lettuce (<B><I>Valerianella</I>)</B>.", "0"],
["valeriano", "valerian-o", "valerian, all-heal (<I>Valeriana</I>). <B>~a radiko</B>. ➞ <B><I>centrant</I></B>.", "0"],
["valeto", "valet-o", "(<I>ĉambristo</I>), valet, manservant. <B>~ino</B>, lady’s maid.", "0"],
["valida", "valid-a", "[OA] Valid, fulfilling the necessary conditions. <I>~a bileto, edziĝo, kialo, kontrakto, pasporto, testamento. Ne plu ~a</I>, out of date, expired, lapsed. <B>~eco</B>, -ity. <B>~igi</B>, -ate. <B>Ne~igi</B>, <B>Sen~igi</B>, in-ate.", "0"],
["valizo", "valiz-o", "[UV] valise, hand-bag, small portmanteau, suit-case, (Am) grip. <B>~eto</B>, attache-case. ➞ <I>kofr, tek</I>.", "0"],
["valo", "val-o", "[UV] Valley; dale, vale. <I>Kruta ~o (ravino). Se neĝas sur la monto, estas malvarme en la ~o</I>. <B>f</B> ~o <I>de larmoj. ~o de mallumo</I> (Ps 23/4). <B>~en</B>, <B>al~e</B>, down-hill, down-stream, v-wards. <B>~ano</B>, dalesman. <B>~eto</B>, combe, dell, glen. ➞ <I>talveg</I>.", "0"],
["valso", "vals-o", "[UV] <B>~i</B>, Waltz. <B>Kun~anto</B>, partner in w.", "0"],
["valuto", "valut-o", "(fin) (<I>monvaloro</I>), currency value of paper money.", "0"],
["valvo", "valv-o", "Valv/e. <B>1</B> (mec) <I>~o de aertubo, fluto</I>. ~o enlasa, inlet v. ~o ellasa, outlet v. ~o glita, tira, slide v. ~o globa, ball v. ~o haltiga, stop v. ~o klapa, key v. ~o piŝta, piston v. ~o sekuriga, safety v-. ~o suĉa, suction v. <B>2</B> (anat) <I>~o de koro</I>. <B>3</B> (rad) (a. <I>tubo</I>), lamp: <I>~o (mal)brila: du~(tri~)elektroda (= diodo, triodo). ~a ululo</I>. <B>4</B> half-shell of a mollusc: <B>~(ohav)a</B>, -ular. <B>Du~a</B>, bi-a. (el) <B>~ingo</B>, contact socket. ➞ <I>klap</I>.", "0"],
["vampiro", "vampir-o", "[OA] Vampire, ghoul. <B>1</B> (myth) blood-sucking ghost. <B>2</B> v-bat (harmless) (<I>Desmodus</I>). <B>f</B> bloodsucker, extortioner. <B>~ino</B>, <B>f</B> vamp. <B>~ismo</B>.", "0"],
["vana", "van-a", "[UV] Vain, in v., barren, bootless, fruitless, useless, false, futile, sterile, illusory. <I>~a espero, klopodo, penado, triumfo</I>. <B>~e</B>, -ly, in v., to no purpose, without result. <I>~e labori, peti, provi. ~e vi tentas, mi ne konsentas</I>. <B>~aĵo</B>, idle dream (hope), twaddle. <B>~eco</B>, futility, inanity. <B>~igi</B>, baffle, defeat, foil, frustrate, thwart. <I>~igi atakon</I>. ➞ <I>senefik, senpov, senrezult, senutil, vant</I>.", "0"],
["vanadio", "vanadi-o", "(chem) vanadium (V). Combining form: <I>vanad-</I>.", "0"],
["vandalo", "vandal-o", "Vandal. <B>~a</B>, of -ism, barbarous. <B>~aĵo</B>, act of -ism. <B>~eco</B>, <B>~ismo</B>, -ism.", "0"],
["vando", "vand-o", "(<I>fakmuro</I>), Partition. <B>1</B> dividing wall: <I>Per ~oj dividi salonon en ĉambrojn. Vitra ~o</I>. (mar) bulkhead. <B>2</B> (of obj): <I>~o de forno, kesto, ŝranko</I>. <B>~eto</B> (<I>de frukto, koro, nazo</I>). <B>For~i</B>, p. off. ➞ <I>pari</I>.", "0"],
["vanelo", "vanel-o", "[OA] lapwing, peewit, green plover (<I>Vanellus</I>).", "0"],
["vanesoj", "vanes-oj", "vanessa butterflies &gt; ~o karda, painted lady; ~o pava (<I>nimfalo</I>), peacock b.; ~o urtika, small tortoise-shell. ➞ <I>antiop, atalant</I>.", "0"],
["vango", "vang-o", "[UV] Cheek, jowl. <I>Propran ~on neniu batas. ~o ĉe ~o</I>, c. by j. (mech) c. of gun-carriage, pulley-block, etc. <B>~osto</B>, c-bone. <B>Kavo~a</B>, hollow c-ed. <B>Puf~a</B>, <B>Rond~a</B>, chubby (M 185/12). <B>Ruĝ~a</B>, rosy c-ed, ruddy. <B>Sid~o</B> (<I>gluteo</I>), buttocks. <B>~~oj</B>, bottom, rump. <B>Sur~o</B>, (<B>~frapo</B>), box on the ear, slap on the face (K 79/17).", "0"],
["vanilo", "vanil-o", "[UV] Vanilla (plant and spice) (<I>Vanilla planifolia</I>). <B>~i</B>, flavour with v. <B>~a</B> <I>guŝo</I>, v-bean. <I>~a glaciaĵo</I>.", "0"],
["vanta", "vant-a", "[UV] Vain; empty, ephemeral, evanescent, fleeting, frivolous, futile, unavailing, valueless, without importance. <I>~a estas la helpo de homo</I> (Ps 60/11). <I>La ~aj plezuroj de la mondo. ~a babilado, ~aj vortoj</I>, clap-trap, empty chatter, hot-air, idle words. <I>~aj promesoj</I>, hollow promises. <I>~aj parolantoj</I> (Tit 1/10). <I>Nur</I> ~e <I>li klopodas</I> (Ps 39/6). <I>Ne ~e ripetadu</I> (Mt 6/7). <B>~aĵo</B>, vanity, chimera, mere nothing, vain imagining, worthless thing. <I>~aĵo de ~aĵoj, tio estas ~aĵo</I> (Pr 1/2; Se 12/11; Jona 2/8). <B>~eco</B>, futility, transitoriness, vanity. <B>~(em)ulo</B>, empty-head, vapourer. <B>~iĝi</B>, end in smoke, evanesce, become worthless (Jer 2/5). ➞ <I>bagatel, trivial, van</I>.", "0"],
["vanto", "vant-o", "(<I>transversa stajo</I>), (mar) shroud.", "0"],
["Vanuatuo", "Vanuatu-o", "VU.", "0"],
["vaporo", "vapor-o", "[UV] Steam, Vapour; fume. <I>~o de akvo, etero. Malaperi kiel ~o</I>. <B>~i</B>, s., give off v. <I>La supo agrable ~is</I>. <B>~a</B>, s-y, v-y. <B>~eto</B>, mist. <B>~igi</B>, <B>~umi</B>, atomize, v-ize. <I>~igi akvon</I>. <B>~igilo</B>, v-izer, <B>~iĝi</B>, evaporate. <B>~iĝema</B>, volatile. <I>La akvo (lia kuraĝo) for~iĝis</I>. <B>~izi</B>, fumigate, s. <I>Vojaĝi</I> <B>plen~e</B>, full s. ahead. ➞ <I>elĉerpiĝ, estingiĝ, foriĝ, fum, nebulet</I>.", "0"],
["varango", "varang-o", "(mar) floor-plate-(-timber), dividing outer bottom from inner.", "0"],
["varano", "varan-o", "(zoo) monitor lizard (<I>Varanus</I>). ➞ <I>monitor</I>.", "0"],
["varbi", "varb-i", "(<I>-n, al, en, por</I>) [UV], Enlist, enrol, gain over, recruit. <I>~i iun en la armeon</I>. f <I>al doktrino, Esperanto, partio. ~i voĉdonojn</I>, canvass for votes. <B>~emo</B>, proselytism. <B>~iĝi</B>, be -ed, join, be won over. <B>~ito</B>, recruit. ➞ <I>adeptig, konvert, prozelit, rekrut</I>.", "0"],
["varfo", "varf-o", "(<I>havena kajo</I>), wharf.", "0"],
["variacio", "variaci-o", "(mus) variation. <I>Temo kun ~oj</I>.", "0"],
["varianto", "variant-o", "[OA] (<I>variaĵo</I>), (lit) variant, difft form. <I>~oj de literado, parolo, poemo, rakonto, teksto</I>. (mat) variable.", "0"],
["varicelo", "varicel-o", "(a. <I>varioleto</I>), chicken-pox (<I>Varicella</I>).", "0"],
["varieteo", "variete-o", "variety show. <B>~a</B> teatro<B></B>, music-hall, variety theatre.", "0"],
["varii", "vari-i", "(nt) [OA], vary, undergo change, be of difft kinds. <I>La vetero ~as</I>. ~o, Vari/ation. (bot) -ety, sport, subdivision of species. <B>~(em)a</B>, -able, fickle, inconstant, shifting. <I>~ema stelo</I>, -able star. <B>~ema</B> (broken, unsettled) <I>vetero</I>. <B>~ado</B>, -ation. <B>~igi</B>, (cause to) v. <B>Ne~a</B>, in-able. <B>~ometro</B>. ➞ <I>divers, ŝanĝiĝ, variant</I>.", "0"],
["variko", "varik-o", "(<I>dilataĵo</I>), varix. <B>~a</B> <I>vejno</I>, varicose vein. <B>~a</B> <I>bandaĝo</I>.", "0"],
["variolo", "variol-o", "[UV] small-pox. <B>~a</B> <I>marko</I>, pock-mark. ➞ <I>varicel</I>.", "0"],
["varma", "varm-a", "[UV] Warm, Hot. <B>1</B> (temperature): ~a <I>ĉambro, forno, klimato, sango, supo, vetero</I>. <I>Estas</I> <B>~e</B>, It is warm. <B>2</B> (<I>sensation</I>): <B>~aj</B> <I>manoj, piedoj</I>. <I>Kapo febre ~a. ~aj ruĝoj (flushes</I>). <B>3</B> (<I>of taste</I>): ~a <I>mustardo (pipro</I>). <B>4</B> (= ~konserva), ~a <I>kovrilo, lano</I>. ~a <I>vestaĵo</I>. <B>f</B> (<I>fervora, pasia</I>): ~a <I>akcepto, amo, amiko, danko, koro</I>. ~a <I>diskuto,</I> animated discussion. <B>~e</B> <I>vestita</I>. <B>~(ec)o</B>, heat, warmth. <B>~o</B> <I>de la fajro, suno</I>. <I>Kaŝita</I> <B>~o</B>, latent heat, <B>f</B> <B>~eco</B> <I>de disputo</I>. <B>~ega</B>, [UV] hot, ardent, <B>f</B> passionate. <I>Ami</I> <B>~ege</B>. <B>~ejo</B>, (<B>~bedo</B>, <B>~domo</B>), hot-bed, hot-house. <B>Flor~eja</B> <I>kreskaĵo</I>, h-house plant (3 FA 18/9). <B>~eta</B>, tepid, warmish. <B>~igi</B>, warm, heat (<I>akvon, la manojn</I>). <B>~igilo</B>, heater. <B>Lit~igilo</B> (<I>varmflasko</I>), h-water bottle. <B>Pied~igilo</B>, foot warmer. <B>~iĝi</B> (bask) <I>sub la suno</I>. <I><B>blank~a</B>, [UV] incandescent, white- fa. <B>Brul~a</B>, burning. hot. <B>Duon~a</B>, luke-warm. <B>Re~igi</B>, warm up again. <B>Super~iĝi</B>, <B>Tro~iĝi</B>, get over-heated. <B>Seks~eco</B>, rut. ➞ ard, flam, stov, vigl</I>.", "0"],
["varo", "var-o", "[OA] article of commerce, commodity. <B>~oj</B>, goods, merchandise, wares. <I>Konsum~oj</I>, consumer goods. <I>Skrib~oj</I>, stationery. <I>Ŝut~oj</I>, loose goods. <B>~aĉoj</B>, shoddy goods. <B>~ejo</B>, warehouse.", "0"],
["varpo", "varp-o", "(tex) Warp, threads stretched lengthwise on loom. <B>~i</B>, warp, plait. <B>~a</B> <I>ringo</I>, heddle. ➞ <I>veft</I>.", "0"],
["varti", "vart-i", "(<I>-n</I>), [UV] Nurs/e (look after, take care of, tend). <I>~i beston, floron, infanon. Per tro multa ~o malboniĝas la farto</I>. <B>~at(in)o</B>, charge, -ling. <B>~ejo</B>, dayery, infant school. <B>~isto</B>, keeper, etc. <I>~istino</I>, dry n., nannie, maid. ➞ <I>fleg, gard, nutr, zoring</I>.", "0"],
["vasalo", "vasal-o", "Vassal, humble servant, liege(man). <B>~eco</B>, v-age.", "0"],
["vasta", "vast-a", "[UV] vast; capacious, extensive, of wide extent, spacious. <I>~a ĉambro, kampo;</I> (farflung) <I>imperio</I>. <B>f</B> (<I>grandampleksa</I>): <I>~a programo, senso, sperto;</I> (comprehensive, allembracing): <I>~a scio</I>. (phon) <I>~a</I> (open) <I>vokalo</I>. <B>~e</B>, at large. <B>~aĵo</B>, broad, expanse. <B>~eco</B>, immensity. <B>~ega</B>, immense. <B>(pli)~igi</B>, [UV] broaden, extend, enlarge, spread, widen. (pli)<B>~iĝi</B>, broaden, develop, dilate, spread, swell. <B>Dis~igi</B> (<I>dis-etend-konig-sem-i</I>), extend, promulgate, propagate, spread abroad. (extend) <I>la flugilojn. ~~i famon, lingvon, influon. La ideo ~~iĝis</I> (spread, was noised abroad). <B>malvast-a</B>, [UV] Narrow, limited, restricted. <I>~a rigardo, spirito. ~a loko</I>, confined space, (phon) closed (<I>vokalo</I>). (cl) (<I>strikta</I>), tight. <I>~a pantalono. Ligi</I> ~e. <B>~eco</B>, n-ness. <I>Mensa ~eco</I>, pettiness. <B>~ega</B>, exiguous, scanty. <B>~ejo</B>, (mar) narrows, straits; (<I>monta</I>) defile, gorge, ravine. <B>~igi</B>, n., circumscribe, restrict.", "0"],
["Vatikano", "Vatikan-o", "VA.", "0"],
["vato", "vat-o", "[UV] <B>1</B> Wadding, Cotton-wool. <I>Absorba ~o</I>, absorbent c-w. <B>~i</B>, pad, wad. <I>~i bandaĝon, veston</I>. <B>~ita</B>, wadded. <B>~bulo</B>, tampon. ➞ <I>ŭat</I>.", "0"],
["vazelino", "vazelin-o", "[OA] Vaseline, petroleum jelly. <B>~i</B>, smear with v.", "0"],
["vazistaso", "vazistas-o", "fanlight (over door), ventilator (in window, over door).", "0"],
["vazo", "vaz-o", "[UV] <B>1</B> Vase: Flor~o. <B>2</B> vessel; <B>Lav~o</B>, hand-basin, wash-pot. Nokta <B>~o</B>, chamber. <B>Trink~o</B>, trough (for animals). <B>3</B> (phys) Sang~o. <B>~a</B>, vascular. <B>~aro</B>, plates and dishes, table-service. Arĝenta <B>~aro</B>, silver plate. <B>Ter~aro</B>, crockery, earthenware. <I>Lavi la ~ojn</I>, wash up. ~akvo, dish-water.", "0"],
["ve", "", "[UV] (interjection) Woe! Ho -!, Alas! Ah me! Heigh ho! Woe is me! <B>~ al</B>, w. betide, w. unto (Jeĥ 30/2, Mt 23/13, Ap 8/13). <B>~(aspekt)a</B>, w-ful, dejected, down-cast, lowspirited, lugubrious. <B>~o</B>, plaint. <I>Ĝemoj kaj ~oj</I> (Jeĥ 2/10). <B>~(ad)i</B> (<I>krii ~e</I>), lament, wail. <I>La vento ~adis</I>. <B>~inda</B>, deplorable. <I>PFX =</I> of w. (grief, distress, mourning, sorrow). <I>Saliko Babilona estas</I> ~arbo. <B>~krio</B>, cry of grief. <I>La Jerusalema</I> <B>~muro</B>. <I>Jeremia estis</I> <B>~profeto</B>. <B>~plena</B>, lamentable. <B>~spiri</B>, (heave a) sigh. II Sometimes = of ill omen. <I>Korvo estas</I> <B>~birdo</B>. <B>~signo</B>, harbinger of ill. ➞ <I>lament</I>.", "0"],
["vefto", "veft-o", "(tex) weft, threads crossing from side to side of web in loom, <B>f</B> <I>La ~o</I> (thread, web) <I>de parolo, vivo</I>. ➞ <I>var p</I>.", "0"],
["vegetalo", "vegetal-o", "plant. ~a (<I>planta) regno,</I> vegetable kingdom. <I>~a butero (vegetalino</I>), nut butter (fat). <B>~aro</B>, vegetation.", "0"],
["vegetara", "vegetar-a", "[OA] Vegetarian. ~a (<I>sen- kadavra) dieto</I>. <B>~ano</B>, v. ~ismo, -ism.", "0"],
["vegeti", "veget-i", "[UV] Vegetat/e, exist as a plant, <B>f</B> lead dull monotonous uneventful life. <I>~i en la kamparo. Vivi</I> ~e. <B>~ado</B>, -ing. <B>~aĵo</B> (<I>planto</I>) (Ps 37/2). <B>~aĵaro</B> (<I>flaŭro</I>), flora. ➞ <I>kreskaĵ, plant, vegetal</I>.", "0"],
["vejno", "vejn-o", "[UV] Vein. <B>1</B> (phys): <I>Kol~o,</I> jugular v. <B>2</B> (min). <I>Erc~o, Min~o</I>, lode of ore; <I>~o el karbo</I>, seam of coal. <B>3</B> similar marking, streak, stripe: <I>~oj sur floro, folio;</I> nervure (of insect’s wing). <B>~(hav)a</B>, -ed. <B>~i</B> (<I>-n</I>), mark with veins, grain, marble, etc. <B>~aro</B>, venous system. <I>Ligna</I> <B><I>~aro</I></B>, (wood) grain. <B>~eto</B>, v-let, thin streak, thread. <B>~ito</B> (<I>flebito</I>). <B>~tranĉo</B>, blood-letting.", "0"],
["veki", "vek-i", "(<I>-n</I>), [UV] Wake(n), rouse (from sleep). <I>Li dormas, sed mi lin ~os</I>. <B>f</B> arouse, give birth (rise) to, provoke, stir up.<B> <I>~i atenton, dubon, esperon, kuraĝon, malamon, ribelon, ridon. Tiu bildo ~as memorojn. Spirito</I> ~a</B><I>,</I> rousing, stimulating. <B>~iĝi</B>, a-w,. regain consciousness, rise, w. up (Ps 3/5). f<B> <I>~iĝis la voĉo de konscienco</I></B>. <B>~isto</B>, knocker-up. <B>~ita</B>, <B>~iĝinta</B>, wide awake. <B>~iteco</B>, w-fulness. ➞ <B><I>estig, komenc, maldorm, nask, viglig</I></B>.", "0"],
["vekto", "vekt-o", "[UV] <B>1</B> beam, arm (of balance, scales). <B>2</B> similar object. Yoke (shoulder- piece) for carrying buckets, etc. (el) yoke of electro-magnet.", "0"],
["vektoro", "vektor-o", "(geom) vector.", "0"],
["veldi", "veld-i", "Weld, unite by hammering or pressure. <B>~ado</B>, w-ing. <B>~ita</B> (<I>ŝtalo</I>), w-ed, wrought. <B>~punkto</B>, -ed joint (seam). ➞ <I>braz, lut, sold</I>.", "0"],
["veleno", "velen-o", "[UV] vellum. <B>1</B> calf-skin prepared for writing. <B>2</B> sim, paper. ➞ <I>pergamen</I>.", "0"],
["velki", "velk-i", "[UV] Droop, Fade, Wither; lose beauty (freshness, lustre), wilt. <I>La floro, koloro, vizaĝo ~is. Kies folio ne ~as</I> (Ps 1/3). <B>f</B> (<I>kadukiĝi, konsumiĝi, senfortiĝi</I>), decline, languish, waste away. <I>Lia energio, entuziasmo, sano ~is</I>. (el) <I>=fadi</I>. ~(int)a, f-(w-)ed, drab, flabby, flaccid. <I>~a animo, mano. ~inta folio. Siaj manoj pendis</I> ~e (<I>senergie</I>). ~ema, d-(f-languish-) ing. <B>~igi</B>, w. up, blight (<I>esperojn). La suno ~igis la florojn</I>. ~(sek)iĝi, dry up, atrophy. ~ozo, (hort) wilt. For<B>~i</B>, f. (w. pine) away, die away (down) Ne~ema, fast, indelible (<I>koloro</I>). ➞ <I>senkoloriĝ, sensukiĝ, ŝrump</I>.", "0"],
["velo", "vel-o", "[UV] (mar) Sail. <I>Brajli, ferli, hisi la ~ojn</I>. <B>Antaŭ~o</B>, fore-s; <B>Ĉiel~o</B>, sky-s; <B>Gaf~o</B>, gaff-s; <B>Granda ~o</B>, main-s; <B>Latin~o</B>, lateen-s; <B>Laŭlarĝa</B> <B>~o</B>, square-s; <B>Laŭlonga</B> <B>~o</B>, fore and aft s; <B>Lugra</B> <B>~o</B>, lug-s; <B>Sprit~o</B>, sprit-s; <B>Staj~o</B>, stay-s; <B>Top~o</B>, top-s. <B>~iri</B>, <B>~veturi</B>, s., scud along. <B>~aĵo</B>, (<B>~tolo</B>), s-cloth, canvas. <B>~preta</B>, outward bound. <B>~faristo</B>, s-maker. ➞ <I>kanvas</I>. <B>2</B> (anat) <I>Palata ~o</I>, soft palate.", "0"],
["velocipedo", "velociped-o", "[OA] velocipede, foot-moved vehicle. ➞ <I>bicikl, tandem</I>.", "0"],
["veluro", "velur-o", "[UV] Velvet. <I>Sur la ventro <B>~o</B>, en la ventro murmuro</I>. <B>Kotona ~o</B>, -een. <B>~(ec)a</B>, (~e mold), -y, downy, mellow, smooth as v. <B>~a</B> <I>persiko, vango</I>. <B>f</B> <I>Esti sur ~o</I>.", "0"],
["vendi", "vend-i", "(<I>-n</I>) [UV], Sell; realize (securities). <I>~i por du pencoj</I> (= for 2d); <I>po du pencoj</I> (= at 2d). <I>~i kontante, kredite</I>. <B>~o</B>, sale. <I>Proponi</I> <B>~e</B>, for s. <B>~anto</B>, vendor. <B>~ebla</B>, marketable, saleable. <B>~ejo</B>, market, salesroom, shop. <B>~iĝi</B>, s., be sold. -isto, salesman. <B>~ita</B>, sold. <B>~ota</B>, for (on) sale, to be sold. <B>El~i</B>, <B>For~i</B>, s. out. <I>El~ita</I>, out of print (stock). <I>For~i sian havon</I>. <B>Ne~eblaĵo</B>, junk. <B>Re~i</B>, re-s. <I>~~aĵo</I>, second-hand goods. <I>~~isto</I>, s-h dealer. <I>Vest~~isto</I>, old-clothes man, wardrobe dealer. <B>Strat~isto</B>, <B>vag~isto</B>, hawker, pedlar, <B>~arto</B>, salesmanship. ➞ <I>aĉet</I>.", "0"],
["vendredo", "vendred-o", "[UV] Friday. <I>Sankta ~o,</I> Good F.", "0"],
["veneno", "venen-o", "[UV] <B>1</B> (<I>tokso</I>), Poison. <I>Rat~o,</I> rat’s bane. <I>Striknino estas ~o</I>. <B>2</B> venom. <I>~o de serpento</I>. <B>f</B> gall, spleen. <B>~a</B>, -ous, toxic, venemous. <B>f</B> noxious, pernicious. <I>~a fungo, gaso. ~a dento</I>, p-fang. <B>~i</B>, p. <I>~i hundon</I>. <B>f</B> embitter, envenom, mar, vitiate. ~i <I>rilatojn, la vivon</I>. <B>~ita</B>, -ed, embittered. <B>Kontraŭ~o</B> (<I>antidote</I>). <B>Ne~a</B>, harmless. <B>Sin~o</B>, ➞ <I>antidot, difekt, mortig, sumak, toks</I>.", "0"],
["venera", "vener-a", "venereal, of sexual intercourse. <I>~a deziro, malsano</I>.", "0"],
["Venezuelo", "Venezuel-o", "[OA 8] VE.", "0"],
["venĝi", "venĝ-i", "(<I>al iu, pro io</I>) [UV] <B>1</B> Avenge, (take) Revenge, wreak Vengeance, exact satisfaction, inflict retribution. <I>La krimo (sia morto) estos ~ita</I>. <B>2</B> Be a-(r-)ed, have (take) r. on, retaliate, wreak v. on. <I>~i al iu</I> (pay him out) <I>pro la ofendo</I>. <B>~o</B>, r., v., requital (retribution). <B>~a</B>, a-ing. <B>~anto</B>, a-er. <B>~ema</B>, r-ful, resentful, vindictive. <B>~emo</B>, thirst for v., rancour, vindictiveness. <B>~enda</B>, that calls for r. <B>Re~o</B>, reprisal, retaliation. ➞ <I>pag</I>.", "0"],
["veni", "ven-i", "[UV] (nt) Come. <B>1</B> (to the speaker, to a place): <I>~u ĉi tien</I>, step this way. <I>Mi ~as</I>, I’m -ing. <I>Lasu la infanojn ~i al mi</I> (Mt 19/14). <B>2</B> (<I>alveni</I>): arrive at, reach. <I>~i hejmen. ~is du leteroj. ~i al celo, konvinko, interkonsento. La akvo ~is ĝis liaj genuoj. Unue~into</I>, first comer. <B>3</B> (originate): <I>~i de Parizo. Tiu vorto ~as el la Latina. De tio ~as malpaco. 4 (estiĝi</I>), occur: <I>Fine ~is la horo, somero</I>. -onta, approaching. <I>En la ~onta</I> (coming, future, next) <I>semajno, tempo. Tuj ~onta</I>, imminent. -o, advent, arrival, <B>~igi</B>, bring, fetch, get, obtain, procure, send for. <I>~igi fiakron, kuraciston, pacon</I>. <B>Al~i</B>, arrive. <I>Li ĵus ~~is. La horo de lia ~~o. ~</I><B>~ebla</B>, accessible. <B>Antau~i</B>, precede. <B>~~into</B>, forerunner, precursor. <B>de~i</B> (de) [OA], c., arise, be derived, originate, proceed, result (from). <B>~~o</B>, derivation, extraction, origin, parentage, source. <B>~~igi</B>, deduce (derive) from. <B>Miks~~a</B>, of mixed origin. <B>El~i</B>, c. out. <B>~~o</B>, issue, out-c. <B>En~i</B>, c. in, enter, <B>f</B> (Ge 19/31, 38/16). <B>Inter~i</B>, c. between, intervene, step in, take a hand. <B>Kun~i</B>, c. together, assemble, meet. <I>~~i en kafejo, por diskuto, sur la strato</I>. <B>~~o</B>, Meeting. <I>~~o politika, religia, sporta, de du amikoj, de instruistoj. ~~ejo</I>, m-place, assembly room, hall. <B>~~igi</B>, call (convene, convoke, summon) a meeting. <B>~~intaro</B>, m., assembly, gathering. <B>Post~i</B>, c. after (next), succeed. <B>~veninto</B>, successor. <B>Re~i</B>, c. back (again), return. <I>hejmen, al la demando. ~~igi</I>, bring back. <I>Ne~~igebla (sen~~a</I>), irre-medi(-par-voc)able. <I>Sen~~e perdita</I>, irretrievably lost, past praying for. <B>Bon~a</B>, <B>~o</B>, <B>~igi</B>, <B>~inta</B>, welcome.", "0"],
["venki", "venk-i", "(<I>-n, abs</I>), [UV] Conquer, Vanquish; beat, defeat, overthrow, prevail against, triumph over. <B>1</B> (in battle) (<I>~bati): ~i armeon, malamikon. Nia lando nepre ~os. ~(akir)i landon</I>. <B>2</B> (in competition): gain the victory. ~i <I>ĉiun rivalon</I>. <B>f</B> master, overcome. <I>~i la alfabeton, baron, antaŭjuĝon, timon. La vero ~os en la fino</I>. <B>~o</B>, conquest, victory. <I>Atingi, gajni la ~on</I>. <B>~(oplen)a</B>, victorious. <B>~e</B>, with success, <B>~into</B>, c-or. <B>~ita</B>, c-ed, v-ed, beaten. <B>Dis~i</B>, put to flight, rout. <B>Mal~o</B>, defeat, <B>f</B> <I>La ~~oj de la vivo</I>. <B>~~i</B>, suffer defeat, be overthrown. <B>Ne~ebla</B>, insuperable (invincible), not to be beaten. Super~i (surmount, get over) <I>krizon</I>. ➞ <I>konker, triumf</I>.", "0"],
["vento", "vent-o", "[UV] Wind. <I>~o mara, norda. ŝanĝiĝi kiel la ~o. Disiĝi kiel polvo en ~o</I>. <B>f</B> <I>Kvietigi la ~on. Ĉirkaŭpelata de ĉiu ~o de doktrino</I> (Ef 4/14). <B>Dors~o</B>, leading w. <B>Ŝtorm~o</B> (uragano), <I>gale. Turn~o, whirl-w</I>. <B>~~ego</B> (<I>ciklono</I>). <B>~a</B>, -y, boisterous, stormy, unsettled, <B>f</B> (aera, malfirma, senbaza, senvalora): <I>~aj vortoj</I>, (Ij 16/3). <I>~a entrepreno, loko</I>. <B>~(ad)-i</B>, be -y, blow. <I>Forte ~as</I>. <B>~aĵo</B> (Pr 2/17). <B>f</B> empty chatter, idle (mere) words. <B>~ego</B> (<I>ŝtormo, tempesto</I>), <I>strong w</I>. <B>Neĝ~ego</B>, <I>blizzard, <B>f</B></I> <B>~ego</B> <I>da riproĉoj</I>. <B>~egi</B>, <I>blow great guns, storm, rage. <B>~eto</B>, breeze. <B>~ulo</B>, w-bag, weathercock. <B>~um-i</B>, [UV] fan, winnow</I>. <B>Gren~~aĵo</B>, <I>chaff (Ps 1/4</I>). <B>~~ilo</B>, <I>fan. <B>~frapo</B>, gust. <B>Al~e</B>, <B>~en</B>, wind-ward. <B>Ek~o</B>, gust of w. <B>Kontraŭ-e</B>, in the teeth of (against) the w. <B>Mal~a</B> (lee</I>) <I>flanko</I>. <B>Mal~en</B>, <I>leeward</I>. <I>Plena <B>sen~o</B> (kalmo</I>), <I>calm</I>. <I>Ekvatoraj sen~oj, doldrums. <B>Kirl~o</B>, whirl-w. <B>Tra~o</B>, air-current, draught. ➞ blov, spir, vant, ventol</I>.", "0"],
["ventoli", "ventol-i", "[UV] Ventilat/e, air. <I>~i ĉambron, tunelon</I>. <B>f</B> <I>~i demandon</I>. <B>~ado</B>, -ation. <B>~ejo</B>, air-trap, vane. <B>~ilo</B>, -ing fan, -or (of chimney). ➞ <I>aerum</I>.", "0"],
["ventriklo", "ventrikl-o", "(<I>kavaĵo), (anat) ventricle</I>. ~o de la cerbo, koro.", "0"],
["ventro", "ventr-o", "[UV] <B>1</B> Belly, abdomen:<I>Kuŝi sur~e</I>, grovel. <B>2</B> (col) tummy: <I>Okuloj pli grandaj, ol la ~o</I>. <B>3</B> womb: <I>Filo de mia ~o. Senfrukta ~o</I>. <B>f</B> b., bulge, swell (<I>de botelo, ondo, ŝipo, k.s.</I>) <B>~a bendo,</B> saddle-girth (horse). <B>~a doloro</B>, colic. <B>~aĉo</B>, <B>~ego</B>, paunch, \"corporation\". <B>~oforma</B>, distended, ventricose. <B>~opleno</B>, b-full. <B>Dik~a</B>, corpulent, obese, potbellied. ➞ <I>abdomen, stomak, uter</I>.", "0"],
["vepro", "vepr-o", "brushwood, underwood, scrub. <B>~aĵo</B>, brake, copse, thicket. <B>~ejo</B>, the bush, brushwood-covered heath. <B>Sen~igi</B>, clear of undergrowth.", "0"],
["vera", "ver-a", "[UV] Tru/e, authentic, genuine, real, veritable. <I>~a amiko, diamanto, rakonto. ~a opinio montriĝas en ebrio</I>. <B>~o</B>, Truth. <I>La tempo malkaŝos la ~on. Amiko estas kara, sed ~o pli kara</I>. <B>~e</B>, -ly, candidly, frankly, genuinely, verily. ~epar0/-(re.s7&gt;o«/ -)i. <I>~e malsana. ~e ne!</I> <B>~aĵo</B>, fact, verity. <I>La ~aĵoj de religio, scienco</I>. <B>~eco</B>, t-fulness, genuineness, veracity. <I>Dubi, pruvi la ~econ de aserto</I>. <B>~igi</B>, confirm, <B>~ama</B>, sincere, t-loving. <B>~dire</B>, to tell the t., <B>~(dir)ema</B> (<B>~parola</B>), t-ful, veracious. <B>~ŝajna</B>, likely, plausible, probable, seeming. <I>~~eco</I>, verisimilitude, <B>Ne~~a</B>, unlikely. <B>Mal~a</B>, apocryphal, false, counterfeit, lying, mendacious, spurious. ~~a <I>kiel epitaĵo. ~~a atesto</I>, f. witness. <I>~~o,</I> lie, un-truth. <B>Pli~e</B>, more correctly, rather. <B>Sen~a</B>, devoid of t., unfounded, unjustified. <B>Vivo~a</B>, t. to life, realistic, vivid. ➞ <I>fals, ĝust, mensog</I>.", "0"],
["verando", "verand-o", "[OA] veranda, roofed portico of gallery.", "0"],
["veratro", "veratr-o", "white (false) Hellebore (<I>Veratrum</I>). ~o verda, green h., bear’s foot. ➞ <I>helebor</I>.", "0"],
["verbasko", "verbask-o", "Mullein, Aaron’s rod (Verbaseum). <B>Nigra ~o</B>, dark m.", "0"],
["verbeno", "verben-o", "<I>[OA]</I>, Vervain (<I>Verbena</I>).", "0"],
["verbo", "verb-o", "[UV] Verb. <B>~a</B>, -al. <B>~igi</B>. -alize. <I>~igi adjektivon</I>.", "0"],
["verda", "verd-a", "[UV] Green, verdant. <I>La ~a Stelo. ~aj fazeoloj, pizoj, pomoj</I>. Botel~(hel~mar~ musk~pom~smerald~)a. (mar) ~a flanko, starboard. <B>~en!</B> Starboard! <B>~o</B>, g. <B>~i</B>, be g. <I>~as la herbo en Majo</I>. <B>~aĵo</B>, g., verdure. <B>~aĵo</B> Pariza, (agr. hort) Paris g. (insecticide). <B>~eta (</B>iom ~a), -ish. Ee. ŝtono <B>~iĝas</B>, se ĝi longe ne moviĝas.", "0"],
["verdigro", "verdigr-o", "[UV] verdigris, green rust on copper. ~iĝi.", "0"],
["verdikto", "verdikt-o", "[OA] Verdict, finding of the jury, judicial decision (1 Rg 20/40). <I>Konfirmi, kontesti, skribi ~on</I>. <B>~i</B>, <I>liveri ~on</I>. ➞ <I>sentene</I>.", "0"],
["vergo", "verg-o", "[UV] <B>1</B> Rod, Stick; staff, switch, wand. <B>Ĉarpentista</B> <B>~o</B>, foot-rule. Fe~ (Sorĉ~)o, magic wand. Fera <B>~o</B>, r. of iron. Kurtena <B>~o</B>, curtain-r, tringle. Pedela verge. <B>Plat~o</B>, (typ) rule. <B>Raketa</B> <B>~o</B>, rocket-s. <B>Tambura</B> <B>~o</B>, drum-s. <B>Tir~o</B> (<I>puŝstango</I>), (org) s-er (➞ <I>pivotaĵ</I>). <B>Vid~o</B>, (surv) aim-post, range-pole. <B>~aĵo</B>, <B>~fasko</B>, bundle of ss (twigs etc.). ➞ <I>bastonet, branĉeto, stanget</I>. <B>2</B> (for punishment) Cane. <B>~i</B>, beat, birch, cane, flog, spank. <I>~i infanon</I>. ➞ <I>skurĝ, vip</I>.", "0"],
["veriso", "veris-o", "(bot) cowslip (<I>Primula veris</I>).", "0"],
["verki", "verk-i", "(<I>-n</I>), [UV] Writ/e, make (by mental labour). <I>~i libron, poemon, raporton</I>, compose (a. <I>komponi) muzikon, fugon</I>. <B>~o</B>, work, composition, opus, production writing. <I>La ~oj de Z. Ĉef~o (Majstro~o</I>), masterpiece. <B>~ado</B>, composition. <B>~aro</B>, complete (set of) works. <B>~eto</B>, booklet, pamphlet, sketch, treatise. <B>~into</B>, <B>~isto</B>, author, -er. <I>Dram~isto</I>, dramatist. <B>Re~i</B>, recast, rewrite, adapt, revise. ➞ <I>aŭtor, kre, kompon, skrib</I>.", "0"],
["vermiĉelo", "vermiĉel-o", "[UV] (cul) vermicelli,", "0"],
["vermiljono", "vermiljon-o", "(<I>artefarita cinabro</I>), Vermillion, red colour from cinnabar.", "0"],
["vermo", "verm-o", "[UV] <B>1</B> Worm. <B>2</B> grub, larva, maggot. <B>Sag~o</B>, arrow-w. <B>Ter~o</B> (<I>lumbriko</I>), earth-w. <B>Ventumila ~o</B>, fan-w. <B>f</B> <I>Enŝteliĝis en lian cerbon la ~o de dubo</I>. <B>~oj</B>, (med) ww. <B>~borita</B>, w-eaten. <B>Kontraŭ~aĵo</B> (<I>~icido, ~forigilo, ~pulvoro</I>), vermicide, vermifuge. <B>Sen~igi</B> <I>kampon</I>. ➞ <I>askarid, larv, nereid, raŭp, teni, tered</I>.", "0"],
["vermuto", "vermut-o", "[OA] <B>1</B> (bev) vermuth. <B>2</B> wormwood, various bitter plants, <B>f</B> bitterness. <I>La memoro estas ~o kaj galo</I> (PI 3/19, Am 6/12).", "0"],
["verniero", "vernier-o", "vernier, slide-gauge,", "0"],
["vernizo", "verniz-o", "Varnish, Glaze (us. from gum or rezin). ~o <I>alkohola, celuloza, kopala, olea, terebinta</I>, spirit-(celulose-copal-oil -turpentine-)v. Polura <B>~o</B>, French polish. <B>Ungo~o</B>. <B>~i</B>, (v., g.,) <I>pentraĵon (meblon</I>). <B>~ado</B>, v-(g-)ing. <B>~itaj</B> <I>ŝuoj</I>, patent-leather shoes. ➞ <I>glace, glazur, lak</I>.", "0"],
["veronalo", "veronal-o", "(pharm) veronal.", "0"],
["veroniko", "veronik-o", "speedwell, bird’s eye (<I>Veronica) &gt; bekabung</I>.", "0"],
["verso", "vers-o", "[UV] Vers/e. <B>1</B> line of poetry. <B>~ero</B>, foot. <B>~duono</B>, hemistitch, half-line of v. Dek~o, Kvar~o, 10-(4-)line stanza. <B>2</B> (a. <I>~aĵo</I>), v. in gen., piece of v. <I>~o libera</I>, free v. <I>~o senrima</I>, blank v. <B>~a</B>, in v. <B>~(far)i</B>, make (write) in v. <B>~aĉo</B>, doggerel. <B>~etoj</B>, light v. <B>(En)~igi</B>, -ify, put into v. <B>3</B> v. (of Bible, Koran, etc.). <I>Citi ĉapitron kaj ~on</I>. ➞ <I>stanz, strof</I>.", "0"],
["versto", "verst-o", "[UV] verst, Russian measure. (2/3 English mile).", "0"],
["verŝi", "verŝ-i", "(<I>-n</I>) [UV], Pour out (liquids), discharge. ~i <I>inkon en inkujon; lakton en kruĉon. ~i larmojn</I>, shed tears. <I>~i betonon,</I> lay (spray) concrete, <B>f</B> <I>~i mokon(sur</I>), p. ridicule (on). <I>~i dolĉan lumon</I>, shed soft light. <B>~iĝi</B>, fall (rain), flow. <B>~ilo</B>, -er, watering-can. <B>~isto</B>, cup-bearer, etc. <B>De~i</B> (<B>Trans~i</B>), p. off, decant. <B>Dis~i</B>, p. all over, diffuse, spill. EM, p. out, empty. <I>Edzino pli ~~as per funelo, ol edzo en~as per sitelo. ~~i sian sangon. (kor) ~~o</I>, effusion. <B>En~i</B>, p. into. <I>~~i novan energion en la movadon</I>. <B>Pri~i</B> (<B>Sur~i</B>), water, spray (<I>florojn), razenon, liton per larmoj</I> (Ps 6/6). <B>Super~i</B> (<I>inundi, kovri</I>), overflow, run over. <I>Kampo tute ~~ita</I> (flooded). <I>Pejzaĝo ~~ita</I> (bathed) <I>de sunradioj. ~~iĝi</I>, spill over. <B>Sang~o</B>, bloodshed. ➞ <I>pluvig</I>.", "0"],
["vertebro", "vertebr-o", "[UV] (<I>spinosto</I>), Vertebr/a. <B>~a</B>, -al. <B>~aro</B> (~a <I>kolono, spino</I>), spine, backbone. <B>~ulo</B>, -ate. <B>Sen~ulo</B>, invertebrate.", "0"],
["verticilo", "verticil-o", "(bot) whorl, verticil,", "0"],
["vertico", "vertic-o", "vertex, apex, highest part or point, top (of an angle, etc.).", "0"],
["vertiĝo", "vertiĝ-o", "(med) vertigo, dizziness, giddiness, swimming of the head.", "0"],
["vertikala", "vertikal-a", "[UV] Vertical, perpendicular (rel. to horizon), plumb, sheer, upright. ~o, <I>~(il)o</I>, v., plummet (Am 7/7; Jes 28/17; 34/11). <B>~e</B>, -ly, straight up and down. <B>~igi</B>, stand upright. ➞ <I>perpendikl</I>.", "0"],
["verto", "vert-o", "[UV] crown, pate, top of head (Ge 49/26; <B>2</B> Sa 14/25). <I>Frakasi ies ~on</I>. vertag-o (<I>melhundo</I>), badger-dog, basset- hound (<I>Canis vertagus</I>).", "0"],
["veruko", "veruk-o", "[UV] Wart (bot) gnarl, knobby growth on tree. <B>~eto</B>, verrucosity. <B>~ozo</B>, w-disease, e.g., <I>terpoma malsano</I>.", "0"],
["vervo", "verv-o", "[OA] verve, animation, \"go\", life, spirit, vim, zest. <I>Deklami, gesti, ŝerci kun ~o</I>. <B>~a</B>, breezy, lively, spirited. <B>~e</B> <I>paroli, marŝi, polemiki</I>. <B>Sen~a</B>, dull, flat.", "0"],
["vespero", "vesper-o", "[UV] Evening (Ge 1/5). <B>f</B> <I>Atingi la ~on de sia vivo</I>. <B>~a</B>, of the e., vesper. <I>~a Diservo, himno, stelo. ~a krepusko,</I> e-twilight, dusk, gloaming. <B>~e</B>, in the e. <I>Matenas</I>, <B>~as</B>, <I>kaj tago malaperas</I>. <B>~iĝas</B>, the day is drawing in. <B>~(iĝ)e</B>, at eventide, in the gloaming. <B>Antaŭ~o</B>, eve (of festival).", "0"],
["vesperto", "vespert-o", "[UV] bat (<I>Vesper tilio</I>). ➞ <I>noktol,plekot</I>.", "0"],
["vespo", "vesp-o", "[UV] Wasp (<I>Vespa</I>). <B>~(osimil)a</B>, <B>~(ec)a</B>, -ish. <B>~aro</B>, swam of ww. <B>~ejo</B>, w’s nest, <B>~otalia</B>.", "0"],
["vespro", "vespr-o", "vespers. <I>~a sonorilo</I>, vesper bell.", "0"],
["vestalo", "vestal-o", "vestal virgin.", "0"],
["vesti", "vest-i", "(<I>-n</I>) [UV], Cloth/e, Dress, Robe. <I>~i nudulon. Ne havi ion por sin ~i</I>, have nothing to wear. <I>Ĉifone ~ita</I>, d-ed in rags. <B>~o</B>, [UV] <B>~aĵo</B>, article of c-ing, apparel, d., garb, gar-(rai-)ment. <I>De~meti, sur~meti (Ŝanĝi) ~on. ~o multekolora</I>. <B>Kap~o</B>, head-gear. <B>Pied~o</B>, foot-wear. <B>Ŝtorm~o</B>, sou-wester. <B>~oj</B>, <B>~aro</B>, cc., outfit. <I>Sport~oj,</I> sporting outfit. <B>~aĉo</B>, cast-offs, duds, slops, tatters. <B>~ejo</B>, cloak-(d-ing)room; vestry. <B>~eto</B>, child’s d. <B>~iĝi</B> (<I>sin ~i</I>), c. one’s, d. <B>f</B> <I>La kampo ~iĝis per greno</I>. (th) <B>~istino</B>, d-er. <B>~faristo</B>, c-ier. <B>Ali~i</B>, disguise. <B>Mal~i</B> (<I>sen~igi) (-n</I>), un-d. <B>Sen~a</B>, naked. <B>~~iĝi</B>, un-d, disrobe, strip. <B><I>Danco</I> sen~iĝa</B>, strip-tease. <B>Super~o</B>, overall. [Do not say <B>\"Si</B> vestis (dressed!) <B>la botojn, (la jupon)\". Ŝi</B> <I>surmetis</I> <B>ilin</B> (put them on), <B>por vesti la piedojn (sin)]</B>.", "0"],
["vestiblo", "vestibl-o", "[UV] Vestibule, ante-chamber, entrance hall, lobby, (anat) <I>Kora ~o</I>.", "0"],
["veŝto", "veŝt-o", "[UV] waistcoat, vest. <I>Trikota ~o,</I> cardigan.", "0"],
["veterano", "veteran-o", "[OA] <B>~a</B>, veteran. <I>~a soldato,</I> old campaigner, fold hand.", "0"],
["veterinaro", "veterinar-o", "[OA] (<I>bestkuracisto</I>), veterinary surgeon.", "0"],
["vetero", "veter-o", "[UV] Weather. <I>~o bel-(j’rost-prin- temp-storm-)a</I>. ~informoj, w- forecasts (reports). ~a <I>stato</I>, w-conditns. ~oficejo, meterological office.", "0"],
["veti", "vet-i", "(<I>-n</I>, abs), [UV] Bet, Wager, lay, stake. <I>~i por ĉevalo</I>, back a horse. <I>~i, ke io (ne) okazos. ~i kontraŭ</I>, lay against. ~i <I>por kaj kontraŭ</I>, hedge. <B>~o</B>, b., w. <I>Gajn-(perd-)i ~on</I>. <B>~e</B>, for a w. <B>~aĵo</B>, -mono, stake. ~anto, punter. ~libro, betting book. ~ludi, gamble. ~peristo, bookmaker.", "0"],
["vetoo", "veto-o", "<B>veto</B>. ~o <I>absoluta, provizora</I>. <B>~i</B> <I>proponon</I>. <B>~rajto</B>. ➞ <I>malpermes, prohib</I>.", "0"],
["veturi", "vetur-i", "[UV] go (travel) by vehicle; Drive, fly, ride, sail. ~i <I>Oslon (al Oslo) per (sur) ŝipo, per (en) vagonaro. Sip~o,</I> voyage. <I>Aer~</I> ado, aviation. <I>Mar~ado,</I> navigation. ~anto, passenger. <B>~ebla</B>, negotiable (route, etc.). <B>~igi</B>, d., cart, carry, convey, transport. <I>~igisto</I>, driver, chauffeur, coachman (➞ <I>koĉer, ŝofor</I>). ~ilo, carriage, conveyance, vehicle. Aer ~ilo, air-craft. Ĉel~ilo, prison van. ĉerk~ilo, hearse. <B>glit~ilo</B> [UV] (<I>sledo</I>), sled(ge), sleigh, toboggan. Kirasa ~ilo, armoured vehicle. <B>Loĝ~ilo</B> (<I>Ruldomo</I>), caravan. <B>Puŝ~ilo</B>, barrow, push-cart. <B>Ŝarĝ~ilo</B> (<I>kamiono</I>), cart, dray, lorry, van. <B>Tram~ilo</B>, tramcar, streetcar. <B>Tren~ilo</B>, trailer. <I>~ila</I>, vehicular. <I>~ilaro,</I> traffic (<I>trafiko). ~ilejo</I>, cab-stand, coachhouse (<I>remizo</I>). Ĉirkaŭ~i, El~i, En~i, For~i, Kun~i, Preter~i, Re~i, Sur~i, Tra~i, d. round (out, into, away, with, past, back, on, through). Ek<B>~i</B>, set off, start out. (mot). <B>Sur-i</B>, run over. <B>Trans~i</B>, cross, pass over. <B>Pet~i</B>, hitch-hike. ➞ <I>fiakr, kaleŝ, navig, promen, rajd, vojaĝ</I>.", "0"],
["veziko", "vezik-o", "[UV] <B>1</B> Bladder: ~o <I>gala, piedpilka, urina</I>. <B>2</B> (<B>~eto</B>, <B>haŭt~o</B>), blister (<I>sur kalkano, pentraĵo</I>); flaw (<I>en vitro, metalo</I>). <B>3</B> bubble (<I>bobelo</I>): <B>Aer~o</B>, <B>sap~o</B>. <B>~iga</B>, vesicant. ➞ <I>kist, kolute</I>.", "0"],
["veziro", "vezir-o", "[UV] vizier, Turkish minister. <B>Ĉef~o</B>, grand-v.", "0"],
["vi", "", "[UV] You (sing, and pi), <I>~ estas</I> (a) <I>bela</I>, (b) <I>belaj</I>. <B>~a</B>, [UV] your (<I>libro). La libro estas ~a</I> (yours). <I>Mi amas</I> ~n. ~aflanke, as far as you are concerned, for your part.", "0"],
["viadukto", "viadukt-o", "[OA] viaduct.", "0"],
["viando", "viand-o", "[UV] Meat, flesh used, for food. <I>Ĝi estas nek ~o, nek fiŝo</I>. <I>Ĉevala ~o</I>. <B>~ejo</B>, butcher’s shop. <B>~isto</B>, butcher. <B>~ujo</B>, m-safe. <B>~omanĝa</B>, carnivorous. <I>Dieto sen~a</I>, m-less. ➞ <I>buĉ, karn, vegetar</I>.", "0"],
["vibri", "vibr-i", "(nt) [OA], Vibra/te, flutter, quiver. <I>~is kordo, sonorilo, la sono de flutoj</I>. <B>f</B> <I>Mil ĝojaj sentoj ~is en lia koro</I>. <B>~(ad)o</B>, vibration, tremor. <B>~(ant)a</B>, resonant, throbbing, v-nt. (phon) <I>~a</I> (a. <I>voĉa</I>), voiced (<I>konsonanto</I>). <B>~eco</B>, (med) fremitus (<I>fremito</I>). <B>~igi</B>, cause to v. <I>~igi la kordojn de la animo</I>, move the soul. <I>Tra~iga</I>, thrilling. <B>~ilo</B>, buzzer, vibrator. <B>~afono</B>, (m.i.) vibraphone. ➞ <I>balanciĝ, pendol</I>.", "0"],
["viburno", "viburn-o", "[UV] viburnum, wayfaring (mealy) tree (<I>V. lantana) &gt; opol</I>.", "0"],
["vicio", "vici-o", "(bot) vetch (<I>Vicia</I>). ➞ <I>latir</I> (= vetchling).", "0"],
["vico", "vic-o", "[UV] Line, Rank, Turn. <B>1</B> file, row, succession, suite (side by side, or one after another): <I>~o da arboj, domoj, soldatoj, veturiloj. La unua</I> ~o <I>de seĝoj</I>, row (tier) of seats, (chs, drs) rank. (org) rank, register, stop. <I>En ~o</I>, in line. <I>Po ses en ~o</I>, in ranks of six. <B>2</B> series of events: <I>~o de bataloj, eraroj, jaroj, malfeliĉoj</I>. <B>3</B> Turn, innings, rota: <I>Nun estas mia ~o. La parol~o estas al vi. Ĉiu</I> <B><I>sia~e</I></B>, in his turn. <B>~o</B>. <B>~aro</B>, ranks, rank and file. <I>La Filiŝtoj starigis siajn ~ojn. Densigi la ~ojn</I>, close the ranks. (bells) changes. <B>~a</B>, serial, successive. <B>(Laŭ)~e</B>, in turn, one after another, point by point, seriatim. <I>Atendi</I> <B><I>~e</I></B>, queue. <I>~e de (~~anstataŭ</I>). <B>~ego</B> (<I>da</I>), long string (of insults, words, etc.). <B>~igi</B>, align, range in lines. <B>(En)~iĝi</B>, fall into line, join the ranks., take one’s place. <B>Ekster~e</B>, out of turn. <B>Sorto~o</B>, vicissitude. <B>Unu~e</B>, in single file. <B>Unua~e</B>, foremost. <I>PFX:</I> Vice-: acting in place of, or second in rank to (another). <B>Vic-admiralo</B>, <B>~prezidento</B>. <B>~grafo</B>, viscount. <B>~reĝo</B>, viceroy. ➞ <I>len, seri, stif</I>.", "0"],
["vidi", "vid-i", "(<I>-n</I>), [UV] See, Sight. <B>1</B> be witness of, behold, set eyes on: <I>Mi ~as per la okuloj. ~i estas kredi. Aliajn gvidas, sed mem ne ~as. Ne ~i</I>, miss, not s., overlook, f <I>~i la infanojn de siaj infanoj</I>. (Ps 128/6). <I>~i ruĝe</I> (col), s. red. <I>~i la tombon (morti). Mi ~u!</I> Let me s.! <B>2</B> (<I>konstati</I>) (Ge 1/12): <I>Mi ~as, ke mi trompiĝis</I>. <B>3</B> (<I>kompreni, konscii): Mi ne ~as la signifon de tio</I>. <B>4</B> (<I>viziti): ~i muze-(pacient-)on</I>. <B>~o</B>, Sight, view. <I>~o flanka, fronta</I>. (mus) <I>Ludi le ~o</I>, at s. <I>~(pov)o</I>, eye-s, vision. <I>Havi bonan ~on, perdi la ~on. Cambro kun ~o</I> (outlook) <I>sur la maron</I> (with a seaview). <B>~aĵo</B>, s., scene, spectacle, view. <I>~aĵoj de Parizo</I>. <B>~a</B>, ocular, optic, visual. <B>~ebla</B>, clear, visible. <I>Okul~eble</I>, evidently, obviously. <I>Montri ~eble</I>, afford ocular proof. <I>~ebleco</I>, visibility. <I>~ebliĝi</I>, come into s. <B>Ne~ebla</B>, invisible. <B>~igi</B>, exhibit, show. <B>~iĝi</B>, appear, be evident (seen). <B>~ilo</B> (<I>lorneto</I>), spy-glass, etc. <B>~inda</B>, worth s-ing. <I>~indajo</I>, beauty spot, s. <B>~into</B>, eye-witness. <B>Antaŭ~i</B>, anticipate, fore-s. <I>~~ema</I>, fore-ing. <B>~enda</B>, that must be seen. <B>Ek~i</B>, catch s. of, descry, perceive. <I>~~o</I>, glimpse. <B>Inter~iĝo</B>, interview, meeting. <B>Laŭ~e</B>, by s. <B>Ne~ata</B>, unseen. <B>Ne~ema</B>, incurious, oblivious, un-ing. <B>Preter~i</B>, not notice, overlook, pass over. <B>Re~i</B>, s. agn. <I>Ĝis la ~~o!</I> au revoir! <B>Retro~a</B>, retrospective. <I>~~ilo</I>, rear-view mirror. <B>Sen~a</B>, s-less, without perspective. <I>~~eco,</I> visibility nil. <B>Tra~i</B>, s. through. <B>~~ebla</B>, limpid, pellucid, transparent. <I>Ricevi ~~on</I>, catch a glimpse through (4 FA 127/8). <B>Unua~e</B>, at first s. <B>~al~e</B>, face to face, facing (<I>fronte al</I>). ➞ <I>blind, dazl, diafan, okul, rigard, spekt, vizi</I>.", "0"],
["vidvo", "vidv-o", "[UV] Widow/er. ~(iĝint)a, -ed. ~ino, w. <I>~inon kaj orfon ne premu. Pajla ~ino</I>, grass widow (4 FA 224/29). <I>~inajoj (~ina vesto</I>), w’s weeds.", "0"],
["vigla", "vigl-a", "[UV] animated. <B>1</B> bright, fresh, keen: <I>~a humor-(vizaĝ-)o</I>. <B>2</B> lively, nimble, quick, spirited, sprightly: <I>~a danco, knabo, stilo</I>. <B>3</B> energetic, vigorous: <I>~a grup-(labor-trafik-)o. 4</I> alert, vigilant, wide-awake: <I>~a singardo</I>. ~e bright -(vigorously. with spirit, (mus) allegro. <B>~i</B>, be alive to. <B>~eco</B>, animation, vigour, vim. <B>~igi</B>, enliven, rouse, spur, stimulate. <I>Pli~igi la vivon de la grupo. ~igilo,</I> pick-me-up. ~iĝi, bestir one’s, brighten up. <B>~iĝu!</B> Look alive! <B>Mal~a</B>, apathetic, dull, heavy lifeless, spiritless. <I>~~a fajro,</I> slow fire. <I>~~eco</I>, prostration. <I>~~igi,</I> deaden, depress, enervate, take the life out of. <B>Re~igi</B>, put new heart into, re~ate, revive. ➞ <I>energi, viv</I>.", "0"],
["vikario", "vikari-o", "[UV] <B>1</B> deputy, substitute (for official). <B>2</B> (ecc) curate. ~a vicarious. <B>~i</B>, act as <I>~o</I>. <B>~eco</B>, curacy. ➞ <I>anstataŭ [Ne= parohestr]</I>,", "0"],
["vikingo", "viking-o", "viking. ~edzino (4 FA 24/6).", "0"],
["viktimo", "viktim-o", "[OA] Victim <B>1</B> (<I>oferato</I>) of sacrifice. <B>2</B> (<I>suferanto</I>) of cruelty, hardship, etc. <I>~o de milito, trompo</I>. ➞ <I>trompit</I>. <B>~igi</B>, -ize.", "0"],
["vikuno", "vikun-o", "vicugna (<I>Lama vicugna</I>). ~a <I>lano</I>.", "0"],
["vilaĝo", "vilaĝ-o", "[UV] Villag/e. <B>~a</B>, v., rural, rustic. <B>~ano</B>, [UV] -er, <B>~ego</B>, important village, small town. <B>~estro</B>, squire. <B>~eto</B>, hamlet. <B>~ulino</B>, country lass (woman). ➞ <I>kamparan</I>.", "0"],
["vilao", "vila-o", "(<I>kampdomo, somerdomo</I>), villa, cottage, country house, summer residence.", "0"],
["vilo", "vil-o", "[UV] villus (<B>~oj</B>, villi), slender soft hair on fruit, plant, skin, etc. <I>~oj intestaj</I>. ~a (<I>harkovrita</I>), villous, hairy, shaggy, hirsute, untrimmed. <I>~a barbo, brovo, felo, homo, kapro</I> (Da 8/21). <B>~aĵo</B>, mat, tangle. <B>~eco</B>, villosity. <B>~igo</B>, buffing (shoe). ➞ <I>har, hirt, tuf</I>.", "0"],
["vimeno", "vimen-o", "(<I>salika tigo</I>), Osier, shoot of Willow. <B>~a</B> <I>ligilo</I>, osier-tie, binder, withy. <I>~a tego</I>, o-covering, e.g., of bottle. <I>~a vergo</I>, willow-sprig. <B>~aĵo</B>, willow-basket, willow-work. <B>~ejo</B>, o-bed.", "0"],
["vinagro", "vinagr-o", "[UV] Vinegar. <B>~a</B>, -ary. <B>f</B> cantankerous, crabby. <I>~a konservaĵo,</I> pickle. <I>~a humoro. Havi ~on en la mieno</I>. preserve in (season with) v. <B>~ujo</B>, v-cruet. ➞ <I>acid, malafabl, maldolĉ</I>.", "0"],
["vinbero", "vinber-o", "[UV] Grape. <B>sek~o</B> [UV] (<I>rosino</I>), raisin. <B>Sek~eto</B> (<I>korinto</I>), currant. ~aro (<I>grapolo</I>), bunch of grapes. ~ejo (<I>vitejo</I>), vineyard. ~ujo (<I>vito</I>), vine.", "0"],
["vinĉo", "vinĉ-o", "(<I>tirlevilo, turnlevilo</I>), winch, mine- hoist, winding-drum. <I>Ankra ~o (vindaso</I>), windlass. ➞ <I>kapstan</I>.", "0"],
["vindaso", "vindas-o", "(mar) windlass. <I>Vapor~o,</I> donkey-engine, steam-winch.", "0"],
["vindi", "vind-i", "[UV] (<I>ĉirkaŭvolvi</I>), Swaddl/e, wind (wrap) round, <I>~ita per morta tolaĵo</I>. ~(aĵ)oj, -ling-clothes. <I>Ankoraŭ en ~oj,</I> not yet shortened, f <I>~oj</I> (trammels) <I>de superstiĉo</I>. <B>~iĝi</B>, coil (twine) round. <I>Sia robo ~iĝis ĉirkaŭ ŝiaj kruroj</I>. <B>Ĉirkaŭ~ita</B> (Lk 2/12). <B>El~igi</B>, free from restraint. <I>~~iĝi</I>, extricate one’s from difficult situation. <B>Trans~i</B> <I>suĉinfanon, bebon</I>, change nappies. <B>~infano</B>. ➞ <I>bend, imbrik</I>.", "0"],
["vinjeto", "vinjet-o", "[OA] (typ) vignette, tail-piece, ornamental cut or border.", "0"],
["vinko", "vink-o", "[OA] (bot) ‘periwinkle (<I>Vinca</I>) (2 FA 58/37).", "0"],
["vinkto", "vinkt-o", "[OA] rivet (for china) (2FA108/11), clip, paper-fastener, snap (for gloves). ➞ <I>agraf, nit</I>.", "0"],
["vino", "vin-o", "[UV] Wine. <I>~o blanka, ruĝa; dolĉa. seka; grosa, oranĝa</I>. <B>Miel~o</B>, (<I>medo</I>), mead. <B>Pir~o</B>, perry. <B>Pom~o</B> (<I>cidro</I>), cider. <B>~(ec)a</B>, vinous. <B>~ejo</B>, <B>~kelo</B>, wine-cellar, vault. <B>~isto</B>, butler, cellarer. <I>~istestro</I> (Ge 41/9), chief cupbearer. <B>~vendisto</B>, w-merchant, vintner. ➞ <I>most</I>.", "0"],
["vintro", "vintr-o", "[UV] Winter. <I>Kiu taŭgas por somero, ne taŭgas por ~o</I>. <B>~a</B>, w. <I>~a sezono, vesto, vetero</I>. <B>~e</B>, in the winter. <B>~ado</B>, wintering. <B>(Tra)~i</B>, pass the w. <B>~eca</B>, wintry. <B>~ejo</B>, w-quarters. <B>Tra~iĝi</B>, (plants) survive the w. <B>~odormi</B>, hibernate. <B>~omeza</B>, midwinter.", "0"],
["violo", "viol-o", "[UV] Violet (Pansy, viola). <B>~o hirta</B>, hairy v. (<I>V. hirta). ~o</I> hunda, dog v. (<I>V. canina</I> and <I>riviniana</I>). <B>~o kampa</B>, field v. (<I>V. arvensis</I>). <B>~o korna</B>, garden v. (<I>V. cornuta</I>). ~o marĉa, marsh v. (<I>V. palustris). ~o</I> odora, sweet v. (<I>V. odorata</I>). <B>~o trikolora</B> (<I>penseo</I>), p., heartsease (<I>V. tricolor</I>). <B>~eta</B>, <B>~kolora</B>, violet (colour). <B>Preter~a</B>, <B>Trans~a</B>, <B>Ultra~a</B>, ultraviolet.", "0"],
["violonĉelo", "violonĉel-o", "[UV] violoncello.", "0"],
["violono", "violon-o", "[UV] Violin, fiddle. <I>Se vi prenis ~on, prenu ankaŭ la arĉon</I>. <B>~i</B> (<I>ludi ~on</I>), <B>~aĉi</B>, scrape. <B>~isto</B>, -ist. <I>Ĉef~isto</I>, leader of orchestra. <B>~ujo</B>, v-case. <B>Ald~o</B>, viola. <B>Bas~o</B> (<I>kontrabaso</I>), double-bass, <B>Najl~o</B>, nail-v.", "0"],
["vipo", "vip-o", "[UV] Whip, lash. <B>~i</B> (<I>-ri</I>), (beat with) whip, lash, <B>f</B> <I>Hajlo ~is lian vizaĝon. Herbo ~ata de la vento</I>. <B>f</B> criticize caustically, unmercifully. <I>Li ~is ĉiun per mokaj vortoj</I>. <B>~egi</B>, flog, thrash. <B>~eti</B>, touch with the w. <B>~krako</B>, crack of w. <B>~stango</B>, <B>~tenilo</B>, grip (stock) of whip. <B>~ŝnuro</B>, w-thong. ➞ <I>skurĝ</I>.", "0"],
["vipuro", "vipur-o", "[UV] Viper (<I>Vipera). Veneno de ~o</I> (Ps 140/3). <I>Piki kiel ~o</I> (Se 23/32; Ag 28/3). <B>Pufa ~o</B> (<I>bitiso</I>), puff adder (<I>Bitis</I>). <B>f</B> <I>Lango</I> <B>~a</B>, venomous tongue. <B>~edoj</B>, viperidae. <B>f ~idoj</B> (Mt 23/33, Lk 3/7). ➞ <I>aspid, cerast, kolubr</I>. <B>Rim</B>.: Diru <I>vipuro</I>, ne <I>vipero</I> (Z, LR /45).", "0"],
["virga", "virg-a", "[UV]. <B>1</B> Virgin, chaste: <I>~a fraŭl(in)o</I>. <B>2</B> Unexplored, uncultivated, untouched, fresh: <I>~a arbaro, tero</I>. <B>3</B> pure, spotless: <I>~a koro. ~a blanko de neĝo. ~a bluo de la ĉielo</I>. <B>~eco</B>, -ity. <I>Konservi sian ~econ</I>. <B>~ulino</B>, v., maid. <I>La Sankta ~~ino</I>. <B>mal~igi</B>, [UV] deflower, dishonour, rape, ravish, vioiate. ➞ <I>cast, pur, makul, virt</I>.", "0"],
["viro", "vir-o", "[UV] <B>1</B> (<I>virseksulo</I>), male (opposite female). <B>2</B> Man (opp woman). <B>3</B> Man, adult (opp child). <B>~(ec)a</B>, male, manly, masculine, virile. <I>~a sekso (vizaĝo</I>). (pros) masculine, ending with stressed syllable. <B>~eco</B>, [UV] virility, etc. <B>~eto</B>, little man, whipper-snapper. <B>~iĝi</B>. attain puberty, grow up, reach ra-hood. <I>~(iri)iĝanta</I>, adolescent. <B>~iĝinto</B>, adult. <B>~ino</B>, [UV] Woman, female. <I>~ino bela (saĝa). ~o kaj ~ino</I> (Ge 1/27). <I>Krom~ino,</I> concubine. <I>~ina</I>, w-ly. <I>~ina amemo (babilemo). ~inaro</I>, w-kind. <I>~~ato</I>, hag. <B>~ineco</B>, [UV] femininity, <I>~inejo</I> (Es 2/9), w’s quarters, harem, etc. <B>Mal~a</B>, <B>Ne~a</B>. <B>~ineca</B>, effeminate, unmanly. <B>~aspekta</B>, mannish. <I>PFX:</I> Male. ~bestoj kaj ~inbestoj (Ge 7/3). <B>~bovo</B>, bull. <B>~ĉevalo</B>, stallion. <B>~infano</B>, male child. <B>~ŝafo</B>, ram. ➞ <I>horn, in, maskl</I>.", "0"],
["virto", "virt-o", "[UV] Virtu/e, moral excellence, uprightness. <I>El neceso fari ~on. Pli bona ~o sen oro, ol oro sen ~o</I>. <B>~a</B>, -ous, good, righteous, upright. <I>~a ag-(edzin-)o</I>. <B>~ulo</B>, -ous person, good man, Mal<B>~o</B>, vice. ~<B>~a</B>, depraved, vicious, wicked. <I>~~igi</I>, corrupt, pervert. <I>~~ulo</I>, evil-doer, <I>Niaj ~oj ofte estas maskitaj mal~oj</I>. ➞ <I>cast, moral</I>.", "0"],
["virtuala", "virtual-a", "virtual, for practical purposes, though not formally or actually. <I>~a promeso</I>. <B>~e</B>, -ly, as good as, to all intents and purposes.", "0"],
["virtuozo", "virtuoz-o", "[UV] Virtuos/o, brilliant perform-(play-)er; artist with outstanding talent. <B>~eco</B>, -ity.", "0"],
["viruso", "virus-o", "Virus. ~a malsano. Kontraŭ<B>~a</B>, anti-v. ➞ <I>bakteri, malign</I>.", "0"],
["viscero", "viscer-o", "viscus, internal organ. ~oj, viscera.", "0"],
["viskio", "viski-o", "[OA] whisky.", "0"],
["visko", "visk-o", "[OA] mistletoe (<I>Viscum album</I>).", "0"],
["viskoza", "viskoz-a", "Visc-id, -ous; glutinous, gluey, sticky. <B>~eco</B>, -osity. <B>~iĝi</B>, become v., jell, thicken.", "0"],
["vistario", "vistari-o", "(bot) wistaria (<I>Wistaria</I>).", "0"],
["visto", "vist-o", "[OA] (cgm) Whist. ~rondo, ~turniro, w-drive.", "0"],
["viŝi", "viŝ-i", "[UV] Wipe (clean, dry, mop up) (Lk 7/38). <I>~i fenestron, frunton, nazon, vizaĝon</I>. <B>~ilo</B>, [UV] w-er, clout, dish-cloth, sponge, etc. Man~ilo (<I>mantuko</I>), towel. Plum~ilo, pen-wiper. Polvo~ilo, duster. <B>El~i</B>, w. clean. <I>~~i pladon</I> (2 Rĝ 21/13. <B>For~i</B>, obliterate, w. (rub) away (off, out). <I>For-i larmojn, ŝuldojn, panerojn</I>. f <I>Ne for~u miajn bonajn agojn</I> (Ne 13/14). <I>For~ita de la tempo</I>.", "0"],
["vitala", "vital-a", "(<I>vivesenca</I>), (phi). Vital. ~ismo, -ism.", "0"],
["vitamino", "vitamin-o", "vitamin.", "0"],
["vitelo", "vitel-o", "Vitellus, Yolk of egg. ~ino, -ine. <I>~a membrano</I>, y-sac.", "0"],
["vito", "vit-o", "(<I>vinberujo</I>), (grape-)Vine (<I>Vitis ampelos). ~o sovaĝa</I>, wild v. ~ejo, v-yard. -kultivado, viticulture. ~Ŝimo (<I>melduo</I>), v-mildew. ➞ <I>grapol, vinber</I>.", "0"],
["vitralo", "vitral-o", "leaded light, stained-glass window. <I>~a fenestro</I>, latticed window.", "0"],
["vitrino", "vitrin-o", "(<I>vitroŝranko</I>), <B>1</B> shop-window. <B>2</B> glass show-case (cabinet).", "0"],
["vitriolo", "vitriol-o", "[UV] (H<SUB>2</SUB>S0<SUB>4</SUB>), Vitriol, concentrated sulphuric acid. ➞ <I>sulfat</I>. <B>~a</B>, f -ic, scathing, extremely caustic. <I>~a plumo</I>.", "0"],
["vitro", "vitr-o", "[UV] <B>1</B> Glass (substance). <I>~o klara, polurita. Botel~o. Dom~o</I>, sheet (window) g. <I>Drat~o</I>, wired g. <I>Plumba ~o (flinto</I>), flint g. <I>Nesplitebla ~o</I>, safety g. <B>2</B> Obj of g. <I>Fenestra ~o</I>, window pane. <I>Grandiga ~o (lupeo</I>), magnifying glass. <B>okul~oj</B>, [UV] eyeglasses, spectacles. <I>Sun~~oj</I>, sunglasses. <B>~a</B>, of glass. <B>~a <I>domo, lano, okulo, papero</I>. ~a <I>glaso,</I></B> glass tumbler. <B>~a <I>ŝranko</I> (<I>vitrino</I>). ~a <I>vergo</I></B>, glass rod. <B>~(iz)i</B>, provide with glass, glaze. <B>~aĵo</B>, g-object. <B>~aĵaro</B>, g-ware. <B>Tuba ~aĵeto (bido)</B>, bugle. <B>~eca</B>, -y, hyaline, vitreous. <B><I>~eca okulo, rigardo</I>. ~isto</B>, glazier. <B>~igi</B>, <B>~iĝi</B>, glaze, vitrify, <B>f <I>Larmoj ~igis ŝiajn pupilojn</I></B>. ➞ <I>flint, glas, glazur, kraŭn, silikat</I>.", "0"],
["vivi", "viv-i", "(nt), [UV] <B>1</B> Liv/e, be Alive, have Life: <I>~i nur unu tagon. Oni devas manĝi por ~i</I>. ~u (Long 1.) <I>la reĝo! Tosti</I> <B>~uon</B>, <B>~ui</B>, (4 FA 213/11) cheer, hurrah. <B>2</B> remain alive, endure, last: <I>Kiu ~os, tiu vidos</I>, 1. and learn, time will show. <I>~u kaj lasu ~i</I>. <B>3</B> remain in memory: <I>Lia nomo ~os eterne</I>. <B>4</B> manage, maintain 1., subsist (on): ➞ <I>sin teni. ~i bone, lukse, malriĉe; de sia plumo (rentoj</I>). <B>5</B> conduct one’s 1.; <I>~i emerite, honeste, pie, virte</I>. <B>6</B> (<I>loĝi</I>) dwell: <I>~i kun amiko, en urbo</I>. <B>~o</B>, Life. <I>~o bonfara, estonta, intelekta. Perdi la ~on. Esti inter ~o kaj morto</I>. <B>~aranĝo</B>, <B>~maniero</B>, 1., activities, existce. <I>~o aktora, artista, serioza</I>, <B>~a</B>, 1 (~anta), -ing, that -s. <I>Pentri laŭ ~a modelo</I>. <B>2</B> (<B>~eca</B>, <B>~ema</B>, <B>~oplena</B>), -ly, vital, vivid. <I>~a disputo (simpatio</I>). <B>~e</B>, with life, brightly, (mus) vivace. <B>~adi</B>, l. on. <B>~aĵo</B>, -ing thing. <I>La</I> <B>~antoj</B> <I>kaj la mortintoj</I>, the quick and the dead. <B>~eco</B>, animation, vitality, vivacity. <B>~eca</B>, sprightly, <B>~ega</B>, impetuous, vigorous. <B>~eti</B> (<I>vegeti</I>), just exist, keep body and soul together, l. sparingly. <B>~iga</B> (<B>~dona</B>), life-giving. <I>~igi</I>, give life to, animate, quicken, vivify. <I>~igi la fajron</I>. <B>~iĝi</B>, become a. <B>~ulo</B>, -ing being. <B>~okapabla</B>, <B>~ipova</B>, <B>~iva</B>, able to live, capable of life, viable, <B>~rimedoj</B>, <B>~pano</B>, <B>~(sub)teno</B>, <B>por~aĵoj</B>, means of -lihood, maintenance, sustenance. <B>Dum~a</B>, for life. <I>~~a puno</I>, life-sentence. <B>Ĝis~i</B> (<I>atingi</I>), live to see (till); attain, reach. <B>~~</B><I>i la centan jaron</I>. <B>Kun~i</B>, live together., co-exist (-habit). <I>~~ant(in)o</I>, companion, consort. life-partner. <B>Mal~a</B>, dead, not a. ~~e <I>naskita,</I> still-born. <B>Post~i</B>, <B>Trans~i</B>, <B>1</B> outlast, outlive: <I>Post~i la filon</I>. <B>2</B> live after death. <I>Lia influo, memoro, verkaro lin ~~os</I>. <I>~~o</I>, after-1. <B>Por~aĵo</B>, livelihood <B>Re~i</B>, relive, l. again. <I>~~igi</I>, bring back to life, raise from the dead, resuscitate, revive. <I>~~igi droninton</I>. <B>~iĝo</B>, resurrection. <B>Sen~a</B> (a. <B>mal~a</B>), -less, inanimate. <B>~~aĵo</B>, -less object. <I>~~igi</I>, deprive of life, kill. <I>~~iga,</I> deadening. <B>Tra~i</B>, 1. (pass) through, experience, meet. <I>~~i epokon, sperton</I>. <B><I>~~aĵo</I></B>, experience. <B>Bon~o</B>, 1. of pleasure, good -ing. <I>~~anto, bon vivant</I>, person who enjoys life. <B>Kvazaŭ~a</B>, 1-like. <B>Long~eco</B>, longevity. ➞ <I>anim, ekzist, vigl</I>.", "0"],
["vivisekcio", "vivisekci-o", "[OA] vivisection. <B>1</B> = <I>vivisekcado</I>. <B>2</B> s. experimental actions on living animals.", "0"],
["vizaĝo", "vizaĝ-o", "[UV] Fac/e, countenance, look, visage, (col) phiz. mug. <I>Bela ~o. Nur pano kun fromaĝo, sed afabla ~o</I>. <I>~o kontrau ~o</I>, face to face. <I>Turni al (Forturni de) iu la ~on. Diri al iu rekte en la ~o</I> (to his face). <I>Rigardi la morton en la ~o (fronti la ~on</I>). <B>f</B> <I>La ~o de la tero</I>. (col) <I>fari sian ~on</I>, make up. <B>~a</B>, -ial. <B>~eto</B>, (pretty) little face. <B>Du~a</B>, twofaced. ➞ <I>fizionomi, mien, trajt</I>.", "0"],
["viziero", "vizier-o", "[UV] vizor, beaver (of helmet), peak (of cap). ➞ <I>bek, kasked</I>.", "0"],
["vizio", "vizi-o", "[OA] Vision, apparition, imagined or supernatural appearance. <I>~o de poetoj. Nokta ~o</I>, v. of the night. <I>Li diris al Abram en ~o</I> <B>(</B>Ge 15/1, Jes 1/1). <B>~a</B>, -ary, fanciful. see in a vision, have visions. <I>Profetaĵo kiun ~is Miĥa</I> (Mi 1/1). <B>~ulo</B>, -ary, dreamer. ➞ <I>aper, fantazi, utopi</I>.", "0"],
["viziti", "vizit-i", "(<I>-n</I>), [UV] Visit. <B>1</B> Call on, go to see: <I>~i amikon, muzeon, urbon</I>. ~i (attend) <I>pacienton</I>. <B>2</B> (<I>ĉeesti</I>), attend: <I>klinikon, preĝejon, spektaklon</I>. <B>~o</B>, v., call. <I>~o ceremonia, formala, kondola, oficiala. ~o de kuracisto (pastro). Mizero faras ~on, ne atendante inviton</I>. <B>~adi</B> kurson (lernejon). <B>Rond~ado</B>, round (<I>de kuracisto, laktisto</I>). <B>~anto</B>, -or, caller. <I>Someraj ~antoj</I>. <B>Ne~ata</B>, lonely, sequestered, unfrequented. <B>Tre~ata</B>, well attended, etc. <B>~ejo</B>, room for -ors. <B>~isto</B>, district -or.", "0"],
["vizo", "viz-o", "[OA] Visa. <B>1 ~i</B>, v., endorse (<I>pasporton</I>), countersign (<I>dokumenton</I>), certify (<I>ĉekon</I>).", "0"],
["vizono", "vizon-o", "American Mink (Mustela vison). <B>~pelta mantelo</B>, m. coat. ➞ l<I>utreol, mustel</I>.", "0"],
["Vjetnamujo, Vjetnamio", "Vjetnam-ujo, Vjetnamio", "VN.", "0"],
["vjolo", "vjol-o", "(<I>praviolono</I>), viol. <I>Bas~o</I>, viola da gamba.", "0"],
["Vo", "V-o", "[F], letter V. <I>Duobla vo =</I> W. <I>V-fero, V-junt, V-noĉo, V-tegment-o</I>, V-iron (-joint -notch-roof). ➞ <I>angul</I>.", "0"],
["voĉo", "voĉ-o", "[UV] Voice. <B>1</B> (<I>sono</I>): ~o <I>dolĉa, forta, sincera, de birdo. Levi (perdi) la ~on</I>. <B>2</B> (<I>parolo</I>): <I>obei la ~on de Dio</I>. <B>f</B> <I>La ~o de konscienco (prudento), de la popolo, maro, ŝtormo. La ~o de la sango de via frato</I> (Ge 4/10). <B>3</B> (mus) Part: ~o <I>soprana (tenora</I>). <B>Kvar~a</B> <I>kanto</I>, four-part song. <B>Plur~a</B> <I>kanto</I>, part-song. Fugo por 5 ~oj. <B>4</B> (<I>~dono</I>), vote, expression of opinion: Decida <B>~o</B>, casting vote. 10 ~oj kontraŭ 9. Akcepti proponon ĉies~e, ĉiu~e, unu~e (unanimously). ➞ <I>unuanim</I>. <B>5</B> (gram) v. of verb: ~o aktiva (pasiva). <B>~a</B>, oral, vocal. ~a instruo (muziko). Legi <B>~e</B>, vocally, viva voce. Proklami ~e kaj skribe. <B>~(don)i</B>, vote. Mi ~as por Aprilo! <B>~donrajto</B>. <B>~done</B> <I>superita</I>, out-voted. <B>Duon~e</B>, <B>mez~e</B>, <B>sub~e</B>, in a low voice. (undertone), sotto voce, under one’s breath. <I>Krii</I> <B>laut~e</B>, <B>plen~e</B>, shout at the top of one’s voice. <B>Mult~a</B>, <B>Plur~a</B>, polyphonic. <B>Sen~a</B>, dumb, mute, speechless, (phon) <B>~~a</B>, (breathed, voiceless) konsonanto. ➞ <I>balot, kri, mut, vok</I>.", "0"],
["vodevilo", "vodevil-o", "vaudeville, light comedy with song.", "0"],
["vodko", "vodk-o", "vodka, Russian rye brandy.", "0"],
["vojaĝi", "vojaĝ-i", "[UV] (make a) Journey, Travel; (<I>birdoj</I>) migrate. <B>Rim</B>.: Wider meaning than \"vojage\". <I>~i aeroplane, omnibuse, ŝipe, vagonare. ~i eksterlande. Multe ~i,</I> get about a good deal. (<I>Dum</I>)<B><I>~e</I></B>, while t-ling. <B>~o</B>, j., trip. <I>~o esplora, feria, plezura</I>. <B>Mar~o</B>, (sea) vojage. <B>Prova ~o</B>, trial trip. <B>Rond~o</B>, circular tour, round trip. <I>Bonan ~on!</I> a pleasant j.! <B>~a</B> <I>kosto, kostumo</I>. <B>~ado</B>, t-ling. <B>~anto</B>, t-ler. <I>Pendola ~anto</I>, commuter. <B>Kaŝ~anto</B>, stowaway. <B>~ema</B>, fond of t. <B>~eto</B>, trip. <I>Komerca</I> <B>~isto</B>, (<I>~anta komizo</I>), commercial traveller. <B>Ek~i</B>, set out (start off). <B>Tra~i</B>, traverse. <B>Mult~inta</B>, t-led. <B>Pied~i</B>, hike. ➞ <I>migr, vagabond, vetur, vojir</I>.", "0"],
["vojevodo", "vojevod-o", "voyivode, Slavonic governor.", "0"],
["vojo", "voj-o", "[UV] Way, Path, Road, Track. <I>La~o al Bath. ~libera, pavimita</I>. <B>Alira ~o</B>, drive, gateway. <B>Aŭto~o</B>, motorway. <B>Batita ~o</B>, beaten track. <B>Brut~o</B>, drove-road. <B>Cikla ~o</B>, cycle-path. <B>(Ne)ĉefa ~o</B>, Major (minor) road. <B>fer~o</B>, [UV] railway. <I>Zona ~~o</I>, circle ry. <B>Flug~o</B>, air-route. <B>Grund~o</B>, field t. <B>Kava ~o</B>, sunken road. (astr) <B>Lakta V~o</B>, milky way. <B>Lika ~o</B>, leakage path. <B>Mul~o</B>, mule track. <B>Pied~o</B>, foot-p, walk. <B>Publika ~o</B>, thoroughfare. <B>Rajd~o</B>, bridle-path, ride. <B>Spur~o</B>, track. <B>Sub~o</B>, subway. <B>Super~o</B>, viaduct, etc. <B>Trafika ~o</B>, arterial r. <B>Tren~o</B>, tow-p. <I>Malfermi (trabati al si) ~on. Montri la ~on</I>. <B>f</B> <I>Fari (Iri) sian ~on. Iri la ~on de ĉio tera (= morti</I>). <B>2</B> path of moving object. e.g. <I>planed~o, river~o, vent~o</I>. means of attaining end: <I>La ~o ĝusta, irenda, de prudento. Ni iru la ~on celitan. Li trovis ~on al mia koro. Kie estas volo, tie estas ~o</I>. <B>~e</B> (<I>per ~o) de,</I> via. <B>~(ir)i</B>, be on one’s w. <I>Hundo bojas, homo ~as</I> (P). <B>~eto</B>, p., passage. <B>~isto</B>, road-labourer (r-mender). <B>~ulaĉo</B>, guttersnipe, tramp. <B>Apud~a</B>, roadside, wayside. <B>De~iĝi</B>, <B>~erari</B>, be on the wrong track, go astray, lose one’s way. <I>De~iĝema</I>, froward. wayward, perverse. <B>Dis~iĝo</B> (<B>~forko</B>), fork of the road. <B>Sur~e</B>, en route, on the way. <B>Duon~e</B>, <B>Mez~e</B>, halfway, midway. ➞ <I>irej, manier, pad, strat, ŝose, vojaĝ</I>.", "0"],
["vokalo", "vokal-o", "[UV] Vowel (<I>a, e, i, o, u</I>). <B>~izi</B>, -ize. <B>Duon~o</B>, semi-v (<I>j, u</I>). (sten) <I>~o enŝovita</I> (interpolated).", "0"],
["vokativo", "vokativ-o", "[OA] (gram) vocative case.", "0"],
["voki", "vok-i", "(-<I>n, al</I>) [UV], <B>1</B> Call to, cry out: <I>~i al amik-(hundo, fiakristo. ~u pli laŭte! Ne ~u diablon, ĉar li povas aperi</I>. <B>2</B> call in, ask (invite) to appear (come, visit): <I>~i kuraciston, pastron</I>. <B>3</B> call upon, appeal to, invite, summon (<I>por devo, al ofico): ~i al batalo, al Dio por helpo. Dio (la devo, la konscienco) min ~as. Multaj ~itoj, sed ne multaj elektitoj</I>. <B>~o</B>, call, summons. <I>Li ne aŭdis mian ~on</I>. <B>~egi</B>, shout. <B>Al~i</B>, appeal to, invoke. ~<I>~ iun kiel atestanton</I>. <I>~~o</I>, appeal, entreaty, invitation, invocation. <I>~iteco</I>, vocation. <B>El~i</B>, <B>1</B> c. forth (out): elicit, evoke. ~~i <I>iun al ludo, mortinton per sorĉo</I>. <B>2</B> (<I>veki</I>): bring into being, cause, excite. <I>~~i emocion, intereson, malpacon, ridon, skandalon. ~~iva,</I> evocative. <B>Kun~i</B>, call together, convoke. ~~i <I>amikojn, komitaton, kunvenon. ~~o,</I> convocation. <B>Re~i</B>, call again (back), recall, repeal, revoke. <I>~~i senditon; al la memoro; en memoron</I>. <B>Ne~~ebla</B>, irrevocable. <B>Kontrol~o</B>, <B>Nom~o</B>, muster, rollcall. ➞ <I>apel, kri, nom, vol</I>.", "0"],
["vokto", "vokt-o", "taskmaster, overseer, supervisor (of forced labour) (El 5/6).", "0"],
["volano", "volan-o", "(<I>plumpilko</I>), (gm) shuttlecock, <B>~ludo</B>, badminton. ➞ <I>raked</I>.", "0"],
["Volapuko", "Volapuk-o", "Volapük. <I>Tio estas por mi ~aĵo</I>, That is all Greek to me. ~isto.", "0"],
["volatila", "volatil-a", "(<I>vaporiĝema</I>), volatile.", "0"],
["volbo", "volb-o", "Arch(way), Vault(ing). <I>~o de katedralo (la ĉielo</I>), <B>Eĝ~o</B>, groined a. <B>~a</B>, arched, vaulted. (person) stooping. <B>~i</B>, a., v. <I>La blua ĉielo ~is super ni. La kato</I> ~igis <I>la dorson</I>. <B>~iĝo</B>, bend, curve (of a.). ➞ <I>ŝton</I>.", "0"],
["volframo", "volfram-o", "(chem) Wolfram (W) (a. <I>tungsteno</I>).", "0"],
["voli", "vol-i", "(<I>~n, -i</I>) [UV] <B>1</B> Will (use w-power), choose, determine, have a mind, mean (to realize an aim): <I>Kiu ~as, tiu povas. Mi ~as, ke vi iru</I>, I mean you to go. <B>2</B> Desire, like, want, wish for: <I>Se vi ~as</I>, if you like. <I>Kiom vi ~as</I>, as much as you like. <I>Ĉu vi ~us iri?</I> Would you like to go? <I>Mi ~as (iri) malsupren</I>. (4 FA 140/11,19). <I>Faru kiel vi ~as</I>, Do as you please. <I>Dio ~u!</I> Please God! <I>Kion vi ~as?</I> What do you want? Ne demur, hold back, object. <I>Li ne ~as pagi</I>, he won’t pay. <B>~o</B>, w., choice. <I>~o energia, forta, libera. Laŭ la ~o de Dio</I>, as God wills. ~(it)a, conscious, intentional. <I>~a ago (movo</I>). ~e (<I>aŭ) ne</I> <B><I>~e</I></B>, whether one likes or not, willy-nilly, <B>~ado</B>, exercise of w-power, volition. <B>~eto</B>, fancy, inclination, slight wish, stray, impulse. <B>Laŭ~a</B>, facultative, optional. <B>~~e</B>, as you please, at w. <B>Kontraŭ~a</B>, against one’s w. (the grain), constrained, forced. <I>Edziĝo ~~a</I>. <B>Mal~i</B>, decline, kick at, fight shy of, set one’s face against. <B>Preter~a</B>, involuntary, unintentional (K 120/10). <B>Ne~a</B>, reluctant, un-ing. <B>Sen~a</B>, characterless, spineless, weak-minded. <I>~~eco,</I> (med) abulia. <B>Bon~o</B>, benovolence, good w., kindness. <B>~~e</B>, kindly, please. ~~&lt;? <I>kantu (~~u kanti</I>), please sing, be so good as to sing. <I>~~ulo</I>, man of good w. <I>Mai~~o</I>, malevolence. <B>Liber~a</B>, free-w., spontaneous. <B>Mem~e</B>, <B>propra~e</B>, voluntarily, on one’s own account (initiative). <B>Plaĉi~a</B>, affable, amiable, engaging. <B>Plen~e</B>, with a w. <B>Pli~e</B>, preferably. <B>Sci~a</B>, inquisitive. <I>Mi ~~as</I> (wonder), <I>lu. ~~igi,</I> arouse curiosity. ➞ <I>bezon, cel, decid. dezir, intenc, -os, volont</I>.", "0"],
["volitivo", "volitiv-o", "(U-modo), (gram) optative (voli- tive) mood. ➞ <I>-u</I>.", "0"],
["volonte", "volont-e", "[UV] Willingly, gladly, readily, fain, with pleasure. <I>~e akcepti inviton; plenumi deziron. Mi iras</I> <B>~e</B>, go with pleasure, like to go, am fond of going. <I>Mi ~e ĝin aĉetas</I>, it finds a ready purchaser in me. <I>~e mi trinkus</I>, I could do with a drink. <I>~e mi venus</I>, I should like to (fain word) come. <I>Li ~e iros</I>, he will be pleased to go, won’t mind going. <B>~i</B>, be ready and w., volunteer. <B>~a</B>, w., ready. <B>~eco</B>, alacrity, eager-(readiness) (Ps 54/6). <B>~igi</B> (<I>-n</I>), dispose, incline, induce. <B>~ulo</B>, volunteer. <B>Mal~e</B>, <B>Ne~e</B>, reluctantly, with a bad grace. <I>~~e .</I>../, be averse (disinclined, loath) to. ➞ <I>afabl, ĝoj, plaĉ, vol</I>. <B>Rim</B>.: memvole suggests <I>konsenton,</I> volonte <I>plaĉon</I>.", "0"],
["voltaeca", "voltaec-a", "voltaic.", "0"],
["volto", "volt-o", "(el) Volt. <B>Alt~a</B>. <B>~aro</B>, -age. <B>~metro</B>, -meter. <B>Mili~o</B>.", "0"],
["volucelo", "volucel-o", "(ent) buzzing swift-flier (hover-fly) (<I>Syrphus</I>).", "0"],
["volumeno", "volumen-o", "[OA] Volum/e, bulk, mass (space occupied). <I>~o de materialo</I>. <B>~a</B>, -inous, of v. <B>~eco</B>, -inosity. ➞ <I>ampleks, volum</I>.", "0"],
["volumo", "volum-o", "[UV] Volume, pages bound together with cover. <I>Verko du-a</I>. <B>~ego</B>, tome.", "0"],
["volupt(am)a", "", "[UV] voluptuous, sensual, carnal, lascivious, licentious, <B>~(aĵ)o</B>, sensual delight (pleasure). &lt;?«/ <I>~on</I>. <B>~eco</B>, <B>~emo</B>, s-al appetite. <B>~ulo</B>, voluptuary, sensualist.", "0"],
["voluto", "volut-o", "[1], volute, spiral, curl, whorl, (arch, vn) volute, scroll, <B>f</B> <I>~o el fumo, ondo</I>.", "0"],
["voluto", "volut-o", "[2], (zoo) marine gastropod (<I>Voluta</I>).", "0"],
["volvi", "volv-i", "(<I>-n</I>) [UV]. Wrap, Roll, wind. <B>1</B> (round another object.): <I>~i bandaĝon ĉirkaŭ brako; skarpon - kolo; ŝnuron - bastono</I>. <B>2</B> (round itself): <I>~i paperon, folion, ombrelon, rubandon, lanon en bulon</I>. <B>~ado</B>, wrapping. <B>~(aĵ)o</B>, ball of wool, paper, etc. (el) winding. <B>~e</B> <I>rampi (grimpi</I>), climb (as tendril). <B>~iĝi</B>, <B>sin ~i</B>, coil, curl, wind itself. <I>Hedero ~iĝis ĉirkaŭ la arbo</I>. <B>ĉirkaŭ~i</B>, envelope in, tie up, wrap round. <I>~~i brakon per bandaĝo</I>. ~~o (mar) lash. <B>Dis~i</B>, <B>El~i</B>, expand, extend, spread out. <I>~~i rulaĵon, standardon</I>. <B>f</B> develop, widen. <I>~~i siajn talentojn</I>. <I>~~i argumenton. planon</I>. <B>~~iĝi</B>, expand, develop, evolve. <I>La industrio, literaturo ~~iĝis. La floro ~~iĝis (opened</I>). <B>En~i</B>, w. up, enfold, envelope, pack up. <I>~~i pakaĵon en papero, sin en mantelo</I>. <B>f</B> <I>La nokto ~~is la teron per nigra vualo</I>. <I>Esti ~~ita en komplikaĵoj</I>. <I>Kun~i, r. (w.) up (together</I>), ~~aĵo, <I>r. of objj. <B>Mal~i</B>, un-r., unfold, unwind. ~~i kurtenon, mapon</I>; <I>unpack, unwrap pakaĵon</I>. <I>Kun manikoj Supren~itaj. ➞ rul, vind</I>.", "0"],
["vombato", "vombat-o", "(zoo) wombat (<I>Phaseolomys</I>).", "0"],
["vomi", "vom-i", "(<I>-n, abs</I>), [UV] Vomit, be Sick, bring (throw) up, spew. <I>Kiel ebriulo ŝanceliĝas ~ante</I> (Jes 19/14). <I>~i sangon</I>. <B>f</B> belch forth. <I>Kamentubo ~as fumon; vulkano lafon. Esti</I> <B>~ema</B>, feel sick. <B>~igilo</B>, emetic. <I>Kiel hundo revenas al sia</I> <B>~itaĵo</B> (Se 26/11). <B>Ek~i</B>, retch. <I>La fiŝo el~is Jonan</I> (Jona 2/10). <B>f</B> <I>insultojn</I>.", "0"],
["vori", "vor-i", "(<I>glutegi, manĝegi</I>), devour, wolf. <B>~a</B>, (six), (<I>~manĝa</I>), -ivorous. <B>~ema</B>, voracious.", "0"],
["vortico", "vortic-o", "(<I>turniĝo</I>), vortex. <I>~o de akvo, vento</I>. (also figuratively) ➞ <I>ciklon, kirlaj</I>.", "0"],
["vorto", "vort-o", "[UV] <B>1</B> Word, vocable: <I>~o dubesenca, ĝusta, koda, kunmetita. Per unu ~o</I>, in a w. <I>Per malmultaj ~oj</I>, briefly, tersely. <B>Lig~o</B>, copula. <B>Pas~o</B>, pass-w. <B>Signal~o</B>, cue. <B>2</B> speech, message. (Jĝ 3/20): <I>Deziri ~on kun iu. De ~o ĝentila ne doloras la lango. Lasi al iu la lastan ~on</I>. <B>3</B> Promise: <I>Je mia ~o</I>, upon my w. <I>Plenumi, teni sian ~on</I>. <B>4</B> (rel) (Gk <I>logos): La Vorto</I> (Jn 1/1), <B>~a</B>. of a w., verbal. <I>~aj promesoj</I>. <B>~aĉo</B>, coarse expressn, ugly w. <B>~aro</B> [UV] (<I>~libro</I>), dictionary. ➞ <I>konkordanc, leksikon, terminar</I>. <B>Rim~~o</B>, rhyming dictionary. <I>~areto</I>, vocabulary, <I>~aristo,</I> lexicographer. <B>~ero</B>, w-element. <I>Enmeti</I> <B>~eton</B>. <B>~igi</B>, draw up, formulate, put into words. <I>Ne~igita</I>, implicit, tacit. <B>Laŭ~a</B>, <B>~e</B> literal(ly), verbatim, textual, w. for w. <I>Ripe to ~~e. ~~a traduko</I>. <B>Sen~e</B>, without (saying) a word, silently. <B>Ali~e</B>, in other ww. <I>Saĝa kapo</I> <B>duon~on</B> <I>komprenas</I>. <B>Fi~o</B>, bad (dirty, indecent, nasty, swear) w. <B>Mult~a</B>, -y, diffuse, prolix, verbose. <B>Pra~o</B>, primitiv w. <B>Kejl~o</B>, stop-gap, word used merely to supply another syllable. <B>Kruc~o</B>, cross-w. <B>Unu~e</B>, in a w., shortly. ➞ <I>dir, parol, termin</I>.", "0"],
["vosto", "vost-o", "[UV] Tail. <B>1</B> (of animal, bird, fish), brush (fox). <I>Ĉiu vulpo sian ~on laŭdas. Korniko vundita propran ~on timas</I>. <B>2</B> End, last part: <I>la ~o de kometo, robo, de frako (= basko</I>). (mus) crook (hook) of note. <I>~o libera, ligita</I>. <B>3</B> queue. <B>~a</B>, tail, caudal. <B>Ruĝ~ulo</B> <B>(<I>fenikuro</I>). Sen~uloj (<I>batrakoj</I></B>), batrachians <B>(<I>bufo, rano</I>). ~umi (<I>svingi la ~on</I>). Vulp~o</B> (bot), (<I>alopekuro</I>). ➞ <I>trenaĵ</I>.", "0"],
["voto", "vot-o", "(<I>sankta promeso</I>), <B>~i</B>, Vow. <B>~a</B>, votive, consecrated (offered) in fulfillment of a v. ➞ <I>voĉdon</I>.", "0"],
["vrako", "vrak-o", "(<I>ŝipruino</I>), wreck.", "0"],
["vringi", "vring-i", "(<I>elpremi, eltordi</I>), Wring, w. out (also figuratively).", "0"],
["vualo", "vual-o", "[UV] Veil. <I>~o de virino</I>. (<I>rel</I>) <I>Alpreni la ~on</I>, take the v. <B>Kul~o</B>, mosquito net. <B>f</B> <I>~o</I> (blur) <I>de larmoj</I>. <I>La ~oj</I> (shades) <I>de la nokto</I>. <I>~o falis de liaj okuloj. La tempo tiros ~on sur la tragedion</I>. <B>~i</B>, veil. <B>1</B> cover. <I>Densaj nuboj ~is la ĉielon. Kiam nokto ~as, ĉiuj koloroj egalas</I>. <B>2</B> confuse (hinder) vision, draw a v. over. <I>Larmoj ~is liajn okulojn</I>. <B>~aĵo</B>, -ing (material). <B>~eto</B>, (hat)-v, fall. <B>~iĝi</B>, put on a v. <B>~ita</B>, -ed. <B>Sen~igi (~iĝi)</B>, unveil.", "0"],
["vulgara", "vulgar-a", "[OA] Vulgar (in the sense Common, everyday, generally prevalent, of the people, usual). <I>~a antaŭjuĝo, kutimo, opinio. ~a eraro</I>, common mistake, v. error. <I>~a lingvo</I>, v. tongue, vernacular, language of the people. <B>~e</B>, commonly. <I>~e akceptita teksto,</I> c-ly received version. <B>~aĉa</B>, v., coarse, low, plebian, unrefined, <B>~igi</B>, popularize, v-ize. <I>~igo de scienco</I>. <B>~ismo</B> (<I>~a esprimo</I>), vulgarism. <B>~ulo</B>, c-er, man of the people. <B>~uloj</B>, c. people, vulgar herd. ➞ <I>krud, maldec, maldelikat, ordinar, popol, trivial</I>.", "0"],
["vulgato", "vulgat-o", "vulgate, Latin Bible (by Jerome, 4th century).", "0"],
["vulkanizi", "vulkaniz-i", "volcanize.", "0"],
["vulkano", "vulkan-o", "[UV] volcano. <B>~a</B>, volcanic.", "0"],
["vulpo", "vulp-o", "[UV] Fox (<I>Vulpes</I>). <I>Ruza, kiel ~o. Ne ekzistas naiva ~o. Vizaĝo sen kulpo, sed koro de ~o. ~o arĝenta, arkta, ruĝa</I>. <B>~o feneka</B>, fennec fox (<I>Fennecus zerda</I>) <B>~a</B>, foxy, cunning, crafty, vulpine. <B>~ido</B>, f-cub. <B>~ino</B>, vixen. ➞ alopekur.", "0"],
["vulturo", "vultur-o", "[UV] vulture (<I>Vultur</I>). ➞ <I>gip, gipaet, grif, kondor, milv, perknopter</I>.", "0"],
["vulvo", "vulv-o", "(anat) Vulv/a. <B>~a</B>, -ar. <B>~ito</B>, -itis. <B>~oforma</B>, -iform.", "0"],
["vundi", "vund-i", "(<I>-n</I>), [UV] Wound (by abrasion, blow, cut, tear, etc.). Hurt. <I>~i la brakon. Kiu batas edzinon, tiu ~as sin mem</I>. <B>f</B> <I>~i reputacion, sentojn. Via diro ~is min profunde</I>. <B>~o</B> hurt, wound, sore. <I>Saĝa hundo post la ~o</I>. <B>Brog~o</B>, scald. <B>Brul~o</B>, burn. <B>Grat~o</B>, scratch. <B>Paf~o</B>, bullet-w. <B>Pik~o</B>, stab. <B>Skrap~o</B>, chafe, gall, graze. <B>Spron~o</B>, spur-gall. <B>Streĉ~o</B>, rick, strain. <B>Ŝir~o</B>, laceration. <B>Tranĉ~o</B>, cut. <B>f</B> <I>Langa ~o plej profunda</I>. <B>~a</B>, traumatic. <I>~a loko</I>, tender (sore, weak) spot. <B>~ebla</B>, susceptible to injury, vulnerable. <B>Ne~ebla</B>. <B>~eti</B>, w. slightly. <B>~iĝi</B>, be -ed, hurt. <B>~ita</B>, <B>~ito</B>, -ed. <I>Flegi ~ojn</I>. <B>Sen~a</B>, unhurt (uninjured, unscathed). <B>~osaniga</B>, vulnerary. ➞ <I>cikatr, damaĝ, kontuz, lez, ofend</I>.", "0"],
["Zambio", "Zambi-o", "ZM.", "0"],
["zebro", "zebr-o", "[UV] Zebra (<I>Equus zebra) &gt;</I> quagga. <I>~ostria</I>, strip-ed, -y.", "0"],
["zebuo", "zebu-o", "(zoo) zebu (<I>Bos indieus</I>).", "0"],
["zefiro", "zefir-o", "[OA] zephyr, soft light wind.", "0"],
["Zelando", "Zeland-o", ". <B>Nov-Zelando</B> NZ.", "0"],
["zeloto", "zelot-o", "zealot, fanatical enthusiast. ➞ <I>fanatik</I>.", "0"],
["zenito", "zenit-o", "[UV] (astr) zenith. <I>La suno atingis la ~on</I>. <B>f</B> highest point. <I>Lia famo estis ĉe la ~o. La entuziasmo atingis sian ~on,</I> ➞ <I>apoge, kulmin</I>.", "0"],
["zeo", "ze-o", "(ich) John Dory (<I>Zeus</I>).", "0"],
["zeŭgmo", "zeŭgm-o", "(rh) zeugma, one verb applied to two nouns, another verb being understood, e.g., <I>La popolo vidis la tondrojn kaj la</I> <B><I>fulmojn</I></B> (El 20/18). <B><I>Figuron vi ne vidis, nur la voĉon</I></B> (Rd 4/12).", "0"],
["zibelo", "zibel-o", "[UV] Sable, s-marten (<I>Martes zibellina</I>). <B>~aĵoj</B>, sables, furs. ➞ <I>martes</I>.", "0"],
["zigeno", "zigen-o", "(ent) burnet moth (<I>Zygaena</I>).", "0"],
["zigzago", "zigzag-o", "[OA] <B>~a</B>, Zigzag. ~a vojo, linio. La fulmoj <B>~e</B> sin ĵetis en la maron. <B>~i</B> (~e iri), z., lurch; fork (fulmo); tack (ŝipo).", "0"],
["Zimbabvo", "Zimbabv-o", "ZW. Zimbabwe.", "0"],
["zimbalono", "zimbalon-o", "(m.i.) dulcimer (Hungarian: (c)zimbalon). ➞ <I>citr, ziter</I>.", "0"],
["zingibro", "zingibr-o", "[UV] Ginger (plant and spice) (<I>Zingiber</I>). <B>~a</B> <I>biero. ~a konfitaĵo,</I> preserved ginger.", "0"],
["zinio", "zini-o", "(bot) zinnia (<I>Zinnia</I>).", "0"],
["zinko", "zink-o", "[UV] Zinc (Zn). <I>Kruda ~o</I>, spelter. <B>~a</B> <I>pulvoro</I>, z-dust. <B>~i</B> (coat with) z., galvanize. <B>~oksido</B>, z-oxide, zinc-white, Chinese white. <B>~ogravuro</B>, -ography. <B>~sulfido</B>, zinc-blend.", "0"],
["zipo", "zip-o", "= <I>glitfermilo, tirfermilo</I>. zip fastener.", "0"],
["zirkono", "zirkon-o", "Zircon. <B>~io</B>, -ium (Zr).", "0"],
["zitero", "ziter-o", "zither (m.i. typical of the Tyrol, with 30-45 strings). <B>Akord~o</B>, <B>harp~o</B>, autoharp. ➞ <I>citr, zimbalon</I>. <B>Rim</B>.: G. <I>Zither</I> = (a) <I>zitero</I>, (b) <I>citro</I>.", "0"],
["zizel", "", "-o, [UV] souslik (<I>Citellus</I>). ➞ <I>marmot</I>.", "0"],
["zizifo", "zizif-o", "(bot) Jujube, Indian plum (<I>Zizphus jujuba</I>). <B>~arbo</B>, j-tree.", "0"],
["Zo", "Z-o", "[F], letter Z. <B>Z-fero</B>.", "0"],
["zoarko", "zoark-o", "(ich) eel pout, viviparous blenny (<I>Zoarces</I>).", "0"],
["zodiako", "zodiak-o", "[OA] zodiac. <B>~a</B>, zodiacal.", "0"],
["zomi", "zom-i", "(av) zoom, mount at high speed. <B>~o</B>, steep rapid climb.", "0"],
["zono", "zon-o", "[UV] Zone. <B>1</B> Belt, girdle, waistband, e.g., <I>de jupo, pantalono. Leda ~o</I>. <B>Ĉeval~o</B>, <B>ventro~o</B>, belly-band, girth. <B>Kartoĉa ~o</B>, cartridge belt. <B>Naĝ~o</B>, swimming-b. <B>Sav~o</B>, life-b. <B>2</B> similar obj: <B>Krur~o</B>, garter. <B>Mam~o</B>, brassiere, bust-bodice. <B>Rubanda ~o</B>, sash. <B>Sekuriga ~o</B>, safety belt. <B>ŝultra ~o</B>, (<I>balteo</I>), shoulder-b. <B>f</B> (<I>talio). Naĝi (Nuda) ĝis la ~o</I>. <B>3</B> (<I>ter~o</I>): z. on earth’s surface. <I>~o glacia, norda, mezvarma. ~o tropika (varmega</I>), torrid, <B>f</B> <I>~o milita, okupacia, poŝta</I>. <B>~a</B>, zonal. <B>~i</B>, gird on, surround (as with a z.): <I>~i la lumbo(j)n,</I> gird up one’s loins. <I>Dio ~is min per ĝojo. ~ita de potenco</I>, girt with might, <B>f</B> <I>neĝaj suproj ~is la horizonton</I>. <B>2</B> (<I>surmeti): ~i glavon sur sia femuro; sabron al sia flanko</I>. <B>Duon~o</B>, half-b. <B>Sen~igi</B>, unbelt. <B>Sel~o</B>, saddle-girth. ➞ <I>jartel, ruband, vind</I>.", "0"],
["zoofito", "zoofit-o", "(<I>animalo plantsimila</I>), zoophyte.", "0"],
["zoologio", "zoolog-io", "[F], zoolog/y. <B>-o</B>, [OA] -ist.", "0"],
["zorgi", "zorg-i", "(<I>pri, -n</I>) [UV]. <B>1</B> Care (for) attend (see) to, be in charge of, bestow c. (keep an eye) on, look after, watch over: <I>Pli ~as unu patrino pri dek infanoj, ol dek infanoj pri unu patrino. Faru vian aferon, Dio ~os ceteron. ~u, ke li venu</I>.<B>< 2<</B> Be anxious (concerned, troubled) about: <I>En tempo de sekeco (arbo) ne ~as</I> (Jer 17/8). <B>~o</B>, <B>1</B> care, attention, effort, trouble: <I>Patrina ~o. Akcepti infanon sub sian ~on</I>. <B>2</B> anxiety, concern, solicitude, uneasiness, worry: <I>De ~oj, ne de jaroj, blankiĝas la haroj. Rusto manĝas feron, kaj ~o la homon. Ofico sen ~oj</I>, sinecure. <I>Pezaj ~oj premas mian bruston. Ne ~i pri,</I> be remiss about. <B>~(em)a</B>, <B>~oplena</B>, c-ful, attentive, conscientious, scrupulous, solicitous, watchful. <I>~a okulo</I>. <B>~e</B> (with care, closely) <I>korekti provaĵon. ~e de X</I> (in address), C/o X. <B>~anto</B>, [UV] guardian, foster-father, protector, tutor. <B>~ato</B>, [UV] foster-child, ward. <I>~ataro</I>, charge, flock. <B>~ateco</B>, protection, tutelage, ward-ship. <B>Antaŭ~a</B>, c-ful, provident. <I>Esti ~~a, kaj sin asekuri</I>. <B>~~o</B>, precaution; <B><I>~~</I>i</B>, take precautions. <B>~iga</B>, causing anxiety. <B>Mal~i</B>, neglect, pay no attention to. <I>~~i sian devon, meton, sanon; siajn aferojn (amikojn</I>). <B>~~o</B>, negligence, slackness. <B>Ne~ita</B>, neglected, unc-ed for. <B>Pri~i</B> (<I>flegi, varti</I>), look after. <I>Socia pri~ateco</I>, social security, (mot) <B>~~o</B>, upkeep, service. <B>Sen~a</B>, <B>Ne~ema</B>, carefree, careless, heedless, thoughtless, reckless, slovenly, untidy. <B><I>~~</I>ulo</B>, careless fellow. ➞ <I>atent, fleg, gard, ĝen, okupiĝ, vart</I>.", "0"],
["zostero", "zoster-o", "eel-grass, sea-grass, grass-wrack (<I>Zostera</I>). Used as padding or stuffing. ➞ <I>aling, fuk</I>.", "0"],
["zostro", "zostr-o", "(med) shingles (<I>Herpeto zona</I>).", "0"],
["zuavo", "zuav-o", "[OA] zouave, infantryman (Fr. African army).", "0"],
["zumi", "zum-i", "[UV] <B>1</B> Buzz (fly); drone (bee, wasp); hum (motor); purr (<I>= ronroni,</I> cat). <B>2</B> (kanteti), hum. <B>f</B> Muŝo ~as en lia kapo<I>, he has queer ideas. La kanto (pensoj) ~as en mia cerbo. La kuloj</I> <B>~adis</B>. <B>~ado</B>, throbbing (whirring) (machine)<I>. Mallaŭta ~ado de konversacio. Surdiga ~ado de kugloj</I>.", "0"],
["?????", "", "(➞ <I>ledisi</I>). <B>~sako</B>, leathern bottle, wineskin (Ge 21/14). <B>Sen~igi</B>, flay, skin, <B>f</B> (<I>ekspluati, senplumigi</I>): sweat. ➞ <I>haŭt, led, pelt</I>.", "0"],
["?????", "", "to pain or pleasure, patient endurance. <B>~ulo</B>, -al person. ➞ <I>flegm, sinreg</I>.", "0"],
];

var butlerFuns= {
	"conv1":null, "conv2":null,
	
	"makeEntry":function(entry, index, klass) {
	var word= ((entry[1])?entry[1]:entry[0]).replace('-','');
	var div= document.createElement("div");
	div.className=klass;
	div.setAttribute("params", index);
	var txt= document.createTextNode(word);
	div.appendChild(txt);
	return div;
	},
	
	"makeDef":makeDef_html
};

callback("butler", butlerDict, butlerFuns);
